-- --------------------------------------------------------
-- Host:                         10.254.200.60
-- Server version:               10.6.7-MariaDB-2ubuntu1.1 - Ubuntu 22.04
-- Server OS:                    debian-linux-gnu
-- HeidiSQL Version:             11.3.0.6295
-- --------------------------------------------------------

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET NAMES utf8 */;
/*!50503 SET NAMES utf8mb4 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;


-- Dumping structure for table test.catalog_items
DROP TABLE IF EXISTS `catalog_items`;
CREATE TABLE IF NOT EXISTS `catalog_items` (
  `id` int(16) NOT NULL AUTO_INCREMENT,
  `item_ids` varchar(256) COLLATE utf8mb4_unicode_ci NOT NULL,
  `page_id` int(11) NOT NULL,
  `catalog_name` varchar(64) COLLATE utf8mb4_unicode_ci NOT NULL,
  `cost_credits` int(11) NOT NULL DEFAULT 3,
  `cost_points` int(11) NOT NULL DEFAULT 0,
  `points_type` int(3) NOT NULL DEFAULT 0 COMMENT '0 for duckets; 5 for diamonds; and any seasonal/GOTW currencies you have in your emu_settings table.',
  `amount` int(11) NOT NULL DEFAULT 1,
  `limited_stack` int(11) NOT NULL DEFAULT 0 COMMENT 'Change this number to make the item limited.',
  `limited_sells` int(11) NOT NULL DEFAULT 0 COMMENT 'This automatically logs from the emu; do not change it.',
  `order_number` int(11) NOT NULL DEFAULT 1,
  `offer_id` int(11) NOT NULL DEFAULT -1,
  `song_id` int(3) unsigned NOT NULL DEFAULT 0,
  `extradata` varchar(128) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `have_offer` enum('0','1') COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '1',
  `club_only` enum('0','1','2') COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '0' COMMENT '0 = No HC/VIP req. 1 = HC is req. 2 = VIP is req.',
  PRIMARY KEY (`id`) USING BTREE,
  KEY `page_id` (`page_id`) USING BTREE,
  KEY `catalog_name` (`catalog_name`) USING BTREE,
  KEY `costs` (`cost_credits`,`cost_points`,`points_type`) USING BTREE,
  KEY `id` (`id`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=14614 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci ROW_FORMAT=DYNAMIC;

-- Dumping data for table test.catalog_items: ~13,118 rows (approximately)
/*!40000 ALTER TABLE `catalog_items` DISABLE KEYS */;
REPLACE INTO `catalog_items` (`id`, `item_ids`, `page_id`, `catalog_name`, `cost_credits`, `cost_points`, `points_type`, `amount`, `limited_stack`, `limited_sells`, `order_number`, `offer_id`, `song_id`, `extradata`, `have_offer`, `club_only`) VALUES
	(1, '1', 22, 'post.it', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(2, '2', 22, 'post.it.vd', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3, '3', 429, 'photo', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4, '4', 9, 'bot_generic', 25, 0, 0, 1, 0, 0, 1, 4, 0, 'name:Robbie;motto:Generic;figure:hr-3020-31.sh-3089-82.lg-3057-1330.ch-225-1408.ca-3084-82-82.wa-2003-63.hd-3091-1383;gender:m', '0', '0'),
	(5, '5', 9, 'bot_bartender', 40, 0, 0, 1, 0, 0, 3, 5, 0, 'name:Love;motto:Bartender;figure:hr-9534-45.sh-3064-1425.lg-3058-82.ch-818-1408.wa-2005-63.hd-600-1;gender:f', '0', '0'),
	(6, '6', 9, 'rentable_bot_visitor_log', 35, 0, 0, 1, 0, 0, 2, 6, 0, 'name:Belle;motto:Visitor Counter;figure:sh-3064-91.lg-3166-82.ch-3076-82-73.hr-3251-31-1355.hd-3096-1;gender:f', '0', '0'),
	(7, '7', 429, 'product_avatar_effect113', 4, 0, 0, 1, 0, 0, 99, 7, 0, '113', '0', '0'),
	(8, '13', 27, 'shelves_norja', 4, 0, 0, 1, 0, 0, 105, 5, 0, '', '1', '0'),
	(9, '14', 17, 'shelves_polyfon', 4, 0, 0, 1, 0, 0, 1, 6, 0, '', '1', '0'),
	(10, '15', 281, 'shelves_silo', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(11, '17', 17, 'table_polyfon_small', 5, 0, 0, 1, 0, 0, 2, 18168, 0, '', '1', '0'),
	(12, '18', 17, 'chair_polyfon', 2, 0, 0, 1, 0, 0, 4, 158, 0, '', '1', '0'),
	(13, '20', 27, 'table_norja_med', 5, 0, 0, 1, 0, 0, 165, 10, 0, '', '1', '0'),
	(14, '21', 281, 'table_silo_med', 5, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(15, '22', 511, 'table_plasto_4leg', 5, 0, 0, 1, 0, 0, 40, -1, 0, '', '1', '0'),
	(16, '23', 511, 'table_plasto_round', 5, 0, 0, 1, 0, 0, 80, -1, 0, '', '1', '0'),
	(17, '24', 511, 'table_plasto_bigsquare', 5, 0, 0, 1, 0, 0, 60, -1, 0, '', '1', '0'),
	(18, '25', 17, 'stand_polyfon_z', 4, 0, 0, 1, 0, 0, 5, 159, 0, '', '1', '0'),
	(19, '26', 281, 'chair_silo', 2, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(20, '28', 281, 'sofa_silo', 3, 0, 0, 1, 0, 0, 34, -1, 0, '', '1', '0'),
	(21, '29', 27, 'couch_norja', 4, 0, 0, 1, 0, 0, 15, 18, 0, '', '1', '0'),
	(22, '30', 27, 'chair_norja', 2, 0, 0, 1, 0, 0, 1, 18073, 0, '', '1', '0'),
	(23, '31', 17, 'table_polyfon_med', 5, 0, 0, 1, 0, 0, 3, 20, 0, '', '1', '0'),
	(24, '32', 559, 'doormat_love', 4, 0, 0, 1, 0, 0, 32, 21, 0, '', '1', '0'),
	(25, '33', 559, 'doormat_plain', 4, 0, 0, 1, 0, 0, 22, 22, 0, '', '1', '0'),
	(26, '34', 17, 'sofachair_polyfon', 2, 0, 0, 1, 0, 0, 10, 23, 0, '', '1', '0'),
	(27, '35', 17, 'sofa_polyfon', 3, 0, 0, 1, 0, 0, 20, 24, 0, '', '1', '0'),
	(28, '36', 281, 'sofachair_silo', 2, 0, 0, 1, 0, 0, 44, -1, 0, '', '1', '0'),
	(29, '38', 511, 'chair_plasty', 2, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(30, '39', 511, 'chair_plasto', 2, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(31, '40', 511, 'table_plasto_square', 2, 0, 0, 1, 0, 0, 100, -1, 0, '', '1', '0'),
	(32, '41', 17, 'bed_polyfon', 4, 0, 0, 1, 0, 0, 30, 29, 0, '', '1', '0'),
	(33, '42', 17, 'bed_polyfon_one', 4, 0, 0, 1, 0, 0, 40, 30, 0, '', '1', '0'),
	(34, '43', 429, 'bed_trad_one', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(35, '44', 429, 'bed_trad', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(36, '45', 281, 'bed_silo_one', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(37, '46', 281, 'bed_silo_two', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(38, '47', 281, 'table_silo_small', 2, 0, 0, 1, 0, 0, 54, -1, 0, '', '1', '0'),
	(39, '48', 18, 'bed_armas_two', 4, 0, 0, 1, 0, 0, 5, 34, 0, '', '1', '0'),
	(40, '49', 429, 'bed_budget_one', 4, 0, 0, 1, 0, 0, 101, -1, 0, '', '1', '0'),
	(41, '50', 429, 'bed_budget', 4, 0, 0, 1, 0, 0, 43, -1, 0, '', '1', '0'),
	(42, '51', 18, 'shelves_armas', 4, 0, 0, 1, 0, 0, 14, 18203, 0, '', '1', '0'),
	(43, '52', 18, 'bench_armas', 4, 0, 0, 1, 0, 0, 6, 38, 0, '', '1', '0'),
	(44, '53', 18, 'table_armas', 5, 0, 0, 1, 0, 0, 17, 39, 0, '', '1', '0'),
	(45, '54', 18, 'small_table_armas', 2, 0, 0, 1, 0, 0, 16, 40, 0, '', '1', '0'),
	(46, '55', 18, 'small_chair_armas', 2, 0, 0, 1, 0, 0, 15, 41, 0, '', '1', '0'),
	(47, '56', 18, 'fireplace_armas', 4, 0, 0, 1, 0, 0, 11, 42, 0, '', '1', '0'),
	(48, '57', 18, 'lamp_armas', 4, 0, 0, 1, 0, 0, 13, 43, 0, '', '1', '0'),
	(49, '58', 18, 'bed_armas_one', 4, 0, 0, 1, 0, 0, 4, 18185, 0, '', '1', '0'),
	(50, '59', 559, 'carpet_standard', 4, 0, 0, 1, 0, 0, 12, 45, 0, '', '1', '0'),
	(51, '60', 18, 'carpet_armas', 4, 0, 0, 1, 0, 0, 7, 46, 0, '', '1', '0'),
	(52, '61', 559, 'carpet_polar', 4, 0, 0, 1, 0, 0, 1, 3184, 0, '', '1', '0'),
	(53, '62', 17, 'fireplace_polyfon', 4, 0, 0, 1, 0, 0, 6, 48, 0, '', '1', '0'),
	(54, '63', 511, 'table_plasto_4leg*1', 5, 0, 0, 1, 0, 0, 41, -1, 0, '', '1', '0'),
	(55, '64', 511, 'table_plasto_bigsquare*1', 5, 0, 0, 1, 0, 0, 61, -1, 0, '', '1', '0'),
	(56, '65', 511, 'table_plasto_round*1', 5, 0, 0, 1, 0, 0, 81, -1, 0, '', '1', '0'),
	(57, '66', 511, 'table_plasto_square*1', 2, 0, 0, 1, 0, 0, 101, -1, 0, '', '1', '0'),
	(58, '67', 511, 'chair_plasto*1', 2, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(59, '68', 559, 'carpet_standard*1', 4, 0, 0, 1, 0, 0, 18, 55, 0, '', '1', '0'),
	(60, '69', 559, 'doormat_plain*1', 4, 0, 0, 1, 0, 0, 23, 56, 0, '', '1', '0'),
	(61, '70', 511, 'table_plasto_4leg*2', 5, 0, 0, 1, 0, 0, 42, -1, 0, '', '1', '0'),
	(62, '71', 511, 'table_plasto_bigsquare*2', 5, 0, 0, 1, 0, 0, 62, -1, 0, '', '1', '0'),
	(63, '72', 511, 'table_plasto_round*2', 5, 0, 0, 1, 0, 0, 82, -1, 0, '', '1', '0'),
	(64, '73', 511, 'table_plasto_square*2', 2, 0, 0, 1, 0, 0, 102, -1, 0, '', '1', '0'),
	(65, '74', 511, 'chair_plasto*2', 2, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(66, '75', 559, 'doormat_plain*2', 4, 0, 0, 1, 0, 0, 24, 62, 0, '', '1', '0'),
	(67, '76', 559, 'carpet_standard*2', 4, 0, 0, 1, 0, 0, 13, 63, 0, '', '1', '0'),
	(68, '77', 511, 'table_plasto_4leg*3', 5, 0, 0, 1, 0, 0, 43, -1, 0, '', '1', '0'),
	(69, '78', 511, 'table_plasto_bigsquare*3', 5, 0, 0, 1, 0, 0, 63, -1, 0, '', '1', '0'),
	(70, '79', 511, 'table_plasto_round*3', 5, 0, 0, 1, 0, 0, 83, -1, 0, '', '1', '0'),
	(71, '80', 511, 'table_plasto_square*3', 2, 0, 0, 1, 0, 0, 103, -1, 0, '', '1', '0'),
	(72, '81', 511, 'chair_plasto*3', 2, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(73, '82', 559, 'carpet_standard*3', 4, 0, 0, 1, 0, 0, 14, 69, 0, '', '1', '0'),
	(74, '83', 559, 'doormat_plain*3', 4, 0, 0, 1, 0, 0, 25, 70, 0, '', '1', '0'),
	(75, '84', 511, 'table_plasto_4leg*4', 5, 0, 0, 1, 0, 0, 44, -1, 0, '', '1', '0'),
	(76, '85', 511, 'table_plasto_bigsquare*4', 3, 0, 0, 1, 0, 0, 64, -1, 0, '', '1', '0'),
	(77, '86', 511, 'table_plasto_round*4', 3, 0, 0, 1, 0, 0, 84, -1, 0, '', '1', '0'),
	(78, '87', 511, 'table_plasto_square*4', 2, 0, 0, 1, 0, 0, 104, -1, 0, '', '1', '0'),
	(79, '88', 511, 'chair_plasto*4', 2, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(80, '89', 559, 'carpet_standard*4', 4, 0, 0, 1, 0, 0, 15, 75, 0, '', '1', '0'),
	(81, '90', 559, 'doormat_plain*4', 4, 0, 0, 1, 0, 0, 25, 76, 0, '', '1', '0'),
	(82, '91', 559, 'doormat_plain*6', 4, 0, 0, 1, 0, 0, 26, 77, 0, '', '1', '0'),
	(83, '93', 559, 'doormat_plain*5', 4, 0, 0, 1, 0, 0, 26, 78, 0, '', '1', '0'),
	(84, '94', 559, 'carpet_standard*5', 4, 0, 0, 1, 0, 0, 16, 79, 0, '', '1', '0'),
	(85, '95', 511, 'table_plasto_4leg*5', 5, 0, 0, 1, 0, 0, 45, -1, 0, '', '1', '0'),
	(86, '96', 511, 'table_plasto_bigsquare*5', 5, 0, 0, 1, 0, 0, 65, -1, 0, '', '1', '0'),
	(87, '97', 511, 'table_plasto_round*5', 5, 0, 0, 1, 0, 0, 85, -1, 0, '', '1', '0'),
	(88, '98', 511, 'table_plasto_square*5', 2, 0, 0, 1, 0, 0, 105, -1, 0, '', '1', '0'),
	(89, '99', 511, 'chair_plasto*5', 2, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(90, '100', 511, 'table_plasto_4leg*6', 5, 0, 0, 1, 0, 0, 46, -1, 0, '', '1', '0'),
	(91, '101', 511, 'table_plasto_bigsquare*6', 5, 0, 0, 1, 0, 0, 66, -1, 0, '', '1', '0'),
	(92, '102', 511, 'table_plasto_round*6', 5, 0, 0, 1, 0, 0, 86, -1, 0, '', '1', '0'),
	(93, '103', 511, 'table_plasto_square*6', 2, 0, 0, 1, 0, 0, 106, -1, 0, '', '1', '0'),
	(94, '104', 511, 'chair_plasto*6', 2, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(95, '105', 511, 'table_plasto_4leg*7', 5, 0, 0, 1, 0, 0, 47, -1, 0, '', '1', '0'),
	(96, '106', 511, 'table_plasto_bigsquare*7', 5, 0, 0, 1, 0, 0, 67, -1, 0, '', '1', '0'),
	(97, '107', 511, 'table_plasto_round*7', 5, 0, 0, 1, 0, 0, 87, -1, 0, '', '1', '0'),
	(98, '108', 511, 'table_plasto_square*7', 2, 0, 0, 1, 0, 0, 107, -1, 0, '', '1', '0'),
	(99, '109', 511, 'chair_plasto*7', 2, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(100, '110', 511, 'table_plasto_4leg*8', 5, 0, 0, 1, 0, 0, 48, -1, 0, '', '1', '0'),
	(101, '111', 511, 'table_plasto_bigsquare*8', 5, 0, 0, 1, 0, 0, 68, -1, 0, '', '1', '0'),
	(102, '112', 511, 'table_plasto_round*8', 5, 0, 0, 1, 0, 0, 88, -1, 0, '', '1', '0'),
	(103, '113', 511, 'table_plasto_square*8', 2, 0, 0, 1, 0, 0, 108, -1, 0, '', '1', '0'),
	(104, '114', 511, 'chair_plasto*8', 2, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(105, '115', 511, 'table_plasto_4leg*9', 5, 0, 0, 1, 0, 0, 49, -1, 0, '', '1', '0'),
	(106, '116', 511, 'table_plasto_bigsquare*9', 5, 0, 0, 1, 0, 0, 69, -1, 0, '', '1', '0'),
	(107, '117', 511, 'table_plasto_round*9', 5, 0, 0, 1, 0, 0, 89, -1, 0, '', '1', '0'),
	(108, '118', 511, 'table_plasto_square*9', 2, 0, 0, 1, 0, 0, 109, -1, 0, '', '1', '0'),
	(109, '119', 511, 'chair_plasto*9', 2, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(110, '120', 559, 'carpet_standard*6', 4, 0, 0, 1, 0, 0, 17, 17926, 0, '', '1', '0'),
	(111, '121', 511, 'chair_plasty*1', 2, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(112, '122', 22, 'pizza', 4, 0, 0, 1, 0, 0, 10, 18008, 0, '', '1', '0'),
	(113, '123', 22, 'drinks', 4, 0, 0, 1, 0, 0, 10, 17962, 0, '', '1', '0'),
	(114, '124', 511, 'chair_plasty*2', 2, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(115, '125', 511, 'chair_plasty*3', 2, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(116, '126', 511, 'chair_plasty*4', 2, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(117, '127', 17, 'bar_polyfon', 4, 0, 0, 1, 0, 0, 7, 3175, 0, '', '1', '0'),
	(118, '128', 663, 'plant_cruddy', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(119, '129', 22, 'bottle', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(120, '130', 17, 'bardesk_polyfon', 4, 0, 0, 1, 0, 0, 50, 115, 0, '', '1', '0'),
	(121, '131', 17, 'bardeskcorner_polyfon', 4, 0, 0, 1, 0, 0, 60, 116, 0, '', '1', '0'),
	(122, '132', 429, 'floortile', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(123, '133', 18, 'bar_armas', 4, 0, 0, 1, 0, 0, 2, 118, 0, '', '1', '0'),
	(124, '134', 18, 'bartable_armas', 4, 0, 0, 1, 0, 0, 1, 119, 0, '', '1', '0'),
	(125, '135', 18, 'bar_chair_armas', 2, 0, 0, 1, 0, 0, 3, 120, 0, '', '1', '0'),
	(126, '136', 559, 'carpet_soft', 3, 0, 0, 1, 0, 0, 5, 121, 0, '', '1', '0'),
	(127, '137', 559, 'carpet_soft*1', 3, 0, 0, 1, 0, 0, 6, 17852, 0, '', '1', '0'),
	(128, '138', 559, 'carpet_soft*2', 3, 0, 0, 1, 0, 0, 7, 123, 0, '', '1', '0'),
	(129, '139', 559, 'carpet_soft*3', 3, 0, 0, 1, 0, 0, 8, 124, 0, '', '1', '0'),
	(130, '140', 559, 'carpet_soft*4', 3, 0, 0, 1, 0, 0, 9, 125, 0, '', '1', '0'),
	(131, '141', 559, 'carpet_soft*5', 3, 0, 0, 1, 0, 0, 10, 126, 0, '', '1', '0'),
	(132, '143', 559, 'carpet_soft*6', 3, 0, 0, 1, 0, 0, 11, 127, 0, '', '1', '0'),
	(133, '144', 22, 'red_tv', 4, 0, 0, 1, 0, 0, 7, 128, 0, '', '1', '0'),
	(134, '145', 22, 'wood_tv', 4, 0, 0, 1, 0, 0, 8, 129, 0, '', '1', '0'),
	(135, '146', 556, 'carpet_polar*1', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(136, '147', 511, 'chair_plasty*5', 2, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(137, '148', 559, 'carpet_polar*2', 4, 0, 0, 1, 0, 0, 2, 132, 0, '', '1', '0'),
	(138, '149', 559, 'carpet_polar*3', 4, 0, 0, 1, 0, 0, 3, 133, 0, '', '1', '0'),
	(139, '150', 559, 'carpet_polar*4', 4, 0, 0, 1, 0, 0, 4, 134, 0, '', '1', '0'),
	(140, '151', 511, 'chair_plasty*6', 2, 0, 0, 1, 0, 0, 26, -1, 0, '', '1', '0'),
	(141, '152', 17, 'table_polyfon', 5, 0, 0, 1, 0, 0, 8, 347, 0, '', '1', '0'),
	(142, '153', 17, 'smooth_table_polyfon', 5, 0, 0, 1, 0, 0, 9, 137, 0, '', '1', '0'),
	(143, '154', 556, 'sofachair_polyfon_girl', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(144, '155', 556, 'bed_polyfon_girl_one', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(145, '156', 556, 'bed_polyfon_girl', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(146, '157', 556, 'sofa_polyfon_girl', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(147, '158', 429, 'bed_budgetb_one', 4, 0, 0, 1, 0, 0, 42, -1, 0, '', '1', '0'),
	(148, '159', 429, 'bed_budgetb', 4, 0, 0, 1, 0, 0, 104, -1, 0, '', '1', '0'),
	(149, '160', 20, 'plant_pineapple', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(150, '161', 20, 'plant_fruittree', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(151, '162', 20, 'plant_small_cactus', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(152, '163', 20, 'plant_bonsai', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(153, '164', 20, 'plant_big_cactus', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(154, '165', 20, 'plant_yukka', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(155, '166', 559, 'carpet_standard*7', 4, 0, 0, 1, 0, 0, 18, 149, 0, '', '1', '0'),
	(156, '167', 559, 'carpet_standard*8', 4, 0, 0, 1, 0, 0, 18, 150, 0, '', '1', '0'),
	(157, '168', 559, 'carpet_standard*9', 4, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(158, '169', 559, 'carpet_standard*10', 4, 0, 0, 1, 0, 0, 20, 152, 0, '', '1', '0'),
	(159, '170', 559, 'carpet_standard*11', 4, 0, 0, 1, 0, 0, 21, 153, 0, '', '1', '0'),
	(160, '171', 20, 'plant_sunflower', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(161, '172', 20, 'plant_rose', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(162, '173', 22, 'tv_luxus', 4, 0, 0, 1, 0, 0, 9, 156, 0, '', '1', '0'),
	(163, '174', 182, 'bath', 4, 0, 0, 1, 0, 0, 42, 165, 0, '', '1', '0'),
	(164, '177', 182, 'sink', 4, 0, 0, 1, 0, 0, 35, 166, 0, '', '1', '0'),
	(165, '178', 182, 'toilet', 4, 0, 0, 1, 0, 0, 39, 167, 0, '', '1', '0'),
	(166, '179', 182, 'duck', 4, 0, 0, 1, 0, 0, 34, 168, 0, '', '1', '0'),
	(167, '180', 182, 'tile', 4, 0, 0, 1, 0, 0, 36, 169, 0, '', '1', '0'),
	(168, '181', 182, 'toilet_red', 4, 0, 0, 1, 0, 0, 40, 170, 0, '', '1', '0'),
	(169, '182', 182, 'toilet_yell', 4, 0, 0, 1, 0, 0, 41, 171, 0, '', '1', '0'),
	(170, '183', 182, 'tile_red', 4, 0, 0, 1, 0, 0, 37, 172, 0, '', '1', '0'),
	(171, '184', 182, 'tile_yell', 4, 0, 0, 1, 0, 0, 38, 173, 0, '', '1', '0'),
	(172, '185', 663, 'prize1', 5, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(173, '186', 663, 'prize2', 5, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(174, '187', 260, 'present_gen', 7, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(175, '188', 260, 'present_gen1', 7, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(176, '189', 260, 'present_gen2', 7, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(177, '190', 260, 'present_gen3', 7, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(178, '191', 260, 'present_gen4', 7, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(179, '192', 260, 'present_gen5', 7, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(180, '193', 260, 'present_gen6', 7, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(181, '195', 180, 'bar_basic', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(182, '196', 180, 'shelves_basic', 4, 0, 0, 1, 0, 0, 4, 3252, 0, '', '1', '0'),
	(183, '197', 27, 'soft_sofachair_norja', 2, 0, 0, 1, 0, 0, 120, 184, 0, '', '1', '0'),
	(184, '198', 27, 'soft_sofa_norja', 3, 0, 0, 1, 0, 0, 135, 183, 0, '', '1', '0'),
	(185, '199', 180, 'lamp_basic', 4, 0, 0, 1, 0, 0, 3, 18197, 0, '', '1', '0'),
	(186, '200', 18, 'lamp2_armas', 4, 0, 0, 1, 0, 0, 12, 3294, 0, '', '1', '0'),
	(187, '201', 180, 'fridge', 4, 0, 0, 1, 0, 0, 2, 18136, 0, '', '1', '0'),
	(188, '202', 224, 'door', 6, 0, 0, 1, 0, 0, 3, 17890, 0, '', '1', '0'),
	(189, '204', 224, 'doorB', 3, 0, 0, 1, 0, 0, 1, 17882, 0, '', '1', '0'),
	(190, '205', 224, 'doorC', 4, 0, 0, 1, 0, 0, 4, 17883, 0, '', '1', '0'),
	(191, '206', 388, 'pumpkin', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(192, '207', 772, 'skullcandle', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(193, '208', 772, 'deadduck', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(195, '210', 388, 'deadduck3', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(196, '211', 473, 'menorah', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(197, '212', 473, 'pudding', 3, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(198, '213', 22, 'ham', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(199, '214', 473, 'turkey', 2, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(200, '215', 473, 'xmasduck', 1, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(201, '216', 473, 'house', 2, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(202, '217', 473, 'triplecandle', 3, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(203, '218', 473, 'tree3', 6, 0, 0, 1, 0, 0, 78, -1, 0, '', '1', '0'),
	(204, '219', 473, 'tree4', 6, 0, 0, 1, 0, 0, 80, -1, 0, '', '1', '0'),
	(205, '220', 473, 'tree5', 6, 0, 0, 1, 0, 0, 79, -1, 0, '', '1', '0'),
	(206, '223', 22, 'ham2', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(207, '224', 473, 'wcandleset', 3, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(208, '225', 473, 'rcandleset', 3, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(209, '226', 445, 'statue', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(210, '228', 445, 'valeduck', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(211, '230', 663, 'throne', 5, 0, 0, 1, 0, 0, 31, -1, 0, '', '1', '0'),
	(212, '231', 663, 'samovar', 5, 0, 0, 1, 0, 0, 29, -1, 0, '', '1', '0'),
	(213, '232', 20, 'giftflowers', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(214, '233', 22, 'habbocake', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(215, '234', 663, 'hologram', 5, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(216, '235', 378, 'easterduck', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(217, '236', 378, 'bunny', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(218, '237', 378, 'basket', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(219, '238', 378, 'birdie', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(220, '239', 22, 'edice', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(221, '243', 663, 'prize3', 5, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(222, '244', 17, 'divider_poly3', 3, 0, 0, 1, 0, 0, 70, 18166, 0, '', '1', '0'),
	(223, '245', 18, 'divider_arm1', 3, 0, 0, 1, 0, 0, 8, 214, 0, '', '1', '0'),
	(224, '246', 18, 'divider_arm2', 4, 0, 0, 1, 0, 0, 9, 215, 0, '', '1', '0'),
	(225, '247', 18, 'divider_arm3', 3, 0, 0, 1, 0, 0, 10, 219, 0, '', '1', '0'),
	(226, '248', 27, 'divider_nor1', 4, 0, 0, 1, 0, 0, 30, 216, 0, '', '1', '0'),
	(227, '249', 281, 'divider_silo1', 3, 0, 0, 1, 0, 0, 64, -1, 0, '', '1', '0'),
	(228, '250', 27, 'divider_nor2', 4, 0, 0, 1, 0, 0, 45, 217, 0, '', '1', '0'),
	(229, '251', 281, 'divider_silo2', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(230, '252', 27, 'divider_nor3', 4, 0, 0, 1, 0, 0, 60, 3206, 0, '', '1', '0'),
	(231, '253', 281, 'divider_silo3', 3, 0, 0, 1, 0, 0, 75, -1, 0, '', '1', '0'),
	(232, '254', 663, 'typingmachine', 5, 0, 0, 1, 0, 0, 32, -1, 0, '', '1', '0'),
	(233, '260', 663, 'spyro', 5, 0, 0, 1, 0, 0, 30, -1, 0, '', '1', '0'),
	(234, '261', 663, 'redhologram', 5, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(235, '263', 22, 'camera', 10, 0, 0, 1, 0, 0, 30, -1, 0, '', '1', '0'),
	(236, '264', 473, 'joulutahti', 3, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(237, '265', 473, 'hyacinth1', 3, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(238, '266', 473, 'hyacinth2', 3, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(239, '267', 349, 'club_sofa', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '1'),
	(240, '268', 511, 'chair_plasto*10', 2, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(241, '269', 511, 'chair_plasto*11', 2, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(242, '270', 429, 'bardeskcorner_polyfon*12', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(243, '271', 429, 'bardeskcorner_polyfon*13', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '0', '0'),
	(244, '273', 511, 'chair_plasto*12', 2, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(245, '274', 511, 'chair_plasto*13', 3, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(246, '275', 349, 'chair_plasto*14', 5, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '1'),
	(247, '276', 349, 'table_plasto_4leg*14', 5, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '1'),
	(248, '277', 349, 'mocchamaster', 5, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '1'),
	(249, '278', 217, 'carpet_legocourt', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(250, '279', 217, 'bench_lego', 4, 0, 0, 1, 0, 0, 99, 18385, 0, '', '1', '0'),
	(251, '280', 217, 'legotrophy', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(252, '283', 663, 'valentinescreen', 5, 0, 0, 1, 0, 0, 33, -1, 0, '', '1', '0'),
	(253, '284', 349, 'edicehc', 5, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '1'),
	(254, '285', 663, 'rare_daffodil_rug', 5, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(255, '286', 663, 'rare_beehive_bulb', 5, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(256, '287', 349, 'hcsohva', 5, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '1'),
	(257, '288', 349, 'hcamme', 5, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '1'),
	(258, '289', 663, 'rare_parasol*0', 5, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(259, '290', 663, 'rare_elephant_statue', 5, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(260, '291', 663, 'rare_fountain', 5, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(261, '292', 663, 'rare_stand', 5, 0, 0, 1, 0, 0, 27, -1, 0, '', '1', '0'),
	(262, '293', 663, 'rare_globe', 5, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(263, '294', 663, 'rare_hammock', 5, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(264, '295', 663, 'rare_elephant_statue*1', 5, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(265, '296', 663, 'rare_elephant_statue*2', 5, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(266, '297', 663, 'rare_fountain*1', 5, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(267, '298', 663, 'rare_fountain*2', 5, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(268, '299', 663, 'rare_fountain*3', 5, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(269, '300', 663, 'rare_beehive_bulb*1', 5, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(270, '301', 663, 'rare_beehive_bulb*2', 5, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(271, '302', 663, 'rare_xmas_screen', 5, 0, 0, 1, 0, 0, 34, -1, 0, '', '1', '0'),
	(272, '303', 663, 'rare_parasol*1', 5, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(273, '304', 663, 'rare_parasol*2', 5, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(274, '305', 663, 'rare_parasol*3', 5, 0, 0, 1, 0, 0, 26, -1, 0, '', '1', '0'),
	(275, '420', 429, 'soft_jaggara_norja', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '0', '0'),
	(276, '428', 473, 'house2', 2, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(277, '449', 663, 'djesko_turntable', 5, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(278, '456', 198, 'md_sofa', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(279, '457', 663, 'md_limukaappi', 5, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(280, '1001', 429, 'Chess', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '0', '0'),
	(281, '1011', 429, 'TicTacToe', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '0', '0'),
	(282, '1021', 429, 'BattleShip', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '0', '0'),
	(283, '1484', 511, 'table_plasto_4leg*10', 5, 0, 0, 1, 0, 0, 50, -1, 0, '', '1', '0'),
	(284, '1486', 511, 'table_plasto_4leg*15', 5, 0, 0, 1, 0, 0, 51, -1, 0, '', '1', '0'),
	(285, '1487', 511, 'table_plasto_bigsquare*14', 5, 0, 0, 1, 0, 0, 70, -1, 0, '', '1', '0'),
	(286, '1488', 511, 'table_plasto_bigsquare*15', 5, 0, 0, 1, 0, 0, 71, -1, 0, '', '1', '0'),
	(287, '1489', 511, 'table_plasto_round*14', 5, 0, 0, 1, 0, 0, 90, -1, 0, '', '1', '0'),
	(288, '1490', 511, 'table_plasto_round*15', 5, 0, 0, 1, 0, 0, 91, -1, 0, '', '1', '0'),
	(289, '1491', 511, 'table_plasto_square*14', 2, 0, 0, 1, 0, 0, 110, -1, 0, '', '1', '0'),
	(290, '1492', 511, 'table_plasto_square*15', 2, 0, 0, 1, 0, 0, 111, -1, 0, '', '1', '0'),
	(291, '1495', 511, 'chair_plasto*15', 2, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(292, '1496', 511, 'chair_plasty*7', 2, 0, 0, 1, 0, 0, 27, -1, 0, '', '1', '0'),
	(293, '1497', 511, 'chair_plasty*8', 2, 0, 0, 1, 0, 0, 28, -1, 0, '', '1', '0'),
	(294, '1498', 511, 'chair_plasty*9', 2, 0, 0, 1, 0, 0, 29, -1, 0, '', '1', '0'),
	(295, '1499', 511, 'chair_plasty*10', 2, 0, 0, 1, 0, 0, 30, -1, 0, '', '1', '0'),
	(296, '1500', 511, 'chair_plasty*11', 2, 0, 0, 1, 0, 0, 31, -1, 0, '', '1', '0'),
	(297, '1501', 511, 'chair_plasto*16', 2, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(298, '1502', 511, 'table_plasto_4leg*16', 5, 0, 0, 1, 0, 0, 52, -1, 0, '', '1', '0'),
	(299, '1503', 217, 'hockey_score', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(300, '1504', 217, 'hockey_light', 3, 0, 0, 1, 0, 0, 99, 17946, 0, '', '1', '0'),
	(301, '1505', 349, 'doorD', 5, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '1'),
	(302, '1506', 225, 'prizetrophy2*3', 8, 0, 0, 1, 0, 0, 6, 421, 0, '', '1', '0'),
	(303, '1507', 225, 'prizetrophy3*3', 8, 0, 0, 1, 0, 0, 9, 422, 0, '', '1', '0'),
	(304, '1508', 225, 'prizetrophy4*3', 8, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(305, '1509', 225, 'prizetrophy5*3', 8, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(306, '1510', 225, 'prizetrophy6*3', 8, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(307, '1512', 225, 'prizetrophy*1', 12, 0, 0, 1, 0, 0, 1, 427, 0, '', '1', '0'),
	(308, '1513', 225, 'prizetrophy2*1', 12, 0, 0, 1, 0, 0, 4, 428, 0, '', '1', '0'),
	(309, '1514', 225, 'prizetrophy3*1', 12, 0, 0, 1, 0, 0, 7, 429, 0, '', '1', '0'),
	(310, '1515', 225, 'prizetrophy4*1', 12, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(311, '1516', 225, 'prizetrophy5*1', 12, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(312, '1517', 225, 'prizetrophy6*1', 12, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(313, '1518', 736, 'prizetrophy7*1', 12, 0, 0, 1, 0, 0, -3, -1, 0, '', '1', '0'),
	(314, '1519', 225, 'prizetrophy*2', 10, 0, 0, 1, 0, 0, 2, 434, 0, '', '1', '0'),
	(315, '1520', 225, 'prizetrophy2*2', 10, 0, 0, 1, 0, 0, 5, 435, 0, '', '1', '0'),
	(316, '1521', 225, 'prizetrophy3*2', 10, 0, 0, 1, 0, 0, 8, 436, 0, '', '1', '0'),
	(317, '1522', 225, 'prizetrophy4*2', 10, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(318, '1523', 225, 'prizetrophy5*2', 10, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(319, '1524', 225, 'prizetrophy6*2', 10, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(320, '1525', 736, 'prizetrophy7*2', 10, 0, 0, 1, 0, 0, -2, -1, 0, '', '1', '0'),
	(321, '1526', 225, 'prizetrophy*3', 8, 0, 0, 1, 0, 0, 3, 441, 0, '', '1', '0'),
	(322, '1527', 349, 'hc_chr', 5, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '1'),
	(323, '1528', 349, 'hc_tbl', 5, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '1'),
	(324, '1529', 349, 'hc_lmp', 5, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '1'),
	(325, '1530', 349, 'hc_dsk', 5, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '1'),
	(326, '1531', 115, 'nest', 2, 0, 0, 1, 0, 0, 29, -1, 0, '', '1', '0'),
	(327, '1532', 52, 'petfood1', 1, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(328, '1533', 52, 'petfood2', 1, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(329, '1534', 52, 'petfood3', 1, 0, 0, 1, 0, 0, 1, 4591, 0, '', '1', '0'),
	(330, '1535', 115, 'waterbowl*4', 2, 0, 0, 1, 0, 0, 60, 456, 0, '', '1', '0'),
	(331, '1536', 115, 'waterbowl*5', 2, 0, 0, 1, 0, 0, 59, 457, 0, '', '1', '0'),
	(332, '1537', 115, 'waterbowl*2', 2, 0, 0, 1, 0, 0, 58, 458, 0, '', '1', '0'),
	(333, '1538', 115, 'waterbowl*1', 2, 0, 0, 1, 0, 0, 57, 459, 0, '', '1', '0'),
	(334, '1539', 115, 'waterbowl*3', 2, 0, 0, 1, 0, 0, 28, 460, 0, '', '1', '0'),
	(335, '1540', 115, 'toy1', 2, 0, 0, 1, 0, 0, 27, 461, 0, '', '1', '0'),
	(336, '1541', 115, 'toy1*1', 2, 0, 0, 1, 0, 0, 54, 462, 0, '', '1', '0'),
	(337, '1542', 115, 'toy1*2', 2, 0, 0, 1, 0, 0, 26, 463, 0, '', '1', '0'),
	(338, '1543', 115, 'toy1*3', 2, 0, 0, 1, 0, 0, 25, 464, 0, '', '1', '0'),
	(339, '1544', 115, 'toy1*4', 2, 0, 0, 1, 0, 0, 51, 465, 0, '', '1', '0'),
	(340, '1545', 52, 'goodie1', 1, 0, 0, 1, 0, 0, 33, -1, 0, '', '1', '0'),
	(341, '1546', 52, 'goodie1*1', 1, 0, 0, 1, 0, 0, 34, -1, 0, '', '1', '0'),
	(342, '1547', 52, 'goodie1*2', 1, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(343, '1548', 52, 'goodie2', 1, 0, 0, 1, 0, 0, 32, -1, 0, '', '1', '0'),
	(344, '1549', 331, 'scifiport*0', 5, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(345, '1550', 331, 'scifiport*9', 5, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(346, '1551', 331, 'scifiport*8', 5, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(347, '1552', 331, 'scifiport*7', 5, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(348, '1553', 331, 'scifiport*6', 5, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(349, '1554', 331, 'scifiport*5', 5, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(350, '1555', 331, 'scifiport*4', 5, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(351, '1556', 331, 'scifiport*3', 5, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(352, '1557', 331, 'scifiport*2', 5, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(353, '1558', 331, 'scifiport*1', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(354, '1559', 336, 'scifirocket*9', 5, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(355, '1560', 336, 'scifirocket*8', 5, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(356, '1561', 336, 'scifirocket*7', 5, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(357, '1562', 336, 'scifirocket*6', 5, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(358, '1563', 336, 'scifirocket*5', 5, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(359, '1564', 336, 'scifirocket*4', 5, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(360, '1565', 336, 'scifirocket*3', 5, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(361, '1566', 336, 'scifirocket*2', 5, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(362, '1567', 336, 'scifirocket*1', 5, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(363, '1568', 336, 'scifirocket*0', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(364, '1569', 333, 'scifidoor*10', 5, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(365, '1570', 333, 'scifidoor*9', 5, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(366, '1571', 333, 'scifidoor*8', 5, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(367, '1572', 333, 'scifidoor*7', 5, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(368, '1573', 333, 'scifidoor*6', 5, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(369, '1574', 333, 'scifidoor*5', 5, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(370, '1575', 333, 'scifidoor*4', 5, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(371, '1576', 333, 'scifidoor*3', 5, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(372, '1577', 333, 'scifidoor*2', 5, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(373, '1578', 333, 'scifidoor*1', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(374, '1579', 347, 'pillow*5', 5, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(375, '1580', 347, 'pillow*8', 5, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(376, '1581', 347, 'pillow*0', 5, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(377, '1582', 347, 'pillow*1', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(378, '1583', 347, 'pillow*2', 5, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(379, '1584', 347, 'pillow*7', 5, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(380, '1585', 347, 'pillow*9', 5, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(381, '1586', 347, 'pillow*4', 5, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(382, '1587', 347, 'pillow*6', 5, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(383, '1588', 347, 'pillow*3', 5, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(384, '1589', 332, 'marquee*1', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(385, '1590', 332, 'marquee*2', 5, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(386, '1591', 332, 'marquee*7', 5, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(387, '1592', 332, 'marquee*10', 5, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(388, '1593', 332, 'marquee*8', 5, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(389, '1594', 332, 'marquee*9', 5, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(390, '1595', 332, 'marquee*5', 5, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(391, '1596', 332, 'marquee*4', 5, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(392, '1597', 332, 'marquee*6', 5, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(393, '1598', 332, 'marquee*3', 5, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(394, '1599', 334, 'wooden_screen*1', 5, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(395, '1600', 334, 'wooden_screen*2', 5, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(396, '1601', 334, 'wooden_screen*7', 5, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(397, '1602', 334, 'wooden_screen*0', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(398, '1603', 334, 'wooden_screen*8', 5, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(399, '1604', 334, 'wooden_screen*5', 5, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(400, '1605', 334, 'wooden_screen*9', 5, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(401, '1606', 334, 'wooden_screen*4', 5, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(402, '1607', 334, 'wooden_screen*6', 5, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(403, '1608', 334, 'wooden_screen*3', 5, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(404, '1609', 335, 'pillar*6', 5, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(405, '1610', 335, 'pillar*1', 5, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(406, '1611', 335, 'pillar*9', 5, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(407, '1612', 335, 'pillar*0', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(408, '1613', 335, 'pillar*8', 5, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(409, '1614', 335, 'pillar*2', 5, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(410, '1615', 335, 'pillar*5', 5, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(411, '1616', 335, 'pillar*4', 5, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(412, '1617', 335, 'pillar*7', 5, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(413, '1618', 335, 'pillar*3', 5, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(414, '1619', 328, 'rare_dragonlamp*4', 5, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(415, '1620', 328, 'rare_dragonlamp*0', 5, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(416, '1621', 328, 'rare_dragonlamp*5', 5, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(417, '1622', 328, 'rare_dragonlamp*2', 5, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(418, '1623', 328, 'rare_dragonlamp*8', 5, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(419, '1624', 328, 'rare_dragonlamp*9', 5, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(420, '1625', 328, 'rare_dragonlamp*7', 5, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(421, '1626', 328, 'rare_dragonlamp*6', 5, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(422, '1627', 328, 'rare_dragonlamp*1', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(423, '1628', 328, 'rare_dragonlamp*3', 5, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(424, '1629', 330, 'rare_icecream*1', 5, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(425, '1630', 330, 'rare_icecream*7', 5, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(426, '1631', 330, 'rare_icecream*8', 5, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(427, '1632', 330, 'rare_icecream*2', 5, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(428, '1633', 330, 'rare_icecream*6', 5, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(429, '1634', 330, 'rare_icecream*9', 5, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(430, '1635', 330, 'rare_icecream*3', 5, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(431, '1636', 330, 'rare_icecream*0', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(432, '1637', 330, 'rare_icecream*4', 5, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(433, '1638', 330, 'rare_icecream*5', 5, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(434, '1639', 329, 'rare_fan*7', 5, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(435, '1640', 329, 'rare_fan*6', 5, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(436, '1641', 329, 'rare_fan*9', 5, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(437, '1642', 329, 'rare_fan*3', 5, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(438, '1643', 329, 'rare_fan*0', 5, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(439, '1644', 329, 'rare_fan*4', 5, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(440, '1645', 329, 'rare_fan*5', 5, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(441, '1646', 329, 'rare_fan*1', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(442, '1647', 329, 'rare_fan*8', 5, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(443, '1648', 329, 'rare_fan*2', 5, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(444, '1649', 42, 'queue_tile1*3', 7, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(445, '1650', 42, 'queue_tile1*6', 7, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(446, '1651', 42, 'queue_tile1*4', 7, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(447, '1652', 42, 'queue_tile1*9', 7, 0, 0, 1, 0, 0, 4, 590, 0, '', '1', '0'),
	(448, '1653', 42, 'queue_tile1*8', 7, 0, 0, 1, 0, 0, 5, 591, 0, '', '1', '0'),
	(449, '1654', 42, 'queue_tile1*5', 7, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(450, '1655', 42, 'queue_tile1*7', 7, 0, 0, 1, 0, 0, 7, 597, 0, '', '1', '0'),
	(451, '1656', 42, 'queue_tile1*2', 7, 0, 0, 1, 0, 0, 8, 17887, 0, '', '1', '0'),
	(452, '1657', 42, 'queue_tile1*1', 7, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(453, '1658', 42, 'queue_tile1*0', 7, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(454, '1659', 429, 'ticket', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '0', '0'),
	(455, '1738', 344, 'rare_snowrug', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(456, '1741', 302, 'cn_lamp', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(457, '1742', 302, 'cn_sofa', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(458, '1745', 217, 'sporttrack1*1', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(459, '1747', 217, 'sporttrack1*3', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(460, '1748', 217, 'sporttrack1*2', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(461, '1750', 217, 'sporttrack2*1', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(462, '1751', 217, 'sporttrack2*2', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(463, '1752', 217, 'sporttrack2*3', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(464, '1754', 217, 'sporttrack3*1', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(465, '1755', 217, 'sporttrack3*2', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(466, '1756', 217, 'sporttrack3*3', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(467, '1757', 217, 'footylamp', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(468, '1758', 473, 'tree1', 6, 0, 0, 1, 0, 0, 84, -1, 0, '', '1', '0'),
	(469, '1759', 281, 'barchair_silo', 2, 0, 0, 1, 0, 0, 84, -1, 0, '', '1', '0'),
	(470, '1760', 27, 'divider_nor4*4', 4, 0, 0, 1, 0, 0, 78, 680, 0, '', '1', '0'),
	(471, '1761', 343, 'traffic_light*1', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(472, '1762', 343, 'traffic_light*2', 4, 0, 0, 1, 0, 0, 2, 682, 0, '', '1', '0'),
	(473, '1763', 343, 'traffic_light*3', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(474, '1764', 343, 'traffic_light*4', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(475, '1765', 343, 'traffic_light*6', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(476, '1766', 342, 'rubberchair*1', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(477, '1767', 342, 'rubberchair*2', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(478, '1768', 342, 'rubberchair*3', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(479, '1769', 342, 'rubberchair*4', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(480, '1770', 342, 'rubberchair*5', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(481, '1771', 342, 'rubberchair*6', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(482, '1772', 343, 'barrier*1', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(483, '1773', 343, 'barrier*2', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(484, '1774', 343, 'barrier*3', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(485, '1775', 342, 'rubberchair*7', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(486, '1776', 342, 'rubberchair*8', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(487, '1777', 27, 'table_norja_med*2', 5, 0, 0, 1, 0, 0, 166, 697, 0, '', '1', '0'),
	(488, '1778', 27, 'table_norja_med*3', 5, 0, 0, 1, 0, 0, 167, 698, 0, '', '1', '0'),
	(489, '1779', 27, 'table_norja_med*4', 5, 0, 0, 1, 0, 0, 168, 699, 0, '', '1', '0'),
	(490, '1780', 27, 'table_norja_med*5', 5, 0, 0, 1, 0, 0, 169, 700, 0, '', '1', '0'),
	(491, '1781', 27, 'table_norja_med*6', 5, 0, 0, 1, 0, 0, 170, 701, 0, '', '1', '0'),
	(492, '1782', 27, 'table_norja_med*7', 5, 0, 0, 1, 0, 0, 171, 702, 0, '', '1', '0'),
	(493, '1783', 27, 'table_norja_med*8', 5, 0, 0, 1, 0, 0, 172, 703, 0, '', '1', '0'),
	(494, '1784', 27, 'table_norja_med*9', 5, 0, 0, 1, 0, 0, 173, 704, 0, '', '1', '0'),
	(495, '1785', 27, 'couch_norja*2', 4, 0, 0, 1, 0, 0, 16, 705, 0, '', '1', '0'),
	(496, '1786', 27, 'couch_norja*3', 4, 0, 0, 1, 0, 0, 17, 706, 0, '', '1', '0'),
	(497, '1787', 27, 'couch_norja*4', 4, 0, 0, 1, 0, 0, 18, 707, 0, '', '1', '0'),
	(498, '1788', 27, 'couch_norja*5', 4, 0, 0, 1, 0, 0, 19, 708, 0, '', '1', '0'),
	(499, '1789', 27, 'couch_norja*6', 4, 0, 0, 1, 0, 0, 20, 709, 0, '', '1', '0'),
	(500, '1790', 27, 'couch_norja*7', 4, 0, 0, 1, 0, 0, 21, 710, 0, '', '1', '0'),
	(501, '1791', 27, 'couch_norja*8', 4, 0, 0, 1, 0, 0, 22, 711, 0, '', '1', '0'),
	(502, '1792', 27, 'couch_norja*9', 4, 0, 0, 1, 0, 0, 23, 712, 0, '', '1', '0'),
	(503, '1793', 27, 'shelves_norja*2', 4, 0, 0, 1, 0, 0, 106, 713, 0, '', '1', '0'),
	(504, '1794', 27, 'shelves_norja*3', 4, 0, 0, 1, 0, 0, 107, 714, 0, '', '1', '0'),
	(505, '1795', 27, 'shelves_norja*4', 4, 0, 0, 1, 0, 0, 108, 715, 0, '', '1', '0'),
	(506, '1796', 27, 'shelves_norja*5', 4, 0, 0, 1, 0, 0, 109, 716, 0, '', '1', '0'),
	(507, '1797', 27, 'shelves_norja*6', 4, 0, 0, 1, 0, 0, 110, 717, 0, '', '1', '0'),
	(508, '1798', 27, 'shelves_norja*7', 4, 0, 0, 1, 0, 0, 111, 718, 0, '', '1', '0'),
	(509, '1799', 27, 'shelves_norja*8', 4, 0, 0, 1, 0, 0, 112, 719, 0, '', '1', '0'),
	(510, '1800', 27, 'shelves_norja*9', 4, 0, 0, 1, 0, 0, 113, 720, 0, '', '1', '0'),
	(511, '1801', 27, 'chair_norja*2', 2, 0, 0, 1, 0, 0, 2, 18803, 0, '', '1', '0'),
	(512, '1802', 27, 'chair_norja*3', 2, 0, 0, 1, 0, 0, 3, 18099, 0, '', '1', '0'),
	(513, '1803', 27, 'chair_norja*4', 2, 0, 0, 1, 0, 0, 4, 18086, 0, '', '1', '0'),
	(514, '1804', 27, 'chair_norja*5', 2, 0, 0, 1, 0, 0, 5, 18120, 0, '', '1', '0'),
	(515, '1805', 27, 'chair_norja*6', 2, 0, 0, 1, 0, 0, 6, 18103, 0, '', '1', '0'),
	(516, '1806', 27, 'chair_norja*7', 2, 0, 0, 1, 0, 0, 7, 18094, 0, '', '1', '0'),
	(517, '1807', 27, 'chair_norja*8', 2, 0, 0, 1, 0, 0, 8, 18079, 0, '', '1', '0'),
	(518, '1808', 27, 'chair_norja*9', 2, 0, 0, 1, 0, 0, 9, 18121, 0, '', '1', '0'),
	(519, '1809', 27, 'divider_nor1*2', 4, 0, 0, 1, 0, 0, 31, 729, 0, '', '1', '0'),
	(520, '1810', 27, 'divider_nor1*3', 4, 0, 0, 1, 0, 0, 32, 730, 0, '', '1', '0'),
	(521, '1811', 27, 'divider_nor1*4', 4, 0, 0, 1, 0, 0, 33, 731, 0, '', '1', '0'),
	(522, '1812', 27, 'divider_nor1*5', 4, 0, 0, 1, 0, 0, 34, 732, 0, '', '1', '0'),
	(523, '1813', 27, 'divider_nor1*6', 4, 0, 0, 1, 0, 0, 35, 733, 0, '', '1', '0'),
	(524, '1814', 27, 'divider_nor1*7', 4, 0, 0, 1, 0, 0, 36, 734, 0, '', '1', '0'),
	(525, '1815', 27, 'divider_nor1*8', 4, 0, 0, 1, 0, 0, 37, 735, 0, '', '1', '0'),
	(526, '1816', 27, 'divider_nor1*9', 4, 0, 0, 1, 0, 0, 38, 736, 0, '', '1', '0'),
	(527, '1817', 27, 'soft_sofa_norja*2', 3, 0, 0, 1, 0, 0, 136, 737, 0, '', '1', '0'),
	(528, '1818', 27, 'soft_sofa_norja*3', 3, 0, 0, 1, 0, 0, 137, 738, 0, '', '1', '0'),
	(529, '1819', 27, 'soft_sofa_norja*4', 3, 0, 0, 1, 0, 0, 138, 739, 0, '', '1', '0'),
	(530, '1820', 27, 'soft_sofa_norja*5', 3, 0, 0, 1, 0, 0, 139, 740, 0, '', '1', '0'),
	(531, '1821', 27, 'soft_sofa_norja*6', 3, 0, 0, 1, 0, 0, 140, 741, 0, '', '1', '0'),
	(532, '1822', 27, 'soft_sofa_norja*7', 3, 0, 0, 1, 0, 0, 146, 742, 0, '', '1', '0'),
	(533, '1823', 27, 'soft_sofa_norja*8', 3, 0, 0, 1, 0, 0, 147, 743, 0, '', '1', '0'),
	(534, '1824', 27, 'soft_sofa_norja*9', 3, 0, 0, 1, 0, 0, 148, 744, 0, '', '1', '0'),
	(535, '1825', 27, 'soft_sofachair_norja*2', 2, 0, 0, 1, 0, 0, 121, 745, 0, '', '1', '0'),
	(536, '1826', 27, 'soft_sofachair_norja*3', 2, 0, 0, 1, 0, 0, 122, 746, 0, '', '1', '0'),
	(537, '1827', 27, 'soft_sofachair_norja*4', 2, 0, 0, 1, 0, 0, 123, 747, 0, '', '1', '0'),
	(538, '1828', 27, 'soft_sofachair_norja*5', 2, 0, 0, 1, 0, 0, 124, 748, 0, '', '1', '0'),
	(539, '1829', 27, 'soft_sofachair_norja*6', 2, 0, 0, 1, 0, 0, 125, 749, 0, '', '1', '0'),
	(540, '1830', 27, 'soft_sofachair_norja*7', 2, 0, 0, 1, 0, 0, 126, 750, 0, '', '1', '0'),
	(541, '1831', 27, 'soft_sofachair_norja*8', 2, 0, 0, 1, 0, 0, 127, 751, 0, '', '1', '0'),
	(542, '1832', 27, 'soft_sofachair_norja*9', 2, 0, 0, 1, 0, 0, 128, 752, 0, '', '1', '0'),
	(543, '1833', 281, 'sofachair_silo*2', 2, 0, 0, 1, 0, 0, 45, -1, 0, '', '1', '0'),
	(544, '1834', 281, 'sofachair_silo*3', 2, 0, 0, 1, 0, 0, 46, -1, 0, '', '1', '0'),
	(545, '1835', 281, 'sofachair_silo*4', 2, 0, 0, 1, 0, 0, 47, -1, 0, '', '1', '0'),
	(546, '1836', 281, 'sofachair_silo*5', 2, 0, 0, 1, 0, 0, 48, -1, 0, '', '1', '0'),
	(547, '1837', 281, 'sofachair_silo*6', 2, 0, 0, 1, 0, 0, 49, -1, 0, '', '1', '0'),
	(548, '1838', 281, 'sofachair_silo*7', 2, 0, 0, 1, 0, 0, 50, -1, 0, '', '1', '0'),
	(549, '1839', 281, 'sofachair_silo*8', 2, 0, 0, 1, 0, 0, 51, -1, 0, '', '1', '0'),
	(550, '1840', 281, 'sofachair_silo*9', 2, 0, 0, 1, 0, 0, 52, -1, 0, '', '1', '0'),
	(551, '1841', 281, 'table_silo_small*2', 2, 0, 0, 1, 0, 0, 55, -1, 0, '', '1', '0'),
	(552, '1842', 281, 'table_silo_small*3', 2, 0, 0, 1, 0, 0, 56, -1, 0, '', '1', '0'),
	(553, '1843', 281, 'table_silo_small*4', 2, 0, 0, 1, 0, 0, 57, -1, 0, '', '1', '0'),
	(554, '1844', 281, 'table_silo_small*5', 2, 0, 0, 1, 0, 0, 58, -1, 0, '', '1', '0'),
	(555, '1845', 281, 'table_silo_small*6', 2, 0, 0, 1, 0, 0, 59, -1, 0, '', '1', '0'),
	(556, '1846', 281, 'table_silo_small*7', 2, 0, 0, 1, 0, 0, 60, -1, 0, '', '1', '0'),
	(557, '1847', 281, 'table_silo_small*8', 2, 0, 0, 1, 0, 0, 61, -1, 0, '', '1', '0'),
	(558, '1848', 281, 'table_silo_small*9', 2, 0, 0, 1, 0, 0, 62, -1, 0, '', '1', '0'),
	(559, '1849', 281, 'divider_silo1*2', 3, 0, 0, 1, 0, 0, 65, -1, 0, '', '1', '0'),
	(560, '1850', 281, 'divider_silo1*3', 3, 0, 0, 1, 0, 0, 66, -1, 0, '', '1', '0'),
	(561, '1851', 281, 'divider_silo1*4', 3, 0, 0, 1, 0, 0, 67, -1, 0, '', '1', '0'),
	(562, '1852', 281, 'divider_silo1*5', 3, 0, 0, 1, 0, 0, 68, -1, 0, '', '1', '0'),
	(563, '1853', 281, 'divider_silo1*6', 3, 0, 0, 1, 0, 0, 69, -1, 0, '', '1', '0'),
	(564, '1854', 281, 'divider_silo1*7', 3, 0, 0, 1, 0, 0, 70, -1, 0, '', '1', '0'),
	(565, '1855', 281, 'divider_silo1*8', 3, 0, 0, 1, 0, 0, 71, -1, 0, '', '1', '0'),
	(566, '1856', 281, 'divider_silo1*9', 3, 0, 0, 1, 0, 0, 72, -1, 0, '', '1', '0'),
	(567, '1857', 281, 'divider_silo3*2', 3, 0, 0, 1, 0, 0, 74, -1, 0, '', '1', '0'),
	(568, '1858', 281, 'divider_silo3*3', 3, 0, 0, 1, 0, 0, 76, -1, 0, '', '1', '0'),
	(569, '1859', 281, 'divider_silo3*4', 3, 0, 0, 1, 0, 0, 77, -1, 0, '', '1', '0'),
	(570, '1860', 281, 'divider_silo3*5', 3, 0, 0, 1, 0, 0, 78, -1, 0, '', '1', '0'),
	(571, '1861', 281, 'divider_silo3*6', 3, 0, 0, 1, 0, 0, 79, -1, 0, '', '1', '0'),
	(572, '1862', 281, 'divider_silo3*7', 3, 0, 0, 1, 0, 0, 80, -1, 0, '', '1', '0'),
	(573, '1863', 281, 'divider_silo3*8', 3, 0, 0, 1, 0, 0, 81, -1, 0, '', '1', '0'),
	(574, '1864', 281, 'divider_silo3*9', 3, 0, 0, 1, 0, 0, 82, -1, 0, '', '1', '0'),
	(575, '1865', 281, 'table_silo_med*2', 5, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(576, '1866', 281, 'table_silo_med*3', 5, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(577, '1867', 281, 'table_silo_med*4', 5, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(578, '1868', 281, 'table_silo_med*5', 5, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(579, '1869', 281, 'table_silo_med*6', 5, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(580, '1870', 281, 'table_silo_med*7', 5, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(581, '1871', 281, 'table_silo_med*8', 5, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(582, '1872', 281, 'table_silo_med*9', 5, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(583, '1873', 281, 'sofa_silo*2', 3, 0, 0, 1, 0, 0, 35, -1, 0, '', '1', '0'),
	(584, '1874', 281, 'sofa_silo*3', 3, 0, 0, 1, 0, 0, 36, -1, 0, '', '1', '0'),
	(585, '1875', 281, 'sofa_silo*4', 3, 0, 0, 1, 0, 0, 37, -1, 0, '', '1', '0'),
	(586, '1876', 281, 'sofa_silo*5', 3, 0, 0, 1, 0, 0, 38, -1, 0, '', '1', '0'),
	(587, '1877', 281, 'sofa_silo*6', 3, 0, 0, 1, 0, 0, 39, -1, 0, '', '1', '0'),
	(588, '1878', 281, 'sofa_silo*7', 3, 0, 0, 1, 0, 0, 40, -1, 0, '', '1', '0'),
	(589, '1879', 281, 'sofa_silo*8', 3, 0, 0, 1, 0, 0, 41, -1, 0, '', '1', '0'),
	(590, '1880', 281, 'sofa_silo*9', 3, 0, 0, 1, 0, 0, 42, -1, 0, '', '1', '0'),
	(591, '1881', 17, 'sofachair_polyfon*2', 2, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(592, '1882', 17, 'sofachair_polyfon*3', 2, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(593, '1883', 17, 'sofachair_polyfon*4', 2, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(594, '1884', 17, 'sofachair_polyfon*6', 2, 0, 0, 1, 0, 0, 12, 804, 0, '', '1', '0'),
	(595, '1885', 17, 'sofachair_polyfon*7', 2, 0, 0, 1, 0, 0, 13, 805, 0, '', '1', '0'),
	(596, '1886', 17, 'sofachair_polyfon*8', 2, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(597, '1887', 17, 'sofachair_polyfon*9', 2, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(598, '1888', 17, 'sofa_polyfon*2', 3, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(599, '1889', 17, 'sofa_polyfon*3', 3, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(600, '1890', 17, 'sofa_polyfon*4', 3, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(601, '1891', 17, 'sofa_polyfon*6', 3, 0, 0, 1, 0, 0, 22, 811, 0, '', '1', '0'),
	(602, '1892', 17, 'sofa_polyfon*7', 3, 0, 0, 1, 0, 0, 23, 812, 0, '', '1', '0'),
	(603, '1893', 17, 'sofa_polyfon*8', 3, 0, 0, 1, 0, 0, 26, -1, 0, '', '1', '0'),
	(604, '1894', 17, 'sofa_polyfon*9', 3, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(605, '1895', 17, 'bed_polyfon*2', 4, 0, 0, 1, 0, 0, 31, -1, 0, '', '1', '0'),
	(606, '1896', 17, 'bed_polyfon*3', 4, 0, 0, 1, 0, 0, 35, -1, 0, '', '1', '0'),
	(607, '1897', 17, 'bed_polyfon*4', 4, 0, 0, 1, 0, 0, 31, -1, 0, '', '1', '0'),
	(608, '1898', 17, 'bed_polyfon*6', 4, 0, 0, 1, 0, 0, 32, 818, 0, '', '1', '0'),
	(609, '1899', 17, 'bed_polyfon*7', 4, 0, 0, 1, 0, 0, 33, 819, 0, '', '1', '0'),
	(610, '1900', 17, 'bed_polyfon*8', 4, 0, 0, 1, 0, 0, 36, -1, 0, '', '1', '0'),
	(611, '1901', 17, 'bed_polyfon*9', 4, 0, 0, 1, 0, 0, 34, -1, 0, '', '1', '0'),
	(612, '1902', 17, 'bed_polyfon_one*2', 4, 0, 0, 1, 0, 0, 41, -1, 0, '', '1', '0'),
	(613, '1903', 17, 'bed_polyfon_one*3', 4, 0, 0, 1, 0, 0, 45, -1, 0, '', '1', '0'),
	(614, '1904', 17, 'bed_polyfon_one*4', 4, 0, 0, 1, 0, 0, 41, -1, 0, '', '1', '0'),
	(615, '1905', 17, 'bed_polyfon_one*6', 4, 0, 0, 1, 0, 0, 42, 825, 0, '', '1', '0'),
	(616, '1906', 17, 'bed_polyfon_one*7', 4, 0, 0, 1, 0, 0, 43, 826, 0, '', '1', '0'),
	(617, '1907', 17, 'bed_polyfon_one*8', 4, 0, 0, 1, 0, 0, 46, -1, 0, '', '1', '0'),
	(618, '1908', 17, 'bed_polyfon_one*9', 4, 0, 0, 1, 0, 0, 44, -1, 0, '', '1', '0'),
	(619, '1909', 17, 'bardesk_polyfon*2', 5, 0, 0, 1, 0, 0, 51, -1, 0, '', '1', '0'),
	(620, '1910', 17, 'bardesk_polyfon*3', 5, 0, 0, 1, 0, 0, 55, -1, 0, '', '1', '0'),
	(621, '1911', 17, 'bardesk_polyfon*4', 5, 0, 0, 1, 0, 0, 51, -1, 0, '', '1', '0'),
	(622, '1912', 556, 'bardesk_polyfon*5', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(623, '1913', 17, 'bardesk_polyfon*6', 5, 0, 0, 1, 0, 0, 52, 833, 0, '', '1', '0'),
	(624, '1914', 17, 'bardesk_polyfon*7', 5, 0, 0, 1, 0, 0, 53, 834, 0, '', '1', '0'),
	(625, '1915', 17, 'bardesk_polyfon*8', 5, 0, 0, 1, 0, 0, 56, -1, 0, '', '1', '0'),
	(626, '1916', 17, 'bardesk_polyfon*9', 5, 0, 0, 1, 0, 0, 54, -1, 0, '', '1', '0'),
	(627, '1917', 17, 'bardeskcorner_polyfon*2', 5, 0, 0, 1, 0, 0, 61, -1, 0, '', '1', '0'),
	(628, '1918', 17, 'bardeskcorner_polyfon*3', 5, 0, 0, 1, 0, 0, 65, -1, 0, '', '1', '0'),
	(629, '1919', 17, 'bardeskcorner_polyfon*4', 5, 0, 0, 1, 0, 0, 61, -1, 0, '', '1', '0'),
	(630, '1920', 556, 'bardeskcorner_polyfon*5', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(631, '1921', 17, 'bardeskcorner_polyfon*6', 5, 0, 0, 1, 0, 0, 62, 841, 0, '', '1', '0'),
	(632, '1922', 17, 'bardeskcorner_polyfon*7', 5, 0, 0, 1, 0, 0, 63, 842, 0, '', '1', '0'),
	(633, '1923', 17, 'bardeskcorner_polyfon*8', 5, 0, 0, 1, 0, 0, 66, -1, 0, '', '1', '0'),
	(634, '1924', 17, 'bardeskcorner_polyfon*9', 5, 0, 0, 1, 0, 0, 64, -1, 0, '', '1', '0'),
	(635, '1925', 17, 'divider_poly3*2', 3, 0, 0, 1, 0, 0, 71, -1, 0, '', '1', '0'),
	(636, '1926', 17, 'divider_poly3*3', 3, 0, 0, 1, 0, 0, 75, -1, 0, '', '1', '0'),
	(637, '1927', 17, 'divider_poly3*4', 3, 0, 0, 1, 0, 0, 71, -1, 0, '', '1', '0'),
	(638, '1928', 556, 'divider_poly3*5', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(639, '1929', 17, 'divider_poly3*6', 3, 0, 0, 1, 0, 0, 72, 18132, 0, '', '1', '0'),
	(640, '1930', 17, 'divider_poly3*7', 3, 0, 0, 1, 0, 0, 73, 18147, 0, '', '1', '0'),
	(641, '1931', 17, 'divider_poly3*8', 3, 0, 0, 1, 0, 0, 76, -1, 0, '', '1', '0'),
	(642, '1932', 17, 'divider_poly3*9', 3, 0, 0, 1, 0, 0, 74, -1, 0, '', '1', '0'),
	(643, '1933', 281, 'chair_silo*2', 2, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(644, '1934', 281, 'chair_silo*3', 2, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(645, '1935', 281, 'chair_silo*4', 2, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(646, '1936', 281, 'chair_silo*5', 2, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(647, '1937', 281, 'chair_silo*6', 2, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(648, '1938', 281, 'chair_silo*7', 2, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(649, '1939', 281, 'chair_silo*8', 2, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(650, '1940', 281, 'chair_silo*9', 2, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(651, '1941', 27, 'divider_nor3*2', 4, 0, 0, 1, 0, 0, 61, 18792, 0, '', '1', '0'),
	(652, '1942', 27, 'divider_nor3*3', 4, 0, 0, 1, 0, 0, 62, 3183, 0, '', '1', '0'),
	(653, '1943', 27, 'divider_nor3*4', 4, 0, 0, 1, 0, 0, 63, 3207, 0, '', '1', '0'),
	(654, '1944', 27, 'divider_nor3*5', 4, 0, 0, 1, 0, 0, 64, 18092, 0, '', '1', '0'),
	(655, '1945', 27, 'divider_nor3*6', 4, 0, 0, 1, 0, 0, 65, 18119, 0, '', '1', '0'),
	(656, '1946', 27, 'divider_nor3*7', 4, 0, 0, 1, 0, 0, 66, 18075, 0, '', '1', '0'),
	(657, '1947', 27, 'divider_nor3*8', 4, 0, 0, 1, 0, 0, 67, 18112, 0, '', '1', '0'),
	(658, '1948', 27, 'divider_nor3*9', 4, 0, 0, 1, 0, 0, 68, 18095, 0, '', '1', '0'),
	(659, '1949', 27, 'divider_nor2*2', 4, 0, 0, 1, 0, 0, 46, 869, 0, '', '1', '0'),
	(660, '1950', 27, 'divider_nor2*3', 4, 0, 0, 1, 0, 0, 47, 870, 0, '', '1', '0'),
	(661, '1951', 27, 'divider_nor2*4', 4, 0, 0, 1, 0, 0, 48, 871, 0, '', '1', '0'),
	(662, '1952', 27, 'divider_nor2*5', 4, 0, 0, 1, 0, 0, 49, 872, 0, '', '1', '0'),
	(663, '1953', 27, 'divider_nor2*6', 4, 0, 0, 1, 0, 0, 50, 873, 0, '', '1', '0'),
	(664, '1954', 27, 'divider_nor2*7', 4, 0, 0, 1, 0, 0, 51, 874, 0, '', '1', '0'),
	(665, '1955', 27, 'divider_nor2*8', 4, 0, 0, 1, 0, 0, 52, 875, 0, '', '1', '0'),
	(666, '1956', 27, 'divider_nor2*9', 4, 0, 0, 1, 0, 0, 53, 876, 0, '', '1', '0'),
	(667, '1957', 281, 'silo_studydesk', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(668, '1958', 27, 'solarium_norja', 4, 0, 0, 1, 0, 0, 152, 878, 0, '', '1', '0'),
	(669, '1959', 27, 'solarium_norja*1', 4, 0, 0, 1, 0, 0, 150, 879, 0, '', '1', '0'),
	(670, '1960', 27, 'solarium_norja*2', 4, 0, 0, 1, 0, 0, 151, 880, 0, '', '1', '0'),
	(671, '1961', 27, 'solarium_norja*3', 4, 0, 0, 1, 0, 0, 153, 881, 0, '', '1', '0'),
	(672, '1962', 27, 'solarium_norja*5', 4, 0, 0, 1, 0, 0, 154, 882, 0, '', '1', '0'),
	(673, '1963', 27, 'solarium_norja*6', 4, 0, 0, 1, 0, 0, 155, 883, 0, '', '1', '0'),
	(674, '1964', 27, 'solarium_norja*7', 4, 0, 0, 1, 0, 0, 156, 884, 0, '', '1', '0'),
	(675, '1965', 27, 'solarium_norja*8', 4, 0, 0, 1, 0, 0, 157, 885, 0, '', '1', '0'),
	(676, '1966', 27, 'solarium_norja*9', 4, 0, 0, 1, 0, 0, 158, 886, 0, '', '1', '0'),
	(677, '1967', 344, 'sandrug', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(678, '1968', 344, 'rare_moonrug', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(679, '1969', 302, 'chair_china', 2, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(680, '1970', 302, 'china_table', 2, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(681, '1971', 340, 'sleepingbag*1', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(682, '1972', 340, 'sleepingbag*2', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(683, '1973', 340, 'sleepingbag*3', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(684, '1974', 340, 'sleepingbag*4', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(685, '1975', 281, 'safe_silo', 4, 0, 0, 1, 0, 0, 94, -1, 0, '', '1', '0'),
	(686, '1976', 340, 'sleepingbag*7', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(687, '1977', 340, 'sleepingbag*9', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(688, '1978', 340, 'sleepingbag*5', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(689, '1979', 340, 'sleepingbag*10', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(690, '1980', 340, 'sleepingbag*6', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(691, '1981', 340, 'sleepingbag*8', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(692, '1982', 302, 'china_shelve', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(693, '1983', 343, 'traffic_light*5', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(694, '1984', 27, 'divider_nor4*2', 4, 0, 0, 1, 0, 0, 76, 904, 0, '', '1', '0'),
	(695, '1985', 27, 'divider_nor4*3', 4, 0, 0, 1, 0, 0, 77, 905, 0, '', '1', '0'),
	(696, '1986', 27, 'divider_nor4*5', 4, 0, 0, 1, 0, 0, 79, 906, 0, '', '1', '0'),
	(697, '1987', 27, 'divider_nor4*6', 4, 0, 0, 1, 0, 0, 80, 907, 0, '', '1', '0'),
	(698, '1988', 27, 'divider_nor4*7', 4, 0, 0, 1, 0, 0, 81, 908, 0, '', '1', '0'),
	(699, '1989', 27, 'divider_nor4*8', 4, 0, 0, 1, 0, 0, 82, 909, 0, '', '1', '0'),
	(700, '1990', 27, 'divider_nor4*9', 4, 0, 0, 1, 0, 0, 83, 910, 0, '', '1', '0'),
	(701, '1991', 27, 'divider_nor5*2', 4, 0, 0, 1, 0, 0, 91, 18807, 0, '', '1', '0'),
	(702, '1992', 27, 'divider_nor5*3', 4, 0, 0, 1, 0, 0, 92, 3178, 0, '', '1', '0'),
	(703, '1993', 27, 'divider_nor5*4', 4, 0, 0, 1, 0, 0, 93, 3201, 0, '', '1', '0'),
	(704, '1994', 27, 'divider_nor5*5', 4, 0, 0, 1, 0, 0, 94, 18096, 0, '', '1', '0'),
	(705, '1995', 27, 'divider_nor5*6', 4, 0, 0, 1, 0, 0, 95, 18076, 0, '', '1', '0'),
	(706, '1996', 27, 'divider_nor5*7', 4, 0, 0, 1, 0, 0, 96, 18074, 0, '', '1', '0'),
	(707, '1997', 27, 'divider_nor5*8', 4, 0, 0, 1, 0, 0, 97, 18088, 0, '', '1', '0'),
	(708, '1998', 27, 'divider_nor5*9', 4, 0, 0, 1, 0, 0, 98, 18113, 0, '', '1', '0'),
	(709, '1999', 27, 'divider_nor5', 4, 0, 0, 1, 0, 0, 90, 3200, 0, '', '1', '0'),
	(710, '2000', 27, 'divider_nor4', 4, 0, 0, 1, 0, 0, 75, 920, 0, '', '1', '0'),
	(711, '2001', 302, 'wall_china', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(712, '2002', 302, 'corner_china', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(713, '2003', 281, 'barchair_silo*2', 2, 0, 0, 1, 0, 0, 85, -1, 0, '', '1', '0'),
	(714, '2004', 281, 'barchair_silo*3', 2, 0, 0, 1, 0, 0, 86, -1, 0, '', '1', '0'),
	(715, '2005', 281, 'barchair_silo*4', 2, 0, 0, 1, 0, 0, 87, -1, 0, '', '1', '0'),
	(716, '2006', 281, 'barchair_silo*5', 2, 0, 0, 1, 0, 0, 88, -1, 0, '', '1', '0'),
	(717, '2007', 281, 'barchair_silo*6', 2, 0, 0, 1, 0, 0, 89, -1, 0, '', '1', '0'),
	(718, '2008', 281, 'barchair_silo*7', 2, 0, 0, 1, 0, 0, 90, -1, 0, '', '1', '0'),
	(719, '2009', 281, 'barchair_silo*8', 2, 0, 0, 1, 0, 0, 91, -1, 0, '', '1', '0'),
	(720, '2010', 281, 'Poker', 2, 0, 0, 1, 0, 0, 92, -1, 0, '', '1', '0'),
	(721, '2011', 281, 'safe_silo*2', 10, 0, 0, 1, 0, 0, 95, -1, 0, '', '1', '0'),
	(722, '2012', 281, 'safe_silo*3', 10, 0, 0, 1, 0, 0, 96, -1, 0, '', '1', '0'),
	(723, '2013', 281, 'safe_silo*4', 10, 0, 0, 1, 0, 0, 97, -1, 0, '', '1', '0'),
	(724, '2014', 281, 'safe_silo*5', 10, 0, 0, 1, 0, 0, 98, -1, 0, '', '1', '0'),
	(725, '2015', 281, 'safe_silo*6', 10, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(726, '2016', 281, 'safe_silo*7', 10, 0, 0, 1, 0, 0, 100, -1, 0, '', '1', '0'),
	(727, '2017', 281, 'safe_silo*8', 10, 0, 0, 1, 0, 0, 101, -1, 0, '', '1', '0'),
	(728, '2018', 281, 'safe_silo*9', 10, 0, 0, 1, 0, 0, 102, -1, 0, '', '1', '0'),
	(729, '2019', 29, 'glass_shelf', 5, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(730, '2020', 29, 'glass_chair', 2, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(731, '2021', 29, 'glass_stool', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(732, '2022', 29, 'glass_sofa', 3, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(733, '2023', 29, 'glass_table', 5, 0, 0, 1, 0, 0, 28, -1, 0, '', '1', '0'),
	(734, '2024', 29, 'glass_table*2', 5, 0, 0, 1, 0, 0, 29, -1, 0, '', '1', '0'),
	(735, '2025', 29, 'glass_table*3', 5, 0, 0, 1, 0, 0, 30, -1, 0, '', '1', '0'),
	(736, '2026', 29, 'glass_table*4', 5, 0, 0, 1, 0, 0, 31, -1, 0, '', '1', '0'),
	(737, '2027', 29, 'glass_table*5', 5, 0, 0, 1, 0, 0, 32, -1, 0, '', '1', '0'),
	(738, '2028', 29, 'glass_table*6', 5, 0, 0, 1, 0, 0, 33, -1, 0, '', '1', '0'),
	(739, '2029', 29, 'glass_table*7', 5, 0, 0, 1, 0, 0, 34, -1, 0, '', '1', '0'),
	(740, '2030', 29, 'glass_table*8', 5, 0, 0, 1, 0, 0, 35, -1, 0, '', '1', '0'),
	(741, '2031', 29, 'glass_table*9', 5, 0, 0, 1, 0, 0, 36, -1, 0, '', '1', '0'),
	(742, '2032', 29, 'glass_chair*2', 2, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(743, '2033', 29, 'glass_chair*3', 2, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(744, '2034', 29, 'glass_chair*4', 2, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(745, '2035', 29, 'glass_chair*5', 2, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(746, '2036', 29, 'glass_chair*6', 2, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(747, '2037', 29, 'glass_chair*7', 2, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(748, '2038', 29, 'glass_chair*8', 2, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(749, '2039', 29, 'glass_chair*9', 2, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(750, '2040', 29, 'glass_sofa*2', 3, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(751, '2041', 29, 'glass_sofa*3', 3, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(752, '2042', 29, 'glass_sofa*4', 3, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(753, '2043', 29, 'glass_sofa*5', 3, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(754, '2044', 29, 'glass_sofa*6', 3, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(755, '2045', 29, 'glass_sofa*7', 3, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(756, '2046', 29, 'glass_sofa*8', 3, 0, 0, 1, 0, 0, 26, -1, 0, '', '1', '0'),
	(757, '2047', 29, 'glass_sofa*9', 3, 0, 0, 1, 0, 0, 27, -1, 0, '', '1', '0'),
	(758, '2048', 29, 'glass_stool*2', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(759, '2050', 29, 'glass_stool*4', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(760, '2051', 29, 'glass_stool*5', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(761, '2052', 29, 'glass_stool*6', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(762, '2053', 29, 'glass_stool*7', 4, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(763, '2054', 29, 'glass_stool*8', 4, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(764, '2056', 29, 'glass_stool*3', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(765, '2057', 29, 'glass_stool*9', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(766, '2063', 12, 'CF_10_coin_gold', 10, 0, 0, 1, 0, 0, 5, 1197, 0, '', '1', '0'),
	(768, '2065', 12, 'CF_20_moneybag', 20, 0, 0, 1, 0, 0, 6, 1199, 0, '', '1', '0'),
	(769, '2066', 12, 'CF_50_goldbar', 50, 0, 0, 1, 0, 0, 7, 1200, 0, '', '1', '0'),
	(771, '2068', 349, 'hc_crpt', 5, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '1'),
	(772, '2069', 349, 'hc_tv', 5, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '1'),
	(773, '2070', 30, 'gothgate', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(774, '2071', 30, 'gothiccandelabra', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(775, '2072', 30, 'gothrailing', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(776, '2073', 30, 'goth_table', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(777, '2074', 349, 'hc_bkshlf', 5, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '1'),
	(778, '2075', 349, 'hc_btlr', 5, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '1'),
	(779, '2076', 349, 'hc_crtn', 5, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '1'),
	(780, '2077', 349, 'hc_djset', 5, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '1'),
	(781, '2078', 349, 'hc_frplc', 5, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '1'),
	(782, '2079', 349, 'hc_lmpst', 5, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '1'),
	(783, '2080', 349, 'hc_machine', 5, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '1'),
	(784, '2081', 349, 'hc_rllr', 5, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '1'),
	(785, '2082', 349, 'hc_rntgn', 5, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '1'),
	(786, '2083', 349, 'hc_trll', 5, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '1'),
	(787, '2084', 30, 'gothic_chair*1', 2, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(788, '2085', 30, 'gothic_sofa*1', 3, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(789, '2086', 30, 'gothic_stool*1', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(790, '2087', 30, 'gothic_chair*2', 2, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(791, '2088', 30, 'gothic_sofa*2', 3, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(792, '2089', 30, 'gothic_stool*2', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(793, '2090', 30, 'gothic_chair*3', 2, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(794, '2091', 30, 'gothic_sofa*3', 3, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(795, '2092', 30, 'gothic_stool*3', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(796, '2093', 30, 'gothic_chair*4', 2, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(797, '2094', 30, 'gothic_sofa*4', 3, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(798, '2095', 30, 'gothic_stool*4', 4, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(799, '2096', 30, 'gothic_chair*5', 2, 0, 0, 1, 0, 0, 27, -1, 0, '', '1', '0'),
	(800, '2097', 30, 'gothic_sofa*5', 3, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(801, '2098', 30, 'gothic_stool*5', 4, 0, 0, 1, 0, 0, 26, -1, 0, '', '1', '0'),
	(802, '2099', 30, 'gothic_chair*6', 2, 0, 0, 1, 0, 0, 30, -1, 0, '', '1', '0'),
	(803, '2100', 30, 'gothic_sofa*6', 3, 0, 0, 1, 0, 0, 28, -1, 0, '', '1', '0'),
	(804, '2101', 30, 'gothic_stool*6', 4, 0, 0, 1, 0, 0, 29, -1, 0, '', '1', '0'),
	(805, '2102', 473, 'wcandle', 2, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(806, '2103', 445, 'val_cauldron', 10, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(808, '2105', 187, 'sound_machine', 4, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(809, '2106', 35, 'romantique_pianochair*3', 2, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(810, '2107', 35, 'romantique_pianochair*5', 2, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(811, '2108', 35, 'romantique_pianochair*2', 2, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(812, '2109', 35, 'romantique_pianochair*4', 2, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(813, '2110', 35, 'romantique_pianochair*1', 2, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(814, '2111', 35, 'romantique_divan*3', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(815, '2112', 35, 'romantique_divan*5', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(816, '2113', 35, 'romantique_divan*2', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(817, '2114', 35, 'romantique_divan*4', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(818, '2115', 35, 'romantique_divan*1', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(819, '2116', 35, 'romantique_chair*3', 2, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(820, '2117', 35, 'romantique_chair*5', 2, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(821, '2118', 35, 'romantique_chair*2', 2, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(822, '2119', 35, 'romantique_chair*4', 2, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(823, '2120', 35, 'romantique_chair*1', 2, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(824, '2121', 473, 'rcandle', 2, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(825, '2122', 663, 'rare_parasol', 4, 0, 0, 1, 0, 0, 36, -1, 0, '', '1', '0'),
	(826, '2123', 445, 'plant_valentinerose*3', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(827, '2124', 445, 'plant_valentinerose*5', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(828, '2125', 445, 'plant_valentinerose*2', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(829, '2126', 445, 'plant_valentinerose*4', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(830, '2127', 445, 'plant_valentinerose*1', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(831, '2128', 20, 'plant_mazegate', 6, 0, 0, 1, 0, 0, 99, 1266, 0, '', '1', '0'),
	(832, '2129', 20, 'plant_maze', 5, 0, 0, 1, 0, 0, 99, 1267, 0, '', '1', '0'),
	(833, '2130', 20, 'plant_bulrush', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(834, '2131', 52, 'petfood4', 1, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(835, '2132', 445, 'carpet_valentine', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(836, '2133', 30, 'gothic_carpet', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(837, '2134', 30, 'gothic_carpet2', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(838, '2135', 30, 'gothic_chair', 2, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(839, '2136', 30, 'gothic_sofa', 3, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(840, '2137', 30, 'gothic_stool', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(841, '2138', 35, 'grand_piano*3', 4, 0, 0, 1, 0, 0, 29, -1, 0, '', '1', '0'),
	(842, '2139', 35, 'grand_piano*5', 4, 0, 0, 1, 0, 0, 31, -1, 0, '', '1', '0'),
	(843, '2140', 35, 'grand_piano*2', 4, 0, 0, 1, 0, 0, 28, -1, 0, '', '1', '0'),
	(844, '2141', 35, 'grand_piano*4', 4, 0, 0, 1, 0, 0, 30, -1, 0, '', '1', '0'),
	(845, '2142', 35, 'grand_piano*1', 4, 0, 0, 1, 0, 0, 27, -1, 0, '', '1', '0'),
	(846, '2143', 280, 'theatre_seat', 4, 0, 0, 1, 0, 0, -5, -1, 0, '', '1', '0'),
	(847, '2144', 35, 'romantique_tray2', 4, 0, 0, 1, 0, 0, 47, -1, 0, '', '1', '0'),
	(848, '2145', 35, 'romantique_tray1', 4, 0, 0, 1, 0, 0, 46, -1, 0, '', '1', '0'),
	(849, '2146', 35, 'romantique_smalltabl*3', 4, 0, 0, 1, 0, 0, 36, -1, 0, '', '1', '0'),
	(850, '2147', 35, 'romantique_smalltabl*5', 4, 0, 0, 1, 0, 0, 38, -1, 0, '', '1', '0'),
	(851, '2148', 35, 'romantique_smalltabl*2', 4, 0, 0, 1, 0, 0, 35, -1, 0, '', '1', '0'),
	(852, '2149', 35, 'romantique_smalltabl*4', 4, 0, 0, 1, 0, 0, 37, -1, 0, '', '1', '0'),
	(853, '2150', 35, 'romantique_smalltabl*1', 4, 0, 0, 1, 0, 0, 34, -1, 0, '', '1', '0'),
	(854, '2151', 35, 'romantique_mirrortabl', 4, 0, 0, 1, 0, 0, 45, -1, 0, '', '1', '0'),
	(855, '2152', 35, 'romantique_divider*3', 4, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(856, '2153', 35, 'romantique_divider*2', 4, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(857, '2154', 35, 'romantique_divider*4', 4, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(858, '2155', 35, 'romantique_divider*1', 4, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(859, '2156', 31, 'jp_tatami2', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(860, '2157', 31, 'jp_tatami', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(861, '2158', 663, 'habbowood_chair', 2, 0, 0, 1, 0, 0, 37, -1, 0, '', '1', '0'),
	(862, '2159', 31, 'jp_bamboo', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(863, '2160', 31, 'jp_irori', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(864, '2161', 31, 'jp_pillow', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(865, '2162', 46, 'sound_set_1', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(866, '2163', 46, 'sound_set_2', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(867, '2164', 46, 'sound_set_3', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(868, '2165', 46, 'sound_set_4', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(869, '2166', 46, 'sound_set_5', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(870, '2167', 46, 'sound_set_6', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(871, '2168', 46, 'sound_set_7', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(872, '2169', 46, 'sound_set_8', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(873, '2170', 46, 'sound_set_9', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(874, '2171', 187, 'sound_machine*1', 4, 0, 0, 1, 0, 0, -1, -1, 0, '', '1', '0'),
	(875, '227', 445, 'heart', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(876, '229', 445, 'heartsofa', 3, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(877, '2457', 46, 'sound_set_23', 4, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(878, '2458', 500, 'rclr_garden', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(879, '2459', 500, 'rclr_sofa', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(880, '2460', 180, 'pura_mdl1*1', 4, 0, 0, 1, 0, 0, 50, 1341, 0, '', '1', '0'),
	(881, '2461', 180, 'pura_mdl1*2', 4, 0, 0, 1, 0, 0, 55, 1342, 0, '', '1', '0'),
	(882, '2462', 180, 'pura_mdl1*3', 4, 0, 0, 1, 0, 0, 52, -1, 0, '', '1', '0'),
	(883, '2463', 180, 'pura_mdl1*4', 4, 0, 0, 1, 0, 0, 59, -1, 0, '', '1', '0'),
	(884, '2464', 180, 'pura_mdl1*5', 4, 0, 0, 1, 0, 0, 51, 1345, 0, '', '1', '0'),
	(885, '2465', 180, 'pura_mdl1*6', 4, 0, 0, 1, 0, 0, 53, 1346, 0, '', '1', '0'),
	(886, '2466', 180, 'pura_mdl1*7', 4, 0, 0, 1, 0, 0, 54, 1347, 0, '', '1', '0'),
	(887, '2467', 180, 'pura_mdl1*8', 4, 0, 0, 1, 0, 0, 58, 1348, 0, '', '1', '0'),
	(888, '2468', 180, 'pura_mdl1*9', 4, 0, 0, 1, 0, 0, 57, 1349, 0, '', '1', '0'),
	(889, '2469', 46, 'sound_set_19', 4, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(890, '2470', 46, 'sound_set_25', 4, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(891, '2471', 31, 'jp_lantern', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(892, '2472', 180, 'pura_mdl4*1', 4, 0, 0, 1, 0, 0, 80, 1353, 0, '', '1', '0'),
	(893, '2473', 180, 'pura_mdl4*2', 4, 0, 0, 1, 0, 0, 85, 1354, 0, '', '1', '0'),
	(894, '2474', 180, 'pura_mdl4*3', 4, 0, 0, 1, 0, 0, 82, -1, 0, '', '1', '0'),
	(895, '2475', 180, 'pura_mdl4*4', 4, 0, 0, 1, 0, 0, 89, -1, 0, '', '1', '0'),
	(896, '2476', 180, 'pura_mdl4*5', 4, 0, 0, 1, 0, 0, 81, 1357, 0, '', '1', '0'),
	(897, '2477', 180, 'pura_mdl4*6', 4, 0, 0, 1, 0, 0, 83, 1358, 0, '', '1', '0'),
	(898, '2478', 180, 'pura_mdl4*7', 4, 0, 0, 1, 0, 0, 84, 1359, 0, '', '1', '0'),
	(899, '2479', 180, 'pura_mdl4*8', 4, 0, 0, 1, 0, 0, 88, 1360, 0, '', '1', '0'),
	(900, '2480', 180, 'pura_mdl4*9', 4, 0, 0, 1, 0, 0, 87, 1361, 0, '', '1', '0'),
	(901, '2481', 46, 'sound_set_10', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(902, '2482', 46, 'sound_set_14', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(903, '2483', 180, 'pura_mdl2*1', 4, 0, 0, 1, 0, 0, 60, 1364, 0, '', '1', '0'),
	(904, '2484', 180, 'pura_mdl2*2', 4, 0, 0, 1, 0, 0, 65, 1365, 0, '', '1', '0'),
	(905, '2485', 180, 'pura_mdl2*3', 4, 0, 0, 1, 0, 0, 62, -1, 0, '', '1', '0'),
	(906, '2486', 180, 'pura_mdl2*4', 4, 0, 0, 1, 0, 0, 69, -1, 0, '', '1', '0'),
	(907, '2487', 180, 'pura_mdl2*5', 4, 0, 0, 1, 0, 0, 61, 1368, 0, '', '1', '0'),
	(908, '2488', 180, 'pura_mdl2*6', 4, 0, 0, 1, 0, 0, 63, 1369, 0, '', '1', '0'),
	(909, '2489', 180, 'pura_mdl2*7', 4, 0, 0, 1, 0, 0, 64, 1370, 0, '', '1', '0'),
	(910, '2490', 180, 'pura_mdl2*8', 4, 0, 0, 1, 0, 0, 68, 1371, 0, '', '1', '0'),
	(911, '2491', 180, 'pura_mdl2*9', 4, 0, 0, 1, 0, 0, 67, 1372, 0, '', '1', '0'),
	(912, '2492', 46, 'sound_set_24', 4, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(913, '2493', 46, 'sound_set_12', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(914, '2494', 46, 'sound_set_21', 4, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(915, '2495', 46, 'sound_set_15', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(916, '2496', 46, 'sound_set_28', 4, 0, 0, 1, 0, 0, 28, -1, 0, '', '1', '0'),
	(917, '2497', 46, 'sound_set_18', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(918, '2498', 180, 'bed_budget_one*1', 4, 0, 0, 1, 0, 0, 10, 18159, 0, '', '1', '0'),
	(919, '2499', 180, 'bed_budget_one*2', 4, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(920, '2500', 180, 'bed_budget_one*3', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(921, '2501', 180, 'bed_budget_one*4', 4, 0, 0, 1, 0, 0, 19, 1382, 0, '', '1', '0'),
	(922, '2502', 180, 'bed_budget_one*5', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(923, '2503', 180, 'bed_budget_one*6', 4, 0, 0, 1, 0, 0, 13, 18157, 0, '', '1', '0'),
	(924, '2504', 180, 'bed_budget_one*7', 4, 0, 0, 1, 0, 0, 14, 18156, 0, '', '1', '0'),
	(925, '2505', 180, 'bed_budget_one*8', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(926, '2506', 180, 'bed_budget_one*9', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(927, '2507', 859, 'rare_icecream_campaign', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(928, '2508', 46, 'sound_set_26', 4, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(929, '2509', 180, 'pura_mdl5*1', 4, 0, 0, 1, 0, 0, 90, 1390, 0, '', '1', '0'),
	(930, '2510', 180, 'pura_mdl5*2', 4, 0, 0, 1, 0, 0, 95, 1391, 0, '', '1', '0'),
	(931, '2511', 180, 'pura_mdl5*3', 4, 0, 0, 1, 0, 0, 92, -1, 0, '', '1', '0'),
	(932, '2512', 180, 'pura_mdl5*4', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(933, '2513', 180, 'pura_mdl5*5', 4, 0, 0, 1, 0, 0, 91, 1394, 0, '', '1', '0'),
	(934, '2514', 180, 'pura_mdl5*6', 4, 0, 0, 1, 0, 0, 93, 1395, 0, '', '1', '0'),
	(935, '2515', 180, 'pura_mdl5*7', 4, 0, 0, 1, 0, 0, 94, 1396, 0, '', '1', '0'),
	(936, '2516', 180, 'pura_mdl5*8', 4, 0, 0, 1, 0, 0, 98, 1397, 0, '', '1', '0'),
	(937, '2517', 180, 'pura_mdl5*9', 4, 0, 0, 1, 0, 0, 97, 1398, 0, '', '1', '0'),
	(938, '2518', 280, 'rope_divider', 4, 0, 0, 1, 0, 0, -10, -1, 0, '', '1', '0'),
	(939, '2519', 280, 'spotlight', 4, 0, 0, 1, 0, 0, -9, -1, 0, '', '1', '0'),
	(940, '2520', 35, 'romantique_clock', 4, 0, 0, 1, 0, 0, 44, -1, 0, '', '1', '0'),
	(941, '2521', 46, 'sound_set_22', 4, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(942, '2522', 31, 'jp_drawer', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(943, '2523', 46, 'sound_set_13', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(944, '2524', 46, 'sound_set_20', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(945, '2525', 180, 'chair_basic*1', 2, 0, 0, 1, 0, 0, 30, 1406, 0, '', '1', '0'),
	(946, '2526', 180, 'chair_basic*2', 2, 0, 0, 1, 0, 0, 35, -1, 0, '', '1', '0'),
	(947, '2527', 180, 'chair_basic*3', 2, 0, 0, 1, 0, 0, 32, -1, 0, '', '1', '0'),
	(948, '2528', 180, 'chair_basic*4', 2, 0, 0, 1, 0, 0, 39, -1, 0, '', '1', '0'),
	(949, '2529', 180, 'chair_basic*5', 2, 0, 0, 1, 0, 0, 31, -1, 0, '', '1', '0'),
	(950, '2530', 180, 'chair_basic*6', 2, 0, 0, 1, 0, 0, 33, -1, 0, '', '1', '0'),
	(951, '2531', 180, 'chair_basic*7', 2, 0, 0, 1, 0, 0, 34, 1412, 0, '', '1', '0'),
	(952, '2532', 180, 'chair_basic*8', 2, 0, 0, 1, 0, 0, 38, -1, 0, '', '1', '0'),
	(953, '2533', 180, 'chair_basic*9', 2, 0, 0, 1, 0, 0, 37, -1, 0, '', '1', '0'),
	(954, '2534', 180, 'pura_mdl3*1', 4, 0, 0, 1, 0, 0, 70, 1415, 0, '', '1', '0'),
	(955, '2535', 180, 'pura_mdl3*2', 4, 0, 0, 1, 0, 0, 75, 1416, 0, '', '1', '0'),
	(956, '2536', 180, 'pura_mdl3*3', 4, 0, 0, 1, 0, 0, 72, -1, 0, '', '1', '0'),
	(957, '2537', 180, 'pura_mdl3*4', 4, 0, 0, 1, 0, 0, 79, -1, 0, '', '1', '0'),
	(958, '2538', 180, 'pura_mdl3*5', 4, 0, 0, 1, 0, 0, 71, 1419, 0, '', '1', '0'),
	(959, '2539', 180, 'pura_mdl3*6', 4, 0, 0, 1, 0, 0, 73, 1420, 0, '', '1', '0'),
	(960, '2540', 180, 'pura_mdl3*7', 4, 0, 0, 1, 0, 0, 74, 1421, 0, '', '1', '0'),
	(961, '2541', 180, 'pura_mdl3*8', 4, 0, 0, 1, 0, 0, 78, 1422, 0, '', '1', '0'),
	(962, '2542', 180, 'pura_mdl3*9', 4, 0, 0, 1, 0, 0, 77, 1423, 0, '', '1', '0'),
	(963, '2543', 187, 'sound_machine*2', 4, 0, 0, 1, 0, 0, -2, -1, 0, '', '1', '0'),
	(964, '2544', 187, 'sound_machine*3', 4, 0, 0, 1, 0, 0, -3, -1, 0, '', '1', '0'),
	(965, '2545', 187, 'sound_machine*4', 4, 0, 0, 1, 0, 0, -4, -1, 0, '', '1', '0'),
	(966, '2546', 187, 'sound_machine*5', 4, 0, 0, 1, 0, 0, -5, -1, 0, '', '1', '0'),
	(967, '2547', 187, 'sound_machine*6', 4, 0, 0, 1, 0, 0, -6, -1, 0, '', '1', '0'),
	(968, '2548', 187, 'sound_machine*7', 4, 0, 0, 1, 0, 0, -7, -1, 0, '', '1', '0'),
	(969, '2549', 46, 'sound_set_27', 4, 0, 0, 1, 0, 0, 27, -1, 0, '', '1', '0'),
	(970, '2550', 46, 'sound_set_17', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(971, '2551', 35, 'rom_lamp', 4, 0, 0, 1, 0, 0, 43, -1, 0, '', '1', '0'),
	(972, '2552', 180, 'bed_budget*1', 4, 0, 0, 1, 0, 0, 20, 18133, 0, '', '1', '0'),
	(973, '2553', 180, 'bed_budget*2', 4, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(974, '2554', 180, 'bed_budget*3', 4, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(975, '2555', 180, 'bed_budget*4', 4, 0, 0, 1, 0, 0, 29, 1437, 0, '', '1', '0'),
	(976, '2556', 180, 'bed_budget*5', 4, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(977, '2557', 180, 'bed_budget*6', 4, 0, 0, 1, 0, 0, 23, 18134, 0, '', '1', '0'),
	(978, '2558', 180, 'bed_budget*7', 4, 0, 0, 1, 0, 0, 24, 18135, 0, '', '1', '0'),
	(979, '2559', 180, 'bed_budget*8', 4, 0, 0, 1, 0, 0, 28, -1, 0, '', '1', '0'),
	(980, '2560', 180, 'bed_budget*9', 4, 0, 0, 1, 0, 0, 27, -1, 0, '', '1', '0'),
	(981, '2561', 46, 'sound_set_16', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(982, '2562', 500, 'rclr_chair', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(983, '2563', 46, 'sound_set_11', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(984, '2564', 46, 'sound_set_33', 4, 0, 0, 1, 0, 0, 33, -1, 0, '', '1', '0'),
	(985, '2565', 46, 'sound_set_37', 4, 0, 0, 1, 0, 0, 37, -1, 0, '', '1', '0'),
	(986, '2566', 280, 'tile_marble', 1, 0, 0, 1, 0, 0, -7, -1, 0, '', '1', '0'),
	(987, '2567', 700, 'exe_rug', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(988, '2568', 280, 'tile_stella', 1, 0, 0, 1, 0, 0, -6, -1, 0, '', '1', '0'),
	(989, '2569', 46, 'sound_set_32', 4, 0, 0, 1, 0, 0, 32, -1, 0, '', '1', '0'),
	(990, '2570', 46, 'sound_set_34', 4, 0, 0, 1, 0, 0, 34, -1, 0, '', '1', '0'),
	(991, '2571', 405, 'summer_chair*1', 2, 0, 0, 1, 0, 0, 1, 1475, 0, '', '1', '0'),
	(992, '2572', 405, 'summer_chair*2', 2, 0, 0, 1, 0, 0, 2, 1476, 0, '', '1', '0'),
	(993, '2573', 405, 'summer_chair*3', 2, 0, 0, 1, 0, 0, 3, 1477, 0, '', '1', '0'),
	(994, '2574', 405, 'summer_chair*4', 2, 0, 0, 1, 0, 0, 4, 1478, 0, '', '1', '0'),
	(995, '2575', 405, 'summer_chair*5', 2, 0, 0, 1, 0, 0, 5, 1479, 0, '', '1', '0'),
	(996, '2576', 405, 'summer_chair*6', 2, 0, 0, 1, 0, 0, 6, 1480, 0, '', '1', '0'),
	(997, '2577', 405, 'summer_chair*7', 2, 0, 0, 1, 0, 0, 7, 1481, 0, '', '1', '0'),
	(998, '2578', 405, 'summer_chair*8', 2, 0, 0, 1, 0, 0, 8, 1482, 0, '', '1', '0'),
	(999, '2579', 405, 'summer_chair*9', 2, 0, 0, 1, 0, 0, 9, 1483, 0, '', '1', '0'),
	(1000, '2580', 46, 'sound_set_29', 4, 0, 0, 1, 0, 0, 29, -1, 0, '', '1', '0'),
	(1001, '2581', 700, 'exe_s_table', 5, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(1002, '2582', 280, 'tile_brown', 1, 0, 0, 1, 0, 0, -8, -1, 0, '', '1', '0'),
	(1003, '2583', 46, 'sound_set_36', 4, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(1004, '2584', 344, 'rare_mnstr', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(1005, '2585', 46, 'sound_set_30', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(1006, '2586', 736, 'prizetrophy7*3', 8, 0, 0, 1, 0, 0, -1, -1, 0, '', '1', '0'),
	(1007, '2587', 405, 'summer_grill*1', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(1008, '2588', 405, 'summer_grill*2', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(1009, '2589', 405, 'summer_grill*3', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(1010, '2590', 405, 'summer_grill*4', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(1011, '2591', 405, 'summer_pool*1', 4, 0, 0, 1, 0, 0, 14, 18402, 0, '', '1', '0'),
	(1012, '2592', 405, 'summer_pool*2', 4, 0, 0, 1, 0, 0, 13, 18407, 0, '', '1', '0'),
	(1013, '2593', 405, 'summer_pool*3', 4, 0, 0, 1, 0, 0, 14, 18481, 0, '', '1', '0'),
	(1014, '2594', 405, 'summer_pool*4', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(1015, '2595', 46, 'sound_set_35', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(1016, '2596', 46, 'sound_set_31', 4, 0, 0, 1, 0, 0, 31, -1, 0, '', '1', '0'),
	(1017, '2597', 341, 'one_way_door*1', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(1018, '2598', 341, 'one_way_door*2', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(1019, '2599', 341, 'one_way_door*3', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(1020, '2600', 341, 'one_way_door*4', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(1021, '2601', 341, 'one_way_door*5', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(1022, '2602', 341, 'one_way_door*6', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(1023, '2603', 341, 'one_way_door*7', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(1024, '2604', 341, 'one_way_door*8', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(1025, '2605', 341, 'one_way_door*9', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(1026, '2606', 187, 'sound_machine_pro', 4, 0, 0, 1, 0, 0, -8, -1, 0, '', '1', '0'),
	(1027, '2607', 274, 'song_disk', 4, 0, 0, 1, 0, 0, 99, 18805, 0, '', '1', '0'),
	(1028, '2608', 253, 'jukebox*1', 5, 0, 0, 1, 0, 0, 99, 1716, 0, '', '1', '0'),
	(1029, '2609', 559, 'carpet_soft_tut', 4, 0, 0, 1, 0, 0, 27, -1, 0, '', '1', '0'),
	(1030, '2610', 46, 'sound_set_44', 4, 0, 0, 1, 0, 0, 44, -1, 0, '', '1', '0'),
	(1031, '2611', 388, 'habboween_crypt', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(1032, '2612', 46, 'sound_set_41', 4, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(1033, '2613', 764, 'grunge_sign', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(1034, '2614', 46, 'sound_set_43', 4, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(1035, '2615', 46, 'sound_set_40', 4, 0, 0, 1, 0, 0, 40, -1, 0, '', '1', '0'),
	(1036, '2616', 46, 'sound_set_38', 4, 0, 0, 1, 0, 0, 38, -1, 0, '', '1', '0'),
	(1037, '2617', 764, 'grunge_chair', 2, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(1038, '2618', 764, 'grunge_mattress', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(1039, '2619', 764, 'grunge_shelf', 5, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(1040, '2620', 388, 'hal_grave', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(1041, '2621', 764, 'grunge_radiator', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(1042, '2622', 46, 'sound_set_39', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(1043, '2623', 764, 'grunge_table', 5, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(1044, '2624', 46, 'sound_set_42', 4, 0, 0, 1, 0, 0, 42, -1, 0, '', '1', '0'),
	(1045, '2625', 388, 'hal_cauldron', 10, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(1046, '2626', 388, 'habboween_grass', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(1047, '2627', 46, 'sound_set_47', 4, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(1048, '2628', 46, 'sound_set_45', 4, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(1049, '2629', 46, 'sound_set_48', 4, 0, 0, 1, 0, 0, 48, -1, 0, '', '1', '0'),
	(1050, '2630', 46, 'sound_set_46', 4, 0, 0, 1, 0, 0, 46, -1, 0, '', '1', '0'),
	(1051, '2631', 46, 'sound_set_51', 4, 0, 0, 1, 0, 0, 51, -1, 0, '', '1', '0'),
	(1052, '2632', 46, 'sound_set_50', 4, 0, 0, 1, 0, 0, 50, -1, 0, '', '1', '0'),
	(1053, '2633', 46, 'sound_set_52', 4, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(1054, '2634', 46, 'sound_set_49', 4, 0, 0, 1, 0, 0, 49, -1, 0, '', '1', '0'),
	(1055, '2635', 473, 'plant_maze_snow', 4, 0, 0, 1, 0, 0, 89, -1, 0, '', '1', '0'),
	(1056, '2636', 473, 'xmas_cstl_gate', 6, 0, 0, 1, 0, 0, 97, -1, 0, '', '1', '0'),
	(1057, '2637', 473, 'christmas_reindeer', 25, 0, 0, 1, 0, 0, 95, -1, 0, '', '1', '0'),
	(1058, '2638', 473, 'tree6', 6, 0, 0, 1, 0, 0, 82, -1, 0, '', '1', '0'),
	(1059, '2639', 700, 'exe_sofa', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(1060, '2640', 473, 'plant_mazegate_snow', 6, 0, 0, 1, 0, 0, 90, -1, 0, '', '1', '0'),
	(1061, '2641', 473, 'xmas_icelamp', 3, 0, 0, 1, 0, 0, 100, -1, 0, '', '1', '0'),
	(1062, '2642', 346, 'safe_silo_pb', 4, 0, 0, 1, 0, 0, 48, -1, 0, '', '1', '0'),
	(1063, '2643', 700, 'exe_bardesk', 5, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(1064, '2644', 700, 'exe_table', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(1065, '2645', 726, 'exe_drinks', 4, 0, 0, 1, 0, 0, 11, 24152, 0, '', '1', '0'),
	(1066, '2646', 473, 'xmas_cstl_wall', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(1067, '2647', 700, 'exe_chair', 2, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(1068, '2648', 473, 'christmas_sleigh', 5, 0, 0, 1, 0, 0, 96, -1, 0, '', '1', '0'),
	(1069, '2649', 46, 'sound_set_54', 4, 0, 0, 1, 0, 0, 54, -1, 0, '', '1', '0'),
	(1070, '2650', 700, 'exe_chair2', 2, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(1071, '2651', 473, 'xmas_cstl_twr', 3, 0, 0, 1, 0, 0, 98, -1, 0, '', '1', '0'),
	(1072, '2652', 46, 'sound_set_53', 4, 0, 0, 1, 0, 0, 26, -1, 0, '', '1', '0'),
	(1073, '2653', 473, 'tree7', 6, 0, 0, 1, 0, 0, 83, -1, 0, '', '1', '0'),
	(1074, '2654', 473, 'christmas_poop', 1, 0, 0, 1, 0, 0, 94, -1, 0, '', '1', '0'),
	(1075, '2655', 700, 'exe_corner', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(1076, '2656', 46, 'sound_set_58', 4, 0, 0, 1, 0, 0, 58, -1, 0, '', '1', '0'),
	(1077, '2657', 47, 'noob_stool*1', 0, 10, 0, 1, 0, 0, 38, -1, 0, '', '1', '0'),
	(1078, '2658', 47, 'noob_stool*2', 0, 10, 0, 1, 0, 0, 39, -1, 0, '', '1', '0'),
	(1079, '2659', 47, 'noob_stool*3', 0, 10, 0, 1, 0, 0, 40, -1, 0, '', '1', '0'),
	(1080, '2660', 47, 'noob_stool*4', 0, 10, 0, 1, 0, 0, 41, -1, 0, '', '1', '0'),
	(1081, '2661', 47, 'noob_stool*5', 0, 10, 0, 1, 0, 0, 42, -1, 0, '', '1', '0'),
	(1082, '2662', 47, 'noob_stool*6', 0, 10, 0, 1, 0, 0, 43, -1, 0, '', '1', '0'),
	(1083, '2663', 47, 'noob_lamp*1', 0, 10, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(1084, '2664', 47, 'noob_lamp*2', 0, 10, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(1085, '2665', 47, 'noob_lamp*3', 0, 10, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(1086, '2666', 47, 'noob_lamp*4', 0, 10, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(1087, '2667', 47, 'noob_lamp*5', 0, 10, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(1088, '2668', 47, 'noob_lamp*6', 0, 10, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(1089, '2669', 46, 'sound_set_56', 4, 0, 0, 1, 0, 0, 28, -1, 0, '', '1', '0'),
	(1090, '2670', 46, 'sound_set_59', 4, 0, 0, 1, 0, 0, 59, -1, 0, '', '1', '0'),
	(1091, '2671', 46, 'sound_set_55', 4, 0, 0, 1, 0, 0, 27, -1, 0, '', '1', '0'),
	(1092, '2672', 700, 'exe_globe', 4, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(1093, '2673', 46, 'sound_set_57', 4, 0, 0, 1, 0, 0, 57, -1, 0, '', '1', '0'),
	(1094, '2674', 700, 'exe_plant', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(1095, '2675', 47, 'noob_chair*1', 0, 10, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(1096, '2676', 47, 'noob_chair*2', 0, 10, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(1097, '2677', 47, 'noob_chair*3', 0, 10, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(1098, '2678', 47, 'noob_chair*4', 0, 10, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(1099, '2679', 47, 'noob_chair*5', 0, 10, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(1100, '2680', 47, 'noob_chair*6', 0, 10, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(1101, '2681', 47, 'noob_rug*1', 0, 10, 0, 1, 0, 0, 26, -1, 0, '', '1', '0'),
	(1102, '2682', 47, 'noob_rug*2', 0, 10, 0, 1, 0, 0, 27, -1, 0, '', '1', '0'),
	(1103, '2683', 47, 'noob_rug*3', 0, 10, 0, 1, 0, 0, 28, -1, 0, '', '1', '0'),
	(1104, '2684', 47, 'noob_rug*4', 0, 10, 0, 1, 0, 0, 29, -1, 0, '', '1', '0'),
	(1105, '2685', 47, 'noob_rug*5', 0, 10, 0, 1, 0, 0, 30, -1, 0, '', '1', '0'),
	(1106, '2686', 47, 'noob_rug*6', 0, 10, 0, 1, 0, 0, 31, -1, 0, '', '1', '0'),
	(1107, '2687', 47, 'noob_table*1', 0, 10, 0, 1, 0, 0, 44, -1, 0, '', '1', '0'),
	(1108, '2688', 47, 'noob_table*2', 0, 10, 0, 1, 0, 0, 45, -1, 0, '', '1', '0'),
	(1109, '2689', 47, 'noob_table*3', 0, 10, 0, 1, 0, 0, 46, -1, 0, '', '1', '0'),
	(1110, '2690', 47, 'noob_table*4', 0, 10, 0, 1, 0, 0, 47, -1, 0, '', '1', '0'),
	(1111, '2691', 47, 'noob_table*5', 0, 10, 0, 1, 0, 0, 48, -1, 0, '', '1', '0'),
	(1112, '2692', 47, 'noob_table*6', 0, 10, 0, 1, 0, 0, 49, -1, 0, '', '1', '0'),
	(1113, '2693', 224, 'teleport_door', 6, 0, 0, 1, 0, 0, 5, 3233, 0, '', '1', '0'),
	(1114, '2694', 453, 'fortune', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(1115, '2695', 46, 'sound_set_60', 4, 0, 0, 1, 0, 0, 60, -1, 0, '', '1', '0'),
	(1116, '2696', 663, 'val_randomizer', 4, 0, 0, 1, 0, 0, 35, -1, 0, '', '1', '0'),
	(1117, '2697', 453, 'val_choco', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(1118, '2698', 46, 'sound_set_61', 4, 0, 0, 1, 0, 0, 29, -1, 0, '', '1', '0'),
	(1119, '2699', 453, 'val_teddy*1', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(1120, '2700', 453, 'val_teddy*2', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(1121, '2701', 453, 'val_teddy*3', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(1122, '2702', 453, 'val_teddy*4', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(1123, '2703', 453, 'val_teddy*5', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(1124, '2704', 453, 'val_teddy*6', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(1125, '2705', 405, 'sand_cstl_twr', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(1126, '2706', 764, 'grunge_barrel', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(1127, '2707', 764, 'grunge_bench', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(1128, '2708', 764, 'grunge_candle', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(1129, '2709', 123, 'sw_chest', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(1130, '2710', 405, 'sand_cstl_wall', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(1131, '2711', 123, 'sw_raven', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(1132, '2712', 405, 'sand_cstl_gate', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(1133, '2713', 123, 'sw_table', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(1134, '2714', 28, 'arabian_tetbl', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(1135, '2715', 31, 'jp_tray1', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(1136, '2716', 28, 'arabian_teamk', 10, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(1137, '2717', 31, 'jp_tray5', 4, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(1138, '2718', 736, 'prizetrophy9*1', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '0', '0'),
	(1139, '2719', 28, 'arabian_rug', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(1140, '2720', 31, 'jp_tray6', 4, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(1141, '2721', 28, 'arabian_chair', 2, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(1142, '2722', 28, 'arabian_pllw', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(1143, '2723', 28, 'arabian_tray3', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(1144, '2724', 31, 'jp_tray2', 4, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(1145, '2725', 31, 'jp_tray4', 4, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(1146, '2726', 31, 'jp_tray3', 4, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(1147, '2727', 198, 'md_rug', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(1148, '2728', 28, 'arabian_tray4', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(1149, '2729', 736, 'prizetrophy8*1', 5, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(1150, '2730', 28, 'arabian_divdr', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(1151, '2731', 28, 'arabian_bigtb', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(1152, '2732', 28, 'arabian_snake', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(1153, '2733', 500, 'rclr_lamp', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(1154, '2734', 28, 'arabian_tray1', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(1155, '2735', 28, 'arabian_tray2', 4, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(1156, '2736', 565, 'nouvelle_trax', 4, 0, 0, 1, 0, 0, 46, -1, 0, '', '1', '0'),
	(1157, '2737', 73, 'calippo', 4, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(1158, '2738', 46, 'sound_set_64', 4, 0, 0, 1, 0, 0, 64, -1, 0, '', '1', '0'),
	(1159, '2739', 496, 'jukebox_ptv*1', 5, 0, 0, 0, 0, 0, 23, -1, 0, '', '1', '0'),
	(1160, '2740', 46, 'sound_set_63', 4, 0, 0, 1, 0, 0, 63, -1, 0, '', '1', '0'),
	(1161, '2741', 46, 'sound_set_62', 4, 0, 0, 1, 0, 0, 30, -1, 0, '', '1', '0'),
	(1162, '2742', 187, 'traxgold', 4, 0, 0, 1, 0, 0, -11, -1, 0, '', '1', '0'),
	(1163, '2743', 187, 'traxbronze', 4, 0, 0, 1, 0, 0, -9, -1, 0, '', '1', '0'),
	(1164, '2744', 187, 'traxsilver', 4, 0, 0, 1, 0, 0, -10, -1, 0, '', '1', '0'),
	(1165, '2745', 544, 'bench_puffet', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(1166, '2746', 323, 'footylamp_campaign', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(1167, '2747', 31, 'jp_katana2', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(1168, '2748', 31, 'jp_katana3', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(1169, '2749', 31, 'jp_table', 5, 0, 0, 1, 0, 0, 26, -1, 0, '', '1', '0'),
	(1170, '2750', 31, 'jp_rare', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(1171, '2751', 31, 'jp_katana1', 4, 0, 0, 1, 0, 0, 9, 2312, 0, '', '1', '0'),
	(1172, '2752', 46, 'sound_set_66', 4, 0, 0, 1, 0, 0, 66, -1, 0, '', '1', '0'),
	(1173, '2753', 408, 'tiki_tray3', 4, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(1174, '2754', 539, 'tampax_rug', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(1175, '2755', 408, 'tiki_tray1', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(1176, '2756', 408, 'tiki_toucan', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(1177, '2757', 408, 'tiki_waterfall', 4, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(1184, '2764', 307, 'CFC_500_goldbar', 500, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(1185, '2765', 408, 'tiki_tray4', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(1186, '2766', 46, 'sound_set_65', 4, 0, 0, 1, 0, 0, 65, -1, 0, '', '1', '0'),
	(1187, '2767', 46, 'sound_set_70', 4, 0, 0, 1, 0, 0, 70, -1, 0, '', '1', '0'),
	(1188, '2768', 408, 'tiki_tray2', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(1189, '2769', 408, 'tiki_parasol', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(1190, '2770', 307, 'CFC_200_moneybag', 200, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(1191, '2771', 46, 'sound_set_67', 4, 0, 0, 1, 0, 0, 31, -1, 0, '', '1', '0'),
	(1192, '2772', 307, 'CFC_50_coin_silver', 50, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(1193, '2773', 408, 'tiki_torch', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(1194, '2774', 31, 'jp_teamaker', 10, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(1201, '2781', 408, 'tiki_junglerug', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(1202, '2782', 408, 'tiki_statue', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(1203, '2783', 47, 'noob_plant', 0, 10, 0, 1, 0, 0, 60, -1, 0, '', '1', '0'),
	(1204, '2784', 408, 'tiki_bench', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(1205, '2785', 408, 'tiki_bflies', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(1212, '2792', 408, 'tiki_tray0', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(1213, '2793', 46, 'sound_set_68', 4, 0, 0, 1, 0, 0, 32, -1, 0, '', '1', '0'),
	(1214, '2794', 408, 'tiki_corner', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(1215, '2795', 408, 'tiki_bardesk', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(1216, '2796', 307, 'CFC_100_coin_gold', 100, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(1217, '2797', 307, 'CFC_10_coin_bronze', 10, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(1218, '2798', 408, 'tiki_sand', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(1219, '2799', 46, 'sound_set_69', 4, 0, 0, 1, 0, 0, 33, -1, 0, '', '1', '0'),
	(1220, '2800', 43, 'diner_tray_4', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(1221, '2801', 345, 'svnr_de', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(1222, '2802', 43, 'diner_tray_2', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(1223, '2803', 43, 'diner_rug', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(1224, '2804', 43, 'diner_sofa_2*1', 4, 0, 0, 1, 0, 0, 98, -1, 0, '', '1', '0'),
	(1225, '2805', 43, 'diner_sofa_2*2', 4, 0, 0, 1, 0, 0, 97, -1, 0, '', '1', '0'),
	(1226, '2806', 43, 'diner_sofa_2*3', 4, 0, 0, 1, 0, 0, 92, -1, 0, '', '1', '0'),
	(1227, '2807', 43, 'diner_sofa_2*4', 4, 0, 0, 1, 0, 0, 95, -1, 0, '', '1', '0'),
	(1228, '2808', 43, 'diner_sofa_2*5', 4, 0, 0, 1, 0, 0, 90, -1, 0, '', '1', '0'),
	(1229, '2809', 43, 'diner_sofa_2*6', 4, 0, 0, 1, 0, 0, 91, -1, 0, '', '1', '0'),
	(1230, '2810', 43, 'diner_sofa_2*7', 4, 0, 0, 1, 0, 0, 93, -1, 0, '', '1', '0'),
	(1231, '2811', 43, 'diner_sofa_2*8', 4, 0, 0, 1, 0, 0, 96, -1, 0, '', '1', '0'),
	(1232, '2812', 43, 'diner_sofa_2*9', 4, 0, 0, 1, 0, 0, 94, -1, 0, '', '1', '0'),
	(1233, '2813', 345, 'svnr_it', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(1234, '2814', 43, 'diner_shaker', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(1235, '2815', 43, 'diner_tray_5', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(1236, '2816', 43, 'diner_cashreg*1', 4, 0, 0, 1, 0, 0, 58, -1, 0, '', '1', '0'),
	(1237, '2817', 43, 'diner_cashreg*2', 4, 0, 0, 1, 0, 0, 57, -1, 0, '', '1', '0'),
	(1238, '2818', 43, 'diner_cashreg*3', 4, 0, 0, 1, 0, 0, 52, -1, 0, '', '1', '0'),
	(1239, '2819', 43, 'diner_cashreg*4', 4, 0, 0, 1, 0, 0, 56, -1, 0, '', '1', '0'),
	(1240, '2820', 43, 'diner_cashreg*5', 4, 0, 0, 1, 0, 0, 50, -1, 0, '', '1', '0'),
	(1241, '2821', 43, 'diner_cashreg*6', 4, 0, 0, 1, 0, 0, 51, -1, 0, '', '1', '0'),
	(1242, '2822', 43, 'diner_cashreg*7', 4, 0, 0, 1, 0, 0, 53, -1, 0, '', '1', '0'),
	(1243, '2823', 43, 'diner_cashreg*8', 4, 0, 0, 1, 0, 0, 55, -1, 0, '', '1', '0'),
	(1244, '2824', 43, 'diner_cashreg*9', 4, 0, 0, 1, 0, 0, 54, -1, 0, '', '1', '0'),
	(1245, '2825', 345, 'svnr_nl', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(1246, '2826', 43, 'diner_tray_6', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(1247, '2827', 43, 'diner_gumvendor*1', 4, 0, 0, 1, 0, 0, 78, -1, 0, '', '1', '0'),
	(1248, '2828', 43, 'diner_gumvendor*2', 4, 0, 0, 1, 0, 0, 77, -1, 0, '', '1', '0'),
	(1249, '2829', 43, 'diner_gumvendor*3', 4, 0, 0, 1, 0, 0, 72, -1, 0, '', '1', '0'),
	(1250, '2830', 43, 'diner_gumvendor*4', 4, 0, 0, 1, 0, 0, 75, -1, 0, '', '1', '0'),
	(1251, '2831', 43, 'diner_gumvendor*5', 4, 0, 0, 1, 0, 0, 70, -1, 0, '', '1', '0'),
	(1252, '2832', 43, 'diner_gumvendor*6', 4, 0, 0, 1, 0, 0, 71, -1, 0, '', '1', '0'),
	(1253, '2833', 43, 'diner_gumvendor*7', 4, 0, 0, 1, 0, 0, 73, -1, 0, '', '1', '0'),
	(1254, '2834', 43, 'diner_gumvendor*8', 4, 0, 0, 1, 0, 0, 76, -1, 0, '', '1', '0'),
	(1255, '2835', 43, 'diner_gumvendor*9', 10, 0, 0, 1, 0, 0, 74, -1, 0, '', '1', '0'),
	(1256, '2836', 345, 'svnr_aus', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(1257, '2837', 43, 'diner_tray_0', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(1258, '2838', 345, 'svnr_uk', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(1259, '2839', 43, 'diner_tray_1', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(1260, '2840', 43, 'diner_tray_7', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(1261, '2841', 43, 'diner_tray_3', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(1262, '2842', 43, 'diner_bardesk_gate*1', 5, 0, 0, 1, 0, 0, 48, -1, 0, '', '1', '0'),
	(1263, '2843', 43, 'diner_bardesk_gate*2', 5, 0, 0, 1, 0, 0, 47, -1, 0, '', '1', '0'),
	(1264, '2844', 43, 'diner_bardesk_gate*3', 5, 0, 0, 1, 0, 0, 42, -1, 0, '', '1', '0'),
	(1265, '2845', 43, 'diner_bardesk_gate*4', 5, 0, 0, 1, 0, 0, 45, -1, 0, '', '1', '0'),
	(1266, '2846', 43, 'diner_bardesk_gate*5', 5, 0, 0, 1, 0, 0, 40, -1, 0, '', '1', '0'),
	(1267, '2847', 43, 'diner_bardesk_gate*6', 5, 0, 0, 1, 0, 0, 41, -1, 0, '', '1', '0'),
	(1268, '2848', 43, 'diner_bardesk_gate*7', 5, 0, 0, 1, 0, 0, 43, -1, 0, '', '1', '0'),
	(1269, '2849', 43, 'diner_bardesk_gate*8', 5, 0, 0, 1, 0, 0, 46, -1, 0, '', '1', '0'),
	(1270, '2850', 43, 'diner_bardesk_gate*9', 5, 0, 0, 1, 0, 0, 44, -1, 0, '', '1', '0'),
	(1271, '2851', 43, 'diner_bardesk*1', 5, 0, 0, 1, 0, 0, 28, -1, 0, '', '1', '0'),
	(1272, '2852', 43, 'diner_bardesk*2', 5, 0, 0, 1, 0, 0, 27, -1, 0, '', '1', '0'),
	(1273, '2853', 43, 'diner_bardesk*3', 5, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(1274, '2854', 43, 'diner_bardesk*4', 5, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(1275, '2855', 43, 'diner_bardesk*5', 5, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(1276, '2856', 43, 'diner_bardesk*6', 5, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(1277, '2857', 43, 'diner_bardesk*7', 5, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(1278, '2858', 43, 'diner_bardesk*8', 5, 0, 0, 1, 0, 0, 26, -1, 0, '', '1', '0'),
	(1279, '2859', 43, 'diner_bardesk*9', 5, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(1280, '2860', 309, 'ads_dave_cns', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(1281, '2861', 43, 'diner_chair*1', 2, 0, 0, 1, 0, 0, 68, -1, 0, '', '1', '0'),
	(1282, '2862', 43, 'diner_chair*2', 2, 0, 0, 1, 0, 0, 67, -1, 0, '', '1', '0'),
	(1283, '2863', 43, 'diner_chair*3', 2, 0, 0, 1, 0, 0, 62, -1, 0, '', '1', '0'),
	(1284, '2864', 43, 'diner_chair*4', 2, 0, 0, 1, 0, 0, 65, -1, 0, '', '1', '0'),
	(1285, '2865', 43, 'diner_chair*5', 2, 0, 0, 1, 0, 0, 60, -1, 0, '', '1', '0'),
	(1286, '2866', 43, 'diner_chair*6', 2, 0, 0, 1, 0, 0, 61, -1, 0, '', '1', '0'),
	(1287, '2867', 43, 'diner_chair*7', 2, 0, 0, 1, 0, 0, 63, -1, 0, '', '1', '0'),
	(1288, '2868', 43, 'diner_chair*8', 2, 0, 0, 1, 0, 0, 66, -1, 0, '', '1', '0'),
	(1289, '2869', 43, 'diner_chair*9', 2, 0, 0, 1, 0, 0, 64, -1, 0, '', '1', '0'),
	(1290, '2870', 43, 'diner_bardesk_corner*1', 5, 0, 0, 1, 0, 0, 38, -1, 0, '', '1', '0'),
	(1291, '2871', 43, 'diner_bardesk_corner*2', 5, 0, 0, 1, 0, 0, 37, -1, 0, '', '1', '0'),
	(1292, '2872', 43, 'diner_bardesk_corner*3', 5, 0, 0, 1, 0, 0, 32, -1, 0, '', '1', '0'),
	(1293, '2873', 43, 'diner_bardesk_corner*4', 5, 0, 0, 1, 0, 0, 35, -1, 0, '', '1', '0'),
	(1294, '2874', 43, 'diner_bardesk_corner*5', 5, 0, 0, 1, 0, 0, 30, -1, 0, '', '1', '0'),
	(1295, '2875', 43, 'diner_bardesk_corner*6', 5, 0, 0, 1, 0, 0, 31, -1, 0, '', '1', '0'),
	(1296, '2876', 43, 'diner_bardesk_corner*7', 5, 0, 0, 1, 0, 0, 33, -1, 0, '', '1', '0'),
	(1297, '2877', 43, 'diner_bardesk_corner*8', 5, 0, 0, 1, 0, 0, 36, -1, 0, '', '1', '0'),
	(1298, '2878', 43, 'diner_bardesk_corner*9', 5, 0, 0, 1, 0, 0, 34, -1, 0, '', '1', '0'),
	(1299, '2879', 43, 'diner_table_2*1', 4, 0, 0, 1, 0, 0, 118, -1, 0, '', '1', '0'),
	(1300, '2880', 43, 'diner_table_2*2', 4, 0, 0, 1, 0, 0, 117, -1, 0, '', '1', '0'),
	(1301, '2881', 43, 'diner_table_2*3', 4, 0, 0, 1, 0, 0, 112, -1, 0, '', '1', '0'),
	(1302, '2882', 43, 'diner_table_2*4', 4, 0, 0, 1, 0, 0, 115, -1, 0, '', '1', '0'),
	(1303, '2883', 43, 'diner_table_2*5', 4, 0, 0, 1, 0, 0, 110, -1, 0, '', '1', '0'),
	(1304, '2884', 43, 'diner_table_2*6', 4, 0, 0, 1, 0, 0, 111, -1, 0, '', '1', '0'),
	(1305, '2885', 43, 'diner_table_2*7', 4, 0, 0, 1, 0, 0, 113, -1, 0, '', '1', '0'),
	(1306, '2886', 43, 'diner_table_2*8', 4, 0, 0, 1, 0, 0, 116, -1, 0, '', '1', '0'),
	(1307, '2887', 43, 'diner_table_2*9', 4, 0, 0, 1, 0, 0, 114, -1, 0, '', '1', '0'),
	(1308, '2888', 43, 'diner_sofa_1*1', 4, 0, 0, 1, 0, 0, 88, -1, 0, '', '1', '0'),
	(1309, '2889', 43, 'diner_sofa_1*2', 4, 0, 0, 1, 0, 0, 87, -1, 0, '', '1', '0'),
	(1310, '2890', 43, 'diner_sofa_1*3', 4, 0, 0, 1, 0, 0, 82, -1, 0, '', '1', '0'),
	(1311, '2891', 43, 'diner_sofa_1*4', 4, 0, 0, 1, 0, 0, 85, -1, 0, '', '1', '0'),
	(1312, '2892', 43, 'diner_sofa_1*5', 4, 0, 0, 1, 0, 0, 80, -1, 0, '', '1', '0'),
	(1313, '2893', 43, 'diner_sofa_1*6', 4, 0, 0, 1, 0, 0, 81, -1, 0, '', '1', '0'),
	(1314, '2894', 43, 'diner_sofa_1*7', 4, 0, 0, 1, 0, 0, 83, -1, 0, '', '1', '0'),
	(1315, '2895', 43, 'diner_sofa_1*8', 4, 0, 0, 1, 0, 0, 86, -1, 0, '', '1', '0'),
	(1316, '2896', 43, 'diner_sofa_1*9', 4, 0, 0, 1, 0, 0, 84, -1, 0, '', '1', '0'),
	(1317, '2897', 43, 'diner_table_1*1', 5, 0, 0, 1, 0, 0, 108, -1, 0, '', '1', '0'),
	(1318, '2898', 43, 'diner_table_1*2', 5, 0, 0, 1, 0, 0, 107, -1, 0, '', '1', '0'),
	(1319, '2899', 43, 'diner_table_1*3', 5, 0, 0, 1, 0, 0, 102, -1, 0, '', '1', '0'),
	(1320, '2900', 43, 'diner_table_1*4', 5, 0, 0, 1, 0, 0, 105, -1, 0, '', '1', '0'),
	(1321, '2901', 43, 'diner_table_1*5', 5, 0, 0, 1, 0, 0, 100, -1, 0, '', '1', '0'),
	(1322, '2902', 43, 'diner_table_1*6', 5, 0, 0, 1, 0, 0, 101, -1, 0, '', '1', '0'),
	(1323, '2903', 43, 'diner_table_1*7', 5, 0, 0, 1, 0, 0, 103, -1, 0, '', '1', '0'),
	(1324, '2904', 43, 'diner_table_1*8', 5, 0, 0, 1, 0, 0, 106, -1, 0, '', '1', '0'),
	(1325, '2905', 43, 'diner_table_1*9', 5, 0, 0, 1, 0, 0, 104, -1, 0, '', '1', '0'),
	(1326, '2906', 216, 'greek_seat', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(1327, '2907', 541, 'easy_bowl2', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(1328, '2908', 216, 'greek_gate', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(1329, '2909', 216, 'greek_pillars', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(1330, '2910', 216, 'greek_corner', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(1331, '2911', 541, 'easy_carpet', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(1332, '2912', 736, 'greektrophy*1', 12, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(1333, '2913', 736, 'greektrophy*2', 10, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(1334, '2914', 736, 'greektrophy*3', 8, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(1335, '2915', 216, 'greek_block', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(1336, '2916', 540, 'netari_carpet', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(1337, '2917', 229, 'hcc_shelf', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '1'),
	(1338, '2918', 272, 'det_divider', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(1339, '2919', 229, 'hcc_chair', 5, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '1'),
	(1340, '2920', 229, 'hcc_stool', 5, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '1'),
	(1341, '2921', 229, 'hcc_sofa', 5, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '1'),
	(1342, '2922', 272, 'det_body', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(1343, '2923', 229, 'hcc_table', 5, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '1'),
	(1344, '2924', 229, 'hcc_minibar', 5, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '1'),
	(1345, '2925', 229, 'hcc_sofachair', 5, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '1'),
	(1346, '2926', 229, 'hcc_crnr', 5, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '1'),
	(1347, '2927', 229, 'hcc_dvdr', 5, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '1'),
	(1348, '2928', 559, 'sob_carpet', 4, 0, 0, 1, 0, 0, 34, -1, 0, '', '1', '0'),
	(1349, '2929', 121, 'igor_seat', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(1350, '2930', 536, 'ads_711*1', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(1351, '2931', 536, 'ads_711*2', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(1352, '2932', 536, 'ads_711*3', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(1353, '2933', 536, 'ads_711*4', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(1354, '2934', 121, 'ads_igorswitch', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(1355, '2935', 121, 'ads_igorraygun', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(1356, '2936', 121, 'ads_igorbrain', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(1357, '2937', 389, 'hween08_bed2', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(1358, '2938', 389, 'hween08_defibs', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(1359, '2939', 389, 'hween08_defibs2', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(1360, '2940', 389, 'hween08_sink2', 10, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(1361, '2941', 389, 'hween08_trll', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(1362, '2942', 389, 'hween08_curtain', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(1363, '2943', 389, 'hween08_bbag', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(1364, '2944', 389, 'hween08_sink', 10, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(1365, '2945', 389, 'hween08_bed', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(1366, '2946', 389, 'hween08_manhole', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(1367, '2947', 389, 'hween08_bath2', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(1368, '2948', 389, 'hween08_bath', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(1369, '2949', 389, 'hween08_curtain2', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(1370, '2950', 33, 'party_block2', 4, 0, 0, 1, 0, 0, 6, 2971, 0, '', '1', '0'),
	(1371, '2951', 33, 'party_tube_bubble', 4, 0, 0, 1, 0, 0, 31, 18145, 0, '', '1', '0'),
	(1372, '2952', 33, 'party_seat', 4, 0, 0, 1, 0, 0, 27, 2973, 0, '', '1', '0'),
	(1373, '2953', 33, 'party_mic', 4, 0, 0, 1, 0, 0, 20, 18188, 0, '', '1', '0'),
	(1374, '2954', 621, 'party_djtable', 3, 0, 0, 1, 0, 0, 99, 2975, 0, '', '1', '0'),
	(1375, '2955', 33, 'party_tray', 10, 0, 0, 1, 0, 0, 30, 2976, 0, '', '1', '0'),
	(1376, '2956', 33, 'party_table', 2, 0, 0, 1, 0, 0, 29, 2977, 0, '', '1', '0'),
	(1377, '2957', 33, 'party_barcorn', 4, 0, 0, 1, 0, 0, 1, 2978, 0, '', '1', '0'),
	(1378, '2958', 33, 'party_floor', 2, 0, 0, 1, 0, 0, 18, 2979, 0, '', '1', '0'),
	(1379, '2959', 33, 'party_block', 4, 0, 0, 1, 0, 0, 5, 2980, 0, '', '1', '0'),
	(1380, '2960', 33, 'party_chair', 2, 0, 0, 1, 0, 0, 7, 2981, 0, '', '1', '0'),
	(1381, '2961', 33, 'party_beamer', 4, 0, 0, 1, 0, 0, 4, 18137, 0, '', '1', '0'),
	(1382, '2962', 33, 'party_bardesk', 5, 0, 0, 1, 0, 0, 2, 2983, 0, '', '1', '0'),
	(1383, '2963', 33, 'party_discol', 4, 0, 0, 1, 0, 0, 16, 18181, 0, '', '1', '0'),
	(1384, '2964', 33, 'party_ball', 4, 0, 0, 1, 0, 0, 3, 18202, 0, '', '1', '0'),
	(1385, '2965', 33, 'party_ravel', 4, 0, 0, 1, 0, 0, 26, 18142, 0, '', '1', '0'),
	(1386, '2966', 33, 'party_tube_lava', 4, 0, 0, 1, 0, 0, 32, 18183, 0, '', '1', '0'),
	(1387, '2967', 475, 'xmas08_icetree', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(1388, '2968', 475, 'xmas08_lantern', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(1389, '2969', 504, 'penguin_robot', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(1390, '2970', 475, 'xmas08_dvdr2', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(1391, '2971', 504, 'penguin_elf', 4, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(1392, '2972', 504, 'xmas08_trph1', 4, 0, 0, 1, 0, 0, 40, -1, 0, '', '1', '0'),
	(1393, '2973', 504, 'penguin_skater', 4, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(1394, '2974', 475, 'campfire', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(1395, '2975', 504, 'penguin_bunny', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(1396, '2976', 504, 'penguin_ninja', 4, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(1397, '2977', 504, 'penguin_basic', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(1398, '2978', 475, 'xmas08_telep', 4, 0, 0, 1, 0, 0, 14, 3110, 0, '', '1', '0'),
	(1399, '2979', 504, 'penguin_boxer', 4, 0, 0, 1, 0, 0, 26, -1, 0, '', '1', '0'),
	(1400, '2980', 475, 'xmas08_hole', 10, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(1401, '2981', 504, 'penguin_ski', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(1402, '2982', 475, 'xmas_snow', 4, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(1403, '2983', 504, 'penguin_infected', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(1404, '2984', 504, 'penguin_swim', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(1405, '2985', 475, 'xmas08_geysir', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(1406, '2986', 475, 'xmas08_hottub', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(1407, '2987', 504, 'penguin_cowboy', 4, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(1408, '2988', 504, 'penguin_icehockey', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(1409, '2989', 504, 'penguin_clown', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(1410, '2990', 504, 'penguin_wrestler', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(1411, '2991', 345, 'svnr_fi', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(1412, '2992', 475, 'xmas08_dvdr1', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(1413, '2993', 504, 'penguin_glow', 4, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(1414, '2994', 504, 'penguin_sumo', 4, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(1415, '2995', 504, 'penguin_musketeer', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(1416, '2996', 504, 'penguin_ballet', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(1417, '2997', 504, 'penguin_magician', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(1418, '2998', 504, 'penguin_super', 4, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(1419, '2999', 504, 'penguin_pirate', 4, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(1420, '3000', 46, 'sound_set_71', 4, 0, 0, 1, 0, 0, 34, -1, 0, '', '1', '0'),
	(1421, '3001', 475, 'wallpaper', 2, 0, 0, 1, 0, 0, 1, 9714, 0, '', '1', '0'),
	(1422, '3002', 475, 'floor', 4, 0, 0, 1, 0, 0, 8, 9874, 0, '', '1', '0'),
	(1423, '3003', 504, 'penguin_hunchback', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(1424, '3004', 504, 'penguin_punk', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(1425, '3005', 475, 'xmas08_snowpl', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(1426, '3006', 475, 'xmas08_cubetree', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(1427, '3007', 504, 'penguin_pilot', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(1428, '3008', 504, 'penguin_suit', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(1429, '3009', 475, 'xmas08_table', 5, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(1430, '3010', 504, 'penguin_rock', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(1431, '3011', 23, 'fx_explosion', 0, 250, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(1432, '3012', 23, 'fx_bubble', 0, 250, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(1433, '3013', 23, 'fx_flare', 0, 250, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(1434, '3014', 516, 'ads_cltele', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(1435, '3015', 500, 'xmas08_trph2', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(1436, '3016', 345, 'lostc_merdragon', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(1437, '3017', 516, 'ads_cldesk', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(1438, '3018', 529, 'ads_ob_pillow', 4, 0, 0, 1, 0, 0, 113, -1, 0, '', '1', '0'),
	(1439, '3019', 516, 'ads_clfloor', 4, 0, 0, 1, 0, 0, 33, -1, 0, '', '1', '0'),
	(1440, '3020', 119, 'ads_mall_tele', 4, 0, 0, 1, 0, 0, 90, -1, 0, '', '1', '0'),
	(1441, '3021', 516, 'ads_cllava2', 4, 0, 0, 1, 0, 0, 34, -1, 0, '', '1', '0'),
	(1442, '3022', 37, 'bolly_lotus_pool', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(1443, '3023', 683, 'kinkysofa', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(1444, '3024', 302, 'china_moongt', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(1445, '3025', 302, 'china_ox', 4, 0, 0, 1, 0, 0, 26, -1, 0, '', '1', '0'),
	(1446, '3026', 37, 'bolly_petals', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(1447, '3027', 37, 'bolly_tile2', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(1448, '3028', 37, 'bolly_tile1', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(1449, '3029', 37, 'bolly_fountain', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(1450, '3030', 37, 'bolly_pillow', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(1451, '3031', 37, 'bolly_corner', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(1452, '3032', 37, 'bolly_drapec', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(1453, '3033', 37, 'bolly_phant', 10, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(1454, '3034', 37, 'bolly_desk', 5, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(1455, '3035', 37, 'bolly_table', 5, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(1456, '3036', 37, 'bolly_monkey_lamp', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(1457, '3037', 37, 'bolly_swing', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(1458, '3038', 37, 'bolly_drapea', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(1459, '3039', 37, 'bolly_palm', 4, 0, 0, 1, 0, 0, 30, -1, 0, '', '1', '0'),
	(1460, '3040', 37, 'bolly_drapeb', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(1461, '3041', 37, 'bolly_lamp', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(1462, '3042', 37, 'bolly_tree', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(1463, '3043', 37, 'bolly_vase', 10, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(1464, '3044', 39, 'planet_of_love', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(1465, '3045', 58, 'ads_idol_floor1', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(1466, '3046', 121, 'ads_igor_flask', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(1467, '3047', 58, 'ads_idol_floor2', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(1468, '3048', 58, 'ads_idol_drape', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(1469, '3049', 121, 'ads_igor_dsk', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(1470, '3050', 58, 'ads_idol_desk', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(1471, '3051', 58, 'ads_idol_ch', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(1472, '3052', 345, 'lostc_octopus', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(1473, '3053', 58, 'ads_idol_tele', 3, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(1474, '3054', 58, 'ads_idol_mic', 4, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(1475, '3055', 58, 'ads_idol_trax', 4, 0, 0, 1, 0, 0, 26, -1, 0, '', '1', '0'),
	(1476, '3056', 58, 'ads_idol_pchair', 4, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(1477, '3057', 58, 'ads_idol_audChr', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(1478, '3058', 58, 'ads_idol_piano', 4, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(1479, '3059', 58, 'ads_idol_jukebox*1', 10, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(1480, '3060', 303, 'lc_glass_floor', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(1481, '3061', 303, 'lc_chair', 2, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(1482, '3062', 303, 'lc_crab1', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(1483, '3063', 303, 'lc_stool', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(1484, '3064', 303, 'lc_medusa1', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(1485, '3065', 303, 'lc_tubes_straight', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(1486, '3066', 536, 'ads_711shelf', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(1487, '3067', 303, 'lc_table', 5, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(1488, '3068', 303, 'lc_crab2', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(1489, '3069', 303, 'lc_tile2', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(1490, '3070', 303, 'lc_desk', 5, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(1491, '3071', 345, 'lostc_teleport', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(1492, '3072', 303, 'lc_tubes_corners', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(1493, '3073', 303, 'lc_medusa2', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(1494, '3074', 303, 'lc_anemone', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(1495, '3075', 303, 'lc_corner', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(1496, '3076', 303, 'lc_tile1', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(1497, '3077', 303, 'lc_coral_divider_low', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(1498, '3078', 303, 'lc_coral_divider_hi', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(1499, '3079', 58, 'ads_idol_clRack', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(1500, '3080', 58, 'ads_idol_hotspot', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(1501, '3081', 58, 'ads_idol_voting_ch', 4, 0, 0, 1, 0, 0, 29, -1, 0, '', '1', '0'),
	(1502, '3082', 499, 'eco_light2', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(1503, '3083', 499, 'eco_cactus1', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(1504, '3084', 499, 'eco_chair1', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(1505, '3085', 499, 'eco_cactus3', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(1506, '3086', 499, 'eco_table3', 4, 0, 0, 1, 0, 0, 26, -1, 0, '', '1', '0'),
	(1507, '3087', 48, 'bump_tottero', 0, 10, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(1508, '3088', 499, 'eco_sofa3', 4, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(1509, '3089', 499, 'eco_table2', 4, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(1510, '3090', 48, 'bump_signs', 0, 15, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(1511, '3091', 499, 'eco_lamp3', 4, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(1512, '3092', 499, 'eco_lamp2', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(1513, '3093', 499, 'eco_tree1', 4, 0, 0, 1, 0, 0, 27, -1, 0, '', '1', '0'),
	(1514, '3094', 499, 'eco_chair3', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(1515, '3095', 261, 'ecotron_box', 7, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(1516, '3096', 499, 'eco_sofa1', 4, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(1517, '3097', 499, 'eco_lamp1', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(1518, '3098', 499, 'eco_light1', 4, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(1519, '3099', 499, 'eco_table1', 4, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(1520, '3100', 499, 'eco_sofa2', 4, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(1521, '3101', 48, 'bump_tires', 0, 10, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(1522, '3102', 499, 'eco_fruits2', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(1523, '3103', 48, 'bump_lights', 0, 25, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(1524, '3104', 499, 'eco_fruits3', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(1525, '3105', 499, 'eco_cactus2', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(1526, '3106', 499, 'eco_chair2', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(1527, '3107', 499, 'eco_fruits1', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(1528, '3108', 499, 'eco_light3', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(1529, '3109', 499, 'eco_tree2', 4, 0, 0, 1, 0, 0, 28, -1, 0, '', '1', '0'),
	(1530, '3110', 48, 'bump_road', 0, 10, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(1531, '3111', 550, 'ads_frankb', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(1532, '3112', 534, 'ads_grefusa_cactus', 4, 0, 0, 1, 0, 0, 51, -1, 0, '', '1', '0'),
	(1533, '3113', 345, 'totem_leg', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(1534, '3114', 700, 'exe_artlamp', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(1535, '3115', 282, 'env_bushes', 4, 0, 0, 1, 0, 0, 23, 3848, 0, '', '1', '0'),
	(1536, '3116', 58, 'ads_idol_newsDsk', 4, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(1537, '3117', 282, 'env_tree1', 4, 0, 0, 1, 0, 0, 27, 3850, 0, '', '1', '0'),
	(1538, '3118', 282, 'env_tree4', 4, 0, 0, 1, 0, 0, 30, 3851, 0, '', '1', '0'),
	(1539, '3119', 700, 'exe_gate', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(1540, '3120', 58, 'ads_idol_cork', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(1541, '3121', 700, 'exe_cubelight', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(1542, '3122', 700, 'exe_light', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(1543, '3123', 282, 'env_tree2', 4, 0, 0, 1, 0, 0, 28, 3856, 0, '', '1', '0'),
	(1544, '3124', 58, 'ads_idol_ichair', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(1545, '3125', 282, 'env_tree3', 4, 0, 0, 1, 0, 0, 29, 3858, 0, '', '1', '0'),
	(1546, '3126', 58, 'ads_idol_tube', 4, 0, 0, 1, 0, 0, 27, -1, 0, '', '1', '0'),
	(1547, '3127', 516, 'ads_cl_jukeb', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(1548, '3128', 282, 'env_bushes_gate', 4, 0, 0, 1, 0, 0, 24, 18011, 0, '', '1', '0'),
	(1549, '3129', 282, 'env_grass', 4, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(1550, '3130', 249, 'tray_glasstower', 10, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(1551, '3131', 531, 'ads_malaco_gu', 4, 0, 0, 1, 0, 0, 39, -1, 0, '', '1', '0'),
	(1552, '3132', 353, 'ads_reebok_block2', 4, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(1553, '3133', 249, 'tray_cake', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(1554, '3134', 249, 'tray_champagne', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(1555, '3135', 531, 'ads_malaco_rug', 4, 0, 0, 1, 0, 0, 86, -1, 0, '', '1', '0'),
	(1556, '3136', 58, 'ads_idol_tblCloth', 4, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(1557, '3137', 516, 'ads_cl_sofa', 4, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(1558, '3138', 58, 'ads_idol_lamp', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(1559, '3139', 516, 'ads_clcake', 4, 0, 0, 1, 0, 0, 29, -1, 0, '', '1', '0'),
	(1560, '3140', 58, 'ads_idol_carpet', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(1561, '3141', 282, 'country_fnc2', 4, 0, 0, 1, 0, 0, 5, 3971, 0, '', '1', '0'),
	(1562, '3142', 499, 'eco_mush1', 4, 0, 0, 1, 0, 0, 30, -1, 0, '', '1', '0'),
	(1563, '3143', 282, 'country_rbw', 4, 0, 0, 1, 0, 0, 15, 3973, 0, '', '1', '0'),
	(1564, '3144', 46, 'sound_set_72', 4, 0, 0, 1, 0, 0, 35, -1, 0, '', '1', '0'),
	(1565, '3145', 282, 'country_soil', 4, 0, 0, 1, 0, 0, 17, 3975, 0, '', '1', '0'),
	(1566, '3146', 282, 'country_log', 4, 0, 0, 1, 0, 0, 12, 17977, 0, '', '1', '0'),
	(1567, '3147', 282, 'country_trctr', 4, 0, 0, 1, 0, 0, 19, 19359, 0, '', '1', '0'),
	(1568, '3148', 282, 'country_stage', 4, 0, 0, 1, 0, 0, 18, 3978, 0, '', '1', '0'),
	(1569, '3149;50523', 282, 'country_well', 10, 0, 0, 1, 0, 0, 21, 3979, 0, '', '1', '0'),
	(1570, '3150', 282, 'country_gate', 4, 0, 0, 1, 0, 0, 9, 17960, 0, '', '1', '0'),
	(1571, '3151', 313, 'ads_goldtabl', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(1572, '3152', 282, 'country_fnc3', 4, 0, 0, 1, 0, 0, 6, 3982, 0, '', '1', '0'),
	(1573, '3153', 282, 'country_rain', 4, 0, 0, 1, 0, 0, 14, 3983, 0, '', '1', '0'),
	(1574, '3154', 282, 'country_fnc1', 4, 0, 0, 1, 0, 0, 4, 3984, 0, '', '1', '0'),
	(1575, '3155', 499, 'eco_mush2', 4, 0, 0, 1, 0, 0, 31, -1, 0, '', '1', '0'),
	(1576, '3156', 73, 'ads_calip_cola*1', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(1577, '3157', 73, 'ads_calip_cola*2', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(1578, '3158', 73, 'ads_calip_cola*3', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(1579, '3159', 73, 'ads_calip_cola*4', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(1580, '3160', 282, 'country_scarecrow', 4, 0, 0, 1, 0, 0, 16, 3990, 0, '', '1', '0'),
	(1581, '3161', 282, 'env_telep', 4, 0, 0, 1, 0, 0, 26, 3991, 0, '', '1', '0'),
	(1582, '3162', 282, 'country_grass', 4, 0, 0, 1, 0, 0, 10, 3992, 0, '', '1', '0'),
	(1583, '3163', 282, 'country_wheat', 4, 0, 0, 1, 0, 0, 2, 18806, 0, '', '1', '0'),
	(1584, '3164', 282, 'country_corner', 4, 0, 0, 1, 0, 0, 1, 18010, 0, '', '1', '0'),
	(1585, '3165', 282, 'country_ditch', 4, 0, 0, 1, 0, 0, 3, 17991, 0, '', '1', '0'),
	(1586, '3166', 282, 'country_patio', 4, 0, 0, 1, 0, 0, 13, 4005, 0, '', '1', '0'),
	(1587, '3167', 345, 'totem_head', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(1588, '3168', 73, 'ads_calip_chair', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(1589, '3169', 737, 'ads_idol_trophy', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(1590, '3170', 32, 'LT_pillar2', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(1591, '3171', 32, 'LT_throne', 4, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(1592, '3172', 32, 'lt_gate', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(1593, '3173', 22, 'laptopdesk', 4, 0, 0, 1, 0, 0, 100, -1, 0, '', '1', '0'),
	(1594, '3174', 32, 'lt_bughill', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(1595, '3175', 32, 'lt_stage2', 4, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(1596, '3176', 32, 'lt_lava', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(1597, '3177', 32, 'lt_stone2', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(1598, '3178', 32, 'lt_spider', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(1599, '3179', 683, 'audChr', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(1600, '3180', 32, 'lt_lavac', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(1601, '3181', 39, 'saturn', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(1602, '3182', 73, 'ads_calip_pool', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(1603, '3183', 32, 'lt_stage1', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(1604, '3184', 53, 'clrack', 4, 0, 0, 1, 0, 0, 14, 4062, 0, '', '1', '0'),
	(1605, '3185', 32, 'lt_statue', 4, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(1606, '3186', 22, 'noticeboard', 4, 0, 0, 1, 0, 0, 99, 4064, 0, '', '1', '0'),
	(1607, '3187', 32, 'LT_pillar', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(1608, '3188', 32, 'lt_patch', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(1609, '3189', 32, 'LT_skull', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(1610, '3190', 73, 'ads_calip_tele', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(1611, '3195', 73, 'ads_calip_parasol', 4, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(1612, '3196', 32, 'lt_stone1', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(1613, '3197', 73, 'ads_calip_lava', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(1614, '3198', 73, 'ads_calip_fan', 4, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(1615, '3199', 36, 'transparent_floor', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(1616, '3200', 345, 'totem_planet', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(1617, '3201', 683, 'voting_ch', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(1618, '3202', 119, 'ads_mall_coffeem', 4, 0, 0, 1, 0, 0, 87, -1, 0, '', '1', '0'),
	(1619, '3203', 36, 'sf_roof', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(1620, '3204', 36, 'SF_crate_2', 4, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(1621, '3205', 36, 'SF_crate_1', 4, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(1622, '3206', 36, 'sf_stick', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(1623, '3207', 36, 'SF_chair_blue', 2, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(1624, '3208', 36, 'SF_panel3', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(1625, '3209', 36, 'sf_roller', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(1626, '3210', 345, 'SF_alien', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(1627, '3211', 36, 'SF_floor_2', 2, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(1628, '3212', 36, 'SF_reactor', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(1629, '3213', 36, 'sf_floor', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(1630, '3214', 36, 'sf_tele', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(1631, '3215', 36, 'SF_chair_green', 2, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(1632, '3216', 119, 'ads_mall_kiosk', 4, 0, 0, 1, 0, 0, 89, -1, 0, '', '1', '0'),
	(1633, '3217', 36, 'SF_panel1', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(1634, '3218', 36, 'SF_panel2', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(1635, '3219', 345, 'sf_pod', 4, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(1636, '3220', 36, 'SF_table', 5, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(1637, '3221', 36, 'sf_gate', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(1638, '3222', 36, 'SF_floor_1', 2, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(1639, '3223', 36, 'SF_chair_red', 2, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(1640, '3224', 36, 'SF_lamp', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(1641, '3225', 736, 'prizetrophy_cool', 4, 0, 0, 1, 0, 0, 150, -1, 0, '', '1', '0'),
	(1642, '3226', 324, 'ads_elisa_gnome', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(1643, '3227', 405, 'summer_raft2', 4, 0, 0, 1, 0, 0, 58, 18533, 0, '', '1', '0'),
	(1644, '3228', 405, 'summer_raft1', 4, 0, 0, 1, 0, 0, 57, 18534, 0, '', '1', '0'),
	(1645, '3229', 736, 'prizetrophy_hot', 4, 0, 0, 1, 0, 0, 151, -1, 0, '', '1', '0'),
	(1646, '3230', 346, 'ads_oc_soda', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(1647, '3231', 405, 'summer_icebox', 10, 0, 0, 1, 0, 0, 54, 18419, 0, '', '1', '0'),
	(1648, '3232', 36, 'marsrug', 4, 0, 0, 1, 0, 0, 100, -1, 0, '', '1', '0'),
	(1649, '3233', 34, 'rela_stone', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(1650, '3234', 34, 'rela_candles1', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(1651, '3235', 34, 'rela_candle3', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(1652, '3236', 34, 'rela_candles3', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(1653, '3237', 39, 'pix_asteroid', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(1654, '3238', 34, 'rela_candle1', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(1655, '3239', 34, 'rela_orchid', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(1656, '3240', 34, 'rela_stick', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(1657, '3241', 536, 'ads_711*5', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(1658, '3242', 536, 'ads_711*6', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(1659, '3243', 536, 'ads_711*7', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(1660, '3244', 34, 'rela_candle2', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(1661, '3245', 34, 'rela_candles2', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(1662, '3246', 34, 'rela_plant', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(1663, '3247', 34, 'rela_hchair', 2, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(1664, '3248', 34, 'rela_rock', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(1665, '3249', 59, 'ktchn_fridge', 10, 0, 0, 1, 0, 0, 7, 18199, 0, '', '1', '0'),
	(1666, '3250', 59, 'ktchn_inspctr', 4, 0, 0, 1, 0, 0, 10, 18138, 0, '', '1', '0'),
	(1667, '3251', 346, 'ads_1800tele', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(1668, '3252', 59, 'ktchn_pots', 4, 0, 0, 1, 0, 0, 15, 18162, 0, '', '1', '0'),
	(1669, '3253', 59, 'ktchn_countr_2', 4, 0, 0, 1, 0, 0, 4, 4251, 0, '', '1', '0'),
	(1670, '3254', 59, 'ktchn_gate', 4, 0, 0, 1, 0, 0, 8, 4252, 0, '', '1', '0'),
	(1671, '3255', 59, 'ktchn_bBlock', 4, 0, 0, 1, 0, 0, 18, 4253, 0, '', '1', '0'),
	(1672, '3256', 59, 'ktchn_stove', 4, 0, 0, 1, 0, 0, 17, 4254, 0, '', '1', '0'),
	(1673, '3257', 59, 'ktchn_cornr', 4, 0, 0, 1, 0, 0, 2, 4255, 0, '', '1', '0'),
	(1674, '3258', 59, 'ktchn_light', 4, 0, 0, 1, 0, 0, 12, 4256, 0, '', '1', '0'),
	(1675, '3259', 59, 'ktchn_dvdr', 4, 0, 0, 1, 0, 0, 6, 4257, 0, '', '1', '0'),
	(1676, '3260', 59, 'ktchn_desk', 5, 0, 0, 1, 0, 0, 5, 4258, 0, '', '1', '0'),
	(1677, '3261', 59, 'ktchn_countr_1', 4, 0, 0, 1, 0, 0, 3, 4259, 0, '', '1', '0'),
	(1678, '3262', 59, 'ktchn_sink', 4, 0, 0, 1, 0, 0, 16, 4260, 0, '', '1', '0'),
	(1679, '3263', 59, 'ktchn_plates', 4, 0, 0, 1, 0, 0, 14, 4261, 0, '', '1', '0'),
	(1680, '3264', 59, 'ktchn_trash', 4, 0, 0, 1, 0, 0, 18, 4262, 0, '', '1', '0'),
	(1681, '3265', 272, 'urban_lamp', 4, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(1682, '3266', 272, 'urban_bin', 4, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(1683, '3267', 272, 'urban_fence', 4, 0, 0, 1, 0, 0, 20, 4309, 0, '', '1', '0'),
	(1684, '3268', 272, 'urban_carsofa', 3, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(1685, '3269', 272, 'urban_bench', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(1686, '3270', 272, 'urban_blocker', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(1687, '3271', 272, 'urban_bsktbll', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(1688, '3272', 272, 'urban_wpost', 4, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(1689, '3273', 345, 'sf_mbar', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(1690, '3274', 272, 'urban_sidewalk', 4, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(1691, '3275', 272, 'urban_fence_corner', 4, 0, 0, 1, 0, 0, 21, 4317, 0, '', '1', '0'),
	(1692, '3276', 58, 'ads_idol_l_carpet', 4, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(1693, '3277', 533, 'ads_gsArcade_1', 4, 0, 0, 1, 0, 0, 26, -1, 0, '', '1', '0'),
	(1694, '3278', 533, 'ads_gsArcade_2', 4, 0, 0, 1, 0, 0, 54, -1, 0, '', '1', '0'),
	(1695, '3279', 530, 'ads_mtvtrophy_gold', 4, 0, 0, 1, 0, 0, 42, -1, 0, '', '1', '0'),
	(1696, '3280', 524, 'ads_spang_sleep', 4, 0, 0, 1, 0, 0, 27, -1, 0, '', '1', '0'),
	(1697, '3281', 530, 'ads_mtvtrophy_silver', 4, 0, 0, 1, 0, 0, 43, -1, 0, '', '1', '0'),
	(1698, '3282', 345, 'hween09_organ', 4, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(1699, '3283', 58, 'ads_idol_chmpgn', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(1700, '3284', 272, 'urban_bench_plain', 4, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(1701, '3285', 390, 'hween09_hatch', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(1702, '3286', 390, 'hween09_table', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(1703, '3287', 390, 'hween09_jar', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(1704, '3288', 390, 'hween09_floor', 2, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(1705, '3289', 49, 'byesw_hotel', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(1706, '3290', 390, 'hween09_ghost', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(1707, '3291', 49, 'byesw_hand', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(1708, '3292', 390, 'hween09_tv', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(1709, '3293', 390, 'hween09_mirror', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(1710, '3294', 390, 'hween09_chandelier', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(1711, '3295', 390, 'hween09_chair', 2, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(1712, '3296', 44, 'ads_twi_toolbx', 4, 0, 0, 1, 0, 0, 141, -1, 0, '', '1', '0'),
	(1713, '3297', 44, 'ads_twi_table', 4, 0, 0, 1, 0, 0, 140, -1, 0, '', '1', '0'),
	(1714, '3298', 44, 'ads_twi_tower', 4, 0, 0, 1, 0, 0, 52, -1, 0, '', '1', '0'),
	(1715, '3299', 44, 'ads_twi_piano', 4, 0, 0, 1, 0, 0, 138, -1, 0, '', '1', '0'),
	(1716, '3300', 44, 'ads_twi_chair', 4, 0, 0, 1, 0, 0, 130, -1, 0, '', '1', '0'),
	(1717, '3301', 44, 'ads_twi_fountn', 4, 0, 0, 1, 0, 0, 135, -1, 0, '', '1', '0'),
	(1718, '3302', 44, 'ads_twi_dvdr2', 4, 0, 0, 1, 0, 0, 49, -1, 0, '', '1', '0'),
	(1719, '3303', 44, 'ads_twi_dvdr1', 4, 0, 0, 1, 0, 0, 133, -1, 0, '', '1', '0'),
	(1720, '3304', 44, 'ads_twi_roses', 4, 0, 0, 1, 0, 0, 139, -1, 0, '', '1', '0'),
	(1721, '3305', 700, 'exe_elevator', 5, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(1722, '3306', 119, 'ads_mall_elevator', 4, 0, 0, 1, 0, 0, 88, -1, 0, '', '1', '0'),
	(1723, '3307', 59, 'ktchn_hlthNut', 4, 0, 0, 1, 0, 0, 9, 4534, 0, '', '1', '0'),
	(1724, '3308', 44, 'ads_twi_mist', 4, 0, 0, 1, 0, 0, 50, -1, 0, '', '1', '0'),
	(1725, '3309', 115, 'nest_plow_bro', 2, 0, 0, 1, 0, 0, 50, 4543, 0, '', '1', '0'),
	(1726, '3310', 115, 'nest_snug_grn', 2, 0, 0, 1, 0, 0, 33, 4544, 0, '', '1', '0'),
	(1727, '3311', 736, 'ads_twi_trophy', 4, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(1728, '3312', 28, 'arabian_tile', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(1729, '3313', 476, 'xm09_lrgBauble', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(1730, '3314', 476, 'xm09_candyCane', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(1731, '3315', 115, 'nest_snug_blu', 2, 0, 0, 1, 0, 0, 49, 4549, 0, '', '1', '0'),
	(1732, '3316', 115, 'nest_plow_blu', 2, 0, 0, 1, 0, 0, 48, 4550, 0, '', '1', '0'),
	(1733, '3317', 115, 'nest_snug_red', 2, 0, 0, 1, 0, 0, 24, 4551, 0, '', '1', '0'),
	(1734, '3318', 115, 'nest_plow_reg', 2, 0, 0, 1, 0, 0, 46, 4552, 0, '', '1', '0'),
	(1735, '3319', 115, 'nest_snug_yel', 2, 0, 0, 1, 0, 0, 23, 4553, 0, '', '1', '0'),
	(1736, '3320', 115, 'nest_plow_red', 2, 0, 0, 1, 0, 0, 1, 17857, 0, '', '1', '0'),
	(1737, '3321', 52, 'petfood7', 1, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(1738, '3322', 52, 'petfood9', 1, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(1739, '3323', 52, 'petfood6', 1, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(1740, '3324', 52, 'petfood5', 1, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(1741, '3325', 52, 'petfood8', 1, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(1742, '3326', 52, 'petfood10', 1, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(1743, '3327', 33, 'party_lantern', 4, 0, 0, 1, 0, 0, 101, 4608, 0, '', '1', '0'),
	(1744, '3328', 476, 'xm09_man_b', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(1745, '3329', 476, 'xm09_man_c', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(1746, '3330', 476, 'xm09_man_a', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(1747, '3331', 115, 'nest_dirt', 2, 0, 0, 1, 0, 0, 22, 4612, 0, '', '1', '0'),
	(1748, '3332', 115, 'nest_snug_prp', 2, 0, 0, 1, 0, 0, 42, 4613, 0, '', '1', '0'),
	(1749, '3333', 115, 'nest_basket', 2, 0, 0, 1, 0, 0, 21, 4614, 0, '', '1', '0'),
	(1750, '3334', 115, 'nest_nest', 2, 0, 0, 1, 0, 0, 40, 4615, 0, '', '1', '0'),
	(1751, '3335', 476, 'xm09_table', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(1752, '3336', 115, 'nest_nails', 2, 0, 0, 1, 0, 0, 20, 4617, 0, '', '1', '0'),
	(1753, '3337', 476, 'xm09_cocoa', 10, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(1754, '3338', 115, 'nest_snug_bla', 2, 0, 0, 1, 0, 0, 38, 4619, 0, '', '1', '0'),
	(1755, '3339', 115, 'nest_ice', 2, 0, 0, 1, 0, 0, 37, 4620, 0, '', '1', '0'),
	(1756, '3340', 476, 'xm09_bench', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(1757, '3341', 115, 'nest_plow_skl', 2, 0, 0, 1, 0, 0, 19, 4622, 0, '', '1', '0'),
	(1758, '3342', 516, 'ads_cl_moodi', 4, 0, 0, 1, 0, 0, 40, -1, 0, '', '1', '0'),
	(1759, '3343', 737, 'prizetrophy_nrj', 5, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(1760, '3344', 302, 'china_tiger', 4, 0, 0, 1, 0, 0, 31, -1, 0, '', '1', '0'),
	(1761, '3345', 51, 'org_chrblk', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(1762, '3346', 302, 'china_tigrSeat', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(1763, '3347', 51, 'org_tblblk', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(1764, '3348', 51, 'org_lamppnk', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(1765, '3349', 51, 'org_chairblk', 2, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(1766, '3350', 51, 'org_chrpnk', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(1767, '3351', 736, 'xm09_trophy', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(1768, '3352', 51, 'org_tblpnk', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(1769, '3353', 51, 'org_lampblk', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(1770, '3354', 51, 'org_chairpnk', 2, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(1771, '3355', 302, 'china_plmTree', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(1772, '3356', 51, 'org_table', 5, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(1773, '3357', 50, 'val09_floor2', 2, 0, 0, 1, 0, 0, 43, 24152, 0, '', '1', '0'),
	(1774, '3358', 194, 'petfood11', 0, 10, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(1775, '3359', 194, 'petfood13', 0, 10, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(1776, '3360', 50, 'bling_chair_b', 2, 0, 0, 1, 0, 0, 28, -1, 0, '', '1', '0'),
	(1777, '3361', 50, 'bling_chair_c', 2, 0, 0, 1, 0, 0, 29, -1, 0, '', '1', '0'),
	(1778, '3362', 50, 'bling_toilet', 4, 0, 0, 1, 0, 0, 36, -1, 0, '', '1', '0'),
	(1779, '3363', 50, 'val09_floor', 2, 0, 0, 1, 0, 0, 42, -1, 0, '', '1', '0'),
	(1780, '3364', 50, 'bling_bed', 4, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(1781, '3365', 548, 'ads_droetker_paula', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(1782, '3366', 50, 'bling_fridge', 10, 0, 0, 1, 0, 0, 30, -1, 0, '', '1', '0'),
	(1783, '3367', 305, 'ads_chups', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(1784, '3368', 50, 'bling_chair_a', 2, 0, 0, 1, 0, 0, 27, -1, 0, '', '1', '0'),
	(1785, '3369', 50, 'bling_pool', 4, 0, 0, 1, 0, 0, 32, -1, 0, '', '1', '0'),
	(1786, '3370', 194, 'petfood12', 0, 10, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(1787, '3371', 50, 'bling_sofa', 3, 0, 0, 1, 0, 0, 35, -1, 0, '', '1', '0'),
	(1788, '3372', 261, 'present_wrap*1', 7, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(1789, '3373', 261, 'present_wrap*10', 7, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(1790, '3374', 261, 'present_wrap*2', 7, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(1791, '3375', 261, 'present_wrap*3', 7, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(1792, '3376', 261, 'present_wrap*4', 7, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(1793, '3377', 261, 'present_wrap*5', 7, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(1794, '3378', 261, 'present_wrap*6', 7, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(1795, '3379', 261, 'present_wrap*7', 7, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(1796, '3380', 261, 'present_wrap*8', 7, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(1797, '3381', 261, 'present_wrap*9', 7, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(1798, '3382', 452, 'val_basket', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(1799, '3383', 452, 'teddy_pink', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(1800, '3384', 452, 'teddy_pendergrass', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(1801, '3385', 452, 'teddy_bear', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(1802, '3386', 452, 'val_hSeat*1', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(1803, '3387', 452, 'val_hSeat*2', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(1804, '3388', 452, 'val_hSeat*3', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(1805, '3389', 452, 'val_hSeat*4', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(1806, '3390', 452, 'val_hSeat*5', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(1807, '3391', 452, 'val_hSeat*6', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(1808, '3392', 452, 'val_hSeat*7', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(1809, '3393', 452, 'teddy_basic', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(1810, '3394', 50, 'bling_fridge_restricted', 10, 0, 0, 1, 0, 0, 31, -1, 0, '', '1', '0'),
	(1811, '3395', 542, 'ads_percyrock', 4, 0, 0, 1, 0, 0, 117, -1, 0, '', '1', '0'),
	(1812, '3396', 50, 'bling_shwr', 4, 0, 0, 1, 0, 0, 33, -1, 0, '', '1', '0'),
	(1813, '3397', 452, 'val_table1', 2, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(1814, '3398', 849, 'rare_trex', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(1815, '3399', 849, 'rare_ironmaiden', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(1816, '3400', 849, 'crystal_patch', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(1817, '3401', 849, 'beanstalk', 4, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(1818, '3402', 849, 'rare_mmmth', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(1819, '3403', 849, 'rare_vdoll', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(1820, '3404', 401, 'garden_mursu', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(1821, '3405', 401, 'garden_jyrki', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(1822, '3406', 401, 'garden_seed', 4, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(1823, '3407', 401, 'garden_lupin3', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(1824, '3408', 401, 'garden_mursu3', 4, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(1825, '3409', 401, 'garden_flo2', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(1826, '3410', 737, 'prizetrophy_thumb', 5, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(1827, '3411', 401, 'garden_lupin5', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(1828, '3412', 401, 'garden_mursu2', 4, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(1829, '3413', 401, 'garden_orchtree', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(1830, '3414', 401, 'garden_mursu4', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(1831, '3415', 401, 'garden_flolamp', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(1832, '3416', 401, 'garden_lupin2', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(1833, '3417', 401, 'garden_staringbush', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(1834, '3418', 401, 'garden_flo1', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(1835, '3419', 401, 'garden_lupin4', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(1836, '3420', 401, 'garden_flytrap', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(1837, '3421', 401, 'garden_lupin1', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(1838, '3422', 401, 'garden_jungle', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(1839, '3423', 534, 'ads_grefusa_yum', 4, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(1840, '3424', 401, 'garden_volcano', 4, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(1841, '3425', 401, 'garden_leaves', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(1842, '3426', 401, 'garden_flo3', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(1843, '3427', 53, 'runway_bigchr_2', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(1844, '3428', 352, 'hc2_vase', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '1'),
	(1845, '3429', 53, 'runway_chair_2', 2, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(1846, '3430', 352, 'hc2_cart', 5, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '1'),
	(1847, '3431', 352, 'hc3_divider', 5, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '1'),
	(1848, '3432', 53, 'runway_head', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(1849, '3433', 53, 'runway_block_1', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(1850, '3434', 352, 'hc2_sofatbl', 5, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '1'),
	(1851, '3435', 53, 'runway_bigchr_4', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(1852, '3436', 352, 'hc2_armchair', 5, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '1'),
	(1853, '3437', 53, 'runway_manqn_1', 4, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(1854, '3438', 352, 'hc3_shelf', 5, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '1'),
	(1855, '3439', 352, 'hc2_barchair', 5, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '1'),
	(1856, '3440', 352, 'hc2_carpet', 5, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '1'),
	(1857, '3441', 352, 'hc3_sofa', 5, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '1'),
	(1858, '3442', 53, 'runway_stool', 4, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(1859, '3443', 53, 'runway_block_2', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(1860, '3444', 53, 'runway_table_2', 4, 0, 0, 1, 0, 0, 27, -1, 0, '', '1', '0'),
	(1861, '3445', 352, 'hc3_bard', 5, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '1'),
	(1862, '3446', 352, 'hc2_biglamp', 5, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '1'),
	(1863, '3447', 352, 'hc3_hugelamp', 5, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '1'),
	(1864, '3448', 352, 'hc3_stool', 5, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '1'),
	(1865, '3449', 352, 'hc2_divider', 5, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '1'),
	(1866, '3450', 352, 'hc2_coffee', 5, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '1'),
	(1867, '3451', 53, 'runway_chair_1', 2, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(1868, '3452', 352, 'hc2_sofa', 5, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '1'),
	(1869, '3453', 553, 'ads_cheetos', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(1870, '3454', 53, 'runway_bigchr_3', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(1871, '3455', 492, 'merger_chest', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(1872, '3456', 53, 'runway_dvdr', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(1873, '3457', 53, 'runway_display', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(1874, '3458', 352, 'hc2_frplc', 5, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '1'),
	(1875, '3459', 352, 'hc2_dvn', 5, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '1'),
	(1876, '3460', 53, 'runway_table_1', 4, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(1877, '3461', 352, 'hc3_dc', 5, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '1'),
	(1878, '3462', 53, 'runway_bigchr_1', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(1879, '3463', 53, 'runway_bigchr_5', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(1880, '3464', 53, 'runway_bench', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(1881, '3465', 352, 'hc3_light', 5, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '1'),
	(1882, '3466', 352, 'hc3_table', 5, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '1'),
	(1883, '3467', 53, 'runway_manqn_2', 4, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(1884, '3468', 492, 'cmp_fish_s', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(1885, '3469', 492, 'cmp_fish_bk', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(1886, '3470', 352, 'hc3_stereo', 5, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '1'),
	(1887, '3471', 492, 'cmp_nobox_2', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(1888, '3472', 492, 'cmp_fish_b', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(1889, '3473', 492, 'cmp_nobox_3', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(1890, '3474', 492, 'cmp_fish_gr', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(1891, '3475', 492, 'cmp_fish_g', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(1892, '3476', 492, 'cmp_nobox', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(1893, '3477', 492, 'cmp_fish_r', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(1894, '3478', 492, 'cmp_sub', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(1895, '3479', 352, 'hc3_vase', 5, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '1'),
	(1896, '3480', 33, 'party_crate2_1', 4, 0, 0, 1, 0, 0, 12, 5766, 0, '', '1', '0'),
	(1897, '3481', 33, 'party_crate1_3', 4, 0, 0, 1, 0, 0, 10, 5767, 0, '', '1', '0'),
	(1898, '3482', 249, 'wed_plant', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(1899, '3483', 249, 'wed_arch', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(1900, '3484', 33, 'party_djset', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(1901, '3485', 33, 'party_crate1_4', 4, 0, 0, 1, 0, 0, 11, 5771, 0, '', '1', '0'),
	(1902, '3486', 546, 'ads_chocapic', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(1903, '3487', 33, 'party_crate1_1', 4, 0, 0, 1, 0, 0, 8, 5773, 0, '', '1', '0'),
	(1904, '3488', 249, 'wed_icesculp', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(1905, '3489', 33, 'party_crate1_2', 4, 0, 0, 1, 0, 0, 9, 5775, 0, '', '1', '0'),
	(1906, '3490', 33, 'party_crate2_2', 4, 0, 0, 1, 0, 0, 13, 5776, 0, '', '1', '0'),
	(1907, '3491', 33, 'party_crate2_3', 4, 0, 0, 1, 0, 0, 14, 5777, 0, '', '1', '0'),
	(1908, '3492', 33, 'party_crate2_4', 4, 0, 0, 1, 0, 0, 15, 5778, 0, '', '1', '0'),
	(1909, '3493', 249, 'wed_carsofa', 3, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(1910, '3494', 523, 'fball_bench', 1, 0, 0, 1, 0, 0, 9, 17981, 0, '', '1', '0'),
	(1911, '3495', 523, 'fball_fnc3', 3, 0, 0, 1, 0, 0, 14, 5805, 0, '', '1', '0'),
	(1912, '3496', 523, 'fball_score_b', 2, 0, 0, 1, 0, 0, 31, 9256, 0, '', '1', '0'),
	(1913, '3497', 523, 'fball_ball3', 15, 0, 0, 1, 0, 0, 5, 5807, 0, '', '1', '0'),
	(1914, '3498', 523, 'fball_ptch5', 3, 0, 0, 1, 0, 0, 26, 5808, 0, '', '1', '0'),
	(1915, '3499', 523, 'fball_light', 6, 0, 0, 1, 0, 0, 20, 5809, 0, '', '1', '0'),
	(1916, '3500', 523, 'fball_audbench', 6, 0, 0, 1, 0, 0, 1, 5810, 0, '', '1', '0'),
	(1917, '3501', 523, 'fball_fnc1', 2, 0, 0, 1, 0, 0, 13, 5811, 0, '', '1', '0'),
	(1918, '3502', 523, 'fball_ptch8', 3, 0, 0, 1, 0, 0, 29, 5812, 0, '', '1', '0'),
	(1919, '3503', 523, 'fball_crnr', 2, 0, 0, 1, 0, 0, 12, 5813, 0, '', '1', '0'),
	(1920, '3504', 523, 'fball_ptch4', 3, 0, 0, 1, 0, 0, 25, 5814, 0, '', '1', '0'),
	(1921, '3505', 737, 'fball_trophy', 5, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(1922, '3506', 523, 'fball_score_y', 2, 0, 0, 1, 0, 0, 34, -1, 0, '', '1', '0'),
	(1923, '3507', 523, 'fball_cote', 3, 0, 0, 1, 0, 0, 10, 5817, 0, '', '1', '0'),
	(1924, '3508', 523, 'fball_ball', 5, 0, 0, 1, 0, 0, 3, 18006, 0, '', '1', '0'),
	(1925, '3509', 523, 'fball_ptch7', 3, 0, 0, 1, 0, 0, 28, 5819, 0, '', '1', '0'),
	(1926, '3510', 523, 'fball_ball2', 15, 0, 0, 1, 0, 0, 4, 5820, 0, '', '1', '0'),
	(1927, '3511', 523, 'fball_ptch2', 3, 0, 0, 1, 0, 0, 23, 5821, 0, '', '1', '0'),
	(1928, '3512', 523, 'fball_score_g', 2, 0, 0, 1, 0, 0, 32, -1, 0, '', '1', '0'),
	(1929, '3513', 523, 'fball_ptch3', 3, 0, 0, 1, 0, 0, 24, 5823, 0, '', '1', '0'),
	(1930, '3514', 523, 'fball_goal_r', 3, 0, 0, 1, 0, 0, 18, 5824, 0, '', '1', '0'),
	(1931, '3515', 523, 'fball_goal_b', 3, 0, 0, 1, 0, 0, 16, 5825, 0, '', '1', '0'),
	(1932, '3516', 523, 'fball_gate', 15, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(1933, '3517', 523, 'fball_ptch6', 3, 0, 0, 1, 0, 0, 27, 5827, 0, '', '1', '0'),
	(1934, '3518', 523, 'fball_ball5', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(1935, '3519', 523, 'fball_goal_g', 3, 0, 0, 1, 0, 0, 17, 5829, 0, '', '1', '0'),
	(1936, '3520', 523, 'fball_ptch0', 3, 0, 0, 1, 0, 0, 21, 5830, 0, '', '1', '0'),
	(1937, '3521', 523, 'fball_ball4', 15, 0, 0, 1, 0, 0, 6, 5831, 0, '', '1', '0'),
	(1938, '3522', 523, 'fball_score_r', 2, 0, 0, 1, 0, 0, 33, 9256, 0, '', '1', '0'),
	(1939, '3523', 523, 'fball_goal_y', 3, 0, 0, 1, 0, 0, 19, 5833, 0, '', '1', '0'),
	(1940, '3524', 523, 'fball_ptch1', 3, 0, 0, 1, 0, 0, 22, 5834, 0, '', '1', '0'),
	(1941, '3525', 523, 'fball_counter', 10, 0, 0, 1, 0, 0, 11, 7675, 0, '', '1', '0'),
	(1942, '3526', 54, 'prison_gate', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(1943, '3527', 403, 'bw_boat', 4, 0, 0, 1, 0, 0, 2, 18327, 0, '', '1', '0'),
	(1944, '3528', 54, 'prison_crnr', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(1945, '3529', 403, 'bw_lgchair', 2, 0, 0, 1, 0, 0, 18, 8732, 0, '', '1', '0'),
	(1946, '3530', 403, 'bw_water_1', 4, 0, 0, 1, 0, 0, 42, 8733, 0, '', '1', '0'),
	(1947, '3531', 54, 'prison_tower', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(1948, '3532', 54, 'prison_dvdr2', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(1949, '3533', 403, 'bw_sofa', 3, 0, 0, 1, 0, 0, 32, 8736, 0, '', '1', '0'),
	(1950, '3534', 54, 'prison_dvdr1', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(1951, '3535', 537, 'ads_capri_chair', 4, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(1952, '3536', 537, 'ads_capri_lava', 4, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(1953, '3537', 54, 'prison_stone', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(1954, '3538', 403, 'bw_fin', 4, 0, 0, 1, 0, 0, 10, 8741, 0, '', '1', '0'),
	(1955, '3539', 403, 'bw_ccnuts', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(1956, '3540', 403, 'bw_shower', 4, 0, 0, 1, 0, 0, 31, 8743, 0, '', '1', '0'),
	(1957, '3541', 403, 'bw_water_2', 4, 0, 0, 1, 0, 0, 43, 8744, 0, '', '1', '0'),
	(1958, '3542', 403, 'bw_croc', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(1959, '3543', 403, 'bw_sboard', 4, 0, 0, 1, 0, 0, 28, 8746, 0, '', '1', '0'),
	(1960, '3544', 403, 'bw_chair', 2, 0, 0, 1, 0, 0, 6, 18458, 0, '', '1', '0'),
	(1961, '3545', 403, 'bw_table', 5, 0, 0, 1, 0, 0, 35, 8748, 0, '', '1', '0'),
	(1962, '3546', 537, 'ads_capri_tree', 4, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(1963, '3547', 403, 'bw_bball', 4, 0, 0, 1, 0, 0, 1, 8750, 0, '', '1', '0'),
	(1964, '3548', 403, 'bw_mttrss', 4, 0, 0, 1, 0, 0, 19, 18333, 0, '', '1', '0'),
	(1965, '3549', 403, 'bw_van', 4, 0, 0, 1, 0, 0, 39, 18580, 0, '', '1', '0'),
	(1966, '3550', 403, 'bw_tele', 4, 0, 0, 1, 0, 0, 38, 8753, 0, '', '1', '0'),
	(1967, '3551', 403, 'bw_fnc_crnr', 4, 0, 0, 1, 0, 0, 11, 8754, 0, '', '1', '0'),
	(1968, '3552', 403, 'bw_fnc', 4, 0, 0, 1, 0, 0, 14, 8755, 0, '', '1', '0'),
	(1969, '3553', 537, 'ads_capri_arcade', 4, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(1970, '3554', 351, 'ads_pepsi0', 4, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(1971, '3555', 403, 'bw_boat_p', 4, 0, 0, 1, 0, 0, 4, 18504, 0, '', '1', '0'),
	(1972, '3556', 403, 'bw_pool_a3', 4, 0, 0, 1, 0, 0, 24, 8777, 0, '', '1', '0'),
	(1973, '3557', 403, 'bw_fnc_g', 4, 0, 0, 1, 0, 0, 15, 8778, 0, '', '1', '0'),
	(1974, '3558', 403, 'bw_mttrss_g', 4, 0, 0, 1, 0, 0, 20, 18527, 0, '', '1', '0'),
	(1975, '3559', 403, 'bw_mttrss_p', 4, 0, 0, 1, 0, 0, 21, 18524, 0, '', '1', '0'),
	(1976, '3560', 403, 'bw_pool_b1', 4, 0, 0, 1, 0, 0, 25, 8781, 0, '', '1', '0'),
	(1977, '3561', 403, 'bw_sofa_p', 3, 0, 0, 1, 0, 0, 34, 8782, 0, '', '1', '0'),
	(1978, '3562', 403, 'bw_sboard_g', 4, 0, 0, 1, 0, 0, 29, 8783, 0, '', '1', '0'),
	(1979, '3563', 403, 'bw_fnc_crnr_g', 4, 0, 0, 1, 0, 0, 12, 8784, 0, '', '1', '0'),
	(1980, '3564', 403, 'bw_pool_a2', 4, 0, 0, 1, 0, 0, 23, 8785, 0, '', '1', '0'),
	(1981, '3565', 403, 'bw_pool_b2', 4, 0, 0, 1, 0, 0, 26, 8786, 0, '', '1', '0'),
	(1982, '3566', 403, 'bw_table_g', 5, 0, 0, 1, 0, 0, 36, 8787, 0, '', '1', '0'),
	(1983, '3567', 403, 'bw_chair_p', 2, 0, 0, 1, 0, 0, 8, 18563, 0, '', '1', '0'),
	(1984, '3568', 403, 'bw_boat_g', 4, 0, 0, 1, 0, 0, 3, 18503, 0, '', '1', '0'),
	(1985, '3569', 403, 'bw_fnc_p', 4, 0, 0, 1, 0, 0, 16, 8790, 0, '', '1', '0'),
	(1986, '3570', 403, 'bw_van_p', 4, 0, 0, 1, 0, 0, 41, 18500, 0, '', '1', '0'),
	(1987, '3571', 403, 'bw_sboard_p', 4, 0, 0, 1, 0, 0, 30, 8792, 0, '', '1', '0'),
	(1988, '3572', 403, 'bw_chair_g', 2, 0, 0, 1, 0, 0, 7, 18560, 0, '', '1', '0'),
	(1989, '3573', 403, 'bw_pool_b3', 4, 0, 0, 1, 0, 0, 27, 8794, 0, '', '1', '0'),
	(1990, '3574', 403, 'bw_van_g', 4, 0, 0, 1, 0, 0, 40, 18496, 0, '', '1', '0'),
	(1991, '3575', 403, 'bw_sofa_g', 3, 0, 0, 1, 0, 0, 33, 8796, 0, '', '1', '0'),
	(1992, '3576', 403, 'bw_fnc_crnr_p', 4, 0, 0, 1, 0, 0, 13, 8797, 0, '', '1', '0'),
	(1993, '3577', 403, 'bw_pool_a1', 4, 0, 0, 1, 0, 0, 22, 8798, 0, '', '1', '0'),
	(1994, '3578', 403, 'bw_table_p', 5, 0, 0, 1, 0, 0, 37, 8799, 0, '', '1', '0'),
	(1995, '3579', 68, 'african_fence', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(1996, '3580', 59, 'ktchn10_pot', 4, 0, 0, 1, 0, 0, 22, 8864, 0, '', '1', '0'),
	(1997, '3581', 59, 'ktchn10_stove', 4, 0, 0, 1, 0, 0, 24, 8865, 0, '', '1', '0'),
	(1998, '3582', 66, 'easel_0', 4, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(1999, '3583', 52, 'petfood15', 1, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(2000, '3584', 68, 'african_tree1', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(2001, '3585', 553, 'ads_cheetos_hotdog', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(2002, '3586', 444, 'hosptl_cab1', 10, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(2003, '3587', 115, 'nest_lion2', 2, 0, 0, 1, 0, 0, 18, 8871, 0, '', '1', '0'),
	(2004, '3588', 444, 'hosptl_curtain', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(2005, '3589', 59, 'ktchn10_block', 4, 0, 0, 1, 0, 0, 20, 8873, 0, '', '1', '0'),
	(2006, '3590', 444, 'hosptl_bed', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(2007, '3591', 444, 'hosptl_bbag', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(2008, '3592', 59, 'ktchn10_tea', 4, 0, 0, 1, 0, 0, 25, 8876, 0, '', '1', '0'),
	(2009, '3593', 553, 'ads_cheetos_bath', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(2010, '3594', 66, 'easel_1', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(2011, '3595', 408, 'tiki_gate', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(2012, '3596', 66, 'easel_3', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(2013, '3597', 115, 'nest_rhino', 2, 0, 0, 1, 0, 0, 34, 8881, 0, '', '1', '0'),
	(2014, '3598', 346, 'ads_oc_soda_cherry', 4, 0, 0, 1, 0, 0, 34, -1, 0, '', '1', '0'),
	(2015, '3599', 52, 'petfood14', 1, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(2016, '3600', 66, 'easel_4', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(2017, '3601', 115, 'nest_lion', 2, 0, 0, 1, 0, 0, 33, 8885, 0, '', '1', '0'),
	(2018, '3602', 68, 'african_patch', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(2019, '3603', 66, 'easel_2', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(2020, '3604', 444, 'hosptl_skele', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(2021, '3605', 68, 'african_tree2', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(2022, '3606', 444, 'hosptl_defibs', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(2023, '3607', 68, 'african_stage', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(2024, '3608', 444, 'hosptl_cab2', 10, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(2025, '3609', 68, 'african_bones', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(2026, '3610', 444, 'hosptl_light', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(2027, '3611', 444, 'hosptl_seat', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(2028, '3612', 59, 'ktchn10_sink', 4, 0, 0, 1, 0, 0, 23, 8896, 0, '', '1', '0'),
	(2029, '3613', 562, 'ads_disney_tv', 4, 0, 0, 1, 0, 0, 35, -1, 0, '', '1', '0'),
	(2030, '3614', 45, 'bb_crnr', 2, 0, 0, 1, 0, 0, 14, 8927, 0, '', '1', '0'),
	(2031, '3615', 45, 'bb_score_b', 5, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(2032, '3616', 45, 'bb_robo', 5, 0, 0, 1, 0, 0, 21, 8929, 0, '', '1', '0'),
	(2033, '3617', 45, 'bb_dragon', 5, 0, 0, 1, 0, 0, 20, 8930, 0, '', '1', '0'),
	(2034, '3618', 45, 'bb_ducklight', 3, 0, 0, 1, 0, 0, 30, 8931, 0, '', '1', '0'),
	(2035, '3619', 45, 'bb_caterhead', 2, 0, 0, 1, 0, 0, 23, 8932, 0, '', '1', '0'),
	(2036, '3620', 45, 'bb_cargobox', 3, 0, 0, 1, 0, 0, 22, 8933, 0, '', '1', '0'),
	(2037, '3621', 45, 'bb_gate_g', 5, 0, 0, 1, 0, 0, 9, 8934, 0, '', '1', '0'),
	(2038, '3622', 45, 'bb_crchair3', 3, 0, 0, 1, 0, 0, 28, 8935, 0, '', '1', '0'),
	(2039, '3623', 45, 'bb_score_g', 5, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(2040, '3624', 45, 'bb_crchair', 3, 0, 0, 1, 0, 0, 27, 8937, 0, '', '1', '0'),
	(2041, '3625', 45, 'bb_crchair2', 3, 0, 0, 1, 0, 0, 29, 8938, 0, '', '1', '0'),
	(2042, '3626', 45, 'bb_score_y', 5, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(2043, '3627', 45, 'bb_knj1', 2, 0, 0, 1, 0, 0, 25, 8940, 0, '', '1', '0'),
	(2044, '3628', 45, 'bb_gate_r', 5, 0, 0, 1, 0, 0, 10, 8941, 0, '', '1', '0'),
	(2045, '3629', 45, 'bb_tddhnd', 2, 0, 0, 1, 0, 0, 31, 8942, 0, '', '1', '0'),
	(2046, '3630', 45, 'bb_lightdiv', 2, 0, 0, 1, 0, 0, 32, 8943, 0, '', '1', '0'),
	(2047, '3631', 45, 'bb_tddhead', 3, 0, 0, 1, 0, 0, 30, 8944, 0, '', '1', '0'),
	(2048, '3632', 45, 'bb_pyramid', 3, 0, 0, 1, 0, 0, 19, 8945, 0, '', '1', '0'),
	(2049, '3633', 45, 'bb_patch1', 1, 0, 0, 1, 0, 0, 16, 8946, 0, '', '1', '0'),
	(2050, '3634', 45, 'bb_fnc3', 3, 0, 0, 1, 0, 0, 13, 8947, 0, '', '1', '0'),
	(2051, '3635', 45, 'bb_gate_y', 5, 0, 0, 1, 0, 0, 11, 8948, 0, '', '1', '0'),
	(2052, '3636', 391, 'hween10_zombie', 10, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(2053, '3637', 45, 'bb_apparatus', 8, 0, 0, 1, 0, 0, 3, 8950, 0, '', '1', '0'),
	(2054, '3638', 45, 'bb_caterbody', 2, 0, 0, 1, 0, 0, 24, 8951, 0, '', '1', '0'),
	(2055, '3639', 45, 'bb_knj2', 2, 0, 0, 1, 0, 0, 26, 8952, 0, '', '1', '0'),
	(2056, '3640', 45, 'bb_fnc1', 2, 0, 0, 1, 0, 0, 12, 8953, 0, '', '1', '0'),
	(2057, '3641', 45, 'bb_puck', 5, 0, 0, 1, 0, 0, 15, 8954, 0, '', '1', '0'),
	(2058, '3642', 45, 'bb_rnd_tele', 2, 0, 0, 1, 0, 0, 1, 17891, 0, '', '1', '0'),
	(2059, '3643', 45, 'bb_gate_b', 5, 0, 0, 1, 0, 0, 8, 8956, 0, '', '1', '0'),
	(2060, '3644', 45, 'bb_score_r', 5, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(2061, '3645', 45, 'bb_counter', 3, 0, 0, 1, 0, 0, 2, 17830, 0, '', '1', '0'),
	(2062, '3646', 391, 'hween10_tarot', 4, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(2063, '3647', 391, 'hween10_voodoo1', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(2064, '3648', 391, 'hween10_tree', 4, 0, 0, 1, 0, 0, 24, 21590, 0, '', '1', '0'),
	(2065, '3649', 391, 'hween10_swamp', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(2066, '3650', 391, 'hween10_pond', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(2067, '3651', 391, 'hween10_jar', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(2068, '3652', 391, 'hween10_fog', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(2069, '3653', 391, 'hween10_voodoo2', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(2070, '3654', 391, 'hween10_skullpost', 4, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(2071, '3655', 391, 'hween10_voodoo3', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(2072, '3656', 391, 'hween10_logs', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(2073, '3657', 391, 'hween10_ffly', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(2074, '3658', 391, 'hween10_chicken', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(2075, '3659', 391, 'hween10_tele', 4, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(2076, '3660', 391, 'hween10_throne', 4, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(2077, '3661', 391, 'hween10_portch', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(2078, '3662', 391, 'hween10_bat', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(2079, '3663', 64, 'wf_act_move_rotate', 4, 0, 0, 1, 0, 0, 1, 9098, 0, '', '1', '0'),
	(2080, '3664', 211, 'wf_wire2', 4, 0, 0, 1, 0, 0, 12, 9099, 0, '', '1', '0'),
	(2081, '3665', 65, 'wf_cnd_time_more_than', 5, 0, 0, 1, 0, 0, 1, 9100, 0, '', '1', '0'),
	(2082, '3666', 211, 'wf_colortile', 2, 0, 0, 1, 0, 0, 6, 9101, 0, '', '1', '0'),
	(2083, '3667', 211, 'wf_floor_switch2', 4, 0, 0, 1, 0, 0, 2, 9102, 0, '', '1', '0'),
	(2084, '3668', 63, 'wf_trg_state_changed', 4, 0, 0, 1, 0, 0, 1, 9103, 0, '', '1', '0'),
	(2085, '3669', 64, 'wf_xtra_random', 5, 0, 0, 1, 0, 0, 40, 9104, 0, '', '1', '0'),
	(2086, '3670', 64, 'wf_xtra_unseen', 5, 0, 0, 1, 0, 0, 41, 9105, 0, '', '1', '0'),
	(2087, '3671', 63, 'wf_trg_periodically', 6, 0, 0, 1, 0, 0, 2, 9106, 0, '', '1', '0'),
	(2088, '3672', 211, 'wf_pyramid', 4, 0, 0, 1, 0, 0, 9, 9107, 0, '', '1', '0'),
	(2089, '3673', 63, 'wf_trg_score_achieved', 5, 0, 0, 1, 0, 0, 3, 9108, 0, '', '1', '0'),
	(2090, '3674', 64, 'wf_act_teleport_to', 6, 0, 0, 1, 0, 0, 4, 9109, 0, '', '1', '0'),
	(2091, '3675', 63, 'wf_trg_says_something', 4, 0, 0, 1, 0, 0, 4, 9110, 0, '', '1', '0'),
	(2092, '3676', 211, 'wf_colorwheel', 4, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(2093, '3677', 211, 'wf_wire4', 4, 0, 0, 1, 0, 0, 14, 9112, 0, '', '1', '0'),
	(2094, '3678', 63, 'wf_trg_walks_off_furni', 4, 0, 0, 1, 0, 0, 5, 9113, 0, '', '1', '0'),
	(2095, '3679', 63, 'wf_trg_at_given_time', 6, 0, 0, 1, 0, 0, 6, 9114, 0, '', '1', '0'),
	(2096, '3680', 63, 'wf_trg_game_ends', 5, 0, 0, 1, 0, 0, 7, 9115, 0, '', '1', '0'),
	(2097, '3681', 64, 'wf_act_show_message', 4, 0, 0, 1, 0, 0, 5, 9116, 0, '', '1', '0'),
	(2098, '3682', 65, 'wf_cnd_time_less_than', 5, 0, 0, 1, 0, 0, 2, 9117, 0, '', '1', '0'),
	(2099, '3683', 63, 'wf_trg_enter_room', 5, 0, 0, 1, 0, 0, 8, 9118, 0, '', '1', '0'),
	(2100, '3684', 346, 'ads_hh_safe', 4, 0, 0, 1, 0, 0, 38, -1, 0, '', '1', '0'),
	(2101, '3685', 64, 'wf_act_toggle_state', 4, 0, 0, 1, 0, 0, 6, 9120, 0, '', '1', '0'),
	(2102, '3686', 211, 'wf_firegate', 5, 0, 0, 1, 0, 0, 10, 9121, 0, '', '1', '0'),
	(2103, '3687', 211, 'wf_ringplate', 2, 0, 0, 1, 0, 0, 4, 9122, 0, '', '1', '0'),
	(2104, '3688', 211, 'wf_pressureplate', 2, 0, 0, 1, 0, 0, 3, 9123, 0, '', '1', '0'),
	(2105, '3689', 211, 'wf_glowball', 4, 0, 0, 1, 0, 0, 8, 9124, 0, '', '1', '0'),
	(2106, '3690', 361, 'bb_lightstrip', 4, 0, 0, 1, 0, 0, 111, -1, 0, '', '1', '0'),
	(2107, '3691', 64, 'wf_act_reset_timers', 6, 0, 0, 1, 0, 0, 7, 9126, 0, '', '1', '0'),
	(2108, '3692', 65, 'wf_cnd_furnis_hv_avtrs', 5, 0, 0, 1, 0, 0, 3, 9127, 0, '', '1', '0'),
	(2109, '3693', 211, 'wf_arrowplate', 2, 0, 0, 1, 0, 0, 5, 9128, 0, '', '1', '0'),
	(2110, '3694', 65, 'wf_cnd_trggrer_on_frn', 5, 0, 0, 1, 0, 0, 4, 9129, 0, '', '1', '0'),
	(2111, '3695', 65, 'wf_cnd_match_snapshot', 5, 0, 0, 1, 0, 0, 5, 9130, 0, '', '1', '0'),
	(2112, '3696', 211, 'wf_wire1', 4, 0, 0, 1, 0, 0, 11, 9131, 0, '', '1', '0'),
	(2113, '3697', 64, 'wf_act_give_score', 10, 0, 0, 1, 0, 0, 8, 9132, 0, '', '1', '0'),
	(2114, '3698', 211, 'wf_wire3', 4, 0, 0, 1, 0, 0, 13, 9133, 0, '', '1', '0'),
	(2115, '3699', 211, 'wf_glassdoor', 3, 0, 0, 1, 0, 0, 7, 9134, 0, '', '1', '0'),
	(2116, '3700', 64, 'wf_act_match_to_sshot', 8, 0, 0, 1, 0, 0, 9, 9135, 0, '', '1', '0'),
	(2117, '3701', 211, 'wf_floor_switch1', 3, 0, 0, 1, 0, 0, 1, 9136, 0, '', '1', '0'),
	(2118, '3702', 63, 'wf_trg_game_starts', 5, 0, 0, 1, 0, 0, 9, 9137, 0, '', '1', '0'),
	(2119, '3703', 63, 'wf_trg_walks_on_furni', 4, 0, 0, 1, 0, 0, 10, 9138, 0, '', '1', '0'),
	(2120, '3704', 700, 'exe_copier', 4, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(2121, '3705', 700, 'exe_wrkdesk', 5, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(2122, '3706', 700, 'exe_glassdvdr', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(2123, '3707', 700, 'exe_seccam', 4, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(2125, '3709', 239, 'duck_vip', 0, 10, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(2126, '3710', 239, 'duck_hc', 0, 10, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(2128, '3712', 477, 'es_bench', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(2129, '3713', 477, 'es_icestar', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(2130, '3714', 477, 'es_fnc_2', 4, 0, 0, 1, 0, 0, 11, 24152, 0, '', '1', '0'),
	(2131, '3715', 477, 'qt_xm10_monkey_lamp', 4, 0, 0, 1, 0, 0, 46, -1, 0, '', '1', '0'),
	(2132, '3716', 477, 'es_sidewalk', 4, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(2133, '3717', 477, 'es_statue', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(2134, '3718', 851, 'qt_xm10_iceclubsofa', 5, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(2135, '3719', 477, 'qt_xm10_xmduck', 4, 0, 0, 1, 0, 0, 50, -1, 0, '', '1', '0'),
	(2136, '3720', 477, 'qt_xm10_palm_tree', 4, 0, 0, 1, 0, 0, 48, -1, 0, '', '1', '0'),
	(2137, '3721', 477, 'es_fnc_crnr', 4, 0, 0, 1, 0, 0, 12, 24152, 0, '', '1', '0'),
	(2138, '3722', 477, 'qt_xm10_trex', 4, 0, 0, 1, 0, 0, 50, -1, 0, '', '1', '0'),
	(2139, '3723', 477, 'es_epictree', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(2140, '3724', 477, 'qt_xm10_elephant', 4, 0, 0, 1, 0, 0, 38, -1, 0, '', '1', '0'),
	(2141, '3725', 477, 'es_wpost', 4, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(2142, '3726', 477, 'qt_xm10_gnome', 4, 0, 0, 1, 0, 0, 39, -1, 0, '', '1', '0'),
	(2143, '3727', 772, 'qt_xm10_iceduck', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(2144, '3728', 477, 'qt_xm10_icetiger', 4, 0, 0, 1, 0, 0, 44, -1, 0, '', '1', '0'),
	(2145, '3729', 477, 'es_fnc_1', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(2146, '3730', 477, 'qt_xm10_iceplasto', 4, 0, 0, 1, 0, 0, 41, -1, 0, '', '1', '0'),
	(2147, '3731', 477, 'es_icestar_g', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(2148, '3732', 477, 'qt_xm10_icelupin', 4, 0, 0, 1, 0, 0, 40, -1, 0, '', '1', '0'),
	(2149, '3733', 737, 'prizetrophy_nrj_2011', 5, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(2150, '3734', 477, 'qt_xm10_iceteddy', 4, 0, 0, 1, 0, 0, 43, -1, 0, '', '1', '0'),
	(2151, '3735', 477, 'es_lmppst', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(2152, '3736', 415, 'es_skating_ice', 10, 0, 0, 1, 0, 0, 34, 9213, 0, '', '1', '0'),
	(2153, '3737', 851, 'qt_xm10_icepillar', 5, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(2154, '3738', 477, 'es_roaster', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(2155, '3739', 415, 'es_puck', 10, 0, 0, 1, 0, 0, 16, 9216, 0, '', '1', '0'),
	(2156, '3740', 477, 'es_santa', 4, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(2157, '3741', 415, 'es_tagging', 10, 0, 0, 1, 0, 0, 19, 18227, 0, '', '1', '0'),
	(2158, '3742', 477, 'qt_xm10_nest', 4, 0, 0, 1, 0, 0, 47, -1, 0, '', '1', '0'),
	(2159, '3743', 477, 'qt_xm10_icesilotable', 4, 0, 0, 1, 0, 0, 41, -1, 0, '', '1', '0'),
	(2160, '3744', 52, 'petfood16', 1, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(2161, '3745', 477, 'es_icestar_r', 4, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(2162, '3746', 851, 'qt_xm10_icedragon', 5, 0, 0, 1, 0, 1, 21, -1, 0, '', '1', '0'),
	(2163, '3747', 477, 'qt_xm10_stone', 4, 0, 0, 1, 0, 0, 49, -1, 0, '', '1', '0'),
	(2164, '3748', 477, 'qt_xm10_ice_fish', 4, 0, 0, 1, 0, 0, 45, -1, 0, '', '1', '0'),
	(2165, '3749', 477, 'es_icestar_y', 4, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(2166, '3750', 477, 'qt_xm10_bench', 4, 0, 0, 1, 0, 0, 37, -1, 0, '', '1', '0'),
	(2167, '3751', 683, 'xmas10_surprise', 3, 0, 0, 1, 0, 0, 29, -1, 0, '', '1', '0'),
	(2168, '3752', 477, 'xmas10_fireplace', 5, 0, 0, 1, 0, 0, 28, -1, 0, '', '1', '0'),
	(2169, '3753', 38, 'es_geysir', 3, 0, 0, 1, 0, 0, 0, 17925, 0, '', '1', '0'),
	(2170, '3754', 683, 'xmas10_present', 7, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(2171, '3755', 851, 'qt_xm10_iceelephant', 5, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(2172, '3756', 38, 'es_score_b', 5, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(2173, '3757', 38, 'es_tile', 1, 0, 0, 1, 0, 0, 0, 9304, 0, '', '1', '0'),
	(2174, '3758', 38, 'es_box', 3, 0, 0, 1, 0, 0, 1, 17990, 0, '', '1', '0'),
	(2175, '3759', 38, 'es_exit', 3, 0, 0, 1, 0, 0, 3, 9306, 0, '', '1', '0'),
	(2176, '3760', 38, 'es_gate_r', 5, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(2177, '3761', 38, 'es_gate_g', 5, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(2178, '3762', 38, 'es_gate_b', 5, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(2179, '3763', 38, 'es_gate_y', 5, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(2180, '3764', 38, 'es_counter', 3, 0, 0, 1, 0, 0, 2, 17917, 0, '', '1', '0'),
	(2181, '3765', 38, 'es_score_r', 5, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(2182, '3766', 38, 'es_score_g', 5, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(2183, '3767', 38, 'es_score_y', 5, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(2184, '3768', 469, 'year2011_waver_y', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(2185, '3769', 736, 'prizetrophy_2011_w', 10, 0, 0, 1, 0, 0, 165, -1, 0, '', '1', '0'),
	(2186, '3770', 736, 'prizetrophy_2011_r', 5, 1, 0, 1, 0, 0, 163, -1, 0, '', '1', '0'),
	(2187, '3771', 736, 'prizetrophy_2011_y', 5, 1, 0, 1, 0, 0, 164, -1, 0, '', '1', '0'),
	(2188, '3772', 469, 'fireworks_01', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(2189, '3773', 736, 'prizetrophy_2011_b', 5, 1, 0, 1, 0, 0, 160, -1, 0, '', '1', '0'),
	(2190, '3774', 469, 'fireworks_03', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(2191, '3775', 736, 'prizetrophy_2011_p', 5, 1, 0, 1, 0, 0, 162, -1, 0, '', '1', '0'),
	(2192, '3776', 469, 'fireworks_02', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(2193, '3777', 469, 'year2011_waver_r', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(2194, '3778', 736, 'prizetrophy_2011_g', 5, 1, 0, 1, 0, 0, 161, -1, 0, '', '1', '0'),
	(2195, '3779', 469, 'fireworks_05', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(2196, '3780', 469, 'year2011_waver_g', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(2197, '3781', 469, 'year2011_waver_b', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(2198, '3782', 469, 'fireworks_07', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(2199, '3783', 469, 'fireworks_06', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(2200, '3784', 469, 'fireworks_04', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(2201, '3785', 50, 'bling11_statue2', 4, 0, 0, 1, 0, 0, 15, 9410, 0, '', '1', '0'),
	(2202, '3786', 50, 'bling11_slot', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(2203, '3787', 50, 'bling11_towels', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(2204, '3788', 50, 'bling11_rug1', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(2205, '3789', 50, 'bling11_tele', 4, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(2206, '3790', 50, 'bling11_sofa', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(2207, '3791', 50, 'bling11_statue1', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(2208, '3792', 460, 'val11_floor', 2, 0, 0, 1, 0, 0, 10, 9417, 0, '', '1', '0'),
	(2209, '3793', 50, 'bling11_dvd', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(2210, '3794', 50, 'bling11_floor', 2, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(2211, '3795', 50, 'bling11_plant', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(2212, '3796', 302, 'china_rabbit', 4, 0, 0, 1, 0, 0, 28, -1, 0, '', '1', '0'),
	(2213, '3797', 50, 'bling11_rug2', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(2214, '3798', 50, 'bling11_dvn', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(2215, '3799', 50, 'bling11_seat2', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(2216, '3800', 50, 'bling11_seat1', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(2217, '3801', 50, 'bling11_block', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(2218, '3802', 50, 'bling11_pillar', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(2219, '3803', 850, 'qt_val11_holoduck', 5, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(2220, '3804', 630, 'val11_playa', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(2221, '3805', 459, 'qt_val11_discoball', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(2222, '3806', 630, 'val11_chair', 2, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(2223, '3807', 459, 'qt_val11_nest', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(2224, '3808', 115, 'nest_terrarium', 2, 0, 0, 1, 0, 0, 32, 9437, 0, '', '1', '0'),
	(2225, '3809', 459, 'qt_val11_duckformer', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(2226, '3810', 459, 'qt_val11_jellychair', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(2227, '3811', 459, 'qt_val11_jellyheart', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(2228, '3812', 630, 'val11_rail', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(2229, '3813', 850, 'qt_val11_holoheart', 5, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(2230, '3814', 346, 'ads_leaf_teleport', 4, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(2231, '3815', 543, 'ads_sunnyvend', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(2232, '3816', 52, 'petfood18', 1, 0, 0, 1, 0, 0, 19, 9477, 0, '', '1', '0'),
	(2233, '3817', 52, 'petfood17', 1, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(2234, '3819', 280, 'limo_w_mid', 4, 0, 0, 1, 0, 0, 68, 9478, 0, '', '1', '0'),
	(2235, '3820', 280, 'limo_w_mid2', 4, 0, 0, 1, 0, 0, 69, 9479, 0, '', '1', '0'),
	(2236, '3821', 52, 'petfood19', 1, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(2237, '3822', 280, 'limo_w_back', 4, 0, 0, 1, 0, 0, 66, 9481, 0, '', '1', '0'),
	(2238, '3823', 280, 'limo_w_front', 4, 0, 0, 1, 0, 0, 67, 9482, 0, '', '1', '0'),
	(2239, '3824', 30, 'gothic_bed', 4, 0, 0, 1, 0, 0, 32, -1, 0, '', '1', '0'),
	(2240, '3825', 30, 'gothic_candles', 4, 0, 0, 1, 0, 0, 38, -1, 0, '', '1', '0'),
	(2241, '3826', 30, 'gothic_desk', 5, 0, 0, 1, 0, 0, 39, -1, 0, '', '1', '0'),
	(2242, '3827', 534, 'ads_grefu_trophy', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(2243, '3828', 30, 'gothic_bowl', 10, 0, 0, 1, 0, 0, 33, -1, 0, '', '1', '0'),
	(2244, '3830', 115, 'nest_frog', 2, 0, 0, 1, 0, 0, 31, 9513, 0, '', '1', '0'),
	(2245, '3831', 115, 'pond', 2, 0, 0, 1, 0, 0, 17, 9514, 0, '', '1', '0'),
	(2246, '3832', 683, 'val11_present', 7, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(2247, '3833', 225, 'prizetrophy_cine', 6, 0, 0, 1, 0, 0, 71, 9521, 0, '', '1', '0'),
	(2248, '3834', 280, 'cine_vipsign', 4, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(2249, '3835', 50, 'limo_b_mid3', 10, 0, 0, 1, 0, 0, 41, -1, 0, '', '1', '0'),
	(2250, '3836', 50, 'limo_b_mid2', 4, 0, 0, 1, 0, 0, 40, -1, 0, '', '1', '0'),
	(2251, '3837', 50, 'limo_b_front', 4, 0, 0, 1, 0, 0, 38, -1, 0, '', '1', '0'),
	(2252, '3838', 50, 'limo_b_mid', 4, 0, 0, 1, 0, 0, 39, -1, 0, '', '1', '0'),
	(2253, '3839', 225, 'cine_star', 4, 0, 0, 1, 0, 0, 70, 9527, 0, '', '1', '0'),
	(2254, '3840', 50, 'limo_b_back', 4, 0, 0, 1, 0, 0, 37, -1, 0, '', '1', '0'),
	(2255, '3841', 280, 'cine_curtain', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(2256, '3842', 280, 'cine_screen', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(2257, '3843', 280, 'theatre_seat_g', 4, 0, 0, 1, 0, 0, -3, -1, 0, '', '1', '0'),
	(2258, '3844', 280, 'cine_tile', 1, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(2259, '3845', 280, 'cine_bench_b', 4, 0, 0, 1, 0, 0, -1, -1, 0, '', '1', '0'),
	(2260, '3846', 280, 'theatre_seat_b', 4, 0, 0, 1, 0, 0, -4, -1, 0, '', '1', '0'),
	(2261, '3847', 280, 'cine_roof', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(2262, '3848', 280, 'cine_popcorn', 10, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(2263, '3849', 280, 'cine_bench', 4, 0, 0, 1, 0, 0, -2, -1, 0, '', '1', '0'),
	(2264, '3850', 280, 'cine_bench_g', 4, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(2265, '3851', 280, 'cine_ticket_booth', 4, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(2266, '3852', 280, 'cine_projector', 4, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(2267, '3853', 211, 'wf_box', 2, 0, 0, 1, 0, 0, 18, 9549, 0, '', '1', '0'),
	(2268, '3854', 211, 'wf_maze', 4, 0, 0, 1, 0, 0, 17, 9555, 0, '', '1', '0'),
	(2269, '3855', 549, 'ads_rangocactus', 4, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(2270, '3856', 280, 'cine_glass', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(2271, '3857', 65, 'wf_cnd_has_furni_on', 5, 0, 0, 1, 0, 0, 6, 9558, 0, '', '1', '0'),
	(2272, '3858', 56, 'cubie_lamp_b', 4, 0, 0, 1, 0, 0, 19, 17949, 0, '', '1', '0'),
	(2273, '3859', 56, 'cubie_chair_b', 2, 0, 0, 1, 0, 0, 7, 17984, 0, '', '1', '0'),
	(2274, '3860', 56, 'cubie_rug_b', 4, 0, 0, 1, 0, 0, 21, 17993, 0, '', '1', '0'),
	(2275, '3861', 56, 'cubie_bigtable_b', 5, 0, 0, 1, 0, 0, 5, 18054, 0, '', '1', '0'),
	(2276, '3862', 56, 'cubie_beanbag_p', 4, 0, 0, 1, 0, 0, 2, 18003, 0, '', '1', '0'),
	(2277, '3863', 56, 'cubie_lamp_p', 4, 0, 0, 1, 0, 0, 20, 17952, 0, '', '1', '0'),
	(2278, '3864', 56, 'cubie_sofaseat_p', 4, 0, 0, 1, 0, 0, 34, 18053, 0, '', '1', '0'),
	(2279, '3865', 56, 'cubie_shelf_0_b', 5, 0, 0, 1, 0, 0, 23, 9579, 0, '', '1', '0'),
	(2280, '3866', 56, 'cubie_shelf_4_p', 5, 0, 0, 1, 0, 0, 32, 17973, 0, '', '1', '0'),
	(2281, '3867', 56, 'cubie_shelf_2_p', 5, 0, 0, 1, 0, 0, 28, 18051, 0, '', '1', '0'),
	(2282, '3868', 56, 'cubie_bed_p', 3, 0, 0, 1, 0, 0, 4, 18030, 0, '', '1', '0'),
	(2283, '3869', 56, 'cubie_stool_b', 4, 0, 0, 1, 0, 0, 35, 9583, 0, '', '1', '0'),
	(2284, '3870', 56, 'cubie_rug_p', 4, 0, 0, 1, 0, 0, 22, 17876, 0, '', '1', '0'),
	(2285, '3871', 56, 'cubie_bed_b', 3, 0, 0, 1, 0, 0, 3, 18029, 0, '', '1', '0'),
	(2286, '3872', 56, 'cubie_shelf_3_b', 5, 0, 0, 1, 0, 0, 29, 17957, 0, '', '1', '0'),
	(2287, '3873', 56, 'cubie_shelf_3_p', 5, 0, 0, 1, 0, 0, 30, 17956, 0, '', '1', '0'),
	(2288, '3874', 56, 'cubie_shelf_1_p', 5, 0, 0, 1, 0, 0, 26, 9588, 0, '', '1', '0'),
	(2289, '3875', 56, 'cubie_shelf_1_b', 5, 0, 0, 1, 0, 0, 25, 9589, 0, '', '1', '0'),
	(2290, '3876', 56, 'cubie_bigtable_p', 5, 0, 0, 1, 0, 0, 6, 18055, 0, '', '1', '0'),
	(2291, '3877', 56, 'cubie_beanbag_b', 4, 0, 0, 1, 0, 0, 1, 18002, 0, '', '1', '0'),
	(2292, '3878', 56, 'cubie_stool_p', 4, 0, 0, 1, 0, 0, 36, 9592, 0, '', '1', '0'),
	(2293, '3879', 56, 'cubie_chair_p', 2, 0, 0, 1, 0, 0, 8, 17986, 0, '', '1', '0'),
	(2294, '3880', 56, 'cubie_table', 4, 0, 0, 1, 0, 0, 37, 17968, 0, '', '1', '0'),
	(2295, '3881', 56, 'cubie_sofaseat_b', 4, 0, 0, 1, 0, 0, 33, 18056, 0, '', '1', '0'),
	(2296, '3882', 56, 'cubie_shelf_4_b', 5, 0, 0, 1, 0, 0, 31, 17975, 0, '', '1', '0'),
	(2297, '3883', 56, 'cubie_shelf_2_b', 5, 0, 0, 1, 0, 0, 27, 18052, 0, '', '1', '0'),
	(2298, '3884', 56, 'cubie_shelf_0_p', 5, 0, 0, 1, 0, 0, 24, 9598, 0, '', '1', '0'),
	(2299, '3885', 683, 'newbie_present', 3, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(2300, '3886', 57, 'tv_flat', 4, 0, 0, 1, 0, 0, 13, 17992, 0, '', '1', '0'),
	(2301, '3887', 57, 'waasa_table2', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(2302, '3888', 57, 'computer_flatscreen', 4, 0, 0, 1, 0, 0, 14, 9620, 0, '', '1', '0'),
	(2303, '3889', 57, 'waasa_chair', 2, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(2304, '3890', 57, 'waasa_ship2', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(2305, '3891', 57, 'waasa_ship1', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(2306, '3892', 57, 'waasa_bunk_bed', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(2307, '3893', 57, 'computer_laptop', 4, 0, 0, 1, 0, 0, 1, 9625, 0, '', '1', '0'),
	(2308, '3894', 57, 'computer_old', 4, 0, 0, 1, 0, 0, 2, 9626, 0, '', '1', '0'),
	(2309, '3895', 57, 'waasa_table1', 2, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(2310, '3896', 57, 'waasa_desk', 5, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(2311, '3897', 632, 'newbie_nest', 4, 0, 0, 1, 0, 0, 41, -1, 0, '', '1', '0'),
	(2312, '3898', 57, 'waasa_rug5', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(2313, '3899', 57, 'waasa_rug1', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(2314, '3900', 57, 'waasa_rug3', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(2315, '3901', 57, 'waasa_aquarium', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(2316, '3902', 57, 'waasa_rug4', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(2317, '3903', 57, 'waasa_chair_wood', 2, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(2318, '3904', 57, 'waasa_rug2', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(2319, '3905', 253, 'jukebox_big', 10, 0, 0, 1, 0, 0, 99, 17910, 0, '', '1', '0'),
	(2320, '3906', 115, 'milkbowl', 1, 0, 0, 1, 0, 0, 1, 12283, 0, '', '1', '0'),
	(2321, '3907', 115, 'petfood21', 1, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(2322, '3908', 386, 'easter11_basket', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(2323, '3909', 386, 'easter11_grasspatch', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(2324, '3910', 562, 'ads_wowpball', 4, 0, 0, 1, 0, 0, 42, -1, 0, '', '1', '0'),
	(2325, '3911', 52, 'pet_food_corn', 1, 0, 0, 1, 0, 0, 31, -1, 0, '', '1', '0'),
	(2326, '3912', 115, 'pet_toy_trampoline', 2, 0, 0, 1, 0, 0, 43, 9707, 0, '', '1', '0'),
	(2327, '3913', 115, 'nest_chick', 2, 0, 0, 1, 0, 0, 44, 9708, 0, '', '1', '0'),
	(2328, '3914', 386, 'easter11_tag', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(2329, '3915', 379, 'easter11_tuip_g', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(2330, '3916', 379, 'easter11_tuip_y', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(2331, '3917', 379, 'easter11_mushroom4', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(2332, '3918', 379, 'easter11_mushroom1', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(2333, '3919', 555, 'kuurna_sofa', 0, 10, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(2334, '3920', 379, 'easter11_mushroom3', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(2335, '3921', 379, 'easter11_mushroom2', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(2336, '3922', 555, 'kuurna_lamp', 0, 10, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(2337, '3923', 555, 'kuurna_chair', 0, 10, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(2338, '3924', 555, 'kuurna_mat', 0, 10, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(2339, '3925', 555, 'kuurna_table1', 0, 10, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(2340, '3926', 555, 'kuurna_table', 0, 10, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(2341, '3927', 382, 'ads_suun', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(2342, '3928', 555, 'kuurna_chair1', 0, 10, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(2343, '3929', 379, 'easter11_tuip_p', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(2344, '3930', 69, 'anna_divider*1', 3, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(2345, '3931', 69, 'anna_divider*2', 3, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(2346, '3932', 69, 'anna_divider*3', 3, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(2347, '3933', 69, 'anna_divider*4', 3, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(2348, '3934', 69, 'anna_divider*5', 3, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(2349, '3935', 69, 'anna_div_gate*1', 4, 0, 0, 1, 0, 0, 16, 10051, 0, '', '1', '0'),
	(2350, '3936', 69, 'anna_div_gate*2', 4, 0, 0, 1, 0, 0, 17, 10052, 0, '', '1', '0'),
	(2351, '3937', 69, 'anna_div_gate*3', 4, 0, 0, 1, 0, 0, 18, 10053, 0, '', '1', '0'),
	(2352, '3938', 69, 'anna_div_gate*4', 4, 0, 0, 1, 0, 0, 19, 10054, 0, '', '1', '0'),
	(2353, '3939', 69, 'anna_div_gate*5', 4, 0, 0, 1, 0, 0, 20, 10055, 0, '', '1', '0'),
	(2354, '3940', 69, 'anna_chair*1', 2, 0, 0, 1, 0, 0, 1, 17947, 0, '', '1', '0'),
	(2355, '3941', 69, 'anna_chair*2', 2, 0, 0, 1, 0, 0, 2, 17985, 0, '', '1', '0'),
	(2356, '3942', 69, 'anna_chair*3', 2, 0, 0, 1, 0, 0, 3, 18060, 0, '', '1', '0'),
	(2357, '3943', 69, 'anna_chair*4', 2, 0, 0, 1, 0, 0, 4, 18059, 0, '', '1', '0'),
	(2358, '3944', 69, 'anna_chair*5', 2, 0, 0, 1, 0, 0, 5, 18009, 0, '', '1', '0'),
	(2359, '3945', 69, 'anna_stool*1', 4, 0, 0, 1, 0, 0, 41, 10061, 0, '', '1', '0'),
	(2360, '3946', 69, 'anna_stool*2', 4, 0, 0, 1, 0, 0, 42, 10062, 0, '', '1', '0'),
	(2361, '3947', 69, 'anna_stool*3', 4, 0, 0, 1, 0, 0, 43, 10063, 0, '', '1', '0'),
	(2362, '3948', 69, 'anna_stool*4', 4, 0, 0, 1, 0, 0, 44, 10064, 0, '', '1', '0'),
	(2363, '3949', 69, 'anna_stool*5', 4, 0, 0, 1, 0, 0, 45, 10065, 0, '', '1', '0'),
	(2364, '3950', 69, 'anna_table*1', 5, 0, 0, 1, 0, 0, 46, 10066, 0, '', '1', '0'),
	(2365, '3951', 69, 'anna_table*2', 5, 0, 0, 1, 0, 0, 47, 10067, 0, '', '1', '0'),
	(2366, '3952', 69, 'anna_table*3', 5, 0, 0, 1, 0, 0, 48, 10068, 0, '', '1', '0'),
	(2367, '3953', 69, 'anna_table*4', 5, 0, 0, 1, 0, 0, 49, 10069, 0, '', '1', '0'),
	(2368, '3954', 69, 'anna_table*5', 5, 0, 0, 1, 0, 0, 50, 10070, 0, '', '1', '0'),
	(2369, '3955', 69, 'anna_rug*1', 4, 0, 0, 1, 0, 0, 31, 10071, 0, '', '1', '0'),
	(2370, '3956', 69, 'anna_rug*2', 4, 0, 0, 1, 0, 0, 32, 10072, 0, '', '1', '0'),
	(2371, '3957', 69, 'anna_rug*3', 4, 0, 0, 1, 0, 0, 33, 10073, 0, '', '1', '0'),
	(2372, '3958', 69, 'anna_rug*4', 4, 0, 0, 1, 0, 0, 34, 17827, 0, '', '1', '0'),
	(2373, '3959', 69, 'anna_rug*5', 4, 0, 0, 1, 0, 0, 35, 10075, 0, '', '1', '0'),
	(2374, '3960', 69, 'anna_sofa*1', 3, 0, 0, 1, 0, 0, 36, 10076, 0, '', '1', '0'),
	(2375, '3961', 69, 'anna_sofa*2', 3, 0, 0, 1, 0, 0, 37, 10077, 0, '', '1', '0'),
	(2376, '3962', 69, 'anna_sofa*3', 3, 0, 0, 1, 0, 0, 38, 10078, 0, '', '1', '0'),
	(2377, '3963', 69, 'anna_sofa*4', 3, 0, 0, 1, 0, 0, 39, 10079, 0, '', '1', '0'),
	(2378, '3964', 69, 'anna_sofa*5', 3, 0, 0, 1, 0, 0, 40, 10080, 0, '', '1', '0'),
	(2379, '3965', 69, 'anna_pill*1', 4, 0, 0, 1, 0, 0, 26, 10081, 0, '', '1', '0'),
	(2380, '3966', 69, 'anna_pill*2', 4, 0, 0, 1, 0, 0, 27, 10082, 0, '', '1', '0'),
	(2381, '3967', 69, 'anna_pill*3', 4, 0, 0, 1, 0, 0, 28, 10083, 0, '', '1', '0'),
	(2382, '3968', 69, 'anna_pill*4', 4, 0, 0, 1, 0, 0, 29, 10084, 0, '', '1', '0'),
	(2383, '3969', 69, 'anna_pill*5', 4, 0, 0, 1, 0, 0, 30, 10085, 0, '', '1', '0'),
	(2384, '3970', 69, 'anna_lamp*1', 4, 0, 0, 1, 0, 0, 21, 18044, 0, '', '1', '0'),
	(2385, '3971', 69, 'anna_lamp*2', 4, 0, 0, 1, 0, 0, 22, 17994, 0, '', '1', '0'),
	(2386, '3972', 69, 'anna_lamp*3', 4, 0, 0, 1, 0, 0, 23, 18019, 0, '', '1', '0'),
	(2387, '3973', 69, 'anna_lamp*4', 4, 0, 0, 1, 0, 0, 24, 18025, 0, '', '1', '0'),
	(2388, '3974', 69, 'anna_lamp*5', 4, 0, 0, 1, 0, 0, 25, 18031, 0, '', '1', '0'),
	(2389, '3975', 69, 'anna_div_crnr*1', 4, 0, 0, 1, 0, 0, 11, 10091, 0, '', '1', '0'),
	(2390, '3976', 69, 'anna_div_crnr*2', 4, 0, 0, 1, 0, 0, 12, 10092, 0, '', '1', '0'),
	(2391, '3977', 69, 'anna_div_crnr*3', 4, 0, 0, 1, 0, 0, 13, 10093, 0, '', '1', '0'),
	(2392, '3978', 69, 'anna_div_crnr*4', 4, 0, 0, 1, 0, 0, 14, 10094, 0, '', '1', '0'),
	(2393, '3979', 69, 'anna_div_crnr*5', 4, 0, 0, 1, 0, 0, 15, 10095, 0, '', '1', '0'),
	(2394, '3980', 282, 'picnic_blanket_yel', 4, 0, 0, 1, 0, 0, 35, 18007, 0, '', '1', '0'),
	(2395, '3981', 282, 'picnic_pillow_yel', 4, 0, 0, 1, 0, 0, 42, 10098, 0, '', '1', '0'),
	(2396, '3982', 282, 'picnic_food1', 4, 0, 0, 1, 0, 0, 37, 10099, 0, '', '1', '0'),
	(2397, '3983', 22, 'note_tag', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(2398, '3984', 282, 'picnic_wfall', 4, 0, 0, 1, 0, 0, 44, 10101, 0, '', '1', '0'),
	(2399, '3985', 282, 'picnic_blanket_blu', 4, 0, 0, 1, 0, 0, 34, 17976, 0, '', '1', '0'),
	(2400, '3986', 282, 'picnic_food3', 4, 0, 0, 1, 0, 0, 39, 10103, 0, '', '1', '0'),
	(2401, '3987', 282, 'picnic_blanket', 4, 0, 0, 1, 0, 0, 33, 18050, 0, '', '1', '0'),
	(2402, '3988', 282, 'picnic_pillow_blu', 4, 0, 0, 1, 0, 0, 41, 10105, 0, '', '1', '0'),
	(2403, '3989', 282, 'picnic_food2', 4, 0, 0, 1, 0, 0, 38, 10106, 0, '', '1', '0'),
	(2404, '3990', 282, 'picnic_tele', 4, 0, 0, 1, 0, 0, 43, 10107, 0, '', '1', '0'),
	(2405, '3991', 282, 'picnic_basket', 4, 0, 0, 1, 0, 0, 32, 10108, 0, '', '1', '0'),
	(2406, '3992', 282, 'picnic_pillow', 4, 0, 0, 1, 0, 0, 40, 10109, 0, '', '1', '0'),
	(2407, '3993', 282, 'picnic_chair', 2, 0, 0, 1, 0, 0, 36, 10110, 0, '', '1', '0'),
	(2408, '3994', 282, 'picnic_3brds', 4, 0, 0, 1, 0, 0, 31, 10111, 0, '', '1', '0'),
	(2409, '3995', 52, 'petfood23', 1, 0, 0, 1, 0, 0, 24, 10117, 0, '', '1', '0'),
	(2410, '3996', 40, 'ads_background', 7, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(2411, '3997', 451, 'ads_kelloggs_statue', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(2412, '3998', 737, 'race_trophy', 5, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(2413, '3999', 185, 'ads_kfp2statue', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(2414, '4000', 52, 'petfood22', 1, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(2415, '4001', 115, 'poster', 2, 0, 0, 1, 0, 0, 29, 17812, 0, '', '1', '0'),
	(2416, '4002', 115, 'gothicfountain', 2, 0, 0, 1, 0, 0, 45, -1, 0, '', '1', '0'),
	(2417, '4003', 115, 'hc_wall_lamp', 2, 0, 0, 1, 0, 0, 46, -1, 0, '', '1', '0'),
	(2418, '4004', 115, 'industrialfan', 2, 0, 0, 1, 0, 0, 47, -1, 0, '', '1', '0'),
	(2419, '4005', 104, 'torch', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(2420, '4006', 104, 'val_heart', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(2421, '4007', 104, 'wallmirror', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(2422, '4008', 104, 'jp_ninjastars', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(2423, '4009', 104, 'habw_mirror', 2, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(2424, '4010', 104, 'habbowheel', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(2425, '4011', 104, 'guitar_skull', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(2426, '4012', 850, 'guitar_v', 5, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(2427, '4013', 104, 'hrella_poster_2', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(2428, '4014', 52, 'hrella_poster_1', 1, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(2429, '4015', 463, 'xmas_light', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(2430, '4016', 463, 'hrella_poster_3', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(2431, '4017', 407, 'sw_swords', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(2432, '4018', 407, 'sw_stone', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(2433, '4019', 407, 'sw_hole', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(2434, '4020', 407, 'arabian_swords', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(2435, '4021', 407, 'jp_sheet3', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(2436, '4022', 407, 'arabian_wndw', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(2437, '4023', 407, 'md_logo_wall', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(2438, '4024', 407, 'jp_sheet1', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(2439, '4025', 850, 'md_can', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(2440, '4026', 463, 'jp_sheet2', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(2441, '4027', 225, 'roomdimmer', 4, 0, 0, 1, 0, 0, 19, 2276, 0, '', '1', '0'),
	(2442, '4028', 225, 'tiki_surfboard', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(2443, '4029', 225, 'tampax_wall', 4, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(2444, '4030', 272, 'tiki_wallplnt', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(2445, '4031', 272, 'window_single_default', 4, 0, 0, 1, 0, 0, 8, 2452, 0, '', '1', '0'),
	(2446, '4032', 272, 'window_double_default', 4, 0, 0, 1, 0, 0, 5, 2451, 0, '', '1', '0'),
	(2447, '4033', 272, 'noob_window_double', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(2448, '4034', 272, 'window_chinese_wide', 4, 0, 0, 1, 0, 0, 12, 2453, 0, '', '1', '0'),
	(2449, '4035', 115, 'window_golden', 2, 0, 0, 1, 0, 0, 28, 2454, 0, '', '1', '0'),
	(2450, '4036', 40, 'window_square', 7, 0, 0, 1, 0, 0, 3, 2455, 0, '', '1', '0'),
	(2451, '4037', 52, 'window_romantic_narrow', 1, 0, 0, 1, 0, 0, 25, 17895, 0, '', '1', '0'),
	(2452, '4039', 404, 'window_70s_wide', 4, 0, 0, 1, 0, 0, 18, 2458, 0, '', '1', '0'),
	(2453, '4040', 404, 'window_70s_narrow', 4, 0, 0, 1, 0, 0, 8, 17853, 0, '', '1', '0'),
	(2454, '4041', 404, 'window_romantic_wide', 4, 0, 0, 1, 0, 0, 25, 2461, 0, '', '1', '0'),
	(2455, '4042', 404, 'window_basic', 2, 0, 0, 1, 0, 0, 1, 2462, 0, '', '1', '0'),
	(2456, '4043', 404, 'ads_sunnyd', 4, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(2457, '4044', 404, 'window_grunge', 4, 0, 0, 1, 0, 0, 20, 18404, 0, '', '1', '0'),
	(2458, '4045', 404, 'window_triple', 4, 0, 0, 1, 0, 0, 28, 2465, 0, '', '1', '0'),
	(2459, '4046', 404, 'window_diner2', 4, 0, 0, 1, 0, 0, 6, 2566, 0, '', '1', '0'),
	(2460, '4047', 404, 'ads_dave_wall', 2, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(2461, '4048', 404, 'diner_walltable', 4, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(2462, '4049', 404, 'window_diner', 2, 0, 0, 1, 0, 0, 16, 2569, 0, '', '1', '0'),
	(2463, '4050', 404, 'ads_nokia_logo', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(2464, '4051', 404, 'easy_poster', 5, 0, 0, 1, 0, 0, 30, -1, 0, '', '1', '0'),
	(2465, '4052', 404, 'window_hole', 4, 0, 0, 1, 0, 0, 17, 20854, 0, '', '1', '0'),
	(2466, '4053', 404, 'ads_nokia_phone', 2, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(2467, '4054', 404, 'window_skyscraper', 4, 0, 0, 1, 0, 0, 27, 17821, 0, '', '1', '0'),
	(2468, '4055', 404, 'landscape', 4, 0, 0, 1, 0, 0, 23, 12282, 0, '', '1', '0'),
	(2469, '4056', 404, 'det_bhole', 5, 0, 0, 1, 0, 0, 31, -1, 0, '', '1', '0'),
	(2470, '4057', 404, 'netari_poster', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(2471, '4058', 404, 'ads_campguitar', 2, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(2472, '4059', 404, 'hween08_rad', 2, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(2473, '4060', 404, 'hw_08_xray', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(2474, '4061', 404, 'hween08_wndwb', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(2475, '4062', 404, 'hween08_wndw', 2, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(2476, '4063', 404, 'hween08_bio', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(2477, '4064', 404, 'hw08_xray', 2, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(2478, '4065', 404, 'gothicfountain2', 4, 0, 0, 1, 0, 0, 26, -1, 0, '', '1', '0'),
	(2479, '4066', 404, 'party_led', 4, 0, 0, 1, 0, 0, 9, 2988, 0, '', '1', '0'),
	(2480, '4067', 235, 'ads_cmusic', 3, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(2481, '4068', 235, 'party_wc_girl', 15, 0, 0, 1, 0, 0, 4, 2990, 0, '', '1', '0'),
	(2482, '4069', 40, 'party_neon1', 7, 0, 0, 1, 0, 0, 2, 2991, 0, '', '1', '0'),
	(2483, '4070', 52, 'party_wc_boy', 1, 0, 0, 1, 0, 0, 16, 2992, 0, '', '1', '0'),
	(2484, '4071', 215, 'party_shelf', 8, 50, 0, 1, 0, 0, 8, 2993, 0, '', '1', '0'),
	(2485, '4073', 235, 'party_neon2', 3, 0, 0, 1, 0, 0, 7, 2995, 0, '', '1', '0'),
	(2486, '4074', 554, 'party_neon5', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(2487, '4075', 554, 'party_neon3', 4, 0, 0, 1, 0, 0, 99, 2997, 0, '', '1', '0'),
	(2488, '4076', 235, 'xmas08_icewall', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(2489, '4077', 115, 'xmas08_wallpaper', 2, 0, 0, 1, 0, 0, 48, -1, 0, '', '1', '0'),
	(2490, '4078', 115, 'ads_clwall2', 2, 0, 0, 1, 0, 0, 49, -1, 0, '', '1', '0'),
	(2491, '4079', 530, 'ads_clwall3', 4, 0, 0, 1, 0, 0, 104, -1, 0, '', '1', '0'),
	(2492, '4080', 55, 'xmas_icewall', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(2493, '4081', 55, 'ads_ob_wall', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(2494, '4082', 55, 'ads_clwall1', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(2495, '4083', 55, 'ads_mall_window', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(2496, '4084', 55, 'china_pstr1', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(2497, '4085', 55, 'china_pstr2', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(2498, '4086', 55, 'china_light', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(2499, '4087', 55, 'bolly_wdw_wd', 2, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(2500, '4088', 55, 'ads_idol_wall', 5, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(2501, '4089', 55, 'ads_igorevilb', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(2502, '4090', 55, 'ads_igor_wall', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(2503, '4091', 55, 'ads_mall_winpet', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(2504, '4092', 55, 'ads_mall_winfur', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(2505, '4093', 55, 'ads_idol_tv', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(2506, '4094', 55, 'lc_window1', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(2507, '4095', 55, 'lc_wall1', 2, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(2508, '4096', 46, 'lc_window2', 4, 0, 0, 1, 0, 0, 50, 24152, 0, '', '1', '0'),
	(2509, '4097', 46, 'lc_wall2', 4, 0, 0, 1, 0, 0, 51, -1, 0, '', '1', '0'),
	(2510, '4098', 46, 'ads_mall_wincin', 4, 0, 0, 1, 0, 0, 52, -1, 0, '', '1', '0'),
	(2511, '4099', 46, 'ads_idol_mirror', 4, 0, 0, 1, 0, 0, 53, -1, 0, '', '1', '0'),
	(2512, '4100', 407, 'ads_mall_winbea', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(2513, '4101', 407, 'ads_mall_winmus', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(2514, '4102', 235, 'eco_curtains2', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(2515, '4103', 235, 'ads_mall_winchi', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(2516, '4104', 235, 'eco_curtains3', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(2517, '4105', 683, 'eco_curtains1', 4, 0, 0, 1, 0, 0, 54, -1, 0, '', '1', '0'),
	(2518, '4106', 235, 'ads_mall_winspo', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(2519, '4107', 850, 'exe_wfall', 5, 0, 0, 1, 0, 1, 17, -1, 0, '', '1', '0'),
	(2520, '4108', 60, 'ads_idol_logo', 4, 0, 0, 1, 0, 0, 103, -1, 0, '', '1', '0'),
	(2521, '4109', 60, 'ads_mall_winice', 4, 0, 0, 1, 0, 0, 124, -1, 0, '', '1', '0'),
	(2522, '4110', 60, 'exe_map', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(2523, '4111', 60, 'ads_puffet_tv', 5, 0, 0, 1, 0, 0, 104, -1, 0, '', '1', '0'),
	(2524, '4112', 60, 'ads_reebok_tv', 4, 0, 0, 1, 0, 0, 133, -1, 0, '', '1', '0'),
	(2525, '4113', 60, 'ads_malaco_tv', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(2526, '4114', 60, 'country_forestwall', 5, 0, 0, 1, 0, 0, 135, 3952, 0, '', '1', '0'),
	(2527, '4115', 60, 'ads_lin_wh_c', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(2528, '4116', 60, 'country_lantern', 4, 0, 0, 1, 0, 0, 137, 3994, 0, '', '1', '0'),
	(2529, '4117', 60, 'country_fp', 4, 0, 0, 1, 0, 0, 125, 3995, 0, '', '1', '0'),
	(2530, '4118', 60, 'country_wall', 4, 0, 0, 1, 0, 0, 131, 3996, 0, '', '1', '0'),
	(2531, '4119', 60, 'flag_norway', 4, 0, 0, 1, 0, 0, 6, 4042, 0, '', '1', '0'),
	(2532, '4120', 60, 'diner_poster', 4, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(2533, '4121', 60, 'lt_jngl_wall', 4, 0, 0, 1, 0, 0, 132, -1, 0, '', '1', '0'),
	(2534, '4122', 60, 'ads_mirror', 5, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(2535, '4123', 60, 'lt_wall', 4, 0, 0, 1, 0, 0, 130, -1, 0, '', '1', '0'),
	(2536, '4124', 60, 'usva5_lamble', 4, 0, 0, 1, 0, 0, 121, 10331, 0, '', '1', '0'),
	(2537, '4125', 60, 'usva2_lamp', 4, 0, 0, 1, 0, 0, 2, 18140, 0, '', '1', '0'),
	(2538, '4126', 60, 'usva4_chair', 4, 0, 0, 1, 0, 0, 10, 10333, 0, '', '1', '0'),
	(2539, '4127', 60, 'usva3_shelf2', 5, 0, 0, 1, 0, 0, 105, 18143, 0, '', '1', '0'),
	(2540, '4128', 60, 'usva3_table', 4, 0, 0, 1, 0, 0, 107, 18176, 0, '', '1', '0'),
	(2541, '4129', 60, 'usva2_rug', 4, 0, 0, 1, 0, 0, 3, 10336, 0, '', '1', '0'),
	(2542, '4130', 60, 'usva4_table', 4, 0, 0, 1, 0, 0, 15, 18163, 0, '', '1', '0'),
	(2543, '4131', 60, 'usva5_lamp', 4, 0, 0, 1, 0, 0, 122, 18200, 0, '', '1', '0'),
	(2544, '4132', 60, 'usva3_chair', 4, 0, 0, 1, 0, 0, 100, 10339, 0, '', '1', '0'),
	(2545, '4133', 60, 'usva3_lamble', 4, 0, 0, 1, 0, 0, 101, 10340, 0, '', '1', '0'),
	(2546, '4134', 60, 'usva_sofa', 4, 0, 0, 1, 0, 0, 136, 10341, 0, '', '1', '0'),
	(2547, '4135', 60, 'usva_shelf', 5, 0, 0, 1, 0, 0, 134, 10342, 0, '', '1', '0'),
	(2548, '4136', 60, 'usva4_lamp', 4, 0, 0, 1, 0, 0, 12, 18178, 0, '', '1', '0'),
	(2549, '4137', 60, 'usva2_lamble', 4, 0, 0, 1, 0, 0, 1, 10346, 0, '', '1', '0'),
	(2550, '4138', 60, 'usva3_lamp', 4, 0, 0, 1, 0, 0, 102, 18154, 0, '', '1', '0'),
	(2551, '4139', 60, 'usva4_rug', 4, 0, 0, 1, 0, 0, 13, 10348, 0, '', '1', '0'),
	(2552, '4140', 60, 'usva2_shelf', 5, 0, 0, 1, 0, 0, 4, 10349, 0, '', '1', '0'),
	(2553, '4141', 60, 'usva3_sofa', 4, 0, 0, 1, 0, 0, 106, 10352, 0, '', '1', '0'),
	(2554, '4142', 60, 'usva5_rug', 4, 0, 0, 1, 0, 0, 123, 10353, 0, '', '1', '0'),
	(2555, '4143', 60, 'usva5_chair', 4, 0, 0, 1, 0, 0, 120, 10354, 0, '', '1', '0'),
	(2556, '4144', 429, 'uservoice_soapbox', 4, 0, 0, 1, 0, 0, 57, -1, 0, '', '1', '0'),
	(2557, '4145', 467, 'school_platform', 4, 0, 0, 1, 0, 0, 30, -1, 0, '', '1', '0'),
	(2558, '4146', 467, 'school_locker_b', 4, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(2559, '4147', 467, 'school_locker_r_nosale', 4, 0, 0, 1, 0, 0, 28, -1, 0, '', '1', '0'),
	(2560, '4148', 467, 'school_toilet_stall', 4, 0, 0, 1, 0, 0, 38, -1, 0, '', '1', '0'),
	(2561, '4149', 467, 'school_stuff_06', 4, 0, 0, 1, 0, 0, 36, -1, 0, '', '1', '0'),
	(2562, '4150', 467, 'school_locker_r', 4, 0, 0, 1, 0, 0, 27, -1, 0, '', '1', '0'),
	(2563, '4151', 467, 'school_bus', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(2564, '4152', 467, 'school_table', 4, 0, 0, 1, 0, 0, 37, -1, 0, '', '1', '0'),
	(2565, '4153', 467, 'school_bench', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(2566, '4154', 467, 'school_console', 4, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(2567, '4155', 467, 'school_stuff_01', 4, 0, 0, 1, 0, 0, 31, -1, 0, '', '1', '0'),
	(2568, '4156', 467, 'school_stuff_05', 4, 0, 0, 1, 0, 0, 35, -1, 0, '', '1', '0'),
	(2569, '4157', 467, 'school_floor', 2, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(2570, '4158', 467, 'school_locker_b_nosale', 4, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(2571, '4159', 467, 'school_stuff_02', 4, 0, 0, 1, 0, 0, 32, -1, 0, '', '1', '0'),
	(2572, '4160', 467, 'school_stuff_04', 4, 0, 0, 1, 0, 0, 34, -1, 0, '', '1', '0'),
	(2573, '4161', 467, 'school_stuff_03', 4, 0, 0, 1, 0, 0, 33, -1, 0, '', '1', '0'),
	(2574, '4162', 467, 'school_chair', 2, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(2575, '4163', 52, 'petfood26', 1, 0, 0, 1, 0, 0, 27, 10391, 0, '', '1', '0'),
	(2576, '4164', 106, 'boutique_floor1a', 1, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(2577, '4165', 106, 'boutique_table1', 2, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(2578, '4166', 106, 'boutique_clothingpile', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(2579, '4167', 106, 'boutique_changing1', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(2580, '4168', 106, 'boutique_changing3', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(2581, '4169', 106, 'boutique_sofa2', 3, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(2582, '4170', 106, 'boutique_mannequin1', 4, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(2583, '4171', 106, 'boutique_sofa1', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(2584, '4172', 106, 'boutique_table2', 4, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(2585, '4173', 106, 'boutique_cashreg', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(2586, '4174', 106, 'boutique_changing2', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(2587, '4175', 106, 'boutique_plant1', 4, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(2588, '4176', 106, 'boutique_plant2', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(2589, '4177', 106, 'boutique_counter', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(2590, '4178', 106, 'boutique_floor2b', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(2591, '4179', 106, 'boutique_floor1b', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(2592, '4180', 106, 'boutique_floor2a', 1, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(2593, '4181', 115, 'waterbowl_basic*1', 2, 0, 0, 1, 0, 0, 27, 10440, 0, '', '1', '0'),
	(2594, '4182', 115, 'waterbowl_basic*2', 2, 0, 0, 1, 0, 0, 16, 10441, 0, '', '1', '0'),
	(2595, '4183', 115, 'waterbowl_basic*3', 2, 0, 0, 1, 0, 0, 25, 10442, 0, '', '1', '0'),
	(2596, '4184', 115, 'waterbowl_basic*4', 2, 0, 0, 1, 0, 0, 24, 10443, 0, '', '1', '0'),
	(2597, '4185', 115, 'waterbowl_basic*5', 2, 0, 0, 1, 0, 0, 23, 10444, 0, '', '1', '0'),
	(2598, '4186', 106, 'boutique_hcsign', 4, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(2599, '4187', 106, 'boutique_vipsign', 4, 0, 0, 1, 0, 0, 26, -1, 0, '', '1', '0'),
	(2600, '4188', 180, 'bubble_lamp1', 4, 0, 0, 1, 0, 0, 5, 18189, 0, '', '1', '0'),
	(2601, '4189', 180, 'pura_roundpad8', 4, 0, 0, 1, 0, 0, 108, 18169, 0, '', '1', '0'),
	(2602, '4190', 180, 'pura_block_lamp1', 4, 0, 0, 1, 0, 0, 6, 10449, 0, '', '1', '0'),
	(2603, '4191', 180, 'pura_roundpad9', 4, 0, 0, 1, 0, 0, 107, 18170, 0, '', '1', '0'),
	(2604, '4192', 180, 'eleblock2', 4, 0, 0, 1, 0, 0, 45, 19335, 0, '', '1', '0'),
	(2605, '4193', 180, 'eleblock4', 4, 0, 0, 1, 0, 0, 49, -1, 0, '', '1', '0'),
	(2606, '4194', 180, 'pura_roundpad6', 4, 0, 0, 1, 0, 0, 103, 18171, 0, '', '1', '0'),
	(2607, '4195', 180, 'eleblock7', 4, 0, 0, 1, 0, 0, 44, 18193, 0, '', '1', '0'),
	(2608, '4196', 180, 'pura_roundpad3', 4, 0, 0, 1, 0, 0, 102, -1, 0, '', '1', '0'),
	(2609, '4197', 180, 'pura_roundpad4', 4, 0, 0, 1, 0, 0, 109, -1, 0, '', '1', '0'),
	(2610, '4198', 180, 'eleblock5', 4, 0, 0, 1, 0, 0, 41, 18190, 0, '', '1', '0'),
	(2611, '4199', 180, 'eleblock3', 4, 0, 0, 1, 0, 0, 42, -1, 0, '', '1', '0'),
	(2612, '4200', 180, 'eleblock1', 4, 0, 0, 1, 0, 0, 40, 18192, 0, '', '1', '0'),
	(2613, '4201', 180, 'pura_roundpad1', 4, 0, 0, 1, 0, 0, 100, 18175, 0, '', '1', '0'),
	(2614, '4202', 180, 'pura_roundpad2', 4, 0, 0, 1, 0, 0, 105, 18174, 0, '', '1', '0'),
	(2615, '4203', 180, 'eleblock8', 4, 0, 0, 1, 0, 0, 48, 18194, 0, '', '1', '0'),
	(2616, '4204', 180, 'pura_roundpad5', 4, 0, 0, 1, 0, 0, 101, 18173, 0, '', '1', '0'),
	(2617, '4205', 180, 'eleblock9', 4, 0, 0, 1, 0, 0, 47, 18195, 0, '', '1', '0'),
	(2618, '4206', 180, 'pura_roundpad7', 4, 0, 0, 1, 0, 0, 104, 18172, 0, '', '1', '0'),
	(2619, '4207', 180, 'eleblock6', 4, 0, 0, 1, 0, 0, 43, 18191, 0, '', '1', '0'),
	(2620, '4208', 243, 'horse_dye_08', 1, 0, 0, 1, 0, 0, 48, 10479, 0, '', '1', '0'),
	(2621, '4209', 245, 'horse_hayfloor', 3, 0, 0, 1, 0, 0, 25, 10480, 0, '', '1', '0'),
	(2622, '4210', 243, 'horse_dye_11', 1, 0, 0, 1, 0, 0, 51, 10482, 0, '', '1', '0'),
	(2623, '4211', 243, 'horse_hairdye_06', 1, 0, 0, 1, 0, 0, 7, 10483, 0, '', '1', '0'),
	(2624, '4212', 243, 'horse_dye_02', 1, 0, 0, 1, 0, 0, 42, 10484, 0, '', '1', '0'),
	(2625, '4213', 245, 'horse_stable_gate', 3, 0, 0, 1, 0, 0, 9, 10485, 0, '', '1', '0'),
	(2626, '4214', 243, 'horse_hairdye_09', 1, 0, 0, 1, 0, 0, 10, 10486, 0, '', '1', '0'),
	(2627, '4215', 243, 'horse_hairdye_07', 1, 0, 0, 1, 0, 0, 8, 10487, 0, '', '1', '0'),
	(2628, '4216', 243, 'horse_dye_12', 1, 0, 0, 1, 0, 0, 25, 10488, 0, '', '1', '0'),
	(2629, '4217', 243, 'horse_dye_03', 1, 0, 0, 1, 0, 0, 22, 10489, 0, '', '1', '0'),
	(2630, '4218', 243, 'horse_dye_05', 1, 0, 0, 1, 0, 0, 23, 10490, 0, '', '1', '0'),
	(2631, '4219', 243, 'horse_hairdye_11', 1, 0, 0, 1, 0, 0, 11, 10491, 0, '', '1', '0'),
	(2632, '4220', 243, 'post_it_vd', 1, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(2633, '4221', 242, 'post_it', 5, 0, 0, 1, 0, 0, 1, 17997, 0, '', '1', '0'),
	(2634, '4222', 245, 'ads_veet', 3, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(2635, '4223', 245, 'sf_wall3', 3, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(2636, '4224', 243, 'sf_window', 1, 0, 0, 1, 0, 0, 44, -1, 0, '', '1', '0'),
	(2637, '4225', 243, 'ads_mall_wintra', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(2638, '4226', 243, 'ads_wwe_poster', 1, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(2639, '4227', 243, 'sf_wall', 1, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(2640, '4228', 243, 'sf_wall2', 1, 0, 0, 1, 0, 0, 26, -1, 0, '', '1', '0'),
	(2641, '4229', 245, 'flag_belgium', 3, 0, 0, 1, 0, 0, 16, 4239, 0, '', '1', '0'),
	(2642, '4230', 243, 'ads_mall_wingar', 1, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(2643, '4231', 243, 'flag_portugal', 1, 0, 0, 1, 0, 0, 4, 4241, 0, '', '1', '0'),
	(2644, '4232', 243, 'rela_wall', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(2645, '4233', 245, 'ktchn_knives', 3, 0, 0, 1, 0, 0, 7, 18141, 0, '', '1', '0'),
	(2646, '4234', 243, 'ktchn_oven', 1, 0, 0, 1, 0, 0, 1, 4264, 0, '', '1', '0'),
	(2647, '4235', 243, 'ktchn_wall', 2, 0, 0, 1, 0, 0, 1, 4265, 0, '', '1', '0'),
	(2648, '4236', 245, 'ads_mall_winclo', 3, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(2649, '4237', 243, 'dimmer_swtch', 1, 0, 0, 1, 0, 0, 46, 17815, 0, '', '1', '0'),
	(2650, '4238', 243, 'dimmer_buttn', 1, 0, 0, 1, 0, 0, 3, 17810, 0, '', '1', '0'),
	(2651, '4239', 245, 'dimmer_fuse2', 2, 0, 0, 1, 0, 0, 1, 4302, 0, '', '1', '0'),
	(2652, '4240', 245, 'dimmer_fuse6', 3, 0, 0, 1, 0, 0, 12, 4303, 0, '', '1', '0'),
	(2653, '4241', 243, 'ads_mtv_bigtv', 1, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(2654, '4242', 243, 'ads_mtv_tv', 1, 0, 0, 1, 0, 0, 54, -1, 0, '', '1', '0'),
	(2655, '4243', 243, 'ads_idol_l_logo', 1, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(2656, '4244', 243, 'urban_wall', 1, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(2657, '4245', 243, 'ads_idol_l_tv', 1, 0, 0, 1, 0, 0, 40, -1, 0, '', '1', '0'),
	(2658, '4246', 245, 'flag_peru', 3, 0, 0, 1, 0, 0, 17, 4398, 0, '', '1', '0'),
	(2659, '4247', 245, 'hween09_crnr1', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(2660, '4248', 108, 'flag_tunisia', 3, 0, 0, 1, 0, 0, 9, 4400, 0, '', '1', '0'),
	(2661, '4249', 108, 'flag_singapore', 4, 0, 0, 1, 0, 0, 8, 4401, 0, '', '1', '0'),
	(2662, '4250', 108, 'flag_mexico', 1, 0, 0, 1, 0, 0, 16, 4402, 0, '', '1', '0'),
	(2663, '4251', 108, 'flag_philippines', 1, 0, 0, 1, 0, 0, 15, 4403, 0, '', '1', '0'),
	(2664, '4252', 108, 'flag_malaysia', 1, 0, 0, 1, 0, 0, 20, 4404, 0, '', '1', '0'),
	(2665, '4253', 108, 'flag_greece', 4, 0, 0, 1, 0, 0, 13, 4405, 0, '', '1', '0'),
	(2666, '4254', 108, 'flag_venezl', 3, 0, 0, 1, 0, 0, 14, 4406, 0, '', '1', '0'),
	(2667, '4255', 550, 'flag_turkey', 4, 0, 0, 1, 0, 0, 99, 4407, 0, '', '1', '0'),
	(2668, '4256', 244, 'flag_chile', 3, 0, 0, 1, 0, 0, 3, 4408, 0, '', '1', '0'),
	(2669, '4257', 244, 'hween09_wall1', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(2670, '4258', 243, 'flag_columbia', 1, 0, 0, 1, 0, 0, 27, 4410, 0, '', '1', '0'),
	(2671, '4259', 244, 'hween09_stonewall', 3, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(2672, '4260', 244, 'flag_newzealand', 3, 0, 0, 1, 0, 0, 2, 4412, 0, '', '1', '0'),
	(2673, '4261', 244, 'flag_argentina', 3, 0, 0, 1, 0, 0, 4, 4413, 0, '', '1', '0'),
	(2674, '4262', 243, 'flag_panama', 1, 0, 0, 1, 0, 0, 28, 4414, 0, '', '1', '0'),
	(2675, '4263', 244, 'hween09_paint', 3, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(2676, '4264', 225, 'flag_morocco', 5, 0, 0, 1, 0, 0, 72, 4416, 0, '', '1', '0'),
	(2677, '4265', 392, 'flag_dominicanrepublic', 4, 0, 0, 1, 0, 0, 2, 4417, 0, '', '1', '0'),
	(2678, '4266', 392, 'hween09_curt', 10, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(2679, '4267', 392, 'byesw_loadscreen', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(2680, '4268', 392, 'flag_ecuador', 4, 0, 0, 1, 0, 0, 8, 4420, 0, '', '1', '0'),
	(2681, '4269', 392, 'hween09_treewall', 3, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(2682, '4270', 392, 'flag_algeria', 4, 0, 0, 1, 0, 0, 5, 4422, 0, '', '1', '0'),
	(2683, '4271', 392, 'hween09_win', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(2684, '4272', 392, 'ads_twi_paint', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(2685, '4273', 392, 'ads_twi_dreamc', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(2686, '4274', 235, 'ads_twi_bwall1', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(2687, '4275', 245, 'ads_twi_crest', 3, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(2688, '4276', 40, 'ads_twi_bwall2', 7, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(2689, '4277', 346, 'ads_twi_windw', 4, 0, 0, 1, 0, 0, 60, -1, 0, '', '1', '0'),
	(2690, '4278', 392, 'xm09_bauble_24', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(2691, '4279', 20, 'xm09_bauble_27', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(2692, '4280', 346, 'xm09_stocking', 4, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(2693, '4281', 65, 'xm09_bauble_17', 5, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(2694, '4282', 479, 'xm09_bauble_4', 5, 0, 0, 1, 0, 0, 61, -1, 0, '', '1', '0'),
	(2695, '4283', 479, 'xm09_bauble_19', 2, 0, 0, 1, 0, 0, 31, -1, 0, '', '1', '0'),
	(2696, '4284', 479, 'xm09_bauble_6', 4, 0, 0, 1, 0, 0, 72, -1, 0, '', '1', '0'),
	(2697, '4285', 479, 'xm09_bauble_3', 4, 0, 0, 1, 0, 0, 62, -1, 0, '', '1', '0'),
	(2698, '4286', 479, 'xm09_bauble_25', 4, 0, 0, 1, 0, 0, 71, -1, 0, '', '1', '0'),
	(2699, '4287', 479, 'arabian_wall', 4, 0, 0, 1, 0, 0, 78, -1, 0, '', '1', '0'),
	(2700, '4288', 479, 'xm09_bauble_5', 2, 0, 0, 1, 0, 0, 70, -1, 0, '', '1', '0'),
	(2701, '4289', 479, 'xm09_bauble_11', 4, 0, 0, 1, 0, 0, 38, -1, 0, '', '1', '0'),
	(2702, '4290', 479, 'xm09_bauble_14', 4, 0, 0, 1, 0, 0, 37, -1, 0, '', '1', '0'),
	(2703, '4291', 479, 'xm09_bauble_7', 4, 0, 0, 1, 0, 0, 78, -1, 0, '', '1', '0'),
	(2704, '4292', 479, 'xm09_bauble_23', 4, 0, 0, 1, 0, 0, 36, -1, 0, '', '1', '0'),
	(2705, '4293', 479, 'xm09_bauble_10', 4, 0, 0, 1, 0, 0, 63, -1, 0, '', '1', '0'),
	(2706, '4294', 479, 'xm09_bauble_9', 4, 0, 0, 1, 0, 0, 67, -1, 0, '', '1', '0'),
	(2707, '4295', 479, 'xm09_bauble_8', 4, 0, 0, 1, 0, 0, 77, -1, 0, '', '1', '0'),
	(2708, '4296', 479, 'xm09_bauble_20', 2, 0, 0, 1, 0, 0, 63, -1, 0, '', '1', '0'),
	(2709, '4297', 479, 'xm09_bauble_2', 4, 0, 0, 1, 0, 0, 27, -1, 0, '', '1', '0'),
	(2710, '4298', 479, 'xm09_bauble_18', 4, 0, 0, 1, 0, 0, 75, -1, 0, '', '1', '0'),
	(2711, '4299', 850, 'xm09_bauble_13', 5, 0, 0, 1, 0, 0, 68, -1, 0, '', '1', '0'),
	(2712, '4300', 479, 'xm09_bauble_1', 1, 0, 0, 1, 0, 0, 60, -1, 0, '', '1', '0'),
	(2713, '4301', 479, 'xm09_bauble_15', 4, 0, 0, 1, 0, 0, 73, -1, 0, '', '1', '0'),
	(2714, '4302', 479, 'xm09_bauble_22', 4, 0, 0, 1, 0, 0, 59, -1, 0, '', '1', '0'),
	(2715, '4303', 479, 'xm09_bauble_16', 2, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(2716, '4304', 479, 'xm09_bauble_12', 4, 0, 0, 1, 0, 0, 76, -1, 0, '', '1', '0'),
	(2717, '4305', 479, 'xm09_bauble_21', 4, 0, 0, 1, 0, 0, 74, -1, 0, '', '1', '0'),
	(2718, '4306', 479, 'xm09_bauble_26', 4, 0, 0, 1, 0, 0, 79, -1, 0, '', '1', '0'),
	(2719, '4307', 479, 'xm09_firwall', 4, 0, 0, 1, 0, 0, 76, -1, 0, '', '1', '0'),
	(2720, '4308', 479, 'xm09_forestwall', 4, 0, 0, 1, 0, 0, 78, -1, 0, '', '1', '0'),
	(2721, '4309', 479, 'xm09_infotv', 4, 0, 0, 1, 0, 0, 35, -1, 0, '', '1', '0'),
	(2722, '4310', 244, 'party_lights', 3, 0, 0, 1, 0, 0, 7, 18186, 0, '', '1', '0'),
	(2723, '4313', 479, 'year2010', 4, 0, 0, 1, 0, 0, 80, -1, 0, '', '1', '0'),
	(2725, '4315', 479, 'ads_tv_jaapuisto', 4, 0, 0, 1, 0, 0, 32, -1, 0, '', '1', '0'),
	(2726, '4316', 479, 'val09_wall2', 4, 0, 0, 1, 0, 0, 64, -1, 0, '', '1', '0'),
	(2727, '4317', 479, 'val09_wdrobe_g', 4, 0, 0, 1, 0, 0, 66, -1, 0, '', '1', '0'),
	(2728, '4318', 479, 'val09_wall1', 4, 0, 0, 1, 0, 0, 65, -1, 0, '', '1', '0'),
	(2729, '4319', 479, 'bling_sink', 4, 0, 0, 1, 0, 0, 40, -1, 0, '', '1', '0'),
	(2730, '4320', 479, 'val09_wdrobe_b', 2, 0, 0, 1, 0, 0, 32, -1, 0, '', '1', '0'),
	(2731, '4321', 479, 'bling_cabinet', 2, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(2732, '4322', 850, 'ads_percyw', 5, 0, 0, 1, 0, 0, 51, -1, 0, '', '1', '0'),
	(2733, '4323', 479, 'ads_boost_surfb', 4, 0, 0, 1, 0, 0, 28, -1, 0, '', '1', '0'),
	(2734, '4324', 479, 'ads_tlc_wheel', 2, 0, 0, 1, 0, 0, 33, -1, 0, '', '1', '0'),
	(2735, '4325', 479, 'garden_wall', 4, 0, 0, 1, 0, 0, 30, -1, 0, '', '1', '0'),
	(2736, '4326', 479, 'ads_tv_yle', 2, 0, 0, 1, 0, 0, 26, -1, 0, '', '1', '0'),
	(2737, '4327', 479, 'runway_shelf', 4, 0, 0, 1, 0, 0, 29, -1, 0, '', '1', '0'),
	(2738, '4328', 479, 'ads_latrobe_flag', 2, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(2739, '4329', 479, 'hc3_walldeco', 4, 0, 0, 1, 0, 0, 39, -1, 0, '', '1', '0'),
	(2740, '4330', 479, 'ads_nokia_x6', 4, 0, 0, 1, 0, 0, 39, -1, 0, '', '1', '0'),
	(2741, '4331', 22, 'runway_fabric', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(2742, '4332', 467, 'ads_target_wall', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(2743, '4333', 479, 'ads_super_pop', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(2744, '4334', 479, 'ads_tv_chocapic_02', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(2745, '4335', 479, 'ads_tv_chocapic_01', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(2746, '4336', 479, 'bw_jaws', 4, 0, 0, 1, 0, 0, 13, 8757, 0, '', '1', '0'),
	(2747, '4337', 467, 'ads_grefusa_surfb', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(2748, '4338', 467, 'ktchn10_cabnt', 4, 0, 0, 1, 0, 0, 3, 8897, 0, '', '1', '0'),
	(2749, '4339', 479, 'hosptl_xray', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(2750, '4340', 479, 'hween10_fogwall', 4, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(2751, '4341', 479, 'bb_painimies1', 4, 0, 0, 1, 0, 0, 16, 8959, 0, '', '1', '0'),
	(2752, '4342', 479, 'bb_painimies2', 10, 0, 0, 1, 0, 0, 17, 8960, 0, '', '1', '0'),
	(2753, '4343', 479, 'ads_mtv_bigtv2', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(2754, '4344', 479, 'ads_mtv_tv2', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(2755, '4345', 479, 'hween10_card_3', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(2756, '4346', 479, 'hween10_card_1', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(2757, '4347', 467, 'hween10_card_4', 4, 0, 0, 1, 0, 0, 42, -1, 0, '', '1', '0'),
	(2758, '4348', 479, 'hween10_card_6', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(2759, '4349', 479, 'hween10_wallskull', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(2760, '4350', 479, 'hween10_card_2', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(2761, '4351', 506, 'hween10_card_5', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(2762, '4352', 632, 'ads_nokiax3_wall2', 4, 0, 0, 1, 0, 0, 61, -1, 0, '', '1', '0'),
	(2763, '4353', 414, 'ads_nokiax3_wall3', 4, 0, 0, 1, 0, 0, 62, -1, 0, '', '1', '0'),
	(2764, '4354', 414, 'ads_nokiax3_wall1', 4, 0, 0, 1, 0, 0, 63, -1, 0, '', '1', '0'),
	(2765, '4355', 414, 'ads_nokiax3_phn', 4, 0, 0, 1, 0, 0, 64, -1, 0, '', '1', '0'),
	(2766, '4356', 414, 'exe_sensor', 4, 0, 0, 1, 0, 0, 65, -1, 0, '', '1', '0'),
	(2767, '4357', 414, 'qt_calendar2', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(2768, '4358', 414, 'ads_r7logo', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(2769, '4359', 683, 'qt_calendar0', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(2770, '4360', 414, 'qt_calendar1', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(2771, '4361', 414, 'qt_xm10_bauble2', 4, 0, 0, 1, 0, 0, 32, -1, 0, '', '1', '0'),
	(2772, '4362', 414, 'es_build1', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(2773, '4363', 350, 'es_build4', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(2774, '4364', 532, 'es_build2', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(2775, '4365', 239, 'qt_xm10_bauble1', 0, 10, 0, 1, 0, 0, 3, -1, 0, '', '0', '0'),
	(2776, '4366', 414, 'es_build3', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(2777, '4368', 470, 'qt_xm10_bauble3', 4, 0, 0, 1, 0, 0, 102, -1, 0, '', '1', '0'),
	(2778, '4369', 470, 'qt_xm10_icestar', 2, 0, 0, 1, 0, 0, 54, -1, 0, '', '1', '0'),
	(2779, '4370', 470, 'es_big1', 4, 0, 0, 1, 0, 0, 101, -1, 0, '', '1', '0'),
	(2780, '4371', 470, 'es_big3', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(2781, '4372', 470, 'es_big2', 4, 0, 0, 1, 0, 0, 58, -1, 0, '', '1', '0'),
	(2782, '4373', 470, 'year2011', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(2783, '4374', 470, 'bling11_wall1', 3, 0, 0, 1, 0, 0, 55, -1, 0, '', '1', '0'),
	(2784, '4375', 470, 'bling11_wall4', 2, 0, 0, 1, 0, 0, 53, -1, 0, '', '1', '0'),
	(2785, '4376', 470, 'bling11_wall2', 10, 0, 0, 1, 0, 0, 100, -1, 0, '', '1', '0'),
	(2786, '4377', 470, 'bling11_wall3', 4, 0, 0, 1, 0, 0, 103, -1, 0, '', '1', '0'),
	(2787, '4378', 470, 'qt_val11_heartlights', 2, 0, 0, 1, 0, 0, 47, -1, 0, '', '1', '0'),
	(2788, '4379', 470, 'bling11_big1', 4, 0, 0, 1, 0, 0, 51, -1, 0, '', '1', '0'),
	(2789, '4380', 470, 'gothic_st_glass', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(2790, '4381', 470, 'ads_bigtv_missmix', 3, 0, 0, 1, 0, 0, 56, -1, 0, '', '1', '0'),
	(2791, '4382', 470, 'cine_light2', 4, 0, 0, 1, 0, 0, 52, -1, 0, '', '1', '0'),
	(2792, '4383', 470, 'cine_light1', 2, 0, 0, 1, 0, 0, 49, -1, 0, '', '1', '0'),
	(2793, '4384', 470, 'cubie_decal_3_b', 4, 0, 0, 1, 0, 0, 11, 9599, 0, '', '1', '0'),
	(2794, '4385', 470, 'cubie_decklight_p', 3, 0, 0, 1, 0, 0, 57, 18045, 0, '', '1', '0'),
	(2795, '4386', 470, 'cubie_decal_1_b', 2, 0, 0, 1, 0, 0, 48, 9601, 0, '', '1', '0'),
	(2796, '4387', 470, 'cubie_decal_2_b', 4, 0, 0, 1, 0, 0, 10, 9602, 0, '', '1', '0'),
	(2797, '4388', 470, 'cubie_decal_3_p', 4, 0, 0, 1, 0, 0, 50, 9603, 0, '', '1', '0'),
	(2798, '4389', 108, 'cubie_wallshelf_b', 7, 0, 0, 1, 0, 0, 10, 9604, 0, '', '1', '0'),
	(2799, '4390', 412, 'cubie_decal_1_p', 5, 0, 0, 1, 0, 0, 99, 9605, 0, '', '1', '0'),
	(2800, '4391', 412, 'cubie_decal_3', 2, 0, 0, 1, 0, 0, 99, 9606, 0, '', '1', '0'),
	(2801, '4392', 412, 'cubie_wallshelf_p', 1, 0, 0, 1, 0, 0, 99, 9607, 0, '', '1', '0'),
	(2802, '4393', 412, 'cubie_decal_2_p', 3, 0, 0, 1, 0, 0, 99, 9608, 0, '', '1', '0'),
	(2803, '4394', 412, 'cubie_decklight_b', 2, 0, 0, 1, 0, 0, 99, 18046, 0, '', '1', '0'),
	(2804, '4395', 412, 'cubie_decal_0', 5, 0, 0, 1, 0, 0, 99, 9610, 0, '', '1', '0'),
	(2805, '4402', 421, 'ads_kfp2_tv', 3, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(2806, '4403', 421, 'ads_kfp2_wall', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(2807, '4404', 421, 'dng_wall', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(2808, '4405', 421, 'ads_cchups_screen', 4, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(2809, '4406', 421, 'sb_tag1', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(2810, '4407', 421, 'sb_wall', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(2811, '4408', 338, 'sb_tag2', 5, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(2812, '4409', 338, 'sb_tag3', 5, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(2813, '4410', 468, 'ads_durex_screen', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(2814, '4411', 851, 'ads_mtv_wall', 5, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(2815, '4412', 338, 'summer_sunset_wall', 5, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(2816, '4413', 468, 'usva5_wallrug', 4, 0, 0, 1, 0, 0, 3, 10355, 0, '', '1', '0'),
	(2817, '4414', 421, 'usva3_wallrug', 4, 0, 0, 1, 0, 0, 66, 10356, 0, '', '1', '0'),
	(2818, '4415', 421, 'usva_wallrug', 4, 0, 0, 1, 0, 0, 67, 10357, 0, '', '1', '0'),
	(2819, '4416', 446, 'usva4_wallrug', 4, 0, 0, 1, 0, 0, 7, 10358, 0, '', '1', '0'),
	(2820, '4417', 446, 'usva2_wallrug', 4, 0, 0, 1, 0, 0, 3, 10359, 0, '', '1', '0'),
	(2821, '4418', 446, 'school_chalkboard', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(2822, '4419', 446, 'school_urinal', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(2823, '4420', 446, 'school_wall', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(2824, '4421', 446, 'school_charts', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(2825, '4422', 446, 'school_toilet_wall', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(2826, '4423', 446, 'boutique_lampwall', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(2827, '4424', 446, 'boutique_shrack2', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(2828, '4425', 446, 'boutique_shrack1', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(2829, '4426', 446, 'boutique_speakers', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(2830, '4427', 446, 'boutique_clrack2', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(2831, '4428', 446, 'boutique_clrack1', 3, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(2832, '4429', 683, 'ads_flag_un', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(2833, '4430', 446, 'horse_pitchfork_wall', 3, 0, 0, 1, 0, 0, 14, 10523, 0, '', '1', '0'),
	(2834, '4431', 446, 'horse_stable_wall', 4, 0, 0, 1, 0, 0, 8, 10524, 0, '', '1', '0'),
	(2835, '4432', 446, 'horse_stable_wall_w', 4, 0, 0, 1, 0, 0, 11, 10526, 0, '', '1', '0'),
	(2836, '4433', 446, 'horse_shoe_wall', 2, 0, 0, 1, 0, 0, 15, 10528, 0, '', '1', '0'),
	(2837, '4434', 545, 'hween11_window', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(2838, '4435', 683, 'xmas11_hd4', 1, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(2839, '4436', 115, 'xmas11_wall', 1, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(2840, '4437', 115, 'xmas11_hd2', 2, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(2841, '4438', 115, 'xmas11_hd5', 2, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(2842, '4439', 115, 'xmas11_hd3', 2, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(2843, '4440', 115, 'xmas11_hd1', 2, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(2844, '4441', 683, 'xmas11_hd6', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(2845, '4442', 429, 'ads_alvinsurf', 4, 0, 0, 1, 0, 0, 68, -1, 0, '', '1', '0'),
	(2846, '4443', 446, 'xmas11_cuckoo', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(2847, '4444', 280, 'ads_m6_wall', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(2848, '4445', 22, 'year2012', 4, 0, 0, 1, 0, 0, 69, -1, 0, '', '1', '0'),
	(2849, '4446', 22, 'snowb_mountain_wall', 5, 0, 0, 1, 0, 0, 70, 10796, 0, '', '1', '0'),
	(2850, '4447', 22, 'flag_denmark', 4, 0, 0, 1, 0, 0, 71, 10827, 0, '', '1', '0'),
	(2851, '4448', 22, 'urban_wall_china', 4, 0, 0, 1, 0, 0, 72, -1, 0, '', '1', '0'),
	(2852, '4449', 479, 'ads_antena3_wall', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(2853, '4450', 242, 'xm11_stocking', 5, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(2854, '4451', 245, 'wallchair', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(2855, '4452', 245, 'jp_window', 1, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(2856, '4453', 245, 'jp_wall', 3, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(2857, '4454', 245, 'stone_wall', 2, 0, 0, 1, 0, 0, 27, 11117, 0, '', '1', '0'),
	(2858, '4455', 245, 'gardenshed_wall', 1, 0, 0, 1, 0, 0, 13, 11118, 0, '', '1', '0'),
	(2859, '4456', 429, 'js_exe_wfall', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(2860, '4457', 52, 'football12_es', 1, 0, 0, 1, 0, 0, 20, 11233, 0, '', '1', '0'),
	(2861, '4458', 282, 'football12_it', 4, 0, 0, 1, 0, 0, 22, 11232, 0, '', '1', '0'),
	(2862, '4459', 120, 'football12_de', 4, 0, 0, 1, 0, 0, 25, 11234, 0, '', '1', '0'),
	(2863, '4460', 455, 'football12_pt', 3, 0, 0, 1, 0, 0, 74, 11231, 0, '', '1', '0'),
	(2864, '4461', 245, 'anc_savanna_wall', 3, 0, 0, 1, 0, 0, 31, -1, 0, '', '1', '0'),
	(2865, '4462', 245, 'anc_sunset_wall', 5, 0, 0, 1, 0, 0, 32, -1, 0, '', '1', '0'),
	(2866, '4463', 245, 'lon_skyline', 3, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(2867, '4464', 52, 'hween12_dartboard', 1, 0, 0, 1, 0, 0, 28, -1, 0, '', '1', '0'),
	(2868, '4465', 244, 'hs_wall', 3, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(2869, '4466', 245, 'hs_wlight', 5, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(2870, '4467', 245, 'hs_applause', 3, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(2871, '4468', 245, 'xmas12_wall_in', 3, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(2872, '4469', 245, 'xmas12_window', 3, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(2873, '4470', 245, 'xmas12_wall_out', 3, 0, 0, 1, 0, 0, 29, -1, 0, '', '1', '0'),
	(2874, '4471', 245, 'xmas12_door', 3, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(2875, '4472', 245, 'xmas12_torch', 3, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(2876, '4473', 245, 'obstacle_oxer3', 3, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(2877, '4474', 245, 'obstacle_oxer2', 3, 0, 0, 1, 0, 0, 20, 17933, 0, '', '1', '0'),
	(2878, '4475', 245, 'year2013', 3, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(2879, '4476', 245, 'ny2013_wall', 3, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(2880, '4477', 243, 'china_pstr4', 1, 0, 0, 1, 0, 0, 75, -1, 0, '', '1', '0'),
	(2881, '4478', 212, 'val13_wall_2', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(2882, '4479', 244, 'val13_wall_3', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(2883, '4480', 115, 'val13_wall_1', 2, 0, 0, 1, 0, 0, 76, -1, 0, '', '1', '0'),
	(2884, '4481', 738, 'pixel_clock_red', 5, 0, 0, 1, 0, 0, 2, 11956, 0, '', '1', '0'),
	(2885, '4482', 31, 'pixel_walldeco', 4, 0, 0, 1, 0, 0, 45, 11957, 0, '', '1', '0'),
	(2886, '4483', 31, 'pixel_clock_pink', 4, 0, 0, 1, 0, 0, 44, 11958, 0, '', '1', '0'),
	(2887, '4484', 738, 'pixel_mirror', 5, 0, 0, 1, 0, 0, 14, 11959, 0, '', '1', '0'),
	(2888, '4485', 738, 'pixel_clock_black', 5, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(2889, '4486', 738, 'pixel_clock_green', 5, 0, 0, 1, 0, 0, 19, 11961, 0, '', '1', '0'),
	(2890, '4487', 738, 'pixel_clock_blue', 5, 0, 0, 1, 0, 0, 12, 11962, 0, '', '1', '0'),
	(2891, '4488', 35, 'pixel_wall_green', 4, 0, 0, 1, 0, 0, 26, 12146, 0, '', '1', '0'),
	(2892, '4489', 738, 'pixel_wall_red', 5, 0, 0, 1, 0, 0, 1, 12147, 0, '', '1', '0'),
	(2893, '4490', 12, 'pixel_painting_pink', 500, 0, 0, 1, 0, 0, 14, 12148, 0, '', '1', '0'),
	(2894, '4491', 41, 'pixel_painting_green', 4, 0, 0, 1, 0, 0, 12, 12149, 0, '', '1', '0'),
	(2895, '4492', 41, 'pixel_wall_pink', 4, 0, 0, 1, 0, 0, 7, 12150, 0, '', '1', '0'),
	(2896, '4493', 41, 'pixel_painting_black', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(2897, '4494', 41, 'pixel_painting_blue', 4, 0, 0, 1, 0, 0, 6, 12152, 0, '', '1', '0'),
	(2898, '4495', 41, 'pixel_painting_red', 4, 0, 0, 1, 0, 0, 8, 12153, 0, '', '1', '0'),
	(2899, '4496', 41, 'pixel_wall_blue', 4, 0, 0, 1, 0, 0, 14, 12154, 0, '', '1', '0'),
	(2900, '4497', 41, 'pixel_wall_black', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(2901, '4498', 41, 'pixel_poster2', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(2902, '4499', 41, 'dimmer_steampunk', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(2903, '4500', 41, 'steampunk_wall2', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(2904, '4501', 41, 'steampunk_wall1', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(2905, '4502', 41, 'steampunk_window', 4, 0, 0, 1, 0, 0, 77, 12326, 0, '', '1', '0'),
	(2906, '4503', 41, 'steampunk_map', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(2907, '4504', 41, 'easter13_wall3', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(2908, '4505', 255, 'easter13_window', 7, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(2909, '4506', 52, 'easter13_wall1', 1, 0, 0, 1, 0, 0, 29, -1, 0, '', '1', '0'),
	(2910, '4507', 115, 'easter13_wall2', 1, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(2911, '4508', 115, 'mystics_bwall', 2, 0, 0, 1, 0, 0, 78, -1, 0, '', '1', '0'),
	(2912, '4509', 115, 'mystics_gwall', 2, 0, 0, 1, 0, 0, 79, -1, 0, '', '1', '0'),
	(2913, '4510', 115, 'flag_austria', 2, 0, 0, 1, 0, 0, 80, 12813, 0, '', '1', '0'),
	(2914, '4511', 369, 'grungewall', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(2915, '4512', 369, 'school_chalkboard2', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(2916, '4513', 369, 'cine_pstr_6', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(2917, '4514', 369, 'cine_pstr_4', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(2918, '4515', 369, 'cine_pstr_7', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(2919, '4516', 369, 'cine_pstr_8', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(2920, '4517', 369, 'cine_pstr_1', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(2921, '4518', 369, 'cine_pstr_5', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(2922, '4519', 369, 'cine_pstr_0', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(2923, '4520', 369, 'cine_pstr_3', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(2924, '4521', 369, 'cine_pstr_9', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(2925, '4522', 369, 'cine_pstr_2', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(2926, '4523', 369, 'habbopage_wall', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(2927, '4524', 369, 'brnd_cscape_wall', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(2928, '4525', 369, 'ads_nokiax3_wallb', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(2929, '4526', 371, 'ads_nokiax3_wall', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(2930, '4527', 371, 'builderwall_exp', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(2931, '4528', 371, 'test_habbopage_display', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(2932, '4529', 371, 'cine_pstr_10', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(2933, '4530', 371, 'hc_exe_wfall', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(2934, '4531', 371, 'post_it_xmas', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(2935, '4532', 371, 'year2014', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(2936, '4533', 371, 'post_it_dreams', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(2937, '4534', 371, 'china_pstr5', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(2938, '4535', 370, 'storieshero_poster', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(2939, '4536', 370, 'external_image_wallitem', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(2940, '4537', 370, 'val14_wall1', 4, 0, 0, 1, 0, 0, 20, 18084, 0, '', '1', '0'),
	(2941, '4538', 370, 'val14_wall3', 4, 0, 0, 1, 0, 0, 10, 18085, 0, '', '1', '0'),
	(2942, '4539', 370, 'val14_wall2', 4, 0, 0, 1, 0, 0, 6, 18083, 0, '', '1', '0'),
	(2943, '4540', 370, 'post_it_shakesp', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(2944, '4541', 370, 'external_image_wallitem_photo', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(2945, '4542', 370, 'runway_fabric2', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(2946, '4543', 370, 'stories_sch_glass', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(2947, '4544', 370, 'easter14_wall', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(2948, '4545', 370, 'diamond_painting6', 4, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(2949, '4546', 370, 'diamond_painting4', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(2950, '4547', 370, 'diamond_painting2', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(2951, '4548', 370, 'diamond_painting5', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(2952, '4549', 370, 'diamond_painting1', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(2953, '4550', 370, 'diamond_painting3', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(2954, '4551', 370, 'vikings_banner_r', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(2955, '4552', 370, 'vikings_banner_g', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(2956, '4553', 370, 'vikings_wallshield_g', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(2957, '4554', 370, 'vikings_wallshield_r', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(2958, '4555', 738, 'vikings_wall_g', 5, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(2959, '4556', 115, 'vikings_wall_r', 2, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(2960, '4557', 115, 'post_it_juninas', 2, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(2961, '4558', 566, 'hblooza14_wall', 4, 0, 0, 1, 0, 0, 81, -1, 0, '', '1', '0'),
	(2962, '4559', 738, 'wildwest_wallpaper', 5, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(2963, '4560', 513, 'st_wildwest_wallskull', 2, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(2964, '4561', 513, 'uni_floppy', 2, 0, 0, 1, 0, 0, 6, 14135, 0, '', '1', '0'),
	(2965, '4562', 515, 'uni_fairylights', 2, 0, 0, 1, 0, 0, 1, 14136, 0, '', '1', '0'),
	(2966, '4563', 515, 'uni_poster1', 5, 0, 0, 1, 0, 0, 3, 14137, 0, '', '1', '0'),
	(2967, '4564', 515, 'uni_pinupgirl', 2, 0, 0, 1, 0, 0, 2, 14138, 0, '', '1', '0'),
	(2968, '4565', 738, 'uni_hipdeer', 5, 0, 0, 1, 0, 0, 8, 14139, 0, '', '1', '0'),
	(2969, '4566', 738, 'uni_poster2', 5, 0, 0, 1, 0, 0, 4, 14140, 0, '', '1', '0'),
	(2970, '4567', 515, 'uni_libraryshelf', 5, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(2971, '4568', 515, 'uni_coatrack', 2, 0, 0, 1, 0, 0, 6, 14142, 0, '', '1', '0'),
	(2972, '4569', 738, 'uni_girlcoatrack', 5, 0, 0, 1, 0, 0, 6, 14143, 0, '', '1', '0'),
	(2973, '4570', 513, 'uni_pinupboy', 5, 0, 0, 1, 0, 0, 4, 14144, 0, '', '1', '0'),
	(2974, '4571', 513, 'uni_vinyl', 5, 0, 0, 1, 0, 0, 3, 14145, 0, '', '1', '0'),
	(2975, '4572', 513, 'uni_moustache', 5, 0, 0, 1, 0, 0, 5, 14146, 0, '', '1', '0'),
	(2976, '4573', 738, 'bathroom_wall4', 5, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(2977, '4574', 513, 'bathroom_wall1', 2, 0, 0, 1, 0, 0, 1, 14180, 0, '', '1', '0'),
	(2978, '4575', 738, 'bathroom_wall3', 5, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(2979, '4576', 515, 'bathroom_wall2', 5, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(2980, '4577', 66, 'st_uni_poster', 4, 0, 0, 1, 0, 0, 5, 14183, 0, '', '1', '0'),
	(2981, '4578', 248, 'hween14_stainglass', 3, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(2982, '4579', 212, 'hween14_hcglass', 4, 0, 0, 1, 0, 0, 42, 14258, 0, '', '1', '0'),
	(2983, '4580', 212, 'hween14_wall', 4, 0, 0, 1, 0, 0, 48, -1, 0, '', '1', '0'),
	(2984, '4581', 212, 'external_image_wallitem_poster', 4, 0, 0, 1, 0, 0, 41, -1, 0, '', '1', '0'),
	(2985, '4582', 247, 'cine_pstr_11', 20, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(2986, '4583', 212, 'cine_pstr_18', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(2987, '4584', 212, 'cine_pstr_16', 4, 0, 0, 1, 0, 0, 45, -1, 0, '', '1', '0'),
	(2988, '4585', 212, 'cine_pstr_12', 4, 0, 0, 1, 0, 0, 46, -1, 0, '', '1', '0'),
	(2989, '4586', 514, 'cine_pstr_19', 2, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(2990, '4587', 514, 'cine_pstr_13', 2, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(2991, '4588', 514, 'cine_pstr_15', 2, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(2992, '4589', 514, 'cine_pstr_14', 2, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(2993, '4590', 514, 'cine_pstr_17', 2, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(2994, '4591', 514, 'st_pstr_felipe', 5, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(2995, '4592', 248, 'hc_arab_wndw', 10, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(2996, '4593', 248, 'hc_arab_swords', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(2997, '4594', 738, 'val15_fujiwall', 5, 0, 0, 1, 0, 1, 13, -1, 0, '', '1', '0'),
	(2998, '4595', 31, 'attic15_wall', 3, 0, 0, 1, 0, 0, 42, -1, 0, '', '1', '0'),
	(2999, '4596', 31, 'attic15_painting', 4, 0, 0, 1, 0, 0, 43, -1, 0, '', '1', '0'),
	(3000, '4597', 736, 'external_image_wallitem_poster_small', 12, 0, 0, 1, 0, 0, 37, -1, 0, '', '1', '0'),
	(3001, '4598', 736, 'carnival15_wallmask', 10, 0, 0, 1, 0, 0, 38, -1, 0, '', '1', '0'),
	(3002, '4599', 736, 'cpunk_c15_wall', 8, 0, 0, 1, 0, 0, 39, -1, 0, '', '1', '0'),
	(3003, '4600', 736, 'china_pstr6', 12, 0, 0, 1, 0, 0, 43, -1, 0, '', '1', '0'),
	(3004, '4601', 736, 'cypunk_c15_wall', 10, 0, 0, 1, 0, 0, 44, -1, 0, '', '1', '0'),
	(3005, '4602', 736, 'cland_c15_wall', 8, 0, 0, 1, 0, 0, 45, -1, 0, '', '1', '0'),
	(3006, '4603', 212, 'diamond_painting9', 4, 0, 0, 1, 0, 0, 44, -1, 0, '', '1', '0'),
	(3007, '4604', 247, 'diamond_painting18', 150, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(3008, '4605', 551, 'diamond_painting17', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3009, '4606', 738, 'diamond_painting15', 5, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(3010, '4607', 248, 'diamond_painting16', 30, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(3011, '4608', 248, 'diamond_painting14', 80, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(3012, '4609', 738, 'diamond_painting13', 5, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(3013, '4610', 552, 'diamond_painting10', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3014, '4611', 474, 'diamond_painting7', 4, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(3015, '4612', 307, 'diamond_painting12', 75, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(3016, '4613', 307, 'diamond_painting11', 200, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(3017, '4614', 736, 'army15_poster', 6, 0, 0, 1, 0, 0, 152, -1, 0, '', '1', '0'),
	(3018, '4615', 216, 'army_c15_insig', 4, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(3019, '4616', 408, 'army15_largescreen', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(3020, '4617', 555, 'army_c15_wall', 0, 10, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(3021, '4618', 555, 'dino_c15_wallpiece', 0, 10, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(3022, '4619', 555, 'paris_c15_wall', 0, 10, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(3023, '4620', 555, 'lodge_c15_window', 0, 10, 0, 1, 0, 0, 1, 18151, 0, '', '1', '0'),
	(3024, '4621', 555, 'lodge_c15_wall', 0, 10, 0, 1, 0, 0, 4, 16633, 0, '', '1', '0'),
	(3025, '4622', 555, 'drago_c15_flag', 0, 10, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(3026, '4623', 49, 'anc_c15_wall', 4, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(3027, '4624', 737, 'tiki_c15_wall', 5, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(3028, '4625', 701, 'exe_c15_wall', 2, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(3029, '4626', 701, 'romantique_c15_wall', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(3030, '4627', 701, 'bling_c15_wall', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(3031, '4628', 701, 'hween_c15_sky', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(3032, '4629', 701, 'cine_pstr_20', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(3033, '4630', 701, 'ktchn_c15_cupboard', 4, 0, 0, 1, 0, 0, 7, 16978, 0, '', '1', '0'),
	(3034, '4631', 701, 'gift_hhome', 2, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(3035, '4632', 701, 'gold_c15_arc_icewall', 5, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(3036, '4633', 120, 'xmas_c15_advent9', 4, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(3037, '4634', 120, 'xmas_c15_advent10', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(3038, '4635', 120, 'china_pstr7', 4, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(3039, '4636', 120, 'gothic_r16_fountain', 4, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(3040, '4637', 120, 'super_c16_pstriron', 4, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(3041, '4638', 120, 'super_c16_pstrcat', 4, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(3042, '4639', 120, 'super_c16_pstrsulk', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(3043, '4640', 738, 'super_c16_pstrlove', 5, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(3044, '4641', 737, 'olympics_c16_walldecal', 5, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(3045, '4642', 120, 'xmas_c16_painting', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(3046, '4643', 120, 'classic5_window', 4, 0, 0, 1, 0, 0, 28, -1, 0, '', '1', '0'),
	(3047, '4644', 120, 'china_pstr8', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(3048, '4645', 120, 'mall_c17_winclo', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(3049, '4646', 120, 'mall_c17_winpet', 4, 0, 0, 1, 0, 0, 27, -1, 0, '', '1', '0'),
	(3050, '4647', 120, 'mall_c17_winspo', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(3051, '4648', 120, 'easter_c17_countrybg', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(3052, '4649', 120, 'year2018', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(3053, '4650', 120, 'hc17_7', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(3054, '4651', 120, 'china_pstr9', 4, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(3055, '4652', 120, 'coralking_c18_seabg', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(3056, '4653', 120, 'diamond_painting26', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(3057, '4654', 120, 'diamond_painting28', 4, 0, 0, 1, 0, 0, 26, -1, 0, '', '1', '0'),
	(3058, '4655', 120, 'diamond_painting27', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(3059, '4656', 697, 'diamond_painting23', 4, 0, 0, 1, 0, 0, 195, -1, 0, '', '1', '0'),
	(3060, '4657', 697, 'diamond_painting21', 4, 0, 0, 1, 0, 0, 197, -1, 0, '', '1', '0'),
	(3061, '4658', 697, 'diamond_painting20', 4, 0, 0, 1, 0, 0, 193, -1, 0, '', '1', '0'),
	(3062, '4659', 697, 'diamond_painting19', 10, 0, 0, 1, 0, 0, 199, -1, 0, '', '1', '0'),
	(3063, '4660', 697, 'diamond_painting24', 4, 0, 0, 1, 0, 0, 192, -1, 0, '', '1', '0'),
	(3064, '4661', 697, 'diamond_painting29', 4, 0, 0, 1, 0, 0, 198, -1, 0, '', '1', '0'),
	(3065, '4662', 697, 'diamond_painting30', 4, 0, 0, 1, 0, 0, 194, -1, 0, '', '1', '0'),
	(3066, '4663', 851, 'diamond_painting22', 5, 0, 0, 1, 0, 0, 57, -1, 0, '', '1', '0'),
	(3067, '4664', 697, 'diamond_painting25', 4, 0, 0, 1, 0, 0, 191, -1, 0, '', '1', '0'),
	(3068, '4665', 225, 'hween_c18_labwallpanel', 15, 0, 0, 1, 0, 0, 65, -1, 0, '', '1', '0'),
	(3069, '4666', 225, 'xmas_c18_starrybg', 10, 0, 0, 1, 0, 0, 66, -1, 0, '', '1', '0'),
	(3070, '4667', 225, 'year2019', 5, 0, 0, 1, 0, 0, 67, -1, 0, '', '1', '0'),
	(3071, '4668', 738, 'china_pstr10', 5, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(3072, '4669', 738, 'easter_c19_forrestbg', 5, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(3073, '4670', 697, 'fest_c19_bgwall', 4, 0, 0, 1, 0, 0, 200, -1, 0, '', '1', '0'),
	(3074, '4671', 697, 'diamond_painting37', 4, 0, 0, 1, 0, 0, 201, -1, 0, '', '1', '0'),
	(3075, '4672', 697, 'diamond_painting33', 4, 0, 0, 1, 0, 0, 202, -1, 0, '', '1', '0'),
	(3076, '4673', 697, 'diamond_painting31', 4, 0, 0, 1, 0, 0, 197, -1, 0, '', '1', '0'),
	(3077, '4674', 697, 'diamond_painting36', 4, 0, 0, 1, 0, 0, 205, -1, 0, '', '1', '0'),
	(3078, '4675', 697, 'diamond_painting40', 4, 0, 0, 1, 0, 0, 204, -1, 0, '', '1', '0'),
	(3079, '4676', 429, 'diamond_painting35', 4, 0, 0, 1, 0, 0, 83, -1, 0, '', '1', '0'),
	(3080, '4677', 6, 'diamond_painting41', 4, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(3081, '4678', 6, 'diamond_painting32', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(3082, '4679', 6, 'diamond_painting38', 4, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(3083, '4680', 6, 'diamond_painting34', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(3084, '4681', 6, 'celestial_c19_wall', 4, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(3085, '4682', 6, 'celestial_c19_constellations', 4, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(3086, '4683', 6, 'hween_c19_mistywoodsbg', 4, 0, 0, 1, 0, 0, 6, 21590, 0, '', '1', '0'),
	(3087, '4684', 6, 'china_pstr11', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(3088, '4685', 6, 'year2020', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(3089, '4686', 6, 'art_c20_wall', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(3090, '4687', 6, 'art_c20_window', 4, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(3091, '4688', 6, 'india_c20_sunsetbg', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(3092, '4689', 6, 'diamond_painting52', 4, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(3093, '4690', 6, 'diamond_painting42', 4, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(3094, '4691', 560, 'diamond_painting46', 4, 0, 0, 1, 0, 0, 28, -1, 0, '', '1', '0'),
	(3095, '4692', 261, 'diamond_painting51', 7, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(3096, '4693', 6, 'diamond_painting44', 4, 0, 0, 1, 0, 0, 26, -1, 0, '', '1', '0'),
	(3097, '4694', 6, 'diamond_painting45', 10, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(3098, '4695', 36, 'diamond_painting43', 4, 0, 0, 1, 0, 0, 31, -1, 0, '', '1', '0'),
	(3099, '4696', 551, 'party_nt_neon4', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3100, '4697', 223, 'rela_nt_wall', 20, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(3101, '4698', 271, 'party_nt_led', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(3102, '4699', 223, 'usva_nt_wallrug', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(3103, '4700', 223, 'lt_nt_jngl_wall', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(3104, '4701', 738, 'cine_nt_light1', 5, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(3105, '4702', 738, 'val09_nt_wdrobe_g', 5, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(3106, '4703', 503, 'party_nt_shelf', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(3107, '4704', 503, 'window_nt_skyscraper', 4, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(3108, '4705', 503, 'window_nt_diner2', 4, 0, 0, 1, 0, 0, 30, -1, 0, '', '1', '0'),
	(3109, '4706', 503, 'cubie_nt_decal_2_p', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(3110, '4707', 503, 'cubie_nt_decal_1_p', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(3111, '4708', 503, 'hween_c20_floorwallb', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(3112, '4709', 503, 'xmas_c20_forestbg', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(3113, '4710', 503, 'poster_duck', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(3114, '4711', 503, 'pixelduck_wall', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(3115, '4712', 503, 'year2021', 4, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(3116, '4713', 503, 'diamond_painting55', 4, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(3117, '4714', 503, 'diamond_painting58', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(3118, '4715', 503, 'diamond_painting61', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(3119, '4716', 503, 'diamond_painting57', 4, 0, 0, 1, 0, 0, 31, -1, 0, '', '1', '0'),
	(3120, '4717', 737, 'diamond_painting63', 5, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(3121, '4718', 503, 'diamond_painting56', 4, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(3122, '4719', 503, 'diamond_painting53', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(3123, '4720', 503, 'thai_c21_tropicalbg', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(3124, '4721', 503, 'vwave_c21_sunsetbg', 4, 0, 0, 1, 0, 0, 3, 25842, 0, '', '1', '0'),
	(3125, '4722', 503, 'vwave_c21_glitchsunsetbg', 4, 0, 0, 1, 0, 0, 7, 25842, 0, '', '1', '0'),
	(3126, '4723', 851, 'hween_c21_mistymountainbg', 5, 0, 0, 1, 0, 2, 11, -1, 0, '', '1', '0'),
	(3127, '4724', 851, 'xmas_c21_winterrailbg', 5, 0, 0, 1, 0, 0, 32, -1, 0, '', '1', '0'),
	(3128, '4725', 503, 'year2022', 4, 0, 0, 1, 0, 0, 29, -1, 0, '', '1', '0'),
	(3129, '4726', 503, 'diamond_painting74', 4, 0, 0, 1, 0, 0, 10, 24681, 0, '', '1', '0'),
	(3130, '4727', 738, 'diamond_painting67', 5, 0, 0, 1, 0, 0, 16, 24755, 0, '', '1', '0'),
	(3131, '4728', 503, 'diamond_painting64', 4, 0, 0, 1, 0, 0, 22, 24756, 0, '', '1', '0'),
	(3132, '4729', 393, 'diamond_painting65', 4, 0, 0, 1, 0, 0, 2, 24757, 0, '', '1', '0'),
	(3133, '4730', 393, 'diamond_painting66', 4, 0, 0, 1, 0, 0, 7, 24758, 0, '', '1', '0'),
	(3134, '4731', 393, 'diamond_painting68', 4, 0, 0, 1, 0, 0, 19, 24759, 0, '', '1', '0'),
	(3135, '4732', 393, 'diamond_painting71', 4, 0, 0, 1, 0, 0, 13, 24760, 0, '', '1', '0'),
	(3136, '4733', 393, 'diamond_painting73', 4, 0, 0, 1, 0, 0, 14, 24761, 0, '', '1', '0'),
	(3137, '4734', 393, 'flag_ukraine', 4, 0, 0, 1, 0, 0, -1, 25466, 0, '', '1', '0'),
	(3138, '4735', 393, 'hween12_costume_hopper', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(3139, '4736', 393, 'hween12_track_crl', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(3140, '4737', 393, 'hween12_shedskin', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(3141, '4738', 772, 'hween12_guillotine', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(3142, '4739', 393, 'hween12_track_crr', 4, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(3143, '4740', 393, 'hween12_moon', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(3144, '4741', 393, 'hween12_coffin', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(3145, '4742', 393, 'hween12_lantern', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(3146, '4743', 393, 'hween12_mirror', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(3147, '4744', 393, 'cannon', 4, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(3148, '4745', 393, 'hween12_duck', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(3149, '4746', 393, 'hween12_floor', 2, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(3150, '4747', 393, 'hween12_wall', 4, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(3151, '4748', 393, 'costume_gate', 4, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(3152, '4749', 393, 'hween12_fortune', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(3153, '4750', 393, 'hween12_cage', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(3154, '4751', 393, 'hween12_grabby', 10, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(3155, '4752', 393, 'hween12_wolf', 4, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(3156, '4753', 393, 'hween12_strengthtest', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(3157, '4754', 74, 'hs_stage_blue', 4, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(3158, '4755', 74, 'hs_smoke', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(3159, '4756', 74, 'hs_carpet', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(3160, '4757', 74, 'hs_circstage', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(3161, '4758', 74, 'hs_stage_black', 4, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(3162, '4759', 74, 'hs_stage_pink', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(3163, '4760', 74, 'hs_prop', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(3164, '4761', 74, 'hs_dnctile_1', 1, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(3165, '4762', 74, 'hs_lightstrip_pink', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(3166, '4763', 74, 'hs_stage_long_black', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(3167, '4764', 74, 'hs_carpet_blk', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(3168, '4765', 74, 'hs_stage_long_blue', 4, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(3169, '4766', 74, 'hs_stairs_pink', 4, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(3170, '4767', 74, 'hs_stage_long_pink', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(3171, '4768', 74, 'hs_bpass', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(3172, '4769', 74, 'hs_stairs_blue', 4, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(3173, '4770', 74, 'hs_stairs_black', 4, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(3174, '4771', 74, 'hs_lightstrip_blue', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(3175, '4772', 74, 'hs_marswalk', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(3176, '4773', 74, 'hs_balcony', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(3177, '4774', 74, 'hs_box', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(3178, '4775', 74, 'hs_chair', 2, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(3179, '4776', 421, 'sfx_xylo', 4, 0, 0, 1, 0, 0, 23, 11785, 0, '', '1', '0'),
	(3180, '4777', 421, 'sfx_dubstep3_2', 4, 0, 0, 1, 0, 0, 8, 11786, 0, '', '1', '0'),
	(3181, '4778', 421, 'sfx_dubstep3', 4, 0, 0, 1, 0, 0, 7, 11787, 0, '', '1', '0'),
	(3182, '4779', 421, 'sfx_xylo_high', 4, 0, 0, 1, 0, 0, 16, 11788, 0, '', '1', '0'),
	(3183, '4780', 421, 'sfx_bigfinish_jamesbrown', 4, 0, 0, 1, 0, 0, 85, -1, 0, '', '1', '0'),
	(3184, '4781', 421, 'sfx_funkhorn', 4, 0, 0, 1, 0, 0, 10, 11790, 0, '', '1', '0'),
	(3185, '4782', 421, 'sfx_dubstep1', 4, 0, 0, 1, 0, 0, 5, 11791, 0, '', '1', '0'),
	(3186, '4783', 421, 'sfx_xylo2', 4, 0, 0, 1, 0, 0, 24, 11792, 0, '', '1', '0'),
	(3187, '4784', 421, 'sfx_dubstep2', 4, 0, 0, 1, 0, 0, 6, 11793, 0, '', '1', '0'),
	(3188, '4785', 421, 'sfx_highhatintro', 4, 0, 0, 1, 0, 0, 11, 11794, 0, '', '1', '0'),
	(3189, '4786', 421, 'sfx_jamesbrown_hey', 4, 0, 0, 1, 0, 0, 86, -1, 0, '', '1', '0'),
	(3190, '4787', 421, 'sfx_drumloop', 4, 0, 0, 1, 0, 0, 4, 11796, 0, '', '1', '0'),
	(3191, '4788', 421, 'sfx_pad3', 4, 0, 0, 1, 0, 0, 17, 11797, 0, '', '1', '0'),
	(3192, '4789', 421, 'sfx_xylopattern', 4, 0, 0, 1, 0, 0, 25, 11798, 0, '', '1', '0'),
	(3193, '4790', 421, 'sfx_pad1', 4, 0, 0, 1, 0, 0, 13, 11799, 0, '', '1', '0'),
	(3194, '4791', 421, 'sfx_pad2', 4, 0, 0, 1, 0, 0, 14, 11800, 0, '', '1', '0'),
	(3195, '4792', 46, 'sound_set_77', 4, 0, 0, 1, 0, 0, 87, -1, 0, '', '1', '0'),
	(3196, '4793', 46, 'sound_set_78', 4, 0, 0, 1, 0, 0, 88, -1, 0, '', '1', '0'),
	(3197, '4794', 851, 'dia_uplink', 5, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3198, '4795', 851, 'dia_podium', 5, 0, 0, 1, 0, 0, 31, -1, 0, '', '1', '0'),
	(3199, '4796', 278, 'pet_breeding_bear', 15, 0, 0, 1, 0, 0, 99, -1, 0, '0', '1', '0'),
	(3200, '4797', 683, 'mystery_box', 3, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(3201, '4798', 421, 'sfx_strange_echoes_2', 4, 0, 0, 1, 0, 0, 20, 11809, 0, '', '1', '0'),
	(3202, '4799', 421, 'sfx_bass1', 4, 0, 0, 1, 0, 0, 1, 11810, 0, '', '1', '0'),
	(3203, '4800', 421, 'sfx_sqrpad_dbldotted', 4, 0, 0, 1, 0, 0, 18, 11811, 0, '', '1', '0'),
	(3204, '4801', 421, 'sfx_bass_dbl', 3, 0, 0, 1, 0, 0, 2, 11812, 0, '', '1', '0'),
	(3205, '4802', 421, 'sfx_strange_echoes_1', 4, 0, 0, 1, 0, 0, 19, 11813, 0, '', '1', '0'),
	(3206, '4803', 421, 'sfx_strange_echoes_3', 4, 0, 0, 1, 0, 0, 21, 11814, 0, '', '1', '0'),
	(3207, '4804', 481, 'xmas12_floortile', 2, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(3208, '4805', 481, 'xmas12_bardesk', 5, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(3209, '4806', 481, 'xmas12_pork', 4, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(3210, '4807', 481, 'xmas12_nutcracker', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(3211, '4808', 481, 'xmas12_table', 5, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(3212, '4809', 738, 'xmas12_santathrone', 5, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(3213, '4810', 481, 'xmas12_npole', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(3214, '4811', 481, 'xmas12_chair', 2, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(3215, '4812', 481, 'xmas12_fireplace', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(3216, '4813', 481, 'xmas12_pillar2', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(3217, '4814', 481, 'xmas12_barrel', 10, 0, 0, 1, 0, 0, 3, 24152, 0, '', '1', '0'),
	(3218, '4815', 481, 'xmas12_pillar1', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(3219, '4816', 481, 'xmas12_pillar3', 4, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(3220, '4817', 481, 'xmas12_snack', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(3221, '4818', 481, 'xmas12_floortile2', 2, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(3222, '4819', 481, 'xmas12_cfloor', 1, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(3223, '4820', 738, 'xmas12_worktable', 5, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(3224, '4821', 481, 'xmas12_cfloorbig', 2, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(3225, '4822', 481, 'roombg_aurora', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(3226, '4823', 115, 'pet_toy_ball', 2, 0, 0, 1, 0, 0, 12, 11854, 0, '', '1', '0'),
	(3227, '4824', 115, 'pet_waterbottle', 2, 0, 0, 1, 0, 0, 11, 11855, 0, '', '1', '0'),
	(3228, '4825', 278, 'pet_breeding_terrier', 15, 0, 0, 1, 0, 0, 99, -1, 0, '0', '1', '0'),
	(3229, '4826', 115, 'pet_blanket_pink', 2, 0, 0, 1, 0, 0, 10, 11857, 0, '', '1', '0'),
	(3230, '4827', 115, 'pet_basket_blue', 2, 0, 0, 1, 0, 0, 10, 11858, 0, '', '1', '0'),
	(3231, '4828', 115, 'pet_basket_pink', 2, 0, 0, 1, 0, 0, 9, 11859, 0, '', '1', '0'),
	(3232, '4829', 115, 'pet_blanket_blue', 2, 0, 0, 1, 0, 0, 8, 11860, 0, '', '1', '0'),
	(3233, '4830', 212, 'mnstr_compost', 4, 0, 0, 1, 0, 0, 43, -1, 0, '', '1', '0'),
	(3234, '4831', 683, 'ny2013_res', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(3235, '4832', 683, 'ny2013_extrares', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(3236, '4833', 851, 'holo_dragon', 5, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(3237, '4834', 64, 'wf_act_call_stacks', 10, 0, 0, 1, 0, 0, 10, 11865, 0, '', '1', '0'),
	(3238, '4835', 67, 'fireworks_15', 4, 0, 0, 1, 0, 0, 51, -1, 0, '', '1', '0'),
	(3239, '4836', 67, 'ny2013_chair', 2, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(3240, '4837', 67, 'reef_aquarium', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(3241, '4838', 67, 'ny2013_calendar', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(3242, '4839', 67, 'ny2013_block', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(3243, '4840', 67, 'fireworks_14', 4, 0, 0, 1, 0, 0, 50, -1, 0, '', '1', '0'),
	(3244, '4841', 67, 'ny2013_aftermath', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(3245, '4842', 67, 'ny2013_floor', 2, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(3246, '4843', 67, 'ny2013_clock', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(3247, '4844', 67, 'ny2013_cup', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(3248, '4845', 229, 'hc_roundchair', 5, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '1'),
	(3249, '4846', 229, 'hc_bigvase', 5, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '1'),
	(3250, '4847', 229, 'hc_knight_1', 5, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '1'),
	(3251, '4848', 229, 'hc_roundtable', 5, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '1'),
	(3252, '4849', 229, 'hc_cab', 5, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '1'),
	(3253, '4850', 229, 'hc_radio', 5, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '1'),
	(3254, '4851', 229, 'hc_luggage', 5, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '1'),
	(3255, '4852', 739, 'rare_dragonlamp_pink', 5, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(3256, '4853', 739, 'pillow_silver', 5, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(3257, '4854', 739, 'pillow_bronze', 5, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(3258, '4855', 736, 'prizetrophy_cake*1', 8, 0, 0, 1, 0, 0, 40, -1, 0, '', '1', '0'),
	(3259, '4856', 736, 'prizetrophy_cake*2', 10, 0, 0, 1, 0, 0, 41, -1, 0, '', '1', '0'),
	(3260, '4857', 736, 'prizetrophy_cake*3', 12, 0, 0, 1, 0, 0, 42, -1, 0, '', '1', '0'),
	(3261, '4858', 302, 'china_snake', 4, 0, 0, 1, 0, 0, 30, -1, 0, '', '1', '0'),
	(3262, '4859', 852, 'rare_icecream*10', 5, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(3263, '4860', 450, 'val13_build_3', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(3264, '4861', 450, 'val13_gond_post', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(3265, '4862', 450, 'val13_gond_mid1', 4, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(3266, '4863', 450, 'val13_water', 4, 0, 0, 1, 0, 0, 31, -1, 0, '', '1', '0'),
	(3267, '4864', 450, 'val13_div_2', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(3268, '4865', 450, 'val13_gond_front', 4, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(3269, '4866', 450, 'val13_build_1', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(3270, '4867', 450, 'val13_build_2', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(3271, '4868', 450, 'val13_gond_back', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(3272, '4869', 450, 'val13_gond_mid2', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(3273, '4870', 450, 'val13_div_1', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(3274, '4871', 24, 'pixel_plantred', 4, 0, 0, 1, 0, 0, 47, 18020, 0, '', '1', '0'),
	(3275, '4872', 24, 'pixel_plantpink', 4, 0, 0, 1, 0, 0, 46, 17989, 0, '', '1', '0'),
	(3276, '4873', 24, 'pixel_light_red', 4, 0, 0, 1, 0, 0, 36, 18016, 0, '', '1', '0'),
	(3277, '4874', 24, 'pixel_plantblue', 4, 0, 0, 1, 0, 0, 44, 18040, 0, '', '1', '0'),
	(3278, '4875', 24, 'pixel_plantgreen', 4, 0, 0, 1, 0, 0, 45, 17974, 0, '', '1', '0'),
	(3279, '4876', 24, 'pixel_light_green', 4, 0, 0, 1, 0, 0, 34, 18017, 0, '', '1', '0'),
	(3280, '4877', 24, 'pixel_light_pink', 4, 0, 0, 1, 0, 0, 35, 17950, 0, '', '1', '0'),
	(3281, '4878', 24, 'pixel_plantblack', 4, 0, 0, 1, 0, 0, 43, -1, 0, '', '1', '0'),
	(3282, '4879', 24, 'pixel_light_blue', 4, 0, 0, 1, 0, 0, 33, 18013, 0, '', '1', '0'),
	(3283, '4880', 24, 'pixel_carpet_red', 4, 0, 0, 1, 0, 0, 10, 17988, 0, '', '1', '0'),
	(3284, '4881', 24, 'pixel_carpet_blue', 4, 0, 0, 1, 0, 0, 7, 18042, 0, '', '1', '0'),
	(3285, '4882', 24, 'pixel_carpet_pink', 4, 0, 0, 1, 0, 0, 9, 17961, 0, '', '1', '0'),
	(3286, '4883', 24, 'pixel_light_black', 4, 0, 0, 1, 0, 0, 32, -1, 0, '', '1', '0'),
	(3287, '4884', 24, 'pixel_carpet_black', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(3288, '4885', 240, 'valentines_lovelock', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(3289, '4886', 24, 'pixel_bed_blue', 4, 0, 0, 1, 0, 0, 2, 11949, 0, '', '1', '0'),
	(3290, '4887', 24, 'pixel_smalltable_blue', 2, 0, 0, 1, 0, 0, 50, 17970, 0, '', '1', '0'),
	(3291, '4888', 24, 'pixel_smalltable_red', 2, 0, 0, 1, 0, 0, 53, 17995, 0, '', '1', '0'),
	(3292, '4889', 24, 'pixel_smalltable_pink', 2, 0, 0, 1, 0, 0, 52, 18026, 0, '', '1', '0'),
	(3293, '4890', 24, 'pixel_smalltable_black', 2, 0, 0, 1, 0, 0, 49, -1, 0, '', '1', '0'),
	(3294, '4891', 24, 'pixel_smalltable_green', 2, 0, 0, 1, 0, 0, 51, 18057, 0, '', '1', '0'),
	(3295, '4892', 240, 'valentines_lovelock9', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(3296, '4893', 24, 'pixel_table_red', 5, 0, 0, 1, 0, 0, 58, 11969, 0, '', '1', '0'),
	(3297, '4894', 24, 'pixel_chair_blue', 2, 0, 0, 1, 0, 0, 12, 18032, 0, '', '1', '0'),
	(3298, '4895', 24, 'pixel_floor_pink', 2, 0, 0, 1, 0, 0, 29, 11971, 0, '', '1', '0'),
	(3299, '4896', 24, 'pixel_floor_brown', 2, 0, 0, 1, 0, 0, 27, 11972, 0, '', '1', '0'),
	(3300, '4897', 24, 'pixel_floor_yellow', 2, 0, 0, 1, 0, 0, 31, 11973, 0, '', '1', '0'),
	(3301, '4898', 24, 'pixel_bed_red', 4, 0, 0, 1, 0, 0, 5, 11974, 0, '', '1', '0'),
	(3302, '4899', 24, 'pixel_chair_green', 2, 0, 0, 1, 0, 0, 13, 17998, 0, '', '1', '0'),
	(3303, '4900', 24, 'pixel_table_black', 5, 0, 0, 1, 0, 0, 54, -1, 0, '', '1', '0'),
	(3304, '4901', 24, 'pixel_bed_black', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(3305, '4902', 24, 'pixel_table_blue', 5, 0, 0, 1, 0, 0, 55, 11978, 0, '', '1', '0'),
	(3306, '4903', 24, 'pixel_floor_green', 2, 0, 0, 1, 0, 0, 28, 11979, 0, '', '1', '0'),
	(3307, '4904', 24, 'pixel_floor_silver', 2, 0, 0, 1, 0, 0, 30, 11980, 0, '', '1', '0'),
	(3308, '4905', 24, 'pixel_table_pink', 5, 0, 0, 1, 0, 0, 57, 11981, 0, '', '1', '0'),
	(3309, '4906', 24, 'pixel_chair_pink', 2, 0, 0, 1, 0, 0, 14, 17965, 0, '', '1', '0'),
	(3310, '4907', 24, 'pixel_table_green', 5, 0, 0, 1, 0, 0, 56, 11983, 0, '', '1', '0'),
	(3311, '4908', 24, 'pixel_bed_pink', 4, 0, 0, 1, 0, 0, 4, 11984, 0, '', '1', '0'),
	(3312, '4909', 24, 'pixel_bed_green', 4, 0, 0, 1, 0, 0, 3, 11985, 0, '', '1', '0'),
	(3313, '4910', 24, 'pixel_chair_red', 2, 0, 0, 1, 0, 0, 15, 17945, 0, '', '1', '0'),
	(3314, '4911', 24, 'pixel_chair_black', 2, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(3315, '4912', 24, 'pixel_floor_blue', 2, 0, 0, 1, 0, 0, 26, 11988, 0, '', '1', '0'),
	(3316, '4913', 240, 'valentines_lovelock8', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(3317, '4914', 240, 'valentines_lovelock7', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(3318, '4915', 240, 'valentines_lovelock3', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(3319, '4916', 240, 'valentines_lovelock4', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(3320, '4917', 240, 'valentines_lovelock6', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(3321, '4918', 240, 'valentines_lovelock5', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(3322, '4919', 240, 'valentines_lovelock2', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(3323, '4920', 240, 'valentines_lovelock10', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(3324, '4921', 450, 'val13_div_3', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(3325, '4922', 450, 'val13_archway', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(3326, '4923', 450, 'val13_grass', 4, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(3327, '4924', 450, 'val13_pillar', 4, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(3328, '4925', 450, 'val13_floor1', 2, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(3329, '4926', 450, 'val13_gazebo', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(3330, '4927', 450, 'val13_div_3_crnr', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(3331, '4928', 450, 'val13_roses', 4, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(3332, '4929', 450, 'val13_table', 5, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(3333, '4930', 450, 'val13_lamp', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(3334, '4931', 450, 'val13_flower', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(3335, '4932', 450, 'val13_div_3_crnr2', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(3336, '4933', 450, 'val13_light', 4, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(3337, '4934', 450, 'val13_chair', 2, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(3338, '4935', 450, 'val13_shrub_circ', 4, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(3339, '4936', 450, 'val13_shrub_duck', 4, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(3340, '4937', 24, 'pixel_carpet_green', 4, 0, 0, 1, 0, 0, 8, 17979, 0, '', '1', '0'),
	(3341, '4938', 24, 'pixel_couch_blue', 4, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(3342, '4939', 739, 'val13_easel_4', 5, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(3343, '4940', 739, 'val13_easel_3', 5, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(3344, '4941', 739, 'val13_easel_1', 5, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(3345, '4942', 739, 'val13_easel_2', 5, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(3346, '4943', 739, 'val13_easel_5', 5, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(3347, '4944', 450, 'val13_statue', 4, 0, 0, 1, 0, 0, 26, -1, 0, '', '1', '0'),
	(3348, '4945', 307, 'CF_120_sapphire_small', 120, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(3349, '4946', 307, 'CF_240_sapphire', 240, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(3350, '4947', 64, 'wf_act_kick_user', 4, 0, 0, 1, 0, 0, 11, 12303, 0, '', '1', '0'),
	(3351, '4948', 70, 'steampunk_table_1', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3352, '4949', 70, 'steampunk_pillar_1', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3353, '4950', 70, 'steampunk_rack', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3354, '4951', 70, 'steampunk_pillar_2', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3355, '4952', 70, 'steampunk_chand', 4, 0, 0, 1, 0, 0, 17, 12309, 0, '', '1', '0'),
	(3356, '4953', 70, 'steampunk_floor1', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3357, '4954', 70, 'steampunk_sofachair', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3358, '4955', 70, 'steampunk_chair', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3359, '4956', 70, 'steampunk_tele', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3360, '4957', 70, 'steampunk_table_2', 5, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3361, '4958', 70, 'steampunk_gear_1', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3362, '4959', 70, 'steampunk_arch', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3363, '4960', 70, 'steampunk_lamp', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3364, '4961', 70, 'steampunk_computer', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3365, '4962', 70, 'steampunk_floor2', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3366, '4963', 70, 'steampunk_globe', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3367, '4964', 70, 'steampunk_gear_2', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3368, '4965', 70, 'steampunk_carpet', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3369, '4966', 70, 'steampunk_gramophone', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3370, '4967', 70, 'steampunk_timemach', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3371, '4968', 70, 'steampunk_zep', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3372, '4969', 243, 'horse_hairdye_17', 3, 0, 0, 1, 0, 0, 1, 17930, 0, '', '1', '0'),
	(3373, '4970', 243, 'horse_dye_17', 3, 0, 0, 1, 0, 0, 1, 17885, 0, '', '1', '0'),
	(3374, '4971', 243, 'horse_hairdye_15', 1, 0, 0, 1, 0, 0, 14, 12396, 0, '', '1', '0'),
	(3375, '4972', 243, 'horse_hairdye_14', 1, 0, 0, 1, 0, 0, 13, 12397, 0, '', '1', '0'),
	(3376, '4973', 243, 'horse_hairdye_13', 1, 0, 0, 1, 0, 0, 14, 17931, 0, '', '1', '0'),
	(3377, '4974', 243, 'horse_hairdye_16', 1, 0, 0, 1, 0, 0, 17, 12399, 0, '', '1', '0'),
	(3378, '4975', 380, 'easter13_flower_2', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(3379, '4976', 380, 'easter13_flower_1', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(3380, '4977', 380, 'easter13_arch', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(3381, '4978', 380, 'easter13_floor_1', 2, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(3382, '4979', 380, 'easter13_teleport', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(3383, '4980', 380, 'easter13_bulbs', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(3384, '4981', 380, 'easter13_stage_1', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(3385, '4982', 380, 'easter13_sshrooms', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(3386, '4983', 380, 'easter13_stage_2', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(3387, '4984', 380, 'easter13_flower_3', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(3388, '4985', 52, 'petfood29', 1, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(3389, '4986', 837, 'easter13_egg_0', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3390, '4987', 837, 'easter13_egg_3', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3391, '4988', 837, 'easter13_egg_1', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3392, '4989', 837, 'easter13_egg_2', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3393, '4990', 281, 'table_silo_med*10', 2, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(3394, '4991', 281, 'sofa_silo*10', 3, 0, 0, 1, 0, 0, 43, -1, 0, '', '1', '0'),
	(3395, '4992', 281, 'safe_silo*10', 10, 0, 0, 1, 0, 0, 103, -1, 0, '', '1', '0'),
	(3396, '4993', 281, 'sofachair_silo*10', 2, 0, 0, 1, 0, 0, 53, -1, 0, '', '1', '0'),
	(3397, '4994', 281, 'divider_silo3*10', 3, 0, 0, 1, 0, 0, 83, -1, 0, '', '1', '0'),
	(3398, '4995', 281, 'chair_silo*10', 2, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(3399, '4996', 281, 'barchair_silo*10', 2, 0, 0, 1, 0, 0, 93, -1, 0, '', '1', '0'),
	(3400, '4997', 281, 'divider_silo1*10', 3, 0, 0, 1, 0, 0, 73, -1, 0, '', '1', '0'),
	(3401, '4998', 281, 'table_silo_small*10', 2, 0, 0, 1, 0, 0, 63, -1, 0, '', '1', '0'),
	(3402, '4999', 380, 'easter13_globe', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(3403, '5000', 839, 'easter13_stonefrank', 4, 0, 0, 1, 0, 0, 89, -1, 0, '', '1', '0'),
	(3404, '5001', 380, 'duck_scuba', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3405, '5002', 380, 'duck_afro', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3406, '5003', 380, 'duck_frank', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3407, '5004', 839, 'penguin_frank', 4, 0, 0, 1, 0, 0, 53, -1, 0, '', '1', '0'),
	(3408, '5005', 839, 'penguin_tribal', 4, 0, 0, 1, 0, 0, 52, -1, 0, '', '1', '0'),
	(3409, '5006', 839, 'easter13_stonehead', 4, 0, 0, 1, 0, 0, 92, -1, 0, '', '1', '0'),
	(3410, '5007', 380, 'duck_zombie', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3411, '5008', 839, 'penguin_wip', 4, 0, 0, 1, 0, 0, 51, -1, 0, '', '1', '0'),
	(3412, '5009', 839, 'easter13_sub', 4, 0, 0, 1, 0, 0, 94, -1, 0, '', '1', '0'),
	(3413, '5010', 839, 'penguin_skele', 4, 0, 0, 1, 0, 0, 50, -1, 0, '', '1', '0'),
	(3414, '5011', 739, 'easter13_dinoegg', 5, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(3415, '5012', 380, 'easter13_chair', 2, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(3416, '5013', 25, 'badge_display2', 5, 0, 0, 1, 0, 0, 3, 12463, 0, '', '1', '0'),
	(3417, '5014', 25, 'badge_display', 4, 0, 0, 1, 0, 0, 2, 12464, 0, '', '1', '1'),
	(3418, '5015', 25, 'badge_display4', 4, 0, 0, 1, 0, 0, 5, 12466, 0, '', '1', '0'),
	(3419, '5016', 25, 'badge_display3', 4, 0, 0, 1, 0, 0, 1, 12467, 0, '', '1', '0'),
	(3420, '5017', 25, 'badge_display5', 4, 0, 0, 1, 0, 0, 4, 12471, 0, '', '1', '0'),
	(3421, '5018', 856, 'exe_icecream', 5, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(3422, '5019', 736, 'prizetrophy_hockey*1', 12, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(3423, '5020', 736, 'prizetrophy_hockey*2', 10, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(3424, '5021', 736, 'prizetrophy_hockey*3', 8, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(3425, '5022', 736, 'prizetrophy_football*1', 12, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(3426, '5023', 736, 'prizetrophy_football*2', 10, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(3427, '5024', 736, 'prizetrophy_football*3', 8, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(3428, '5025', 736, 'prizetrophy_freeze*1', 12, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(3429, '5026', 736, 'prizetrophy_freeze*2', 10, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(3430, '5027', 736, 'prizetrophy_freeze*3', 8, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(3431, '5028', 736, 'prizetrophy_bb*1', 12, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(3432, '5029', 736, 'prizetrophy_bb*2', 10, 0, 0, 1, 0, 0, 26, -1, 0, '', '1', '0'),
	(3433, '5030', 736, 'prizetrophy_bb*3', 8, 0, 0, 1, 0, 0, 27, -1, 0, '', '1', '0'),
	(3434, '5031', 736, 'prizetrophy_snow*1', 12, 0, 0, 1, 0, 0, 28, -1, 0, '', '1', '0'),
	(3435, '5032', 736, 'prizetrophy_snow*2', 10, 0, 0, 1, 0, 0, 29, -1, 0, '', '1', '0'),
	(3436, '5033', 736, 'prizetrophy_snow*3', 8, 0, 0, 1, 0, 0, 30, -1, 0, '', '1', '0'),
	(3437, '5034', 736, 'prizetrophy_roller*1', 12, 0, 0, 1, 0, 0, 31, -1, 0, '', '1', '0'),
	(3438, '5035', 736, 'prizetrophy_roller*2', 10, 0, 0, 1, 0, 0, 32, -1, 0, '', '1', '0'),
	(3439, '5036', 736, 'prizetrophy_roller*3', 8, 0, 0, 1, 0, 0, 33, -1, 0, '', '1', '0'),
	(3440, '5037', 108, 'gld_hangflag2', 5, 0, 0, 1, 0, 0, 12, 12501, 0, '', '1', '0'),
	(3441, '5038', 108, 'gld_tile2', 3, 0, 0, 1, 0, 0, 19, 12502, 0, '', '1', '0'),
	(3442, '5039', 108, 'gld_hangflag1', 5, 0, 0, 1, 0, 0, 11, 12503, 0, '', '1', '0'),
	(3443, '5040', 108, 'gld_tile1', 5, 0, 0, 1, 0, 0, 18, 12504, 0, '', '1', '0'),
	(3444, '5041', 108, 'gld_table1', 5, 0, 0, 1, 0, 0, 17, 12505, 0, '', '1', '0'),
	(3445, '5042', 63, 'wf_trg_period_long', 7, 0, 0, 1, 0, 0, 11, 12506, 0, '', '1', '0'),
	(3446, '5043', 64, 'wf_act_give_score_tm', 10, 0, 0, 1, 0, 0, 12, 12507, 0, '', '1', '0'),
	(3447, '5044', 256, 'highscore_classic*1', 7, 0, 0, 1, 0, 0, 1, 12508, 0, '', '1', '0'),
	(3448, '5045', 256, 'highscore_classic*2', 7, 0, 0, 1, 0, 0, 2, 12509, 0, '', '1', '0'),
	(3449, '5046', 256, 'highscore_classic*3', 7, 0, 0, 1, 0, 0, 3, 12510, 0, '', '1', '0'),
	(3450, '5047', 256, 'highscore_classic*4', 7, 0, 0, 1, 0, 0, 4, 12511, 0, '', '1', '0'),
	(3451, '5048', 64, 'wf_act_move_to_dir', 7, 0, 0, 1, 0, 0, 13, 12512, 0, '', '1', '0'),
	(3452, '5049', 64, 'wf_act_leave_team', 7, 0, 0, 1, 0, 0, 14, 12513, 0, '', '1', '0'),
	(3453, '5050', 63, 'wf_trg_collision', 7, 0, 0, 1, 0, 0, 12, 12514, 0, '', '1', '0'),
	(3454, '5051', 256, 'highscore_perteam*1', 7, 0, 0, 1, 0, 0, 9, 12515, 0, '', '1', '0'),
	(3455, '5052', 256, 'highscore_perteam*2', 7, 0, 0, 1, 0, 0, 10, 12516, 0, '', '1', '0'),
	(3456, '5053', 256, 'highscore_perteam*3', 7, 0, 0, 1, 0, 0, 10, 12517, 0, '', '1', '0'),
	(3457, '5054', 256, 'highscore_perteam*4', 7, 0, 0, 1, 0, 0, 11, 12518, 0, '', '1', '0'),
	(3458, '5055', 64, 'wf_act_chase', 7, 0, 0, 1, 0, 0, 15, 12519, 0, '', '1', '0'),
	(3459, '5056', 65, 'wf_cnd_actor_in_team', 5, 0, 0, 1, 0, 0, 8, 12520, 0, '', '1', '0'),
	(3460, '5057', 256, 'highscore_mostwin*1', 7, 0, 0, 1, 0, 0, 5, 12521, 0, '', '1', '0'),
	(3461, '5058', 256, 'highscore_mostwin*2', 7, 0, 0, 1, 0, 0, 6, 12522, 0, '', '1', '0'),
	(3462, '5059', 256, 'highscore_mostwin*3', 7, 0, 0, 1, 0, 0, 7, 12523, 0, '', '1', '0'),
	(3463, '5060', 256, 'highscore_mostwin*4', 7, 0, 0, 1, 0, 0, 8, 12524, 0, '', '1', '0'),
	(3464, '5061', 64, 'wf_act_flee', 7, 0, 0, 1, 0, 0, 16, 12525, 0, '', '1', '0'),
	(3465, '5062', 64, 'wf_act_join_team', 7, 0, 0, 1, 0, 0, 17, 12526, 0, '', '1', '0'),
	(3466, '5063', 739, 'arcade_cab', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(3467, '5064', 852, 'bb_tddhead_rc1', 5, 0, 0, 1, 0, 0, 97, -1, 0, '', '1', '0'),
	(3468, '5065', 852, 'bb_robo_rc1', 5, 0, 0, 1, 0, 0, 98, -1, 0, '', '1', '0'),
	(3469, '5066', 852, 'bb_apparatus_rc1', 5, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3470, '5067', 211, 'wf_blob', 4, 0, 0, 1, 0, 0, 19, 12531, 0, '', '1', '0'),
	(3471, '5068', 211, 'wf_blob2', 4, 0, 0, 1, 0, 0, 20, 12532, 0, '', '1', '0'),
	(3472, '5069', 122, 'loyalty_toad', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3473, '5070', 122, 'statue_dragon', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3474, '5071', 122, 'statue_griffin', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3475, '5072', 122, 'loyalty_mouse', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3476, '5073', 122, 'statue_elk', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3477, '5074', 62, 'mystics_gstool', 4, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(3478, '5075', 62, 'mystics_bspike2', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(3479, '5076', 62, 'mystics_bbench', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(3480, '5077', 62, 'mystics_gblock1', 4, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(3481, '5078', 62, 'mystics_bfloor', 2, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(3482, '5079', 62, 'mystics_bstool', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(3483, '5080', 62, 'mystics_gbench', 4, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(3484, '5081', 62, 'mystics_garch', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(3485, '5082', 62, 'mystics_gblock2', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(3486, '5083', 62, 'mystics_gfloor', 2, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(3487, '5084', 62, 'mystics_barch', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(3488, '5085', 62, 'mystics_gtile1', 1, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(3489, '5086', 62, 'mystics_bbed', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(3490, '5087', 62, 'mystics_btile2', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(3491, '5088', 62, 'mystics_bspike1', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(3492, '5089', 62, 'mystics_btile1', 1, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(3493, '5090', 62, 'mystics_btable', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(3494, '5091', 62, 'mystics_gtable', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(3495, '5092', 62, 'mystics_gbed', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(3496, '5093', 62, 'mystics_gtree', 4, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(3497, '5094', 255, 'wf_cnd_wearing_badge', 7, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(3498, '5095', 255, 'wf_cnd_wearing_effect', 7, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(3499, '5096', 852, 'mystics_gthrone', 5, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(3500, '5097', 852, 'mystics_bthrone', 5, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(3501, '5098', 122, 'mystics_ltstatue', 4, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(3502, '5099', 821, 'mystics_crystal_s', 3, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(3503, '5100', 821, 'mystics_crystal_m', 3, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(3504, '5101', 725, 'mystics_duck', 4, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(3505, '5102', 817, 'mystics_crystal_l', 4, 0, 0, 1, 0, 0, 27, -1, 0, '', '1', '0'),
	(3506, '5103', 215, 'tile_stackmagic', 4, 0, 0, 1, 0, 0, 1, 17911, 0, '', '1', '0'),
	(3507, '5104', 739, 'mystics_rfountain', 5, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(3508, '5105', 739, 'mystics_rpillar', 5, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(3509, '5106', 739, 'holo_nelly', 5, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(3511, '5108', 43, 'diner_bardesk_corner*10', 5, 0, 0, 1, 0, 0, 39, -1, 0, '', '1', '0'),
	(3512, '5109', 43, 'diner_bardesk_gate*10', 5, 0, 0, 1, 0, 0, 49, -1, 0, '', '1', '0'),
	(3513, '5110', 43, 'diner_sofa_1*10', 4, 0, 0, 1, 0, 0, 89, -1, 0, '', '1', '0'),
	(3514, '5111', 43, 'diner_bardesk*10', 5, 0, 0, 1, 0, 0, 29, -1, 0, '', '1', '0'),
	(3515, '5112', 43, 'diner_table_1*10', 5, 0, 0, 1, 0, 0, 109, -1, 0, '', '1', '0'),
	(3516, '5113', 43, 'diner_gumvendor*10', 4, 0, 0, 1, 0, 0, 79, -1, 0, '', '1', '0'),
	(3517, '5114', 43, 'diner_sofa_2*10', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3518, '5115', 43, 'diner_table_2*10', 4, 0, 0, 1, 0, 0, 119, -1, 0, '', '1', '0'),
	(3519, '5116', 43, 'diner_chair*10', 2, 0, 0, 1, 0, 0, 69, -1, 0, '', '1', '0'),
	(3520, '5117', 43, 'diner_cashreg*10', 4, 0, 0, 1, 0, 0, 59, -1, 0, '', '1', '0'),
	(3521, '5118', 122, 'loyalty_dolphin', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3522, '5119', 535, 'ads_clearasil_tile1', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3523, '5120', 535, 'ads_clearasil_vend', 4, 0, 0, 1, 0, 0, 31, -1, 0, '', '1', '0'),
	(3524, '5121', 269, 'tent_orange', 10, 0, 0, 1, 0, 0, 7, 12619, 0, '', '1', '0'),
	(3525, '5122', 269, 'hblooza_bbq', 2, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(3526, '5123', 269, 'foldabletable_camo', 1, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(3527, '5124', 269, 'foldabletable_beige', 1, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(3528, '5125', 269, 'hblooza_icecream', 10, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(3529, '5126', 269, 'hblooza_stage2*1', 4, 0, 0, 1, 0, 0, 42, -1, 0, '', '1', '0'),
	(3530, '5127', 269, 'hblooza_stage2*2', 4, 0, 0, 1, 0, 0, 43, -1, 0, '', '1', '0'),
	(3531, '5128', 269, 'hblooza_stage2*3', 4, 0, 0, 1, 0, 0, 44, -1, 0, '', '1', '0'),
	(3532, '5129', 269, 'hblooza_stage2*4', 4, 0, 0, 1, 0, 0, 45, -1, 0, '', '1', '0'),
	(3533, '5130', 269, 'hblooza_popcorn', 4, 0, 0, 1, 0, 0, 26, -1, 0, '', '1', '0'),
	(3534, '5131', 269, 'hblooza_dirtfloor', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(3535, '5132', 269, 'hblooza_tfnc_1', 4, 0, 0, 1, 0, 0, 46, -1, 0, '', '1', '0'),
	(3536, '5133', 269, 'tent_beige', 10, 0, 0, 1, 0, 0, 4, 17829, 0, '', '1', '0'),
	(3537, '5134', 269, 'hblooza_spacerent3x4', 4, 0, 0, 1, 0, 0, 211, -1, 0, '', '1', '0'),
	(3538, '5135', 269, 'hblooza_sfnc_crnr*1', 4, 0, 0, 1, 0, 0, 34, -1, 0, '', '1', '0'),
	(3539, '5136', 269, 'hblooza_sfnc_crnr*2', 4, 0, 0, 1, 0, 0, 35, -1, 0, '', '1', '0'),
	(3540, '5137', 269, 'hblooza_sfnc_crnr*3', 4, 0, 0, 1, 0, 0, 36, -1, 0, '', '1', '0'),
	(3541, '5138', 269, 'hblooza_sfnc_crnr*4', 4, 0, 0, 1, 0, 0, 37, -1, 0, '', '1', '0'),
	(3542, '5139', 269, 'hblooza_stage1*1', 4, 0, 0, 1, 0, 0, 38, -1, 0, '', '1', '0'),
	(3543, '5140', 269, 'hblooza_stage1*2', 4, 0, 0, 1, 0, 0, 39, -1, 0, '', '1', '0'),
	(3544, '5141', 269, 'hblooza_stage1*3', 4, 0, 0, 1, 0, 0, 40, -1, 0, '', '1', '0'),
	(3545, '5142', 269, 'hblooza_stage1*4', 4, 0, 0, 1, 0, 0, 41, -1, 0, '', '1', '0'),
	(3546, '5143', 269, 'tent_camo', 10, 0, 0, 1, 0, 0, 5, 17822, 0, '', '1', '0'),
	(3547, '5144', 269, 'hblooza_fnc_crnr', 4, 0, 0, 1, 0, 0, 28, -1, 0, '', '1', '0'),
	(3548, '5145', 269, 'hblooza_bubblejuice', 4, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(3549, '5146', 269, 'hblooza_tfnc_2*1', 4, 0, 0, 1, 0, 0, 47, -1, 0, '', '1', '0'),
	(3550, '5147', 269, 'hblooza_tfnc_2*2', 4, 0, 0, 1, 0, 0, 48, -1, 0, '', '1', '0'),
	(3551, '5148', 269, 'hblooza_tfnc_2*3', 4, 0, 0, 1, 0, 0, 49, -1, 0, '', '1', '0'),
	(3552, '5149', 269, 'hblooza_tfnc_2*4', 4, 0, 0, 1, 0, 0, 50, -1, 0, '', '1', '0'),
	(3553, '5150', 269, 'hblooza_pillar1', 4, 0, 0, 1, 0, 0, 29, -1, 0, '', '1', '0'),
	(3554, '5151', 269, 'bigtent_beige', 15, 0, 0, 1, 0, 0, 2, 17937, 0, '', '1', '0'),
	(3555, '5152', 269, 'foldablechair_camo', 1, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(3556, '5153', 269, 'hblooza_candyfloss', 10, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(3557, '5154', 269, 'hblooza_fnc', 4, 0, 0, 1, 0, 0, 27, -1, 0, '', '1', '0'),
	(3558, '5155', 269, 'hblooza_spacerent6x6', 4, 0, 0, 1, 0, 0, 213, -1, 0, '', '1', '0'),
	(3559, '5156', 269, 'hblooza_hotdog', 4, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(3560, '5157', 269, 'bigtent_camo', 15, 0, 0, 1, 0, 0, 3, 17862, 0, '', '1', '0'),
	(3561, '5158', 269, 'hblooza_sfnc*1', 4, 0, 0, 1, 0, 0, 30, -1, 0, '', '1', '0'),
	(3562, '5159', 269, 'hblooza_sfnc*2', 4, 0, 0, 1, 0, 0, 31, -1, 0, '', '1', '0'),
	(3563, '5160', 269, 'hblooza_sfnc*3', 4, 0, 0, 1, 0, 0, 32, -1, 0, '', '1', '0'),
	(3564, '5161', 269, 'hblooza_sfnc*4', 4, 0, 0, 1, 0, 0, 33, -1, 0, '', '1', '0'),
	(3565, '5162', 269, 'foldablechair_beige', 1, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(3566, '5163', 269, 'tent_blue', 10, 0, 0, 1, 0, 0, 6, 12664, 0, '', '1', '0'),
	(3567, '5164', 739, 'hblooza_kiosk', 5, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(3568, '5165', 269, 'hblooza_tgate*1', 4, 0, 0, 1, 0, 0, 51, -1, 0, '', '1', '0'),
	(3569, '5166', 269, 'hblooza_tgate*2', 4, 0, 0, 1, 0, 0, 52, -1, 0, '', '1', '0'),
	(3570, '5167', 269, 'hblooza_tgate*3', 4, 0, 0, 1, 0, 0, 53, -1, 0, '', '1', '0'),
	(3571, '5168', 269, 'hblooza_tgate*4', 4, 0, 0, 1, 0, 0, 54, -1, 0, '', '1', '0'),
	(3572, '5169', 269, 'hblooza_chicken', 10, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(3573, '5170', 269, 'hblooza_sign', 4, 0, 0, 1, 0, 0, 60, -1, 0, '', '1', '0'),
	(3574, '5171', 269, 'hblooza_spacerent7x7', 4, 0, 0, 1, 0, 0, 214, -1, 0, '', '1', '0'),
	(3575, '5172', 269, 'hblooza_spacerent5x5', 4, 0, 0, 1, 0, 0, 212, -1, 0, '', '1', '0'),
	(3576, '5173', 109, 'yttv3', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(3577, '5174', 109, 'yttv2', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(3578, '5175', 109, 'yttv1', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(3579, '5176', 109, 'yttv2b', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(3580, '5177', 736, 'prizetrophy_hblooza*1', 12, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(3581, '5178', 736, 'prizetrophy_hblooza*2', 10, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(3582, '5179', 736, 'prizetrophy_hblooza*3', 8, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(3583, '5180', 215, 'tile_stackmagic1', 6, 0, 0, 1, 0, 0, 2, 12690, 0, '', '1', '0'),
	(3584, '5181', 215, 'tile_stackmagic2', 8, 0, 0, 1, 0, 0, 3, 12691, 0, '', '1', '0'),
	(3585, '5182', 266, 'hblooza_guitar3', 4, 0, 0, 1, 0, 0, 59, -1, 0, '', '1', '0'),
	(3586, '5183', 266, 'hblooza_guitar1', 4, 0, 0, 1, 0, 0, 57, -1, 0, '', '1', '0'),
	(3587, '5184', 266, 'hblooza_guitar11', 4, 0, 0, 1, 0, 0, 31, -1, 0, '', '1', '0'),
	(3588, '5185', 266, 'hblooza_guitar7', 4, 0, 0, 1, 0, 0, 63, -1, 0, '', '1', '0'),
	(3589, '5186', 266, 'hblooza_guitar9', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(3590, '5187', 266, 'hblooza_guitar8', 4, 0, 0, 1, 0, 0, 64, -1, 0, '', '1', '0'),
	(3591, '5188', 266, 'hblooza_guitar6', 4, 0, 0, 1, 0, 0, 30, -1, 0, '', '1', '0'),
	(3592, '5189', 266, 'hblooza_guitar10', 4, 0, 0, 1, 0, 0, 66, -1, 0, '', '1', '0'),
	(3593, '5190', 266, 'hblooza_guitar5', 4, 0, 0, 1, 0, 0, 29, -1, 0, '', '1', '0'),
	(3594, '5191', 266, 'hblooza_guitar4', 4, 0, 0, 1, 0, 0, 60, -1, 0, '', '1', '0'),
	(3595, '5192', 266, 'hblooza_guitar2', 4, 0, 0, 1, 0, 0, 58, -1, 0, '', '1', '0'),
	(3596, '5193', 600, 'hblooza_pinata2', 25, 0, 0, 1, 0, 0, 40, -1, 0, '', '1', '0'),
	(3597, '5194', 600, 'hblooza_pinata1', 12, 0, 0, 1, 0, 0, 39, -1, 0, '', '1', '0'),
	(3598, '5195', 547, 'ads_vpiggy_flag', 4, 0, 0, 1, 0, 0, 40, -1, 0, '', '1', '0'),
	(3599, '5196', 547, 'ads_vpiggy_pig', 4, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(3600, '5197', 708, 'pirate_bottle_1', 4, 0, 0, 1, 0, 0, 71, -1, 0, '', '1', '0'),
	(3601, '5198', 708, 'pirate_dvdr3', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(3602, '5199', 708, 'pirate_bottle_3', 4, 0, 0, 1, 0, 0, 73, -1, 0, '', '1', '0'),
	(3603, '5200', 708, 'pirate_bottle_2', 4, 0, 0, 1, 0, 0, 72, -1, 0, '', '1', '0'),
	(3604, '5201', 708, 'pirate_chest1', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(3605, '5202', 708, 'pirate_barrel1', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(3606, '5203', 708, 'pirate_cannonballs', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(3607, '5204', 708, 'pirate_mast2', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(3608, '5205', 108, 'pirate_mast2grp', 6, 0, 0, 1, 0, 0, 21, 12719, 0, '', '1', '0'),
	(3609, '5206', 708, 'pirate_bottle_8', 4, 0, 0, 1, 0, 0, 78, -1, 0, '', '1', '0'),
	(3610, '5207', 708, 'pirate_bottle_7', 4, 0, 0, 1, 0, 0, 77, -1, 0, '', '1', '0'),
	(3611, '5208', 708, 'pirate_dvdr2', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(3612, '5209', 708, 'pirate_crate', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(3613, '5210', 708, 'pirate_parrot', 4, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(3614, '5211', 108, 'pirate_mast3grp', 6, 0, 0, 1, 0, 0, 22, 12725, 0, '', '1', '0'),
	(3615, '5212', 708, 'pirate_swordrack', 4, 0, 0, 1, 0, 0, 30, -1, 0, '', '1', '0'),
	(3616, '5213', 708, 'pirate_bottle_10', 4, 0, 0, 1, 0, 0, 80, -1, 0, '', '1', '0'),
	(3617, '5214', 708, 'pirate_gate', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(3618, '5215', 708, 'pirate_side1', 4, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(3619, '5216', 708, 'pirate_roombg', 4, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(3620, '5217', 708, 'pirate_stage3', 4, 0, 0, 1, 0, 0, 28, -1, 0, '', '1', '0'),
	(3621, '5218', 708, 'pirate_bottle_4', 4, 0, 0, 1, 0, 0, 74, -1, 0, '', '1', '0'),
	(3622, '5219', 708, 'pirate_bottle_9', 4, 0, 0, 1, 0, 0, 79, -1, 0, '', '1', '0'),
	(3623, '5220', 708, 'pirate_stage2', 4, 0, 0, 1, 0, 0, 27, -1, 0, '', '1', '0'),
	(3624, '5221', 708, 'pirate_mast1', 4, 0, 0, 1, 0, 0, 16, 24152, 0, '', '1', '0'),
	(3625, '5222', 708, 'pirate_cannon', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(3626, '5223', 708, 'pirate_stairs', 4, 0, 0, 1, 0, 0, 29, -1, 0, '', '1', '0'),
	(3627, '5224', 269, 'spacerent_room', 4, 0, 0, 1, 0, 0, 210, -1, 0, '', '1', '0'),
	(3628, '5225', 108, 'pirate_mast4grp', 6, 0, 0, 1, 0, 0, 23, 12739, 0, '', '1', '0'),
	(3629, '5226', 708, 'pirate_grate', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(3630, '5227', 708, 'ship_wheel', 4, 0, 0, 1, 0, 0, 32, -1, 0, '', '1', '0'),
	(3631, '5228', 708, 'pirate_bottle_6', 4, 0, 0, 1, 0, 0, 76, -1, 0, '', '1', '0'),
	(3632, '5229', 708, 'pirate_mast3', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(3633, '5230', 708, 'pirate_stage', 4, 0, 0, 1, 0, 0, 26, -1, 0, '', '1', '0'),
	(3634, '5231', 708, 'pirate_bottle_5', 4, 0, 0, 1, 0, 0, 75, -1, 0, '', '1', '0'),
	(3635, '5232', 708, 'pirate_flag', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(3636, '5233', 708, 'pirate_barrel2', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(3637, '5234', 708, 'pirate_plank', 4, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(3638, '5235', 708, 'pirate_anchor', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(3639, '5236', 708, 'pirate_gunrack', 4, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(3640, '5237', 708, 'pirate_sandtrap', 4, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(3641, '5238', 708, 'pirate_barrel3', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(3642, '5239', 708, 'pirate_mast4', 4, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(3643, '5240', 708, 'pirate_dvdr1', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(3644, '5241', 708, 'pirate_teleport', 4, 0, 0, 1, 0, 0, 31, -1, 0, '', '1', '0'),
	(3645, '5242', 708, 'pirate_poseidon', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3646, '5243', 708, 'pirate_kraken', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3647, '5244', 708, 'pirate_navdesk', 5, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(3648, '5245', 709, 'pirate_dvdr1_g', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(3649, '5246', 709, 'pirate_stage_g', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(3650, '5247', 709, 'pirate_stage3_g', 3, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(3651, '5248', 709, 'pirate_stairs_g', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(3652, '5249', 709, 'pirate_plank_g', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(3653, '5250', 709, 'pirate_flag_g', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(3654, '5251', 709, 'pirate_mast_g', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(3655, '5252', 709, 'pirate_gate_g', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(3656, '5253', 709, 'pirate_stage2_g', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(3657, '5254', 709, 'ship_wheel_g', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(3658, '5255', 709, 'pirate_dvdr3_g', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(3659, '5256', 709, 'pirate_dvdr2_g', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(3660, '5257;59970', 852, 'school_chairgold', 5, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(3661, '5258', 467, 'school_coatrack_g', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(3662, '5259', 467, 'school_locker_g_notele', 4, 0, 0, 1, 0, 0, 26, -1, 0, '', '1', '0'),
	(3663, '5260', 467, 'school_coatrack_b', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(3664, '5261', 467, 'school_locker_b_notele', 4, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(3665, '5262', 467, 'school_chair_b', 2, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(3666, '5263', 467, 'school_locker_g', 4, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(3667, '5264;59970', 852, 'school_consolegold', 5, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(3668, '5265', 467, 'school_chair_g', 2, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(3669, '5266', 467, 'school_fountain', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(3670, '5267', 467, 'school_locker_r_notele', 4, 0, 0, 1, 0, 0, 29, -1, 0, '', '1', '0'),
	(3671, '5268', 467, 'school_console_g', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(3672, '5269', 467, 'school_console_b', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(3673, '5270', 467, 'school_coatrack_r', 4, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(3674, '5271;59971', 467, 'school_gate', 4, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(3675, '5272', 467, 'school_cafe', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(3676, '5273', 764, 'grungelamp', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(3677, '5274', 535, 'ads_clearasil_vend2', 4, 0, 0, 1, 0, 0, 32, -1, 0, '', '1', '0'),
	(3678, '5275', 739, 'golden_apple', 5, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(3679, '5276', 467, 'trophy_display', 4, 0, 0, 1, 0, 0, 43, -1, 0, '', '1', '0'),
	(3680, '5277', 394, 'hween13_sheep', 4, 0, 0, 1, 0, 0, 30, -1, 0, '', '1', '0'),
	(3681, '5278', 394, 'hween13_rose', 4, 0, 0, 1, 0, 0, 29, -1, 0, '', '1', '0'),
	(3682, '5279', 394, 'hween13_book', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(3683, '5280', 394, 'hween13_castleturret3', 4, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(3684, '5281', 394, 'hween13_castleturret1', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(3685, '5282', 394, 'hween13_castleturret2', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(3686, '5283', 394, 'hween13_castleblock2', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(3687, '5284', 394, 'hween13_bridgeend', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(3688, '5285', 394, 'hween13_thorndiv2', 4, 0, 0, 1, 0, 0, 37, -1, 0, '', '1', '0'),
	(3689, '5286', 394, 'hween13_thorndiv1', 4, 0, 0, 1, 0, 0, 36, 21590, 0, '', '1', '0'),
	(3690, '5287', 394, 'hween13_gutsfloor', 1, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(3691, '5288', 394, 'hween13_grass', 4, 0, 0, 1, 0, 0, 23, 21590, 0, '', '1', '0'),
	(3692, '5289', 394, 'hween13_castlespike', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(3693, '5290', 394, 'hween13_castleblock1', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(3694, '5291', 394, 'hween13_floor2', 2, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(3695, '5292', 394, 'hween13_roombg', 4, 0, 0, 1, 0, 0, 28, -1, 0, '', '1', '0'),
	(3696, '5293', 394, 'hween13_bridgemid', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(3697, '5294', 394, 'hween13_fence_1', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(3698, '5295', 394, 'hween13_stage_s', 4, 0, 0, 1, 0, 0, 32, -1, 0, '', '1', '0'),
	(3699, '5296', 394, 'hween13_crnr_1', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(3700, '5297', 394, 'hween13_cardtable', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(3701, '5298', 394, 'hween13_gate_1', 4, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(3702, '5299', 394, 'hween13_tree', 4, 0, 0, 1, 0, 0, 41, -1, 0, '', '1', '0'),
	(3703, '5300', 772, 'hween13_bldtrail', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(3704, '5301', 394, 'hween13_teacup', 4, 0, 0, 1, 0, 0, 33, -1, 0, '', '1', '0'),
	(3705, '5302', 394, 'hween13_tile1', 1, 0, 0, 1, 0, 0, 39, -1, 0, '', '1', '0'),
	(3706, '5303', 394, 'hween13_stage_l', 4, 0, 0, 1, 0, 0, 31, -1, 0, '', '1', '0'),
	(3707, '5304', 394, 'hween13_tele', 4, 0, 0, 1, 0, 0, 35, -1, 0, '', '1', '0'),
	(3708, '5305', 394, 'hween13_chair', 2, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(3709, '5306', 394, 'hween13_tile2', 1, 0, 0, 1, 0, 0, 40, -1, 0, '', '1', '0'),
	(3710, '5307', 394, 'hween13_mirror', 4, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(3711, '5308', 394, 'hween13_candle', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(3712, '5309', 394, 'hween13_piglamp', 4, 0, 0, 1, 0, 0, 27, -1, 0, '', '1', '0'),
	(3713, '5310', 394, 'hween13_castlegarg', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(3714, '5311', 394, 'hween13_castledoor', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(3715, '5312', 394, 'hween13_teaset', 4, 0, 0, 1, 0, 0, 34, -1, 0, '', '1', '0'),
	(3716, '5313', 394, 'hween13_dwarfdiv', 4, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(3717, '5314', 394, 'hween13_dwarfcrn', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(3718, '5315', 255, 'info_terminal', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(3719, '5316', 429, 'button_green', 4, 0, 0, 1, 0, 0, 117, -1, 0, '', '1', '0'),
	(3720, '5317', 394, 'hween13_bed', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(3721, '5318', 122, 'loyalty_pig', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3722, '5319', 394, 'hween13_monsterpea', 4, 0, 0, 1, 0, 0, 26, -1, 0, '', '1', '0'),
	(3723, '5320', 739, 'hween13_sheepdemon', 5, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(3724, '5321', 394, 'hween13_throne', 4, 0, 0, 1, 0, 0, 38, -1, 0, '', '1', '0'),
	(3725, '5322', 109, 'yttv2n', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(3726, '5323', 280, 'cine_teleport4', 4, 0, 0, 1, 0, 0, 29, -1, 0, '', '1', '0'),
	(3727, '5324', 280, 'cine_starchair', 2, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(3728, '5325', 280, 'cine_pillarlight', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(3729, '5326', 280, 'cine_teleport2', 4, 0, 0, 1, 0, 0, 27, -1, 0, '', '1', '0'),
	(3730, '5327', 280, 'cine_bigcorn', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(3731, '5328', 280, 'cine_teleport1', 4, 0, 0, 1, 0, 0, 26, -1, 0, '', '1', '0'),
	(3732, '5329', 280, 'cine_soda', 4, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(3733, '5330', 280, 'cine_teleport3', 4, 0, 0, 1, 0, 0, 28, -1, 0, '', '1', '0'),
	(3734, '5331', 538, 'ads_dtlrare', 4, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(3735, '5332', 429, 'mystics_crystal', 4, 0, 0, 1, 0, 0, 119, -1, 0, '', '1', '0'),
	(3736, '5333', 421, 'sfx_taperec_breakbeat', 4, 0, 0, 1, 0, 0, 120, -1, 0, '', '1', '0'),
	(3737, '5334', 421, 'sfx_taperec', 4, 0, 0, 1, 0, 0, 121, -1, 0, '', '1', '0'),
	(3738, '5335', 421, 'sfx_taperec_bassline', 4, 0, 0, 1, 0, 0, 122, -1, 0, '', '1', '0'),
	(3739, '5336', 46, 'sound_set_79', 4, 0, 0, 1, 0, 0, 123, -1, 0, '', '1', '0'),
	(3740, '5337', 429, 'background_color', 4, 0, 0, 1, 0, 0, 124, -1, 0, '', '1', '0'),
	(3741, '5338', 24, 'pixel_couch_pink', 4, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(3742, '5339', 24, 'pixel_couch_green', 4, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(3743, '5340', 24, 'pixel_couch_black', 4, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(3744, '5341', 24, 'pixel_couch_red', 4, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(3745, '5342', 483, 'xmas13_block2', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(3746, '5343', 483, 'xmas13_snowflake10', 4, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(3747, '5344', 483, 'xmas13_snowflake2', 4, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(3748, '5345', 483, 'xmas13_table', 4, 0, 0, 1, 0, 0, 33, -1, 0, '', '1', '0'),
	(3749, '5346', 483, 'xmas13_snowflake5', 4, 0, 0, 1, 0, 0, 28, -1, 0, '', '1', '0'),
	(3750, '5347', 483, 'xmas13_snack', 4, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(3751, '5348', 483, 'xmas13_snowflake9', 4, 0, 0, 1, 0, 0, 32, -1, 0, '', '1', '0'),
	(3752, '5349', 483, 'xmas13_snowflake3', 4, 0, 0, 1, 0, 0, 26, -1, 0, '', '1', '0'),
	(3753, '5350', 483, 'xmas13_block1', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(3754, '5351', 483, 'xmas13_snowflake6', 4, 0, 0, 1, 0, 0, 29, -1, 0, '', '1', '0'),
	(3755, '5352', 483, 'xmas13_snowflake1', 4, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(3756, '5353', 483, 'xmas13_snowflake7', 4, 0, 0, 1, 0, 0, 30, -1, 0, '', '1', '0'),
	(3757, '5354', 483, 'xmas13_snowflake4', 4, 0, 0, 1, 0, 0, 27, -1, 0, '', '1', '0'),
	(3758, '5355', 483, 'xmas13_snowflake8', 4, 0, 0, 1, 0, 0, 31, -1, 0, '', '1', '0'),
	(3759, '5356', 483, 'xmas13_chair', 2, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(3760, '5357', 483, 'xmas13_floor', 2, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(3761, '5358', 455, 'js_bling_chair_w', 2, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(3762, '5359', 455, 'js_bling_bed', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(3763, '5360', 503, 'js_chandelier', 4, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(3764, '5361', 455, 'js_bling11_seat1', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(3765, '5362', 455, 'js_bling_fridge', 10, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(3766, '5363', 455, 'js_bling11_seat2', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(3767, '5364', 455, 'js_bling11_sofa', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(3768, '5365', 455, 'js_bling11_dvn', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(3769, '5366', 369, 'lidotower', 4, 0, 0, 1, 0, 0, 125, -1, 0, '', '1', '0'),
	(3770, '5367', 429, 'test_tent', 4, 0, 0, 1, 0, 0, 126, -1, 0, '', '1', '0'),
	(3771, '5368', 429, 'test_cnd_not_stuff_is', 4, 0, 0, 1, 0, 0, 127, -1, 0, '', '0', '0'),
	(3772, '5369', 429, 'test_cnd_not_furni_on', 4, 0, 0, 1, 0, 0, 128, -1, 0, '', '0', '0'),
	(3773, '5370', 429, 'info_terminal_test', 4, 0, 0, 1, 0, 0, 129, -1, 0, '', '0', '0'),
	(3774, '5371', 429, 'talking_fridge', 4, 0, 0, 1, 0, 0, 130, -1, 0, '', '0', '0'),
	(3775, '5372', 429, 'telescopetest', 4, 0, 0, 1, 0, 0, 131, -1, 0, '', '0', '0'),
	(3776, '5373', 429, 'test_spacerent', 4, 0, 0, 1, 0, 0, 132, -1, 0, '', '0', '0'),
	(3777, '5374', 429, 'guild_customized', 4, 0, 0, 1, 0, 0, 133, -1, 0, '', '0', '0'),
	(3778, '5375', 429, 'test_effectswitch', 4, 0, 0, 1, 0, 0, 134, -1, 0, '', '0', '0'),
	(3779, '5376', 429, 'test_cnd_not_hv_avtrs', 4, 0, 0, 1, 0, 0, 135, -1, 0, '', '0', '0'),
	(3780, '5377', 429, 'vimeo_cubie', 4, 0, 0, 1, 0, 0, 136, -1, 0, '', '0', '0'),
	(3781, '5378', 429, 'vote_majority', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(3782, '5379', 429, 'test_cnd_not_in_group', 4, 0, 0, 1, 0, 0, 137, -1, 0, '', '0', '0'),
	(3783, '5380', 109, 'ytprojector', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3784, '5381', 429, 'test_cnd_not_match_snap', 4, 0, 0, 1, 0, 0, 138, -1, 0, '', '0', '0'),
	(3785, '5382', 429, 'testbot', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(3786, '5383', 429, 'ach_resolution_test', 4, 0, 0, 1, 0, 0, 139, -1, 0, '', '0', '0'),
	(3787, '5384', 429, 'test_bigtent', 4, 0, 0, 1, 0, 0, 140, -1, 0, '', '0', '0'),
	(3788, '5385', 429, 'test_cnd_not_in_team', 4, 0, 0, 1, 0, 0, 141, -1, 0, '', '0', '0'),
	(3789, '5386', 429, 'icecream_stand', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(3790, '5387', 429, 'test_candyfloss', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(3791, '5388', 429, 'test_cnd_not_wearing_b', 4, 0, 0, 1, 0, 0, 142, -1, 0, '', '0', '0'),
	(3792, '5389', 429, 'shallow_test', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(3793, '5390', 429, 'test_cnd_not_wearing_f', 4, 0, 0, 1, 0, 0, 143, -1, 0, '', '0', '0'),
	(3794, '5391', 429, 'test_builder_placeholder', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3795, '5392', 429, 'test_cnd_not_trggrer_on', 4, 0, 0, 1, 0, 0, 144, -1, 0, '', '0', '0'),
	(3796, '5393', 429, 'change_state_on_step', 4, 0, 0, 1, 0, 0, 145, -1, 0, '', '0', '0'),
	(3797, '5394', 429, 'test_highscore*1', 4, 0, 0, 1, 0, 0, 146, -1, 0, '', '0', '0'),
	(3798, '5395', 429, 'test_highscore*2', 4, 0, 0, 1, 0, 0, 147, -1, 0, '', '0', '0'),
	(3799, '5396', 429, 'test_highscore*3', 4, 0, 0, 1, 0, 0, 148, -1, 0, '', '0', '0'),
	(3800, '5397', 429, 'test_highscore*4', 4, 0, 0, 1, 0, 0, 149, -1, 0, '', '0', '0'),
	(3801, '5398', 429, 'testtubetv2', 4, 0, 0, 1, 0, 0, 150, -1, 0, '', '0', '0'),
	(3802, '5399', 429, 'vimeo_test', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3803, '5400', 429, 'action_link_furni_test', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3804, '5401', 429, 'test_highscore_wins*1', 4, 0, 0, 1, 0, 0, 151, -1, 0, '', '0', '0'),
	(3805, '5402', 429, 'test_highscore_wins*2', 4, 0, 0, 1, 0, 0, 152, -1, 0, '', '0', '0'),
	(3806, '5403', 429, 'test_highscore_wins*3', 4, 0, 0, 1, 0, 0, 153, -1, 0, '', '0', '0'),
	(3807, '5404', 429, 'test_highscore_wins*4', 4, 0, 0, 1, 0, 0, 154, -1, 0, '', '0', '0'),
	(3808, '5405', 429, 'cr_tree_basic_01', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3809, '5406', 429, 'handitem_tester', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(3810, '5407', 429, 'random_tele_1', 4, 0, 0, 1, 0, 0, 155, -1, 0, '', '0', '0'),
	(3811, '5408', 429, 'builder_exp', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(3812, '5409', 429, 'cameraproto', 4, 0, 0, 1, 0, 0, 156, -1, 0, '', '0', '0'),
	(3813, '5410', 429, 'test_shipside', 4, 0, 0, 1, 0, 0, 157, -1, 0, '', '0', '0'),
	(3814, '5411', 429, 'lovelock_test', 4, 0, 0, 1, 0, 0, 158, -1, 0, '', '0', '0'),
	(3815, '5412', 429, 'testing_crackable', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3816, '5413', 429, 'royal_sofa', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(3817, '5414', 429, 'test_ltd_handitem', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(3818, '5415', 429, 'testing_yt', 4, 0, 0, 1, 0, 0, 159, -1, 0, '', '0', '0'),
	(3819, '5416', 429, 'vote_machine', 4, 0, 0, 1, 0, 0, 160, -1, 0, '', '0', '0'),
	(3820, '5417', 429, 'badge_display_case', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3821, '5418', 429, 'testtubetv1', 4, 0, 0, 1, 0, 0, 161, -1, 0, '', '0', '0'),
	(3822, '5419', 429, 'royal_chair', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(3823, '5420', 429, 'random_tele_2', 4, 0, 0, 1, 0, 0, 162, -1, 0, '', '0', '0'),
	(3824, '5421', 429, 'statestoragetesting*1', 4, 0, 0, 1, 0, 0, 163, -1, 0, '', '0', '0'),
	(3825, '5422', 429, 'statestoragetesting*2', 4, 0, 0, 1, 0, 0, 164, -1, 0, '', '0', '0'),
	(3826, '5423', 429, 'statestoragetesting*3', 4, 0, 0, 1, 0, 0, 165, -1, 0, '', '0', '0'),
	(3827, '5424', 429, 'statestoragetesting*4', 4, 0, 0, 1, 0, 0, 166, -1, 0, '', '0', '0'),
	(3828, '5425', 429, 'statestoragetesting*5', 4, 0, 0, 1, 0, 0, 167, -1, 0, '', '0', '0'),
	(3829, '5426', 429, 'statestoragetesting*6', 4, 0, 0, 1, 0, 0, 168, -1, 0, '', '0', '0'),
	(3830, '5427', 429, 'statestoragetesting*7', 4, 0, 0, 1, 0, 0, 169, -1, 0, '', '0', '0'),
	(3831, '5428', 429, 'statestoragetesting*8', 4, 0, 0, 1, 0, 0, 170, -1, 0, '', '0', '0'),
	(3832, '5429', 429, 'statestoragetesting*9', 4, 0, 0, 1, 0, 0, 171, -1, 0, '', '0', '0'),
	(3833, '5430', 429, 'test_cnd_not_user_count', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(3834, '5431', 429, 'soundblock', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(3835, '5432', 429, 'testing_rentablespace', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3836, '5433', 429, 'test_festhotdog', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(3837, '5434', 429, 'random_teleport', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(3838, '5435', 429, 'soundblock_breakbeat', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(3839, '5436', 429, 'stackable_water', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(3841, '5438', 65, 'wf_cnd_not_trggrer_on', 5, 0, 0, 1, 0, 0, 9, 13119, 0, '', '1', '0'),
	(3842, '5439', 65, 'wf_cnd_not_in_team', 5, 0, 0, 1, 0, 0, 10, 13120, 0, '', '1', '0'),
	(3843, '5440', 65, 'wf_cnd_not_furni_on', 5, 0, 0, 1, 0, 0, 11, 13121, 0, '', '1', '0'),
	(3844, '5441', 65, 'wf_cnd_not_hv_avtrs', 5, 0, 0, 1, 0, 0, 12, 13122, 0, '', '1', '0'),
	(3845, '5442', 63, 'wf_trg_at_time_long', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(3846, '5443', 65, 'wf_cnd_not_user_count', 5, 0, 0, 1, 0, 0, 13, 13124, 0, '', '1', '0'),
	(3847, '5444', 255, 'wf_cnd_not_wearing_fx', 7, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(3848, '5445', 65, 'wf_cnd_user_count_in', 5, 0, 0, 1, 0, 0, 14, 13126, 0, '', '1', '0'),
	(3849, '5446', 255, 'wf_cnd_not_wearing_b', 7, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(3850, '5447', 65, 'wf_cnd_stuff_is', 5, 0, 0, 1, 0, 0, 15, 13128, 0, '', '1', '0'),
	(3851, '5448', 65, 'wf_cnd_not_in_group', 5, 0, 0, 1, 0, 0, 16, 13129, 0, '', '1', '0'),
	(3852, '5449', 65, 'wf_cnd_not_stuff_is', 5, 0, 0, 1, 0, 0, 17, 13130, 0, '', '1', '0'),
	(3853, '5450', 64, 'wf_act_move_furni_to', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(3854, '5451', 429, 'wf_act_toggle_to_rnd', 4, 0, 0, 1, 0, 0, 175, -1, 0, '', '0', '0'),
	(3855, '5452', 65, 'wf_cnd_not_match_snap', 5, 0, 0, 1, 0, 0, 18, 13133, 0, '', '1', '0'),
	(3858, '5455', 683, 'white_dino_egg', 5, 0, 0, 1, 0, 0, 178, -1, 0, '', '1', '0'),
	(3860, '5457', 215, 'hole4', 4, 25, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(3861, '5458', 429, 'hole1x1test', 4, 0, 0, 1, 0, 0, 181, -1, 0, '', '0', '0'),
	(3862, '5459', 429, 'teleport_random', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3863, '5460', 429, 'teleport_random_2', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3864, '5461', 307, 'CF_5000_suitcase', 5000, 0, 0, 1, 0, 0, 36, -1, 0, '', '1', '0'),
	(3865, '5462', 139, 'bc_block_0*1', 2, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(3866, '5463', 139, 'bc_block_0*10', 2, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(3867, '5464', 139, 'bc_block_0*11', 2, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(3868, '5465', 139, 'bc_block_0*12', 2, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(3869, '5466', 139, 'bc_block_0*13', 2, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(3870, '5467', 139, 'bc_block_0*14', 2, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(3871, '5468', 139, 'bc_block_0*2', 2, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(3872, '5469', 139, 'bc_block_0*3', 2, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(3873, '5470', 139, 'bc_block_0*4', 2, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(3874, '5471', 139, 'bc_block_0*5', 2, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(3875, '5472', 139, 'bc_block_0*6', 2, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(3876, '5473', 139, 'bc_block_0*7', 2, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(3877, '5474', 139, 'bc_block_0*8', 2, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(3878, '5475', 139, 'bc_block_0*9', 2, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(3879, '5476', 140, 'bc_block_1*1', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3880, '5477', 140, 'bc_block_1*10', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3881, '5478', 140, 'bc_block_1*11', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3882, '5479', 140, 'bc_block_1*12', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3883, '5480', 140, 'bc_block_1*13', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3884, '5481', 140, 'bc_block_1*14', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3885, '5482', 140, 'bc_block_1*2', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3886, '5483', 140, 'bc_block_1*3', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3887, '5484', 140, 'bc_block_1*4', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3888, '5485', 140, 'bc_block_1*5', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3889, '5486', 140, 'bc_block_1*6', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3890, '5487', 140, 'bc_block_1*7', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3891, '5488', 140, 'bc_block_1*8', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3892, '5489', 140, 'bc_block_1*9', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3893, '5490', 483, 'xmas13_rug', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(3894, '5491', 483, 'xmas13_shelves', 4, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(3895, '5492', 483, 'xmas13_pillar', 4, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(3896, '5493', 483, 'xmas13_toyhorse', 4, 0, 0, 1, 0, 0, 41, -1, 0, '', '1', '0'),
	(3897, '5494', 483, 'xmas13_tools1', 4, 0, 0, 1, 0, 0, 36, -1, 0, '', '1', '0'),
	(3898, '5495', 483, 'xmas13_paintsplat1', 4, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(3899, '5496', 483, 'xmas13_gingerbread', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(3900, '5497', 483, 'xmas13_light', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(3901, '5498', 483, 'xmas13_candycane1', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(3902, '5499', 483, 'xmas13_paintsplat3', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(3903, '5500', 483, 'xmas13_paintsplat4', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(3904, '5501', 483, 'xmas13_paintsplat2', 4, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(3905, '5502', 483, 'xmas13_candycane2', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(3906, '5503', 483, 'xmas13_bucket1', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(3907, '5504', 483, 'xmas13_toyblock2', 4, 0, 0, 1, 0, 0, 38, -1, 0, '', '1', '0'),
	(3908, '5505', 483, 'xmas13_toyblock4', 4, 0, 0, 1, 0, 0, 40, -1, 0, '', '1', '0'),
	(3909, '5506', 483, 'xmas13_toyblock3', 4, 0, 0, 1, 0, 0, 39, -1, 0, '', '1', '0'),
	(3910, '5507', 483, 'xmas13_toyblock1', 4, 0, 0, 1, 0, 0, 37, -1, 0, '', '1', '0'),
	(3911, '5508', 354, 'hc_exe_seccam', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '1'),
	(3912, '5509', 354, 'hc_exe_wrkdesk', 5, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '1'),
	(3913, '5510', 354, 'hc_exe_glassdvdr', 5, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '1'),
	(3914, '5511', 354, 'hc_exe_sofa', 5, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '1'),
	(3915, '5512', 354, 'hc_exe_s_table', 5, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '1'),
	(3916, '5513', 354, 'hc_exe_light', 5, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '1'),
	(3917, '5514', 354, 'hc_exe_chair2', 5, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '1'),
	(3918, '5515', 354, 'hc_exe_table', 5, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '1'),
	(3919, '5516', 354, 'hc_exe_chair', 5, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '1'),
	(3920, '5517', 354, 'hc_exe_elevator', 5, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '1'),
	(3921, '5518', 354, 'hc_exe_cubelight', 5, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '1'),
	(3922, '5519', 683, 'mutearea_sign', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(3923, '5520', 683, 'buildarea_sign', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(3924, '5521', 483, 'xmas13_mincepies', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(3925, '5522', 483, 'xmas13_eggnogbowl', 10, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(3926, '5523', 483, 'xmas13_eggnogglass', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(3927, '5524', 483, 'xmas13_machine1', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(3928, '5525', 483, 'xmas13_jack', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(3929, '5526', 740, 'xmas13_throne', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(3930, '5527', 483, 'xmas13_toolbox', 4, 0, 0, 1, 0, 0, 35, -1, 0, '', '1', '0'),
	(3931, '5528', 483, 'xmas13_workdesk', 5, 0, 0, 1, 0, 0, 42, -1, 0, '', '1', '0'),
	(3932, '5529', 852, 'xmas13_robotdino', 5, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(3933, '5530', 238, 'gnome_box', 25, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3934, '5531', 307, 'CF_750_duck', 750, 0, 0, 1, 0, 0, 26, -1, 0, '', '1', '0'),
	(3935, '5532', 307, 'CF_350_duck', 350, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(3936, '5533', 483, 'xmas13_terminal', 4, 0, 0, 1, 0, 0, 34, -1, 0, '', '1', '0'),
	(3937, '5534', 852, 'xmas13_icecream', 5, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(3938, '5535', 470, 'roombg_stars', 4, 0, 0, 1, 0, 0, -3, 21590, 0, '', '1', '0'),
	(3939, '5536', 470, 'roombg_city1', 4, 0, 0, 1, 0, 0, -1, -1, 0, '', '1', '0'),
	(3940, '5537', 470, 'roombg_city2', 4, 0, 0, 1, 0, 0, -2, -1, 0, '', '1', '0'),
	(3941, '5538', 853, 'rare_chinahorse', 4, 0, 0, 1, 0, 0, 60, -1, 0, '', '1', '0'),
	(3942, '5539', 146, 'bc_block_redbrick*1', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3943, '5540', 146, 'bc_block_redbrick*10', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3944, '5541', 146, 'bc_block_redbrick*11', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3945, '5542', 146, 'bc_block_redbrick*12', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3946, '5543', 146, 'bc_block_redbrick*13', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3947, '5544', 146, 'bc_block_redbrick*14', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3948, '5545', 146, 'bc_block_redbrick*2', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3949, '5546', 146, 'bc_block_redbrick*3', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3950, '5547', 146, 'bc_block_redbrick*4', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3951, '5548', 146, 'bc_block_redbrick*5', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3952, '5549', 146, 'bc_block_redbrick*6', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3953, '5550', 146, 'bc_block_redbrick*7', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3954, '5551', 146, 'bc_block_redbrick*8', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3955, '5552', 146, 'bc_block_redbrick*9', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3956, '5553', 150, 'bc_block_artdeco1*1', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3957, '5554', 150, 'bc_block_artdeco1*2', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3958, '5555', 150, 'bc_block_artdeco1*3', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3959, '5556', 150, 'bc_block_artdeco1*4', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3960, '5557', 150, 'bc_block_artdeco1*5', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3961, '5558', 151, 'bc_block_industrial*1', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3962, '5559', 151, 'bc_block_industrial*2', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3963, '5560', 151, 'bc_block_industrial*3', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3964, '5561', 151, 'bc_block_industrial*4', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3965, '5562', 151, 'bc_block_industrial*5', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3966, '5563', 148, 'bc_lavarock*1', 2, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(3967, '5564', 148, 'bc_lavarock*10', 2, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(3968, '5565', 148, 'bc_lavarock*11', 2, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(3969, '5566', 148, 'bc_lavarock*12', 2, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(3970, '5567', 148, 'bc_lavarock*13', 2, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(3971, '5568', 148, 'bc_lavarock*14', 2, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(3972, '5569', 148, 'bc_lavarock*2', 2, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(3973, '5570', 148, 'bc_lavarock*3', 2, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(3974, '5571', 148, 'bc_lavarock*4', 2, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(3975, '5572', 148, 'bc_lavarock*5', 2, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(3976, '5573', 148, 'bc_lavarock*6', 2, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(3977, '5574', 148, 'bc_lavarock*7', 2, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(3978, '5575', 148, 'bc_lavarock*8', 2, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(3979, '5576', 148, 'bc_lavarock*9', 2, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(3980, '5577', 153, 'bc_block_metalgrip*1', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3981, '5578', 153, 'bc_block_metalgrip*2', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3982, '5579', 153, 'bc_block_metalgrip*3', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3983, '5580', 153, 'bc_block_metalgrip*4', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3984, '5581', 153, 'bc_block_metalgrip*5', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3985, '5582', 157, 'bc_block_grass*1', 2, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(3986, '5583', 157, 'bc_block_grass*2', 2, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(3987, '5584', 157, 'bc_block_grass*3', 2, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(3988, '5585', 157, 'bc_block_grass*4', 2, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(3989, '5586', 157, 'bc_block_grass*5', 2, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(3990, '5587', 157, 'bc_block_grass*6', 2, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(3991, '5588', 157, 'bc_block_grass*7', 2, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(3992, '5589', 149, 'bc_block_marble*1', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3993, '5590', 149, 'bc_block_marble*10', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3994, '5591', 149, 'bc_block_marble*11', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3995, '5592', 149, 'bc_block_marble*12', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3996, '5593', 149, 'bc_block_marble*13', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3997, '5594', 149, 'bc_block_marble*14', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3998, '5595', 149, 'bc_block_marble*2', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(3999, '5596', 149, 'bc_block_marble*3', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4000, '5597', 149, 'bc_block_marble*4', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4001, '5598', 149, 'bc_block_marble*5', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4002, '5599', 149, 'bc_block_marble*6', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4003, '5600', 149, 'bc_block_marble*7', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4004, '5601', 149, 'bc_block_marble*8', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4005, '5602', 149, 'bc_block_marble*9', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4006, '5603', 152, 'bc_block_sand*1', 2, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(4007, '5604', 152, 'bc_block_sand*2', 2, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(4008, '5605', 152, 'bc_block_sand*3', 2, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(4009, '5606', 152, 'bc_block_sand*4', 2, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(4010, '5607', 152, 'bc_block_sand*5', 2, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(4011, '5608', 152, 'bc_block_sand*6', 2, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(4012, '5609', 152, 'bc_block_sand*7', 2, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(4013, '5610', 147, 'bc_block_glass*1', 2, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(4014, '5611', 147, 'bc_block_glass*10', 2, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(4015, '5612', 147, 'bc_block_glass*11', 2, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(4016, '5613', 147, 'bc_block_glass*12', 2, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(4017, '5614', 147, 'bc_block_glass*13', 2, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(4018, '5615', 147, 'bc_block_glass*14', 2, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(4019, '5616', 147, 'bc_block_glass*2', 2, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(4020, '5617', 147, 'bc_block_glass*3', 2, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(4021, '5618', 147, 'bc_block_glass*4', 2, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(4022, '5619', 147, 'bc_block_glass*5', 2, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(4023, '5620', 147, 'bc_block_glass*6', 2, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(4024, '5621', 147, 'bc_block_glass*7', 2, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(4025, '5622', 147, 'bc_block_glass*8', 2, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(4026, '5623', 147, 'bc_block_glass*9', 2, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(4027, '5624', 138, 'bc_round*1', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4028, '5625', 138, 'bc_round*10', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4029, '5626', 138, 'bc_round*11', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4030, '5627', 138, 'bc_round*12', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4031, '5628', 138, 'bc_round*13', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4032, '5629', 138, 'bc_round*14', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4033, '5630', 138, 'bc_round*2', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4034, '5631', 138, 'bc_round*3', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4035, '5632', 138, 'bc_round*4', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4036, '5633', 138, 'bc_round*5', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4037, '5634', 138, 'bc_round*6', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4038, '5635', 138, 'bc_round*7', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4039, '5636', 138, 'bc_round*8', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4040, '5637', 138, 'bc_round*9', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4041, '5638', 156, 'bc_block_wool*1', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4042, '5639', 156, 'bc_block_wool*10', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4043, '5640', 156, 'bc_block_wool*11', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4044, '5641', 156, 'bc_block_wool*12', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4045, '5642', 156, 'bc_block_wool*13', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4046, '5643', 156, 'bc_block_wool*14', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4047, '5644', 156, 'bc_block_wool*2', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4048, '5645', 156, 'bc_block_wool*3', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4049, '5646', 156, 'bc_block_wool*4', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4050, '5647', 156, 'bc_block_wool*5', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4051, '5648', 156, 'bc_block_wool*6', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4052, '5649', 156, 'bc_block_wool*7', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4053, '5650', 156, 'bc_block_wool*8', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4054, '5651', 156, 'bc_block_wool*9', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4055, '5652', 155, 'bc_stone*1', 2, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(4056, '5653', 155, 'bc_stone*10', 2, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(4057, '5654', 155, 'bc_stone*11', 2, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(4058, '5655', 155, 'bc_stone*12', 2, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(4059, '5656', 155, 'bc_stone*13', 2, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(4060, '5657', 155, 'bc_stone*14', 2, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(4061, '5658', 155, 'bc_stone*2', 2, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(4062, '5659', 155, 'bc_stone*3', 2, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(4063, '5660', 155, 'bc_stone*4', 2, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(4064, '5661', 155, 'bc_stone*5', 2, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(4065, '5662', 155, 'bc_stone*6', 2, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(4066, '5663', 155, 'bc_stone*7', 2, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(4067, '5664', 155, 'bc_stone*8', 2, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(4068, '5665', 155, 'bc_stone*9', 2, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(4069, '5666', 154, 'bc_metalcrate*1', 2, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(4070, '5667', 154, 'bc_metalcrate*10', 2, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(4071, '5668', 154, 'bc_metalcrate*11', 2, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(4072, '5669', 154, 'bc_metalcrate*12', 2, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(4073, '5670', 154, 'bc_metalcrate*13', 2, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(4074, '5671', 154, 'bc_metalcrate*14', 2, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(4075, '5672', 154, 'bc_metalcrate*2', 2, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(4076, '5673', 154, 'bc_metalcrate*3', 2, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(4077, '5674', 154, 'bc_metalcrate*4', 2, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(4078, '5675', 154, 'bc_metalcrate*5', 2, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(4079, '5676', 154, 'bc_metalcrate*6', 2, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(4080, '5677', 154, 'bc_metalcrate*7', 2, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(4081, '5678', 154, 'bc_metalcrate*8', 2, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(4082, '5679', 154, 'bc_metalcrate*9', 2, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(4083, '5680', 302, 'china_horse', 4, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(4084, '5681', 506, 'prizetrophy_storieshero', 6, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(4085, '5682', 312, 'book_rare*0', 10, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(4086, '5683', 312, 'book_rare*1', 10, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(4087, '5684', 312, 'book_rare*2', 10, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(4088, '5685', 312, 'book_rare*3', 10, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(4089, '5686', 312, 'book_rare*4', 10, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(4090, '5687', 312, 'book_rare*5', 10, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(4091, '5688', 312, 'book_rare*6', 10, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(4092, '5689', 312, 'book_rare*7', 10, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(4093, '5690', 312, 'book_rare*8', 10, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(4094, '5691', 312, 'book_rare*9', 10, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(4095, '5692', 299, 'val14_bench', 4, 0, 0, 1, 0, 0, 5, 13458, 0, '', '1', '0'),
	(4096, '5693', 299, 'val14_table', 2, 0, 0, 1, 0, 0, 25, 13459, 0, '', '1', '0'),
	(4097, '5694', 299, 'val14_rosebook', 4, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(4098, '5695', 299, 'val14_stool', 4, 0, 0, 1, 0, 0, 24, 13461, 0, '', '1', '0'),
	(4099, '5696', 299, 'val14_bed_g', 4, 0, 0, 1, 0, 0, -19, 13463, 0, '', '1', '0'),
	(4100, '5697', 299, 'val14_b_roof', 4, 0, 0, 1, 0, 0, -17, 13464, 0, '', '1', '0'),
	(4101, '5698', 299, 'val14_gate', 4, 0, 0, 1, 0, 0, 13, 13465, 0, '', '1', '0'),
	(4102, '5699', 299, 'val14_tile2', 1, 0, 0, 1, 0, 0, -10, 13466, 0, '', '1', '0'),
	(4103, '5700', 299, 'val14_bed_o', 4, 0, 0, 1, 0, 0, -18, 13467, 0, '', '1', '0'),
	(4104, '5701', 299, 'val14_wchair', 2, 0, 0, 1, 0, 0, 32, -1, 0, '', '1', '0'),
	(4105, '5702', 299, 'val14_tile3', 1, 0, 0, 1, 0, 0, -9, 13469, 0, '', '1', '0'),
	(4106, '5703', 299, 'val14_g_roof', 4, 0, 0, 1, 0, 0, -16, 13470, 0, '', '1', '0'),
	(4107, '5704', 299, 'val14_bigplant1', 4, 0, 0, 1, 0, 0, 6, 18107, 0, '', '1', '0'),
	(4108, '5705', 299, 'val14_pot1', 4, 0, 0, 1, 0, 0, 21, 18102, 0, '', '1', '0'),
	(4109, '5706', 299, 'val14_fbath', 4, 0, 0, 1, 0, 0, 11, 13473, 0, '', '1', '0'),
	(4110, '5707', 299, 'val14_largetile', 4, 0, 0, 1, 0, 0, 17, 13474, 0, '', '1', '0'),
	(4111, '5708', 299, 'val14_tile1', 1, 0, 0, 1, 0, 0, -11, 13475, 0, '', '1', '0'),
	(4112, '5709', 299, 'val14_y_roof', 4, 0, 0, 1, 0, 0, -15, 13476, 0, '', '1', '0'),
	(4113, '5710', 299, 'val14_archway', 4, 0, 0, 1, 0, 0, 1, 13477, 0, '', '1', '0'),
	(4114, '5711', 299, 'val14_door', 4, 0, 0, 1, 0, 0, 10, 18097, 0, '', '1', '0'),
	(4115, '5712', 299, 'val14_recchair', 2, 0, 0, 1, 0, 0, 22, 18089, 0, '', '1', '0'),
	(4116, '5713', 299, 'val14_bed_b', 4, 0, 0, 1, 0, 0, -20, 13480, 0, '', '1', '0'),
	(4117, '5714', 299, 'val14_bigplant2', 4, 0, 0, 1, 0, 0, 7, 18106, 0, '', '1', '0'),
	(4118, '5715', 299, 'val14_b_wall', 4, 0, 0, 1, 0, 0, -14, 13485, 0, '', '1', '0'),
	(4119, '5716', 299, 'val14_g_wall', 4, 0, 0, 1, 0, 0, -13, 13486, 0, '', '1', '0'),
	(4120, '5717', 299, 'val14_y_wall', 4, 0, 0, 1, 0, 0, -12, 13487, 0, '', '1', '0'),
	(4121, '5718', 299, 'val14_lovelock1', 4, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(4122, '5719', 299, 'val14_lovelock2', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(4123, '5720', 736, 'prizetrophy_room2*1', 12, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(4124, '5721', 736, 'prizetrophy_room2*2', 10, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(4125, '5722', 736, 'prizetrophy_room2*3', 8, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(4126, '5723', 736, 'prizetrophy_hotel1*1', 12, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(4127, '5724', 736, 'prizetrophy_hotel1*2', 10, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(4128, '5725', 736, 'prizetrophy_hotel1*3', 8, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(4129, '5726', 601, 'rare_pbag*0', 5, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(4130, '5727', 601, 'rare_pbag*1', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(4131, '5728', 601, 'rare_pbag*2', 5, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(4132, '5729', 601, 'rare_pbag*3', 5, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(4133, '5730', 601, 'rare_pbag*4', 5, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(4134, '5731', 601, 'rare_pbag*5', 5, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(4135, '5732', 601, 'rare_pbag*6', 5, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(4136, '5733', 853, 'br_phoenix', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(4137, '5734', 299, 'val14_lamp', 4, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(4138, '5735', 506, 'stories_shakespeare_tree', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(4139, '5736', 506, 'stories_shakespeare_swing', 4, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(4140, '5737', 506, 'stories_shakespeare_bench', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(4141, '5738', 506, 'stories_shakespeare_fairy', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(4142, '5739', 697, 'hlympic_bear', 4, 0, 0, 1, 0, 0, 196, -1, 0, '', '1', '0'),
	(4143, '5740', 299, 'val14_fountain', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(4144, '5741', 854, 'portabandeira', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4145, '5742', 299, 'val14_lovelock3', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(4146, '5743', 53, 'runway_camera', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(4147, '5744', 528, 'ads_nick_geyeser', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4148, '5745', 528, 'ads_nick_faketile', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4149, '5746', 53, 'runway_hangingb', 4, 0, 0, 1, 0, 0, 19, 13557, 0, '', '1', '0'),
	(4150, '5747', 53, 'runway_umbrellalight', 4, 0, 0, 1, 0, 0, 28, 13558, 0, '', '1', '0'),
	(4151, '5748', 53, 'runway_fan', 4, 0, 0, 1, 0, 0, 18, 13559, 0, '', '1', '0'),
	(4152, '5749', 53, 'runway_changing', 4, 0, 0, 1, 0, 0, 11, 13560, 0, '', '1', '0'),
	(4153, '5750', 683, 'rare_sage', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(4154, '5751', 53, 'runway_oldecamera', 4, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(4155, '5752', 53, 'runway_changingrare', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(4156, '5753', 853, 'rare_stpat14', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(4157, '5754', 115, 'nest_leprechaun', 3, 0, 0, 1, 0, 0, 99, 13590, 0, '', '1', '0'),
	(4158, '5755', 115, 'nest_gnome', 2, 0, 0, 1, 0, 0, 7, 13591, 0, '', '1', '0'),
	(4159, '5756', 426, 'leprechaun_box', 25, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(4160, '5757', 632, 'newbie_stairs_pink', 4, 0, 0, 1, 0, 0, 183, -1, 0, '', '1', '0'),
	(4161, '5758', 632, 'newbie_stairs_black', 4, 0, 0, 1, 0, 0, 184, -1, 0, '', '1', '0'),
	(4162, '5759', 683, 'newbie_present_2014', 7, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(4163, '5760', 632, 'newbie_eleblock5', 4, 0, 0, 1, 0, 0, 185, -1, 0, '', '1', '0'),
	(4164, '5761', 632, 'newbie_eleblock1', 4, 0, 0, 1, 0, 0, 186, -1, 0, '', '1', '0'),
	(4165, '5762', 506, 'stories_sch_book', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(4166, '5763', 506, 'stories_sch_hourglass', 4, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(4167, '5764', 740, 'LTD_fashionistam', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(4168, '5765', 740, 'LTD_fashionistaf', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(4169, '5766', 429, 'effect_faketile', 4, 0, 0, 1, 0, 0, 187, -1, 0, '', '0', '0'),
	(4170, '5767', 143, 'bc_block_water*1', 2, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(4171, '5768', 143, 'bc_block_water*2', 2, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(4172, '5769', 143, 'bc_block_water*3', 2, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(4173, '5770', 143, 'bc_block_water*4', 2, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(4174, '5771', 143, 'bc_block_water*5', 2, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(4175, '5772', 143, 'bc_block_water*6', 2, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(4176, '5773', 141, 'bc_tile*1', 2, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(4177, '5774', 141, 'bc_tile*10', 2, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(4178, '5775', 141, 'bc_tile*11', 2, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(4179, '5776', 141, 'bc_tile*12', 2, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(4180, '5777', 141, 'bc_tile*13', 2, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(4181, '5778', 141, 'bc_tile*14', 2, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(4182, '5779', 141, 'bc_tile*2', 2, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(4183, '5780', 141, 'bc_tile*3', 2, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(4184, '5781', 141, 'bc_tile*4', 2, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(4185, '5782', 141, 'bc_tile*5', 2, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(4186, '5783', 141, 'bc_tile*6', 2, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(4187, '5784', 141, 'bc_tile*7', 2, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(4188, '5785', 141, 'bc_tile*8', 2, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(4189, '5786', 141, 'bc_tile*9', 2, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(4190, '5787', 145, 'bc_terra*1', 2, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(4191, '5788', 145, 'bc_terra*10', 2, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(4192, '5789', 145, 'bc_terra*11', 2, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(4193, '5790', 145, 'bc_terra*12', 2, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(4194, '5791', 145, 'bc_terra*13', 2, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(4195, '5792', 145, 'bc_terra*14', 2, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(4196, '5793', 145, 'bc_terra*2', 2, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(4197, '5794', 145, 'bc_terra*3', 2, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(4198, '5795', 145, 'bc_terra*4', 2, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(4199, '5796', 145, 'bc_terra*5', 2, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(4200, '5797', 145, 'bc_terra*6', 2, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(4201, '5798', 145, 'bc_terra*7', 2, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(4202, '5799', 145, 'bc_terra*8', 2, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(4203, '5800', 145, 'bc_terra*9', 2, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(4204, '5801', 142, 'bc_flowerhedge*1', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4205, '5802', 142, 'bc_flowerhedge*10', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4206, '5803', 142, 'bc_flowerhedge*11', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4207, '5804', 142, 'bc_flowerhedge*12', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4208, '5805', 142, 'bc_flowerhedge*13', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4209, '5806', 142, 'bc_flowerhedge*14', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4210, '5807', 142, 'bc_flowerhedge*2', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4211, '5808', 142, 'bc_flowerhedge*3', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4212, '5809', 142, 'bc_flowerhedge*4', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4213, '5810', 142, 'bc_flowerhedge*5', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4214, '5811', 142, 'bc_flowerhedge*6', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4215, '5812', 142, 'bc_flowerhedge*7', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4216, '5813', 142, 'bc_flowerhedge*8', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4217, '5814', 142, 'bc_flowerhedge*9', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4218, '5815', 506, 'stories_sch_chair', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(4219, '5816', 506, 'stories_sch_bookshelf', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(4220, '5817', 381, 'easter14_chocchestrare', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(4221, '5818', 429, 'free_placement_room', 4, 0, 0, 1, 0, 0, 188, -1, 0, '', '0', '0'),
	(4222, '5819', 381, 'easter14_plant', 4, 0, 0, 1, 0, 0, 35, -1, 0, '', '1', '0'),
	(4223, '5820', 381, 'easter14_elecdivdr', 4, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(4224, '5821', 381, 'easter14_jar', 4, 0, 0, 1, 0, 0, 30, -1, 0, '', '1', '0'),
	(4225, '5822', 381, 'easter14_pillar', 4, 0, 0, 1, 0, 0, 34, -1, 0, '', '1', '0'),
	(4226, '5823', 381, 'easter14_block3', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(4227, '5824', 381, 'easter14_block1', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(4228, '5825', 381, 'easter14_metalfloor', 2, 0, 0, 1, 0, 0, 32, -1, 0, '', '1', '0'),
	(4229, '5826', 381, 'easter14_lamp', 4, 0, 0, 1, 0, 0, 31, -1, 0, '', '1', '0'),
	(4230, '5827', 381, 'easter14_roombg', 4, 0, 0, 1, 0, 0, 36, -1, 0, '', '1', '0'),
	(4231, '5828', 381, 'easter14_corner', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(4232, '5829', 381, 'easter14_captainchr', 4, 0, 0, 1, 0, 0, 6, 13697, 0, '', '1', '0'),
	(4233, '5830', 381, 'easter14_flower', 4, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(4234, '5831', 381, 'easter14_palmtree', 4, 0, 0, 1, 0, 0, 33, -1, 0, '', '1', '0'),
	(4235, '5832', 381, 'easter14_teleport', 4, 0, 0, 1, 0, 0, 43, -1, 0, '', '1', '0'),
	(4236, '5833', 381, 'easter14_eggplant', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(4237, '5834', 381, 'easter14_gate', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(4238, '5835', 381, 'easter14_divider', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(4239, '5836', 381, 'easter14_block2', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(4240, '5837', 381, 'easter14_block4', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(4241, '5838', 381, 'easter14_techtreebrkn', 4, 0, 0, 1, 0, 0, 42, -1, 0, '', '1', '0'),
	(4242, '5839', 381, 'easter14_sandfloor', 2, 0, 0, 1, 0, 0, 37, -1, 0, '', '1', '0'),
	(4243, '5840', 381, 'easter14_chair', 2, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(4244, '5841', 381, 'easter14_grasspatch', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(4245, '5842', 381, 'easter14_techstump', 4, 0, 0, 1, 0, 0, 41, -1, 0, '', '1', '0'),
	(4246, '5843', 381, 'easter14_table', 4, 0, 0, 1, 0, 0, 40, -1, 0, '', '1', '0'),
	(4247, '5844', 381, 'easter14_effectgiver', 4, 0, 0, 1, 0, 0, 11, 13712, 0, '', '1', '0'),
	(4248, '5845', 381, 'easter14_eleccrn', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(4249, '5846', 381, 'easter14_screen', 4, 0, 0, 1, 0, 0, 38, -1, 0, '', '1', '0'),
	(4250, '5847', 381, 'easter14_statue', 4, 0, 0, 1, 0, 0, 39, -1, 0, '', '1', '0'),
	(4251, '5848', 381, 'easter14_bunnysphinx', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(4252, '5849', 381, 'easter14_eggstar', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(4253, '5850', 740, 'ltd_habberge3', 3, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(4254, '5851', 740, 'ltd_habberge2', 3, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(4255, '5852', 739, 'ltd_habberge4', 5, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(4256, '5853', 740, 'ltd_habberge5', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(4257, '5854', 255, 'wf_act_mute_triggerer', 7, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(4258, '5855', 740, 'ltd_habberge1', 3, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(4259, '5856', 381, 'easter14_habberge6', 4, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(4260, '5857', 506, 'stories_oldmusic_neon', 4, 0, 0, 1, 0, 0, 10, 13749, 0, '', '1', '0'),
	(4261, '5858', 506, 'stories_oldmusic_vinyl', 4, 0, 0, 1, 0, 0, 11, 13750, 0, '', '1', '0'),
	(4262, '5859', 506, 'stories_oldmusic_guitarcase', 4, 0, 0, 1, 0, 0, 8, 18167, 0, '', '1', '0'),
	(4263, '5860', 506, 'stories_oldmusic_mike', 4, 0, 0, 1, 0, 0, 9, 18184, 0, '', '1', '0'),
	(4264, '5861', 255, 'wf_cnd_date_rng_active', 7, 0, 0, 1, 0, 0, 8, 13753, 0, '', '1', '0'),
	(4265, '5862', 853, 'rare_venusstatue', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(4266, '5863', 163, 'guild_forum', 15, 0, 0, 1, 0, 0, 99, 13767, 0, '', '1', '0'),
	(4267, '5864', 110, 'vikings_table_r', 4, 0, 0, 1, 0, 0, 33, -1, 0, '', '1', '0'),
	(4268, '5865', 110, 'vikings_chair_g', 2, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(4269, '5866', 110, 'vikings_torch', 4, 0, 0, 1, 0, 0, 37, -1, 0, '', '1', '0'),
	(4270, '5867', 110, 'vikings_bed', 3, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(4271, '5868', 110, 'vikings_house', 4, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(4272, '5869', 110, 'vikings_spike', 4, 0, 0, 1, 0, 0, 26, -1, 0, '', '1', '0'),
	(4273, '5870', 110, 'vikings_wooddivdr', 4, 0, 0, 1, 0, 0, 44, -1, 0, '', '1', '0'),
	(4274, '5871', 110, 'vikings_floor', 2, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(4275, '5872', 110, 'vikings_woodgate', 4, 0, 0, 1, 0, 0, 45, -1, 0, '', '1', '0'),
	(4276, '5873', 110, 'vikings_flag_r', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(4277, '5874', 110, 'vikings_stonecrn', 4, 0, 0, 1, 0, 0, 27, -1, 0, '', '1', '0'),
	(4278, '5875', 110, 'vikings_animal_r', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(4279, '5876', 110, 'vikings_basket1', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(4280, '5877', 110, 'vikings_stonedivdr', 4, 0, 0, 1, 0, 0, 28, -1, 0, '', '1', '0'),
	(4281, '5878', 110, 'vikings_outdoorstove', 4, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(4282, '5879', 110, 'vikings_weapon', 4, 0, 0, 1, 0, 0, 42, -1, 0, '', '1', '0'),
	(4283, '5880', 110, 'vikings_animal_g', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(4284, '5881', 110, 'vikings_indoorstove', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(4285, '5882', 110, 'vikings_roof_r', 4, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(4286, '5883', 110, 'vikings_gondola1', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(4287, '5884', 110, 'vikings_basket2', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(4288, '5885', 110, 'vikings_table_g', 2, 0, 0, 1, 0, 0, 32, -1, 0, '', '1', '0'),
	(4289, '5886', 110, 'vikings_gondola2b', 4, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(4290, '5887', 110, 'vikings_woodcrn', 4, 0, 0, 1, 0, 0, 43, -1, 0, '', '1', '0'),
	(4291, '5888', 110, 'vikings_gondola3', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(4292, '5889', 110, 'vikings_teleport', 4, 0, 0, 1, 0, 0, 34, -1, 0, '', '1', '0'),
	(4293, '5890', 110, 'vikings_flag_g', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(4294, '5891', 110, 'vikings_gondola2c', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(4295, '5892', 110, 'vikings_roof_g', 4, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(4296, '5893', 110, 'vikings_chair_r', 2, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(4297, '5894', 110, 'vikings_tombstone', 4, 0, 0, 1, 0, 0, 36, -1, 0, '', '1', '0'),
	(4298, '5895', 110, 'vikings_stonegate', 4, 0, 0, 1, 0, 0, 29, -1, 0, '', '1', '0'),
	(4299, '5896', 110, 'vikings_stool', 4, 0, 0, 1, 0, 0, 30, -1, 0, '', '1', '0'),
	(4300, '5897', 110, 'vikings_gondola2a', 4, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(4301, '5898', 110, 'vikings_stove', 4, 0, 0, 1, 0, 0, 31, -1, 0, '', '1', '0'),
	(4302, '5899', 110, 'vikings_pillar', 4, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(4303, '5900', 144, 'bc_wood*1', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4304, '5901', 144, 'bc_wood*2', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4305, '5902', 144, 'bc_wood*3', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4306, '5903', 144, 'bc_wood*4', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4307, '5904', 144, 'bc_wood*5', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4308, '5905', 144, 'bc_wood*6', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4309, '5906', 110, 'vikings_runestone', 4, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(4310, '5907', 113, 'room_noob_walltl', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(4311, '5908', 113, 'room_noob_bar', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(4312, '5909', 113, 'room_noob_walltr1', 4, 0, 0, 1, 0, 0, 31, -1, 0, '', '1', '0'),
	(4313, '5910', 113, 'room_noob_table1', 4, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(4314, '5911', 113, 'room_noob_carpet1', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(4315, '5912', 113, 'room_noob_fxremove', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(4316, '5913', 113, 'room_noob_barchair', 4, 0, 0, 1, 0, 0, 2, -1, 0, '0', '1', '0'),
	(4317, '5914', 113, 'room_noob_fx1', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(4318, '5915', 113, 'room_noob_table2', 4, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(4319, '5916', 113, 'room_noob_stairside', 4, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(4320, '5917', 113, 'room_noob_walltr2', 4, 0, 0, 1, 0, 0, 32, -1, 0, '', '1', '0'),
	(4321, '5918', 113, 'room_noob_tallfloor', 4, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(4322, '5919', 113, 'room_noob_floor1', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(4323, '5920', 113, 'room_noob_stairs', 4, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(4324, '5921', 113, 'room_noob_fx2', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(4325, '5922', 113, 'room_noob_barside', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(4326, '5923', 113, 'room_noob_sofa', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(4327, '5924', 113, 'room_noob_glow', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(4328, '5925', 113, 'room_noob_plant', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(4329, '5926', 113, 'room_noob_wallcrnr', 4, 0, 0, 1, 0, 0, 29, -1, 0, '', '1', '0'),
	(4330, '5927', 113, 'room_noob_wallbl3', 4, 0, 0, 1, 0, 0, 28, -1, 0, '', '1', '0'),
	(4331, '5928', 113, 'room_noob_hanglight', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(4332, '5929', 113, 'room_noob_wallbl1', 4, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(4333, '5930', 113, 'room_noob_div', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(4334, '5931', 113, 'room_noob_floor3', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(4335, '5932', 113, 'room_noob_floor2', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(4336, '5933', 113, 'room_noob_chair', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(4337, '5934', 113, 'room_noob_bargate', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(4338, '5935', 113, 'room_noob_wallbl2', 4, 0, 0, 1, 0, 0, 27, -1, 0, '', '1', '0'),
	(4339, '5936', 113, 'room_noob_pool', 4, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(4340, '5937', 113, 'room_noob_fx4', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(4341, '5938', 113, 'room_noob_fx3', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(4342, '5939', 255, 'wf_blob_invis', 4, 0, 0, 1, 0, 0, 90, -1, 0, '', '1', '0'),
	(4343, '5940', 255, 'wf_blob2_vis', 4, 0, 0, 1, 0, 0, 90, -1, 0, '', '1', '0'),
	(4344, '5941', 740, 'vikings_throne', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(4345, '5942', 110, 'vikings_yggdrasil', 4, 0, 0, 1, 0, 0, 46, -1, 0, '', '1', '0'),
	(4346, '5943', 110, 'vikings_thor', 4, 0, 0, 1, 0, 0, 35, -1, 0, '', '1', '0'),
	(4347, '5944', 110, 'vikings_chesspiece', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(4348, '5945', 339, 'tablet_vendor', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(4349, '5946', 307, 'CF_500_vikings', 500, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(4350, '5947', 538, 'ads_dtlrare_rc', 4, 0, 0, 1, 0, 0, 46, -1, 0, '', '1', '0'),
	(4351, '5948', 429, 'room_noob_exit', 4, 0, 0, 1, 0, 0, 190, -1, 0, '', '1', '0'),
	(4352, '5949', 853, 'fball_goldenboot', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(4353, '5950', 108, 'fball_grp_crnr', 3, 0, 0, 1, 0, 0, 5, 13876, 0, '', '1', '0'),
	(4355, '5952', 523, 'fball_ball6', 15, 0, 0, 1, 0, 0, 8, 13878, 0, '', '1', '0'),
	(4358, '5955', 108, 'fball_grp_fnc1', 3, 0, 0, 1, 0, 0, 6, 13881, 0, '', '1', '0'),
	(4359, '5956', 108, 'fball_grp_cote', 6, 0, 0, 1, 0, 0, 4, 13882, 0, '', '1', '0'),
	(4360, '5957', 108, 'fball_grp_bench', 1, 0, 0, 1, 0, 0, 3, 18034, 0, '', '1', '0'),
	(4361, '5958', 108, 'fball_grp_fnc3', 5, 0, 0, 1, 0, 0, 7, 13884, 0, '', '1', '0'),
	(4362, '5959', 523, 'fball_audbench2', 6, 0, 0, 1, 0, 0, 2, 13885, 0, '', '1', '0'),
	(4363, '5960', 523, 'stories_football_board', 4, 0, 0, 1, 0, 0, 39, -1, 0, '', '1', '0'),
	(4364, '5961', 523, 'stories_football_table', 4, 0, 0, 1, 0, 0, 41, -1, 0, '', '1', '0'),
	(4365, '5962', 108, 'fball_flag_grp', 2, 0, 0, 1, 0, 0, 2, 17958, 0, '', '1', '0'),
	(4366, '5963', 853, 'fball_goldenboot2', 4, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(4367, '5964', 853, 'fball_mascot', 4, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(4368, '5965', 523, 'fball_scales', 10, 0, 0, 1, 0, 0, 30, -1, 0, '', '1', '0'),
	(4369, '5966', 307, 'CF_diamond_1000', 1000, 0, 0, 1, 0, 0, 30, 17850, 0, '', '1', '0'),
	(4370, '5967', 307, 'CF_diamond_500', 500, 0, 0, 1, 0, 0, 19, 17912, 0, '', '1', '0'),
	(4371, '5968', 307, 'CF_diamond_250', 250, 0, 0, 1, 0, 0, 10, 17905, 0, '', '1', '0'),
	(4372, '5969', 307, 'CF_diamond_100', 100, 0, 0, 1, 0, 0, 4, 17875, 0, '', '1', '0'),
	(4373, '5970', 307, 'CF_diamond_2500', 2500, 0, 0, 1, 0, 0, 35, 17888, 0, '', '1', '0'),
	(4374, '5971', 523, 'stories_football_screen', 4, 0, 0, 1, 0, 0, 40, -1, 0, '', '1', '0'),
	(4375, '5972', 740, 'fball_ltd14', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(4376, '5973', 736, 'prizetrophy_fballbrazil*1', 4, 0, 0, 1, 0, 0, 46, -1, 0, '', '1', '0'),
	(4377, '5974', 736, 'prizetrophy_fballbrazil*2', 4, 0, 0, 1, 0, 0, 47, -1, 0, '', '1', '0'),
	(4378, '5975', 736, 'prizetrophy_fballbrazil*3', 4, 0, 0, 1, 0, 0, 48, -1, 0, '', '1', '0'),
	(4379, '5976', 261, 'gift_mysterytrophy', 7, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(4380, '5977', 567, 'hblooza14_hotair_b', 4, 0, 0, 1, 0, 0, 31, -1, 0, '', '1', '0'),
	(4381, '5978', 567, 'hblooza14_hotair_y', 4, 0, 0, 1, 0, 0, 33, -1, 0, '', '1', '0'),
	(4382, '5979', 269, 'hblooza14_bundkiosk', 4, 0, 0, 1, 0, 0, 103, -1, 0, '', '1', '0'),
	(4383, '5980', 567, 'hblooza14_hotair_p', 4, 0, 0, 1, 0, 0, 32, -1, 0, '', '1', '0'),
	(4384, '5981', 269, 'hblooza14_tent', 4, 0, 0, 1, 0, 0, 129, -1, 0, '', '1', '0'),
	(4385, '5982', 269, 'hblooza14_drinkstall', 10, 0, 0, 1, 0, 0, 106, -1, 0, '', '1', '0'),
	(4386, '5983', 269, 'hblooza14_shotgall', 4, 0, 0, 1, 0, 0, 125, -1, 0, '', '1', '0'),
	(4387, '5984', 269, 'hblooza14_duckhook', 4, 0, 0, 1, 0, 0, 110, -1, 0, '', '1', '0'),
	(4388, '5985', 600, 'hblooza14_pinata2', 7, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(4389, '5986', 269, 'hblooza14_hedgediv', 4, 0, 0, 1, 0, 0, 120, -1, 0, '', '1', '0'),
	(4390, '5987', 269, 'hblooza14_duckgate', 4, 0, 0, 1, 0, 0, 109, -1, 0, '', '1', '0'),
	(4391, '5988', 269, 'hblooza14_tele', 4, 0, 0, 1, 0, 0, 128, -1, 0, '', '1', '0'),
	(4392, '5989', 567, 'hblooza14_duck_balloon_y', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(4393, '5990', 600, 'hblooza14_pinata1', 7, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(4394, '5991', 269, 'hblooza14_flowerlight', 4, 0, 0, 1, 0, 0, 117, -1, 0, '', '1', '0'),
	(4395, '5992', 269, 'hblooza14_flagpole', 4, 0, 0, 1, 0, 0, 112, -1, 0, '', '1', '0'),
	(4396, '5993', 269, 'hblooza14_hctele', 4, 0, 0, 1, 0, 0, 118, 13944, 0, '', '1', '0'),
	(4397, '5994', 269, 'hblooza14_rollercost', 4, 0, 0, 1, 0, 0, 124, -1, 0, '', '1', '0'),
	(4398, '5995', 269, 'hblooza14_duckdvdr', 4, 0, 0, 1, 0, 0, 108, -1, 0, '', '1', '0'),
	(4399, '5996', 567, 'hblooza14_cafe_y', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(4400, '5997', 269, 'hblooza14_duckhookhc', 4, 0, 0, 1, 0, 0, 111, 13948, 0, '', '1', '0'),
	(4401, '5998', 269, 'hblooza14_flagpole_p', 4, 0, 0, 1, 0, 0, 113, -1, 0, '', '1', '0'),
	(4402, '5999', 567, 'hblooza14_horsecarop', 4, 0, 0, 1, 0, 0, 29, -1, 0, '', '1', '0'),
	(4403, '6000', 269, 'hblooza14_candystall', 10, 0, 0, 1, 0, 0, 104, -1, 0, '', '1', '0'),
	(4404, '6001', 600, 'hblooza14_pinata3', 7, 0, 0, 1, 0, 0, 37, -1, 0, '', '1', '0'),
	(4405, '6002', 269, 'hblooza14_ballsign', 4, 0, 0, 1, 0, 0, 102, -1, 0, '', '1', '0'),
	(4406, '6003', 567, 'hblooza14_horsecaroy', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(4407, '6004', 269, 'hblooza14_planepadr', 3, 0, 0, 1, 0, 0, 123, -1, 0, '', '1', '0'),
	(4408, '6005', 567, 'hblooza14_duck_balloon_p', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(4409, '6006', 567, 'hblooza14_cafe_b', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(4410, '6007', 567, 'hblooza14_duck_balloon_b', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(4411, '6008', 269, 'hblooza14_flag_p', 4, 0, 0, 1, 0, 0, 115, -1, 0, '', '1', '0'),
	(4412, '6009', 269, 'hblooza14_flag_y', 4, 0, 0, 1, 0, 0, 116, -1, 0, '', '1', '0'),
	(4413, '6010', 269, 'hblooza14_arrowsign', 4, 0, 0, 1, 0, 0, 101, -1, 0, '', '1', '0'),
	(4414, '6011', 269, 'hblooza14_dance', 4, 0, 0, 1, 0, 0, 105, -1, 0, '', '1', '0'),
	(4415, '6012', 269, 'hblooza14_table', 4, 0, 0, 1, 0, 0, 127, -1, 0, '', '1', '0'),
	(4416, '6013', 269, 'hblooza14_hedgecrn', 4, 0, 0, 1, 0, 0, 119, -1, 0, '', '1', '0'),
	(4417, '6014', 269, 'hblooza14_duckcrn', 4, 0, 0, 1, 0, 0, 107, -1, 0, '', '1', '0'),
	(4418, '6015', 269, 'hblooza14_stool', 4, 0, 0, 1, 0, 0, 126, -1, 0, '', '1', '0'),
	(4419, '6016', 269, 'hblooza14_flag_b', 4, 0, 0, 1, 0, 0, 114, -1, 0, '', '1', '0'),
	(4420, '6017', 567, 'hblooza14_cafe_p', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(4421, '6018', 269, 'hblooza14_mud', 4, 0, 0, 1, 0, 0, 121, -1, 0, '', '1', '0'),
	(4422, '6019', 269, 'hblooza14_arch', 4, 0, 0, 1, 0, 0, 100, -1, 0, '', '1', '0'),
	(4423, '6020', 269, 'hblooza14_planepadb', 3, 0, 0, 1, 0, 0, 122, -1, 0, '', '1', '0'),
	(4424, '6021', 567, 'hblooza14_horsecarob', 4, 0, 0, 1, 0, 0, 28, -1, 0, '', '1', '0'),
	(4425, '6022', 269, 'st_palooza_cake', 4, 0, 0, 1, 0, 0, 201, -1, 0, '', '1', '0'),
	(4426, '6023', 269, 'st_palooza_unicorn', 4, 0, 0, 1, 0, 0, 204, -1, 0, '', '1', '0'),
	(4427, '6024', 726, 'st_palooza_cupcakes', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(4428, '6025', 269, 'hblooza14_track_crl', 4, 0, 0, 1, 0, 0, 131, -1, 0, '', '1', '0'),
	(4429, '6026', 269, 'hblooza14_track', 4, 0, 0, 1, 0, 0, 130, -1, 0, '', '1', '0'),
	(4430, '6027', 269, 'hblooza14_track_crr', 4, 0, 0, 1, 0, 0, 132, -1, 0, '', '1', '0'),
	(4431, '6028', 600, 'hblooza14_pinata4', 7, 0, 0, 1, 0, 0, 38, -1, 0, '', '1', '0'),
	(4432, '6029', 269, 'st_palooza_screen', 4, 0, 0, 1, 0, 0, 203, -1, 0, '', '1', '0'),
	(4433, '6030', 269, 'st_palooza_balloons', 4, 0, 0, 1, 0, 0, 200, -1, 0, '', '1', '0'),
	(4434, '6031', 269, 'st_palooza_pool', 4, 0, 0, 1, 0, 0, 202, -1, 0, '', '1', '0'),
	(4435, '6032', 112, 'wildwest_minecart', 4, 0, 0, 1, 0, 0, 32, -1, 0, '', '1', '0'),
	(4436, '6033', 112, 'wildwest_teleport', 4, 0, 0, 1, 0, 0, 58, -1, 0, '', '1', '0'),
	(4437, '6034', 740, 'wildwest_piano', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(4438, '6035', 112, 'wildwest_floor', 2, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(4439, '6036', 112, 'wildwest_milkcan', 4, 0, 0, 1, 0, 0, 31, -1, 0, '', '1', '0'),
	(4440, '6037', 112, 'wildwest_bank', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(4441, '6038', 112, 'wildwest_sofa', 3, 0, 0, 1, 0, 0, 44, 14012, 0, '', '1', '0'),
	(4442, '6039', 112, 'wildwest_desk', 5, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(4443, '6040', 112, 'wildwest_pump', 4, 0, 0, 1, 0, 0, 33, -1, 0, '', '1', '0'),
	(4444, '6041', 112, 'wildwest_vulture', 4, 0, 0, 1, 0, 0, 62, -1, 0, '', '1', '0'),
	(4445, '6042', 112, 'wildwest_salooncrn', 4, 0, 0, 1, 0, 0, 38, -1, 0, '', '1', '0'),
	(4446, '6043', 112, 'wildwest_floor2', 2, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(4447, '6044', 112, 'wildwest_chair', 2, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(4448, '6045', 112, 'wildwest_cactus1', 4, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(4449, '6046', 112, 'wildwest_stagew2', 4, 0, 0, 1, 0, 0, 53, -1, 0, '', '1', '0'),
	(4450, '6047', 112, 'wildwest_cactus2', 4, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(4451, '6048', 112, 'wildwest_wagon', 4, 0, 0, 1, 0, 0, 63, -1, 0, '', '1', '0'),
	(4452, '6049', 112, 'wildwest_roofr', 4, 0, 0, 1, 0, 0, 35, -1, 0, '', '1', '0'),
	(4453, '6050', 112, 'wildwest_stager2', 4, 0, 0, 1, 0, 0, 51, -1, 0, '', '1', '0'),
	(4454, '6051', 112, 'wildwest_spittoon2', 4, 0, 0, 1, 0, 0, 46, -1, 0, '', '1', '0'),
	(4455, '6052', 112, 'wildwest_roofw', 4, 0, 0, 1, 0, 0, 36, -1, 0, '', '1', '0'),
	(4456, '6053', 112, 'wildwest_store', 4, 0, 0, 1, 0, 0, 55, -1, 0, '', '1', '0'),
	(4457, '6054', 112, 'wildwest_bench', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(4458, '6055', 112, 'wildwest_saloondr', 4, 0, 0, 1, 0, 0, 39, -1, 0, '', '1', '0'),
	(4459, '6056', 112, 'wildwest_divdr', 4, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(4460, '6057', 112, 'wildwest_gate', 4, 0, 0, 1, 0, 0, 27, -1, 0, '', '1', '0'),
	(4461, '6058', 112, 'wildwest_wanted_poster', 4, 0, 0, 1, 0, 0, 65, -1, 0, '', '1', '0'),
	(4462, '6059', 112, 'wildwest_till', 4, 0, 0, 1, 0, 0, 59, -1, 0, '', '1', '0'),
	(4463, '6060', 112, 'wildwest_spittoon', 4, 0, 0, 1, 0, 0, 45, -1, 0, '', '1', '0'),
	(4464, '6061', 112, 'wildwest_stocks', 4, 0, 0, 1, 0, 0, 54, -1, 0, '', '1', '0'),
	(4465, '6062', 112, 'wildwest_light', 4, 0, 0, 1, 0, 0, 28, -1, 0, '', '1', '0'),
	(4466, '6063', 112, 'wildwest_tarbucket', 4, 0, 0, 1, 0, 0, 57, -1, 0, '', '1', '0'),
	(4467, '6064', 112, 'wildwest_tree', 4, 0, 0, 1, 0, 0, 61, -1, 0, '', '1', '0'),
	(4468, '6065', 112, 'wildwest_saloon', 4, 0, 0, 1, 0, 0, 37, -1, 0, '', '1', '0'),
	(4469, '6066', 112, 'wildwest_cabinet', 4, 0, 0, 1, 0, 0, 14, 24152, 0, '', '1', '0'),
	(4470, '6067', 112, 'wildwest_stageb', 4, 0, 0, 1, 0, 0, 47, -1, 0, '', '1', '0'),
	(4471, '6068', 112, 'wildwest_crn', 4, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(4472, '6069', 112, 'wildwest_longhorn', 4, 0, 0, 1, 0, 0, 29, -1, 0, '', '1', '0'),
	(4473, '6070', 112, 'wildwest_clothesline', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(4474, '6071', 112, 'wildwest_bgland', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(4475, '6072', 112, 'wildwest_crate', 4, 0, 0, 1, 0, 0, 19, 24152, 0, '', '1', '0'),
	(4476, '6073', 112, 'wildwest_weed', 4, 0, 0, 1, 0, 0, 66, -1, 0, '', '1', '0'),
	(4477, '6074', 112, 'wildwest_bgland2', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(4478, '6075', 112, 'wildwest_bgtrain', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(4479, '6076', 112, 'wildwest_roofb', 4, 0, 0, 1, 0, 0, 34, -1, 0, '', '1', '0'),
	(4480, '6077', 112, 'wildwest_saloonwall', 4, 0, 0, 1, 0, 0, 41, -1, 0, '', '1', '0'),
	(4481, '6078', 112, 'wildwest_sheriff', 4, 0, 0, 1, 0, 0, 42, -1, 0, '', '1', '0'),
	(4482, '6079', 112, 'wildwest_snake', 4, 0, 0, 1, 0, 0, 43, -1, 0, '', '1', '0'),
	(4483, '6080', 112, 'wildwest_table', 2, 0, 0, 1, 0, 0, 56, -1, 0, '', '1', '0'),
	(4484, '6081', 112, 'wildwest_stageb2', 4, 0, 0, 1, 0, 0, 48, -1, 0, '', '1', '0'),
	(4485, '6082', 112, 'wildwest_stager', 4, 0, 0, 1, 0, 0, 49, -1, 0, '', '1', '0'),
	(4486, '6083', 112, 'wildwest_stagew', 4, 0, 0, 1, 0, 0, 52, -1, 0, '', '1', '0'),
	(4487, '6084', 112, 'wildwest_gallows', 4, 0, 0, 1, 0, 0, 26, -1, 0, '', '1', '0'),
	(4488, '6085', 112, 'st_wildwest_buffalo', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(4489, '6086', 112, 'st_wildwest_cards', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(4490, '6087', 112, 'st_wildwest_barrel', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(4491, '6088', 112, 'st_wildwest_tnt', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(4492, '6089', 112, 'st_wildwest_goldpick', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(4493, '6090', 112, 'st_wildwest_canteen', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(4494, '6091', 6, 'matic_light_cam_red', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(4495, '6092', 6, 'matic_light_cam_blue', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(4496, '6093', 6, 'matic_light_cam_green', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(4497, '6094', 6, 'matic_sanitizer', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(4498, '6095', 6, 'matic_light_cam_orange', 3, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(4499, '6096', 114, 'uni_messwardrobe', 4, 0, 0, 1, 0, 0, 41, 14096, 0, '', '1', '0'),
	(4500, '6097', 114, 'uni_plush1', 4, 0, 0, 1, 0, 0, 49, 14097, 0, '', '1', '0'),
	(4501, '6098', 114, 'uni_owl', 4, 0, 0, 1, 0, 0, 45, -1, 0, '', '1', '0'),
	(4502, '6099', 114, 'uni_ottoman', 4, 0, 0, 1, 0, 0, 44, 14099, 0, '', '1', '0'),
	(4503, '6100', 114, 'uni_drinks', 4, 0, 0, 1, 0, 0, 20, 14100, 0, '', '1', '0'),
	(4504, '6101', 114, 'uni_brotein', 4, 0, 0, 1, 0, 0, 10, 14101, 0, '', '1', '0'),
	(4505, '6102', 114, 'uni_games', 4, 0, 0, 1, 0, 0, 29, 18081, 0, '', '1', '0'),
	(4506, '6103', 114, 'uni_girlchair', 2, 0, 0, 1, 0, 0, 31, 14103, 0, '', '1', '0'),
	(4507, '6104', 114, 'uni_gamershelf', 5, 0, 0, 1, 0, 0, 28, 14104, 0, '', '1', '0'),
	(4508, '6105', 114, 'uni_dumbells', 4, 0, 0, 1, 0, 0, 21, 14105, 0, '', '1', '0'),
	(4509, '6106', 114, 'uni_doorhanging', 4, 0, 0, 1, 0, 0, 19, 14106, 0, '', '1', '0'),
	(4510, '6107', 114, 'uni_wardrobe', 4, 0, 0, 1, 0, 0, 59, 14107, 0, '', '1', '0'),
	(4511, '6108', 114, 'uni_jewellery', 4, 0, 0, 1, 0, 0, 36, 14108, 0, '', '1', '0'),
	(4512, '6109', 114, 'uni_plush2', 4, 0, 0, 1, 0, 0, 50, 14109, 0, '', '1', '0'),
	(4513, '6110', 114, 'uni_cafeterie', 4, 0, 0, 1, 0, 0, 14, 14110, 0, '', '1', '0'),
	(4514, '6111', 114, 'uni_projector', 4, 0, 0, 1, 0, 0, 54, -1, 0, '', '1', '0'),
	(4515, '6112', 114, 'uni_rubik', 4, 0, 0, 1, 0, 0, 55, 18105, 0, '', '1', '0'),
	(4516, '6113', 114, 'uni_hipbed', 3, 0, 0, 1, 0, 0, 33, 14113, 0, '', '1', '0'),
	(4517, '6114', 114, 'uni_laptop', 4, 0, 0, 1, 0, 0, 37, 14114, 0, '', '1', '0'),
	(4518, '6115', 114, 'uni_wobench', 3, 0, 0, 1, 0, 0, 60, 18117, 0, '', '1', '0'),
	(4519, '6116', 114, 'uni_fridge', 10, 0, 0, 1, 0, 0, 25, 14116, 0, '', '1', '0'),
	(4520, '6117', 114, 'uni_bed', 3, 0, 0, 1, 0, 0, 8, 14117, 0, '', '1', '0'),
	(4521, '6118', 114, 'uni_snacks', 4, 0, 0, 1, 0, 0, 56, 14118, 0, '', '1', '0'),
	(4522, '6119', 114, 'uni_chair', 2, 0, 0, 1, 0, 0, 16, 14119, 0, '', '1', '0'),
	(4523, '6120', 114, 'uni_messbed', 3, 0, 0, 1, 0, 0, 40, 14120, 0, '', '1', '0'),
	(4524, '6121', 114, 'uni_gamerdesk', 5, 0, 0, 1, 0, 0, 27, 14121, 0, '', '1', '0'),
	(4525, '6122', 114, 'uni_pizza', 4, 0, 0, 1, 0, 0, 48, 18098, 0, '', '1', '0'),
	(4526, '6123', 114, 'uni_manga', 4, 0, 0, 1, 0, 0, 39, 18108, 0, '', '1', '0'),
	(4527, '6124', 114, 'uni_nstand', 4, 0, 0, 1, 0, 0, 43, 14124, 0, '', '1', '0'),
	(4528, '6125', 114, 'uni_plushpile', 4, 0, 0, 1, 0, 0, 51, 18100, 0, '', '1', '0'),
	(4529, '6126', 114, 'uni_bookshelf', 5, 0, 0, 1, 0, 0, 9, 14126, 0, '', '1', '0'),
	(4530, '6127', 114, 'uni_gamerbed', 3, 0, 0, 1, 0, 0, 26, 14127, 0, '', '1', '0'),
	(4531, '6128', 114, 'uni_hipbookcase', 4, 0, 0, 1, 0, 0, 34, 14128, 0, '', '1', '0'),
	(4532, '6129', 114, 'uni_desk', 5, 0, 0, 1, 0, 0, 18, 18080, 0, '', '1', '0'),
	(4533, '6130', 114, 'uni_girlbed', 3, 0, 0, 1, 0, 0, 30, 14130, 0, '', '1', '0'),
	(4534, '6131', 114, 'uni_alarm', 4, 0, 0, 1, 0, 0, 7, 14131, 0, '', '1', '0'),
	(4535, '6132', 740, 'uni_lectern', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(4536, '6133', 114, 'uni_catrug', 4, 0, 0, 1, 0, 0, 15, 14133, 0, '', '1', '0'),
	(4537, '6134', 114, 'uni_trashcan', 4, 0, 0, 1, 0, 0, 57, 14134, 0, '', '1', '0'),
	(4538, '6135', 182, 'bathroom_bath3', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(4539, '6136', 182, 'bathroom_sinkmodule3', 4, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(4540, '6137', 182, 'bathroom_tablemodule4', 2, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(4541, '6138', 182, 'bathroom_sinkmodule2', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(4542, '6139', 182, 'bathroom_toilet4', 4, 0, 0, 1, 0, 0, 28, -1, 0, '', '1', '0'),
	(4543, '6140', 182, 'bathroom_tablemodule1', 2, 0, 0, 1, 0, 0, 21, 14152, 0, '', '1', '0'),
	(4544, '6141', 182, 'bathroom_toilet1', 4, 0, 0, 1, 0, 0, 25, 18005, 0, '', '1', '0'),
	(4545, '6142', 182, 'bathroom_sinkmodule4', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(4546, '6143', 182, 'bathroom_bath2', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(4547, '6144', 182, 'bathroom_floortile2', 2, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(4548, '6145', 182, 'bathroom_toilet3', 4, 0, 0, 1, 0, 0, 27, -1, 0, '', '1', '0'),
	(4549, '6146', 182, 'bathroom_floortile4', 2, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(4550, '6147', 182, 'bathroom_bath4', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(4551, '6148', 182, 'bathroom_shower1', 4, 0, 0, 1, 0, 0, 13, 14160, 0, '', '1', '0'),
	(4552, '6149', 182, 'bathroom_floortile3', 2, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(4553, '6150', 182, 'bathroom_bath1', 4, 0, 0, 1, 0, 0, 2, 17963, 0, '', '1', '0'),
	(4554, '6151', 182, 'bathroom_toilet2', 4, 0, 0, 1, 0, 0, 26, -1, 0, '', '1', '0'),
	(4555, '6152', 182, 'bathroom_toiletroll', 4, 0, 0, 1, 0, 0, 29, 14164, 0, '', '1', '0'),
	(4556, '6153', 182, 'bathroom_shampoo', 4, 0, 0, 1, 0, 0, 12, 17980, 0, '', '1', '0'),
	(4557, '6154', 182, 'bathroom_floortile1', 2, 0, 0, 1, 0, 0, 7, 18804, 0, '', '1', '0'),
	(4558, '6155', 182, 'bathroom_shower2', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(4559, '6156', 182, 'bathroom_poop', 4, 0, 0, 1, 0, 0, 11, 14168, 0, '', '1', '0'),
	(4560, '6157', 182, 'bathroom_shower4', 4, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(4561, '6158', 182, 'bathroom_chamberpot', 4, 0, 0, 1, 0, 0, 6, 14170, 0, '', '1', '0'),
	(4562, '6159', 182, 'bathroom_tablemodule2', 2, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(4563, '6160', 182, 'bathroom_shower3', 4, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(4564, '6161', 182, 'bathroom_tablemodule3', 2, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(4565, '6162', 182, 'bathroom_sinkmodule1', 4, 0, 0, 1, 0, 0, 17, 14174, 0, '', '1', '0'),
	(4566, '6163', 114, 'st_uni_dnamodel', 4, 0, 0, 1, 0, 0, 1, 14175, 0, '', '1', '0'),
	(4567, '6164', 114, 'st_uni_testtubes', 4, 0, 0, 1, 0, 0, 6, 14176, 0, '', '1', '0'),
	(4568, '6165', 114, 'st_uni_labtable', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(4569, '6166', 114, 'st_uni_ooze', 4, 0, 0, 1, 0, 0, 3, 18087, 0, '', '1', '0'),
	(4570, '6167', 114, 'uni_einstein', 3, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(4571, '6168', 114, 'st_uni_solarsystem', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(4572, '6169', 36, 'matic_water_dispenser', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4573, '6170', 6, 'matic_chair', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(4574, '6171', 6, 'matic_brainjar', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(4575, '6172', 6, 'matic_slime_duck', 4, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(4576, '6173', 6, 'matic_door', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(4577, '6174', 395, 'hween14_crn', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(4578, '6175', 395, 'hween14_floor', 2, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(4579, '6176', 395, 'hween14_catrina', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(4580, '6177', 395, 'hween14_hccoffin', 4, 0, 0, 1, 0, 0, 31, 14220, 0, '', '1', '0'),
	(4581, '6178', 772, 'hween14_skelepieces', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(4582, '6179', 772, 'hween14_mariachi', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(4583, '6180', 395, 'hween14_table', 4, 0, 0, 1, 0, 0, 41, -1, 0, '', '1', '0'),
	(4584, '6181', 395, 'hween14_bench', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(4585, '6182', 395, 'hween14_doll5', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(4586, '6183', 395, 'hween14_carpet', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(4587, '6184', 395, 'hween14_lovelock', 4, 0, 0, 1, 0, 0, 34, -1, 0, '', '1', '0'),
	(4588, '6185', 395, 'hween14_candletrail', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(4589, '6186', 395, 'hween14_doll2', 4, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(4590, '6187', 395, 'hween14_doll8', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(4591, '6188', 395, 'hween14_doll6', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(4592, '6189', 395, 'hween14_doll1', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(4593, '6190', 395, 'hween14_gate', 4, 0, 0, 1, 0, 0, 27, -1, 0, '', '1', '0'),
	(4594, '6191', 395, 'hween14_goat', 4, 0, 0, 1, 0, 0, 28, -1, 0, '', '1', '0'),
	(4595, '6192', 395, 'hween14_doll7', 4, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(4596, '6193', 395, 'hween14_grossfood', 4, 0, 0, 1, 0, 0, 29, -1, 0, '', '1', '0'),
	(4597, '6194', 395, 'hween14_hctele', 4, 0, 0, 1, 0, 0, 33, 14237, 0, '', '1', '0'),
	(4598, '6195', 395, 'hween14_flowertrail', 4, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(4599, '6196', 395, 'hween14_doll10', 4, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(4600, '6197', 395, 'hween14_hangskull', 4, 0, 0, 1, 0, 0, 30, -1, 0, '', '1', '0'),
	(4601, '6198', 395, 'hween14_skullcandle', 4, 0, 0, 1, 0, 0, 38, -1, 0, '', '1', '0'),
	(4602, '6199', 395, 'hween14_rare2', 4, 0, 0, 1, 0, 0, 37, -1, 0, '', '1', '0'),
	(4603, '6200', 395, 'hween14_altarpieces1', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(4604, '6201', 395, 'hween14_teleport', 4, 0, 0, 1, 0, 0, 42, -1, 0, '', '1', '0'),
	(4605, '6202', 395, 'hween14_doll9', 4, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(4606, '6203', 772, 'hween14_doll3', 4, 0, 0, 1, 0, 0, -6, -1, 0, '', '1', '0'),
	(4607, '6204', 772, 'hween14_doll4', 4, 0, 0, 1, 0, 0, -8, -1, 0, '', '1', '0'),
	(4608, '6205', 395, 'hween14_chair', 2, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(4609, '6206', 395, 'hween14_food', 4, 0, 0, 1, 0, 0, 26, -1, 0, '', '1', '0'),
	(4610, '6207', 395, 'hween14_bed', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(4611, '6208', 395, 'hween14_altarpieces2', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(4612, '6209', 395, 'hween14_mirror', 4, 0, 0, 1, 0, 0, 35, -1, 0, '', '1', '0'),
	(4613, '6210', 395, 'hween14_flowerpot', 4, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(4614, '6211', 395, 'hween14_altarpieces3', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(4615, '6212', 395, 'hween14_divdr', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(4616, '6213', 395, 'hween14_skulllight', 4, 0, 0, 1, 0, 0, 39, -1, 0, '', '1', '0'),
	(4617, '6214', 395, 'hween14_demon', 4, 0, 0, 1, 0, 0, 12, 21590, 0, '', '1', '0'),
	(4618, '6215', 395, 'st_hween14_jack', 4, 0, 0, 1, 0, 0, 47, -1, 0, '', '1', '0'),
	(4619, '6216', 395, 'st_hween14_skulls', 4, 0, 0, 1, 0, 0, 49, -1, 0, '', '1', '0'),
	(4620, '6217', 395, 'hween14_carnivalbg', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(4621, '6218', 395, 'st_hween14_horse', 4, 0, 0, 1, 0, 0, 46, -1, 0, '', '1', '0'),
	(4622, '6219', 395, 'st_hween14_mbox', 4, 0, 0, 1, 0, 0, 48, -1, 0, '', '1', '0'),
	(4623, '6220', 395, 'st_hween14_fireplace', 4, 0, 0, 1, 0, 0, 45, -1, 0, '', '1', '0'),
	(4624, '6221', 395, 'st_hween14_closet', 4, 0, 0, 1, 0, 0, 44, -1, 0, '', '1', '0'),
	(4625, '6222', 307, 'CF_350_skull', 350, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(4626, '6223', 395, 'hween14_rare1', 4, 0, 0, 1, 0, 0, 36, -1, 0, '', '1', '0'),
	(4627, '6224', 280, 'limo_r_front', 4, 0, 0, 1, 0, 0, 63, -1, 0, '', '1', '0'),
	(4628, '6225', 280, 'limo_r_back', 4, 0, 0, 1, 0, 0, 62, -1, 0, '', '1', '0'),
	(4629, '6226', 280, 'limo_r_mid2', 4, 0, 0, 1, 0, 0, 65, -1, 0, '', '1', '0'),
	(4630, '6227', 280, 'limo_r_mid', 4, 0, 0, 1, 0, 0, 64, -1, 0, '', '1', '0'),
	(4631, '6228', 740, 'hween14_ltdalter', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(4632, '6229', 737, 'prizetrophy_mastercard', 5, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(4633, '6230', 484, 'xmas14_recliner', 4, 0, 0, 1, 0, 0, 34, -1, 0, '', '1', '0'),
	(4634, '6231', 484, 'xmas14_corner2', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(4635, '6232', 484, 'xmas14_stages1', 4, 0, 0, 1, 0, 0, 51, -1, 0, '', '1', '0'),
	(4636, '6233', 484, 'xmas14_tikibar2', 10, 0, 0, 1, 0, 0, 58, -1, 0, '', '1', '0'),
	(4637, '6234', 484, 'xmas14_beachhut', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(4638, '6235', 484, 'xmas14_divider', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(4639, '6236', 484, 'xmas14_tikibar', 4, 0, 0, 1, 0, 0, 57, -1, 0, '', '1', '0'),
	(4640, '6237', 484, 'xmas14_stages2', 4, 0, 0, 1, 0, 0, 52, -1, 0, '', '1', '0'),
	(4641, '6238', 484, 'xmas14_snowman', 4, 0, 0, 1, 0, 0, 50, -1, 0, '', '1', '0'),
	(4642, '6239', 484, 'xmas14_tele', 4, 0, 0, 1, 0, 0, 56, -1, 0, '', '1', '0'),
	(4643, '6240', 484, 'xmas14_corner1', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(4644, '6241', 484, 'xmas14_table', 4, 0, 0, 1, 0, 0, 55, -1, 0, '', '1', '0'),
	(4645, '6242', 484, 'xmas14_sunbeams', 4, 0, 0, 1, 0, 0, 54, -1, 0, '', '1', '0'),
	(4646, '6243', 484, 'xmas14_sand', 4, 0, 0, 1, 0, 0, 36, -1, 0, '', '1', '0'),
	(4647, '6244', 484, 'xmas14_gate1', 4, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(4648, '6245', 484, 'xmas14_chair', 2, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(4649, '6246', 484, 'xmas14_gate2', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(4650, '6247', 484, 'xmas14_lights1', 4, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(4651, '6248', 484, 'xmas14_lights2', 4, 0, 0, 1, 0, 0, 30, -1, 0, '', '1', '0'),
	(4652, '6249', 484, 'xmas14_starfish', 4, 0, 0, 1, 0, 0, 53, -1, 0, '', '1', '0'),
	(4653, '6250', 484, 'xmas14_inflatabletree', 2, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(4654, '6251', 484, 'xmas14_palm', 4, 0, 0, 1, 0, 0, 33, -1, 0, '', '1', '0'),
	(4655, '6252', 484, 'xmas14_mermaid', 4, 0, 0, 1, 0, 0, 31, -1, 0, '', '1', '0'),
	(4656, '6253', 484, 'xmas14_lobsterdin', 4, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(4657, '6254', 484, 'xmas14_festivehut', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(4658, '6255', 484, 'xmas14_octosanta', 4, 0, 0, 1, 0, 0, 32, -1, 0, '', '1', '0'),
	(4659, '6256', 484, 'xmas14_sharkthrone', 4, 0, 0, 1, 0, 0, 49, -1, 0, '', '1', '0'),
	(4660, '6257', 484, 'xmas14_boomboxman', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(4661, '6258', 484, 'xmas14_rudolph_ring', 4, 0, 0, 1, 0, 0, 35, -1, 0, '', '1', '0'),
	(4662, '6259', 740, 'xmas14_snowglobe', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(4663, '6260', 484, 'xmas14_tubeman', 4, 0, 0, 1, 0, 0, 59, -1, 0, '', '1', '0'),
	(4664, '6261', 484, 'xmas14_elf8', 4, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(4665, '6262', 484, 'xmas14_elf7', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(4666, '6263', 484, 'xmas14_elf3', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(4667, '6264', 484, 'xmas14_elf1', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(4668, '6265', 484, 'xmas14_elf5', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(4669, '6266', 484, 'xmas14_elf10', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(4670, '6267', 484, 'xmas14_elf2', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(4671, '6268', 484, 'xmas14_elf9', 4, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(4672, '6269', 484, 'xmas14_elf4', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(4673, '6270', 484, 'xmas14_elf6', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(4674, '6271', 355, 'hc_arab_tetbl', 5, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '1'),
	(4675, '6272', 355, 'hc_arab_bigtb', 5, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '1'),
	(4676, '6273', 484, 'xmas14_santateller', 4, 0, 0, 1, 0, 0, 38, -1, 0, '', '1', '0'),
	(4677, '6274', 49, 'memorial_size', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4678, '6275', 495, 'bc_blocktrophy_1', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4679, '6276', 484, 'xmas14_hammock', 4, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(4680, '6277', 484, 'xmas14_santastuck', 4, 0, 0, 1, 0, 0, 37, -1, 0, '', '1', '0'),
	(4681, '6278', 581, 'clothing_party1', 3, 0, 0, 1, 0, 0, 1, 14425, 0, '0', '1', '0'),
	(4682, '6279', 207, 'clothing_geometricskirt', 5, 0, 0, 1, 0, 0, 7, 14426, 0, '0', '1', '0'),
	(4683, '6280', 205, 'clothing_waistcoatsuit', 5, 0, 0, 1, 0, 0, 15, 14427, 0, '0', '1', '0'),
	(4684, '6281', 200, 'clothing_meowtfit', 18, 0, 0, 1, 0, 0, 36, 17849, 0, '0', '1', '0'),
	(4685, '6282', 201, 'clothing_gatsby', 6, 0, 0, 1, 0, 0, 59, 14429, 0, '0', '1', '0'),
	(4686, '6283', 310, 'clothing_bow', 6, 0, 0, 1, 0, 0, 80, 14430, 0, '0', '1', '0'),
	(4687, '6284', 202, 'clothing_squid', 6, 0, 0, 1, 0, 0, 37, 14431, 0, '0', '1', '0'),
	(4688, '6285', 201, 'clothing_baldy', 6, 0, 0, 1, 0, 0, 58, 14432, 0, '0', '1', '0'),
	(4689, '6286', 772, 'clothing_wavy2', 6, 0, 0, 1, 0, 0, 50, 14433, 0, '0', '1', '0'),
	(4690, '6287', 201, 'clothing_mutton1', 6, 0, 0, 1, 0, 0, 57, 14434, 0, '0', '1', '0'),
	(4691, '6288', 202, 'clothing_straw2', 4, 0, 0, 1, 0, 0, 36, 14435, 0, '0', '1', '0'),
	(4692, '6289', 570, 'clothing_fishhat', 6, 0, 0, 1, 0, 0, 26, -1, 0, '0', '1', '0'),
	(4693, '6290', 206, 'clothing_rolled_jeans', 3, 0, 0, 1, 0, 0, 14, 17879, 0, '0', '1', '0'),
	(4694, '6291', 208, 'clothing_birdshoes', 3, 0, 0, 1, 0, 0, 11, 18793, 0, '0', '1', '0'),
	(4695, '6292', 200, 'clothing_mermaidoutfit', 12, 0, 0, 1, 0, 0, 35, 14439, 0, '0', '1', '0'),
	(4696, '6293', 204, 'clothing_droopycollar', 3, 0, 0, 1, 0, 0, 38, 18795, 0, '0', '1', '0'),
	(4697, '6294', 310, 'clothing_headband', 6, 0, 0, 1, 0, 0, 79, 14441, 0, '0', '1', '0'),
	(4698, '6295', 202, 'clothing_flowercrown', 5, 0, 0, 1, 0, 0, 35, 14442, 0, '0', '1', '0'),
	(4699, '6296', 310, 'clothing_hheadphones', 6, 0, 0, 1, 0, 0, 78, 17898, 0, '0', '1', '0'),
	(4700, '6297', 201, 'clothing_mutton2', 2, 0, 0, 1, 0, 0, 56, 14444, 0, '0', '1', '0'),
	(4701, '6298', 207, 'clothing_floralskirt', 5, 0, 0, 1, 0, 0, 6, 14445, 0, '0', '1', '0'),
	(4702, '6299', 310, 'clothing_nightvision', 6, 0, 0, 1, 0, 0, 77, 14446, 0, '0', '1', '0'),
	(4703, '6300', 588, 'clothing_mockymouse', 10, 0, 0, 1, 0, 0, 3, 17844, 0, '0', '1', '0'),
	(4704, '6301', 204, 'clothing_xmas1', 5, 0, 0, 1, 0, 0, 37, 14448, 0, '0', '1', '0'),
	(4705, '6302', 201, 'clothing_shavedside', 3, 0, 0, 1, 0, 0, 55, 17873, 0, '0', '1', '0'),
	(4706, '6303', 204, 'clothing_geometricjumper', 5, 0, 0, 1, 0, 0, 36, 14450, 0, '0', '1', '0'),
	(4707, '6304', 201, 'clothing_beard1', 2, 0, 0, 1, 0, 0, 54, 14451, 0, '0', '1', '0'),
	(4708, '6305', 310, 'clothing_beads', 6, 0, 0, 1, 0, 0, 76, 14452, 0, '0', '1', '0'),
	(4709, '6306', 204, 'clothing_twotonecardi', 5, 0, 0, 1, 0, 0, 35, 14453, 0, '0', '1', '0'),
	(4710, '6307', 206, 'clothing_animalprint', 5, 0, 0, 1, 0, 0, 13, 14454, 0, '0', '1', '0'),
	(4711, '6308', 581, 'clothing_party2', 3, 0, 0, 1, 0, 0, 2, 17877, 0, '0', '1', '0'),
	(4712, '6309', 204, 'clothing_tshirt_rolled', 3, 0, 0, 1, 0, 0, 34, 18801, 0, '0', '1', '0'),
	(4713, '6310', 588, 'clothing_rippedjeans', 5, 0, 0, 1, 0, 0, 9, 14457, 0, '0', '1', '0'),
	(4714, '6311', 208, 'clothing_shoestights', 4, 0, 0, 1, 0, 0, 10, 14458, 0, '0', '1', '0'),
	(4715, '6312', 115, 'pet_puppy_toy', 2, 0, 0, 1, 0, 0, 6, 14460, 0, '', '1', '0'),
	(4716, '6313', 115, 'pet_ufo_toy', 2, 0, 0, 1, 0, 0, 5, 14461, 0, '', '1', '0'),
	(4717, '6314', 115, 'yarn', 2, 0, 0, 1, 0, 0, 1, 17920, 0, '', '1', '0'),
	(4718, '6315', 115, 'nest_pig', 2, 0, 0, 1, 0, 0, 3, 14463, 0, '', '1', '0'),
	(4719, '6316', 115, 'nest_bed', 2, 0, 0, 1, 0, 0, 2, 14464, 0, '', '1', '0'),
	(4720, '6317', 115, 'nest_box', 2, 0, 0, 1, 0, 0, 2, 14465, 0, '', '1', '0'),
	(4721, '6318', 423, 'fxbox_fx147', 3, 0, 0, 1, 0, 0, 6, 14466, 0, '', '1', '0'),
	(4722, '6319', 423, 'fxbox_fx92', 3, 0, 0, 1, 0, 0, 1, 18808, 0, '', '1', '0'),
	(4723, '6320', 423, 'fxbox_fx123', 3, 0, 0, 1, 0, 0, 10, 14468, 0, '', '1', '0'),
	(4724, '6321', 423, 'fxbox_fx153', 3, 0, 0, 1, 0, 0, 4, 14469, 0, '', '1', '0'),
	(4725, '6322', 772, 'fxbox_fx152', 3, 0, 0, 1, 0, 0, 5, 14470, 0, '', '1', '0'),
	(4726, '6323', 423, 'fxbox_fx116', 3, 0, 0, 1, 0, 0, 11, 14471, 0, '', '1', '0'),
	(4727, '6324', 772, 'fxbox_fx125', 3, 0, 0, 1, 0, 0, 10, 14472, 0, '', '1', '0'),
	(4728, '6325', 423, 'fxbox_fx143', 3, 0, 0, 1, 0, 0, 7, 14473, 0, '', '1', '0'),
	(4729, '6326', 423, 'fxbox_fx127', 3, 0, 0, 1, 0, 0, 8, 14474, 0, '', '1', '0'),
	(4730, '6327', 423, 'fxbox_fx126', 3, 0, 0, 1, 0, 0, 9, 14475, 0, '', '1', '0'),
	(4731, '6328', 472, 'ny2015_floor2', 1, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(4732, '6329', 472, 'ny2015_archway', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(4733, '6330', 472, 'ny2015_balloons', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(4734, '6331', 472, 'ny2015_chocfountain', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(4735, '6332', 472, 'ny2015_conball', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(4736, '6333', 472, 'ny2015_bar', 10, 0, 0, 1, 0, 0, 3, 24152, 0, '', '1', '0'),
	(4737, '6334', 472, 'ny2015_table', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(4738, '6335', 472, 'ny2015_cctray', 10, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(4739, '6336', 472, 'ny2015_floor1', 1, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(4740, '6337', 472, 'ny2015_drktray', 10, 0, 0, 1, 0, 0, 7, 24152, 0, '', '1', '0'),
	(4741, '6338', 355, 'hc_arab_tray3', 5, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '1'),
	(4742, '6339', 355, 'hc_arab_tray1', 5, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '1'),
	(4743, '6340', 355, 'hc_arab_rug', 5, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '1'),
	(4744, '6341', 355, 'hc_arab_chair', 5, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '1'),
	(4745, '6342', 355, 'hc_arab_divdr', 5, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '1'),
	(4746, '6343', 355, 'hc_arab_teamk', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '1'),
	(4747, '6344', 355, 'hc_arab_snake', 5, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '1'),
	(4748, '6345', 355, 'hc_arab_pllw', 5, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '1'),
	(4749, '6346', 278, 'pet_breeding_dog', 15, 0, 0, 1, 0, 0, 99, -1, 0, '0', '1', '0'),
	(4750, '6347', 278, 'pet_breeding_pig', 15, 0, 0, 1, 0, 0, 99, -1, 0, '0', '1', '0'),
	(4751, '6348', 278, 'pet_breeding_cat', 15, 0, 0, 1, 0, 0, 99, -1, 0, '0', '1', '0'),
	(4752, '6349', 547, 'ads_vpiggy_santapig', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4753, '6350', 130, 'bc_pyramidtip*1', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4754, '6351', 130, 'bc_pyramidtip*10', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4755, '6352', 130, 'bc_pyramidtip*11', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4756, '6353', 130, 'bc_pyramidtip*12', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4757, '6354', 130, 'bc_pyramidtip*13', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4758, '6355', 130, 'bc_pyramidtip*14', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4759, '6356', 130, 'bc_pyramidtip*15', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4760, '6357', 130, 'bc_pyramidtip*16', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4761, '6358', 130, 'bc_pyramidtip*17', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4762, '6359', 130, 'bc_pyramidtip*18', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4763, '6360', 130, 'bc_pyramidtip*19', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4764, '6361', 130, 'bc_pyramidtip*2', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4765, '6362', 130, 'bc_pyramidtip*20', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4766, '6363', 130, 'bc_pyramidtip*21', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4767, '6364', 130, 'bc_pyramidtip*22', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4768, '6365', 130, 'bc_pyramidtip*23', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4769, '6366', 130, 'bc_pyramidtip*24', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4770, '6367', 130, 'bc_pyramidtip*25', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4771, '6368', 130, 'bc_pyramidtip*26', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4772, '6369', 130, 'bc_pyramidtip*27', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4773, '6370', 130, 'bc_pyramidtip*28', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4774, '6371', 130, 'bc_pyramidtip*29', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4775, '6372', 130, 'bc_pyramidtip*3', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4776, '6373', 130, 'bc_pyramidtip*30', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4777, '6374', 130, 'bc_pyramidtip*31', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4778, '6375', 130, 'bc_pyramidtip*32', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4779, '6376', 130, 'bc_pyramidtip*33', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4780, '6377', 130, 'bc_pyramidtip*34', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4781, '6378', 130, 'bc_pyramidtip*35', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4782, '6379', 130, 'bc_pyramidtip*36', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4783, '6380', 130, 'bc_pyramidtip*37', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4784, '6381', 130, 'bc_pyramidtip*38', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4785, '6382', 130, 'bc_pyramidtip*39', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4786, '6383', 130, 'bc_pyramidtip*4', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4787, '6384', 130, 'bc_pyramidtip*40', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4788, '6385', 130, 'bc_pyramidtip*41', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4789, '6386', 130, 'bc_pyramidtip*42', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4790, '6387', 130, 'bc_pyramidtip*43', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4791, '6388', 130, 'bc_pyramidtip*44', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4792, '6389', 130, 'bc_pyramidtip*45', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4793, '6390', 130, 'bc_pyramidtip*46', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4794, '6391', 130, 'bc_pyramidtip*47', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4795, '6392', 130, 'bc_pyramidtip*48', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4796, '6393', 130, 'bc_pyramidtip*49', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4797, '6394', 130, 'bc_pyramidtip*5', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4798, '6395', 130, 'bc_pyramidtip*50', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4799, '6396', 130, 'bc_pyramidtip*51', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4800, '6397', 130, 'bc_pyramidtip*52', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4801, '6398', 130, 'bc_pyramidtip*53', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4802, '6399', 130, 'bc_pyramidtip*54', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4803, '6400', 130, 'bc_pyramidtip*55', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4804, '6401', 130, 'bc_pyramidtip*56', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4805, '6402', 130, 'bc_pyramidtip*57', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4806, '6403', 130, 'bc_pyramidtip*58', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4807, '6404', 130, 'bc_pyramidtip*59', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4808, '6405', 130, 'bc_pyramidtip*6', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4809, '6406', 130, 'bc_pyramidtip*60', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4810, '6407', 130, 'bc_pyramidtip*61', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4811, '6408', 130, 'bc_pyramidtip*62', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4812, '6409', 130, 'bc_pyramidtip*63', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4813, '6410', 130, 'bc_pyramidtip*64', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4814, '6411', 130, 'bc_pyramidtip*65', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4815, '6412', 130, 'bc_pyramidtip*66', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4816, '6413', 130, 'bc_pyramidtip*67', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4817, '6414', 130, 'bc_pyramidtip*68', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4818, '6415', 130, 'bc_pyramidtip*69', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4819, '6416', 130, 'bc_pyramidtip*7', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4820, '6417', 130, 'bc_pyramidtip*8', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4821, '6418', 130, 'bc_pyramidtip*9', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4822, '6419', 126, 'bc_cone*1', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4823, '6420', 126, 'bc_cone*10', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4824, '6421', 126, 'bc_cone*11', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4825, '6422', 126, 'bc_cone*12', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4826, '6423', 126, 'bc_cone*13', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4827, '6424', 126, 'bc_cone*14', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4828, '6425', 126, 'bc_cone*15', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4829, '6426', 126, 'bc_cone*16', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4830, '6427', 126, 'bc_cone*17', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4831, '6428', 126, 'bc_cone*18', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4832, '6429', 126, 'bc_cone*19', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4833, '6430', 126, 'bc_cone*2', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4834, '6431', 126, 'bc_cone*20', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4835, '6432', 126, 'bc_cone*21', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4836, '6433', 126, 'bc_cone*22', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4837, '6434', 126, 'bc_cone*23', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4838, '6435', 126, 'bc_cone*24', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4839, '6436', 126, 'bc_cone*25', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4840, '6437', 126, 'bc_cone*26', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4841, '6438', 126, 'bc_cone*27', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4842, '6439', 126, 'bc_cone*28', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4843, '6440', 126, 'bc_cone*29', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4844, '6441', 126, 'bc_cone*3', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4845, '6442', 126, 'bc_cone*30', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4846, '6443', 126, 'bc_cone*31', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4847, '6444', 126, 'bc_cone*32', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4848, '6445', 126, 'bc_cone*33', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4849, '6446', 126, 'bc_cone*34', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4850, '6447', 126, 'bc_cone*35', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4851, '6448', 126, 'bc_cone*36', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4852, '6449', 126, 'bc_cone*37', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4853, '6450', 126, 'bc_cone*38', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4854, '6451', 126, 'bc_cone*39', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4855, '6452', 126, 'bc_cone*4', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4856, '6453', 126, 'bc_cone*40', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4857, '6454', 126, 'bc_cone*41', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4858, '6455', 126, 'bc_cone*42', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4859, '6456', 126, 'bc_cone*43', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4860, '6457', 126, 'bc_cone*44', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4861, '6458', 126, 'bc_cone*45', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4862, '6459', 126, 'bc_cone*46', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4863, '6460', 126, 'bc_cone*47', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4864, '6461', 126, 'bc_cone*48', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4865, '6462', 126, 'bc_cone*49', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4866, '6463', 126, 'bc_cone*5', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4867, '6464', 126, 'bc_cone*50', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4868, '6465', 126, 'bc_cone*51', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4869, '6466', 126, 'bc_cone*52', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4870, '6467', 126, 'bc_cone*53', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4871, '6468', 126, 'bc_cone*54', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4872, '6469', 126, 'bc_cone*55', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4873, '6470', 126, 'bc_cone*56', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4874, '6471', 126, 'bc_cone*57', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4875, '6472', 126, 'bc_cone*58', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4876, '6473', 126, 'bc_cone*59', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4877, '6474', 126, 'bc_cone*6', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4878, '6475', 126, 'bc_cone*60', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4879, '6476', 126, 'bc_cone*61', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4880, '6477', 126, 'bc_cone*62', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4881, '6478', 126, 'bc_cone*63', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4882, '6479', 126, 'bc_cone*64', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4883, '6480', 126, 'bc_cone*65', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4884, '6481', 126, 'bc_cone*66', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4885, '6482', 126, 'bc_cone*67', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4886, '6483', 126, 'bc_cone*68', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4887, '6484', 126, 'bc_cone*69', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4888, '6485', 126, 'bc_cone*7', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4889, '6486', 126, 'bc_cone*8', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4890, '6487', 126, 'bc_cone*9', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4891, '6488', 133, 'bc_standinghalfcylinder*1', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4892, '6489', 133, 'bc_standinghalfcylinder*10', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4893, '6490', 133, 'bc_standinghalfcylinder*11', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4894, '6491', 133, 'bc_standinghalfcylinder*12', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4895, '6492', 133, 'bc_standinghalfcylinder*13', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4896, '6493', 133, 'bc_standinghalfcylinder*14', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4897, '6494', 133, 'bc_standinghalfcylinder*15', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4898, '6495', 133, 'bc_standinghalfcylinder*16', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4899, '6496', 133, 'bc_standinghalfcylinder*17', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4900, '6497', 133, 'bc_standinghalfcylinder*18', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4901, '6498', 133, 'bc_standinghalfcylinder*19', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4902, '6499', 133, 'bc_standinghalfcylinder*2', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4903, '6500', 133, 'bc_standinghalfcylinder*20', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4904, '6501', 133, 'bc_standinghalfcylinder*21', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4905, '6502', 133, 'bc_standinghalfcylinder*22', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4906, '6503', 133, 'bc_standinghalfcylinder*23', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4907, '6504', 133, 'bc_standinghalfcylinder*24', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4908, '6505', 133, 'bc_standinghalfcylinder*25', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4909, '6506', 133, 'bc_standinghalfcylinder*26', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4910, '6507', 133, 'bc_standinghalfcylinder*27', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4911, '6508', 133, 'bc_standinghalfcylinder*28', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4912, '6509', 133, 'bc_standinghalfcylinder*29', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4913, '6510', 133, 'bc_standinghalfcylinder*3', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4914, '6511', 133, 'bc_standinghalfcylinder*30', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4915, '6512', 133, 'bc_standinghalfcylinder*31', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4916, '6513', 133, 'bc_standinghalfcylinder*32', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4917, '6514', 133, 'bc_standinghalfcylinder*33', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4918, '6515', 133, 'bc_standinghalfcylinder*34', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4919, '6516', 133, 'bc_standinghalfcylinder*35', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4920, '6517', 133, 'bc_standinghalfcylinder*36', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4921, '6518', 133, 'bc_standinghalfcylinder*37', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4922, '6519', 133, 'bc_standinghalfcylinder*38', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4923, '6520', 133, 'bc_standinghalfcylinder*39', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4924, '6521', 133, 'bc_standinghalfcylinder*4', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4925, '6522', 133, 'bc_standinghalfcylinder*40', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4926, '6523', 133, 'bc_standinghalfcylinder*41', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4927, '6524', 133, 'bc_standinghalfcylinder*42', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4928, '6525', 133, 'bc_standinghalfcylinder*43', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4929, '6526', 133, 'bc_standinghalfcylinder*44', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4930, '6527', 133, 'bc_standinghalfcylinder*45', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4931, '6528', 133, 'bc_standinghalfcylinder*46', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4932, '6529', 133, 'bc_standinghalfcylinder*47', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4933, '6530', 133, 'bc_standinghalfcylinder*48', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4934, '6531', 133, 'bc_standinghalfcylinder*49', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4935, '6532', 133, 'bc_standinghalfcylinder*5', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4936, '6533', 133, 'bc_standinghalfcylinder*50', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4937, '6534', 133, 'bc_standinghalfcylinder*51', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4938, '6535', 133, 'bc_standinghalfcylinder*52', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4939, '6536', 133, 'bc_standinghalfcylinder*53', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4940, '6537', 133, 'bc_standinghalfcylinder*54', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4941, '6538', 133, 'bc_standinghalfcylinder*55', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4942, '6539', 133, 'bc_standinghalfcylinder*56', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4943, '6540', 133, 'bc_standinghalfcylinder*57', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4944, '6541', 133, 'bc_standinghalfcylinder*58', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4945, '6542', 133, 'bc_standinghalfcylinder*59', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4946, '6543', 133, 'bc_standinghalfcylinder*6', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4947, '6544', 133, 'bc_standinghalfcylinder*60', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4948, '6545', 133, 'bc_standinghalfcylinder*61', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4949, '6546', 133, 'bc_standinghalfcylinder*62', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4950, '6547', 133, 'bc_standinghalfcylinder*63', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4951, '6548', 133, 'bc_standinghalfcylinder*64', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4952, '6549', 133, 'bc_standinghalfcylinder*65', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4953, '6550', 133, 'bc_standinghalfcylinder*66', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4954, '6551', 133, 'bc_standinghalfcylinder*67', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4955, '6552', 133, 'bc_standinghalfcylinder*68', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4956, '6553', 133, 'bc_standinghalfcylinder*69', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4957, '6554', 133, 'bc_standinghalfcylinder*7', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4958, '6555', 133, 'bc_standinghalfcylinder*8', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4959, '6556', 133, 'bc_standinghalfcylinder*9', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4960, '6557', 129, 'bc_hemisphere*1', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4961, '6558', 129, 'bc_hemisphere*10', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4962, '6559', 129, 'bc_hemisphere*11', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4963, '6560', 129, 'bc_hemisphere*12', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4964, '6561', 129, 'bc_hemisphere*13', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4965, '6562', 129, 'bc_hemisphere*14', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4966, '6563', 129, 'bc_hemisphere*15', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4967, '6564', 129, 'bc_hemisphere*16', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4968, '6565', 129, 'bc_hemisphere*17', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4969, '6566', 129, 'bc_hemisphere*18', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4970, '6567', 129, 'bc_hemisphere*19', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4971, '6568', 129, 'bc_hemisphere*2', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4972, '6569', 129, 'bc_hemisphere*20', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4973, '6570', 129, 'bc_hemisphere*21', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4974, '6571', 129, 'bc_hemisphere*22', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4975, '6572', 129, 'bc_hemisphere*23', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4976, '6573', 129, 'bc_hemisphere*24', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4977, '6574', 129, 'bc_hemisphere*25', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4978, '6575', 129, 'bc_hemisphere*26', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4979, '6576', 129, 'bc_hemisphere*27', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4980, '6577', 129, 'bc_hemisphere*28', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4981, '6578', 129, 'bc_hemisphere*29', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4982, '6579', 129, 'bc_hemisphere*3', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4983, '6580', 129, 'bc_hemisphere*30', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4984, '6581', 129, 'bc_hemisphere*31', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4985, '6582', 129, 'bc_hemisphere*32', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4986, '6583', 129, 'bc_hemisphere*33', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4987, '6584', 129, 'bc_hemisphere*34', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4988, '6585', 129, 'bc_hemisphere*35', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4989, '6586', 129, 'bc_hemisphere*36', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4990, '6587', 129, 'bc_hemisphere*37', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4991, '6588', 129, 'bc_hemisphere*38', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4992, '6589', 129, 'bc_hemisphere*39', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4993, '6590', 129, 'bc_hemisphere*4', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4994, '6591', 129, 'bc_hemisphere*40', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4995, '6592', 129, 'bc_hemisphere*41', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4996, '6593', 129, 'bc_hemisphere*42', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4997, '6594', 129, 'bc_hemisphere*43', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4998, '6595', 129, 'bc_hemisphere*44', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(4999, '6596', 129, 'bc_hemisphere*45', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5000, '6597', 129, 'bc_hemisphere*46', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5001, '6598', 129, 'bc_hemisphere*47', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5002, '6599', 129, 'bc_hemisphere*48', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5003, '6600', 129, 'bc_hemisphere*49', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5004, '6601', 129, 'bc_hemisphere*5', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5005, '6602', 129, 'bc_hemisphere*50', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5006, '6603', 129, 'bc_hemisphere*51', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5007, '6604', 129, 'bc_hemisphere*52', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5008, '6605', 129, 'bc_hemisphere*53', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5009, '6606', 129, 'bc_hemisphere*54', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5010, '6607', 129, 'bc_hemisphere*55', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5011, '6608', 129, 'bc_hemisphere*56', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5012, '6609', 129, 'bc_hemisphere*57', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5013, '6610', 129, 'bc_hemisphere*58', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5014, '6611', 129, 'bc_hemisphere*59', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5015, '6612', 129, 'bc_hemisphere*6', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5016, '6613', 129, 'bc_hemisphere*60', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5017, '6614', 129, 'bc_hemisphere*61', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5018, '6615', 129, 'bc_hemisphere*62', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5019, '6616', 129, 'bc_hemisphere*63', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5020, '6617', 129, 'bc_hemisphere*64', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5021, '6618', 129, 'bc_hemisphere*65', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5022, '6619', 129, 'bc_hemisphere*66', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5023, '6620', 129, 'bc_hemisphere*67', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5024, '6621', 129, 'bc_hemisphere*68', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5025, '6622', 129, 'bc_hemisphere*69', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5026, '6623', 129, 'bc_hemisphere*7', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5027, '6624', 129, 'bc_hemisphere*8', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5028, '6625', 129, 'bc_hemisphere*9', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5029, '6626', 128, 'bc_halfcylinder*1', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5030, '6627', 128, 'bc_halfcylinder*10', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5031, '6628', 128, 'bc_halfcylinder*11', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5032, '6629', 128, 'bc_halfcylinder*12', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5033, '6630', 128, 'bc_halfcylinder*13', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5034, '6631', 128, 'bc_halfcylinder*14', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5035, '6632', 128, 'bc_halfcylinder*15', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5036, '6633', 128, 'bc_halfcylinder*16', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5037, '6634', 128, 'bc_halfcylinder*17', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5038, '6635', 128, 'bc_halfcylinder*18', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5039, '6636', 128, 'bc_halfcylinder*19', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5040, '6637', 128, 'bc_halfcylinder*2', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5041, '6638', 128, 'bc_halfcylinder*20', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5042, '6639', 128, 'bc_halfcylinder*21', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5043, '6640', 128, 'bc_halfcylinder*22', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5044, '6641', 128, 'bc_halfcylinder*23', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5045, '6642', 128, 'bc_halfcylinder*24', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5046, '6643', 128, 'bc_halfcylinder*25', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5047, '6644', 128, 'bc_halfcylinder*26', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5048, '6645', 128, 'bc_halfcylinder*27', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5049, '6646', 128, 'bc_halfcylinder*28', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5050, '6647', 128, 'bc_halfcylinder*29', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5051, '6648', 128, 'bc_halfcylinder*3', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5052, '6649', 128, 'bc_halfcylinder*30', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5053, '6650', 128, 'bc_halfcylinder*31', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5054, '6651', 128, 'bc_halfcylinder*32', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5055, '6652', 128, 'bc_halfcylinder*33', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5056, '6653', 128, 'bc_halfcylinder*34', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5057, '6654', 128, 'bc_halfcylinder*35', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5058, '6655', 128, 'bc_halfcylinder*36', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5059, '6656', 128, 'bc_halfcylinder*37', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5060, '6657', 128, 'bc_halfcylinder*38', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5061, '6658', 128, 'bc_halfcylinder*39', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5062, '6659', 128, 'bc_halfcylinder*4', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5063, '6660', 128, 'bc_halfcylinder*40', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5064, '6661', 128, 'bc_halfcylinder*41', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5065, '6662', 128, 'bc_halfcylinder*42', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5066, '6663', 128, 'bc_halfcylinder*43', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5067, '6664', 128, 'bc_halfcylinder*44', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5068, '6665', 128, 'bc_halfcylinder*45', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5069, '6666', 128, 'bc_halfcylinder*46', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5070, '6667', 128, 'bc_halfcylinder*47', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5071, '6668', 128, 'bc_halfcylinder*48', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5072, '6669', 128, 'bc_halfcylinder*49', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5073, '6670', 128, 'bc_halfcylinder*5', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5074, '6671', 128, 'bc_halfcylinder*50', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5075, '6672', 128, 'bc_halfcylinder*51', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5076, '6673', 128, 'bc_halfcylinder*52', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5077, '6674', 128, 'bc_halfcylinder*53', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5078, '6675', 128, 'bc_halfcylinder*54', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5079, '6676', 128, 'bc_halfcylinder*55', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5080, '6677', 128, 'bc_halfcylinder*56', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5081, '6678', 128, 'bc_halfcylinder*57', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5082, '6679', 128, 'bc_halfcylinder*58', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5083, '6680', 128, 'bc_halfcylinder*59', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5084, '6681', 128, 'bc_halfcylinder*6', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5085, '6682', 128, 'bc_halfcylinder*60', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5086, '6683', 128, 'bc_halfcylinder*61', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5087, '6684', 128, 'bc_halfcylinder*62', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5088, '6685', 128, 'bc_halfcylinder*63', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5089, '6686', 128, 'bc_halfcylinder*64', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5090, '6687', 128, 'bc_halfcylinder*65', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5091, '6688', 128, 'bc_halfcylinder*66', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5092, '6689', 128, 'bc_halfcylinder*67', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5093, '6690', 128, 'bc_halfcylinder*68', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5094, '6691', 128, 'bc_halfcylinder*69', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5095, '6692', 128, 'bc_halfcylinder*7', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5096, '6693', 128, 'bc_halfcylinder*8', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5097, '6694', 128, 'bc_halfcylinder*9', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5098, '6695', 131, 'bc_quarterring*1', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5099, '6696', 131, 'bc_quarterring*10', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5100, '6697', 131, 'bc_quarterring*11', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5101, '6698', 131, 'bc_quarterring*12', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5102, '6699', 131, 'bc_quarterring*13', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5103, '6700', 131, 'bc_quarterring*14', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5104, '6701', 131, 'bc_quarterring*15', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5105, '6702', 131, 'bc_quarterring*16', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5106, '6703', 131, 'bc_quarterring*17', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5107, '6704', 131, 'bc_quarterring*18', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5108, '6705', 131, 'bc_quarterring*19', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5109, '6706', 131, 'bc_quarterring*2', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5110, '6707', 131, 'bc_quarterring*20', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5111, '6708', 131, 'bc_quarterring*21', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5112, '6709', 131, 'bc_quarterring*22', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5113, '6710', 131, 'bc_quarterring*23', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5114, '6711', 131, 'bc_quarterring*24', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5115, '6712', 131, 'bc_quarterring*25', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5116, '6713', 131, 'bc_quarterring*26', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5117, '6714', 131, 'bc_quarterring*27', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5118, '6715', 131, 'bc_quarterring*28', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5119, '6716', 131, 'bc_quarterring*29', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5120, '6717', 131, 'bc_quarterring*3', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5121, '6718', 131, 'bc_quarterring*30', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5122, '6719', 131, 'bc_quarterring*31', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5123, '6720', 131, 'bc_quarterring*32', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5124, '6721', 131, 'bc_quarterring*33', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5125, '6722', 131, 'bc_quarterring*34', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5126, '6723', 131, 'bc_quarterring*35', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5127, '6724', 131, 'bc_quarterring*36', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5128, '6725', 131, 'bc_quarterring*37', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5129, '6726', 131, 'bc_quarterring*38', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5130, '6727', 131, 'bc_quarterring*39', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5131, '6728', 131, 'bc_quarterring*4', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5132, '6729', 131, 'bc_quarterring*40', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5133, '6730', 131, 'bc_quarterring*41', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5134, '6731', 131, 'bc_quarterring*42', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5135, '6732', 131, 'bc_quarterring*43', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5136, '6733', 131, 'bc_quarterring*44', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5137, '6734', 131, 'bc_quarterring*45', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5138, '6735', 131, 'bc_quarterring*46', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5139, '6736', 131, 'bc_quarterring*47', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5140, '6737', 131, 'bc_quarterring*48', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5141, '6738', 131, 'bc_quarterring*49', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5142, '6739', 131, 'bc_quarterring*5', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5143, '6740', 131, 'bc_quarterring*50', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5144, '6741', 131, 'bc_quarterring*51', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5145, '6742', 131, 'bc_quarterring*52', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5146, '6743', 131, 'bc_quarterring*53', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5147, '6744', 131, 'bc_quarterring*54', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5148, '6745', 131, 'bc_quarterring*55', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5149, '6746', 131, 'bc_quarterring*56', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5150, '6747', 131, 'bc_quarterring*57', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5151, '6748', 131, 'bc_quarterring*58', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5152, '6749', 131, 'bc_quarterring*59', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5153, '6750', 131, 'bc_quarterring*6', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5154, '6751', 131, 'bc_quarterring*60', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5155, '6752', 131, 'bc_quarterring*61', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5156, '6753', 131, 'bc_quarterring*62', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5157, '6754', 131, 'bc_quarterring*63', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5158, '6755', 131, 'bc_quarterring*64', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5159, '6756', 131, 'bc_quarterring*65', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5160, '6757', 131, 'bc_quarterring*66', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5161, '6758', 131, 'bc_quarterring*67', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5162, '6759', 131, 'bc_quarterring*68', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5163, '6760', 131, 'bc_quarterring*69', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5164, '6761', 131, 'bc_quarterring*7', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5165, '6762', 131, 'bc_quarterring*8', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5166, '6763', 131, 'bc_quarterring*9', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5167, '6764', 137, 'bc_glasspanel*1', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5168, '6765', 137, 'bc_glasspanel*10', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5169, '6766', 137, 'bc_glasspanel*11', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5170, '6767', 137, 'bc_glasspanel*12', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5171, '6768', 137, 'bc_glasspanel*13', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5172, '6769', 137, 'bc_glasspanel*14', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5173, '6770', 137, 'bc_glasspanel*15', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5174, '6771', 137, 'bc_glasspanel*16', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5175, '6772', 137, 'bc_glasspanel*17', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5176, '6773', 137, 'bc_glasspanel*18', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5177, '6774', 137, 'bc_glasspanel*19', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5178, '6775', 137, 'bc_glasspanel*2', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5179, '6776', 137, 'bc_glasspanel*20', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5180, '6777', 137, 'bc_glasspanel*21', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5181, '6778', 137, 'bc_glasspanel*22', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5182, '6779', 137, 'bc_glasspanel*23', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5183, '6780', 137, 'bc_glasspanel*24', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5184, '6781', 137, 'bc_glasspanel*25', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5185, '6782', 137, 'bc_glasspanel*26', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5186, '6783', 137, 'bc_glasspanel*27', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5187, '6784', 137, 'bc_glasspanel*28', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5188, '6785', 137, 'bc_glasspanel*29', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5189, '6786', 137, 'bc_glasspanel*3', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5190, '6787', 137, 'bc_glasspanel*30', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5191, '6788', 137, 'bc_glasspanel*31', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5192, '6789', 137, 'bc_glasspanel*32', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5193, '6790', 137, 'bc_glasspanel*33', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5194, '6791', 137, 'bc_glasspanel*34', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5195, '6792', 137, 'bc_glasspanel*35', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5196, '6793', 137, 'bc_glasspanel*36', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5197, '6794', 137, 'bc_glasspanel*37', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5198, '6795', 137, 'bc_glasspanel*38', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5199, '6796', 137, 'bc_glasspanel*39', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5200, '6797', 137, 'bc_glasspanel*4', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5201, '6798', 137, 'bc_glasspanel*40', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5202, '6799', 137, 'bc_glasspanel*41', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5203, '6800', 137, 'bc_glasspanel*42', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5204, '6801', 137, 'bc_glasspanel*43', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5205, '6802', 137, 'bc_glasspanel*44', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5206, '6803', 137, 'bc_glasspanel*45', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5207, '6804', 137, 'bc_glasspanel*46', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5208, '6805', 137, 'bc_glasspanel*47', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5209, '6806', 137, 'bc_glasspanel*48', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5210, '6807', 137, 'bc_glasspanel*49', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5211, '6808', 137, 'bc_glasspanel*5', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5212, '6809', 137, 'bc_glasspanel*50', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5213, '6810', 137, 'bc_glasspanel*51', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5214, '6811', 137, 'bc_glasspanel*52', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5215, '6812', 137, 'bc_glasspanel*53', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5216, '6813', 137, 'bc_glasspanel*54', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5217, '6814', 137, 'bc_glasspanel*55', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5218, '6815', 137, 'bc_glasspanel*56', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5219, '6816', 137, 'bc_glasspanel*57', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5220, '6817', 137, 'bc_glasspanel*58', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5221, '6818', 137, 'bc_glasspanel*59', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5222, '6819', 137, 'bc_glasspanel*6', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5223, '6820', 137, 'bc_glasspanel*60', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5224, '6821', 137, 'bc_glasspanel*61', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5225, '6822', 137, 'bc_glasspanel*62', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5226, '6823', 137, 'bc_glasspanel*63', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5227, '6824', 137, 'bc_glasspanel*64', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5228, '6825', 137, 'bc_glasspanel*65', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5229, '6826', 137, 'bc_glasspanel*66', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5230, '6827', 137, 'bc_glasspanel*67', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5231, '6828', 137, 'bc_glasspanel*68', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5232, '6829', 137, 'bc_glasspanel*69', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5233, '6830', 137, 'bc_glasspanel*7', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5234, '6831', 137, 'bc_glasspanel*8', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5235, '6832', 137, 'bc_glasspanel*9', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5236, '6833', 135, 'bc_wedge*1', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5237, '6834', 135, 'bc_wedge*10', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5238, '6835', 135, 'bc_wedge*11', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5239, '6836', 135, 'bc_wedge*12', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5240, '6837', 135, 'bc_wedge*13', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5241, '6838', 135, 'bc_wedge*14', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5242, '6839', 135, 'bc_wedge*15', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5243, '6840', 135, 'bc_wedge*16', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5244, '6841', 135, 'bc_wedge*17', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5245, '6842', 135, 'bc_wedge*18', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5246, '6843', 135, 'bc_wedge*19', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5247, '6844', 135, 'bc_wedge*2', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5248, '6845', 135, 'bc_wedge*20', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5249, '6846', 135, 'bc_wedge*21', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5250, '6847', 135, 'bc_wedge*22', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5251, '6848', 135, 'bc_wedge*23', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5252, '6849', 135, 'bc_wedge*24', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5253, '6850', 135, 'bc_wedge*25', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5254, '6851', 135, 'bc_wedge*26', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5255, '6852', 135, 'bc_wedge*27', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5256, '6853', 135, 'bc_wedge*28', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5257, '6854', 135, 'bc_wedge*29', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5258, '6855', 135, 'bc_wedge*3', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5259, '6856', 135, 'bc_wedge*30', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5260, '6857', 135, 'bc_wedge*31', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5261, '6858', 135, 'bc_wedge*32', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5262, '6859', 135, 'bc_wedge*33', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5263, '6860', 135, 'bc_wedge*34', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5264, '6861', 135, 'bc_wedge*35', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5265, '6862', 135, 'bc_wedge*36', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5266, '6863', 135, 'bc_wedge*37', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5267, '6864', 135, 'bc_wedge*38', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5268, '6865', 135, 'bc_wedge*39', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5269, '6866', 135, 'bc_wedge*4', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5270, '6867', 135, 'bc_wedge*40', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5271, '6868', 135, 'bc_wedge*41', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5272, '6869', 135, 'bc_wedge*42', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5273, '6870', 135, 'bc_wedge*43', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5274, '6871', 135, 'bc_wedge*44', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5275, '6872', 135, 'bc_wedge*45', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5276, '6873', 135, 'bc_wedge*46', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5277, '6874', 135, 'bc_wedge*47', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5278, '6875', 135, 'bc_wedge*48', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5279, '6876', 135, 'bc_wedge*49', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5280, '6877', 135, 'bc_wedge*5', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5281, '6878', 135, 'bc_wedge*50', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5282, '6879', 135, 'bc_wedge*51', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5283, '6880', 135, 'bc_wedge*52', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5284, '6881', 135, 'bc_wedge*53', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5285, '6882', 135, 'bc_wedge*54', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5286, '6883', 135, 'bc_wedge*55', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5287, '6884', 135, 'bc_wedge*56', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5288, '6885', 135, 'bc_wedge*57', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5289, '6886', 135, 'bc_wedge*58', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5290, '6887', 135, 'bc_wedge*59', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5291, '6888', 135, 'bc_wedge*6', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5292, '6889', 135, 'bc_wedge*60', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5293, '6890', 135, 'bc_wedge*61', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5294, '6891', 135, 'bc_wedge*62', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5295, '6892', 135, 'bc_wedge*63', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5296, '6893', 135, 'bc_wedge*64', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5297, '6894', 135, 'bc_wedge*65', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5298, '6895', 135, 'bc_wedge*66', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5299, '6896', 135, 'bc_wedge*67', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5300, '6897', 135, 'bc_wedge*68', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5301, '6898', 135, 'bc_wedge*69', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5302, '6899', 135, 'bc_wedge*7', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5303, '6900', 135, 'bc_wedge*8', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5304, '6901', 135, 'bc_wedge*9', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5305, '6902', 139, 'bc_block_0*15', 2, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(5306, '6903', 139, 'bc_block_0*16', 2, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(5307, '6904', 139, 'bc_block_0*17', 2, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(5308, '6905', 139, 'bc_block_0*18', 2, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(5309, '6906', 139, 'bc_block_0*19', 2, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(5310, '6907', 139, 'bc_block_0*20', 2, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(5311, '6908', 139, 'bc_block_0*21', 2, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(5312, '6909', 139, 'bc_block_0*22', 2, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(5313, '6910', 139, 'bc_block_0*23', 2, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(5314, '6911', 139, 'bc_block_0*24', 2, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(5315, '6912', 139, 'bc_block_0*25', 2, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(5316, '6913', 139, 'bc_block_0*26', 2, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(5317, '6914', 139, 'bc_block_0*27', 2, 0, 0, 1, 0, 0, 27, -1, 0, '', '1', '0'),
	(5318, '6915', 139, 'bc_block_0*28', 2, 0, 0, 1, 0, 0, 28, -1, 0, '', '1', '0'),
	(5319, '6916', 139, 'bc_block_0*29', 2, 0, 0, 1, 0, 0, 29, -1, 0, '', '1', '0'),
	(5320, '6917', 139, 'bc_block_0*30', 2, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(5321, '6918', 139, 'bc_block_0*31', 2, 0, 0, 1, 0, 0, 31, -1, 0, '', '1', '0'),
	(5322, '6919', 139, 'bc_block_0*32', 2, 0, 0, 1, 0, 0, 32, -1, 0, '', '1', '0'),
	(5323, '6920', 139, 'bc_block_0*33', 2, 0, 0, 1, 0, 0, 33, -1, 0, '', '1', '0'),
	(5324, '6921', 139, 'bc_block_0*34', 2, 0, 0, 1, 0, 0, 34, -1, 0, '', '1', '0'),
	(5325, '6922', 139, 'bc_block_0*35', 2, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(5326, '6923', 139, 'bc_block_0*36', 2, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(5327, '6924', 139, 'bc_block_0*37', 2, 0, 0, 1, 0, 0, 37, -1, 0, '', '1', '0'),
	(5328, '6925', 139, 'bc_block_0*38', 2, 0, 0, 1, 0, 0, 38, -1, 0, '', '1', '0'),
	(5329, '6926', 139, 'bc_block_0*39', 2, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(5330, '6927', 139, 'bc_block_0*40', 2, 0, 0, 1, 0, 0, 40, -1, 0, '', '1', '0'),
	(5331, '6928', 139, 'bc_block_0*41', 2, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(5332, '6929', 139, 'bc_block_0*42', 2, 0, 0, 1, 0, 0, 42, -1, 0, '', '1', '0'),
	(5333, '6930', 139, 'bc_block_0*43', 2, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(5334, '6931', 139, 'bc_block_0*44', 2, 0, 0, 1, 0, 0, 44, -1, 0, '', '1', '0'),
	(5335, '6932', 139, 'bc_block_0*45', 2, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(5336, '6933', 139, 'bc_block_0*46', 2, 0, 0, 1, 0, 0, 46, -1, 0, '', '1', '0'),
	(5337, '6934', 139, 'bc_block_0*47', 2, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(5338, '6935', 139, 'bc_block_0*48', 2, 0, 0, 1, 0, 0, 48, -1, 0, '', '1', '0'),
	(5339, '6936', 139, 'bc_block_0*49', 2, 0, 0, 1, 0, 0, 49, -1, 0, '', '1', '0'),
	(5340, '6937', 139, 'bc_block_0*50', 2, 0, 0, 1, 0, 0, 50, -1, 0, '', '1', '0'),
	(5341, '6938', 139, 'bc_block_0*51', 2, 0, 0, 1, 0, 0, 51, -1, 0, '', '1', '0'),
	(5342, '6939', 139, 'bc_block_0*52', 2, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(5343, '6940', 139, 'bc_block_0*53', 2, 0, 0, 1, 0, 0, 26, -1, 0, '', '1', '0'),
	(5344, '6941', 139, 'bc_block_0*54', 2, 0, 0, 1, 0, 0, 54, -1, 0, '', '1', '0'),
	(5345, '6942', 139, 'bc_block_0*55', 2, 0, 0, 1, 0, 0, 27, -1, 0, '', '1', '0'),
	(5346, '6943', 139, 'bc_block_0*56', 2, 0, 0, 1, 0, 0, 28, -1, 0, '', '1', '0'),
	(5347, '6944', 139, 'bc_block_0*57', 2, 0, 0, 1, 0, 0, 57, -1, 0, '', '1', '0'),
	(5348, '6945', 139, 'bc_block_0*58', 2, 0, 0, 1, 0, 0, 58, -1, 0, '', '1', '0'),
	(5349, '6946', 139, 'bc_block_0*59', 2, 0, 0, 1, 0, 0, 59, -1, 0, '', '1', '0'),
	(5350, '6947', 139, 'bc_block_0*60', 2, 0, 0, 1, 0, 0, 60, -1, 0, '', '1', '0'),
	(5351, '6948', 139, 'bc_block_0*61', 2, 0, 0, 1, 0, 0, 29, -1, 0, '', '1', '0'),
	(5352, '6949', 139, 'bc_block_0*62', 2, 0, 0, 1, 0, 0, 30, -1, 0, '', '1', '0'),
	(5353, '6950', 139, 'bc_block_0*63', 2, 0, 0, 1, 0, 0, 63, -1, 0, '', '1', '0'),
	(5354, '6951', 139, 'bc_block_0*64', 2, 0, 0, 1, 0, 0, 64, -1, 0, '', '1', '0'),
	(5355, '6952', 139, 'bc_block_0*65', 2, 0, 0, 1, 0, 0, 65, -1, 0, '', '1', '0'),
	(5356, '6953', 139, 'bc_block_0*66', 2, 0, 0, 1, 0, 0, 66, -1, 0, '', '1', '0'),
	(5357, '6954', 139, 'bc_block_0*67', 2, 0, 0, 1, 0, 0, 31, -1, 0, '', '1', '0'),
	(5358, '6955', 139, 'bc_block_0*68', 2, 0, 0, 1, 0, 0, 32, -1, 0, '', '1', '0'),
	(5359, '6956', 139, 'bc_block_0*69', 2, 0, 0, 1, 0, 0, 33, -1, 0, '', '1', '0'),
	(5360, '6957', 127, 'bc_cylinder*1', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5361, '6958', 127, 'bc_cylinder*10', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5362, '6959', 127, 'bc_cylinder*11', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5363, '6960', 127, 'bc_cylinder*12', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5364, '6961', 127, 'bc_cylinder*13', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5365, '6962', 127, 'bc_cylinder*14', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5366, '6963', 127, 'bc_cylinder*15', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5367, '6964', 127, 'bc_cylinder*16', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5368, '6965', 127, 'bc_cylinder*17', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5369, '6966', 127, 'bc_cylinder*18', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5370, '6967', 127, 'bc_cylinder*19', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5371, '6968', 127, 'bc_cylinder*2', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5372, '6969', 127, 'bc_cylinder*20', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5373, '6970', 127, 'bc_cylinder*21', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5374, '6971', 127, 'bc_cylinder*22', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5375, '6972', 127, 'bc_cylinder*23', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5376, '6973', 127, 'bc_cylinder*24', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5377, '6974', 127, 'bc_cylinder*25', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5378, '6975', 127, 'bc_cylinder*26', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5379, '6976', 127, 'bc_cylinder*27', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5380, '6977', 127, 'bc_cylinder*28', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5381, '6978', 127, 'bc_cylinder*29', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5382, '6979', 127, 'bc_cylinder*3', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5383, '6980', 127, 'bc_cylinder*30', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5384, '6981', 127, 'bc_cylinder*31', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5385, '6982', 127, 'bc_cylinder*32', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5386, '6983', 127, 'bc_cylinder*33', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5387, '6984', 127, 'bc_cylinder*34', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5388, '6985', 127, 'bc_cylinder*35', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5389, '6986', 127, 'bc_cylinder*36', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5390, '6987', 127, 'bc_cylinder*37', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5391, '6988', 127, 'bc_cylinder*38', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5392, '6989', 127, 'bc_cylinder*39', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5393, '6990', 127, 'bc_cylinder*4', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5394, '6991', 127, 'bc_cylinder*40', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5395, '6992', 127, 'bc_cylinder*41', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5396, '6993', 127, 'bc_cylinder*42', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5397, '6994', 127, 'bc_cylinder*43', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5398, '6995', 127, 'bc_cylinder*44', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5399, '6996', 127, 'bc_cylinder*45', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5400, '6997', 127, 'bc_cylinder*46', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5401, '6998', 127, 'bc_cylinder*47', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5402, '6999', 127, 'bc_cylinder*48', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5403, '7000', 127, 'bc_cylinder*49', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5404, '7001', 127, 'bc_cylinder*5', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5405, '7002', 127, 'bc_cylinder*50', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5406, '7003', 127, 'bc_cylinder*51', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5407, '7004', 127, 'bc_cylinder*52', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5408, '7005', 127, 'bc_cylinder*53', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5409, '7006', 127, 'bc_cylinder*54', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5410, '7007', 127, 'bc_cylinder*55', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5411, '7008', 127, 'bc_cylinder*56', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5412, '7009', 127, 'bc_cylinder*57', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5413, '7010', 127, 'bc_cylinder*58', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5414, '7011', 127, 'bc_cylinder*59', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5415, '7012', 127, 'bc_cylinder*6', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5416, '7013', 127, 'bc_cylinder*60', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5417, '7014', 127, 'bc_cylinder*61', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5418, '7015', 127, 'bc_cylinder*62', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5419, '7016', 127, 'bc_cylinder*63', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5420, '7017', 127, 'bc_cylinder*64', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5421, '7018', 127, 'bc_cylinder*65', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5422, '7019', 127, 'bc_cylinder*66', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5423, '7020', 127, 'bc_cylinder*67', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5424, '7021', 127, 'bc_cylinder*68', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5425, '7022', 127, 'bc_cylinder*69', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5426, '7023', 127, 'bc_cylinder*7', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5427, '7024', 127, 'bc_cylinder*8', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5428, '7025', 127, 'bc_cylinder*9', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5429, '7026', 134, 'bc_standingtriangularprism*1', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5430, '7027', 134, 'bc_standingtriangularprism*10', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5431, '7028', 134, 'bc_standingtriangularprism*11', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5432, '7029', 134, 'bc_standingtriangularprism*12', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5433, '7030', 134, 'bc_standingtriangularprism*13', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5434, '7031', 134, 'bc_standingtriangularprism*14', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5435, '7032', 134, 'bc_standingtriangularprism*15', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5436, '7033', 134, 'bc_standingtriangularprism*16', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5437, '7034', 134, 'bc_standingtriangularprism*17', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5438, '7035', 134, 'bc_standingtriangularprism*18', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5439, '7036', 134, 'bc_standingtriangularprism*19', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5440, '7037', 134, 'bc_standingtriangularprism*2', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5441, '7038', 134, 'bc_standingtriangularprism*20', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5442, '7039', 134, 'bc_standingtriangularprism*21', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5443, '7040', 134, 'bc_standingtriangularprism*22', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5444, '7041', 134, 'bc_standingtriangularprism*23', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5445, '7042', 134, 'bc_standingtriangularprism*24', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5446, '7043', 134, 'bc_standingtriangularprism*25', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5447, '7044', 134, 'bc_standingtriangularprism*26', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5448, '7045', 134, 'bc_standingtriangularprism*27', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5449, '7046', 134, 'bc_standingtriangularprism*28', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5450, '7047', 134, 'bc_standingtriangularprism*29', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5451, '7048', 134, 'bc_standingtriangularprism*3', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5452, '7049', 134, 'bc_standingtriangularprism*30', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5453, '7050', 134, 'bc_standingtriangularprism*31', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5454, '7051', 134, 'bc_standingtriangularprism*32', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5455, '7052', 134, 'bc_standingtriangularprism*33', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5456, '7053', 134, 'bc_standingtriangularprism*34', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5457, '7054', 134, 'bc_standingtriangularprism*35', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5458, '7055', 134, 'bc_standingtriangularprism*36', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5459, '7056', 134, 'bc_standingtriangularprism*37', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5460, '7057', 134, 'bc_standingtriangularprism*38', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5461, '7058', 134, 'bc_standingtriangularprism*39', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5462, '7059', 134, 'bc_standingtriangularprism*4', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5463, '7060', 134, 'bc_standingtriangularprism*40', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5464, '7061', 134, 'bc_standingtriangularprism*41', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5465, '7062', 134, 'bc_standingtriangularprism*42', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5466, '7063', 134, 'bc_standingtriangularprism*43', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5467, '7064', 134, 'bc_standingtriangularprism*44', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5468, '7065', 134, 'bc_standingtriangularprism*45', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5469, '7066', 134, 'bc_standingtriangularprism*46', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5470, '7067', 134, 'bc_standingtriangularprism*47', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5471, '7068', 134, 'bc_standingtriangularprism*48', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5472, '7069', 134, 'bc_standingtriangularprism*49', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5473, '7070', 134, 'bc_standingtriangularprism*5', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5474, '7071', 134, 'bc_standingtriangularprism*50', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5475, '7072', 134, 'bc_standingtriangularprism*51', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5476, '7073', 134, 'bc_standingtriangularprism*52', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5477, '7074', 134, 'bc_standingtriangularprism*53', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5478, '7075', 134, 'bc_standingtriangularprism*54', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5479, '7076', 134, 'bc_standingtriangularprism*55', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5480, '7077', 134, 'bc_standingtriangularprism*56', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5481, '7078', 134, 'bc_standingtriangularprism*57', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5482, '7079', 134, 'bc_standingtriangularprism*58', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5483, '7080', 134, 'bc_standingtriangularprism*59', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5484, '7081', 134, 'bc_standingtriangularprism*6', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5485, '7082', 134, 'bc_standingtriangularprism*60', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5486, '7083', 134, 'bc_standingtriangularprism*61', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5487, '7084', 134, 'bc_standingtriangularprism*62', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5488, '7085', 134, 'bc_standingtriangularprism*63', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5489, '7086', 134, 'bc_standingtriangularprism*64', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5490, '7087', 134, 'bc_standingtriangularprism*65', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5491, '7088', 134, 'bc_standingtriangularprism*66', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5492, '7089', 134, 'bc_standingtriangularprism*67', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5493, '7090', 134, 'bc_standingtriangularprism*68', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5494, '7091', 134, 'bc_standingtriangularprism*69', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5495, '7092', 134, 'bc_standingtriangularprism*7', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5496, '7093', 134, 'bc_standingtriangularprism*8', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5497, '7094', 134, 'bc_standingtriangularprism*9', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5498, '7095', 140, 'bc_block_1*15', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5499, '7096', 140, 'bc_block_1*16', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5500, '7097', 140, 'bc_block_1*17', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5501, '7098', 140, 'bc_block_1*18', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5502, '7099', 140, 'bc_block_1*19', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5503, '7100', 140, 'bc_block_1*20', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5504, '7101', 140, 'bc_block_1*21', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5505, '7102', 140, 'bc_block_1*22', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5506, '7103', 140, 'bc_block_1*23', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5507, '7104', 140, 'bc_block_1*24', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5508, '7105', 140, 'bc_block_1*25', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5509, '7106', 140, 'bc_block_1*26', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5510, '7107', 140, 'bc_block_1*27', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5511, '7108', 140, 'bc_block_1*28', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5512, '7109', 140, 'bc_block_1*29', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5513, '7110', 140, 'bc_block_1*30', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5514, '7111', 140, 'bc_block_1*31', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5515, '7112', 140, 'bc_block_1*32', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5516, '7113', 140, 'bc_block_1*33', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5517, '7114', 140, 'bc_block_1*34', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5518, '7115', 140, 'bc_block_1*35', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5519, '7116', 140, 'bc_block_1*36', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5520, '7117', 140, 'bc_block_1*37', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5521, '7118', 140, 'bc_block_1*38', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5522, '7119', 140, 'bc_block_1*39', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5523, '7120', 140, 'bc_block_1*40', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5524, '7121', 140, 'bc_block_1*41', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5525, '7122', 140, 'bc_block_1*42', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5526, '7123', 140, 'bc_block_1*43', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5527, '7124', 140, 'bc_block_1*44', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5528, '7125', 140, 'bc_block_1*45', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5529, '7126', 140, 'bc_block_1*46', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5530, '7127', 140, 'bc_block_1*47', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5531, '7128', 140, 'bc_block_1*48', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5532, '7129', 140, 'bc_block_1*49', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5533, '7130', 140, 'bc_block_1*50', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5534, '7131', 140, 'bc_block_1*51', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5535, '7132', 140, 'bc_block_1*52', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5536, '7133', 140, 'bc_block_1*53', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5537, '7134', 140, 'bc_block_1*54', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5538, '7135', 140, 'bc_block_1*55', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5539, '7136', 140, 'bc_block_1*56', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5540, '7137', 140, 'bc_block_1*57', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5541, '7138', 140, 'bc_block_1*58', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5542, '7139', 140, 'bc_block_1*59', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5543, '7140', 140, 'bc_block_1*60', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5544, '7141', 140, 'bc_block_1*61', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5545, '7142', 140, 'bc_block_1*62', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5546, '7143', 140, 'bc_block_1*63', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5547, '7144', 140, 'bc_block_1*64', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5548, '7145', 140, 'bc_block_1*65', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5549, '7146', 140, 'bc_block_1*66', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5550, '7147', 140, 'bc_block_1*67', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5551, '7148', 140, 'bc_block_1*68', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5552, '7149', 140, 'bc_block_1*69', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5553, '7150', 136, 'bc_triangularprism*1', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5554, '7151', 136, 'bc_triangularprism*10', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5555, '7152', 136, 'bc_triangularprism*11', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5556, '7153', 136, 'bc_triangularprism*12', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5557, '7154', 136, 'bc_triangularprism*13', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5558, '7155', 136, 'bc_triangularprism*14', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5559, '7156', 136, 'bc_triangularprism*15', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5560, '7157', 136, 'bc_triangularprism*16', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5561, '7158', 136, 'bc_triangularprism*17', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5562, '7159', 136, 'bc_triangularprism*18', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5563, '7160', 136, 'bc_triangularprism*19', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5564, '7161', 136, 'bc_triangularprism*2', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5565, '7162', 136, 'bc_triangularprism*20', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5566, '7163', 136, 'bc_triangularprism*21', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5567, '7164', 136, 'bc_triangularprism*22', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5568, '7165', 136, 'bc_triangularprism*23', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5569, '7166', 136, 'bc_triangularprism*24', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5570, '7167', 136, 'bc_triangularprism*25', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5571, '7168', 136, 'bc_triangularprism*26', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5572, '7169', 136, 'bc_triangularprism*27', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5573, '7170', 136, 'bc_triangularprism*28', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5574, '7171', 136, 'bc_triangularprism*29', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5575, '7172', 136, 'bc_triangularprism*3', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5576, '7173', 136, 'bc_triangularprism*30', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5577, '7174', 136, 'bc_triangularprism*31', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5578, '7175', 136, 'bc_triangularprism*32', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5579, '7176', 136, 'bc_triangularprism*33', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5580, '7177', 136, 'bc_triangularprism*34', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5581, '7178', 136, 'bc_triangularprism*35', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5582, '7179', 136, 'bc_triangularprism*36', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5583, '7180', 136, 'bc_triangularprism*37', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5584, '7181', 136, 'bc_triangularprism*38', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5585, '7182', 136, 'bc_triangularprism*39', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5586, '7183', 136, 'bc_triangularprism*4', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5587, '7184', 136, 'bc_triangularprism*40', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5588, '7185', 136, 'bc_triangularprism*41', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5589, '7186', 136, 'bc_triangularprism*42', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5590, '7187', 136, 'bc_triangularprism*43', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5591, '7188', 136, 'bc_triangularprism*44', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5592, '7189', 136, 'bc_triangularprism*45', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5593, '7190', 136, 'bc_triangularprism*46', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5594, '7191', 136, 'bc_triangularprism*47', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5595, '7192', 136, 'bc_triangularprism*48', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5596, '7193', 136, 'bc_triangularprism*49', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5597, '7194', 136, 'bc_triangularprism*5', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5598, '7195', 136, 'bc_triangularprism*50', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5599, '7196', 136, 'bc_triangularprism*51', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5600, '7197', 136, 'bc_triangularprism*52', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5601, '7198', 136, 'bc_triangularprism*53', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5602, '7199', 136, 'bc_triangularprism*54', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5603, '7200', 136, 'bc_triangularprism*55', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5604, '7201', 136, 'bc_triangularprism*56', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5605, '7202', 136, 'bc_triangularprism*57', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5606, '7203', 136, 'bc_triangularprism*58', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5607, '7204', 136, 'bc_triangularprism*59', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5608, '7205', 136, 'bc_triangularprism*6', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5609, '7206', 136, 'bc_triangularprism*60', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5610, '7207', 136, 'bc_triangularprism*61', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5611, '7208', 136, 'bc_triangularprism*62', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5612, '7209', 136, 'bc_triangularprism*63', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5613, '7210', 136, 'bc_triangularprism*64', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5614, '7211', 136, 'bc_triangularprism*65', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5615, '7212', 136, 'bc_triangularprism*66', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5616, '7213', 136, 'bc_triangularprism*67', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5617, '7214', 136, 'bc_triangularprism*68', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5618, '7215', 136, 'bc_triangularprism*69', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5619, '7216', 136, 'bc_triangularprism*7', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5620, '7217', 136, 'bc_triangularprism*8', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5621, '7218', 136, 'bc_triangularprism*9', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5622, '7219', 132, 'bc_sphere*1', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5623, '7220', 132, 'bc_sphere*10', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5624, '7221', 132, 'bc_sphere*11', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5625, '7222', 132, 'bc_sphere*12', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5626, '7223', 132, 'bc_sphere*13', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5627, '7224', 132, 'bc_sphere*14', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5628, '7225', 132, 'bc_sphere*15', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5629, '7226', 132, 'bc_sphere*16', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5630, '7227', 132, 'bc_sphere*17', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5631, '7228', 132, 'bc_sphere*18', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5632, '7229', 132, 'bc_sphere*19', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5633, '7230', 132, 'bc_sphere*2', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5634, '7231', 132, 'bc_sphere*20', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5635, '7232', 132, 'bc_sphere*21', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5636, '7233', 132, 'bc_sphere*22', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5637, '7234', 132, 'bc_sphere*23', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5638, '7235', 132, 'bc_sphere*24', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5639, '7236', 132, 'bc_sphere*25', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5640, '7237', 132, 'bc_sphere*26', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5641, '7238', 132, 'bc_sphere*27', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5642, '7239', 132, 'bc_sphere*28', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5643, '7240', 132, 'bc_sphere*29', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5644, '7241', 132, 'bc_sphere*3', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5645, '7242', 132, 'bc_sphere*30', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5646, '7243', 132, 'bc_sphere*31', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5647, '7244', 132, 'bc_sphere*32', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5648, '7245', 132, 'bc_sphere*33', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5649, '7246', 132, 'bc_sphere*34', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5650, '7247', 132, 'bc_sphere*35', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5651, '7248', 132, 'bc_sphere*36', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5652, '7249', 132, 'bc_sphere*37', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5653, '7250', 132, 'bc_sphere*38', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5654, '7251', 132, 'bc_sphere*39', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5655, '7252', 132, 'bc_sphere*4', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5656, '7253', 132, 'bc_sphere*40', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5657, '7254', 132, 'bc_sphere*41', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5658, '7255', 132, 'bc_sphere*42', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5659, '7256', 132, 'bc_sphere*43', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5660, '7257', 132, 'bc_sphere*44', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5661, '7258', 132, 'bc_sphere*45', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5662, '7259', 132, 'bc_sphere*46', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5663, '7260', 132, 'bc_sphere*47', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5664, '7261', 132, 'bc_sphere*48', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5665, '7262', 132, 'bc_sphere*49', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5666, '7263', 132, 'bc_sphere*5', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5667, '7264', 132, 'bc_sphere*50', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5668, '7265', 132, 'bc_sphere*51', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5669, '7266', 132, 'bc_sphere*52', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5670, '7267', 132, 'bc_sphere*53', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5671, '7268', 132, 'bc_sphere*54', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5672, '7269', 132, 'bc_sphere*55', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5673, '7270', 132, 'bc_sphere*56', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5674, '7271', 132, 'bc_sphere*57', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5675, '7272', 132, 'bc_sphere*58', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5676, '7273', 132, 'bc_sphere*59', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5677, '7274', 132, 'bc_sphere*6', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5678, '7275', 132, 'bc_sphere*60', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5679, '7276', 132, 'bc_sphere*61', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5680, '7277', 132, 'bc_sphere*62', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5681, '7278', 132, 'bc_sphere*63', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5682, '7279', 132, 'bc_sphere*64', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5683, '7280', 132, 'bc_sphere*65', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5684, '7281', 132, 'bc_sphere*66', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5685, '7282', 132, 'bc_sphere*67', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5686, '7283', 132, 'bc_sphere*68', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5687, '7284', 132, 'bc_sphere*69', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5688, '7285', 132, 'bc_sphere*7', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5689, '7286', 132, 'bc_sphere*8', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5690, '7287', 132, 'bc_sphere*9', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5691, '7288', 138, 'bc_round*15', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5692, '7289', 138, 'bc_round*16', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5693, '7290', 138, 'bc_round*17', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5694, '7291', 138, 'bc_round*18', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5695, '7292', 138, 'bc_round*19', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5696, '7293', 138, 'bc_round*20', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5697, '7294', 138, 'bc_round*21', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5698, '7295', 138, 'bc_round*22', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5699, '7296', 138, 'bc_round*23', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5700, '7297', 138, 'bc_round*24', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5701, '7298', 138, 'bc_round*25', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5702, '7299', 138, 'bc_round*26', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5703, '7300', 138, 'bc_round*27', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5704, '7301', 138, 'bc_round*28', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5705, '7302', 138, 'bc_round*29', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5706, '7303', 138, 'bc_round*30', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5707, '7304', 138, 'bc_round*31', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5708, '7305', 138, 'bc_round*32', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5709, '7306', 138, 'bc_round*33', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5710, '7307', 138, 'bc_round*34', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5711, '7308', 138, 'bc_round*35', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5712, '7309', 138, 'bc_round*36', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5713, '7310', 138, 'bc_round*37', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5714, '7311', 138, 'bc_round*38', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5715, '7312', 138, 'bc_round*39', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5716, '7313', 138, 'bc_round*40', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5717, '7314', 138, 'bc_round*41', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5718, '7315', 138, 'bc_round*42', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5719, '7316', 138, 'bc_round*43', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5720, '7317', 138, 'bc_round*44', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5721, '7318', 138, 'bc_round*45', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5722, '7319', 138, 'bc_round*46', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5723, '7320', 138, 'bc_round*47', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5724, '7321', 138, 'bc_round*48', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5725, '7322', 138, 'bc_round*49', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5726, '7323', 138, 'bc_round*50', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5727, '7324', 138, 'bc_round*51', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5728, '7325', 138, 'bc_round*52', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5729, '7326', 138, 'bc_round*53', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5730, '7327', 138, 'bc_round*54', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5731, '7328', 138, 'bc_round*55', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5732, '7329', 138, 'bc_round*56', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5733, '7330', 138, 'bc_round*57', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5734, '7331', 138, 'bc_round*58', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5735, '7332', 138, 'bc_round*59', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5736, '7333', 138, 'bc_round*60', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5737, '7334', 138, 'bc_round*61', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5738, '7335', 138, 'bc_round*62', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5739, '7336', 138, 'bc_round*63', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5740, '7337', 138, 'bc_round*64', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5741, '7338', 138, 'bc_round*65', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5742, '7339', 138, 'bc_round*66', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5743, '7340', 138, 'bc_round*67', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5744, '7341', 138, 'bc_round*68', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5745, '7342', 138, 'bc_round*69', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5746, '7343', 307, 'CF_1500_suitcase', 1500, 0, 0, 1, 0, 0, 34, -1, 0, '', '1', '0'),
	(5747, '7344', 117, 'bc_alpha1_w*1', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5748, '7345', 117, 'bc_alpha1_w*10', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5749, '7346', 117, 'bc_alpha1_w*11', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5750, '7347', 117, 'bc_alpha1_w*12', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5751, '7348', 117, 'bc_alpha1_w*13', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5752, '7349', 878, 'bc_alpha1_w*14', 2, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(5753, '7350', 117, 'bc_alpha1_w*2', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5754, '7351', 117, 'bc_alpha1_w*3', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5755, '7352', 117, 'bc_alpha1_w*4', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5756, '7353', 117, 'bc_alpha1_w*5', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5757, '7354', 117, 'bc_alpha1_w*6', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5758, '7355', 117, 'bc_alpha1_w*7', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5759, '7356', 117, 'bc_alpha1_w*8', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5760, '7357', 117, 'bc_alpha1_w*9', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5761, '7358', 117, 'bc_alpha1_g*1', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5762, '7359', 117, 'bc_alpha1_g*10', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5763, '7360', 117, 'bc_alpha1_g*11', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5764, '7361', 117, 'bc_alpha1_g*12', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5765, '7362', 117, 'bc_alpha1_g*13', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5766, '7363', 878, 'bc_alpha1_g*14', 2, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(5767, '7364', 117, 'bc_alpha1_g*2', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5768, '7365', 117, 'bc_alpha1_g*3', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5769, '7366', 117, 'bc_alpha1_g*4', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5770, '7367', 117, 'bc_alpha1_g*5', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5771, '7368', 117, 'bc_alpha1_g*6', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5772, '7369', 117, 'bc_alpha1_g*7', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5773, '7370', 117, 'bc_alpha1_g*8', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5774, '7371', 117, 'bc_alpha1_g*9', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5775, '7372', 117, 'bc_alpha1_r*1', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5776, '7373', 117, 'bc_alpha1_r*10', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5777, '7374', 117, 'bc_alpha1_r*11', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5778, '7375', 117, 'bc_alpha1_r*12', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5779, '7376', 117, 'bc_alpha1_r*13', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5780, '7377', 878, 'bc_alpha1_r*14', 2, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(5781, '7378', 117, 'bc_alpha1_r*2', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5782, '7379', 117, 'bc_alpha1_r*3', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5783, '7380', 117, 'bc_alpha1_r*4', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5784, '7381', 117, 'bc_alpha1_r*5', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5785, '7382', 117, 'bc_alpha1_r*6', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5786, '7383', 117, 'bc_alpha1_r*7', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5787, '7384', 117, 'bc_alpha1_r*8', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5788, '7385', 117, 'bc_alpha1_r*9', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5789, '7386', 117, 'bc_alpha1_s*1', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5790, '7387', 117, 'bc_alpha1_s*10', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5791, '7388', 117, 'bc_alpha1_s*11', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5792, '7389', 117, 'bc_alpha1_s*12', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5793, '7390', 117, 'bc_alpha1_s*13', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5794, '7391', 878, 'bc_alpha1_s*14', 2, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(5795, '7392', 117, 'bc_alpha1_s*2', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5796, '7393', 117, 'bc_alpha1_s*3', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5797, '7394', 117, 'bc_alpha1_s*4', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5798, '7395', 117, 'bc_alpha1_s*5', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5799, '7396', 117, 'bc_alpha1_s*6', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5800, '7397', 117, 'bc_alpha1_s*7', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5801, '7398', 117, 'bc_alpha1_s*8', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5802, '7399', 117, 'bc_alpha1_s*9', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5803, '7400', 117, 'bc_alpha1_h*1', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5804, '7401', 117, 'bc_alpha1_h*10', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5805, '7402', 117, 'bc_alpha1_h*11', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5806, '7403', 117, 'bc_alpha1_h*12', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5807, '7404', 117, 'bc_alpha1_h*13', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5808, '7405', 878, 'bc_alpha1_h*14', 2, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(5809, '7406', 117, 'bc_alpha1_h*2', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5810, '7407', 117, 'bc_alpha1_h*3', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5811, '7408', 117, 'bc_alpha1_h*4', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5812, '7409', 117, 'bc_alpha1_h*5', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5813, '7410', 117, 'bc_alpha1_h*6', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5814, '7411', 117, 'bc_alpha1_h*7', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5815, '7412', 117, 'bc_alpha1_h*8', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5816, '7413', 117, 'bc_alpha1_h*9', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5817, '7414', 117, 'bc_alpha1_t*1', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5818, '7415', 117, 'bc_alpha1_t*10', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5819, '7416', 117, 'bc_alpha1_t*11', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5820, '7417', 117, 'bc_alpha1_t*12', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5821, '7418', 117, 'bc_alpha1_t*13', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5822, '7419', 878, 'bc_alpha1_t*14', 2, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(5823, '7420', 117, 'bc_alpha1_t*2', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5824, '7421', 117, 'bc_alpha1_t*3', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5825, '7422', 117, 'bc_alpha1_t*4', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5826, '7423', 117, 'bc_alpha1_t*5', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5827, '7424', 117, 'bc_alpha1_t*6', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5828, '7425', 117, 'bc_alpha1_t*7', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5829, '7426', 117, 'bc_alpha1_t*8', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5830, '7427', 117, 'bc_alpha1_t*9', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5831, '7428', 117, 'bc_alpha1_o*1', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5832, '7429', 117, 'bc_alpha1_o*10', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5833, '7430', 117, 'bc_alpha1_o*11', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5834, '7431', 117, 'bc_alpha1_o*12', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5835, '7432', 117, 'bc_alpha1_o*13', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5836, '7433', 878, 'bc_alpha1_o*14', 2, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(5837, '7434', 117, 'bc_alpha1_o*2', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5838, '7435', 117, 'bc_alpha1_o*3', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5839, '7436', 117, 'bc_alpha1_o*4', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5840, '7437', 117, 'bc_alpha1_o*5', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5841, '7438', 117, 'bc_alpha1_o*6', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5842, '7439', 117, 'bc_alpha1_o*7', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5843, '7440', 117, 'bc_alpha1_o*8', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5844, '7441', 117, 'bc_alpha1_o*9', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5845, '7442', 117, 'bc_alpha1_v*1', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5846, '7443', 117, 'bc_alpha1_v*10', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5847, '7444', 117, 'bc_alpha1_v*11', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5848, '7445', 117, 'bc_alpha1_v*12', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5849, '7446', 117, 'bc_alpha1_v*13', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5850, '7447', 878, 'bc_alpha1_v*14', 2, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(5851, '7448', 117, 'bc_alpha1_v*2', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5852, '7449', 117, 'bc_alpha1_v*3', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5853, '7450', 117, 'bc_alpha1_v*4', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5854, '7451', 117, 'bc_alpha1_v*5', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5855, '7452', 117, 'bc_alpha1_v*6', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5856, '7453', 117, 'bc_alpha1_v*7', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5857, '7454', 117, 'bc_alpha1_v*8', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5858, '7455', 117, 'bc_alpha1_v*9', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5859, '7456', 117, 'bc_alpha1_c*1', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5860, '7457', 117, 'bc_alpha1_c*10', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5861, '7458', 117, 'bc_alpha1_c*11', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5862, '7459', 117, 'bc_alpha1_c*12', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5863, '7460', 117, 'bc_alpha1_c*13', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5864, '7461', 878, 'bc_alpha1_c*14', 2, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(5865, '7462', 117, 'bc_alpha1_c*2', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5866, '7463', 117, 'bc_alpha1_c*3', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5867, '7464', 117, 'bc_alpha1_c*4', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5868, '7465', 117, 'bc_alpha1_c*5', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5869, '7466', 117, 'bc_alpha1_c*6', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5870, '7467', 117, 'bc_alpha1_c*7', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5871, '7468', 117, 'bc_alpha1_c*8', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5872, '7469', 117, 'bc_alpha1_c*9', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5873, '7470', 117, 'bc_alpha1_b*1', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5874, '7471', 117, 'bc_alpha1_b*10', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5875, '7472', 117, 'bc_alpha1_b*11', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5876, '7473', 117, 'bc_alpha1_b*12', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5877, '7474', 117, 'bc_alpha1_b*13', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5878, '7475', 878, 'bc_alpha1_b*14', 2, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(5879, '7476', 117, 'bc_alpha1_b*2', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5880, '7477', 117, 'bc_alpha1_b*3', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5881, '7478', 117, 'bc_alpha1_b*4', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5882, '7479', 117, 'bc_alpha1_b*5', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5883, '7480', 117, 'bc_alpha1_b*6', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5884, '7481', 117, 'bc_alpha1_b*7', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5885, '7482', 117, 'bc_alpha1_b*8', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5886, '7483', 117, 'bc_alpha1_b*9', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5887, '7484', 117, 'bc_alpha1_m*1', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5888, '7485', 117, 'bc_alpha1_m*10', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5889, '7486', 117, 'bc_alpha1_m*11', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5890, '7487', 117, 'bc_alpha1_m*12', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5891, '7488', 117, 'bc_alpha1_m*13', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5892, '7489', 878, 'bc_alpha1_m*14', 2, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(5893, '7490', 117, 'bc_alpha1_m*2', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5894, '7491', 117, 'bc_alpha1_m*3', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5895, '7492', 117, 'bc_alpha1_m*4', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5896, '7493', 117, 'bc_alpha1_m*5', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5897, '7494', 117, 'bc_alpha1_m*6', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5898, '7495', 117, 'bc_alpha1_m*7', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5899, '7496', 117, 'bc_alpha1_m*8', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5900, '7497', 117, 'bc_alpha1_m*9', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5901, '7498', 117, 'bc_alpha1_i*1', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5902, '7499', 117, 'bc_alpha1_i*10', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5903, '7500', 117, 'bc_alpha1_i*11', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5904, '7501', 117, 'bc_alpha1_i*12', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5905, '7502', 117, 'bc_alpha1_i*13', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5906, '7503', 878, 'bc_alpha1_i*14', 2, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(5907, '7504', 117, 'bc_alpha1_i*2', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5908, '7505', 117, 'bc_alpha1_i*3', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5909, '7506', 117, 'bc_alpha1_i*4', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5910, '7507', 117, 'bc_alpha1_i*5', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5911, '7508', 117, 'bc_alpha1_i*6', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5912, '7509', 117, 'bc_alpha1_i*7', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5913, '7510', 117, 'bc_alpha1_i*8', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5914, '7511', 117, 'bc_alpha1_i*9', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5915, '7512', 117, 'bc_alpha1_x*1', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5916, '7513', 117, 'bc_alpha1_x*10', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5917, '7514', 117, 'bc_alpha1_x*11', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5918, '7515', 117, 'bc_alpha1_x*12', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5919, '7516', 117, 'bc_alpha1_x*13', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5920, '7517', 878, 'bc_alpha1_x*14', 2, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(5921, '7518', 117, 'bc_alpha1_x*2', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5922, '7519', 117, 'bc_alpha1_x*3', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5923, '7520', 117, 'bc_alpha1_x*4', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5924, '7521', 117, 'bc_alpha1_x*5', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5925, '7522', 117, 'bc_alpha1_x*6', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5926, '7523', 117, 'bc_alpha1_x*7', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5927, '7524', 117, 'bc_alpha1_x*8', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5928, '7525', 117, 'bc_alpha1_x*9', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5929, '7526', 117, 'bc_alpha1_l*1', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5930, '7527', 117, 'bc_alpha1_l*10', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5931, '7528', 117, 'bc_alpha1_l*11', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5932, '7529', 117, 'bc_alpha1_l*12', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5933, '7530', 117, 'bc_alpha1_l*13', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5934, '7531', 878, 'bc_alpha1_l*14', 2, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(5935, '7532', 117, 'bc_alpha1_l*2', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5936, '7533', 117, 'bc_alpha1_l*3', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5937, '7534', 117, 'bc_alpha1_l*4', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5938, '7535', 117, 'bc_alpha1_l*5', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5939, '7536', 117, 'bc_alpha1_l*6', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5940, '7537', 117, 'bc_alpha1_l*7', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5941, '7538', 117, 'bc_alpha1_l*8', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5942, '7539', 117, 'bc_alpha1_l*9', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5943, '7540', 117, 'bc_alpha1_j*1', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5944, '7541', 117, 'bc_alpha1_j*10', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5945, '7542', 117, 'bc_alpha1_j*11', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5946, '7543', 117, 'bc_alpha1_j*12', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5947, '7544', 117, 'bc_alpha1_j*13', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5948, '7545', 878, 'bc_alpha1_j*14', 2, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(5949, '7546', 117, 'bc_alpha1_j*2', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5950, '7547', 117, 'bc_alpha1_j*3', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5951, '7548', 117, 'bc_alpha1_j*4', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5952, '7549', 117, 'bc_alpha1_j*5', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5953, '7550', 117, 'bc_alpha1_j*6', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5954, '7551', 117, 'bc_alpha1_j*7', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5955, '7552', 117, 'bc_alpha1_j*8', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5956, '7553', 117, 'bc_alpha1_j*9', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5957, '7554', 117, 'bc_alpha1_f*1', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5958, '7555', 117, 'bc_alpha1_f*10', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5959, '7556', 117, 'bc_alpha1_f*11', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5960, '7557', 117, 'bc_alpha1_f*12', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5961, '7558', 117, 'bc_alpha1_f*13', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5962, '7559', 878, 'bc_alpha1_f*14', 2, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(5963, '7560', 117, 'bc_alpha1_f*2', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5964, '7561', 117, 'bc_alpha1_f*3', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5965, '7562', 117, 'bc_alpha1_f*4', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5966, '7563', 117, 'bc_alpha1_f*5', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5967, '7564', 117, 'bc_alpha1_f*6', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5968, '7565', 117, 'bc_alpha1_f*7', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5969, '7566', 117, 'bc_alpha1_f*8', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5970, '7567', 117, 'bc_alpha1_f*9', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5971, '7568', 117, 'bc_alpha1_e*1', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5972, '7569', 117, 'bc_alpha1_e*10', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5973, '7570', 117, 'bc_alpha1_e*11', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5974, '7571', 117, 'bc_alpha1_e*12', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5975, '7572', 117, 'bc_alpha1_e*13', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5976, '7573', 878, 'bc_alpha1_e*14', 2, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(5977, '7574', 117, 'bc_alpha1_e*2', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5978, '7575', 117, 'bc_alpha1_e*3', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5979, '7576', 117, 'bc_alpha1_e*4', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5980, '7577', 117, 'bc_alpha1_e*5', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5981, '7578', 117, 'bc_alpha1_e*6', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5982, '7579', 117, 'bc_alpha1_e*7', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5983, '7580', 117, 'bc_alpha1_e*8', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5984, '7581', 117, 'bc_alpha1_e*9', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5985, '7582', 117, 'bc_alpha1_q*1', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5986, '7583', 117, 'bc_alpha1_q*10', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5987, '7584', 117, 'bc_alpha1_q*11', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5988, '7585', 117, 'bc_alpha1_q*12', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5989, '7586', 117, 'bc_alpha1_q*13', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5990, '7587', 878, 'bc_alpha1_q*14', 2, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(5991, '7588', 117, 'bc_alpha1_q*2', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5992, '7589', 117, 'bc_alpha1_q*3', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5993, '7590', 117, 'bc_alpha1_q*4', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5994, '7591', 117, 'bc_alpha1_q*5', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5995, '7592', 117, 'bc_alpha1_q*6', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5996, '7593', 117, 'bc_alpha1_q*7', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5997, '7594', 117, 'bc_alpha1_q*8', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5998, '7595', 117, 'bc_alpha1_q*9', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(5999, '7596', 117, 'bc_alpha1_y*1', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6000, '7597', 117, 'bc_alpha1_y*10', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6001, '7598', 117, 'bc_alpha1_y*11', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6002, '7599', 117, 'bc_alpha1_y*12', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6003, '7600', 117, 'bc_alpha1_y*13', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6004, '7601', 878, 'bc_alpha1_y*14', 2, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(6005, '7602', 117, 'bc_alpha1_y*2', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6006, '7603', 117, 'bc_alpha1_y*3', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6007, '7604', 117, 'bc_alpha1_y*4', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6008, '7605', 117, 'bc_alpha1_y*5', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6009, '7606', 117, 'bc_alpha1_y*6', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6010, '7607', 117, 'bc_alpha1_y*7', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6011, '7608', 117, 'bc_alpha1_y*8', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6012, '7609', 117, 'bc_alpha1_y*9', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6013, '7610', 117, 'bc_alpha1_d*1', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6014, '7611', 117, 'bc_alpha1_d*10', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6015, '7612', 117, 'bc_alpha1_d*11', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6016, '7613', 117, 'bc_alpha1_d*12', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6017, '7614', 117, 'bc_alpha1_d*13', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6018, '7615', 878, 'bc_alpha1_d*14', 2, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(6019, '7616', 117, 'bc_alpha1_d*2', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6020, '7617', 117, 'bc_alpha1_d*3', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6021, '7618', 117, 'bc_alpha1_d*4', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6022, '7619', 117, 'bc_alpha1_d*5', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6023, '7620', 117, 'bc_alpha1_d*6', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6024, '7621', 117, 'bc_alpha1_d*7', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6025, '7622', 117, 'bc_alpha1_d*8', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6026, '7623', 117, 'bc_alpha1_d*9', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6027, '7624', 117, 'bc_alpha1_n*1', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6028, '7625', 117, 'bc_alpha1_n*10', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6029, '7626', 117, 'bc_alpha1_n*11', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6030, '7627', 117, 'bc_alpha1_n*12', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6031, '7628', 117, 'bc_alpha1_n*13', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6032, '7629', 878, 'bc_alpha1_n*14', 2, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(6033, '7630', 117, 'bc_alpha1_n*2', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6034, '7631', 117, 'bc_alpha1_n*3', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6035, '7632', 117, 'bc_alpha1_n*4', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6036, '7633', 117, 'bc_alpha1_n*5', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6037, '7634', 117, 'bc_alpha1_n*6', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6038, '7635', 117, 'bc_alpha1_n*7', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6039, '7636', 117, 'bc_alpha1_n*8', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6040, '7637', 117, 'bc_alpha1_n*9', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6041, '7638', 117, 'bc_alpha1_k*1', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6042, '7639', 117, 'bc_alpha1_k*10', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6043, '7640', 117, 'bc_alpha1_k*11', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6044, '7641', 117, 'bc_alpha1_k*12', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6045, '7642', 117, 'bc_alpha1_k*13', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6046, '7643', 878, 'bc_alpha1_k*14', 2, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(6047, '7644', 117, 'bc_alpha1_k*2', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6048, '7645', 117, 'bc_alpha1_k*3', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6049, '7646', 117, 'bc_alpha1_k*4', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6050, '7647', 117, 'bc_alpha1_k*5', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6051, '7648', 117, 'bc_alpha1_k*6', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6052, '7649', 117, 'bc_alpha1_k*7', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6053, '7650', 117, 'bc_alpha1_k*8', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6054, '7651', 117, 'bc_alpha1_k*9', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6055, '7652', 117, 'bc_alpha1_num*1', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6056, '7653', 117, 'bc_alpha1_num*10', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6057, '7654', 117, 'bc_alpha1_num*11', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6058, '7655', 117, 'bc_alpha1_num*12', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6059, '7656', 117, 'bc_alpha1_num*13', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6060, '7657', 878, 'bc_alpha1_num*14', 2, 0, 0, 1, 0, 0, 27, -1, 0, '', '1', '0'),
	(6061, '7658', 117, 'bc_alpha1_num*2', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6062, '7659', 117, 'bc_alpha1_num*3', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6063, '7660', 117, 'bc_alpha1_num*4', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6064, '7661', 117, 'bc_alpha1_num*5', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6065, '7662', 117, 'bc_alpha1_num*6', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6066, '7663', 117, 'bc_alpha1_num*7', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6067, '7664', 117, 'bc_alpha1_num*8', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6068, '7665', 117, 'bc_alpha1_num*9', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6069, '7666', 117, 'bc_alpha1_u*1', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6070, '7667', 117, 'bc_alpha1_u*10', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6071, '7668', 117, 'bc_alpha1_u*11', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6072, '7669', 117, 'bc_alpha1_u*12', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6073, '7670', 117, 'bc_alpha1_u*13', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6074, '7671', 878, 'bc_alpha1_u*14', 2, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(6075, '7672', 117, 'bc_alpha1_u*2', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6076, '7673', 117, 'bc_alpha1_u*3', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6077, '7674', 117, 'bc_alpha1_u*4', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6078, '7675', 117, 'bc_alpha1_u*5', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6079, '7676', 117, 'bc_alpha1_u*6', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6080, '7677', 117, 'bc_alpha1_u*7', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6081, '7678', 117, 'bc_alpha1_u*8', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6082, '7679', 117, 'bc_alpha1_u*9', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6083, '7680', 117, 'bc_alpha1_z*1', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6084, '7681', 117, 'bc_alpha1_z*10', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6085, '7682', 117, 'bc_alpha1_z*11', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6086, '7683', 117, 'bc_alpha1_z*12', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6087, '7684', 117, 'bc_alpha1_z*13', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6088, '7685', 878, 'bc_alpha1_z*14', 2, 0, 0, 1, 0, 0, 26, -1, 0, '', '1', '0'),
	(6089, '7686', 117, 'bc_alpha1_z*2', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6090, '7687', 117, 'bc_alpha1_z*3', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6091, '7688', 117, 'bc_alpha1_z*4', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6092, '7689', 117, 'bc_alpha1_z*5', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6093, '7690', 117, 'bc_alpha1_z*6', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6094, '7691', 117, 'bc_alpha1_z*7', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6095, '7692', 117, 'bc_alpha1_z*8', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6096, '7693', 117, 'bc_alpha1_z*9', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6097, '7694', 117, 'bc_alpha1_a*1', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6098, '7695', 117, 'bc_alpha1_a*10', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6099, '7696', 117, 'bc_alpha1_a*11', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6100, '7697', 117, 'bc_alpha1_a*12', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6101, '7698', 117, 'bc_alpha1_a*13', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6102, '7699', 878, 'bc_alpha1_a*14', 2, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(6103, '7700', 117, 'bc_alpha1_a*2', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6104, '7701', 117, 'bc_alpha1_a*3', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6105, '7702', 117, 'bc_alpha1_a*4', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6106, '7703', 117, 'bc_alpha1_a*5', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6107, '7704', 117, 'bc_alpha1_a*6', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6108, '7705', 117, 'bc_alpha1_a*7', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6109, '7706', 117, 'bc_alpha1_a*8', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6110, '7707', 117, 'bc_alpha1_a*9', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6111, '7708', 117, 'bc_alpha1_p*1', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6112, '7709', 117, 'bc_alpha1_p*10', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6113, '7710', 117, 'bc_alpha1_p*11', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6114, '7711', 117, 'bc_alpha1_p*12', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6115, '7712', 117, 'bc_alpha1_p*13', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6116, '7713', 878, 'bc_alpha1_p*14', 2, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(6117, '7714', 117, 'bc_alpha1_p*2', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6118, '7715', 117, 'bc_alpha1_p*3', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6119, '7716', 117, 'bc_alpha1_p*4', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6120, '7717', 117, 'bc_alpha1_p*5', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6121, '7718', 117, 'bc_alpha1_p*6', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6122, '7719', 117, 'bc_alpha1_p*7', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6123, '7720', 117, 'bc_alpha1_p*8', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6124, '7721', 117, 'bc_alpha1_p*9', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6125, '7722', 116, 'attic15_cabinet', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(6126, '7723', 456, 'val15_gift2', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(6127, '7724', 456, 'val15_zen', 4, 0, 0, 1, 0, 0, 34, -1, 0, '', '1', '0'),
	(6128, '7725', 456, 'val15_tele', 4, 0, 0, 1, 0, 0, 31, -1, 0, '', '1', '0'),
	(6129, '7726', 456, 'val15_sakura', 4, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(6130, '7727', 456, 'val15_lilys', 4, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(6131, '7728', 456, 'val15_rock1', 4, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(6132, '7729', 456, 'val15_shamisen', 4, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(6133, '7730', 456, 'val15_tea', 4, 0, 0, 1, 0, 0, 30, -1, 0, '', '1', '0'),
	(6134, '7731', 456, 'val15_gift1', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(6135, '7732', 456, 'val15_hottub', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(6136, '7733', 456, 'val15_petals', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(6137, '7734', 456, 'val15_stage2', 4, 0, 0, 1, 0, 0, 28, -1, 0, '', '1', '0'),
	(6138, '7735', 456, 'val15_lantern', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(6139, '7736', 456, 'val15_gift3', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(6140, '7737', 456, 'val15_corner', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(6141, '7738', 456, 'val15_dogstat', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(6142, '7739', 456, 'val15_table', 4, 0, 0, 1, 0, 0, 29, -1, 0, '', '1', '0'),
	(6143, '7740', 456, 'val15_chair', 2, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(6144, '7741', 456, 'val15_rock2', 4, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(6145, '7742', 456, 'val15_bridge2', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(6146, '7743', 456, 'val15_divider', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(6147, '7744', 456, 'val15_water', 4, 0, 0, 1, 0, 0, 33, -1, 0, '', '1', '0'),
	(6148, '7745', 741, 'val15_armour', 4, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(6149, '7746', 456, 'val15_koipond', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(6150, '7747', 456, 'val15_crane', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(6151, '7748', 456, 'val15_bench', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(6152, '7749', 456, 'val15_gazebo', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(6153, '7750', 456, 'val15_tree', 4, 0, 0, 1, 0, 0, 32, -1, 0, '', '1', '0'),
	(6154, '7751', 456, 'val15_shinto_arch', 4, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(6155, '7752', 456, 'val15_gate', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(6156, '7753', 456, 'val15_bridge1', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(6157, '7754', 456, 'val15_stage1', 4, 0, 0, 1, 0, 0, 27, -1, 0, '', '1', '0'),
	(6158, '7755', 116, 'attic15_sofa', 3, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(6159, '7756', 116, 'attic15_crn', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(6160, '7757', 116, 'attic15_box', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(6161, '7758', 116, 'attic15_chest', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6162, '7759', 116, 'attic15_oillamp', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(6163, '7760', 116, 'attic15_bigshelf', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(6164, '7761', 116, 'attic15_chair', 2, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(6165, '7762', 116, 'attic15_bigtable', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(6166, '7763', 116, 'attic15_lamp', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(6167, '7764', 116, 'attic15_table', 2, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(6168, '7765', 116, 'attic15_paintingfloor', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(6169, '7766', 116, 'attic15_window', 4, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(6170, '7767', 116, 'attic15_cradle', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(6171, '7768', 116, 'attic15_telescope', 4, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(6172, '7769', 116, 'attic15_gate', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(6173, '7770', 116, 'attic15_clock', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(6174, '7771', 116, 'attic15_mousetrap', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(6175, '7772', 116, 'attic15_carpet', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(6176, '7773', 116, 'attic15_tele', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(6177, '7774', 116, 'attic15_shelf', 5, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(6178, '7775', 116, 'attic15_divider', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(6179, '7776', 456, 'val15_shrub', 4, 0, 0, 1, 0, 0, 26, -1, 0, '', '1', '0'),
	(6180, '7777', 200, 'clothing_kimono1', 20, 0, 0, 1, 0, 0, 34, 15949, 0, '0', '1', '0'),
	(6181, '7778', 200, 'clothing_kimono2', 16, 0, 0, 1, 0, 0, 33, 15950, 0, '0', '1', '0'),
	(6182, '7779', 490, 'rare_prize15*1', 6, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(6183, '7780', 490, 'rare_prize15*10', 6, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(6184, '7781', 490, 'rare_prize15*11', 6, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(6185, '7782', 490, 'rare_prize15*12', 6, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(6186, '7783', 490, 'rare_prize15*2', 6, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(6187, '7784', 490, 'rare_prize15*3', 6, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(6188, '7785', 490, 'rare_prize15*4', 6, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(6189, '7786', 490, 'rare_prize15*5', 6, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(6190, '7787', 490, 'rare_prize15*6', 6, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(6191, '7788', 490, 'rare_prize15*7', 6, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(6192, '7789', 490, 'rare_prize15*8', 6, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(6193, '7790', 490, 'rare_prize15*9', 6, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(6194, '7791', 854, 'carnival15_hotair_brazil', 4, 0, 0, 1, 0, 0, 38, -1, 0, '', '1', '0'),
	(6195, '7792', 490, 'rare_prize15*13', 6, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(6196, '7793', 490, 'rare_prize15*14', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6197, '7794', 490, 'rare_prize15*15', 6, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(6198, '7795', 490, 'rare_prize15*16', 6, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(6199, '7796', 490, 'rare_prize15*17', 6, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(6200, '7797', 490, 'rare_prize15*18', 6, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(6201, '7798', 490, 'rare_prize15*19', 6, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(6202, '7799', 490, 'rare_prize15*20', 6, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(6203, '7800', 490, 'rare_prize15*21', 6, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(6204, '7801', 490, 'rare_prize15*22', 6, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(6205, '7802', 490, 'rare_prize15*23', 6, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(6206, '7803', 490, 'rare_prize15*24', 6, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(6207, '7804', 118, 'cpunk_c15_neoarrowup', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(6208, '7805', 118, 'cpunk_c15_neonx', 4, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(6209, '7806', 741, 'cpunk15_robofrank', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(6210, '7807', 118, 'cpunk_c15_tele', 4, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(6211, '7808', 118, 'cpunk15_robo', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(6212, '7809', 118, 'cpunk15_gift', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(6213, '7810', 118, 'cpunk_c15_rain', 4, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(6214, '7811', 118, 'cpunk_c15_table', 4, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(6215, '7812', 208, 'clothing_cyboots', 4, 0, 0, 1, 0, 0, 9, 16019, 0, '0', '1', '0'),
	(6216, '7813', 118, 'cpunk_c15_searchlight', 4, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(6217, '7814', 205, 'clothing_cyzipped', 5, 0, 0, 1, 0, 0, 14, -1, 0, '0', '1', '0'),
	(6218, '7815', 200, 'clothing_cystraphood', 18, 0, 0, 1, 0, 0, 32, 16022, 0, '0', '1', '0'),
	(6219, '7816', 310, 'clothing_goggles', 6, 0, 0, 1, 0, 0, 75, 16023, 0, '0', '1', '0'),
	(6220, '7817', 118, 'cpunk_c15_robojunk', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(6221, '7818', 118, 'cpunk15_blimp', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(6222, '7819', 588, 'clothing_cyskirt', 4, 0, 0, 1, 0, 0, 1, 17878, 0, '0', '1', '0'),
	(6223, '7820', 588, 'clothing_cyquif', 6, 0, 0, 1, 0, 0, 4, 16027, 0, '0', '1', '0'),
	(6224, '7821', 118, 'cpunk_c15_building2', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(6225, '7822', 202, 'clothing_cyhood', 6, 0, 0, 1, 0, 0, 32, 16029, 0, '0', '1', '0'),
	(6226, '7823', 118, 'cpunk_c15_tubes', 4, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(6227, '7824', 201, 'clothing_cyhair', 6, 0, 0, 1, 0, 0, 51, 16031, 0, '0', '1', '0'),
	(6228, '7825', 118, 'cpunk_c15_neonsk', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(6229, '7826', 118, 'cpunk_c15_neoarrow', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(6230, '7827', 206, 'clothing_cystrappants', 5, 0, 0, 1, 0, 0, 12, 16034, 0, '0', '1', '0'),
	(6231, '7828', 118, 'cpunk_c15_road', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(6232, '7829', 118, 'cpunk15_gunvender', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(6233, '7830', 118, 'cpunk_c15_neond', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(6234, '7831', 208, 'clothing_cystrapboots', 4, 0, 0, 1, 0, 0, 8, 16038, 0, '0', '1', '0'),
	(6235, '7832', 310, 'clothing_cymask', 6, 0, 0, 1, 0, 0, 74, 16039, 0, '0', '1', '0'),
	(6236, '7833', 118, 'cpunk_c15_stool', 4, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(6237, '7834', 118, 'cpunk_c15_traffic', 4, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(6238, '7835', 588, 'clothing_cyglass', 8, 0, 0, 1, 0, 0, 6, 16042, 0, '0', '1', '0'),
	(6239, '7836', 118, 'cpunk_c15_door', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(6240, '7837', 200, 'clothing_cygirl', 16, 0, 0, 1, 0, 0, 31, 16044, 0, '0', '1', '0'),
	(6241, '7838', 118, 'cpunk15_roborat', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(6242, '7839', 118, 'cpunk15_robosheep', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(6243, '7840', 118, 'cpunk_c15_bar', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(6244, '7841', 310, 'clothing_cycircuit', 6, 0, 0, 1, 0, 0, 73, 16048, 0, '0', '1', '0'),
	(6245, '7842', 588, 'clothing_cyleather', 4, 0, 0, 1, 0, 0, 2, 17897, 0, '0', '1', '0'),
	(6246, '7843', 310, 'clothing_cyphones', 6, 0, 0, 1, 0, 0, 72, 16050, 0, '0', '1', '0'),
	(6247, '7844', 118, 'cpunk_c15_building1', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(6248, '7845', 302, 'cny_sheepballoon', 4, 0, 0, 1, 0, 0, 58, -1, 0, '', '1', '0'),
	(6249, '7846', 302, 'china_goat', 4, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(6250, '7847', 118, 'cpunk_c15_stage1', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(6251, '7848', 64, 'wf_act_bot_clothes', 10, 0, 0, 1, 0, 0, 19, 16064, 0, '', '1', '0'),
	(6252, '7849', 64, 'wf_act_bot_teleport', 10, 0, 0, 1, 0, 0, 20, 16065, 0, '', '1', '0'),
	(6253, '7850', 63, 'wf_trg_bot_reached_stf', 7, 0, 0, 1, 0, 0, 14, 16066, 0, '', '1', '0'),
	(6254, '7851', 64, 'wf_act_bot_follow_avatar', 10, 0, 0, 1, 0, 0, 21, 16067, 0, '', '1', '0'),
	(6255, '7852', 64, 'wf_act_bot_give_handitem', 10, 0, 0, 1, 0, 0, 22, 16068, 0, '', '1', '0'),
	(6256, '7853', 64, 'wf_act_bot_move', 10, 0, 0, 1, 0, 0, 23, 16069, 0, '', '1', '0'),
	(6257, '7854', 65, 'wf_cnd_has_handitem', 5, 0, 0, 1, 0, 0, 19, 16070, 0, '', '1', '0'),
	(6258, '7855', 64, 'wf_act_bot_talk_to_avatar', 10, 0, 0, 1, 0, 0, 24, 16071, 0, '', '1', '0'),
	(6259, '7856', 63, 'wf_trg_bot_reached_avtr', 7, 0, 0, 1, 0, 0, 15, 16072, 0, '', '1', '0'),
	(6260, '7857', 64, 'wf_act_bot_talk', 10, 0, 0, 1, 0, 0, 25, 16073, 0, '', '1', '0'),
	(6261, '7858', 436, 'room_cof15_tree1', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6262, '7859', 436, 'room_cof15_counter2', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6263, '7860', 436, 'room_cof15_table3', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6264, '7861', 436, 'room_cof15_lamp1', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6265, '7862', 436, 'room_cof15_chair', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6266, '7863', 436, 'room_cof15_counter1', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6267, '7864', 436, 'room_cof15_table1', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6268, '7865', 436, 'room_cof15_table2', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6269, '7866', 436, 'room_cof15_sofa1', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6270, '7867', 436, 'room_cof15_cup', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6271, '7868', 436, 'room_cof15_planter', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6272, '7869', 436, 'room_cof15_pillar1', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6273, '7870', 436, 'room_cof15_counter3', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6274, '7871', 436, 'room_cof15_espresso', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6275, '7872', 436, 'room_cof15_lamp2', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6276, '7873', 436, 'room_cof15_shelf2', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6277, '7874', 436, 'room_cof15_shelf', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6278, '7875', 436, 'room_cof15_door', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6279, '7876', 436, 'room_cof15_cup2', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6280, '7877', 436, 'room_cof15_sofa2', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6281, '7878', 436, 'room_cof15_press', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6282, '7879', 160, 'room_gh15_cab2', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(6283, '7880', 160, 'room_gh15_light', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(6284, '7881', 160, 'room_gh15_cab3', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(6285, '7882', 160, 'room_gh15_cab1', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(6286, '7883', 160, 'room_gh15_desk', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(6287, '7884', 160, 'room_gh15_cab4', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(6288, '7885', 160, 'room_gh15_cab6', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(6289, '7886', 160, 'room_gh15_ball', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(6290, '7887', 160, 'room_gh15_rtele', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(6291, '7888', 160, 'room_gh15_cab5', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(6292, '7889', 440, 'room_hcl15_tree2', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6293, '7890', 440, 'room_hcl15_gate', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6294, '7891', 440, 'room_hcl15_dj', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6295, '7892', 440, 'room_hcl15_table1', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6296, '7893', 440, 'room_hcl15_table2', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6297, '7894', 440, 'room_hcl15_sofa', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6298, '7895', 440, 'room_hcl15_amp', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6299, '7896', 440, 'room_hcl15_div', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6300, '7897', 440, 'room_hcl15_tube', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6301, '7898', 440, 'room_hcl15_bar', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6302, '7899', 440, 'room_hcl15_barchair', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6303, '7900', 440, 'room_hcl15_floor', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6304, '7901', 440, 'room_hcl15_tree1', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6305, '7902', 440, 'room_hcl15_djtable', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6306, '7903', 439, 'room_wl15_mag1', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6307, '7904', 439, 'room_wl15_table1', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6308, '7905', 439, 'room_wl15_ele', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6309, '7906', 439, 'room_wl15_sink', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6310, '7907', 441, 'room_wlof15_bed', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6311, '7908', 439, 'room_wl15_teleblock', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6312, '7909', 439, 'room_wl15_tree', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6313, '7910', 439, 'room_wl15_infolink', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6314, '7911', 439, 'room_wl15_pillar', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6315, '7912', 439, 'room_wl15_trashbin', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6316, '7913', 439, 'room_wl15_table3', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6317, '7914', 439, 'room_wl15_bthdoor', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6318, '7915', 439, 'room_wl15_toiletbroke', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6319, '7916', 439, 'room_wl15_deskgate', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6320, '7917', 439, 'room_wl15_deskfront', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6321, '7918', 439, 'room_wl15_table2', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6322, '7919', 441, 'room_wlof15_chair', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6323, '7920', 439, 'room_wl15_mirror', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6324, '7921', 441, 'room_wlof15_wardrobe', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6325, '7922', 441, 'room_wlof15_bookcase', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6326, '7923', 439, 'room_wl15_toilet', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6327, '7924', 439, 'room_wl15_sofa', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6328, '7925', 437, 'room_hall15_wfall', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6329, '7926', 437, 'room_hall15_dish1', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6330, '7927', 437, 'room_hall15_ele', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6331, '7928', 437, 'room_hall15_light1', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6332, '7929', 437, 'room_hall15_dish2', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6333, '7930', 437, 'room_hall15_arch', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6334, '7931', 437, 'room_hall15_plant1', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6335, '7932', 400, 'cland_c15_table', 2, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(6336, '7933', 400, 'cland_c15_icreamtree', 4, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(6337, '7934', 201, 'clothing_frontswirl', 4, 0, 0, 1, 0, 0, 50, 17908, 0, '0', '1', '0'),
	(6338, '7935', 205, 'clothing_cjersey', 5, 0, 0, 1, 0, 0, 13, 16189, 0, '0', '1', '0'),
	(6339, '7936', 200, 'clothing_candygirl', 18, 0, 0, 1, 0, 0, 30, 16190, 0, '0', '1', '0'),
	(6340, '7937', 400, 'cland_c15_gate', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(6341, '7938', 741, 'cland15_LTD5', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(6342, '7939', 400, 'cland_c15_jellyseat2', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(6343, '7940', 400, 'cland15_tent', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(6344, '7941', 400, 'cland_c15_pillar', 4, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(6345, '7942', 400, 'cland_c15_waferblock', 4, 0, 0, 1, 0, 0, 28, -1, 0, '', '1', '0'),
	(6346, '7943', 204, 'clothing_cjumper', 5, 0, 0, 1, 0, 0, 33, 17904, 0, '0', '1', '0'),
	(6347, '7944', 400, 'cland_c15_gatepink', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(6348, '7945', 741, 'cland15_ltd4', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(6349, '7946', 400, 'cland_c15_pavement', 4, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(6350, '7947', 400, 'cland_c15_roof', 4, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(6351, '7948', 310, 'clothing_cherries', 6, 0, 0, 1, 0, 0, 71, 16202, 0, '0', '1', '0'),
	(6352, '7949', 400, 'cland_c15_swirltree', 4, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(6353, '7950', 400, 'cland_c15_cakeblock', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(6354, '7951', 206, 'clothing_cshorts', 5, 0, 0, 1, 0, 0, 11, 16205, 0, '0', '1', '0'),
	(6355, '7952', 201, 'clothing_habloompa', 6, 0, 0, 1, 0, 0, 49, 16206, 0, '0', '1', '0'),
	(6356, '7953', 400, 'cland15_candythrone', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(6357, '7954', 310, 'clothing_cherrybomb', 6, 0, 0, 1, 0, 0, 70, 16208, 0, '0', '1', '0'),
	(6358, '7955', 400, 'cland_c15_wafer', 4, 0, 0, 1, 0, 0, 26, -1, 0, '', '1', '0'),
	(6359, '7956', 741, 'cland15_ltd3', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(6360, '7957', 400, 'cland15_unipoo', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(6361, '7958', 310, 'clothing_candyphones', 6, 0, 0, 1, 0, 0, 69, 17909, 0, '0', '1', '0'),
	(6362, '7959', 400, 'cland_c15_light', 4, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(6363, '7960', 400, 'cland15_unicorn', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(6364, '7961', 202, 'clothing_sidehat', 4, 0, 0, 1, 0, 0, 31, 16215, 0, '0', '1', '0'),
	(6365, '7962', 400, 'cland15_fountain', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(6366, '7963', 207, 'clothing_swirlskirt', 5, 0, 0, 1, 0, 0, 4, 16217, 0, '0', '1', '0'),
	(6367, '7964', 400, 'cland_c15_grass', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(6368, '7965', 741, 'cland15_ltd1', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(6369, '7966', 400, 'cland15_flosstree', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(6370, '7967', 202, 'clothing_chocodrop', 4, 0, 0, 1, 0, 0, 30, 16221, 0, '0', '1', '0'),
	(6371, '7968', 741, 'cland15_ltd2', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(6372, '7969', 400, 'cland_c15_goofloor', 2, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(6373, '7970', 400, 'cland_c15_lollytree', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(6374, '7971', 400, 'cland_c15_jellyseat3', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(6375, '7972', 400, 'cland_c15_jellyseat1', 4, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(6376, '7973', 204, 'clothing_swirltop', 5, 0, 0, 1, 0, 0, 32, 16227, 0, '0', '1', '0'),
	(6377, '7974', 400, 'cland_c15_chocostick', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(6378, '7975', 400, 'cland_c15_chocorock', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(6379, '7976', 200, 'clothing_candyboy', 12, 0, 0, 1, 0, 0, 29, 16230, 0, '0', '1', '0'),
	(6380, '7977', 230, 'petbox_epic', 7, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(6381, '7978;50289', 570, 'clothing_knitalien', 6, 0, 0, 1, 0, 0, 5, -1, 0, '0', '1', '0'),
	(6382, '7979', 339, 'tablet_vendorg', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(6383, '7980', 683, 'prize_alienplush', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(6384, '7981', 159, 'room_info15_shrub1', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6385, '7982', 159, 'room_info15_shrub3', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6386, '7983', 159, 'room_info15_shrub2', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6387, '7984', 159, 'room_info15_statue1', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6388, '7985', 159, 'room_info15_counter3', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6389, '7986', 159, 'room_info15_sofa2', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6390, '7987', 159, 'room_info15_tree1', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6391, '7988', 159, 'room_info15_bus*1', 4, 0, 0, 1, 0, 0, 51, -1, 0, '', '1', '0'),
	(6392, '7989', 159, 'room_info15_bus*10', 4, 0, 0, 1, 0, 0, 60, -1, 0, '', '1', '0'),
	(6393, '7990', 159, 'room_info15_bus*11', 4, 0, 0, 1, 0, 0, 29, -1, 0, '', '1', '0'),
	(6394, '7991', 159, 'room_info15_bus*12', 4, 0, 0, 1, 0, 0, 30, -1, 0, '', '1', '0'),
	(6395, '7992', 159, 'room_info15_bus*13', 4, 0, 0, 1, 0, 0, 63, -1, 0, '', '1', '0'),
	(6396, '7993', 159, 'room_info15_bus*14', 4, 0, 0, 1, 0, 0, 64, -1, 0, '', '1', '0'),
	(6397, '7994', 159, 'room_info15_bus*15', 4, 0, 0, 1, 0, 0, 65, -1, 0, '', '1', '0'),
	(6398, '7995', 159, 'room_info15_bus*16', 4, 0, 0, 1, 0, 0, 66, -1, 0, '', '1', '0'),
	(6399, '7996', 159, 'room_info15_bus*17', 4, 0, 0, 1, 0, 0, 31, -1, 0, '', '1', '0'),
	(6400, '7997', 159, 'room_info15_bus*18', 4, 0, 0, 1, 0, 0, 32, -1, 0, '', '1', '0'),
	(6401, '7998', 159, 'room_info15_bus*19', 4, 0, 0, 1, 0, 0, 33, -1, 0, '', '1', '0'),
	(6402, '7999', 159, 'room_info15_bus*2', 4, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(6403, '8000', 159, 'room_info15_bus*20', 4, 0, 0, 1, 0, 0, 70, -1, 0, '', '1', '0'),
	(6404, '8001', 159, 'room_info15_bus*3', 4, 0, 0, 1, 0, 0, 26, -1, 0, '', '1', '0'),
	(6405, '8002', 159, 'room_info15_bus*4', 4, 0, 0, 1, 0, 0, 54, -1, 0, '', '1', '0'),
	(6406, '8003', 159, 'room_info15_bus*5', 4, 0, 0, 1, 0, 0, 27, -1, 0, '', '1', '0'),
	(6407, '8004', 159, 'room_info15_bus*6', 4, 0, 0, 1, 0, 0, 28, -1, 0, '', '1', '0'),
	(6408, '8005', 159, 'room_info15_bus*7', 4, 0, 0, 1, 0, 0, 57, -1, 0, '', '1', '0'),
	(6409, '8006', 159, 'room_info15_bus*8', 4, 0, 0, 1, 0, 0, 58, -1, 0, '', '1', '0'),
	(6410, '8007', 159, 'room_info15_bus*9', 4, 0, 0, 1, 0, 0, 59, -1, 0, '', '1', '0'),
	(6411, '8008', 159, 'room_info15_bridge1', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6412, '8009', 159, 'room_info15_bridge2', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6413, '8010', 159, 'room_info15_clouds', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6414, '8011', 159, 'room_info15_lamp1', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6415, '8012', 159, 'room_info15_bench', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6416, '8013', 159, 'room_info15_sofa1', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6417, '8014', 159, 'room_info15_reed', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6418, '8015', 159, 'room_info15_fridge', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6419, '8016', 159, 'room_info15_counter4', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6420, '8017', 159, 'room_info15_counter2', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6421, '8018', 159, 'room_info15_counter1', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6422, '8019', 159, 'room_info15_statue2', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6423, '8020', 159, 'room_info15_bg', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6424, '8021', 491, 'diamond_painting8', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(6425, '8022', 158, 'army15_copter', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(6426, '8023', 158, 'army_c15_contable2', 2, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(6427, '8024', 310, 'clothing_rank4', 6, 0, 0, 1, 0, 0, 68, 16304, 0, '0', '1', '0'),
	(6428, '8025', 741, 'army15_ltdhumvee', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(6429, '8026', 158, 'army_c15_telemine', 4, 0, 0, 1, 0, 0, 39, -1, 0, '', '1', '0'),
	(6430, '8027', 158, 'army_c15_medictent', 4, 0, 0, 1, 0, 0, 30, -1, 0, '', '1', '0'),
	(6431, '8028', 158, 'army_c15_notice', 4, 0, 0, 1, 0, 0, 31, -1, 0, '', '1', '0'),
	(6432, '8029', 158, 'army_c15_crate', 4, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(6433, '8030', 200, 'clothing_parade', 15, 0, 0, 1, 0, 0, 28, 16310, 0, '0', '1', '0'),
	(6434, '8031', 158, 'army_c15_compass', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(6435, '8032', 158, 'army_c15_glasscrn', 4, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(6436, '8033', 158, 'army_c15_doorscan', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(6437, '8034', 200, 'clothing_kevlaroutfit', 18, 0, 0, 1, 0, 0, 27, 16314, 0, '0', '1', '0'),
	(6438, '8035', 158, 'army_c15_gate', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(6439, '8036', 158, 'army_c15_leatherchr', 4, 0, 0, 1, 0, 0, 27, -1, 0, '', '1', '0'),
	(6440, '8037', 158, 'army_c15_guardcub', 4, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(6441, '8038', 158, 'army_c15_wirecrn', 4, 0, 0, 1, 0, 0, 42, -1, 0, '', '1', '0'),
	(6442, '8039', 158, 'army_c15_sandbag', 4, 0, 0, 1, 0, 0, 34, -1, 0, '', '1', '0'),
	(6443, '8040', 158, 'army_c15_light', 4, 0, 0, 1, 0, 0, 28, -1, 0, '', '1', '0'),
	(6444, '8041', 205, 'clothing_militaryjacket', 5, 0, 0, 1, 0, 0, 12, 16321, 0, '0', '1', '0'),
	(6445, '8042', 200, 'clothing_camooutfit', 14, 0, 0, 1, 0, 0, 26, 16322, 0, '0', '1', '0'),
	(6446, '8043', 202, 'clothing_napkin', 4, 0, 0, 1, 0, 0, 28, 16323, 0, '0', '1', '0'),
	(6447, '8044', 205, 'clothing_kevlar', 5, 0, 0, 1, 0, 0, 11, 16324, 0, '0', '1', '0'),
	(6448, '8045', 588, 'clothing_camoboots', 4, 0, 0, 1, 0, 0, 10, 16325, 0, '0', '1', '0'),
	(6449, '8046', 158, 'army_c15_screen', 4, 0, 0, 1, 0, 0, 35, -1, 0, '', '1', '0'),
	(6450, '8047', 310, 'clothing_rank5', 6, 0, 0, 1, 0, 0, 67, 16327, 0, '0', '1', '0'),
	(6451, '8048', 158, 'army15_scanner', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(6452, '8049', 158, 'army_c15_wiredividr', 4, 0, 0, 1, 0, 0, 43, -1, 0, '', '1', '0'),
	(6453, '8050', 158, 'army_c15_jerrycan', 4, 0, 0, 1, 0, 0, 26, -1, 0, '', '1', '0'),
	(6454, '8051', 202, 'clothing_kevlarhat', 4, 0, 0, 1, 0, 0, 27, 16331, 0, '0', '1', '0'),
	(6455, '8052', 158, 'army_c15_watchtwr', 4, 0, 0, 1, 0, 0, 41, -1, 0, '', '1', '0'),
	(6456, '8053', 158, 'army_c15_contable', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(6457, '8054', 158, 'army15_statue', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(6458, '8055', 158, 'army_c15_locker', 4, 0, 0, 1, 0, 0, 29, -1, 0, '', '1', '0'),
	(6459, '8056', 310, 'clothing_medal1', 6, 0, 0, 1, 0, 0, 66, 17913, 0, '0', '1', '0'),
	(6460, '8057', 310, 'clothing_rank3', 6, 0, 0, 1, 0, 0, 65, 16337, 0, '0', '1', '0'),
	(6461, '8058', 158, 'army_c15_officetent', 4, 0, 0, 1, 0, 0, 32, -1, 0, '', '1', '0'),
	(6462, '8059', 310, 'clothing_medal3', 6, 0, 0, 1, 0, 0, 63, 17914, 0, '0', '1', '0'),
	(6463, '8060', 158, 'army_c15_teledoor', 4, 0, 0, 1, 0, 0, 38, -1, 0, '', '1', '0'),
	(6464, '8061', 741, 'army15_ltddesk', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(6465, '8062', 158, 'army_c15_chair', 2, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(6466, '8063', 202, 'clothing_drillserg', 4, 0, 0, 1, 0, 0, 26, 16343, 0, '0', '1', '0'),
	(6467, '8064', 158, 'army_c15_plant', 4, 0, 0, 1, 0, 0, 33, -1, 0, '', '1', '0'),
	(6468, '8065', 310, 'clothing_rank2', 6, 0, 0, 1, 0, 0, 62, 16345, 0, '0', '1', '0'),
	(6469, '8066', 158, 'army_c15_table', 4, 0, 0, 1, 0, 0, 37, -1, 0, '', '1', '0'),
	(6470, '8067', 158, 'army_c15_bed', 3, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(6471, '8068', 158, 'army_c15_cabinet', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(6472, '8069', 158, 'army_c15_bookshelf', 5, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(6473, '8070', 158, 'army_c15_gunrack', 4, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(6474, '8071', 158, 'army_c15_shipcon', 4, 0, 0, 1, 0, 0, 36, -1, 0, '', '1', '0'),
	(6475, '8072', 310, 'clothing_rank1', 6, 0, 0, 1, 0, 0, 61, 16352, 0, '0', '1', '0'),
	(6476, '8073', 158, 'army_c15_glassdivdr', 4, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(6477, '8074', 207, 'clothing_armyskirt', 5, 0, 0, 1, 0, 0, 3, 16354, 0, '0', '1', '0'),
	(6478, '8075', 206, 'clothing_militarypants', 5, 0, 0, 1, 0, 0, 10, 16355, 0, '0', '1', '0'),
	(6479, '8076', 158, 'army_c15_food', 4, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(6480, '8077', 158, 'army_c15_carpet', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(6481, '8078', 310, 'clothing_walkie', 6, 0, 0, 1, 0, 0, 60, 16358, 0, '0', '1', '0'),
	(6482, '8079', 158, 'army15_dog', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(6483, '8080', 158, 'army_c15_deskcomp', 5, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(6484, '8081', 158, 'army_c15_deskitem', 5, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(6485, '8082', 108, 'army_c15_groupflag', 2, 0, 0, 1, 0, 0, 1, 17823, 0, '', '1', '0'),
	(6486, '8083', 310, 'clothing_medal2', 6, 0, 0, 1, 0, 0, 59, 17915, 0, '0', '1', '0'),
	(6487, '8084', 204, 'clothing_camotank', 5, 0, 0, 1, 0, 0, 31, 16364, 0, '0', '1', '0'),
	(6488, '8085', 202, 'clothing_militaryhat', 4, 0, 0, 1, 0, 0, 24, 17901, 0, '0', '1', '0'),
	(6489, '8086', 202, 'clothing_camocap', 4, 0, 0, 1, 0, 0, 23, 16366, 0, '0', '1', '0'),
	(6490, '8087', 206, 'clothing_camotuck', 5, 0, 0, 1, 0, 0, 9, 16367, 0, '0', '1', '0'),
	(6491, '8088', 159, 'room_info15_div', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6492, '8089', 159, 'room_info15_gate', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6493, '8090', 429, 'botnest', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6494, '8091', 199, 'dino_c15_footprint', 4, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(6495, '8092', 199, 'dino15_dinoprize6', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(6496, '8093', 199, 'dino15_fossil2', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(6497, '8094', 199, 'dino15_fossil5', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(6498, '8095', 199, 'dino_c15_venusfly', 4, 0, 0, 1, 0, 0, 33, -1, 0, '', '1', '0'),
	(6499, '8096', 199, 'dino_c15_nest', 4, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(6500, '8097', 202, 'clothing_dinohat', 4, 0, 0, 1, 0, 0, 22, 16429, 0, '', '1', '0'),
	(6501, '8098', 741, 'dino15_throne', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(6502, '8099', 199, 'dino_c15_floor', 2, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(6503, '8100', 199, 'dino_c15_blocks', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(6504, '8101', 199, 'dino_c15_rocksmall', 4, 0, 0, 1, 0, 0, 27, -1, 0, '', '1', '0'),
	(6505, '8102', 199, 'dino_c15_table', 4, 0, 0, 1, 0, 0, 28, -1, 0, '', '1', '0'),
	(6506, '8103', 199, 'dino_c15_dilosaur', 4, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(6507, '8104', 199, 'dino_c15_tree1', 4, 0, 0, 1, 0, 0, 30, -1, 0, '', '1', '0'),
	(6508, '8105', 199, 'dino_c15_crn', 4, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(6509, '8106', 199, 'dino_c15_volcano', 4, 0, 0, 1, 0, 0, 34, -1, 0, '', '1', '0'),
	(6510, '8107', 199, 'dino15_amberbug', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(6511, '8108', 741, 'dino15_dragonfly', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(6512, '8109', 199, 'dino_c15_gate', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(6513, '8110', 199, 'dino_c15_tele', 4, 0, 0, 1, 0, 0, 29, -1, 0, '', '1', '0'),
	(6514, '8111', 204, 'clothing_caveshirt', 5, 0, 0, 1, 0, 0, 30, 16443, 0, '0', '1', '0'),
	(6515, '8112', 199, 'dino_c15_ribcage', 4, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(6516, '8113', 199, 'dino_c15_tree2', 4, 0, 0, 1, 0, 0, 31, -1, 0, '', '1', '0'),
	(6517, '8114', 199, 'dino15_dinoprize1', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(6518, '8115', 201, 'clothing_cavehair', 6, 0, 0, 1, 0, 0, 48, 16447, 0, '0', '1', '0'),
	(6519, '8116', 199, 'dino15_fossil3', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(6520, '8117', 199, 'dino_c15_rocklarge', 4, 0, 0, 1, 0, 0, 26, -1, 0, '', '1', '0'),
	(6521, '8118', 199, 'dino15_amberduck', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(6522, '8119', 199, 'dino_c15_plant2', 4, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(6523, '8120', 199, 'dino_c15_plant1', 4, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(6524, '8121', 200, 'clothing_dino', 14, 0, 0, 1, 0, 0, 25, 16453, 0, '', '1', '0'),
	(6525, '8122', 199, 'dino_c15_divdr', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(6526, '8123', 199, 'dino15_dinoprize3', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(6527, '8124', 199, 'dino15_fossil1', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(6528, '8125', 200, 'clothing_caveman', 10, 0, 0, 1, 0, 0, 24, 16457, 0, '0', '1', '0'),
	(6529, '8126', 199, 'dino_c15_log', 4, 0, 0, 1, 0, 0, 21, 21590, 0, '', '1', '0'),
	(6530, '8127', 199, 'dino15_dinoprize4', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(6531, '8128', 199, 'dino15_fossil4', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(6532, '8129', 199, 'dino15_dinoprize5', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(6533, '8130', 202, 'clothing_hat_skulldino', 6, 0, 0, 1, 0, 0, 21, 16462, 0, '', '1', '0'),
	(6534, '8131', 199, 'dino15_dinoprize2', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(6535, '8132', 199, 'dino_c15_tree3', 4, 0, 0, 1, 0, 0, 32, -1, 0, '', '1', '0'),
	(6536, '8133', 423, 'fxbox_fx183', 3, 0, 0, 1, 0, 0, 200, -1, 0, '', '1', '0'),
	(6537, '8134', 307, 'CF_300_bricks', 300, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(6538, '8135', 438, 'room_thr15_spot', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(6539, '8136', 438, 'room_thr15_chair2', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(6540, '8137', 438, 'room_thr15_div2', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(6541, '8138', 438, 'room_thr15_curtain1', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(6542, '8139', 438, 'room_thr15_bubjuice', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(6543, '8140', 438, 'room_thr15_popcorn', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(6544, '8141', 438, 'room_thr15_stair', 4, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(6545, '8142', 438, 'room_thr15_icecream', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(6546, '8143', 438, 'room_thr15_chair1', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(6547, '8144', 438, 'room_thr15_div3', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(6548, '8145', 438, 'room_thr15_stage', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(6549, '8146', 438, 'room_thr15_ramp', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(6550, '8147', 438, 'room_thr15_block', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(6551, '8148', 438, 'room_thr15_div1', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(6552, '8149', 438, 'room_thr15_frontcur', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(6553, '8150', 438, 'room_thr15_cover', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(6554, '8151', 438, 'room_thr15_candy', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(6555, '8152', 438, 'room_thr15_hotdog', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(6556, '8153', 438, 'room_thr15_sofa', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(6557, '8154', 159, 'room_info15_roller', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6558, '8155', 115, 'nest_raptor', 2, 0, 0, 1, 0, 0, 201, 16509, 0, '', '1', '0'),
	(6559, '8156;8159', 102, 'velociraptor_egg', 25, 0, 0, 1, 0, 0, 1, 16510, 0, '', '1', '0'),
	(6560, '8157;8158', 232, 'pterosaur_egg', 35, 0, 0, 1, 0, 0, 1, 16511, 0, '', '1', '0'),
	(6561, '8158', 52, 'petfood31', 1, 0, 0, 1, 0, 0, 32, 16511, 0, '', '1', '0'),
	(6562, '8159', 52, 'petfood30', 1, 0, 0, 1, 0, 0, 32, 16510, 0, '', '1', '0'),
	(6563, '8160', 161, 'paris_c15_roof', 4, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(6564, '8161', 161, 'paris_c15_crn', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(6565, '8162', 161, 'paris15_paintings', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(6566, '8163', 588, 'clothing_breton', 5, 0, 0, 1, 0, 0, 8, 16535, 0, '0', '1', '0'),
	(6567, '8164', 161, 'paris_c15_table', 2, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(6568, '8165', 161, 'paris15_bicycle', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(6569, '8166', 161, 'paris_c15_building2', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(6570, '8167', 161, 'paris_c15_chair', 2, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(6571, '8168', 161, 'paris15_pigeon', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(6572, '8169', 161, 'paris_c15_food3', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(6573, '8170', 161, 'paris_c15_menu', 4, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(6574, '8171', 161, 'paris_c15_food1', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(6575, '8172', 161, 'paris15_poodle', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(6576, '8173', 161, 'paris15_giftsnails', 4, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(6577, '8174', 161, 'paris_c15_flowerpot', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(6578, '8175', 161, 'paris_c15_vegstall3', 4, 0, 0, 1, 0, 0, 29, -1, 0, '', '1', '0'),
	(6579, '8176', 161, 'paris15_cake', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(6580, '8177', 161, 'paris_c15_building1', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(6581, '8178', 161, 'paris_c15_arch', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(6582, '8179', 310, 'clothing_necktie', 6, 0, 0, 1, 0, 0, 58, 16551, 0, '0', '1', '0'),
	(6583, '8180', 161, 'paris_c15_shadow', 4, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(6584, '8181', 161, 'paris_c15_vegstall2', 4, 0, 0, 1, 0, 0, 28, -1, 0, '', '1', '0'),
	(6585, '8182', 741, 'paris15_ltdfountain', 4, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(6586, '8183', 161, 'paris_c15_floor', 2, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(6587, '8184', 161, 'paris_c15_food2', 4, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(6588, '8185', 161, 'paris_c15_flowerstl', 10, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(6589, '8186', 161, 'paris_c15_awning', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(6590, '8187', 161, 'paris_c15_pavement', 4, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(6591, '8188', 161, 'paris_c15_breadstall', 10, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(6592, '8189', 161, 'paris_c15_vegstall1', 10, 0, 0, 1, 0, 0, 27, -1, 0, '', '1', '0'),
	(6593, '8190', 161, 'paris_c15_parasol', 4, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(6594, '8191', 115, 'nest_pterosaur', 2, 0, 0, 1, 0, 0, 202, 16576, 0, '', '1', '0'),
	(6595, '8192', 109, 'yttv_retro', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6596, '8193', 192, 'habbo15_rare_crackable', 7, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6597, '8194', 162, 'habbo15_comp_photo', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6598, '8195', 162, 'habbo15_comp_clothing', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6599, '8196', 162, 'habbo15_comp_room', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6600, '8197', 162, 'habbo15_comp_video', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6601, '8198', 162, 'habbo15_placeholder', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6602, '8199', 162, 'habbo15_comp_furni', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6603, '8200', 162, 'habbo15_comp_blocks', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6604, '8201', 192, 'habbo15_crackable', 7, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6605, '8202', 162, 'room_hall_trophy2', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6606, '8203', 162, 'room_hall15_window', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6607, '8204', 162, 'room_hall15_pillar', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6608, '8205', 162, 'room_hall15_sofa', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6609, '8206', 162, 'room_hall_trophy1', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6610, '8207', 162, 'room_hall15_barch', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6611, '8208', 337, 'pillar*10', 5, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(6612, '8209', 337, 'rare_parasol*4', 5, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(6613, '8210', 337, 'scifidoor*11', 5, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(6614, '8211', 337, 'sleepingbag*11', 5, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(6615, '8212', 337, 'rare_fountain*4', 5, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(6616, '8213', 337, 'rare_dragonlamp*10', 5, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(6617, '8214', 337, 'rare_fan*10', 5, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(6618, '8215', 337, 'rare_icecream*11', 5, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(6619, '8216', 337, 'wooden_screen*10', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(6620, '8217', 337, 'rare_beehive_bulb*3', 5, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(6621, '8218', 337, 'pillow*10', 5, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(6622, '8219', 337, 'scifiport*10', 5, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(6623, '8220', 337, 'rare_elephant_statue*3', 5, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(6624, '8221', 337, 'marquee*11', 5, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(6625, '8222', 337, 'scifirocket*10', 5, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(6626, '8223', 68, 'africa15_meerkat', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6627, '8224', 18, 'lodge_c15_floor', 2, 0, 0, 1, 0, 0, 18, 16626, 0, '', '1', '0'),
	(6628, '8225', 104, 'drago_c15_bed', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(6629, '8226', 104, 'drago_c15_sofa', 3, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(6630, '8227', 30, 'gothic_c15_toilet', 4, 0, 0, 1, 0, 0, 31, -1, 0, '', '1', '0'),
	(6631, '8228', 30, 'gothic_c15_tower', 4, 0, 0, 1, 0, 0, 37, -1, 0, '', '1', '0'),
	(6632, '8229', 30, 'gothic_c15_dvdr', 4, 0, 0, 1, 0, 0, 36, -1, 0, '', '1', '0'),
	(6633, '8230', 772, 'gothic_c15_chandelier', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(6634, '8231', 30, 'gothic_c15_crn', 4, 0, 0, 1, 0, 0, 35, -1, 0, '', '1', '0'),
	(6635, '8232', 120, 'anc15_pharaohduck', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(6636, '8233', 120, 'anc_c15_table', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(6637, '8234', 120, 'anc_c15_chair', 2, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(6639, '8236', 32, 'lt_c15_tree', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(6640, '8237', 32, 'lt15_tele', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(6641, '8238', 32, 'lt_c15_bush', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(6642, '8239', 68, 'africa_c15_table', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6643, '8240', 68, 'africa_c15_chair', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6644, '8241', 68, 'africa_c15_bongos', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6645, '8242', 569, 'habbo15_win_2', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(6646, '8243', 569, 'habbo15_win_3', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(6647, '8244', 569, 'habbo15_win_1', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(6648, '8245', 408, 'tiki_c15_leigiver', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(6649, '8246', 408, 'tiki_c15_tele', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(6650, '8247', 216, 'greek_c15_floor', 2, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(6651, '8248', 216, 'greek_c15_bench', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(6652, '8249', 216, 'greek_c15_lamp', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(6653, '8250', 216, 'greek_c15_tile', 1, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(6654, '8251', 212, 'garden_c15_toolshed', 4, 0, 0, 1, 0, 0, 10, 17934, 0, '', '1', '0'),
	(6655, '8252', 212, 'garden_c15_shroomchr', 4, 0, 0, 1, 0, 0, 9, 16670, 0, '', '1', '0'),
	(6656, '8253', 212, 'garden15_lawnmower', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(6657, '8254', 569, 'habbo15_win_5', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(6658, '8255', 569, 'habbo15_win_4', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(6659, '8256', 569, 'habbo15_win_10', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(6660, '8257', 569, 'habbo15_win_7', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(6661, '8258', 569, 'habbo15_win_6', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(6662, '8259', 569, 'habbo15_win_8', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(6663, '8260', 700, 'exe_c15_telephone', 4, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(6664, '8261', 700, 'exe_c15_printer', 4, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(6665, '8262', 700, 'exe_c15_desktidy', 5, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(6666, '8263', 70, 'steampunk15_plane', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6667, '8264', 70, 'steampunk_c15_door', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6668, '8265', 70, 'steampunk_c15_bed', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6669, '8266', 70, 'steampunk_c15_stage', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6670, '8267', 569, 'habbo15_win_13', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(6671, '8268', 569, 'habbo15_win_12', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(6672, '8269', 162, 'habbo15_birthdaycake', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6673, '8270', 569, 'habbo15_win_14', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(6674, '8271', 569, 'habbo15_win_11', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(6675, '8272', 569, 'habbo15_win_9', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(6676, '8273', 35, 'romantique_c15_table*1', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(6677, '8274', 35, 'romantique_c15_table*2', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(6678, '8275', 35, 'romantique_c15_table*3', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(6679, '8276', 35, 'romantique_c15_table*4', 4, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(6680, '8277', 35, 'romantique_c15_table*5', 4, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(6681, '8278', 35, 'romantique_c15_dresser', 4, 0, 0, 1, 0, 0, 49, -1, 0, '', '1', '0'),
	(6682, '8279', 114, 'uni_c15_lamp', 4, 0, 0, 1, 0, 0, 12, 16704, 0, '', '1', '0'),
	(6683, '8280', 114, 'uni_c15_shelvescrn', 4, 0, 0, 1, 0, 0, 13, 18101, 0, '', '1', '0'),
	(6684, '8281', 114, 'uni_c15_chair', 2, 0, 0, 1, 0, 0, 11, 16706, 0, '', '1', '0'),
	(6685, '8282', 50, 'bling_c15_chandalier', 4, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(6686, '8283', 50, 'bling15_pooltable', 4, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(6687, '8284', 31, 'jp_c15_daruma', 4, 0, 0, 1, 0, 0, 52, -1, 0, '', '1', '0'),
	(6688, '8285', 31, 'jp_c15_dresser', 4, 0, 0, 1, 0, 0, 51, -1, 0, '', '1', '0'),
	(6689, '8286', 31, 'jp_c15_teapot', 4, 0, 0, 1, 0, 0, 50, -1, 0, '', '1', '0'),
	(6690, '8287', 31, 'jp15_luckycat', 4, 0, 0, 1, 0, 0, 53, -1, 0, '', '1', '0'),
	(6691, '8288', 569, 'habbo15_win_19', 4, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(6692, '8289', 569, 'habbo15_win_16', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(6693, '8290', 569, 'habbo15_win_17', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(6694, '8291', 569, 'habbo15_win_20', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(6695, '8292', 569, 'habbo15_win_15', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(6696, '8293', 569, 'habbo15_win_22', 4, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(6697, '8294', 569, 'habbo15_win_18', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(6698, '8295', 569, 'habbo15_win_24', 4, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(6699, '8296', 569, 'habbo15_win_28', 4, 0, 0, 1, 0, 0, 28, -1, 0, '', '1', '0'),
	(6700, '8297', 569, 'habbo15_win_21', 4, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(6701, '8298', 569, 'habbo15_win_25', 4, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(6702, '8299', 569, 'habbo15_win_23', 4, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(6703, '8300', 569, 'habbo15_win_29', 4, 0, 0, 1, 0, 0, 29, -1, 0, '', '1', '0'),
	(6704, '8301', 569, 'habbo15_win_26', 4, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(6705, '8302', 196, 'room_pcnc15_dvd2', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(6706, '8303', 196, 'room_pcnc15_dvd1', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(6707, '8304', 196, 'room_pcnc15_hotdog', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(6708, '8305', 196, 'room_pcnc15_awn', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(6709, '8306', 196, 'room_pcnc15_carrot', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(6710, '8307', 196, 'room_pcnc15_table1', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(6711, '8308', 196, 'room_pcnc15_gzb', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(6712, '8309', 196, 'room_pcnc15_wbench', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(6713, '8310', 196, 'room_pcnc15_soda', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(6714, '8311', 196, 'room_pcnc15_table3', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(6715, '8312', 196, 'room_pcnc15_table2', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(6716, '8313', 196, 'room_pcnc15_blanket', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(6717, '8314', 196, 'room_pcnc15_chair1', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(6718, '8315', 196, 'room_pcnc15_wood', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(6719, '8316', 196, 'room_pcnc15_bbq', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(6720, '8317', 569, 'habbo15_win_32', 4, 0, 0, 1, 0, 0, 32, -1, 0, '', '1', '0'),
	(6721, '8318', 569, 'habbo15_win_34', 4, 0, 0, 1, 0, 0, 34, -1, 0, '', '1', '0'),
	(6722, '8319', 569, 'habbo15_win_30', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(6723, '8320', 569, 'habbo15_win_31', 4, 0, 0, 1, 0, 0, 31, -1, 0, '', '1', '0'),
	(6724, '8321', 569, 'habbo15_win_35', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(6725, '8322', 569, 'habbo15_win_33', 4, 0, 0, 1, 0, 0, 33, -1, 0, '', '1', '0'),
	(6726, '8323', 569, 'habbo15_win_27', 4, 0, 0, 1, 0, 0, 27, -1, 0, '', '1', '0'),
	(6727, '8324', 569, 'habbo15_win_36', 4, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(6728, '8325', 569, 'habbo15_win_38', 4, 0, 0, 1, 0, 0, 38, -1, 0, '', '1', '0'),
	(6729, '8326', 569, 'habbo15_win_39', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(6730, '8327', 569, 'habbo15_win_41', 4, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(6731, '8328', 569, 'habbo15_win_37', 4, 0, 0, 1, 0, 0, 37, -1, 0, '', '1', '0'),
	(6732, '8329', 569, 'habbo15_win_43', 4, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(6733, '8330', 569, 'habbo15_win_40', 4, 0, 0, 1, 0, 0, 40, -1, 0, '', '1', '0'),
	(6734, '8331', 569, 'habbo15_win_42', 4, 0, 0, 1, 0, 0, 42, -1, 0, '', '1', '0'),
	(6735, '8332', 569, 'habbo15_win_44', 4, 0, 0, 1, 0, 0, 44, -1, 0, '', '1', '0'),
	(6736, '8333', 569, 'habbo15_win_45', 4, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(6737, '8334', 588, 'clothing_knighttop', 6, 0, 0, 1, 0, 0, 7, 16812, 0, '0', '1', '0'),
	(6738, '8335', 200, 'clothing_demonoutfit', 12, 0, 0, 1, 0, 0, 23, 16813, 0, '0', '1', '0'),
	(6739, '8336', 772, 'clothing_waterhelm', 6, 0, 0, 1, 0, 0, 40, -1, 0, '0', '1', '0'),
	(6740, '8337', 310, 'clothing_fammask', 6, 0, 0, 1, 0, 0, 57, -1, 0, '0', '1', '0'),
	(6741, '8338', 203, 'clothing_demoncloak', 6, 0, 0, 1, 0, 0, 10, 16816, 0, '0', '1', '0'),
	(6742, '8339', 310, 'clothing_warmask', 6, 0, 0, 1, 0, 0, 56, -1, 0, '', '1', '0'),
	(6743, '8340', 772, 'clothing_airhelm', 6, 0, 0, 1, 0, 0, 20, -1, 0, '0', '1', '0'),
	(6744, '8341', 200, 'clothing_knightoutfit', 9, 0, 0, 1, 0, 0, 22, 16819, 0, '0', '1', '0'),
	(6745, '8342', 772, 'clothing_firehelm', 6, 0, 0, 1, 0, 0, 38, -1, 0, '0', '1', '0'),
	(6746, '8343', 202, 'clothing_demonhood', 6, 0, 0, 1, 0, 0, 20, 16821, 0, '0', '1', '0'),
	(6747, '8344', 206, 'clothing_knighttrousers', 5, 0, 0, 1, 0, 0, 8, 16822, 0, '0', '1', '0'),
	(6748, '8345', 310, 'clothing_skullnecklace', 6, 0, 0, 1, 0, 0, 55, 16823, 0, '0', '1', '0'),
	(6749, '8346', 772, 'clothing_earthhelm', 6, 0, 0, 1, 0, 0, 19, -1, 0, '0', '1', '0'),
	(6750, '8347', 310, 'clothing_deathmask', 6, 0, 0, 1, 0, 0, 54, -1, 0, '0', '1', '0'),
	(6751, '8348', 310, 'clothing_pestmask', 6, 0, 0, 1, 0, 0, 53, -1, 0, '0', '1', '0'),
	(6752, '8349', 396, 'hween_c15_angel', 4, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(6753, '8350', 662, 'bonusrare16_2*1', 5, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(6754, '8351', 662, 'bonusrare16_2*2', 5, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(6755, '8352', 662, 'bonusrare16_2*3', 5, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(6756, '8353', 662, 'bonusrare16_2*4', 5, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(6757, '8354', 662, 'bonusrare16_1*1', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(6758, '8355', 662, 'bonusrare16_1*2', 5, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(6759, '8356', 662, 'bonusrare16_1*3', 5, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(6760, '8357', 662, 'bonusrare16_1*4', 5, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(6761, '8358', 662, 'bonusrare16_3*1', 5, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(6762, '8359', 662, 'bonusrare16_3*2', 5, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(6763, '8360', 662, 'bonusrare16_3*3', 5, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(6764, '8361', 662, 'bonusrare16_3*4', 5, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(6765, '8362', 771, 'hween_c15_evilcrystal2', 4, 0, 0, 1, 0, 0, 65, -1, 0, '', '1', '0'),
	(6766, '8363', 771, 'hween_c15_purecrystal2', 4, 0, 0, 1, 0, 0, 30, -1, 0, '', '1', '0'),
	(6767, '8364', 396, 'hween_c15_stage', 4, 0, 0, 1, 0, 0, 48, 25834, 0, '', '1', '0'),
	(6768, '8365', 771, 'hween_c15_evilcrystal3', 4, 0, 0, 1, 0, 0, 66, -1, 0, '', '1', '0'),
	(6769, '8366', 396, 'hween_c15_fog', 4, 0, 0, 1, 0, 0, 33, 25834, 0, '', '1', '0'),
	(6770, '8367', 396, 'hween_c15_stagecorner', 4, 0, 0, 1, 0, 0, 49, -1, 0, '', '1', '0'),
	(6771, '8368', 396, 'hween_c15_building', 4, 0, 0, 1, 0, 0, 15, 25834, 0, '', '1', '0'),
	(6772, '8369', 396, 'hween_c15_tele', 4, 0, 0, 1, 0, 0, 51, 25834, 0, '', '1', '0'),
	(6773, '8370', 771, 'hween_c15_evilcrystal1', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(6774, '8371', 396, 'hween_c15_dump', 4, 0, 0, 1, 0, 0, 27, -1, 0, '', '1', '0'),
	(6775, '8372', 396, 'hween15_horseman3', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(6776, '8373', 771, 'hween_c15_purecrystal3', 4, 0, 0, 1, 0, 0, 63, -1, 0, '', '1', '0'),
	(6777, '8374', 396, 'hween_c15_tree', 4, 0, 0, 1, 0, 0, 26, 21590, 0, '', '1', '0'),
	(6778, '8375', 741, 'hween15_ltdhorseman4', 3, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(6779, '8376', 396, 'hween_c15_shinycarpet', 4, 0, 0, 1, 0, 0, 46, -1, 0, '', '1', '0'),
	(6780, '8377', 396, 'hween_c15_corner', 4, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(6781, '8378', 396, 'hween_c15_car', 4, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(6782, '8379', 824, 'hween15_saintini', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(6783, '8380', 824, 'hween15_evilfrank', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(6784, '8381', 396, 'hween_c15_busstop', 4, 0, 0, 1, 0, 0, 23, 25834, 0, '', '1', '0'),
	(6785, '8382', 396, 'hween_c15_telewire', 4, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(6786, '8383', 396, 'hween_c15_phone', 4, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(6787, '8384', 824, 'hween15_evilraider', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(6788, '8385', 396, 'hween_c15_stairs', 4, 0, 0, 1, 0, 0, 50, -1, 0, '', '1', '0'),
	(6789, '8386', 396, 'hween_c15_rubbish', 4, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(6790, '8387', 396, 'hween_c15_road', 4, 0, 0, 1, 0, 0, 42, 25834, 0, '', '1', '0'),
	(6791, '8388', 770, 'hween_c15_altar', 4, 0, 0, 1, 0, 0, -1, -1, 0, '', '1', '0'),
	(6792, '8389', 396, 'hween_c15_evilcloud', 4, 0, 0, 1, 0, 0, 28, 25834, 0, '', '1', '0'),
	(6793, '8390', 396, 'hween_c15_demoncat', 4, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(6794, '8391', 741, 'hween15_ltdhorseman2', 3, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(6795, '8392', 396, 'hween15_horseman2', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(6796, '8393', 396, 'hween_c15_fire', 4, 0, 0, 1, 0, 0, 32, 21590, 0, '', '1', '0'),
	(6797, '8394', 396, 'hween_c15_pavement', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(6798, '8395', 741, 'hween15_ltdhorseman3', 3, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(6799, '8396', 396, 'hween15_horseman1', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(6800, '8397', 396, 'hween_c15_sdcrack', 4, 0, 0, 1, 0, 0, 44, 25834, 0, '', '1', '0'),
	(6801, '8398', 396, 'hween_c15_sdwater', 4, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(6802, '8399', 741, 'hween15_ltdhorseman1', 3, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(6803, '8400', 396, 'hween_c15_lamp', 4, 0, 0, 1, 0, 0, 34, 25834, 0, '', '1', '0'),
	(6804, '8401', 824, 'hween15_saintta', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(6805, '8402', 396, 'hween15_horseman4', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(6806, '8403', 396, 'hween15_horseman5', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(6807, '8404', 771, 'hween_c15_purecrystal1', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(6808, '8405', 307, 'CF_750_evilskull', 750, 0, 0, 1, 0, 0, 27, -1, 0, '', '1', '0'),
	(6809, '8406', 396, 'hween_c15_altarbed', 4, 0, 0, 1, 0, 0, 204, -1, 0, '', '1', '0'),
	(6810, '8407', 243, 'horse_dye_18', 1, 0, 0, 1, 0, 0, 58, -1, 0, '', '1', '0'),
	(6811, '8408', 423, 'fxbox_fx14', 3, 0, 0, 1, 0, 0, 205, -1, 0, '', '1', '0'),
	(6812, '8409', 191, 'hween_c15_pumpkin2', 7, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(6813, '8410', 191, 'hween_c15_pumpkin1', 7, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(6814, '8411', 59, 'ktchn_c15_chair_b', 2, 0, 0, 1, 0, 0, 42, 16951, 0, '', '1', '0'),
	(6815, '8412', 59, 'ktchn_c15_divdr', 4, 0, 0, 1, 0, 0, 49, 16952, 0, '', '1', '0'),
	(6816, '8413', 59, 'ktchn_c15_table_g', 5, 0, 0, 1, 0, 0, 61, 16953, 0, '', '1', '0'),
	(6817, '8414', 59, 'ktchn_c15_floor', 2, 0, 0, 1, 0, 0, 51, 16954, 0, '', '1', '0'),
	(6818, '8415', 59, 'ktchn_c15_bread', 4, 0, 0, 1, 0, 0, 40, -1, 0, '', '1', '0'),
	(6819, '8416', 59, 'ktchn_c15_table_b', 5, 0, 0, 1, 0, 0, 60, 18093, 0, '', '1', '0'),
	(6820, '8417', 59, 'ktchn_c15_chopboard', 4, 0, 0, 1, 0, 0, 45, -1, 0, '', '1', '0'),
	(6821, '8418', 59, 'ktchn_c15_chair_g', 2, 0, 0, 1, 0, 0, 43, 16958, 0, '', '1', '0'),
	(6822, '8419', 59, 'ktchn_c15_lamp_p', 4, 0, 0, 1, 0, 0, 56, 16959, 0, '', '1', '0'),
	(6823, '8420', 59, 'ktchn15_coffeemaker', 10, 0, 0, 1, 0, 0, 28, -1, 0, '', '1', '0'),
	(6824, '8421', 59, 'ktchn_c15_cereal', 4, 0, 0, 1, 0, 0, 41, -1, 0, '', '1', '0'),
	(6825, '8422', 59, 'ktchn_c15_lamp_b', 4, 0, 0, 1, 0, 0, 54, 18104, 0, '', '1', '0'),
	(6826, '8423', 59, 'ktchn_c15_sink', 4, 0, 0, 1, 0, 0, 58, 16963, 0, '', '1', '0'),
	(6827, '8424', 59, 'ktchn_c15_chair_p', 2, 0, 0, 1, 0, 0, 44, 16964, 0, '', '1', '0'),
	(6828, '8425', 59, 'ktchn_c15_lamp_g', 4, 0, 0, 1, 0, 0, 55, 16965, 0, '', '1', '0'),
	(6829, '8426', 59, 'ktchn_c15_crn', 4, 0, 0, 1, 0, 0, 48, 16966, 0, '', '1', '0'),
	(6830, '8427', 59, 'ktchn15_cabinet', 4, 0, 0, 1, 0, 0, 27, -1, 0, '', '1', '0'),
	(6831, '8428', 59, 'ktchn_c15_tele', 4, 0, 0, 1, 0, 0, 63, 16968, 0, '', '1', '0'),
	(6832, '8429', 59, 'ktchn_c15_dishwasher', 4, 0, 0, 1, 0, 0, 46, 18082, 0, '', '1', '0'),
	(6833, '8430', 59, 'ktchn_c15_table_p', 5, 0, 0, 1, 0, 0, 62, 16970, 0, '', '1', '0'),
	(6834, '8431', 59, 'ktchn_c15_stove', 4, 0, 0, 1, 0, 0, 59, 16971, 0, '', '1', '0'),
	(6835, '8432', 59, 'ktchn15_bubblejuicerack', 4, 0, 0, 1, 0, 0, 26, -1, 0, '', '1', '0'),
	(6836, '8433', 59, 'ktchn_c15_gate', 4, 0, 0, 1, 0, 0, 50, 18118, 0, '', '1', '0'),
	(6837, '8434', 59, 'ktchn15_fridge', 10, 0, 0, 1, 0, 0, 29, -1, 0, '', '1', '0'),
	(6838, '8435', 59, 'ktchn_c15_food', 4, 0, 0, 1, 0, 0, 52, -1, 0, '', '1', '0'),
	(6839, '8436', 59, 'ktchn_c15_microwave', 4, 0, 0, 1, 0, 0, 57, -1, 0, '', '1', '0'),
	(6840, '8437', 59, 'ktchn_c15_drinks', 4, 0, 0, 1, 0, 0, 53, 16977, 0, '', '1', '0'),
	(6841, '8438', 823, 'habbo15_pumpkin1', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(6842, '8439', 823, 'habbo15_pumpkin2', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(6843, '8440', 485, 'xmas_c15_bushy1', 4, 0, 0, 1, 0, 0, 29, -1, 0, '', '1', '0'),
	(6844, '8441', 727, 'gold_c15_arc_div2', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(6845, '8442', 727, 'gold_c15_arc_seat', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(6846, '8443', 485, 'gold_c15_arc_icerug', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(6847, '8444', 727, 'gold_c15_arc_statue', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(6848, '8445', 727, 'gold_c15_arc_div1', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(6849, '8446', 727, 'gold_c15_arc_lantern', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(6850, '8447', 727, 'gold_c15_arc_lamp', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(6851, '8448', 727, 'gold_c15_arc_camp', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(6852, '8449', 727, 'gold_c15_arc_tub', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(6853, '8450', 727, 'gold_c15_arc_chair', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(6854, '8451', 637, 'gold_rare_crackable', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6855, '8452', 727, 'gold_c15_arc_tree1', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(6856, '8453', 727, 'gold_c15_arc_table', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(6857, '8454', 727, 'gold_c15_arc_geysir', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(6858, '8455', 727, 'gold_c15_arc_tele', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(6859, '8456', 727, 'gold_c15_arc_hole', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(6860, '8457', 727, 'gold_c15_arc_snow', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(6861, '8458', 727, 'gold_c15_arc_tree2', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(6862, '8459', 741, 'xmas15_nutcrackerltd', 4, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(6863, '8460', 485, 'xmas_c15_advent6', 4, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(6864, '8461', 485, 'xmas_c15_bushy5', 4, 0, 0, 1, 0, 0, 33, -1, 0, '', '1', '0'),
	(6865, '8462', 206, 'clothing_santapants', 5, 0, 0, 1, 0, 0, 7, 17053, 0, '0', '1', '0'),
	(6866, '8463', 485, 'xmas_c15_store1', 4, 0, 0, 1, 0, 0, 47, -1, 0, '', '1', '0'),
	(6867, '8464', 310, 'clothing_bscarf', 6, 0, 0, 1, 0, 0, 52, 17055, 0, '0', '1', '0'),
	(6868, '8465', 485, 'xmas_c15_roof1', 4, 0, 0, 1, 0, 0, 41, -1, 0, '', '1', '0'),
	(6869, '8466', 485, 'winter15_freeze', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(6870, '8467', 485, 'xmas_c15_fnc', 4, 0, 0, 1, 0, 0, 36, -1, 0, '', '1', '0'),
	(6871, '8468', 485, 'winter15_wpost', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(6872, '8469', 485, 'winter15_icehockey', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(6873, '8470', 485, 'xmas_c15_buildbase2', 4, 0, 0, 1, 0, 0, 26, -1, 0, '', '1', '0'),
	(6874, '8471', 485, 'xmas_c15_bushy3', 4, 0, 0, 1, 0, 0, 31, -1, 0, '', '1', '0'),
	(6875, '8472', 485, 'xmas_c15_store4', 4, 0, 0, 1, 0, 0, 49, -1, 0, '', '1', '0'),
	(6876, '8473', 310, 'clothing_xmasbow', 6, 0, 0, 1, 0, 0, 51, 17064, 0, '0', '1', '0'),
	(6877, '8474', 485, 'xmas_c15_advent5', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(6878, '8475', 485, 'xmas_c15_poinsettia', 4, 0, 0, 1, 0, 0, 40, -1, 0, '', '1', '0'),
	(6879, '8476', 485, 'xmas_c15_buildbase1', 4, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(6880, '8477', 485, 'xmas_c15_crnr', 4, 0, 0, 1, 0, 0, 35, -1, 0, '', '1', '0'),
	(6881, '8478', 485, 'xmas15_clocktower', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(6882, '8479', 200, 'clothing_santaoutfit', 15, 0, 0, 1, 0, 0, 21, 17070, 0, '0', '1', '0'),
	(6883, '8480', 200, 'clothing_cladyoutfit', 15, 0, 0, 1, 0, 0, 20, 17071, 0, '0', '1', '0'),
	(6884, '8481', 485, 'xmas_c15_store2', 4, 0, 0, 1, 0, 0, 48, -1, 0, '', '1', '0'),
	(6885, '8482', 485, 'xmas_c15_stall', 4, 0, 0, 1, 0, 0, 45, -1, 0, '', '1', '0'),
	(6886, '8483', 485, 'xmas_c15_snow', 4, 0, 0, 1, 0, 0, 43, 25838, 0, '', '1', '0'),
	(6887, '8484', 485, 'xmas_c15_bndstnd', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(6888, '8485', 485, 'xmas15_rudolf', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(6889, '8486', 485, 'xmas_c15_roof2', 4, 0, 0, 1, 0, 0, 42, -1, 0, '', '1', '0'),
	(6890, '8487', 203, 'clothing_cladydress', 5, 0, 0, 1, 0, 0, 9, 18796, 0, '0', '1', '0'),
	(6891, '8488', 485, 'xmas_c15_advent2', 4, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(6892, '8489', 485, 'winter15_tree4', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(6893, '8490', 485, 'xmas_c15_bushy2', 4, 0, 0, 1, 0, 0, 30, -1, 0, '', '1', '0'),
	(6894, '8491', 741, 'xmas15_wishltd', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(6895, '8492', 485, 'xmas_c15_advent8', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(6896, '8493', 201, 'clothing_cladyhair', 6, 0, 0, 1, 0, 0, 47, 17084, 0, '0', '1', '0'),
	(6897, '8494', 741, 'xmas15_glowdeerltd', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(6898, '8495', 204, 'clothing_santatop', 5, 0, 0, 1, 0, 0, 29, 17086, 0, '0', '1', '0'),
	(6899, '8496', 310, 'clothing_ribbon', 6, 0, 0, 1, 0, 0, 50, 17087, 0, '0', '1', '0'),
	(6900, '8497', 485, 'xmas_c15_advent3', 4, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(6901, '8498', 202, 'clothing_santahat', 6, 0, 0, 1, 0, 0, 19, 17089, 0, '0', '1', '0'),
	(6902, '8499', 485, 'xmas_c15_reindeer', 4, 0, 0, 1, 0, 0, 31, -1, 0, '', '1', '0'),
	(6903, '8500', 741, 'xmas15_fountainltd', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(6904, '8501', 310, 'clothing_snood', 6, 0, 0, 1, 0, 0, 49, 17092, 0, '0', '1', '0'),
	(6905, '8502', 485, 'xmas_c15_store3', 4, 0, 0, 1, 0, 0, 50, -1, 0, '', '1', '0'),
	(6906, '8503', 485, 'xmas_c15_advent1', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(6907, '8504', 485, 'xmas_c15_arch', 4, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(6908, '8505', 485, 'winter15_fnc_crnr', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(6909, '8506', 485, 'xmas_c15_advent4', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(6910, '8507', 208, 'clothing_cladyshoes', 4, 0, 0, 1, 0, 0, 7, 17098, 0, '0', '1', '0'),
	(6911, '8508', 485, 'winter15_snowboard', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(6912, '8509', 201, 'clothing_santabeard', 2, 0, 0, 1, 0, 0, 46, 17100, 0, '0', '1', '0'),
	(6913, '8510', 485, 'xmas_c15_mntn', 4, 0, 0, 1, 0, 0, 39, -1, 0, '', '1', '0'),
	(6914, '8511', 485, 'xmas15_stand', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(6915, '8512', 485, 'xmas_c15_buildmid2', 4, 0, 0, 1, 0, 0, 28, -1, 0, '', '1', '0'),
	(6916, '8513', 485, 'xmas_c15_bushy6', 4, 0, 0, 1, 0, 0, 34, -1, 0, '', '1', '0'),
	(6917, '8514', 485, 'xmas_c15_snwbush', 4, 0, 0, 1, 0, 0, 44, -1, 0, '', '1', '0'),
	(6918, '8515', 485, 'xmas15_sleigh', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(6919, '8516', 485, 'winter15_iceskater', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(6920, '8517', 485, 'xmas_c15_alpinetree', 4, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(6921, '8518', 310, 'clothing_knitband', 6, 0, 0, 1, 0, 0, 48, 17109, 0, '0', '1', '0'),
	(6922, '8519', 485, 'xmas_c15_decotree', 4, 0, 0, 1, 0, 0, 37, -1, 0, '', '1', '0'),
	(6923, '8520', 485, 'xmas_c15_stone', 4, 0, 0, 1, 0, 0, 43, -1, 0, '', '1', '0'),
	(6924, '8521', 485, 'xmas_c15_bushy4', 4, 0, 0, 1, 0, 0, 32, -1, 0, '', '1', '0'),
	(6925, '8522', 485, 'winter15_lmppst', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(6926, '8523', 485, 'xmas_c15_advent7', 4, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(6927, '8524', 485, 'xmas_c15_mlight', 4, 0, 0, 1, 0, 0, 38, 21590, 0, '', '1', '0'),
	(6928, '8525', 485, 'xmas_c15_buildmid1', 4, 0, 0, 1, 0, 0, 27, -1, 0, '', '1', '0'),
	(6929, '8526', 588, 'clothing_knithat', 6, 0, 0, 1, 0, 0, 5, 17117, 0, '0', '1', '0'),
	(6930, '8527', 229, 'hc16_10', 5, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '1'),
	(6931, '8528', 229, 'hc16_1', 5, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '1'),
	(6932, '8529', 229, 'hc16_4', 5, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '1'),
	(6933, '8530', 229, 'hc16_12', 5, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '1'),
	(6934, '8531', 229, 'hc16_11', 5, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '1'),
	(6935, '8532', 229, 'hc16_5', 5, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '1'),
	(6936, '8533', 229, 'hc16_9', 5, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '1'),
	(6937, '8534', 229, 'hc16_7', 5, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '1'),
	(6938, '8535', 229, 'hc16_2', 5, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '1'),
	(6939, '8536', 229, 'hc16_6', 5, 0, 0, 1, 0, 0, 26, -1, 0, '', '1', '1'),
	(6940, '8537', 229, 'hc16_3', 5, 0, 0, 1, 0, 0, 27, -1, 0, '', '1', '1'),
	(6941, '8538', 229, 'hc16_8', 5, 0, 0, 1, 0, 0, 28, -1, 0, '', '1', '1'),
	(6942, '8539', 472, 'ny16_stars', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(6943, '8540', 581, 'clothing_party5', 5, 0, 0, 1, 0, 0, 5, -1, 0, '0', '1', '0'),
	(6944, '8541', 581, 'clothing_party4', 5, 0, 0, 1, 0, 0, 4, -1, 0, '0', '1', '0'),
	(6945, '8542', 581, 'clothing_party8', 5, 0, 0, 1, 0, 0, 8, -1, 0, '0', '1', '0'),
	(6946, '8543', 581, 'clothing_party6', 5, 0, 0, 1, 0, 0, 6, -1, 0, '0', '1', '0'),
	(6947, '8544', 472, 'ny_c16_sign', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(6948, '8545', 581, 'clothing_party3', 5, 0, 0, 1, 0, 0, 3, -1, 0, '0', '1', '0'),
	(6949, '8546', 581, 'clothing_party7', 5, 0, 0, 1, 0, 0, 7, -1, 0, '0', '1', '0'),
	(6950, '8547', 302, 'cny16_monkeyballoon', 4, 0, 0, 1, 0, 0, 55, -1, 0, '', '1', '0'),
	(6951, '8548', 668, 'ny16_crackable', 7, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(6952, '8549', 585, 'clothing_goldpack1', 5, 0, 0, 1, 0, 0, 1, -1, 0, '0', '1', '0'),
	(6953, '8550', 302, 'china_monkey', 4, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(6954, '8551', 307, 'CF_1200_ny16', 1200, 0, 0, 1, 0, 0, 32, -1, 0, '', '1', '0'),
	(6955, '8552', 429, 'tile_fxprovider_nfs', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(6956, '8553', 580, 'clothing_hat_space1', 5, 0, 0, 1, 0, 0, 1, -1, 0, '0', '1', '0'),
	(6957, '8554', 597, 'rare_prize16*1', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(6958, '8555', 597, 'rare_prize16*10', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(6959, '8556', 597, 'rare_prize16*11', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(6960, '8557', 597, 'rare_prize16*12', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(6961, '8558', 597, 'rare_prize16*13', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(6962, '8559', 597, 'rare_prize16*14', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(6963, '8560', 597, 'rare_prize16*2', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(6964, '8561', 597, 'rare_prize16*3', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(6965, '8562', 597, 'rare_prize16*4', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(6966, '8563', 597, 'rare_prize16*5', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(6967, '8564', 597, 'rare_prize16*6', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(6968, '8565', 597, 'rare_prize16*7', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(6969, '8566', 597, 'rare_prize16*8', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(6970, '8567', 597, 'rare_prize16*9', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(6971, '8568', 457, 'val16_float2', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(6972, '8569', 457, 'val_c16_lovebirds', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(6973, '8570', 457, 'val_c16_tikicat', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(6974, '8571', 457, 'val_c16_tikicat2', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(6975, '8572', 457, 'val16_float3', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(6976, '8573', 457, 'val_c16_shellfountain', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(6977, '8574', 457, 'val16_float1', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(6978, '8575', 457, 'val16_float4', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(6979, '8576', 457, 'val_c16_vase', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(6980, '8577', 742, 'easter16_habberge6ltd', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(6981, '8578', 204, 'clothing_pjtop3', 5, 0, 0, 1, 0, 0, 28, 17277, 0, '0', '1', '0'),
	(6982, '8579', 206, 'clothing_sportpants', 5, 0, 0, 1, 0, 0, 6, 17278, 0, '0', '1', '0'),
	(6983, '8580', 200, 'clothing_urbanoutfit', 16, 0, 0, 1, 0, 0, 17, 17279, 0, '0', '1', '0'),
	(6984, '8581', 310, 'clothing_tiedjumper', 6, 0, 0, 1, 0, 0, 47, 17280, 0, '0', '1', '0'),
	(6985, '8582', 310, 'clothing_cumberband', 6, 0, 0, 1, 0, 0, 46, 17281, 0, '0', '1', '0'),
	(6986, '8583', 200, 'clothing_casualoutfit1', 12, 0, 0, 1, 0, 0, 16, 17282, 0, '0', '1', '0'),
	(6987, '8584', 201, 'clothing_manbun', 6, 0, 0, 1, 0, 0, 45, 17283, 0, '0', '1', '0'),
	(6988, '8585', 204, 'clothing_denimvest', 5, 0, 0, 1, 0, 0, 27, 17284, 0, '0', '1', '0'),
	(6989, '8586', 206, 'clothing_pjbottoms1', 5, 0, 0, 1, 0, 0, 5, 17285, 0, '0', '1', '0'),
	(6990, '8587', 204, 'clothing_pjtop1', 5, 0, 0, 1, 0, 0, 26, 17286, 0, '0', '1', '0'),
	(6991, '8588', 310, 'clothing_hipsterglasses', 6, 0, 0, 1, 0, 0, 45, 17287, 0, '0', '1', '0'),
	(6992, '8589', 204, 'clothing_tux', 5, 0, 0, 1, 0, 0, 25, 17288, 0, '0', '1', '0'),
	(6993, '8590', 310, 'clothing_tie1', 6, 0, 0, 1, 0, 0, 44, 17289, 0, '0', '1', '0'),
	(6994, '8591', 202, 'clothing_bandage', 6, 0, 0, 1, 0, 0, 18, -1, 0, '0', '1', '0'),
	(6995, '8592', 206, 'clothing_denimshorts', 5, 0, 0, 1, 0, 0, 4, 17291, 0, '0', '1', '0'),
	(6996, '8593', 202, 'clothing_brainjar', 6, 0, 0, 1, 0, 0, 17, -1, 0, '0', '1', '0'),
	(6997, '8594', 400, 'easter_c16_mallowduck', 4, 0, 0, 1, 0, 0, 100, -1, 0, '', '1', '0'),
	(6998, '8595', 200, 'clothing_floraloutfit', 18, 0, 0, 1, 0, 0, 15, 17294, 0, '0', '1', '0'),
	(6999, '8596', 742, 'easter16_habberge9ltd', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(7000, '8597', 202, 'clothing_duckhat', 6, 0, 0, 1, 0, 0, 16, -1, 0, '0', '1', '0'),
	(7001, '8598', 200, 'clothing_punkoutfit2', 18, 0, 0, 1, 0, 0, 14, 17297, 0, '0', '1', '0'),
	(7002, '8599', 204, 'clothing_tuxshirt', 5, 0, 0, 1, 0, 0, 24, 17298, 0, '0', '1', '0'),
	(7003, '8600', 200, 'clothing_pjoutfit1', 12, 0, 0, 1, 0, 0, 13, 17299, 0, '0', '1', '0'),
	(7004, '8601', 200, 'clothing_hipoutfit3', 16, 0, 0, 1, 0, 0, 12, 17300, 0, '0', '1', '0'),
	(7005, '8602', 208, 'clothing_sliponcanvas', 4, 0, 0, 1, 0, 0, 6, 17301, 0, '0', '1', '0'),
	(7006, '8603', 200, 'clothing_punkoutfit1', 16, 0, 0, 1, 0, 0, 11, 17302, 0, '0', '1', '0'),
	(7007, '8604', 202, 'clothing_backcap', 4, 0, 0, 1, 0, 0, 15, 17303, 0, '0', '1', '0'),
	(7008, '8605', 580, 'clothing_mermaid', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(7009, '8606', 205, 'clothing_jacket_twotone', 5, 0, 0, 1, 0, 0, 10, 17305, 0, '0', '1', '0'),
	(7010, '8607', 201, 'clothing_hipster2', 6, 0, 0, 1, 0, 0, 44, 17306, 0, '0', '1', '0'),
	(7011, '8608', 742, 'easter16_habberge8ltd', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(7012, '8609', 201, 'clothing_disco', 6, 0, 0, 1, 0, 0, 41, 17308, 0, '0', '1', '0'),
	(7013, '8610', 204, 'clothing_longtshirt', 5, 0, 0, 1, 0, 0, 23, 17309, 0, '0', '1', '0'),
	(7014, '8611', 205, 'clothing_sportsjckt', 5, 0, 0, 1, 0, 0, 9, 17310, 0, '0', '1', '0'),
	(7015, '8612', 203, 'clothing_polkadress', 5, 0, 0, 1, 0, 0, 8, 18799, 0, '0', '1', '0'),
	(7016, '8613', 205, 'clothing_tuxoutfit', 5, 0, 0, 1, 0, 0, 8, 17312, 0, '0', '1', '0'),
	(7017, '8614', 204, 'clothing_rippedtop', 5, 0, 0, 1, 0, 0, 22, 17313, 0, '0', '1', '0'),
	(7018, '8615', 742, 'easter16_habberge7ltd', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(7019, '8616', 200, 'clothing_hipoutfit1', 10, 0, 0, 1, 0, 0, 10, 17315, 0, '0', '1', '0'),
	(7020, '8617', 200, 'clothing_hipoutfit2', 16, 0, 0, 1, 0, 0, 9, 17316, 0, '0', '1', '0'),
	(7021, '8618', 310, 'clothing_camera', 6, 0, 0, 1, 0, 0, 43, -1, 0, '0', '1', '0'),
	(7022, '8619', 201, 'clothing_bedhair', 6, 0, 0, 1, 0, 0, 40, 17318, 0, '0', '1', '0'),
	(7023, '8620', 204, 'clothing_halter', 5, 0, 0, 1, 0, 0, 21, 17319, 0, '0', '1', '0'),
	(7024, '8621', 200, 'clothing_pjoutfit2', 12, 0, 0, 1, 0, 0, 8, 17320, 0, '0', '1', '0'),
	(7025, '8622', 204, 'clothing_pjtop2', 5, 0, 0, 1, 0, 0, 20, 17321, 0, '0', '1', '0'),
	(7026, '8623', 200, 'clothing_pjoutfit3', 12, 0, 0, 1, 0, 0, 7, 17322, 0, '0', '1', '0'),
	(7027, '8624', 204, 'clothing_offshldrjumper', 5, 0, 0, 1, 0, 0, 19, 17323, 0, '0', '1', '0'),
	(7028, '8625', 580, 'clothing_bigshades', 6, 0, 0, 1, 0, 0, 3, -1, 0, '0', '1', '0'),
	(7029, '8626', 580, 'clothing_noblecrown', 5, 0, 0, 1, 0, 0, 4, -1, 0, '0', '1', '0'),
	(7030, '8627', 201, 'clothing_ombrehr', 6, 0, 0, 1, 0, 0, 39, 17326, 0, '0', '1', '0'),
	(7031, '8628', 662, 'bonusrare16_4*1', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(7032, '8629', 662, 'bonusrare16_4*2', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(7033, '8630', 662, 'bonusrare16_4*3', 4, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(7034, '8631', 662, 'bonusrare16_4*4', 4, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(7035, '8632', 622, 'icedblk_c16_table', 5, 0, 0, 1, 0, 0, 210, 17358, 0, '', '1', '0'),
	(7036, '8633', 762, 'icedblk_c16_table*10', 5, 0, 0, 1, 0, 0, 174, 17359, 0, '', '1', '0'),
	(7037, '8634', 762, 'icedblk_c16_table*2', 5, 0, 0, 1, 0, 0, 166, 17360, 0, '', '1', '0'),
	(7038, '8635', 762, 'icedblk_c16_table*3', 5, 0, 0, 1, 0, 0, 167, 17361, 0, '', '1', '0'),
	(7039, '8636', 762, 'icedblk_c16_table*4', 5, 0, 0, 1, 0, 0, 168, 17362, 0, '', '1', '0'),
	(7040, '8637', 762, 'icedblk_c16_table*5', 5, 0, 0, 1, 0, 0, 169, 17363, 0, '', '1', '0'),
	(7041, '8638', 762, 'icedblk_c16_table*6', 5, 0, 0, 1, 0, 0, 170, 17364, 0, '', '1', '0'),
	(7042, '8639', 762, 'icedblk_c16_table*7', 5, 0, 0, 1, 0, 0, 171, 17365, 0, '', '1', '0'),
	(7043, '8640', 762, 'icedblk_c16_table*8', 5, 0, 0, 1, 0, 0, 172, 17366, 0, '', '1', '0'),
	(7044, '8641', 762, 'icedblk_c16_table*9', 5, 0, 0, 1, 0, 0, 173, 17367, 0, '', '1', '0'),
	(7045, '8642', 622, 'icedblk_c16_div4', 4, 0, 0, 1, 0, 0, 220, 17368, 0, '', '1', '0'),
	(7046, '8643', 762, 'icedblk_c16_div4*10', 4, 0, 0, 1, 0, 0, 84, 17369, 0, '', '1', '0'),
	(7047, '8644', 762, 'icedblk_c16_div4*2', 4, 0, 0, 1, 0, 0, 76, 17370, 0, '', '1', '0'),
	(7048, '8645', 762, 'icedblk_c16_div4*3', 4, 0, 0, 1, 0, 0, 77, 17371, 0, '', '1', '0'),
	(7049, '8646', 762, 'icedblk_c16_div4*4', 4, 0, 0, 1, 0, 0, 78, 17372, 0, '', '1', '0'),
	(7050, '8647', 762, 'icedblk_c16_div4*5', 4, 0, 0, 1, 0, 0, 79, 17373, 0, '', '1', '0'),
	(7051, '8648', 762, 'icedblk_c16_div4*6', 4, 0, 0, 1, 0, 0, 80, 17374, 0, '', '1', '0'),
	(7052, '8649', 762, 'icedblk_c16_div4*7', 4, 0, 0, 1, 0, 0, 81, 17375, 0, '', '1', '0'),
	(7053, '8650', 762, 'icedblk_c16_div4*8', 4, 0, 0, 1, 0, 0, 82, 17376, 0, '', '1', '0'),
	(7054, '8651', 762, 'icedblk_c16_div4*9', 4, 0, 0, 1, 0, 0, 83, 17377, 0, '', '1', '0'),
	(7055, '8652', 622, 'icedblk_c16_div2', 4, 0, 0, 1, 0, 0, 230, 17378, 0, '', '1', '0'),
	(7056, '8653', 762, 'icedblk_c16_div2*10', 4, 0, 0, 1, 0, 0, 54, 17379, 0, '', '1', '0'),
	(7057, '8654', 762, 'icedblk_c16_div2*2', 4, 0, 0, 1, 0, 0, 46, 17380, 0, '', '1', '0'),
	(7058, '8655', 762, 'icedblk_c16_div2*3', 4, 0, 0, 1, 0, 0, 47, 17381, 0, '', '1', '0'),
	(7059, '8656', 762, 'icedblk_c16_div2*4', 4, 0, 0, 1, 0, 0, 48, 17382, 0, '', '1', '0'),
	(7060, '8657', 762, 'icedblk_c16_div2*5', 4, 0, 0, 1, 0, 0, 49, 17383, 0, '', '1', '0'),
	(7061, '8658', 762, 'icedblk_c16_div2*6', 4, 0, 0, 1, 0, 0, 50, 17384, 0, '', '1', '0'),
	(7062, '8659', 762, 'icedblk_c16_div2*7', 4, 0, 0, 1, 0, 0, 51, 17385, 0, '', '1', '0'),
	(7063, '8660', 762, 'icedblk_c16_div2*8', 4, 0, 0, 1, 0, 0, 52, 17386, 0, '', '1', '0'),
	(7064, '8661', 762, 'icedblk_c16_div2*9', 4, 0, 0, 1, 0, 0, 53, 17387, 0, '', '1', '0'),
	(7065, '8662', 622, 'icedblk_c16_couch', 4, 0, 0, 1, 0, 0, 240, 17388, 0, '', '1', '0'),
	(7066, '8663', 762, 'icedblk_c16_couch*10', 4, 0, 0, 1, 0, 0, 24, 17389, 0, '', '1', '0'),
	(7067, '8664', 762, 'icedblk_c16_couch*2', 4, 0, 0, 1, 0, 0, 16, 17390, 0, '', '1', '0'),
	(7068, '8665', 762, 'icedblk_c16_couch*3', 4, 0, 0, 1, 0, 0, 17, 17391, 0, '', '1', '0'),
	(7069, '8666', 762, 'icedblk_c16_couch*4', 4, 0, 0, 1, 0, 0, 18, 17392, 0, '', '1', '0'),
	(7070, '8667', 762, 'icedblk_c16_couch*5', 4, 0, 0, 1, 0, 0, 19, 17393, 0, '', '1', '0'),
	(7071, '8668', 762, 'icedblk_c16_couch*6', 4, 0, 0, 1, 0, 0, 20, 17394, 0, '', '1', '0'),
	(7072, '8669', 762, 'icedblk_c16_couch*7', 4, 0, 0, 1, 0, 0, 21, 17395, 0, '', '1', '0'),
	(7073, '8670', 762, 'icedblk_c16_couch*8', 4, 0, 0, 1, 0, 0, 22, 17396, 0, '', '1', '0'),
	(7074, '8671', 762, 'icedblk_c16_couch*9', 4, 0, 0, 1, 0, 0, 23, 17397, 0, '', '1', '0'),
	(7075, '8672', 622, 'icedblk_c16_div3', 4, 0, 0, 1, 0, 0, 99, 17398, 0, '', '1', '0'),
	(7076, '8673', 762, 'icedblk_c16_div3*10', 4, 0, 0, 1, 0, 0, 69, 17399, 0, '', '1', '0'),
	(7077, '8674', 762, 'icedblk_c16_div3*2', 4, 0, 0, 1, 0, 0, 61, 17400, 0, '', '1', '0'),
	(7078, '8675', 762, 'icedblk_c16_div3*3', 4, 0, 0, 1, 0, 0, 62, 17401, 0, '', '1', '0'),
	(7079, '8676', 762, 'icedblk_c16_div3*4', 4, 0, 0, 1, 0, 0, 63, 17402, 0, '', '1', '0'),
	(7080, '8677', 762, 'icedblk_c16_div3*5', 4, 0, 0, 1, 0, 0, 64, 17403, 0, '', '1', '0'),
	(7081, '8678', 762, 'icedblk_c16_div3*6', 4, 0, 0, 1, 0, 0, 65, 17404, 0, '', '1', '0'),
	(7082, '8679', 762, 'icedblk_c16_div3*7', 4, 0, 0, 1, 0, 0, 66, 17405, 0, '', '1', '0'),
	(7083, '8680', 762, 'icedblk_c16_div3*8', 4, 0, 0, 1, 0, 0, 67, 17406, 0, '', '1', '0'),
	(7084, '8681', 762, 'icedblk_c16_div3*9', 4, 0, 0, 1, 0, 0, 68, 17407, 0, '', '1', '0'),
	(7085, '8682', 622, 'icedblk_c16_solarium', 4, 0, 0, 1, 0, 0, 251, 17408, 0, '', '1', '0'),
	(7086, '8683', 762, 'icedblk_c16_solarium*10', 4, 0, 0, 1, 0, 0, 159, 17409, 0, '', '1', '0'),
	(7087, '8684', 762, 'icedblk_c16_solarium*2', 4, 0, 0, 1, 0, 0, 151, 17410, 0, '', '1', '0'),
	(7088, '8685', 762, 'icedblk_c16_solarium*3', 4, 0, 0, 1, 0, 0, 152, 17411, 0, '', '1', '0'),
	(7089, '8686', 762, 'icedblk_c16_solarium*4', 4, 0, 0, 1, 0, 0, 153, 17412, 0, '', '1', '0'),
	(7090, '8687', 762, 'icedblk_c16_solarium*5', 4, 0, 0, 1, 0, 0, 154, 17413, 0, '', '1', '0'),
	(7091, '8688', 762, 'icedblk_c16_solarium*6', 4, 0, 0, 1, 0, 0, 155, 17414, 0, '', '1', '0'),
	(7092, '8689', 762, 'icedblk_c16_solarium*7', 4, 0, 0, 1, 0, 0, 156, 17415, 0, '', '1', '0'),
	(7093, '8690', 762, 'icedblk_c16_solarium*8', 4, 0, 0, 1, 0, 0, 157, 17416, 0, '', '1', '0'),
	(7094, '8691', 762, 'icedblk_c16_solarium*9', 4, 0, 0, 1, 0, 0, 158, 17417, 0, '', '1', '0'),
	(7095, '8692', 622, 'icedblk_c16_shelves', 4, 0, 0, 1, 0, 0, 261, 17418, 0, '', '1', '0'),
	(7096, '8693', 762, 'icedblk_c16_shelves*10', 4, 0, 0, 1, 0, 0, 114, 17419, 0, '', '1', '0'),
	(7097, '8694', 762, 'icedblk_c16_shelves*2', 4, 0, 0, 1, 0, 0, 106, 17420, 0, '', '1', '0'),
	(7098, '8695', 762, 'icedblk_c16_shelves*3', 4, 0, 0, 1, 0, 0, 107, 17421, 0, '', '1', '0'),
	(7099, '8696', 762, 'icedblk_c16_shelves*4', 4, 0, 0, 1, 0, 0, 108, 17422, 0, '', '1', '0'),
	(7100, '8697', 762, 'icedblk_c16_shelves*5', 4, 0, 0, 1, 0, 0, 109, 17423, 0, '', '1', '0'),
	(7101, '8698', 762, 'icedblk_c16_shelves*6', 4, 0, 0, 1, 0, 0, 110, 17424, 0, '', '1', '0'),
	(7102, '8699', 762, 'icedblk_c16_shelves*7', 4, 0, 0, 1, 0, 0, 111, 17425, 0, '', '1', '0'),
	(7103, '8700', 762, 'icedblk_c16_shelves*8', 4, 0, 0, 1, 0, 0, 112, 17426, 0, '', '1', '0'),
	(7104, '8701', 762, 'icedblk_c16_shelves*9', 4, 0, 0, 1, 0, 0, 113, 17427, 0, '', '1', '0'),
	(7105, '8702', 622, 'icedblk_c16_sofachair', 2, 0, 0, 1, 0, 0, 271, 17428, 0, '', '1', '0'),
	(7106, '8703', 762, 'icedblk_c16_sofachair*10', 2, 0, 0, 1, 0, 0, 129, 17429, 0, '', '1', '0'),
	(7107, '8704', 762, 'icedblk_c16_sofachair*2', 2, 0, 0, 1, 0, 0, 121, 17430, 0, '', '1', '0'),
	(7108, '8705', 762, 'icedblk_c16_sofachair*3', 2, 0, 0, 1, 0, 0, 122, 17431, 0, '', '1', '0'),
	(7109, '8706', 762, 'icedblk_c16_sofachair*4', 2, 0, 0, 1, 0, 0, 123, 17432, 0, '', '1', '0'),
	(7110, '8707', 762, 'icedblk_c16_sofachair*5', 2, 0, 0, 1, 0, 0, 124, 17433, 0, '', '1', '0'),
	(7111, '8708', 762, 'icedblk_c16_sofachair*6', 2, 0, 0, 1, 0, 0, 125, 17434, 0, '', '1', '0'),
	(7112, '8709', 762, 'icedblk_c16_sofachair*7', 2, 0, 0, 1, 0, 0, 126, 17435, 0, '', '1', '0'),
	(7113, '8710', 762, 'icedblk_c16_sofachair*8', 2, 0, 0, 1, 0, 0, 127, 17436, 0, '', '1', '0'),
	(7114, '8711', 762, 'icedblk_c16_sofachair*9', 2, 0, 0, 1, 0, 0, 128, 17437, 0, '', '1', '0'),
	(7115, '8712', 622, 'icedblk_c16_div1', 4, 0, 0, 1, 0, 0, 281, 17438, 0, '', '1', '0'),
	(7116, '8713', 762, 'icedblk_c16_div1*10', 4, 0, 0, 1, 0, 0, 39, 17439, 0, '', '1', '0'),
	(7117, '8714', 762, 'icedblk_c16_div1*2', 4, 0, 0, 1, 0, 0, 31, 17440, 0, '', '1', '0'),
	(7118, '8715', 762, 'icedblk_c16_div1*3', 4, 0, 0, 1, 0, 0, 32, 17441, 0, '', '1', '0'),
	(7119, '8716', 762, 'icedblk_c16_div1*4', 4, 0, 0, 1, 0, 0, 33, 17442, 0, '', '1', '0'),
	(7120, '8717', 762, 'icedblk_c16_div1*5', 4, 0, 0, 1, 0, 0, 34, 17443, 0, '', '1', '0'),
	(7121, '8718', 762, 'icedblk_c16_div1*6', 4, 0, 0, 1, 0, 0, 35, 17444, 0, '', '1', '0'),
	(7122, '8719', 762, 'icedblk_c16_div1*7', 4, 0, 0, 1, 0, 0, 36, 17445, 0, '', '1', '0'),
	(7123, '8720', 762, 'icedblk_c16_div1*8', 4, 0, 0, 1, 0, 0, 37, 17446, 0, '', '1', '0'),
	(7124, '8721', 762, 'icedblk_c16_div1*9', 4, 0, 0, 1, 0, 0, 38, 17447, 0, '', '1', '0'),
	(7125, '8722', 622, 'icedblk_c16_sofa', 3, 0, 0, 1, 0, 0, 99, 17448, 0, '', '1', '0'),
	(7126, '8723', 762, 'icedblk_c16_sofa*10', 3, 0, 0, 1, 0, 0, 144, 17449, 0, '', '1', '0'),
	(7127, '8724', 762, 'icedblk_c16_sofa*2', 3, 0, 0, 1, 0, 0, 136, 17450, 0, '', '1', '0'),
	(7128, '8725', 762, 'icedblk_c16_sofa*3', 3, 0, 0, 1, 0, 0, 137, 17451, 0, '', '1', '0'),
	(7129, '8726', 762, 'icedblk_c16_sofa*4', 3, 0, 0, 1, 0, 0, 138, 17452, 0, '', '1', '0'),
	(7130, '8727', 762, 'icedblk_c16_sofa*5', 3, 0, 0, 1, 0, 0, 139, 17453, 0, '', '1', '0'),
	(7131, '8728', 762, 'icedblk_c16_sofa*6', 3, 0, 0, 1, 0, 0, 140, 17454, 0, '', '1', '0'),
	(7132, '8729', 762, 'icedblk_c16_sofa*7', 3, 0, 0, 1, 0, 0, 141, 17455, 0, '', '1', '0'),
	(7133, '8730', 762, 'icedblk_c16_sofa*8', 3, 0, 0, 1, 0, 0, 142, 17456, 0, '', '1', '0'),
	(7134, '8731', 762, 'icedblk_c16_sofa*9', 3, 0, 0, 1, 0, 0, 143, 17457, 0, '', '1', '0'),
	(7135, '8732', 622, 'icedblk_c16_chair', 2, 0, 0, 1, 0, 0, 99, 17458, 0, '', '1', '0'),
	(7136, '8733', 762, 'icedblk_c16_chair*10', 2, 0, 0, 1, 0, 0, 10, 17459, 0, '', '1', '0'),
	(7137, '8734', 762, 'icedblk_c16_chair*2', 2, 0, 0, 1, 0, 0, 2, 17460, 0, '', '1', '0'),
	(7138, '8735', 762, 'icedblk_c16_chair*3', 2, 0, 0, 1, 0, 0, 3, 17461, 0, '', '1', '0'),
	(7139, '8736', 762, 'icedblk_c16_chair*4', 2, 0, 0, 1, 0, 0, 4, 17462, 0, '', '1', '0'),
	(7140, '8737', 762, 'icedblk_c16_chair*5', 2, 0, 0, 1, 0, 0, 5, 17463, 0, '', '1', '0'),
	(7141, '8738', 762, 'icedblk_c16_chair*6', 2, 0, 0, 1, 0, 0, 6, 17464, 0, '', '1', '0'),
	(7142, '8739', 762, 'icedblk_c16_chair*7', 2, 0, 0, 1, 0, 0, 7, 17465, 0, '', '1', '0'),
	(7143, '8740', 762, 'icedblk_c16_chair*8', 2, 0, 0, 1, 0, 0, 8, 17466, 0, '', '1', '0'),
	(7144, '8741', 762, 'icedblk_c16_chair*9', 2, 0, 0, 1, 0, 0, 9, 17467, 0, '', '1', '0'),
	(7145, '8742', 622, 'icedblk_c16_div5', 4, 0, 0, 1, 0, 0, 298, 17468, 0, '', '1', '0'),
	(7146, '8743', 762, 'icedblk_c16_div5*10', 4, 0, 0, 1, 0, 0, 99, 17469, 0, '', '1', '0'),
	(7147, '8744', 762, 'icedblk_c16_div5*2', 4, 0, 0, 1, 0, 0, 91, 17470, 0, '', '1', '0'),
	(7148, '8745', 762, 'icedblk_c16_div5*3', 4, 0, 0, 1, 0, 0, 92, 17471, 0, '', '1', '0'),
	(7149, '8746', 762, 'icedblk_c16_div5*4', 4, 0, 0, 1, 0, 0, 93, 17472, 0, '', '1', '0'),
	(7150, '8747', 762, 'icedblk_c16_div5*5', 4, 0, 0, 1, 0, 0, 94, 17473, 0, '', '1', '0'),
	(7151, '8748', 762, 'icedblk_c16_div5*6', 4, 0, 0, 1, 0, 0, 95, 17474, 0, '', '1', '0'),
	(7152, '8749', 762, 'icedblk_c16_div5*7', 4, 0, 0, 1, 0, 0, 96, 17475, 0, '', '1', '0'),
	(7153, '8750', 762, 'icedblk_c16_div5*8', 4, 0, 0, 1, 0, 0, 97, 17476, 0, '', '1', '0'),
	(7154, '8751', 762, 'icedblk_c16_div5*9', 4, 0, 0, 1, 0, 0, 98, 17477, 0, '', '1', '0'),
	(7155, '8752', 656, 'purablk_c16_shelve', 4, 0, 0, 1, 0, 0, 4, 17478, 0, '', '1', '0'),
	(7156, '8753', 656, 'purablk_c16_eleblock*1', 4, 0, 0, 1, 0, 0, 40, 17479, 0, '', '1', '0'),
	(7157, '8754', 656, 'purablk_c16_eleblock*10', 4, 0, 0, 1, 0, 0, 46, 17480, 0, '', '1', '0'),
	(7158, '8755', 656, 'purablk_c16_eleblock*2', 4, 0, 0, 1, 0, 0, 45, 17481, 0, '', '1', '0'),
	(7159, '8756', 656, 'purablk_c16_eleblock*3', 4, 0, 0, 1, 0, 0, 42, 17482, 0, '', '1', '0'),
	(7160, '8757', 656, 'purablk_c16_eleblock*4', 4, 0, 0, 1, 0, 0, 49, 17483, 0, '', '1', '0'),
	(7161, '8758', 656, 'purablk_c16_eleblock*5', 4, 0, 0, 1, 0, 0, 41, 17484, 0, '', '1', '0'),
	(7162, '8759', 656, 'purablk_c16_eleblock*6', 4, 0, 0, 1, 0, 0, 43, 17485, 0, '', '1', '0'),
	(7163, '8760', 656, 'purablk_c16_eleblock*7', 4, 0, 0, 1, 0, 0, 44, 17486, 0, '', '1', '0'),
	(7164, '8761', 656, 'purablk_c16_eleblock*8', 4, 0, 0, 1, 0, 0, 48, 17487, 0, '', '1', '0'),
	(7165, '8762', 656, 'purablk_c16_eleblock*9', 4, 0, 0, 1, 0, 0, 47, 17488, 0, '', '1', '0'),
	(7166, '8763', 656, 'purablk_c16_round*1', 4, 0, 0, 1, 0, 0, 100, 17489, 0, '', '1', '0'),
	(7167, '8764', 656, 'purablk_c16_round*10', 4, 0, 0, 1, 0, 0, 106, 17490, 0, '', '1', '0'),
	(7168, '8765', 656, 'purablk_c16_round*2', 4, 0, 0, 1, 0, 0, 105, 17491, 0, '', '1', '0'),
	(7169, '8766', 656, 'purablk_c16_round*3', 4, 0, 0, 1, 0, 0, 102, 17492, 0, '', '1', '0'),
	(7170, '8767', 656, 'purablk_c16_round*4', 4, 0, 0, 1, 0, 0, 109, 17493, 0, '', '1', '0'),
	(7171, '8768', 656, 'purablk_c16_round*5', 4, 0, 0, 1, 0, 0, 101, 17494, 0, '', '1', '0'),
	(7172, '8769', 656, 'purablk_c16_round*6', 4, 0, 0, 1, 0, 0, 103, 17495, 0, '', '1', '0'),
	(7173, '8770', 656, 'purablk_c16_round*7', 4, 0, 0, 1, 0, 0, 104, 17496, 0, '', '1', '0'),
	(7174, '8771', 656, 'purablk_c16_round*8', 4, 0, 0, 1, 0, 0, 108, 17497, 0, '', '1', '0'),
	(7175, '8772', 656, 'purablk_c16_round*9', 4, 0, 0, 1, 0, 0, 107, 17498, 0, '', '1', '0'),
	(7176, '8773', 656, 'purablk_c16_lamp1', 4, 0, 0, 1, 0, 0, 1, 17499, 0, '', '1', '0'),
	(7177, '8774', 656, 'purablk_c16_chair*1', 2, 0, 0, 1, 0, 0, 30, 17500, 0, '', '1', '0'),
	(7178, '8775', 656, 'purablk_c16_chair*10', 2, 0, 0, 1, 0, 0, 36, 17501, 0, '', '1', '0'),
	(7179, '8776', 656, 'purablk_c16_chair*2', 2, 0, 0, 1, 0, 0, 35, 17502, 0, '', '1', '0'),
	(7180, '8777', 656, 'purablk_c16_chair*3', 2, 0, 0, 1, 0, 0, 32, 17503, 0, '', '1', '0'),
	(7181, '8778', 656, 'purablk_c16_chair*4', 2, 0, 0, 1, 0, 0, 39, 17504, 0, '', '1', '0'),
	(7182, '8779', 656, 'purablk_c16_chair*5', 2, 0, 0, 1, 0, 0, 31, 17505, 0, '', '1', '0'),
	(7183, '8780', 656, 'purablk_c16_chair*6', 2, 0, 0, 1, 0, 0, 33, 17506, 0, '', '1', '0'),
	(7184, '8781', 656, 'purablk_c16_chair*7', 2, 0, 0, 1, 0, 0, 34, 17507, 0, '', '1', '0'),
	(7185, '8782', 656, 'purablk_c16_chair*8', 2, 0, 0, 1, 0, 0, 38, 17508, 0, '', '1', '0'),
	(7186, '8783', 656, 'purablk_c16_chair*9', 2, 0, 0, 1, 0, 0, 37, 17509, 0, '', '1', '0'),
	(7187, '8784', 656, 'purablk_c16_lamp3', 4, 0, 0, 1, 0, 0, 3, 17510, 0, '', '1', '0'),
	(7188, '8785', 656, 'purablk_c16_bed*1', 4, 0, 0, 1, 0, 0, 20, 17511, 0, '', '1', '0'),
	(7189, '8786', 656, 'purablk_c16_bed*10', 4, 0, 0, 1, 0, 0, 26, 17512, 0, '', '1', '0'),
	(7190, '8787', 656, 'purablk_c16_bed*2', 4, 0, 0, 1, 0, 0, 25, 17513, 0, '', '1', '0'),
	(7191, '8788', 656, 'purablk_c16_bed*3', 4, 0, 0, 1, 0, 0, 22, 17514, 0, '', '1', '0'),
	(7192, '8789', 656, 'purablk_c16_bed*4', 4, 0, 0, 1, 0, 0, 29, 17515, 0, '', '1', '0'),
	(7193, '8790', 656, 'purablk_c16_bed*5', 4, 0, 0, 1, 0, 0, 21, 17516, 0, '', '1', '0'),
	(7194, '8791', 656, 'purablk_c16_bed*6', 4, 0, 0, 1, 0, 0, 23, 17517, 0, '', '1', '0'),
	(7195, '8792', 656, 'purablk_c16_bed*7', 4, 0, 0, 1, 0, 0, 24, 17518, 0, '', '1', '0'),
	(7196, '8793', 656, 'purablk_c16_bed*8', 4, 0, 0, 1, 0, 0, 28, 17519, 0, '', '1', '0'),
	(7197, '8794', 656, 'purablk_c16_bed*9', 4, 0, 0, 1, 0, 0, 27, 17520, 0, '', '1', '0'),
	(7198, '8795', 656, 'purablk_c16_mdl3*1', 4, 0, 0, 1, 0, 0, 70, 17521, 0, '', '1', '0'),
	(7199, '8796', 656, 'purablk_c16_mdl3*10', 4, 0, 0, 1, 0, 0, 76, 17522, 0, '', '1', '0'),
	(7200, '8797', 656, 'purablk_c16_mdl3*2', 4, 0, 0, 1, 0, 0, 75, 17523, 0, '', '1', '0'),
	(7201, '8798', 656, 'purablk_c16_mdl3*3', 4, 0, 0, 1, 0, 0, 72, 17524, 0, '', '1', '0'),
	(7202, '8799', 656, 'purablk_c16_mdl3*4', 4, 0, 0, 1, 0, 0, 79, 17525, 0, '', '1', '0'),
	(7203, '8800', 656, 'purablk_c16_mdl3*5', 4, 0, 0, 1, 0, 0, 71, 17526, 0, '', '1', '0'),
	(7204, '8801', 656, 'purablk_c16_mdl3*6', 4, 0, 0, 1, 0, 0, 73, 17527, 0, '', '1', '0'),
	(7205, '8802', 656, 'purablk_c16_mdl3*7', 4, 0, 0, 1, 0, 0, 74, 17528, 0, '', '1', '0'),
	(7206, '8803', 656, 'purablk_c16_mdl3*8', 4, 0, 0, 1, 0, 0, 78, 17529, 0, '', '1', '0'),
	(7207, '8804', 656, 'purablk_c16_mdl3*9', 4, 0, 0, 1, 0, 0, 77, 17530, 0, '', '1', '0'),
	(7208, '8805', 656, 'purablk_c16_bedone*1', 4, 0, 0, 1, 0, 0, 10, 17531, 0, '', '1', '0'),
	(7209, '8806', 656, 'purablk_c16_bedone*10', 4, 0, 0, 1, 0, 0, 16, 17532, 0, '', '1', '0'),
	(7210, '8807', 656, 'purablk_c16_bedone*2', 4, 0, 0, 1, 0, 0, 15, 17533, 0, '', '1', '0'),
	(7211, '8808', 656, 'purablk_c16_bedone*3', 4, 0, 0, 1, 0, 0, 12, 17534, 0, '', '1', '0'),
	(7212, '8809', 656, 'purablk_c16_bedone*4', 4, 0, 0, 1, 0, 0, 19, 17535, 0, '', '1', '0'),
	(7213, '8810', 656, 'purablk_c16_bedone*5', 4, 0, 0, 1, 0, 0, 11, 17536, 0, '', '1', '0'),
	(7214, '8811', 656, 'purablk_c16_bedone*6', 4, 0, 0, 1, 0, 0, 13, 17537, 0, '', '1', '0'),
	(7215, '8812', 656, 'purablk_c16_bedone*7', 4, 0, 0, 1, 0, 0, 14, 17538, 0, '', '1', '0'),
	(7216, '8813', 656, 'purablk_c16_bedone*8', 4, 0, 0, 1, 0, 0, 18, 17539, 0, '', '1', '0'),
	(7217, '8814', 656, 'purablk_c16_bedone*9', 4, 0, 0, 1, 0, 0, 17, 17540, 0, '', '1', '0'),
	(7218, '8815', 656, 'purablk_c16_mdl2*1', 4, 0, 0, 1, 0, 0, 60, 17541, 0, '', '1', '0'),
	(7219, '8816', 656, 'purablk_c16_mdl2*10', 4, 0, 0, 1, 0, 0, 66, 17542, 0, '', '1', '0'),
	(7220, '8817', 656, 'purablk_c16_mdl2*2', 4, 0, 0, 1, 0, 0, 65, 17543, 0, '', '1', '0'),
	(7221, '8818', 656, 'purablk_c16_mdl2*3', 4, 0, 0, 1, 0, 0, 62, 17544, 0, '', '1', '0'),
	(7222, '8819', 656, 'purablk_c16_mdl2*4', 4, 0, 0, 1, 0, 0, 69, 17545, 0, '', '1', '0'),
	(7223, '8820', 656, 'purablk_c16_mdl2*5', 4, 0, 0, 1, 0, 0, 61, 17546, 0, '', '1', '0'),
	(7224, '8821', 656, 'purablk_c16_mdl2*6', 4, 0, 0, 1, 0, 0, 63, 17547, 0, '', '1', '0'),
	(7225, '8822', 656, 'purablk_c16_mdl2*7', 4, 0, 0, 1, 0, 0, 64, 17548, 0, '', '1', '0'),
	(7226, '8823', 656, 'purablk_c16_mdl2*8', 4, 0, 0, 1, 0, 0, 68, 17549, 0, '', '1', '0'),
	(7227, '8824', 656, 'purablk_c16_mdl2*9', 4, 0, 0, 1, 0, 0, 67, 17550, 0, '', '1', '0'),
	(7228, '8825', 656, 'purablk_c16_bar', 10, 0, 0, 1, 0, 0, 6, 17551, 0, '', '1', '0'),
	(7229, '8826', 656, 'purablk_c16_fridge', 10, 0, 0, 1, 0, 0, 5, 17552, 0, '', '1', '0'),
	(7230, '8827', 656, 'purablk_c16_mdl5*1', 4, 0, 0, 1, 0, 0, 90, 17553, 0, '', '1', '0'),
	(7231, '8828', 656, 'purablk_c16_mdl5*10', 4, 0, 0, 1, 0, 0, 96, 17554, 0, '', '1', '0'),
	(7232, '8829', 656, 'purablk_c16_mdl5*2', 4, 0, 0, 1, 0, 0, 95, 17555, 0, '', '1', '0'),
	(7233, '8830', 656, 'purablk_c16_mdl5*3', 4, 0, 0, 1, 0, 0, 92, 17556, 0, '', '1', '0'),
	(7234, '8831', 656, 'purablk_c16_mdl5*4', 4, 0, 0, 1, 0, 0, 99, 17557, 0, '', '1', '0'),
	(7235, '8832', 656, 'purablk_c16_mdl5*5', 4, 0, 0, 1, 0, 0, 91, 17558, 0, '', '1', '0'),
	(7236, '8833', 656, 'purablk_c16_mdl5*6', 4, 0, 0, 1, 0, 0, 93, 17559, 0, '', '1', '0'),
	(7237, '8834', 656, 'purablk_c16_mdl5*7', 4, 0, 0, 1, 0, 0, 94, 17560, 0, '', '1', '0'),
	(7238, '8835', 656, 'purablk_c16_mdl5*8', 4, 0, 0, 1, 0, 0, 98, 17561, 0, '', '1', '0'),
	(7239, '8836', 656, 'purablk_c16_mdl5*9', 4, 0, 0, 1, 0, 0, 97, 17562, 0, '', '1', '0'),
	(7240, '8837', 656, 'purablk_c16_mdl1*1', 4, 0, 0, 1, 0, 0, 50, 17563, 0, '', '1', '0'),
	(7241, '8838', 656, 'purablk_c16_mdl1*10', 4, 0, 0, 1, 0, 0, 56, 17564, 0, '', '1', '0'),
	(7242, '8839', 656, 'purablk_c16_mdl1*2', 4, 0, 0, 1, 0, 0, 55, 17565, 0, '', '1', '0'),
	(7243, '8840', 656, 'purablk_c16_mdl1*3', 4, 0, 0, 1, 0, 0, 52, 17566, 0, '', '1', '0'),
	(7244, '8841', 656, 'purablk_c16_mdl1*4', 4, 0, 0, 1, 0, 0, 59, 17567, 0, '', '1', '0'),
	(7245, '8842', 656, 'purablk_c16_mdl1*5', 4, 0, 0, 1, 0, 0, 51, 17568, 0, '', '1', '0'),
	(7246, '8843', 656, 'purablk_c16_mdl1*6', 4, 0, 0, 1, 0, 0, 53, 17569, 0, '', '1', '0'),
	(7247, '8844', 656, 'purablk_c16_mdl1*7', 4, 0, 0, 1, 0, 0, 54, 17570, 0, '', '1', '0'),
	(7248, '8845', 656, 'purablk_c16_mdl1*8', 4, 0, 0, 1, 0, 0, 58, 17571, 0, '', '1', '0'),
	(7249, '8846', 656, 'purablk_c16_mdl1*9', 4, 0, 0, 1, 0, 0, 57, 17572, 0, '', '1', '0'),
	(7250, '8847', 656, 'purablk_c16_lamp2', 4, 0, 0, 1, 0, 0, 2, 17573, 0, '', '1', '0'),
	(7251, '8848', 656, 'purablk_c16_mdl4*1', 4, 0, 0, 1, 0, 0, 80, 17574, 0, '', '1', '0'),
	(7252, '8849', 656, 'purablk_c16_mdl4*10', 4, 0, 0, 1, 0, 0, 86, 17575, 0, '', '1', '0'),
	(7253, '8850', 656, 'purablk_c16_mdl4*2', 4, 0, 0, 1, 0, 0, 85, 17576, 0, '', '1', '0'),
	(7254, '8851', 656, 'purablk_c16_mdl4*3', 4, 0, 0, 1, 0, 0, 82, 17577, 0, '', '1', '0'),
	(7255, '8852', 656, 'purablk_c16_mdl4*4', 4, 0, 0, 1, 0, 0, 89, 17578, 0, '', '1', '0'),
	(7256, '8853', 656, 'purablk_c16_mdl4*5', 4, 0, 0, 1, 0, 0, 81, 17579, 0, '', '1', '0'),
	(7257, '8854', 656, 'purablk_c16_mdl4*6', 4, 0, 0, 1, 0, 0, 83, 17580, 0, '', '1', '0'),
	(7258, '8855', 656, 'purablk_c16_mdl4*7', 4, 0, 0, 1, 0, 0, 84, 17581, 0, '', '1', '0'),
	(7259, '8856', 656, 'purablk_c16_mdl4*8', 4, 0, 0, 1, 0, 0, 88, 17582, 0, '', '1', '0'),
	(7260, '8857', 656, 'purablk_c16_mdl4*9', 4, 0, 0, 1, 0, 0, 87, 17583, 0, '', '1', '0'),
	(7261, '8858', 180, 'pura_mdl4*10', 4, 0, 0, 1, 0, 0, 86, 17584, 0, '', '1', '0'),
	(7262, '8859', 180, 'bed_budget*10', 4, 0, 0, 1, 0, 0, 26, 17585, 0, '', '1', '0'),
	(7263, '8860', 180, 'pura_c16_roundpad10', 4, 0, 0, 1, 0, 0, 106, 17586, 0, '', '1', '0'),
	(7264, '8861', 180, 'bed_budget_one*10', 4, 0, 0, 1, 0, 0, 16, 17587, 0, '', '1', '0'),
	(7265, '8862', 180, 'pura_mdl3*10', 4, 0, 0, 1, 0, 0, 76, 17588, 0, '', '1', '0'),
	(7266, '8863', 180, 'pura_mdl5*10', 4, 0, 0, 1, 0, 0, 96, 17589, 0, '', '1', '0'),
	(7267, '8864', 180, 'pura_mdl2*10', 4, 0, 0, 1, 0, 0, 66, 17590, 0, '', '1', '0'),
	(7268, '8865', 180, 'chair_basic*10', 2, 0, 0, 1, 0, 0, 36, 17591, 0, '', '1', '0'),
	(7269, '8866', 180, 'pura_c16_eleblock10', 4, 0, 0, 1, 0, 0, 46, 17592, 0, '', '1', '0'),
	(7270, '8867', 180, 'pura_mdl1*10', 4, 0, 0, 1, 0, 0, 56, 17593, 0, '', '1', '0'),
	(7271, '8868', 27, 'divider_nor1*10', 4, 0, 0, 1, 0, 0, 39, 17594, 0, '', '1', '0'),
	(7272, '8869', 27, 'divider_nor5*10', 4, 0, 0, 1, 0, 0, 99, 17595, 0, '', '1', '0'),
	(7273, '8870', 27, 'solarium_norja*10', 4, 0, 0, 1, 0, 0, 164, 17596, 0, '', '1', '0'),
	(7274, '8871', 27, 'divider_nor4*10', 4, 0, 0, 1, 0, 0, 84, 17597, 0, '', '1', '0'),
	(7275, '8872', 27, 'soft_sofa_norja*10', 3, 0, 0, 1, 0, 0, 149, 17598, 0, '', '1', '0'),
	(7276, '8873', 27, 'chair_norja*10', 2, 0, 0, 1, 0, 0, 10, 17599, 0, '', '1', '0'),
	(7277, '8874', 27, 'table_norja_med*10', 2, 0, 0, 1, 0, 0, 174, 17600, 0, '', '1', '0'),
	(7278, '8875', 27, 'shelves_norja*10', 4, 0, 0, 1, 0, 0, 114, 17601, 0, '', '1', '0'),
	(7279, '8876', 27, 'divider_nor3*10', 4, 0, 0, 1, 0, 0, 69, 17602, 0, '', '1', '0'),
	(7280, '8877', 27, 'soft_sofachair_norja*10', 2, 0, 0, 1, 0, 0, 129, 17603, 0, '', '1', '0'),
	(7281, '8878', 27, 'couch_norja*10', 4, 0, 0, 1, 0, 0, 24, 17604, 0, '', '1', '0'),
	(7282, '8879', 27, 'divider_nor2*10', 4, 0, 0, 1, 0, 0, 54, 17605, 0, '', '1', '0'),
	(7283, '8880', 845, 'easter_r16_squid', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(7284, '8881', 844, 'easter_r16_crackable', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(7285, '8882', 845, 'easter_r16_pot', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(7286, '8883', 110, 'easter_c16_house', 4, 0, 0, 1, 0, 0, 100, -1, 0, '', '1', '0'),
	(7287, '8884', 845, 'easter_r16_gold', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(7288, '8885', 708, 'easter_c16_nest', 4, 0, 0, 1, 0, 0, 100, -1, 0, '', '1', '0'),
	(7289, '8886', 845, 'easter_r16_throne', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(7290, '8887', 662, 'bonusrare16_5*1', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(7291, '8888', 662, 'bonusrare16_5*2', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(7292, '8889', 662, 'bonusrare16_5*3', 4, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(7293, '8890', 662, 'bonusrare16_5*4', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(7294, '8891', 662, 'bonusrare16_5*5', 4, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(7295, '8892', 662, 'bonusrare16_5*6', 4, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(7296, '8893', 662, 'bonusrare16_6*1', 4, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(7297, '8894', 662, 'bonusrare16_6*2', 4, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(7298, '8895', 662, 'bonusrare16_6*3', 4, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(7299, '8896', 662, 'bonusrare16_6*4', 4, 0, 0, 1, 0, 0, 26, -1, 0, '', '1', '0'),
	(7300, '8897', 662, 'bonusrare16_6*5', 4, 0, 0, 1, 0, 0, 27, -1, 0, '', '1', '0'),
	(7301, '8898', 662, 'bonusrare16_6*6', 4, 0, 0, 1, 0, 0, 28, -1, 0, '', '1', '0'),
	(7302, '8899', 280, 'super_r16_herodisplay', 4, 0, 0, 1, 0, 0, 91, -1, 0, '', '1', '0'),
	(7303, '8900', 280, 'super_r16_adamskele', 4, 0, 0, 1, 0, 0, 90, -1, 0, '', '1', '0'),
	(7304, '8901', 580, 'clothing_r16_helmhero', 5, 0, 0, 1, 0, 0, 5, -1, 0, '0', '1', '0'),
	(7305, '8902', 580, 'clothing_r16_helmprotect', 5, 0, 0, 1, 0, 0, 6, -1, 0, '0', '1', '0'),
	(7306, '8903', 439, 'room_wl15_telehc', 4, 0, 0, 1, 0, 0, 308, -1, 0, '', '1', '0'),
	(7307, '8904', 359, 'classic1_table2', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(7308, '8905', 359, 'classic1_lamp', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(7309, '8906', 359, 'classic1_pillar', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(7310, '8907', 359, 'classic1_plant', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(7311, '8908', 359, 'classic1_chair', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(7312, '8909', 359, 'classic1_desk', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(7313, '8910', 359, 'classic1_gate', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(7314, '8911', 359, 'classic1_wall2', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(7315, '8912', 359, 'classic1_table1', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(7316, '8913', 359, 'classic1_shelf', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(7317, '8914', 359, 'classic1_floor', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(7318, '8915', 359, 'classic1_sofa', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(7319, '8916', 359, 'classic1_wall1', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(7320, '8917', 538, 'ads_dtlrare_2', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(7321, '8918', 214, 'jungle_c16_flowerd2', 4, 0, 0, 1, 0, 0, 110, -1, 0, '', '1', '0'),
	(7322, '8919', 214, 'jungle_c16_flowerd1', 4, 0, 0, 1, 0, 0, 109, -1, 0, '', '1', '0'),
	(7323, '8920', 214, 'jungle_c16_roof', 4, 0, 0, 1, 0, 0, 34, -1, 0, '', '1', '0'),
	(7324, '8921', 774, 'jungle_c16_berry', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(7325, '8922', 214, 'jungle_c16_swingsofa', 3, 0, 0, 1, 0, 0, 41, -1, 0, '', '1', '0'),
	(7326, '8923', 775, 'jungle_c16_bridgeend3', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(7327, '8924', 214, 'jungle_c16_light', 4, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(7328, '8925', 775, 'jungle_c16_table3', 4, 0, 0, 1, 0, 0, 46, -1, 0, '', '1', '0'),
	(7329, '8926', 214, 'jungle_c16_flowerc3', 4, 0, 0, 1, 0, 0, 108, -1, 0, '', '1', '0'),
	(7330, '8927', 214, 'jungle_c16_stairs', 4, 0, 0, 1, 0, 0, 38, -1, 0, '', '1', '0'),
	(7331, '8928', 775, 'jungle_c16_gate3', 4, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(7332, '8929', 214, 'jungle_c16_pot', 4, 0, 0, 1, 0, 0, 28, -1, 0, '', '1', '0'),
	(7333, '8930', 214, 'jungle_c16_tallgrass', 4, 0, 0, 1, 0, 0, 47, -1, 0, '', '1', '0'),
	(7334, '8931', 214, 'jungle_c16_floor', 2, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(7335, '8932', 742, 'jungle_ltd16_orangutan', 4, 0, 0, 1, 0, 0, 32, -1, 0, '', '1', '0'),
	(7336, '8933', 214, 'jungle_r16_basket', 4, 0, 0, 1, 0, 0, 58, -1, 0, '', '1', '0'),
	(7337, '8934', 775, 'jungle_c16_mat3', 4, 0, 0, 1, 0, 0, 26, -1, 0, '', '1', '0'),
	(7338, '8935', 214, 'jungle_c16_mat', 4, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(7339, '8936', 774, 'jungle_c16_berry2', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(7340, '8937', 775, 'jungle_c16_mat2', 4, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(7341, '8938', 773, 'jungle_c16_worktable', 4, 0, 0, 1, 0, 0, 31, -1, 0, '', '1', '0'),
	(7342, '8939', 775, 'jungle_c16_stairs3', 4, 0, 0, 1, 0, 0, 40, -1, 0, '', '1', '0'),
	(7343, '8940', 214, 'jungle_c16_rafflesia', 4, 0, 0, 1, 0, 0, 32, -1, 0, '', '1', '0'),
	(7344, '8941', 775, 'jungle_c16_pot2', 4, 0, 0, 1, 0, 0, 29, -1, 0, '', '1', '0'),
	(7345, '8942', 775, 'jungle_c16_swingsofa2', 3, 0, 0, 1, 0, 0, 42, -1, 0, '', '1', '0'),
	(7346, '8943', 775, 'jungle_c16_wall2', 4, 0, 0, 1, 0, 0, 54, -1, 0, '', '1', '0'),
	(7347, '8944', 775, 'jungle_c16_bridgeend2', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(7348, '8945', 214, 'jungle_r16_pitcherplant', 4, 0, 0, 1, 0, 0, 59, -1, 0, '', '1', '0'),
	(7349, '8946', 214, 'jungle_c16_tele', 4, 0, 0, 1, 0, 0, 48, -1, 0, '', '1', '0'),
	(7350, '8947', 214, 'jungle_c16_table', 4, 0, 0, 1, 0, 0, 44, -1, 0, '', '1', '0'),
	(7351, '8948', 214, 'jungle_c16_flowera3', 4, 0, 0, 1, 0, 0, 102, -1, 0, '', '1', '0'),
	(7352, '8949', 214, 'jungle_c16_tree', 4, 0, 0, 1, 0, 0, 49, -1, 0, '', '1', '0'),
	(7353, '8950', 775, 'jungle_c16_stairs2', 4, 0, 0, 1, 0, 0, 39, -1, 0, '', '1', '0'),
	(7354, '8951', 214, 'jungle_c16_flowerd3', 4, 0, 0, 1, 0, 0, 111, -1, 0, '', '1', '0'),
	(7355, '8952', 775, 'jungle_c16_wall3', 4, 0, 0, 1, 0, 0, 55, -1, 0, '', '1', '0'),
	(7356, '8953', 775, 'jungle_c16_dvdr2', 4, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(7357, '8954', 775, 'jungle_c16_swingsofa3', 3, 0, 0, 1, 0, 0, 43, -1, 0, '', '1', '0'),
	(7358, '8955', 214, 'jungle_c16_treestage', 4, 0, 0, 1, 0, 0, 50, -1, 0, '', '1', '0'),
	(7359, '8956', 214, 'jungle_c16_rocks', 4, 0, 0, 1, 0, 0, 33, -1, 0, '', '1', '0'),
	(7360, '8957', 214, 'jungle_c16_fruits', 4, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(7361, '8958', 775, 'jungle_c16_treestage2', 4, 0, 0, 1, 0, 0, 51, -1, 0, '', '1', '0'),
	(7362, '8959', 214, 'jungle_c16_bush', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(7363, '8960', 775, 'jungle_c16_gate2', 4, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(7364, '8961', 214, 'jungle_c16_ctrick', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(7365, '8962', 214, 'jungle_c16_gate', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(7366, '8963', 214, 'jungle_c16_dvdr', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(7367, '8964', 214, 'jungle_c16_plant', 4, 0, 0, 1, 0, 0, 27, -1, 0, '', '1', '0'),
	(7368, '8965', 214, 'jungle_c16_sacks', 4, 0, 0, 1, 0, 0, 37, -1, 0, '', '1', '0'),
	(7369, '8966', 214, 'jungle_r16_raft', 4, 0, 0, 1, 0, 0, 60, -1, 0, '', '1', '0'),
	(7370, '8967', 214, 'jungle_c16_wall', 4, 0, 0, 1, 0, 0, 53, -1, 0, '', '1', '0'),
	(7371, '8968', 214, 'jungle_c16_flowerc2', 4, 0, 0, 1, 0, 0, 107, -1, 0, '', '1', '0'),
	(7372, '8969', 214, 'jungle_c16_watertile', 4, 0, 0, 1, 0, 0, 56, -1, 0, '', '1', '0'),
	(7373, '8970', 214, 'jungle_c16_watertrap', 4, 0, 0, 1, 0, 0, 57, -1, 0, '', '1', '0'),
	(7374, '8971', 775, 'jungle_c16_roof3', 4, 0, 0, 1, 0, 0, 36, -1, 0, '', '1', '0'),
	(7375, '8972', 775, 'jungle_c16_table2', 4, 0, 0, 1, 0, 0, 45, -1, 0, '', '1', '0'),
	(7376, '8973', 214, 'jungle_c16_radio', 4, 0, 0, 1, 0, 0, 31, -1, 0, '', '1', '0'),
	(7377, '8974', 580, 'clothing_r16_sloth', 5, 0, 0, 1, 0, 0, 7, -1, 0, '0', '1', '0'),
	(7378, '8975', 214, 'jungle_c16_flowera1', 4, 0, 0, 1, 0, 0, 100, -1, 0, '', '1', '0'),
	(7379, '8976', 775, 'jungle_c16_bkcase2', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(7380, '8977', 214, 'jungle_c16_flowerb3', 4, 0, 0, 1, 0, 0, 105, -1, 0, '', '1', '0'),
	(7381, '8978', 775, 'jungle_c16_roof2', 4, 0, 0, 1, 0, 0, 35, -1, 0, '', '1', '0'),
	(7382, '8979', 214, 'jungle_c16_bridgeend', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(7383, '8980', 775, 'jungle_c16_dvdr3', 4, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(7384, '8981', 214, 'jungle_c16_flowerb2', 4, 0, 0, 1, 0, 0, 104, -1, 0, '', '1', '0'),
	(7385, '8982', 214, 'jungle_c16_flowerb1', 4, 0, 0, 1, 0, 0, 103, -1, 0, '', '1', '0'),
	(7386, '8983', 214, 'jungle_c16_flowerc1', 4, 0, 0, 1, 0, 0, 106, -1, 0, '', '1', '0'),
	(7387, '8984', 775, 'jungle_c16_pot3', 4, 0, 0, 1, 0, 0, 30, -1, 0, '', '1', '0'),
	(7388, '8985', 775, 'jungle_c16_bkcase3', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(7389, '8986', 214, 'jungle_c16_bkcase', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(7390, '8987', 214, 'jungle_c16_flowera2', 4, 0, 0, 1, 0, 0, 101, -1, 0, '', '1', '0'),
	(7391, '8988', 775, 'jungle_c16_treestage3', 4, 0, 0, 1, 0, 0, 52, -1, 0, '', '1', '0'),
	(7392, '8989', 775, 'jungle_c16_bridgemid3', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(7393, '8990', 775, 'jungle_c16_bridgemid2', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(7394, '8991', 214, 'jungle_c16_bridgemid', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(7395, '8992', 423, 'fxbox_fx192', 3, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(7396, '8993', 664, 'bonusbag16_1', 7, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(7397, '8994', 664, 'bonusbag16_2', 7, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(7398, '8995', 503, 'js_c16_bed', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(7399, '8996', 503, 'js_c16_lounger', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(7400, '8997', 503, 'js_r16_boat', 4, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(7401, '8998', 503, 'js_r16_jelly', 4, 0, 0, 1, 0, 0, 27, -1, 0, '', '1', '0'),
	(7402, '8999', 503, 'js_r16_shark', 4, 0, 0, 1, 0, 0, 28, -1, 0, '', '1', '0'),
	(7403, '9000', 503, 'js_c16_cat', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(7404, '9001', 503, 'js_r16_heli', 4, 0, 0, 1, 0, 0, 26, -1, 0, '', '1', '0'),
	(7405, '9002', 503, 'js_c16_drkcab', 10, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(7406, '9003', 697, 'olympics_c16_counter', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(7407, '9004', 697, 'olympics_c16_softmat', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(7408, '9005', 697, 'olympics_c16_pommel', 4, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(7409, '9006', 697, 'olympics_c16_weightrack', 10, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(7410, '9007', 697, 'olympics_r16_vendingmchn', 4, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(7411, '9008', 697, 'olympics_c16_plantdvdr', 4, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(7412, '9009', 697, 'olympics_c16_graperack', 10, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(7413, '9010', 697, 'olympics_c16_cadorack', 10, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(7414, '9011', 697, 'olympics_r16_cheerleader', 4, 0, 0, 1, 0, 0, 44, -1, 0, '', '1', '0'),
	(7415, '9012', 742, 'olympics_ltd16_missolympus', 4, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(7416, '9013', 697, 'olympics_c16_saladbar', 4, 0, 0, 1, 0, 0, 28, -1, 0, '', '1', '0'),
	(7417, '9014', 697, 'olympics_c16_merchdisplay', 4, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(7418, '9015', 697, 'olympics_c16_merch', 10, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(7419, '9016', 697, 'olympics_c16_banner', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(7420, '9017', 697, 'olympics_c16_adsboard', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(7421, '9018', 697, 'olympics_c16_bbeam', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(7422, '9019', 697, 'olympics_r16_smoothie', 4, 0, 0, 1, 0, 0, 46, -1, 0, '', '1', '0'),
	(7423, '9020', 697, 'olympics_c16_yogamat*1', 4, 0, 0, 1, 0, 0, 37, -1, 0, '', '1', '0'),
	(7424, '9021', 697, 'olympics_c16_yogamat*2', 4, 0, 0, 1, 0, 0, 38, -1, 0, '', '1', '0'),
	(7425, '9022', 697, 'olympics_c16_yogamat*3', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(7426, '9023', 697, 'olympics_c16_yogamat*4', 4, 0, 0, 1, 0, 0, 40, -1, 0, '', '1', '0'),
	(7427, '9024', 697, 'olympics_c16_yogamat*5', 4, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(7428, '9025', 697, 'olympics_c16_yogamat*6', 4, 0, 0, 1, 0, 0, 42, -1, 0, '', '1', '0'),
	(7429, '9026', 697, 'olympics_c16_emptrack', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(7430, '9027', 697, 'olympics_c16_table', 4, 0, 0, 1, 0, 0, 32, -1, 0, '', '1', '0'),
	(7431, '9028', 697, 'olympics_c16_trampoline', 4, 0, 0, 1, 0, 0, 33, -1, 0, '', '1', '0'),
	(7432, '9029', 697, 'olympics_c16_veggiething', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(7433, '9030', 697, 'olympics_c16_sportsbag', 4, 0, 0, 1, 0, 0, 31, -1, 0, '', '1', '0'),
	(7434, '9031', 697, 'olympics_c16_crosstrainer', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(7435, '9032', 697, 'olympics_c16_glssdvdr', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(7436, '9033', 697, 'olympics_c16_mannequin', 4, 0, 0, 1, 0, 0, 309, -1, 0, '', '1', '0'),
	(7437, '9034', 697, 'olympics_c16_rug', 4, 0, 0, 1, 0, 0, 27, -1, 0, '', '1', '0'),
	(7438, '9035', 697, 'olympics_c16_light', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(7439, '9036', 697, 'olympics_c16_pillar', 4, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(7440, '9037', 697, 'olympics_c16_nanarack', 4, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(7441, '9038', 697, 'olympics_c16_sofa', 3, 0, 0, 1, 0, 0, 29, -1, 0, '', '1', '0'),
	(7442, '9039', 697, 'olympics_c16_fitnessduck', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(7443, '9040', 697, 'olympics_c16_chair', 2, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(7444, '9041', 697, 'olympics_r16_gymfreak', 4, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(7445, '9042', 697, 'olympics_c16_swissball*1', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(7446, '9043', 697, 'olympics_c16_swissball*2', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(7447, '9044', 697, 'olympics_c16_swissball*3', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(7448, '9045', 697, 'olympics_c16_swissball*4', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(7449, '9046', 697, 'olympics_c16_swissball*5', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(7450, '9047', 697, 'olympics_c16_swissball*6', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(7451, '9048', 697, 'olympics_c16_treadmill', 4, 0, 0, 1, 0, 0, 34, -1, 0, '', '1', '0'),
	(7452, '9049', 212, 'garden_birdbath', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(7453, '9050', 212, 'garden_basketflower', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(7454, '9051', 212, 'garden_basket', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(7455, '9052', 212, 'garden_climber', 4, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(7456, '9053', 212, 'garden_grass', 4, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(7457, '9054', 212, 'garden_pond', 4, 0, 0, 1, 0, 0, 26, -1, 0, '', '1', '0'),
	(7458, '9055', 212, 'garden_boots', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(7459, '9056', 212, 'garden_patio', 4, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(7460, '9057', 212, 'garden_stonesteps', 4, 0, 0, 1, 0, 0, 30, -1, 0, '', '1', '0'),
	(7461, '9058', 212, 'garden_smallpot', 4, 0, 0, 1, 0, 0, 29, -1, 0, '', '1', '0'),
	(7462, '9059', 212, 'garden_fishgnome', 4, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(7463, '9060', 212, 'garden_rosearch', 4, 0, 0, 1, 0, 0, 27, -1, 0, '', '1', '0'),
	(7464, '9061', 212, 'garden_rosefence', 4, 0, 0, 1, 0, 0, 28, -1, 0, '', '1', '0'),
	(7465, '9062', 212, 'garden_chair', 2, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(7466, '9063', 212, 'garden_bigpot', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(7467, '9064', 212, 'garden_table', 2, 0, 0, 1, 0, 0, 40, -1, 0, '', '1', '0'),
	(7468, '9065', 212, 'garden_flowerbed', 4, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(7469, '9066', 360, 'classic2_drinkmach', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(7470, '9067', 360, 'classic2_gate', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(7471, '9068', 360, 'classic2_corner', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(7472, '9069', 360, 'classic2_tray', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(7473, '9070', 360, 'classic2_drinkcup', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(7474, '9071', 360, 'classic2_drinkmach2', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(7475, '9072', 360, 'classic2_wall', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(7476, '9073', 360, 'classic2_trashcan', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(7477, '9074', 360, 'classic2_counter', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(7478, '9075', 360, 'classic2_sofa', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(7479, '9076', 360, 'classic2_plantdivdr', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(7480, '9077', 360, 'classic2_grill', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(7481, '9078', 360, 'classic2_table', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(7482, '9079', 360, 'classic2_floor', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(7483, '9080', 360, 'classic2_burger', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(7484, '9081', 360, 'classic2_napkin', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(7485, '9082', 361, 'classic3_chair*0', 4, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(7486, '9083', 361, 'classic3_chair*1', 4, 0, 0, 1, 0, 0, 37, -1, 0, '', '1', '0'),
	(7487, '9084', 361, 'classic3_chair*2', 4, 0, 0, 1, 0, 0, 38, -1, 0, '', '1', '0'),
	(7488, '9085', 361, 'classic3_chair*3', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(7489, '9086', 361, 'classic3_plant*0', 4, 0, 0, 1, 0, 0, 64, -1, 0, '', '1', '0'),
	(7490, '9087', 361, 'classic3_plant*1', 4, 0, 0, 1, 0, 0, 65, -1, 0, '', '1', '0'),
	(7491, '9088', 361, 'classic3_plant*2', 4, 0, 0, 1, 0, 0, 66, -1, 0, '', '1', '0'),
	(7492, '9089', 361, 'classic3_plant*3', 4, 0, 0, 1, 0, 0, 31, -1, 0, '', '1', '0'),
	(7493, '9090', 361, 'classic3_plant*4', 4, 0, 0, 1, 0, 0, 32, -1, 0, '', '1', '0'),
	(7494, '9091', 361, 'classic3_pillar1', 4, 0, 0, 1, 0, 0, 29, -1, 0, '', '1', '0'),
	(7495, '9092', 361, 'classic3_div2*0', 4, 0, 0, 1, 0, 0, 42, -1, 0, '', '1', '0'),
	(7496, '9093', 361, 'classic3_div2*1', 4, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(7497, '9094', 361, 'classic3_div2*2', 4, 0, 0, 1, 0, 0, 44, -1, 0, '', '1', '0'),
	(7498, '9095', 361, 'classic3_div2*3', 4, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(7499, '9096', 361, 'classic3_div2*4', 4, 0, 0, 1, 0, 0, 46, -1, 0, '', '1', '0'),
	(7500, '9097', 361, 'classic3_floor3*0', 4, 0, 0, 1, 0, 0, 28, -1, 0, '', '1', '0'),
	(7501, '9098', 361, 'classic3_floor3*1', 4, 0, 0, 1, 0, 0, 57, -1, 0, '', '1', '0'),
	(7502, '9099', 361, 'classic3_floor3*2', 4, 0, 0, 1, 0, 0, 58, -1, 0, '', '1', '0'),
	(7503, '9100', 361, 'classic3_floor3*3', 4, 0, 0, 1, 0, 0, 59, -1, 0, '', '1', '0'),
	(7504, '9101', 361, 'classic3_floor3*4', 4, 0, 0, 1, 0, 0, 60, -1, 0, '', '1', '0'),
	(7505, '9102', 361, 'classic3_table', 4, 0, 0, 1, 0, 0, 78, -1, 0, '', '1', '0'),
	(7506, '9103', 361, 'classic3_pillar2', 4, 0, 0, 1, 0, 0, 30, -1, 0, '', '1', '0'),
	(7507, '9104', 361, 'classic3_ticket', 4, 0, 0, 1, 0, 0, 79, -1, 0, '', '1', '0'),
	(7508, '9105', 361, 'classic3_sofa*0', 4, 0, 0, 1, 0, 0, 33, -1, 0, '', '1', '0'),
	(7509, '9106', 361, 'classic3_sofa*1', 4, 0, 0, 1, 0, 0, 70, -1, 0, '', '1', '0'),
	(7510, '9107', 361, 'classic3_sofa*2', 4, 0, 0, 1, 0, 0, 34, -1, 0, '', '1', '0'),
	(7511, '9108', 361, 'classic3_sofa*3', 4, 0, 0, 1, 0, 0, 35, -1, 0, '', '1', '0'),
	(7512, '9109', 361, 'classic3_floor2', 4, 0, 0, 1, 0, 0, 27, -1, 0, '', '1', '0'),
	(7513, '9110', 361, 'classic3_stool*0', 4, 0, 0, 1, 0, 0, 36, -1, 0, '', '1', '0'),
	(7514, '9111', 361, 'classic3_stool*1', 4, 0, 0, 1, 0, 0, 37, -1, 0, '', '1', '0'),
	(7515, '9112', 361, 'classic3_stool*2', 4, 0, 0, 1, 0, 0, 75, -1, 0, '', '1', '0'),
	(7516, '9113', 361, 'classic3_stool*3', 4, 0, 0, 1, 0, 0, 76, -1, 0, '', '1', '0'),
	(7517, '9114', 361, 'classic3_block', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(7518, '9115', 361, 'classic3_floor1', 4, 0, 0, 1, 0, 0, 50, -1, 0, '', '1', '0'),
	(7519, '9116', 361, 'classic3_bench*0', 4, 0, 0, 1, 0, 0, 31, -1, 0, '', '1', '0'),
	(7520, '9117', 361, 'classic3_bench*1', 4, 0, 0, 1, 0, 0, 32, -1, 0, '', '1', '0'),
	(7521, '9118', 361, 'classic3_bench*2', 4, 0, 0, 1, 0, 0, 33, -1, 0, '', '1', '0'),
	(7522, '9119', 361, 'classic3_bench*3', 4, 0, 0, 1, 0, 0, 34, -1, 0, '', '1', '0'),
	(7523, '9120', 361, 'classic3_wall2*0', 4, 0, 0, 1, 0, 0, 87, -1, 0, '', '1', '0'),
	(7524, '9121', 361, 'classic3_wall2*1', 4, 0, 0, 1, 0, 0, 82, -1, 0, '', '1', '0'),
	(7525, '9122', 361, 'classic3_wall2*2', 4, 0, 0, 1, 0, 0, 83, -1, 0, '', '1', '0'),
	(7526, '9123', 361, 'classic3_wall2*3', 4, 0, 0, 1, 0, 0, 84, -1, 0, '', '1', '0'),
	(7527, '9124', 361, 'classic3_wall2*4', 4, 0, 0, 1, 0, 0, 39, -1, 0, '', '1', '0'),
	(7528, '9125', 361, 'classic3_wall2*5', 4, 0, 0, 1, 0, 0, 86, -1, 0, '', '1', '0'),
	(7529, '9126', 361, 'classic3_wall2*6', 4, 0, 0, 1, 0, 0, 87, -1, 0, '', '1', '0'),
	(7530, '9127', 361, 'classic3_wall2*7', 4, 0, 0, 1, 0, 0, 88, -1, 0, '', '1', '0'),
	(7531, '9128', 361, 'classic3_wall1', 4, 0, 0, 1, 0, 0, 38, -1, 0, '', '1', '0'),
	(7532, '9129', 361, 'classic3_pillar3', 4, 0, 0, 1, 0, 0, 63, -1, 0, '', '1', '0'),
	(7533, '9130', 361, 'classic3_div1', 4, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(7534, '9131', 258, 'rare_colourable_marquee*1', 5, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(7535, '9132', 258, 'rare_colourable_scifirocket*1', 5, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(7536, '9133', 258, 'rare_colourable_fountain*1', 5, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(7537, '9134', 610, 'hhistory_r16_crackable', 7, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(7538, '9135', 258, 'rare_colourable_wooden_screen*1', 5, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(7539, '9136', 258, 'rare_colourable_dragonlamp*1', 5, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(7540, '9137', 258, 'rare_colourable_parasol*1', 5, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(7541, '9138', 258, 'rare_colourable_pillar*1', 5, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(7542, '9139', 258, 'rare_colourable_beehive_bulb*1', 5, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(7543, '9140', 258, 'rare_colourable_icecream*1', 5, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(7544, '9141', 258, 'rare_colourable_elephant_statue*1', 5, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(7545, '9142', 258, 'rare_colourable_scifidoor*1', 5, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(7546, '9143', 258, 'rare_colourable_fan*1', 5, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(7547, '9144', 258, 'rare_colourable_pillow*1', 5, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(7548, '9145', 258, 'rare_colourable_scifiport*1', 5, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(7549, '9146', 258, 'rare_colourable_barrier*1', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(7550, '9147', 397, 'hween_c16_teleport', 4, 0, 0, 1, 0, 0, 37, -1, 0, '', '1', '0'),
	(7551, '9148', 784, 'hween_c16_chair2', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(7552, '9149', 397, 'hween_c16_roundtable', 2, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(7553, '9150', 397, 'hween_c16_barchair', 2, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(7554, '9151', 784, 'hween_c16_lamp2', 4, 0, 0, 1, 0, 0, 34, -1, 0, '', '1', '0'),
	(7555, '9152', 397, 'hween_c16_balcony', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(7556, '9153', 397, 'hween_c16_fireplace', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(7557, '9154', 825, 'hween_r16_crackable2', 7, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(7558, '9155', 784, 'hween_c16_cabinet2', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(7559, '9156', 826, 'hween_r16_chandelier', 4, 0, 0, 1, 0, 0, -1, -1, 0, '', '1', '0'),
	(7560, '9157', 784, 'hween_c16_barchair2', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(7561, '9158', 826, 'hween_c16_ghostash', 4, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(7562, '9159', 397, 'hween_c16_webs', 4, 0, 0, 1, 0, 0, 44, -1, 0, '', '1', '0'),
	(7563, '9160', 784, 'hween_c16_fireplace2', 4, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(7564, '9161', 397, 'hween_c16_wall', 4, 0, 0, 1, 0, 0, 42, -1, 0, '', '1', '0'),
	(7565, '9162', 397, 'hween_c16_vase', 4, 0, 0, 1, 0, 0, 40, -1, 0, '', '1', '0'),
	(7566, '9163', 784, 'hween_c16_balcony2', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(7567, '9164', 825, 'hween_c16_crackable1', 7, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(7568, '9165', 784, 'hween_r16_grandpiano2', 4, 0, 0, 1, 0, 0, -3, -1, 0, '', '1', '0'),
	(7569, '9166', 784, 'hween_c16_roundtable2', 4, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(7570, '9167', 784, 'hween_c16_bed2', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(7571, '9168', 784, 'hween_c16_bar2', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(7572, '9169', 782, 'hween_c16_ghostmchn', 4, 0, 0, 1, 0, 0, -4, -1, 0, '', '1', '0'),
	(7573, '9170', 397, 'hween_c16_bust', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(7574, '9171', 580, 'clothing_r16_catface', 5, 0, 0, 1, 0, 0, 8, -1, 0, '0', '1', '0'),
	(7575, '9172', 784, 'hween_c16_floor2', 4, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(7576, '9173', 397, 'hween_c16_vanity', 4, 0, 0, 1, 0, 0, 38, -1, 0, '', '1', '0'),
	(7577, '9174', 397, 'hween_c16_endtable', 2, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(7578, '9175', 784, 'hween_c16_wall2', 4, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(7579, '9176', 397, 'hween_c16_floor', 1, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(7580, '9177', 397, 'hween_c16_cabinet', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(7581, '9178', 826, 'hween_r16_grandpiano', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(7582, '9179', 397, 'hween_c16_bkcase', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(7583, '9180', 784, 'hween_c16_bust2', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(7584, '9181', 784, 'hween_c16_ladder2', 4, 0, 0, 1, 0, 0, 32, -1, 0, '', '1', '0'),
	(7585, '9182', 397, 'hween_c16_ladder', 4, 0, 0, 1, 0, 0, 31, -1, 0, '', '1', '0'),
	(7586, '9183', 742, 'hween_ltd16_ghostcar', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(7587, '9184', 784, 'hween_c16_bkcase2', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(7588, '9185', 397, 'hween_c16_glasstable', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(7589, '9186', 397, 'hween_c16_bed', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(7590, '9187', 397, 'hween_c16_lamp', 4, 0, 0, 1, 0, 0, 33, -1, 0, '', '1', '0'),
	(7591, '9188', 826, 'hween_c16_ghostorb', 4, 0, 0, 1, 0, 0, 27, -1, 0, '', '1', '0'),
	(7592, '9189', 784, 'hween_c16_glasstable2', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(7593, '9190', 397, 'hween_c16_chair', 2, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(7594, '9191', 826, 'hween_c16_ghostvial', 4, 0, 0, 1, 0, 0, 28, -1, 0, '', '1', '0'),
	(7595, '9192', 784, 'hween_c16_vanity2', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(7596, '9193', 784, 'hween_c16_endtable2', 4, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(7597, '9194', 397, 'hween_c16_bar', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(7598, '9195', 784, 'hween_r16_chandelier2', 4, 0, 0, 1, 0, 0, -2, -1, 0, '', '1', '0'),
	(7599, '9196', 784, 'hween_c16_vase2', 4, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(7600, '9197', 580, 'clothing_r16_cyclops', 5, 0, 0, 1, 0, 0, 9, -1, 0, '0', '1', '0'),
	(7601, '9198', 423, 'fxbox_fx16', 3, 0, 0, 1, 0, 0, 2, 18824, 0, '', '1', '0'),
	(7602, '9199', 429, 'test_ltd', 4, 0, 0, 1, 0, 0, 310, -1, 0, '', '1', '0'),
	(7603, '9200', 429, 'test_ltd2', 4, 0, 0, 1, 0, 0, 311, -1, 0, '', '1', '0'),
	(7604, '9201', 486, 'xmas_c16_elf8', 4, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(7605, '9202', 486, 'xmas_c16_woodfloor', 2, 0, 0, 1, 0, 0, 35, -1, 0, '', '1', '0'),
	(7606, '9203', 486, 'xmas_c16_fireplace', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(7607, '9204', 486, 'xmas_c16_dvdr', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(7608, '9205', 486, 'xmas_r16_throne', 4, 0, 0, 1, 0, 0, 39, -1, 0, '', '1', '0'),
	(7609, '9206', 202, 'clothing_bearhat', 6, 0, 0, 1, 0, 0, 12, 18943, 0, '0', '1', '0'),
	(7610, '9207', 486, 'xmas_c16_woodtile', 1, 0, 0, 1, 0, 0, 36, 24152, 0, '', '1', '0'),
	(7611, '9208', 486, 'xmas_c16_deskitems', 5, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(7612, '9209', 580, 'clothing_r16_icetiara', 5, 0, 0, 1, 0, 0, 10, -1, 0, '0', '1', '0'),
	(7613, '9210', 486, 'xmas_c16_chair', 2, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(7614, '9211', 836, 'xmas_c16_creature3', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(7615, '9212', 486, 'xmas_c16_banner', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(7616, '9213', 486, 'xmas_c16_presentstack', 4, 0, 0, 1, 0, 0, 27, -1, 0, '', '1', '0'),
	(7617, '9214', 836, 'xmas_c16_creature7', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(7618, '9215', 200, 'clothing_bear', 6, 0, 0, 1, 0, 0, 6, 18952, 0, '0', '1', '0'),
	(7619, '9216', 836, 'xmas_c16_elf9', 4, 0, 0, 1, 0, 0, 32, -1, 0, '', '1', '0'),
	(7620, '9217', 836, 'xmas_c16_elf7', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(7621, '9218', 836, 'xmas_c16_elf3', 4, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(7622, '9219', 486, 'xmas_c16_diningtable', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(7623, '9220', 486, 'xmas_c16_diningbench', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(7624, '9221', 486, 'xmas_c16_food2', 4, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(7625, '9222', 486, 'xmas_c16_roundtable', 5, 0, 0, 1, 0, 0, 28, -1, 0, '', '1', '0'),
	(7626, '9223', 486, 'xmas_c16_balcony', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(7627, '9224', 836, 'xmas_c16_creature5', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(7628, '9225', 486, 'xmas_c16_wreathdeco', 4, 0, 0, 1, 0, 0, 37, -1, 0, '', '1', '0'),
	(7629, '9226', 486, 'xmas_c16_dresser', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(7630, '9227', 486, 'xmas_c16_desk', 5, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(7631, '9228', 486, 'xmas_c16_food3', 4, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(7632, '9229', 310, 'clothing_bearscarf', 6, 0, 0, 1, 0, 0, 42, 18966, 0, '0', '1', '0'),
	(7633, '9230', 835, 'xmas_c16_stocking', 7, 0, 0, 1, 0, 0, 28, -1, 0, '', '1', '0'),
	(7634, '9231', 486, 'xmas_c16_tinybed', 4, 0, 0, 1, 0, 0, 32, -1, 0, '', '1', '0'),
	(7635, '9232', 835, 'xmas_c16_egg', 7, 0, 0, 1, 0, 0, 27, -1, 0, '', '1', '0'),
	(7636, '9233', 486, 'xmas_c16_elf1', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(7637, '9234', 486, 'xmas_c16_tele', 4, 0, 0, 1, 0, 0, 31, -1, 0, '', '1', '0'),
	(7638, '9235', 310, 'clothing_reindeer', 6, 0, 0, 1, 0, 0, 41, -1, 0, '0', '1', '0'),
	(7639, '9236', 486, 'xmas_c16_door', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(7640, '9237', 486, 'xmas_c16_elf10', 4, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(7641, '9238', 836, 'xmas_c16_creature1', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(7642, '9239', 486, 'xmas_c16_elf6', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(7643, '9240', 486, 'xmas_c16_deskcandles', 5, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(7644, '9241', 486, 'xmas_c16_elf4', 4, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(7645, '9242', 836, 'xmas_c16_creature6', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(7646, '9243', 486, 'xmas_c16_food1', 4, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(7647, '9244', 204, 'clothing_xmas2', 5, 0, 0, 1, 0, 0, 18, 18981, 0, '0', '1', '0'),
	(7648, '9245', 486, 'xmas_c16_rug', 4, 0, 0, 1, 0, 0, 29, -1, 0, '', '1', '0'),
	(7649, '9246', 836, 'xmas_c16_creature9', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(7650, '9247', 580, 'clothing_r16_cathat', 5, 0, 0, 1, 0, 0, 11, -1, 0, '0', '1', '0'),
	(7651, '9248', 486, 'xmas_c16_sofa', 3, 0, 0, 1, 0, 0, 30, -1, 0, '', '1', '0'),
	(7652, '9249', 486, 'xmas_c16_tinychair', 4, 0, 0, 1, 0, 0, 33, -1, 0, '', '1', '0'),
	(7653, '9250', 486, 'xmas_c16_wall', 4, 0, 0, 1, 0, 0, 34, 24152, 0, '', '1', '0'),
	(7654, '9251', 836, 'xmas_c16_creature4', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(7655, '9252', 204, 'clothing_xmas3', 5, 0, 0, 1, 0, 0, 17, 18989, 0, '0', '1', '0'),
	(7656, '9253', 486, 'xmas_c16_candles', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(7657, '9254', 836, 'xmas_c16_elf2', 4, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(7658, '9255', 486, 'xmas_c16_pillarlight', 4, 0, 0, 1, 0, 0, 26, -1, 0, '', '1', '0'),
	(7659, '9256', 836, 'xmas_c16_creature8', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(7660, '9257', 486, 'xmas_c16_mailshelf', 5, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(7661, '9258', 836, 'xmas_c16_creature2', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(7662, '9259', 486, 'xmas_c16_elf5', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(7663, '9260', 486, 'xmas_r16_owl', 4, 0, 0, 1, 0, 0, 38, -1, 0, '', '1', '0'),
	(7664, '9261', 742, 'xmas_ltd16_bearbed', 4, 0, 0, 1, 0, 0, 34, -1, 0, '', '1', '0'),
	(7665, '9262', 204, 'clothing_xmas4', 5, 0, 0, 1, 0, 0, 16, 18999, 0, '0', '1', '0'),
	(7666, '9263', 570, 'clothing_longscarf', 6, 0, 0, 1, 0, 0, 34, -1, 0, '0', '1', '0'),
	(7667, '9264', 236, 'virus_r16_piratank', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(7668, '9265', 236, 'virus_r16_crabtank', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(7669, '9266', 236, 'virus_r16_eeltank', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(7670, '9267', 236, 'virus_r16_troptank', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(7671, '9268', 236, 'virus_r16_pufftank', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(7672, '9269', 236, 'virus_r16_turttank', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(7673, '9270', 236, 'virus_r16_angtank', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(7674, '9271', 362, 'classic5_sofa', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(7675, '9272', 362, 'classic5_table_yel', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(7676, '9273', 362, 'classic5_stage', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(7677, '9274', 362, 'classic5_speaker', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(7678, '9275', 362, 'classic5_floor', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(7679, '9276', 362, 'classic5_wall', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(7680, '9277', 362, 'classic5_chair_blu', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(7681, '9278', 362, 'classic5_stairs', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(7682, '9279', 362, 'classic5_chair_yel', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(7683, '9280', 362, 'classic5_table_blu', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(7684, '9281', 664, 'bonusbag16_3', 7, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(7685, '9282', 662, 'bonusrare16_7*1', 4, 0, 0, 1, 0, 0, 29, -1, 0, '', '1', '0'),
	(7686, '9283', 662, 'bonusrare16_7*2', 4, 0, 0, 1, 0, 0, 30, -1, 0, '', '1', '0'),
	(7687, '9284', 662, 'bonusrare16_7*3', 4, 0, 0, 1, 0, 0, 31, -1, 0, '', '1', '0'),
	(7688, '9285', 662, 'bonusrare16_7*4', 4, 0, 0, 1, 0, 0, 32, -1, 0, '', '1', '0'),
	(7689, '9286', 662, 'bonusrare16_7*5', 4, 0, 0, 1, 0, 0, 33, -1, 0, '', '1', '0'),
	(7690, '9287', 662, 'bonusrare16_7*6', 4, 0, 0, 1, 0, 0, 34, -1, 0, '', '1', '0'),
	(7691, '9288', 668, 'ny17_crackable', 7, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(7692, '9289', 583, 'clothing_r16_party14', 4, 0, 0, 1, 0, 0, 6, -1, 0, '0', '1', '0'),
	(7693, '9290', 302, 'cny17_roosterballoon', 4, 0, 0, 1, 0, 0, 56, -1, 0, '', '1', '0'),
	(7694, '9291', 583, 'clothing_r16_party13', 4, 0, 0, 1, 0, 0, 5, -1, 0, '0', '1', '0'),
	(7695, '9292', 583, 'clothing_r16_party11', 4, 0, 0, 1, 0, 0, 3, -1, 0, '0', '1', '0'),
	(7696, '9293', 583, 'clothing_r16_party9', 4, 0, 0, 1, 0, 0, 1, -1, 0, '0', '1', '0'),
	(7697, '9294', 583, 'clothing_r16_party12', 4, 0, 0, 1, 0, 0, 4, -1, 0, '0', '1', '0'),
	(7698, '9295', 583, 'clothing_r16_party10', 4, 0, 0, 1, 0, 0, 2, -1, 0, '0', '1', '0'),
	(7699, '9296', 356, 'clothing_wink', 5, 0, 0, 1, 0, 0, 1, -1, 0, '0', '1', '1'),
	(7700, '9297', 356, 'clothing_love', 5, 0, 0, 1, 0, 0, 2, -1, 0, '0', '1', '1'),
	(7701, '9298', 356, 'clothing_surprised', 5, 0, 0, 1, 0, 0, 3, -1, 0, '0', '1', '1'),
	(7702, '9299', 356, 'clothing_happy', 5, 0, 0, 1, 0, 0, 4, -1, 0, '0', '1', '1'),
	(7703, '9300', 356, 'clothing_poop', 5, 0, 0, 1, 0, 0, 5, -1, 0, '0', '1', '1'),
	(7704, '9301', 356, 'clothing_angry', 5, 0, 0, 1, 0, 0, 6, -1, 0, '0', '1', '1'),
	(7705, '9302', 356, 'clothing_sad', 5, 0, 0, 1, 0, 0, 7, -1, 0, '0', '1', '1'),
	(7706, '9303', 356, 'clothing_excited', 5, 0, 0, 1, 0, 0, 8, -1, 0, '0', '1', '1'),
	(7707, '9304', 356, 'clothing_cool', 5, 0, 0, 1, 0, 0, 9, -1, 0, '0', '1', '1'),
	(7708, '9305', 356, 'clothing_shy', 5, 0, 0, 1, 0, 0, 10, -1, 0, '0', '1', '1'),
	(7709, '9306', 356, 'clothing_bobba', 5, 0, 0, 1, 0, 0, 11, -1, 0, '0', '1', '1'),
	(7710, '9307', 356, 'clothing_silly', 5, 0, 0, 1, 0, 0, 12, -1, 0, '0', '1', '1'),
	(7711, '9308', 363, 'classic6_stool', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(7712, '9309', 363, 'classic6_sofa', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(7713, '9310', 363, 'classic6_tearice', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(7714, '9311', 363, 'classic6_bigtable', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(7715, '9312', 363, 'classic6_chair', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(7716, '9313', 363, 'classic6_endtable', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(7717, '9314', 363, 'classic6_lowtable', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(7718, '9315', 363, 'classic6_lantern', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(7719, '9316', 363, 'classic6_wall', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(7720, '9317', 363, 'classic6_woodfloor', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(7721, '9318', 363, 'classic6_stonecarpet', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(7722, '9319', 363, 'classic6_arch', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(7723, '9320', 363, 'classic6_vase', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(7724, '9321', 363, 'classic6_food', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(7725, '9322', 363, 'classic6_mat', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(7726, '9323', 363, 'classic6_dvdr', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(7727, '9324', 954, 'bc_gift_31days', 105, 105, 5, 1, 0, 0, 2, 20096, 0, '', '0', '1'),
	(7728, '9325', 954, 'hc_gift_14days', 30, 30, 0, 1, 0, 0, 6, 19114, 0, '', '0', '1'),
	(7729, '9326', 954, 'hc_gift_31days', 50, 50, 0, 1, 0, 0, 7, 20099, 0, '', '0', '1'),
	(7730, '9327', 954, 'bc_gift_14days', 60, 60, 5, 1, 0, 0, 1, 19116, 0, '', '0', '1'),
	(7731, '9328', 302, 'china_rooster', 4, 0, 0, 1, 0, 0, 32, -1, 0, '', '1', '0'),
	(7732, '9329', 598, 'rare_prize17*1', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(7733, '9330', 598, 'rare_prize17*10', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(7734, '9331', 598, 'rare_prize17*11', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(7735, '9332', 598, 'rare_prize17*12', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(7736, '9333', 598, 'rare_prize17*13', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(7737, '9334', 598, 'rare_prize17*14', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(7738, '9335', 598, 'rare_prize17*2', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(7739, '9336', 598, 'rare_prize17*3', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(7740, '9337', 598, 'rare_prize17*4', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(7741, '9338', 598, 'rare_prize17*5', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(7742, '9339', 598, 'rare_prize17*6', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(7743, '9340', 598, 'rare_prize17*7', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(7744, '9341', 598, 'rare_prize17*8', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(7745, '9342', 598, 'rare_prize17*9', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(7746, '9343', 659, 'bonusrare17_1*0', 4, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(7747, '9344', 659, 'bonusrare17_1*1', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(7748, '9345', 659, 'bonusrare17_1*2', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(7749, '9346', 659, 'bonusrare17_1*3', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(7750, '9347', 659, 'bonusrare17_1*4', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(7751, '9348', 659, 'bonusrare17_1*5', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(7752, '9349', 659, 'bonusrare17_4*1', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(7753, '9350', 659, 'bonusrare17_4*2', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(7754, '9351', 659, 'bonusrare17_4*3', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(7755, '9352', 659, 'bonusrare17_4*4', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(7756, '9353', 659, 'bonusrare17_4*5', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(7757, '9354', 659, 'bonusrare17_4*6', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(7758, '9355', 659, 'bonusrare17_3*1', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(7759, '9356', 659, 'bonusrare17_3*2', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(7760, '9357', 659, 'bonusrare17_3*3', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(7761, '9358', 659, 'bonusrare17_3*4', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(7762, '9359', 659, 'bonusrare17_3*5', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(7763, '9360', 659, 'bonusrare17_3*6', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(7764, '9361', 659, 'bonusrare17_2*0', 4, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(7765, '9362', 659, 'bonusrare17_2*1', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(7766, '9363', 659, 'bonusrare17_2*2', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(7767, '9364', 659, 'bonusrare17_2*3', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(7768, '9365', 659, 'bonusrare17_2*4', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(7769, '9366', 659, 'bonusrare17_2*5', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(7770, '9367', 364, 'classic7_gate', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(7771, '9368', 364, 'classic7_stage', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(7772, '9369', 364, 'classic7_dvdr', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(7773, '9370', 364, 'classic7_drinks', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(7774, '9371', 364, 'classic7_table', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(7775, '9372', 364, 'classic7_drinkdispenser', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(7776, '9373', 364, 'classic7_djbooth', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(7777, '9374', 364, 'classic7_floor', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(7778, '9375', 364, 'classic7_starlight', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(7779, '9376', 364, 'classic7_chair', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(7780, '9377', 364, 'classic7_tree', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(7781, '9378', 364, 'classic7_stairs', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(7782, '9379', 364, 'classic7_wall', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(7783, '9380', 364, 'classic7_drinkcabinet', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(7784, '9381', 364, 'classic7_fridge', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(7785, '9382', 364, 'classic7_crn', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(7786, '9383', 577, 'clothing_r17_wedveil', 5, 0, 0, 1, 0, 0, 1, -1, 0, '0', '1', '0'),
	(7787, '9384', 577, 'clothing_r17_weddingdress', 5, 0, 0, 1, 0, 0, 2, -1, 0, '0', '1', '0'),
	(7788, '9385', 577, 'clothing_r17_weddingset', 5, 0, 0, 1, 0, 0, 3, -1, 0, '0', '1', '0'),
	(7789, '9386', 449, 'val_c17_roseplant', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(7790, '9387', 449, 'val_c17_chair', 2, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(7791, '9388', 449, 'val_c17_rosedivider', 3, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(7792, '9389', 449, 'val_c17_bandstand', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(7793, '9390', 449, 'val_c17_vase', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(7794, '9391', 743, 'val_r17_organltd', 4, 0, 0, 1, 0, 0, 29, -1, 0, '', '1', '0'),
	(7795, '9392', 585, 'clothing_goldpack2', 5, 0, 0, 1, 0, 0, 2, -1, 0, '0', '1', '0'),
	(7796, '9393', 250, 'exotic_r17_chamele', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(7797, '9394', 250, 'exotic_r17_treefrog', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(7798, '9395', 250, 'exotic_r17_snake', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(7799, '9396', 250, 'exotic_r17_chipmunk', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(7800, '9397', 250, 'exotic_r17_birds', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(7801, '9398', 250, 'exotic_r17_bat', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(7802, '9399', 250, 'exotic_r17_chinchil', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(7803, '9400', 250, 'exotic_r17_sloth', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(7804, '9401', 119, 'mall_c17_tele', 4, 0, 0, 1, 0, 0, 312, -1, 0, '', '1', '0'),
	(7805, '9402', 119, 'mall_c17_kiosk', 4, 0, 0, 1, 0, 0, 313, -1, 0, '', '1', '0'),
	(7806, '9403', 855, 'mall_r17_coffeem', 4, 0, 0, 1, 0, 0, 314, -1, 0, '', '1', '0'),
	(7807, '9404', 383, 'easter_c17_fence2', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(7808, '9405', 203, 'clothing_apron', 5, 0, 0, 1, 0, 0, 7, 19246, 0, '0', '1', '0'),
	(7809, '9406', 383, 'easter_c17_barngate', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(7810, '9407', 383, 'easter_c17_table', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(7811, '9408', 843, 'easter_c17_floweringbush', 4, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(7812, '9409', 383, 'easter_c17_appletree', 10, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(7813, '9410', 577, 'clothing_r17_cow', 5, 0, 0, 1, 0, 0, 4, -1, 0, '0', '1', '0'),
	(7814, '9411', 777, 'easter_c17_flour', 4, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(7815, '9412', 776, 'easter_c17_combistove', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(7816, '9413', 201, 'clothing_crownbraid', 6, 0, 0, 1, 0, 0, 38, 19254, 0, '0', '1', '0'),
	(7817, '9414', 383, 'easter_c17_chickens', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(7818, '9415', 743, 'easter_ltd17_harvestgoddess', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(7819, '9416', 842, 'easter_c17_egg', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(7820, '9417', 383, 'easter_c17_barn', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(7821, '9418', 778, 'easter_c17_fruitsalad', 4, 0, 0, 1, 0, 0, 27, -1, 0, '', '1', '0'),
	(7822, '9419', 778, 'easter_c17_berrycupcake', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(7823, '9420', 383, 'easter_c17_fence', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(7824, '9421', 778, 'easter_c17_raspjam', 4, 0, 0, 1, 0, 0, 33, -1, 0, '', '1', '0'),
	(7825, '9422', 383, 'easter_c17_gate', 4, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(7826, '9423', 778, 'easter_c17_pastries', 4, 0, 0, 1, 0, 0, 29, -1, 0, '', '1', '0'),
	(7827, '9424', 383, 'easter_c17_peachtree', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(7828, '9425', 843, 'easter_c17_leafsprout', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(7829, '9426', 577, 'clothing_r17_chicken', 5, 0, 0, 1, 0, 0, 5, -1, 0, '0', '1', '0'),
	(7830, '9427', 383, 'easter_c17_roof2', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(7831, '9428', 778, 'easter_c17_choctart', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(7832, '9429', 383, 'easter_c17_peartree', 10, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(7833, '9430', 383, 'easter_c17_windmill', 4, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(7834, '9431', 777, 'easter_c17_strawbsbush', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(7835, '9432', 383, 'easter_c17_collie', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(7836, '9433', 843, 'easter_c17_sapling', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(7837, '9434', 777, 'easter_c17_raspbush', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(7838, '9435', 778, 'easter_c17_strawbsjam', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(7839, '9436', 777, 'easter_c17_carrot', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(7840, '9437', 778, 'easter_c17_choccupcake', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(7841, '9438', 383, 'easter_c17_sprinkler', 4, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(7842, '9439', 383, 'easter_c17_coop', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(7843, '9440', 251, 'cowbox', 25, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(7844, '9441', 201, 'clothing_messyhalfbun', 6, 0, 0, 1, 0, 0, 37, 19282, 0, '0', '1', '0'),
	(7845, '9442', 383, 'easter_c17_tree', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(7846, '9443', 383, 'easter_r17_farmcutout', 4, 0, 0, 1, 0, 0, -5, -1, 0, '', '1', '0'),
	(7847, '9444', 777, 'easter_c17_blkberrybush', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(7848, '9445', 843, 'easter_c17_seeds', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(7849, '9446', 778, 'easter_c17_chocbunny', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(7850, '9447', 842, 'easter_c17_seedbag', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(7851, '9448', 383, 'easter_c17_crn', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(7852, '9449', 778, 'easter_c17_carrotcake', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(7853, '9450', 778, 'easter_c17_berrytart', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(7854, '9451', 383, 'easter_c17_farmsoil', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(7855, '9452', 558, 'cowbox_gold', 25, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(7856, '9453', 577, 'clothing_r17_horse', 5, 0, 0, 1, 0, 0, 6, -1, 0, '0', '1', '0'),
	(7857, '9454', 383, 'easter_c17_beehive', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(7858, '9455', 778, 'easter_c17_blkberryjam', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(7859, '9456', 383, 'easter_c17_roof', 4, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(7860, '9457', 777, 'easter_c17_choc', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(7861, '9458', 778, 'easter_c17_sweetpastries', 4, 0, 0, 1, 0, 0, 40, -1, 0, '', '1', '0'),
	(7862, '9459', 778, 'easter_c17_strawbscake', 4, 0, 0, 1, 0, 0, 38, -1, 0, '', '1', '0'),
	(7863, '9460', 383, 'easter_c17_chairs', 2, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(7864, '9461', 664, 'bonusbag17_1', 7, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(7865, '9462', 416, 'santorini_c17_pottedplants', 4, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(7866, '9463', 730, 'santorini_c17_artefact4', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(7867, '9464', 416, 'santorini_c17_bar', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(7868, '9465', 416, 'santorini_c17_arch', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(7869, '9466', 416, 'santorini_c17_pottedshrub', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(7870, '9467', 730, 'santorini_c17_artefact3', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(7871, '9468', 416, 'santorini_c17_roof', 4, 0, 0, 1, 0, 0, 27, -1, 0, '', '1', '0'),
	(7872, '9469', 416, 'santorini_c17_rockroof', 4, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(7873, '9470', 730, 'clothing_leafcrown', 5, 0, 0, 1, 0, 0, 17, -1, 0, '0', '1', '0'),
	(7874, '9471', 416, 'santorini_c17_flowerdivider', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(7875, '9472', 730, 'clothing_hermeshat', 5, 0, 0, 1, 0, 0, 14, -1, 0, '0', '1', '0'),
	(7876, '9473', 416, 'santorini_c17_rocks', 4, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(7877, '9474', 416, 'santorini_c17_sand', 4, 0, 0, 1, 0, 0, 28, -1, 0, '', '1', '0'),
	(7878, '9475', 730, 'santorini_c17_artefact5', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(7879, '9476', 416, 'santorini_c17_food1', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(7880, '9477', 61, 'santorini_r17_chest', 7, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(7881, '9478', 416, 'santorini_c17_trellis', 4, 0, 0, 1, 0, 0, 31, -1, 0, '', '1', '0'),
	(7882, '9479', 730, 'clothing_hoplitehelm', 5, 0, 0, 1, 0, 0, 13, -1, 0, '0', '1', '0'),
	(7883, '9480', 730, 'santorini_c17_artefact1', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(7884, '9481', 416, 'santorini_c17_rockpool', 4, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(7885, '9482', 730, 'clothing_greektoga', 5, 0, 0, 1, 0, 0, 14, -1, 0, '0', '1', '0'),
	(7886, '9483', 416, 'santorini_c17_dividerend', 3, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(7887, '9484;59965', 416, 'santorini_r17_chimera', 4, 0, 0, 1, 0, 0, 33, -1, 0, '', '1', '0'),
	(7888, '9485;59966', 416, 'santorini_r17_hydra', 4, 0, 0, 1, 0, 0, 34, -1, 0, '', '1', '0'),
	(7889, '9486', 416, 'santorini_c17_rockstage', 4, 0, 0, 1, 0, 0, 26, -1, 0, '', '1', '0'),
	(7890, '9487', 416, 'santorini_c17_donkey', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(7891, '9488', 416, 'santorini_c17_pierend', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(7892, '9489', 416, 'santorini_c17_ornatepots', 4, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(7893, '9490', 416, 'santorini_c17_dolphin', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(7894, '9491', 416, 'santorini_c17_mosaicfloor', 2, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(7895, '9492', 730, 'clothing_hermesshoes', 5, 0, 0, 1, 0, 0, 12, -1, 0, '0', '1', '0'),
	(7896, '9493', 416, 'santorini_c17_rockcave', 4, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(7897, '9494', 416, 'santorini_c17_belltop', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(7898, '9495', 416, 'santorini_c17_gate', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(7899, '9496;59968', 416, 'santorini_r17_centaur', 4, 0, 0, 1, 0, 0, 32, -1, 0, '', '1', '0'),
	(7900, '9497', 743, 'santorini_ltd17_lighthouse', 4, 0, 0, 1, 0, 0, 38, -1, 0, '', '1', '0'),
	(7901, '9498', 416, 'santorini_c17_divider', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(7902, '9499', 416, 'santorini_c17_piermid', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(7903, '9500', 416, 'santorini_c17_house', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(7904, '9501', 416, 'santorini_c17_table', 2, 0, 0, 1, 0, 0, 30, -1, 0, '', '1', '0'),
	(7905, '9502', 730, 'santorini_c17_artefact2', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(7906, '9503;59967', 416, 'santorini_r17_minotaur', 4, 0, 0, 1, 0, 0, 35, -1, 0, '', '1', '0'),
	(7907, '9504', 416, 'santorini_c17_chair', 2, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(7908, '9505', 202, 'clothing_octohat', 6, 0, 0, 1, 0, 0, 11, -1, 0, '0', '1', '0'),
	(7909, '9506', 416, 'santorini_c17_pebblefloor', 2, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(7910, '9507', 712, 'santorini_c17_lighthouse', 4, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(7911, '9508', 416, 'santorini_c17_stairs', 4, 0, 0, 1, 0, 0, 29, -1, 0, '', '1', '0'),
	(7912, '9509', 416, 'santorini_c17_food2', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(7913, '9510', 416, 'santorini_c17_rockfloat', 4, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(7914, '9511', 36, 'scifi_r17_bed', 4, 0, 0, 1, 0, 0, 315, -1, 0, '', '1', '0'),
	(7915, '9512', 36, 'scifi_c17_xcannon', 4, 0, 0, 1, 0, 0, 316, -1, 0, '', '1', '0'),
	(7916, '9513', 36, 'scifi_c17_airlock', 4, 0, 0, 1, 0, 0, 317, -1, 0, '', '1', '0'),
	(7917, '9514', 577, 'clothing_r17_explorerhelm', 5, 0, 0, 1, 0, 0, 7, -1, 0, '0', '1', '0'),
	(7918, '9515', 36, 'scifi_r17_cruiser', 4, 0, 0, 1, 0, 0, 318, -1, 0, '', '1', '0'),
	(7919, '9516', 743, 'scifi_ltd17_mech', 4, 0, 0, 1, 0, 0, 319, -1, 0, '', '1', '0'),
	(7920, '9517', 577, 'clothing_r17_sentinelhelm', 5, 0, 0, 1, 0, 0, 8, -1, 0, '0', '1', '0'),
	(7921, '9518', 310, 'clothing_facehugger', 6, 0, 0, 1, 0, 0, 40, -1, 0, '0', '1', '0'),
	(7922, '9519', 419, 'modern_c17_sofa', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(7923, '9520', 419, 'modern_c17_pictures', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(7924, '9521', 419, 'modern_c17_pug', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(7925, '9522', 419, 'modern_c17_lamp', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(7926, '9523', 419, 'modern_c17_bed', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(7927, '9524', 419, 'modern_c17_lowtable', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(7928, '9525', 419, 'modern_c17_folder', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(7929, '9526', 419, 'modern_c17_reads', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(7930, '9527', 419, 'modern_c17_rug', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(7931, '9528', 419, 'modern_c17_incense', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(7932, '9529', 419, 'modern_c17_plant', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(7933, '9530', 419, 'modern_c17_display', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(7934, '9531', 419, 'modern_c17_pillow', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(7935, '9532', 419, 'modern_c17_tv', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(7936, '9533', 419, 'modern_c17_floor', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(7937, '9534', 419, 'modern_c17_photos', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(7938, '9535', 419, 'modern_c17_desk', 5, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(7939, '9536', 419, 'modern_c17_wall', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(7940, '9537', 419, 'modern_c17_iscreen', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(7941, '9538', 419, 'modern_c17_floorlamp', 1, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(7942, '9539', 419, 'modern_c17_creative', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(7943, '9540', 419, 'modern_c17_chair', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(7944, '9541', 419, 'modern_c17_speakers', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(7945, '9542', 419, 'modern_c17_shelf', 5, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(7946, '9543', 419, 'modern_c17_endtable', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(7947, '9544', 310, 'clothing_toxicfacehugger', 6, 0, 0, 1, 0, 0, 39, -1, 0, '0', '1', '0'),
	(7948, '9545', 409, 'summer_c17_merchstall', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(7949, '9546', 409, 'summer_c17_astrotelescope', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(7950, '9547', 409, 'summer_c17_burgertruck', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(7951, '9548', 409, 'summer_c17_promenadelamp', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(7952, '9549', 664, 'bonusbag17_2', 7, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(7953, '9550', 781, 'bazaar_c17_lampbluepinktrim', 4, 0, 0, 1, 0, 0, 170, -1, 0, '', '1', '0'),
	(7954, '9551', 781, 'bazaar_c17_pillowbluepinktrim', 4, 0, 0, 1, 0, 0, 190, -1, 0, '', '1', '0'),
	(7955, '9552', 781, 'bazaar_c17_lampyellow', 4, 0, 0, 1, 0, 0, 170, -1, 0, '', '1', '0'),
	(7956, '9553', 781, 'bazaar_c17_curtainblue', 4, 0, 0, 1, 0, 0, 150, -1, 0, '', '1', '0'),
	(7957, '9554', 781, 'bazaar_c17_lamppurple', 4, 0, 0, 1, 0, 0, 170, -1, 0, '', '1', '0'),
	(7958, '9555', 781, 'bazaar_c17_curtainyellowbluetrim', 4, 0, 0, 1, 0, 0, 150, -1, 0, '', '1', '0'),
	(7959, '9556', 781, 'bazaar_c17_ruggreen', 4, 0, 0, 1, 0, 0, 210, -1, 0, '', '1', '0'),
	(7960, '9557', 417, 'bazaar_c17_pots', 4, 0, 0, 1, 0, 0, 58, -1, 0, '', '1', '0'),
	(7961, '9558', 417, 'bazaar_c17_fruitbasket', 4, 0, 0, 1, 0, 0, 30, -1, 0, '', '1', '0'),
	(7962, '9559', 417, 'bazaar_c17_rugrolls', 4, 0, 0, 1, 0, 0, 50, -1, 0, '', '1', '0'),
	(7963, '9560', 781, 'bazaar_c17_rugpurpleyellowtrim', 4, 0, 0, 1, 0, 0, 210, -1, 0, '', '1', '0'),
	(7964, '9561', 781, 'bazaar_c17_vasepinkbluetrim', 4, 0, 0, 1, 0, 0, 230, -1, 0, '', '1', '0'),
	(7965, '9562', 201, 'clothing_exoticbeard', 2, 0, 0, 1, 0, 0, 36, 19538, 0, '0', '1', '0'),
	(7966, '9563', 781, 'bazaar_c17_vasebluepinktrim', 4, 0, 0, 1, 0, 0, 230, -1, 0, '', '1', '0'),
	(7967, '9564', 417, 'bazaar_c17_basket', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(7968, '9565', 417, 'bazaar_c17_camel', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(7969, '9566', 781, 'bazaar_c17_pillowmystic', 4, 0, 0, 1, 0, 0, 190, -1, 0, '', '1', '0'),
	(7970, '9567', 781, 'bazaar_c17_pillowgreenpurpletrim', 4, 0, 0, 1, 0, 0, 190, -1, 0, '', '1', '0'),
	(7971, '9568', 781, 'bazaar_c17_vasepurple', 4, 0, 0, 1, 0, 0, 230, -1, 0, '', '1', '0'),
	(7972, '9569', 781, 'bazaar_c17_curtaingreen', 4, 0, 0, 1, 0, 0, 150, -1, 0, '', '1', '0'),
	(7973, '9570', 310, 'clothing_alluringeyes', 6, 0, 0, 1, 0, 0, 38, 19546, 0, '0', '1', '0'),
	(7974, '9571', 781, 'bazaar_c17_vasegreenpurpletrim', 4, 0, 0, 1, 0, 0, 230, -1, 0, '', '1', '0'),
	(7975, '9572', 781, 'bazaar_c17_curtaingreenpurpletrim', 4, 0, 0, 1, 0, 0, 150, -1, 0, '', '1', '0'),
	(7976, '9573', 781, 'bazaar_c17_rugblue', 4, 0, 0, 1, 0, 0, 210, -1, 0, '', '1', '0'),
	(7977, '9574', 780, 'bazaar_c17_dyemystic', 4, 0, 0, 1, 0, 0, 94, -1, 0, '', '1', '0'),
	(7978, '9575', 781, 'bazaar_c17_pillowpurple', 4, 0, 0, 1, 0, 0, 190, -1, 0, '', '1', '0'),
	(7979, '9576', 417, 'bazaar_r17_throne', 4, 0, 0, 1, 0, 0, 202, -1, 0, '', '1', '0'),
	(7980, '9577', 781, 'bazaar_c17_rugyellowbluetrim', 4, 0, 0, 1, 0, 0, 210, -1, 0, '', '1', '0'),
	(7981, '9578', 781, 'bazaar_c17_vaseblue', 4, 0, 0, 1, 0, 0, 230, -1, 0, '', '1', '0'),
	(7982, '9579', 743, 'bazaar_ltd17_ele', 4, 0, 0, 1, 0, 0, -4, -1, 0, '', '1', '0'),
	(7983, '9580', 781, 'bazaar_c17_vaseyellowbluetrim', 4, 0, 0, 1, 0, 0, 230, -1, 0, '', '1', '0'),
	(7984, '9581', 780, 'bazaar_c17_dyeblue', 4, 0, 0, 1, 0, 0, 98, -1, 0, '', '1', '0'),
	(7985, '9582', 780, 'bazaar_c17_dyegreen', 4, 0, 0, 1, 0, 0, 93, -1, 0, '', '1', '0'),
	(7986, '9583', 781, 'bazaar_c17_curtainpinkbluetrim', 4, 0, 0, 1, 0, 0, 150, -1, 0, '', '1', '0'),
	(7987, '9584', 781, 'bazaar_c17_lampmystic', 4, 0, 0, 1, 0, 0, 170, -1, 0, '', '1', '0'),
	(7988, '9585', 417, 'bazaar_c17_curtain', 4, 0, 0, 1, 0, 0, 106, -1, 0, '', '1', '0'),
	(7989, '9586', 781, 'bazaar_c17_pillowyellow', 4, 0, 0, 1, 0, 0, 190, -1, 0, '', '1', '0'),
	(7990, '9587', 781, 'bazaar_c17_rugmystic', 4, 0, 0, 1, 0, 0, 210, -1, 0, '', '1', '0'),
	(7991, '9588', 781, 'bazaar_c17_rugbluepinktrim', 4, 0, 0, 1, 0, 0, 210, -1, 0, '', '1', '0'),
	(7992, '9589', 417, 'bazaar_c17_flycarpet', 4, 0, 0, 1, 0, 0, 29, -1, 0, '', '1', '0'),
	(7993, '9590', 204, 'clothing_exoticvest', 5, 0, 0, 1, 0, 0, 15, 19566, 0, '0', '1', '0'),
	(7994, '9591', 417, 'bazaar_c17_sticklizard', 4, 0, 0, 1, 0, 0, 74, -1, 0, '', '1', '0'),
	(7995, '9592', 781, 'bazaar_c17_lampblue', 4, 0, 0, 1, 0, 0, 170, -1, 0, '', '1', '0'),
	(7996, '9593', 781, 'bazaar_c17_pillowblue', 4, 0, 0, 1, 0, 0, 190, -1, 0, '', '1', '0'),
	(7997, '9594', 417, 'bazaar_c17_clothroof2', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(7998, '9595', 417, 'bazaar_c17_marketroofsmall', 4, 0, 0, 1, 0, 0, 44, -1, 0, '', '1', '0'),
	(7999, '9596', 781, 'bazaar_c17_curtainbluepinktrim', 4, 0, 0, 1, 0, 0, 150, -1, 0, '', '1', '0'),
	(8000, '9597', 417, 'bazaar_c17_balcony', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(8001, '9598', 780, 'bazaar_c17_dyeyellow', 4, 0, 0, 1, 0, 0, 100, -1, 0, '', '1', '0'),
	(8002, '9599', 781, 'bazaar_c17_lampyellowbluetrim', 4, 0, 0, 1, 0, 0, 170, -1, 0, '', '1', '0'),
	(8003, '9600', 200, 'clothing_bazaarfemale', 16, 0, 0, 1, 0, 0, 5, 19576, 0, '0', '1', '0'),
	(8004, '9601', 781, 'bazaar_c17_ruggreenpurpletrim', 4, 0, 0, 1, 0, 0, 210, -1, 0, '', '1', '0'),
	(8005, '9602', 781, 'bazaar_c17_pillowyellowbluetrim', 4, 0, 0, 1, 0, 0, 190, -1, 0, '', '1', '0'),
	(8006, '9603', 779, 'bazaar_c17_colourbucket', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(8007, '9604', 781, 'bazaar_c17_vasegreen', 4, 0, 0, 1, 0, 0, 230, -1, 0, '', '1', '0'),
	(8008, '9605', 417, 'bazaar_c17_meat', 4, 0, 0, 1, 0, 0, 45, -1, 0, '', '1', '0'),
	(8009, '9606', 781, 'bazaar_c17_curtainpurple', 4, 0, 0, 1, 0, 0, 150, -1, 0, '', '1', '0'),
	(8010, '9607', 781, 'bazaar_c17_vasepink', 4, 0, 0, 1, 0, 0, 230, -1, 0, '', '1', '0'),
	(8011, '9608', 417, 'bazaar_c17_building', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(8012, '9609', 781, 'bazaar_c17_lampgreen', 4, 0, 0, 1, 0, 0, 170, -1, 0, '', '1', '0'),
	(8013, '9610', 781, 'bazaar_c17_vaseyellow', 4, 0, 0, 1, 0, 0, 230, -1, 0, '', '1', '0'),
	(8014, '9611', 780, 'bazaar_c17_dyepink', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(8015, '9612', 781, 'bazaar_c17_rugpinkbluetrim', 4, 0, 0, 1, 0, 0, 210, -1, 0, '', '1', '0'),
	(8016, '9613', 781, 'bazaar_c17_vasemystic', 4, 0, 0, 1, 0, 0, 230, -1, 0, '', '1', '0'),
	(8017, '9614', 781, 'bazaar_c17_vasepurpleyellowtrim', 4, 0, 0, 1, 0, 0, 230, -1, 0, '', '1', '0'),
	(8018, '9615', 208, 'clothing_pointyshoes', 4, 0, 0, 1, 0, 0, 5, 19591, 0, '0', '1', '0'),
	(8019, '9616', 417, 'bazaar_c17_scorpion', 4, 0, 0, 1, 0, 0, 72, -1, 0, '', '1', '0'),
	(8020, '9617', 417, 'bazaar_c17_bubblejuiceblower', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(8021, '9618', 781, 'bazaar_c17_rugyellow', 4, 0, 0, 1, 0, 0, 210, -1, 0, '', '1', '0'),
	(8022, '9619', 781, 'bazaar_c17_lamppink', 4, 0, 0, 1, 0, 0, 170, -1, 0, '', '1', '0'),
	(8023, '9620', 781, 'bazaar_c17_rugpink', 4, 0, 0, 1, 0, 0, 210, -1, 0, '', '1', '0'),
	(8024, '9621', 780, 'bazaar_c17_dyepurple', 4, 0, 0, 1, 0, 0, 95, -1, 0, '', '1', '0'),
	(8025, '9622', 417, 'bazaar_c17_rug', 4, 0, 0, 1, 0, 0, 109, -1, 0, '', '1', '0'),
	(8026, '9623', 204, 'clothing_exotictop', 5, 0, 0, 1, 0, 0, 14, 19599, 0, '0', '1', '0'),
	(8027, '9624', 577, 'clothing_r17_cursedmask', 5, 0, 0, 1, 0, 0, 9, -1, 0, '0', '1', '0'),
	(8028, '9625', 417, 'bazaar_c17_displaytable', 4, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(8029, '9626', 417, 'bazaar_c17_spice', 4, 0, 0, 1, 0, 0, 101, -1, 0, '', '1', '0'),
	(8030, '9627', 417, 'bazaar_c17_lamp', 4, 0, 0, 1, 0, 0, 107, -1, 0, '', '1', '0'),
	(8031, '9628', 781, 'bazaar_c17_pillowpinkbluetrim', 4, 0, 0, 1, 0, 0, 190, -1, 0, '', '1', '0'),
	(8032, '9629', 781, 'bazaar_c17_pillowpurpleyellowtrim', 4, 0, 0, 1, 0, 0, 190, -1, 0, '', '1', '0'),
	(8033, '9630', 417, 'bazaar_r17_fountain', 4, 0, 0, 1, 0, 0, 200, -1, 0, '', '1', '0'),
	(8034, '9631', 781, 'bazaar_c17_curtainpink', 4, 0, 0, 1, 0, 0, 150, -1, 0, '', '1', '0'),
	(8035, '9632', 417, 'bazaar_c17_pillow', 4, 0, 0, 1, 0, 0, 108, -1, 0, '', '1', '0'),
	(8036, '9633', 781, 'bazaar_c17_pillowgreen', 4, 0, 0, 1, 0, 0, 190, -1, 0, '', '1', '0'),
	(8037, '9634', 417, 'bazaar_c17_marketroofbig', 4, 0, 0, 1, 0, 0, 43, -1, 0, '', '1', '0'),
	(8038, '9635', 417, 'bazaar_c17_chillies', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(8039, '9636', 781, 'bazaar_c17_curtainpurpleyellowtrim', 4, 0, 0, 1, 0, 0, 150, -1, 0, '', '1', '0'),
	(8040, '9637', 781, 'bazaar_c17_curtainyellow', 4, 0, 0, 1, 0, 0, 150, -1, 0, '', '1', '0'),
	(8041, '9638', 781, 'bazaar_c17_lamppinkbluetrim', 4, 0, 0, 1, 0, 0, 170, -1, 0, '', '1', '0'),
	(8042, '9639', 781, 'bazaar_c17_pillowpink', 4, 0, 0, 1, 0, 0, 190, -1, 0, '', '1', '0'),
	(8043, '9640', 781, 'bazaar_c17_lampgreenpurpletrim', 4, 0, 0, 1, 0, 0, 170, -1, 0, '', '1', '0'),
	(8044, '9641', 781, 'bazaar_c17_rugpurple', 4, 0, 0, 1, 0, 0, 210, -1, 0, '', '1', '0'),
	(8045, '9642', 781, 'bazaar_c17_curtainmystic', 4, 0, 0, 1, 0, 0, 150, -1, 0, '', '1', '0'),
	(8046, '9643', 417, 'bazaar_r17_monkey', 4, 0, 0, 1, 0, 0, 201, -1, 0, '', '1', '0'),
	(8047, '9644', 781, 'bazaar_c17_lamppurpleyellowtrim', 4, 0, 0, 1, 0, 0, 170, -1, 0, '', '1', '0'),
	(8048, '9645', 417, 'bazaar_c17_vase', 4, 0, 0, 1, 0, 0, 110, -1, 0, '', '1', '0'),
	(8049, '9646', 206, 'clothing_harempants', 5, 0, 0, 1, 0, 0, 3, 19622, 0, '0', '1', '0'),
	(8050, '9647', 417, 'bazaar_c17_clothroof', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(8051, '9648', 200, 'clothing_bazaarmale', 18, 0, 0, 1, 0, 0, 4, 19624, 0, '0', '1', '0'),
	(8052, '9649', 417, 'bazaar_c17_arch', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(8053, '9650', 409, 'summer_r17_sealion', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(8054, '9651', 577, 'clothing_r17_boxerbraids', 5, 0, 0, 1, 0, 0, 10, -1, 0, '0', '1', '0'),
	(8055, '9652', 409, 'summer_r17_fishingboat', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(8056, '9653', 577, 'clothing_r17_sharkmask', 5, 0, 0, 1, 0, 0, 11, -1, 0, '0', '1', '0'),
	(8057, '9654', 712, 'bazaar_c17_eleengage', 4, 0, 0, 1, 0, 0, 320, -1, 0, '', '1', '0'),
	(8058, '9655', 208, 'clothing_flipflopsocks', 4, 0, 0, 1, 0, 0, 4, -1, 0, '0', '1', '0'),
	(8059, '9656', 259, 'rare_colourable_marquee*2', 5, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(8060, '9657', 259, 'rare_colourable_scifirocket*2', 5, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(8061, '9658', 259, 'rare_colourable_fountain*2', 5, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(8062, '9659', 259, 'rare_colourable_wooden_screen*2', 5, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(8063, '9660', 259, 'rare_colourable_dragonlamp*2', 5, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(8064, '9661', 259, 'rare_colourable_parasol*2', 5, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(8065, '9662', 259, 'rare_colourable_sleepingbag*2', 5, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(8066, '9663', 259, 'rare_colourable_pillar*2', 5, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(8067, '9664', 259, 'rare_colourable_beehive_bulb*2', 5, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(8068, '9665', 259, 'rare_colourable_icecream*2', 5, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(8069, '9666', 259, 'rare_colourable_elephant_statue*2', 5, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(8070, '9667', 610, 'hhistory_r17_crackable', 7, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(8071, '9668', 259, 'rare_colourable_scifidoor*2', 5, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(8072, '9669', 259, 'rare_colourable_fan*2', 5, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(8073, '9670', 259, 'rare_colourable_pillow*2', 5, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(8074, '9671', 259, 'rare_colourable_scifiport*2', 5, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(8075, '9672', 259, 'rare_colourable_barrier*2', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(8076, '9673', 522, 'dessertcafe_c17_armchair', 2, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(8077, '9674', 522, 'dessertcafe_c17_windoor', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(8078, '9675', 203, 'clothing_cutie', 6, 0, 0, 1, 0, 0, 6, -1, 0, '0', '1', '0'),
	(8079, '9676', 522, 'dessertcafe_c17_creamrolls', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(8080, '9677', 522, 'dessertcafe_c17_teaplant', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(8081, '9678', 522, 'dessertcafe_c17_vase', 4, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(8082, '9679', 522, 'dessertcafe_c17_table', 2, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(8083, '9680', 522, 'dessertcafe_c17_floor', 2, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(8084, '9681', 522, 'dessertcafe_c17_donut', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(8085, '9682', 522, 'dessertcafe_c17_glass', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(8086, '9683', 522, 'dessertcafe_c17_shelf', 5, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(8087, '9684', 522, 'dessertcafe_c17_rug', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(8088, '9685', 310, 'clothing_maidband', 6, 0, 0, 1, 0, 0, 37, 19710, 0, '0', '1', '0'),
	(8089, '9686', 522, 'dessertcafe_c17_coffeetable', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(8090, '9687', 522, 'dessertcafe_c17_sofa', 3, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(8091, '9688', 208, 'clothing_bowtights', 4, 0, 0, 1, 0, 0, 3, 19713, 0, '0', '1', '0'),
	(8092, '9689', 522, 'dessertcafe_c17_counter', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(8093, '9690', 203, 'clothing_maid', 5, 0, 0, 1, 0, 0, 5, 19715, 0, '', '1', '0'),
	(8094, '9691', 522, 'dessertcafe_c17_mochi', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(8095, '9692', 310, 'clothing_ribbonband', 6, 0, 0, 1, 0, 0, 36, -1, 0, '0', '1', '0'),
	(8096, '9693', 522, 'dessertcafe_c17_wall', 4, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(8097, '9694', 522, 'dessertcafe_c17_froyo', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(8098, '9695', 593, 'elegant_c17_window', 4, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(8099, '9696', 593, 'elegant_c17_vanity', 4, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(8100, '9697', 593, 'elegantp_c17_sofa', 3, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(8101, '9698', 593, 'elegantp_c17_chair', 2, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(8102, '9699', 593, 'elegant_c17_flowerpot', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(8103, '9700', 593, 'elegant_c17_sofa', 3, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(8104, '9701', 593, 'elegant_c17_bed', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(8105, '9702', 593, 'elegant_c17_teaset', 4, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(8106, '9703', 593, 'elegant_c17_stool', 4, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(8107, '9704', 593, 'elegant_c17_smalltable', 2, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(8108, '9705', 593, 'elegant_c17_floor', 2, 0, 0, 1, 0, 0, 31, -1, 0, '', '1', '0'),
	(8109, '9706', 593, 'elegantp_c17_stool', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(8110, '9707', 593, 'elegant_c17_carpet', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(8111, '9708', 593, 'elegantp_c17_cat', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(8112, '9709', 593, 'elegant_c17_wall', 4, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(8113, '9710', 577, 'clothing_r17_elegantcrown', 5, 0, 0, 1, 0, 0, 12, -1, 0, '0', '1', '0'),
	(8114, '9711', 593, 'elegant_c17_chair', 2, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(8115, '9712', 593, 'elegantp_c17_window', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(8116, '9713', 593, 'elegant_c17_cat', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(8117, '9714', 593, 'elegantp_c17_bed', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(8118, '9715', 593, 'elegantp_c17_carpet', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(8119, '9716', 593, 'elegant_c17_cupboard', 4, 0, 0, 1, 0, 0, 30, -1, 0, '', '1', '0'),
	(8120, '9717', 593, 'elegant_c17_light', 4, 0, 0, 1, 0, 0, 32, -1, 0, '', '1', '0'),
	(8121, '9718', 593, 'elegant_c17_walldecor', 4, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(8122, '9719', 593, 'elegant_c17_table', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(8123, '9720', 593, 'elegantp_c17_flowerpot', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(8124, '9721', 398, 'hween_c17_monstertele', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(8125, '9722', 398, 'hween_c17_zombiegrunt', 4, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(8126, '9723', 743, 'hween_ltd17_dragon', 4, 0, 0, 1, 0, 0, 27, -1, 0, '', '1', '0'),
	(8127, '9724', 398, 'hween_c17_hangingroots', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(8128, '9725', 398, 'hween_c17_fallingrocks', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(8129, '9726', 398, 'hween_c17_zombiesleep', 4, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(8130, '9727', 828, 'clothing_badasshelmet', 5, 0, 0, 1, 0, 0, 27, -1, 0, '0', '1', '0'),
	(8131, '9728', 201, 'clothing_layerbuns', 6, 0, 0, 1, 0, 0, 35, 19753, 0, '0', '1', '0'),
	(8132, '9729', 398, 'hween_c17_mimic', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(8133, '9730', 398, 'hween_r17_lichthrone', 4, 0, 0, 1, 0, 0, 29, -1, 0, '', '1', '0'),
	(8134, '9731', 310, 'clothing_demoneyes', 6, 0, 0, 1, 0, 0, 35, 19756, 0, '0', '1', '0'),
	(8135, '9732', 398, 'hween_c17_thefallen', 4, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(8136, '9733', 828, 'clothing_herochest', 5, 0, 0, 1, 0, 0, 14, -1, 0, '0', '1', '0'),
	(8137, '9734', 828, 'clothing_rebelchest', 5, 0, 0, 1, 0, 0, 12, -1, 0, '0', '1', '0'),
	(8138, '9735', 398, 'hween_c17_rat', 4, 0, 0, 1, 0, 0, 13, 21590, 0, '', '1', '0'),
	(8139, '9736', 398, 'hween_c17_rockdrip', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(8140, '9737', 577, 'clothing_r17_bathat', 5, 0, 0, 1, 0, 0, 13, -1, 0, '0', '1', '0'),
	(8141, '9738', 828, 'clothing_herohelmet', 5, 0, 0, 1, 0, 0, 16, -1, 0, '0', '1', '0'),
	(8142, '9739', 828, 'clothing_legarmour', 5, 0, 0, 1, 0, 0, 3, -1, 0, '0', '1', '0'),
	(8143, '9740', 398, 'hween_c17_lichen', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(8144, '9741', 398, 'hween_c17_bonfire', 4, 0, 0, 1, 0, 0, 1, 21590, 0, '', '1', '0'),
	(8145, '9742', 398, 'hween_c17_hidewall', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(8146, '9743', 398, 'hween_c17_rock', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(8147, '9744', 310, 'clothing_plaguemask', 6, 0, 0, 1, 0, 0, 34, 19769, 0, '0', '1', '0'),
	(8148, '9745', 712, 'hween_dragengage', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(8149, '9746', 398, 'hween_c17_portcullis', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(8150, '9747', 398, 'hween_c17_pillar', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(8151, '9748', 855, 'hween_r17_ancdrago', 4, 0, 0, 1, 0, 0, 28, -1, 0, '', '1', '0'),
	(8152, '9749', 577, 'clothing_r17_hweencrown', 5, 0, 0, 1, 0, 0, 14, -1, 0, '0', '1', '0'),
	(8153, '9750', 398, 'hween_c17_shroomthing', 4, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(8154, '9751', 398, 'hween_c17_handstrap', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(8155, '9752', 398, 'hween_c17_gibbet', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(8156, '9753', 827, 'hween_c17_flamingknight', 7, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(8157, '9754', 398, 'hween_c17_wall', 4, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(8158, '9755', 310, 'clothing_zombieeyes', 6, 0, 0, 1, 0, 0, 33, 19780, 0, '0', '1', '0'),
	(8159, '9756', 398, 'hween_c17_pillarsmall', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(8160, '9757', 398, 'hween_c17_cavefloor', 1, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(8161, '9758', 398, 'hween_c17_spiketrap', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(8162, '9759', 398, 'hween_c17_tent', 4, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(8163, '9760', 828, 'clothing_shoearmour', 5, 0, 0, 1, 0, 0, 5, -1, 0, '0', '1', '0'),
	(8164, '9761', 398, 'hween_c17_torturebed', 4, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(8165, '9762', 398, 'hween_c17_rock2', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(8166, '9763', 664, 'bonusbag17_3', 7, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(8167, '9764', 664, 'bonusbag17_4', 7, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(8168, '9765', 658, 'america_r17_beaver', 4, 0, 0, 1, 0, 0, 321, -1, 0, '', '1', '0'),
	(8169, '9766', 595, 'chess_w_bishop', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(8170, '9767', 595, 'chess_boardtile', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(8171, '9768', 595, 'chess_b_rook', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(8172, '9769', 595, 'chess_b_knight', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(8173, '9770', 595, 'chess_w_rook', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(8174, '9771', 595, 'chess_w_queen', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(8175, '9772', 595, 'chess_w_king', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(8176, '9773', 595, 'chess_w_pawn', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(8177, '9774', 595, 'chess_b_king', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(8178, '9775', 595, 'chess_b_bishop', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(8179, '9776', 595, 'chess_b_pawn', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(8180, '9777', 595, 'chess_b_queen', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(8181, '9778', 595, 'chess_w_knight', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(8182, '9779', 658, 'america_r17_skunk', 4, 0, 0, 1, 0, 0, 322, -1, 0, '', '1', '0'),
	(8183, '9780', 577, 'clothing_r17_daveycrockett', 5, 0, 0, 1, 0, 0, 15, -1, 0, '0', '1', '0'),
	(8184, '9781', 577, 'clothing_r17_frontierbraids', 5, 0, 0, 1, 0, 0, 16, -1, 0, '0', '1', '0'),
	(8185, '9782', 658, 'america_r17_opossum', 4, 0, 0, 1, 0, 0, 323, -1, 0, '', '1', '0'),
	(8186, '9783', 658, 'america_r17_raccoon', 4, 0, 0, 1, 0, 0, 324, -1, 0, '', '1', '0'),
	(8187, '9784', 658, 'america_r17_eagle', 4, 0, 0, 1, 0, 0, 325, -1, 0, '', '1', '0'),
	(8188, '9785', 658, 'america_r17_armadillo', 4, 0, 0, 1, 0, 0, 326, -1, 0, '', '1', '0'),
	(8189, '9786', 577, 'clothing_r17_goldtophat', 5, 0, 0, 1, 0, 0, 17, -1, 0, '0', '1', '0'),
	(8190, '9787', 487, 'xmas_c17_britishbulldog', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(8191, '9788', 487, 'xmas_c17_girl', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(8192, '9789', 487, 'xmas_c17_man', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(8193, '9790', 786, 'xmas_c17_blueprint3', 4, 0, 0, 1, 0, 0, 36, -1, 0, '', '1', '0'),
	(8194, '9791', 487, 'xmas_c17_snowybasket', 4, 0, 0, 1, 0, 0, 37, -1, 0, '', '1', '0'),
	(8195, '9792', 487, 'xmas_c17_doll2', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(8196, '9793', 786, 'xmas_c17_blueprint6', 4, 0, 0, 1, 0, 0, 38, -1, 0, '', '1', '0'),
	(8197, '9794', 785, 'xmas_c17_sewingmchn', 4, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(8198, '9795', 487, 'xmas_c17_roof', 4, 0, 0, 1, 0, 0, -2, -1, 0, '', '1', '0'),
	(8199, '9796', 487, 'xmas_c17_door', 4, 0, 0, 1, 0, 0, -8, -1, 0, '', '1', '0'),
	(8200, '9797', 487, 'xmas_c17_hatshop', 4, 0, 0, 1, 0, 0, -7, -1, 0, '', '1', '0'),
	(8201, '9798', 487, 'xmas_c17_doll4', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(8202, '9799', 743, 'xmas_ltd17_ted', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(8203, '9800', 487, 'xmas_c17_stove', 4, 0, 0, 1, 0, 0, 40, -1, 0, '', '1', '0'),
	(8204, '9801', 786, 'xmas_c17_blueprint5', 4, 0, 0, 1, 0, 0, 37, -1, 0, '', '1', '0'),
	(8205, '9802', 487, 'xmas_c17_hangingbasket', 4, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(8206, '9803', 487, 'xmas_c17_lamp', 4, 0, 0, 1, 0, 0, 27, -1, 0, '', '1', '0'),
	(8207, '9804', 487, 'xmas_c17_pavement', 4, 0, 0, 1, 0, 0, 29, -1, 0, '', '1', '0'),
	(8208, '9805', 487, 'xmas_c17_smallpavement', 4, 0, 0, 1, 0, 0, 36, -1, 0, '', '1', '0'),
	(8209, '9806', 487, 'xmas_r17_carriage', 4, 0, 0, 1, 0, 0, 48, -1, 0, '', '1', '0'),
	(8210, '9807', 787, 'clothing_featherflower', 6, 0, 0, 1, 0, 0, 25, -1, 0, '0', '1', '0'),
	(8211, '9808', 831, 'xmas_c17_book', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(8212, '9809', 487, 'xmas_c17_chair', 2, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(8213, '9810', 787, 'clothing_buttonpants', 5, 0, 0, 1, 0, 0, 2, -1, 0, '0', '1', '0'),
	(8214, '9811', 487, 'xmas_c17_doll1', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(8215, '9812', 487, 'xmas_c17_tree', 4, 0, 0, 1, 0, 0, 44, -1, 0, '', '1', '0'),
	(8216, '9813', 487, 'xmas_c17_frizzycat', 4, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(8217, '9814', 577, 'clothing_r17_goldfeatherflower', 5, 0, 0, 1, 0, 0, 18, -1, 0, '0', '1', '0'),
	(8218, '9815', 487, 'xmas_c17_bigwindows2', 4, 0, 0, 1, 0, 0, -11, -1, 0, '', '1', '0'),
	(8219, '9816', 487, 'xmas_c17_teashop', 4, 0, 0, 1, 0, 0, -4, -1, 0, '', '1', '0'),
	(8220, '9817', 487, 'xmas_c17_doll6', 4, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(8221, '9818', 487, 'xmas_c17_snowypot', 4, 0, 0, 1, 0, 0, 39, -1, 0, '', '1', '0'),
	(8222, '9819', 487, 'xmas_c17_cobbleroad', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(8223, '9820', 487, 'xmas_r17_musicbox', 4, 0, 0, 1, 0, 0, 50, -1, 0, '', '1', '0'),
	(8224, '9821', 487, 'xmas_c17_window', 4, 0, 0, 1, 0, 0, -3, -1, 0, '', '1', '0'),
	(8225, '9822', 487, 'xmas_c17_fencecorner', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(8226, '9823', 487, 'xmas_c17_chestnutstall', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(8227, '9824', 310, 'clothing_beautyface', 6, 0, 0, 1, 0, 0, 32, 19890, 0, '0', '1', '0'),
	(8228, '9825', 487, 'xmas_c17_bench', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(8229, '9826', 786, 'xmas_c17_thread', 4, 0, 0, 1, 0, 0, 43, -1, 0, '', '1', '0'),
	(8230, '9827', 487, 'xmas_c17_wall', 4, 0, 0, 1, 0, 0, -1, -1, 0, '', '1', '0'),
	(8231, '9828', 487, 'xmas_c17_pillar', 4, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(8232, '9829', 832, 'xmas_c17_blueprint4', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(8233, '9830', 487, 'xmas_c17_drain', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(8234, '9831', 487, 'xmas_c17_fence', 4, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(8235, '9832', 487, 'xmas_c17_table', 2, 0, 0, 1, 0, 0, 41, -1, 0, '', '1', '0'),
	(8236, '9833', 786, 'xmas_c17_blueprint2', 4, 0, 0, 1, 0, 0, 35, -1, 0, '', '1', '0'),
	(8237, '9834', 487, 'xmas_c17_doll5', 4, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(8238, '9835', 487, 'xmas_c17_boy', 10, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(8239, '9836', 787, 'clothing_ruffleshirt', 5, 0, 0, 1, 0, 0, 17, -1, 0, '0', '1', '0'),
	(8240, '9837', 487, 'xmas_c17_pub2', 4, 0, 0, 1, 0, 0, -5, -1, 0, '', '1', '0'),
	(8241, '9838', 786, 'xmas_c17_cloth', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(8242, '9839', 787, 'clothing_tophat', 6, 0, 0, 1, 0, 0, 25, -1, 0, '0', '1', '0'),
	(8243, '9840', 712, 'xmas_c17_engage_ted', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(8244, '9841', 487, 'xmas_c17_snowygrass', 4, 0, 0, 1, 0, 0, 38, -1, 0, '', '1', '0'),
	(8245, '9842', 786, 'xmas_c17_blueprint1', 4, 0, 0, 1, 0, 0, 34, -1, 0, '', '1', '0'),
	(8246, '9843', 487, 'xmas_c17_doll3', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(8247, '9844', 487, 'xmas_c17_robins', 4, 0, 0, 1, 0, 0, 34, -1, 0, '', '1', '0'),
	(8248, '9845', 487, 'xmas_c17_woman', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(8249, '9846', 787, 'clothing_dress', 6, 0, 0, 1, 0, 0, 2, -1, 0, '0', '1', '0'),
	(8250, '9847', 487, 'xmas_c17_bigwindows1', 4, 0, 0, 1, 0, 0, -10, -1, 0, '', '1', '0'),
	(8251, '9848', 487, 'xmas_c17_pram', 4, 0, 0, 1, 0, 0, 31, -1, 0, '', '1', '0'),
	(8252, '9849', 487, 'xmas_r17_lion', 4, 0, 0, 1, 0, 0, 49, -1, 0, '', '1', '0'),
	(8253, '9850', 487, 'xmas_c17_horse', 4, 0, 0, 1, 0, 0, 26, -1, 0, '', '1', '0'),
	(8254, '9851', 787, 'clothing_tailedcoat', 5, 0, 0, 1, 0, 0, 11, -1, 0, '0', '1', '0'),
	(8255, '9852', 487, 'xmas_c17_pub1', 4, 0, 0, 1, 0, 0, -6, -1, 0, '', '1', '0'),
	(8256, '9853', 487, 'xmas_c17_gate', 4, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(8257, '9854', 487, 'xmas_c17_candyshop', 4, 0, 0, 1, 0, 0, -9, -1, 0, '', '1', '0'),
	(8258, '9855', 310, 'clothing_sasquatchmask', 6, 0, 0, 1, 0, 0, 31, -1, 0, '0', '1', '0'),
	(8259, '9856', 598, 'rare_prize17xmas', 5, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(8260, '9857', 570, 'clothing_loyaltycrown_V', 6, 0, 0, 1, 0, 0, 4, -1, 0, '0', '1', '0'),
	(8261, '9858', 570, 'clothing_loyaltycrown_X', 6, 0, 0, 1, 0, 0, 3, -1, 0, '0', '1', '0'),
	(8262, '9859', 570, 'clothing_loyaltycrown_II', 6, 0, 0, 1, 0, 0, 2, -1, 0, '0', '1', '0'),
	(8263, '9860', 585, 'clothing_goldpack3', 5, 0, 0, 1, 0, 0, 3, -1, 0, '0', '1', '0'),
	(8264, '9861', 660, 'bonusrare18_3*0', 4, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(8265, '9862', 660, 'bonusrare18_3*1', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(8266, '9863', 660, 'bonusrare18_3*2', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(8267, '9864', 660, 'bonusrare18_3*3', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(8268, '9865', 660, 'bonusrare18_3*4', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(8269, '9866', 660, 'bonusrare18_3*5', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(8270, '9867', 664, 'bonusbag18_3', 7, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(8271, '9868', 664, 'bonusbag18_2', 7, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(8272, '9869', 660, 'bonusrare18_2*0', 4, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(8273, '9870', 660, 'bonusrare18_2*1', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(8274, '9871', 660, 'bonusrare18_2*2', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(8275, '9872', 660, 'bonusrare18_2*3', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(8276, '9873', 660, 'bonusrare18_2*4', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(8277, '9874', 660, 'bonusrare18_2*5', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(8278, '9875', 664, 'bonusbag18_4', 7, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(8279, '9876', 664, 'bonusbag18_1', 7, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(8280, '9877', 660, 'bonusrare18_4*0', 4, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(8281, '9878', 660, 'bonusrare18_4*1', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(8282, '9879', 660, 'bonusrare18_4*2', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(8283, '9880', 660, 'bonusrare18_4*3', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(8284, '9881', 660, 'bonusrare18_4*4', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(8285, '9882', 660, 'bonusrare18_4*5', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(8286, '9883', 660, 'bonusrare18_1*0', 4, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(8287, '9884', 660, 'bonusrare18_1*1', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(8288, '9885', 660, 'bonusrare18_1*2', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(8289, '9886', 660, 'bonusrare18_1*3', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(8290, '9887', 660, 'bonusrare18_1*4', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(8291, '9888', 660, 'bonusrare18_1*5', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(8292, '9889', 582, 'clothing_mini_bowlerhat_dark', 5, 0, 0, 1, 0, 0, 1, -1, 0, '0', '1', '0'),
	(8293, '9890', 582, 'clothing_mini_bowlerhat_cream', 5, 0, 0, 1, 0, 0, 2, -1, 0, '0', '1', '0'),
	(8294, '9891', 582, 'clothing_mini_bowlerhat_gold', 5, 0, 0, 1, 0, 0, 3, -1, 0, '0', '1', '0'),
	(8295, '9892', 582, 'clothing_mini_bowlerhat_green', 5, 0, 0, 1, 0, 0, 4, -1, 0, '0', '1', '0'),
	(8296, '9893', 582, 'clothing_mini_bowlerhat_red', 5, 0, 0, 1, 0, 0, 5, -1, 0, '0', '1', '0'),
	(8297, '9894', 582, 'clothing_mini_bowlerhat_purple', 5, 0, 0, 1, 0, 0, 6, -1, 0, '0', '1', '0'),
	(8298, '9895', 582, 'clothing_mini_bowlerhat_blue', 5, 0, 0, 1, 0, 0, 7, -1, 0, '0', '1', '0'),
	(8299, '9896', 668, 'ny18_crackable', 7, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(8300, '9897', 365, 'classic8_bar', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(8301, '9898', 366, 'classic9_floor2', 4, 0, 0, 1, 0, 0, 138, -1, 0, '', '1', '0'),
	(8302, '9899', 365, 'classic8_chair', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(8303, '9900', 366, 'classic9_statue', 4, 0, 0, 1, 0, 0, 141, -1, 0, '', '1', '0'),
	(8304, '9901', 365, 'classic8_rug', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(8305, '9902', 365, 'classic8_records', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(8306, '9903', 365, 'classic8_sofa', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(8307, '9904', 366, 'classic9_carpet', 4, 0, 0, 1, 0, 0, 49, -1, 0, '', '1', '0'),
	(8308, '9905', 365, 'classic8_statue', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(8309, '9906', 365, 'classic8_curtains', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(8310, '9907', 365, 'classic8_stairs', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(8311, '9908', 365, 'classic8_glassfloor', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(8312, '9909', 366, 'classic9_counter', 4, 0, 0, 1, 0, 0, 50, -1, 0, '', '1', '0'),
	(8313, '9910', 366, 'classic9_chair', 4, 0, 0, 1, 0, 0, 135, -1, 0, '', '1', '0'),
	(8314, '9911', 366, 'classic9_light', 4, 0, 0, 1, 0, 0, 139, -1, 0, '', '1', '0'),
	(8315, '9912', 365, 'classic8_pillar', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(8316, '9913', 366, 'classic9_floor1', 4, 0, 0, 1, 0, 0, 51, -1, 0, '', '1', '0'),
	(8317, '9914', 366, 'classic9_table', 4, 0, 0, 1, 0, 0, 143, -1, 0, '', '1', '0'),
	(8318, '9915', 365, 'classic8_divider', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(8319, '9916', 365, 'classic8_floor', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(8320, '9917', 365, 'classic8_sign', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(8321, '9918', 365, 'classic8_shelf', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(8322, '9919', 366, 'classic9_plant', 4, 0, 0, 1, 0, 0, 140, -1, 0, '', '1', '0'),
	(8323, '9920', 365, 'classic8_disco', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(8324, '9921', 366, 'classic9_stool', 4, 0, 0, 1, 0, 0, 52, -1, 0, '', '1', '0'),
	(8325, '9922', 366, 'classic9_bookshelf', 4, 0, 0, 1, 0, 0, 133, -1, 0, '', '1', '0'),
	(8326, '9923', 365, 'classic8_wall', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(8327, '9924', 366, 'classic9_books', 4, 0, 0, 1, 0, 0, 132, -1, 0, '', '1', '0'),
	(8328, '9925', 365, 'classic8_plant', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(8329, '9926', 366, 'classic9_wall', 4, 0, 0, 1, 0, 0, 53, -1, 0, '', '1', '0'),
	(8330, '9927', 592, 'rare_prize18*0', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(8331, '9928', 592, 'rare_prize18*1', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(8332, '9929', 592, 'rare_prize18*10', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(8333, '9930', 592, 'rare_prize18*11', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(8334, '9931', 592, 'rare_prize18*12', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(8335, '9932', 592, 'rare_prize18*2', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(8336, '9933', 592, 'rare_prize18*3', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(8337, '9934', 592, 'rare_prize18*4', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(8338, '9935', 592, 'rare_prize18*5', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(8339, '9936', 592, 'rare_prize18*6', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(8340, '9937', 592, 'rare_prize18*7', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(8341, '9938', 592, 'rare_prize18*8', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(8342, '9939', 592, 'rare_prize18*9', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(8343, '9940', 357, 'hc17_3', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '1'),
	(8344, '9941', 357, 'hc17_8', 5, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '1'),
	(8345, '9942', 357, 'hc17_10', 5, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '1'),
	(8346, '9943', 357, 'hc17_11', 5, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '1'),
	(8347, '9944', 357, 'hc17_5', 5, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '1'),
	(8348, '9945', 357, 'hc17_2', 5, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '1'),
	(8349, '9946', 357, 'hc17_6', 5, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '1'),
	(8350, '9947', 357, 'hc17_12', 5, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '1'),
	(8351, '9948', 357, 'hc17_9', 5, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '1'),
	(8352, '9949', 357, 'hc17_4', 5, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '1'),
	(8353, '9950', 357, 'hc17_1', 5, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '1'),
	(8354, '9951', 458, 'val_c18_chest', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(8355, '9952', 458, 'val_c18_wardrobe', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(8356, '9953', 201, 'clothing_judgewig', 6, 0, 0, 1, 0, 0, 34, 20107, 0, '0', '1', '0'),
	(8357, '9954', 201, 'clothing_elegantponytail', 6, 0, 0, 1, 0, 0, 30, 20108, 0, '0', '1', '0'),
	(8358, '9955', 578, 'clothing_r18_unicorn', 5, 0, 0, 1, 0, 0, 1, -1, 0, '0', '1', '0'),
	(8359, '9956', 458, 'val_c18_swan', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(8360, '9957', 578, 'clothing_r18_dress', 5, 0, 0, 1, 0, 0, 2, -1, 0, '0', '1', '0'),
	(8361, '9958', 458, 'val_r18_bed', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(8362, '9959', 202, 'clothing_gentcap', 4, 0, 0, 1, 0, 0, 10, 20113, 0, '0', '1', '0'),
	(8363, '9960', 384, 'easter_c18_lemontree', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(8364, '9961', 847, 'easter_c18_snowdrop3', 4, 0, 0, 1, 0, 0, 106, -1, 0, '', '1', '0'),
	(8365, '9962', 310, 'clothing_shades', 6, 0, 0, 1, 0, 0, 30, 20126, 0, '0', '1', '0'),
	(8366, '9963', 847, 'easter_c18_lupin1', 4, 0, 0, 1, 0, 0, 44, -1, 0, '', '1', '0'),
	(8367, '9964', 201, 'clothing_braidedwavy', 6, 0, 0, 1, 0, 0, 28, 20128, 0, '0', '1', '0'),
	(8368, '9965', 847, 'easter_c18_tulip2', 4, 0, 0, 1, 0, 0, 101, -1, 0, '', '1', '0'),
	(8369, '9966', 846, 'easter_c18_seedpackrose', 7, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(8370, '9967', 310, 'clothing_satchel', 6, 0, 0, 1, 0, 0, 29, 20131, 0, '0', '1', '0'),
	(8371, '9968', 384, 'easter_c18_dancingplant', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(8372, '9969', 847, 'easter_c18_badflower', 4, 0, 0, 1, 0, 0, 54, -1, 0, '', '1', '0'),
	(8373, '9970', 846, 'easter_c18_seedpacktulip', 7, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(8374, '9971', 847, 'easter_c18_rose3', 4, 0, 0, 1, 0, 0, 110, -1, 0, '', '1', '0'),
	(8375, '9972', 847, 'easter_c18_tulip3', 4, 0, 0, 1, 0, 0, 42, -1, 0, '', '1', '0'),
	(8376, '9973', 384, 'easter_c18_tricyle', 4, 0, 0, 1, 0, 0, 27, -1, 0, '', '1', '0'),
	(8377, '9974', 384, 'easter_c18_recyclebin', 4, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(8378, '9975', 384, 'easter_c18_ivybeam', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(8379, '9976', 847, 'easter_c18_lupin3', 4, 0, 0, 1, 0, 0, 114, -1, 0, '', '1', '0'),
	(8380, '9977', 384, 'easter_c18_radio', 4, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(8381, '9978', 847, 'easter_c18_lupin4', 4, 0, 0, 1, 0, 0, 115, -1, 0, '', '1', '0'),
	(8382, '9979', 384, 'easter_c18_ceilingfan', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(8383, '9980', 384, 'easter_c18_ivylight', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(8384, '9981', 204, 'clothing_tiedtop', 5, 0, 0, 1, 0, 0, 13, 20145, 0, '0', '1', '0'),
	(8385, '9982', 846, 'easter_c18_seedpacksnowdrop', 7, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(8386, '9983', 847, 'easter_c18_rose4', 4, 0, 0, 1, 0, 0, 111, -1, 0, '', '1', '0'),
	(8387, '9984', 384, 'easter_r18_bonzaifountain', 4, 0, 0, 1, 0, 0, 32, -1, 0, '', '1', '0'),
	(8388, '9985', 384, 'easter_c18_hutch', 4, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(8389, '9986', 847, 'easter_c18_snowdrop4', 4, 0, 0, 1, 0, 0, 107, -1, 0, '', '1', '0'),
	(8390, '9987', 384, 'easter_c18_shelfplants', 5, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(8391, '9988', 384, 'easter_r18_bigbunny', 4, 0, 0, 1, 0, 0, 31, -1, 0, '', '1', '0'),
	(8392, '9989', 384, 'easter_c18_curtains', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(8393, '9990', 578, 'clothing_r18_bunniemask', 5, 0, 0, 1, 0, 0, 3, -1, 0, '0', '1', '0'),
	(8394, '9991', 384, 'easter_c18_washline', 4, 0, 0, 1, 0, 0, 29, -1, 0, '', '1', '0'),
	(8395, '9992', 384, 'easter_c18_glassbrickcnr', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(8396, '9993', 384, 'easter_c18_birchpillar', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(8397, '9994', 847, 'easter_c18_rose2', 4, 0, 0, 1, 0, 0, 109, -1, 0, '', '1', '0'),
	(8398, '9995', 384, 'easter_c18_boxplanter', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(8399, '9996', 578, 'clothing_r18_bunniehat', 5, 0, 0, 1, 0, 0, 4, -1, 0, '0', '1', '0'),
	(8400, '9997', 847, 'easter_c18_tulip1', 4, 0, 0, 1, 0, 0, 100, -1, 0, '', '1', '0'),
	(8401, '9998', 201, 'clothing_floppyhair', 6, 0, 0, 1, 0, 0, 27, 20162, 0, '0', '1', '0'),
	(8402, '9999', 744, 'easter_ltd18_habberge10', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(8403, '10000', 384, 'easter_c18_hangingplant', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(8404, '10001', 384, 'easter_c18_woodendeco', 4, 0, 0, 1, 0, 0, 30, -1, 0, '', '1', '0'),
	(8405, '10002', 847, 'easter_c18_lupin2', 4, 0, 0, 1, 0, 0, 113, -1, 0, '', '1', '0'),
	(8406, '10003', 384, 'easter_c18_dragonflies', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(8407, '10004', 201, 'clothing_retrohair', 6, 0, 0, 1, 0, 0, 26, 20168, 0, '0', '1', '0'),
	(8408, '10005', 384, 'easter_c18_chair', 2, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(8409, '10006', 847, 'easter_c18_tulip4', 4, 0, 0, 1, 0, 0, 43, -1, 0, '', '1', '0'),
	(8410, '10007', 202, 'clothing_floppysunhat', 6, 0, 0, 1, 0, 0, 9, 20171, 0, '0', '1', '0'),
	(8411, '10008', 384, 'easter_c18_patternfloor', 2, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(8412, '10009', 384, 'easter_c18_glassdoor', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(8413, '10010', 384, 'easter_c18_slatestack', 4, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(8414, '10011', 384, 'easter_c18_stackedplants', 4, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(8415, '10012', 384, 'easter_c18_countryteaset', 4, 0, 0, 1, 0, 0, 6, 24152, 0, '', '1', '0'),
	(8416, '10013', 846, 'easter_c18_seedpacklupin', 7, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(8417, '10014', 384, 'easter_c18_glassbrickwall', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(8418, '10015', 384, 'easter_c18_chiaplants', 4, 0, 0, 1, 0, 0, 5, 24152, 0, '', '1', '0'),
	(8419, '10016', 384, 'easter_c18_table', 4, 0, 0, 1, 0, 0, 26, -1, 0, '', '1', '0'),
	(8420, '10017', 847, 'easter_c18_snowdrop1', 4, 0, 0, 1, 0, 0, 104, -1, 0, '', '1', '0'),
	(8421, '10018', 384, 'easter_c18_radiator', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(8422, '10019', 384, 'easter_c18_fawn', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(8423, '10020', 384, 'easter_c18_veg', 4, 0, 0, 1, 0, 0, 28, -1, 0, '', '1', '0'),
	(8424, '10021', 847, 'easter_c18_snowdrop2', 4, 0, 0, 1, 0, 0, 105, -1, 0, '', '1', '0'),
	(8425, '10022', 847, 'easter_c18_rose1', 4, 0, 0, 1, 0, 0, 108, -1, 0, '', '1', '0'),
	(8426, '10023', 737, 'trophy_netsafety_0', 5, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(8427, '10024', 816, 'clothing_kpopbuns', 6, 0, 0, 1, 0, 0, 24, -1, 0, '0', '1', '0'),
	(8428, '10025', 816, 'clothing_kpop', 6, 0, 0, 1, 0, 0, 23, -1, 0, '0', '1', '0'),
	(8429, '10026', 816, 'clothing_bffshirt', 5, 0, 0, 1, 0, 0, 13, -1, 0, '0', '1', '0'),
	(8430, '10027', 816, 'clothing_bffhat', 6, 0, 0, 1, 0, 0, 19, -1, 0, '0', '1', '0'),
	(8431, '10028', 302, 'china_dog', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(8432, '10029', 302, 'cny18_dogballoon', 4, 0, 0, 1, 0, 0, 57, -1, 0, '', '1', '0'),
	(8433, '10030', 307, 'CF_500_moneytree', 500, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(8434, '10031', 815, 'gift_bff_a', 4, 0, 0, 1, 0, 0, 327, -1, 0, '', '1', '0'),
	(8435, '10032', 814, 'crafting_jarhearts', 4, 0, 0, 1, 0, 0, 328, -1, 0, '', '1', '0'),
	(8436, '10033', 815, 'gift_bff_b', 4, 0, 0, 1, 0, 0, 329, -1, 0, '', '1', '0'),
	(8437, '10034', 280, 'cine_r18_buggy', 4, 0, 0, 1, 0, 0, 100, -1, 0, '', '1', '0'),
	(8438, '10035', 280, 'cine_r18_camera', 4, 0, 0, 1, 0, 0, 101, -1, 0, '', '1', '0'),
	(8439, '10036', 280, 'cine_r18_catcopter', 4, 0, 0, 1, 0, 0, 102, -1, 0, '', '1', '0'),
	(8440, '10037', 205, 'clothing_poncho', 5, 0, 0, 1, 0, 0, 7, -1, 0, '0', '1', '0'),
	(8441, '10038', 204, 'clothing_inmate', 5, 0, 0, 1, 0, 0, 12, -1, 0, '0', '1', '0'),
	(8442, '10039', 200, 'clothing_mercenary', 20, 0, 0, 1, 0, 0, 3, -1, 0, '0', '1', '0'),
	(8443, '10040', 208, 'clothing_yetifeet', 4, 0, 0, 1, 0, 0, 2, -1, 0, '0', '1', '0'),
	(8444, '10041', 280, 'cine_r18_trailer', 4, 0, 0, 1, 0, 0, 103, -1, 0, '', '1', '0'),
	(8445, '10042', 204, 'clothing_c18_cutething', 5, 0, 0, 1, 0, 0, 11, -1, 0, '0', '1', '0'),
	(8446, '10043', 479, 'gift_c18_cookiejar', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(8447, '10044', 422, 'gaming_c18_hswap', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(8448, '10045', 501, 'laundry_c18_ironing', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(8449, '10046', 501, 'laundry_c18_dustpan', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(8450, '10047', 422, 'gaming_c18_chairpro', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(8451, '10048', 501, 'laundry_c18_basket', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(8452, '10049', 501, 'laundry_c18_products', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(8453, '10050', 422, 'gaming_c18_gameplush2', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(8454, '10051', 501, 'laundry_c18_washmachine', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(8455, '10052', 422, 'gaming_c18_gameplush1', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(8456, '10053', 422, 'gaming_c18_gamecollection', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(8457, '10054', 422, 'gaming_c18_setuppro', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(8458, '10055', 422, 'gaming_c18_cubelight', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(8459, '10056', 501, 'laundry_r18_vacuum', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(8460, '10057', 501, 'laundry_c18_dryingrack', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(8461, '10058', 422, 'gaming_c18_hs4', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(8462, '10059', 422, 'gaming_c18_rigpro', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(8463, '10060', 428, 'jp_r18_asiandoll', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(8464, '10061', 578, 'clothing_r18_seahorse', 5, 0, 0, 1, 0, 0, 5, -1, 0, '0', '1', '0'),
	(8465, '10062', 731, 'coralking_c18_cone', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(8466, '10063', 424, 'coralking_c18_gate', 4, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(8467, '10064', 424, 'coralking_c18_fishnet', 4, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(8468, '10065', 731, 'coralking_c18_spinycoral2', 4, 0, 0, 1, 0, 0, 40, -1, 0, '', '1', '0'),
	(8469, '10066', 424, 'coralking_c18_anchor', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(8470, '10067', 424, 'coralking_r18_turtleride', 4, 0, 0, 1, 0, 0, 47, -1, 0, '', '1', '0'),
	(8471, '10068', 424, 'coralking_c18_shelltele', 4, 0, 0, 1, 0, 0, 42, -1, 0, '', '1', '0'),
	(8472, '10069', 731, 'coralking_c18_starfish1', 4, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(8473, '10070', 103, 'coralking_c18_treasurechest', 7, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(8474, '10071', 424, 'coralking_c18_tropicalfish', 4, 0, 0, 1, 0, 0, 46, -1, 0, '', '1', '0'),
	(8475, '10072', 731, 'coralking_c18_goldenfish', 4, 0, 0, 1, 0, 0, 27, -1, 0, '', '1', '0'),
	(8476, '10073', 424, 'coralking_c18_bluesand', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(8477, '10074', 201, 'clothing_luscioushair', 6, 0, 0, 1, 0, 0, 25, 20304, 0, '0', '1', '0'),
	(8478, '10075', 424, 'coralking_c18_sunkenpots', 4, 0, 0, 1, 0, 0, 43, -1, 0, '', '1', '0'),
	(8479, '10076', 424, 'coralking_c18_catfish', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(8480, '10077', 731, 'coralking_c18_closedspiral1', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(8481, '10078', 103, 'coralking_r18_goldenchest', 7, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(8482, '10079', 424, 'coralking_c18_bubbleseat', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(8483, '10080', 731, 'coralking_c18_closedspiral2', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(8484, '10081', 731, 'coralking_c18_spinycoral1', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(8485, '10082', 208, 'clothing_flippers', 4, 0, 0, 1, 0, 0, 1, 20312, 0, '0', '1', '0'),
	(8486, '10083', 424, 'coralking_c18_trash', 4, 0, 0, 1, 0, 0, 45, -1, 0, '', '1', '0'),
	(8487, '10084', 731, 'coralking_c18_bushycoral2', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(8488, '10085', 424, 'coralking_c18_corner', 4, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(8489, '10086', 731, 'coralking_c18_openspiral1', 4, 0, 0, 1, 0, 0, 32, -1, 0, '', '1', '0'),
	(8490, '10087', 424, 'coralking_c18_seafloor', 2, 0, 0, 1, 0, 0, 41, -1, 0, '', '1', '0'),
	(8491, '10088', 424, 'coralking_c18_kelppillar', 4, 0, 0, 1, 0, 0, 27, -1, 0, '', '1', '0'),
	(8492, '10089', 731, 'coralking_c18_clamshell2', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(8493, '10090', 424, 'coralking_c18_neoncoral2', 4, 0, 0, 1, 0, 0, 29, -1, 0, '', '1', '0'),
	(8494, '10091', 204, 'clothing_wetsuit', 5, 0, 0, 1, 0, 0, 10, 20321, 0, '0', '1', '0'),
	(8495, '10092', 424, 'coralking_c18_boulders1', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(8496, '10093', 731, 'clothing_r18_goldfish', 5, 0, 0, 1, 0, 0, 14, -1, 0, '0', '1', '0'),
	(8497, '10094', 424, 'coralking_r18_vanitytable', 4, 0, 0, 1, 0, 0, 48, -1, 0, '', '1', '0'),
	(8498, '10095', 424, 'coralking_c18_coralfloor', 2, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(8499, '10096', 424, 'coralking_c18_bed', 3, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(8500, '10097', 424, 'coralking_c18_gazebo', 4, 0, 0, 1, 0, 0, 26, -1, 0, '', '1', '0'),
	(8501, '10098', 424, 'coralking_c18_neoncoral3', 4, 0, 0, 1, 0, 0, 30, -1, 0, '', '1', '0'),
	(8502, '10099', 731, 'coralking_c18_trident', 4, 0, 0, 1, 0, 0, 46, -1, 0, '', '1', '0'),
	(8503, '10100', 731, 'coralking_c18_starfish2', 4, 0, 0, 1, 0, 0, 42, -1, 0, '', '1', '0'),
	(8504, '10101', 424, 'coralking_c18_table', 4, 0, 0, 1, 0, 0, 44, -1, 0, '', '1', '0'),
	(8505, '10102', 424, 'coralking_c18_fence', 4, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(8506, '10103', 744, 'coralking_ltd18_royalseahorse', 4, 0, 0, 1, 0, 0, 49, -1, 0, '', '1', '0'),
	(8507, '10104', 731, 'coralking_c18_seaweed', 4, 0, 0, 1, 0, 0, 37, -1, 0, '', '1', '0'),
	(8508, '10105', 424, 'coralking_c18_clownfish', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(8509, '10106', 578, 'clothing_r18_divershelmet', 5, 0, 0, 1, 0, 0, 6, -1, 0, '0', '1', '0'),
	(8510, '10107', 204, 'clothing_sailortop', 5, 0, 0, 1, 0, 0, 9, 20337, 0, '0', '1', '0'),
	(8511, '10108', 731, 'coralking_c18_openspiral2', 4, 0, 0, 1, 0, 0, 33, -1, 0, '', '1', '0'),
	(8512, '10109', 424, 'coralking_c18_angelfish', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(8513, '10110', 731, 'coralking_c18_clamshell3', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(8514, '10111', 731, 'coralking_c18_chalice', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(8515, '10112', 424, 'coralking_c18_bubblerock', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(8516, '10113', 731, 'clothing_r18_seawreath', 5, 0, 0, 1, 0, 0, 14, -1, 0, '0', '1', '0'),
	(8517, '10114', 424, 'coralking_c18_chair', 2, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(8518, '10115', 424, 'coralking_c18_neoncoral1', 4, 0, 0, 1, 0, 0, 28, -1, 0, '', '1', '0'),
	(8519, '10116', 424, 'coralking_c18_boulders2', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(8520, '10117', 731, 'coralking_c18_pearloyster', 4, 0, 0, 1, 0, 0, 34, -1, 0, '', '1', '0'),
	(8521, '10118', 731, 'coralking_c18_clamshell1', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(8522, '10119', 731, 'coralking_c18_bushycoral1', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(8523, '10120', 683, 'coralking_engageseahorse', 3, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(8524, '10121', 307, 'CF_750_goldenpig', 750, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(8525, '10122', 578, 'clothing_r18_tiedwavylocks', 5, 0, 0, 1, 0, 0, 7, -1, 0, '0', '1', '0'),
	(8526, '10123', 578, 'clothing_r18_frohawk', 5, 0, 0, 1, 0, 0, 8, -1, 0, '0', '1', '0'),
	(8527, '10124', 657, 'birds_r18_spoonbill', 4, 0, 0, 1, 0, 0, 330, -1, 0, '', '1', '0'),
	(8528, '10125', 657, 'birds_r18_puffin', 4, 0, 0, 1, 0, 0, 331, -1, 0, '', '1', '0'),
	(8529, '10126', 657, 'birds_r18_peacock', 4, 0, 0, 1, 0, 0, 332, -1, 0, '', '1', '0'),
	(8530, '10127', 657, 'birds_r18_crane', 4, 0, 0, 1, 0, 0, 333, -1, 0, '', '1', '0'),
	(8531, '10128', 657, 'birds_r18_quetzal', 4, 0, 0, 1, 0, 0, 334, -1, 0, '', '1', '0'),
	(8532, '10129', 657, 'birds_r18_cardinal', 4, 0, 0, 1, 0, 0, 335, -1, 0, '', '1', '0'),
	(8533, '10130', 744, 'trophy_ltd18_wcup', 4, 0, 0, 1, 0, 0, 336, -1, 0, '', '1', '0'),
	(8534, '10131', 428, 'tokyo_c18_residential', 4, 0, 0, 1, 0, 0, 15, 25836, 0, '', '1', '0'),
	(8535, '10132', 768, 'tokyo_c18_toy4', 4, 0, 0, 1, 0, 0, 30, -1, 0, '', '1', '0'),
	(8536, '10133', 768, 'tokyo_c18_toy6', 4, 0, 0, 1, 0, 0, 31, -1, 0, '', '1', '0'),
	(8537, '10134', 769, 'clothing_animehair', 6, 0, 0, 1, 0, 0, 21, -1, 0, '0', '1', '0'),
	(8538, '10135', 428, 'tokyo_c18_railing', 4, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(8539, '10136', 428, 'tokyo_c18_retroarcade', 4, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(8540, '10137', 428, 'tokyo_c18_motorbike', 4, 0, 0, 1, 0, 0, 14, 25836, 0, '', '1', '0'),
	(8541, '10138', 428, 'tokyo_c18_neonsign2', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(8542, '10139', 768, 'tokyo_c18_toy9', 4, 0, 0, 1, 0, 0, 33, -1, 0, '', '1', '0'),
	(8543, '10140', 428, 'tokyo_c18_shopdisplay', 4, 0, 0, 1, 0, 0, 28, 25836, 0, '', '1', '0'),
	(8544, '10141', 428, 'tokyo_c18_pole', 4, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(8545, '10142', 428, 'tokyo_c18_trellis', 4, 0, 0, 1, 0, 0, 44, 25836, 0, '', '1', '0'),
	(8546, '10143', 428, 'tokyo_r18_mapletree', 4, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(8547, '10144', 768, 'tokyo_c18_toy5', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(8548, '10145', 428, 'tokyo_c18_bugsmachine', 10, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(8549, '10146', 428, 'tokyo_c18_drinksmachine', 10, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(8550, '10147', 428, 'tokyo_c18_gamesign', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(8551, '10148', 428, 'tokyo_c18_adposters', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(8552, '10149', 769, 'clothing_sakurajacket', 5, 0, 0, 1, 0, 0, 10, -1, 0, '0', '1', '0'),
	(8553, '10150', 428, 'tokyo_c18_lights', 4, 0, 0, 1, 0, 0, 14, 25836, 0, '', '1', '0'),
	(8554, '10151', 428, 'tokyo_c18_snackroof', 4, 0, 0, 1, 0, 0, 32, 25836, 0, '', '1', '0'),
	(8555, '10152', 768, 'tokyo_c18_toy2', 4, 0, 0, 1, 0, 0, 28, -1, 0, '', '1', '0'),
	(8556, '10153', 769, 'clothing_dragonplushhat', 5, 0, 0, 1, 0, 0, 18, -1, 0, '0', '1', '0'),
	(8557, '10154', 744, 'tokyo_ltd18_shiba', 4, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(8558, '10155', 768, 'tokyo_c18_toy1', 4, 0, 0, 1, 0, 0, 26, -1, 0, '', '1', '0'),
	(8559, '10156', 428, 'tokyo_c18_road', 4, 0, 0, 1, 0, 0, 25, 25836, 0, '', '1', '0'),
	(8560, '10157', 428, 'tokyo_c18_scarydino', 4, 0, 0, 1, 0, 0, 27, -1, 0, '', '1', '0'),
	(8561, '10158', 428, 'tokyo_c18_jpmerchshop', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(8562, '10159', 428, 'tokyo_c18_floor', 2, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(8563, '10160', 428, 'tokyo_c18_lanterns', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(8564, '10161', 428, 'tokyo_c18_magazinerack', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(8565, '10162', 428, 'tokyo_c18_racearcade', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(8566, '10163', 310, 'clothing_cuteglasses', 6, 0, 0, 1, 0, 0, 28, 20486, 0, '0', '1', '0'),
	(8567, '10164', 428, 'tokyo_c18_retroarcade2', 4, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(8568, '10165', 202, 'clothing_shogunhelmet', 5, 0, 0, 1, 0, 0, 8, 20488, 0, '0', '1', '0'),
	(8569, '10166', 428, 'tokyo_c18_snackdisplay', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(8570, '10167', 768, 'tokyo_c18_toy10', 4, 0, 0, 1, 0, 0, 27, -1, 0, '', '1', '0'),
	(8571, '10168', 768, 'tokyo_c18_toy3', 4, 0, 0, 1, 0, 0, 29, -1, 0, '', '1', '0'),
	(8572, '10169', 578, 'clothing_r18_catbag', 5, 0, 0, 1, 0, 0, 9, -1, 0, '0', '1', '0'),
	(8573, '10170', 193, 'tokyo_c18_gacha', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(8574, '10171', 768, 'tokyo_c18_toy8', 4, 0, 0, 1, 0, 0, 42, -1, 0, '', '1', '0'),
	(8575, '10172', 428, 'tokyo_c18_snackdisplay2', 4, 0, 0, 1, 0, 0, 31, -1, 0, '', '1', '0'),
	(8576, '10173', 578, 'clothing_r18_kitsunemask', 5, 0, 0, 1, 0, 0, 10, -1, 0, '0', '1', '0'),
	(8577, '10174', 767, 'tokyo_c18_craftbot', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(8578, '10175', 428, 'tokyo_c18_shopfront', 4, 0, 0, 1, 0, 0, 29, 25836, 0, '', '1', '0'),
	(8579, '10176', 769, 'clothing_harajukubow', 6, 0, 0, 1, 0, 0, 19, -1, 0, '0', '1', '0'),
	(8580, '10177', 428, 'tokyo_c18_sakura', 4, 0, 0, 1, 0, 0, 16, 25836, 0, '', '1', '0'),
	(8581, '10178', 207, 'clothing_tutu', 5, 0, 0, 1, 0, 0, 2, 20501, 0, '0', '1', '0'),
	(8582, '10179', 428, 'tokyo_c18_adposters2', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(8583, '10180', 428, 'tokyo_c18_neonsign1', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(8584, '10181', 428, 'tokyo_c18_bigbillboard', 4, 0, 0, 1, 0, 0, 3, 25836, 0, '', '1', '0'),
	(8585, '10182', 769, 'clothing_botface', 6, 0, 0, 1, 0, 0, 18, -1, 0, '0', '1', '0'),
	(8586, '10183', 428, 'tokyo_r18_koikite', 4, 0, 0, 1, 0, 0, 46, -1, 0, '', '1', '0'),
	(8587, '10184', 428, 'tokyo_c18_snackroof2', 4, 0, 0, 1, 0, 0, 33, -1, 0, '', '1', '0'),
	(8588, '10185', 768, 'tokyo_c18_toy7', 4, 0, 0, 1, 0, 0, 32, -1, 0, '', '1', '0'),
	(8589, '10186', 769, 'clothing_harajukuhair', 6, 0, 0, 1, 0, 0, 20, -1, 0, '0', '1', '0'),
	(8590, '10187', 856, 'anniversary_r18_throne', 5, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(8591, '10188', 821, 'tokyo_c18_gacha2', 3, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(8592, '10189', 434, 'zengarden_c18_glasspond', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(8593, '10190', 434, 'zengarden_c18_light', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(8594, '10191', 434, 'zengarden_c18_roof', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(8595, '10192', 434, 'zengarden_c18_stonebench', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(8596, '10193', 434, 'zengarden_c18_rootplant', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(8597, '10194', 434, 'zengarden_c18_stonetable', 2, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(8598, '10195', 434, 'zengarden_c18_divider', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(8599, '10196', 434, 'zengarden_c18_moss', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(8600, '10197', 434, 'zengarden_c18_peacefrog', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(8601, '10198', 434, 'zengarden_c18_bamboo', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(8602, '10199', 434, 'zengarden_c18_door', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(8603, '10200', 434, 'zengarden_c18_plankfloor', 1, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(8604, '10201', 434, 'zengarden_c18_roofcorner', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(8605, '10202', 434, 'zengarden_c18_spikeyplant', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(8606, '10203', 434, 'zengarden_r18_fountain', 4, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(8607, '10204', 434, 'zengarden_c18_pebbles', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(8608, '10205', 578, 'clothing_r18_longwavy', 5, 0, 0, 1, 0, 0, 11, -1, 0, '0', '1', '0'),
	(8609, '10206', 596, 'rare_colourable_marquee*3', 5, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(8610, '10207', 596, 'rare_colourable_scifirocket*3', 5, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(8611, '10208', 596, 'rare_colourable_fountain*3', 5, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(8612, '10209', 596, 'rare_colourable_wooden_screen*3', 5, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(8613, '10210', 596, 'rare_colourable_dragonlamp*3', 5, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(8614, '10211', 596, 'rare_colourable_parasol*3', 5, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(8615, '10212', 610, 'hhistory_r18_crackable', 7, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(8616, '10213', 596, 'rare_colourable_sleepingbag*3', 5, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(8617, '10214', 596, 'rare_colourable_pillar*3', 5, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(8618, '10215', 596, 'rare_colourable_beehive_bulb*3', 5, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(8619, '10216', 596, 'rare_colourable_icecream*3', 5, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(8620, '10217', 596, 'rare_colourable_elephant_statue*3', 5, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(8621, '10218', 596, 'rare_colourable_scifidoor*3', 5, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(8622, '10219', 596, 'rare_colourable_fan*3', 5, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(8623, '10220', 596, 'rare_colourable_pillow*3', 5, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(8624, '10221', 596, 'rare_colourable_scifiport*3', 5, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(8625, '10222', 596, 'rare_colourable_barrier*3', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(8626, '10223', 367, 'hotel_c18_pool', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(8627, '10224', 367, 'hotel_c18_stairs', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(8628, '10225', 367, 'hotel_c18_roof', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(8629, '10226', 367, 'hotel_c18_rail', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(8630, '10227', 367, 'hotel_c18_fountain', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(8631, '10228', 367, 'hotel_c18_block2', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(8632, '10229', 367, 'hotel_c18_awning', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(8633, '10230', 367, 'hotel_c18_block1', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(8634, '10231', 367, 'hotel_c18_tree', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(8635, '10232', 367, 'hotel_c18_foundation', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(8636, '10233', 367, 'hotel_c18_cypress', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(8637, '10234', 367, 'hotel_c18_rooftop', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(8638, '10235', 399, 'hween_c18_deskitems2', 5, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(8639, '10236', 399, 'hween_c18_ceilingrays', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(8640, '10237', 399, 'hween_c18_complexmchn3', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(8641, '10238', 792, 'clothing_brownglasses', 6, 0, 0, 1, 0, 0, 17, -1, 0, '0', '1', '0'),
	(8642, '10239', 791, 'hween_c18_toy5old', 4, 0, 0, 1, 0, 0, 51, -1, 0, '', '1', '0'),
	(8643, '10240', 399, 'hween_c18_complexmchn2', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(8644, '10241', 792, 'hween_c18_toy5new', 4, 0, 0, 1, 0, 0, 54, -1, 0, '', '1', '0'),
	(8645, '10242', 201, 'clothing_brain', 5, 0, 0, 1, 0, 0, 24, 20641, 0, '0', '1', '0'),
	(8646, '10243', 399, 'hween_c18_olddocs2', 4, 0, 0, 1, 0, 0, 38, -1, 0, '', '1', '0'),
	(8647, '10244', 399, 'hween_c18_ceilingfan', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(8648, '10245', 791, 'hween_c18_toy4old', 4, 0, 0, 1, 0, 0, 50, -1, 0, '', '1', '0'),
	(8649, '10246', 399, 'hween_c18_labglasswall', 4, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(8650, '10247', 399, 'hween_c18_retropc', 4, 0, 0, 1, 0, 0, 42, -1, 0, '', '1', '0'),
	(8651, '10248', 399, 'hween_c18_dimlights', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(8652, '10249', 399, 'hween_c18_medicineshelf', 5, 0, 0, 1, 0, 0, 35, -1, 0, '', '1', '0'),
	(8653, '10250', 399, 'hween_c18_labtilewall', 4, 0, 0, 1, 0, 0, 32, -1, 0, '', '1', '0'),
	(8654, '10251', 399, 'hween_c18_labcage', 4, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(8655, '10252', 744, 'hween_ltd18_cosplaycat', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(8656, '10253', 399, 'hween_c18_oldceilingrays', 4, 0, 0, 1, 0, 0, 36, -1, 0, '', '1', '0'),
	(8657, '10254', 399, 'hween_c18_labcurtains', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(8658, '10255', 792, 'hween_c18_toy3new', 4, 0, 0, 1, 0, 0, 50, -1, 0, '', '1', '0'),
	(8659, '10256', 792, 'hween_c18_toy2new', 4, 0, 0, 1, 0, 0, 48, -1, 0, '', '1', '0'),
	(8660, '10257', 399, 'hween_c18_labsteelfloor', 2, 0, 0, 1, 0, 0, 28, -1, 0, '', '1', '0'),
	(8661, '10258', 399, 'hween_c18_labmchn1', 4, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(8662, '10259', 399, 'hween_c18_rustyceilingfan', 4, 0, 0, 1, 0, 0, 43, -1, 0, '', '1', '0'),
	(8663, '10260', 399, 'hween_c18_labstoolold', 4, 0, 0, 1, 0, 0, 30, -1, 0, '', '1', '0'),
	(8664, '10261', 399, 'hween_c18_labmchn2', 4, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(8665, '10262', 399, 'hween_c18_brokenglasswall', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(8666, '10263', 399, 'hween_c18_floormould', 1, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(8667, '10264', 792, 'clothing_vintagejacket', 5, 0, 0, 1, 0, 0, 9, -1, 0, '0', '1', '0'),
	(8668, '10265', 791, 'hween_c18_washliquid', 4, 0, 0, 1, 0, 0, 52, -1, 0, '', '1', '0'),
	(8669, '10266', 792, 'hween_c18_toy1new', 4, 0, 0, 1, 0, 0, 46, -1, 0, '', '1', '0'),
	(8670, '10267', 792, 'clothing_sideponytail', 6, 0, 0, 1, 0, 0, 19, -1, 0, '0', '1', '0'),
	(8671, '10268', 399, 'hween_c18_zaptele', 4, 0, 0, 1, 0, 0, 54, -1, 0, '', '1', '0'),
	(8672, '10269', 578, 'clothing_r18_axe', 5, 0, 0, 1, 0, 0, 12, -1, 0, '0', '1', '0'),
	(8673, '10270', 790, 'hween_c18_washmchn', 4, 0, 0, 1, 0, 0, 57, -1, 0, '', '1', '0'),
	(8674, '10271', 399, 'hween_c18_labglovebox', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(8675, '10272', 399, 'hween_c18_bloodcurtains', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(8676, '10273', 792, 'clothing_legwarmershoes', 4, 0, 0, 1, 0, 0, 2, -1, 0, '0', '1', '0'),
	(8677, '10274', 792, 'hween_c18_toy4new', 4, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(8678, '10275', 399, 'hween_c18_labshelf', 5, 0, 0, 1, 0, 0, 27, -1, 0, '', '1', '0'),
	(8679, '10276', 791, 'clothing_bloodshoes', 3, 0, 0, 1, 0, 0, 1, 20675, 0, '0', '1', '0'),
	(8680, '10277', 399, 'hween_c18_bloodfloorstreak', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(8681, '10278', 578, 'clothing_r18_vamp', 5, 0, 0, 1, 0, 0, 13, -1, 0, '0', '1', '0'),
	(8682, '10279', 399, 'hween_c18_labdesk', 5, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(8683, '10280', 399, 'hween_c18_oldlabdesk', 5, 0, 0, 1, 0, 0, 39, -1, 0, '', '1', '0'),
	(8684, '10281', 399, 'hween_c18_labchair', 2, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(8685, '10282', 399, 'hween_c18_ceilingmould', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(8686, '10283', 399, 'hween_c18_labjar1', 4, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(8687, '10284', 791, 'hween_c18_washpowder', 4, 0, 0, 1, 0, 0, 53, -1, 0, '', '1', '0'),
	(8688, '10285', 399, 'hween_r18_pupbot', 4, 0, 0, 1, 0, 0, 56, -1, 0, '', '1', '0'),
	(8689, '10286', 399, 'hween_c18_labmchn3', 4, 0, 0, 1, 0, 0, 26, -1, 0, '', '1', '0'),
	(8690, '10287', 791, 'clothing_bloodjacket', 4, 0, 0, 1, 0, 0, 1, 20686, 0, '0', '1', '0'),
	(8691, '10288', 399, 'hween_c18_complexmchn1', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(8692, '10289', 399, 'hween_c18_spareparts', 4, 0, 0, 1, 0, 0, 45, -1, 0, '', '1', '0'),
	(8693, '10290', 205, 'clothing_labcoat', 4, 0, 0, 1, 0, 0, 6, 20689, 0, '0', '1', '0'),
	(8694, '10291', 791, 'hween_c18_toy2old', 4, 0, 0, 1, 0, 0, 48, -1, 0, '', '1', '0'),
	(8695, '10292', 792, 'clothing_shortcurlhair', 6, 0, 0, 1, 0, 0, 18, -1, 0, '0', '1', '0'),
	(8696, '10293', 399, 'hween_c18_labjar2', 4, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(8697, '10294', 399, 'hween_c18_labstool', 4, 0, 0, 1, 0, 0, 29, -1, 0, '', '1', '0'),
	(8698, '10295', 399, 'hween_c18_labtooltable', 2, 0, 0, 1, 0, 0, 33, -1, 0, '', '1', '0'),
	(8699, '10296', 791, 'clothing_bloodponytail', 5, 0, 0, 1, 0, 0, 1, 20695, 0, '0', '1', '0'),
	(8700, '10297', 399, 'hween_r18_antiquechemset', 4, 0, 0, 1, 0, 0, 55, -1, 0, '', '1', '0'),
	(8701, '10298', 791, 'hween_c18_toy1old', 4, 0, 0, 1, 0, 0, 47, -1, 0, '', '1', '0'),
	(8702, '10299', 399, 'hween_c18_oldlabtilewall', 4, 0, 0, 1, 0, 0, 41, -1, 0, '', '1', '0'),
	(8703, '10300', 399, 'hween_c18_deskitems1', 5, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(8704, '10301', 791, 'clothing_bloodglasses', 6, 0, 0, 1, 0, 0, 14, 20700, 0, '0', '1', '0'),
	(8705, '10302', 399, 'hween_c18_staffoftheyr', 4, 0, 0, 1, 0, 0, 46, -1, 0, '', '1', '0'),
	(8706, '10303', 791, 'clothing_bloodscruffyhair', 5, 0, 0, 1, 0, 0, 1, 20702, 0, '0', '1', '0'),
	(8707, '10304', 399, 'hween_c18_olddocs1', 4, 0, 0, 1, 0, 0, 37, -1, 0, '', '1', '0'),
	(8708, '10305', 791, 'hween_c18_toy3old', 4, 0, 0, 1, 0, 0, 49, -1, 0, '', '1', '0'),
	(8709, '10306', 399, 'hween_c18_labtilefloor', 2, 0, 0, 1, 0, 0, 31, -1, 0, '', '1', '0'),
	(8710, '10307', 399, 'hween_c18_oldlablocker', 4, 0, 0, 1, 0, 0, 40, -1, 0, '', '1', '0'),
	(8711, '10308', 399, 'hween_c18_flashlight', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(8712, '10309', 399, 'hween_c18_labbed', 4, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(8713, '10310', 399, 'hween_c18_lablocker', 4, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(8714, '10311', 307, 'CF_350_jadefish', 350, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(8715, '10312', 427, 'hygge_c18_stove', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(8716, '10313', 427, 'hygge_c18_cushion', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(8717, '10314', 578, 'clothing_r18_antlers', 5, 0, 0, 1, 0, 0, 14, -1, 0, '0', '1', '0'),
	(8718, '10315', 427, 'hygge_r18_fox', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(8719, '10316', 578, 'clothing_r18_hyggehair', 5, 0, 0, 1, 0, 0, 15, -1, 0, '0', '1', '0'),
	(8720, '10317', 427, 'hygge_c18_shelf', 5, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(8721, '10318', 427, 'hygge_c18_chair', 2, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(8722, '10319', 578, 'clothing_r18_dungarees', 5, 0, 0, 1, 0, 0, 16, -1, 0, '0', '1', '0'),
	(8723, '10320', 578, 'clothing_r18_diaparty', 5, 0, 0, 1, 0, 0, 17, -1, 0, '0', '1', '0'),
	(8724, '10321', 733, 'clothing_dianoblecrown', 7, 0, 0, 1, 0, 0, 1, -1, 0, '0', '1', '0'),
	(8725, '10322', 169, 'diamond_c18_giftbox', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(8726, '10323', 733, 'clothing_diafish', 7, 0, 0, 1, 0, 0, 3, -1, 0, '0', '1', '0'),
	(8727, '10324', 733, 'clothing_dialeafcrown', 7, 0, 0, 1, 0, 0, 2, -1, 0, '0', '1', '0'),
	(8728, '10325', 488, 'xmas_c18_deer_comet', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(8729, '10326', 488, 'xmas_c18_stocking_snoopy', 4, 0, 0, 1, 0, 0, 50, -1, 0, '', '1', '0'),
	(8730, '10327', 488, 'xmas_c18_souvenir', 4, 0, 0, 1, 0, 0, 35, -1, 0, '', '1', '0'),
	(8731, '10328', 488, 'xmas_c18_deer_dasher', 4, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(8732, '10329', 795, 'clothing_halo', 10, 0, 0, 1, 0, 0, 13, -1, 0, '0', '1', '0'),
	(8733, '10330', 488, 'xmas_c18_snowfootball', 4, 0, 0, 1, 0, 0, 33, -1, 0, '', '1', '0'),
	(8734, '10331', 488, 'xmas_c18_stocking_cinnamon', 4, 0, 0, 1, 0, 0, 46, -1, 0, '', '1', '0'),
	(8735, '10332', 488, 'xmas_c18_stool', 4, 0, 0, 1, 0, 0, 52, -1, 0, '', '1', '0'),
	(8736, '10333', 488, 'xmas_c18_stage', 4, 0, 0, 1, 0, 0, 36, -1, 0, '', '1', '0'),
	(8737, '10334', 488, 'xmas_c18_metro', 4, 0, 0, 1, 0, 0, 26, -1, 0, '', '1', '0'),
	(8738, '10335', 488, 'xmas_c18_stocking_tiger', 4, 0, 0, 1, 0, 0, 51, -1, 0, '', '1', '0'),
	(8739, '10336', 488, 'xmas_c18_snowman', 4, 0, 0, 1, 0, 0, 34, -1, 0, '', '1', '0'),
	(8740, '10337', 488, 'xmas_c18_snowballpit', 4, 0, 0, 1, 0, 0, 32, 25838, 0, '', '1', '0'),
	(8741, '10338', 488, 'xmas_c18_stocking_crusoe', 4, 0, 0, 1, 0, 0, 48, -1, 0, '', '1', '0'),
	(8742, '10339', 488, 'xmas_c18_stallroof', 4, 0, 0, 1, 0, 0, 42, -1, 0, '', '1', '0'),
	(8743, '10340', 488, 'xmas_c18_presentelf', 4, 0, 0, 1, 0, 0, 29, -1, 0, '', '1', '0'),
	(8744, '10341', 794, 'xmas_c18_doll10', 7, 0, 0, 1, 0, 0, 40, -1, 0, '', '1', '0'),
	(8745, '10342', 795, 'clothing_rudolphhat', 5, 0, 0, 1, 0, 0, 1, -1, 0, '0', '1', '0'),
	(8746, '10343', 794, 'xmas_c18_doll8', 7, 0, 0, 1, 0, 0, 47, -1, 0, '', '1', '0'),
	(8747, '10344', 488, 'xmas_c18_deer_vixen', 4, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(8748, '10345', 488, 'xmas_c18_stagecurtains', 4, 0, 0, 1, 0, 0, 39, 24152, 0, '', '1', '0'),
	(8749, '10346', 488, 'xmas_c18_stocking_cleo', 4, 0, 0, 1, 0, 0, 47, -1, 0, '', '1', '0'),
	(8750, '10347', 488, 'xmas_c18_presents', 4, 0, 0, 1, 0, 0, 30, 25838, 0, '', '1', '0'),
	(8751, '10348', 488, 'xmas_r18_snowyowl', 4, 0, 0, 1, 0, 0, 56, -1, 0, '', '1', '0'),
	(8752, '10349', 794, 'xmas_c18_doll6', 7, 0, 0, 1, 0, 0, 45, -1, 0, '', '1', '0'),
	(8753, '10350', 488, 'xmas_c18_stalltable', 2, 0, 0, 1, 0, 0, 43, -1, 0, '', '1', '0'),
	(8754, '10351', 488, 'xmas_c18_streetlight', 4, 0, 0, 1, 0, 0, 53, 25838, 0, '', '1', '0'),
	(8755, '10352', 794, 'xmas_c18_doll5', 7, 0, 0, 1, 0, 0, 44, -1, 0, '', '1', '0'),
	(8756, '10353', 488, 'xmas_r18_lightfountain', 4, 0, 0, 1, 0, 0, 55, -1, 0, '', '1', '0'),
	(8757, '10354', 795, 'clothing_poinsettia', 6, 0, 0, 1, 0, 0, 13, -1, 0, '0', '1', '0'),
	(8758, '10355', 674, 'clothing_bobblehat', 4, 0, 0, 1, 0, 0, 12, 20781, 0, '0', '1', '0'),
	(8759, '10356', 488, 'xmas_c18_groundlight', 4, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(8760, '10357', 488, 'xmas_c18_stagechair', 2, 0, 0, 1, 0, 0, 38, -1, 0, '', '1', '0'),
	(8761, '10358', 578, 'clothing_r18_featherdress', 5, 0, 0, 1, 0, 0, 18, -1, 0, '0', '1', '0'),
	(8762, '10359', 488, 'xmas_c18_stagestairs', 4, 0, 0, 1, 0, 0, 40, -1, 0, '', '1', '0'),
	(8763, '10360', 488, 'xmas_c18_deer_rudolph', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(8764, '10361', 795, 'clothing_penguin', 3, 0, 0, 1, 0, 0, 11, -1, 0, '0', '1', '0'),
	(8765, '10362', 488, 'xmas_c18_xmastree', 4, 0, 0, 1, 0, 0, 54, 25838, 0, '', '1', '0'),
	(8766, '10363', 488, 'xmas_c18_booth', 4, 0, 0, 1, 0, 0, 4, 25838, 0, '', '1', '0'),
	(8767, '10364', 488, 'xmas_c18_curtaintopper', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(8768, '10365', 488, 'xmas_c18_building', 4, 0, 0, 1, 0, 0, 7, 25838, 0, '', '1', '0'),
	(8769, '10366', 744, 'xmas_ltd18_snowhabberge', 4, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(8770, '10367', 488, 'xmas_c18_iciclelight', 4, 0, 0, 1, 0, 0, 25, 25838, 0, '', '1', '0'),
	(8771, '10368', 488, 'xmas_c18_deer_cupid', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(8772, '10369', 488, 'xmas_c18_borscht', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(8773, '10370', 794, 'xmas_c18_doll3', 7, 0, 0, 1, 0, 0, 42, -1, 0, '', '1', '0'),
	(8774, '10371', 794, 'xmas_c18_doll2', 7, 0, 0, 1, 0, 0, 41, -1, 0, '', '1', '0'),
	(8775, '10372', 488, 'xmas_c18_balllight', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(8776, '10373', 488, 'xmas_c18_harp', 4, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(8777, '10374', 578, 'clothing_r18_feathercrown', 5, 0, 0, 1, 0, 0, 19, -1, 0, '0', '1', '0'),
	(8778, '10375', 488, 'xmas_c18_penguin', 4, 0, 0, 1, 0, 0, 27, -1, 0, '', '1', '0'),
	(8779, '10376', 488, 'xmas_c18_deer_prancer', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(8780, '10377', 201, 'clothing_sideflopped', 6, 0, 0, 1, 0, 0, 23, 20803, 0, '0', '1', '0'),
	(8781, '10378', 794, 'xmas_c18_doll1', 7, 0, 0, 1, 0, 0, 39, -1, 0, '', '1', '0'),
	(8782, '10379', 488, 'xmas_c18_rainlightfloor', 1, 0, 0, 1, 0, 0, 31, 25838, 0, '', '1', '0'),
	(8783, '10380', 488, 'xmas_c18_candycane', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(8784, '10381', 488, 'xmas_c18_stocking_norbert', 4, 0, 0, 1, 0, 0, 49, -1, 0, '', '1', '0'),
	(8785, '10382', 795, 'clothing_snowman', 3, 0, 0, 1, 0, 0, 10, -1, 0, '0', '1', '0'),
	(8786, '10383', 488, 'xmas_c18_buildingpillar', 4, 0, 0, 1, 0, 0, 8, 25838, 0, '', '1', '0'),
	(8787, '10384', 794, 'xmas_c18_doll7', 7, 0, 0, 1, 0, 0, 46, -1, 0, '', '1', '0'),
	(8788, '10385', 488, 'xmas_c18_bounceycastle', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(8789, '10386', 488, 'xmas_c18_babushka', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(8790, '10387', 794, 'xmas_c18_doll9', 7, 0, 0, 1, 0, 0, 48, -1, 0, '', '1', '0'),
	(8791, '10388', 488, 'xmas_c18_stagewindow', 4, 0, 0, 1, 0, 0, 41, 25838, 0, '', '1', '0'),
	(8792, '10389', 795, 'clothing_xmas5', 5, 0, 0, 1, 0, 0, 10, -1, 0, '0', '1', '0'),
	(8793, '10390', 310, 'clothing_mittens', 6, 0, 0, 1, 0, 0, 27, 20816, 0, '0', '1', '0'),
	(8794, '10391', 488, 'xmas_c18_fairylightree', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(8795, '10392', 488, 'xmas_c18_deer_blitzen', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(8796, '10393', 488, 'xmas_c18_stocking_boo', 4, 0, 0, 1, 0, 0, 45, -1, 0, '', '1', '0'),
	(8797, '10394', 793, 'xmas_c18_nutcracker', 4, 0, 0, 1, 0, 0, 37, -1, 0, '', '1', '0'),
	(8798, '10395', 488, 'xmas_c18_stagebackdrop', 4, 0, 0, 1, 0, 0, 37, -1, 0, '', '1', '0'),
	(8799, '10396', 488, 'xmas_c18_bearlight', 4, 0, 0, 1, 0, 0, 3, 25838, 0, '', '1', '0'),
	(8800, '10397', 488, 'xmas_c18_deer_dancer', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(8801, '10398', 794, 'xmas_c18_doll4', 7, 0, 0, 1, 0, 0, 43, -1, 0, '', '1', '0'),
	(8802, '10399', 488, 'xmas_c18_food', 4, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(8803, '10400', 488, 'xmas_c18_fatherfrost', 4, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(8804, '10401', 205, 'clothing_regiment', 5, 0, 0, 1, 0, 0, 5, 20827, 0, '0', '1', '0'),
	(8805, '10402', 488, 'xmas_c18_piano', 4, 0, 0, 1, 0, 0, 28, -1, 0, '', '1', '0'),
	(8806, '10403', 795, 'clothing_treepartyhat', 3, 0, 0, 1, 0, 0, 10, -1, 0, '0', '1', '0'),
	(8807, '10404', 488, 'xmas_c18_deer_donna', 4, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(8808, '10405', 592, 'rare_prize18_xmas', 5, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(8809, '10406', 444, 'hosp_c19_drinksvend', 10, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(8810, '10407', 585, 'clothing_r18_goldpack4', 5, 0, 0, 1, 0, 0, 4, -1, 0, '0', '1', '0'),
	(8811, '10408', 116, 'attic_c19_hammock', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(8812, '10409', 584, 'clothing_r18_sparkleparty2', 5, 0, 0, 1, 0, 0, 2, -1, 0, '0', '1', '0'),
	(8813, '10410', 584, 'clothing_r18_sparkleparty1', 5, 0, 0, 1, 0, 0, 1, -1, 0, '0', '1', '0'),
	(8814, '10411', 584, 'clothing_r18_sparkleparty7', 5, 0, 0, 1, 0, 0, 7, -1, 0, '0', '1', '0'),
	(8815, '10412', 584, 'clothing_r18_sparkleparty4', 5, 0, 0, 1, 0, 0, 4, -1, 0, '0', '1', '0'),
	(8816, '10413', 579, 'clothing_r19_longwavy2', 5, 0, 0, 1, 0, 0, 1, -1, 0, '0', '1', '0'),
	(8817, '10414', 668, 'ny_r18_crackable', 7, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(8818, '10415', 584, 'clothing_r18_sparkleparty8', 5, 0, 0, 1, 0, 0, 8, -1, 0, '0', '1', '0'),
	(8819, '10416', 584, 'clothing_r18_sparkleparty6', 5, 0, 0, 1, 0, 0, 6, -1, 0, '0', '1', '0'),
	(8820, '10417', 584, 'clothing_r18_sparkleparty3', 5, 0, 0, 1, 0, 0, 3, -1, 0, '0', '1', '0'),
	(8821, '10418', 584, 'clothing_r18_sparkleparty5', 5, 0, 0, 1, 0, 0, 5, -1, 0, '0', '1', '0'),
	(8822, '10419', 821, 'diamond_c18_giftbox2', 3, 0, 0, 1, 0, 0, 337, -1, 0, '', '1', '0'),
	(8823, '10420', 307, 'CF_1000_goldenkey', 1000, 0, 0, 1, 0, 0, 31, -1, 0, '', '1', '0'),
	(8824, '10421', 394, 'hween13_c19_frog', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(8825, '10422', 358, 'hc19_11', 5, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '1'),
	(8826, '10423', 358, 'hc19_1', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '1'),
	(8827, '10424', 358, 'hc19_4', 5, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '1'),
	(8828, '10425', 358, 'hc19_5', 5, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '1'),
	(8829, '10426', 358, 'hc19_9', 5, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '1'),
	(8830, '10427', 358, 'hc19_3', 5, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '1'),
	(8831, '10428', 358, 'hc19_2', 5, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '1'),
	(8832, '10429', 358, 'hc19_10', 5, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '1'),
	(8833, '10430', 358, 'hc19_12', 5, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '1'),
	(8834, '10431', 358, 'hc19_7', 5, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '1'),
	(8835, '10432', 358, 'hc19_6', 5, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '1'),
	(8836, '10433', 358, 'hc19_8', 5, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '1'),
	(8837, '10434', 448, 'val_c19_food', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(8838, '10435', 448, 'val_c19_bottlewall', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(8839, '10436', 579, 'clothing_r19_messybun', 5, 0, 0, 1, 0, 0, 2, -1, 0, '0', '1', '0'),
	(8840, '10437', 448, 'val_r19_bath', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(8841, '10438', 448, 'val_r19_recordplayer', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(8842, '10439', 579, 'clothing_r19_frilledskirt', 5, 0, 0, 1, 0, 0, 3, -1, 0, '0', '1', '0'),
	(8843, '10440', 448, 'val_c19_bottle', 4, 0, 0, 1, 0, 0, 2, 24152, 0, '', '1', '0'),
	(8844, '10441', 448, 'val_r19_puppy', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(8845, '10442', 448, 'val_c19_till', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(8846, '10443', 448, 'val_r19_unicorn', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(8847, '10444', 579, 'clothing_r19_shortcurly', 4, 0, 0, 1, 0, 0, 4, -1, 0, '0', '1', '0'),
	(8848, '10445', 579, 'clothing_r19_waistcoat', 4, 0, 0, 1, 0, 0, 5, -1, 0, '0', '1', '0'),
	(8849, '10446', 448, 'val_c19_tableacc', 2, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(8850, '10447', 448, 'val_c19_chair', 2, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(8851, '10448', 448, 'val_c19_petals', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(8852, '10449', 448, 'val_c19_awning', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(8853, '10450', 448, 'val_c19_table', 2, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(8854, '10451', 448, 'val_r19_sofa', 3, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(8855, '10452', 302, 'china_pig', 4, 0, 0, 1, 0, 0, 27, -1, 0, '', '1', '0'),
	(8856, '10453', 302, 'china_goldenpig', 4, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(8857, '10454', 202, 'clothing_piglethat', 3, 0, 0, 1, 0, 0, 7, 20944, 0, '0', '1', '0'),
	(8858, '10455', 591, 'rare_prize19*0', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(8859, '10456', 591, 'rare_prize19*1', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(8860, '10457', 591, 'rare_prize19*10', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(8861, '10458', 591, 'rare_prize19*11', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(8862, '10459', 591, 'rare_prize19*12', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(8863, '10460', 591, 'rare_prize19*13', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(8864, '10461', 591, 'rare_prize19*2', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(8865, '10462', 591, 'rare_prize19*3', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(8866, '10463', 591, 'rare_prize19*4', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(8867, '10464', 591, 'rare_prize19*5', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(8868, '10465', 591, 'rare_prize19*6', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(8869, '10466', 591, 'rare_prize19*7', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(8870, '10467', 591, 'rare_prize19*8', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(8871, '10468', 591, 'rare_prize19*9', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(8872, '10469', 215, 'room_invisible_block', 3, 0, 0, 1, 0, 0, 9, 20964, 0, '', '1', '1'),
	(8873, '10470', 857, 'rare_colourable_scifirocket*4', 5, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(8874, '10471', 857, 'rare_colourable_parasol*4', 5, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(8875, '10472', 425, 'rare_r19_car1', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(8876, '10473', 204, 'clothing_topbuttonshirt', 5, 0, 0, 1, 0, 0, 8, 20999, 0, '0', '1', '0'),
	(8877, '10474', 206, 'clothing_rippedjeans2', 5, 0, 0, 1, 0, 0, 2, 21000, 0, '0', '1', '0'),
	(8878, '10475', 579, 'clothing_r19_scuffedboots', 4, 0, 0, 1, 0, 0, 6, -1, 0, '0', '1', '0'),
	(8879, '10476', 579, 'clothing_r19_longtwotone', 4, 0, 0, 1, 0, 0, 7, -1, 0, '0', '1', '0'),
	(8880, '10477', 425, 'band_c19_drums', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(8881, '10478', 579, 'clothing_r19_punkhat', 4, 0, 0, 1, 0, 0, 8, -1, 0, '0', '1', '0'),
	(8882, '10479', 425, 'band_c19_guitar', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(8883, '10480', 579, 'clothing_r19_messybangs', 4, 0, 0, 1, 0, 0, 9, -1, 0, '0', '1', '0'),
	(8884, '10481', 201, 'clothing_messycurls', 5, 0, 0, 1, 0, 0, 22, 21007, 0, '0', '1', '0'),
	(8885, '10482', 425, 'band_c19_synth', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(8886, '10483', 201, 'clothing_highfade', 5, 0, 0, 1, 0, 0, 21, 21009, 0, '0', '1', '0'),
	(8887, '10484', 841, 'easter_c19_kelpie', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(8888, '10485', 579, 'clothing_r19_forrestcrown', 4, 0, 0, 1, 0, 0, 10, -1, 0, '0', '1', '0'),
	(8889, '10486', 745, 'easter_ltd19_flowerthrone', 4, 0, 0, 1, 0, 0, 44, -1, 0, '', '1', '0'),
	(8890, '10487', 841, 'easter_c19_babyent', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(8891, '10488', 841, 'easter_c19_habshirecat', 4, 0, 0, 1, 0, 0, 28, -1, 0, '', '1', '0'),
	(8892, '10489', 385, 'easter_r19_treeswing', 4, 0, 0, 1, 0, 0, 46, -1, 0, '', '1', '1'),
	(8893, '10490', 191, 'easter_c19_book4a', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(8894, '10491', 385, 'easter_c19_turnipbuddies', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '1'),
	(8895, '10492', 385, 'easter_c19_wisestone', 4, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '1'),
	(8896, '10493', 191, 'easter_c19_ancientbook2', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(8897, '10494', 841, 'clothing_ribboncurls', 4, 0, 0, 1, 0, 0, 11, -1, 0, '0', '1', '0'),
	(8898, '10495', 841, 'easter_c19_earthdrago', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(8899, '10496', 385, 'easter_c19_logtable', 4, 0, 0, 1, 0, 0, 34, -1, 0, '', '1', '1'),
	(8900, '10497', 840, 'easter_c19_book1', 3, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(8901, '10498', 840, 'easter_c19_book3', 3, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(8902, '10499', 202, 'clothing_archerhat', 4, 0, 0, 1, 0, 0, 6, 21025, 0, '0', '1', '0'),
	(8903, '10500', 385, 'easter_c19_littlefairies', 4, 0, 0, 1, 0, 0, 32, -1, 0, '', '1', '1'),
	(8904, '10501', 840, 'easter_c19_book2', 3, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(8905, '10502', 385, 'easter_c19_logchair', 2, 0, 0, 1, 0, 0, 33, -1, 0, '', '1', '1'),
	(8906, '10503', 191, 'easter_c19_book3a', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(8907, '10504', 841, 'clothing_madhat', 4, 0, 0, 1, 0, 0, 7, -1, 0, '0', '1', '0'),
	(8908, '10505', 840, 'easter_c19_book4', 3, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(8909, '10506', 191, 'easter_c19_book2a', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(8910, '10507', 385, 'easter_c19_meadow', 4, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '1'),
	(8911, '10508', 385, 'easter_c19_dirtpath', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '1'),
	(8912, '10509', 385, 'easter_c19_flowertea', 4, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '1'),
	(8913, '10510', 841, 'easter_c19_babyhippogriff', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(8914, '10511', 385, 'easter_c19_mushrooms', 4, 0, 0, 1, 0, 0, 37, -1, 0, '', '1', '1'),
	(8915, '10512', 840, 'easter_c19_forrestegg', 4, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(8916, '10513', 841, 'easter_c19_chillgnome', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(8917, '10514', 191, 'easter_c19_babykelpie2', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(8918, '10515', 191, 'easter_c19_babyhippogriff2', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(8919, '10516', 841, 'easter_c19_ent', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(8920, '10517', 841, 'easter_c19_wolf', 4, 0, 0, 1, 0, 0, 42, -1, 0, '', '1', '0'),
	(8921, '10518', 840, 'easter_c19_ancientbook', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(8922, '10519', 385, 'easter_r19_mysticalbird', 4, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '1'),
	(8923, '10520', 202, 'clothing_mushroomhat', 4, 0, 0, 1, 0, 0, 5, 21046, 0, '0', '1', '0'),
	(8924, '10521', 203, 'clothing_petaldress', 6, 0, 0, 1, 0, 0, 4, 21047, 0, '0', '1', '0'),
	(8925, '10522', 841, 'clothing_wolfmask', 4, 0, 0, 1, 0, 0, 12, -1, 0, '0', '1', '0'),
	(8926, '10523', 841, 'clothing_flowerponytail', 4, 0, 0, 1, 0, 0, 10, -1, 0, '0', '1', '0'),
	(8927, '10524', 841, 'easter_c19_busybunny', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(8928, '10525', 385, 'easter_c19_forrestfood', 4, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '1'),
	(8929, '10526', 385, 'easter_c19_springtree', 4, 0, 0, 1, 0, 0, 38, -1, 0, '', '1', '1'),
	(8930, '10527', 191, 'easter_c19_book1a', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(8931, '10528', 841, 'easter_c19_waterdrago', 4, 0, 0, 1, 0, 0, 40, -1, 0, '', '1', '0'),
	(8932, '10529', 841, 'easter_c19_babykelpie', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(8933, '10530', 841, 'easter_c19_habelina', 4, 0, 0, 1, 0, 0, 27, -1, 0, '', '1', '0'),
	(8934, '10531', 191, 'easter_c19_babyent2', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(8935, '10532', 841, 'easter_c19_woodlandcritters', 4, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(8936, '10533', 579, 'clothing_r19_fox', 4, 0, 0, 1, 0, 0, 11, -1, 0, '0', '1', '0'),
	(8937, '10534', 191, 'easter_c19_forrestegg2', 4, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(8938, '10535', 841, 'easter_c19_lilredbonnie', 4, 0, 0, 1, 0, 0, 31, -1, 0, '', '1', '0'),
	(8939, '10536', 385, 'easter_c19_magicringtele', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '1'),
	(8940, '10537', 841, 'easter_c19_hippogriff', 4, 0, 0, 1, 0, 0, 29, -1, 0, '', '1', '0'),
	(8941, '10538', 841, 'easter_c19_fairyprince', 4, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(8942, '10539', 201, 'clothing_leafhair', 6, 0, 0, 1, 0, 0, 20, 21065, 0, '0', '1', '0'),
	(8943, '10540', 385, 'easter_c19_forrestfloor', 2, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '1'),
	(8944, '10541', 841, 'easter_c19_bearowl', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(8945, '10542', 385, 'easter_c19_flowerlamp', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '1'),
	(8946, '10543', 664, 'bonusbag19_1', 7, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(8947, '10544', 661, 'bonusrare19_1*0', 4, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(8948, '10545', 661, 'bonusrare19_1*1', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(8949, '10546', 661, 'bonusrare19_1*2', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(8950, '10547', 661, 'bonusrare19_1*3', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(8951, '10548', 661, 'bonusrare19_1*4', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(8952, '10549', 661, 'bonusrare19_1*5', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(8953, '10550', 579, 'clothing_r19_comedymask', 4, 0, 0, 1, 0, 0, 12, -1, 0, '0', '1', '0'),
	(8954, '10551', 734, 'greek_c19_scrolls1', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(8955, '10552', 216, 'greek_c19_table', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(8956, '10553', 216, 'greek_c19_vase2', 4, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(8957, '10554', 216, 'greek_c19_scrolls2', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(8958, '10555', 734, 'greek_c19_harp2', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(8959, '10556', 579, 'clothing_r19_tragedymask', 4, 0, 0, 1, 0, 0, 13, -1, 0, '0', '1', '0'),
	(8960, '10557', 734, 'greek_c19_fruitbowl', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(8961, '10558', 734, 'greek_c19_harp', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(8962, '10559', 734, 'greek_c19_pythagorascup', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(8963, '10560', 579, 'clothing_r19_minotaurhorns', 4, 0, 0, 1, 0, 0, 14, -1, 0, '0', '1', '0'),
	(8964, '10561', 216, 'greek_r19_tiledbath', 4, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(8965, '10562', 216, 'greek_c19_shield2', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(8966, '10563', 734, 'greek_c19_vase1', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(8967, '10564', 216, 'greek_c19_chair', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(8968, '10565', 579, 'clothing_r19_medusa', 4, 0, 0, 1, 0, 0, 15, -1, 0, '0', '1', '0'),
	(8969, '10566', 216, 'greek_r19_chariot', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(8970, '10567', 216, 'greek_c19_statue', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(8971, '10568', 734, 'greek_c19_shield1', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(8972, '10569', 216, 'greek_ltd19_harp', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(8973, '10570', 216, 'greek_r19_luxbed', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(8974, '10571', 216, 'greek_c19_wall', 4, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(8975, '10572', 213, 'booster_c19_box1', 7, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(8976, '10573', 213, 'booster_c19_box2', 7, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(8977, '10574', 525, 'fest_c19_parasol1', 4, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(8978, '10575', 798, 'fest_c19_stool3', 4, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(8979, '10576', 525, 'fest_c19_loverstent', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(8980, '10577', 525, 'fest_c19_bobbatea', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(8981, '10578', 525, 'fest_ltd19_alpaca', 4, 0, 0, 1, 0, 0, 31, -1, 0, '', '1', '0'),
	(8982, '10579', 525, 'fest_c19_ticketstall', 4, 0, 0, 1, 0, 0, 30, -1, 0, '', '1', '0'),
	(8983, '10580', 798, 'fest_c19_parasol3', 4, 0, 0, 1, 0, 0, 33, -1, 0, '', '1', '0'),
	(8984, '10581', 798, 'clothing_bohogems', 6, 0, 0, 1, 0, 0, 11, -1, 0, '0', '1', '0'),
	(8985, '10582', 797, 'fest_c19_materials', 4, 0, 0, 1, 0, 0, 29, -1, 0, '', '1', '0'),
	(8986, '10583', 798, 'clothing_bohoheadgems', 6, 0, 0, 1, 0, 0, 10, -1, 0, '0', '1', '0'),
	(8987, '10584', 204, 'clothing_plungebikini', 5, 0, 0, 1, 0, 0, 7, 21165, 0, '0', '1', '0'),
	(8988, '10585', 525, 'fest_c19_falafelstall', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(8989, '10586', 525, 'fest_c19_pole', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(8990, '10587', 525, 'fest_c19_skull3', 4, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(8991, '10588', 201, 'clothing_flowerbeard', 2, 0, 0, 1, 0, 0, 16, 21169, 0, '0', '1', '0'),
	(8992, '10589', 525, 'fest_c19_coalicecream', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(8993, '10590', 201, 'clothing_dreadlockstied', 5, 0, 0, 1, 0, 0, 15, 21171, 0, '0', '1', '0'),
	(8994, '10591', 798, 'fest_c19_cushion3', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(8995, '10592', 525, 'fest_c19_hangingdecor', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(8996, '10593', 579, 'clothing_r19_rainbowhair', 4, 0, 0, 1, 0, 0, 16, -1, 0, '0', '1', '0'),
	(8997, '10594', 798, 'clothing_bohotunic', 5, 0, 0, 1, 0, 0, 7, -1, 0, '0', '1', '0'),
	(8998, '10595', 525, 'fest_c19_backdrop1', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(8999, '10596', 797, 'fest_c19_dye1', 4, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(9000, '10597', 797, 'fest_c19_dye2', 4, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(9001, '10598', 798, 'fest_c19_cushion2', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(9002, '10599', 310, 'clothing_waistbag', 6, 0, 0, 1, 0, 0, 26, 21180, 0, '0', '1', '0'),
	(9003, '10600', 703, 'fest_c19_bprint1', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(9004, '10601', 525, 'fest_c19_dreamcatcher', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(9005, '10602', 525, 'fest_c19_bongos', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(9006, '10603', 525, 'fest_r19_gemowl', 4, 0, 0, 1, 0, 0, 32, -1, 0, '', '1', '0'),
	(9007, '10604', 201, 'clothing_grandetail', 5, 0, 0, 1, 0, 0, 14, 21185, 0, '0', '1', '0'),
	(9008, '10605', 525, 'fest_c19_dj', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(9009, '10606', 703, 'fest_c19_bprint4', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(9010, '10607', 525, 'fest_c19_skull5', 4, 0, 0, 1, 0, 0, 26, -1, 0, '', '1', '0'),
	(9011, '10608', 525, 'fest_c19_skull4', 4, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(9012, '10609', 798, 'fest_c19_parasol2', 4, 0, 0, 1, 0, 0, 32, -1, 0, '', '1', '0'),
	(9013, '10610', 525, 'fest_c19_skull2', 4, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(9014, '10611', 798, 'clothing_bohobackpack', 6, 0, 0, 1, 0, 0, 9, -1, 0, '0', '1', '0'),
	(9015, '10612', 525, 'fest_c19_brazier', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(9016, '10613', 204, 'clothing_flowingshirt', 5, 0, 0, 1, 0, 0, 6, 21194, 0, '0', '1', '0'),
	(9017, '10614', 703, 'fest_c19_bprint3', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(9018, '10615', 579, 'clothing_r19_rainbowshades', 4, 0, 0, 1, 0, 0, 17, -1, 0, '0', '1', '0'),
	(9019, '10616', 525, 'fest_c19_lamp', 4, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(9020, '10617', 525, 'fest_c19_palm', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(9021, '10618', 798, 'clothing_bohovest', 5, 0, 0, 1, 0, 0, 5, -1, 0, '0', '1', '0'),
	(9022, '10619', 798, 'clothing_bohotiara', 6, 0, 0, 1, 0, 0, 8, -1, 0, '0', '1', '0'),
	(9023, '10620', 525, 'fest_r19_ladygaia', 4, 0, 0, 1, 0, 0, 33, -1, 0, '', '1', '0'),
	(9024, '10621', 525, 'fest_c19_stool1', 4, 0, 0, 1, 0, 0, 29, -1, 0, '', '1', '0'),
	(9025, '10622', 525, 'fest_c19_hipdog', 4, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(9026, '10623', 798, 'fest_c19_backdrop2', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(9027, '10624', 525, 'fest_c19_amp', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(9028, '10625', 525, 'fest_c19_didgeridoo', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(9029, '10626', 183, 'fest_c19_bprintcrackable', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(9030, '10627', 525, 'fest_c19_skull1', 4, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(9031, '10628', 798, 'clothing_ruggedbackpack', 6, 0, 0, 1, 0, 0, 7, -1, 0, '0', '1', '0'),
	(9032, '10629', 798, 'clothing_bohopaint', 6, 0, 0, 1, 0, 0, 6, -1, 0, '0', '1', '0'),
	(9033, '10630', 310, 'clothing_bohobag', 6, 0, 0, 1, 0, 0, 25, 21211, 0, '0', '1', '0'),
	(9034, '10631', 798, 'fest_c19_backdrop3', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(9035, '10632', 525, 'fest_c19_skull6', 4, 0, 0, 1, 0, 0, 27, -1, 0, '', '1', '0'),
	(9036, '10633', 525, 'fest_c19_sitar', 4, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(9037, '10634', 796, 'fest_c19_craft', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(9038, '10635', 798, 'fest_c19_stool2', 4, 0, 0, 1, 0, 0, 44, -1, 0, '', '1', '0'),
	(9039, '10636', 703, 'fest_c19_bprint2', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(9040, '10637', 525, 'fest_c19_stage', 4, 0, 0, 1, 0, 0, 28, -1, 0, '', '1', '0'),
	(9041, '10638', 525, 'fest_c19_cushion1', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(9042, '10639', 525, 'fest_c19_flags', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(9043, '10640', 418, 'pastel_c19_plushie3', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(9044, '10641', 418, 'pastel_c19_stool', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(9045, '10642', 418, 'pastel_c19_cupcake', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(9046, '10643', 418, 'pastel_c19_bedsidetable', 2, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(9047, '10644', 418, 'pastel_c19_stardeco', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(9048, '10645', 579, 'clothing_r19_rainbowstarjumper', 4, 0, 0, 1, 0, 0, 18, -1, 0, '0', '1', '0'),
	(9049, '10646', 418, 'pastel_c19_sofa', 3, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(9050, '10647', 418, 'pastel_c19_cupboard', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(9051, '10648', 418, 'pastel_c19_unicornposter', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(9052, '10649', 418, 'pastel_c19_lamp', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(9053, '10650', 418, 'pastel_c19_shootingstar', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(9054, '10651', 418, 'pastel_c19_carpet', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(9055, '10652', 418, 'pastel_c19_lights', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(9056, '10653', 418, 'pastel_c19_table', 2, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(9057, '10654', 418, 'pastel_c19_plushie1', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(9058, '10655', 418, 'pastel_c19_starlights', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(9059, '10656', 418, 'pastel_c19_wall', 4, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(9060, '10657', 418, 'pastel_c19_cubeseat', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(9061, '10658', 418, 'pastel_c19_plushiepile', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(9062, '10659', 418, 'pastel_c19_floor', 2, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(9063, '10660', 418, 'pastel_c19_plushie2', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(9064, '10661', 418, 'pastel_c19_bed', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(9065, '10662', 307, 'CF_350_sceptre', 350, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(9066, '10663', 491, 'diamond_painting39', 4, 0, 0, 1, 0, 0, 39, -1, 0, '', '1', '0'),
	(9067, '10664', 821, 'fest_c19_bprintcrackableb', 3, 0, 0, 1, 0, 0, 339, -1, 0, '', '1', '0'),
	(9068, '10665', 664, 'bonusbag19_2', 7, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(9069, '10666', 661, 'bonusrare19_2*0', 4, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(9070, '10667', 661, 'bonusrare19_2*1', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(9071, '10668', 661, 'bonusrare19_2*2', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(9072, '10669', 661, 'bonusrare19_2*3', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(9073, '10670', 661, 'bonusrare19_2*4', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(9074, '10671', 661, 'bonusrare19_2*5', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(9075, '10672', 430, 'rainbow_r19_pineapplefloat', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(9076, '10673', 430, 'rainbow_c19_table', 2, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(9077, '10674', 745, 'rainbow_ltd19_parasol', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(9078, '10675', 430, 'rainbow_c19_rug', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(9079, '10676', 430, 'rainbow_c19_chair', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(9080, '10677', 430, 'rainbow_c19_lights', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(9081, '10678', 430, 'rainbow_c19_bed', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(9082, '10679', 430, 'rainbow_r19_peacockfloat', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(9083, '10680', 430, 'rainbow_r19_rainbowfloat', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(9084, '10681', 430, 'rainbow_r19_flamingofloat', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(9085, '10682', 433, 'celestial_c19_wardrobe', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(9086, '10683', 433, 'celestial_c19_starshower', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(9087, '10684', 433, 'celestial_c19_dresser', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(9088, '10685', 433, 'celestial_c19_moonbed', 3, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(9089, '10686', 433, 'celestial_c19_spacebun', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(9090, '10687', 433, 'celestial_c19_rug', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(9091, '10688', 433, 'celestial_c19_planet', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(9092, '10689', 433, 'celestial_c19_tree', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(9093, '10690', 433, 'celestial_c19_aurora', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(9094, '10691', 433, 'celestial_c19_flower', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(9095, '10692', 433, 'celestial_c19_table', 2, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(9096, '10693', 433, 'celestial_c19_starchair', 2, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(9097, '10694', 433, 'celestial_c19_floor', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(9098, '10695', 579, 'clothing_r19_celestialdress', 4, 0, 0, 1, 0, 0, 19, -1, 0, '0', '1', '0'),
	(9099, '10696', 204, 'clothing_zebratop', 5, 0, 0, 1, 0, 0, 5, 21346, 0, '0', '1', '0'),
	(9100, '10697', 636, 'clothing_nt_zebratop', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(9101, '10698', 204, 'clothing_croppedjumper', 5, 0, 0, 1, 0, 0, 4, 21348, 0, '0', '1', '0'),
	(9102, '10699', 207, 'clothing_layeredlongskirt', 5, 0, 0, 1, 0, 0, 1, 21349, 0, '0', '1', '0'),
	(9103, '10700', 430, 'rainbow_c19_flags', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(9104, '10701', 201, 'clothing_longmohawk', 5, 0, 0, 1, 0, 0, 13, 21351, 0, '0', '1', '0'),
	(9105, '10702', 435, 'suncity_c19_botshop', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(9106, '10703', 435, 'suncity_c19_jellyfood', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(9107, '10704', 435, 'suncity_c19_building', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(9108, '10705', 435, 'suncity_c19_chair', 2, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(9109, '10706', 435, 'suncity_c19_waterway', 4, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(9110, '10707', 435, 'suncity_c19_divider', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(9111, '10708', 201, 'clothing_shortcut', 6, 0, 0, 1, 0, 0, 12, 21366, 0, '0', '1', '0'),
	(9112, '10709', 205, 'clothing_loosekimono', 5, 0, 0, 1, 0, 0, 4, 21367, 0, '0', '1', '0'),
	(9113, '10710', 435, 'suncity_c19_flora', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(9114, '10711', 800, 'suncity_c19_glass', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(9115, '10712', 435, 'suncity_c19_plantpillar', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(9116, '10713', 435, 'suncity_c19_awning', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(9117, '10714', 203, 'clothing_gardenapron', 5, 0, 0, 1, 0, 0, 3, 21372, 0, '0', '1', '0'),
	(9118, '10715', 745, 'suncity_ltd19_duckpond', 4, 0, 0, 1, 0, 0, 31, -1, 0, '', '1', '0'),
	(9119, '10716', 801, 'suncity_c19_clock', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(9120, '10717', 801, 'suncity_c19_lamp', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(9121, '10718', 636, 'clothing_nt_flowytop', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(9122, '10719', 801, 'clothing_butterflymask', 6, 0, 0, 1, 0, 0, 4, -1, 0, '0', '1', '0'),
	(9123, '10720', 800, 'suncity_c19_plastic', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(9124, '10721', 435, 'suncity_c19_munchling', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(9125, '10722', 435, 'suncity_c19_balcony', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(9126, '10723', 435, 'suncity_c19_solarpanel', 4, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(9127, '10724', 579, 'clothing_r19_butterflydress', 4, 0, 0, 1, 0, 0, 20, -1, 0, '0', '1', '0'),
	(9128, '10725', 435, 'suncity_r19_biosphere', 4, 0, 0, 1, 0, 0, 26, -1, 0, '', '1', '0'),
	(9129, '10726', 435, 'suncity_c19_floor', 2, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(9130, '10727', 801, 'clothing_leafmask', 6, 0, 0, 1, 0, 0, 3, -1, 0, '0', '1', '0'),
	(9131, '10728', 801, 'clothing_gogglehat', 6, 0, 0, 1, 0, 0, 5, -1, 0, '0', '1', '0'),
	(9132, '10729', 800, 'suncity_c19_paper', 4, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(9133, '10730', 435, 'suncity_c19_tree', 4, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(9134, '10731', 204, 'clothing_flowytop', 5, 0, 0, 1, 0, 0, 3, 21389, 0, '0', '1', '0'),
	(9135, '10732', 799, 'suncity_c19_trashboy', 4, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(9136, '10733', 801, 'suncity_c19_biokit', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(9137, '10734', 310, 'clothing_leafearrings', 6, 0, 0, 1, 0, 0, 24, 21392, 0, '0', '1', '0'),
	(9138, '10735', 435, 'suncity_c19_glasswall', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(9139, '10736', 435, 'suncity_c19_gazebo', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(9140, '10737', 579, 'clothing_r19_featheredcowl', 5, 0, 0, 1, 0, 0, 21, -1, 0, '0', '1', '0'),
	(9141, '10738', 435, 'suncity_c19_wateroutlet', 4, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(9142, '10739', 801, 'clothing_floralbag', 6, 0, 0, 1, 0, 0, 1, -1, 0, '0', '1', '0'),
	(9143, '10740', 435, 'suncity_c19_streetlight', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(9144, '10741', 435, 'suncity_r19_glassfountain', 4, 0, 0, 1, 0, 0, 27, -1, 0, '', '1', '0'),
	(9145, '10742', 435, 'suncity_c19_minibridge', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(9146, '10743', 435, 'suncity_c19_waterwaycrnr', 4, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(9147, '10744', 435, 'suncity_c19_table', 2, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(9148, '10745', 202, 'clothing_sprout', 4, 0, 0, 1, 0, 0, 4, 21403, 0, '0', '1', '0'),
	(9149, '10746', 435, 'suncity_c19_perfumeshop', 4, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(9150, '10747', 801, 'suncity_c19_vase', 4, 0, 0, 1, 0, 0, 27, -1, 0, '', '1', '0'),
	(9151, '10748', 636, 'clothing_nt_loosekimono', 5, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(9152, '10749', 636, 'clothing_nt_shortcut', 5, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(9153, '10750', 636, 'clothing_nt_sprout', 5, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(9154, '10751', 636, 'clothing_nt_leafearrings', 5, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(9155, '10752', 636, 'clothing_nt_gardenapron', 5, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(9156, '10753', 518, 'rainyday_c19_lamp', 4, 0, 0, 1, 0, 0, 6, 21456, 0, '', '1', '0'),
	(9157, '10754', 518, 'rainyday_c19_beanbag', 4, 0, 0, 1, 0, 0, 3, 21457, 0, '', '1', '0'),
	(9158, '10755', 518, 'rainyday_c19_pillowfort', 4, 0, 0, 1, 0, 0, 7, 21458, 0, '', '1', '0'),
	(9159, '10756', 518, 'rainyday_c19_rainwindows', 4, 0, 0, 1, 0, 0, 8, 21459, 0, '', '1', '0'),
	(9160, '10757', 201, 'clothing_halftiedhair', 5, 0, 0, 1, 0, 0, 11, -1, 0, '0', '1', '0'),
	(9161, '10758', 579, 'clothing_r19_raincoat', 5, 0, 0, 1, 0, 0, 22, -1, 0, '0', '1', '0'),
	(9162, '10759', 518, 'rainyday_c19_boardgames', 4, 0, 0, 1, 0, 0, 4, 21462, 0, '', '1', '0'),
	(9163, '10760', 579, 'clothing_r19_teddygown', 5, 0, 0, 1, 0, 0, 23, -1, 0, '0', '1', '0'),
	(9164, '10761', 310, 'clothing_bookbag', 5, 0, 0, 1, 0, 0, 23, -1, 0, '0', '1', '0'),
	(9165, '10762', 518, 'rainyday_c19_tartanseat', 4, 0, 0, 1, 0, 0, 10, 21465, 0, '', '1', '0'),
	(9166, '10763', 518, 'rainyday_c19_rugblanket', 4, 0, 0, 1, 0, 0, 9, 21466, 0, '', '1', '0'),
	(9167, '10764', 518, 'rainyday_c19_cocoa', 4, 0, 0, 1, 0, 0, 5, 21467, 0, '', '1', '0'),
	(9168, '10765', 518, 'rainyday_r19_rainbear', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(9169, '10766', 518, 'rainyday_r19_fluffbun', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(9170, '10767', 519, 'market_c19_drygoods', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(9171, '10768', 519, 'market_c19_trolley', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(9172, '10769', 519, 'market_c19_icecreamfreezer', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(9173, '10770', 519, 'market_c19_deli1', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(9174, '10771', 519, 'market_c19_icecreamtubs', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(9175, '10772', 519, 'market_c19_stationary', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(9176, '10773', 519, 'market_c19_selfcheckout', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(9177, '10774', 519, 'market_c19_spill', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(9178, '10775', 519, 'market_c19_meat', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(9179, '10776', 519, 'market_c19_floor', 2, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(9180, '10777', 519, 'market_c19_vegfruit', 4, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(9181, '10778', 519, 'market_c19_deli2', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(9182, '10779', 519, 'market_c19_banner', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(9183, '10780', 519, 'market_c19_dairyfridge', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(9184, '10781', 519, 'market_c19_basket', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(9185, '10782', 519, 'market_c19_antitheftalarm', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(9186, '10783', 519, 'market_c19_dvds', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(9187, '10784', 519, 'market_c19_checkoutdesk', 5, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(9188, '10785', 519, 'market_c19_signboard', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(9189, '10786', 521, 'hween_c19_autumnfloor', 2, 0, 0, 1, 0, 0, 3, 21590, 0, '', '1', '0'),
	(9190, '10787', 803, 'hween_c19_tarot', 4, 0, 0, 1, 0, 0, 31, -1, 0, '', '1', '0'),
	(9191, '10788', 521, 'hween_c19_crookedfloor', 2, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(9192, '10789', 521, 'hween_c19_bewitchedcauldron', 4, 0, 0, 1, 0, 0, 5, 21590, 0, '', '1', '0'),
	(9193, '10790', 579, 'clothing_r19_warlocks', 5, 0, 0, 1, 0, 0, 24, -1, 0, '0', '1', '0'),
	(9194, '10791', 803, 'hween_c19_herbs', 4, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(9195, '10792', 579, 'clothing_r19_longlonghair', 5, 0, 0, 1, 0, 0, 25, -1, 0, '0', '1', '0'),
	(9196, '10793', 521, 'hween_c19_stonewall', 4, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(9197, '10794', 521, 'hween_c19_pumpkinpatch', 4, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(9198, '10795', 521, 'hween_c19_bewitchedchair', 2, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(9199, '10796', 521, 'hween_c19_bewitchedbed', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(9200, '10797', 521, 'hween_c19_bewitchedtable', 2, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(9201, '10798', 803, 'hween_c19_crystal', 4, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(9202, '10799', 521, 'hween_c19_roofcorner', 4, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(9203, '10800', 829, 'hween_c19_witchsatchel', 7, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(9204, '10801', 804, 'hween_c19_flameon', 4, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(9205, '10802', 636, 'clothing_nt_possessedeyes', 5, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(9206, '10803', 521, 'hween_c19_angleroof', 4, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(9207, '10804', 579, 'clothing_r19_demonwings', 5, 0, 0, 1, 0, 0, 26, -1, 0, '0', '1', '0'),
	(9208, '10805', 521, 'hween_c19_birchtree', 4, 0, 0, 1, 0, 0, 9, 21590, 0, '', '1', '0'),
	(9209, '10806', 804, 'hween_c19_firechild', 4, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(9210, '10807', 521, 'hween_c19_bigroof', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(9211, '10808', 802, 'hween_c19_witchcraft', 4, 0, 0, 1, 0, 0, 32, -1, 0, '', '1', '0'),
	(9212, '10809', 521, 'hween_c19_claddedwall', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(9213, '10810', 310, 'clothing_possessedeyes', 5, 0, 0, 1, 0, 0, 22, 21514, 0, '0', '1', '0'),
	(9214, '10811', 636, 'clothing_nt_witchrobes', 5, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(9215, '10812', 803, 'hween_c19_bewitchedskull', 4, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(9216, '10813', 745, 'hween_ltd19_skullthrone', 4, 0, 0, 1, 0, 0, 34, -1, 0, '', '1', '0'),
	(9217, '10814', 521, 'hween_c19_archway', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(9218, '10815', 521, 'hween_r19_weepingwillow', 4, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(9219, '10816', 521, 'hween_c19_smallroof', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(9220, '10817', 804, 'hween_c19_darkwerewolf', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(9221, '10818', 521, 'hween_r19_witchfamiliar', 4, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(9222, '10819', 521, 'hween_c19_fireplace', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(9223, '10820', 310, 'clothing_witchhat2', 5, 0, 0, 1, 0, 0, 21, 21524, 0, '0', '1', '0'),
	(9224, '10821', 203, 'clothing_witchrobes', 5, 0, 0, 1, 0, 0, 2, 21525, 0, '0', '1', '0'),
	(9225, '10822', 804, 'hween_c19_spiritowl', 4, 0, 0, 1, 0, 0, 28, -1, 0, '', '1', '0'),
	(9226, '10823', 521, 'hween_c19_steeproof', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(9227, '10824', 803, 'hween_c19_potions', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(9228, '10825', 803, 'hween_c19_feathers', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(9229, '10826', 803, 'hween_c19_crystalball', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(9230, '10827', 636, 'clothing_nt_witchhat2', 5, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(9231, '10828', 804, 'hween_c19_slimeblob', 4, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(9232, '10829', 803, 'hween_c19_bewitchedcandles', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(9233, '10830', 191, 'hween_c19_witchsatchel2', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(9234, '10831', 521, 'hween_c19_broomstaffstand', 4, 0, 0, 1, 0, 0, 10, 21590, 0, '', '1', '0'),
	(9235, '10832', 307, 'CF_250_Hucci', 250, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(9236, '10833', 664, 'bonusbag19_3', 7, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(9237, '10834', 661, 'bonusrare19_3*0', 5, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(9238, '10835', 661, 'bonusrare19_3*1', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(9239, '10836', 661, 'bonusrare19_3*2', 5, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(9240, '10837', 661, 'bonusrare19_3*3', 5, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(9241, '10838', 661, 'bonusrare19_3*4', 5, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(9242, '10839', 661, 'bonusrare19_3*5', 5, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(9243, '10840', 255, 'mutearea_sign2', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(9244, '10841', 310, 'clothing_habpods', 5, 0, 0, 1, 0, 0, 20, 21594, 0, '0', '1', '0'),
	(9245, '10842', 636, 'clothing_nt_shortscarf', 5, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(9246, '10843', 636, 'clothing_nt_habpods', 5, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(9247, '10844', 636, 'clothing_nt_flaredtrench', 5, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(9248, '10845', 310, 'clothing_microbag', 5, 0, 0, 1, 0, 0, 19, 21598, 0, '0', '1', '0'),
	(9249, '10846', 205, 'clothing_hitchedjumper', 5, 0, 0, 1, 0, 0, 3, 21599, 0, '0', '1', '0'),
	(9250, '10847', 636, 'clothing_nt_hitchedjumper', 5, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(9251, '10848', 428, 'autumn_r19_maplebonsai', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9252, '10849', 310, 'clothing_shortscarf', 5, 0, 0, 1, 0, 0, 18, 21602, 0, '0', '1', '0'),
	(9253, '10850', 636, 'clothing_nt_microbag', 5, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(9254, '10851', 205, 'clothing_flaredtrench', 5, 0, 0, 1, 0, 0, 2, 21604, 0, '0', '1', '0'),
	(9255, '10852', 326, 'wintercabin_c19_window', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(9256, '10853', 326, 'wintercabin_c19_floor', 2, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(9257, '10854', 326, 'wintercabin_c19_sofa', 3, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(9258, '10855', 326, 'wintercabin_c19_fence', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(9259, '10856', 326, 'wintercabin_c19_cabintable', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(9260, '10857', 326, 'wintercabin_c19_stairs', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(9261, '10858', 326, 'wintercabin_c19_antlerlight', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(9262, '10859', 326, 'wintercabin_c19_corner', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(9263, '10860', 326, 'wintercabin_c19_stage', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(9264, '10861', 326, 'wintercabin_c19_fireplace', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(9265, '10862', 326, 'wintercabin_c19_lamp', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(9266, '10863', 326, 'wintercabin_c19_cabinrug', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(9267, '10864', 326, 'wintercabin_c19_glasstable', 2, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(9268, '10865', 326, 'wintercabin_c19_items', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(9269, '10866', 326, 'wintercabin_c19_wall', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(9270, '10867', 326, 'wintercabin_c19_drawers', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(9271, '10868', 326, 'wintercabin_c19_cabinchair', 2, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(9272, '10869', 326, 'wintercabin_c19_bed', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(9273, '10870', 205, 'clothing_leatherhoodie', 5, 0, 0, 1, 0, 0, 1, 21623, 0, '0', '1', '0'),
	(9274, '10871', 636, 'clothing_nt_shortfluffy', 5, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(9275, '10872', 201, 'clothing_wavy3', 5, 0, 0, 1, 0, 0, 10, 21625, 0, '0', '1', '0'),
	(9276, '10873', 579, 'clothing_r19_autumndress', 5, 0, 0, 1, 0, 0, 27, -1, 0, '0', '1', '0'),
	(9277, '10874', 636, 'clothing_nt_leatherhoodie', 5, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(9278, '10875', 579, 'clothing_r19_autumnhairpiece', 5, 0, 0, 1, 0, 0, 28, -1, 0, '0', '1', '0'),
	(9279, '10876', 636, 'clothing_nt_wavy3', 5, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(9280, '10877', 201, 'clothing_shortfluffy', 5, 0, 0, 1, 0, 0, 6, 21630, 0, '0', '1', '0'),
	(9281, '10878', 579, 'clothing_r19_puppyacc', 5, 0, 0, 1, 0, 0, 29, -1, 0, '0', '1', '0'),
	(9282, '10879', 307, 'CF_500_orb', 500, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(9283, '10880', 325, 'xmas_c19_balcony', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(9284, '10881', 806, 'xmas_c19_jarofgold', 4, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(9285, '10882', 325, 'xmas_c19_terrierplushie', 4, 0, 0, 1, 0, 0, 30, -1, 0, '', '1', '0'),
	(9286, '10883', 325, 'xmas_c19_icicles', 4, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(9287, '10884', 806, 'xmas_c19_angelfigure', 4, 0, 0, 1, 0, 0, 49, -1, 0, '', '1', '0'),
	(9288, '10885', 325, 'xmas_c19_hamsterplushie', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(9289, '10886', 745, 'xmas_ltd19_icethrone', 4, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(9290, '10887', 325, 'xmas_c19_snowsprites', 4, 0, 0, 1, 0, 0, 28, -1, 0, '', '1', '0'),
	(9291, '10888', 310, 'clothing_pompombag', 5, 0, 0, 1, 0, 0, 17, 21642, 0, '0', '1', '0'),
	(9292, '10889', 579, 'clothing_r19_elisa', 5, 0, 0, 1, 0, 0, 30, -1, 0, '0', '1', '0'),
	(9293, '10890', 191, 'xmas_c19_box4b', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(9294, '10891', 636, 'clothing_nt_pompombag', 5, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(9295, '10892', 191, 'xmas_c19_box1b', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(9296, '10893', 325, 'xmas_c19_elfguard', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(9297, '10894', 325, 'xmas_c19_crystalfloor', 2, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(9298, '10895', 636, 'clothing_nt_frostedbeard', 5, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(9299, '10896', 325, 'xmas_c19_elffairy', 4, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(9300, '10897', 807, 'xmas_c19_reindeerfigure2', 4, 0, 0, 1, 0, 0, 33, -1, 0, '', '1', '0'),
	(9301, '10898', 191, 'xmas_c19_box6b', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(9302, '10899', 191, 'xmas_c19_box5b', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(9303, '10900', 325, 'xmas_c19_curtain', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(9304, '10901', 833, 'xmas_c19_box3', 7, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(9305, '10902', 806, 'xmas_c19_robinfigure', 4, 0, 0, 1, 0, 0, 52, -1, 0, '', '1', '0'),
	(9306, '10903', 200, 'clothing_snowmansuit', 15, 0, 0, 1, 0, 0, 2, 21657, 0, '0', '1', '0'),
	(9307, '10904', 636, 'clothing_nt_bearmuffs', 5, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(9308, '10905', 201, 'clothing_frostedbeard', 5, 0, 0, 1, 0, 0, 5, 21659, 0, '0', '1', '0'),
	(9309, '10906', 325, 'xmas_c19_icetree', 4, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(9310, '10907', 806, 'xmas_c19_reindeerfigure', 4, 0, 0, 1, 0, 0, 51, -1, 0, '', '1', '0'),
	(9311, '10908', 325, 'xmas_r19_crystalharp', 4, 0, 0, 1, 0, 0, 33, -1, 0, '', '1', '0'),
	(9312, '10909', 325, 'xmas_c19_archwall', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(9313, '10910', 325, 'xmas_c19_furbanner', 4, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(9314, '10911', 805, 'xmas_c19_snowcraft', 4, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(9315, '10912;50290', 570, 'clothing_nordicscarf', 5, 0, 0, 1, 0, 0, 1, -1, 0, '0', '1', '0'),
	(9316, '10913', 325, 'xmas_c19_crystaltable', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(9317, '10914', 325, 'xmas_c19_catplushie', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(9318, '10915', 807, 'xmas_c19_dragonfigure2', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(9319, '10916', 833, 'xmas_c19_box2', 7, 0, 0, 1, 0, 0, 40, -1, 0, '', '1', '0'),
	(9320, '10917', 325, 'xmas_c19_elfeskimo', 4, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(9321, '10918', 325, 'xmas_c19_lamp', 4, 0, 0, 1, 0, 0, 26, -1, 0, '', '1', '0'),
	(9322, '10919', 310, 'clothing_pompomhat', 5, 0, 0, 1, 0, 0, 16, 21673, 0, '0', '1', '0'),
	(9323, '10920', 325, 'xmas_c19_stackedicedrinks', 10, 0, 0, 1, 0, 0, 29, -1, 0, '', '1', '0'),
	(9324, '10921', 325, 'xmas_c19_pugplushie', 4, 0, 0, 1, 0, 0, 27, -1, 0, '', '1', '0'),
	(9325, '10922', 579, 'clothing_r19_frosted', 5, 0, 0, 1, 0, 0, 31, -1, 0, '0', '1', '0'),
	(9326, '10923', 325, 'xmas_r19_crystalfountain', 4, 0, 0, 1, 0, 0, 32, -1, 0, '', '1', '0'),
	(9327, '10924', 325, 'xmas_c19_crystalchair', 2, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(9328, '10925', 310, 'clothing_bearmuffs', 5, 0, 0, 1, 0, 0, 15, 21679, 0, '0', '1', '0'),
	(9329, '10926', 191, 'xmas_c19_box3b', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(9330, '10927', 325, 'xmas_c19_windowwall', 4, 0, 0, 1, 0, 0, 31, -1, 0, '', '1', '0'),
	(9331, '10928', 833, 'xmas_c19_box6', 7, 0, 0, 1, 0, 0, 44, -1, 0, '', '1', '0'),
	(9332, '10929', 807, 'xmas_c19_unicornfigure2', 4, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(9333, '10930', 806, 'xmas_c19_dragonfigure', 4, 0, 0, 1, 0, 0, 50, -1, 0, '', '1', '0'),
	(9334, '10931', 833, 'xmas_c19_box4', 7, 0, 0, 1, 0, 0, 42, -1, 0, '', '1', '0'),
	(9335, '10932', 636, 'clothing_nt_pompomhat', 5, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(9336, '10933', 807, 'xmas_c19_robinfigure2', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(9337, '10934', 807, 'xmas_c19_angelfigure2', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(9338, '10935', 325, 'xmas_c19_iceshards', 4, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(9339, '10936', 833, 'xmas_c19_box5', 7, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(9340, '10937', 325, 'xmas_c19_elfmage', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(9341, '10938', 325, 'xmas_c19_chandelier', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(9342, '10939', 191, 'xmas_c19_box2b', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(9343, '10940', 806, 'xmas_c19_unicornfigure', 4, 0, 0, 1, 0, 0, 53, -1, 0, '', '1', '0'),
	(9344, '10941', 325, 'xmas_c19_icefood', 4, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(9345, '10942', 636, 'clothing_nt_snowmansuit', 5, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(9346, '10943', 833, 'xmas_c19_box1', 7, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(9347, '10944', 834, 'clothing_icecrown', 5, 0, 0, 1, 0, 0, 1, -1, 0, '0', '1', '0'),
	(9348, '10945', 661, 'bonusrare19_4*0', 5, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(9349, '10946', 661, 'bonusrare19_4*1', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(9350, '10947', 661, 'bonusrare19_4*2', 5, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(9351, '10948', 661, 'bonusrare19_4*3', 5, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(9352, '10949', 661, 'bonusrare19_4*4', 5, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(9353, '10950', 661, 'bonusrare19_4*5', 5, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(9354, '10951', 664, 'bonusbag19_4', 7, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(9355, '10952', 591, 'rare_prize19_xmas', 5, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(9356, '10953', 501, 'shome_keys', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9357, '10954', 501, 'shome_hamster', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9358, '10955', 585, 'clothing_goldpack4', 5, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(9359, '10956', 687, 'clothing_r20_galaxybackpack', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(9360, '10957', 310, 'clothing_heartnecklace', 3, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(9361, '10958', 687, 'clothing_r20_kittyearphones', 3, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(9362, '10959', 302, 'china_goldenrat', 3, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(9363, '10960', 302, 'china_rat', 3, 0, 0, 1, 0, 0, 29, -1, 0, '', '1', '0'),
	(9364, '10961', 310, 'clothing_rat', 3, 0, 0, 1, 0, 0, 13, 21750, 0, '', '1', '0'),
	(9365, '10962', 688, 'clothing_r19_sparklywaist5', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9366, '10963', 688, 'clothing_r19_sparklywaist6', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9367, '10964', 688, 'clothing_r19_sparklywaist7', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9368, '10965', 688, 'clothing_r19_sparklywaist8', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9369, '10966', 688, 'clothing_r19_sparklywaist2', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9370, '10967', 688, 'clothing_r19_sparklywaist3', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9371, '10968', 688, 'clothing_r19_sparklywaist1', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9372, '10969', 688, 'clothing_r19_sparklywaist4', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9373, '10970', 668, 'ny_r19_crackable', 7, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(9374, '10971', 689, 'hc20_9', 5, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '1'),
	(9375, '10972', 689, 'hc20_8', 5, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '1'),
	(9376, '10973', 689, 'hc20_4', 5, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '1'),
	(9377, '10974', 689, 'hc20_2', 5, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '1'),
	(9378, '10975', 689, 'hc20_12', 5, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '1'),
	(9379, '10976', 689, 'hc20_3', 5, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '1'),
	(9380, '10977', 689, 'hc20_7', 5, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '1'),
	(9381, '10978', 689, 'hc20_10', 5, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '1'),
	(9382, '10979', 689, 'hc20_11', 5, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '1'),
	(9383, '10980', 689, 'hc20_5', 5, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '1'),
	(9384, '10981', 689, 'hc20_6', 5, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '1'),
	(9385, '10982', 689, 'hc20_1', 5, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '1'),
	(9386, '10983', 307, 'CF_750_minihabberge', 750, 0, 0, 1, 0, 0, 28, -1, 0, '', '1', '0'),
	(9387, '10984', 690, 'rare_prize20*0', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9388, '10985', 690, 'rare_prize20*1', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9389, '10986', 690, 'rare_prize20*10', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9390, '10987', 690, 'rare_prize20*11', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9391, '10988', 690, 'rare_prize20*12', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9392, '10989', 690, 'rare_prize20*13', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9393, '10990', 690, 'rare_prize20*2', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9394, '10991', 690, 'rare_prize20*3', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9395, '10992', 690, 'rare_prize20*4', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9396, '10993', 690, 'rare_prize20*5', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9397, '10994', 690, 'rare_prize20*6', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9398, '10995', 690, 'rare_prize20*7', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9399, '10996', 690, 'rare_prize20*8', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9400, '10997', 690, 'rare_prize20*9', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9401, '10998', 692, 'rare_r20_wardrobe', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9402, '10999', 687, 'clothing_r20_quinn', 3, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(9403, '11000', 692, 'rare_r20_balloonchair', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9404, '11001', 692, 'val_c20_cakestand', 3, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(9405, '11002', 692, 'val_c20_chair', 3, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(9406, '11003', 692, 'val_c20_lights', 3, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(9407, '11004', 692, 'val_c20_floor', 3, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(9408, '11005', 692, 'val_c20_blackboard', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(9409, '11006', 692, 'val_c20_window', 3, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(9410, '11007', 692, 'val_c20_tablecounter', 3, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(9411, '11008', 200, 'clothing_chocochefoutfit', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(9412, '11009', 692, 'val_c20_cakedisplay', 3, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(9413, '11010', 692, 'val_c20_wall', 3, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(9414, '11011', 692, 'val_c20_cake', 3, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(9415, '11012', 687, 'clothing_r20_tattoo', 3, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(9416, '11013', 692, 'val_c20_chocgift', 3, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(9417, '11014', 692, 'val_c20_chocfountain', 3, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(9418, '11015', 692, 'val_c20_table', 3, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(9419, '11016', 692, 'val_c20_seats', 3, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(9420, '11017', 664, 'bonusbag20_1', 3, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(9421, '11018', 693, 'bonusrare20_1a*1', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9422, '11019', 693, 'bonusrare20_1a*2', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9423, '11020', 693, 'bonusrare20_1a*3', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9424, '11021', 693, 'bonusrare20_1a*4', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9425, '11022', 693, 'bonusrare20_1a*5', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9426, '11023', 693, 'bonusrare20_1a*6', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9427, '11024', 693, 'bonusrare20_2*1', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9428, '11025', 693, 'bonusrare20_2*2', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9429, '11026', 693, 'bonusrare20_2*3', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9430, '11027', 693, 'bonusrare20_2*4', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9431, '11028', 693, 'bonusrare20_2*5', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9432, '11029', 693, 'bonusrare20_2*6', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9433, '11030', 664, 'bonusbag20_3', 3, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(9434, '11031', 693, 'bonusrare20_3*1', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9435, '11032', 693, 'bonusrare20_3*2', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9436, '11033', 693, 'bonusrare20_3*3', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9437, '11034', 693, 'bonusrare20_3*4', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9438, '11035', 693, 'bonusrare20_3*5', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9439, '11036', 693, 'bonusrare20_3*6', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9440, '11037', 693, 'bonusrare20_4*0', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9441, '11038', 693, 'bonusrare20_4*1', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9442, '11039', 693, 'bonusrare20_4*2', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9443, '11040', 693, 'bonusrare20_4*3', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9444, '11041', 693, 'bonusrare20_4*4', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9445, '11042', 693, 'bonusrare20_4*5', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9446, '11043', 664, 'bonusbag20_2', 3, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(9447, '11044', 664, 'bonusbag20_4', 3, 0, 0, 1, 0, 0, 26, -1, 0, '', '1', '0'),
	(9448, '11045', 517, 'rare_r20_grandebackdrop', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9449, '11046', 818, 'clothing_c20_goldheartbp', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9450, '11047', 517, 'art_c20_plant', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9451, '11048', 184, 'booster_c20_box', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9452, '11049', 517, 'art_c20_rug', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9453, '11050', 821, 'booster_c20_box1', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9454, '11051', 517, 'art_c20_floor', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9455, '11052', 517, 'art_c20_light', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9456, '11053', 517, 'art_c20_paintings', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9457, '11054', 818, 'art_c20_gold4', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9458, '11055', 517, 'art_c20_chair', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9459, '11056', 818, 'art_c20_pillow', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9460, '11057', 517, 'art_c20_bin', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9461, '11058', 818, 'art_c20_gold1', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9462, '11059', 818, 'clothing_c20_heartbackpack', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9463, '11060', 517, 'art_c20_drawingtablet', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9464, '11061', 818, 'art_c20_gold2', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9465, '11062', 818, 'art_c20_chair2', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9466, '11063', 517, 'art_c20_desk', 5, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9467, '11064', 517, 'art_c20_shelves', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9468, '11065', 818, 'art_c20_chair4', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9469, '11066', 517, 'art_c20_canvas', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9470, '11067', 818, 'art_c20_gold5', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9471, '11068', 517, 'art_c20_sofa', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9472, '11069', 818, 'art_c20_chair1', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9473, '11070', 818, 'art_c20_clock', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9474, '11071', 517, 'art_c20_clotheshanger', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9475, '11072', 517, 'art_c20_rolledpaper', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9476, '11073', 818, 'art_c20_gold3', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9477, '11074', 517, 'art_c20_artstool', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9478, '11075', 517, 'art_c20_easel', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9479, '11076', 818, 'art_c20_chair3', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9480, '11077', 517, 'art_c20_coffeetable', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9481, '11078', 517, 'art_c20_caddy', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9482, '11079', 226, 'easter_c20_heather', 3, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(9483, '11080', 226, 'easter_r20_mountaingoat', 3, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(9484, '11081', 848, 'easter_c20_darkrock', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9485, '11082', 633, 'clothing_mysticrobes', 3, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(9486, '11083', 633, 'easter_c20_darkprize4', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9487, '11084', 226, 'easter_c20_scatteredforestfloor', 3, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(9488, '11085', 226, 'easter_c20_fishingpole', 3, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(9489, '11086', 636, 'clothing_nt_yogatop', 5, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(9490, '11087', 636, 'clothing_nt_campingbackpack', 5, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(9491, '11088', 226, 'easter_c20_stickteepee', 3, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(9492, '11089', 633, 'easter_c20_ancientbird', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9493, '11090', 310, 'clothing_explorersash', 3, 0, 0, 1, 0, 0, 12, 21910, 0, '', '1', '0'),
	(9494, '11091', 226, 'easter_c20_rockboulders', 3, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(9495, '11092', 687, 'clothing_r20_bunnyoutfit', 3, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(9496, '11093', 633, 'easter_c20_darkprize2', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9497, '11094', 310, 'clothing_puffyvest', 3, 0, 0, 1, 0, 0, 11, 21914, 0, '', '1', '0'),
	(9498, '11095', 226, 'easter_c20_mountainslopes', 3, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(9499, '11096', 746, 'easter_ltd20_fortuneduck', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9500, '11097', 226, 'easter_r20_mystictree', 3, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(9501, '11098', 226, 'easter_c20_campingessentials', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(9502, '11099', 310, 'clothing_binoculars', 3, 0, 0, 1, 0, 0, 10, 21919, 0, '', '1', '0'),
	(9503, '11100', 226, 'easter_c20_ornamentalrocks', 3, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(9504, '11101', 226, 'easter_c20_picnicfood', 3, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(9505, '11102', 310, 'clothing_campingbackpack', 3, 0, 0, 1, 0, 0, 9, 21922, 0, '', '1', '0'),
	(9506, '11103', 226, 'easter_c20_mountainflats', 3, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(9507, '11104', 633, 'easter_c20_darkprize3', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9508, '11105', 633, 'easter_c20_darkprize1', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9509, '11106', 204, 'clothing_yogatop', 3, 0, 0, 1, 0, 0, 2, 21926, 0, '', '1', '0'),
	(9510, '11107', 636, 'clothing_nt_puffyvest', 5, 0, 0, 1, 0, 0, 26, -1, 0, '', '1', '0'),
	(9511, '11108', 636, 'clothing_nt_sportshair', 5, 0, 0, 1, 0, 0, 27, -1, 0, '', '1', '0'),
	(9512, '11109', 226, 'easter_c20_camprug', 3, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(9513, '11110', 226, 'easter_c20_mossydivider', 3, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(9514, '11111', 226, 'easter_c20_firstaidkit', 3, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(9515, '11112', 201, 'clothing_sportshair', 3, 0, 0, 1, 0, 0, 4, 21932, 0, '', '1', '0'),
	(9516, '11113', 226, 'easter_c20_logwalk', 3, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(9517, '11114', 633, 'clothing_mysticcrown', 3, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(9518, '11115', 206, 'clothing_yogapants', 3, 0, 0, 1, 0, 0, 1, 21935, 0, '', '1', '0'),
	(9519, '11116', 633, 'easter_c20_ancienthorse', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9520, '11117', 226, 'easter_c20_kayak', 3, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(9521, '11118', 687, 'clothing_r20_ponytailcap', 3, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(9522, '11119', 636, 'clothing_nt_yogapants', 5, 0, 0, 1, 0, 0, 28, -1, 0, '', '1', '0'),
	(9523, '11120', 633, 'easter_c20_lightprize3', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9524, '11121', 226, 'easter_c20_climbingropetele', 3, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(9525, '11122', 636, 'clothing_nt_sportsshade', 5, 0, 0, 1, 0, 0, 29, -1, 0, '', '1', '0'),
	(9526, '11123', 636, 'clothing_nt_binoculars', 5, 0, 0, 1, 0, 0, 30, -1, 0, '', '1', '0'),
	(9527, '11124', 633, 'easter_c20_lightprize2', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9528, '11125', 226, 'easter_c20_forestfriends', 3, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(9529, '11126', 848, 'easter_c20_lightrock', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9530, '11127', 633, 'easter_c20_clayrelic', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9531, '11128', 226, 'easter_c20_fishstream', 3, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(9532, '11129', 310, 'clothing_rainbowegg', 3, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(9533, '11130', 633, 'easter_c20_jadeguardian', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9534, '11131', 226, 'easter_c20_heatherrock', 3, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(9535, '11132', 633, 'easter_c20_ancientstatue', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9536, '11133', 310, 'clothing_sportsshade', 3, 0, 0, 1, 0, 0, 7, 21953, 0, '', '1', '0'),
	(9537, '11134', 633, 'easter_c20_lightprize4', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9538, '11135', 633, 'easter_c20_lightprize1', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9539, '11136', 226, 'easter_c20_waypointrocks', 3, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(9540, '11137', 226, 'easter_c20_energyfood', 3, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(9541, '11138', 633, 'easter_c20_zenmaster', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9542, '11139', 636, 'clothing_nt_explorersash', 5, 0, 0, 1, 0, 0, 31, -1, 0, '', '1', '0'),
	(9543, '11140', 226, 'easter_c20_foresttree', 3, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(9544, '11141', 226, 'easter_c20_rapids', 3, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(9545, '11142', 191, 'easter_c20_lightrock1', 4, 0, 0, 1, 0, 0, 363, -1, 0, '', '1', '0'),
	(9546, '11143', 191, 'easter_c20_darkrock1', 4, 0, 0, 1, 0, 0, 364, -1, 0, '', '1', '0'),
	(9547, '11144', 858, 'rare_r20_corgi', 4, 0, 0, 1, 0, 0, 365, -1, 0, '', '1', '0'),
	(9548, '11145', 858, 'rare_r20_marimo', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9549, '11146', 858, 'rare_r20_treehouse', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9550, '11147', 735, 'spa_c20_bbrose', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9551, '11148', 186, 'spa_c20_crackable1A', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9552, '11149', 735, 'clothing_towelwraphalf', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9553, '11150', 821, 'spa_c20_crackable1B', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9554, '11151', 735, 'clothing_eyemask', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9555, '11152', 810, 'clothing_maskmint', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9556, '11153', 735, 'spa_c20_bbmint', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9557, '11154', 735, 'spa_c20_bbcharcoal', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9558, '11155', 735, 'clothing_towelhair', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9559, '11156', 735, 'clothing_eyetomato', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9560, '11157', 810, 'clothing_maskrose', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9561, '11158', 735, 'clothing_eyecucumber', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9562, '11159', 735, 'spa_c20_lavendersalt', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9563, '11160', 735, 'clothing_towelwrapfull', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9564, '11161', 810, 'clothing_maskcitrus', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9565, '11162', 735, 'spa_c20_bbcitrus', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9566, '11163', 735, 'spa_c20_incense', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9567, '11164', 810, 'clothing_maskcharcoal', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9568, '11165', 735, 'clothing_eyecitrus', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9569, '11166', 186, 'spa_c20_crackable2A', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9570, '11167', 735, 'clothing_eyestrawberry', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9571, '11168', 821, 'spa_c20_crackable2B', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9572, '11169', 808, 'spa_c20_bath', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9573, '11170', 307, 'CF_500_goldenbeetle', 500, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(9574, '11171', 687, 'clothing_r20_monkeyfezhat', 3, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(9575, '11172', 812, 'india_c20_saribp', 3, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(9576, '11173', 696, 'india_c20_longpillow', 3, 0, 0, 1, 0, 0, 99, 25840, 0, '', '1', '0'),
	(9577, '11174', 310, 'clothing_moviestarmakeup', 3, 0, 0, 1, 0, 0, 6, 22046, 0, '', '1', '0'),
	(9578, '11175', 813, 'clothing_cobra', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9579, '11176', 696, 'india_r20_bengaltiger', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9580, '11177', 696, 'india_c20_incense', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9581, '11178', 813, 'clothing_exoticcape', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(9582, '11179', 812, 'india_c20_capebp', 3, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(9583, '11180', 696, 'india_c20_eleseat', 3, 0, 0, 1, 0, 0, 99, 25840, 0, '', '1', '0'),
	(9584, '11181', 696, 'india_c20_flowerbelldeco', 3, 0, 0, 1, 0, 0, 99, 25840, 0, '', '1', '0'),
	(9585, '11182', 812, 'india_c20_dye', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9586, '11183', 813, 'clothing_headjewel', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9587, '11184', 201, 'clothing_moviestarhair', 3, 0, 0, 1, 0, 0, 3, 22056, 0, '', '1', '0'),
	(9588, '11185', 813, 'clothing_grandsari', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9589, '11186', 696, 'india_c20_sofa', 3, 0, 0, 1, 0, 0, 99, 25840, 0, '', '1', '0'),
	(9590, '11187', 813, 'clothing_grandheadjewel', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9591, '11188', 696, 'india_c20_jewellerybox', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9592, '11189', 813, 'clothing_sherwani', 3, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(9593, '11190', 812, 'india_c20_sherwanibp', 3, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(9594, '11191', 696, 'india_c20_light', 3, 0, 0, 1, 0, 0, 99, 25840, 0, '', '1', '0'),
	(9595, '11192', 636, 'clothing_nt_turban', 5, 0, 0, 1, 0, 0, 32, -1, 0, '', '1', '0'),
	(9596, '11193', 696, 'india_c20_balconydoor', 3, 0, 0, 1, 0, 0, 99, 25840, 0, '', '1', '0'),
	(9597, '11194', 696, 'india_c20_archway', 3, 0, 0, 1, 0, 0, 99, 25840, 0, '', '1', '0'),
	(9598, '11195', 812, 'india_c20_snakebp', 3, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(9599, '11196', 696, 'india_c20_dessert', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9600, '11197', 696, 'india_c20_tiledfloor', 3, 0, 0, 1, 0, 0, 99, 25840, 0, '', '1', '0'),
	(9601, '11198', 202, 'clothing_turban', 3, 0, 0, 1, 0, 0, 3, 22070, 0, '', '1', '0'),
	(9602, '11199', 812, 'india_c20_cloth', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9603, '11200', 813, 'clothing_grandsherwani', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9604, '11201', 696, 'india_c20_curries', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9605, '11202', 696, 'india_c20_palmvase', 3, 0, 0, 1, 0, 0, 99, 25840, 0, '', '1', '0'),
	(9606, '11203', 636, 'clothing_nt_moviestarhair', 5, 0, 0, 1, 0, 0, 33, -1, 0, '', '1', '0'),
	(9607, '11204', 813, 'clothing_grandexoticcape', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9608, '11205', 811, 'india_c20_sewingmachine', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9609, '11206', 821, 'india_c20_blueprintb', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9610, '11207', 696, 'india_c20_eletable', 3, 0, 0, 1, 0, 0, 99, 25840, 0, '', '1', '0'),
	(9611, '11208', 696, 'india_r20_exotictent', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9612, '11209', 813, 'clothing_snake', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9613, '11210', 189, 'india_c20_blueprint', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9614, '11211', 696, 'india_c20_teaset', 3, 0, 0, 1, 0, 0, 99, 25840, 0, '', '1', '0'),
	(9615, '11212', 812, 'india_c20_headjewelbp', 3, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(9616, '11213', 636, 'clothing_nt_moviestarmakeup', 5, 0, 0, 1, 0, 0, 34, -1, 0, '', '1', '0'),
	(9617, '11214', 696, 'india_c20_beadbellsdeco', 3, 0, 0, 1, 0, 0, 99, 25840, 0, '', '1', '0'),
	(9618, '11215', 813, 'clothing_sari', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9619, '11216', 687, 'clothing_r20_jewelbraidhair', 3, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(9620, '11217', 746, 'india_ltd20_sultanthrone', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9621, '11218', 491, 'diamond_painting48', 3, 0, 0, 1, 0, 0, 48, -1, 0, '', '1', '0'),
	(9622, '11219', 491, 'diamond_painting50', 3, 0, 0, 1, 0, 0, 50, -1, 0, '', '1', '0'),
	(9623, '11220', 491, 'diamond_painting49', 3, 0, 0, 1, 0, 0, 49, -1, 0, '', '1', '0'),
	(9624, '11221', 491, 'diamond_painting47', 3, 0, 0, 1, 0, 0, 47, -1, 0, '', '1', '0'),
	(9625, '11222', 202, 'clothing_studentcap', 3, 0, 0, 1, 0, 0, 2, 22108, 0, '', '1', '0'),
	(9626, '11223', 636, 'clothing_nt_studentcap', 5, 0, 0, 1, 0, 0, 35, -1, 0, '', '1', '0'),
	(9627, '20060', 683, 'DEAL_HC_1', 3, 0, 0, 1, 0, 0, 15, 20060, 0, '', '0', '0'),
	(9628, '20100', 429, 'Poker', 4, 0, 0, 1, 0, 0, 366, -1, 0, '', '1', '0'),
	(9629, '40010', 274, 'poster 599', 4, 0, 0, 1, 0, 0, 99, 40010, 0, '599', '1', '0'),
	(9630, '40020', 30, 'a0 gothicfountain', 3, 0, 0, 1, 0, 0, 6, 40020, 0, '', '1', '0'),
	(9631, '40030', 349, 'a0 hc_wall_lamp', 5, 0, 0, 1, 0, 0, 25, 40030, 0, '', '1', '1'),
	(9632, '40040', 21, 'industrialfan', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(9633, '40050', 30, 'a0 torch', 3, 0, 0, 1, 0, 0, 9, 40050, 0, '', '1', '0'),
	(9634, '40060', 445, 'a0 val_heart', 3, 0, 0, 1, 0, 0, 7, 40060, 0, '', '1', '0'),
	(9635, '40070', 35, 'DEV wallmirror', 3, 0, 0, 1, 0, 0, 48, 40070, 0, '', '1', '0'),
	(9636, '40080', 31, 'DEV jp_ninjastars', 3, 0, 0, 1, 0, 0, 5, 40080, 0, '', '1', '0'),
	(9637, '40090', 280, 'DEV habw_mirror', 3, 0, 0, 1, 0, 0, 20, 40090, 0, '', '1', '0'),
	(9638, '40100', 22, 'a0 habbowheel_fan', 4, 0, 0, 1, 0, 0, 1, 40100, 0, '', '1', '0'),
	(9639, '40110', 772, 'guitar_skull', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9640, '40120', 21, 'guitar_v', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(9641, '40130', 21, 'Habborella Poster 2 Life Buoy', 4, 0, 0, 1, 0, 0, 4, 40130, 0, '', '1', '0'),
	(9642, '40140', 21, 'Habborella Poster 1 Porthole', 4, 0, 0, 1, 0, 0, 3, 40140, 0, '', '1', '0'),
	(9643, '40150', 473, 'a0 xmas_light', 2, 0, 0, 1, 0, 0, 1, 40150, 0, '', '1', '0'),
	(9644, '40160', 21, 'Habborella Poster 3 Anchor', 4, 0, 0, 1, 0, 0, 5, 40160, 0, '', '1', '0'),
	(9645, '40170', 123, 'sw_swords', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9646, '40180', 123, 'sw_stone', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9647, '40190', 123, 'sw_hole', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9648, '40200', 28, 'arabian_swords', 3, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(9649, '40210', 31, 'jp_sheet3', 3, 0, 0, 1, 0, 0, 32, -1, 0, '', '1', '0'),
	(9650, '40220', 28, 'arabian_wndw', 3, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(9651, '40230', 198, 'md_logo_wall', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9652, '40240', 31, 'jp_sheet1', 3, 0, 0, 1, 0, 0, 30, -1, 0, '', '1', '0'),
	(9653, '40250', 198, 'md_can', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9654, '40260', 31, 'jp_sheet2', 3, 0, 0, 1, 0, 0, 31, -1, 0, '', '1', '0'),
	(9655, '40270', 16, 'a0 roomdimmer', 12, 0, 0, 1, 0, 0, 3, 40270, 0, '', '1', '0'),
	(9656, '40280', 408, 'tiki_surfboard', 3, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(9657, '40290', 539, 'tampax_wall', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9658, '40300', 408, 'tiki_wallplnt', 3, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(9659, '40310', 306, 'DEV window_single_default', 4, 0, 0, 1, 0, 0, 10, 40310, 0, '', '1', '0'),
	(9660, '40320', 306, 'DEV window_double_default', 1, 0, 0, 1, 0, 0, 5, 40320, 0, '', '1', '0'),
	(9661, '40330', 306, 'DEV noob_window', 4, 0, 0, 1, 0, 0, 1, 40330, 0, '', '1', '0'),
	(9662, '40340', 306, 'DEV window_chinese_wide', 5, 0, 0, 1, 0, 0, 23, 40340, 0, '', '1', '0'),
	(9663, '40350', 306, 'DEV window_golden', 4, 0, 0, 1, 0, 0, 6, 40350, 0, '', '1', '0'),
	(9664, '40360', 306, 'DEV window_square', 2, 0, 0, 1, 0, 0, 12, 40360, 0, '', '1', '0'),
	(9665, '40370', 306, 'DEV window_romantic_narrow', 5, 0, 0, 1, 0, 0, 9, 40370, 0, '', '1', '0'),
	(9666, '40380', 306, 'DEV window_chinese_narrow', 3, 0, 0, 1, 0, 0, 15, 40380, 0, '', '1', '0'),
	(9667, '40390', 306, 'DEV window_70s_wide', 4, 0, 0, 1, 0, 0, 3, 40390, 0, '', '1', '0'),
	(9668, '40400', 306, 'DEV window_70s_narrow', 5, 0, 0, 1, 0, 0, 2, 40400, 0, '', '1', '0'),
	(9669, '40410', 306, 'DEV window_romantic_wide', 4, 0, 0, 1, 0, 0, 10, 40410, 0, '', '1', '0'),
	(9670, '40420', 306, 'DEV window_basic', 1, 0, 0, 1, 0, 0, 4, 40420, 0, '', '1', '0'),
	(9671, '40430', 543, 'ads_sunnyd', 4, 0, 0, 1, 0, 0, 47, -1, 0, '', '1', '0'),
	(9672, '40440', 306, 'DEV window_grunge', 5, 0, 0, 1, 0, 0, 19, 40440, 0, '', '1', '0'),
	(9673, '40450', 306, 'DEV window_triple', 5, 0, 0, 1, 0, 0, 14, 40450, 0, '', '1', '0'),
	(9674, '40460', 306, 'window_diner2', 3, 0, 0, 1, 0, 0, 104, 2566, 0, '', '1', '0'),
	(9675, '40470', 346, 'ads_dave_wall', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9676, '40480', 43, 'diner_walltable', 3, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(9677, '40490', 306, 'window_diner', 4, 0, 0, 1, 0, 0, 43, 2569, 0, '', '1', '0'),
	(9678, '40500', 527, 'ads_nokia_logo', 4, 0, 0, 1, 0, 0, 110, -1, 0, '', '1', '0'),
	(9679, '40510', 541, 'easy_poster', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9680, '40520', 764, 'DEV window_hole', 3, 0, 0, 1, 0, 0, 1, 40520, 0, '', '1', '0'),
	(9681, '40530', 527, 'ads_nokia_phone', 4, 0, 0, 1, 0, 0, 111, -1, 0, '', '1', '0'),
	(9682, '40540', 306, 'DEV window_skyscraper', 5, 0, 0, 1, 0, 0, 11, 40540, 0, '', '1', '0'),
	(9683, '40560', 272, 'det_bhole', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(9684, '40570', 540, 'netari_poster', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9685, '40580', 346, 'ads_campguitar', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(9686, '40590', 389, 'hween08_rad', 3, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(9687, '40600', 389, 'a0 hw_08_xray', 3, 0, 0, 1, 0, 0, 18, 40600, 0, '', '1', '0'),
	(9688, '40610', 389, 'hween08_wndwb', 3, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(9689, '40620', 389, 'hween08_wndw', 3, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(9690, '40630', 389, 'hween08_bio', 3, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(9691, '40640', 389, 'hween08_xray', 3, 0, 0, 1, 0, 0, 99, 40640, 0, '', '1', '0'),
	(9692, '40650', 30, 'a0 gothicfountain 2', 3, 0, 0, 1, 0, 0, 7, 40650, 0, '', '1', '0'),
	(9693, '40660', 33, 'party_led', 3, 0, 0, 1, 0, 0, 19, 2988, 0, '', '1', '0'),
	(9694, '40670', 265, 'ads_cmusic', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(9695, '40680', 33, 'party_wc_girl', 3, 0, 0, 1, 0, 0, 34, 2990, 0, '', '1', '0'),
	(9696, '40690', 33, 'party_neon1', 3, 0, 0, 1, 0, 0, 21, 2991, 0, '', '1', '0'),
	(9697, '40700', 33, 'party_wc_boy', 3, 0, 0, 1, 0, 0, 33, 2992, 0, '', '1', '0'),
	(9698, '40710', 33, 'party_shelf', 5, 0, 0, 1, 0, 0, 28, 2993, 0, '', '1', '0'),
	(9699, '40720', 33, 'party_neon4', 3, 0, 0, 1, 0, 0, 24, 2994, 0, '', '1', '0'),
	(9700, '40730', 33, 'party_neon2', 3, 0, 0, 1, 0, 0, 22, 2995, 0, '', '1', '0'),
	(9701, '40740', 33, 'party_neon5', 3, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(9702, '40750', 33, 'party_neon3', 3, 0, 0, 1, 0, 0, 23, 2997, 0, '', '1', '0'),
	(9703, '40760', 475, 'xmas08_icewall', 3, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(9704, '40770', 475, 'xmas08_wallpaper', 3, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(9705, '40780', 516, 'ads_clwall2', 4, 0, 0, 1, 0, 0, 37, -1, 0, '', '1', '0'),
	(9707, '40800', 475, 'xmas_icewall', 3, 0, 0, 1, 0, 0, 367, -1, 0, '', '1', '0'),
	(9708, '40810', 529, 'ads_ob_wall', 4, 0, 0, 1, 0, 0, 114, -1, 0, '', '1', '0'),
	(9709, '40820', 516, 'ads_clwall1', 4, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(9710, '40830', 119, 'ads_mall_window', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9711, '40840', 302, 'china_pstr1', 3, 0, 0, 1, 0, 0, 40, -1, 0, '', '1', '0'),
	(9712, '40850', 302, 'china_pstr2', 3, 0, 0, 1, 0, 0, 43, -1, 0, '', '1', '0'),
	(9713, '40860', 302, 'china_light', 3, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(9714, '40870', 37, 'herry', 6, 0, 0, 1, 0, 0, 99, 40870, 0, '', '1', '0'),
	(9715, '40880', 58, 'ads_idol_wall', 4, 0, 0, 1, 0, 0, 30, -1, 0, '', '1', '0'),
	(9716, '40890', 121, 'ads_igorevilb', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(9717, '40900', 121, 'ads_igor_wall', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(9718, '40910', 119, 'ads_mall_winpet', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9719, '40920', 119, 'ads_mall_winfur', 4, 0, 0, 1, 0, 0, 40, -1, 0, '', '1', '0'),
	(9720, '40930', 58, 'ads_idol_tv', 4, 0, 0, 1, 0, 0, 28, -1, 0, '', '1', '0'),
	(9721, '40940', 303, 'Lost City Window 1', 3, 0, 0, 1, 0, 0, 20, 40940, 0, '', '1', '0'),
	(9722, '40950', 303, 'lc_wall1', 3, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(9723, '40960', 303, 'Lost City Window 2', 3, 0, 0, 1, 0, 0, 21, 40960, 0, '', '1', '0'),
	(9724, '40970', 303, 'lc_wall2', 3, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(9725, '40980', 119, 'ads_mall_wincin', 4, 0, 0, 1, 0, 0, 93, -1, 0, '', '1', '0'),
	(9726, '40990', 58, 'ads_idol_mirror', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(9727, '41000', 119, 'ads_mall_winbea', 4, 0, 0, 1, 0, 0, 91, -1, 0, '', '1', '0'),
	(9728, '41010', 119, 'ads_mall_winmus', 4, 0, 0, 1, 0, 0, 98, -1, 0, '', '1', '0'),
	(9729, '41020', 499, 'eco_curtains2', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(9730, '41030', 119, 'ads_mall_winchi', 4, 0, 0, 1, 0, 0, 92, -1, 0, '', '1', '0'),
	(9731, '41040', 499, 'eco_curtains3', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(9732, '41050', 499, 'eco_curtains1', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(9733, '41060', 119, 'ads_mall_winspo', 4, 0, 0, 1, 0, 0, 100, -1, 0, '', '1', '0'),
	(9734, '41070', 700, 'exe_wfall', 3, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(9735, '41080', 58, 'ads_idol_logo', 4, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(9736, '41090', 119, 'ads_mall_winice', 4, 0, 0, 1, 0, 0, 97, -1, 0, '', '1', '0'),
	(9737, '41100', 700, 'exe_map', 3, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(9738, '41110', 544, 'ads_puffet_tv', 4, 0, 0, 1, 0, 0, 119, -1, 0, '', '1', '0'),
	(9739, '41120', 353, 'ads_reebok_tv', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9740, '41130', 531, 'ads_malaco_tv', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9741, '41140', 282, 'country_forestwall', 3, 0, 0, 1, 0, 0, 7, 3952, 0, '', '1', '0'),
	(9742, '41150', 346, 'ads_lin_wh_c', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9743, '41160', 282, 'country_lantern', 3, 0, 0, 1, 0, 0, 11, 3994, 0, '', '1', '0'),
	(9744, '41170', 282, 'country_fp', 3, 0, 0, 1, 0, 0, 8, 3995, 0, '', '1', '0'),
	(9745, '41180', 282, 'country_wall', 3, 0, 0, 1, 0, 0, 20, 3996, 0, '', '1', '0'),
	(9746, '41190', 231, 'flag_norway', 4, 0, 0, 1, 0, 0, 15, 4042, 0, '', '1', '0'),
	(9747, '41200', 663, 'diner_poster', 3, 0, 0, 1, 0, 0, 55, -1, 0, '', '1', '0'),
	(9748, '41210', 32, 'lt_jngl_wall', 3, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(9749, '41220', 280, 'ads_mirror', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(9750, '41230', 32, 'lt_wall', 3, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(9751, '42200', 683, 'a2 slp', 4, 0, 0, 20, 0, 0, 17, 42200, 0, '', '1', '0'),
	(9752, '42210', 683, 'A2 tlp 20', 4, 0, 0, 20, 0, 0, 18, 42210, 0, '', '1', '0'),
	(9753, '42220', 564, 'ads_veet', 4, 0, 0, 1, 0, 0, 38, -1, 0, '', '1', '0'),
	(9754, '42230', 36, 'sf_wall3', 3, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(9755, '42240', 36, 'sf_window', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(9756, '42250', 119, 'ads_mall_wintra', 4, 0, 0, 1, 0, 0, 101, -1, 0, '', '1', '0'),
	(9757, '42260', 489, 'ads_wwe_poster', 4, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(9758, '42270', 36, 'sf_wall', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9759, '42280', 36, 'sf_wall2', 3, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(9760, '42290', 231, 'flag_belgium', 4, 0, 0, 1, 0, 0, 4, 4239, 0, '', '1', '0'),
	(9761, '42300', 119, 'ads_mall_wingar', 4, 0, 0, 1, 0, 0, 41, -1, 0, '', '1', '0'),
	(9762, '42310', 231, 'flag_portugal', 4, 0, 0, 1, 0, 0, 19, 4241, 0, '', '1', '0'),
	(9763, '42320', 34, 'rela_wall', 3, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(9764, '42330', 59, 'ktchn_knives', 3, 0, 0, 1, 0, 0, 11, 18141, 0, '', '1', '0'),
	(9765, '42340', 59, 'ktchn_oven', 3, 0, 0, 1, 0, 0, 13, 4264, 0, '', '1', '0'),
	(9766, '42350', 59, 'ktchn_wall', 3, 0, 0, 1, 0, 0, 19, 4265, 0, '', '1', '0'),
	(9767, '42360', 119, 'ads_mall_winclo', 4, 0, 0, 1, 0, 0, 94, -1, 0, '', '1', '0'),
	(9768, '42370', 16, 'dimmer_swtch', 10, 0, 0, 1, 0, 0, 2, 17815, 0, '', '1', '0'),
	(9769, '42380', 16, 'dimmer_buttn', 8, 0, 0, 1, 0, 0, 1, 17810, 0, '', '1', '0'),
	(9770, '42390', 16, 'dimmer_fuse2', 10, 0, 0, 1, 0, 0, 4, 4302, 0, '', '1', '0'),
	(9771, '42400', 16, 'dimmer_fuse6', 10, 0, 0, 1, 0, 0, 5, 4303, 0, '', '1', '0'),
	(9772, '42410', 530, 'ads_mtv_bigtv', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9773, '42420', 530, 'ads_mtv_tv', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9774, '42430', 58, 'ads_idol_l_logo', 5, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(9775, '42440', 272, 'urban_wall', 3, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(9776, '42450', 58, 'ads_idol_l_tv', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(9777, '42460', 231, 'flag_peru', 4, 0, 0, 1, 0, 0, 17, 4398, 0, '', '1', '0'),
	(9778, '42470', 390, 'hween09_crnr1', 3, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(9779, '42480', 231, 'flag_tunisia', 4, 0, 0, 1, 0, 0, 21, 4400, 0, '', '1', '0'),
	(9780, '42490', 231, 'flag_singapore', 4, 0, 0, 1, 0, 0, 20, 4401, 0, '', '1', '0'),
	(9781, '42500', 231, 'flag_mexico', 4, 0, 0, 1, 0, 0, 12, 4402, 0, '', '1', '0'),
	(9782, '42510', 231, 'flag_philippines', 4, 0, 0, 1, 0, 0, 18, 4403, 0, '', '1', '0'),
	(9783, '42520', 231, 'flag_malaysia', 4, 0, 0, 1, 0, 0, 11, 4404, 0, '', '1', '0'),
	(9784, '42530', 231, 'flag_greece', 4, 0, 0, 1, 0, 0, 10, 4405, 0, '', '1', '0'),
	(9785, '42540', 231, 'flag_venezl', 4, 0, 0, 1, 0, 0, 23, 4406, 0, '', '1', '0'),
	(9786, '42550', 231, 'flag_turkey', 4, 0, 0, 1, 0, 0, 22, 4407, 0, '', '1', '0'),
	(9787, '42560', 231, 'flag_chile', 4, 0, 0, 1, 0, 0, 5, 4408, 0, '', '1', '0'),
	(9788, '42570', 390, 'hween09_wall1', 3, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(9789, '42580', 231, 'flag_columbia', 4, 0, 0, 1, 0, 0, 6, 4410, 0, '', '1', '0'),
	(9790, '42590', 390, 'hween09_stonewall', 3, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(9791, '42600', 231, 'flag_newzealand', 4, 0, 0, 1, 0, 0, 14, 4412, 0, '', '1', '0'),
	(9792, '42610', 231, 'flag_argentina', 4, 0, 0, 1, 0, 0, 2, 4413, 0, '', '1', '0'),
	(9793, '42620', 231, 'flag_panama', 4, 0, 0, 1, 0, 0, 16, 4414, 0, '', '1', '0'),
	(9794, '42630', 390, 'hween09_paint', 3, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(9795, '42640', 231, 'flag_morocco', 4, 0, 0, 1, 0, 0, 13, 4416, 0, '', '1', '0'),
	(9796, '42650', 231, 'flag_dominicanrepublic', 4, 0, 0, 1, 0, 0, 8, 4417, 0, '', '1', '0'),
	(9797, '42660', 390, 'hween09_curt', 3, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(9798, '42670', 49, 'byesw_loadscreen', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(9799, '42680', 231, 'flag_ecuador', 4, 0, 0, 1, 0, 0, 9, 4420, 0, '', '1', '0'),
	(9800, '42690', 390, 'hween09_treewall', 3, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(9801, '42700', 231, 'flag_algeria', 4, 0, 0, 1, 0, 0, 1, 4422, 0, '', '1', '0'),
	(9802, '42710', 390, 'hween09_win', 3, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(9803, '42720', 44, 'ads_twi_paint', 4, 0, 0, 1, 0, 0, 51, -1, 0, '', '1', '0'),
	(9804, '42730', 44, 'ads_twi_dreamc', 4, 0, 0, 1, 0, 0, 132, -1, 0, '', '1', '0'),
	(9805, '42740', 44, 'ads_twi_bwall1', 4, 0, 0, 1, 0, 0, 128, -1, 0, '', '1', '0'),
	(9806, '42750', 44, 'ads_twi_crest', 4, 0, 0, 1, 0, 0, 131, -1, 0, '', '1', '0'),
	(9807, '42760', 44, 'ads_twi_bwall2', 4, 0, 0, 1, 0, 0, 48, -1, 0, '', '1', '0'),
	(9808, '42770', 44, 'ads_twi_windw', 4, 0, 0, 1, 0, 0, 53, -1, 0, '', '1', '0'),
	(9809, '42780', 476, 'xm09_bauble_24', 3, 0, 0, 1, 0, 0, 124, -1, 0, '', '1', '0'),
	(9810, '42790', 476, 'xm09_bauble_27', 3, 0, 0, 1, 0, 0, 127, -1, 0, '', '1', '0'),
	(9811, '42800', 476, 'xm09_stocking', 3, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(9812, '42810', 476, 'xm09_bauble_17', 3, 0, 0, 1, 0, 0, 117, -1, 0, '', '1', '0'),
	(9813, '42820', 476, 'xm09_bauble_4', 3, 0, 0, 1, 0, 0, 104, -1, 0, '', '1', '0'),
	(9814, '42830', 476, 'xm09_bauble_19', 3, 0, 0, 1, 0, 0, 119, -1, 0, '', '1', '0'),
	(9815, '42840', 476, 'xm09_bauble_6', 3, 0, 0, 1, 0, 0, 106, -1, 0, '', '1', '0'),
	(9816, '42850', 476, 'xm09_bauble_3', 3, 0, 0, 1, 0, 0, 43, -1, 0, '', '1', '0'),
	(9817, '42860', 476, 'xm09_bauble_25', 3, 0, 0, 1, 0, 0, 125, -1, 0, '', '1', '0'),
	(9818, '42870', 28, 'arabian_wall', 3, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(9819, '42880', 476, 'xm09_bauble_5', 3, 0, 0, 1, 0, 0, 105, -1, 0, '', '1', '0'),
	(9820, '42890', 476, 'xm09_bauble_11', 3, 0, 0, 1, 0, 0, 111, -1, 0, '', '1', '0'),
	(9821, '42900', 476, 'xm09_bauble_14', 3, 0, 0, 1, 0, 0, 114, -1, 0, '', '1', '0'),
	(9822, '42910', 476, 'xm09_bauble_7', 3, 0, 0, 1, 0, 0, 107, -1, 0, '', '1', '0'),
	(9823, '42920', 476, 'xm09_bauble_23', 3, 0, 0, 1, 0, 0, 47, -1, 0, '', '1', '0'),
	(9824, '42930', 476, 'xm09_bauble_10', 3, 0, 0, 1, 0, 0, 110, -1, 0, '', '1', '0'),
	(9825, '42940', 476, 'xm09_bauble_9', 3, 0, 0, 1, 0, 0, 109, -1, 0, '', '1', '0'),
	(9826, '42950', 476, 'xm09_bauble_8', 3, 0, 0, 1, 0, 0, 108, -1, 0, '', '1', '0'),
	(9827, '42960', 476, 'xm09_bauble_20', 3, 0, 0, 1, 0, 0, 45, -1, 0, '', '1', '0'),
	(9828, '42970', 476, 'xm09_bauble_2', 3, 0, 0, 1, 0, 0, 42, -1, 0, '', '1', '0'),
	(9829, '42980', 476, 'xm09_bauble_18', 3, 0, 0, 1, 0, 0, 118, -1, 0, '', '1', '0'),
	(9830, '42990', 476, 'xm09_bauble_13', 3, 0, 0, 1, 0, 0, 113, -1, 0, '', '1', '0'),
	(9831, '43000', 476, 'xm09_bauble_1', 3, 0, 0, 1, 0, 0, 101, -1, 0, '', '1', '0'),
	(9832, '43010', 476, 'xm09_bauble_15', 3, 0, 0, 1, 0, 0, 115, -1, 0, '', '1', '0'),
	(9833, '43020', 476, 'xm09_bauble_22', 3, 0, 0, 1, 0, 0, 46, -1, 0, '', '1', '0'),
	(9834, '43030', 476, 'xm09_bauble_16', 3, 0, 0, 1, 0, 0, 116, -1, 0, '', '1', '0'),
	(9835, '43040', 476, 'xm09_bauble_12', 3, 0, 0, 1, 0, 0, 44, -1, 0, '', '1', '0'),
	(9836, '43050', 476, 'xm09_bauble_21', 3, 0, 0, 1, 0, 0, 121, -1, 0, '', '1', '0'),
	(9837, '43060', 476, 'xm09_bauble_26', 3, 0, 0, 1, 0, 0, 126, -1, 0, '', '1', '0'),
	(9838, '43070', 476, 'xm09_firwall', 3, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(9839, '43080', 476, 'xm09_forestwall', 3, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(9840, '43090', 476, 'xm09_infotv', 3, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(9841, '43100', 33, 'party_lights', 3, 0, 0, 1, 0, 0, 100, 18186, 0, '', '1', '0'),
	(9842, '43110', 476, 'xm09_lodgewall', 3, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(9843, '43120', 476, 'xm09_frplc', 3, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(9844, '43130', 275, 'year2010', 3, 0, 0, 1, 0, 0, -5, -1, 0, '', '1', '0'),
	(9845, '43140', 302, 'china_pstr3', 3, 0, 0, 1, 0, 0, 44, -1, 0, '', '1', '0'),
	(9846, '43150', 461, 'ads_tv_jaapuisto', 4, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(9847, '43160', 50, 'val09_wall2', 3, 0, 0, 1, 0, 0, 45, -1, 0, '', '1', '0'),
	(9848, '43170', 50, 'val09_wdrobe_g', 3, 0, 0, 1, 0, 0, 47, -1, 0, '', '1', '0'),
	(9849, '43180', 50, 'val09_wall1', 3, 0, 0, 1, 0, 0, 44, -1, 0, '', '1', '0'),
	(9850, '43190', 50, 'bling_sink', 3, 0, 0, 1, 0, 0, 34, -1, 0, '', '1', '0'),
	(9851, '43200', 50, 'val09_wdrobe_b', 3, 0, 0, 1, 0, 0, 46, -1, 0, '', '1', '0'),
	(9852, '43210', 50, 'bling_cabinet', 3, 0, 0, 1, 0, 0, 26, -1, 0, '', '1', '0'),
	(9853, '43220', 542, 'ads_percyw', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9854, '43230', 264, 'ads_boost_surfb', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(9855, '43240', 516, 'ads_tlc_wheel', 4, 0, 0, 1, 0, 0, 33, -1, 0, '', '1', '0'),
	(9856, '43250', 401, 'garden_wall', 3, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(9857, '43260', 563, 'ads_tv_yle', 4, 0, 0, 1, 0, 0, 37, -1, 0, '', '1', '0'),
	(9858, '43270', 53, 'runway_shelf', 5, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(9859, '43280', 346, 'ads_latrobe_flag', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(9860, '43290', 352, 'hc3_walldeco', 5, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '1'),
	(9861, '43300', 527, 'ads_nokia_x6', 4, 0, 0, 1, 0, 0, 44, -1, 0, '', '1', '0'),
	(9862, '43310', 53, 'runway_fabric', 3, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(9863, '43320', 44, 'ads_target_wall', 4, 0, 0, 1, 0, 0, 32, -1, 0, '', '1', '0'),
	(9864, '43330', 561, 'ads_super_pop', 4, 0, 0, 1, 0, 0, 29, -1, 0, '', '1', '0'),
	(9865, '43340', 546, 'ads_tv_chocapic_02', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(9866, '43350', 546, 'ads_tv_chocapic_01', 4, 0, 0, 1, 0, 0, 34, -1, 0, '', '1', '0'),
	(9867, '43360', 403, 'bw_jaws', 3, 0, 0, 1, 0, 0, 17, 8757, 0, '', '1', '0'),
	(9868, '43370', 534, 'ads_grefusa_surfb', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9869, '43380', 59, 'ktchn10_cabnt', 3, 0, 0, 1, 0, 0, 21, 8897, 0, '', '1', '0'),
	(9870, '43390', 444, 'hosptl_xray', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9871, '43400', 391, 'hween10_fogwall', 3, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(9872, '43410', 45, 'bb_painimies1', 3, 0, 0, 1, 0, 0, 18, 8959, 0, '', '1', '0'),
	(9873, '43420', 45, 'bb_painimies2', 3, 0, 0, 1, 0, 0, 17, 8960, 0, '', '1', '0'),
	(9874, '43430', 530, 'ads_mtv_bigtv2', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9875, '43440', 530, 'ads_mtv_tv2', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9876, '43450', 391, 'hween10_card_3', 3, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(9877, '43460', 391, 'hween10_card_1', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(9878, '43470', 391, 'hween10_card_4', 3, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(9879, '43480', 391, 'hween10_card_6', 3, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(9880, '43490', 391, 'hween10_wallskull', 3, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(9881, '43500', 391, 'hween10_card_2', 3, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(9882, '43510', 391, 'hween10_card_5', 3, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(9883, '43520', 527, 'ads_nokiax3_wall2', 4, 0, 0, 1, 0, 0, 108, -1, 0, '', '1', '0'),
	(9884, '43530', 527, 'ads_nokiax3_wall3', 4, 0, 0, 1, 0, 0, 109, -1, 0, '', '1', '0'),
	(9885, '43540', 527, 'ads_nokiax3_wall1', 4, 0, 0, 1, 0, 0, 107, -1, 0, '', '1', '0'),
	(9886, '43550', 527, 'ads_nokiax3_phn', 4, 0, 0, 1, 0, 0, 106, -1, 0, '', '1', '0'),
	(9887, '43560', 700, 'exe_sensor', 3, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(9888, '43570', 477, 'qt_calendar2', 4, 0, 0, 1, 0, 0, 33, -1, 0, '', '1', '0'),
	(9889, '43580', 520, 'ads_r7logo', 4, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(9890, '43590', 477, 'qt_calendar0', 4, 0, 0, 1, 0, 0, 31, -1, 0, '', '1', '0'),
	(9891, '43600', 477, 'qt_calendar1', 4, 0, 0, 1, 0, 0, 32, -1, 0, '', '1', '0'),
	(9892, '43610', 477, 'qt_xm10_bauble2', 4, 0, 0, 1, 0, 0, 35, -1, 0, '', '1', '0'),
	(9893, '43620', 477, 'es_build1', 3, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(9894, '43630', 477, 'es_build4', 3, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(9895, '43640', 477, 'es_build2', 3, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(9896, '43650', 477, 'qt_xm10_bauble1', 4, 0, 0, 1, 0, 0, 34, -1, 0, '', '1', '0'),
	(9897, '43660', 477, 'es_build3', 3, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(9898, '43670', 477, 'es_window', 3, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(9899, '4367', 255, 'es_window', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(9900, '43680', 477, 'qt_xm10_bauble3', 4, 0, 0, 1, 0, 0, 36, -1, 0, '', '1', '0'),
	(9901, '43690', 477, 'qt_xm10_icestar', 4, 0, 0, 1, 0, 0, 42, -1, 0, '', '1', '0'),
	(9902, '43700', 477, 'es_big1', 3, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(9903, '43710', 477, 'es_big3', 3, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(9904, '43720', 477, 'es_big2', 3, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(9905, '43730', 275, 'year2011', 3, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(9906, '43740', 50, 'bling11_wall1', 3, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(9907, '43750', 50, 'bling11_wall4', 3, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(9908, '43760', 50, 'bling11_wall2', 3, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(9909, '43770', 50, 'bling11_wall3', 3, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(9910, '43780', 459, 'qt_val11_heartlights', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(9911, '43790', 50, 'bling11_big1', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(9912, '43800', 30, 'gothic_st_glass', 3, 0, 0, 1, 0, 0, 40, -1, 0, '', '1', '0'),
	(9913, '43810', 263, 'ads_bigtv_missmix', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(9914, '43820', 280, 'cine_light2', 3, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(9915, '43830', 280, 'cine_light1', 3, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(9916, '43840', 56, 'cubie_decal_3_b', 3, 0, 0, 1, 0, 0, 15, 9599, 0, '', '1', '0'),
	(9917, '43850', 56, 'cubie_decklight_p', 3, 0, 0, 1, 0, 0, 18, 18045, 0, '', '1', '0'),
	(9918, '43860', 56, 'cubie_decal_1_b', 3, 0, 0, 1, 0, 0, 10, 9601, 0, '', '1', '0'),
	(9919, '43870', 56, 'cubie_decal_2_b', 3, 0, 0, 1, 0, 0, 12, 9602, 0, '', '1', '0'),
	(9920, '43880', 56, 'cubie_decal_3_p', 3, 0, 0, 1, 0, 0, 16, 9603, 0, '', '1', '0'),
	(9921, '43890', 56, 'cubie_wallshelf_b', 5, 0, 0, 1, 0, 0, 38, 9604, 0, '', '1', '0'),
	(9922, '43900', 56, 'cubie_decal_1_p', 3, 0, 0, 1, 0, 0, 11, 9605, 0, '', '1', '0'),
	(9923, '43910', 56, 'cubie_decal_3', 3, 0, 0, 1, 0, 0, 14, 9606, 0, '', '1', '0'),
	(9924, '43920', 56, 'cubie_wallshelf_p', 5, 0, 0, 1, 0, 0, 39, 9607, 0, '', '1', '0'),
	(9925, '43930', 56, 'cubie_decal_2_p', 3, 0, 0, 1, 0, 0, 13, 9608, 0, '', '1', '0'),
	(9926, '43940', 56, 'cubie_decklight_b', 3, 0, 0, 1, 0, 0, 17, 18046, 0, '', '1', '0'),
	(9927, '43950', 56, 'cubie_decal_0', 3, 0, 0, 1, 0, 0, 9, 9610, 0, '', '1', '0'),
	(9928, '43960', 57, 'waasa_wall_shelf2', 5, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(9929, '43970', 57, 'waasa_wall_shelf1', 5, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(9930, '43980', 379, 'easter11_wall', 3, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(9931, '43990', 382, 'ads_suunvuorow', 4, 0, 0, 1, 0, 0, 31, -1, 0, '', '1', '0'),
	(9932, '44000', 462, 'ads_volkswagen_poster', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(9933, '44010', 346, 'picture_car', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9934, '44020', 185, 'ads_kfp2_tv', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(9935, '44030', 185, 'ads_kfp2_wall', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(9936, '44040', 104, 'dng_wall', 3, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(9937, '44050', 305, 'ads_cchups_screen', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9938, '44060', 272, 'sb_tag1', 3, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(9939, '44070', 272, 'sb_wall', 3, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(9940, '44080', 272, 'sb_tag2', 3, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(9941, '44090', 272, 'sb_tag3', 3, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(9942, '44100', 554, 'ads_durex_screen', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9943, '44110', 530, 'ads_mtv_wall', 4, 0, 0, 1, 0, 0, 105, -1, 0, '', '1', '0'),
	(9944, '44120', 407, 'summer_sunset_wall', 3, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(9945, '44130', 60, 'usva5_wallrug', 3, 0, 0, 1, 0, 0, 126, 10355, 0, '', '1', '0'),
	(9946, '44140', 60, 'usva3_wallrug', 3, 0, 0, 1, 0, 0, 108, 10356, 0, '', '1', '0'),
	(9947, '44150', 60, 'usva_wallrug', 3, 0, 0, 1, 0, 0, 138, 10357, 0, '', '1', '0'),
	(9948, '44160', 60, 'usva4_wallrug', 3, 0, 0, 1, 0, 0, 16, 10358, 0, '', '1', '0'),
	(9949, '44170', 60, 'usva2_wallrug', 3, 0, 0, 1, 0, 0, 8, 10359, 0, '', '1', '0'),
	(9950, '44180', 467, 'school_chalkboard', 3, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(9951, '44190', 467, 'school_urinal', 3, 0, 0, 1, 0, 0, 40, -1, 0, '', '1', '0'),
	(9952, '44200', 467, 'school_wall', 3, 0, 0, 1, 0, 0, 41, -1, 0, '', '1', '0'),
	(9953, '44210', 467, 'school_charts', 3, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(9954, '44220', 467, 'school_toilet_wall', 3, 0, 0, 1, 0, 0, 39, -1, 0, '', '1', '0'),
	(9955, '44230', 106, 'boutique_lampwall', 3, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(9956, '44240', 106, 'boutique_shrack2', 3, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(9957, '44250', 106, 'boutique_shrack1', 3, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(9958, '44260', 106, 'boutique_speakers', 3, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(9959, '44270', 106, 'boutique_clrack2', 3, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(9960, '44280', 106, 'boutique_clrack1', 3, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(9961, '44290', 552, 'ads_flag_un', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(9962, '44300', 245, 'horse_pitchfork_wall', 3, 0, 0, 1, 0, 0, 34, 10523, 0, '', '1', '0'),
	(9963, '44310', 245, 'horse_stable_wall', 3, 0, 0, 1, 0, 0, 10, 10524, 0, '', '1', '0'),
	(9964, '44320', 245, 'horse_stable_wall_w', 3, 0, 0, 1, 0, 0, 11, 10526, 0, '', '1', '0'),
	(9965, '44330', 245, 'horse_shoe_wall', 3, 0, 0, 1, 0, 0, 33, 10528, 0, '', '1', '0'),
	(9966, '44340', 392, 'hween11_window', 3, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(9967, '44350', 479, 'xmas11_hd4', 3, 0, 0, 1, 0, 0, 44, -1, 0, '', '1', '0'),
	(9968, '44360', 479, 'xmas11_wall', 3, 0, 0, 1, 0, 0, 69, -1, 0, '', '1', '0'),
	(9969, '44370', 479, 'xmas11_hd2', 3, 0, 0, 1, 0, 0, 42, -1, 0, '', '1', '0'),
	(9970, '44380', 479, 'xmas11_hd5', 3, 0, 0, 1, 0, 0, 45, -1, 0, '', '1', '0'),
	(9971, '44390', 479, 'xmas11_hd3', 3, 0, 0, 1, 0, 0, 43, -1, 0, '', '1', '0'),
	(9972, '44400', 479, 'xmas11_hd1', 3, 0, 0, 1, 0, 0, 41, -1, 0, '', '1', '0'),
	(9973, '44410', 479, 'xmas11_hd6', 3, 0, 0, 1, 0, 0, 46, -1, 0, '', '1', '0'),
	(9974, '44420', 301, 'ads_alvinsurf', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(9975, '44430', 479, 'xmas11_cuckoo', 3, 0, 0, 1, 0, 0, 34, -1, 0, '', '1', '0'),
	(9976, '44440', 532, 'ads_m6_wall', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9977, '44450', 275, 'year2012', 3, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(9978, '44460', 412, 'snowb_mountain_wall', 5, 0, 0, 1, 0, 0, 99, 10796, 0, '', '1', '0'),
	(9979, '44470', 231, 'flag_denmark', 4, 0, 0, 1, 0, 0, 7, 10827, 0, '', '1', '0'),
	(9980, '44480', 468, 'urban_wall_china', 3, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(9981, '44490', 545, 'ads_antena3_wall', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(9982, '44500', 479, 'xm11_stocking', 3, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(9983, '44510', 467, 'wallchair', 3, 0, 0, 1, 0, 0, 44, -1, 0, '', '1', '0'),
	(9984, '44520', 31, 'jp_window', 3, 0, 0, 1, 0, 0, 40, -1, 0, '', '1', '0'),
	(9985, '44530', 31, 'jp_wall', 3, 0, 0, 1, 0, 0, 41, -1, 0, '', '1', '0'),
	(9986, '44540', 212, 'stone_wall', 3, 0, 0, 1, 0, 0, 47, 11117, 0, '', '1', '0'),
	(9987, '44550', 212, 'gardenshed_wall', 3, 0, 0, 1, 0, 0, 3, 11118, 0, '', '1', '0'),
	(9988, '44560', 701, 'js_exe_wfall', 3, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(9989, '44570;50036', 523, 'football12_es', 3, 0, 0, 1, 0, 0, 36, 11233, 0, '', '1', '0'),
	(9990, '44580;50038', 523, 'football12_it', 3, 0, 0, 1, 0, 0, 37, 11232, 0, '', '1', '0'),
	(9991, '44590;50039', 523, 'football12_de', 3, 0, 0, 1, 0, 0, 35, 11234, 0, '', '1', '0'),
	(9992, '44600;50037', 523, 'football12_pt', 3, 0, 0, 1, 0, 0, 38, 11231, 0, '', '1', '0'),
	(9993, '44610', 120, 'anc_savanna_wall', 3, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(9994, '44620', 120, 'anc_sunset_wall', 3, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(9995, '44630', 697, 'lon_skyline', 4, 0, 0, 1, 0, 0, 206, -1, 0, '', '1', '0'),
	(9996, '44640', 393, 'hween12_dartboard', 3, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(9997, '44650', 74, 'hs_wall', 3, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(9998, '44660', 74, 'hs_wlight', 3, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(9999, '44670', 74, 'hs_applause', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10000, '44680', 481, 'xmas12_wall_in', 3, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(10001, '44690', 481, 'xmas12_window', 3, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(10002, '44700', 481, 'xmas12_wall_out', 3, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(10003, '44710', 481, 'xmas12_door', 3, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(10004, '44720', 481, 'xmas12_torch', 3, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(10005, '44750', 275, 'year2013', 3, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(10006, '44760', 67, 'ny2013_wall', 3, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(10007, '44770', 302, 'china_pstr4', 3, 0, 0, 1, 0, 0, 45, -1, 0, '', '1', '0'),
	(10008, '44780', 450, 'val13_wall_2', 3, 0, 0, 1, 0, 0, 29, -1, 0, '', '1', '0'),
	(10009, '44790', 450, 'val13_wall_3', 3, 0, 0, 1, 0, 0, 30, -1, 0, '', '1', '0'),
	(10010, '44800', 450, 'val13_wall_1', 3, 0, 0, 1, 0, 0, 28, -1, 0, '', '1', '0'),
	(10011, '44810', 24, 'pixel_clock_red', 3, 0, 0, 1, 0, 0, 20, 11956, 0, '', '1', '0'),
	(10012, '44820', 24, 'pixel_walldeco', 3, 0, 0, 1, 0, 0, 70, 11957, 0, '', '1', '0'),
	(10013, '44830', 24, 'pixel_clock_pink', 3, 0, 0, 1, 0, 0, 19, 11958, 0, '', '1', '0'),
	(10014, '44840', 24, 'pixel_mirror', 3, 0, 0, 1, 0, 0, 72, 11959, 0, '', '1', '0'),
	(10015, '44850', 24, 'pixel_clock_black', 3, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(10016, '44860', 24, 'pixel_clock_green', 3, 0, 0, 1, 0, 0, 18, 11961, 0, '', '1', '0'),
	(10017, '44870', 24, 'pixel_clock_blue', 3, 0, 0, 1, 0, 0, 17, 11962, 0, '', '1', '0'),
	(10018, '44880', 24, 'pixel_wall_green', 3, 0, 0, 1, 0, 0, 62, 12146, 0, '', '1', '0'),
	(10019, '44890', 24, 'pixel_wall_red', 3, 0, 0, 1, 0, 0, 64, 12147, 0, '', '1', '0'),
	(10020, '44900', 24, 'pixel_painting_pink', 3, 0, 0, 1, 0, 0, 41, 12148, 0, '', '1', '0'),
	(10021, '44910', 24, 'pixel_painting_green', 3, 0, 0, 1, 0, 0, 40, 12149, 0, '', '1', '0'),
	(10022, '44920', 24, 'pixel_wall_pink', 3, 0, 0, 1, 0, 0, 63, 12150, 0, '', '1', '0'),
	(10023, '44930', 24, 'pixel_painting_black', 3, 0, 0, 1, 0, 0, 38, -1, 0, '', '1', '0'),
	(10024, '44940', 24, 'pixel_painting_blue', 3, 0, 0, 1, 0, 0, 39, 12152, 0, '', '1', '0'),
	(10025, '44950', 24, 'pixel_painting_red', 3, 0, 0, 1, 0, 0, 42, 12153, 0, '', '1', '0'),
	(10026, '44960', 24, 'pixel_wall_blue', 3, 0, 0, 1, 0, 0, 61, 12154, 0, '', '1', '0'),
	(10027, '44970', 24, 'pixel_wall_black', 3, 0, 0, 1, 0, 0, 60, -1, 0, '', '1', '0'),
	(10028, '44980', 24, 'pixel_poster2', 3, 0, 0, 1, 0, 0, 71, -1, 0, '', '1', '0'),
	(10029, '44990', 70, 'dimmer_steampunk', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(10030, '45000', 70, 'steampunk_wall2', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(10031, '45010', 70, 'steampunk_wall1', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(10032, '45020', 70, 'steampunk_window', 3, 0, 0, 1, 0, 0, 29, 12326, 0, '', '1', '0'),
	(10033, '45030', 70, 'steampunk_map', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(10034, '45040', 380, 'easter13_wall3', 3, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(10035, '45050', 380, 'easter13_window', 3, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0');
REPLACE INTO `catalog_items` (`id`, `item_ids`, `page_id`, `catalog_name`, `cost_credits`, `cost_points`, `points_type`, `amount`, `limited_stack`, `limited_sells`, `order_number`, `offer_id`, `song_id`, `extradata`, `have_offer`, `club_only`) VALUES
	(10036, '45060', 380, 'easter13_wall1', 3, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(10037, '45070', 380, 'easter13_wall2', 3, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(10038, '45080', 62, 'mystics_bwall', 3, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(10039, '45090', 62, 'mystics_gwall', 3, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(10040, '45100', 231, 'flag_austria', 4, 0, 0, 1, 0, 0, 3, 12813, 0, '', '1', '0'),
	(10041, '45110', 272, 'grungewall', 3, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(10042, '45120', 467, 'school_chalkboard2', 3, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(10043, '45130', 280, 'cine_pstr_6', 3, 0, 0, 1, 0, 0, 77, -1, 0, '', '1', '0'),
	(10044, '45140', 280, 'cine_pstr_4', 3, 0, 0, 1, 0, 0, 77, -1, 0, '', '1', '0'),
	(10045, '45150', 280, 'cine_pstr_7', 3, 0, 0, 1, 0, 0, 77, -1, 0, '', '1', '0'),
	(10046, '45160', 280, 'cine_pstr_8', 3, 0, 0, 1, 0, 0, 77, -1, 0, '', '1', '0'),
	(10047, '45170', 280, 'cine_pstr_1', 3, 0, 0, 1, 0, 0, 71, -1, 0, '', '1', '0'),
	(10048, '45180', 280, 'cine_pstr_5', 3, 0, 0, 1, 0, 0, 77, -1, 0, '', '1', '0'),
	(10049, '45190', 280, 'cine_pstr_0', 3, 0, 0, 1, 0, 0, 70, -1, 0, '', '1', '0'),
	(10050, '45200', 280, 'cine_pstr_3', 3, 0, 0, 1, 0, 0, 77, -1, 0, '', '1', '0'),
	(10051, '45210', 280, 'cine_pstr_9', 3, 0, 0, 1, 0, 0, 77, -1, 0, '', '1', '0'),
	(10052, '45220', 280, 'cine_pstr_2', 3, 0, 0, 1, 0, 0, 77, -1, 0, '', '1', '0'),
	(10053, '45230', 683, 'habbopage_wall', 4, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(10054, '45240', 346, 'brnd_cscape_wall', 4, 0, 0, 1, 0, 0, 44, -1, 0, '', '1', '0'),
	(10055, '45250', 527, 'ads_nokiax3_wallb', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(10056, '45260', 527, 'ads_nokiax3_wall', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(10057, '45270', 429, 'builderwall_exp', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(10058, '45280', 429, 'test_habbopage_display', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(10059, '45290', 280, 'cine_pstr_10', 3, 0, 0, 1, 0, 0, 72, -1, 0, '', '1', '0'),
	(10060, '45300', 354, 'hc_exe_wfall', 5, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '1'),
	(10061, '45310', 506, 'post_it_xmas', 4, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(10062, '45320', 275, 'year2014', 3, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(10063, '45330', 506, 'post_it_dreams', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(10064, '45340', 302, 'china_pstr5', 3, 0, 0, 1, 0, 0, 46, -1, 0, '', '1', '0'),
	(10065, '45350', 506, 'storieshero_poster', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(10066, '45360', 274, 'external_image_wallitem', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(10067, '45370', 299, 'val14_wall1', 3, 0, 0, 1, 0, 0, -8, 18084, 0, '', '1', '0'),
	(10068, '45380', 299, 'val14_wall3', 3, 0, 0, 1, 0, 0, -6, 18085, 0, '', '1', '0'),
	(10069, '45390', 299, 'val14_wall2', 3, 0, 0, 1, 0, 0, -7, 18083, 0, '', '1', '0'),
	(10070, '45400', 506, 'post_it_shakesp', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(10071, '45410', 274, 'external_image_wallitem_photo', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(10072, '45420', 53, 'runway_fabric2', 3, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(10073, '45430', 506, 'stories_sch_glass', 4, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(10074, '45440', 381, 'easter14_wall', 3, 0, 0, 1, 0, 0, 44, -1, 0, '', '1', '0'),
	(10075, '45450', 491, 'diamond_painting6', 3, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(10078, '45460', 491, 'diamond_painting4', 4, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(10079, '45470', 491, 'diamond_painting2', 3, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(10081, '45480', 491, 'diamond_painting5', 3, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(10083, '45490', 491, 'diamond_painting1', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10084, '45500', 491, 'diamond_painting3', 3, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(10086, '45510', 110, 'vikings_banner_r', 3, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(10087, '45520', 110, 'vikings_banner_g', 3, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(10088, '45530', 110, 'vikings_wallshield_g', 3, 0, 0, 1, 0, 0, 38, -1, 0, '', '1', '0'),
	(10089, '45540', 110, 'vikings_wallshield_r', 3, 0, 0, 1, 0, 0, 39, -1, 0, '', '1', '0'),
	(10090, '45550', 110, 'vikings_wall_g', 3, 0, 0, 1, 0, 0, 40, -1, 0, '', '1', '0'),
	(10091, '45560', 110, 'vikings_wall_r', 3, 0, 0, 1, 0, 0, 41, -1, 0, '', '1', '0'),
	(10092, '45570', 506, 'post_it_juninas', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(10093, '45580', 269, 'hblooza14_wall', 3, 0, 0, 1, 0, 0, 133, -1, 0, '', '1', '0'),
	(10094, '45590', 112, 'wildwest_wallpaper', 3, 0, 0, 1, 0, 0, 64, -1, 0, '', '1', '0'),
	(10095, '45600', 112, 'st_wildwest_wallskull', 3, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(10096, '45610', 114, 'uni_floppy', 3, 0, 0, 1, 0, 0, 24, 14135, 0, '', '1', '0'),
	(10097, '45620', 114, 'uni_fairylights', 3, 0, 0, 1, 0, 0, 23, 14136, 0, '', '1', '0'),
	(10098, '45630', 114, 'uni_poster1', 3, 0, 0, 1, 0, 0, 52, 14137, 0, '', '1', '0'),
	(10099, '45640', 114, 'uni_pinupgirl', 3, 0, 0, 1, 0, 0, 47, 14138, 0, '', '1', '0'),
	(10100, '45650', 114, 'uni_hipdeer', 3, 0, 0, 1, 0, 0, 35, 14139, 0, '', '1', '0'),
	(10101, '45660', 114, 'uni_poster2', 3, 0, 0, 1, 0, 0, 53, 14140, 0, '', '1', '0'),
	(10102, '45670', 114, 'uni_libraryshelf', 5, 0, 0, 1, 0, 0, 38, -1, 0, '', '1', '0'),
	(10103, '45680', 114, 'uni_coatrack', 3, 0, 0, 1, 0, 0, 17, 14142, 0, '', '1', '0'),
	(10104, '45690', 114, 'uni_girlcoatrack', 3, 0, 0, 1, 0, 0, 32, 14143, 0, '', '1', '0'),
	(10105, '45700', 114, 'uni_pinupboy', 3, 0, 0, 1, 0, 0, 46, 14144, 0, '', '1', '0'),
	(10106, '45710', 114, 'uni_vinyl', 3, 0, 0, 1, 0, 0, 58, 14145, 0, '', '1', '0'),
	(10107, '45720', 114, 'uni_moustache', 3, 0, 0, 1, 0, 0, 42, 14146, 0, '', '1', '0'),
	(10108, '45730', 182, 'bathroom_wall4', 4, 0, 0, 1, 0, 0, 33, -1, 0, '', '1', '0'),
	(10109, '45740', 182, 'bathroom_wall1', 4, 0, 0, 1, 0, 0, 30, 14180, 0, '', '1', '0'),
	(10110, '45750', 182, 'bathroom_wall3', 4, 0, 0, 1, 0, 0, 32, -1, 0, '', '1', '0'),
	(10111, '45760', 182, 'bathroom_wall2', 4, 0, 0, 1, 0, 0, 31, -1, 0, '', '1', '0'),
	(10112, '45770', 114, 'st_uni_poster', 3, 0, 0, 1, 0, 0, 4, 14183, 0, '', '1', '0'),
	(10113, '45780', 395, 'hween14_stainglass', 3, 0, 0, 1, 0, 0, 40, -1, 0, '', '1', '0'),
	(10114, '45790', 395, 'hween14_hcglass', 3, 0, 0, 1, 0, 0, 32, 14258, 0, '', '1', '0'),
	(10115, '45800', 395, 'hween14_wall', 3, 0, 0, 1, 0, 0, 43, -1, 0, '', '1', '0'),
	(10116, '45810', 274, 'external_image_wallitem_poster', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(10117, '45820', 280, 'cine_pstr_11', 3, 0, 0, 1, 0, 0, 73, -1, 0, '', '1', '0'),
	(10118, '45830', 280, 'cine_pstr_18', 3, 0, 0, 1, 0, 0, 77, -1, 0, '', '1', '0'),
	(10119, '45840', 280, 'cine_pstr_16', 3, 0, 0, 1, 0, 0, 77, -1, 0, '', '1', '0'),
	(10120, '45850', 280, 'cine_pstr_12', 3, 0, 0, 1, 0, 0, 74, -1, 0, '', '1', '0'),
	(10121, '45860', 280, 'cine_pstr_19', 3, 0, 0, 1, 0, 0, 77, -1, 0, '', '1', '0'),
	(10122, '45870', 280, 'cine_pstr_13', 3, 0, 0, 1, 0, 0, 75, -1, 0, '', '1', '0'),
	(10123, '45880', 280, 'cine_pstr_15', 3, 0, 0, 1, 0, 0, 77, -1, 0, '', '1', '0'),
	(10124, '45890', 280, 'cine_pstr_14', 3, 0, 0, 1, 0, 0, 77, -1, 0, '', '1', '0'),
	(10125, '45900', 280, 'cine_pstr_17', 3, 0, 0, 1, 0, 0, 77, -1, 0, '', '1', '0'),
	(10126, '45910', 280, 'st_pstr_felipe', 3, 0, 0, 1, 0, 0, 78, -1, 0, '', '1', '0'),
	(10127, '45920', 355, 'hc_arab_wndw', 5, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '1'),
	(10128, '45930', 355, 'hc_arab_swords', 5, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '1'),
	(10129, '45940', 456, 'val15_fujiwall', 3, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(10130, '45950', 116, 'attic15_wall', 3, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(10131, '45960', 116, 'attic15_painting', 3, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(10132, '45970', 274, 'external_image_wallitem_poster_small', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(10133, '45980', 854, 'carnival15_wallmask', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10134, '45990', 118, 'cpunk_c15_wall', 3, 0, 0, 1, 0, 0, 26, -1, 0, '', '1', '0'),
	(10135, '46000', 302, 'china_pstr6', 3, 0, 0, 1, 0, 0, 47, -1, 0, '', '1', '0'),
	(10136, '46010', 429, 'cypunk_c15_wall', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(10137, '46020', 400, 'cland_c15_wall', 3, 0, 0, 1, 0, 0, 29, -1, 0, '', '1', '0'),
	(10138, '46030', 491, 'diamond_painting9', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(10139, '46040', 491, 'diamond_painting18', 4, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(10140, '46050', 491, 'diamond_painting17', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(10141, '46060', 491, 'diamond_painting15', 4, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(10142, '46070', 491, 'diamond_painting16', 4, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(10143, '46080', 491, 'diamond_painting14', 4, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(10144, '46090', 491, 'diamond_painting13', 4, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(10145, '46100', 491, 'diamond_painting10', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(10146, '46110', 491, 'diamond_painting7', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(10147, '46120', 491, 'diamond_painting12', 4, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(10148, '46130', 491, 'diamond_painting11', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(10149, '46140', 158, 'army15_poster', 3, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(10150, '46150', 158, 'army_c15_insig', 3, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(10151, '46160', 158, 'army15_largescreen', 3, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(10152, '46170', 158, 'army_c15_wall', 3, 0, 0, 1, 0, 0, 40, -1, 0, '', '1', '0'),
	(10153, '46180', 199, 'dino_c15_wallpiece', 3, 0, 0, 1, 0, 0, 35, -1, 0, '', '1', '0'),
	(10154, '46190', 161, 'paris_c15_wall', 3, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(10155, '46200', 18, 'lodge_c15_window', 4, 0, 0, 1, 0, 0, 20, 18151, 0, '', '1', '0'),
	(10156, '46210', 18, 'lodge_c15_wall', 4, 0, 0, 1, 0, 0, 19, 16633, 0, '', '1', '0'),
	(10157, '46220', 104, 'drago_c15_flag', 3, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(10158, '46230', 120, 'anc_c15_wall', 3, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(10159, '46240', 408, 'tiki_c15_wall', 3, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(10160, '46250', 700, 'exe_c15_wall', 3, 0, 0, 1, 0, 0, 26, -1, 0, '', '1', '0'),
	(10161, '46260', 35, 'romantique_c15_wall', 3, 0, 0, 1, 0, 0, 50, -1, 0, '', '1', '0'),
	(10162, '46270', 50, 'bling_c15_wall', 3, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(10163, '46280', 396, 'hween_c15_sky', 3, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(10164, '46290', 280, 'cine_pstr_20', 3, 0, 0, 1, 0, 0, 77, -1, 0, '', '1', '0'),
	(10165, '46300', 59, 'ktchn_c15_cupboard', 3, 0, 0, 1, 0, 0, 47, 16978, 0, '', '1', '0'),
	(10166, '46310', 683, 'gift_hhome', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(10167, '46320', 727, 'gold_c15_arc_icewall', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(10168, '46330', 485, 'xmas_c15_advent9', 3, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(10169, '46340', 485, 'xmas_c15_advent10', 3, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(10170, '46350', 302, 'Monkey Poster', 3, 0, 0, 1, 0, 0, 49, 46350, 0, '', '1', '0'),
	(10171, '46360', 845, 'gothic_r16_fountain', 4, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(10172, '46370', 280, 'super_c16_pstriron', 3, 0, 0, 1, 0, 0, 80, -1, 0, '', '1', '0'),
	(10173, '46380', 280, 'super_c16_pstrcat', 3, 0, 0, 1, 0, 0, 79, -1, 0, '', '1', '0'),
	(10174, '46390', 280, 'super_c16_pstrsulk', 3, 0, 0, 1, 0, 0, 82, -1, 0, '', '1', '0'),
	(10175, '46400', 280, 'super_c16_pstrlove', 3, 0, 0, 1, 0, 0, 81, -1, 0, '', '1', '0'),
	(10176, '46410', 697, 'olympics_c16_walldecal', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(10177, '46420', 486, 'xmas_c16_painting', 3, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(10178, '46430', 362, 'classic5_window', 4, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(10179, '46440', 302, 'Rooster Poster', 3, 0, 0, 1, 0, 0, 50, 46440, 0, '', '1', '0'),
	(10180, '46450', 119, 'mall_c17_winclo', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(10181, '46460', 119, 'mall_c17_winpet', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(10182, '46470', 119, 'mall_c17_winspo', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(10183, '46480', 383, 'easter_c17_countrybg', 3, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(10184, '46490', 275, 'year2018', 3, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(10185, '46500', 357, 'hc17_7', 5, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '1'),
	(10186, '46510', 302, 'china_pstr9', 3, 0, 0, 1, 0, 0, 48, -1, 0, '', '1', '0'),
	(10187, '46520', 424, 'coralking_c18_seabg', 3, 0, 0, 1, 0, 0, 40, -1, 0, '', '1', '0'),
	(10188, '46530', 491, 'diamond_painting26', 4, 0, 0, 1, 0, 0, 26, -1, 0, '', '1', '0'),
	(10189, '46540', 491, 'diamond_painting28', 4, 0, 0, 1, 0, 0, 28, -1, 0, '', '1', '0'),
	(10190, '46550', 491, 'diamond_painting27', 4, 0, 0, 1, 0, 0, 27, -1, 0, '', '1', '0'),
	(10191, '46560', 491, 'diamond_painting23', 4, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(10192, '46570', 491, 'diamond_painting21', 4, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(10193, '46580', 491, 'diamond_painting20', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(10194, '46590', 491, 'diamond_painting19', 4, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(10195, '46600', 491, 'diamond_painting24', 4, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(10196, '46610', 491, 'diamond_painting29', 4, 0, 0, 1, 0, 0, 29, -1, 0, '', '1', '0'),
	(10197, '46620', 491, 'diamond_painting30', 4, 0, 0, 1, 0, 0, 30, -1, 0, '', '1', '0'),
	(10198, '46630', 491, 'diamond_painting22', 4, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(10199, '46640', 491, 'diamond_painting25', 4, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(10200, '46650', 399, 'hween_c18_labwallpanel', 3, 0, 0, 1, 0, 0, 34, -1, 0, '', '1', '0'),
	(10201, '46660', 488, 'xmas_c18_starrybg', 3, 0, 0, 1, 0, 0, 44, -1, 0, '', '1', '0'),
	(10202, '46670', 275, 'year2019', 3, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(10203, '46680', 302, 'china_pstr10', 3, 0, 0, 1, 0, 0, 41, -1, 0, '', '1', '0'),
	(10204, '46690', 385, 'easter_c19_forrestbg', 3, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '1'),
	(10205, '46700', 525, 'fest_c19_bgwall', 3, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(10206, '46710', 491, 'diamond_painting37', 4, 0, 0, 1, 0, 0, 37, -1, 0, '', '1', '0'),
	(10207, '46720', 491, 'diamond_painting33', 4, 0, 0, 1, 0, 0, 33, -1, 0, '', '1', '0'),
	(10208, '46730', 491, 'diamond_painting31', 4, 0, 0, 1, 0, 0, 31, -1, 0, '', '1', '0'),
	(10209, '46740', 491, 'diamond_painting36', 4, 0, 0, 1, 0, 0, 36, -1, 0, '', '1', '0'),
	(10210, '46750', 491, 'diamond_painting40', 4, 0, 0, 1, 0, 0, 40, -1, 0, '', '1', '0'),
	(10211, '46760', 491, 'diamond_painting35', 4, 0, 0, 1, 0, 0, 35, -1, 0, '', '1', '0'),
	(10212, '46770', 491, 'diamond_painting41', 4, 0, 0, 1, 0, 0, 41, -1, 0, '', '1', '0'),
	(10213, '46780', 491, 'diamond_painting32', 4, 0, 0, 1, 0, 0, 32, -1, 0, '', '1', '0'),
	(10214, '46790', 491, 'diamond_painting38', 4, 0, 0, 1, 0, 0, 38, -1, 0, '', '1', '0'),
	(10215, '46800', 491, 'diamond_painting34', 4, 0, 0, 1, 0, 0, 34, -1, 0, '', '1', '0'),
	(10216, '46810', 433, 'celestial_c19_wall', 3, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(10217, '46820', 433, 'celestial_c19_constellations', 3, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(10218, '46830', 521, 'hween_c19_mistywoodsbg', 3, 0, 0, 1, 0, 0, 14, 21590, 0, '', '1', '0'),
	(10219, '46840', 302, 'china_pstr11', 3, 0, 0, 1, 0, 0, 42, -1, 0, '', '1', '0'),
	(10220, '46850', 275, 'year2020', 3, 0, 0, 1, 0, 0, 369, -1, 0, '', '1', '0'),
	(10221, '46860', 517, 'art_c20_wall', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(10222, '46870', 517, 'art_c20_window', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(10223, '46880', 696, 'india_c20_sunsetbg', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(10224, '46890', 491, 'diamond_painting52', 3, 0, 0, 1, 0, 0, 52, -1, 0, '', '1', '0'),
	(10225, '46900', 491, 'diamond_painting42', 3, 0, 0, 1, 0, 0, 42, -1, 0, '', '1', '0'),
	(10226, '46910', 491, 'diamond_painting46', 3, 0, 0, 1, 0, 0, 46, -1, 0, '', '1', '0'),
	(10227, '46920', 491, 'diamond_painting51', 3, 0, 0, 1, 0, 0, 51, -1, 0, '', '1', '0'),
	(10228, '46930', 491, 'diamond_painting44', 3, 0, 0, 1, 0, 0, 44, -1, 0, '', '1', '0'),
	(10229, '46940', 491, 'diamond_painting45', 3, 0, 0, 1, 0, 0, 45, -1, 0, '', '1', '0'),
	(10230, '46950', 491, 'diamond_painting43', 3, 0, 0, 1, 0, 0, 43, -1, 0, '', '1', '0'),
	(10231, '50000', 75, 'a0 pet0', 20, 0, 0, 1, 0, 0, 0, 50000, 0, '', '0', '0'),
	(10232, '50001', 76, 'a0 pet1', 20, 0, 0, 1, 0, 0, 1, 50001, 0, '', '0', '0'),
	(10233, '50002', 77, 'a0 pet2', 20, 0, 0, 1, 0, 0, 2, 50002, 0, '', '0', '0'),
	(10234, '50003', 78, 'a0 pet3', 20, 0, 0, 1, 0, 0, 3, 50003, 0, '', '0', '0'),
	(10235, '50004', 79, 'a0 pet4', 20, 0, 0, 1, 0, 0, 4, 50004, 0, '', '0', '0'),
	(10236, '50005', 80, 'a0 pet5', 20, 0, 0, 1, 0, 0, 5, 50005, 0, '', '0', '0'),
	(10237, '50006', 81, 'a0 pet6', 20, 0, 0, 1, 0, 0, 6, 50006, 0, '', '0', '0'),
	(10238, '50007', 82, 'a0 pet7', 20, 0, 0, 1, 0, 0, 7, 50007, 0, '', '0', '0'),
	(10239, '50008', 83, 'a0 pet8', 15, 0, 0, 1, 0, 0, 8, 50008, 0, '', '0', '0'),
	(10240, '50009', 84, 'a0 pet9', 20, 0, 0, 1, 0, 0, 9, 50009, 0, '', '0', '0'),
	(10241, '50010', 85, 'a0 pet10', 0, 75, 0, 1, 0, 0, 10, 50010, 0, '', '0', '0'),
	(10242, '50011', 86, 'a0 pet11', 15, 0, 0, 1, 0, 0, 10, 50011, 0, '', '0', '0'),
	(10243, '50012', 87, 'a0 pet12', 12, 0, 0, 1, 0, 0, 11, 50012, 0, '', '0', '0'),
	(10244, '50014', 88, 'a0 pet14', 20, 0, 0, 1, 0, 0, 14, 50014, 0, '', '0', '0'),
	(10245, '50015', 89, 'a0 pet15', 20, 0, 0, 1, 0, 0, 13, 50015, 0, '', '0', '0'),
	(10246, '50017', 90, 'a0 pet17', 0, 75, 0, 1, 0, 0, 17, 50017, 0, '', '0', '0'),
	(10247, '50018', 91, 'a0 pet18', 0, 75, 0, 1, 0, 0, 18, 50018, 0, '', '0', '0'),
	(10248, '50019', 92, 'a0 pet19', 0, 75, 0, 1, 0, 0, 19, 50019, 0, '', '0', '0'),
	(10249, '50020', 93, 'a0 pet20', 0, 75, 0, 1, 0, 0, 20, 50020, 0, '', '0', '0'),
	(10250, '50021', 94, 'a0 pet21', 0, 75, 0, 1, 0, 0, 21, 50021, 0, '', '0', '0'),
	(10251, '50022', 95, 'a0 pet22', 0, 75, 0, 1, 0, 0, 15, 50022, 0, '', '0', '0'),
	(10252, '50023', 96, 'a0 pet23', 0, 75, 0, 1, 0, 0, 23, 50023, 0, '', '0', '0'),
	(10253, '50024', 97, 'a0 pet24', 0, 75, 0, 1, 0, 0, 24, 50024, 0, '', '0', '0'),
	(10254, '50025', 98, 'a0 pet25', 0, 75, 0, 1, 0, 0, 25, 50025, 0, '', '0', '0'),
	(10255, '50028', 99, 'a0 pet28', 0, 75, 0, 1, 0, 0, 28, 50028, 0, '', '0', '0'),
	(10256, '50029', 100, 'a0 pet29', 0, 75, 0, 1, 0, 0, 29, 50029, 0, '', '0', '0'),
	(10257, '50030', 101, 'a0 pet30', 0, 75, 0, 1, 0, 0, 17, 50030, 0, '', '0', '0'),
	(10258, '50031', 429, 'a0 pet31', 0, 75, 0, 1, 0, 0, 31, 50031, 0, '', '0', '0'),
	(10259, '50032', 685, 'a0 pet32', 0, 75, 0, 1, 0, 0, 32, 50032, 0, '', '0', '0'),
	(10260, '50035', 681, 'a0 pet35', 0, 75, 0, 1, 0, 0, 17, 50035, 0, '', '0', '0'),
	(10261, '50037', 683, 'Football_PT', 3, 0, 0, 1, 0, 0, 20, 50037, 0, '', '1', '0'),
	(10262, '50038', 683, 'Football_IT', 3, 0, 0, 1, 0, 0, 21, 50038, 0, '', '1', '0'),
	(10263, '50039', 683, 'Football_DE', 3, 0, 0, 1, 0, 0, 22, 50039, 0, '', '1', '0'),
	(10264, '40010', 21, 'poster 1', 4, 0, 0, 1, 0, 0, 20, 40010, 0, '1', '1', '0'),
	(10265, '40010', 21, 'poster 2', 4, 0, 0, 1, 0, 0, 21, 40010, 0, '2', '1', '0'),
	(10266, '40010', 21, 'poster 3', 4, 0, 0, 1, 0, 0, 22, 40010, 0, '3', '1', '0'),
	(10267, '40010', 21, 'poster 4', 4, 0, 0, 1, 0, 0, 23, 40010, 0, '4', '1', '0'),
	(10268, '40010', 21, 'poster 5', 4, 0, 0, 1, 0, 0, 24, 40010, 0, '5', '1', '0'),
	(10269, '40010', 21, 'poster 6', 4, 0, 0, 1, 0, 0, 25, 40010, 0, '6', '1', '0'),
	(10270, '40010', 21, 'poster 7', 4, 0, 0, 1, 0, 0, 26, 40010, 0, '7', '1', '0'),
	(10271, '40010', 21, 'poster 8', 4, 0, 0, 1, 0, 0, 27, 40010, 0, '8', '1', '0'),
	(10272, '40010', 21, 'poster 9', 4, 0, 0, 1, 0, 0, 28, 40010, 0, '9', '1', '0'),
	(10273, '40010', 21, 'poster 10', 4, 0, 0, 1, 0, 0, 29, 40010, 0, '10', '1', '0'),
	(10274, '40010', 21, 'poster 11', 4, 0, 0, 1, 0, 0, 30, 40010, 0, '11', '1', '0'),
	(10275, '40010', 21, 'poster 12', 4, 0, 0, 1, 0, 0, 31, 40010, 0, '12', '1', '0'),
	(10276, '40010', 21, 'poster 13', 4, 0, 0, 1, 0, 0, 32, 40010, 0, '13', '1', '0'),
	(10277, '40010', 21, 'poster 14', 4, 0, 0, 1, 0, 0, 33, 40010, 0, '14', '1', '0'),
	(10278, '40010', 21, 'poster 15', 4, 0, 0, 1, 0, 0, 34, 40010, 0, '15', '1', '0'),
	(10279, '40010', 21, 'poster 16', 4, 0, 0, 1, 0, 0, 35, 40010, 0, '16', '1', '0'),
	(10280, '40010', 21, 'poster 17', 4, 0, 0, 1, 0, 0, 36, 40010, 0, '17', '1', '0'),
	(10281, '40010', 21, 'poster 18', 4, 0, 0, 1, 0, 0, 37, 40010, 0, '18', '1', '0'),
	(10282, '40010', 21, 'poster 19', 4, 0, 0, 1, 0, 0, 38, 40010, 0, '19', '1', '0'),
	(10283, '40010', 21, 'poster 20', 4, 0, 0, 1, 0, 0, 39, 40010, 0, '20', '1', '0'),
	(10284, '40010', 21, 'poster 21', 4, 0, 0, 1, 0, 0, 40, 40010, 0, '21', '1', '0'),
	(10285, '40010', 21, 'poster 22', 4, 0, 0, 1, 0, 0, 41, 40010, 0, '22', '1', '0'),
	(10286, '40010', 21, 'poster 23', 4, 0, 0, 1, 0, 0, 42, 40010, 0, '23', '1', '0'),
	(10287, '40010', 21, 'poster 24', 4, 0, 0, 1, 0, 0, 43, 40010, 0, '24', '1', '0'),
	(10288, '40010', 21, 'poster 25', 4, 0, 0, 1, 0, 0, 44, 40010, 0, '25', '1', '0'),
	(10289, '40010', 21, 'poster 26', 4, 0, 0, 1, 0, 0, 45, 40010, 0, '26', '1', '0'),
	(10290, '40010', 21, 'poster 27', 4, 0, 0, 1, 0, 0, 46, 40010, 0, '27', '1', '0'),
	(10291, '40010', 21, 'poster 28', 4, 0, 0, 1, 0, 0, 47, 40010, 0, '28', '1', '0'),
	(10292, '40010', 21, 'poster 29', 4, 0, 0, 1, 0, 0, 48, 40010, 0, '29', '1', '0'),
	(10293, '40010', 21, 'poster 30', 4, 0, 0, 1, 0, 0, 49, 40010, 0, '30', '1', '0'),
	(10294, '40010', 21, 'poster 31', 4, 0, 0, 1, 0, 0, 50, 40010, 0, '31', '1', '0'),
	(10295, '40010', 21, 'poster 32', 4, 0, 0, 1, 0, 0, 60, 40010, 0, '32', '1', '0'),
	(10296, '40010', 21, 'poster 33', 4, 0, 0, 1, 0, 0, 61, 40010, 0, '33', '1', '0'),
	(10297, '40010', 21, 'poster 34', 4, 0, 0, 1, 0, 0, 62, 40010, 0, '34', '1', '0'),
	(10298, '40010', 21, 'poster 35', 4, 0, 0, 1, 0, 0, 63, 40010, 0, '35', '1', '0'),
	(10299, '40010', 21, 'poster 36', 4, 0, 0, 1, 0, 0, 64, 40010, 0, '36', '1', '0'),
	(10300, '40010', 21, 'poster 37', 4, 0, 0, 1, 0, 0, 65, 40010, 0, '37', '1', '0'),
	(10301, '40010', 21, 'poster 38', 4, 0, 0, 1, 0, 0, 66, 40010, 0, '38', '1', '0'),
	(10302, '40010', 21, 'poster 39', 4, 0, 0, 1, 0, 0, 67, 40010, 0, '39', '1', '0'),
	(10303, '40010', 21, 'poster 40', 4, 0, 0, 1, 0, 0, 68, 40010, 0, '40', '1', '0'),
	(10304, '40010', 21, 'poster 41', 4, 0, 0, 1, 0, 0, 69, 40010, 0, '41', '1', '0'),
	(10305, '40010', 21, 'poster 42', 4, 0, 0, 1, 0, 0, 70, 40010, 0, '42', '1', '0'),
	(10306, '40010', 21, 'poster 43', 4, 0, 0, 1, 0, 0, 80, 40010, 0, '43', '1', '0'),
	(10307, '40010', 21, 'poster 44', 4, 0, 0, 1, 0, 0, 81, 40010, 0, '44', '1', '0'),
	(10308, '40010', 21, 'poster 45', 4, 0, 0, 1, 0, 0, 82, 40010, 0, '45', '1', '0'),
	(10309, '40010', 21, 'poster 46', 4, 0, 0, 1, 0, 0, 83, 40010, 0, '46', '1', '0'),
	(10310, '40010', 21, 'poster 47', 4, 0, 0, 1, 0, 0, 84, 40010, 0, '47', '1', '0'),
	(10311, '40010', 21, 'poster 48', 4, 0, 0, 1, 0, 0, 85, 40010, 0, '48', '1', '0'),
	(10312, '40010', 21, 'poster 49', 4, 0, 0, 1, 0, 0, 86, 40010, 0, '49', '1', '0'),
	(10313, '40010', 21, 'poster 51', 4, 0, 0, 1, 0, 0, 87, 40010, 0, '50', '1', '0'),
	(10314, '40010', 21, 'poster 52', 4, 0, 0, 1, 0, 0, 88, 40010, 0, '51', '1', '0'),
	(10315, '40010', 21, 'poster 53', 4, 0, 0, 1, 0, 0, 89, 40010, 0, '52', '1', '0'),
	(10316, '40010', 21, 'poster 54', 4, 0, 0, 1, 0, 0, 90, 40010, 0, '53', '1', '0'),
	(10317, '40010', 21, 'poster 55', 4, 0, 0, 1, 0, 0, 100, 40010, 0, '54', '1', '0'),
	(10318, '40010', 101, 'poster 56', 4, 0, 0, 1, 0, 0, 21, 40010, 0, '55', '1', '0'),
	(10319, '40010', 663, 'poster 57', 4, 0, 0, 1, 0, 0, 102, 40010, 0, '57', '1', '0'),
	(10320, '40010', 21, 'poster 58', 4, 0, 0, 1, 0, 0, 103, 40010, 0, '57', '1', '0'),
	(10321, '40010', 21, 'poster 59', 4, 0, 0, 1, 0, 0, 104, 40010, 0, '58', '1', '0'),
	(10322, '40010', 231, 'poster 500', 4, 0, 0, 1, 0, 0, 24, 40010, 0, '500', '1', '0'),
	(10323, '40010', 231, 'poster 501', 4, 0, 0, 1, 0, 0, 25, 40010, 0, '501', '1', '0'),
	(10324, '40010', 231, 'poster 502', 4, 0, 0, 1, 0, 0, 26, 40010, 0, '502', '1', '0'),
	(10325, '40010', 231, 'poster 503', 4, 0, 0, 1, 0, 0, 27, 40010, 0, '503', '1', '0'),
	(10326, '40010', 231, 'poster 504', 4, 0, 0, 1, 0, 0, 28, 40010, 0, '504', '1', '0'),
	(10327, '40010', 231, 'poster 505', 4, 0, 0, 1, 0, 0, 29, 40010, 0, '505', '1', '0'),
	(10328, '40010', 231, 'poster 506', 4, 0, 0, 1, 0, 0, 30, 40010, 0, '506', '1', '0'),
	(10329, '40010', 231, 'poster 507', 4, 0, 0, 1, 0, 0, 31, 40010, 0, '507', '1', '0'),
	(10330, '40010', 231, 'poster 508', 4, 0, 0, 1, 0, 0, 32, 40010, 0, '508', '1', '0'),
	(10331, '40010', 231, 'poster 509', 4, 0, 0, 1, 0, 0, 33, 40010, 0, '509', '1', '0'),
	(10332, '40010', 231, 'poster 510', 4, 0, 0, 1, 0, 0, 34, 40010, 0, '510', '1', '0'),
	(10333, '40010', 231, 'poster 511', 4, 0, 0, 1, 0, 0, 35, 40010, 0, '511', '1', '0'),
	(10334, '40010', 231, 'poster 512', 4, 0, 0, 1, 0, 0, 36, 40010, 0, '512', '1', '0'),
	(10335, '40010', 231, 'poster 513', 4, 0, 0, 1, 0, 0, 37, 40010, 0, '513', '1', '0'),
	(10336, '40010', 231, 'poster 514', 4, 0, 0, 1, 0, 0, 38, 40010, 0, '514', '1', '0'),
	(10337, '40010', 231, 'poster 515', 4, 0, 0, 1, 0, 0, 39, 40010, 0, '515', '1', '0'),
	(10338, '40010', 231, 'poster 516', 4, 0, 0, 1, 0, 0, 40, 40010, 0, '516', '1', '0'),
	(10339, '40010', 231, 'poster 517', 4, 0, 0, 1, 0, 0, 41, 40010, 0, '517', '1', '0'),
	(10340, '40010', 231, 'poster 518', 4, 0, 0, 1, 0, 0, 42, 40010, 0, '518', '1', '0'),
	(10341, '40010', 231, 'poster 520', 4, 0, 0, 1, 0, 0, 43, 40010, 0, '520', '1', '0'),
	(10342, '40010', 231, 'poster 521', 4, 0, 0, 1, 0, 0, 44, 40010, 0, '521', '1', '0'),
	(10343, '40010', 231, 'poster 522', 4, 0, 0, 1, 0, 0, 45, 40010, 0, '522', '1', '0'),
	(10344, '40010', 231, 'poster 523', 4, 0, 0, 1, 0, 0, 46, 40010, 0, '523', '1', '0'),
	(10345, '40010', 429, 'poster 38', 4, 0, 0, 1, 0, 0, 82, 40010, 0, '38', '1', '0'),
	(10346, '40010', 21, 'poster 1000', 4, 0, 0, 1, 0, 0, 110, 40010, 0, '1000', '1', '0'),
	(10347, '40010', 21, 'poster 1001', 4, 0, 0, 1, 0, 0, 111, 40010, 0, '1001', '1', '0'),
	(10348, '40010', 21, 'poster 1002', 4, 0, 0, 1, 0, 0, 112, 40010, 0, '1002', '1', '0'),
	(10349, '40010', 21, 'poster 1003', 4, 0, 0, 1, 0, 0, 113, 40010, 0, '1003', '1', '0'),
	(10350, '40010', 663, 'poster 1004', 4, 0, 0, 1, 0, 0, 50, 40010, 0, '1004', '1', '0'),
	(10351, '40010', 21, 'poster 1005', 4, 0, 0, 1, 0, 0, 115, 40010, 0, '1005', '1', '0'),
	(10352, '40010', 21, 'poster 1006', 4, 0, 0, 1, 0, 0, 116, 40010, 0, '1006', '1', '0'),
	(10353, '40010', 21, 'poster 2000', 4, 0, 0, 1, 0, 0, 120, 40010, 0, '2000', '1', '0'),
	(10354, '40010', 21, 'poster 2001', 4, 0, 0, 1, 0, 0, 121, 40010, 0, '2001', '1', '0'),
	(10355, '40010', 21, 'poster 2002', 4, 0, 0, 1, 0, 0, 122, 40010, 0, '2002', '1', '0'),
	(10356, '40010', 21, 'poster 2003', 4, 0, 0, 1, 0, 0, 123, 40010, 0, '2003', '1', '0'),
	(10357, '40010', 21, 'poster 2009', 4, 0, 0, 1, 0, 0, 127, 40010, 0, '2004', '1', '0'),
	(10358, '40010', 663, 'infobus', 5, 0, 0, 1, 0, 0, 6, 40010, 0, '2005', '1', '0'),
	(10359, '40010', 21, 'poster 2006', 4, 0, 0, 1, 0, 0, 124, 40010, 0, '2006', '1', '0'),
	(10360, '40010', 21, 'poster 2007', 4, 0, 0, 1, 0, 0, 125, 40010, 0, '2007', '1', '0'),
	(10361, '40010', 21, 'poster 2008', 4, 0, 0, 1, 0, 0, 126, 40010, 0, '2008', '1', '0'),
	(10362, '59964', 683, 'Football_PT', 3, 0, 0, 1, 0, 0, 23, 59964, 0, '', '1', '0'),
	(10363, '2607', 254, 'song_disk', 1, 0, 0, 1, 0, 0, 1, 18805, 25, 'electric_pixels', '1', '0'),
	(10364, '2607', 254, 'song_disk', 1, 0, 0, 1, 0, 0, 2, 18805, 23, 'lost_my_tapes_at_goa', '1', '0'),
	(10365, '2607', 254, 'song_disk', 1, 0, 0, 1, 0, 0, 3, 18805, 21, 'epic_flail', '1', '0'),
	(10366, '2607', 254, 'song_disk', 1, 0, 0, 1, 0, 0, 4, 18805, 26, 'xmas_2011', '1', '0'),
	(10367, '2607', 254, 'song_disk', 1, 0, 0, 1, 0, 0, 5, 18805, 27, 'who_dares_stacks', '1', '0'),
	(10368, '2607', 254, 'song_disk', 1, 0, 0, 1, 0, 0, 6, 18805, 24, 'galactic_disco', '1', '0'),
	(10369, '2607', 254, 'song_disk', 1, 0, 0, 1, 0, 0, 7, 18805, 22, 'alley_cat_in_trouble', '1', '0'),
	(10370, '2607', 254, 'song_disk', 1, 0, 0, 1, 0, 0, 8, 18805, 15, 'party_trax', '1', '0'),
	(10371, '2607', 254, 'song_disk', 1, 0, 0, 1, 0, 0, 9, 18805, 14, 'double_peks', '1', '0'),
	(10372, '2607', 254, 'song_disk', 1, 0, 0, 1, 0, 0, 10, 18805, 20, 'chilled_trax', '1', '0'),
	(10373, '2607', 254, 'song_disk', 1, 0, 0, 1, 0, 0, 10, 18805, 13, 'weirdodo', '1', '0'),
	(10374, '2607', 254, 'song_disk', 1, 0, 0, 1, 0, 0, 12, 18805, 12, 'haadolocknloll', '1', '0'),
	(10375, '2607', 254, 'song_disk', 1, 0, 0, 1, 0, 0, 12, 18805, 11, 'good_trade', '1', '0'),
	(10376, '2607', 254, 'song_disk', 1, 0, 0, 1, 0, 0, 14, 18805, 1, 'ballad_of_bonnie', '1', '0'),
	(10377, '2607', 254, 'song_disk', 1, 0, 0, 1, 0, 0, 13, 18805, 2, 'bossa_nova', '1', '0'),
	(10378, '2607', 254, 'song_disk', 1, 0, 0, 1, 0, 0, 14, 18805, 10, 'disco_extreme', '1', '0'),
	(10379, '2607', 254, 'song_disk', 1, 0, 0, 1, 0, 0, 17, 18805, 9, 'klub_haus', '1', '0'),
	(10380, '2607', 254, 'song_disk', 1, 0, 0, 1, 0, 0, 18, 18805, 8, 'limber_take', '1', '0'),
	(10381, '2607', 254, 'song_disk', 1, 0, 0, 1, 0, 0, 19, 18805, 7, 'miami_miamor', '1', '0'),
	(10382, '2607', 254, 'song_disk', 1, 0, 0, 1, 0, 0, 20, 18805, 6, 'gold_coin_digger', '1', '0'),
	(10383, '2607', 254, 'song_disk', 1, 0, 0, 1, 0, 0, 21, 18805, 18, 'park_adventure', '1', '0'),
	(10384, '2607', 254, 'song_disk', 1, 0, 0, 1, 0, 0, 15, 18805, 4, 'pianissimo', '1', '0'),
	(10385, '2607', 254, 'song_disk', 1, 0, 0, 1, 0, 0, 23, 18805, 17, 'rnb_swat_teem', '1', '0'),
	(10386, '2960', 605, 'party_chair', 3, 0, 0, 1, 0, 0, 99, 2981, 0, '', '1', '0'),
	(10387, '1656', 605, 'queue_tile1*2', 7, 0, 0, 1, 0, 0, 99, 17887, 0, '', '1', '0'),
	(10388, '19894', 13, 'floor_single_501', 1, 0, 0, 1, 0, 0, 99, 19894, 0, '', '1', '0'),
	(10389, '19894', 13, 'floor_single_502', 1, 0, 0, 1, 0, 0, 99, 19894, 0, '', '1', '0'),
	(10390, '19894', 13, 'floor_single_503', 1, 0, 0, 1, 0, 0, 99, 19894, 0, '', '1', '0'),
	(10391, '19894', 13, 'floor_single_504', 1, 0, 0, 1, 0, 0, 99, 19894, 0, '', '1', '0'),
	(10392, '19894', 13, 'floor_single_505', 1, 0, 0, 1, 0, 0, 99, 19894, 0, '', '1', '0'),
	(10393, '19894', 13, 'floor_single_506', 1, 0, 0, 1, 0, 0, 99, 19894, 0, '', '1', '0'),
	(10394, '19894', 13, 'floor_single_507', 1, 0, 0, 1, 0, 0, 99, 19894, 0, '', '1', '0'),
	(10395, '19894', 13, 'floor_single_601', 1, 0, 0, 1, 0, 0, 99, 19894, 0, '', '1', '0'),
	(10396, '19894', 13, 'floor_single_602', 1, 0, 0, 1, 0, 0, 99, 19894, 0, '', '1', '0'),
	(10397, '19894', 13, 'floor_single_602', 1, 0, 0, 1, 0, 0, 99, 19894, 0, '', '1', '0'),
	(10398, '19894', 13, 'floor_single_604', 1, 0, 0, 1, 0, 0, 99, 19894, 0, '', '1', '0'),
	(10399, '19894', 13, 'floor_single_605', 1, 0, 0, 1, 0, 0, 99, 19894, 0, '', '1', '0'),
	(10400, '19894', 13, 'floor_single_606', 1, 0, 0, 1, 0, 0, 99, 19894, 0, '', '1', '0'),
	(10401, '19894', 13, 'floor_single_607', 1, 0, 0, 1, 0, 0, 99, 19894, 0, '', '1', '0'),
	(10402, '19894', 13, 'floor_single_608', 1, 0, 0, 1, 0, 0, 99, 19894, 0, '', '1', '0'),
	(10403, '19894', 13, 'floor_single_609', 1, 0, 0, 1, 0, 0, 99, 19894, 0, '', '1', '0'),
	(10404, '19894', 13, 'floor_single_610', 1, 0, 0, 1, 0, 0, 99, 19894, 0, '', '1', '0'),
	(10405, '19926', 13, 'landscape_single_1.1', 1, 0, 0, 1, 0, 0, 99, 19926, 0, '', '1', '0'),
	(10406, '19926', 13, 'landscape_single_2.1', 1, 0, 0, 1, 0, 0, 99, 19926, 0, '', '1', '0'),
	(10407, '19926', 13, 'landscape_single_3.1', 1, 0, 0, 1, 0, 0, 99, 19926, 0, '', '1', '0'),
	(10408, '19926', 13, 'landscape_single_4.1', 1, 0, 0, 1, 0, 0, 99, 19926, 0, '', '1', '0'),
	(10409, '19926', 13, 'landscape_single_5.1', 1, 0, 0, 1, 0, 0, 99, 19926, 0, '', '1', '0'),
	(10410, '19926', 13, 'landscape_single_6.1', 1, 0, 0, 1, 0, 0, 99, 19926, 0, '', '1', '0'),
	(10411, '19926', 13, 'landscape_single_7.1', 1, 0, 0, 1, 0, 0, 99, 19926, 0, '', '1', '0'),
	(10412, '19926', 13, 'landscape_single_1.2', 1, 0, 0, 1, 0, 0, 99, 19926, 0, '', '1', '0'),
	(10413, '19926', 13, 'landscape_single_1.3', 1, 0, 0, 1, 0, 0, 99, 19926, 0, '', '1', '0'),
	(10414, '19926', 13, 'landscape_single_2.3', 1, 0, 0, 1, 0, 0, 99, 19926, 0, '', '1', '0'),
	(10415, '19926', 13, 'landscape_single_3.3', 1, 0, 0, 1, 0, 0, 99, 19926, 0, '', '1', '0'),
	(10416, '19926', 13, 'landscape_single_4.3', 1, 0, 0, 1, 0, 0, 99, 19926, 0, '', '1', '0'),
	(10417, '19926', 13, 'landscape_single_5.3', 1, 0, 0, 1, 0, 0, 99, 19926, 0, '', '1', '0'),
	(10418, '19926', 13, 'landscape_single_6.3', 1, 0, 0, 1, 0, 0, 99, 19926, 0, '', '1', '0'),
	(10419, '19926', 13, 'landscape_single_7.3', 1, 0, 0, 1, 0, 0, 99, 19926, 0, '', '1', '0'),
	(10420, '19926', 13, 'landscape_single_1.4', 1, 0, 0, 1, 0, 0, 99, 19926, 0, '', '1', '0'),
	(10421, '19926', 13, 'landscape_single_2.4', 1, 0, 0, 1, 0, 0, 99, 19926, 0, '', '1', '0'),
	(10422, '19926', 13, 'landscape_single_3.4', 1, 0, 0, 1, 0, 0, 99, 19926, 0, '', '1', '0'),
	(10423, '19926', 13, 'landscape_single_4.4', 1, 0, 0, 1, 0, 0, 99, 19926, 0, '', '1', '0'),
	(10424, '19926', 13, 'landscape_single_5.4', 1, 0, 0, 1, 0, 0, 99, 19926, 0, '', '1', '0'),
	(10425, '19926', 13, 'landscape_single_6.4', 1, 0, 0, 1, 0, 0, 99, 19926, 0, '', '1', '0'),
	(10426, '19926', 13, 'landscape_single_7.4', 1, 0, 0, 1, 0, 0, 99, 19926, 0, '', '1', '0'),
	(10427, '19926', 13, 'landscape_single_1.5', 1, 0, 0, 1, 0, 0, 99, 19926, 0, '', '1', '0'),
	(10428, '19926', 13, 'landscape_single_2.5', 1, 0, 0, 1, 0, 0, 99, 19926, 0, '', '1', '0'),
	(10429, '19926', 13, 'landscape_single_3.5', 1, 0, 0, 1, 0, 0, 99, 19926, 0, '', '1', '0'),
	(10430, '19926', 13, 'landscape_single_4.5', 1, 0, 0, 1, 0, 0, 99, 19926, 0, '', '1', '0'),
	(10431, '19926', 13, 'landscape_single_5.5', 1, 0, 0, 1, 0, 0, 99, 19926, 0, '', '1', '0'),
	(10432, '19926', 13, 'landscape_single_6.5', 1, 0, 0, 1, 0, 0, 99, 19926, 0, '', '1', '0'),
	(10433, '19926', 13, 'landscape_single_7.5', 1, 0, 0, 1, 0, 0, 99, 19926, 0, '', '1', '0'),
	(10434, '19926', 13, 'landscape_single_1.6', 1, 0, 0, 1, 0, 0, 99, 19926, 0, '', '1', '0'),
	(10435, '19926', 13, 'landscape_single_2.6', 1, 0, 0, 1, 0, 0, 99, 19926, 0, '', '1', '0'),
	(10436, '19926', 13, 'landscape_single_3.6', 1, 0, 0, 1, 0, 0, 99, 19926, 0, '', '1', '0'),
	(10437, '19926', 13, 'landscape_single_4.6', 1, 0, 0, 1, 0, 0, 99, 19926, 0, '', '1', '0'),
	(10438, '19926', 13, 'landscape_single_5.6', 1, 0, 0, 1, 0, 0, 99, 19926, 0, '', '1', '0'),
	(10439, '19926', 13, 'landscape_single_6.6', 1, 0, 0, 1, 0, 0, 99, 19926, 0, '', '1', '0'),
	(10440, '19926', 13, 'landscape_single_7.6', 1, 0, 0, 1, 0, 0, 99, 19926, 0, '', '1', '0'),
	(10441, '19926', 13, 'landscape_single_1.7', 1, 0, 0, 1, 0, 0, 99, 19926, 0, '', '1', '0'),
	(10442, '19926', 13, 'landscape_single_2.7', 1, 0, 0, 1, 0, 0, 99, 19926, 0, '', '1', '0'),
	(10443, '19926', 13, 'landscape_single_3.7', 1, 0, 0, 1, 0, 0, 99, 19926, 0, '', '1', '0'),
	(10444, '19926', 13, 'landscape_single_4.7', 1, 0, 0, 1, 0, 0, 99, 19926, 0, '', '1', '0'),
	(10445, '19926', 13, 'landscape_single_5.7', 1, 0, 0, 1, 0, 0, 99, 19926, 0, '', '1', '0'),
	(10446, '19926', 13, 'landscape_single_6.7', 1, 0, 0, 1, 0, 0, 99, 19926, 0, '', '1', '0'),
	(10447, '19926', 13, 'landscape_single_7.7', 1, 0, 0, 1, 0, 0, 99, 19926, 0, '', '1', '0'),
	(10448, '19926', 13, 'landscape_single_1.8', 1, 0, 0, 1, 0, 0, 99, 19926, 0, '', '1', '0'),
	(10449, '19926', 13, 'landscape_single_1.9', 1, 0, 0, 1, 0, 0, 99, 19926, 0, '', '1', '0'),
	(10450, '19926', 13, 'landscape_single_1.10', 1, 0, 0, 1, 0, 0, 99, 19926, 0, '', '1', '0'),
	(10451, '19926', 13, 'landscape_single_1.11', 1, 0, 0, 1, 0, 0, 99, 19926, 0, '', '1', '0'),
	(10452, '19926', 13, 'landscape_single_7.12', 1, 0, 0, 1, 0, 0, 99, 19926, 0, '', '1', '0'),
	(10453, '42380', 605, 'dimmer_buttn', 6, 0, 0, 1, 0, 0, 99, 17810, 0, '', '1', '0'),
	(10454, '135', 605, 'bar_chair_armas', 1, 0, 0, 1, 0, 0, 99, 120, 0, '', '1', '0'),
	(10455, '3589', 605, 'ktchn10_block', 2, 0, 0, 1, 0, 0, 99, 8873, 0, '', '1', '0'),
	(10456, '3261', 605, 'ktchn_countr_1', 1, 0, 0, 1, 0, 0, 99, 4259, 0, '', '1', '0'),
	(10457, '1898', 605, 'bed_polyfon*6', 4, 0, 0, 1, 0, 0, 99, 818, 0, '', '1', '0'),
	(10458, '2503', 605, 'bed_budget_one*6', 3, 0, 0, 1, 0, 0, 99, 18157, 0, '', '1', '0'),
	(10459, '246', 605, 'divider_arm2', 3, 0, 0, 1, 0, 0, 99, 215, 0, '', '1', '0'),
	(10460, '1984', 605, 'divider_nor4*2', 4, 0, 0, 1, 0, 0, 99, 904, 0, '', '1', '0'),
	(10461, '42390', 605, 'dimmer_fuse2', 10, 0, 0, 1, 0, 0, 99, 4302, 0, '', '1', '0'),
	(10462, '3214', 605, 'sf_tele', 5, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(10463, '1655', 605, 'queue_tile1*7', 7, 0, 0, 1, 0, 0, 99, 597, 0, '', '1', '0'),
	(10464, '135', 606, 'bar_chair_armas', 1, 0, 0, 1, 0, 0, 99, 120, 0, '', '1', '0'),
	(10465, '55', 606, 'small_chair_armas', 1, 0, 0, 1, 0, 0, 99, 41, 0, '', '1', '0'),
	(10466, '4628', 606, 'hween_c15_sky', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(10467, '8798', 606, 'purablk_c16_mdl3*3', 2, 0, 0, 1, 0, 0, 99, 17524, 0, '', '1', '0'),
	(10468, '8830', 606, 'purablk_c16_mdl5*3', 2, 0, 0, 1, 0, 0, 99, 17556, 0, '', '1', '0'),
	(10469, '2960', 606, 'party_chair', 3, 0, 0, 1, 0, 0, 99, 2981, 0, '', '1', '0'),
	(10470, '2517', 606, 'pura_mdl5*9', 1, 0, 0, 1, 0, 0, 99, 1398, 0, '', '1', '0'),
	(10471, '8851', 606, 'purablk_c16_mdl4*3', 2, 0, 0, 1, 0, 0, 99, 17577, 0, '', '1', '0'),
	(10472, '1817', 606, 'soft_sofa_norja*2', 4, 0, 0, 1, 0, 0, 99, 737, 0, '', '1', '0'),
	(10473, '8831', 606, 'purablk_c16_mdl5*4', 2, 0, 0, 1, 0, 0, 99, 17557, 0, '', '1', '0'),
	(10474, '3993', 606, 'picnic_chair', 2, 0, 0, 1, 0, 0, 99, 10110, 0, '', '1', '0'),
	(10475, '174', 606, 'bath', 6, 0, 0, 1, 0, 0, 99, 165, 0, '', '1', '0'),
	(10476, '3981', 606, 'picnic_pillow_yel', 2, 0, 0, 1, 0, 0, 99, 10098, 0, '', '1', '0'),
	(10477, '3988', 606, 'picnic_pillow_blu', 2, 0, 0, 1, 0, 0, 99, 10105, 0, '', '1', '0'),
	(10478, '3992', 606, 'picnic_pillow', 2, 0, 0, 1, 0, 0, 99, 10109, 0, '', '1', '0'),
	(10479, '3125', 606, 'env_tree3', 3, 0, 0, 1, 0, 0, 99, 3858, 0, '', '1', '0'),
	(10480, '3961', 606, 'anna_sofa*2', 4, 0, 0, 1, 0, 0, 99, 10077, 0, '', '1', '0'),
	(10481, '1818', 606, 'soft_sofa_norja*3', 4, 0, 0, 1, 0, 0, 99, 738, 0, '', '1', '0'),
	(10482, '3570', 606, 'bw_van_p', 7, 0, 0, 1, 0, 0, 99, 18500, 0, '', '1', '0'),
	(10483, '35', 606, 'sofa_polyfon', 4, 0, 0, 1, 0, 0, 99, 24, 0, '', '1', '0'),
	(10484, '3260', 607, 'ktchn_desk', 4, 0, 0, 1, 0, 0, 99, 4258, 0, '', '1', '0'),
	(10485, '54', 607, 'small_table_armas', 2, 0, 0, 1, 0, 0, 99, 40, 0, '', '1', '0'),
	(10486, '4632', 607, 'gold_c15_arc_icewall', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(10487, '25', 607, 'stand_polyfon_z', 3, 0, 0, 1, 0, 0, 99, 159, 0, '', '1', '0'),
	(10488, '130', 607, 'bardesk_polyfon', 3, 0, 0, 1, 0, 0, 99, 115, 0, '', '1', '0'),
	(10489, '3953', 607, 'anna_table*4', 4, 0, 0, 1, 0, 0, 99, 10069, 0, '', '1', '0'),
	(10490, '153', 607, 'smooth_table_polyfon', 4, 0, 0, 1, 0, 0, 99, 137, 0, '', '1', '0'),
	(10491, '48', 608, 'bed_armas_two', 4, 0, 0, 1, 0, 0, 99, 34, 0, '', '1', '0'),
	(10492, '1898', 608, 'bed_polyfon*6', 4, 0, 0, 1, 0, 0, 99, 818, 0, '', '1', '0'),
	(10493, '1899', 608, 'bed_polyfon*7', 4, 0, 0, 1, 0, 0, 99, 819, 0, '', '1', '0'),
	(10494, '2937', 608, 'hween08_bed2', 5, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(10495, '4898', 608, 'pixel_bed_red', 3, 0, 0, 1, 0, 0, 99, 11974, 0, '', '1', '0'),
	(10496, '10096', 608, 'coralking_c18_bed', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(10497, '245', 609, 'divider_arm1', 4, 0, 0, 1, 0, 0, 99, 214, 0, '', '1', '0'),
	(10498, '246', 609, 'divider_arm2', 2, 0, 0, 1, 0, 0, 99, 215, 0, '', '1', '0'),
	(10499, '1951', 609, 'divider_nor2*4', 4, 0, 0, 1, 0, 0, 99, 871, 0, '', '1', '0'),
	(10500, '3077', 609, 'lc_coral_divider_low', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(10501, '3078', 609, 'lc_coral_divider_hi', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(10502, '250', 609, 'divider_nor2', 4, 0, 0, 1, 0, 0, 99, 217, 0, '', '1', '0'),
	(10503, '3642', 224, 'bb_rnd_tele', 2, 0, 0, 1, 0, 0, 2, 17891, 0, '', '1', '0'),
	(10504, '5832', 224, 'easter14_teleport', 7, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(10505, '2978', 224, 'xmas08_telep', 5, 0, 0, 1, 0, 0, 7, 3110, 0, '', '1', '0'),
	(10506, '3214', 224, 'sf_tele', 5, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(10507, '3550', 224, 'bw_tele', 6, 0, 0, 1, 0, 0, 9, 8753, 0, '', '1', '0'),
	(10508, '3990', 224, 'picnic_tele', 6, 0, 0, 1, 0, 0, 10, 10107, 0, '', '1', '0'),
	(10509, '61', 611, 'carpet_polar', 4, 0, 0, 1, 0, 0, 1, 3184, 0, '', '1', '0'),
	(10510, '40540', 611, 'DEV window_skyscraper', 3, 0, 0, 1, 0, 0, 2, 40540, 0, '', '1', '0'),
	(10511, '2693', 611, 'teleport_door', 5, 0, 0, 1, 0, 0, 3, 3233, 0, '', '1', '0'),
	(10512, '40710', 611, 'party_shelf', 2, 0, 0, 1, 0, 0, 4, 2993, 0, '', '1', '0'),
	(10513, '60', 611, 'carpet_armas', 3, 0, 0, 1, 0, 0, 5, 46, 0, '', '1', '0'),
	(10514, '40400', 611, 'DEV window_70s_narrow', 3, 0, 0, 1, 0, 0, 6, 40400, 0, '', '1', '0'),
	(10515, '40420', 611, 'DEV window_basic', 4, 0, 0, 1, 0, 0, 7, 40420, 0, '', '1', '0'),
	(10516, '6154', 612, 'bathroom_floortile1', 3, 0, 0, 1, 0, 0, 99, 18804, 0, '', '1', '0'),
	(10517, '4912', 612, 'pixel_floor_blue', 4, 0, 0, 1, 0, 0, 99, 11988, 0, '', '1', '0'),
	(10518, '4896', 612, 'pixel_floor_brown', 4, 0, 0, 1, 0, 0, 99, 11972, 0, '', '1', '0'),
	(10519, '4903', 612, 'pixel_floor_green', 4, 0, 0, 1, 0, 0, 99, 11979, 0, '', '1', '0'),
	(10520, '4895', 612, 'pixel_floor_pink', 4, 0, 0, 1, 0, 0, 99, 11971, 0, '', '1', '0'),
	(10521, '4904', 612, 'pixel_floor_silver', 4, 0, 0, 1, 0, 0, 99, 11980, 0, '', '1', '0'),
	(10522, '4897', 612, 'pixel_floor_yellow', 4, 0, 0, 1, 0, 0, 99, 11973, 0, '', '1', '0'),
	(10523, '180', 612, 'tile', 3, 0, 0, 1, 0, 0, 99, 169, 0, '', '1', '0'),
	(10524, '183', 612, 'tile_red', 3, 0, 0, 1, 0, 0, 99, 172, 0, '', '1', '0'),
	(10525, '184', 612, 'tile_yell', 3, 0, 0, 1, 0, 0, 99, 173, 0, '', '1', '0'),
	(10526, '5707', 612, 'val14_largetile', 3, 0, 0, 1, 0, 0, 99, 13474, 0, '', '1', '0'),
	(10527, '8414', 612, 'ktchn_c15_floor', 5, 0, 0, 1, 0, 0, 99, 16954, 0, '', '1', '0'),
	(10528, '2958', 612, 'party_floor', 5, 0, 0, 1, 0, 0, 99, 2979, 0, '', '1', '0'),
	(10529, '5711', 615, 'val14_door', 4, 0, 0, 1, 0, 0, 99, 18097, 0, '', '1', '0'),
	(10530, '3699', 615, 'wf_glassdoor', 3, 0, 0, 1, 0, 0, 99, 9134, 0, '', '1', '0'),
	(10531, '1862', 615, 'divider_silo3*7', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(10532, '1861', 615, 'divider_silo3*6', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(10533, '244', 615, 'divider_poly3', 2, 0, 0, 1, 0, 0, 99, 18166, 0, '', '1', '0'),
	(10534, '4705', 615, 'window_nt_diner2', 5, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(10535, '4722', 615, 'vwave_c21_glitchsunsetbg', 20, 0, 0, 1, 0, 0, 99, 25842, 0, '', '1', '0'),
	(10536, '5698', 615, 'val14_gate', 5, 0, 0, 1, 0, 0, 99, 13465, 0, '', '1', '0'),
	(10537, '3254', 615, 'ktchn_gate', 3, 0, 0, 1, 0, 0, 99, 4252, 0, '', '1', '0'),
	(10538, '247', 615, 'divider_arm3', 4, 0, 0, 1, 0, 0, 99, 219, 0, '', '1', '0'),
	(10539, '163', 616, 'plant_bonsai', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(10540, '4076', 616, 'xmas08_icewall', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(10541, '3163', 616, 'country_wheat', 3, 0, 0, 1, 0, 0, 99, 18806, 0, '', '1', '0'),
	(10542, '3115', 616, 'env_bushes', 2, 0, 0, 1, 0, 0, 99, 3848, 0, '', '1', '0'),
	(10543, '3984', 616, 'picnic_wfall', 10, 0, 0, 1, 0, 0, 99, 10101, 0, '', '1', '0'),
	(10544, '3162', 616, 'country_grass', 4, 0, 0, 1, 0, 0, 99, 3992, 0, '', '1', '0'),
	(10545, '3145', 616, 'country_soil', 3, 0, 0, 1, 0, 0, 99, 3975, 0, '', '1', '0'),
	(10546, '41140', 616, 'country_forestwall', 4, 0, 0, 1, 0, 0, 99, 3952, 0, '', '1', '0'),
	(10551, '3164', 613, 'country_corner', 3, 0, 0, 1, 0, 0, 99, 18010, 0, '', '1', '0'),
	(10552, '3753', 613, 'es_geysir', 2, 0, 0, 1, 0, 0, 99, 17925, 0, '', '1', '0'),
	(10553, '3165', 613, 'country_ditch', 3, 0, 0, 1, 0, 0, 99, 17991, 0, '', '1', '0'),
	(10554, '4076', 613, 'xmas08_icewall', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(10555, '2591', 613, 'summer_pool*1', 4, 0, 0, 1, 0, 0, 99, 18402, 0, '', '1', '0'),
	(10556, '2593', 613, 'summer_pool*3', 4, 0, 0, 1, 0, 0, 99, 18481, 0, '', '1', '0'),
	(10557, '2592', 613, 'summer_pool*2', 4, 0, 0, 1, 0, 0, 99, 18407, 0, '', '1', '0'),
	(10558, '3153', 613, 'country_rain', 5, 0, 0, 1, 0, 0, 99, 3983, 0, '', '1', '0'),
	(10559, '3984', 613, 'picnic_wfall', 10, 0, 0, 1, 0, 0, 99, 10101, 0, '', '1', '0'),
	(10560, '5706', 613, 'val14_fbath', 2, 0, 0, 1, 0, 0, 99, 13473, 0, '', '1', '0'),
	(10561, '4643', 613, 'classic5_window', 8, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(10562, '3541', 613, 'bw_water_2', 6, 0, 0, 1, 0, 0, 99, 8744, 0, '', '1', '0'),
	(10563, '3540', 613, 'bw_shower', 4, 0, 0, 1, 0, 0, 99, 8743, 0, '', '1', '0'),
	(10564, '3831', 613, 'pond', 2, 0, 0, 1, 0, 0, 99, 9514, 0, '', '1', '0'),
	(10565, '4472', 613, 'xmas12_torch', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(10566, '4476', 613, 'ny2013_wall', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(10567, '202', 605, 'door', 6, 0, 0, 1, 0, 0, 99, 17890, 0, '', '1', '0'),
	(10569, '6122', 621, 'uni_pizza', 2, 0, 0, 1, 0, 0, 99, 18098, 0, '', '1', '0'),
	(10570, '4136', 621, 'usva4_lamp', 2, 0, 0, 1, 0, 0, 99, 18178, 0, '', '1', '0'),
	(10571, '4170', 621, 'boutique_mannequin1', 6, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(10572, '3549', 621, 'bw_van', 7, 0, 0, 1, 0, 0, 99, 18580, 0, '', '1', '0'),
	(10573, '6148', 621, 'bathroom_shower1', 7, 0, 0, 1, 0, 0, 99, 14160, 0, '', '1', '0'),
	(10574, '3125', 621, 'env_tree3', 3, 0, 0, 1, 0, 0, 99, 3858, 0, '', '1', '0'),
	(10575, '3875', 621, 'cubie_shelf_1_b', 5, 0, 0, 1, 0, 0, 99, 9589, 0, '', '1', '0'),
	(10576, '2832', 621, 'diner_gumvendor*6', 3, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(10577, '5710', 621, 'val14_archway', 4, 0, 0, 1, 0, 0, 99, 13477, 0, '', '1', '0'),
	(10578, '8423', 621, 'ktchn_c15_sink', 10, 0, 0, 1, 0, 0, 99, 16963, 0, '', '1', '0'),
	(10579, '46210', 621, 'lodge_c15_wall', 3, 0, 0, 1, 0, 0, 99, 16633, 0, '', '1', '0'),
	(10580, '1905', 621, 'bed_polyfon_one*6', 3, 0, 0, 1, 0, 0, 99, 825, 0, '', '1', '0'),
	(10581, '3701', 617, 'wf_floor_switch1', 3, 0, 0, 1, 0, 0, 99, 9136, 0, '', '1', '0'),
	(10582, '3857', 617, 'wf_cnd_has_furni_on', 6, 0, 0, 1, 0, 0, 99, 9558, 0, '', '1', '0'),
	(10583, '3683', 617, 'wf_trg_enter_room', 5, 0, 0, 1, 0, 0, 99, 9118, 0, '', '1', '0'),
	(10584, '3663', 617, 'wf_act_move_rotate', 4, 0, 0, 1, 0, 0, 99, 9098, 0, '', '1', '0'),
	(10585, '5044', 617, 'highscore_classic*1', 7, 0, 0, 1, 0, 0, 99, 12508, 0, '', '1', '0'),
	(10586, '3693:4;3703:4;3663:4;3689', 618, 'wf_deal7', 34, 0, 0, 1, 0, 0, 7, 3693, 0, '', '1', '0'),
	(10587, '3703;3699;3685;3688', 618, 'wf_deal3', 10, 0, 0, 1, 0, 0, 3, 3703, 0, '', '1', '0'),
	(10588, '3699;3685;3701;3668', 618, 'wf_deal2', 10, 0, 0, 1, 0, 0, 2, 3699, 0, '', '1', '0'),
	(10589, '3683;3681', 618, 'wf_deal5', 5, 0, 0, 1, 0, 0, 5, 3683, 0, '', '1', '0'),
	(10591, '3686:4;3671;3685', 618, 'wf_deal9', 25, 0, 0, 1, 0, 0, 9, 3686, 0, '', '1', '0'),
	(10592, '3163', 614, 'country_wheat', 3, 0, 0, 1, 0, 0, 99, 18806, 0, '', '1', '0'),
	(10593, '3145', 614, 'country_soil', 3, 0, 0, 1, 0, 0, 99, 3975, 0, '', '1', '0'),
	(10594, '3129', 614, 'env_grass', 4, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(10595, '4209', 614, 'horse_hayfloor', 3, 0, 0, 1, 0, 0, 99, 10480, 0, '', '1', '0'),
	(10596, '4229', 614, 'flag_belgium', 3, 0, 0, 1, 0, 0, 99, 4239, 0, '', '1', '0'),
	(10597, '4454', 614, 'stone_wall', 3, 0, 0, 1, 0, 0, 99, 11117, 0, '', '1', '0'),
	(10598, '3753', 620, 'es_geysir', 2, 0, 0, 1, 0, 0, 99, 17925, 0, '', '1', '0'),
	(10599, '3645', 620, 'bb_counter', 10, 0, 0, 1, 0, 0, 99, 17830, 0, '', '1', '0'),
	(10600, '3497', 620, 'fball_ball3', 15, 0, 0, 1, 0, 0, 99, 5807, 0, '', '1', '0'),
	(10601, '4390', 620, 'cubie_decal_1_p', 5, 0, 0, 1, 0, 0, 99, 9605, 0, '', '1', '0'),
	(10602, '3739', 620, 'es_puck', 10, 0, 0, 1, 0, 0, 99, 9216, 0, '', '1', '0'),
	(10603, '3792', 620, 'val11_floor', 8, 0, 0, 1, 0, 0, 99, 9417, 0, '', '1', '0'),
	(10604, '3757:100;3758:50', 38, 'es_tile', 80, 0, 0, 1, 0, 0, 13, 9304, 0, '', '1', '0'),
	(10605, '3757:10;3758:5', 38, 'es_tile', 10, 0, 0, 1, 0, 0, 14, 9304, 0, '', '1', '0'),
	(10606, '3757:50;3758:25', 38, 'es_tile', 35, 0, 0, 1, 0, 0, 15, 9304, 0, '', '1', '0'),
	(10608, '3494', 413, 'fball_bench', 3, 0, 0, 1, 0, 0, 99, 17981, 0, '', '1', '0'),
	(10609, '3739', 413, 'es_puck', 10, 0, 0, 1, 0, 0, 99, 9216, 0, '', '1', '0'),
	(10610, '3507', 413, 'fball_cote', 3, 0, 0, 1, 0, 0, 99, 5817, 0, '', '1', '0'),
	(10611, '3499', 413, 'fball_light', 6, 0, 0, 1, 0, 0, 99, 5809, 0, '', '1', '0'),
	(10612, '3500', 413, 'fball_audbench', 6, 0, 0, 1, 0, 0, 99, 5810, 0, '', '1', '0'),
	(10613, '3525', 413, 'fball_counter', 10, 0, 0, 1, 0, 0, 99, 7675, 0, '', '1', '0'),
	(10614, '3307', 413, 'ktchn_hlthNut', 15, 0, 0, 1, 0, 0, 99, 4534, 0, '', '1', '0'),
	(10615, '3267', 413, 'urban_fence', 3, 0, 0, 1, 0, 0, 99, 4309, 0, '', '1', '0'),
	(10616, '3275', 413, 'urban_fence_corner', 2, 0, 0, 1, 0, 0, 99, 4317, 0, '', '1', '0'),
	(10617, '3640', 413, 'bb_fnc1', 2, 0, 0, 1, 0, 0, 99, 8953, 0, '', '1', '0'),
	(10618, '3639', 413, 'bb_knj2', 2, 0, 0, 1, 0, 0, 99, 8952, 0, '', '1', '0'),
	(10619, '3634', 413, 'bb_fnc3', 3, 0, 0, 1, 0, 0, 99, 8947, 0, '', '1', '0'),
	(10620, '3736', 413, 'es_skating_ice', 10, 0, 0, 1, 0, 0, 99, 9213, 0, '', '1', '0'),
	(10621, '3792', 630, 'val11_floor', 8, 0, 0, 1, 0, 0, 99, 9417, 0, '', '1', '0'),
	(10622, '3322', 623, 'petfood9', 1, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(10623, '1532', 623, 'petfood1', 1, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(10624, '4070', 623, 'party_wc_boy', 1, 0, 0, 1, 0, 0, 99, 2992, 0, '', '1', '0'),
	(10625, '5755', 623, 'nest_gnome', 15, 0, 0, 1, 0, 0, 99, 13591, 0, '', '1', '0'),
	(10626, '4828', 623, 'pet_basket_pink', 5, 0, 0, 1, 0, 0, 99, 11859, 0, '', '1', '0'),
	(10627, '3895', 607, 'waasa_table1', 2, 0, 0, 1, 0, 0, 99, -1, 0, '', '1', '0'),
	(10628, '3887', 607, 'waasa_table2', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10629, '4152', 607, 'school_table', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10630, '9388', 609, 'val_c17_rosedivider', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10631, '9498', 609, 'santorini_c17_divider', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10632, '2154', 609, 'romantique_divider*4', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10633, '2518', 609, 'rope_divider', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10634, '1991', 609, 'divider_nor5*2', 4, 0, 0, 1, 0, 0, 1, 18807, 0, '', '1', '0'),
	(10635, '11224', 202, 'clothing_spottedoctohat', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10636, '11225', 518, 'rainyday_c20_craftset', 3, 0, 0, 1, 0, 0, 1, 22145, 0, '', '1', '0'),
	(10637, '11226', 518, 'rainyday_c20_woodentable', 3, 0, 0, 1, 0, 0, 1, 22146, 0, '', '1', '0'),
	(10638, '11227', 518, 'rainyday_c20_rainceilingwindow', 3, 0, 0, 1, 0, 0, 1, 22147, 0, '', '1', '0'),
	(10639, '11228', 518, 'rainyday_c20_paintset', 3, 0, 0, 1, 0, 0, 1, 22148, 0, '', '1', '0'),
	(10640, '11229', 518, 'rainyday_c20_typewriter', 3, 0, 0, 1, 0, 0, 1, 22149, 0, '', '1', '0'),
	(10641, '11230', 518, 'rainyday_c20_scentedcandles', 3, 0, 0, 1, 0, 0, 1, 22150, 0, '', '1', '0'),
	(10642, '11231', 518, 'rainyday_c20_cosywhippet', 3, 0, 0, 1, 0, 0, 1, 22151, 0, '', '1', '0'),
	(10643, '11232', 518, 'rainyday_c20_woodendesk', 3, 0, 0, 1, 0, 0, 1, 22152, 0, '', '1', '0'),
	(10644, '11233', 518, 'rainyday_c20_glowstars', 3, 0, 0, 1, 0, 0, 1, 22153, 0, '', '1', '0'),
	(10645, '11234', 518, 'rainyday_c20_raindropwall', 3, 0, 0, 1, 0, 0, 1, 22154, 0, '', '1', '0'),
	(10646, '11235', 518, 'rainyday_c20_woodenfloor', 3, 0, 0, 1, 0, 0, 1, 22155, 0, '', '1', '0'),
	(10647, '11236', 518, 'rainyday_c20_snugblanket', 3, 0, 0, 1, 0, 0, 1, 22156, 0, '', '1', '0'),
	(10648, '11237', 518, 'rainyday_c20_stackoflogs', 3, 0, 0, 1, 0, 0, 1, 22157, 0, '', '1', '0'),
	(10649, '11238', 518, 'rainyday_c20_coathanger', 3, 0, 0, 1, 0, 0, 1, 22158, 0, '', '1', '0'),
	(10650, '11239', 518, 'rainyday_c20_homebakes', 3, 0, 0, 1, 0, 0, 1, 22159, 0, '', '1', '0'),
	(10651, '11240', 518, 'rainyday_c20_retrogames', 3, 0, 0, 1, 0, 0, 1, 22160, 0, '', '1', '0'),
	(10652, '11241', 636, 'clothing_nt_starearrings', 5, 0, 0, 1, 0, 0, 36, -1, 0, '', '1', '0'),
	(10653, '11242', 310, 'clothing_starearrings', 3, 0, 0, 1, 0, 0, 5, 22162, 0, '', '1', '0'),
	(10654, '11243', 310, 'clothing_glitzypurse', 3, 0, 0, 1, 0, 0, 4, 22163, 0, '', '1', '0'),
	(10655, '11244', 636, 'clothing_nt_flapperdress', 5, 0, 0, 1, 0, 0, 37, -1, 0, '', '1', '0'),
	(10656, '11245', 310, 'clothing_chiseledface', 3, 0, 0, 1, 0, 0, 3, 22165, 0, '', '1', '0'),
	(10657, '11246', 636, 'clothing_nt_modernshortwave', 5, 0, 0, 1, 0, 0, 38, -1, 0, '', '1', '0'),
	(10658, '11247', 753, 'habbo20_c20_artdecocarpet', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10659, '11248', 636, 'clothing_nt_silkgloves', 5, 0, 0, 1, 0, 0, 39, -1, 0, '', '1', '0'),
	(10660, '11249', 753, 'habbo20_c20_balloons', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10661, '11250', 636, 'clothing_nt_slickedbackhair', 5, 0, 0, 1, 0, 0, 40, -1, 0, '', '1', '0'),
	(10662, '11251', 687, 'clothing_r20_glitzytux', 3, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(10663, '11252', 310, 'clothing_pencilmoustache', 3, 0, 0, 1, 0, 0, 2, 22172, 0, '', '1', '0'),
	(10664, '11253', 636, 'clothing_nt_glitzypurse', 5, 0, 0, 1, 0, 0, 41, -1, 0, '', '1', '0'),
	(10665, '11254', 201, 'clothing_modernshortwave', 3, 0, 0, 1, 0, 0, 2, 22174, 0, '', '1', '0'),
	(10666, '11255', 201, 'clothing_slickedbackhair', 3, 0, 0, 1, 0, 0, 1, 22175, 0, '', '1', '0'),
	(10667, '11256', 203, 'clothing_flapperdress', 3, 0, 0, 1, 0, 0, 1, 22176, 0, '', '1', '0'),
	(10668, '11257', 636, 'clothing_nt_pencilmoustache', 5, 0, 0, 1, 0, 0, 42, -1, 0, '', '1', '0'),
	(10669, '11258', 753, 'habbo20_c20_artdecochair', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10670, '11259', 310, 'clothing_silkgloves', 3, 0, 0, 1, 0, 0, 1, 22179, 0, '', '1', '0'),
	(10671, '11260', 753, 'habbo20_c20_artdecobackdrop', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10672, '11261', 753, 'habbo20_c20_glitzytable', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10673, '11262', 636, 'clothing_nt_chiseledface', 5, 0, 0, 1, 0, 0, 43, -1, 0, '', '1', '0'),
	(10674, '11263', 748, 'neonpunk_c20_wall', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10675, '11264', 748, 'neonpunk_c20_cupboard', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10676, '11265', 748, 'neonpunk_c20_strawberries', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10677, '11266', 748, 'neonpunk_c20_stool', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10678, '11267', 748, 'neonpunk_c20_lamp', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10679, '11268', 687, 'clothing_r20_neonpunkset', 25, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(10680, '11269', 748, 'neonpunk_c20_bed', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10681, '11270', 748, 'neonpunk_c20_stardeco', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10682, '11271', 748, 'neonpunk_c20_unicornposter', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10683, '11272', 748, 'neonpunk_c20_candylights', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10684, '11273', 748, 'neonpunk_c20_bows', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10685, '11274', 748, 'neonpunk_c20_carpet', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10686, '11275', 748, 'neonpunk_c20_lights', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10687, '11276', 748, 'neonpunk_c20_table', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10688, '11277', 748, 'neonpunk_c20_cubeseat', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10689, '11278', 748, 'neonpunk_c20_storage', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10690, '11279', 748, 'neonpunk_c20_plushiepile', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10691, '11280', 748, 'neonpunk_c20_plushie1', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10692, '11281', 748, 'neonpunk_c20_dresser', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10693, '11282', 748, 'neonpunk_c20_food', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10694, '11283', 748, 'neonpunk_c20_floor', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10695, '11284', 748, 'neonpunk_c20_plushie2', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10696, '11285', 748, 'neonpunk_c20_plushie3', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10697, '11286', 748, 'neonpunk_c20_sofa', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10698, '11287', 748, 'neonpunk_c20_bedsidetable', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10699, '11288', 749, 'gothiccafe_c20_sofa', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10700, '11289', 769, 'gothiccafe_c20_creamrolls', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10701, '11290', 749, 'gothiccafe_c20_bookcase', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10702, '11291', 749, 'gothiccafe_c20_table', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10703, '11292', 749, 'gothiccafe_c20_teaplant', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10704, '11293', 749, 'gothiccafe_c20_glass', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10705, '11294', 749, 'gothiccafe_c20_vase', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10706, '11295', 749, 'gothiccafe_c20_icetea', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10707, '11296', 749, 'gothiccafe_c20_donut', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10708, '11297', 749, 'gothiccafe_c20_coffeetable', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10709, '11298', 749, 'gothiccafe_c20_floor', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10710, '11299', 687, 'clothing_r20_gothicset', 25, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(10711, '11300', 749, 'gothiccafe_c20_rosepainting', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10712, '11301', 749, 'gothiccafe_c20_shelf', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10713, '11302', 749, 'gothiccafe_c20_wall', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10714, '11303', 749, 'gothiccafe_c20_mochicake', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10715, '11304', 749, 'gothiccafe_c20_counter', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10716, '11305', 749, 'gothiccafe_c20_rug', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10717, '11306', 749, 'gothiccafe_c20_windoor', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10718, '11307', 749, 'gothiccafe_c20_armchair', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10719, '11308', 760, 'habbo20_r20_crackable', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10720, '11309', 760, 'habbo20_c20_crackable', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10721, '11310', 821, 'habbo20_c20_blackgoldballoon', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10722, '11311', 204, 'clothing_h20th', 1, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10723, '11312', 821, 'habbo20_c20_rosegoldballoon', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10724, '11313', 754, 'rare_blackrosegold_parasol', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10725, '11314', 754, 'rare_blackrosegold_icecream', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10726, '11315', 754, 'rare_blackrosegold_fountain', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10727, '11316', 858, 'rare_r20_candle', 3, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(10728, '11317', 754, 'rare_blackrosegold_beehive_bulb', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10729, '11318', 754, 'rare_blackrosegold_scifidoor', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10730, '11319', 754, 'rare_blackrosegold_pillar', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10731, '11320', 754, 'rare_blackrosegold_pillow', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10732, '11321', 754, 'rare_blackrosegold_wooden_screen', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10733, '11322', 754, 'rare_blackrosegold_barrier', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10734, '11323', 754, 'rare_blackrosegold_scifirocket', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10735, '11324', 754, 'rare_blackrosegold_marquee', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10736, '11325', 754, 'rare_blackrosegold_elephant_statue', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10737, '11326', 858, 'rare_r20_throne', 3, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(10738, '11327', 754, 'rare_blackrosegold_dragonlamp', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10739, '11328', 754, 'rare_blackrosegold_sleepingbag', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10740, '11329', 754, 'rare_blackrosegold_scifiport', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10741, '11330', 754, 'rare_blackrosegold_fan', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10742, '11331', 755, 'darkelegant_c20_flowerpot', 3, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(10743, '11332', 755, 'darkelegant_c20_smalltable', 3, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(10744, '11333', 755, 'darkelegant_c20_floor', 3, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(10745, '11334', 755, 'darkelegant_c20_chair', 3, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(10746, '11335', 755, 'darkelegant_c20_walldecor', 3, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(10747, '11336', 755, 'darkelegant_c20_window', 3, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(10748, '11337', 755, 'darkelegant_c20_vanity', 3, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(10749, '11338', 755, 'darkelegant_c20_light', 3, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(10750, '11339', 755, 'darkelegant_c20_lionstatue', 3, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(10751, '11340', 755, 'darkelegant_c20_teaset', 3, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(10752, '11341', 755, 'darkelegant_c20_lamp', 3, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(10753, '11342', 755, 'darkelegant_c20_stool', 3, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(10754, '11343', 755, 'darkelegant_c20_cat', 3, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(10755, '11344', 755, 'darkelegant_c20_table', 3, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(10756, '11345', 687, 'clothing_darkelegantset', 12, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(10757, '11346', 755, 'darkelegant_c20_cupboard', 3, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(10758, '11347', 755, 'darkelegant_c20_bed', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10759, '11348', 755, 'darkelegant_c20_sofa', 3, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(10760, '11349', 755, 'darkelegant_c20_wall', 3, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(10761, '11350', 755, 'darkelegant_c20_carpet', 3, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(10762, '11351', 750, 'sunsetcafe_c20_duck', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10763, '11352', 750, 'sunsetcafe_c20_plant', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10764, '11353', 750, 'sunsetcafe_c20_floor', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10765, '11354', 750, 'sunsetcafe_c20_table', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10766, '11355', 750, 'sunsetcafe_c20_wallcorner', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10767, '11356', 750, 'sunsetcafe_c20_bench', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10768, '11357', 750, 'sunsetcafe_c20_benchcornerconcave', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10769, '11358', 750, 'sunsetcafe_c20_coffeemachine', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10770, '11359', 750, 'sunsetcafe_c20_logdecor', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10771, '11360', 750, 'sunsetcafe_c20_swordfish', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10772, '11361', 750, 'sunsetcafe_c20_barcorner', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10773, '11362', 750, 'sunsetcafe_c20_lightupfloor', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10774, '11363', 750, 'sunsetcafe_c20_bar', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10775, '11364', 750, 'sunsetcafe_c20_shallow', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10776, '11365', 750, 'sunsetcafe_c20_drinks', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10777, '11366', 750, 'sunsetcafe_c20_logsteppingstones', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10778, '11367', 750, 'sunsetcafe_c20_wall', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10779, '11368', 756, 'darkmodern_c20_wall', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10780, '11369', 756, 'darkmodern_c20_incense', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10781, '11370', 756, 'darkmodern_c20_neonlight', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10782, '11371', 756, 'darkmodern_c20_folder', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10783, '11372', 756, 'darkmodern_c20_floor', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10784, '11373', 756, 'darkmodern_c20_creative', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10785, '11374', 756, 'darkmodern_c20_rug', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10786, '11375', 756, 'darkmodern_c20_display', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10787, '11376', 756, 'darkmodern_c20_speakers', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10788, '11377', 756, 'darkmodern_c20_pictures', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10789, '11378', 756, 'darkmodern_c20_bed', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10790, '11379', 756, 'darkmodern_c20_glassblockwall', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10791, '11380', 756, 'darkmodern_c20_lowtable', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10792, '11381', 756, 'darkmodern_c20_plant', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10793, '11382', 756, 'darkmodern_c20_endtable', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10794, '11383', 756, 'darkmodern_c20_reads', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10795, '11384', 756, 'darkmodern_c20_bunnylight', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10796, '11385', 756, 'darkmodern_c20_pillow', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10797, '11386', 756, 'darkmodern_c20_desk', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10798, '11387', 756, 'darkmodern_c20_sofa', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10799, '11388', 756, 'darkmodern_c20_hoomba', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10800, '11389', 756, 'darkmodern_c20_chair', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10801, '11390', 756, 'darkmodern_c20_pug', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10802, '11391', 756, 'darkmodern_c20_shelf', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10803, '11392', 756, 'darkmodern_c20_lamp', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10804, '11393', 756, 'darkmodern_c20_tubelights', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10805, '11394', 756, 'darkmodern_c20_tv', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10806, '11395', 756, 'darkmodern_c20_floorlight', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10807, '11396', 434, 'zengarden_c20_stonebench', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10808, '11397', 434, 'zengarden_c20_peacedog', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10809, '11398', 687, 'clothing_r20_harmonyset', 25, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(10810, '11399', 434, 'zengarden_c20_spikeyplant', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10811, '11400', 434, 'zengarden_c20_stonetable', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10812, '11401', 434, 'zengarden_c20_door', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10813, '11402', 434, 'zengarden_c20_rootplant', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10814, '11403', 434, 'zengarden_c20_light', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10815, '11404', 434, 'zengarden_c20_roof', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10816, '11405', 434, 'zengarden_c20_plankfloor', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10817, '11406', 434, 'zengarden_c20_roofcorner', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10818, '11407', 434, 'zengarden_c20_moss', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10819, '11408', 434, 'zengarden_c20_goldenmobile', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10820, '11409', 434, 'zengarden_c20_pebbles', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10821, '11410', 434, 'zengarden_c20_bamboo', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10822, '11411', 434, 'zengarden_c20_divider', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10823, '11412', 434, 'zengarden_c20_glasspond', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10824, '11413', 753, 'habbo20_c20_trophybronze', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10825, '11414', 753, 'habbo20_c20_trophyblock', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10826, '11415', 753, 'habbo20_c20_trophygold', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10827, '11416', 753, 'habbo20_c20_trophylooks', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10828, '11417', 753, 'habbo20_c20_trophydesign', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10829, '11418', 753, 'habbo20_c20_trophysilver', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10830, '11419', 753, 'habbo20_c20_trophyvideo', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(10831, '11420', 307, 'CF_1500_suitcase2', 1500, 0, 0, 1, 0, 0, 33, -1, 0, '', '0', '0'),
	(10834, '19894', 13, 'floor_single_101', 1, 0, 0, 1, 0, 0, 99, 19894, 0, '', '1', '0'),
	(10835, '19894', 13, 'floor_single_102', 1, 0, 0, 1, 0, 0, 99, 19894, 0, '', '1', '0'),
	(10836, '19894', 13, 'floor_single_103', 1, 0, 0, 1, 0, 0, 99, 19894, 0, '', '1', '0'),
	(10837, '19894', 13, 'floor_single_104', 1, 0, 0, 1, 0, 0, 99, 19894, 0, '', '1', '0'),
	(10838, '19894', 13, 'floor_single_105', 1, 0, 0, 1, 0, 0, 99, 19894, 0, '', '1', '0'),
	(10839, '19894', 13, 'floor_single_106', 1, 0, 0, 1, 0, 0, 99, 19894, 0, '', '1', '0'),
	(10840, '19894', 13, 'floor_single_107', 1, 0, 0, 1, 0, 0, 99, 19894, 0, '', '1', '0'),
	(10841, '19894', 13, 'floor_single_108', 1, 0, 0, 1, 0, 0, 99, 19894, 0, '', '1', '0'),
	(10842, '19894', 13, 'floor_single_109', 1, 0, 0, 1, 0, 0, 99, 19894, 0, '', '1', '0'),
	(10843, '19894', 13, 'floor_single_110', 1, 0, 0, 1, 0, 0, 99, 19894, 0, '', '1', '0'),
	(10844, '19894', 13, 'floor_single_111', 1, 0, 0, 1, 0, 0, 99, 19894, 0, '', '1', '0'),
	(10845, '19894', 13, 'floor_single_201', 1, 0, 0, 1, 0, 0, 99, 19894, 0, '', '1', '0'),
	(10846, '19894', 13, 'floor_single_201', 1, 0, 0, 1, 0, 0, 99, 19894, 0, '', '1', '0'),
	(10847, '19894', 13, 'floor_single_202', 1, 0, 0, 1, 0, 0, 99, 19894, 0, '', '1', '0'),
	(10848, '19894', 13, 'floor_single_202', 1, 0, 0, 1, 0, 0, 99, 19894, 0, '', '1', '0'),
	(10849, '19894', 13, 'floor_single_203', 1, 0, 0, 1, 0, 0, 99, 19894, 0, '', '1', '0'),
	(10850, '19894', 13, 'floor_single_203', 1, 0, 0, 1, 0, 0, 99, 19894, 0, '', '1', '0'),
	(10851, '19894', 13, 'floor_single_204', 1, 0, 0, 1, 0, 0, 99, 19894, 0, '', '1', '0'),
	(10852, '19894', 13, 'floor_single_204', 1, 0, 0, 1, 0, 0, 99, 19894, 0, '', '1', '0'),
	(10853, '19894', 13, 'floor_single_205', 1, 0, 0, 1, 0, 0, 99, 19894, 0, '', '1', '0'),
	(10854, '19894', 13, 'floor_single_205', 1, 0, 0, 1, 0, 0, 99, 19894, 0, '', '1', '0'),
	(10855, '19894', 13, 'floor_single_206', 1, 0, 0, 1, 0, 0, 99, 19894, 0, '', '1', '0'),
	(10856, '19894', 13, 'floor_single_206', 1, 0, 0, 1, 0, 0, 99, 19894, 0, '', '1', '0'),
	(10857, '19894', 13, 'floor_single_207', 1, 0, 0, 1, 0, 0, 99, 19894, 0, '', '1', '0'),
	(10858, '19894', 13, 'floor_single_207', 1, 0, 0, 1, 0, 0, 99, 19894, 0, '', '1', '0'),
	(10859, '19894', 13, 'floor_single_208', 1, 0, 0, 1, 0, 0, 99, 19894, 0, '', '1', '0'),
	(10860, '19894', 13, 'floor_single_209', 1, 0, 0, 1, 0, 0, 99, 19894, 0, '', '1', '0'),
	(10861, '19894', 13, 'floor_single_209', 1, 0, 0, 1, 0, 0, 99, 19894, 0, '', '1', '0'),
	(10862, '19894', 13, 'floor_single_210', 1, 0, 0, 1, 0, 0, 99, 19894, 0, '', '1', '0'),
	(10863, '19894', 13, 'floor_single_210', 1, 0, 0, 1, 0, 0, 99, 19894, 0, '', '1', '0'),
	(10864, '19894', 13, 'floor_single_211', 1, 0, 0, 1, 0, 0, 99, 19894, 0, '', '1', '0'),
	(10865, '19894', 13, 'floor_single_211', 1, 0, 0, 1, 0, 0, 99, 19894, 0, '', '1', '0'),
	(10866, '19894', 13, 'floor_single_301', 1, 0, 0, 1, 0, 0, 99, 19894, 0, '', '1', '0'),
	(10867, '19894', 13, 'floor_single_302', 1, 0, 0, 1, 0, 0, 99, 19894, 0, '', '1', '0'),
	(10868, '19894', 13, 'floor_single_303', 1, 0, 0, 1, 0, 0, 99, 19894, 0, '', '1', '0'),
	(10869, '19894', 13, 'floor_single_304', 1, 0, 0, 1, 0, 0, 99, 19894, 0, '', '1', '0'),
	(10870, '19894', 13, 'floor_single_305', 1, 0, 0, 1, 0, 0, 99, 19894, 0, '', '1', '0'),
	(10871, '19894', 13, 'floor_single_306', 1, 0, 0, 1, 0, 0, 99, 19894, 0, '', '1', '0'),
	(10872, '19894', 13, 'floor_single_307', 1, 0, 0, 1, 0, 0, 99, 19894, 0, '', '1', '0'),
	(10873, '19894', 13, 'floor_single_401', 1, 0, 0, 1, 0, 0, 99, 19894, 0, '', '1', '0'),
	(10874, '19894', 13, 'floor_single_402', 1, 0, 0, 1, 0, 0, 99, 19894, 0, '', '1', '0'),
	(10875, '19894', 13, 'floor_single_403', 1, 0, 0, 1, 0, 0, 99, 19894, 0, '', '1', '0'),
	(10876, '19894', 13, 'floor_single_404', 1, 0, 0, 1, 0, 0, 99, 19894, 0, '', '1', '0'),
	(10877, '19894', 13, 'floor_single_405', 1, 0, 0, 1, 0, 0, 99, 19894, 0, '', '1', '0'),
	(10878, '19894', 13, 'floor_single_406', 1, 0, 0, 1, 0, 0, 99, 19894, 0, '', '1', '0'),
	(10879, '19894', 13, 'floor_single_407', 1, 0, 0, 1, 0, 0, 99, 19894, 0, '', '1', '0'),
	(10880, '19894', 13, 'floor_single_408', 1, 0, 0, 1, 0, 0, 99, 19894, 0, '', '1', '0'),
	(10881, '19894', 13, 'floor_single_409', 1, 0, 0, 1, 0, 0, 99, 19894, 0, '', '1', '0'),
	(10882, '19894', 13, 'floor_single_410', 1, 0, 0, 1, 0, 0, 99, 19894, 0, '', '1', '0'),
	(10883, '19896', 13, 'wallpaper_single_101', 1, 0, 0, 1, 0, 0, 101, 19896, 0, '', '1', '0'),
	(10884, '19896', 13, 'wallpaper_single_102', 1, 0, 0, 1, 0, 0, 42, 19896, 0, '', '1', '0'),
	(10885, '19896', 13, 'wallpaper_single_103', 1, 0, 0, 1, 0, 0, 43, 19896, 0, '', '1', '0'),
	(10886, '19896', 13, 'wallpaper_single_104', 1, 0, 0, 1, 0, 0, 104, 19896, 0, '', '1', '0'),
	(10887, '19896', 13, 'wallpaper_single_105', 1, 0, 0, 1, 0, 0, 105, 19896, 0, '', '1', '0'),
	(10888, '19896', 13, 'wallpaper_single_106', 1, 0, 0, 1, 0, 0, 106, 19896, 0, '', '1', '0'),
	(10889, '19896', 13, 'wallpaper_single_107', 1, 0, 0, 1, 0, 0, 107, 19896, 0, '', '1', '0'),
	(10890, '19896', 13, 'wallpaper_single_108', 1, 0, 0, 1, 0, 0, 108, 19896, 0, '', '1', '0'),
	(10891, '19896', 13, 'wallpaper_single_109', 1, 0, 0, 1, 0, 0, 109, 19896, 0, '', '1', '0'),
	(10892, '19896', 13, 'wallpaper_single_110', 1, 0, 0, 1, 0, 0, 110, 19896, 0, '', '1', '0'),
	(10893, '19896', 13, 'wallpaper_single_111', 1, 0, 0, 1, 0, 0, 111, 19896, 0, '', '1', '0'),
	(10894, '19896', 13, 'wallpaper_single_112', 1, 0, 0, 1, 0, 0, 44, 19896, 0, '', '1', '0'),
	(10895, '19896', 13, 'wallpaper_single_113', 1, 0, 0, 1, 0, 0, 113, 19896, 0, '', '1', '0'),
	(10896, '19896', 13, 'wallpaper_single_114', 1, 0, 0, 1, 0, 0, 114, 19896, 0, '', '1', '0'),
	(10897, '19896', 13, 'wallpaper_single_115', 1, 0, 0, 1, 0, 0, 115, 19896, 0, '', '1', '0'),
	(10898, '19896', 13, 'wallpaper_single_201', 1, 0, 0, 1, 0, 0, 201, 19896, 0, '', '1', '0'),
	(10899, '19896', 13, 'wallpaper_single_202', 1, 0, 0, 1, 0, 0, 202, 19896, 0, '', '1', '0'),
	(10900, '19896', 13, 'wallpaper_single_203', 1, 0, 0, 1, 0, 0, 203, 19896, 0, '', '1', '0'),
	(10901, '19896', 13, 'wallpaper_single_204', 1, 0, 0, 1, 0, 0, 204, 19896, 0, '', '1', '0'),
	(10902, '19896', 13, 'wallpaper_single_205', 1, 0, 0, 1, 0, 0, 205, 19896, 0, '', '1', '0'),
	(10903, '19896', 13, 'wallpaper_single_206', 1, 0, 0, 1, 0, 0, 206, 19896, 0, '', '1', '0'),
	(10904, '19896', 13, 'wallpaper_single_207', 1, 0, 0, 1, 0, 0, 207, 19896, 0, '', '1', '0'),
	(10905, '19896', 13, 'wallpaper_single_208', 1, 0, 0, 1, 0, 0, 208, 19896, 0, '', '1', '0'),
	(10906, '19896', 13, 'wallpaper_single_209', 1, 0, 0, 1, 0, 0, 209, 19896, 0, '', '1', '0'),
	(10907, '19896', 13, 'wallpaper_single_210', 1, 0, 0, 1, 0, 0, 210, 19896, 0, '', '1', '0'),
	(10908, '19896', 13, 'wallpaper_single_211', 1, 0, 0, 1, 0, 0, 211, 19896, 0, '', '1', '0'),
	(10909, '19896', 13, 'wallpaper_single_212', 1, 0, 0, 1, 0, 0, 212, 19896, 0, '', '1', '0'),
	(10910, '19896', 13, 'wallpaper_single_213', 1, 0, 0, 1, 0, 0, 213, 19896, 0, '', '1', '0'),
	(10911, '19896', 13, 'wallpaper_single_214', 1, 0, 0, 1, 0, 0, 214, 19896, 0, '', '1', '0'),
	(10912, '19896', 13, 'wallpaper_single_215', 1, 0, 0, 1, 0, 0, 215, 19896, 0, '', '1', '0'),
	(10913, '19896', 13, 'wallpaper_single_216', 1, 0, 0, 1, 0, 0, 216, 19896, 0, '', '1', '0'),
	(10914, '19896', 13, 'wallpaper_single_217', 1, 0, 0, 1, 0, 0, 217, 19896, 0, '', '1', '0'),
	(10915, '19896', 13, 'wallpaper_single_218', 1, 0, 0, 1, 0, 0, 218, 19896, 0, '', '1', '0'),
	(10916, '19896', 13, 'wallpaper_single_301', 1, 0, 0, 1, 0, 0, 301, 19896, 0, '', '1', '0'),
	(10917, '19896', 13, 'wallpaper_single_302', 1, 0, 0, 1, 0, 0, 63, 19896, 0, '', '1', '0'),
	(10918, '19896', 13, 'wallpaper_single_303', 1, 0, 0, 1, 0, 0, 64, 19896, 0, '', '1', '0'),
	(10919, '19896', 13, 'wallpaper_single_304', 1, 0, 0, 1, 0, 0, 65, 19896, 0, '', '1', '0'),
	(10920, '19896', 13, 'wallpaper_single_305', 1, 0, 0, 1, 0, 0, 305, 19896, 0, '', '1', '0'),
	(10921, '19896', 13, 'wallpaper_single_306', 1, 0, 0, 1, 0, 0, 306, 19896, 0, '', '1', '0'),
	(10922, '19896', 13, 'wallpaper_single_307', 1, 0, 0, 1, 0, 0, 307, 19896, 0, '', '1', '0'),
	(10923, '19896', 13, 'wallpaper_single_401', 1, 0, 0, 1, 0, 0, 401, 19896, 0, '', '1', '0'),
	(10924, '19896', 13, 'wallpaper_single_402', 1, 0, 0, 1, 0, 0, 402, 19896, 0, '', '1', '0'),
	(10925, '19896', 13, 'wallpaper_single_403', 1, 0, 0, 1, 0, 0, 403, 19896, 0, '', '1', '0'),
	(10926, '19896', 13, 'wallpaper_single_404', 1, 0, 0, 1, 0, 0, 404, 19896, 0, '', '1', '0'),
	(10927, '19896', 13, 'wallpaper_single_405', 1, 0, 0, 1, 0, 0, 405, 19896, 0, '', '1', '0'),
	(10928, '19896', 13, 'wallpaper_single_406', 1, 0, 0, 1, 0, 0, 406, 19896, 0, '', '1', '0'),
	(10929, '19896', 13, 'wallpaper_single_407', 1, 0, 0, 1, 0, 0, 407, 19896, 0, '', '1', '0'),
	(10930, '19896', 13, 'wallpaper_single_408', 1, 0, 0, 1, 0, 0, 408, 19896, 0, '', '1', '0'),
	(10931, '19896', 13, 'wallpaper_single_501', 1, 0, 0, 1, 0, 0, 503, 19896, 0, '', '1', '0'),
	(10932, '19896', 13, 'wallpaper_single_502', 1, 0, 0, 1, 0, 0, 68, 19896, 0, '', '1', '0'),
	(10933, '19896', 13, 'wallpaper_single_503', 1, 0, 0, 1, 0, 0, 503, 19896, 0, '', '1', '0'),
	(10934, '19896', 13, 'wallpaper_single_504', 1, 0, 0, 1, 0, 0, 504, 19896, 0, '', '1', '0'),
	(10935, '19896', 13, 'wallpaper_single_505', 1, 0, 0, 1, 0, 0, 505, 19896, 0, '', '1', '0'),
	(10936, '19896', 13, 'wallpaper_single_506', 1, 0, 0, 1, 0, 0, 506, 19896, 0, '', '1', '0'),
	(10937, '19896', 13, 'wallpaper_single_507', 1, 0, 0, 1, 0, 0, 507, 19896, 0, '', '1', '0'),
	(10938, '19896', 13, 'wallpaper_single_508', 1, 0, 0, 1, 0, 0, 508, 19896, 0, '', '1', '0'),
	(10939, '19896', 13, 'wallpaper_single_601', 1, 0, 0, 1, 0, 0, 601, 19896, 0, '', '1', '0'),
	(10940, '19896', 13, 'wallpaper_single_602', 1, 0, 0, 1, 0, 0, 602, 19896, 0, '', '1', '0'),
	(10941, '19896', 13, 'wallpaper_single_603', 1, 0, 0, 1, 0, 0, 603, 19896, 0, '', '1', '0'),
	(10942, '19896', 13, 'wallpaper_single_604', 1, 0, 0, 1, 0, 0, 604, 19896, 0, '', '1', '0'),
	(10943, '19896', 13, 'wallpaper_single_605', 1, 0, 0, 1, 0, 0, 605, 19896, 0, '', '1', '0'),
	(10944, '19896', 13, 'wallpaper_single_606', 1, 0, 0, 1, 0, 0, 606, 19896, 0, '', '1', '0'),
	(10945, '19896', 13, 'wallpaper_single_607', 1, 0, 0, 1, 0, 0, 607, 19896, 0, '', '1', '0'),
	(10946, '19896', 13, 'wallpaper_single_608', 1, 0, 0, 1, 0, 0, 608, 19896, 0, '', '1', '0'),
	(10947, '19896', 13, 'wallpaper_single_609', 1, 0, 0, 1, 0, 0, 609, 19896, 0, '', '1', '0'),
	(10948, '19896', 13, 'wallpaper_single_610', 1, 0, 0, 1, 0, 0, 610, 19896, 0, '', '1', '0'),
	(10949, '19896', 13, 'wallpaper_single_701', 1, 0, 0, 1, 0, 0, 701, 19896, 0, '', '1', '0'),
	(10950, '19896', 13, 'wallpaper_single_702', 1, 0, 0, 1, 0, 0, 702, 19896, 0, '', '1', '0'),
	(10951, '19896', 13, 'wallpaper_single_703', 1, 0, 0, 1, 0, 0, 703, 19896, 0, '', '1', '0'),
	(10952, '19896', 13, 'wallpaper_single_704', 1, 0, 0, 1, 0, 0, 704, 19896, 0, '', '1', '0'),
	(10953, '19896', 13, 'wallpaper_single_705', 1, 0, 0, 1, 0, 0, 705, 19896, 0, '', '1', '0'),
	(10954, '19896', 13, 'wallpaper_single_706', 1, 0, 0, 1, 0, 0, 706, 19896, 0, '', '1', '0'),
	(10955, '19896', 13, 'wallpaper_single_707', 1, 0, 0, 1, 0, 0, 707, 19896, 0, '', '1', '0'),
	(10956, '19896', 13, 'wallpaper_single_708', 1, 0, 0, 1, 0, 0, 708, 19896, 0, '', '1', '0'),
	(10957, '19896', 13, 'wallpaper_single_709', 1, 0, 0, 1, 0, 0, 709, 19896, 0, '', '1', '0'),
	(10958, '19896', 13, 'wallpaper_single_710', 1, 0, 0, 1, 0, 0, 710, 19896, 0, '', '1', '0'),
	(10959, '19896', 13, 'wallpaper_single_801', 1, 0, 0, 1, 0, 0, 801, 19896, 0, '', '1', '0'),
	(10960, '19896', 13, 'wallpaper_single_802', 1, 0, 0, 1, 0, 0, 802, 19896, 0, '', '1', '0'),
	(10961, '19896', 13, 'wallpaper_single_803', 1, 0, 0, 1, 0, 0, 803, 19896, 0, '', '1', '0'),
	(10962, '19896', 13, 'wallpaper_single_804', 1, 0, 0, 1, 0, 0, 804, 19896, 0, '', '1', '0'),
	(10963, '19896', 13, 'wallpaper_single_805', 1, 0, 0, 1, 0, 0, 805, 19896, 0, '', '1', '0'),
	(10964, '19896', 13, 'wallpaper_single_806', 1, 0, 0, 1, 0, 0, 806, 19896, 0, '', '1', '0'),
	(10965, '19896', 13, 'wallpaper_single_807', 1, 0, 0, 1, 0, 0, 807, 19896, 0, '', '1', '0'),
	(10966, '19896', 13, 'wallpaper_single_808', 1, 0, 0, 1, 0, 0, 808, 19896, 0, '', '1', '0'),
	(10967, '19896', 13, 'wallpaper_single_809', 1, 0, 0, 1, 0, 0, 809, 19896, 0, '', '1', '0'),
	(10968, '19896', 13, 'wallpaper_single_810', 1, 0, 0, 1, 0, 0, 810, 19896, 0, '', '1', '0'),
	(10969, '19896', 13, 'wallpaper_single_901', 1, 0, 0, 1, 0, 0, 901, 19896, 0, '', '1', '0'),
	(10970, '19896', 13, 'wallpaper_single_902', 1, 0, 0, 1, 0, 0, 902, 19896, 0, '', '1', '0'),
	(10971, '19896', 13, 'wallpaper_single_903', 1, 0, 0, 1, 0, 0, 903, 19896, 0, '', '1', '0'),
	(10972, '19896', 13, 'wallpaper_single_904', 1, 0, 0, 1, 0, 0, 904, 19896, 0, '', '1', '0'),
	(10973, '19896', 13, 'wallpaper_single_905', 1, 0, 0, 1, 0, 0, 905, 19896, 0, '', '1', '0'),
	(10974, '19896', 13, 'wallpaper_single_906', 1, 0, 0, 1, 0, 0, 906, 19896, 0, '', '1', '0'),
	(10975, '19896', 13, 'wallpaper_single_907', 1, 0, 0, 1, 0, 0, 907, 19896, 0, '', '1', '0'),
	(10976, '19896', 13, 'wallpaper_single_908', 1, 0, 0, 1, 0, 0, 908, 19896, 0, '', '1', '0'),
	(10977, '19896', 13, 'wallpaper_single_1001', 1, 0, 0, 1, 0, 0, 76, 19896, 0, '', '1', '0'),
	(10978, '19896', 13, 'wallpaper_single_1002', 1, 0, 0, 1, 0, 0, 77, 19896, 0, '', '1', '0'),
	(10979, '19896', 13, 'wallpaper_single_1003', 1, 0, 0, 1, 0, 0, 78, 19896, 0, '', '1', '0'),
	(10980, '19896', 13, 'wallpaper_single_1004', 1, 0, 0, 1, 0, 0, 79, 19896, 0, '', '1', '0'),
	(10981, '19896', 13, 'wallpaper_single_1005', 1, 0, 0, 1, 0, 0, 80, 19896, 0, '', '1', '0'),
	(10982, '19896', 13, 'wallpaper_single_1006', 1, 0, 0, 1, 0, 0, 81, 19896, 0, '', '1', '0'),
	(10983, '19896', 13, 'wallpaper_single_1007', 1, 0, 0, 1, 0, 0, 82, 19896, 0, '', '1', '0'),
	(10984, '19896', 13, 'wallpaper_single_1101', 1, 0, 0, 1, 0, 0, 1101, 19896, 0, '', '1', '0'),
	(10985, '19896', 13, 'wallpaper_single_1201', 1, 0, 0, 1, 0, 0, 1201, 19896, 0, '', '1', '0'),
	(10986, '19896', 13, 'wallpaper_single_1301', 1, 0, 0, 1, 0, 0, 1301, 19896, 0, '', '1', '0'),
	(10987, '19896', 13, 'wallpaper_single_1401', 1, 0, 0, 1, 0, 0, 1401, 19896, 0, '', '1', '0'),
	(10988, '19896', 13, 'wallpaper_single_1501', 1, 0, 0, 1, 0, 0, 1501, 19896, 0, '', '1', '0'),
	(10989, '19896', 13, 'wallpaper_single_1601', 1, 0, 0, 1, 0, 0, 1601, 19896, 0, '', '1', '0'),
	(10990, '19896', 13, 'wallpaper_single_1701', 1, 0, 0, 1, 0, 0, 1701, 19896, 0, '', '1', '0'),
	(10991, '19896', 13, 'wallpaper_single_1801', 1, 0, 0, 1, 0, 0, 1801, 19896, 0, '', '1', '0'),
	(10992, '19896', 13, 'wallpaper_single_1901', 1, 0, 0, 1, 0, 0, 1901, 19896, 0, '', '1', '0'),
	(10993, '19896', 13, 'wallpaper_single_1902', 1, 0, 0, 1, 0, 0, 1902, 19896, 0, '', '1', '0'),
	(10994, '19896', 13, 'wallpaper_single_2001', 1, 0, 0, 1, 0, 0, 2001, 19896, 0, '', '1', '0'),
	(10995, '19896', 13, 'wallpaper_single_2002', 1, 0, 0, 1, 0, 0, 2002, 19896, 0, '', '1', '0'),
	(10996, '19896', 13, 'wallpaper_single_2003', 1, 0, 0, 1, 0, 0, 2003, 19896, 0, '', '1', '0'),
	(10997, '19896', 13, 'wallpaper_single_2101', 1, 0, 0, 1, 0, 0, 2101, 19896, 0, '', '1', '0'),
	(10998, '19896', 13, 'wallpaper_single_2102', 1, 0, 0, 1, 0, 0, 2102, 19896, 0, '', '1', '0'),
	(10999, '19896', 13, 'wallpaper_single_2103', 1, 0, 0, 1, 0, 0, 2103, 19896, 0, '', '1', '0'),
	(11000, '19896', 13, 'wallpaper_single_2201', 1, 0, 0, 1, 0, 0, 2201, 19896, 0, '', '1', '0'),
	(11001, '19896', 13, 'wallpaper_single_2202', 1, 0, 0, 1, 0, 0, 2202, 19896, 0, '', '1', '0'),
	(11002, '19896', 13, 'wallpaper_single_2203', 1, 0, 0, 1, 0, 0, 2203, 19896, 0, '', '1', '0'),
	(11003, '19896', 13, 'wallpaper_single_2204', 1, 0, 0, 1, 0, 0, 2204, 19896, 0, '', '1', '0'),
	(11004, '19896', 13, 'wallpaper_single_2205', 1, 0, 0, 1, 0, 0, 2205, 19896, 0, '', '1', '0'),
	(11005, '19896', 13, 'wallpaper_single_2206', 1, 0, 0, 1, 0, 0, 2206, 19896, 0, '', '1', '0'),
	(11006, '19896', 13, 'wallpaper_single_2301', 1, 0, 0, 1, 0, 0, 2301, 19896, 0, '', '1', '0'),
	(11007, '19896', 13, 'wallpaper_single_2302', 1, 0, 0, 1, 0, 0, 2302, 19896, 0, '', '1', '0'),
	(11008, '19896', 13, 'wallpaper_single_2303', 1, 0, 0, 1, 0, 0, 2303, 19896, 0, '', '1', '0'),
	(11009, '19896', 13, 'wallpaper_single_2304', 1, 0, 0, 1, 0, 0, 2304, 19896, 0, '', '1', '0'),
	(11010, '19896', 13, 'wallpaper_single_2401', 1, 0, 0, 1, 0, 0, 2401, 19896, 0, '', '1', '0'),
	(11011, '19896', 13, 'wallpaper_single_2402', 1, 0, 0, 1, 0, 0, 2402, 19896, 0, '', '1', '0'),
	(11012, '19896', 13, 'wallpaper_single_2403', 1, 0, 0, 1, 0, 0, 2403, 19896, 0, '', '1', '0'),
	(11013, '19896', 13, 'wallpaper_single_2501', 1, 0, 0, 1, 0, 0, 2501, 19896, 0, '', '1', '0'),
	(11014, '19896', 13, 'wallpaper_single_2502', 1, 0, 0, 1, 0, 0, 2502, 19896, 0, '', '1', '0'),
	(11015, '19896', 13, 'wallpaper_single_2503', 1, 0, 0, 1, 0, 0, 2503, 19896, 0, '', '1', '0'),
	(11016, '19896', 13, 'wallpaper_single_2504', 1, 0, 0, 1, 0, 0, 2504, 19896, 0, '', '1', '0'),
	(11017, '19896', 13, 'wallpaper_single_2601', 1, 0, 0, 1, 0, 0, 2601, 19896, 0, '', '1', '0'),
	(11018, '19896', 13, 'wallpaper_single_2602', 1, 0, 0, 1, 0, 0, 2602, 19896, 0, '', '1', '0'),
	(11019, '19896', 13, 'wallpaper_single_2603', 1, 0, 0, 1, 0, 0, 2603, 19896, 0, '', '1', '0'),
	(11020, '19896', 13, 'wallpaper_single_2604', 1, 0, 0, 1, 0, 0, 2604, 19896, 0, '', '1', '0'),
	(11021, '19896', 13, 'wallpaper_single_2701', 1, 0, 0, 1, 0, 0, 2701, 19896, 0, '', '1', '0'),
	(11022, '19896', 13, 'wallpaper_single_2702', 1, 0, 0, 1, 0, 0, 2702, 19896, 0, '', '1', '0'),
	(11023, '19896', 13, 'wallpaper_single_2703', 1, 0, 0, 1, 0, 0, 2703, 19896, 0, '', '1', '0'),
	(11024, '19896', 13, 'wallpaper_single_2704', 1, 0, 0, 1, 0, 0, 2704, 19896, 0, '', '1', '0'),
	(11025, '19896', 13, 'wallpaper_single_2801', 1, 0, 0, 1, 0, 0, 2801, 19896, 0, '', '1', '0'),
	(11026, '19896', 13, 'wallpaper_single_2802', 1, 0, 0, 1, 0, 0, 2802, 19896, 0, '', '1', '0'),
	(11027, '19896', 13, 'wallpaper_single_2803', 1, 0, 0, 1, 0, 0, 2803, 19896, 0, '', '1', '0'),
	(11028, '19896', 13, 'wallpaper_single_2804', 1, 0, 0, 1, 0, 0, 2804, 19896, 0, '', '1', '0'),
	(11029, '19896', 13, 'wallpaper_single_2901', 1, 0, 0, 1, 0, 0, 2901, 19896, 0, '', '1', '0'),
	(11030, '19896', 13, 'wallpaper_single_2902', 1, 0, 0, 1, 0, 0, 2902, 19896, 0, '', '1', '0'),
	(11031, '19896', 13, 'wallpaper_single_2903', 1, 0, 0, 1, 0, 0, 2903, 19896, 0, '', '1', '0'),
	(11032, '19896', 13, 'wallpaper_single_2904', 1, 0, 0, 1, 0, 0, 2904, 19896, 0, '', '1', '0'),
	(11033, '19896', 13, 'wallpaper_single_3001', 1, 0, 0, 1, 0, 0, 3001, 19896, 0, '', '1', '0'),
	(11034, '19896', 13, 'wallpaper_single_3002', 1, 0, 0, 1, 0, 0, 3002, 19896, 0, '', '1', '0'),
	(11035, '19896', 13, 'wallpaper_single_3003', 1, 0, 0, 1, 0, 0, 3003, 19896, 0, '', '1', '0'),
	(11036, '19896', 13, 'wallpaper_single_3004', 1, 0, 0, 1, 0, 0, 3004, 19896, 0, '', '1', '0'),
	(11037, '19896', 13, 'wallpaper_single_3101', 1, 0, 0, 1, 0, 0, 3101, 19896, 0, '', '1', '0'),
	(11038, '19896', 13, 'wallpaper_single_3102', 1, 0, 0, 1, 0, 0, 3102, 19896, 0, '', '1', '0'),
	(11039, '19896', 13, 'wallpaper_single_3103', 1, 0, 0, 1, 0, 0, 3103, 19896, 0, '', '1', '0'),
	(11040, '19896', 13, 'wallpaper_single_3104', 1, 0, 0, 1, 0, 0, 3104, 19896, 0, '', '1', '0'),
	(11041, '19896', 13, 'wallpaper_single_3105', 1, 0, 0, 1, 0, 0, 3105, 19896, 0, '', '1', '0'),
	(11042, '19896', 13, 'wallpaper_single_3106', 1, 0, 0, 1, 0, 0, 3106, 19896, 0, '', '1', '0'),
	(11050, '59974', 5000, 'rotating_roomdeal287', 30, 30, 5, 1, 0, 0, 1, 59974, 0, '50202', '0', '0'),
	(11051, '59975', 5001, 'rotating_roomdeal280', 30, 30, 5, 1, 0, 0, 1, 59975, 0, '50203', '0', '0'),
	(11052, '59976', 5002, 'rotating_roomdeal287', 30, 30, 5, 1, 0, 0, 1, 59976, 0, '50204', '0', '0'),
	(11053, '59977', 5003, 'rotating_roomdeal287', 30, 30, 5, 1, 0, 0, 1, 59977, 0, '50205', '0', '0'),
	(11054, '59978', 5004, 'rotating_roomdeal281', 30, 30, 5, 1, 0, 0, 1, 59978, 0, '50206', '0', '0'),
	(11055, '11311', 753, 'clothing_h20th', 1, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11064, '2064', 12, 'CF_1_coin_bronze', 1, 0, 0, 1, 0, 0, 3, 18629, 0, '', '1', '0'),
	(11065, '2067', 12, 'CF_5_coin_silver', 5, 0, 0, 1, 0, 0, 4, 18802, 0, '', '1', '0'),
	(11066, '8', 26, 'room_ad_plus_badge', 0, 75, 0, 1, 0, 0, 1, 8, 0, '', '1', '0'),
	(11069, '5535', 223, 'roombg_stars', 4, 0, 0, 1, 0, 0, 10, 21590, 0, '', '1', '0'),
	(11070, '5536', 223, 'roombg_city1', 4, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(11071, '5537', 223, 'roombg_city2', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(11072, '4734', 223, 'flag_ukraine', 4, 0, 0, 1, 0, 0, 7, 25466, 0, '', '1', '0'),
	(11073, '4725', 223, 'year2022', 4, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(11074, '4698', 223, 'party_nt_led', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(11075, '4822', 223, 'roombg_aurora', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11076, '6203', 395, 'hween14_doll3', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(11077, '6204', 395, 'hween14_doll4', 4, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(11078, '8632', 762, 'icedblk_c16_table', 4, 0, 0, 1, 0, 0, 165, 17358, 0, '', '1', '0'),
	(11079, '8642', 762, 'icedblk_c16_div4', 4, 0, 0, 1, 0, 0, 75, 17368, 0, '', '1', '0'),
	(11080, '8652', 762, 'icedblk_c16_div2', 4, 0, 0, 1, 0, 0, 45, 17378, 0, '', '1', '0'),
	(11081, '8662', 762, 'icedblk_c16_couch', 4, 0, 0, 1, 0, 0, 15, 17388, 0, '', '1', '0'),
	(11082, '8672', 762, 'icedblk_c16_div3', 4, 0, 0, 1, 0, 0, 60, 17398, 0, '', '1', '0'),
	(11083, '8682', 762, 'icedblk_c16_solarium', 4, 0, 0, 1, 0, 0, 150, 17408, 0, '', '1', '0'),
	(11084, '8692', 762, 'icedblk_c16_shelves', 4, 0, 0, 1, 0, 0, 105, 17418, 0, '', '1', '0'),
	(11085, '8702', 762, 'icedblk_c16_sofachair', 4, 0, 0, 1, 0, 0, 120, 17428, 0, '', '1', '0'),
	(11086, '8712', 762, 'icedblk_c16_div1', 4, 0, 0, 1, 0, 0, 30, 17438, 0, '', '1', '0'),
	(11087, '8722', 762, 'icedblk_c16_sofa', 4, 0, 0, 1, 0, 0, 135, 17448, 0, '', '1', '0'),
	(11088, '8732', 762, 'icedblk_c16_chair', 4, 0, 0, 1, 0, 0, 1, 17458, 0, '', '1', '0'),
	(11089, '8742', 762, 'icedblk_c16_div5', 4, 0, 0, 1, 0, 0, 90, 17468, 0, '', '1', '0'),
	(11091, '209', 388, 'deadduck2', 3, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(11092, '40110', 21, 'guitar_skull', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11093, '3189', 772, 'LT_skull', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11094, '2993', 772, 'penguin_glow', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11095, '5300', 394, 'hween13_bldtrail', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11096, '8230', 30, 'gothic_c15_chandelier', 3, 0, 0, 1, 0, 0, 34, -1, 0, '', '1', '0'),
	(11097, '4738', 393, 'hween12_guillotine', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11098, '3727', 477, 'qt_xm10_iceduck', 3, 0, 0, 1, 0, 0, 40, -1, 0, '', '1', '0'),
	(11099, '6178', 395, 'hween14_skelepieces', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11100, '6179', 395, 'hween14_mariachi', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11101, '208', 388, 'deadduck', 3, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(11102, '207', 388, 'skullcandle', 3, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(11104, '9158', 783, 'hween_c16_ghostash', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11105, '9188', 783, 'hween_c16_ghostorb', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11106, '9191', 783, 'hween_c16_ghostvial', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11107, '9829', 786, 'xmas_c17_blueprint4', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11109, '9969', 789, 'easter_c18_badflower', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11110, '9445', 789, 'easter_c17_seeds', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11111, '9433', 789, 'easter_c17_sapling', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11112, '9425', 789, 'easter_c17_leafsprout', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11113, '9963', 789, 'easter_c18_lupin1', 4, 0, 0, 1, 0, 0, 44, -1, 0, '', '1', '0'),
	(11114, '10002', 789, 'easter_c18_lupin2', 4, 0, 0, 1, 0, 0, 113, -1, 0, '', '1', '0'),
	(11115, '9976', 789, 'easter_c18_lupin3', 4, 0, 0, 1, 0, 0, 114, -1, 0, '', '1', '0'),
	(11116, '9978', 789, 'easter_c18_lupin4', 4, 0, 0, 1, 0, 0, 115, -1, 0, '', '1', '0'),
	(11117, '10022', 789, 'easter_c18_rose1', 4, 0, 0, 1, 0, 0, 108, -1, 0, '', '1', '0'),
	(11118, '9994', 789, 'easter_c18_rose2', 4, 0, 0, 1, 0, 0, 109, -1, 0, '', '1', '0'),
	(11119, '9971', 789, 'easter_c18_rose3', 4, 0, 0, 1, 0, 0, 110, -1, 0, '', '1', '0'),
	(11120, '9983', 789, 'easter_c18_rose4', 4, 0, 0, 1, 0, 0, 111, -1, 0, '', '1', '0'),
	(11121, '10017', 789, 'easter_c18_snowdrop1', 4, 0, 0, 1, 0, 0, 104, -1, 0, '', '1', '0'),
	(11122, '10021', 789, 'easter_c18_snowdrop2', 4, 0, 0, 1, 0, 0, 105, -1, 0, '', '1', '0'),
	(11123, '9961', 789, 'easter_c18_snowdrop3', 4, 0, 0, 1, 0, 0, 106, -1, 0, '', '1', '0'),
	(11124, '9986', 789, 'easter_c18_snowdrop4', 4, 0, 0, 1, 0, 0, 107, -1, 0, '', '1', '0'),
	(11125, '9997', 789, 'easter_c18_tulip1', 4, 0, 0, 1, 0, 0, 100, -1, 0, '', '1', '0'),
	(11126, '9965', 789, 'easter_c18_tulip2', 4, 0, 0, 1, 0, 0, 101, -1, 0, '', '1', '0'),
	(11127, '9972', 789, 'easter_c18_tulip3', 4, 0, 0, 1, 0, 0, 42, -1, 0, '', '1', '0'),
	(11128, '10006', 789, 'easter_c18_tulip4', 4, 0, 0, 1, 0, 0, 43, -1, 0, '', '1', '0'),
	(11129, '10600', 797, 'fest_c19_bprint1', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11130, '10636', 797, 'fest_c19_bprint2', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11131, '10614', 797, 'fest_c19_bprint3', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11132, '10606', 797, 'fest_c19_bprint4', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11133, '11154', 809, 'spa_c20_bbcharcoal', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11134, '11162', 809, 'spa_c20_bbcitrus', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11135, '11153', 809, 'spa_c20_bbmint', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11136, '11147', 809, 'spa_c20_bbrose', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11137, '8992', 788, 'fxbox_fx192', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11138, '10132', 732, 'tokyo_c18_toy4', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11139, '10133', 732, 'tokyo_c18_toy6', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11140, '10139', 732, 'tokyo_c18_toy9', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11141, '10144', 732, 'tokyo_c18_toy5', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11142, '10152', 732, 'tokyo_c18_toy2', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11143, '10155', 732, 'tokyo_c18_toy1', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11144, '10167', 732, 'tokyo_c18_toy10', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11145, '10168', 732, 'tokyo_c18_toy3', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11146, '10171', 732, 'tokyo_c18_toy8', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11147, '10185', 732, 'tokyo_c18_toy7', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11148, '11172', 819, 'india_c20_saribp', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11149, '11179', 819, 'india_c20_capebp', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11150, '11190', 819, 'india_c20_sherwanibp', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11151, '11195', 819, 'india_c20_snakebp', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11152, '11212', 819, 'india_c20_headjewelbp', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11153, '10787', 830, 'hween_c19_tarot', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11154, '10791', 830, 'hween_c19_herbs', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11155, '10798', 830, 'hween_c19_crystal', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11156, '10812', 830, 'hween_c19_bewitchedskull', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11157, '10824', 830, 'hween_c19_potions', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11158, '10825', 830, 'hween_c19_feathers', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11159, '10826', 830, 'hween_c19_crystalball', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11160, '10829', 830, 'hween_c19_bewitchedcandles', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11161, '9842', 832, 'xmas_c17_blueprint1', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11162, '9833', 832, 'xmas_c17_blueprint2', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11163, '9790', 832, 'xmas_c17_blueprint3', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11165, '9801', 832, 'xmas_c17_blueprint5', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11166, '9793', 832, 'xmas_c17_blueprint6', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11167, '10884', 834, 'xmas_c19_angelfigure', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11168, '10930', 834, 'xmas_c19_dragonfigure', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11169, '10907', 834, 'xmas_c19_reindeerfigure', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11170, '10902', 834, 'xmas_c19_robinfigure', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11171, '10940', 834, 'xmas_c19_unicornfigure', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11172, '5007', 839, 'duck_zombie', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11173, '5001', 839, 'duck_scuba', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11174, '5002', 839, 'duck_afro', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11175, '5003', 839, 'duck_frank', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11176, '40130', 453, 'Habborella Poster 2 Life Buoy', 3, 0, 0, 1, 0, 0, 99, 40130, 0, '', '1', '0'),
	(11177, '40140', 453, 'Habborella Poster 1 Porthole', 3, 0, 0, 1, 0, 0, 99, 40140, 0, '', '1', '0'),
	(11178, '40160', 453, 'Habborella Poster 3 Anchor', 3, 0, 0, 1, 0, 0, 99, 40160, 0, '', '1', '0'),
	(11179, '40040', 30, 'industrialfan', 3, 0, 0, 1, 0, 0, 41, -1, 0, '', '1', '0'),
	(11180, '40010', 473, 'poster 21', 4, 0, 0, 1, 0, 0, 40, 40010, 0, '21', '1', '0'),
	(11181, '40010', 473, 'poster 22', 4, 0, 0, 1, 0, 0, 41, 40010, 0, '22', '1', '0'),
	(11182, '40010', 473, 'poster 23', 4, 0, 0, 1, 0, 0, 42, 40010, 0, '23', '1', '0'),
	(11183, '40010', 473, 'poster 24', 4, 0, 0, 1, 0, 0, 43, 40010, 0, '24', '1', '0'),
	(11184, '40010', 473, 'poster 25', 4, 0, 0, 1, 0, 0, 44, 40010, 0, '25', '1', '0'),
	(11185, '40010', 473, 'poster 26', 4, 0, 0, 1, 0, 0, 45, 40010, 0, '26', '1', '0'),
	(11186, '40010', 473, 'poster 27', 4, 0, 0, 1, 0, 0, 46, 40010, 0, '27', '1', '0'),
	(11187, '40010', 473, 'poster 28', 4, 0, 0, 1, 0, 0, 47, 40010, 0, '28', '1', '0'),
	(11188, '40010', 473, 'poster 29', 4, 0, 0, 1, 0, 0, 48, 40010, 0, '29', '1', '0'),
	(11189, '40010', 473, 'poster 30', 4, 0, 0, 1, 0, 0, 49, 40010, 0, '30', '1', '0'),
	(11190, '40010', 473, 'poster 20', 4, 0, 0, 1, 0, 0, 39, 40010, 0, '20', '1', '0'),
	(11191, '40010', 388, 'poster 42', 4, 0, 0, 1, 0, 0, 70, 40010, 0, '42', '1', '0'),
	(11192, '40010', 388, 'poster 43', 4, 0, 0, 1, 0, 0, 80, 40010, 0, '43', '1', '0'),
	(11193, '40010', 388, 'poster 44', 4, 0, 0, 1, 0, 0, 81, 40010, 0, '44', '1', '0'),
	(11194, '40010', 388, 'poster 45', 4, 0, 0, 1, 0, 0, 82, 40010, 0, '45', '1', '0'),
	(11195, '40010', 302, 'poster 58', 4, 0, 0, 1, 0, 0, 8, 40010, 0, '57', '1', '0'),
	(11196, '40010', 302, 'poster 59', 4, 0, 0, 1, 0, 0, 8, 40010, 0, '58', '1', '0'),
	(11197, '40380', 302, 'DEV window_chinese_narrow', 3, 0, 0, 1, 0, 0, 1, 40380, 0, '', '1', '0'),
	(11198, '40340', 302, 'DEV window_chinese_wide', 3, 0, 0, 1, 0, 0, 1, 40340, 0, '', '1', '0'),
	(11199, '40440', 764, 'DEV window_grunge', 3, 0, 0, 1, 0, 0, 1, 40440, 0, '', '1', '0'),
	(11200, '40490', 43, 'window_diner', 3, 0, 0, 1, 0, 0, 1, 2569, 0, '', '1', '0'),
	(11201, '40460', 43, 'window_diner2', 3, 0, 0, 1, 0, 0, 1, 2566, 0, '', '1', '0'),
	(11202, '11497', 864, 'clothing_wingstiara', 5, 0, 0, 1, 0, 0, 0, -1, 0, '0', '1', '0'),
	(11203, '11421', 687, 'clothing_r20_slumberoutfit', 3, 0, 0, 1, 0, 0, 14, -1, 0, '0', '1', '0'),
	(11204, '11422', 538, 'dtl_r20_gold', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11205, '11423', 861, 'party_nt_barcorn', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11206, '11424', 861, 'country_nt_rbw', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11207, '11425', 861, 'party_nt_chair', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11208, '11426', 861, 'bw_nt_water_2', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11209, '11427', 861, 'usva_nt_shelf', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11210, '11428', 861, 'tiki_nt_bflies', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11211, '11429', 861, 'chair_nt_polyfon', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11212, '11430', 861, 'party_nt_bardesk', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11213, '11431', 861, 'party_nt_tube_bubble', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11214, '11432', 861, 'usva5_nt_sofa', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11215, '11433', 861, 'bw_nt_pool_a1', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11216, '11434', 861, 'rela_nt_plant', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11217, '11435', 861, 'usva_nt_rug', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11218, '11436', 861, 'pura_nt_mdl36', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11219, '11437', 861, 'bw_nt_pool_a3', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11220, '11438', 861, 'rela_nt_rock', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11221, '11439', 861, 'anna_nt_table_blue', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11222, '11440', 861, 'rela_nt_hchair', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11223, '11441', 861, 'cubie_nt_shelf_2_b', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11224, '11442', 861, 'lc_nt_tile2', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11225, '11443', 861, 'val12_nt_pillar1', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11226, '11444', 861, 'party_nt_tube_lava', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11227, '11445', 861, 'bb_nt_lightdiv', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11228, '11446', 861, 'usva2_nt_shelf2', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11229, '11447', 861, 'cubie_nt_shelf_1_b', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11230, '11448', 861, 'pura_nt_mdl26', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11231, '11449', 861, 'usva5_nt_rug', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11232, '11450', 861, 'party_nt_floor', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11233, '11451', 861, 'usva5_nt_chair', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11234, '11452', 861, 'tiki_nt_tray2', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11235, '11453', 861, 'usva5_nt_lamp', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11236, '11454', 861, 'usva2_nt_shelf', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11237, '11455', 861, 'pixel_nt_floor_silver', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11238, '11456', 861, 'coco_nt_sofatable_c3', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11239, '11457', 861, 'pura_nt_mdl16', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11240, '11458', 861, 'rela_nt_stone', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11241, '46960', 861, 'party_nt_neon4', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11242, '46970', 861, 'rela_nt_wall', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11243, '46980', 861, 'party_nt_led', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11244, '46990', 861, 'usva_nt_wallrug', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11245, '47000', 861, 'lt_nt_jngl_wall', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11246, '47010', 861, 'cine_nt_light1', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11247, '47020', 861, 'val09_nt_wdrobe_g', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11248, '47030', 861, 'party_nt_shelf', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11249, '47040', 861, 'window_nt_skyscraper', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11250, '47050', 861, 'window_nt_diner2', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11251, '47060', 861, 'cubie_nt_decal_2_p', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11252, '47070', 861, 'cubie_nt_decal_1_p', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11253, '11459', 589, 'clothing_cyeyepiece', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11254, '11470', 860, 'autumn_c20_bench', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11255, '11460', 860, 'autumn_c20_birdfood', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11256, '11465', 860, 'autumn_c20_tree1', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11257, '11471', 860, 'autumn_c20_tree2', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11258, '11461', 860, 'autumn_c20_tree3', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11259, '11478', 860, 'autumn_c20_tree4', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11260, '11474', 860, 'autumn_c20_tree5', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11261, '11472', 860, 'autumn_c20_tree6', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11262, '11477', 860, 'autumn_r20_pond', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11263, '11462', 687, 'clothing_r20_cyborgface', 3, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(11264, '11463;50263', 948, 'clothing_cybuns', 5, 10, 5, 1, 0, 0, 2, -1, 0, '', '0', '0'),
	(11265, '11464;50265', 948, 'clothing_cylegs', 4, 10, 5, 1, 0, 0, 3, -1, 0, '', '0', '0'),
	(11266, '11466;50262', 948, 'clothing_cytrainers', 3, 10, 5, 1, 0, 0, 4, -1, 0, '', '0', '0'),
	(11267, '11467', 687, 'clothing_r20_cyborgwings', 3, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(11268, '11469;50266', 948, 'clothing_cyfins', 3, 10, 5, 1, 0, 0, 5, -1, 0, '', '0', '0'),
	(11269, '11473;50264', 948, 'clothing_cygasmask', 7, 10, 5, 1, 0, 0, 6, -1, 0, '', '0', '0'),
	(11270, '11475;50261', 948, 'clothing_cyhelmet', 5, 10, 5, 1, 0, 0, 7, -1, 0, '', '0', '0'),
	(11271, '11476;50268', 948, 'clothing_cychest', 4, 10, 5, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(11272, '11541', 862, 'hween_c20_aspentree', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11273, '11488', 862, 'hween_c20_brokenfloor', 3, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(11274, '11491', 862, 'hween_c20_candyapple', 3, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(11275, '11496', 862, 'hween_c20_creepyshadow', 3, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(11276, '11492', 864, 'hween_c20_crookedclock', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11277, '11535', 864, 'hween_c20_crookedtree', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11278, '11507', 862, 'hween_c20_cursedmirror', 3, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(11279, '11509', 862, 'hween_c20_door', 3, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(11280, '11524', 191, 'hween_c20_duckgoddessb', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11281, '11482', 191, 'hween_c20_evilscarecrowb', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11282, '11540', 191, 'hween_c20_eyedemonb', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11283, '11537', 864, 'hween_c20_eyesofa', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11284, '11479', 864, 'hween_c20_eyetv', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11285, '11525', 862, 'hween_c20_floatingbed', 3, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(11286, '11517', 862, 'hween_c20_floor', 3, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(11287, '11527', 862, 'hween_c20_floorstage', 3, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(11288, '11532', 862, 'hween_c20_floortrap', 3, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(11289, '11530', 864, 'hween_c20_goddesscrystal', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11290, '11483', 864, 'hween_c20_goddessthrone', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11291, '11500', 862, 'hween_c20_hallway', 3, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(11292, '11523', 862, 'hween_c20_housewall', 3, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(11293, '11512', 862, 'hween_c20_hwall', 3, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(11294, '11493', 862, 'hween_c20_infinitywall', 3, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(11295, '11499', 862, 'hween_c20_lamp', 3, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(11296, '11514', 862, 'hween_c20_lrstairs', 3, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(11297, '11486', 862, 'hween_c20_madpaper', 3, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(11298, '11513', 862, 'hween_c20_madwall', 3, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(11299, '11521', 862, 'hween_c20_mannequin', 3, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(11300, '11490', 862, 'hween_c20_octobath', 3, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(11301, '11534', 191, 'hween_c20_octodemonb', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11302, '11480', 862, 'hween_c20_otherdimension', 3, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(11303, '11487', 191, 'hween_c20_pandoraboxB', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11304, '11522', 862, 'hween_c20_porchawning', 3, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(11305, '11485', 862, 'hween_c20_porchdvdr', 3, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(11306, '11484', 862, 'hween_c20_porchfloor', 3, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(11307, '11481', 862, 'hween_c20_secretbkshelf', 3, 0, 0, 1, 0, 0, 27, -1, 0, '', '1', '0'),
	(11308, '11494', 864, 'hween_c20_tentacletable', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11309, '11489', 864, 'hween_c20_tentaclethrone', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11310, '11515', 862, 'hween_c20_udstairs', 3, 0, 0, 1, 0, 0, 28, -1, 0, '', '1', '0'),
	(11311, '11505', 862, 'hween_c20_vwall', 3, 0, 0, 1, 0, 0, 29, -1, 0, '', '1', '0'),
	(11312, '11501', 862, 'hween_c20_warpedsofa', 3, 0, 0, 1, 0, 0, 30, -1, 0, '', '1', '0'),
	(11313, '11528', 862, 'hween_c20_window', 3, 0, 0, 1, 0, 0, 31, -1, 0, '', '1', '0'),
	(11314, '11503', 746, 'hween_ltd20_tearfountain', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11315, '11519', 191, 'hween_r20_evilpandoraboxB', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11316, '11538', 862, 'hween_r20_hourglass', 3, 0, 0, 1, 0, 0, 32, -1, 0, '', '1', '0'),
	(11317, '47080', 862, 'hween_c20_floorwallb', 3, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(11318, '11511', 862, 'hween_r20_meltingpainting', 3, 0, 0, 1, 0, 0, 33, -1, 0, '', '1', '0'),
	(11319, '11495', 863, 'hween_c20_pandorabox', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11320, '11498', 863, 'hween_c20_evilscarecrow', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11321, '11502', 863, 'hween_c20_eyedemon', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11322, '11504', 863, 'hween_c20_octodemon', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11323, '11506', 864, 'clothing_multieyesface', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11324, '11508', 687, 'clothing_r20_possessedhair', 3, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(11325, '11510', 589, 'clothing_tentaclehead', 3, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(11326, '11516', 589, 'clothing_webskirt', 3, 0, 0, 1, 0, 0, 10, 22540, 0, '', '1', '0'),
	(11327, '11518', 636, 'clothing_nt_pumpkinbag', 3, 0, 0, 1, 0, 0, 44, -1, 0, '', '1', '0'),
	(11328, '11520', 863, 'hween_r20_evilpandorabox', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11329, '11526', 636, 'clothing_nt_ghost', 3, 0, 0, 1, 0, 0, 45, -1, 0, '', '1', '0'),
	(11330, '11529', 589, 'clothing_pumpkinbag', 3, 0, 0, 1, 0, 0, 11, 22553, 0, '', '1', '0'),
	(11331, '11531', 863, 'hween_c20_duckgoddess', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11332, '11533', 864, 'clothing_crookedhat', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11333, '11536', 589, 'clothing_ghost', 3, 0, 0, 1, 0, 0, 12, 22560, 0, '', '1', '0'),
	(11334, '11539', 636, 'clothing_nt_webskirt', 3, 0, 0, 1, 0, 0, 46, -1, 0, '', '1', '0'),
	(11335, '11542', 636, 'clothing_nt_clownmask', 3, 0, 0, 1, 0, 0, 47, -1, 0, '', '1', '0'),
	(11336, '11543', 687, 'clothing_r20_pumpkinoutfit', 3, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(11337, '11544', 589, 'clothing_clownmask', 3, 0, 0, 1, 0, 0, 13, 22568, 0, '', '1', '0'),
	(11338, '11548', 862, 'hween_c20_porchstairs', 3, 0, 0, 1, 0, 0, 26, -1, 0, '', '1', '0'),
	(11339, '11545', 858, 'rare_royalchair', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11340, '11546', 858, 'rare_royalsofa', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11341, '11547', 307, 'CF_250_fancywatch', 250, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(11342, '11549', 683, 'antibully_machine', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11343, '11550', 858, 'rare_colourable_parasol*5', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11344, '11583', 868, 'plushie_c20_bluebear', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11345, '11611', 868, 'plushie_c20_bluebear1', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11346, '11565', 868, 'plushie_c20_bluebear2', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11347, '11552', 868, 'plushie_c20_bluebear3', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11348, '11566', 868, 'plushie_c20_bluebunny', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11349, '11574', 868, 'plushie_c20_bluebunny1', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11350, '11555', 868, 'plushie_c20_bluebunny2', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11351, '11560', 868, 'plushie_c20_bluebunny3', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11352, '11553', 868, 'plushie_c20_bluelion', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11353, '11597', 868, 'plushie_c20_bluelion1', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11354, '11602', 868, 'plushie_c20_bluelion2', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11355, '11598', 868, 'plushie_c20_bluelion3', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11356, '11591', 868, 'plushie_c20_bow', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11357, '11570', 868, 'plushie_c20_brownbear', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11358, '11616', 868, 'plushie_c20_brownbear1', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11359, '11609', 868, 'plushie_c20_brownbear2', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11360, '11575', 868, 'plushie_c20_brownbear3', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11361, '11589', 868, 'plushie_c20_brownbunny', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11362, '11582', 868, 'plushie_c20_brownbunny1', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11363, '11568', 868, 'plushie_c20_brownbunny2', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11364, '11615', 868, 'plushie_c20_brownbunny3', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11365, '11600', 868, 'plushie_c20_brownlion', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11366, '11604', 868, 'plushie_c20_brownlion1', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11367, '11594', 868, 'plushie_c20_brownlion2', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11368, '11561', 868, 'plushie_c20_brownlion3', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11369, '11562', 869, 'plushie_c20_crackable', 8, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11370, '11558', 821, 'plushie_c20_crackableB', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11371, '11571', 867, 'plushie_c20_dyeblue', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11372, '11599', 867, 'plushie_c20_dyeneutral', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11373, '11577', 867, 'plushie_c20_dyepink', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11374, '11556', 867, 'plushie_c20_dyerainbow', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11375, '11563', 867, 'plushie_c20_fabric1', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11376, '11610', 867, 'plushie_c20_fabric2', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11377, '11588', 867, 'plushie_c20_fabric3', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11378, '11596', 868, 'plushie_c20_flowercrown', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11379, '11607', 866, 'plushie_c20_fluffmachine', 35, 1, 5, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11380, '11578', 868, 'plushie_c20_pinkbear', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11381, '11581', 868, 'plushie_c20_pinkbear1', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11382, '11606', 868, 'plushie_c20_pinkbear2', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11383, '11554', 868, 'plushie_c20_pinkbear3', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11384, '11608', 868, 'plushie_c20_pinkbunny', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11385, '11613', 868, 'plushie_c20_pinkbunny1', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11386, '11614', 868, 'plushie_c20_pinkbunny2', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11387, '11590', 868, 'plushie_c20_pinkbunny3', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11388, '11585', 868, 'plushie_c20_pinklion', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11389, '11576', 868, 'plushie_c20_pinklion1', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11390, '11595', 868, 'plushie_c20_pinklion2', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11391, '11564', 868, 'plushie_c20_pinklion3', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11392, '11573', 868, 'plushie_c20_rainbowbear', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11393, '11593', 868, 'plushie_c20_rainbowbear1', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11394, '11601', 868, 'plushie_c20_rainbowbear2', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11395, '11605', 868, 'plushie_c20_rainbowbear3', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11396, '11580', 868, 'plushie_c20_rainbowbunny', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11397, '11612', 868, 'plushie_c20_rainbowbunny1', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11398, '11559', 868, 'plushie_c20_rainbowbunny2', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11399, '11584', 868, 'plushie_c20_rainbowbunny3', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11400, '11592', 868, 'plushie_c20_rainbowlion', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11401, '11551', 868, 'plushie_c20_rainbowlion1', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11402, '11579', 868, 'plushie_c20_rainbowlion2', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11403, '11572', 868, 'plushie_c20_rainbowlion3', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11404, '11586', 868, 'plushie_c20_scarf', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11405, '11557', 867, 'plushie_c20_stuffing', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11406, '11587', 858, 'plushie_r20_hammock', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11407, '11569', 858, 'plushie_r20_picnictree', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11408, '11571', 870, 'plushie_c20_dyeblue', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11409, '11599', 870, 'plushie_c20_dyeneutral', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11410, '11577', 870, 'plushie_c20_dyepink', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11411, '11556', 870, 'plushie_c20_dyerainbow', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11412, '11563', 870, 'plushie_c20_fabric1', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11413, '11610', 870, 'plushie_c20_fabric2', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11414, '11588', 870, 'plushie_c20_fabric3', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11415, '11557', 870, 'plushie_c20_stuffing', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11416, '11562', 865, 'plushie_c20_crackable', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11417, '11607', 865, 'plushie_c20_fluffmachine', 35, 1, 5, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11418, '11567', 589, 'clothing_unicornrainbow', 3, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(11419, '11603', 687, 'clothing_r20_teddybpack', 3, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(11420, '11617', 687, 'clothing_r20_bearset', 3, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(11421, '11618;50218', 874, 'xmas_r20_icefountain', 25, 25, 5, 1, 0, 0, 31, -1, 0, '', '1', '0'),
	(11422, '11619', 875, 'xmas_c20_runerockgreen', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11423, '11620', 874, 'xmas_c20_crafter', 10, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11424, '11621', 746, 'xmas_ltd20_yak', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11425, '11622', 874, 'xmas_c20_smallrunestones', 1, 50, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(11426, '11623;50220', 874, 'xmas_r20_magicsword', 30, 30, 5, 1, 0, 0, 32, -1, 0, '', '1', '0'),
	(11427, '11624', 874, 'xmas_c20_frozenstream', 7, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(11428, '11626', 874, 'xmas_c20_frostedweeds', 3, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(11429, '11627', 874, 'xmas_c20_woodentrain', 1, 0, 0, 1, 0, 0, 29, -1, 0, '', '1', '0'),
	(11430, '11629', 874, 'xmas_c20_woodenplane', 1, 0, 0, 1, 0, 0, 28, -1, 0, '', '1', '0'),
	(11431, '11631', 874, 'xmas_c20_woodendog', 1, 0, 0, 1, 0, 0, 26, -1, 0, '', '1', '0'),
	(11432, '11632', 874, 'xmas_c20_treestump', 4, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(11433, '11633', 904, 'xmas_c20_flowerguy', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11434, '11634', 904, 'xmas_c20_earthguy', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11435, '11635', 874, 'xmas_c20_shrine', 2, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(11436, '11636', 904, 'xmas_c20_rockguy', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11437, '11638', 874, 'xmas_c20_bridge', 4, 0, 0, 1, 0, 0, 3, -1, 0, '', '1', '0'),
	(11438, '11639', 874, 'xmas_c20_frostytree', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(11439, '11640', 874, 'xmas_c20_woodenblocks', 1, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(11440, '11641', 874, 'xmas_c20_frozenwaterfall', 4, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(11441, '11642', 875, 'xmas_c20_runerockyellow', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11442, '11644', 874, 'xmas_c20_runetele', 8, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(11443, '11645', 874, 'xmas_c20_snowdrops', 3, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(11444, '11646', 904, 'xmas_c20_fireguy', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11445, '11647', 874, 'xmas_c20_frostedholly', 3, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(11446, '11648', 874, 'xmas_c20_frostedfungi', 2, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(11447, '11649', 904, 'xmas_c20_snowguy', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11448, '11650', 874, 'xmas_c20_pebblepeeps', 1, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(11449, '11651', 874, 'xmas_c20_woodenhouse', 1, 0, 0, 1, 0, 0, 27, -1, 0, '', '1', '0'),
	(11450, '11652', 874, 'xmas_c20_beadgame', 3, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(11451, '11654', 874, 'xmas_c20_bigstump', 15, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(11452, '11655', 874, 'xmas_c20_snowbush', 3, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(11453, '11657', 874, 'xmas_c20_smallstump', 2, 0, 0, 1, 0, 0, 17, -1, 0, '', '1', '0'),
	(11454, '11658', 875, 'xmas_c20_runerockred', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11455, '11659', 875, 'xmas_c20_runerockblue', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11456, '11660', 874, 'xmas_c20_woodenbird', 1, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(11457, '11661', 904, 'xmas_c20_iceguy', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11458, '11662', 874, 'xmas_c20_nutcracker', 1, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(11459, '11663', 874, 'xmas_c20_stage', 10, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(11460, '11664', 875, 'xmas_c20_runerockpurple', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11461, '11667', 904, 'xmas_c20_magicguy', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11462, '11668', 874, 'xmas_c20_stonecauldron', 4, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(11463, '11669', 874, 'xmas_c20_stonearch', 12, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(11464, '11670', 875, 'xmas_c20_runerock', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11465, '47090', 874, 'xmas_c20_forestbg', 5, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(11466, '11625', 636, 'clothing_nt_kilt', 3, 0, 0, 1, 0, 0, 48, -1, 0, '', '1', '0'),
	(11467, '11628', 687, 'clothing_r20_dragonflywings', 3, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(11468, '11630', 589, 'clothing_kilttop', 3, 0, 0, 1, 0, 0, 15, 22727, 0, '', '1', '0'),
	(11469, '11637', 589, 'clothing_kilt', 3, 0, 0, 1, 0, 0, 16, 22734, 0, '', '1', '0'),
	(11470, '11643', 589, 'clothing_lanternstaff', 3, 0, 0, 1, 0, 0, 17, 22740, 0, '', '1', '0'),
	(11471, '11653', 636, 'clothing_nt_kilttop', 3, 0, 0, 1, 0, 0, 49, -1, 0, '', '1', '0'),
	(11472, '11656', 636, 'clothing_nt_lanternstaff', 3, 0, 0, 1, 0, 0, 50, -1, 0, '', '1', '0'),
	(11473, '11665', 687, 'clothing_r20_inuit', 3, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(11474, '11666', 589, 'clothing_braidedwavyhair', 3, 0, 0, 1, 0, 0, 18, 22763, 0, '', '1', '0'),
	(11475, '11675', 636, 'clothing_nt_braidedwavyhair', 3, 0, 0, 1, 0, 0, 51, -1, 0, '', '1', '0'),
	(11476, '11671', 307, 'CF_750_perfume', 750, 0, 0, 1, 0, 0, 29, -1, 0, '', '1', '0'),
	(11477, '11672', 683, 'mysterious_trophy', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11478, '11673', 22, 'house_sofa', 4, 1, 5, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11479, '11674', 307, 'CF_350_sparklybag', 350, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(11480, '11468;50287', 118, 'cpunk_r20_augchair', 25, 25, 5, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11481, '11676', 690, 'rare_prize20_xmas', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11482, '11677', 879, 'messy_c21_messyhifi', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11483, '11678', 879, 'messy_c21_messycloset', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11484, '11679', 879, 'messy_c21_wonkylowtable', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11485, '11680', 879, 'messy_c21_forgottenvase', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11486, '11681', 879, 'messy_c21_messyfootwear', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11487, '11682', 879, 'messy_c21_wonkydoormat', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11488, '11683', 879, 'messy_c21_messydrawers', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11489, '11684', 879, 'messy_c21_wonkywallitems', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11490, '11685', 879, 'messy_c21_stackedletters', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11491, '11686', 879, 'messy_c21_kitchenette', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11492, '11687', 879, 'messy_c21_magazines', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11493, '11688', 879, 'messy_c21_messyendtable', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11494, '11689', 879, 'messy_c21_kitchencorner', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11495, '11690', 879, 'messy_c21_trashbags', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11496, '11691', 879, 'messy_c21_messybed', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11497, '11692', 879, 'messy_c21_oldwall', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11498, '11693', 879, 'messy_c21_messyrug', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11499, '11694', 879, 'messy_c21_plushcarpet', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11500, '11695', 879, 'messy_c21_wonkytable', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11501, '11696', 879, 'messy_c21_wonkylamp', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11502, '11697', 879, 'messy_c21_messysofa', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11503, '11698', 879, 'messy_c21_stepladder', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11504, '11699', 879, 'messy_c21_wonkychair', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11505, '11700', 879, 'messy_c21_clothespile', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11506, '11701', 668, 'ny_r20_crackable', 7, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(11507, '11702', 908, 'clothing_r20_mask3', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11508, '11703', 908, 'clothing_r20_mask1', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11509, '11704', 908, 'clothing_r20_mask8', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11510, '11705', 908, 'clothing_r20_mask7', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11511, '11706', 908, 'clothing_r20_mask4', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11512, '11707', 911, 'clothing_r21_sunnycloudhat', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11513, '11708', 908, 'clothing_r20_mask5', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11514, '11709', 908, 'clothing_r20_mask6', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11515, '11710', 908, 'clothing_r20_mask2', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11516, '11711', 585, 'clothing_goldhatpack1', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11517, '11712', 664, 'bonusbag21_4', 3, 0, 0, 1, 0, 0, 30, -1, 0, '', '0', '0'),
	(11518, '11713', 901, 'bonusrare21_2*0', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11519, '11714', 901, 'bonusrare21_2*1', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11520, '11715', 901, 'bonusrare21_2*2', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11521, '11716', 901, 'bonusrare21_2*3', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11522, '11717', 901, 'bonusrare21_2*4', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11523, '11718', 901, 'bonusrare21_2*5', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11524, '11719', 901, 'bonusrare21_3*1', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11525, '11720', 901, 'bonusrare21_3*2', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11526, '11721', 901, 'bonusrare21_3*3', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11527, '11722', 901, 'bonusrare21_3*4', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11528, '11723', 901, 'bonusrare21_3*5', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11529, '11724', 901, 'bonusrare21_3*6', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11530, '11725', 901, 'bonusrare21_4*0', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11531, '11726', 901, 'bonusrare21_4*1', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11532, '11727', 901, 'bonusrare21_4*2', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11533, '11728', 901, 'bonusrare21_4*3', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11534, '11729', 901, 'bonusrare21_4*4', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11535, '11730', 901, 'bonusrare21_4*5', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11536, '11731', 664, 'bonusbag21_3', 3, 0, 0, 1, 0, 0, 29, -1, 0, '', '1', '0'),
	(11537, '11732', 901, 'bonusrare21_1a*0', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11538, '11733', 901, 'bonusrare21_1a*1', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11539, '11734', 901, 'bonusrare21_1a*2', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11540, '11735', 901, 'bonusrare21_1a*3', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11541, '11736', 901, 'bonusrare21_1a*4', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11542, '11737', 901, 'bonusrare21_1a*5', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11543, '11738', 664, 'bonusbag21_1', 3, 0, 0, 1, 0, 0, 27, -1, 0, '', '1', '0'),
	(11544, '11739', 664, 'bonusbag21_2', 3, 0, 0, 1, 0, 0, 28, -1, 0, '', '1', '0'),
	(11545, '11740', 302, 'clothing_oxset', 4, 0, 0, 1, 0, 0, 1, 22917, 0, '', '0', '0'),
	(11546, '11741', 302, 'china_goldenox', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11547, '11742', 302, 'china_c21_gong', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11548, '11743', 302, 'china_c21_vase', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11549, '11744', 302, 'china_c21_orangebasket', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11550, '11745;50298', 885, 'rare_r21_coffeesiphon', 25, 25, 5, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11551, '11746;50279', 50004, 'ltd21_unicornpup', 250, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11552, '11747', 881, 'hc21_12', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '1'),
	(11553, '11748', 881, 'hc21_3', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '1'),
	(11554, '11749', 881, 'hc21_1', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '1'),
	(11555, '11750', 881, 'hc21_11', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '1'),
	(11556, '11751', 881, 'hc21_6', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '1'),
	(11557, '11752', 881, 'hc21_4', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '1'),
	(11558, '11753', 881, 'hc21_5', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '1'),
	(11559, '11754', 881, 'hc21_2', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '1'),
	(11560, '11755', 881, 'hc21_8', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '1'),
	(11561, '11756', 881, 'hc21_9', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '1'),
	(11562, '11757', 881, 'hc21_10', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '1'),
	(11563, '11758', 881, 'hc21_7', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '1'),
	(11564, '11759;50288', 865, 'plushie_r21_kingbear', 25, 25, 5, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11565, '11760', 491, 'diamond_painting62', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11566, '11761', 491, 'diamond_painting60', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11567, '11762', 491, 'diamond_painting59', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11568, '11763', 491, 'diamond_painting54', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11569, '11764', 307, 'CF_500_egg', 500, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11570, '11765', 307, 'CF_750_golddragon', 750, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11571, '11766', 307, 'CF_350_giantpearl', 350, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11572, '11767', 307, 'CF_250_toiletpaper', 250, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11573, '11768:50286', 896, 'garden_r21_wisteriaarch', 25, 25, 5, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11574, '11769', 880, 'rare_prize21*0', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11575, '11770', 880, 'rare_prize21*1', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11576, '11771', 880, 'rare_prize21*10', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11577, '11772', 880, 'rare_prize21*11', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11578, '11773', 880, 'rare_prize21*12', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11579, '11774', 880, 'rare_prize21*13', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11580, '11775', 880, 'rare_prize21*2', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11581, '11776', 880, 'rare_prize21*3', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11582, '11777', 880, 'rare_prize21*4', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11583, '11778', 880, 'rare_prize21*5', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11584, '11779', 880, 'rare_prize21*6', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11585, '11780', 880, 'rare_prize21*7', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11586, '11781', 880, 'rare_prize21*8', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11587, '11782', 880, 'rare_prize21*9', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11588, '11783', 882, 'SID_c21_plush', 0, 10, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11589, '11784', 435, 'suncity_c21_beehive', 3, 0, 0, 1, 0, 0, 26, -1, 0, '', '0', '0'),
	(11590, '11785', 364, 'classic7_c21_neonlights', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11591, '11786', 683, 'pastel_c21_accessorykit', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11592, '11787', 882, 'celestial_c21_lamp', 8, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11593, '11788', 882, 'val_c21_displaycase', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11594, '11789', 882, 'val_r21_narwhalplush', 25, 25, 5, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11595, '11790', 882, 'val_c21_flowerwreath', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11596, '11791', 882, 'val_r21_bunny', 25, 25, 5, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11597, '11792', 882, 'val_c21_plantstand', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11598, '11793', 911, 'clothing_r21_flowerhair', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11599, '11794', 882, 'val_c21_cashier', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11600, '11795', 882, 'val_c21_shopsign', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11601, '11796', 882, 'val_r21_clock', 25, 25, 5, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11602, '11797', 882, 'val_c21_displaybox', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11603, '11798', 882, 'val_c21_parasol', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11604, '11799', 911, 'clothing_r21_valcorset', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11605, '11800', 882, 'val_c21_vendingmachine', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11606, '11801', 882, 'val_c21_bell', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11607, '11802', 882, 'val_c21_leafmobile', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11608, '11803;50213', 883, 'fruit_c21_bed', 5, 10, 5, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11609, '11804;50207', 883, 'fruit_c21_cherrylamp', 4, 10, 5, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11610, '11805;50209', 883, 'fruit_c21_bananachair', 5, 10, 5, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11611, '11806;50212', 883, 'fruit_c21_strawbmat', 3, 10, 5, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11612, '11807;50208', 883, 'fruit_c21_avowardrobe', 5, 10, 5, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11613, '11808', 883, 'clothing_fruitbag', 6, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11614, '11809', 911, 'clothing_r21_dyedbangs', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11615, '11810;50211', 883, 'fruit_c21_table', 4, 10, 5, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11616, '11811;50214', 883, 'fruit_c21_citrussofa', 5, 10, 5, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11617, '11812;50210', 883, 'fruit_c21_clock', 3, 10, 5, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11618, '11813', 428, 'tokyo_c21_wagashistall', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11619, '11814', 911, 'clothing_r21_catbackpack2', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11620, '11815;50299', 884, 'rare_r21_aussiedog', 25, 25, 5, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11621, '11816;50300', 884, 'rare_r21_blossomtree', 25, 25, 5, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11622, '11817', 683, 'market_c21_toiletroll', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11623, '11818', 683, 'fest_c21_crystalstall', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11624, '11819', 906, 'clothing_camojoggers', 3, 0, 0, 1, 0, 0, 13, -1, 0, '', '0', '0'),
	(11625, '11820', 884, 'easter_c21_digitalfloor', 8, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11626, '11821', 906, 'clothing_blockcroptop', 3, 0, 0, 1, 0, 0, 20, -1, 0, '', '0', '0'),
	(11627, '11822', 884, 'clothing_hiphopsweats', 3, 0, 0, 1, 0, 0, 1, 23064, 0, '', '0', '0'),
	(11628, '11823', 906, 'clothing_blockhoodie', 3, 0, 0, 1, 0, 0, 18, -1, 0, '', '0', '0'),
	(11629, '11824', 906, 'clothing_darkhoodie', 3, 0, 0, 1, 0, 0, 10, -1, 0, '', '0', '0'),
	(11630, '11825', 636, 'clothing_nt_hijab', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11631, '11826', 906, 'clothing_tiedyejoggers', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11632, '11827', 907, 'clothing_basichoodie', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11633, '11828', 884, 'easter_c21_lightplatform', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11634, '11829', 906, 'clothing_patternhoodie', 3, 0, 0, 1, 0, 0, 6, -1, 0, '', '0', '0'),
	(11635, '11830', 906, 'clothing_patternjoggers', 3, 0, 0, 1, 0, 0, 5, -1, 0, '', '0', '0'),
	(11636, '11831', 636, 'clothing_nt_openshirt', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11637, '11832', 884, 'clothing_leathertrousers', 3, 0, 0, 1, 0, 0, 1, 23074, 0, '', '0', '0'),
	(11638, '11833', 884, 'clothing_leathergloves', 2, 0, 0, 1, 0, 0, 1, 23075, 0, '', '0', '0'),
	(11639, '11834', 906, 'clothing_darkjoggers', 3, 0, 0, 1, 0, 0, 9, -1, 0, '', '0', '0'),
	(11640, '11835', 884, 'clothing_middlepart', 6, 0, 0, 1, 0, 0, 1, 23077, 0, '', '0', '0'),
	(11641, '11836', 884, 'clothing_aviatorjacket', 5, 0, 0, 1, 0, 0, 1, 23078, 0, '', '0', '0'),
	(11642, '11837', 636, 'clothing_nt_eggearrings', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11643, '11838', 884, 'clothing_multibadges', 1, 0, 0, 1, 0, 0, 1, 23080, 0, '', '0', '0'),
	(11644, '11839', 906, 'clothing_darkcroptop', 3, 0, 0, 1, 0, 0, 12, -1, 0, '', '0', '0'),
	(11645, '11840', 907, 'clothing_croptop', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11646, '11841', 906, 'clothing_patterncroptop', 3, 0, 0, 1, 0, 0, 8, -1, 0, '', '0', '0'),
	(11647, '11842', 906, 'clothing_tiedyehat', 3, 0, 0, 1, 0, 0, 3, -1, 0, '', '0', '0'),
	(11648, '11843', 906, 'clothing_camohat', 3, 0, 0, 1, 0, 0, 15, -1, 0, '', '0', '0'),
	(11649, '11844;50224', 884, 'easter_r21_pasteldragon', 25, 25, 5, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11650, '11845', 884, 'clothing_offshoulderjumpsuit', 10, 0, 0, 1, 0, 0, 1, 23087, 0, '', '0', '0'),
	(11651, '11846', 906, 'clothing_blockhat', 3, 0, 0, 1, 0, 0, 19, -1, 0, '', '0', '0'),
	(11652, '11847', 884, 'clothing_chestbag', 3, 0, 0, 1, 0, 0, 1, 23089, 0, '', '0', '0'),
	(11653, '11848', 884, 'clothing_hijab', 4, 0, 0, 1, 0, 0, 1, 23090, 0, '', '0', '0'),
	(11654, '11849', 906, 'clothing_patternhat', 3, 0, 0, 1, 0, 0, 7, -1, 0, '', '0', '0'),
	(11655, '11850;50227', 884, 'easter_r21_gianteggbasket', 25, 25, 5, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11656, '11851', 884, 'clothing_openshirt', 5, 0, 0, 1, 0, 0, 1, 23093, 0, '', '0', '0'),
	(11657, '11852', 884, 'easter_c21_digitalwall', 10, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11658, '11853', 636, 'clothing_nt_oxfordshoes', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11659, '11854', 884, 'easter_c21_textile', 2, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11660, '11855;50226', 911, 'clothing_r21_froghat', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11661, '11856;50228', 14, 'easter_ltd21_springvibesegg', 300, 0, 0, 1, 60, 0, 1, -1, 0, '', '0', '0'),
	(11662, '11857', 907, 'clothing_basicjoggers', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11663, '11858', 906, 'clothing_camohoodie', 3, 0, 0, 1, 0, 0, 14, -1, 0, '', '0', '0'),
	(11664, '11859', 884, 'clothing_holographicskirt', 4, 0, 0, 1, 0, 0, 1, 23101, 0, '', '0', '0'),
	(11665, '11860', 907, 'clothing_basichat', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11666, '11861', 884, 'clothing_gothboots', 4, 0, 0, 1, 0, 0, 1, 23103, 0, '', '0', '0'),
	(11667, '11862', 884, 'easter_c21_colourfulink', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11668, '11863', 884, 'clothing_nutrainers', 4, 0, 0, 1, 0, 0, 1, 23105, 0, '', '0', '0'),
	(11669, '11864', 906, 'clothing_blockjoggers', 3, 0, 0, 1, 0, 0, 17, -1, 0, '', '0', '0'),
	(11670, '11865', 884, 'easter_c21_darkink', 1, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11671, '11866', 884, 'clothing_highwaisttrousers', 3, 0, 0, 1, 0, 0, 1, 23108, 0, '', '0', '0'),
	(11672, '11867', 884, 'clothing_oxfordshoes', 4, 0, 0, 1, 0, 0, 1, 23109, 0, '', '0', '0'),
	(11673, '11868', 884, 'easter_c21_hanginglight', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11674, '11869', 906, 'clothing_camocroptop', 3, 0, 0, 1, 0, 0, 16, -1, 0, '', '0', '0'),
	(11675, '11870', 636, 'clothing_nt_offshoulderjumpsuit', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11676, '11871', 906, 'clothing_tiedyecroptop', 3, 0, 0, 1, 0, 0, 4, -1, 0, '', '0', '0'),
	(11677, '11872', 884, 'easter_c21_dyetable', 15, 5, 5, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11678, '11873', 884, 'clothing_eggearrings', 2, 0, 0, 1, 0, 0, 1, 23115, 0, '', '0', '0'),
	(11679, '11874', 906, 'clothing_tiedyehoodie', 3, 0, 0, 1, 0, 0, 2, -1, 0, '', '0', '0'),
	(11680, '11875', 884, 'easter_c21_camoink', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11681, '11876', 884, 'clothing_halfcurlyhair', 7, 0, 0, 1, 0, 0, 1, 23118, 0, '', '0', '0'),
	(11682, '11877', 884, 'clothing_grownoutroots', 6, 0, 0, 1, 0, 0, 1, 23119, 0, '', '0', '0'),
	(11683, '11878', 884, 'clothing_sunsetdress', 10, 0, 0, 1, 0, 0, 1, 23120, 0, '', '0', '0'),
	(11684, '11879', 906, 'clothing_darkhat', 3, 0, 0, 1, 0, 0, 11, -1, 0, '', '0', '0'),
	(11685, '11880', 884, 'clothing_capecoat', 6, 0, 0, 1, 0, 0, 1, 23122, 0, '', '0', '0'),
	(11686, '11881;50225', 911, 'clothing_r21_galaxydress', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11687, '11882', 910, 'ads_dtlrare_gold2', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11688, '11883', 910, 'ads_dtlrare_gold', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11689, '11884', 842, 'farm_c21_pizzaoven', 5, 30, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11690, '11885', 968, 'rare_colourable_dragonlamp*4', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11691, '11886;50282', 14, 'rainbow_ltd21_fan', 1000, 100, 5, 1, 60, 0, 1, -1, 0, '', '0', '0'),
	(11692, '11887', 900, 'ads_fanta_vendingmachine', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11693, '11888', 911, 'clothing_r21_tousledwaves', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11695, '11890', 885, 'clothing_edwardianblouse', 8, 0, 0, 1, 0, 0, 4, 23185, 0, '', '1', '0'),
	(11696, '11891', 885, 'antique_c21_laceparasol', 7, 0, 0, 1, 0, 0, 5, -1, 0, '', '0', '0'),
	(11697, '11892', 885, 'antique_c21_medicinebag', 4, 0, 0, 1, 0, 0, 6, -1, 0, '', '0', '0'),
	(11698, '11893', 885, 'antique_c21_desk', 5, 0, 0, 1, 0, 0, 7, 24152, 0, '', '0', '0'),
	(11699, '11894', 885, 'antique_c21_books', 3, 0, 0, 1, 0, 0, 8, -1, 0, '', '0', '0'),
	(11700, '11895', 885, 'antique_c21_detectiveposter', 4, 0, 0, 1, 0, 0, 9, -1, 0, '', '0', '0'),
	(11701, '11896', 885, 'antique_c21_oldenrug', 5, 0, 0, 1, 0, 0, 10, -1, 0, '', '0', '0'),
	(11702, '11897', 885, 'antique_c21_lamp', 3, 0, 0, 1, 0, 0, 11, -1, 0, '', '0', '0'),
	(11703, '11898', 885, 'antique_c21_magnifyinglass', 3, 0, 0, 1, 0, 0, 12, -1, 0, '', '0', '0'),
	(11704, '11899;50519', 885, 'antique_r21_curiocabinet', 25, 25, 5, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11705, '11900', 885, 'antique_c21_doorteleport', 7, 0, 0, 1, 0, 0, 13, 24152, 0, '', '0', '0'),
	(11706, '11901', 911, 'clothing_r21_detectiveoutfit', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11707, '11902', 885, 'antique_c21_pennyfarthing', 7, 0, 0, 1, 0, 0, 14, -1, 0, '', '0', '0'),
	(11708, '11903', 885, 'antique_c21_teaset', 3, 0, 0, 1, 0, 0, 15, -1, 0, '', '0', '0'),
	(11709, '11904', 885, 'antique_c21_mysterypie', 3, 0, 0, 1, 0, 0, 16, -1, 0, '', '0', '0'),
	(11710, '11905', 885, 'antique_c21_wallclock', 4, 0, 0, 1, 0, 0, 17, -1, 0, '', '0', '0'),
	(11711, '11906', 885, 'antique_c21_armchair', 4, 0, 0, 1, 0, 0, 18, 24152, 0, '', '0', '0'),
	(11712, '11907', 885, 'antique_c21_birdcage', 5, 0, 0, 1, 0, 0, 20, -1, 0, '', '0', '0'),
	(11713, '11908', 886, 'thai_c21_marketstall', 7, 10, 5, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11714, '11909', 886, 'thai_c21_candledish', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11715, '11910', 950, 'thai_c21_woodenwardrobe', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11716, '11911', 886, 'thai_c21_buildingpieces', 5, 0, 0, 1, 0, 0, 1, 24152, 0, '', '0', '0'),
	(11717, '11912', 886, 'thai_c21_bridgewalkway', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11718, '11913', 886, 'thai_c21_pillow', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11719, '11914', 886, 'thai_c21_waterrock', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11720, '11915', 886, 'clothing_bamboohat', 5, 10, 5, 1, 0, 0, 1, 23230, 0, '', '0', '0'),
	(11721, '11916', 886, 'thai_c21_boat1', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11722, '11917', 950, 'clothing_thaisuit', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11723, '11918;50274', 886, 'thai_r21_waterfalltree', 25, 25, 5, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11724, '11919', 886, 'thai_c21_mangrovetree', 9, 10, 5, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11725, '11920', 886, 'thai_c21_strawlamp', 3, 0, 0, 1, 0, 0, 1, 24152, 0, '', '0', '0'),
	(11726, '11921', 950, 'clothing_thaihat', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11727, '11922', 886, 'thai_c21_roofblock', 3, 0, 0, 1, 0, 0, 1, 24152, 0, '', '0', '0'),
	(11728, '11923', 950, 'thai_c21_woodenstatue', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11729, '11924', 950, 'thai_c21_woodensofa', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11730, '11925', 821, 'thai_r21_clothingboxB', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11731, '11926', 886, 'thai_c21_platform', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11732, '11927', 886, 'thai_c21_fruits', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11733, '11928', 886, 'thai_c21_arch', 7, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11734, '11929;50301', 14, 'thai_ltd21_yakgodstatue', 750, 100, 5, 1, 60, 0, 1, -1, 0, '', '0', '0'),
	(11735, '11930', 886, 'thai_c21_mangrovecrab', 2, 10, 5, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11736, '11931', 886, 'thai_r21_clothingbox', 25, 25, 5, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11737, '11932', 886, 'thai_c21_divider', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11738, '11933', 950, 'clothing_thaibunhair', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11739, '11934', 886, 'thai_c21_food', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11740, '11935', 886, 'thai_c21_table', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11741, '11936', 886, 'thai_c21_woodcarvingset', 25, 25, 5, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11742, '11937', 950, 'clothing_thaidress', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11743, '11938', 886, 'thai_c21_boat2', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11744, '11939', 911, 'clothing_r21_muaythaioutfit', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11745, '11940', 911, 'clothing_r21_pangolin', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11746, '11941', 886, 'thai_c21_roof', 3, 0, 0, 1, 0, 0, 1, 24152, 0, '', '0', '0'),
	(11747, '11942', 886, 'thai_c21_indoorstove', 6, 10, 5, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11748, '11943', 886, 'thai_c21_boat3', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11749, '11944', 821, 'thai_c21_woodcarvingsetB', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11750, '11945;50273', 886, 'thai_r21_babyele', 25, 25, 5, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11751, '11946', 950, 'thai_c21_woodenendtable', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11752, '11947', 886, 'thai_c21_closetseat', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11753, '11948', 886, 'clothing_thailei', 2, 10, 5, 1, 0, 0, 1, 23263, 0, '', '0', '0'),
	(11754, '11949', 886, 'thai_c21_rootedgrass', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11755, '11950', 886, 'thai_c21_crystalwater', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11756, '11951', 202, 'clothing_squid2', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11757, '11952', 636, 'clothing_nt_bamboohat', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11758, '11953', 636, 'clothing_nt_thailei', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11759, '11954', 960, 'trading_table', 3, 0, 0, 1, 0, 0, 1, 23298, 0, '', '0', '0'),
	(11760, '11955', 429, 'tile_cursor', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11761, '11956', 911, 'clothing_r21_kimono3', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11762, '11957;50276', 887, 'rainbow_c21_prideflags', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11763, '11958', 887, 'rainbow_c21_crackable2', 7, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(11764, '11959;11957;50277', 887, 'rainbow_c21_bunting', 10, 0, 0, 1, 0, 0, 2, -1, 0, '', '0', '0'),
	(11765, '11960', 887, 'rainbow_c21_crackable1', 7, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(11766, '11961;50283', 14, 'rainbow_ltd21_rainbowboa', 1000, 100, 5, 1, 60, 0, 1, -1, 0, '', '0', '0'),
	(11767, '11962;11957;50277', 887, 'rainbow_c21_balloonarch', 10, 0, 0, 1, 0, 0, 3, -1, 0, '', '0', '0'),
	(11768, '11963', 911, 'clothing_r21_beachywaves', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11769, '11964', 821, 'rainbow_c21_crackable1A', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11770, '11965;11957;50277', 887, 'clothing_pridehoodie', 15, 0, 0, 1, 0, 0, 6, -1, 0, '', '0', '0'),
	(11771, '11966', 911, 'clothing_r21_holojacket', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11772, '11967;11957;50277', 887, 'clothing_rainbowwings', 15, 0, 0, 1, 0, 0, 7, -1, 0, '', '0', '0'),
	(11773, '11968;11957;50277', 887, 'clothing_rainbowundercut', 15, 0, 0, 1, 0, 0, 8, -1, 0, '', '0', '0'),
	(11774, '11969;11957;50277', 887, 'clothing_pridecape', 15, 0, 0, 1, 0, 0, 9, -1, 0, '', '0', '0'),
	(11775, '11970;11957;50277', 887, 'rainbow_c21_rainbowroad', 10, 0, 0, 1, 0, 0, 4, -1, 0, '', '0', '0'),
	(11776, '11971;11957;50277', 887, 'rainbow_c21_lightbulbheart', 10, 0, 0, 1, 0, 0, 5, -1, 0, '', '0', '0'),
	(11777, '11972', 821, 'rainbow_c21_crackable2A', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11778, '11973;50285', 896, 'garden_r21_rosebench', 25, 25, 5, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11779, '11974;50284', 896, 'garden_r21_plantwall', 25, 25, 5, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11780, '11975', 946, 'vwave_c21_glitchbuildings', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11781, '11976', 888, 'vwave_c21_neonsigns', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11782, '11977', 888, 'vwave_c21_brokentech', 2, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11783, '11978', 888, 'vwave_c21_cctv', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11784, '11979', 946, 'vwave_c21_glitchrailcrnr', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11785, '11980', 888, 'vwave_c21_barstool', 3, 0, 0, 1, 0, 0, 1, 24152, 0, '', '1', '0'),
	(11786, '11981', 888, 'clothing_bubblegum', 7, 0, 0, 1, 0, 0, 1, 23514, 0, '', '0', '0'),
	(11787, '11982', 888, 'vwave_c21_buildings', 5, 0, 0, 1, 0, 0, 1, 25842, 0, '', '1', '0'),
	(11788, '11983', 888, 'vwave_c21_railcrnr', 2, 0, 0, 1, 0, 0, 1, 25842, 0, '', '0', '0'),
	(11789, '11984', 946, 'vwave_c21_glitchrailing', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11790, '11985', 888, 'clothing_toughface', 6, 0, 0, 1, 0, 0, 1, 23518, 0, '', '0', '0'),
	(11791, '11986', 888, 'vwave_c21_wall', 7, 0, 0, 1, 0, 0, 1, 25842, 0, '', '1', '0'),
	(11792, '11987', 888, 'vwave_c21_bench', 5, 0, 0, 1, 0, 0, 1, 25842, 0, '', '1', '0'),
	(11793, '11988', 946, 'clothing_gemglasses', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11794, '11989', 946, 'vwave_c21_glitchpalm', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11795, '11990', 888, 'vwave_c21_dumpster', 5, 0, 0, 1, 0, 0, 1, 25842, 0, '', '1', '0'),
	(11796, '11991', 888, 'vwave_c21_planter', 5, 0, 0, 1, 0, 0, 1, 25842, 0, '', '1', '0'),
	(11797, '11992', 888, 'vwave_c21_trash', 2, 0, 0, 1, 0, 0, 1, 25842, 0, '', '1', '0'),
	(11798, '11993', 946, 'vwave_c21_glitchbench', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11799, '11994', 888, 'vwave_c21_pavement', 2, 0, 0, 1, 0, 0, 1, 25842, 0, '', '0', '0'),
	(11800, '11995;50256', 888, 'vwave_r21_motorbike', 35, 35, 5, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(11801, '11996', 946, 'clothing_retroshirt', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11802, '11997', 946, 'clothing_daffyfunkhelmet', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11803, '11998', 946, 'vwave_c21_glitchnightsand', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11804, '11999', 888, 'vwave_c21_rubiks', 2, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11805, '12000', 946, 'vwave_c21_glitchwall', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11806, '12001', 888, 'vwave_c21_mocktails', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11807, '12002', 888, 'vwave_c21_motelfront', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11808, '12003;50254', 911, 'clothing_r21_rollerskates', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11809, '12004;50258', 888, 'clothing_retrosuit', 2, 2, 5, 1, 0, 0, 1, 23537, 0, '', '0', '1'),
	(11810, '12005', 888, 'vwave_c21_motelrooms', 7, 0, 0, 1, 0, 0, 1, 25842, 0, '', '1', '0'),
	(11811, '12006', 888, 'vwave_c21_floppydisk', 2, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11812, '12007', 888, 'vwave_c21_nightclub', 5, 0, 0, 1, 0, 0, 1, 25842, 0, '', '1', '0'),
	(11813, '12008', 888, 'vwave_c21_parkingmeter', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11814, '12009', 946, 'vwave_c21_glitchplanter', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11815, '12010', 888, 'vwave_c21_railing', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11816, '12011', 888, 'vwave_c21_barglasses', 3, 0, 0, 1, 0, 0, 1, 24152, 0, '', '0', '0'),
	(11817, '12012', 946, 'clothing_holographicdress', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11818, '12013', 888, 'clothing_volumehair', 7, 0, 0, 1, 0, 0, 1, 23546, 0, '', '0', '0'),
	(11819, '12014;50253', 911, 'clothing_r21_polaroid', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11820, '12015;50257', 14, 'vwave_ltd21_lambo', 500, 10, 5, 1, 60, 0, 0, -1, 0, '', '0', '0'),
	(11821, '12016', 888, 'clothing_retromakeup', 5, 0, 0, 1, 0, 0, 1, 23549, 0, '', '0', '0'),
	(11822, '12017', 888, 'vwave_c21_streetlight', 4, 0, 0, 1, 0, 0, 1, 25842, 0, '', '0', '0'),
	(11823, '12018;50255', 888, 'vwave_r21_jukebox', 35, 35, 5, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(11824, '12019', 888, 'vwave_c21_pc', 15, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11825, '12020', 888, 'vwave_c21_bartable', 5, 0, 0, 1, 0, 0, 1, 24152, 0, '', '1', '0'),
	(11826, '12021', 946, 'vwave_c21_glitchpavement', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11827, '12022', 888, 'vwave_c21_frenchbulldog', 6, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(11828, '12023', 888, 'vwave_c21_posters', 2, 0, 0, 1, 0, 0, 1, 25842, 0, '', '1', '0'),
	(11829, '12024', 888, 'vwave_c21_nightsand', 6, 0, 0, 1, 0, 0, 1, 25842, 0, '', '0', '0'),
	(11830, '12025', 888, 'vwave_c21_drinkshelf', 3, 0, 0, 1, 0, 0, 1, 24152, 0, '', '1', '0'),
	(11831, '12026', 888, 'vwave_c21_palm', 4, 0, 0, 1, 0, 0, 1, 25842, 0, '', '1', '0'),
	(11832, '12027', 888, 'clothing_modernmullet', 7, 0, 0, 1, 0, 0, 1, 23560, 0, '', '0', '0'),
	(11833, '12028', 946, 'vwave_c21_glitchstreetlight', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11834, '12029', 889, 'clothing_darkcrown', 13, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11835, '12030;50515', 911, 'clothing_r21_fairyhair', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11836, '12031', 889, 'clothing_petalhat', 5, 10, 5, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11837, '12032', 889, 'mushroom_c21_shelves', 5, 10, 5, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11838, '12033;50518', 14, 'mushroom_ltd21_fairy', 750, 0, 0, 1, 60, 0, 1, -1, 0, '', '0', '0'),
	(11839, '12034', 889, 'mushroom_c21_crackable', 2, 10, 5, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11840, '12035', 889, 'clothing_mushroom2', 5, 10, 5, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11841, '12036', 889, 'mushroom_c21_chair', 3, 10, 5, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11842, '12037;50517', 889, 'mushroom_r21_teapot', 25, 25, 5, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11843, '12038', 889, 'mushroom_c21_archway', 6, 10, 5, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11844, '12039;50514', 911, 'clothing_r21_fairywings', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11845, '12040', 889, 'clothing_flowerdress', 5, 10, 5, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11846, '12041', 889, 'mushroom_c21_drawers', 4, 10, 5, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11847, '12042;50516', 889, 'mushroom_r21_magicmirror', 25, 25, 5, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11848, '12043', 889, 'mushroom_c21_bouncymushroom', 12, 50, 5, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11849, '12044', 889, 'mushroom_c21_table', 3, 10, 5, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11850, '12045', 821, 'mushroom_c21_crackableB', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11851, '12046', 889, 'mushroom_c21_bigmushroom', 4, 10, 5, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11852, '12047', 733, 'clothing_diaicetiara', 3, 0, 0, 1, 0, 0, 4, -1, 0, '', '1', '0'),
	(11853, '12048', 169, 'diamond_c21_giftbox', 5, 0, 0, 1, 0, 0, 2, -1, 0, '', '1', '0'),
	(11854, '12049', 733, 'clothing_diahermeshat', 3, 0, 0, 1, 0, 0, 5, -1, 0, '', '1', '0'),
	(11855, '12050', 821, 'diamond_c21_giftbox2', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11856, '12051', 733, 'clothing_diaelegantcrown', 3, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(11857, '12052', 890, 'hween_c21_purificationscroll', 2, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11858, '12053', 890, 'hween_c21_stonefloor', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11859, '12054;50248', 890, 'hween_r21_goldenflowerscreen', 25, 25, 5, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11860, '12055', 890, 'hween_c21_tatami', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11861, '12056', 636, 'clothing_nt_ghostheadband', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11862, '12057', 890, 'hween_c21_biwa', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11863, '12058', 890, 'hween_c21_torii', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11864, '12059', 890, 'hween_c21_chair', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11865, '12060', 890, 'hween_c21_raindoll', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11866, '12061', 890, 'clothing_spiritfire', 2, 0, 0, 1, 0, 0, 1, 23776, 0, '', '0', '0'),
	(11867, '12062', 937, 'hween_c21_kitsune', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11868, '12063', 890, 'hween_c21_shojislidingdoor', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11869, '12064', 890, 'hween_c21_indoorshrine', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11870, '12065', 890, 'clothing_ghosthair', 5, 0, 0, 1, 0, 0, 1, 23780, 0, '', '0', '0'),
	(11871, '12066', 890, 'hween_c21_parasol', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11872, '12067', 937, 'hween_c21_shadownekomata', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11873, '12068', 890, 'hween_c21_shojislidingdoor2', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11874, '12069', 911, 'clothing_r21_ninjaoutfit', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11875, '12070', 636, 'clothing_nt_ghosthair', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11876, '12071', 636, 'clothing_nt_spiritfire', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11877, '12072', 890, 'hween_c21_spiderlily', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11878, '12073', 890, 'hween_c21_giantbamboo', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11879, '12074', 890, 'hween_c21_matchabowl', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11880, '12075', 890, 'hween_c21_scrollaltar', 10, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11881, '12076', 937, 'hween_c21_shadowkappa', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11882, '12077', 890, 'hween_c21_futon', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11883, '12078', 890, 'hween_c21_stonetrap', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11884, '12079', 890, 'hween_c21_kotatsu', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11885, '12080', 937, 'hween_c21_kappa', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11886, '12081', 890, 'hween_c21_gravestone', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11887, '12082', 890, 'hween_c21_kitsunestatue', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11888, '12083', 937, 'hween_c21_nekomata', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11889, '12084', 890, 'hween_c21_magatama', 2, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11890, '12085', 890, 'clothing_ghostheadband', 2, 0, 0, 1, 0, 0, 1, 23800, 0, '', '0', '0'),
	(11891, '12086', 890, 'hween_c21_lantern', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11892, '12087', 890, 'hween_c21_doll', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11893, '12088', 890, 'hween_c21_platform', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11894, '12089', 890, 'hween_c21_natto', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11895, '12090', 890, 'hween_c21_tatamiplatform', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11896, '12091', 890, 'hween_c21_shojiwall', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11897, '12092;502047', 890, 'hween_r21_mirror', 25, 25, 5, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11898, '12093', 890, 'hween_c21_onitriomask', 2, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11899, '12094', 890, 'hween_c21_kappapond', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11900, '12095', 937, 'hween_c21_shadowoni', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11901, '12096', 890, 'hween_c21_wallset', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11902, '12097', 937, 'hween_c21_shadowkitsune', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11903, '12098', 890, 'hween_c21_pillarcorners', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11904, '12099', 937, 'hween_c21_oni', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11905, '12100', 911, 'clothing_r21_himehair', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11906, '12101', 890, 'hween_c21_sushi', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11907, '12102;50249', 14, 'hween_ltd21_pagoda', 500, 0, 0, 1, 60, 0, 1, -1, 0, '', '0', '0'),
	(11908, '12103', 215, 'tile_stackmagic6x6', 12, 0, 0, 1, 0, 0, 5, 23862, 0, '', '1', '0'),
	(11909, '12104', 215, 'tile_stackmagic4x4', 10, 0, 0, 1, 0, 0, 4, 23863, 0, '', '1', '0'),
	(11910, '12105', 215, 'tile_stackmagic8x8', 14, 0, 0, 1, 0, 0, 6, 23864, 0, '', '1', '0'),
	(11911, '12106', 967, 'rare_colourable_parasol*6', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11912, '12107', 967, 'rare_colourable_elephant_statue*4', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11913, '12108', 967, 'rare_colourable_fan*4', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11914, '12109;50281', 14, 'rainbow_ltd21_dragonlamp', 1000, 100, 5, 1, 60, 0, 1, -1, 0, '', '0', '0'),
	(11915, '12110', 891, 'icecream_c21_wall', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11916, '12111', 891, 'icecream_c21_floor', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11917, '12112', 891, 'icecream_c21_chairpurple', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11918, '12113', 891, 'icecream_c21_light', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11919, '12114', 891, 'icecream_c21_stool', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11920, '12115', 891, 'icecream_c21_glasstable', 10, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11921, '12116', 891, 'icecream_c21_chairorange', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11922, '12117', 891, 'icecream_c21_sundaes', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11923, '12118;50238', 891, 'icecream_c21_display', 8, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11924, '12119', 891, 'icecream_c21_menu', 8, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11925, '12120', 891, 'icecream_c21_machine', 12, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11926, '12121', 891, 'icecream_c21_counter', 10, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11927, '12122', 891, 'icecream_c21_bartable', 10, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11928, '12123', 919, 'clothing_conehat', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11929, '12124', 892, 'bubblejuice_c21_window', 4, 0, 0, 1, 0, 0, 1, 24152, 0, '', '0', '0'),
	(11930, '12125', 919, 'bubblejuice_c21_barrel', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11931, '12126', 916, 'bubblejuice_c21_citrus', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11932, '12127;50530', 892, 'bubblejuice_c21_crackable2', 5, 10, 5, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11933, '12128', 916, 'bubblejuice_c21_hops', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11934, '12129', 919, 'bubblejuice_c21_light', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11935, '12130', 916, 'bubblejuice_c21_sofa', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11936, '12131', 919, 'bubblejuice_c21_drinks', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11937, '12132', 892, 'bubblejuice_c21_crackable1', 2, 10, 5, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11938, '12133;50528', 892, 'bubblejuice_r21_juicedispenser', 25, 25, 5, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11939, '12134', 916, 'bubblejuice_c21_dartboard', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11940, '12135', 919, 'clothing_limehead', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11941, '12136', 916, 'bubblejuice_c21_barley', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11942, '12137', 821, 'bubblejuice_c21_crackable1b', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11943, '12138', 919, 'bubblejuice_c21_stool', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11944, '12139', 911, 'clothing_r21_milkmaidbraid', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11945, '12140', 911, 'clothing_r21_cosydungarees', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11946, '12141', 821, 'bubblejuice_c21_crackable2b', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11947, '12142', 892, 'bubblejuice_c21_table', 5, 0, 0, 1, 0, 0, 1, 24152, 0, '', '0', '0'),
	(11948, '12143', 892, 'bubblejuice_c21_wall', 5, 0, 0, 1, 0, 0, 1, 24152, 0, '', '0', '0'),
	(11949, '12144', 892, 'bubblejuice_c21_bar', 7, 10, 5, 1, 0, 0, 1, 24152, 0, '', '0', '0'),
	(11950, '12145', 892, 'bubblejuice_c21_floor', 4, 0, 0, 1, 0, 0, 1, 24152, 0, '', '0', '0'),
	(11951, '12146', 892, 'bubblejuice_c21_chair', 4, 0, 0, 1, 0, 0, 1, 24152, 0, '', '0', '0'),
	(11952, '12147', 892, 'bubblejuice_c21_secretingredient', 10, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11953, '12148', 919, 'clothing_drinkhat', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11954, '12149', 892, 'bubblejuice_c21_sideboard', 6, 0, 0, 1, 0, 0, 1, 24152, 0, '', '0', '0'),
	(11955, '12150', 892, 'clothing_catbeanie', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11956, '12151', 916, 'bubblejuice_c21_neonsign', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11957, '12152;50529', 892, 'bubblejuice_r21_fireplace', 25, 25, 5, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11958, '12153', 919, 'bubblejuice_c21_tableplant', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11959, '12154', 919, 'bubblejuice_c21_dominoes', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11960, '12155', 892, 'bubblejuice_c21_magicbrewer', 10, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11961, '12156', 893, 'xmas_c21_trainplatform', 5, 0, 0, 1, 0, 0, 8, -1, 0, '', '1', '0'),
	(11962, '12157', 893, 'xmas_c21_afternoontea', 2, 0, 0, 1, 0, 0, 9, -1, 0, '', '1', '0'),
	(11963, '12158', 933, 'xmas_c21_royalbird', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11964, '12159', 896, 'clothing_earringbauble', 5, 0, 0, 1, 0, 0, 1, 24004, 0, '', '0', '0'),
	(11965, '12160', 893, 'xmas_c21_readingitems', 2, 0, 0, 1, 0, 0, 10, -1, 0, '', '1', '0'),
	(11966, '12161', 893, 'clothing_pearlnecklace', 3, 0, 0, 1, 0, 0, 1, 24006, 0, '', '0', '0'),
	(11967, '12162', 930, 'xmas_c21_key4', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11968, '12163', 934, 'xmas_c21_advent5', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11969, '12164', 893, 'xmas_c21_tiffanylamp', 3, 0, 0, 1, 0, 0, 11, -1, 0, '', '1', '0'),
	(11970, '12165', 933, 'clothing_conductoroutfit', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11971, '12166', 930, 'xmas_c21_key1', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11972, '12167', 893, 'xmas_c21_trainroofedge', 3, 0, 0, 1, 0, 0, 12, -1, 0, '', '1', '0'),
	(11973, '12168', 893, 'xmas_c21_wallposters', 3, 0, 0, 1, 0, 0, 13, -1, 0, '', '1', '0'),
	(11974, '12169', 933, 'xmas_c21_governesstable', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11975, '12170', 933, 'clothing_salesoutfit', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11976, '12171', 934, 'xmas_c21_advent2', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11977, '12172', 933, 'clothing_governessoutfit', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11978, '12173', 893, 'xmas_c21_trainwall', 5, 0, 0, 1, 0, 0, 14, -1, 0, '', '1', '0'),
	(11979, '12174', 893, 'xmas_c21_traintable', 4, 0, 0, 1, 0, 0, 15, -1, 0, '', '1', '0'),
	(11980, '12175;50243', 893, 'xmas_r21_rideabletrain', 25, 25, 5, 1, 0, 0, 3, -1, 0, '', '0', '0'),
	(11981, '12176', 893, 'xmas_c21_trainsignal', 6, 0, 0, 1, 0, 0, 16, -1, 0, '', '1', '0'),
	(11982, '12177', 893, 'xmas_c21_luggage', 10, 0, 0, 1, 0, 0, 5, -1, 0, '', '0', '0'),
	(11983, '12178', 893, 'xmas_c21_teleport', 7, 0, 0, 1, 0, 0, 17, -1, 0, '', '0', '0'),
	(11984, '12179', 933, 'xmas_c21_doctorscabinet', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11985, '12180', 930, 'xmas_c21_map6', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11986, '12181', 893, 'xmas_c21_trainbase', 5, 0, 0, 1, 0, 0, 18, -1, 0, '', '1', '0'),
	(11987, '12182', 893, 'xmas_c21_trainroof', 4, 0, 0, 1, 0, 0, 19, -1, 0, '', '1', '0'),
	(11988, '12183', 930, 'xmas_c21_lockpick', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11989, '12184', 893, 'xmas_c21_xmasdecor', 3, 0, 0, 1, 0, 0, 20, -1, 0, '', '1', '0'),
	(11990, '12185', 911, 'clothing_r21_warmoversizedcoat', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11991, '12186', 930, 'xmas_c21_key3', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11992, '12187', 636, 'clothing_nt_pearlnecklace', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11993, '12188', 933, 'xmas_c21_minitrain', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11994, '12189', 893, 'clothing_hollyhairpin', 3, 0, 0, 1, 0, 0, 1, 24034, 0, '', '0', '0'),
	(11995, '12190', 934, 'xmas_c21_advent4', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11996, '12191', 934, 'xmas_c21_advent1', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11997, '12192', 934, 'xmas_c21_advent3', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11998, '12193', 930, 'xmas_c21_map4', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(11999, '12194', 934, 'xmas_c21_advent6', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12000, '12195', 930, 'xmas_c21_key2', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12001, '12196', 893, 'xmas_c21_glassroofpillar', 5, 0, 0, 1, 0, 0, 21, -1, 0, '', '1', '0'),
	(12002, '12197', 893, 'xmas_c21_minivase', 2, 0, 0, 1, 0, 0, 22, -1, 0, '', '1', '0'),
	(12003, '12198', 893, 'xmas_c21_trainwallcnr', 5, 0, 0, 1, 0, 0, 23, -1, 0, '', '1', '0'),
	(12004, '12199', 930, 'xmas_c21_map2', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12005, '12200', 933, 'xmas_c21_salesmancase', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12006, '12201', 930, 'xmas_c21_map3', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12007, '12202', 893, 'xmas_c21_velvetseat', 6, 0, 0, 1, 0, 0, 24, -1, 0, '', '1', '0'),
	(12008, '12203', 893, 'xmas_c21_crackableletter', 10, 0, 0, 1, 0, 0, 6, -1, 0, '', '1', '0'),
	(12009, '12204', 893, 'xmas_c21_trainroofedgecnr', 3, 0, 0, 1, 0, 0, 25, -1, 0, '', '1', '0'),
	(12010, '12205', 934, 'xmas_c21_advent8', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12011, '12206', 933, 'clothing_doctorsoutfit', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12012, '12207', 934, 'xmas_c21_advent7', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12013, '12208;50241', 893, 'xmas_r21_luxuryhotchocolate', 25, 25, 5, 1, 0, 0, 4, -1, 0, '', '0', '0'),
	(12014, '12209', 893, 'xmas_c21_traveldocuments', 2, 0, 0, 1, 0, 0, 26, -1, 0, '', '1', '0'),
	(12015, '12210', 930, 'xmas_c21_map1', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12016, '12211', 933, 'clothing_nobleoutfit', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12017, '12212', 911, 'clothing_r21_trainoutfit', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12018, '12213;50244', 14, 'xmas_ltd21_artdecoegg', 750, 0, 0, 1, 60, 0, 1, -1, 0, '', '0', '0'),
	(12019, '12214', 930, 'xmas_c21_key5', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12020, '12215', 930, 'xmas_c21_map5', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12021, '12216', 914, 'bc_curvedramp*1', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12022, '12217', 914, 'bc_curvedramp*10', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12023, '12218', 914, 'bc_curvedramp*11', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12024, '12219', 914, 'bc_curvedramp*12', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12025, '12220', 914, 'bc_curvedramp*13', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12026, '12221', 914, 'bc_curvedramp*14', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12027, '12222', 914, 'bc_curvedramp*15', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12028, '12223', 914, 'bc_curvedramp*16', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12029, '12224', 914, 'bc_curvedramp*17', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12030, '12225', 914, 'bc_curvedramp*18', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12031, '12226', 914, 'bc_curvedramp*19', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12032, '12227', 914, 'bc_curvedramp*2', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12033, '12228', 914, 'bc_curvedramp*20', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12034, '12229', 914, 'bc_curvedramp*21', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12035, '12230', 914, 'bc_curvedramp*22', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12036, '12231', 914, 'bc_curvedramp*23', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12037, '12232', 914, 'bc_curvedramp*24', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12038, '12233', 914, 'bc_curvedramp*25', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12039, '12234', 914, 'bc_curvedramp*26', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12040, '12235', 914, 'bc_curvedramp*27', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12041, '12236', 914, 'bc_curvedramp*28', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12042, '12237', 914, 'bc_curvedramp*29', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12043, '12238', 914, 'bc_curvedramp*3', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12044, '12239', 914, 'bc_curvedramp*30', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12045, '12240', 914, 'bc_curvedramp*31', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12046, '12241', 914, 'bc_curvedramp*32', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12047, '12242', 914, 'bc_curvedramp*33', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12048, '12243', 914, 'bc_curvedramp*34', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12049, '12244', 914, 'bc_curvedramp*35', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12050, '12245', 914, 'bc_curvedramp*36', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12051, '12246', 914, 'bc_curvedramp*37', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12052, '12247', 914, 'bc_curvedramp*38', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12053, '12248', 914, 'bc_curvedramp*39', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12054, '12249', 914, 'bc_curvedramp*4', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12055, '12250', 914, 'bc_curvedramp*40', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12056, '12251', 914, 'bc_curvedramp*41', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12057, '12252', 914, 'bc_curvedramp*42', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12058, '12253', 914, 'bc_curvedramp*43', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12059, '12254', 914, 'bc_curvedramp*44', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12060, '12255', 914, 'bc_curvedramp*45', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12061, '12256', 914, 'bc_curvedramp*46', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12062, '12257', 914, 'bc_curvedramp*47', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12063, '12258', 914, 'bc_curvedramp*48', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12064, '12259', 914, 'bc_curvedramp*49', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12065, '12260', 914, 'bc_curvedramp*5', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12066, '12261', 914, 'bc_curvedramp*50', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12067, '12262', 914, 'bc_curvedramp*51', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12068, '12263', 914, 'bc_curvedramp*52', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12069, '12264', 914, 'bc_curvedramp*53', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12070, '12265', 914, 'bc_curvedramp*54', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12071, '12266', 914, 'bc_curvedramp*55', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12072, '12267', 914, 'bc_curvedramp*56', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12073, '12268', 914, 'bc_curvedramp*57', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12074, '12269', 914, 'bc_curvedramp*58', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12075, '12270', 914, 'bc_curvedramp*59', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12076, '12271', 914, 'bc_curvedramp*6', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12077, '12272', 914, 'bc_curvedramp*60', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12078, '12273', 914, 'bc_curvedramp*61', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12079, '12274', 914, 'bc_curvedramp*62', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12080, '12275', 914, 'bc_curvedramp*63', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12081, '12276', 914, 'bc_curvedramp*64', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12082, '12277', 914, 'bc_curvedramp*65', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12083, '12278', 914, 'bc_curvedramp*66', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12084, '12279', 914, 'bc_curvedramp*67', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12085, '12280', 914, 'bc_curvedramp*68', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12086, '12281', 914, 'bc_curvedramp*69', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12087, '12282', 914, 'bc_curvedramp*7', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12088, '12283', 914, 'bc_curvedramp*8', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12089, '12284', 914, 'bc_curvedramp*9', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12090, '12285', 915, 'bc_block_small*1', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12091, '12286', 915, 'bc_block_small*10', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12092, '12287', 915, 'bc_block_small*11', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12093, '12288', 915, 'bc_block_small*12', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12094, '12289', 915, 'bc_block_small*13', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12095, '12290', 915, 'bc_block_small*14', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12096, '12291', 915, 'bc_block_small*15', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12097, '12292', 915, 'bc_block_small*16', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12098, '12293', 915, 'bc_block_small*17', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12099, '12294', 915, 'bc_block_small*18', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12100, '12295', 915, 'bc_block_small*19', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12101, '12296', 915, 'bc_block_small*2', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12102, '12297', 915, 'bc_block_small*20', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12103, '12298', 915, 'bc_block_small*21', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12104, '12299', 915, 'bc_block_small*22', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12105, '12300', 915, 'bc_block_small*23', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12106, '12301', 915, 'bc_block_small*24', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12107, '12302', 915, 'bc_block_small*25', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12108, '12303', 915, 'bc_block_small*26', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12109, '12304', 915, 'bc_block_small*27', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12110, '12305', 915, 'bc_block_small*28', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12111, '12306', 915, 'bc_block_small*29', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12112, '12307', 915, 'bc_block_small*3', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12113, '12308', 915, 'bc_block_small*30', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12114, '12309', 915, 'bc_block_small*31', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12115, '12310', 915, 'bc_block_small*32', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12116, '12311', 915, 'bc_block_small*33', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12117, '12312', 915, 'bc_block_small*34', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12118, '12313', 915, 'bc_block_small*35', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12119, '12314', 915, 'bc_block_small*36', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12120, '12315', 915, 'bc_block_small*37', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12121, '12316', 915, 'bc_block_small*38', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12122, '12317', 915, 'bc_block_small*39', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12123, '12318', 915, 'bc_block_small*4', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12124, '12319', 915, 'bc_block_small*40', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12125, '12320', 915, 'bc_block_small*41', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12126, '12321', 915, 'bc_block_small*42', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12127, '12322', 915, 'bc_block_small*43', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12128, '12323', 915, 'bc_block_small*44', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12129, '12324', 915, 'bc_block_small*45', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12130, '12325', 915, 'bc_block_small*46', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12131, '12326', 915, 'bc_block_small*47', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12132, '12327', 915, 'bc_block_small*48', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12133, '12328', 915, 'bc_block_small*49', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12134, '12329', 915, 'bc_block_small*5', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12135, '12330', 915, 'bc_block_small*50', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12136, '12331', 915, 'bc_block_small*51', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12137, '12332', 915, 'bc_block_small*52', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12138, '12333', 915, 'bc_block_small*53', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12139, '12334', 915, 'bc_block_small*54', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12140, '12335', 915, 'bc_block_small*55', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12141, '12336', 915, 'bc_block_small*56', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12142, '12337', 915, 'bc_block_small*57', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12143, '12338', 915, 'bc_block_small*58', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12144, '12339', 915, 'bc_block_small*59', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12145, '12340', 915, 'bc_block_small*6', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12146, '12341', 915, 'bc_block_small*60', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12147, '12342', 915, 'bc_block_small*61', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12148, '12343', 915, 'bc_block_small*62', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12149, '12344', 915, 'bc_block_small*63', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12150, '12345', 915, 'bc_block_small*64', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12151, '12346', 915, 'bc_block_small*65', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12152, '12347', 915, 'bc_block_small*66', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12153, '12348', 915, 'bc_block_small*67', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12154, '12349', 915, 'bc_block_small*68', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12155, '12350', 915, 'bc_block_small*69', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12156, '12351', 915, 'bc_block_small*7', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12157, '12352', 915, 'bc_block_small*8', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12158, '12353', 915, 'bc_block_small*9', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12159, '12354', 913, 'bc_panel*1', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12160, '12355', 913, 'bc_panel*10', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12161, '12356', 913, 'bc_panel*11', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12162, '12357', 913, 'bc_panel*12', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12163, '12358', 913, 'bc_panel*13', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12164, '12359', 913, 'bc_panel*14', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12165, '12360', 913, 'bc_panel*15', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12166, '12361', 913, 'bc_panel*16', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12167, '12362', 913, 'bc_panel*17', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12168, '12363', 913, 'bc_panel*18', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12169, '12364', 913, 'bc_panel*19', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12170, '12365', 913, 'bc_panel*2', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12171, '12366', 913, 'bc_panel*20', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12172, '12367', 913, 'bc_panel*21', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12173, '12368', 913, 'bc_panel*22', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12174, '12369', 913, 'bc_panel*23', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12175, '12370', 913, 'bc_panel*24', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12176, '12371', 913, 'bc_panel*25', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12177, '12372', 913, 'bc_panel*26', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12178, '12373', 913, 'bc_panel*27', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12179, '12374', 913, 'bc_panel*28', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12180, '12375', 913, 'bc_panel*29', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12181, '12376', 913, 'bc_panel*3', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12182, '12377', 913, 'bc_panel*30', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12183, '12378', 913, 'bc_panel*31', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12184, '12379', 913, 'bc_panel*32', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12185, '12380', 913, 'bc_panel*33', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12186, '12381', 913, 'bc_panel*34', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12187, '12382', 913, 'bc_panel*35', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12188, '12383', 913, 'bc_panel*36', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12189, '12384', 913, 'bc_panel*37', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12190, '12385', 913, 'bc_panel*38', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12191, '12386', 913, 'bc_panel*39', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12192, '12387', 913, 'bc_panel*4', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12193, '12388', 913, 'bc_panel*40', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12194, '12389', 913, 'bc_panel*41', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12195, '12390', 913, 'bc_panel*42', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12196, '12391', 913, 'bc_panel*43', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12197, '12392', 913, 'bc_panel*44', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12198, '12393', 913, 'bc_panel*45', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12199, '12394', 913, 'bc_panel*46', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12200, '12395', 913, 'bc_panel*47', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12201, '12396', 913, 'bc_panel*48', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12202, '12397', 913, 'bc_panel*49', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12203, '12398', 913, 'bc_panel*5', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12204, '12399', 913, 'bc_panel*50', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12205, '12400', 913, 'bc_panel*51', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12206, '12401', 913, 'bc_panel*52', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12207, '12402', 913, 'bc_panel*53', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12208, '12403', 913, 'bc_panel*54', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12209, '12404', 913, 'bc_panel*55', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12210, '12405', 913, 'bc_panel*56', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12211, '12406', 913, 'bc_panel*57', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12212, '12407', 913, 'bc_panel*58', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12213, '12408', 913, 'bc_panel*59', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12214, '12409', 913, 'bc_panel*6', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12215, '12410', 913, 'bc_panel*60', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12216, '12411', 913, 'bc_panel*61', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12217, '12412', 913, 'bc_panel*62', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12218, '12413', 913, 'bc_panel*63', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12219, '12414', 913, 'bc_panel*64', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12220, '12415', 913, 'bc_panel*65', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12221, '12416', 913, 'bc_panel*66', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12222, '12417', 913, 'bc_panel*67', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12223, '12418', 913, 'bc_panel*68', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12224, '12419', 913, 'bc_panel*69', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12225, '12420', 913, 'bc_panel*7', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12226, '12421', 913, 'bc_panel*8', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12227, '12422', 913, 'bc_panel*9', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12228, '12423', 880, 'rare_prize21_xmas', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12229, '12424', 585, 'clothing_goldhatpack2', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12230, '12425', 898, 'spa_c22_massagebed', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12231, '12426', 898, 'spa_c22_waterfall', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12232, '12427', 898, 'spa_c22_sofa', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12233, '12428', 898, 'spa_c22_stone', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12234, '12429', 898, 'spa_c22_towel', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12235, '12430', 898, 'spa_c22_candle', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12236, '12431', 909, 'clothing_r21_nystarhat3', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12237, '12432', 909, 'clothing_r21_nystarhat7', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12238, '12433', 909, 'clothing_r21_nystarhat6', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12239, '12434', 668, 'ny_r21_crackable', 7, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(12240, '12435', 909, 'clothing_r21_nystarhat1', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12241, '12436', 909, 'clothing_r21_nystarhat4', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12242, '12437', 909, 'clothing_r21_nystarhat2', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12243, '12438', 909, 'clothing_r21_nystarhat8', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12244, '12439', 909, 'clothing_r21_nystarhat5', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12245, '12440', 960, 'nft_club_sofa', 0, 50000, 5, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12246, '12441', 191, 'xmas_c21_crackableletterb', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12247, '12442', 894, 'clothing_tinkywinky', 12, 0, 0, 1, 0, 0, 1, 24525, 0, '', '0', '0'),
	(12248, '12443', 894, 'clothing_po', 12, 0, 0, 1, 0, 0, 1, 24519, 0, '', '0', '0'),
	(12249, '12444', 894, 'clothing_dipsy', 12, 0, 0, 1, 0, 0, 1, 24523, 0, '', '0', '0'),
	(12250, '12445', 894, 'ads_teletubbies_noonoo', 7, 0, 0, 1, 0, 0, 1, 24522, 0, '', '0', '0'),
	(12251, '12446', 894, 'ads_teletubbies_tubbytst', 7, 0, 0, 1, 0, 0, 1, 24521, 0, '', '0', '0'),
	(12252, '12447', 894, 'ads_teletubbies_custardmchn', 10, 0, 0, 1, 0, 0, 1, 24520, 0, '', '0', '0'),
	(12253, '12448', 894, 'clothing_laalaa', 12, 0, 0, 1, 0, 0, 1, 24524, 0, '', '0', '0'),
	(12254, '12449', 895, 'sanrio_c21_hellokittysnowman', 6, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(12255, '12450', 895, 'sanrio_c21_hellokittyrug', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(12256, '12451', 895, 'clothing_hellokittyhat', 7, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12257, '12452', 895, 'sanrio_c21_hellokittytree', 2, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(12258, '12453', 895, 'sanrio_c21_hellokittychair', 5, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(12259, '12454', 895, 'clothing_hellokittybpack', 15, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12260, '12455', 429, 'test_nft_clothing2', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12261, '12456', 429, 'test_nft_clothing', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12262, '12457', 899, 'hc22_7', 7, 0, 0, 1, 0, 0, 7, -1, 0, '210', '1', '1'),
	(12263, '12458', 899, 'hc22_2', 7, 0, 0, 1, 0, 0, 2, -1, 0, '60', '1', '1'),
	(12264, '12459', 899, 'hc22_9', 7, 0, 0, 1, 0, 0, 9, -1, 0, '270', '1', '1'),
	(12265, '12460', 899, 'hc22_11', 7, 0, 0, 1, 0, 0, 11, -1, 0, '330', '1', '1'),
	(12266, '12461', 899, 'hc22_12', 7, 0, 0, 1, 0, 0, 12, -1, 0, '360', '1', '1'),
	(12267, '12462', 899, 'hc22_10', 7, 0, 0, 1, 0, 0, 10, -1, 0, '300', '1', '1'),
	(12268, '12463', 899, 'hc22_5', 7, 0, 0, 1, 0, 0, 5, -1, 0, '150', '1', '1'),
	(12269, '12464', 899, 'hc22_4', 7, 0, 0, 1, 0, 0, 4, -1, 0, '120', '1', '1'),
	(12270, '12465', 899, 'hc22_6', 7, 0, 0, 1, 0, 0, 6, -1, 0, '180', '1', '1'),
	(12271, '12466', 899, 'hc22_1', 7, 0, 0, 1, 0, 0, 1, -1, 0, '30', '1', '1'),
	(12272, '12467', 899, 'hc22_3', 7, 0, 0, 1, 0, 0, 3, -1, 0, '90', '1', '1'),
	(12273, '12468', 899, 'hc22_8', 7, 0, 0, 1, 0, 0, 8, -1, 0, '240', '1', '1'),
	(12274, '12469;50280', 14, 'ltd22_giantcrystal', 250, 0, 0, 1, 60, 0, 1, -1, 0, '', '0', '0'),
	(12275, '12470;50297', 895, 'rare_r22_bluerocococlock', 25, 25, 5, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12276, '12471;50296', 964, 'rare_r22_carbootcabinet', 25, 25, 5, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12277, '12472;50295', 964, 'rare_r22_treasureboxtank', 25, 25, 5, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12278, '12473', 307, 'CF_500_champagne', 500, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12279, '12474', 896, 'bohogarden_c21_rug', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12280, '12475', 896, 'bohogarden_c21_rattansofa', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12281, '12476', 896, 'bohogarden_c21_rattansofacorner', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12282, '12477', 896, 'bohogarden_c21_trellis', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12283, '12478', 896, 'bohogarden_c21_leaves', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12284, '12479', 896, 'bohogarden_c21_lights', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12285, '12480', 896, 'bohogarden_c21_snakeplant', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12286, '12481', 896, 'bohogarden_c21_floor', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12287, '12482', 896, 'bohogarden_c21_candlebowl', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12288, '12483', 896, 'bohogarden_c21_cheeseplant', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12289, '12484', 896, 'bohogarden_c21_rattanmat', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12290, '12485', 896, 'bohogarden_c21_rattantable', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12291, '12486', 896, 'bohogarden_c21_fanpalm', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12292, '12487', 896, 'bohogarden_c21_hanginglantern', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12293, '12488', 896, 'bohogarden_c21_woodenwall', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12294, '12489', 302, 'china_tigerstatue', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12295, '12490', 302, 'china_goldentiger', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12296, '12491', 897, 'clothing_cnytiger', 5, 10, 5, 1, 0, 0, 1, 24649, 0, '', '0', '0'),
	(12297, '12492', 191, 'val_c22_brokenvan1', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12298, '12493;50525', 897, 'val_r22_butterfly', 25, 25, 5, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12299, '12494', 928, 'val_c22_cosyvan', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12300, '12495', 928, 'val_c22_punkvan', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12301, '12496', 928, 'val_c22_beachvan', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12302, '12497', 928, 'val_c22_pastelvan', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12303, '12498', 897, 'clothing_sunhat', 5, 0, 0, 1, 0, 0, 1, 24656, 0, '', '0', '0'),
	(12304, '12499', 897, 'val_c22_brokenvan', 9, 10, 5, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12305, '12500;50304', 912, 'clothing_r22_messierbun', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12306, '12501;50303', 912, 'clothing_r22_bohoshirt', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12307, '12502;50524', 897, 'val_r22_rickshaw', 25, 25, 5, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12308, '12503', 928, 'val_c22_blingvan', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12309, '12504;50239', 897, 'val_r22_peacockspider', 25, 25, 5, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12310, '47100', 683, 'poster_duck', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12311, '47110', 21, 'pixelduck_wall', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12312, '47120', 275, 'year2021', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(12313, '47130', 491, 'diamond_painting55', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12314, '47140', 491, 'diamond_painting58', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12315, '47150', 491, 'diamond_painting61', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12316, '47160', 491, 'diamond_painting57', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12317, '47170', 491, 'diamond_painting63', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12318, '47180', 491, 'diamond_painting56', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12319, '47190', 491, 'diamond_painting53', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12320, '47200', 886, 'thai_c21_tropicalbg', 4, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12321, '47210', 888, 'vwave_c21_sunsetbg', 9, 0, 0, 1, 0, 0, 1, 25842, 0, '', '0', '0'),
	(12322, '47220', 946, 'vwave_c21_glitchsunsetbg', 3, 0, 0, 1, 0, 0, 1, 25842, 0, '', '0', '0'),
	(12323, '47230', 890, 'hween_c21_mistymountainbg', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12324, '47240', 893, 'xmas_c21_winterrailbg', 5, 0, 0, 1, 0, 0, 7, -1, 0, '', '1', '0'),
	(12325, '47250', 275, 'year2022', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(12326, '11620', 876, 'xmas_c20_crafter', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12327, '11670', 874, 'xmas_c20_runerock', 9, 0, 0, 1, 0, 0, 30, -1, 0, '', '1', '0'),
	(12328, '11827', 884, 'clothing_basichoodie', 5, 0, 0, 1, 0, 0, 13, -1, 0, '', '0', '0'),
	(12329, '11860', 884, 'clothing_basichat', 5, 0, 0, 1, 0, 0, 14, -1, 0, '', '0', '0'),
	(12330, '11857', 884, 'clothing_basicjoggers', 5, 0, 0, 1, 0, 0, 15, -1, 0, '', '0', '0'),
	(12331, '11840', 884, 'clothing_croptop', 5, 0, 0, 1, 0, 0, 16, -1, 0, '', '0', '0'),
	(12332, '11872', 905, 'easter_c21_dyetable', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12333, '11854', 907, 'easter_c21_textile', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(12334, '11862', 907, 'easter_c21_colourfulink', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(12335, '11865', 907, 'easter_c21_darkink', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(12336, '11875', 907, 'easter_c21_camoink', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(12337, '12127', 902, 'bubblejuice_c21_crackable2', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12338, '12132', 902, 'bubblejuice_c21_crackable1', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12339, '12139;50527', 892, 'clothing_r21_milkmaidbraid', 25, 25, 5, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12340, '12140;50526', 892, 'clothing_r21_cosydungarees', 35, 35, 5, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12341, '12155', 917, 'bubblejuice_c21_magicbrewer', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12342, '12147', 918, 'bubblejuice_c21_secretingredient', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12343, '12136', 918, 'bubblejuice_c21_barley', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12344, '12128', 918, 'bubblejuice_c21_hops', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12345, '12126', 918, 'bubblejuice_c21_citrus', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12346, '50512;2833;2822;2827;2816;2830;2819;2939;40600;8261;3704;8260;3707;9031;10240;10271;4373;4387;4835;3779;3776;3848;3786;43560;4151;8431;43390;3606;4342;4335;10258;10145;10162;4068;5984', 5500, 'targetoffer10500_bundle', 189, 189, 5, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12347, '50513;2831;2828;2834;2820;2817;2823;9048;6011;6004;10137;10136;4088;3905;10288;10237;4738;3774;4371;3783;4384;10920;4346;4333;4344;6102;6114;2774;4713;3256;2954;9979;10018;9977;9430;3394;4388;5498', 5500, 'extra20_machines2_tto', 189, 189, 5, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12348, '271', 17, 'bardeskcorner_polyfon*13', 5, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12349, '12505', 897, 'clothing_bohonecklace', 4, 0, 0, 1, 0, 0, 0, 24680, 0, '', '0', '0'),
	(12350, '12506', 872, 'rare_prize22*0', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12351, '12507', 872, 'rare_prize22*1', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12352, '12508', 872, 'rare_prize22*10', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12353, '12509', 872, 'rare_prize22*11', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12354, '12510', 872, 'rare_prize22*12', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12355, '12511', 872, 'rare_prize22*13', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12356, '12512', 872, 'rare_prize22*2', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12357, '12513', 872, 'rare_prize22*3', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12358, '12514', 872, 'rare_prize22*4', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12359, '12515', 872, 'rare_prize22*5', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12360, '12516', 872, 'rare_prize22*6', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12361, '12517', 872, 'rare_prize22*7', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12362, '12518', 872, 'rare_prize22*8', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12363, '12519', 872, 'rare_prize22*9', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12364, '12520', 896, 'bohogarden_c21_glasslantern', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12365, '12521', 896, 'bohogarden_c21_fireheater', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12366, '12522', 664, 'bonusbag22_2', 3, 0, 0, 1, 0, 0, 32, -1, 0, '', '0', '0'),
	(12367, '12523', 873, 'bonusrare22_1*0', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12368, '12524', 873, 'bonusrare22_1*1', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12369, '12525', 873, 'bonusrare22_1*2', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12370, '12526', 873, 'bonusrare22_1*3', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12371, '12527', 873, 'bonusrare22_1*4', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12372, '12528', 873, 'bonusrare22_1*5', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12373, '12529', 873, 'bonusrare22_4*0', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12374, '12530', 664, 'bonusbag22_3', 3, 0, 0, 1, 0, 0, 33, -1, 0, '', '0', '0'),
	(12375, '12531', 873, 'bonusrare22_3*0', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12376, '12532', 873, 'bonusrare22_3*1', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12377, '12533', 873, 'bonusrare22_3*2', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12378, '12534', 873, 'bonusrare22_3*3', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12379, '12535', 873, 'bonusrare22_3*4', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12380, '12536', 873, 'bonusrare22_3*5', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12381, '12537', 873, 'bonusrare22_2*0', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12382, '12538', 873, 'bonusrare22_2*1', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12383, '12539', 873, 'bonusrare22_2*2', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12384, '12540', 873, 'bonusrare22_2*3', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12385, '12541', 873, 'bonusrare22_2*4', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12386, '12542', 873, 'bonusrare22_2*5', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12387, '12543', 664, 'bonusbag22_1', 3, 0, 0, 1, 0, 0, 31, -1, 0, '', '0', '0'),
	(12388, '12544', 664, 'bonusbag22_4', 3, 0, 0, 1, 0, 0, 34, -1, 0, '', '0', '0'),
	(12389, '12545', 491, 'diamond_painting72', 3, 0, 0, 1, 0, 0, 0, 24745, 0, '', '0', '0'),
	(12390, '12546', 491, 'diamond_painting70', 3, 0, 0, 1, 0, 0, 0, 24746, 0, '', '0', '0'),
	(12391, '12547', 491, 'diamond_painting75', 3, 0, 0, 1, 0, 0, 0, 24747, 0, '', '0', '0'),
	(12392, '12548', 491, 'diamond_painting69', 3, 0, 0, 1, 0, 0, 0, 24748, 0, '', '0', '0'),
	(12393, '12549', 307, 'CF_350_goldendecanter', 350, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12394, '12550', 307, 'CF_250_stagmount', 250, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12395, '12551', 307, 'CF_350_geode', 350, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12396, '12552', 307, 'CF_250_peacockvase', 350, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12397, '12553', 307, 'CF_750_hphone', 750, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12398, '12554', 307, 'CF_500_jewelledsnake', 500, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12399, '12555', 897, 'SID_c22_plush', 0, 10, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12400, '12556', 895, 'sanrio_c22_mymelodyvase', 6, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(12401, '12557', 895, 'clothing_mymelodyskirt', 5, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12402, '12558', 895, 'clothing_mymelodyheadband', 5, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12403, '12559', 895, 'sanrio_c22_mymelodybed', 4, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(12404, '12560', 895, 'sanrio_c22_mymelodycake', 10, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(12405, '12561', 895, 'sanrio_c22_mymelodydesk', 8, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(12406, '12562', 736, 'trophy_gameprize', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12407, '12563', 736, 'trophy_fansite', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12408, '47260', 491, 'diamond_painting74', 3, 0, 0, 1, 0, 0, 0, 24681, 0, '', '0', '0'),
	(12409, '47270', 491, 'diamond_painting67', 3, 0, 0, 1, 0, 0, 0, 24755, 0, '', '0', '0'),
	(12410, '47280', 491, 'diamond_painting64', 3, 0, 0, 1, 0, 0, 0, 24756, 0, '', '0', '0'),
	(12411, '47290', 491, 'diamond_painting65', 3, 0, 0, 1, 0, 0, 0, 24757, 0, '', '0', '0'),
	(12412, '47300', 491, 'diamond_painting66', 3, 0, 0, 1, 0, 0, 0, 24758, 0, '', '0', '0'),
	(12413, '47310', 491, 'diamond_painting68', 3, 0, 0, 1, 0, 0, 0, 24759, 0, '', '0', '0'),
	(12414, '47320', 491, 'diamond_painting71', 3, 0, 0, 1, 0, 0, 0, 24760, 0, '', '0', '0'),
	(12415, '47330', 491, 'diamond_painting73', 3, 0, 0, 1, 0, 0, 0, 24761, 0, '', '0', '0'),
	(12416, '12034', 920, 'mushroom_c21_crackable', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12417, '11960', 922, 'rainbow_c21_crackable1', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12418, '11958', 922, 'rainbow_c21_crackable2', 7, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12419, '11959', 923, 'rainbow_c21_bunting', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12420, '11962', 923, 'rainbow_c21_balloonarch', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12421, '11970', 923, 'rainbow_c21_rainbowroad', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12422, '11971', 923, 'rainbow_c21_lightbulbheart', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12423, '11965', 923, 'clothing_pridehoodie', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12424, '11967', 923, 'clothing_rainbowwings', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12425, '11968', 923, 'clothing_rainbowundercut', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12426, '11969', 923, 'clothing_pridecape', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12427, '12031', 921, 'clothing_petalhat', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12428, '12032', 921, 'mushroom_c21_shelves', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12429, '12035', 921, 'clothing_mushroom2', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12430, '12036', 921, 'mushroom_c21_chair', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12431, '12038', 921, 'mushroom_c21_archway', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12432, '12040', 921, 'clothing_flowerdress', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12433, '12041', 921, 'mushroom_c21_drawers', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12434, '12043', 921, 'mushroom_c21_bouncymushroom', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12435, '12044', 921, 'mushroom_c21_table', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12436, '12046', 921, 'mushroom_c21_bigmushroom', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12437, '11901;50520', 885, 'clothing_r21_detectiveoutfit', 35, 35, 5, 1, 0, 0, 2, -1, 0, '', '0', '0'),
	(12438, '11888;50521', 885, 'clothing_r21_tousledwaves', 25, 5, 5, 1, 0, 0, 3, -1, 0, '', '0', '0'),
	(12439, '11889;50522', 885, 'animal_r21_gorilla', 25, 25, 5, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12440, '11890', 885, 'clothing_edwardianblouse', 11, 0, 0, 1, 0, 0, 1, 23185, 0, '', '0', '0'),
	(12441, '12499', 927, 'val_c22_brokenvan', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12442, '12491', 302, 'clothing_cnytiger', 5, 10, 0, 1, 0, 0, 1, 24649, 0, '', '0', '0'),
	(12443, '12185;50240', 893, 'clothing_r21_warmoversizedcoat', 35, 35, 5, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12444, '12212;50242', 893, 'clothing_r21_trainoutfit', 25, 25, 5, 1, 0, 0, 2, -1, 0, '', '0', '0'),
	(12445, '12203', 929, 'xmas_c21_crackableletter', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12446, '12177', 931, 'xmas_c21_luggage', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12447, '12069;50245', 890, 'clothing_r21_ninjaoutfit', 25, 25, 5, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12448, '12100;50246', 890, 'clothing_r21_himehair', 25, 25, 5, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12449, '12075', 935, 'hween_c21_scrollaltar', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12450, '12052', 936, 'hween_c21_purificationscroll', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12451, '12084', 936, 'hween_c21_magatama', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12452, '12093', 936, 'hween_c21_onitriomask', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12453, '12057', 936, 'hween_c21_biwa', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12454, '12082', 936, 'hween_c21_kitsunestatue', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12455, '12094', 936, 'hween_c21_kappapond', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12456, '12067', 936, 'hween_c21_shadownekomata', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12457, '12076', 936, 'hween_c21_shadowkappa', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12458, '12095', 936, 'hween_c21_shadowoni', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12459, '12097', 936, 'hween_c21_shadowkitsune', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12460, '6109', 936, 'uni_plush2', 3, 0, 0, 1, 0, 0, 1, 14109, 0, '', '0', '0'),
	(12461, '10090', 936, 'coralking_c18_neoncoral2', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12462, '9605', 936, 'bazaar_c17_meat', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12463, '3982', 936, 'picnic_food1', 3, 0, 0, 1, 0, 0, 1, 10099, 0, '', '0', '0'),
	(12464, '60201', 956, 'avatar_effect1', 3, 0, 0, 1, 0, 0, 1, -1, 0, '3800', '0', '0'),
	(12465, '60202', 956, 'avatar_effect2', 3, 0, 0, 1, 0, 0, 2, -1, 0, '3800', '0', '0'),
	(12466, '60203', 956, 'avatar_effect3', 3, 0, 0, 1, 0, 0, 3, -1, 0, '3800', '0', '0'),
	(12467, '60204', 956, 'avatar_effect4', 3, 0, 0, 1, 0, 0, 4, -1, 0, '3800', '0', '0'),
	(12468, '60205', 956, 'avatar_effect5', 3, 0, 0, 1, 0, 0, 5, -1, 0, '3800', '0', '0'),
	(12469, '60206', 956, 'avatar_effect6', 3, 0, 0, 1, 0, 0, 6, -1, 0, '3800', '0', '0'),
	(12470, '60207', 956, 'avatar_effect7', 3, 0, 0, 1, 0, 0, 7, -1, 0, '3800', '0', '0'),
	(12471, '60208', 956, 'avatar_effect8', 3, 0, 0, 1, 0, 0, 8, -1, 0, '3800', '0', '0'),
	(12472, '60209', 956, 'avatar_effect9', 3, 0, 0, 1, 0, 0, 9, -1, 0, '3800', '0', '0'),
	(12473, '60210', 956, 'avatar_effect10', 3, 0, 0, 1, 0, 0, 10, -1, 0, '3800', '0', '0'),
	(12474, '60211', 956, 'avatar_effect11', 3, 0, 0, 1, 0, 0, 11, -1, 0, '3800', '0', '0'),
	(12475, '60212', 956, 'avatar_effect12', 3, 0, 0, 1, 0, 0, 12, -1, 0, '3800', '0', '0'),
	(12476, '60213', 956, 'avatar_effect13', 3, 0, 0, 1, 0, 0, 13, -1, 0, '3800', '0', '0'),
	(12477, '60214', 956, 'avatar_effect14', 3, 0, 0, 1, 0, 0, 14, -1, 0, '3800', '0', '0'),
	(12478, '60215', 956, 'avatar_effect15', 3, 0, 0, 1, 0, 0, 15, -1, 0, '3800', '0', '0'),
	(12479, '60216', 956, 'avatar_effect16', 3, 0, 0, 1, 0, 0, 16, -1, 0, '3800', '0', '0'),
	(12480, '60217', 956, 'avatar_effect17', 3, 0, 0, 1, 0, 0, 17, -1, 0, '3800', '0', '0'),
	(12481, '60218', 956, 'avatar_effect18', 3, 0, 0, 1, 0, 0, 18, -1, 0, '3800', '0', '0'),
	(12482, '60219', 956, 'avatar_effect19', 3, 0, 0, 1, 0, 0, 19, -1, 0, '3800', '0', '0'),
	(12483, '60220', 956, 'avatar_effect20', 3, 0, 0, 1, 0, 0, 20, -1, 0, '3800', '0', '0'),
	(12484, '60221', 956, 'avatar_effect21', 3, 0, 0, 1, 0, 0, 21, -1, 0, '3800', '0', '0'),
	(12485, '60222', 956, 'avatar_effect22', 3, 0, 0, 1, 0, 0, 22, -1, 0, '3800', '0', '0'),
	(12486, '60223', 956, 'avatar_effect23', 3, 0, 0, 1, 0, 0, 23, -1, 0, '3800', '0', '0'),
	(12487, '60224', 956, 'avatar_effect24', 3, 0, 0, 1, 0, 0, 24, -1, 0, '3800', '0', '0'),
	(12488, '60225', 956, 'avatar_effect25', 3, 0, 0, 1, 0, 0, 25, -1, 0, '3800', '0', '0'),
	(12489, '60226', 956, 'avatar_effect26', 3, 0, 0, 1, 0, 0, 26, -1, 0, '3800', '0', '0'),
	(12490, '60227', 956, 'avatar_effect27', 3, 0, 0, 1, 0, 0, 27, -1, 0, '3800', '0', '0'),
	(12491, '60231', 956, 'avatar_effect31', 3, 0, 0, 1, 0, 0, 31, -1, 0, '3800', '0', '0'),
	(12492, '60232', 956, 'avatar_effect32', 3, 0, 0, 1, 0, 0, 32, -1, 0, '3800', '0', '0'),
	(12493, '60244', 956, 'avatar_effect44', 3, 0, 0, 1, 0, 0, 44, -1, 0, '3800', '0', '0'),
	(12494, '60247', 956, 'avatar_effect47', 3, 0, 0, 1, 0, 0, 47, -1, 0, '3800', '0', '0'),
	(12495, '60248', 956, 'avatar_effect48', 3, 0, 0, 1, 0, 0, 48, -1, 0, '3800', '0', '0'),
	(12496, '60253', 956, 'avatar_effect53', 3, 0, 0, 1, 0, 0, 53, -1, 0, '3800', '0', '0'),
	(12497, '60254', 956, 'avatar_effect54', 3, 0, 0, 1, 0, 0, 54, -1, 0, '3800', '0', '0'),
	(12498, '60259', 956, 'avatar_effect59', 3, 0, 0, 1, 0, 0, 59, -1, 0, '3800', '0', '0'),
	(12499, '60260', 956, 'avatar_effect60', 3, 0, 0, 1, 0, 0, 60, -1, 0, '3800', '0', '0'),
	(12500, '60261', 956, 'avatar_effect61', 3, 0, 0, 1, 0, 0, 61, -1, 0, '3800', '0', '0'),
	(12501, '60262', 956, 'avatar_effect62', 3, 0, 0, 1, 0, 0, 62, -1, 0, '3800', '0', '0'),
	(12502, '60263', 956, 'avatar_effect63', 3, 0, 0, 1, 0, 0, 63, -1, 0, '3800', '0', '0'),
	(12503, '60264', 956, 'avatar_effect64', 3, 0, 0, 1, 0, 0, 64, -1, 0, '3800', '0', '0'),
	(12504, '60265', 956, 'avatar_effect65', 3, 0, 0, 1, 0, 0, 65, -1, 0, '3800', '0', '0'),
	(12505, '60266', 956, 'avatar_effect66', 3, 0, 0, 1, 0, 0, 66, -1, 0, '3800', '0', '0'),
	(12506, '60267', 956, 'avatar_effect67', 3, 0, 0, 1, 0, 0, 67, -1, 0, '3800', '0', '0'),
	(12507, '60269', 956, 'avatar_effect69', 3, 0, 0, 1, 0, 0, 69, -1, 0, '3800', '0', '0'),
	(12508, '60270', 956, 'avatar_effect70', 3, 0, 0, 1, 0, 0, 70, -1, 0, '3800', '0', '0'),
	(12509, '60271', 956, 'avatar_effect71', 3, 0, 0, 1, 0, 0, 71, -1, 0, '3800', '0', '0'),
	(12510, '60272', 956, 'avatar_effect72', 3, 0, 0, 1, 0, 0, 72, -1, 0, '3800', '0', '0'),
	(12511, '60273', 956, 'avatar_effect73', 3, 0, 0, 1, 0, 0, 73, -1, 0, '3800', '0', '0'),
	(12512, '60274', 956, 'avatar_effect74', 3, 0, 0, 1, 0, 0, 74, -1, 0, '3800', '0', '0'),
	(12513, '60275', 956, 'avatar_effect75', 3, 0, 0, 1, 0, 0, 75, -1, 0, '3800', '0', '0'),
	(12514, '60276', 956, 'avatar_effect76', 3, 0, 0, 1, 0, 0, 76, -1, 0, '3800', '0', '0'),
	(12515, '60278', 956, 'avatar_effect78', 3, 0, 0, 1, 0, 0, 78, -1, 0, '3800', '0', '0'),
	(12516, '60279', 956, 'avatar_effect79', 3, 0, 0, 1, 0, 0, 79, -1, 0, '3800', '0', '0'),
	(12517, '60280', 956, 'avatar_effect80', 3, 0, 0, 1, 0, 0, 80, -1, 0, '3800', '0', '0'),
	(12518, '60281', 956, 'avatar_effect81', 3, 0, 0, 1, 0, 0, 81, -1, 0, '3800', '0', '0'),
	(12519, '60282', 956, 'avatar_effect82', 3, 0, 0, 1, 0, 0, 82, -1, 0, '3800', '0', '0'),
	(12520, '60283', 956, 'avatar_effect83', 3, 0, 0, 1, 0, 0, 83, -1, 0, '3800', '0', '0'),
	(12521, '60284', 956, 'avatar_effect84', 3, 0, 0, 1, 0, 0, 84, -1, 0, '3800', '0', '0'),
	(12522, '60285', 956, 'avatar_effect85', 3, 0, 0, 1, 0, 0, 85, -1, 0, '3800', '0', '0'),
	(12523, '60286', 956, 'avatar_effect86', 3, 0, 0, 1, 0, 0, 86, -1, 0, '3800', '0', '0'),
	(12524, '60287', 956, 'avatar_effect87', 3, 0, 0, 1, 0, 0, 87, -1, 0, '3800', '0', '0'),
	(12525, '60288', 956, 'avatar_effect88', 3, 0, 0, 1, 0, 0, 88, -1, 0, '3800', '0', '0'),
	(12526, '60289', 956, 'avatar_effect89', 3, 0, 0, 1, 0, 0, 89, -1, 0, '3800', '0', '0'),
	(12527, '60290', 956, 'avatar_effect90', 3, 0, 0, 1, 0, 0, 90, -1, 0, '3800', '0', '0'),
	(12528, '60291', 956, 'avatar_effect91', 3, 0, 0, 1, 0, 0, 91, -1, 0, '3800', '0', '0'),
	(12529, '60292', 956, 'avatar_effect92', 3, 0, 0, 1, 0, 0, 92, -1, 0, '3800', '0', '0'),
	(12530, '60293', 956, 'avatar_effect93', 3, 0, 0, 1, 0, 0, 93, -1, 0, '3800', '0', '0'),
	(12531, '60294', 956, 'avatar_effect94', 3, 0, 0, 1, 0, 0, 94, -1, 0, '3800', '0', '0'),
	(12532, '60299', 956, 'avatar_effect99', 3, 0, 0, 1, 0, 0, 99, -1, 0, '3800', '0', '0'),
	(12533, '60300', 956, 'avatar_effect100', 3, 0, 0, 1, 0, 0, 100, -1, 0, '3800', '0', '0'),
	(12534, '60301', 956, 'avatar_effect101', 3, 0, 0, 1, 0, 0, 101, -1, 0, '3800', '0', '0'),
	(12535, '60302', 956, 'avatar_effect102', 3, 0, 0, 1, 0, 0, 102, -1, 0, '3800', '0', '0'),
	(12536, '60304', 956, 'avatar_effect104', 3, 0, 0, 1, 0, 0, 104, -1, 0, '3800', '0', '0'),
	(12537, '60305', 956, 'avatar_effect105', 3, 0, 0, 1, 0, 0, 105, -1, 0, '3800', '0', '0'),
	(12538, '60306', 956, 'avatar_effect106', 3, 0, 0, 1, 0, 0, 106, -1, 0, '3800', '0', '0'),
	(12539, '60307', 956, 'avatar_effect107', 3, 0, 0, 1, 0, 0, 107, -1, 0, '3800', '0', '0'),
	(12540, '60308', 956, 'avatar_effect108', 3, 0, 0, 1, 0, 0, 108, -1, 0, '3800', '0', '0'),
	(12541, '60309', 956, 'avatar_effect109', 3, 0, 0, 1, 0, 0, 109, -1, 0, '3800', '0', '0'),
	(12542, '60310', 956, 'avatar_effect110', 3, 0, 0, 1, 0, 0, 110, -1, 0, '3800', '0', '0'),
	(12543, '60311', 956, 'avatar_effect111', 3, 0, 0, 1, 0, 0, 111, -1, 0, '3800', '0', '0'),
	(12544, '60312', 956, 'avatar_effect112', 3, 0, 0, 1, 0, 0, 112, -1, 0, '3800', '0', '0'),
	(12545, '60313', 956, 'avatar_effect113', 3, 0, 0, 1, 0, 0, 113, -1, 0, '3800', '0', '0'),
	(12546, '60314', 956, 'avatar_effect114', 3, 0, 0, 1, 0, 0, 114, -1, 0, '3800', '0', '0'),
	(12547, '60315', 956, 'avatar_effect115', 3, 0, 0, 1, 0, 0, 115, -1, 0, '3800', '0', '0'),
	(12548, '60316', 956, 'avatar_effect116', 3, 0, 0, 1, 0, 0, 116, -1, 0, '3800', '0', '0'),
	(12549, '60317', 956, 'avatar_effect117', 3, 0, 0, 1, 0, 0, 117, -1, 0, '3800', '0', '0'),
	(12550, '60318', 956, 'avatar_effect118', 3, 0, 0, 1, 0, 0, 118, -1, 0, '3800', '0', '0'),
	(12551, '60319', 956, 'avatar_effect119', 3, 0, 0, 1, 0, 0, 119, -1, 0, '3800', '0', '0'),
	(12552, '60320', 956, 'avatar_effect120', 3, 0, 0, 1, 0, 0, 120, -1, 0, '3800', '0', '0'),
	(12553, '60321', 956, 'avatar_effect121', 3, 0, 0, 1, 0, 0, 121, -1, 0, '3800', '0', '0'),
	(12554, '60322', 956, 'avatar_effect122', 3, 0, 0, 1, 0, 0, 122, -1, 0, '3800', '0', '0'),
	(12555, '60323', 956, 'avatar_effect123', 3, 0, 0, 1, 0, 0, 123, -1, 0, '3800', '0', '0'),
	(12556, '60324', 956, 'avatar_effect124', 3, 0, 0, 1, 0, 0, 124, -1, 0, '3800', '0', '0'),
	(12557, '60325', 956, 'avatar_effect125', 3, 0, 0, 1, 0, 0, 125, -1, 0, '3800', '0', '0'),
	(12558, '60326', 956, 'avatar_effect126', 3, 0, 0, 1, 0, 0, 126, -1, 0, '3800', '0', '0'),
	(12559, '60327', 956, 'avatar_effect127', 3, 0, 0, 1, 0, 0, 127, -1, 0, '3800', '0', '0'),
	(12560, '60328', 956, 'avatar_effect128', 3, 0, 0, 1, 0, 0, 128, -1, 0, '3800', '0', '0'),
	(12561, '60329', 956, 'avatar_effect129', 3, 0, 0, 1, 0, 0, 129, -1, 0, '3800', '0', '0'),
	(12562, '60330', 956, 'avatar_effect130', 3, 0, 0, 1, 0, 0, 130, -1, 0, '3800', '0', '0'),
	(12563, '60331', 956, 'avatar_effect131', 3, 0, 0, 1, 0, 0, 131, -1, 0, '3800', '0', '0'),
	(12564, '60332', 956, 'avatar_effect132', 3, 0, 0, 1, 0, 0, 132, -1, 0, '3800', '0', '0'),
	(12565, '60333', 956, 'avatar_effect133', 3, 0, 0, 1, 0, 0, 133, -1, 0, '3800', '0', '0'),
	(12566, '60334', 956, 'avatar_effect134', 3, 0, 0, 1, 0, 0, 134, -1, 0, '3800', '0', '0'),
	(12567, '60335', 956, 'avatar_effect135', 3, 0, 0, 1, 0, 0, 135, -1, 0, '3800', '0', '0'),
	(12568, '60336', 956, 'avatar_effect136', 3, 0, 0, 1, 0, 0, 136, -1, 0, '3800', '0', '0'),
	(12569, '60337', 956, 'avatar_effect137', 3, 0, 0, 1, 0, 0, 137, -1, 0, '3800', '0', '0'),
	(12570, '60338', 956, 'avatar_effect138', 3, 0, 0, 1, 0, 0, 138, -1, 0, '3800', '0', '0'),
	(12571, '60339', 956, 'avatar_effect139', 3, 0, 0, 1, 0, 0, 139, -1, 0, '3800', '0', '0'),
	(12572, '60340', 956, 'avatar_effect140', 3, 0, 0, 1, 0, 0, 140, -1, 0, '3800', '0', '0'),
	(12573, '60341', 956, 'avatar_effect141', 3, 0, 0, 1, 0, 0, 141, -1, 0, '3800', '0', '0'),
	(12574, '60342', 956, 'avatar_effect142', 3, 0, 0, 1, 0, 0, 142, -1, 0, '3800', '0', '0'),
	(12575, '60343', 956, 'avatar_effect143', 3, 0, 0, 1, 0, 0, 143, -1, 0, '3800', '0', '0'),
	(12576, '60344', 956, 'avatar_effect144', 3, 0, 0, 1, 0, 0, 144, -1, 0, '3800', '0', '0'),
	(12577, '60345', 956, 'avatar_effect145', 3, 0, 0, 1, 0, 0, 145, -1, 0, '3800', '0', '0'),
	(12578, '60346', 956, 'avatar_effect146', 3, 0, 0, 1, 0, 0, 146, -1, 0, '3800', '0', '0'),
	(12579, '60347', 956, 'avatar_effect147', 3, 0, 0, 1, 0, 0, 147, -1, 0, '3800', '0', '0'),
	(12580, '60348', 956, 'avatar_effect148', 3, 0, 0, 1, 0, 0, 148, -1, 0, '3800', '0', '0'),
	(12581, '60349', 956, 'avatar_effect149', 3, 0, 0, 1, 0, 0, 149, -1, 0, '3800', '0', '0'),
	(12582, '60350', 956, 'avatar_effect150', 3, 0, 0, 1, 0, 0, 150, -1, 0, '3800', '0', '0'),
	(12583, '60351', 956, 'avatar_effect151', 3, 0, 0, 1, 0, 0, 151, -1, 0, '3800', '0', '0'),
	(12584, '60352', 956, 'avatar_effect152', 3, 0, 0, 1, 0, 0, 152, -1, 0, '3800', '0', '0'),
	(12585, '60353', 956, 'avatar_effect153', 3, 0, 0, 1, 0, 0, 153, -1, 0, '3800', '0', '0'),
	(12586, '60354', 956, 'avatar_effect154', 3, 0, 0, 1, 0, 0, 154, -1, 0, '3800', '0', '0'),
	(12587, '60355', 956, 'avatar_effect155', 3, 0, 0, 1, 0, 0, 155, -1, 0, '3800', '0', '0'),
	(12588, '60356', 956, 'avatar_effect156', 3, 0, 0, 1, 0, 0, 156, -1, 0, '3800', '0', '0'),
	(12589, '60357', 956, 'avatar_effect157', 3, 0, 0, 1, 0, 0, 157, -1, 0, '3800', '0', '0'),
	(12590, '60358', 956, 'avatar_effect158', 3, 0, 0, 1, 0, 0, 158, -1, 0, '3800', '0', '0'),
	(12591, '60359', 956, 'avatar_effect159', 3, 0, 0, 1, 0, 0, 159, -1, 0, '3800', '0', '0'),
	(12592, '60360', 956, 'avatar_effect160', 3, 0, 0, 1, 0, 0, 160, -1, 0, '3800', '0', '0'),
	(12593, '60361', 956, 'avatar_effect161', 3, 0, 0, 1, 0, 0, 161, -1, 0, '3800', '0', '0'),
	(12594, '60362', 956, 'avatar_effect162', 3, 0, 0, 1, 0, 0, 162, -1, 0, '3800', '0', '0'),
	(12595, '60364', 956, 'avatar_effect164', 3, 0, 0, 1, 0, 0, 164, -1, 0, '3800', '0', '0'),
	(12596, '60365', 956, 'avatar_effect165', 3, 0, 0, 1, 0, 0, 165, -1, 0, '3800', '0', '0'),
	(12597, '60366', 956, 'avatar_effect166', 3, 0, 0, 1, 0, 0, 166, -1, 0, '3800', '0', '0'),
	(12598, '60367', 956, 'avatar_effect167', 3, 0, 0, 1, 0, 0, 167, -1, 0, '3800', '0', '0'),
	(12599, '60368', 956, 'avatar_effect168', 3, 0, 0, 1, 0, 0, 168, -1, 0, '3800', '0', '0'),
	(12600, '60369', 956, 'avatar_effect169', 3, 0, 0, 1, 0, 0, 169, -1, 0, '3800', '0', '0'),
	(12601, '60370', 956, 'avatar_effect170', 3, 0, 0, 1, 0, 0, 170, -1, 0, '3800', '0', '0'),
	(12602, '60371', 956, 'avatar_effect171', 3, 0, 0, 1, 0, 0, 171, -1, 0, '3800', '0', '0'),
	(12603, '60372', 956, 'avatar_effect172', 3, 0, 0, 1, 0, 0, 172, -1, 0, '3800', '0', '0'),
	(12604, '60373', 956, 'avatar_effect173', 3, 0, 0, 1, 0, 0, 173, -1, 0, '3800', '0', '0'),
	(12605, '60374', 956, 'avatar_effect174', 3, 0, 0, 1, 0, 0, 174, -1, 0, '3800', '0', '0'),
	(12606, '60375', 956, 'avatar_effect175', 3, 0, 0, 1, 0, 0, 175, -1, 0, '3800', '0', '0'),
	(12607, '60376', 956, 'avatar_effect176', 3, 0, 0, 1, 0, 0, 176, -1, 0, '3800', '0', '0'),
	(12608, '60377', 956, 'avatar_effect177', 3, 0, 0, 1, 0, 0, 177, -1, 0, '3800', '0', '0'),
	(12609, '60378', 956, 'avatar_effect178', 3, 0, 0, 1, 0, 0, 178, -1, 0, '3800', '0', '0'),
	(12610, '60379', 956, 'avatar_effect179', 3, 0, 0, 1, 0, 0, 179, -1, 0, '3800', '0', '0'),
	(12611, '60380', 956, 'avatar_effect180', 3, 0, 0, 1, 0, 0, 180, -1, 0, '3800', '0', '0'),
	(12612, '60381', 956, 'avatar_effect181', 3, 0, 0, 1, 0, 0, 181, -1, 0, '3800', '0', '0'),
	(12613, '60382', 956, 'avatar_effect182', 3, 0, 0, 1, 0, 0, 182, -1, 0, '3800', '0', '0'),
	(12614, '60383', 956, 'avatar_effect183', 3, 0, 0, 1, 0, 0, 183, -1, 0, '3800', '0', '0'),
	(12615, '60386', 956, 'avatar_effect186', 3, 0, 0, 1, 0, 0, 186, -1, 0, '3800', '0', '0'),
	(12616, '60391', 956, 'avatar_effect191', 3, 0, 0, 1, 0, 0, 191, -1, 0, '3800', '0', '0'),
	(12617, '60392', 956, 'avatar_effect192', 3, 0, 0, 1, 0, 0, 192, -1, 0, '3800', '0', '0'),
	(12618, '12564', 964, 'summer_c22_rowboat', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(12619, '12565', 964, 'summer_c22_picnictable', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(12620, '12566', 964, 'summer_c22_lifering', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(12621, '12567', 975, 'bc_ramp*1', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12622, '12568', 975, 'bc_ramp*10', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12623, '12569', 975, 'bc_ramp*11', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12624, '12570', 975, 'bc_ramp*12', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12625, '12571', 975, 'bc_ramp*13', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12626, '12572', 975, 'bc_ramp*14', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12627, '12573', 975, 'bc_ramp*15', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12628, '12574', 975, 'bc_ramp*16', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12629, '12575', 975, 'bc_ramp*17', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12630, '12576', 975, 'bc_ramp*18', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12631, '12577', 975, 'bc_ramp*19', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12632, '12578', 975, 'bc_ramp*2', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12633, '12579', 975, 'bc_ramp*20', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12634, '12580', 975, 'bc_ramp*21', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12635, '12581', 975, 'bc_ramp*22', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12636, '12582', 975, 'bc_ramp*23', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12637, '12583', 975, 'bc_ramp*24', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12638, '12584', 975, 'bc_ramp*25', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12639, '12585', 975, 'bc_ramp*26', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12640, '12586', 975, 'bc_ramp*27', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12641, '12587', 975, 'bc_ramp*28', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12642, '12588', 975, 'bc_ramp*29', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12643, '12589', 975, 'bc_ramp*3', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12644, '12590', 975, 'bc_ramp*30', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12645, '12591', 975, 'bc_ramp*31', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12646, '12592', 975, 'bc_ramp*32', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12647, '12593', 975, 'bc_ramp*33', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12648, '12594', 975, 'bc_ramp*34', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12649, '12595', 975, 'bc_ramp*35', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12650, '12596', 975, 'bc_ramp*36', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12651, '12597', 975, 'bc_ramp*37', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12652, '12598', 975, 'bc_ramp*38', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12653, '12599', 975, 'bc_ramp*39', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12654, '12600', 975, 'bc_ramp*4', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12655, '12601', 975, 'bc_ramp*40', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12656, '12602', 975, 'bc_ramp*41', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12657, '12603', 975, 'bc_ramp*42', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12658, '12604', 975, 'bc_ramp*43', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12659, '12605', 975, 'bc_ramp*44', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12660, '12606', 975, 'bc_ramp*45', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12661, '12607', 975, 'bc_ramp*46', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12662, '12608', 975, 'bc_ramp*47', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12663, '12609', 975, 'bc_ramp*48', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12664, '12610', 975, 'bc_ramp*49', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12665, '12611', 975, 'bc_ramp*5', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12666, '12612', 975, 'bc_ramp*50', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12667, '12613', 975, 'bc_ramp*51', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12668, '12614', 975, 'bc_ramp*52', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12669, '12615', 975, 'bc_ramp*53', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12670, '12616', 975, 'bc_ramp*54', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12671, '12617', 975, 'bc_ramp*55', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12672, '12618', 975, 'bc_ramp*56', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12673, '12619', 975, 'bc_ramp*57', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12674, '12620', 975, 'bc_ramp*58', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12675, '12621', 975, 'bc_ramp*59', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12676, '12622', 975, 'bc_ramp*6', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12677, '12623', 975, 'bc_ramp*60', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12678, '12624', 975, 'bc_ramp*61', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12679, '12625', 975, 'bc_ramp*62', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12680, '12626', 975, 'bc_ramp*63', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12681, '12627', 975, 'bc_ramp*64', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12682, '12628', 975, 'bc_ramp*65', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12683, '12629', 975, 'bc_ramp*66', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12684, '12630', 975, 'bc_ramp*67', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12685, '12631', 975, 'bc_ramp*68', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12686, '12632', 975, 'bc_ramp*69', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12687, '12633', 975, 'bc_ramp*7', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12688, '12634', 975, 'bc_ramp*8', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12689, '12635', 975, 'bc_ramp*9', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12690, '12636', 973, 'bc_stairs*1', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12691, '12637', 973, 'bc_stairs*10', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12692, '12638', 973, 'bc_stairs*11', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12693, '12639', 973, 'bc_stairs*12', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12694, '12640', 973, 'bc_stairs*13', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12695, '12641', 973, 'bc_stairs*14', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12696, '12642', 973, 'bc_stairs*15', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12697, '12643', 973, 'bc_stairs*16', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12698, '12644', 973, 'bc_stairs*17', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12699, '12645', 973, 'bc_stairs*18', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12700, '12646', 973, 'bc_stairs*19', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12701, '12647', 973, 'bc_stairs*2', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12702, '12648', 973, 'bc_stairs*20', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12703, '12649', 973, 'bc_stairs*21', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12704, '12650', 973, 'bc_stairs*22', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12705, '12651', 973, 'bc_stairs*23', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12706, '12652', 973, 'bc_stairs*24', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12707, '12653', 973, 'bc_stairs*25', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12708, '12654', 973, 'bc_stairs*26', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12709, '12655', 973, 'bc_stairs*27', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12710, '12656', 973, 'bc_stairs*28', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12711, '12657', 973, 'bc_stairs*29', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12712, '12658', 973, 'bc_stairs*3', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12713, '12659', 973, 'bc_stairs*30', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12714, '12660', 973, 'bc_stairs*31', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12715, '12661', 973, 'bc_stairs*32', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12716, '12662', 973, 'bc_stairs*33', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12717, '12663', 973, 'bc_stairs*34', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12718, '12664', 973, 'bc_stairs*35', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12719, '12665', 973, 'bc_stairs*36', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12720, '12666', 973, 'bc_stairs*37', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12721, '12667', 973, 'bc_stairs*38', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12722, '12668', 973, 'bc_stairs*39', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12723, '12669', 973, 'bc_stairs*4', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12724, '12670', 973, 'bc_stairs*40', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12725, '12671', 973, 'bc_stairs*41', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12726, '12672', 973, 'bc_stairs*42', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12727, '12673', 973, 'bc_stairs*43', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12728, '12674', 973, 'bc_stairs*44', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12729, '12675', 973, 'bc_stairs*45', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12730, '12676', 973, 'bc_stairs*46', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12731, '12677', 973, 'bc_stairs*47', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12732, '12678', 973, 'bc_stairs*48', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12733, '12679', 973, 'bc_stairs*49', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12734, '12680', 973, 'bc_stairs*5', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12735, '12681', 973, 'bc_stairs*50', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12736, '12682', 973, 'bc_stairs*51', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12737, '12683', 973, 'bc_stairs*52', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12738, '12684', 973, 'bc_stairs*53', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12739, '12685', 973, 'bc_stairs*54', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12740, '12686', 973, 'bc_stairs*55', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12741, '12687', 973, 'bc_stairs*56', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12742, '12688', 973, 'bc_stairs*57', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12743, '12689', 973, 'bc_stairs*58', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12744, '12690', 973, 'bc_stairs*59', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12745, '12691', 973, 'bc_stairs*6', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12746, '12692', 973, 'bc_stairs*60', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12747, '12693', 973, 'bc_stairs*61', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12748, '12694', 973, 'bc_stairs*62', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12749, '12695', 973, 'bc_stairs*63', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12750, '12696', 973, 'bc_stairs*64', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12751, '12697', 973, 'bc_stairs*65', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12752, '12698', 973, 'bc_stairs*66', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12753, '12699', 973, 'bc_stairs*67', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12754, '12700', 973, 'bc_stairs*68', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12755, '12701', 973, 'bc_stairs*69', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12756, '12702', 973, 'bc_stairs*7', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12757, '12703', 973, 'bc_stairs*8', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12758, '12704', 973, 'bc_stairs*9', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12759, '12705', 977, 'bc_stick*1', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12760, '12706', 977, 'bc_stick*10', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12761, '12707', 977, 'bc_stick*11', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12762, '12708', 977, 'bc_stick*12', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12763, '12709', 977, 'bc_stick*13', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12764, '12710', 977, 'bc_stick*14', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12765, '12711', 977, 'bc_stick*15', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12766, '12712', 977, 'bc_stick*16', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12767, '12713', 977, 'bc_stick*17', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12768, '12714', 977, 'bc_stick*18', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12769, '12715', 977, 'bc_stick*19', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12770, '12716', 977, 'bc_stick*2', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12771, '12717', 977, 'bc_stick*20', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12772, '12718', 977, 'bc_stick*21', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12773, '12719', 977, 'bc_stick*22', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12774, '12720', 977, 'bc_stick*23', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12775, '12721', 977, 'bc_stick*24', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12776, '12722', 977, 'bc_stick*25', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12777, '12723', 977, 'bc_stick*26', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12778, '12724', 977, 'bc_stick*27', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12779, '12725', 977, 'bc_stick*28', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12780, '12726', 977, 'bc_stick*29', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12781, '12727', 977, 'bc_stick*3', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12782, '12728', 977, 'bc_stick*30', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12783, '12729', 977, 'bc_stick*31', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12784, '12730', 977, 'bc_stick*32', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12785, '12731', 977, 'bc_stick*33', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12786, '12732', 977, 'bc_stick*34', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12787, '12733', 977, 'bc_stick*35', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12788, '12734', 977, 'bc_stick*36', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12789, '12735', 977, 'bc_stick*37', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12790, '12736', 977, 'bc_stick*38', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12791, '12737', 977, 'bc_stick*39', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12792, '12738', 977, 'bc_stick*4', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12793, '12739', 977, 'bc_stick*40', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12794, '12740', 977, 'bc_stick*41', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12795, '12741', 977, 'bc_stick*42', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12796, '12742', 977, 'bc_stick*43', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12797, '12743', 977, 'bc_stick*44', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12798, '12744', 977, 'bc_stick*45', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12799, '12745', 977, 'bc_stick*46', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12800, '12746', 977, 'bc_stick*47', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12801, '12747', 977, 'bc_stick*48', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12802, '12748', 977, 'bc_stick*49', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12803, '12749', 977, 'bc_stick*5', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12804, '12750', 977, 'bc_stick*50', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12805, '12751', 977, 'bc_stick*51', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12806, '12752', 977, 'bc_stick*52', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12807, '12753', 977, 'bc_stick*53', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12808, '12754', 977, 'bc_stick*54', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12809, '12755', 977, 'bc_stick*55', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12810, '12756', 977, 'bc_stick*56', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12811, '12757', 977, 'bc_stick*57', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12812, '12758', 977, 'bc_stick*58', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12813, '12759', 977, 'bc_stick*59', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12814, '12760', 977, 'bc_stick*6', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12815, '12761', 977, 'bc_stick*60', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12816, '12762', 977, 'bc_stick*61', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12817, '12763', 977, 'bc_stick*62', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12818, '12764', 977, 'bc_stick*63', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12819, '12765', 977, 'bc_stick*64', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12820, '12766', 977, 'bc_stick*65', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12821, '12767', 977, 'bc_stick*66', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12822, '12768', 977, 'bc_stick*67', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12823, '12769', 977, 'bc_stick*68', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12824, '12770', 977, 'bc_stick*69', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12825, '12771', 977, 'bc_stick*7', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12826, '12772', 977, 'bc_stick*8', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12827, '12773', 977, 'bc_stick*9', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12828, '12774', 978, 'bc_quartercircle*1', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12829, '12775', 978, 'bc_quartercircle*10', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12830, '12776', 978, 'bc_quartercircle*11', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12831, '12777', 978, 'bc_quartercircle*12', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12832, '12778', 978, 'bc_quartercircle*13', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12833, '12779', 978, 'bc_quartercircle*14', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12834, '12780', 978, 'bc_quartercircle*15', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12835, '12781', 978, 'bc_quartercircle*16', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12836, '12782', 978, 'bc_quartercircle*17', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12837, '12783', 978, 'bc_quartercircle*18', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12838, '12784', 978, 'bc_quartercircle*19', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12839, '12785', 978, 'bc_quartercircle*2', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12840, '12786', 978, 'bc_quartercircle*20', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12841, '12787', 978, 'bc_quartercircle*21', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12842, '12788', 978, 'bc_quartercircle*22', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12843, '12789', 978, 'bc_quartercircle*23', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12844, '12790', 978, 'bc_quartercircle*24', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12845, '12791', 978, 'bc_quartercircle*25', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12846, '12792', 978, 'bc_quartercircle*26', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12847, '12793', 978, 'bc_quartercircle*27', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12848, '12794', 978, 'bc_quartercircle*28', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12849, '12795', 978, 'bc_quartercircle*29', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12850, '12796', 978, 'bc_quartercircle*3', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12851, '12797', 978, 'bc_quartercircle*30', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12852, '12798', 978, 'bc_quartercircle*31', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12853, '12799', 978, 'bc_quartercircle*32', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12854, '12800', 978, 'bc_quartercircle*33', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12855, '12801', 978, 'bc_quartercircle*34', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12856, '12802', 978, 'bc_quartercircle*35', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12857, '12803', 978, 'bc_quartercircle*36', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12858, '12804', 978, 'bc_quartercircle*37', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12859, '12805', 978, 'bc_quartercircle*38', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12860, '12806', 978, 'bc_quartercircle*39', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12861, '12807', 978, 'bc_quartercircle*4', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12862, '12808', 978, 'bc_quartercircle*40', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12863, '12809', 978, 'bc_quartercircle*41', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12864, '12810', 978, 'bc_quartercircle*42', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12865, '12811', 978, 'bc_quartercircle*43', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12866, '12812', 978, 'bc_quartercircle*44', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12867, '12813', 978, 'bc_quartercircle*45', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12868, '12814', 978, 'bc_quartercircle*46', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12869, '12815', 978, 'bc_quartercircle*47', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12870, '12816', 978, 'bc_quartercircle*48', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12871, '12817', 978, 'bc_quartercircle*49', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12872, '12818', 978, 'bc_quartercircle*5', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12873, '12819', 978, 'bc_quartercircle*50', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12874, '12820', 978, 'bc_quartercircle*51', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12875, '12821', 978, 'bc_quartercircle*52', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12876, '12822', 978, 'bc_quartercircle*53', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12877, '12823', 978, 'bc_quartercircle*54', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12878, '12824', 978, 'bc_quartercircle*55', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12879, '12825', 978, 'bc_quartercircle*56', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12880, '12826', 978, 'bc_quartercircle*57', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12881, '12827', 978, 'bc_quartercircle*58', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12882, '12828', 978, 'bc_quartercircle*59', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12883, '12829', 978, 'bc_quartercircle*6', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12884, '12830', 978, 'bc_quartercircle*60', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12885, '12831', 978, 'bc_quartercircle*61', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12886, '12832', 978, 'bc_quartercircle*62', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12887, '12833', 978, 'bc_quartercircle*63', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12888, '12834', 978, 'bc_quartercircle*64', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12889, '12835', 978, 'bc_quartercircle*65', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12890, '12836', 978, 'bc_quartercircle*66', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12891, '12837', 978, 'bc_quartercircle*67', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12892, '12838', 978, 'bc_quartercircle*68', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12893, '12839', 978, 'bc_quartercircle*69', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12894, '12840', 978, 'bc_quartercircle*7', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12895, '12841', 978, 'bc_quartercircle*8', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12896, '12842', 978, 'bc_quartercircle*9', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12897, '12843', 974, 'bc_sphere_small*1', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12898, '12844', 974, 'bc_sphere_small*10', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12899, '12845', 974, 'bc_sphere_small*11', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12900, '12846', 974, 'bc_sphere_small*12', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12901, '12847', 974, 'bc_sphere_small*13', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12902, '12848', 974, 'bc_sphere_small*14', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12903, '12849', 974, 'bc_sphere_small*15', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12904, '12850', 974, 'bc_sphere_small*16', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12905, '12851', 974, 'bc_sphere_small*17', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12906, '12852', 974, 'bc_sphere_small*18', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12907, '12853', 974, 'bc_sphere_small*19', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12908, '12854', 974, 'bc_sphere_small*2', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12909, '12855', 974, 'bc_sphere_small*20', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12910, '12856', 974, 'bc_sphere_small*21', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12911, '12857', 974, 'bc_sphere_small*22', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12912, '12858', 974, 'bc_sphere_small*23', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12913, '12859', 974, 'bc_sphere_small*24', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12914, '12860', 974, 'bc_sphere_small*25', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12915, '12861', 974, 'bc_sphere_small*26', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12916, '12862', 974, 'bc_sphere_small*27', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12917, '12863', 974, 'bc_sphere_small*28', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12918, '12864', 974, 'bc_sphere_small*29', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12919, '12865', 974, 'bc_sphere_small*3', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12920, '12866', 974, 'bc_sphere_small*30', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12921, '12867', 974, 'bc_sphere_small*31', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12922, '12868', 974, 'bc_sphere_small*32', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12923, '12869', 974, 'bc_sphere_small*33', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12924, '12870', 974, 'bc_sphere_small*34', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12925, '12871', 974, 'bc_sphere_small*35', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12926, '12872', 974, 'bc_sphere_small*36', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12927, '12873', 974, 'bc_sphere_small*37', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12928, '12874', 974, 'bc_sphere_small*38', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12929, '12875', 974, 'bc_sphere_small*39', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12930, '12876', 974, 'bc_sphere_small*4', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12931, '12877', 974, 'bc_sphere_small*40', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12932, '12878', 974, 'bc_sphere_small*41', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12933, '12879', 974, 'bc_sphere_small*42', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12934, '12880', 974, 'bc_sphere_small*43', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12935, '12881', 974, 'bc_sphere_small*44', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12936, '12882', 974, 'bc_sphere_small*45', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12937, '12883', 974, 'bc_sphere_small*46', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12938, '12884', 974, 'bc_sphere_small*47', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12939, '12885', 974, 'bc_sphere_small*48', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12940, '12886', 974, 'bc_sphere_small*49', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12941, '12887', 974, 'bc_sphere_small*5', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12942, '12888', 974, 'bc_sphere_small*50', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12943, '12889', 974, 'bc_sphere_small*51', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12944, '12890', 974, 'bc_sphere_small*52', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12945, '12891', 974, 'bc_sphere_small*53', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12946, '12892', 974, 'bc_sphere_small*54', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12947, '12893', 974, 'bc_sphere_small*55', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12948, '12894', 974, 'bc_sphere_small*56', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12949, '12895', 974, 'bc_sphere_small*57', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12950, '12896', 974, 'bc_sphere_small*58', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12951, '12897', 974, 'bc_sphere_small*59', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12952, '12898', 974, 'bc_sphere_small*6', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12953, '12899', 974, 'bc_sphere_small*60', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12954, '12900', 974, 'bc_sphere_small*61', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12955, '12901', 974, 'bc_sphere_small*62', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12956, '12902', 974, 'bc_sphere_small*63', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12957, '12903', 974, 'bc_sphere_small*64', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12958, '12904', 974, 'bc_sphere_small*65', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12959, '12905', 974, 'bc_sphere_small*66', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12960, '12906', 974, 'bc_sphere_small*67', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12961, '12907', 974, 'bc_sphere_small*68', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12962, '12908', 974, 'bc_sphere_small*69', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12963, '12909', 974, 'bc_sphere_small*7', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12964, '12910', 974, 'bc_sphere_small*8', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12965, '12911', 974, 'bc_sphere_small*9', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12966, '12912;50251', 897, 'clothing_r22_bigflowercrown', 25, 25, 5, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12967, '12913;50250', 897, 'clothing_r22_bouquetdress', 25, 25, 5, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12968, '12914;50294', 959, 'rare_r22_topiaryanimals', 25, 25, 5, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12969, '12915;50252', 897, 'rare_r22_fancyfountain', 25, 25, 5, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(12970, '12006', 945, 'vwave_c21_floppydisk', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(12971, '11999', 945, 'vwave_c21_rubiks', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '1', '0'),
	(12972, '11987', 945, 'vwave_c21_bench', 3, 0, 0, 1, 0, 0, 1, 25842, 0, '', '0', '0'),
	(12973, '11982', 945, 'vwave_c21_buildings', 3, 0, 0, 1, 0, 0, 1, 25842, 0, '', '0', '0'),
	(12974, '12024', 945, 'vwave_c21_nightsand', 3, 0, 0, 1, 0, 0, 1, 25842, 0, '', '0', '0'),
	(12975, '12026', 945, 'vwave_c21_palm', 3, 0, 0, 1, 0, 0, 1, 25842, 0, '', '0', '0'),
	(12976, '11994', 945, 'vwave_c21_pavement', 3, 0, 0, 1, 0, 0, 1, 25842, 0, '', '0', '0'),
	(12977, '11991', 945, 'vwave_c21_planter', 3, 0, 0, 1, 0, 0, 1, 25842, 0, '', '0', '0'),
	(12978, '11983', 945, 'vwave_c21_railcrnr', 3, 0, 0, 1, 0, 0, 1, 25842, 0, '', '0', '0'),
	(12979, '12010', 945, 'vwave_c21_railing', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12980, '12017', 945, 'vwave_c21_streetlight', 3, 0, 0, 1, 0, 0, 1, 25842, 0, '', '0', '0'),
	(12981, '47210', 945, 'vwave_c21_sunsetbg', 3, 0, 0, 1, 0, 0, 1, 25842, 0, '', '0', '0'),
	(12982, '11986', 945, 'vwave_c21_wall', 3, 0, 0, 1, 0, 0, 1, 25842, 0, '', '0', '0'),
	(12983, '12019', 944, 'vwave_c21_pc', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12984, '12048', 947, 'diamond_c21_giftbox', 5, 5, 5, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12985, '59979', 5010, 'rotating_roomdeal', 99, 0, 0, 1, 0, 0, 1, 59979, 0, '50260', '0', '0'),
	(12986, '59980', 5011, 'rotating_roomdeal', 99, 0, 0, 1, 0, 0, 1, 59980, 0, '50259', '0', '0'),
	(12987, '11459;50267', 948, 'clothing_cyeyepiece', 5, 10, 5, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12988, '50270', 894, 'badge_name_TLB01', 0, 10, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12989, '11936', 949, 'thai_c21_woodcarvingset', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12990, '11939;50271', 886, 'clothing_r21_muaythaioutfit', 25, 25, 5, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12991, '11940;50272', 886, 'clothing_r21_pangolin', 25, 25, 5, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12992, '11931', 950, 'thai_r21_clothingbox', 3, 3, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12993, '11931', 949, 'thai_r21_clothingbox', 3, 3, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12994, '11764', 886, 'CF_500_egg', 500, 500, 5, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(12995, '9324', 954, 'bc_gift_31days', 185, 185, 5, 2, 0, 0, 3, 20096, 0, '', '0', '1'),
	(12996, '9324', 954, 'bc_gift_31days', 245, 245, 5, 3, 0, 0, 4, 20096, 0, '', '0', '1'),
	(12997, '9324', 954, 'bc_gift_31days', 430, 430, 5, 6, 0, 0, 5, 20096, 0, '', '0', '1'),
	(12998, '9326', 954, 'hc_gift_31days', 85, 85, 0, 2, 0, 0, 8, 20099, 0, '', '0', '1'),
	(12999, '9326', 954, 'hc_gift_31days', 110, 110, 0, 2, 0, 0, 9, 20099, 0, '', '0', '1'),
	(13000, '9326', 954, 'hc_gift_31days', 185, 185, 0, 2, 0, 0, 10, 20099, 0, '', '0', '1'),
	(13001, '20070', 952, 'builders_club_1_month', 105, 105, 5, 1, 0, 0, 1, 20060, 0, '', '0', '0'),
	(13002, '20070', 941, 'builders_club_1_month', 10, 10, 5, 1, 0, 0, 1, 20060, 0, '', '0', '0'),
	(13003, '20070', 683, 'builders_club_1_month', 3, 0, 0, 1, 0, 0, 16, 20070, 0, '', '1', '0'),
	(13004, '20060', 683, 'DEAL_HC_1', 9, 0, 0, 3, 0, 0, 15, 20060, 0, '', '0', '0'),
	(13005, '20060', 683, 'DEAL_HC_1', 18, 0, 0, 6, 0, 0, 15, 20060, 0, '', '0', '0'),
	(14426, '179', 50002, 'duck', 0, 3, 3, 1, 0, 0, 3, 168, 0, '', '0', '0'),
	(14428, '179', 50002, 'duck', 0, 5, 5, 1, 0, 0, 5, 168, 0, '', '0', '0'),
	(14429, '179', 50002, 'duck', 0, 101, 101, 1, 0, 0, 101, 168, 0, '', '0', '0'),
	(14430, '179', 50002, 'duck', 0, 102, 102, 1, 0, 0, 102, 168, 0, '', '0', '0'),
	(14431, '179', 50002, 'duck', 0, 103, 103, 1, 0, 0, 103, 168, 0, '', '0', '0'),
	(14432, '179', 50002, 'duck', 0, 104, 104, 1, 0, 0, 104, 168, 0, '', '0', '0'),
	(14433, '179', 50002, 'duck', 0, 105, 105, 1, 0, 0, 105, 168, 0, '', '0', '0'),
	(14434, '179', 50002, 'duck', 0, 1, 0, 1, 0, 0, 0, 168, 0, '', '0', '0'),
	(14435, '179', 50002, 'duck', 0, 2, 2, 1, 0, 0, 2, 168, 0, '', '0', '0'),
	(14436, '179', 50002, 'duck', 0, 4, 4, 1, 0, 0, 4, 168, 0, '', '0', '0'),
	(14437, '179', 50002, 'duck', 0, 1, 1, 1, 0, 0, 1, 168, 0, '', '0', '0'),
	(14438, '179', 50002, 'duck', 0, 6, 6, 1, 0, 0, 6, 168, 0, '', '0', '0'),
	(14439, '179', 50002, 'duck', 0, 7, 7, 1, 0, 0, 7, 168, 0, '', '0', '0'),
	(14440, '179', 50002, 'duck', 0, 8, 8, 1, 0, 0, 8, 168, 0, '', '0', '0'),
	(14444, '179', 50002, 'duck', 0, 9, 9, 1, 0, 0, 9, 168, 0, '', '0', '0'),
	(14445, '179', 50002, 'duck', 0, 10, 10, 1, 0, 0, 10, 168, 0, '', '0', '0'),
	(14446, '21;26:2', 958, 'deal01', 15, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(14447, '20;30:2;32', 958, 'deal02', 15, 0, 0, 1, 0, 0, 2, -1, 0, '', '0', '0'),
	(14448, '18:2;31;33', 958, 'deal03', 15, 0, 0, 1, 0, 0, 3, -1, 0, '', '0', '0'),
	(14449, '25;125;144', 958, 'deal04', 15, 0, 0, 1, 0, 0, 4, -1, 0, '', '0', '0'),
	(14450, '139;119:6', 958, 'deal05', 15, 0, 0, 1, 0, 0, 5, -1, 0, '', '0', '0'),
	(14451, '54;55:3', 958, 'deal06', 15, 0, 0, 1, 0, 0, 6, -1, 0, '', '0', '0'),
	(14452, '32;47;171;169', 958, 'deal08', 15, 0, 0, 1, 0, 0, 8, -1, 0, '', '0', '0'),
	(14453, '160;161:2;40010', 958, 'deal09', 15, 0, 0, 1, 0, 0, 9, -1, 0, '1002', '0', '0'),
	(14454, '110;114:4', 958, 'deal07', 15, 0, 0, 1, 0, 0, 7, -1, 0, '', '0', '0'),
	(14455, '160;161:2;40010', 958, 'deal10', 15, 0, 0, 1, 0, 0, 10, -1, 0, '1002', '0', '0'),
	(14456, '1532:10;50275;179', 958, 'deal97', 15, 0, 0, 1, 0, 0, 11, -1, 0, '', '0', '0'),
	(14457, '1534:10;50275;179', 958, 'deal99', 15, 0, 0, 1, 0, 0, 13, -1, 0, '', '0', '0'),
	(14458, '1533:10;50275;179', 958, 'deal98', 15, 0, 0, 1, 0, 0, 12, -1, 0, '', '0', '0'),
	(14459, '2663;2675:2;2686;2783', 958, 'noob_set_1', 0, 30, 1, 1, 0, 0, 14, -1, 0, '', '0', '0'),
	(14460, '2664;2676:2;2682;2783', 958, 'noob_set_2', 0, 30, 1, 1, 0, 0, 15, -1, 0, '', '0', '0'),
	(14461, '2665;2677:2;2683;2783', 958, 'noob_set_3', 0, 30, 1, 1, 0, 0, 16, -1, 0, '', '0', '0'),
	(14462, '2666;2678:2;2684;2783', 958, 'noob_set_4', 0, 30, 1, 1, 0, 0, 17, -1, 0, '', '0', '0'),
	(14463, '2667;2679:2;2685;2783', 958, 'noob_set_5', 0, 30, 1, 1, 0, 0, 18, -1, 0, '', '0', '0'),
	(14464, '2668;2680:2;2686;2783', 958, 'noob_set_6', 0, 30, 1, 1, 0, 0, 19, -1, 0, '', '0', '0'),
	(14465, '3675;3685;3699', 618, 'wf_deal1', 7, 0, 0, 1, 0, 0, 1, 3699, 0, '', '1', '0'),
	(14466, '3685;3688;3699;3703', 618, 'wf_deal4', 10, 0, 0, 1, 0, 0, 4, 3703, 0, '', '1', '0'),
	(14467, '3666;3674;3675', 618, 'wf_deal6', 8, 0, 0, 1, 0, 0, 6, 3683, 0, '', '1', '0'),
	(14468, '3663;3688;3689;3703', 618, 'wf_deal8', 7, 0, 0, 1, 0, 0, 8, 3693, 0, '', '1', '0'),
	(14469, '3633', 45, 'bb_patch1', 25, 0, 0, 50, 0, 0, 0, 8946, 0, '', '1', '0'),
	(14470, '4', 9, 'It\'s TenShie', 100, 0, 0, 1, 0, 0, 4, 4, 0, 'name:TenShie;motto:The Original;figure:hd-3100-5.ch-4067-1417.hr-3251-39-49.he-3884-110-1327.lg-3200-92;gender:F', '0', '0'),
	(14471, '50278', 50000, 'TenShies Badge', 300, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(14472, '12916', 959, 'easter_c22_titanarumplant', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(14473, '12917', 959, 'easter_c22_scarab1', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(14474, '12918', 959, 'easter_ltd22_butterflyenclosure', 250, 0, 0, 1, 60, 0, 0, -1, 0, '', '0', '0'),
	(14475, '12919', 959, 'easter_c22_rockerylight', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(14476, '12920', 959, 'easter_c22_hangingvines', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(14477, '12921', 959, 'easter_c22_mantis1', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(14478, '12922', 959, 'easter_c22_aerialbugs2', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(14479, '12923', 959, 'easter_c22_groundbugs2b', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(14480, '12924', 959, 'clothing_snailfriend2', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(14481, '12925', 959, 'easter_c22_kioskshop', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(14482, '12926', 959, 'easter_c22_sawstagbeetle2', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(14483, '12927', 959, 'easter_c22_deluxebugkitb', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(14484, '12928', 959, 'easter_c22_bioworldwall', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(14485, '12929', 959, 'easter_c22_caterpillar2', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(14486, '12930', 959, 'easter_c22_apparelbagb', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(14487, '12931', 959, 'easter_c22_groundbugs4b', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(14488, '12932', 959, 'easter_c22_caterpillar1', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(14489, '12933', 959, 'clothing_butterflyhair', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(14490, '12934', 959, 'easter_c22_bioworldwall2', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(14491, '12935', 959, 'easter_c22_apparelbag', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(14492, '12936', 959, 'easter_c22_pathlight', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(14493, '12937', 959, 'easter_c22_rockdecor', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(14494, '12938', 959, 'clothing_r22_beetle', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(14495, '12939', 959, 'easter_c22_groundbugs1', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(14496, '12940', 959, 'clothing_ladybirdbag', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(14497, '12941', 959, 'easter_c22_agrias1', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(14498, '12942', 959, 'easter_c22_rockerydark', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(14499, '12943', 959, 'easter_c22_ladybird2', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(14500, '12944', 959, 'easter_c22_rafflesia', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(14501, '12945', 959, 'easter_c22_tree', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(14502, '12946', 959, 'easter_c22_redtippedplant', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(14503, '12947', 959, 'easter_c22_rockfloor', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(14504, '12948', 959, 'easter_c22_ladybird1', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(14505, '12949', 959, 'easter_c22_ropedivider', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(14506, '12950', 959, 'easter_c22_aerialbugs2b', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(14507, '12951', 959, 'easter_c22_roundpalm', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(14508, '12952', 959, 'clothing_snailfriend', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(14509, '12953', 959, 'clothing_r22_mothoutfit', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(14510, '12954', 959, 'easter_r22_boutiquecoffee', 25, 25, 5, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(14511, '12955', 959, 'easter_c22_pottingtable', 10, 2, 5, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(14512, '12956', 959, 'easter_c22_waterfeature', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(14513, '12957', 959, 'easter_c22_tallgrass', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(14514, '12958', 959, 'easter_c22_groundbugs2', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(14515, '12959', 959, 'easter_c22_scarab2', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(14516, '12960', 959, 'easter_c22_barrelcactus', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(14517, '12961', 959, 'easter_c22_dragonfly1', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(14518, '12962', 959, 'clothing_net', 3, 0, 0, 1, 0, 0, 0, 25382, 0, '', '0', '0'),
	(14519, '12963', 959, 'easter_c22_dirtfloor', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(14520, '12964', 959, 'easter_c22_deluxebugkit', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(14521, '12965', 959, 'easter_c22_bugkitb', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(14522, '12966', 959, 'easter_c22_goliathbeetle2', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(14523, '12967', 959, 'easter_c22_beehotel', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(14524, '12968', 959, 'easter_c22_driftwood', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(14525, '12969', 959, 'easter_c22_giantbee', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(14526, '12970', 959, 'easter_c22_agrias2', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(14527, '12971', 959, 'easter_c22_groundbugs4', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(14528, '12972', 959, 'easter_c22_sawstagbeetle1', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(14529, '12973', 959, 'easter_c22_aerialbugs1b', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(14530, '12974', 959, 'easter_c22_goliathbeetle1', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(14531, '12975', 959, 'easter_c22_aerialbugs1', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(14532, '12976', 959, 'easter_c22_bugkit', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(14533, '12977', 959, 'easter_c22_groundbugs3', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(14534, '12978', 959, 'clothing_beetshirt', 3, 0, 0, 1, 0, 0, 0, 25398, 0, '', '0', '0'),
	(14535, '12979', 959, 'easter_c22_groundbugs3b', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(14536, '12980', 959, 'easter_c22_morpho1', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(14537, '12981', 959, 'easter_c22_fossilbench', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(14538, '12982', 959, 'easter_c22_morpho2', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(14539, '12983', 959, 'easter_c22_mantis2', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(14540, '12984', 959, 'easter_c22_groundbugs1b', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(14541, '12985', 959, 'clothing_explorersoutfit', 3, 0, 0, 1, 0, 0, 0, 25405, 0, '', '0', '0'),
	(14542, '12986', 959, 'easter_c22_fanpalm', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(14543, '12987', 959, 'easter_r22_caterpillarsleepingbag', 25, 25, 5, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(14544, '12988', 959, 'easter_c22_informationboard', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(14545, '12989', 959, 'easter_c22_dragonfly2', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '1', '0'),
	(14546, '12990', 34, 'rela_candle4', 4, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(14547, '12991', 895, 'sanrio_c22_badtzdesk', 7, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(14548, '12992', 895, 'sanrio_c22_badtzendtable', 5, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(14549, '12993', 895, 'sanrio_c22_badtzcake', 5, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(14550, '12994', 895, 'clothing_badtzshirt', 4, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(14551, '12995', 895, 'sanrio_c22_badtzlamp', 4, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(14552, '12996', 895, 'clothing_badtzbackpack', 5, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(14553, '12997', 960, 'nft_hologram1', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(14554, '12998', 960, 'nft_hologram3', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(14555, '12999', 960, 'nft_hologram2', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(14556, '13000', 960, 'nft_hologram4', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(14557, '13001', 961, 'bonusrare22_4*1', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(14558, '13002', 961, 'bonusrare22_4*2', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(14559, '13003', 961, 'bonusrare22_4*3', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(14560, '13004', 961, 'bonusrare22_4*4', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(14561, '13005', 961, 'bonusrare22_4*5', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(14562, '13006', 894, 'ads_teletubbies_plushie3', 3, 0, 0, 1, 0, 0, 0, 25486, 0, '', '0', '0'),
	(14563, '13007', 894, 'clothing_headband_laalaa', 7, 0, 0, 1, 0, 0, 0, 25492, 0, '', '0', '0'),
	(14564, '13008', 894, 'ads_teletubbies_beanbag3', 4, 0, 0, 1, 0, 0, 0, 25491, 0, '', '0', '0'),
	(14565, '13009', 894, 'ads_teletubbies_plushie1', 3, 0, 0, 1, 0, 0, 0, 25490, 0, '', '0', '0'),
	(14566, '13010', 894, 'ads_teletubbies_plushie2', 3, 0, 0, 1, 0, 0, 0, 25484, 0, '', '0', '0'),
	(14567, '13011', 894, 'clothing_headband_dipsy', 7, 0, 0, 1, 0, 0, 0, 25488, 0, '', '0', '0'),
	(14568, '13012', 894, 'clothing_headband_po', 7, 0, 0, 1, 0, 0, 0, 25481, 0, '', '0', '0'),
	(14569, '13013', 894, 'ads_teletubbies_beanbag4', 4, 0, 0, 1, 0, 0, 0, 25482, 0, '', '0', '0'),
	(14570, '13014', 894, 'clothing_dipsyhat', 8, 0, 0, 1, 0, 0, 0, 25493, 0, '', '0', '0'),
	(14571, '13015', 894, 'ads_teletubbies_plushie4', 3, 0, 0, 1, 0, 0, 0, 25485, 0, '', '0', '0'),
	(14572, '13016', 894, 'ads_teletubbies_beanbag2', 4, 0, 0, 1, 0, 0, 0, 25489, 0, '', '0', '0'),
	(14573, '13017', 894, 'clothing_headband_tinkywinky', 7, 0, 0, 1, 0, 0, 0, 25483, 0, '', '0', '0'),
	(14574, '13018', 894, 'ads_teletubbies_beanbag1', 4, 0, 0, 1, 0, 0, 0, 25487, 0, '', '0', '0'),
	(14575, '13019;47340;50302', 877, 'UKR01', 0, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(14576, '13020', 960, 'nft_credit_100', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(14577, '13021', 960, 'nft_credit_50', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(14578, '13022', 960, 'nft_credit_1000', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(14579, '13023', 960, 'nft_credit_10', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(14580, '13024', 960, 'nft_credit_500', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(14581, '47340', 231, 'flag_ukraine', 4, 0, 0, 1, 0, 0, 0, 25466, 0, '', '0', '0'),
	(14582, '11899', 965, 'antique_r21_curiocabinet', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(14583, '12152', 965, 'bubblejuice_r21_fireplace', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(14584, '11889', 965, 'animal_r21_gorilla', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(14585, '10912;8484;2064:10;50290;20060', 969, 'bf19_tko1', 105, 105, 5, 1, 0, 0, 7, -1, 0, '0', '1', '0'),
	(14586, '10912;8512;8525;9802;8483:2;8486;8510:2;20060:3;2064:80;50290', 969, 'bf19_tko2', 200, 200, 5, 1, 0, 0, 8, -1, 0, '0', '1', '0'),
	(14587, '9263;8465;8525;8476;5347;4817;2064:70;50293;20060', 969, 'bf16_tko1', 105, 105, 5, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(14588, '9263:2;8486:2;8512:2;8470:2;2064:80;50293;20060:3', 969, 'bf16_tko2', 180, 180, 5, 1, 0, 0, 2, -1, 0, '', '0', '0'),
	(14589, '9855;4306;3002;4286:4;2064:70;50292;20060', 969, 'bf17_tko1', 105, 105, 5, 1, 0, 0, 3, -1, 0, '', '0', '0'),
	(14590, '9855;4306:2;3002:2;4286:4;2064:80;50292;20060:3', 969, 'bf17_tko2', 180, 180, 5, 1, 0, 0, 4, -1, 0, '', '0', '0'),
	(14591, '10320;2064:35;50291;20060', 969, 'bf18_tko1', 80, 80, 5, 1, 0, 0, 5, -1, 0, '', '0', '0'),
	(14592, '10320:2;2064:35;50291;20060:3', 969, 'bf18_tko2', 120, 120, 5, 1, 0, 0, 6, -1, 0, '', '0', '0'),
	(14593, '11815', 965, 'rare_r21_aussiedog', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(14594, '11745', 965, 'rare_r21_coffeesiphon', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(14595, '11816', 965, 'rare_r21_blossomtree', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(14596, '11745', 965, 'rare_r21_coffeesiphon', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(14597, '12955', 962, 'easter_c22_pottingtable', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(14598, '11856', 971, 'easter_ltd21_springvibesegg', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(14599, '12102', 971, 'hween_ltd21_pagoda', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(14600, '11746', 971, 'ltd21_unicornpup', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(14601, '12033', 971, 'mushroom_ltd21_fairy', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(14602, '12109', 971, 'rainbow_ltd21_dragonlamp', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(14603, '11886', 971, 'rainbow_ltd21_fan', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(14604, '11961', 971, 'rainbow_ltd21_rainbowboa', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(14605, '11929', 971, 'thai_ltd21_yakgodstatue', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(14606, '12015', 971, 'vwave_ltd21_lambo', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(14607, '12213', 971, 'xmas_ltd21_artdecoegg', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(14608, '12469', 972, 'ltd22_giantcrystal', 3, 0, 0, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(14609, '12918', 972, 'easter_ltd22_butterflyenclosure', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(14610, '12912;50251', 912, 'clothing_r22_bigflowercrown', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(14611, '12501;50303', 897, 'clothing_r22_bohoshirt', 25, 25, 5, 1, 0, 0, 1, -1, 0, '', '0', '0'),
	(14612, '12913;50250', 912, 'clothing_r22_bouquetdress', 3, 0, 0, 1, 0, 0, 0, -1, 0, '', '0', '0'),
	(14613, '12500;50304', 897, 'clothing_r22_messierbun', 25, 25, 5, 1, 0, 0, 1, -1, 0, '', '0', '0');
/*!40000 ALTER TABLE `catalog_items` ENABLE KEYS */;

-- Dumping structure for table test.catalog_items_bc
DROP TABLE IF EXISTS `catalog_items_bc`;
CREATE TABLE IF NOT EXISTS `catalog_items_bc` (
  `id` int(16) NOT NULL AUTO_INCREMENT,
  `item_ids` varchar(666) COLLATE utf8mb4_unicode_ci NOT NULL,
  `page_id` int(11) NOT NULL,
  `catalog_name` varchar(100) COLLATE utf8mb4_unicode_ci NOT NULL,
  `order_number` int(11) NOT NULL DEFAULT 1,
  `extradata` varchar(500) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci ROW_FORMAT=DYNAMIC;

-- Dumping data for table test.catalog_items_bc: ~0 rows (approximately)
/*!40000 ALTER TABLE `catalog_items_bc` DISABLE KEYS */;
/*!40000 ALTER TABLE `catalog_items_bc` ENABLE KEYS */;

-- Dumping structure for table test.catalog_items_limited
DROP TABLE IF EXISTS `catalog_items_limited`;
CREATE TABLE IF NOT EXISTS `catalog_items_limited` (
  `catalog_item_id` int(11) NOT NULL,
  `number` int(11) NOT NULL,
  `user_id` int(11) NOT NULL DEFAULT 0,
  `timestamp` int(11) NOT NULL DEFAULT 0,
  `item_id` int(11) NOT NULL DEFAULT 0,
  UNIQUE KEY `catalog_item_id` (`catalog_item_id`,`number`) USING BTREE,
  KEY `user_timestamp_index` (`user_id`,`timestamp`) USING BTREE
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci ROW_FORMAT=FIXED;

-- Dumping data for table test.catalog_items_limited: 660 rows
/*!40000 ALTER TABLE `catalog_items_limited` DISABLE KEYS */;
REPLACE INTO `catalog_items_limited` (`catalog_item_id`, `number`, `user_id`, `timestamp`, `item_id`) VALUES
	(11661, 1, 0, 0, 0),
	(11661, 2, 0, 0, 0),
	(11661, 3, 0, 0, 0),
	(11661, 4, 0, 0, 0),
	(11661, 5, 0, 0, 0),
	(11661, 6, 0, 0, 0),
	(11661, 7, 0, 0, 0),
	(11661, 8, 0, 0, 0),
	(11661, 9, 0, 0, 0),
	(11661, 10, 0, 0, 0),
	(11661, 11, 0, 0, 0),
	(11661, 12, 0, 0, 0),
	(11661, 13, 0, 0, 0),
	(11661, 14, 0, 0, 0),
	(11661, 15, 0, 0, 0),
	(11661, 16, 0, 0, 0),
	(11661, 17, 0, 0, 0),
	(11661, 18, 0, 0, 0),
	(11661, 19, 0, 0, 0),
	(11661, 20, 0, 0, 0),
	(11661, 21, 0, 0, 0),
	(11661, 22, 0, 0, 0),
	(11661, 23, 0, 0, 0),
	(11661, 24, 0, 0, 0),
	(11661, 25, 0, 0, 0),
	(11661, 26, 0, 0, 0),
	(11661, 27, 0, 0, 0),
	(11661, 28, 0, 0, 0),
	(11661, 29, 0, 0, 0),
	(11661, 30, 0, 0, 0),
	(11661, 31, 0, 0, 0),
	(11661, 32, 0, 0, 0),
	(11661, 33, 0, 0, 0),
	(11661, 34, 0, 0, 0),
	(11661, 35, 0, 0, 0),
	(11661, 36, 0, 0, 0),
	(11661, 37, 0, 0, 0),
	(11661, 38, 0, 0, 0),
	(11661, 39, 0, 0, 0),
	(11661, 40, 0, 0, 0),
	(11661, 41, 0, 0, 0),
	(11661, 42, 0, 0, 0),
	(11661, 43, 0, 0, 0),
	(11661, 44, 0, 0, 0),
	(11661, 45, 0, 0, 0),
	(11661, 46, 0, 0, 0),
	(11661, 47, 0, 0, 0),
	(11661, 48, 0, 0, 0),
	(11661, 49, 0, 0, 0),
	(11661, 50, 0, 0, 0),
	(11661, 51, 0, 0, 0),
	(11661, 52, 0, 0, 0),
	(11661, 53, 0, 0, 0),
	(11661, 54, 0, 0, 0),
	(11661, 55, 0, 0, 0),
	(11661, 56, 0, 0, 0),
	(11661, 57, 0, 0, 0),
	(11661, 58, 0, 0, 0),
	(11661, 59, 0, 0, 0),
	(11661, 60, 0, 0, 0),
	(11691, 1, 0, 0, 0),
	(11691, 2, 0, 0, 0),
	(11691, 3, 0, 0, 0),
	(11691, 4, 0, 0, 0),
	(11691, 5, 0, 0, 0),
	(11691, 6, 0, 0, 0),
	(11691, 7, 0, 0, 0),
	(11691, 8, 0, 0, 0),
	(11691, 9, 0, 0, 0),
	(11691, 10, 0, 0, 0),
	(11691, 11, 0, 0, 0),
	(11691, 12, 0, 0, 0),
	(11691, 13, 0, 0, 0),
	(11691, 14, 0, 0, 0),
	(11691, 15, 0, 0, 0),
	(11691, 16, 0, 0, 0),
	(11691, 17, 0, 0, 0),
	(11691, 18, 0, 0, 0),
	(11691, 19, 0, 0, 0),
	(11691, 20, 0, 0, 0),
	(11691, 21, 0, 0, 0),
	(11691, 22, 0, 0, 0),
	(11691, 23, 0, 0, 0),
	(11691, 24, 0, 0, 0),
	(11691, 25, 0, 0, 0),
	(11691, 26, 0, 0, 0),
	(11691, 27, 0, 0, 0),
	(11691, 28, 0, 0, 0),
	(11691, 29, 0, 0, 0),
	(11691, 30, 0, 0, 0),
	(11691, 31, 0, 0, 0),
	(11691, 32, 0, 0, 0),
	(11691, 33, 0, 0, 0),
	(11691, 34, 0, 0, 0),
	(11691, 35, 0, 0, 0),
	(11691, 36, 0, 0, 0),
	(11691, 37, 0, 0, 0),
	(11691, 38, 0, 0, 0),
	(11691, 39, 0, 0, 0),
	(11691, 40, 0, 0, 0),
	(11691, 41, 0, 0, 0),
	(11691, 42, 0, 0, 0),
	(11691, 43, 0, 0, 0),
	(11691, 44, 0, 0, 0),
	(11691, 45, 0, 0, 0),
	(11691, 46, 0, 0, 0),
	(11691, 47, 0, 0, 0),
	(11691, 48, 0, 0, 0),
	(11691, 49, 0, 0, 0),
	(11691, 50, 0, 0, 0),
	(11691, 51, 0, 0, 0),
	(11691, 52, 0, 0, 0),
	(11691, 53, 0, 0, 0),
	(11691, 54, 0, 0, 0),
	(11691, 55, 0, 0, 0),
	(11691, 56, 0, 0, 0),
	(11691, 57, 0, 0, 0),
	(11691, 58, 0, 0, 0),
	(11691, 59, 0, 0, 0),
	(11691, 60, 0, 0, 0),
	(11734, 1, 0, 0, 0),
	(11734, 2, 0, 0, 0),
	(11734, 3, 0, 0, 0),
	(11734, 4, 0, 0, 0),
	(11734, 5, 0, 0, 0),
	(11734, 6, 0, 0, 0),
	(11734, 7, 0, 0, 0),
	(11734, 8, 0, 0, 0),
	(11734, 9, 0, 0, 0),
	(11734, 10, 0, 0, 0),
	(11734, 11, 0, 0, 0),
	(11734, 12, 0, 0, 0),
	(11734, 13, 0, 0, 0),
	(11734, 14, 0, 0, 0),
	(11734, 15, 0, 0, 0),
	(11734, 16, 0, 0, 0),
	(11734, 17, 0, 0, 0),
	(11734, 18, 0, 0, 0),
	(11734, 19, 0, 0, 0),
	(11734, 20, 0, 0, 0),
	(11734, 21, 0, 0, 0),
	(11734, 22, 0, 0, 0),
	(11734, 23, 0, 0, 0),
	(11734, 24, 0, 0, 0),
	(11734, 25, 0, 0, 0),
	(11734, 26, 0, 0, 0),
	(11734, 27, 0, 0, 0),
	(11734, 28, 0, 0, 0),
	(11734, 29, 0, 0, 0),
	(11734, 30, 0, 0, 0),
	(11734, 31, 0, 0, 0),
	(11734, 32, 0, 0, 0),
	(11734, 33, 0, 0, 0),
	(11734, 34, 0, 0, 0),
	(11734, 35, 0, 0, 0),
	(11734, 36, 0, 0, 0),
	(11734, 37, 0, 0, 0),
	(11734, 38, 0, 0, 0),
	(11734, 39, 0, 0, 0),
	(11734, 40, 0, 0, 0),
	(11734, 41, 0, 0, 0),
	(11734, 42, 0, 0, 0),
	(11734, 43, 0, 0, 0),
	(11734, 44, 0, 0, 0),
	(11734, 45, 0, 0, 0),
	(11734, 46, 0, 0, 0),
	(11734, 47, 0, 0, 0),
	(11734, 48, 0, 0, 0),
	(11734, 49, 0, 0, 0),
	(11734, 50, 0, 0, 0),
	(11734, 51, 0, 0, 0),
	(11734, 52, 0, 0, 0),
	(11734, 53, 0, 0, 0),
	(11734, 54, 0, 0, 0),
	(11734, 55, 0, 0, 0),
	(11734, 56, 0, 0, 0),
	(11734, 57, 0, 0, 0),
	(11734, 58, 0, 0, 0),
	(11734, 59, 0, 0, 0),
	(11734, 60, 0, 0, 0),
	(11766, 1, 0, 0, 0),
	(11766, 2, 0, 0, 0),
	(11766, 3, 0, 0, 0),
	(11766, 4, 0, 0, 0),
	(11766, 5, 0, 0, 0),
	(11766, 6, 0, 0, 0),
	(11766, 7, 0, 0, 0),
	(11766, 8, 0, 0, 0),
	(11766, 9, 0, 0, 0),
	(11766, 10, 0, 0, 0),
	(11766, 11, 0, 0, 0),
	(11766, 12, 0, 0, 0),
	(11766, 13, 0, 0, 0),
	(11766, 14, 0, 0, 0),
	(11766, 15, 0, 0, 0),
	(11766, 16, 0, 0, 0),
	(11766, 17, 0, 0, 0),
	(11766, 18, 0, 0, 0),
	(11766, 19, 0, 0, 0),
	(11766, 20, 0, 0, 0),
	(11766, 21, 0, 0, 0),
	(11766, 22, 0, 0, 0),
	(11766, 23, 0, 0, 0),
	(11766, 24, 0, 0, 0),
	(11766, 25, 0, 0, 0),
	(11766, 26, 0, 0, 0),
	(11766, 27, 0, 0, 0),
	(11766, 28, 0, 0, 0),
	(11766, 29, 0, 0, 0),
	(11766, 30, 0, 0, 0),
	(11766, 31, 0, 0, 0),
	(11766, 32, 0, 0, 0),
	(11766, 33, 0, 0, 0),
	(11766, 34, 0, 0, 0),
	(11766, 35, 0, 0, 0),
	(11766, 36, 0, 0, 0),
	(11766, 37, 0, 0, 0),
	(11766, 38, 0, 0, 0),
	(11766, 39, 0, 0, 0),
	(11766, 40, 0, 0, 0),
	(11766, 41, 0, 0, 0),
	(11766, 42, 0, 0, 0),
	(11766, 43, 0, 0, 0),
	(11766, 44, 0, 0, 0),
	(11766, 45, 0, 0, 0),
	(11766, 46, 0, 0, 0),
	(11766, 47, 0, 0, 0),
	(11766, 48, 0, 0, 0),
	(11766, 49, 0, 0, 0),
	(11766, 50, 0, 0, 0),
	(11766, 51, 0, 0, 0),
	(11766, 52, 0, 0, 0),
	(11766, 53, 0, 0, 0),
	(11766, 54, 0, 0, 0),
	(11766, 55, 0, 0, 0),
	(11766, 56, 0, 0, 0),
	(11766, 57, 0, 0, 0),
	(11766, 58, 0, 0, 0),
	(11766, 59, 0, 0, 0),
	(11766, 60, 0, 0, 0),
	(11820, 1, 0, 0, 0),
	(11820, 2, 0, 0, 0),
	(11820, 3, 0, 0, 0),
	(11820, 4, 0, 0, 0),
	(11820, 5, 0, 0, 0),
	(11820, 6, 0, 0, 0),
	(11820, 7, 0, 0, 0),
	(11820, 8, 0, 0, 0),
	(11820, 9, 0, 0, 0),
	(11820, 10, 0, 0, 0),
	(11820, 11, 0, 0, 0),
	(11820, 12, 0, 0, 0),
	(11820, 13, 0, 0, 0),
	(11820, 14, 0, 0, 0),
	(11820, 15, 0, 0, 0),
	(11820, 16, 0, 0, 0),
	(11820, 17, 0, 0, 0),
	(11820, 18, 0, 0, 0),
	(11820, 19, 0, 0, 0),
	(11820, 20, 0, 0, 0),
	(11820, 21, 0, 0, 0),
	(11820, 22, 0, 0, 0),
	(11820, 23, 0, 0, 0),
	(11820, 24, 0, 0, 0),
	(11820, 25, 0, 0, 0),
	(11820, 26, 0, 0, 0),
	(11820, 27, 0, 0, 0),
	(11820, 28, 0, 0, 0),
	(11820, 29, 0, 0, 0),
	(11820, 30, 0, 0, 0),
	(11820, 31, 0, 0, 0),
	(11820, 32, 0, 0, 0),
	(11820, 33, 0, 0, 0),
	(11820, 34, 0, 0, 0),
	(11820, 35, 0, 0, 0),
	(11820, 36, 0, 0, 0),
	(11820, 37, 0, 0, 0),
	(11820, 38, 0, 0, 0),
	(11820, 39, 0, 0, 0),
	(11820, 40, 0, 0, 0),
	(11820, 41, 0, 0, 0),
	(11820, 42, 0, 0, 0),
	(11820, 43, 0, 0, 0),
	(11820, 44, 0, 0, 0),
	(11820, 45, 0, 0, 0),
	(11820, 46, 0, 0, 0),
	(11820, 47, 0, 0, 0),
	(11820, 48, 0, 0, 0),
	(11820, 49, 0, 0, 0),
	(11820, 50, 0, 0, 0),
	(11820, 51, 0, 0, 0),
	(11820, 52, 0, 0, 0),
	(11820, 53, 0, 0, 0),
	(11820, 54, 0, 0, 0),
	(11820, 55, 0, 0, 0),
	(11820, 56, 0, 0, 0),
	(11820, 57, 0, 0, 0),
	(11820, 58, 0, 0, 0),
	(11820, 59, 0, 0, 0),
	(11820, 60, 0, 0, 0),
	(11838, 1, 0, 0, 0),
	(11838, 2, 0, 0, 0),
	(11838, 3, 0, 0, 0),
	(11838, 4, 0, 0, 0),
	(11838, 5, 0, 0, 0),
	(11838, 6, 0, 0, 0),
	(11838, 7, 0, 0, 0),
	(11838, 8, 0, 0, 0),
	(11838, 9, 0, 0, 0),
	(11838, 10, 0, 0, 0),
	(11838, 11, 0, 0, 0),
	(11838, 12, 0, 0, 0),
	(11838, 13, 0, 0, 0),
	(11838, 14, 0, 0, 0),
	(11838, 15, 0, 0, 0),
	(11838, 16, 0, 0, 0),
	(11838, 17, 0, 0, 0),
	(11838, 18, 0, 0, 0),
	(11838, 19, 0, 0, 0),
	(11838, 20, 0, 0, 0),
	(11838, 21, 0, 0, 0),
	(11838, 22, 0, 0, 0),
	(11838, 23, 0, 0, 0),
	(11838, 24, 0, 0, 0),
	(11838, 25, 0, 0, 0),
	(11838, 26, 0, 0, 0),
	(11838, 27, 0, 0, 0),
	(11838, 28, 0, 0, 0),
	(11838, 29, 0, 0, 0),
	(11838, 30, 0, 0, 0),
	(11838, 31, 0, 0, 0),
	(11838, 32, 0, 0, 0),
	(11838, 33, 0, 0, 0),
	(11838, 34, 0, 0, 0),
	(11838, 35, 0, 0, 0),
	(11838, 36, 0, 0, 0),
	(11838, 37, 0, 0, 0),
	(11838, 38, 0, 0, 0),
	(11838, 39, 0, 0, 0),
	(11838, 40, 0, 0, 0),
	(11838, 41, 0, 0, 0),
	(11838, 42, 0, 0, 0),
	(11838, 43, 0, 0, 0),
	(11838, 44, 0, 0, 0),
	(11838, 45, 0, 0, 0),
	(11838, 46, 0, 0, 0),
	(11838, 47, 0, 0, 0),
	(11838, 48, 0, 0, 0),
	(11838, 49, 0, 0, 0),
	(11838, 50, 0, 0, 0),
	(11838, 51, 0, 0, 0),
	(11838, 52, 0, 0, 0),
	(11838, 53, 0, 0, 0),
	(11838, 54, 0, 0, 0),
	(11838, 55, 0, 0, 0),
	(11838, 56, 0, 0, 0),
	(11838, 57, 0, 0, 0),
	(11838, 58, 0, 0, 0),
	(11838, 59, 0, 0, 0),
	(11838, 60, 0, 0, 0),
	(11907, 1, 0, 0, 0),
	(11907, 2, 0, 0, 0),
	(11907, 3, 0, 0, 0),
	(11907, 4, 0, 0, 0),
	(11907, 5, 0, 0, 0),
	(11907, 6, 0, 0, 0),
	(11907, 7, 0, 0, 0),
	(11907, 8, 0, 0, 0),
	(11907, 9, 0, 0, 0),
	(11907, 10, 0, 0, 0),
	(11907, 11, 0, 0, 0),
	(11907, 12, 0, 0, 0),
	(11907, 13, 0, 0, 0),
	(11907, 14, 0, 0, 0),
	(11907, 15, 0, 0, 0),
	(11907, 16, 0, 0, 0),
	(11907, 17, 0, 0, 0),
	(11907, 18, 0, 0, 0),
	(11907, 19, 0, 0, 0),
	(11907, 20, 0, 0, 0),
	(11907, 21, 0, 0, 0),
	(11907, 22, 0, 0, 0),
	(11907, 23, 0, 0, 0),
	(11907, 24, 0, 0, 0),
	(11907, 25, 0, 0, 0),
	(11907, 26, 0, 0, 0),
	(11907, 27, 0, 0, 0),
	(11907, 28, 0, 0, 0),
	(11907, 29, 0, 0, 0),
	(11907, 30, 0, 0, 0),
	(11907, 31, 0, 0, 0),
	(11907, 32, 0, 0, 0),
	(11907, 33, 0, 0, 0),
	(11907, 34, 0, 0, 0),
	(11907, 35, 0, 0, 0),
	(11907, 36, 0, 0, 0),
	(11907, 37, 0, 0, 0),
	(11907, 38, 0, 0, 0),
	(11907, 39, 0, 0, 0),
	(11907, 40, 0, 0, 0),
	(11907, 41, 0, 0, 0),
	(11907, 42, 0, 0, 0),
	(11907, 43, 0, 0, 0),
	(11907, 44, 0, 0, 0),
	(11907, 45, 0, 0, 0),
	(11907, 46, 0, 0, 0),
	(11907, 47, 0, 0, 0),
	(11907, 48, 0, 0, 0),
	(11907, 49, 0, 0, 0),
	(11907, 50, 0, 0, 0),
	(11907, 51, 0, 0, 0),
	(11907, 52, 0, 0, 0),
	(11907, 53, 0, 0, 0),
	(11907, 54, 0, 0, 0),
	(11907, 55, 0, 0, 0),
	(11907, 56, 0, 0, 0),
	(11907, 57, 0, 0, 0),
	(11907, 58, 0, 0, 0),
	(11907, 59, 0, 0, 0),
	(11907, 60, 0, 0, 0),
	(11914, 1, 0, 0, 0),
	(11914, 2, 0, 0, 0),
	(11914, 3, 0, 0, 0),
	(11914, 4, 0, 0, 0),
	(11914, 5, 0, 0, 0),
	(11914, 6, 0, 0, 0),
	(11914, 7, 0, 0, 0),
	(11914, 8, 0, 0, 0),
	(11914, 9, 0, 0, 0),
	(11914, 10, 0, 0, 0),
	(11914, 11, 0, 0, 0),
	(11914, 12, 0, 0, 0),
	(11914, 13, 0, 0, 0),
	(11914, 14, 0, 0, 0),
	(11914, 15, 0, 0, 0),
	(11914, 16, 0, 0, 0),
	(11914, 17, 0, 0, 0),
	(11914, 18, 0, 0, 0),
	(11914, 19, 0, 0, 0),
	(11914, 20, 0, 0, 0),
	(11914, 21, 0, 0, 0),
	(11914, 22, 0, 0, 0),
	(11914, 23, 0, 0, 0),
	(11914, 24, 0, 0, 0),
	(11914, 25, 0, 0, 0),
	(11914, 26, 0, 0, 0),
	(11914, 27, 0, 0, 0),
	(11914, 28, 0, 0, 0),
	(11914, 29, 0, 0, 0),
	(11914, 30, 0, 0, 0),
	(11914, 31, 0, 0, 0),
	(11914, 32, 0, 0, 0),
	(11914, 33, 0, 0, 0),
	(11914, 34, 0, 0, 0),
	(11914, 35, 0, 0, 0),
	(11914, 36, 0, 0, 0),
	(11914, 37, 0, 0, 0),
	(11914, 38, 0, 0, 0),
	(11914, 39, 0, 0, 0),
	(11914, 40, 0, 0, 0),
	(11914, 41, 0, 0, 0),
	(11914, 42, 0, 0, 0),
	(11914, 43, 0, 0, 0),
	(11914, 44, 0, 0, 0),
	(11914, 45, 0, 0, 0),
	(11914, 46, 0, 0, 0),
	(11914, 47, 0, 0, 0),
	(11914, 48, 0, 0, 0),
	(11914, 49, 0, 0, 0),
	(11914, 50, 0, 0, 0),
	(11914, 51, 0, 0, 0),
	(11914, 52, 0, 0, 0),
	(11914, 53, 0, 0, 0),
	(11914, 54, 0, 0, 0),
	(11914, 55, 0, 0, 0),
	(11914, 56, 0, 0, 0),
	(11914, 57, 0, 0, 0),
	(11914, 58, 0, 0, 0),
	(11914, 59, 0, 0, 0),
	(11914, 60, 0, 0, 0),
	(12018, 1, 0, 0, 0),
	(12018, 2, 0, 0, 0),
	(12018, 3, 0, 0, 0),
	(12018, 4, 0, 0, 0),
	(12018, 5, 0, 0, 0),
	(12018, 6, 0, 0, 0),
	(12018, 7, 0, 0, 0),
	(12018, 8, 0, 0, 0),
	(12018, 9, 0, 0, 0),
	(12018, 10, 0, 0, 0),
	(12018, 11, 0, 0, 0),
	(12018, 12, 0, 0, 0),
	(12018, 13, 0, 0, 0),
	(12018, 14, 0, 0, 0),
	(12018, 15, 0, 0, 0),
	(12018, 16, 0, 0, 0),
	(12018, 17, 0, 0, 0),
	(12018, 18, 0, 0, 0),
	(12018, 19, 0, 0, 0),
	(12018, 20, 0, 0, 0),
	(12018, 21, 0, 0, 0),
	(12018, 22, 0, 0, 0),
	(12018, 23, 0, 0, 0),
	(12018, 24, 0, 0, 0),
	(12018, 25, 0, 0, 0),
	(12018, 26, 0, 0, 0),
	(12018, 27, 0, 0, 0),
	(12018, 28, 0, 0, 0),
	(12018, 29, 0, 0, 0),
	(12018, 30, 0, 0, 0),
	(12018, 31, 0, 0, 0),
	(12018, 32, 0, 0, 0),
	(12018, 33, 0, 0, 0),
	(12018, 34, 0, 0, 0),
	(12018, 35, 0, 0, 0),
	(12018, 36, 0, 0, 0),
	(12018, 37, 0, 0, 0),
	(12018, 38, 0, 0, 0),
	(12018, 39, 0, 0, 0),
	(12018, 40, 0, 0, 0),
	(12018, 41, 0, 0, 0),
	(12018, 42, 0, 0, 0),
	(12018, 43, 0, 0, 0),
	(12018, 44, 0, 0, 0),
	(12018, 45, 0, 0, 0),
	(12018, 46, 0, 0, 0),
	(12018, 47, 0, 0, 0),
	(12018, 48, 0, 0, 0),
	(12018, 49, 0, 0, 0),
	(12018, 50, 0, 0, 0),
	(12018, 51, 0, 0, 0),
	(12018, 52, 0, 0, 0),
	(12018, 53, 0, 0, 0),
	(12018, 54, 0, 0, 0),
	(12018, 55, 0, 0, 0),
	(12018, 56, 0, 0, 0),
	(12018, 57, 0, 0, 0),
	(12018, 58, 0, 0, 0),
	(12018, 59, 0, 0, 0),
	(12018, 60, 0, 0, 0),
	(12274, 1, 0, 0, 0),
	(12274, 2, 0, 0, 0),
	(12274, 3, 0, 0, 0),
	(12274, 4, 0, 0, 0),
	(12274, 5, 0, 0, 0),
	(12274, 6, 0, 0, 0),
	(12274, 7, 0, 0, 0),
	(12274, 8, 0, 0, 0),
	(12274, 9, 0, 0, 0),
	(12274, 10, 0, 0, 0),
	(12274, 11, 0, 0, 0),
	(12274, 12, 0, 0, 0),
	(12274, 13, 0, 0, 0),
	(12274, 14, 0, 0, 0),
	(12274, 15, 0, 0, 0),
	(12274, 16, 0, 0, 0),
	(12274, 17, 0, 0, 0),
	(12274, 18, 0, 0, 0),
	(12274, 19, 0, 0, 0),
	(12274, 20, 0, 0, 0),
	(12274, 21, 0, 0, 0),
	(12274, 22, 0, 0, 0),
	(12274, 23, 0, 0, 0),
	(12274, 24, 0, 0, 0),
	(12274, 25, 0, 0, 0),
	(12274, 26, 0, 0, 0),
	(12274, 27, 0, 0, 0),
	(12274, 28, 0, 0, 0),
	(12274, 29, 0, 0, 0),
	(12274, 30, 0, 0, 0),
	(12274, 31, 0, 0, 0),
	(12274, 32, 0, 0, 0),
	(12274, 33, 0, 0, 0),
	(12274, 34, 0, 0, 0),
	(12274, 35, 0, 0, 0),
	(12274, 36, 0, 0, 0),
	(12274, 37, 0, 0, 0),
	(12274, 38, 0, 0, 0),
	(12274, 39, 0, 0, 0),
	(12274, 40, 0, 0, 0),
	(12274, 41, 0, 0, 0),
	(12274, 42, 0, 0, 0),
	(12274, 43, 0, 0, 0),
	(12274, 44, 0, 0, 0),
	(12274, 45, 0, 0, 0),
	(12274, 46, 0, 0, 0),
	(12274, 47, 0, 0, 0),
	(12274, 48, 0, 0, 0),
	(12274, 49, 0, 0, 0),
	(12274, 50, 0, 0, 0),
	(12274, 51, 0, 0, 0),
	(12274, 52, 0, 0, 0),
	(12274, 53, 0, 0, 0),
	(12274, 54, 0, 0, 0),
	(12274, 55, 0, 0, 0),
	(12274, 56, 0, 0, 0),
	(12274, 57, 0, 0, 0),
	(12274, 58, 0, 0, 0),
	(12274, 59, 0, 0, 0),
	(12274, 60, 0, 0, 0),
	(14474, 1, 0, 0, 0),
	(14474, 2, 0, 0, 0),
	(14474, 3, 0, 0, 0),
	(14474, 4, 0, 0, 0),
	(14474, 5, 0, 0, 0),
	(14474, 6, 0, 0, 0),
	(14474, 7, 0, 0, 0),
	(14474, 8, 0, 0, 0),
	(14474, 9, 0, 0, 0),
	(14474, 10, 0, 0, 0),
	(14474, 11, 0, 0, 0),
	(14474, 12, 0, 0, 0),
	(14474, 13, 0, 0, 0),
	(14474, 14, 0, 0, 0),
	(14474, 15, 0, 0, 0),
	(14474, 16, 0, 0, 0),
	(14474, 17, 0, 0, 0),
	(14474, 18, 0, 0, 0),
	(14474, 19, 0, 0, 0),
	(14474, 20, 0, 0, 0),
	(14474, 21, 0, 0, 0),
	(14474, 22, 0, 0, 0),
	(14474, 23, 0, 0, 0),
	(14474, 24, 0, 0, 0),
	(14474, 25, 0, 0, 0),
	(14474, 26, 0, 0, 0),
	(14474, 27, 0, 0, 0),
	(14474, 28, 0, 0, 0),
	(14474, 29, 0, 0, 0),
	(14474, 30, 0, 0, 0),
	(14474, 31, 0, 0, 0),
	(14474, 32, 0, 0, 0),
	(14474, 33, 0, 0, 0),
	(14474, 34, 0, 0, 0),
	(14474, 35, 0, 0, 0),
	(14474, 36, 0, 0, 0),
	(14474, 37, 0, 0, 0),
	(14474, 38, 0, 0, 0),
	(14474, 39, 0, 0, 0),
	(14474, 40, 0, 0, 0),
	(14474, 41, 0, 0, 0),
	(14474, 42, 0, 0, 0),
	(14474, 43, 0, 0, 0),
	(14474, 44, 0, 0, 0),
	(14474, 45, 0, 0, 0),
	(14474, 46, 0, 0, 0),
	(14474, 47, 0, 0, 0),
	(14474, 48, 0, 0, 0),
	(14474, 49, 0, 0, 0),
	(14474, 50, 0, 0, 0),
	(14474, 51, 0, 0, 0),
	(14474, 52, 0, 0, 0),
	(14474, 53, 0, 0, 0),
	(14474, 54, 0, 0, 0),
	(14474, 55, 0, 0, 0),
	(14474, 56, 0, 0, 0),
	(14474, 57, 0, 0, 0),
	(14474, 58, 0, 0, 0),
	(14474, 59, 0, 0, 0),
	(14474, 60, 0, 0, 0);
/*!40000 ALTER TABLE `catalog_items_limited` ENABLE KEYS */;

-- Dumping structure for table test.catalog_pages
DROP TABLE IF EXISTS `catalog_pages`;
CREATE TABLE IF NOT EXISTS `catalog_pages` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `parent_id` int(11) NOT NULL DEFAULT 50000 COMMENT 'Page ID 50000 is under 7 (Staff)',
  `caption_save` varchar(25) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `caption` varchar(128) COLLATE utf8mb4_unicode_ci NOT NULL,
  `page_layout` enum('default_3x3','club_buy','club_gift','frontpage','spaces','recycler','recycler_info','recycler_prizes','trophies','plasto','marketplace','marketplace_own_items','spaces_new','soundmachine','guilds','guild_furni','info_duckets','info_rentables','info_pets','roomads','single_bundle','sold_ltd_items','badge_display','bots','pets','pets2','pets3','productpage1','room_bundle','recent_purchases','default_3x3_color_grouping','guild_forum','vip_buy','info_loyalty','loyalty_vip_buy','collectibles','petcustomization','frontpage_featured','builders_club_addons','builders_club_frontpage','builders_club_loyalty','mad_money','monkey','niko') COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT 'default_3x3',
  `icon_color` int(5) NOT NULL DEFAULT 1,
  `icon_image` int(5) NOT NULL DEFAULT 1,
  `min_rank` int(5) NOT NULL DEFAULT 1,
  `order_num` int(5) NOT NULL DEFAULT 1,
  `visible` enum('0','1') COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '1',
  `enabled` enum('0','1') COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '1',
  `club_only` enum('0','1') COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '0',
  `vip_only` enum('1','0') COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '0',
  `page_headline` varchar(1024) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `page_teaser` varchar(64) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `page_special` varchar(2048) COLLATE utf8mb4_unicode_ci DEFAULT '' COMMENT 'Gold Bubble: catalog_special_txtbg1 // Speech Bubble: catalog_special_txtbg2 // Place normal text in page_text_teaser',
  `page_text1` mediumtext COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `page_text2` mediumtext COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `page_text_details` mediumtext COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `page_text_teaser` mediumtext COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `room_id` int(5) DEFAULT 0,
  `includes` varchar(128) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '' COMMENT 'Example usage: 1;2;3\r\n This will include page 1, 2 and 3 in the current page.\r\n Note that permissions are only used for the current entry.',
  PRIMARY KEY (`id`) USING BTREE,
  KEY `id` (`id`) USING BTREE
) ENGINE=MyISAM AUTO_INCREMENT=500005 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci ROW_FORMAT=DYNAMIC;

-- Dumping data for table test.catalog_pages: 791 rows
/*!40000 ALTER TABLE `catalog_pages` DISABLE KEYS */;
REPLACE INTO `catalog_pages` (`id`, `parent_id`, `caption_save`, `caption`, `page_layout`, `icon_color`, `icon_image`, `min_rank`, `order_num`, `visible`, `enabled`, `club_only`, `vip_only`, `page_headline`, `page_teaser`, `page_special`, `page_text1`, `page_text2`, `page_text_details`, `page_text_teaser`, `room_id`, `includes`) VALUES
	(1, -1, 'front_page', 'Front Page', 'frontpage', 1, 213, 1, 1, '1', '1', '0', '0', 'catalog_frontpage_headline_shop_EN', '', '', NULL, 'Redeem your voucher code here:', NULL, NULL, 0, ''),
	(373, 372, 'christmas', 'Christmas', 'default_3x3', 1, 89, 1, 1, '1', '0', '0', '0', 'catalog_header_xmas2013', 'catalog_xmas_teaser', '', NULL, NULL, NULL, NULL, 0, ''),
	(375, 372, 'halloween', 'Halloween', 'default_3x3', 1, 34, 1, 3, '1', '0', '0', '0', 'catalog_header_hw15', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(376, 372, 'valentines_day', 'Valentine\'s Day', 'default_3x3', 1, 144, 1, 6, '1', '0', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(951, -1, 'premium', 'Premium', 'default_3x3', 1, 172, 1, 5, '1', '1', '0', '0', 'catalog_club_headline1_en', 'club', '', NULL, NULL, NULL, NULL, 0, ''),
	(9, 2, 'bots', 'Bots', 'bots', 1, 65, 1, 13, '1', '1', '0', '0', 'catalog_bots_headline1_en', 'catalog_bots_headline1_en', '', 'They walk, they talk, and they make the perfect addition to any room!', NULL, NULL, NULL, 0, ''),
	(10, 220, 'my_sales', 'My Sales', 'marketplace_own_items', 1, 70, 1, 1, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(11, 220, 'offers', 'Offers', 'marketplace', 1, 71, 1, 2, '1', '1', '0', '0', '', '', 'marketplace_offers', NULL, NULL, NULL, NULL, 0, ''),
	(12, 2, 'credit_furni', 'Credit Furni', 'default_3x3', 1, 146, 1, 0, '1', '1', '0', '0', 'catalog_bank_headline1', 'catalog_bank_teaser', '', 'Habbo Exchange is where you can convert your Credits into a tradable currency. You can then use this currency to trade for Furni or just show off your riches in your room.', NULL, NULL, NULL, 0, ''),
	(2, -1, 'furni', 'Furni', 'default_3x3', 1, 263, 1, 2, '1', '1', '0', '0', 'catalog_header_roombuilder', 'cr_infopic3', '', NULL, 'Furni Shop', NULL, NULL, 0, ''),
	(13, 604, 'spaces', 'Spaces', 'spaces_new', 1, 225, 1, 11, '1', '1', '0', '0', 'look_feel_text', '', '', 'Floors, wallpapers, landscapes - get a groovy combination for your room. Use our virtual room preview below to test out the combinations before you buy. Select the design and colour you like and click buy.', NULL, NULL, NULL, 0, ''),
	(14, 2, 'limited_rares', 'Limited Rares', 'default_3x3', 1, 145, 1, 4, '1', '1', '0', '0', 'limited_header', 'catalog_limited_teaser_en', '', 'These are only available for a limited time!', NULL, NULL, NULL, 0, ''),
	(372, 2, 'seasonal_furni_lines', 'By Season', 'default_3x3', 1, 89, 1, 11, '1', '0', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(306, 604, 'windows', 'Windows', 'default_3x3', 1, 218, 1, 14, '1', '1', '0', '0', 'ctlg_windows_headline1_en', 'ctlg_windows_teaser1_en', '', 'Let some sunshine in! Our windows come in many styles to give a unique look to your room. Who said your room can\'t have a view?', NULL, NULL, NULL, 0, ''),
	(16, 604, 'lighting', 'Lighting', 'default_3x3', 1, 115, 1, 6, '1', '1', '0', '0', 'catalog_dimmers_header1_en', 'catalog_dimmer_teaser_en', '', 'Check out the Mood Lights. Use these items to dim the light in your rooms. Try out different light settings with different wallpapers to see what you get. Talk about lighting with style!', NULL, NULL, 'Click on an item for details.', 0, ''),
	(503, 209, 'jet_set', 'Jet Set', 'default_3x3', 1, 237, 1, 112, '1', '1', '0', '0', 'jetset_header', 'jetset_yachtcomp', '', 'Live life to the fullest with our Jetset furni range. This is the Furni for those Habbos who like to throw obscenely huge parties and show off their style.', NULL, NULL, NULL, 0, ''),
	(17, 209, 'mode', 'Mode', 'default_3x3', 1, 39, 1, 130, '1', '1', '0', '0', 'catalog_mode_headline1', 'catalog_mode_teaser1', '', 'Steely functionality combined with a sleek designer upholstery. The Habbo who chooses this furniture is a cool urban cat - streetwise, sassy and so slightly untouchable.', NULL, NULL, NULL, 0, ''),
	(6, 209, 'furnimatic', 'Furnimatic', 'default_3x3', 1, 7, 1, 73, '1', '1', '0', '0', 'catalog_header_furnimatic', 'furnimatic_teaser', ' ', NULL, NULL, NULL, NULL, 0, ''),
	(281, 209, 'area', 'Area', 'default_3x3', 1, 14, 1, 16, '1', '1', '0', '0', 'area', 'catalog_area_teaser1', '', 'A chunky and sofisticated line for the down-to-earth, It\'s simplicty is beautful and will add a welcoming charm to every room.', NULL, NULL, NULL, 0, ''),
	(282, 209, 'country', 'Country', 'default_3x3', 1, 21, 1, 52, '1', '1', '0', '0', 'country_header1_en_001', 'country_teaser', '', '"Moving to the country, gonna eat a lot of peaches"... The great outdoors is calling with the Country Furni range!', NULL, NULL, NULL, 0, ''),
	(277, 4, 'pet_animals', 'Pet Animals', 'pets3', 1, 8, 1, 1, '1', '1', '0', '0', 'catalog_pet_headline1_en', 'ctlg_pet_note', '', 'Pets are inhabitants of Habbo Hotel so each pet owner needs to know a bit about them. If you want to look after your pet properly, make sure you read the following points carefully.', 'A few things you should know:', '*You can place a pet in your room or take one for a walk with you in other rooms.\n*You can\'t trade your pet but they can follow you to friend\'s rooms to gather scratches.\n*You can have up to 50 pets in your room, but look after them all!\n\n\n*Look after your pet with food, water and treats. Check the Pets\' Accessories.\n*Unlock Badges and Achievements by Training your Pet.', 'Click your Pet and hit the "Train" button to get a list of commands that will level up your Pet in no time!', 0, ''),
	(18, 209, 'lodge', 'Lodge', 'default_3x3', 1, 37, 1, 120, '1', '1', '0', '0', 'catalog_lodge_headline1', 'catalog_lodge_teaser1', '', 'For that splendid ski-lodge effect with an open fire and whisky on the sidebar. This range is for those who appreicate the true beauty of solid wood.', NULL, NULL, NULL, 0, ''),
	(182, 209, 'bathroom', 'Bathroom', 'default_3x3', 1, 17, 1, 30, '1', '1', '0', '0', 'bathroom_catahead', 'bcbath_catateaser', '', 'Give yourself and your guests somewhere to freshen up - vital if you want to avoid nasty smells. Might be an idea to put your loo in a corner though.', NULL, NULL, NULL, 0, ''),
	(20, 604, 'vegetation', 'Plants', 'default_3x3', 1, 220, 1, 7, '1', '1', '0', '0', 'catalog_plants_headline1', 'catalog_plants_teaser1', '', 'Every room needs a plant! Not only do they bring a bit of the outside inside, they also enhance the air quality! And what better gift for a friend than a beautiful rose or elegant fruit tree...', NULL, NULL, NULL, 0, ''),
	(559, 604, 'carpets', 'Rugs', 'default_3x3', 1, 116, 1, 10, '1', '1', '0', '0', 'catalog_rugs_headline1', 'catalog_rugs_teaser1', '', 'Rugs for all occasions, all non-slip and washable.', NULL, NULL, NULL, 0, ''),
	(21, 604, 'walls', 'Gallery', 'default_3x3', 1, 219, 1, 5, '1', '1', '0', '0', 'catalog_gallery_headline1', 'catalog_posters_teaser1', '', 'Bring the outdoors in with windows and posters. Transform your surroundings - your walls will never look bare again!', NULL, NULL, NULL, 0, ''),
	(22, 209, 'accessories', 'Accessories', 'default_3x3', 1, 11, 1, 0, '1', '1', '0', '0', 'catalog_extra_headline1', 'catalog_extra_teaser1', '', 'However you place your essential Furniture, it\'s the finishing touches that count!', NULL, NULL, NULL, 0, ''),
	(24, 209, 'base', 'Base', 'default_3x3', 1, 179, 1, 26, '1', '1', '0', '0', 'catalog_header_base', 'base_rentable_teaser', '', 'This colourful range of furni has everything you need to style out your room and build great spaces.', NULL, NULL, NULL, 0, ''),
	(299, 376, '2014_health_spa', '\'14 - Health Spa', 'default_3x3', 1, 211, 1, 14, '1', '1', '0', '0', 'valentines2014_header', 'valentines2014_teaser2', '', 'Sometimes, all you want is a nice relaxing spa day. With this furni line, you can enjoy one with your Valentine!', NULL, NULL, NULL, 0, ''),
	(25, 604, 'badge_display', 'Badge Display', 'badge_display', 1, 224, 1, 2, '1', '1', '0', '0', 'catalog_header_badgedisplay', 'badgedisplay_promo2', '', 'You worked hard to get your badges, right? Now\'s the time to show it off, grab a display case and choose your favorite badge to show off!', NULL, NULL, NULL, 0, ''),
	(26, 2, 'room_event', 'Room Event', 'roomads', 1, 225, 1, 3, '1', '1', '0', '0', 'events_header', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(27, 209, 'iced', 'Iced', 'default_3x3', 1, 72, 1, 106, '1', '1', '0', '0', 'catalog_iced_headline1', 'catalog_iced_teaser1', '', 'It\'s so chic, it says everything and nothing. It\'s a blank canvas, let your imagination run wild!', NULL, NULL, NULL, 0, ''),
	(28, 209, 'alhambra', 'Alhambra', 'default_3x3', 1, 12, 1, 4, '1', '1', '0', '0', 'alhambra_header', 'alhambra_teaser1', '', 'For the cold Arabian nights and hot Arabian days, you\'ll need a palace.. And we have just what you need! Green blossom print should cover it just fine!', NULL, NULL, NULL, 0, ''),
	(302, 209, 'asian', 'Asian', 'default_3x3', 1, 15, 1, 22, '1', '1', '0', '0', 'catalog_asian_headline1', 'catalog_asian_teaser1', '', 'Ting tong! Ching chong? Ting chong ting, ping ping! I mean uh.. with our authentic Chinese furniture, you can make a beautiful oriental room!', NULL, NULL, NULL, 0, ''),
	(303, 209, 'bensalem', 'Bensalem', 'default_3x3', 1, 18, 1, 34, '1', '1', '0', '0', 'catalog_lc_headline2_en', 'catalog_lc_teaser1_en_001', '', 'Glub... glub... glub...', NULL, NULL, NULL, 0, ''),
	(29, 209, 'glass', 'Glass', 'default_3x3', 1, 29, 1, 76, '1', '1', '0', '0', 'catalog_glass_headline1', 'catalog_glass_teaser1', '', 'You can really open up a space with this stylish glass furniture, just don\'t walk into it!', NULL, NULL, NULL, 0, ''),
	(30, 209, 'gothic', 'Gothic', 'default_3x3', 1, 30, 1, 78, '1', '1', '0', '0', 'catalog_gothic_headline1', 'catalog_gothic_teaser1', '', 'As the church bells ring out midnight, you walk through your cobbled hall lit by candles, throw yourself into your medieval throne and paint your nails black. This is what we imagined when we ordered this range!', NULL, NULL, NULL, 0, ''),
	(31, 209, 'japan', 'Japan', 'default_3x3', 1, 36, 1, 110, '1', '1', '0', '0', 'catalog_jap_headline1', 'catalog_jap_teaser3_en', '', 'We have sushi, tatami and katana\'s! I have no idea what the difference is, but I sure know its Japanese! Fulfil your fantasies and buy some today!', NULL, NULL, NULL, 0, ''),
	(32, 209, 'lost_tribe', 'Lost Tribe', 'default_3x3', 1, 38, 1, 124, '1', '1', '0', '0', 'losttribe', 'LT_teaser_br', '', 'Start your own tribal village with our ancient furniture, all carved from hard wearing stone. NOTE: Lava is hot, get an adult to help you.', NULL, NULL, NULL, 0, ''),
	(33, 209, 'neon', 'Neon', 'default_3x3', 1, 41, 1, 140, '1', '1', '0', '0', 'catalog_neon_header1_en', 'catalog_neon_teaser1_en', '', 'Party animals rejoice! Feel the base and reach for the lasers with the Neon Furni range - everything you need to get the party started!', NULL, NULL, NULL, 0, ''),
	(34, 209, 'relax', 'Relax', 'default_3x3', 1, 49, 1, 164, '1', '1', '0', '0', 'relax_header', 'rela_teaser_en', '', 'Relax after a busy day in the Welcome Lounge. Light a few candles, and chill out with a good read in a wicker chair. We understand the needs of a Wulles with a hectic lifestyle!', NULL, NULL, NULL, 0, ''),
	(35, 209, 'romantique', 'Romantique', 'default_3x3', 1, 50, 1, 166, '1', '1', '0', '0', 'catalog_romantique_headline1', 'catalog_rom_teaser_en', '', 'Found in a French barn, this sweet but sexily romantic range caters to every ladies needs. Just going to powder my nose!', NULL, NULL, NULL, 0, ''),
	(36, 209, 'scifi', 'Sci-Fi', 'default_3x3', 1, 53, 1, 174, '1', '1', '0', '0', 'sf_header_en', 'sf_teaser_en', '', 'Sci Fi convention, outer space, the Moon, we have everything you need to make your own mystical, un-earthly room right here!', NULL, NULL, NULL, 0, ''),
	(37, 209, '2009_shalimar', 'Shalimar', 'default_3x3', 1, 54, 1, 176, '1', '1', '0', '0', 'catalog_shal_header1_en', 'catalog_shal_teaser_en', '', 'Based on Bollywood!', NULL, NULL, NULL, 0, ''),
	(38, 219, 'freeze!', 'Freeze!', 'default_3x3', 1, 87, 1, 5, '1', '1', '0', '0', 'catalog_freeze_en', 'ctlg_teaser_es', '', 'Freeze!... and try the newest game to hit Wulles! Team up and plant snowball bombs to snap freeze your competitors. You could say it\'s so cool, it\'s frozen ;)', NULL, NULL, NULL, 0, ''),
	(39, 345, 'pixel_collectibles', 'Pixel Collectables', 'default_3x3', 1, 5, 1, 5, '1', '1', '0', '0', 'tienda-pixel', 'pixel3', '', NULL, NULL, NULL, NULL, 0, ''),
	(40, 7, 'ads_room_backgrounds', 'Ads Room Backgrounds', 'default_3x3', 1, 47, 6, 0, '1', '1', '0', '0', '', '', '', 'Use these to place images in your room. The mpu\'s go to a link when clicked; the AD one does not.', NULL, NULL, NULL, 0, ''),
	(41, 387, 'theatredome', 'Theatredome', 'default_3x3', 1, 264, 1, 25, '1', '1', '0', '0', 'catalog_header_classics', 'article_habboreport2', '', 'The Theatredrome is a very old and popular Public Room. It\'s hosted many campaigns from paying sponsors.', NULL, NULL, NULL, 0, ''),
	(42, 604, 'rollers', 'Rollers', 'default_3x3', 1, 222, 1, 9, '1', '1', '0', '0', 'catalog_roller_headline1', 'catalog_teaser_rollers_en', '', 'Move your imagination. This cool stuff is more than suitable for business and pleasure... Habbo rollers for games and queues. Now available in multipacks.', NULL, NULL, NULL, 0, ''),
	(43, 209, 'diner', 'Diner', 'default_3x3', 1, 204, 1, 64, '1', '1', '0', '0', 'diner', 'catalog_diner_teaser_ens', '', 'Originally from the 50\'s this furni has been refurbished and put right into the catalogue! Use this with the Kitchen range for ultimate diner experience!', NULL, NULL, NULL, 0, ''),
	(44, 209, 'twilight', 'Twilight', 'default_3x3', 1, 62, 1, 204, '1', '1', '0', '0', 'catalog_twilight_header_en', 'Fountain', '', 'I\'ve never read the book, all I know is it has vampires playing basket ball and some heart throb called Edward Cullen, but the furni looks good!', NULL, NULL, NULL, 0, ''),
	(45, 219, 'battle_banzai', 'Battle Banzai', 'default_3x3', 1, 78, 1, 3, '1', '1', '0', '0', 'catalog_battleBanzai_header_en', 'banzai_teaser2', '', 'Bigger, Better, Bouncier - it\'s Battle Banzai! Now YOU set the rules for your own game, in your own room. You got the Banzai Power!', NULL, NULL, NULL, 0, ''),
	(272, 209, 'urban', 'Urban', 'default_3x3', 1, 32, 1, 206, '1', '1', '0', '0', 'urban_header_en', 'urban_teaser_en', '', 'New York City styled furni range, Urban is perfect for any street, alleyway or road. Rubbish bins, street lights and benches, all the Urban furniture you need!', NULL, NULL, NULL, 0, ''),
	(48, 526, 'automobile', 'Automobile', 'default_3x3', 1, 16, 1, 1, '1', '1', '0', '0', 'automobile_header', 'automobile_teaser', '', NULL, NULL, NULL, NULL, 0, ''),
	(348, 557, 'v11_rares', 'V11 Rares', 'default_3x3', 1, 42, 6, 10, '1', '0', '0', '0', '', ' ', '', NULL, NULL, NULL, NULL, 0, ''),
	(595, 209, 'chess', 'Chess', 'default_3x3', 1, 1009, 1, 46, '1', '1', '0', '0', 'chessheader', 'spromo_Chess_Bundle', '', 'Create your own game of chess with these exclusive furni!', NULL, NULL, NULL, 0, ''),
	(49, 209, 'goodbye_big_hand', 'Habbo History', 'default_3x3', 1, 264, 1, 93, '1', '1', '0', '0', 'catal_fp_header', 'memorial', '', 'For the nostalgic players.', NULL, NULL, NULL, 0, ''),
	(50, 209, '2010_bling', 'Bling', 'default_3x3', 1, 92, 1, 36, '1', '1', '0', '0', 'catalog_header_bling_en', 'catalog_teaser_bling11', '', 'Did someone speak in glamour? Chic? Lux? So you\'re speaking the language of Bonnie Blonde, my friend!', NULL, NULL, NULL, 0, ''),
	(51, 209, 'organo', 'Organo', 'default_3x3', 1, 235, 1, 142, '1', '1', '0', '0', 'organo_cata_header', 'organo_teaser', '', 'The latest range from Ann Summers, the Orgie line. Made of soft, wipe clean plastic, its perfect for any three, four or fivesome!', NULL, NULL, NULL, 0, ''),
	(75, 277, 'dogs', 'Dogs', 'pets', 1, 24, 1, 4, '1', '1', '0', '0', 'catalog_pet_headline1', '', '', 'Wet noses, paws and woofs! You\'re about to enter the world of Habbo Dogs. An adorable and cuddly ball of fur awaits you with a waggling tail.', 'Name your Dog:', 'Pick a colour:', 'Pick a breed:', 0, ''),
	(52, 234, 'pet_food', 'Pet Food', 'default_3x3', 1, 201, 1, 2, '1', '1', '0', '0', 'catalog_header_petfood', 'ctlg_pet_teaser1', '', 'Keep your Pet happy and healthy. Feed it and don\'t forget about exercise!', NULL, NULL, NULL, 0, ''),
	(463, 209, 'super_saver_subscription', 'Super Saver', 'default_3x3', 1, 124, 1, 188, '1', '1', '0', '0', 'catalog_super_saver1_en', 'madmoney_supersaver_teaser', '', 'We\'d like you to meet the new Super Saver Subscription!', NULL, NULL, NULL, 0, ''),
	(53, 209, 'runway', 'Runway', 'default_3x3', 1, 74, 1, 168, '1', '1', '0', '0', 'runway_header_en', 'runway_teaser_en', '', 'Spice up your salon, hair parlour or boutique with our stylish yet practical range! From sewing machines to comfy seating, we\'ve got the perfect option for you.', NULL, NULL, NULL, 0, ''),
	(467, 209, 'school', 'School', 'default_3x3', 1, 130, 1, 172, '1', '1', '0', '0', 'ruletheschool_header', 'catalog_school_teaser', '', 'Sick of being told what to do? Want to be the boss of someone else for a change? Well now you can with our very own school range!', NULL, NULL, NULL, 0, ''),
	(76, 277, 'cats', 'Cats', 'pets', 1, 20, 1, 2, '1', '1', '0', '0', 'catalog_pet_headline1', '', '', 'Fluff, whiskers, meows and purrs! These cute little critters make great playmates and will keep you entertained.', 'Name your Cat:', 'Pick a colour:', 'Pick a breed:', 0, ''),
	(77, 277, 'crocs', 'Crocs', 'pets', 1, 22, 1, 3, '1', '1', '0', '0', 'catalog_pet_headline1', '', '', 'Scaly skin, growls and snaps! Security for your room or used to scare your friends - this surprisingly loving Croc can be yours.', 'Name your Croc:', 'Pick a colour:', 'Pick a breed:', 0, ''),
	(78, 277, 'terriers', 'Terriers', 'pets', 1, 66, 1, 14, '1', '1', '0', '0', 'catalog_pet_headline1', '', '', 'The Cairn Terrier is one of the oldest terrier breeds. From the Scottish Highlands, it was used for hunting prey among the cairns! Different breeds have different colours!', 'Name your Terrier:', 'Pick a colour:', 'Pick a breed:\n', 0, ''),
	(79, 277, 'bears', 'Bears', 'pets', 1, 68, 1, 1, '1', '1', '0', '0', 'catalog_pet_headline1', '', '', 'A large mammal that walks on the soles of its feet, with thick fur and a short tail. Did you know that bears are related to dogs and that most species are omnivorous?', 'Name your Bear:', NULL, 'Pick a breed:', 0, ''),
	(80, 277, 'pig', 'Pigs', 'pets', 1, 67, 1, 10, '1', '1', '0', '0', 'catalog_pet_headline1', '', '', 'Finally an excuse to leave your room looking like a pigsty! Mischevious and cute, these little guys are out of the ordinary. Sweet and funny, a pet like no other!', 'Name your Pet Pig:', 'Pick a colour:', 'Pick a breed:\n', 0, ''),
	(523, 219, 'football', 'Football', 'default_3x3', 1, 56, 1, 6, '1', '1', '0', '0', 'catalog_football_001', 'flags', '', 'Whether you call it soccer, football or futbol... you can enjoy the game right here in Habbo! Get a ball and kick it, bounce it, pass it, control it and steal it!', NULL, NULL, NULL, 0, ''),
	(54, 209, 'prison', 'Prison', 'default_3x3', 1, 240, 1, 156, '1', '1', '0', '0', 'catalog_header_prison', 'catalog_teaser_prison', '', 'Hey, he\'s escaping! Just kidding, no one\'s getting out of these high security cells!', NULL, NULL, NULL, 0, ''),
	(55, 209, 'tv_studio', 'TV Studio', 'default_3x3', 1, 136, 1, 202, '1', '1', '0', '0', 'header_studio', 'teaser_studio', '', 'The Studio range lets YOU be your own music producer!', NULL, NULL, NULL, 0, ''),
	(81, 277, 'lion', 'Lions', 'pets', 1, 76, 1, 8, '1', '1', '0', '0', 'catalog_pet_headline1', '', '', 'A boisterous predator in nature, the lion has been tamed to be your fierce friend in Habbo Hotel.', 'Name your pet:', 'Choose a colour:', 'Choose a breed:\n', 0, ''),
	(82, 277, 'rhino', 'Rhinos', 'pets', 1, 77, 1, 12, '1', '1', '0', '0', 'catalog_pet_headline1', '', '', 'The Rhinoceros is an African herbivore that can weigh over a ton. It is proud and slightly aloof, but loyal and never let anything get in the way of a good time!', 'Name your pet:', 'Choose a colour:', 'Choose a breed:', 0, ''),
	(83, 277, 'spider', 'Spiders', 'pets', 1, 95, 1, 13, '1', '1', '0', '0', 'catalog_pet_headline1', '', '', 'One of the most feared creatures in nature, and perhaps the most misunderstood. The majority of Spiders have sharp fangs that inject venom into their prey- but don\'t worry, these spiders won\'t bite! Maybe...', NULL, 'Name your pet:', NULL, 0, ''),
	(84, 277, 'turtle', 'Turtles', 'pets', 1, 126, 1, 15, '1', '1', '0', '0', 'catalog_pet_headline1', '', '', 'Anything but slow, these guys are ready to ride the waves and swim laps at your beaches!', NULL, 'Name your Turtle:', NULL, 0, ''),
	(371, 387, 'welcome_lounge', 'Welcome Lounge', 'default_3x3', 1, 264, 1, 26, '1', '1', '0', '0', 'catalog_header_classics', 'article_habboreport2', '', 'This furni is from the second version of the Welcome Lounge; the first after moving from Shockwave to Flash.', NULL, NULL, NULL, 0, ''),
	(85, 680, 'chick', 'Chick', 'pets', 1, 107, 1, 99, '1', '1', '0', '0', 'catalog_pet_headline1', '', '', NULL, NULL, 'Name your Dragon:', 'Select your colour/breed:\n', 0, ''),
	(56, 209, 'cubie', 'Cubie', 'default_3x3', 1, 100, 1, 54, '1', '1', '0', '0', 'catalog_cubie_header_en', 'catalog_cubie_teaser', '', 'It\'s sleek, it\'s modern, it\'s so darn cool it can barely stand itself... Introducing the Cubie Furni range! Give your Bachelor or Bachelorette pad a homely feel with a sophisticated twist.', NULL, NULL, NULL, 0, ''),
	(57, 209, 'waasa', 'Waasa', 'default_3x3', 1, 103, 1, 214, '1', '1', '0', '0', 'waasa_catalogue_header', 'waasa_teaser', '', 'Waasa is the perfect furniture for a chilled, laidback room. Especially good for students on a budget!', NULL, NULL, NULL, 0, ''),
	(370, 387, 'picnic', 'Picnic', 'default_3x3', 1, 264, 1, 20, '1', '1', '0', '0', 'catalog_header_classics', 'article_habboreport2', '', 'Picnic is one of the oldest, still-standing Public Rooms on Habbo.', NULL, NULL, NULL, 0, ''),
	(58, 209, 'american_idol', 'American Idol', 'default_3x3', 1, 4, 1, 6, '1', '1', '0', '0', 'catalog_header_AI1_en', 'catalog_teaser_idol', '', 'Host your own American Idol show with this replica furniture! All that\'s missing is a Randy Jackson lookalike!', NULL, NULL, NULL, 0, ''),
	(59, 209, 'kitchen', 'Kitchen', 'default_3x3', 1, 217, 1, 116, '1', '1', '0', '0', 'catalog_header_kitchen2015', 'teaser_kitchen2015', '', 'Fancy owning a Habbo restaurant? Or just love catering for Habbos in style? With this furni line you can REALLY get cooking!', NULL, NULL, NULL, 0, ''),
	(86, 277, 'frog', 'Frogs', 'pets', 1, 97, 1, 6, '1', '1', '0', '0', 'catalog_pet_headline1', '', '', 'Cute, green and slimy! Frogs come in a variety of colours and can be found all over the world. They are great jumpers and make great pets, but are harder to hold onto than a supermodel in a tornado.', NULL, 'Name your Frog:', NULL, 0, ''),
	(87, 277, 'dragon', 'Dragons', 'pets', 1, 109, 1, 5, '1', '1', '0', '0', 'catalog_pet_headline1', '', '', 'Keepers of the Dragon, beware...their history is legendary... With their fiery breath and scaly skin, these mythical creatures are nothing but fierce!', NULL, 'Name your Dragon:', NULL, 0, ''),
	(60, 209, 'usva', 'USVA', 'default_3x3', 1, 129, 1, 208, '1', '1', '0', '0', 'catalog_header_USVA', 'usva_teaser', '', 'With a great range of colours and new stacking possibilities, you\'ll love building and creating structures with the new USVA Furni line!', NULL, NULL, NULL, 0, ''),
	(62, 209, 'mystics', 'Mystics', 'default_3x3', 1, 185, 1, 136, '1', '1', '0', '0', 'header_mystics', 'teaser_mystics', '', 'A mystic crystal has crashed outside the hotel bounds and is transforming the hotel into an infected wilderness. Will you fight for the side for good? Or will you fight for the side of evil and help the infection spread?', NULL, NULL, NULL, 0, ''),
	(63, 218, 'triggers', 'Triggers', 'default_3x3', 1, 81, 1, 3, '1', '1', '0', '0', 'catalog_wired_header2_en', 'ctlg_pic_wired_triggers', '', 'Triggers let you define what needs to happen for an Effect to take place. To program a Trigger, place it in a room, double click on it and set it up! You need to stack an Effect with the Trigger to make it work.', NULL, NULL, 'Click to see how each Trigger works.', 0, ''),
	(604, 2, 'indoor_furni', 'By Type', 'default_3x3', 1, 45, 1, 7, '1', '0', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(64, 218, 'effects', 'Effects', 'default_3x3', 1, 82, 1, 4, '1', '1', '0', '0', 'catalog_wired_header3_en', 'ctlg_pic_wired_effects', '', 'Effects are what happens after you activate a Trigger. To program an Effect, place it in a room, double click on it and set it up! You will always need to stack a Trigger with the Effect to make it work.', NULL, NULL, 'Click on an item to see what the Effect does!', 0, ''),
	(65, 218, 'conditions', 'Conditions', 'default_3x3', 1, 83, 1, 5, '1', '1', '0', '0', 'catalog_wired_header4_en', 'ctlg_pic_wired_conditions', '', 'Conditions are specific things that need to be done before a Trigger will work. If you want to use a Condition, you will need to stack it with a Trigger and Effect.', NULL, NULL, 'Click on an item to see what the Condition does!', 0, ''),
	(369, 387, 'lido', 'Lido', 'default_3x3', 1, 264, 1, 18, '1', '1', '0', '0', 'catalog_header_classics', 'article_habboreport2', '', 'The Lido is where the famous "Pool\'s Closed" raid occured in 2006.', NULL, NULL, NULL, 0, ''),
	(66, 442, 'stray_pixels', 'Stray Pixels', 'default_3x3', 1, 10, 4, 61, '1', '1', '0', '0', 'StrayPixelsLogo', 'catalog_pxl_teaser2_nl', '', NULL, NULL, NULL, NULL, 0, ''),
	(67, 209, 'mayan', 'Mayan', 'default_3x3', 1, 171, 1, 128, '1', '1', '0', '0', 'mayanheader2', 'mayanteaser', '', 'Just what you need to prove you survived the apocolypse!', NULL, NULL, NULL, 0, ''),
	(68, 209, 'african', 'African', 'default_3x3', 1, 233, 1, 2, '1', '1', '0', '0', 'african_header', 'african_catateaser', '', 'The new African furniture range is here!', NULL, NULL, NULL, 0, ''),
	(69, 209, 'anna', 'Anna', 'default_3x3', 1, 104, 1, 12, '1', '1', '0', '0', 'catalog_anna_header', 'catalog_anna_teaser', '', 'Make the new Anna range yours!', NULL, NULL, NULL, 0, ''),
	(70, 209, 'steampunk', 'Steampunk', 'default_3x3', 1, 180, 1, 182, '1', '1', '0', '0', 'catalog_header_steampunk', 'catalog_teaser_steampunk', '', 'Infuse your room design with the power of steam! This Steampunk line is a full set of building material to create amazing room designs that resemble an alternate retro-futuristic universe.', NULL, NULL, NULL, 0, ''),
	(367, 387, 'hotel_view', 'Hotel View', 'default_3x3', 1, 264, 1, 14, '1', '1', '0', '0', 'catalog_header_classics', 'HotelView', '', 'You can now make the Hotel in your own shape with this furni line.', NULL, NULL, NULL, 0, ''),
	(73, 442, 'calippo', 'Calippo', 'default_3x3', 1, 10, 4, 8, '1', '1', '0', '0', 'calippo_header_es', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(736, 557, 'special_trophies', 'Special Trophies', 'trophies', 1, 221, 6, 25, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(737, 736, 'individual_trophies', 'Individual Trophies', 'default_3x3', 1, 221, 1, 1, '1', '1', '0', '0', '', '', '', 'These trophies don\'t follow the typical "colour" guidelines like normal trophies.', NULL, NULL, NULL, 0, ''),
	(74, 209, 'habbo_stars', 'Habbo Stars', 'default_3x3', 1, 196, 1, 94, '1', '1', '0', '0', 'Stars_header', 'habbostars2', '', 'Have you always wanted to be famous? Is singing, dancing, or acting your thing? Well we have the next best thing, Wulles Stars! Get your dancing feet on and make your name shine!', NULL, NULL, NULL, 0, ''),
	(359, 387, 'classic_lounge', 'Classic Lounge', 'default_3x3', 1, 264, 1, 2, '1', '1', '0', '0', 'catalog_header_classics', 'classiclounge', '', 'The Welcome Lounge is home not only to newer players, but old Habbo originals who come to guide the newer players or just chill with their friends.', NULL, NULL, NULL, 0, ''),
	(528, 442, 'nickelodeon', 'Nickelodeon', 'default_3x3', 1, 10, 4, 42, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(366, 387, 'library', 'Library', 'default_3x3', 1, 264, 1, 17, '1', '1', '0', '0', 'catalog_header_classics', 'Library', '', 'The room description was "There\'s nothing like a good book..."', NULL, NULL, NULL, 0, ''),
	(104, 209, 'drago', 'Drago', 'default_3x3', 1, 110, 1, 66, '1', '1', '0', '0', 'drago_catalog_header2', 'drago_catalog_teaser2', '', 'Dungeon furniture, the perfect range to create your torturous cellars!', NULL, NULL, NULL, 0, ''),
	(374, 372, 'easter', 'Easter', 'default_3x3', 1, 181, 1, 2, '1', '0', '0', '0', 'catalog_easter_headline1', 'catalog_easter_teaser1', '', NULL, NULL, NULL, NULL, 0, ''),
	(106, 209, 'boutique', 'Boutique', 'default_3x3', 1, 131, 1, 40, '1', '1', '0', '0', 'boutique_catalog_01', 'boutique_catalog_teaser_01', '', 'The boutique range is just the thing if you want to own a high end fashion store in Milan, but are on a budget.', NULL, NULL, NULL, 0, ''),
	(365, 387, 'club_mammoth', 'Club Mammoth', 'default_3x3', 1, 264, 1, 3, '1', '1', '0', '0', 'catalog_header_classics', 'jan18_classic11_internal', '', 'Club Mammoth was first opened to only HC and VIP (when it was introduced) members. The room description was "Monumental and magnificant."', NULL, NULL, NULL, 0, ''),
	(364, 387, 'star_lounge', 'Star Lounge', 'default_3x3', 1, 264, 1, 22, '1', '1', '0', '0', 'catalog_header_classics', 'spromo_Star_Lounge', '', 'While also popular, this room was also used for many Celebrity Visits.', NULL, NULL, NULL, 0, ''),
	(363, 387, 'oriental', 'Oriental', 'default_3x3', 1, 264, 1, 19, '1', '1', '0', '0', 'catalog_header_classics', 'spromo_Classic_Tea_Room', '', 'The room description was "A soothing atmosphere and amazing tea brews."', NULL, NULL, NULL, 0, ''),
	(362, 387, 'ice_cafe', 'Ice Cafe', 'default_3x3', 1, 264, 1, 15, '1', '1', '0', '0', 'catalog_header_classics', 'classic5_furnis', '', 'The Ice Cafe was used a a meeting place in Habbo Experience for Chaplin and his friends.', NULL, NULL, NULL, 0, ''),
	(107, 2, 'habbo_groups', 'Habbo Groups', 'guilds', 1, 203, 1, 15, '1', '1', '0', '0', 'catalog_groups_en', 'catalog_groupsteaser_en', '', 'Habbo Groups are a great way to stay in touch with your friends and share your interests with others. Each Group has a homeroom that can be decorated by other Group members, members can also purchase exclusive Group Furni that can be customised with your Group colours!', NULL, '* Get together with people you get together with!\r\n* Co-op room decorating for group members\r\n* Show off your group badge!\r\n* Get some neat Furni in your group\'s colours!', 'What\'s So Great About Habbo Groups?', 0, ''),
	(108, 107, 'group_furni', 'Group Furni', 'guild_furni', 1, 203, 1, 1, '1', '1', '0', '0', 'catalog_groups_en', '', 'guild_custom_furni', 'Show off your Group spirit with the new customisable Furni. Select your Group and then get your furni in your Groups colours.', NULL, NULL, NULL, 0, ''),
	(377, 372, 'new_years', 'New Years', 'default_3x3', 1, 91, 1, 4, '1', '0', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(109, 209, 'youtube', 'Youtube', 'default_3x3', 1, 188, 1, 220, '1', '1', '0', '0', 'catalog_header_tv', 'yttv', '', 'Remember when Habbo had YouTube TVs? Well it can again, with KrewsTube! Check it out at krews.org', NULL, NULL, NULL, 0, ''),
	(110, 209, 'vikings', 'Vikings', 'default_3x3', 1, 208, 1, 210, '1', '1', '0', '0', 'vikings_catalog_header', 'catalog_teaser_vikings', '', 'From weapon racks and heads on spikes, to ornate hand-carved wooden chairs and benches. This furni has everything you need and more to create the Viking village of your dreams. With furni available in clan colours, you can display your true loyalty with pride!', NULL, NULL, NULL, 0, ''),
	(112, 209, 'wild_wild_west', 'Wild Wild West', 'default_3x3', 1, 229, 1, 218, '1', '1', '0', '0', 'catalog_header_wwest', 'catalog_teaser_wildwest', '', 'From the Shoot\'em Up Saloon to the Sheriff\'s Office, and all the floor tiles, cacti and tumbleweeds in between...Wild West furni has made it\'s way to town.', NULL, NULL, NULL, 0, ''),
	(113, 387, 'club_nx', 'Club NX', 'default_3x3', 1, 264, 1, 4, '1', '1', '0', '0', 'catalog_header_classics', 'catal_fp_pic5', '', 'On Habbo, there is a door at the top next to the bar that leads to Hallway 2.', NULL, NULL, NULL, 0, ''),
	(114, 209, 'habbo_university', 'Habbo University', 'default_3x3', 1, 230, 1, 98, '1', '1', '0', '0', 'university_new_furni_catalog_header', 'university_catalog_teaser', '', 'From pink and flowery, to hipster chic - Every Habbo has a style.', NULL, NULL, NULL, 0, ''),
	(88, 277, 'monkey', 'Monkeys', 'pets', 1, 166, 1, 9, '1', '1', '0', '0', 'catalog_pet_headline1', '', '', 'This mischevious monkey has made his way into the hotel and into our hearts. From the tilted beret to his love of bunches of bananas- this Monkey is sure to liven up your Habbo life!', NULL, 'Name your Monkey:', NULL, 0, ''),
	(89, 277, 'horse', 'Horses', 'pets', 1, 132, 1, 7, '1', '1', '0', '0', 'catalog_horse_header2_en', '', '', 'You can ride your horse around the Hotel and customize its body and hair colour.', NULL, 'Name your Horse:', NULL, 0, ''),
	(90, 680, 'bunny', 'Bunny', 'pets', 1, 148, 1, 99, '1', '1', '0', '0', 'babypets_cata_header', '', '', 'OINK! Partial to a good roll in the mud, these playful piggies have trotted into the hotel and are ready for fun!', NULL, 'Name your Piglet:', 'Select your colour/breed:\n', 0, ''),
	(115, 234, 'toys_and_accessories', 'Toys and Accessories', 'default_3x3', 1, 199, 1, 3, '1', '1', '0', '0', 'catalog_pet_headline2', 'catalog_teaser_pettoys', '', 'The baby pets are here! Take good care of them and keep them happy with our exciting range of food and toys!', NULL, NULL, 'Get some nice accessories for your pet.', 0, ''),
	(116, 209, 'attic', 'Attic', 'default_3x3', 1, 242, 1, 24, '1', '1', '0', '0', 'attic15_catalog_header', 'attic15_catalog_teaser', '', 'From squeaky floor boards to ancient furniture, the Attic 2015 furniture is now here!', NULL, NULL, NULL, 0, ''),
	(117, 222, 'alphabet_blocks', 'Alphabet Blocks', 'default_3x3_color_grouping', 1, 1001, 1, 1, '1', '1', '0', '0', 'catalog_header_alpha1', 'catalog_teaser_alpha1', '', 'A... B... C... and Z, bitch...', NULL, NULL, NULL, 0, ''),
	(118, 209, 'neo-habbo', 'Neo-Habbo', 'default_3x3', 1, 254, 1, 138, '1', '1', '0', '0', 'catalog_header_cpunk15', 'old_cypunk', '', 'Light-filled cityscapes and brightly lit skycrapers looming ovehead... This is the dark, dark furni line of the future. The future is called CyberPunk.', NULL, NULL, NULL, 0, ''),
	(361, 387, 'battleball', 'Battleball', 'default_3x3', 1, 264, 1, 1, '1', '1', '0', '0', 'catalog_header_classics', 'spromo_Blue_BB', '', 'The Battleball game was removed from Habbo along with Snowstorm as Sulake decided to concentrate more on improving other parts of the hotel. ', NULL, NULL, NULL, 0, ''),
	(119, 442, 'habbo_mall', 'Habbo Mall', 'default_3x3', 1, 10, 4, 29, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(120, 209, 'ancients', 'Ancients', 'default_3x3', 1, 170, 1, 8, '1', '1', '0', '0', 'catalog_header_ancients', 'ancients_teaser', '', 'Follow in the footsteps of the Ancients with these wonderous Ancient artifacts.', NULL, NULL, NULL, 0, ''),
	(121, 209, 'mad_scientist', 'Mad Scientist', 'default_3x3', 1, 239, 1, 126, '1', '1', '0', '0', 'igor_mad_scientist_header', 'igor_madscientist_teaser', '', 'This furniture was created to advertise the release of the Igor film in both cinemas and on DVD.', NULL, NULL, NULL, 0, ''),
	(122, 557, '2013_loyalty', 'Loyalty Rewards', 'default_3x3', 1, 184, 5, 45, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(123, 209, 'spiderwick', 'Spiderwick', 'default_3x3', 1, 210, 1, 178, '1', '1', '0', '0', 'spiderwick', 'catalog_spw_teaser1_en', '', 'Spiderwick furniture were for the release of The Spiderwick Chronicles in 2008.', NULL, NULL, NULL, 0, ''),
	(126, 222, 'cone', 'Cone', 'default_3x3', 1, 244, 1, 2, '1', '1', '0', '0', 'block_header', 'teaser_blocks', '', '1 Block... 2 Block... Red Block... Blue Block', NULL, NULL, NULL, 0, ''),
	(127, 222, 'cylinder', 'Cylinder', 'default_3x3', 1, 245, 1, 3, '1', '1', '0', '0', 'block_header', 'teaser_blocks', '', '1 Block... 2 Block... Red Block... Blue Block', NULL, NULL, NULL, 0, ''),
	(128, 222, 'half_cylinder', 'Half Cylinder', 'default_3x3', 1, 251, 1, 5, '1', '1', '0', '0', 'block_header', 'teaser_blocks', '', '1 Block... 2 Block... Red Block... Blue Block', NULL, NULL, NULL, 0, ''),
	(129, 222, 'hemisphere', 'Hemisphere', 'default_3x3', 1, 247, 1, 6, '1', '1', '0', '0', 'block_header', 'teaser_blocks', '', '1 Block... 2 Block... Red Block... Blue Block', NULL, NULL, NULL, 0, ''),
	(130, 222, 'pyramid', 'Pyramid', 'default_3x3', 1, 248, 1, 7, '1', '1', '0', '0', 'block_header', 'teaser_blocks', '', '1 Block... 2 Block... Red Block... Blue Block', NULL, NULL, NULL, 0, ''),
	(131, 222, 'quarter_ring', 'Quarter Ring', 'default_3x3', 1, 249, 1, 8, '1', '1', '0', '0', 'block_header', 'teaser_blocks', '', '1 Block... 2 Block... Red Block... Blue Block', NULL, NULL, NULL, 0, ''),
	(132, 222, 'sphere', 'Sphere', 'default_3x3', 1, 250, 1, 9, '1', '1', '0', '0', 'block_header', 'teaser_blocks', '', '1 Block... 2 Block... Red Block... Blue Block', NULL, NULL, NULL, 0, ''),
	(133, 222, 'standing_half_cylinder', 'Standing Half Cylinder', 'default_3x3', 1, 246, 1, 10, '1', '1', '0', '0', 'block_header', 'teaser_blocks', '', '1 Block... 2 Block... Red Block... Blue Block', NULL, NULL, NULL, 0, ''),
	(134, 222, 'standing_triangular_prism', 'Standing Triangular Prism', 'default_3x3', 1, 252, 1, 11, '1', '1', '0', '0', 'block_header', 'teaser_blocks', '', '1 Block... 2 Block... Red Block... Blue Block', NULL, NULL, NULL, 0, ''),
	(135, 222, 'wedge', 'Wedge', 'default_3x3', 1, 253, 1, 13, '1', '1', '0', '0', 'block_header', 'teaser_blocks', '', '1 Block... 2 Block... Red Block... Blue Block', NULL, NULL, NULL, 0, ''),
	(136, 222, 'triangular_prism', 'Triangular Prism', 'default_3x3', 1, 1000, 1, 12, '1', '1', '0', '0', 'block_header', 'teaser_blocks', '', '1 Block... 2 Block... Red Block... Blue Block', NULL, NULL, NULL, 0, ''),
	(137, 222, 'glass_panel', 'Glass Panel', 'default_3x3', 1, 1003, 1, 4, '1', '1', '0', '0', 'block_header', 'teaser_blocks', '', '1 Block... 2 Block... Red Block... Blue Block', NULL, NULL, NULL, 0, ''),
	(138, 765, 'round', 'Round', 'default_3x3', 1, 28, 1, 12, '1', '1', '0', '0', 'block_header', 'teaser_blocks', '', '1 Block... 2 Block... Red Block... Blue Block', NULL, NULL, NULL, 0, ''),
	(139, 765, 'small', 'Small', 'default_3x3', 1, 28, 1, 15, '1', '1', '0', '0', 'block_header', 'teaser_blocks', '', '1 Block... 2 Block... Red Block... Blue Block', NULL, NULL, NULL, 0, ''),
	(140, 765, 'large', 'Large', 'default_3x3', 1, 28, 1, 7, '1', '1', '0', '0', 'block_header', 'teaser_blocks', '', '1 Block... 2 Block... Red Block... Blue Block', NULL, NULL, NULL, 0, ''),
	(141, 765, 'tile', 'Tile', 'default_3x3', 1, 28, 1, 18, '1', '1', '0', '0', 'block_header', 'teaser_blocks', '', '1 Block... 2 Block... Red Block... Blue Block', NULL, NULL, NULL, 0, ''),
	(142, 765, 'flower_hedge', 'Flower Hedge', 'default_3x3', 1, 28, 1, 3, '1', '1', '0', '0', 'block_header', 'teaser_blocks', '', '1 Block... 2 Block... Red Block... Blue Block', NULL, NULL, NULL, 0, ''),
	(143, 765, 'water', 'Water', 'default_3x3', 1, 28, 1, 19, '1', '1', '0', '0', 'block_header', 'teaser_blocks', '', '1 Block... 2 Block... Red Block... Blue Block', NULL, NULL, NULL, 0, ''),
	(144, 765, 'simple_wood', 'Simple Wood', 'default_3x3', 1, 28, 1, 14, '1', '1', '0', '0', 'block_header', 'teaser_blocks', '', '1 Block... 2 Block... Red Block... Blue Block', NULL, NULL, NULL, 0, ''),
	(145, 765, 'terra', 'Terra', 'default_3x3', 1, 28, 1, 17, '1', '1', '0', '0', 'block_header', 'teaser_blocks', '', '1 Block... 2 Block... Red Block... Blue Block', NULL, NULL, NULL, 0, ''),
	(146, 765, 'brick', 'Brick', 'default_3x3', 1, 28, 1, 2, '1', '1', '0', '0', 'block_header', 'teaser_blocks', '', '1 Block... 2 Block... Red Block... Blue Block', NULL, NULL, NULL, 0, ''),
	(147, 765, 'glass', 'Glass', 'default_3x3', 1, 28, 1, 4, '1', '1', '0', '0', 'block_header', 'teaser_blocks', '', '1 Block... 2 Block... Red Block... Blue Block', NULL, NULL, NULL, 0, ''),
	(148, 765, 'lava', 'Lava', 'default_3x3', 1, 28, 1, 8, '1', '1', '0', '0', 'block_header', 'teaser_blocks', '', '1 Block... 2 Block... Red Block... Blue Block', NULL, NULL, NULL, 0, ''),
	(149, 765, 'marble', 'Marble', 'default_3x3', 1, 28, 1, 9, '1', '1', '0', '0', 'block_header', 'teaser_blocks', '', '1 Block... 2 Block... Red Block... Blue Block', NULL, NULL, NULL, 0, ''),
	(150, 765, 'art_deco', 'Art Deco', 'default_3x3', 1, 28, 1, 1, '1', '1', '0', '0', 'block_header', 'teaser_blocks', '', '1 Block... 2 Block... Red Block... Blue Block', NULL, NULL, NULL, 0, ''),
	(151, 765, 'industrial', 'Industrial', 'default_3x3', 1, 28, 1, 6, '1', '1', '0', '0', 'block_header', 'teaser_blocks', '', '1 Block... 2 Block... Red Block... Blue Block', NULL, NULL, NULL, 0, ''),
	(152, 765, 'sand', 'Sand', 'default_3x3', 1, 28, 1, 13, '1', '1', '0', '0', 'block_header', 'teaser_blocks', '', '1 Block... 2 Block... Red Block... Blue Block', NULL, NULL, NULL, 0, ''),
	(153, 765, 'metal', 'Metal', 'default_3x3', 1, 28, 1, 10, '1', '1', '0', '0', 'block_header', 'teaser_blocks', '', '1 Block... 2 Block... Red Block... Blue Block', NULL, NULL, NULL, 0, ''),
	(154, 765, 'metal_crate', 'Metal Crate', 'default_3x3', 1, 28, 1, 11, '1', '1', '0', '0', 'block_header', 'teaser_blocks', '', '1 Block... 2 Block... Red Block... Blue Block', NULL, NULL, NULL, 0, ''),
	(155, 765, 'stone', 'Stone', 'default_3x3', 1, 28, 1, 16, '1', '1', '0', '0', 'block_header', 'teaser_blocks', '', '1 Block... 2 Block... Red Block... Blue Block', NULL, NULL, NULL, 0, ''),
	(156, 765, 'wool', 'Wool', 'default_3x3', 1, 28, 1, 20, '1', '1', '0', '0', 'block_header', 'teaser_blocks', '', '1 Block... 2 Block... Red Block... Blue Block', NULL, NULL, NULL, 0, ''),
	(157, 765, 'grass', 'Grass', 'default_3x3', 1, 28, 1, 5, '1', '1', '0', '0', 'block_header', 'teaser_blocks', '', '1 Block... 2 Block... Red Block... Blue Block', NULL, NULL, NULL, 0, ''),
	(158, 209, 'army_bootcamp', 'Army Bootcamp', 'default_3x3', 1, 259, 1, 18, '1', '1', '0', '0', 'catalog_header_army15', 'army_newfurni', '', 'Purchase the new in stock army/military based furni - from gun racks to choppers, no matter what item you\'re after; this section will have it!', NULL, NULL, NULL, 0, ''),
	(159, 387, 'infobus', 'Infobus', 'default_3x3', 1, 264, 1, 16, '1', '1', '0', '0', 'catalog_header_classics', 'catal_fp_pic5', '', 'The famous Infobus was only ever opened when staff were hosting events or discussions, whereas the park was always open.', NULL, NULL, NULL, 0, ''),
	(160, 387, 'game_hub', 'Game Hub', 'default_3x3', 1, 264, 1, 7, '1', '1', '0', '0', 'catalog_header_classics', 'catal_fp_pic5', '', 'This room was the main collaboration shown of games and events between users and official Habbo staff.', NULL, NULL, NULL, 0, ''),
	(161, 209, 'paris', 'Paris', 'default_3x3', 1, 261, 1, 146, '1', '1', '0', '0', 'paris_header', 'paris_teaser', '', 'Always wanted to build a Paris designed room? Now is your chance with this brand new set of Paris furniture.', NULL, NULL, NULL, 0, ''),
	(162, 387, 'hall_of_habbo', 'Habbo 15', 'default_3x3', 1, 264, 1, 8, '1', '1', '0', '0', 'catalog_header_classics', 'catal_fp_pic5', '', 'It is the least used Public Room, and features users who have won various competitions.', NULL, NULL, NULL, 0, ''),
	(378, 374, 'classics', 'Classics', 'default_3x3', 1, 25, 1, 1, '1', '1', '0', '0', 'catalog_easter_headline1', 'catalog_easter_teaser1', '', 'Little birdies hatching from their eggs, pretty, dainty flowers blooming and cute rabbits bouncing in Spring meadows.. it\'s Easter!', NULL, NULL, NULL, 0, ''),
	(163, 107, 'groups_forums', 'Groups Forums', 'guild_forum', 1, 207, 1, 2, '1', '1', '0', '0', 'catalog_groups_en', '', '', 'Group Forums are here!', NULL, '<b><font color="#0e3f52" size="16">What are Group Forums?</font></b>\r\n\r\nForums allow you to effortlessly post, comment and discuss topics freely, without even leaving the Hotel!\n\n<i><b><font color="#0e3f52" size="16">Who can start a forum? </font></b></i>\n\nOnly a group owner can start a forum for their group.\n\n<i><b><font color="#0e3f52" size="16">Do I need a Forum Terminal?</font></b></i>\n\nYes - In order to start a Group Forum the group owner must first purchase a forum terminal for the group.\n\n\nFind out more about Group Forums <a href="event:habbopages/forums">here</a>.\n\nPlease note, we will continue to add more functionalities to this feature in the near future.', NULL, 0, ''),
	(659, 664, 'bonus_rare_17', 'Bonus Rare 17', 'default_3x3', 1, 263, 1, 2, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(660, 664, 'bonus_rare_18', 'Bonus Rare 18', 'default_3x3', 1, 263, 1, 3, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(661, 664, 'bonus_rare_19', 'Bonus Rare 19', 'default_3x3', 1, 263, 1, 4, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(662, 664, 'bonus_rare_16', 'Bonus Rare 16', 'default_3x3', 1, 263, 1, 1, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(663, 557, 'v1_rares', 'Classic Rares', 'default_3x3', 1, 42, 6, 1, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(91, 680, 'bunny_bad', 'Bunny - Bad', 'pets', 1, 151, 1, 99, '1', '1', '0', '0', 'catalog_horse_header2_en', '', '', 'You can ride your horse around the Hotel and also customize its body and hair colour.', NULL, 'Name Your Horse:', NULL, 0, ''),
	(199, 209, 'jurassic_habbo', 'Jurassic Habbo', 'default_3x3', 1, 260, 1, 114, '1', '1', '0', '0', 'dino_header', 'dino_teaser', '', 'The creatures of the Primeval times are back! With this furni line you can let pure space in a prehistorican shine!', NULL, NULL, NULL, 0, ''),
	(200, 3, 'outfits', 'Outfits', 'default_3x3', 1, 74, 1, 3, '1', '1', '0', '0', '', 'tradeableclothing_teaser', '', 'Different occasions require different outfits. To wear yours, simply place the new item in your room and double click to bind the oufit clothing to your avatar', NULL, NULL, NULL, 0, ''),
	(201, 3, 'hairdos', 'Hairdos', 'default_3x3', 1, 74, 1, 4, '1', '1', '0', '0', '', 'tradeableclothing_teaser', '', 'Make sure you have a hairstyle for every occasion! To wear, simply place the new item in your room and double click to bind the oufit clothing to your avatar', NULL, NULL, NULL, 0, ''),
	(202, 3, 'hats', 'Hats', 'default_3x3', 1, 74, 1, 5, '1', '1', '0', '0', '', 'tradeableclothing_teaser', '', 'Stay up to date with ALL of the latest headgear! To wear yours, simply place the new item in your room and double click to bind the oufit clothing to your avatar', NULL, NULL, NULL, 0, ''),
	(310, 3, 'accessories', 'Accessories', 'default_3x3', 1, 74, 1, 6, '1', '1', '0', '0', '', 'tradeableclothing_teaser', '', 'Stay snazzy with this comprehensive collection of shiny accessories. To wear, simply place the new item in your room and double click to bind the oufit clothing to your avatar', NULL, NULL, NULL, 0, ''),
	(488, 373, '2018_city_festival', '\'18 - City Festival', 'default_3x3', 1, 277, 1, 16, '1', '1', '0', '0', 'xmas15_head', 'Winter_City_Festival', '', 'Make a beautiful Twinkly Stage and show off your Matryoshka Dolls!', NULL, NULL, NULL, 0, ''),
	(203, 3, 'dresses', 'Dresses', 'default_3x3', 1, 74, 1, 7, '1', '1', '0', '0', '', 'tradeableclothing_teaser', '', 'Dress to impress with these gorgeous, expertly crafted dresses! To wear, simply place the new item in your room and double click to bind the oufit clothing to your avatar', NULL, NULL, NULL, 0, ''),
	(204, 3, 'shirts', 'Shirts', 'default_3x3', 1, 74, 1, 8, '1', '1', '0', '0', '', 'tradeableclothing_teaser', '', 'As the slightly smarter option, our shirts will dazzle your friends! To wear, simply place the new item in your room and double click to bind the oufit clothing to your avatar', NULL, NULL, NULL, 0, ''),
	(487, 373, '2017_victorian', '\'17 - Victorian', 'default_3x3', 1, 277, 1, 15, '1', '1', '0', '0', 'xmas15_head', 'xmas17old', '', 'More shopping, less markets. Big corporations ruined the Christmas markets; but at least they sell less of the same product for a higher price!', NULL, NULL, NULL, 0, ''),
	(205, 3, 'jackets', 'Jackets', 'default_3x3', 1, 74, 1, 9, '1', '1', '0', '0', '', 'tradeableclothing_teaser', '', 'Wrap up warm, but keep it super-stylish with our selection of jackets. To wear, simply place the new item in your room and double click to bind the oufit clothing to your avatar', NULL, NULL, NULL, 0, ''),
	(206, 3, 'trousers', 'Trousers', 'default_3x3', 1, 74, 1, 10, '1', '1', '0', '0', '', 'tradeableclothing_teaser', '', 'Bottom-half clothing for those slightly colder days. To wear, simply place the new item in your room and double click to bind the oufit clothing to your avatar', NULL, NULL, NULL, 0, ''),
	(486, 373, '2016_citadel', '\'16 - Citadel', 'default_3x3', 1, 170, 1, 14, '1', '1', '0', '0', 'xmas15_head', 'xmas16_gen1', '', 'Even Santa\'s elves need to relax every now and then, and we found the furni they use for their relaxation!', NULL, NULL, NULL, 0, ''),
	(207, 3, 'skirts', 'Skirts', 'default_3x3', 1, 74, 1, 11, '1', '1', '0', '0', '', 'tradeableclothing_teaser', '', 'Show off your pixel-legs with our lovely selection of skirts! To wear, simply place the new item in your room and double click to bind the oufit clothing to your avatar', NULL, NULL, NULL, 0, ''),
	(208, 3, 'shoes', 'Shoes', 'default_3x3', 1, 74, 1, 12, '1', '1', '0', '0', '', 'tradeableclothing_teaser', '', 'You can NEVER have too many pairs of shoes. To wear yours, simply place the new item in your room and double click to bind the oufit clothing to your avatar', NULL, NULL, NULL, 0, ''),
	(485, 373, '2015_bavarian', '\'15 - Bavarian', 'default_3x3', 1, 277, 1, 11, '1', '1', '0', '0', 'xmas15_head', 'xmas15_tease', '', 'Christmas markets are always buzzing, in tiny little villages and large cities. Would you plan it differently?', NULL, NULL, NULL, 0, ''),
	(352, 953, 'vip', 'VIP', 'default_3x3', 1, 214, 1, 2, '1', '1', '0', '1', 'catalog_header_hc', 'teaser_habboclub', 'catalog_special_txtbg2', 'As a member of Habbo Club or HC, you can shop from this selection of exclusive items. Every now and then we will also be adding items that are currently unavailable in the regular Furni Shop as well!', NULL, NULL, 'For Club members only!', 0, ''),
	(354, 953, 'executive', 'Executive', 'default_3x3', 1, 214, 1, 4, '1', '1', '0', '1', 'catalog_header_hc', 'teaser_habboclub', 'catalog_special_txtbg2', 'As a member of Habbo Club or HC, you can shop from this selection of exclusive items. Every now and then we will also be adding items that are currently unavailable in the regular Furni Shop as well!', NULL, NULL, 'For Club members only!', 0, ''),
	(355, 953, 'alhambra', 'Alhambra', 'default_3x3', 1, 214, 1, 5, '1', '1', '0', '1', 'catalog_header_hc', 'teaser_habboclub', 'catalog_special_txtbg2', 'As a member of Habbo Club or HC, you can shop from this selection of exclusive items. Every now and then we will also be adding items that are currently unavailable in the regular Furni Shop as well!', NULL, NULL, 'For Club members only!', 0, ''),
	(356, 953, 'emojis', 'Emojis', 'default_3x3', 1, 214, 1, 6, '1', '1', '0', '1', 'catalog_header_hc', 'teaser_habboclub', 'catalog_special_txtbg2', 'As a member of Habbo Club or HC, you can shop from this selection of exclusive items. Every now and then we will also be adding items that are currently unavailable in the regular Furni Shop as well!', NULL, NULL, 'For Club members only!', 0, ''),
	(357, 953, 'bling', 'Bling', 'default_3x3', 1, 214, 1, 7, '1', '1', '0', '1', 'catalog_header_hc', 'teaser_habboclub', 'catalog_special_txtbg2', 'As a member of Habbo Club or HC, you can shop from this selection of exclusive items. Every now and then we will also be adding items that are currently unavailable in the regular Furni Shop as well!', NULL, NULL, 'For Club members only!', 0, ''),
	(358, 953, 'zodiac_statues', 'Zodiac Statues', 'default_3x3', 1, 214, 1, 8, '1', '1', '0', '1', 'catalog_header_hc', 'teaser_habboclub', 'catalog_special_txtbg2', 'As a member of Habbo Club or HC, you can shop from this selection of exclusive items. Every now and then we will also be adding items that are currently unavailable in the regular Furni Shop as well!', NULL, NULL, 'For Club members only!', 0, ''),
	(558, 680, 'cow_gold_box', 'Cow - Gold Box', 'single_bundle', 1, 271, 1, 99, '1', '1', '0', '0', 'cow_pet2', 'cow_pet2', '', NULL, NULL, NULL, NULL, 0, ''),
	(442, 7, 'ad_sales', 'Ad Sales', 'default_3x3', 1, 64, 4, 5, '1', '0', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(491, 557, 'diamond_paintings', 'Diamond Paintings', 'default_3x3', 1, 92, 6, 30, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(483, 373, '2013_santa\'s_workshop', '\'13 - Workshop', 'default_3x3', 1, 168, 1, 9, '1', '1', '0', '0', 'catalog_header_xmas2013', 'catalog_teaser_xmas2013', '', 'Santa needs time to come up with all the gift ideas, and his little helpers copy his blueprints. Here you can create his workshop!', NULL, NULL, NULL, 0, ''),
	(484, 373, '2014_tropical', '\'14 - Tropical', 'default_3x3', 1, 232, 1, 10, '1', '1', '0', '0', 'xmas14_catalog_header', 'xmas14_newfurni_spromo_teaser', '', 'Wacky, wavy, inflatable, arm flailing tubemen! Party on for this hot Christmas.', NULL, NULL, NULL, 0, ''),
	(209, 2, 'furni_by_line', 'By Line', 'pets3', 1, 72, 1, 10, '1', '0', '0', '0', '', 'furni_for_colection', '', NULL, NULL, NULL, NULL, 0, ''),
	(4, -1, 'pets', 'Pets', 'default_3x3', 1, 8, 1, 4, '1', '1', '0', '0', 'catalog_frontpage_headline_shop_EN', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(700, 209, 'executive', 'Executive', 'default_3x3', 1, 27, 1, 70, '1', '1', '0', '0', 'catalog_exe_headline1_en', 'catalog_exe_teaser_en', '', 'The Executive range is ideal for creating a sophisticated working environment, whether it be an office, a mafia headquarters or study!', NULL, NULL, NULL, 0, ''),
	(211, 218, 'add-ons', 'Add-Ons', 'default_3x3', 1, 85, 1, 6, '1', '1', '0', '0', 'catalog_wired_header5_en', 'ctlg_pic_wired_support_furniture', '', 'Use these simple Furni to bring extra spice to your Wired room. These are basic Furni, so you will still need Triggers, Effects and Conditions to make them work!', NULL, 'Use Triggers, Effects and Conditions to make these Furni work!', NULL, 0, ''),
	(212, 209, 'gardening', 'Gardening', 'default_3x3', 1, 157, 1, 74, '1', '1', '0', '0', 'garden_catalog_header', 'garden_catalog_teaser', '', 'Be at one with nature!', NULL, NULL, NULL, 0, ''),
	(481, 373, '2012_castles', '\'12 - Castles', 'default_3x3', 1, 170, 1, 8, '1', '1', '0', '0', 'xmas_2010', 'xmas_furni4', '', 'Santa may be a slave to all the children of the world, but he still deserves a castle.', NULL, NULL, NULL, 0, ''),
	(214, 209, 'stranded_jungle', 'Stranded Jungle', 'default_3x3', 1, 290, 1, 184, '1', '1', '0', '0', 'catalog_header_2016jungle', 'junglenewfurni', '', 'Step into a virtual world of survival, treacherous terrain and life-threatening tropical conditions... because the Stranded Jungle line is here!', NULL, NULL, NULL, 0, ''),
	(215, 604, 'custom_rooms', 'Custom Rooms', 'default_3x3', 1, 125, 1, 3, '1', '1', '0', '0', 'catalog_blackhole_header_en', 'catalog_blackhole_teaser', '', 'Design your own custom room layouts with Stack Magic Tiles and Black holes. Stack your items to the ceiling or use them as dividers...the possibilities are endless!', NULL, NULL, NULL, 0, ''),
	(588, 3, 'top_picks', 'Top Picks', 'default_3x3', 1, 195, 1, 1, '1', '1', '0', '0', 'catalog_hot_header_en', 'catalog_teaser_new', '', 'Need some inspiration? Look no further.', NULL, NULL, NULL, 0, ''),
	(216, 209, 'greek', 'Greek', 'default_3x3', 1, 31, 1, 80, '1', '1', '0', '0', 'greek_header', 'greek_catateaser', '', 'Be transported back to ancient Greece with a couple of thousand pounds and British Airways. Until then, build your own pantheon with our realistic Greek range!', NULL, NULL, NULL, 0, ''),
	(217, 209, 'sports', 'Sports', 'default_3x3', 1, 56, 1, 180, '1', '1', '0', '0', 'catalog_sports_headline1', 'catalog_sports_teaser1', '', 'The whistle blows, but there\'s no track to practice on! Make your own before your trainer notices!', NULL, NULL, NULL, 0, ''),
	(479, 373, '2011_winter_cabin', '\'11 - Cabin', 'default_3x3', 1, 139, 1, 7, '1', '1', '0', '0', 'xmas_2010', 'xmas11_catalog_teaser_01', '', 'Keep yourself nice and toasty in a perfect cabin of your design.', NULL, NULL, NULL, 0, ''),
	(477, 373, '2010_city', '\'10 - City', 'default_3x3', 1, 86, 1, 5, '1', '1', '0', '0', 'xmas_2010', 'xmas10_teaser', '', 'The city is shining with the snow covering everything. Build your own high-street!', NULL, NULL, NULL, 0, ''),
	(260, 262, 'gift_box_i', 'Gift Box I', 'default_3x3', 1, 236, 7, 1, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(261, 262, 'gift_box_ii', 'Gift Box II', 'default_3x3', 1, 236, 7, 2, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(262, 125, 'redeemable_cases', 'Redeemable Cases', 'default_3x3', 1, 99, 4, 6, '1', '0', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(218, 2, 'wired', 'Wired', 'pets3', 1, 80, 1, 12, '1', '0', '0', '0', 'catalog_wired_header1', 'ctlg_pic_teaser_wired', '', NULL, NULL, NULL, NULL, 0, ''),
	(476, 373, '2009', '\'09', 'default_3x3', 1, 168, 1, 4, '1', '1', '0', '0', 'catalog_xmas_headline2_en', 'xmas2009_catalogue', '', 'Get yourself into the Christmas spirit with our selection of festive furni! From baubles to snow-Habbos, we\'ve got it all!', NULL, NULL, NULL, 0, ''),
	(219, 2, 'game_shop', 'Game Shop', 'pets3', 1, 202, 1, 14, '1', '0', '0', '0', 'game_shop_header', 'game_shop_teaser', '', 'Get your gamer gear on!', NULL, NULL, NULL, 0, ''),
	(220, 2, 'marketplace', 'Marketplace', 'pets3', 1, 69, 1, 17, '1', '1', '0', '0', 'catalog_marketplace_header_en', 'catalog_note_marketplace', '', 'Habbo Marketplace is a convenient and safe way to buy and sell items in Habbo.', 'How does the Habbo Marketplace work?', 'Buying items: Browse for the item you want to buy on the Marketplace Offers page and click Buy. We guarantee you\'ll get the item at the cheapest price available at the moment of purchase. No requirements needed.\r\n\r\nSelling items: You can sell any item which is tradable by selecting the item in your inventory and clicking on \'Sell in Marketplace\'. You also can use items currently in the Shop.\r\n\r\nNOTE: you can only sell 250 furni at a time.\r\n\r\nRequirements: To sell your Furni in the Marketplace you\'ll need a Trading Pass, which you can get completing the first steps of the Talent Track.', NULL, 0, ''),
	(221, 4, 'baby_pet_animals', 'Baby Pet Animals', 'pets3', 1, 228, 1, 2, '1', '1', '0', '0', 'babypets_cata_header', 'ctlg_babypet_note', '', 'They\'re friendly. They\'re cute. They\'re here to win your hearts. Who are they? Baby pets! ALL NEW Kittens, puppies, piglets are storming their way through the hotel and joining the Bear Cubs and Terriers. Available via breeding boxes or sale.', 'A few things you should know:', '*You can place a pet in your room or take one for a walk with you in other rooms.\n*You can\'t trade your pet but they can follow you to friend\'s rooms to gather scratches.\n*You can have up to 50 pets in your room, but look after them all!\n\n\n*Look after your pet with food, water and treats.\nCheck the Pets\' Accessories.\n*Unlock Badges and Achievements by Training your Pet.', 'Click your Pet and hit the "Train" button to get a list of commands that will level up your Pet in no time!', 0, ''),
	(624, 7, 'clothing', 'Clothing', 'default_3x3', 1, 74, 5, 15, '1', '0', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(475, 209, '2008_arctic', 'Arctic', 'default_3x3', 1, 13, 1, 14, '1', '1', '0', '0', 'catalog_arc_header1_en', 'arctic_teaser1', '', 'It\'s a very cold winter this year, don\'t slip while building your own icy fortress!', NULL, NULL, NULL, 0, ''),
	(222, 2, 'builders_club', 'Builder\'s Club', 'pets3', 1, 1002, 1, 16, '1', '0', '0', '0', 'block_header', 'ctlg_bclub_note', '', '1 Block... 2 Block... Red Block... Blue Block!', '1 Block... 2 Block... Red\r\nBlock... Blue Block!', '\r\n\r\nWith dozens of all the colours and patterns to choose from, you can really let your creativity run wild!\r\nExclusive to Builders Club.', NULL, 0, ''),
	(223, 604, 'backgrounds', 'Backgrounds', 'default_3x3', 1, 206, 1, 1, '1', '1', '0', '0', 'catalog_header_easter14_001', 'catalog_shal_teaser_da', '', 'Set the scene in your room properly with one of these backgrounds.', NULL, NULL, NULL, 0, ''),
	(224, 604, 'teleports', 'Teleports', 'default_3x3', 1, 120, 1, 12, '1', '1', '0', '0', 'catalog_doors_headline1', 'catalog_door_a', '', 'Beam yourself from one room to another with our space-age teleports. Buy a pair, put one in each room and you\'ve got your own suite! IMPORTANT: teleports are always sold in pairs except for the Random Banzai Teleport.', NULL, NULL, 'Click on an item for details.', 0, ''),
	(225, 604, 'trophies', 'Trophies', 'trophies', 1, 221, 1, 13, '1', '1', '0', '0', 'trophies', '', '', 'Everyone\'s a winner, baby! And now you can reward them all with our fabulous glittering array of bronze, silver and gold trophies.\n\nFirst choose the trophy model by click the arrows. Then select the metal. Type your inscription below and we\'ll engrave it on the trophy along with your name and today\'s date.\nRemember - it\'s permanent!', NULL, NULL, NULL, 0, ''),
	(473, 373, 'classics', 'Classics', 'default_3x3', 1, 168, 1, 0, '1', '1', '0', '0', 'catalog_xmas_headline1_ca', 'catalog_xmas_teaser', '', 'Christmas trees, poinsettas, and decorations. Back to the good old classic Christmas furni!', NULL, NULL, NULL, 0, ''),
	(472, 377, '2015', '\'15', 'default_3x3', 1, 91, 1, 6, '1', '1', '0', '0', 'newyears', 'ny_comeback', '', 'A classic party with bubbly and cupcakes, fun for the whole family.', NULL, NULL, NULL, 0, ''),
	(513, 511, 'black_plasto', 'Black Plasto', 'default_3x3', 1, 46, 1, 2, '1', '1', '0', '0', 'plastic', 'plastic_pasic_promo_1', '', 'Throw on an afro and grab a disco ball! Feel that retro, 1970s vibe? You soon will with this colourful, plastic range! Choose a colour to suit your mood and off you go!\n', NULL, NULL, NULL, 0, ''),
	(379, 374, '2011_fungi', '\'11 - Fungi', 'default_3x3', 1, 73, 1, 4, '1', '1', '0', '0', 'mushroomfurni_header', 'mushroomfurni_teaser', '', 'Alongside flowers, sometimes fungi sprouts. While fungi is delicious, it can also be beautiful.', NULL, NULL, NULL, 0, ''),
	(429, 125, 'testing', 'Testing', 'default_3x3', 1, 10, 7, 9, '1', '1', '0', '0', '', '', '', 'This is the page Habbo uses for all their "testing" categorised furni.', NULL, NULL, NULL, 0, ''),
	(499, 498, 'ecotron_rewards_ii', 'Ecotron Rewards II', 'default_3x3', 1, 163, 1, 2, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(227, 219, 'how_to_play_banzai', 'How to Play Banzai', 'pets2', 1, 42, 1, 2, '1', '1', '0', '0', 'catalog_battleBanzai_header_en', 'catalog_battleBanzai_teaser', '', 'So how does it work? Read the instructions here and you\'ll be Banzai-ing in no time!', 'How to create your own \nBattle Banzai Arena:', '1. In your room, place Banzai tiles on the floor and barriers the playing field\r\n\r\n2. Add a Team portal for each team (max 4: blue,\r\npink, yellow, and green)\r\n \r\n3. Place a Counter and Scoreboards on the playing field\r\n\r\n4. Click the Counter to launch the game!\r\n\r\n5.Jump on the tiles to colour them, jump 3 times to lock - team with most points win!\r\n\r\n\r\n\r\n\r\nTip: Add drama with Pyramids, Dragons and Pucks - they work as obstacles and helpers!', NULL, 0, ''),
	(380, 374, '2013', '\'13 - Easter', 'default_3x3', 1, 181, 1, 5, '1', '1', '0', '0', 'easter13_header', 'easter13_teaser', '', 'This line brings flowers, teleports and a couple of eggs with it. Check out the floral-inspired line below!', NULL, NULL, NULL, 0, ''),
	(381, 374, '2014_lagomorph_', '\'14 - Lagomorph ', 'default_3x3', 1, 181, 1, 6, '1', '1', '0', '0', 'catalog_header_easter14_001', 'easternew', '', 'From shape shifting wall pieces to cryptic teleports, this years Easter furni line is sure to keep you guessing! Nothing is as it seems on this mind-bending island...', NULL, NULL, NULL, 0, ''),
	(228, 219, 'how_to_play_freeze', 'How to Play Freeze!', 'pets2', 1, 42, 1, 4, '1', '1', '0', '0', 'catalog_freeze_en', 'freeze3', '', 'Find out how you can make and host your own Freeze! game by reading the instructions below!', 'How to play Freeze!', '1. Place Tiles and Blocks in your room. Always place blocks on top of tiles! Add Team Gates, a Counter, an Exit Tile and Scoreboards.\n\n2. Ready? Let your friends choose a team. Each team can have up to five players. Then click the Counter\nto start!\n \n3. To place a Snowball, double click on the tile that you are standing on, or double click on a tile next to you. Blow up Blocks for power-ups!\n\n4. Last team standing wins!\n\n\n\n\nRemember: You will be warped to an Exit Tile when you lose all your lives.', NULL, 0, ''),
	(229, 953, 'club_shop', 'Club Shop', 'default_3x3', 1, 214, 1, 3, '1', '1', '0', '1', 'catalog_header_hc', 'teaser_habboclub', '', NULL, NULL, NULL, NULL, 0, ''),
	(230, 680, 'epic_pet', 'Epic Pet', 'default_3x3', 1, 42, 4, 8, '1', '1', '0', '0', '', '', '', 'Once purchased and placed, clicking it will give you a special pet.', NULL, NULL, NULL, 0, ''),
	(231, 604, 'wall_decorations', 'Flags', 'default_3x3', 1, 286, 1, 4, '1', '1', '0', '0', 'catalog_flags_headline1', 'flags_teaser', '', 'Adorn your walls with wondrous works of art, posters, plaques and wall hangings. The Gallery is bursting with items to suit all tastes, from kitsch to cool, traditional to modern.', NULL, NULL, NULL, 0, ''),
	(102, 277, 'velociraptor', 'Velociraptors', 'single_bundle', 1, 260, 1, 16, '1', '1', '0', '0', 'jurassic15_catalog_header', 'dino_pets', '', 'Swift and sneaky, these reptiles have a reputation for being somewhat high-maintenance, incredibly intellectual and endlessly troublesome! You\'ll often find them pondering over deeply philosophical questions, or enjoying the finer things in life, like pedicures and meat straight off the bone.', NULL, NULL, NULL, 0, ''),
	(232, 277, 'pterodactyl', 'Pterodactyls', 'single_bundle', 1, 260, 1, 11, '1', '1', '0', '0', 'jurassic15_catalog_header', 'dino_pets', '', 'These pterrific pets have a fierce appearance with long talons and sharp teeth, but their sweet nature always shines through! Ultra laid-back, these \'flying lizards\' love nothing more than spending time with their owner, soaring through the Hotel skies and eating their favourite food...the humble kale leaf.', NULL, NULL, NULL, 0, ''),
	(233, 2, 'room_bundles', 'Room Bundles', 'default_3x3', 1, 268, 1, 2, '1', '0', '0', '0', 'catalog_header_roombundle', '', 'bundlerooms', NULL, NULL, NULL, NULL, 0, ''),
	(470, 377, '2011', '\'11', 'default_3x3', 1, 91, 1, 3, '1', '1', '0', '0', 'catalog_header_year2011_en', 'catalog_teaser_year2011', '', 'A great way to celebrate the repeal of the Don\'t Ask, Don\'t Tell policy. Oh, and the New Year!', NULL, NULL, NULL, 0, ''),
	(3, -1, 'clothing', 'Clothing', 'default_3x3', 1, 37, 1, 3, '1', '1', '0', '0', 'catalog_frontpage_headline_shop_EN', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(234, 4, 'pet_equipment', 'Pet Equipment', 'default_3x3', 1, 226, 1, 3, '1', '0', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(235, 209, 'monkey_furni', 'Lost Monkey', 'default_3x3', 1, 128, 1, 123, '1', '1', '0', '0', 'catalog_monkey_headline', 'monkey_catalogue_teaser', '', 'Get exclusive Habbo Furni for your very own Pet Monkey!', NULL, NULL, NULL, 0, ''),
	(469, 377, '2010', '\'10', 'default_3x3', 1, 91, 1, 2, '1', '1', '0', '0', 'newyears', 'catal_fp_pic5', '', 'Explosions and wavers, what a way to celebrate the first year without Bush.', NULL, NULL, NULL, 0, ''),
	(269, 209, 'palooza', 'Palooza', 'default_3x3', 1, 227, 1, 144, '1', '1', '0', '0', 'palooza_2014_catalog_header', 'catalog_teaser_palooza', '', NULL, NULL, NULL, NULL, 0, ''),
	(468, 377, '2012_china_town', '\'12 - CNY', 'default_3x3', 1, 91, 1, 4, '1', '1', '0', '0', 'cny_header', 'cny_teaser', '', 'Celebrating all cultures is important for Habbos to get along!', NULL, NULL, NULL, 0, ''),
	(236, 763, 'virus_2016_fish_tanks', 'Fish Tanks', 'default_3x3', 1, 294, 1, 3, '1', '1', '0', '0', 'catalog_pet_headline1', 'fishtank_teaser', '', 'Gotta catch \'em all!', NULL, NULL, NULL, 0, ''),
	(459, 376, '2011_hearts', '\'11 - Hearts', 'default_3x3', 1, 144, 1, 5, '1', '1', '0', '0', 'catalog_love_headline1_ca', 'valentines_teaser3', '', NULL, NULL, NULL, NULL, 0, ''),
	(457, 376, '2016_carnivale', '\'16 - Carnival', 'default_3x3', 1, 14, 1, 18, '1', '1', '0', '0', 'catalog_header_val12', 'val16_teaser', '', 'Cute kitties and some beautiful furni ornaments to perfect your romantic room.', NULL, NULL, NULL, 0, ''),
	(458, 376, '2018_bedroom', '\'18 - Bedroom', 'default_3x3', 1, 62, 1, 20, '1', '1', '0', '0', 'val18_header', 'val18_teaser', '', 'If you want to stay in bed for Valentines, I don\'t blame you! This is the furni line for you!', NULL, NULL, NULL, 0, ''),
	(404, 209, 'coco', 'Coco', 'default_3x3', 1, 127, 1, 48, '1', '1', '0', '0', 'catalog_teaser_coco', 'coconew', '', 'Wooden yet comfortable furniture that wouldn\'t look out of place in a treetop house!\n', NULL, NULL, NULL, 0, ''),
	(456, 376, '2015_ancient_japan', '\'15 - Ancient Japan', 'default_3x3', 1, 243, 1, 17, '1', '1', '0', '0', 'val15_cata_header', 'val15_teaser', '', 'Have a beautiful Picnic under a Sakura tree in Japan, with this Valentines line!', NULL, NULL, NULL, 0, ''),
	(238, 680, 'gnome', 'Gnome', 'single_bundle', 1, 200, 1, 99, '1', '1', '0', '0', 'catalog_header_gnomes', 'catalog_teaser_gnome', '', 'Give a Gnome a home. If you do, it will reward you with loads of fun. Watch it sit. Stand. Walk. It can even change states on your furni. Amazing creatures!', NULL, NULL, NULL, 0, ''),
	(511, 209, 'plasto', 'Plasto', 'default_3x3', 1, 46, 1, 152, '1', '1', '0', '0', 'plastic', 'plastic_pasic_promo_1', '', 'Throw on an afro and grab a disco ball! Feel that retro, 1970s vibe? You soon will with this colourful, plastic range! Choose a colour to suit your mood and off you go!\n', NULL, NULL, NULL, 0, ''),
	(490, 599, 'hippo_statues', 'Hippo Statues', 'default_3x3', 1, 42, 4, 3, '1', '1', '0', '0', '', 'Spromo_Bonus_Bags', '', NULL, NULL, NULL, NULL, 0, ''),
	(239, 262, 'club_trail', 'HC 7Days Trail', 'default_3x3', 1, 75, 1, -1, '1', '1', '0', '0', 'hc2_clubtitle', 'club', '', 'Habbo CLub Trail redeemables', NULL, NULL, NULL, 0, ''),
	(955, 951, 'hc_infotab', 'Informations about HC', 'info_loyalty', 1, 75, 1, 0, '1', '1', '0', '0', 'hc2_clubtitle', 'club', '', '<b><font size="15" color=""> What is Habbo Club (HC)?</font></b>\r\n\r\nHabbo Club (also known as HC) is a special club you can join to get access to more clothing styles, exclusive room designs, more space on your friends list and lots more. You can join directly from the Habbo Club section in the shop. \r\nYou can get different lengths of membership from the website and te in-game Shop’s premium section.\r\n\r\nWhat are the benefits of Habbo Club?\r\n\r\n- Monthly credits paid with HC Payday\r\n- Exclusive hair + clothing styles\r\n- Exclusive HC clothing colour palette\r\n- FREE HC gifts\r\n- Earn twice the amount of Duckets\r\n- Wardrobe tool to save your outfits\r\n\r\n<b>And many more!</b>', NULL, NULL, NULL, 0, ''),
	(440, 387, 'hc_lounge', 'HC Lounge', 'default_3x3', 1, 264, 1, 12, '1', '1', '0', '0', 'catalog_header_classics', 'catal_fp_pic5', '', 'The bartender bot was called HankCupp, and the DJ bot called djDucketz.', NULL, NULL, NULL, 0, ''),
	(441, 387, 'franks_room', 'Franks Room', 'default_3x3', 1, 264, 1, 6, '1', '1', '0', '0', 'catalog_header_classics', 'catal_fp_pic5', '', 'Frank has been the mascot of Habbo for many, many years.', NULL, NULL, NULL, 0, ''),
	(500, 498, 'ecotron_rewards_i', 'Ecotron Rewards I', 'default_3x3', 1, 163, 1, 1, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(455, 50, '2014_white_bling', 'White Bling', 'default_3x3', 1, 92, 1, 16, '1', '1', '0', '0', 'bling', 'whitebling_teaser', '', 'Did someone speak in glamour? Chic? Lux? So you\'re speaking the language of Bonnie Blonde, my friend! Now in white!', NULL, NULL, NULL, 0, ''),
	(240, 376, '2013_love_locks', '\'13 - Love Locks', 'default_3x3', 1, 174, 1, 13, '1', '1', '0', '0', 'valentines2013_lovelocks_header', 'valentines2013_lovelocks_teaser2', '', 'Friendship Padlocks are Furni that show how special your friends are. You and your friend need to be in your room. Put the Padlock in the Room, click 2x on it, and confirm the action. Once closed, your friendship will be saved forever, even if you trade it!', NULL, NULL, NULL, 0, ''),
	(242, 234, 'saddles', 'Saddles', 'petcustomization', 1, 135, 1, 4, '1', '1', '0', '0', 'catalog_saddles_header2_en', 'sadddles', '', 'To use a saddle, place it in a room where you have at least one Horse. Double click the saddle and select what horse you want to ride After placing the saddle you can ride your Horse by clicking on it and selecting \'Ride\'.', NULL, NULL, NULL, 0, ''),
	(453, 376, '2008_habborella', '\'08 - Habborella', 'default_3x3', 1, 144, 1, 2, '1', '1', '0', '0', 'valentines2009_header', 'valentine_furni_001', '', 'Find your true love with the Love Randomiser, and how better to celebrate than with a box of chocolates?', NULL, NULL, NULL, 0, ''),
	(243, 234, 'dyes', 'Dyes', 'petcustomization', 1, 133, 1, 5, '1', '1', '0', '0', 'catalog_horsedyes_header2_en', 'dyes', '', 'Customize your horse with this selection of hair colours and body types. Each dye can also be added to your room as a piece of furniture. To use a dye place it to your room, double click on it and then select the horse you want to customise.', NULL, NULL, NULL, 0, ''),
	(452, 376, '2010_heartbreak_hotel', '\'10 - Heartbreak Hotel', 'default_3x3', 1, 93, 1, 4, '1', '1', '0', '0', 'catalog_header_val12_2_en', 'catalog_love_teaser1', '', 'A gift basket and a cuddly teddy for your Valentine, and some cozy seats for your date.', NULL, NULL, NULL, 0, ''),
	(244, 234, 'hair_styles', 'Hair Styles', 'petcustomization', 1, 134, 1, 6, '1', '1', '0', '0', 'catalog_horsehairstyles2_header_en', 'hairs', '', 'Customize your horse and make him unique with this selection of hair styles.  Each style can also be added to your room as a piece of furniture. To use a hair style place it to your room, double click on it and then select the horse you want to customise.', NULL, NULL, NULL, 0, ''),
	(450, 376, '2013_masquerade_ball', '\'13 - Venice', 'default_3x3', 1, 174, 1, 12, '1', '1', '0', '0', 'valentines2013_header2', 'valentines2013_teaser', '', 'With a smell of flowers and love, use this furni to make your perfect garden party.', NULL, NULL, NULL, 0, ''),
	(245, 234, 'horse_jump', 'Horse Jump', 'default_3x3', 1, 226, 1, 7, '1', '1', '0', '0', 'catalog_header_jumping_en', 'catalog_teaser_horsejump', '', 'Take your horse jumping with these new Furni! Build a formidable race course to test your steed and your riding skills and challenge your friends!', NULL, NULL, NULL, 0, ''),
	(449, 376, '2017_wedding', '\'17 - Wedding', 'default_3x3', 1, 238, 1, 19, '1', '1', '0', '0', 'wedding_header2', 'valentines2017_wedding_teaser', '', 'Do I hear wedding bells? The perfect outdoor setting awaits!', NULL, NULL, NULL, 0, ''),
	(246, 4, 'monster_plants', 'Monster Plants', 'pets3', 1, 153, 1, 5, '1', '1', '0', '0', 'catalog_header_mopla_01', 'ctlg_monster_note', '', 'Monster Plants can sure be a handful, this page gives you some extra advice on raising and looking after your monsterous brood.', 'Taking Care Of Your Plant', 'Your plants need to be tended regularly, or else they die. To ensure a healthy plant tend it every 30 hours\nor so. If it dies, you can use the Revival potion to\nbring it back to life.\nBreeding\nTo breed your plant you have to wait until it\'s fully\ngrown. Clicking Breed on the menu will show you\nwhat other plants in the room are available to breed\nwith.', NULL, 0, ''),
	(448, 376, '2019_restaurant', '\'19 - Restaurant', 'default_3x3', 1, 62, 1, 21, '1', '1', '0', '0', 'catalog_header_val12_2_en', 'val19_newfurni', '', 'Perfect for a romantic evening with your loved one.\n', NULL, NULL, NULL, 0, ''),
	(247, 246, 'monster_plant_seeds', 'Monster Plant Seeds', 'default_3x3', 1, 156, 1, 1, '1', '1', '0', '0', 'catalog_header_mnstrSeeds', 'quest_teaser_monsterplants', '', 'Plant your seeds in your room and tend to keep them alive and healthy. After your plants have matured you can breed your plants to try and get leveled up offspring. Plants can only breed once without using the Rebreeding Potion.', NULL, NULL, NULL, 0, ''),
	(446, 376, '2012_prom', '\'12 - Prom', 'default_3x3', 1, 144, 1, 10, '1', '1', '0', '0', 'catalog_header_val12_en', 'catalog_teaser_val12', '', 'Prom is full of crying teens and bad dance moves, but it\'s always a fond memory for many. Create your perfect prom with this furni!', NULL, NULL, NULL, 0, ''),
	(248, 246, 'monster_plant_potions', 'Monster Plant Potions', 'default_3x3', 1, 155, 1, 2, '1', '1', '0', '0', 'monsterplantsprays_header', 'monsterplantspray_teaser', '', 'On this page you\'ll find everything you need to take care of your plants: Plant Revival for when your plants die. Place potion to room, double click and select the plant you want to revive.', NULL, NULL, NULL, 0, ''),
	(249, 209, 'wedding', 'Wedding', 'default_3x3', 1, 238, 1, 216, '1', '1', '0', '0', 'catalog_header_wedding', 'catalog_teaser_wedding', '', 'Now you can celebrate your great day with our wonderful selection of perfect furni for a wedding!', NULL, NULL, NULL, 0, ''),
	(250, 763, 'exotic_pets_2017', 'Exotic Pets', 'default_3x3', 1, 294, 1, 2, '1', '1', '0', '0', 'catalog_pet_headline1', 'xotic_pets', '', 'Gotta catch \'em all!', NULL, NULL, NULL, 0, ''),
	(274, 125, 'camera_wall_photo', 'Camera Wall Photo', 'default_3x3', 1, 10, 7, 7, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(536, 442, '7-11', '7-11', 'default_3x3', 1, 10, 4, 1, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(445, 376, 'classics', 'Classics', 'default_3x3', 1, 144, 1, 1, '1', '1', '0', '0', 'catalog_love_headline1_ca', 'catalog_love_teaser1', '', 'Love is in the air! Buy your sweetheart a rose or whisper sweet nothings in their ear on a lova sofa. Can you feel it?', NULL, NULL, NULL, 0, ''),
	(251, 680, 'cow_box', 'Cow Box', 'single_bundle', 1, 270, 1, 99, '1', '1', '0', '0', 'catalog_pet_headline1', 'cow_pet2', '', 'We\'re extremely pleased and proud to preent the new cow pet! Get one of 16 different breeds from the Cow Pet box', NULL, NULL, NULL, 0, ''),
	(527, 442, 'nokia', 'Nokia', 'default_3x3', 1, 10, 4, 45, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(383, 374, '2017_farm', '\'17 - Farm', 'default_3x3', 1, 181, 1, 10, '1', '1', '0', '0', 'farm-header', 'farm_teaser', '', 'With this furni line, you can make your quaint farm full of chickens and snacks!', NULL, NULL, NULL, 0, ''),
	(426, 680, 'leprechaun', 'Leprechaun', 'single_bundle', 1, 212, 1, 99, '1', '1', '0', '0', 'catalog_pet_headline1', 'catalog_teaser_lepr', '', 'For a limited time...the St Patrick\'s Day Leprechaun is here! This Irish mischeif-maker is sure to brighten your day. From his quirky sayings to his habit of breaking things... You are going to love him! Includes an AWESOME Badge.', NULL, NULL, NULL, 0, ''),
	(401, 209, '2010_flower_power', 'Flower Power', 'default_3x3', 1, 73, 1, 72, '1', '1', '0', '0', 'catalog_header_flower_power', 'flowerpower_teaser_en', '', 'Flowers look and smell great, and can brighten any room. Use this furni to decorate all kinds of rooms!', NULL, NULL, NULL, 0, ''),
	(444, 209, 'hospital', 'Hospital', 'default_3x3', 1, 269, 1, 104, '1', '1', '0', '0', 'hospital_header', 'hospital_teaser', '', 'Everybody gets sick, it might be time to open a Hospital in Habbo. Get started with some Hospital beds!', NULL, NULL, NULL, 0, ''),
	(436, 387, 'coffee_house', 'Coffee House', 'default_3x3', 1, 264, 1, 5, '1', '1', '0', '0', 'catalog_header_classics', 'catal_fp_pic5', '', 'The bot ColinHouser has a motto of "Want some milk?"', NULL, NULL, NULL, 0, ''),
	(437, 387, 'hallway', 'Hallway', 'default_3x3', 1, 264, 1, 11, '1', '1', '0', '0', 'catalog_header_classics', 'catal_fp_pic5', '', 'Hallways have been featured in Habbo since very early versions.', NULL, NULL, NULL, 0, ''),
	(438, 387, 'theatre', 'Theatre', 'default_3x3', 1, 264, 1, 24, '1', '1', '0', '0', 'catalog_header_classics', 'catal_fp_pic5', '', 'Another old and well-known room, this is the 4th revision of the Theatre.', NULL, NULL, NULL, 0, ''),
	(439, 387, 'welcome_lounge_modern', 'Welcome Lounge - Modern', 'default_3x3', 1, 264, 1, 27, '1', '1', '0', '0', 'catalog_header_classics', 'catal_fp_pic5', '', 'At points on some hotels, another one or two Welcome Lounges had to be added to cope with high traffic.', NULL, NULL, NULL, 0, ''),
	(514, 511, 'pink_plasto', 'Pink Plasto', 'default_3x3', 1, 158, 1, 4, '1', '1', '0', '0', 'plastic', 'plastic_pasic_promo_1', '', 'Throw on an afro and grab a disco ball! Feel that retro, 1970s vibe? You soon will with this colourful, plastic range! Choose a colour to suit your mood and off you go!\n', NULL, NULL, NULL, 0, ''),
	(349, 953, 'classics', 'Classics', 'default_3x3', 1, 214, 1, 1, '1', '1', '0', '1', 'catalog_header_hc', 'teaser_habboclub', 'catalog_special_txtbg2', 'As a member of Habbo Club or HC, you can shop from this selection of exclusive items. Every now and then we will also be adding items that are currently unavailable in the regular Furni Shop as well!', NULL, NULL, 'For Club Members only!', 0, ''),
	(253, 2, 'music_shop', 'Music Shop', 'default_3x3', 1, 4, 1, 16, '1', '1', '0', '0', 'music_header', 'catalog_djshop_teaser1', '', 'Let\'s get loud! Place a Jukebox in your room, add some disks from the \'Habbo Hotel Hits\' list below and you\'re ready to have a dance party!', NULL, NULL, NULL, 0, ''),
	(254, 253, 'habbo_hotel_hits', 'Habbo Hotel Hits', 'soundmachine', 1, 257, 1, 2, '1', '1', '0', '0', 'hotelhits_catalog_header', 'hotelhits_teaser', '', 'Turn up the volume with some cool new tunes for your room. Place a Jukebox in your room, get yourself some of these song discs and add them to your playlist!', NULL, 'You need to be in a room to\n"pre-listen" to the disks!', NULL, 0, ''),
	(255, 7, 'staff_wired', 'Staff Wired/Other', 'default_3x3', 1, 80, 6, 50, '1', '1', '0', '0', 'catalog_wired_header1', 'ctlg_pic_wired_deals', '', NULL, NULL, NULL, NULL, 0, ''),
	(384, 374, '2018_garden', '\'18 - Garden', 'default_3x3', 1, 181, 1, 11, '1', '1', '0', '0', 'easter18_header', 'easter18_teaser', '', 'Your own little hideaway in the woods, perfected with some curtains and cosy chairs in this furni line!', NULL, NULL, NULL, 0, ''),
	(256, 218, 'leaderboards', 'Leaderboards', 'default_3x3', 1, 256, 1, 8, '1', '1', '0', '0', 'wiredleaderboards_catalog_header', 'wiredleaderboards_teaser', '', 'The High Score furni to keep track of scores given in your games and displays them in your room.', NULL, NULL, 'Click an item for details', 0, ''),
	(592, 599, 'turtle_statues', 'Turtle Statues', 'default_3x3', 1, 42, 4, 8, '1', '1', '0', '0', '', 'Spromo_Bonus_Bags', '', NULL, NULL, NULL, NULL, 0, ''),
	(385, 374, '2019_fairytale', '\'19 - Fairytale', 'default_3x3', 1, 284, 1, 12, '1', '1', '0', '0', 'fairytale_header', 'easter19_new', '', 'We\'re all about fairytales this year! Maybe we should go find Alice?', NULL, NULL, NULL, 0, ''),
	(386, 219, '2009_bunny_run', 'Bunny Run', 'default_3x3', 1, 181, 1, 11, '1', '1', '0', '0', 'bunny_run', 'bunnyrun', '', 'Make your own game of Bunny Run with the furni here!', NULL, NULL, NULL, 0, ''),
	(412, 219, 'snowboarding', 'Snowboarding', 'default_3x3', 1, 140, 1, 7, '1', '1', '0', '0', 'snowboarding_catalog_02', 'catalog_snowboarding_teaser1', '', 'Step on the patch an you\'ll be automatically strapped to a Snowboard - like magic! The Snowboard Patch can be adjust to 9 different heights for you to build your own amazing slopes!', NULL, NULL, NULL, 0, ''),
	(387, 7, 'public_room_furni', 'Public Room Furni', 'default_3x3', 1, 264, 1, 25, '1', '0', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(388, 375, 'classics', 'Classics', 'default_3x3', 1, 34, 1, 1, '1', '1', '0', '0', 'hween_header', 'hween_teaser', '', 'Boy, that grave is spooky... Is anybody in that Crypt? Spooky!', NULL, NULL, NULL, 0, ''),
	(414, 125, 'snow_war', 'Snow War', 'default_3x3', 1, 2, 1, 8, '1', '1', '0', '0', 'catalog_rollerskates_header', 'catalog_teaser_rollerblades', '', 'Furni from the good ol\' classic, Snowstorm. It might not be functional, but it can make some nice decoration!', NULL, NULL, NULL, 0, ''),
	(415, 219, 'ice_tag', 'Ice Tag', 'default_3x3', 1, 86, 1, 10, '1', '1', '0', '0', 'catalog_tag_general_2', 'catalog_teaser_xm10_skate', '', 'The fun is ON with our new game! Skate on ice and play Tag with your friends using the new Tag Pole and Ice Skating Patch! Not sure how to put on your skates? Step on an Ice Patch and you\'re good to go.', NULL, NULL, NULL, 0, ''),
	(389, 209, '2008_virus', 'Virus', 'default_3x3', 1, 239, 1, 212, '1', '1', '0', '0', 'virus', 'virus1', '', 'A virus is spreading through Habbo Hotel. Many casualties reported and it could get much worse! Whether you are hoping to help infected Habbos or look after number one, get your hands on our terrifying Infection furni.', NULL, NULL, NULL, 0, ''),
	(390, 375, '2009_house', '\'09 - Haunted House', 'default_3x3', 1, 34, 1, 3, '1', '1', '0', '0', 'hween_header', 'art_hween09_stake', '', 'Who doesn\'t love a good Haunted House? Creep out your friends with this furni line!', NULL, NULL, NULL, 0, ''),
	(416, 209, 'santorini', 'Santorini', 'default_3x3', 1, 273, 1, 170, '1', '1', '0', '0', 'santorini_header', 'teaser_santorini', '', 'Straight from the country of Greece.. Right here at Habbo.', NULL, NULL, NULL, 0, ''),
	(400, 374, '2015_candyland', '\'15 - Candyland', 'default_3x3', 1, 255, 1, 7, '1', '1', '0', '0', 'candyland_header', 'candyland_clothing', '', 'Have you ever wanted a room filled with edible furniture? Of course you have! And now you can build it!', NULL, NULL, NULL, 0, ''),
	(417, 209, 'summer_bazaar', 'Bazaar', 'default_3x3', 1, 275, 1, 32, '1', '1', '0', '0', 'bazaar_header', 'bazaar_new', '', 'New, colourful and inspired by Arabian luxury, shop around and find some things for your own market!', NULL, NULL, NULL, 0, ''),
	(418, 209, 'pastel', 'Pastel', 'default_3x3', 1, 284, 1, 148, '1', '1', '0', '0', 'pastel_header', 'pastel_teaser', '', 'Cute and funny, just like you!', NULL, NULL, NULL, 0, ''),
	(419, 209, 'modern_studio', 'Modern Studio', 'default_3x3', 1, 220, 1, 132, '1', '1', '0', '0', 'feature_cata_hort_modernapt17', 'modern_teaser', '', 'Modern Studio Furni! You asked for it... We added it! Have fun in your new Studio Apartments!', NULL, NULL, NULL, 0, ''),
	(399, 375, '2018_laboratory', '\'18 - Laboratory', 'default_3x3', 1, 282, 1, 12, '1', '1', '0', '0', 'laboratory_header', 'laboratory_teaser', '', 'If you\'re not a mad scientist, then what kind of scientist are you? Create your perfect laboratory here!', NULL, NULL, NULL, 0, ''),
	(391, 375, '2010_voodoo', '\'10 - Voodoo', 'default_3x3', 1, 79, 1, 4, '1', '1', '0', '0', 'catalog_voodoo_header_en', 'voodoo_teaser', '', 'WooOOOOooOOoo! Spooky! Don\'t wanna be left alone with this range at night.. who knows what could happen!', NULL, NULL, NULL, 0, ''),
	(398, 375, '2017_cursed_caves', '\'17 - Cursed Caves', 'default_3x3', 1, 276, 1, 11, '1', '1', '0', '0', 'hween17_header', 'spromo_hween17_gen1', '', 'Build your own dungeon, you filthy little Habbo.', NULL, NULL, NULL, 0, ''),
	(392, 375, '2011_party', '\'11 - Party', 'default_3x3', 1, 34, 1, 5, '1', '1', '0', '0', 'halloween', 'Hween11_teaser', '', 'Looking for a frightastical room? Well, this is the place to be! We have everything you need to spook your friends this Halloween!', NULL, NULL, NULL, 0, ''),
	(397, 375, '2016_ghost_hunter', '\'16 - Ghost Hunter', 'default_3x3', 1, 267, 1, 10, '1', '1', '0', '0', 'ghost_header', 'ghost_teaser', '', 'Spooky lobbies, hotel rooms and libraries. Or, not spooky! Use the Purification Device and use powder to purify the furni.', NULL, NULL, NULL, 0, ''),
	(402, 372, 'summer', 'Summer', 'default_3x3', 1, 57, 1, 5, '1', '0', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(396, 375, '2015_habbocalypse', '\'15 - Habbocalypse', 'default_3x3', 1, 262, 1, 9, '1', '1', '0', '0', 'hween2015_header', 'hween2015_teaser', '', 'Darkness and evil is spreading through the hotel and you\'re one of the ONLY Habbos that can fight the bad energy! Dodge Evil Frank, avoid dark shadowy places and make it your mission to save Habbo Hotel from complete and TOTAL annihilation!', NULL, NULL, NULL, 0, ''),
	(421, 218, 'sound_fx', 'Sound FX', 'default_3x3', 1, 4, 1, 7, '1', '1', '0', '0', 'catalog_wired_header1', 'wiredsound_teaser', '', 'Create your own beats and tracks by combinign these sound FX in your room. Throw a concert for your friends or even start a band in Habbo!', NULL, NULL, NULL, 0, ''),
	(591, 599, 'panda_statues', 'Panda Statues', 'default_3x3', 1, 42, 4, 4, '1', '1', '0', '0', '', 'Spromo_Bonus_Bags', '', NULL, NULL, NULL, NULL, 0, ''),
	(422, 209, 'pro_gamer', 'Pro Gamer', 'default_3x3', 1, 202, 1, 158, '1', '1', '0', '0', 'gamer_header', 'gamer_teaser', '', 'Many people have heard of Legend of Selda, but what about Hario and Wuigi?', NULL, NULL, NULL, 0, ''),
	(395, 375, '2014_day_of_the_dead', '\'14 - Day of the Dead', 'default_3x3', 1, 231, 1, 8, '1', '1', '0', '0', 'hween14_catalog_header', 'hween14_catalog_teaser', '', 'Spooky skulls, bright flowers and traditional altars fill this furni line! Gather your friends and family and come together to celebrate the Habbos of the past.', NULL, NULL, NULL, 0, ''),
	(394, 375, '2013_frightful', '\'13 - Frightful', 'default_3x3', 1, 34, 1, 7, '1', '1', '0', '0', 'hween13_header', 'hween13_roombundle', '', 'Now you can spook up your castle for Halloween! Make sure to add some Demonic Sheep for the full effect.', NULL, NULL, NULL, 0, ''),
	(423, 3, 'effects', 'Effects', 'default_3x3', 1, 61, 1, 13, '1', '1', '0', '0', 'avatar_fx_header', 'permeffects_teaser', '', 'ALL NEW Permanent effects are here! Sick of purchasing effects multiple times? Want to keep effects forever? Want to trade your way to the top of the effects kingdom? Well then, Permanent effects are for you!', NULL, NULL, NULL, 0, ''),
	(424, 209, 'coral_kingdom', 'Coral Kingdom', 'default_3x3', 1, 280, 1, 50, '1', '1', '0', '0', 'catalog_shells_header', 'coralking18_gen', '', 'It\'s here! The all new Coral Kingdom furni line is in the Catalogue. Build your own version of Atlantis in Habbo TODAY!', NULL, NULL, NULL, 0, ''),
	(498, 557, 'ecotron', 'Ecotron', 'default_3x3', 1, 163, 7, 50, '1', '0', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(393, 375, '2012_carnival', '\'12 - Carnival', 'default_3x3', 1, 165, 1, 6, '1', '1', '0', '0', 'hween12_header', 'hween_12_furni', '', 'Carnivals are already creepy, but our Halloween Carnivale furni will really max out the creep factor!', NULL, NULL, NULL, 0, ''),
	(258, 311, 'azure_rares', 'Azure Rares', 'default_3x3', 1, 42, 6, 1, '1', '1', '0', '0', '', 'Azure', '', NULL, NULL, NULL, NULL, 0, ''),
	(259, 311, 'emerald_rares', 'Emerald Rares', 'default_3x3', 1, 42, 6, 2, '1', '1', '0', '0', '', 'Emerald', '', NULL, NULL, NULL, NULL, 0, ''),
	(515, 511, 'clear_plasto', 'Clear Plasto', 'default_3x3', 1, 154, 1, 3, '1', '1', '0', '0', 'plastic', 'plastic_pasic_promo_1', '', 'Throw on an afro and grab a disco ball! Feel that retro, 1970s vibe? You soon will with this colourful, plastic range! Choose a colour to suit your mood and off you go!\n', NULL, NULL, NULL, 0, ''),
	(516, 442, 'idea_agency', 'Idea Agency', 'default_3x3', 1, 10, 4, 32, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(425, 209, 'basement_band_kit', 'Basement Band Kit', 'default_3x3', 1, 257, 1, 28, '1', '1', '0', '0', 'music_header', 'march19_new', '', 'Everything you need to start your own basement band is right here. Three collectible \'Basement Band\' instruments are availabe in the Catalogue NOW!', NULL, NULL, NULL, 0, ''),
	(312, 599, 'books_of_knowledge', 'Books of Knowledge', 'default_3x3', 1, 42, 4, 1, '1', '1', '0', '0', '', 'Spromo_Bonus_Bags', '', NULL, NULL, NULL, NULL, 0, ''),
	(313, 442, 'night_at_the_museum_2', 'Night At The Museum 2', 'default_3x3', 1, 10, 4, 43, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(92, 680, 'bunny_bored', 'Bunny - Bored', 'pets', 1, 150, 1, 99, '1', '1', '0', '0', 'catalog_pet_headline1', '', '', 'These mischievous little pets have travelled all the way from the deep jungles of WobbahLand! Adorable as they are naughty, these little guys love a good sing-a-long.', NULL, 'Name your Obbah Wobbah:', 'Select a colour:', 0, ''),
	(427, 209, 'danish_hygge_furni', 'Danish Hygge', 'default_3x3', 1, 283, 1, 56, '1', '1', '0', '0', 'hygge_header', 'nov18_hyggeline', '', 'Walk through the door and sink into a warm pool of comfort and well-being with this Hygge furnis.', 'Choose a furni.', NULL, NULL, 0, ''),
	(428, 209, 'tokyo', 'Tokyo', 'default_3x3', 1, 281, 1, 194, '1', '1', '0', '0', 'japan_header_cn', 'tokyo18_gen', '', 'Enjoy the awesome new Tokyo-inspired furni line we\'ve released. Subarashii!', NULL, NULL, NULL, 0, ''),
	(266, 600, 'palooza_guitars', 'Palooza Guitars', 'default_3x3', 1, 263, 1, 13, '1', '1', '0', '0', 'catalog_teaser_palooza', 'catalog_teaser_palooza', '', NULL, NULL, NULL, NULL, 0, ''),
	(430, 209, 'pride_furni', 'Pride', 'default_3x3', 1, 286, 1, 154, '1', '1', '0', '0', 'pride_header', 'rbow19_gen', '', 'To celebrate Pride in Habbo, we\'re releasing a set of rainbow-coloured bedroom furni for you all!', NULL, NULL, NULL, 0, ''),
	(433, 209, 'celestial', 'Celestial', 'default_3x3', 1, 164, 1, 44, '1', '1', '0', '0', 'celestial', 'celestial_teaser', '', 'Fly among the stars with this universally loved Furni Line.', NULL, NULL, NULL, 0, ''),
	(504, 125, '2008_penguins', '2008 - Penguins', 'default_3x3', 1, 168, 5, 4, '1', '1', '0', '0', 'catalog_header_xmas2013', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(506, 209, 'habbo_stories', 'Habbo Stories', 'default_3x3', 1, 210, 6, 96, '1', '1', '0', '0', 'catalog_header_stories', 'stories_teaser', '', 'Habbo Stories ran from 2013 to 2015, and gave us a wide range of furniture.', NULL, NULL, NULL, 0, ''),
	(434, 209, 'zen_garden', 'Zen Garden', 'default_3x3', 1, 1006, 1, 222, '1', '1', '0', '0', 'zen', 'sep18_classic14_internal', '', 'It\'s time to dive into a metaphorical pool of psychological solitude.', NULL, NULL, NULL, 0, ''),
	(435, 209, 'sunlight_city', 'Sunlight City', 'default_3x3', 1, 287, 1, 186, '1', '1', '0', '0', 'sunlight_header', 'suncity19_newfurni', '', 'Build the utopian paradise of your dreams with our new furni line: Sunlight City!', NULL, NULL, NULL, 0, ''),
	(300, 557, 'limited_edition_rares', 'Limited Edition Rares', 'default_3x3', 1, 145, 6, 20, '1', '0', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(7, -1, 'staff', 'Staff', 'default_3x3', 1, 65, 4, 7, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(327, 557, 'v7_rares', 'V7 Rares', 'default_3x3', 1, 42, 6, 5, '1', '0', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(547, 442, 'virtual_piggy_ink', 'Virtual Piggy Ink', 'default_3x3', 1, 10, 4, 68, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(328, 327, 'dragon_lamps', 'Dragon Lamps', 'default_3x3', 1, 42, 1, 4, '1', '1', '0', '0', 'rares', 'Dragons', '', NULL, NULL, NULL, NULL, 0, ''),
	(329, 327, 'fans', 'Fans', 'default_3x3', 1, 42, 1, 5, '1', '1', '0', '0', 'rares', 'Fanss', '', NULL, NULL, NULL, NULL, 0, ''),
	(330, 327, 'ice_cream_machines', 'Ice Cream Machines', 'default_3x3', 1, 42, 1, 6, '1', '1', '0', '0', 'rares', 'IceCream', '', NULL, NULL, NULL, NULL, 0, ''),
	(331, 327, 'laser_gates', 'Laser Gates', 'default_3x3', 1, 42, 1, 7, '1', '1', '0', '0', 'rares', 'Lazer', '', NULL, NULL, NULL, NULL, 0, ''),
	(332, 327, 'marquees', 'Marquees', 'default_3x3', 1, 42, 1, 8, '1', '1', '0', '0', 'rares', 'Marquee', '', NULL, NULL, NULL, NULL, 0, ''),
	(333, 327, 'monoliths', 'Monoliths', 'default_3x3', 1, 42, 1, 9, '1', '1', '0', '0', 'rares', 'Mono', '', NULL, NULL, NULL, NULL, 0, ''),
	(334, 327, 'oriental_screens', 'Oriental Screens', 'default_3x3', 1, 42, 1, 10, '1', '1', '0', '0', 'rares', 'Oriental', '', NULL, NULL, NULL, NULL, 0, ''),
	(335, 327, 'pillars', 'Pillars', 'default_3x3', 1, 42, 1, 10, '1', '1', '0', '0', 'rares', 'Pillars', '', NULL, NULL, NULL, NULL, 0, ''),
	(336, 327, 'smoke_machines', 'Smoke Machines', 'default_3x3', 1, 42, 1, 12, '1', '1', '0', '0', 'rares', 'Smokes', '', NULL, NULL, NULL, NULL, 0, ''),
	(337, 311, 'maroon_rares', 'Maroon Rares', 'default_3x3', 1, 77, 6, 3, '1', '1', '0', '0', '', '5af5b5_prizepack_3d', '', NULL, NULL, NULL, NULL, 0, ''),
	(338, 442, 'niko', 'Niko', 'default_3x3', 1, 10, 4, 44, '1', '1', '0', '0', 'catalog_header_niko_en', 'catalog_niko_en', '', NULL, NULL, NULL, NULL, 0, ''),
	(339, 442, 'habbo_mobile_app', 'Habbo Mobile App', 'default_3x3', 1, 10, 4, 30, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(360, 387, 'habburgers', 'Habburgers', 'default_3x3', 1, 264, 1, 10, '1', '1', '0', '0', 'catalog_header_classics', 'aug16_classic2_internal', '', 'The room description was "American classics - burgers, fries and shakes. And ketchup, so much ketchup."', NULL, NULL, NULL, 0, ''),
	(340, 348, 'sleeping_bags', 'Sleeping Bags', 'default_3x3', 1, 42, 1, 4, '1', '1', '0', '0', 'rares', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(341, 348, 'one_way_gates', 'One Way Gates', 'default_3x3', 1, 42, 1, 3, '1', '1', '0', '0', 'rares', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(342, 348, 'inflatable_chairs', 'Inflatable Chairs', 'default_3x3', 1, 234, 1, 1, '1', '1', '0', '0', 'inflatable_chairs_cata_header', 'inflateable_chairs_teaser', '', 'They say that these chairs are Suuuuuper soft because of the air that keeps them full, how about buying one and experiencing yourself? Enjoy!\n', NULL, NULL, NULL, 0, ''),
	(343, 348, 'traffic_lights_barriers', 'Traffic Lights & Road Barriers', 'default_3x3', 1, 42, 1, 5, '1', '1', '0', '0', 'rares', 'catalog_teaser_traffic_signs', '', NULL, NULL, NULL, NULL, 0, ''),
	(557, 7, 'rare_groups', 'Rare Groups', 'default_3x3', 1, 256, 4, 1, '1', '0', '0', '0', '', ' ', '', NULL, NULL, NULL, NULL, 0, ''),
	(344, 348, 'miscellaneous', 'Miscellaneous', 'default_3x3', 1, 42, 1, 2, '1', '1', '0', '0', 'rares', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(345, 557, 'collectibles', 'Collectables', 'default_3x3', 1, 64, 5, 40, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(346, 442, 'others', 'Others', 'default_3x3', 1, 10, 4, 80, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(347, 327, 'pillows', 'Pillows', 'default_3x3', 1, 42, 1, 11, '1', '1', '0', '0', 'rares', 'Pillows', '', NULL, NULL, NULL, NULL, 0, ''),
	(492, 345, 'merge_compensation', 'Merge Compensation', 'default_3x3', 1, 64, 1, 3, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(495, 442, 'builder\'s_club_birthday', 'Builder\'s Club Birthday', 'default_3x3', 1, 10, 4, 7, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(403, 402, '2010_big_wave', '\'10', 'default_3x3', 1, 57, 1, 5, '1', '1', '0', '0', 'summer', 'summer_teaser', '', 'Even more floats! Make your pool party perfect with some inflatables.', NULL, NULL, NULL, 0, ''),
	(405, 402, '2007', 'Classics', 'default_3x3', 1, 57, 1, 1, '1', '1', '0', '0', 'summer', 'summer_teaser', '', 'Relax by the beach with these chairs and BBQs!', NULL, NULL, NULL, 0, ''),
	(407, 402, '2011', '\'11', 'default_3x3', 1, 57, 1, 6, '1', '1', '0', '0', 'summer', 'summer_teaser', '', 'A bonfire on the beach with some Habbo tunes, nothing beats it.', NULL, NULL, NULL, 0, ''),
	(408, 209, '2008_tiki', 'Tiki', 'default_3x3', 1, 59, 1, 192, '1', '1', '0', '0', 'catalog_tiki_header1_en', 'tiki_teaser', '', 'Imagine the scene.. lost on a desert island when you stumble across a small local tribe.. now you can with our Tiki range!\n', NULL, NULL, NULL, 0, ''),
	(409, 402, '2017', '\'17', 'default_3x3', 1, 274, 1, 8, '1', '1', '0', '0', 'summer', 'summer_teaser', '', 'A burger and some shades are all you need to explore a beach town!', NULL, NULL, NULL, 0, ''),
	(681, 680, 'cows', 'Cows', 'pets', 1, 270, 1, 99, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(680, 7, 'pets', 'Special Pets', 'default_3x3', 1, 8, 6, 20, '1', '0', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(518, 209, 'rainy_day', 'Rainy Day', 'default_3x3', 1, 1005, 1, 162, '1', '1', '0', '0', 'rainyday_header', 'spromo_rainy19_gen', '', 'You\'ll never get soaked again.', NULL, NULL, NULL, 0, ''),
	(519, 209, 'supermarket', 'Supermarket', 'default_3x3', 1, 213, 1, 190, '1', '1', '0', '0', 'supermarket_teaser', 'bundle_supermarket_teaser', '', 'Get that last minute shopping in with our supermarket furni!', NULL, NULL, NULL, 0, ''),
	(501, 209, 'laundry', 'Laundry', 'default_3x3', 1, 279, 1, 118, '1', '1', '0', '0', 'laundry_header', 'laundry_teaser', '', 'Kick back and play some games while your clothes wash!', NULL, NULL, NULL, 0, ''),
	(521, 375, '2019_coven', '\'19 - Witches\' Coven', 'default_3x3', 1, 288, 1, 13, '1', '1', '0', '0', 'hween19_header', 'hween19_teaser', '', 'We\'re getting witchy this year! Make your own coven...', NULL, NULL, NULL, 0, ''),
	(522, 209, 'dessert_cafe', 'Dessert Cafe', 'default_3x3', 1, 272, 1, 62, '1', '1', '0', '0', 'dessert_header', 'dessert_teaser', '', 'Who loves desserts? If you do, make sure to pick up some of this Dessert Cafe furni!', NULL, NULL, NULL, 0, ''),
	(185, 442, 'kung_fu_panda_2', 'Kung Fu Panda 2', 'default_3x3', 1, 10, 4, 35, '1', '1', '0', '0', '', 'ctlg_pic_ads_twi_mist', '', 'I\'ve never read the book, all I know is it has vampires playing basket ball and some heart throb called Edward Cullen, but the furni looks good!', NULL, NULL, NULL, 0, ''),
	(307, 125, 'credit_furni', 'Credit Furni', 'default_3x3', 1, 146, 7, 1, '1', '1', '0', '0', 'catalog_bank_headline1', 'catalog_bank_teaser', '', 'Habbo Exchange is where you can convert your Credits into a tradable currency. You can then use this currency to trade for Furni or just show off your riches in your room.', NULL, NULL, NULL, 0, ''),
	(278, 4, 'breeding_boxes', 'Breeding Boxes', 'default_3x3', 1, 99, 1, 4, '1', '1', '0', '0', 'babypets_cata_header', 'babypets_teaser', '', 'To breed a baby pet, you need to purchase a breeding nest and have two adult pets of the same type.  At least one of the adult pets need to be owned by you. Breeding nest vanishes after breeding is done. Over 20 breeds of each baby pet available, including rare and super rare!', NULL, NULL, NULL, 0, ''),
	(589, 3, 'new_additions', 'New Additions', 'default_3x3', 1, 215, 1, 2, '1', '1', '0', '0', 'clothing_catalog_header', 'newclothingeaster16', '', 'The biggest clothing update for YEARS just landed in the Catalogue. We\'ll say no more - just GO LOOK!', NULL, NULL, NULL, 0, ''),
	(593, 209, 'elegant', 'Elegant', 'default_3x3', 1, 51, 1, 68, '1', '1', '0', '0', 'elegant_header', 'elegant_teaser', '', 'Don\'t forget, pinkies out!', NULL, NULL, NULL, 0, ''),
	(47, 526, 'hello', 'Hello', 'default_3x3', 1, 35, 1, 2, '1', '1', '0', '0', 'catalog_hello_header1_da', 'pixel3', '', NULL, NULL, NULL, NULL, 0, ''),
	(555, 526, 'kuurna', 'Kuurna', 'default_3x3', 1, 121, 1, 3, '1', '1', '0', '0', 'ctlg_kuurna_en', 'kuurna_teaser', '', NULL, NULL, NULL, NULL, 0, ''),
	(23, 526, 'pixel_rentals', 'Ducket Rentals', 'default_3x3', 1, 178, 1, 6, '1', '1', '0', '0', 'rental10', 'pixel3', '', NULL, NULL, NULL, NULL, 0, ''),
	(526, 2, 'pixels', 'Duckets', 'info_duckets', 1, 178, 1, 12, '1', '1', '0', '0', 'tienda-pixel', 'pixel3', '', NULL, NULL, NULL, NULL, 0, ''),
	(194, 526, 'pixel_pet_accessories', 'Ducket Pet Accessories', 'default_3x3', 1, 20, 1, 4, '1', '1', '0', '0', 'petfood_header', 'deals_petfood', '', NULL, NULL, NULL, NULL, 0, ''),
	(275, 377, 'countdown', 'Countdown', 'default_3x3', 1, 91, 1, 1, '1', '1', '0', '0', 'newyears', 'catal_fp_pic5', '', 'All these years have gone by, relive them with this furni.', NULL, NULL, NULL, 0, ''),
	(596, 311, 'teal_rares', 'Teal Rares', 'default_3x3', 1, 42, 6, 4, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(326, 373, '2019_log_cabin', '\'19 - Log Cabin', 'default_3x3', 1, 168, 1, 17, '1', '1', '0', '0', 'logcabin_header', 'logcabin_teaser', '', 'Mixing this line with the Winter Cabin Furni, you could make a multi-roomed cozy cabin for you and your friends.', NULL, NULL, NULL, 0, ''),
	(125, 7, 'extras', 'Extras', 'pets2', 1, 215, 5, 55, '1', '0', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(325, 373, '2019_winter_palace', '\'19 - Winter Palace', 'default_3x3', 1, 289, 1, 18, '1', '1', '0', '0', 'xmas19_header', 'icepalace_teaser', '', 'Time to <i>chill</i> out and relax in an icy palace. Just <i>let it go</i>, man.', NULL, NULL, NULL, 0, ''),
	(196, 387, 'picnic', 'Picnic - Modern', 'default_3x3', 1, 264, 1, 21, '1', '1', '0', '0', 'catalog_header_classics', 'catal_fp_pic5', '', 'The remodel was debuted in February 2015, and was renamed from Picnic Area to Picnic.', NULL, NULL, NULL, 0, ''),
	(93, 680, 'bunny_manic', 'Bunny - Manic', 'pets', 1, 149, 1, 99, '1', '1', '0', '0', 'catalog_pet_headline1', '', '', 'One of the most feared creatures in nature, and perhaps the most misunderstood. The majority of Spiders have sharp fangs that inject venom into their prey- but don\'t worry, these spiders won\'t bite ! Maybe...', NULL, 'Name your pet:', NULL, 0, ''),
	(99, 221, 'kittens', 'Kittens', 'pets', 1, 228, 1, 2, '1', '1', '0', '0', 'catalog_pet_headline1', '', '', 'Leaping their way around the Hotel, these fluffy furballs are here to steal your heart...and your yarn!', NULL, 'Name your pet:', NULL, 0, ''),
	(100, 221, 'puppies', 'Puppies', 'pets', 1, 228, 1, 1, '1', '1', '0', '0', 'catalog_pet_headline1', '', '', 'So soft and cuddly, these playful pups are certain to melt your heart. From Labradors to Dalmatians, there\'s a breed for everyone!', NULL, 'Name your pet:', NULL, 0, ''),
	(101, 221, 'piglets', 'Piglets', 'pets', 1, 228, 1, 3, '1', '1', '0', '0', 'catalog_pet_headline1', '', '', 'OINK! Partial to a good roll in the mud, these playful piggies have trotted into the hotel and are ready for fun!', NULL, 'Name your pet:', NULL, 0, ''),
	(198, 442, 'bubblejuice', 'BubbleJuice', 'default_3x3', 1, 10, 4, 6, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(46, 253, 'trax', 'Trax', 'default_3x3', 1, 257, 1, 198, '1', '1', '0', '0', 'hotelhits_catalog_header', 'hotelhits_teaser', '', 'Trax are the Habbo music disks which have many multiple tunes installed onto them which can be played on a Trax Machine in the room. After the Habbo transistion from Shockwave to Flash clients, the trax system was not recovered until April 2011, where only Juke Boxes, old CDs, and Habbo sold CDs were re-released.', NULL, 'For decoration only.. They do not function.', NULL, 0, ''),
	(311, 557, 'colourable_rares', 'Colourable Rares', 'default_3x3', 1, 42, 6, 15, '1', '0', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(529, 442, 'ob', 'OB', 'default_3x3', 1, 10, 4, 47, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(530, 442, 'mtv', 'MTV', 'default_3x3', 1, 10, 4, 40, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(531, 442, 'malaco', 'Malaco', 'default_3x3', 1, 10, 4, 38, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(532, 442, 'm6', 'M6', 'default_3x3', 1, 10, 4, 36, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(533, 442, 'gs_arcade', 'GS Arcade', 'default_3x3', 1, 10, 4, 28, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(534, 442, 'grefusa', 'Grefusa', 'default_3x3', 1, 10, 4, 27, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(535, 442, 'clearasil', 'Clearasil', 'default_3x3', 1, 10, 4, 14, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(98, 680, 'terrier_puppies', 'Terrier Puppies', 'pets', 1, 228, 1, 5, '1', '1', '0', '0', 'catalog_pet_headline1', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(537, 442, 'capri_sun', 'Capri Sun', 'default_3x3', 1, 10, 4, 9, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(96, 680, 'monkey_evil', 'Monkey - Evil', 'pets', 1, 167, 1, 99, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(97, 680, 'bear_cubs', 'Bear Cubs', 'pets', 1, 228, 1, 1, '1', '1', '0', '0', 'catalog_pet_headline1', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(538, 442, 'ditch_the_label', 'Ditch The Label', 'default_3x3', 1, 10, 4, 18, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(94, 680, 'pigeon_wise', 'Pigeon - Wise', 'pets', 1, 160, 1, 99, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(95, 680, 'pigeon_cunning', 'Pigeon - Cunning', 'pets', 1, 160, 1, 99, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(539, 442, 'tampax', 'Tampax', 'default_3x3', 1, 10, 4, 65, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(540, 442, 'netari', 'Netari', 'default_3x3', 1, 10, 4, 41, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(541, 442, 'easy_mac', 'Easy Mac', 'default_3x3', 1, 10, 4, 21, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(542, 442, 'persy_jackson', 'Persy Jackson', 'default_3x3', 1, 10, 4, 53, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(601, 599, 'punching_bags', 'Punching Bags', 'default_3x3', 1, 42, 4, 5, '1', '1', '0', '0', '', 'Spromo_Bonus_Bags', ' ', NULL, NULL, NULL, NULL, 0, ''),
	(745, 300, '2019_ltds', '2019 LTDs', 'default_3x3', 1, 145, 1, 8, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(746, 300, '2020_ltds', '2020 LTDs', 'default_3x3', 1, 145, 1, 9, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(543, 442, 'sunny_delight', 'Sunny Delight', 'default_3x3', 1, 10, 4, 62, '1', '1', '0', '0', 'calippo_header_es', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(544, 442, 'puffet', 'Puffet', 'default_3x3', 1, 10, 4, 54, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(545, 442, 'antena_3', 'Antena 3', 'default_3x3', 1, 10, 4, 4, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(546, 442, 'chocapic', 'Chocapic', 'default_3x3', 1, 10, 4, 12, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(280, 209, 'habbowood', 'Habbowood', 'default_3x3', 1, 33, 1, 102, '1', '1', '0', '0', 'habbowood', 'habbowood_logo', '', 'Whether it\'s a boulevard of stars, a cinema, a theatre, a dressing room or an entire film studio - the Habbowood furni ticks all the stage exit right boxes!', NULL, NULL, NULL, 0, ''),
	(577, 624, 'rare_clothing_2017', '[R] Clothing - 2017', 'default_3x3', 2, 42, 6, 3, '1', '1', '0', '0', '', 'vippremium2', '', 'Unreleased rare clothing.', NULL, NULL, NULL, 0, ''),
	(578, 624, 'rare_clothing_2018', '[R] Clothing - 2018', 'default_3x3', 3, 42, 6, 4, '1', '1', '0', '0', '', 'vippremium2', '', 'Unreleased rare clothing.', NULL, NULL, NULL, 0, ''),
	(579, 624, 'rare_clothing_2019', '[R] Clothing - 2019', 'default_3x3', 4, 42, 6, 5, '1', '1', '0', '0', '', 'vippremium2', '', 'Unreleased rare clothing.', NULL, NULL, NULL, 0, ''),
	(580, 624, 'rare_clothing_2016', '[R] Clothing - 2016', 'default_3x3', 1, 42, 6, 2, '1', '1', '0', '0', '', 'vippremium2', '', 'Unreleased rare clothing.', NULL, NULL, NULL, 0, ''),
	(585, 624, 'golden_accessories', 'Golden Accessories', 'default_3x3', 1, 263, 6, 10, '1', '1', '0', '0', '', 'vippremium2', '', NULL, NULL, NULL, NULL, 0, ''),
	(581, 668, '2015-16_new_year_acc.', '2015-16 NY Acc.', 'default_3x3', 1, 42, 1, 1, '1', '1', '0', '0', '', ' ', '', 'This furniture is used in a New Years Crackable.', NULL, NULL, NULL, 0, ''),
	(582, 668, '2017-18_new_year_acc.', '2017-18 NY Acc.', 'default_3x3', 1, 42, 1, 3, '1', '1', '0', '0', '', '', '', 'This furniture is used in a New Years Crackable.', NULL, NULL, NULL, 0, ''),
	(583, 668, '2016-17_new_year_acc.', '2016-17 NY Acc.', 'default_3x3', 1, 42, 1, 2, '1', '1', '0', '0', '', '', '', 'This furniture is used in a New Years Crackable.', NULL, NULL, NULL, 0, ''),
	(584, 668, '2018-19_new_year_acc.', '2018-19 NY Acc.', 'default_3x3', 1, 42, 1, 4, '1', '1', '0', '0', '', '', '', 'This furniture is used in a New Years Crackable.', NULL, NULL, NULL, 0, ''),
	(525, 209, 'bohemian_festival', 'Bohemian Festival', 'default_3x3', 1, 285, 1, 38, '1', '1', '0', '0', 'festival_header', 'Spromo_fest19_gen', '', 'It\'s time for a festival!', NULL, NULL, NULL, 0, ''),
	(305, 442, 'chupa_chups', 'Chupa Chups', 'default_3x3', 1, 10, 4, 13, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(556, 209, 'candy', 'Candy', 'default_3x3', 1, 19, 1, 42, '1', '1', '0', '0', 'catalog_candy_headline1', 'catalog_candy_teaser1', '', 'For those looking for a girlier version of Mode.', NULL, NULL, NULL, 0, ''),
	(548, 442, 'paula', 'Paula', 'default_3x3', 1, 10, 4, 51, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(549, 442, 'rango', 'Rango', 'default_3x3', 1, 10, 4, 56, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(550, 442, 'frank', 'Frank', 'default_3x3', 1, 10, 4, 25, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(551, 442, 'escape_from_madagascar', 'Escape From Madagascar', 'default_3x3', 1, 10, 4, 23, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(552, 442, 'coolpolitics', 'Coolpolitics', 'default_3x3', 1, 10, 4, 15, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(553, 442, 'cheetos', 'Cheetos', 'default_3x3', 1, 10, 4, 11, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(554, 442, 'durex', 'Durex', 'default_3x3', 1, 10, 4, 20, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(597, 599, 'sloth_statues', 'Sloth Statues', 'default_3x3', 1, 42, 4, 7, '1', '1', '0', '0', '', 'Spromo_Bonus_Bags', '', NULL, NULL, NULL, NULL, 0, ''),
	(742, 300, '2016_ltds', '2016 LTDs', 'default_3x3', 1, 145, 1, 5, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(743, 300, '2017_ltds', '2017 LTDs', 'default_3x3', 1, 145, 1, 6, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(744, 300, '2018_ltds', '2018 LTDs', 'default_3x3', 1, 145, 1, 7, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(598, 599, 'hedgehog_statues', 'Hedgehog Statues', 'default_3x3', 1, 42, 4, 2, '1', '1', '0', '0', '', 'Spromo_Bonus_Bags', '', NULL, NULL, NULL, NULL, 0, ''),
	(738, 300, '2012_ltds', '2012 LTDs', 'default_3x3', 1, 145, 1, 1, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(739, 300, '2013_ltds', '2013 LTDs', 'default_3x3', 1, 145, 1, 2, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(740, 300, '2014_ltds', '2014 LTDs', 'default_3x3', 1, 145, 1, 3, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(599, 557, 'bonus_prizes', 'Bonus Prizes', 'default_3x3', 1, 258, 4, 35, '1', '0', '0', '0', '', 'Spromo_Bonus_Bags', '', NULL, NULL, NULL, NULL, 0, ''),
	(741, 300, '2015_ltds', '2015 LTDs', 'default_3x3', 1, 145, 1, 4, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(674, 7, 'crafting', 'Crafting', 'default_3x3', 1, 1004, 4, 45, '1', '0', '0', '0', '', '', '', 'Either used as prizes or ingredients.', NULL, NULL, NULL, 0, ''),
	(569, 387, 'hoh_winner_statues', 'HoH Winner Statues', 'default_3x3', 1, 264, 1, 13, '1', '1', '0', '0', 'catalog_header_classics', 'catal_fp_pic5', '', 'These statues are shown in the Hall of Habbo as a celebration of 15 years of Habbo.', NULL, NULL, NULL, 0, ''),
	(657, 763, 'exotic_birds', 'Exotic Birds', 'default_3x3', 1, 294, 1, 1, '1', '1', '0', '0', 'catalog_pet_headline1', 'exoticanimal_teaser', '', 'Gotta catch \'em all!', NULL, NULL, NULL, 0, ''),
	(658, 763, 'northern_american_animals', 'North American Animals', 'default_3x3', 1, 294, 1, 4, '1', '1', '0', '0', 'catalog_pet_headline1', 'na_animals_teaser', '', 'Gotta catch \'em all!', NULL, NULL, NULL, 0, ''),
	(664, 7, 'bonus_bags', 'Bonus Bags', 'default_3x3', 1, 263, 4, 40, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(665, 7, 'seasonal_crackables', 'Seasonal Crackables', 'pets2', 1, 263, 4, 35, '1', '1', '0', '0', '', '', '', NULL, '<b>Crackables</b>', 'Contains all seasonal crackables and all the prizes. Use the items_crackable table to match the crackables to the exact prizes.', 'WARNING: Pages could be slow loading due to number of items. All rewards can be found in the `prizes` column in the `items_crackable` table.', 0, ''),
	(668, 665, 'new_year_crackables', 'New Year Crackables', 'default_3x3', 1, 263, 1, 100, '1', '1', '0', '0', '', '', '', 'These must be placed in the main catalogue somewhere for your users to be able to get the prizes, and any linked crafting recipes.', NULL, NULL, NULL, 0, ''),
	(180, 209, 'pura', 'Pura', 'default_3x3', 1, 48, 1, 160, '1', '1', '0', '0', 'catalog_header_pura', 'catalog_pura_teaser1', '', 'This collection breathes frresh, clean air and cool tranquility. Use it to create a haven away from the hullabaloo of the public spaces or your life outside the hotel.', NULL, NULL, NULL, 0, ''),
	(187, 253, 'trax_machines', 'Trax Machines', 'default_3x3', 1, 257, 1, 200, '1', '1', '0', '0', 'music_header', 'catalog_djshop_teaser1', '', 'Let\'s get loud! Trax is an old, well-known feature of Habbo where you could mix your own tracks and get pumpin\'. It\'s not the same without it, but at least the machines are still available!', NULL, NULL, NULL, 0, ''),
	(619, 218, 'how_to_use_wired', 'How To Use Wired', 'info_loyalty', 1, 42, 1, 9, '1', '1', '0', '0', '', '', '', '1. <a href="event:habbopages/wired_triggers">Wired Triggers</a>\r\n2. <a href="event:habbopages/wired_effects">Wired Effects</a>\r\n3. <a href="event:habbopages/wired_conditions">Wired Conditions</a>\r\n4. <a href="event:habbopages/wired_addons">Wired Addons</a>\r\n5. <a href="event:habbopages/wired_leaderboards">Wired Leaderboards</a>', NULL, NULL, NULL, 0, ''),
	(630, 219, 'rollerskating', 'Rollerskating', 'default_3x3', 1, 94, 1, 9, '1', '1', '0', '0', 'catalog_rollerskates_header', 'catalog_teaser_rollerblades', '', 'Show off your tricks on the rink, get your derby going or just invite your friends to a good ol\' roller party! PS. the rink looks great when dressed up with some Neon or Diner Furni!', NULL, NULL, NULL, 0, ''),
	(263, 442, 'miss_mix', 'Miss Mix', 'default_3x3', 1, 10, 4, 39, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(690, 599, 'seal_statues', 'Seal Statues', 'default_3x3', 1, 42, 4, 6, '1', '1', '0', '0', '', 'Spromo_Bonus_Bags', '', NULL, NULL, NULL, NULL, 0, ''),
	(636, 624, 'nt_clothing', 'NT Clothing', 'default_3x3', 1, 42, 5, 11, '1', '1', '0', '0', '', 'vippremium2', '', 'NT stands for Non-Tradable; unsure what Habbo uses these for, but they could be used in competitions and events as prizes.', NULL, NULL, NULL, 0, ''),
	(656, 180, 'aqua_dark_pura', 'Dark Pura', 'default_3x3', 1, 48, 1, 11, '1', '1', '0', '0', 'catalog_header_pura', 'catalog_pura_teaser1', '', 'This collection breathes frresh, clean air and cool tranquility. Use it to create a haven away from the hullabaloo of the public spaces or your life outside the hotel.', NULL, NULL, NULL, 0, ''),
	(193, 820, 'tokyo_crackables', 'Tokyo Crackables', 'default_3x3', 1, 263, 5, 15, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(683, 125, 'other', 'Other (Unreleased)', 'default_3x3', 1, 42, 7, 9, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(685, 680, 'epic_pet_(alone)', 'Epic Pet (alone)', 'pets', 1, 42, 4, 9, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(301, 442, 'alvin', 'Alvin', 'default_3x3', 1, 10, 4, 2, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(687, 624, 'rare_clothing_2020', '[R] Clothing - 2020', 'default_3x3', 1, 42, 6, 6, '1', '1', '0', '0', '', 'vippremium2', '', 'Unreleased rare clothing.', NULL, NULL, NULL, 0, ''),
	(688, 668, '2019-20_ny_acc.', '2019-20 NY Acc.', 'default_3x3', 1, 42, 1, 5, '1', '1', '0', '0', '', '', '', 'This furniture is used in a New Years Crackable.', NULL, NULL, NULL, 0, ''),
	(689, 953, 'masks', 'Masks', 'default_3x3', 1, 214, 1, 9, '1', '1', '0', '1', 'catalog_header_hc', 'teaser_habboclub', 'catalog_special_txtbg2', 'As a member of Habbo Club or HC, you can shop from this selection of exclusive items. Every now and then we will also be adding items that are currently unavailable in the regular Furni Shop as well!', NULL, NULL, 'For Club members only!', 0, ''),
	(692, 376, '2020_cafe', '\'20 - Cafe', 'default_3x3', 1, 283, 1, 22, '1', '1', '0', '0', 'catalog_header_val12_2_en', 'val20_teaser', '', 'Create your own romantic café with this Valentines furni line.', NULL, NULL, NULL, 0, ''),
	(693, 664, 'bonus_rare_20', 'Bonus Rare 20', 'default_3x3', 1, 263, 1, 5, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(570, 624, 'unreleased_clothing', 'Unreleased Clothing', 'default_3x3', 1, 42, 5, 1, '1', '1', '0', '0', '', 'vippremium2', '', 'Clothing that isn\'t released in the main catalogue.', NULL, NULL, NULL, 0, ''),
	(517, 209, 'art', 'Art Studio', 'default_3x3', 1, 195, 1, 20, '1', '1', '0', '0', 'catalog_header_alpha1', 'art_teaser', '', 'Every artist starts somewhere. What better place than your very own apartment, equipped with all the art essentials!', NULL, NULL, NULL, 0, ''),
	(226, 374, '2020_alpine_heights', '\'20 - Alpine', 'default_3x3', 1, 290, 1, 13, '1', '1', '0', '0', 'alps_header', 'alps_teaser', '', 'Setting up a campsite along the river, nothing better than nature. Make your perfect campsite today!', NULL, NULL, NULL, 0, ''),
	(264, 442, 'boost', 'Boost', 'default_3x3', 1, 10, 4, 5, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(696, 209, 'india', 'India', 'default_3x3', 1, 291, 1, 108, '1', '1', '0', '0', 'indian_header', 'indian_teaser', '', 'Fall into a new role and take on the beautiful palace views that come with it. Will you be the next Sultan?', NULL, NULL, NULL, 0, ''),
	(633, 848, 'Alpine Prizes', 'Alpine Prizes', 'default_3x3', 1, 263, 6, 8, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(265, 442, 'central_music', 'Central Music', 'default_3x3', 1, 10, 4, 10, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(309, 442, 'dave', 'Dave', 'default_3x3', 1, 10, 4, 16, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(323, 442, 'football', 'Football', 'default_3x3', 1, 10, 4, 24, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(324, 442, 'elisa', 'Elisa', 'default_3x3', 1, 10, 4, 22, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(350, 442, 'honey', 'Honey', 'default_3x3', 1, 10, 4, 31, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(351, 442, 'pepsi', 'Pepsi', 'default_3x3', 1, 10, 4, 52, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(353, 442, 'reebok', 'Reebok', 'default_3x3', 1, 10, 4, 57, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(382, 442, 'suunvuoru', 'Suunvuoru', 'default_3x3', 1, 10, 4, 64, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(451, 442, 'kelloggs', 'Kelloggs', 'default_3x3', 1, 10, 4, 34, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(461, 442, 'jaapuisto', 'Jaapuisto', 'default_3x3', 1, 10, 4, 33, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(462, 442, 'volkswagen', 'Volkswagen', 'default_3x3', 1, 10, 4, 69, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(474, 442, 'on_tour', 'On Tour', 'default_3x3', 1, 10, 4, 48, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(489, 442, 'wwe', 'WWE', 'default_3x3', 1, 10, 4, 70, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(496, 442, 'pacha', 'Pacha', 'default_3x3', 1, 10, 4, 50, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(520, 442, 'r2', 'R2', 'default_3x3', 1, 10, 4, 55, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(524, 442, 'spangas_on_survival', 'Spangas on Survival', 'default_3x3', 1, 10, 4, 58, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(560, 442, 'spiderman', 'Spiderman', 'default_3x3', 1, 10, 4, 59, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(561, 442, 'superpop', 'SuperPop', 'default_3x3', 1, 10, 4, 63, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(562, 442, 'disney', 'Disney', 'default_3x3', 1, 10, 4, 17, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(563, 442, 'yle', 'YLE', 'default_3x3', 1, 10, 4, 71, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(564, 442, 'veet', 'Veet', 'default_3x3', 1, 10, 4, 67, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(565, 442, 'nouvelle_star', 'Nouvelle Star', 'default_3x3', 1, 10, 4, 46, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(566, 442, 'dubbelfrisss', 'Dubbelfrisss', 'default_3x3', 1, 10, 4, 19, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(600, 820, 'pinatas_crackables', 'Pinatas Crackables', 'default_3x3', 1, 263, 5, 12, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(610, 820, 'coloured_rares_crackables', 'Coloured Rares Crackables', 'default_3x3', 1, 263, 5, 3, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(637, 820, 'gold_crackables', 'Gold Crackables', 'default_3x3', 1, 263, 5, 6, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(61, 820, 'santorini_crackables', 'Santorini Crackables', 'default_3x3', 1, 263, 5, 13, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(103, 820, 'coral_kingdom_crackables', 'Coral Kingdom Crackables', 'default_3x3', 1, 263, 5, 4, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(169, 820, 'hygge_crackables', 'Diamond Gift Box', 'default_3x3', 1, 263, 5, 5, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(183, 820, 'bohemian_crackables', 'Bohemian Festival Crackables', 'default_3x3', 1, 263, 5, 2, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(184, 820, 'art_crackables', 'Art Crackables', 'default_3x3', 1, 263, 5, 1, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(186, 820, 'spa_crackables', 'Spa Crackables', 'default_3x3', 1, 263, 5, 14, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(189, 820, 'india_crackables', 'India Crackables', 'default_3x3', 1, 263, 5, 10, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(191, 665, 'non-crack_versions1', 'B - VERSIONS (SC)', 'default_3x3', 1, 263, 4, 250, '1', '1', '0', '0', '', '', '', 'Habbo sometimes releases non-crackable versions of crackables; find them here.', NULL, NULL, NULL, 0, ''),
	(192, 820, 'habbo15_crackables', 'Habbo 15 Crackables', 'default_3x3', 1, 263, 5, 9, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(213, 820, 'greek_crackables', 'Greek Crackables', 'default_3x3', 1, 263, 5, 7, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(567, 600, 'pinata_prizes', 'Pinata Prizes', 'default_3x3', 1, 263, 1, 14, '1', '1', '0', '0', '', '', '', 'Any missing prizes may be in Secondary Ingredients for Crafting.', NULL, NULL, NULL, 0, ''),
	(697, 209, 'habbo-lympix', 'Habbo-Lympix', 'default_3x3', 1, 266, 1, 100, '1', '1', '0', '0', 'catalog_header_olympic16', 'catalog_teaser_olympic16', '', 'We\'ve got everything you need to spread the Habbo-lympic spirit across the Hotel, from podiums and torches to tracks and one very special lady that will serve you tea!', NULL, NULL, NULL, 0, ''),
	(701, 700, 'vanilla_executive', 'Vanilla Executive', 'default_3x3', 1, 161, 1, 1, '1', '1', '0', '0', '', 'vanillaexecutive_teaser', '', NULL, NULL, NULL, NULL, 0, ''),
	(703, 183, 'bohemian_festival_prizes', 'Bohemian Festival Prizes', 'default_3x3', 1, 263, 1, 1, '1', '1', '0', '0', '', '', '', 'Any missing prizes may be in Secondary Ingredients for Crafting.', NULL, NULL, NULL, 0, ''),
	(708, 209, 'pirates', 'Pirates', 'default_3x3', 1, 190, 1, 150, '1', '1', '0', '0', 'catalog_header_pirate', 'pirate_bundle', '', 'Yarrr! Harrrrr! Fiddle dee dee, being a pirate is alright with me!', NULL, NULL, NULL, 0, ''),
	(709, 708, 'ghost_ship', 'Ghost Ship', 'default_3x3', 1, 190, 1, 1, '1', '1', '0', '0', 'catalog_header_pirate', 'pirate_ghostshipandbadge', '', 'Yarrr! Harrrrr! Fiddle dee dee, being a pirate is alright with me!', NULL, NULL, NULL, 0, ''),
	(725, 817, 'mystics_prizes', 'Mystics Prizes', 'default_3x3', 1, 263, 1, 12, '1', '1', '0', '0', '', '', '', 'Any missing prizes may be in Secondary Ingredients for Crafting.', NULL, NULL, NULL, 0, ''),
	(727, 637, 'gold_rare_prizes', 'Gold Rare Prizes', 'default_3x3', 1, 263, 1, 7, '1', '1', '0', '0', '', '', '', 'Any missing prizes may be in Secondary Ingredients for Crafting.', NULL, NULL, NULL, 0, ''),
	(730, 61, 'santorini_prizes', 'Santorini Prizes', 'default_3x3', 1, 263, 1, 15, '1', '1', '0', '0', '', '', '', 'Any missing prizes may be in Secondary Ingredients for Crafting.', NULL, NULL, NULL, 0, ''),
	(731, 103, 'coral_kingdom_prizes', 'Coral Kingdom Prizes', 'default_3x3', 1, 263, 1, 3, '1', '1', '0', '0', '', '', '', 'Any missing prizes may be in Secondary Ingredients for Crafting.', NULL, NULL, NULL, 0, ''),
	(732, 193, 'tokyo_prizes', 'Tokyo Prizes', 'default_3x3', 1, 263, 1, 17, '1', '1', '0', '0', '', '', '', 'Any missing prizes may be in Secondary Ingredients for Crafting.', NULL, NULL, NULL, 0, ''),
	(733, 169, 'diamond_box_prizes', 'Diamond Gift Box Prizes', 'default_3x3', 1, 263, 1, 4, '1', '1', '0', '0', '', '', '', 'Any missing prizes may be in Secondary Ingredients for Crafting.', NULL, NULL, NULL, 0, ''),
	(734, 213, 'greek_prizes', 'Greek Prizes', 'default_3x3', 1, 263, 1, 8, '1', '1', '0', '0', '', '', '', 'Any missing prizes may be in Secondary Ingredients for Crafting.', NULL, NULL, NULL, 0, ''),
	(735, 186, 'spa_prizes', 'Spa Prizes', 'default_3x3', 1, 263, 1, 16, '1', '1', '0', '0', '', '', '', 'Any missing prizes may be in Secondary Ingredients for Crafting.', NULL, NULL, NULL, 0, ''),
	(679, 7, 'what_you_can_do', 'What You Can Do', 'info_loyalty', 1, 42, 4, -1, '1', '1', '0', '0', '', '', '', 'Page Text 1: <font color="#eb3528">You</font> <font color="#e69d20">can</font> <font color="#e3dc19">use</font> <font color="#8ae324">any</font> <font color="#63e622">colour</font> <font color="#19e3ad">you</font> <font color="#1856db">would</font> <font color="#6d18db">like.</font>\r\n<font size="15">And any size.</font><br>\r\n<font color="#9c0500">I use red a lot on my staff pages, and of course <b>bold for emphasis,</b> <i>italics are important</i>, and <u>underlining.</u></font><br>\r\nYou can add events to <b>some</b> page types too.<br>\r\n<a href="event:habbopages/chat">This opens a habbopage.</a><br>\r\n<a href="event:toolbar/memenu">This opens your menu.</a><br>\r\n<a href="event:navigator/search/Systemaccount">This searches the navigator.</a><br>\r\n<a href="event:avatareditor/open">This opens the Avatar Editor.</a><br>\r\n<a href="event:catalog/open/habbo_club">This opens a Catalog Page.</a><br>\r\n<font size="15"><i>You get the idea.</i><br>\r\n<font size="13">Enjoy the catalogue!</font>', NULL, NULL, NULL, 0, ''),
	(878, 117, 'white_alpha', 'White Alphabet Blocks', 'default_3x3', 1, 1001, 1, 1, '1', '1', '0', '0', 'catalog_header_alpha1', 'catalog_teaser_alpha1', '', 'A... B... C... and Z, bitch...', NULL, NULL, NULL, 0, ''),
	(5004, 233, 'terrier_habitat20', 'Terrier\'s Habitat Bundle', 'room_bundle', 1, 268, 1, 4, '1', '1', '0', '0', 'catalog_header_roombundle', 'may20_pet5_internal', '', 'For your Terrier.', 'New Room Bundle Exclusive for YOU!', 'Grab yourself a new Terrier Habitat Room-Bundle. For only 30 Credits and 30 Diamonds. This could be yours today!', '<b><i><color="#E5580E">The Bundle include:</color></b></i>', 54, ''),
	(5003, 233, 'puppy_habitat20', 'Puppy\'s Habitat Bundle', 'room_bundle', 1, 268, 1, 3, '1', '1', '0', '0', 'catalog_header_roombundle', 'may20_pet2_internal', '', 'For your Puppy.', 'New Room Bundle Exclusive for YOU!', 'Grab yourself a new Puppy Habitat Room-Bundle. For only 30 Credits and 30 Diamonds. This could be yours today!', '<b><i><color="#E5580E">The Bundle include:</color></b></i>', 53, ''),
	(5000, 233, 'pigglets_habitat20', 'Piglet\'s Habitat Bundle', 'room_bundle', 1, 268, 1, 0, '1', '1', '0', '0', 'catalog_header_roombundle', 'may20_pet3_internal', '', 'For your Pigglet.', 'New Room Bundle Exclusive for YOU!', 'Grab yourself a new Pigglet Habitat Room-Bundle. For only 30 Credits and 30 Diamonds. This could be yours today!', '<b><i><color="#E5580E">The Bundle include:</color></b></i>', 50, ''),
	(948, 589, 'neo_clothing22', 'Collectible Neo-Habbo Clothing', 'default_3x3', 1, 74, 1, 1, '1', '1', '0', '0', '', '', '', 'This clothing item comes with an exclusive badge. Pick up all eight of our collectible Neo-Habbo clothing items this month and you\'ll receive a special Mega Collector badge!', NULL, NULL, NULL, 0, ''),
	(949, 820, 'thailand21_crack', 'Tropical Thailand Crackables', 'default_3x3', 1, 263, 5, 19, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(950, 949, 'thailand21_prizes', 'Tropical Thailand Prizes', 'default_3x3', 1, 263, 5, 1, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(5002, 233, 'cat_habitat20', 'Kitten\'s Habitat Bundle', 'room_bundle', 1, 268, 1, 2, '1', '1', '0', '0', 'catalog_header_roombundle', 'may20_pet1_internal', '', 'For your Pussy.', 'New Room Bundle Exclusive for YOU!', 'Grab yourself a new Cat Habitat Room-Bundle. For only 30 Credits and 30 Diamonds. This could be yours today!', '<b><i><color="#E5580E">The Bundle include:</color></b></i>', 52, ''),
	(5001, 233, 'polarbear_habitat20', 'Polar Bear\'s Habitat Bundle', 'room_bundle', 1, 268, 1, 1, '1', '1', '0', '0', 'catalog_header_roombundle', 'may20_pet4_internal', '', 'For your Polar Bear.', 'New Room Bundle Exclusive for YOU!', 'Grab yourself a new Polar Bear Habitat Room-Bundle. For only 30 Credits and 30 Diamonds. This could be yours today!', '<b><i><color="#E5580E">The Bundle include:</color></b></i>', 51, ''),
	(5011, 233, 'room_bundle_mar2', 'NEW: Easter Treehouse Bundle', 'room_bundle', 1, 507, 1, 11, '1', '1', '0', '0', 'catalog_header_roombundle', '', '', 'Your new fancy overpriced Treehouse.', 'New Room Bundle Exclusive for YOU!', 'Pick up your own little Easter treehouse hideaway this year! Included are 15 exclusive Tulip Seed packs. Built by Frission (.COM)', '<b><i><color="#E5580E">The Bundle include:</color></b></i>', 61, ''),
	(748, 209, 'neonpunk_c20', 'Neon Punk', 'default_3x3', 1, 1008, 1, 141, '1', '1', '0', '0', 'neonpunk_header', 'neonpunk_teaser', '', 'If vibrant, neon-style colour schemes are your look and Kawaii is your thing, this furni is for you!', NULL, NULL, NULL, 0, ''),
	(749, 209, 'gothiccafe_c20', 'Gothic Cafe', 'default_3x3', 1, 1007, 1, 79, '1', '1', '0', '0', 'gothcafe_header', 'gothcafe_teaser', '', 'Enjoy a fresh dessert in the brand new Gothic Cafe furni line!', NULL, NULL, NULL, 0, ''),
	(750, 387, 'sunsetcafe_c20', 'Sunset Cafe', 'default_3x3', 1, 264, 1, 23, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(753, 387, 'habbo20_c20', 'Habbo 20', 'default_3x3', 1, 264, 1, 9, '1', '1', '0', '0', 'catalog_header_classics', 'catal_fp_pic5', '', NULL, NULL, NULL, NULL, 0, ''),
	(754, 311, 'rare_blackrosegold', 'Black Rose Gold', 'default_3x3', 1, 42, 6, 5, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(755, 593, 'darkelegant_c20', 'Dark Elegant', 'default_3x3', 1, 51, 1, 1, '1', '1', '0', '0', 'elegant_header', 'dark_elegant20_bundle', '', 'Express your darker side with the Dark Elegant furni line!', NULL, NULL, NULL, 0, ''),
	(756, 419, 'darkmodern_c20', 'Chill Modern', 'default_3x3', 1, 220, 1, 1, '1', '1', '0', '0', '', 'chillmodern_teaser', '', 'Modern Studio Furni! You asked for it... We added it! Have fun in your new Studio Apartments!', NULL, NULL, NULL, 0, ''),
	(5500, 7, 'targetoffer_int', 'Targeted Offers', 'default_3x3', 1, 206, 4, 65, '1', '1', '0', '0', '', '', '', 'Targeted offers Packs', NULL, NULL, NULL, 0, ''),
	(761, 14, 'sold_limited_rares', 'Sold Rares', 'default_3x3', 1, 198, 1, 1, '1', '1', '0', '0', 'limited_header_sold', 'limited_sold_promo', '', 'his page shows past Limited Edition Rares. They won\'t come back on sale in the Shop. If they\'re not sold out, they might be given as prizes later on, but for now the only way to get one is through trading!', NULL, NULL, NULL, 0, ''),
	(760, 820, 'habbo20_crackables', 'Habbo 20 Crackables', 'default_3x3', 1, 263, 5, 8, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(762, 27, 'Beige Dark Iced', 'Dark Iced', 'default_3x3', 1, 72, 1, 1, '1', '1', '0', '0', 'catalog_iced_headline1', 'catalog_iced_teaser1', '', 'It\'s so chic, it says everything and nothing. It\'s a blank canvas, let your imagination run wild!', NULL, NULL, NULL, 0, ''),
	(763, 209, 'animals', 'Animals', 'default_3x3', 1, 294, 1, 10, '1', '0', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(764, 209, 'grunge', 'Grunge', 'default_3x3', 1, 32, 1, 92, '1', '1', '0', '0', 'catalog_grunge_headline1', 'catalog_grunge_teaser_de', '', NULL, NULL, NULL, NULL, 0, ''),
	(765, 222, 'Blocks', 'Blocks', 'default_3x3', 1, 1002, 1, 30, '1', '0', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(767, 674, 'Tokyo Crafting', 'Tokyo Crafting', 'default_3x3', 1, 1004, 1, 13, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(768, 767, 'Tokyo Ingredients', 'Tokyo Ingredients', 'default_3x3', 1, 1, 1, 1, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(769, 767, 'Tokyo Craftables', 'Tokyo Craftables', 'default_3x3', 1, 1, 1, 2, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(770, 674, 'Habbocalypse Crafting', 'Habbocalypse Crafting', 'default_3x3', 1, 1004, 1, 7, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(771, 770, 'Habbocalypse Ingredients', 'Habbocalypse Ingredients', 'default_3x3', 1, 1004, 1, 1, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(772, 770, 'Habbocalypse Craftables', 'Habbocalypse Craftables', 'default_3x3', 1, 1004, 1, 2, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(773, 674, 'Stranded Jungle Crafting', 'Stranded Jungle Crafting', 'default_3x3', 1, 1004, 1, 11, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(774, 773, 'Stranded Jungle Ingredien', 'Stranded Jungle Ingredients', 'default_3x3', 1, 1004, 1, 1, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(775, 773, 'Stranded Jungle Craftable', 'Stranded Jungle Craftables', 'default_3x3', 1, 1004, 1, 2, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(776, 674, 'Farm Crafting', 'Farm Crafting', 'default_3x3', 1, 1004, 1, 5, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(777, 776, 'Farm Ingredients', 'Farm Ingredients', 'default_3x3', 1, 1004, 1, 1, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(778, 776, 'Farm Craftables', 'Farm Craftables', 'default_3x3', 1, 1004, 1, 2, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(779, 674, 'Bazaar Crafting', 'Bazaar Crafting', 'default_3x3', 1, 1004, 1, 1, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(780, 779, 'Bazaar Ingredients', 'Bazaar Ingredients', 'default_3x3', 1, 1004, 1, 1, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(781, 779, 'Bazaar Craftables', 'Bazaar Craftables', 'default_3x3', 1, 1004, 1, 2, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(782, 674, 'Ghost Hunter Crafting', 'Ghost Hunter Crafting', 'default_3x3', 1, 1004, 1, 6, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(783, 782, 'Ghost Hunter Ingredients', 'Ghost Hunter Ingredients', 'default_3x3', 1, 1004, 1, 1, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(784, 782, 'Ghost Hunter Craftables', 'Ghost Hunter Craftables', 'default_3x3', 1, 1004, 1, 2, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(785, 674, 'Victorian Xmas Crafting', 'Victorian Xmas Crafting', 'default_3x3', 1, 1004, 1, 14, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(786, 785, 'Victorian Xmas Ingredient', 'Victorian Xmas Ingredients', 'default_3x3', 1, 1004, 1, 1, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(787, 785, 'Victorian Xmas Craftables', 'Victorian Xmas Craftables', 'default_3x3', 1, 1004, 1, 2, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(788, 674, 'Easter Garden Crafting', 'Easter Garden Crafting', 'default_3x3', 1, 1004, 1, 4, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(877, 2, 'mystery_furni', 'Mystery Furni!', 'single_bundle', 1, 196, 1, 6, '1', '1', '0', '0', 'Stars_header', 'mystery_teaser', 'catalog_special_txtbg2', 'Throughout this month, we\'re releasing several \'mystery\' items. They\'ll be available from the Catalogue for longer than usual, and apart from one (a certain never-released-before parasol) they are NOT considered rare.', 'Support Ukrainie!', 'We hope you stand with us in supporting Ukraine and everyone who has become displaced in these difficult times.', 'Ukrainian Pack', 0, ''),
	(789, 788, 'Easter Garden Craftables', 'Easter Garden Craftables', 'default_3x3', 1, 1004, 1, 2, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(790, 674, 'Laboratory Crafting', 'Laboratory Crafting', 'default_3x3', 1, 1004, 1, 9, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(791, 790, 'Laboratory Ingredients', 'Laboratory Ingredients', 'default_3x3', 1, 1004, 1, 1, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(792, 790, 'Laboratory Craftables', 'Laboratory Craftables', 'default_3x3', 1, 1004, 1, 2, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(793, 674, 'Winter City Crafting', 'Winter City Crafting', 'default_3x3', 1, 1004, 1, 15, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(794, 793, 'Winter City Ingredients', 'Winter City Ingredients', 'default_3x3', 1, 1004, 1, 1, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(795, 793, 'Winter City Craftables', 'Winter City Craftables', 'default_3x3', 1, 1004, 1, 2, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(796, 674, 'Bohemian Festival Craftin', 'Bohemian Festival Crafting', 'default_3x3', 1, 1004, 1, 3, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(797, 796, 'Bohemian Festival Ingredi', 'Bohemian Festival Ingredients', 'default_3x3', 1, 1004, 1, 1, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(798, 796, 'Bohemian Festival Craftab', 'Bohemian Festival Craftables', 'default_3x3', 1, 1004, 1, 2, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(799, 674, 'Sunlight City Crafting', 'Sunlight City Crafting', 'default_3x3', 1, 1004, 1, 12, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(800, 799, 'Sunlight City Ingredients', 'Sunlight City Ingredients', 'default_3x3', 1, 1004, 1, 1, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(801, 799, 'Sunlight City Craftables', 'Sunlight City Craftables', 'default_3x3', 1, 1004, 1, 2, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(802, 674, 'Witches\' Coven Crafting', 'Witches\' Coven Crafting', 'default_3x3', 1, 1004, 1, 17, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(803, 802, 'Witches\' Coven Ingredient', 'Witches\' Coven Ingredients', 'default_3x3', 1, 1004, 1, 1, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(804, 802, 'Witches\' Coven Craftables', 'Witches\' Coven Craftables', 'default_3x3', 1, 1004, 1, 2, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(805, 674, 'Ice Palace Crafting', 'Winter Palace Crafting', 'default_3x3', 1, 1004, 1, 16, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(806, 805, 'Ice Palace Ingredients', 'Ice Palace Ingredients', 'default_3x3', 1, 1004, 1, 1, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(807, 805, 'Winter Palace Craftables', 'Winter Palace Craftables', 'default_3x3', 1, 1004, 1, 2, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(808, 674, 'Spa Crafting', 'Spa Crafting', 'default_3x3', 1, 1004, 1, 10, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(809, 808, 'Spa Ingredients', 'Spa Ingredients', 'default_3x3', 1, 1004, 1, 1, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(810, 808, 'Spa Craftables', 'Spa Craftables', 'default_3x3', 1, 1004, 1, 2, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(811, 674, 'India Crafting', 'India Crafting', 'default_3x3', 1, 1004, 1, 8, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(812, 811, 'India Ingredients', 'India Ingredients', 'default_3x3', 1, 1004, 1, 1, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(813, 811, 'India Craftables', 'India Craftables', 'default_3x3', 1, 1004, 1, 2, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(814, 674, 'BFF Crafting', 'BFF Crafting', 'default_3x3', 1, 1004, 1, 2, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(815, 814, 'BFF Ingredients', 'BFF Ingredients', 'default_3x3', 1, 1004, 1, 1, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(816, 814, 'BFF Craftables', 'BFF Craftables', 'default_3x3', 1, 1004, 1, 2, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(817, 820, 'Mystics Crackables', 'Mystics Crackables', 'default_3x3', 1, 263, 5, 11, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(818, 184, 'Art Prizes', 'Art Prizes', 'default_3x3', 1, 263, 1, 1, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(819, 189, 'India Prizes', 'India Prizes', 'default_3x3', 1, 263, 1, 1, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(820, 7, 'Campaign Crackables', 'Campaign Crackables', 'pets2', 1, 263, 5, 30, '1', '1', '0', '0', '', '', '', NULL, '<b>Crackables</b>', 'Contains all campaign crackables and all the prizes. Use the items_crackable table to match the crackables to the exact prizes.', 'WARNING: Pages could be slow loading due to number of items. All rewards can be found in the `prizes` column in the `items_crackable` table.', 0, ''),
	(821, 820, 'non-crack_versions2', 'B - VERSIONS (CC)', 'default_3x3', 1, 263, 5, 100, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(823, 665, 'Habbocalypse Crackables', 'Halloween \'15 Crackables', 'default_3x3', 1, 263, 1, 7, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(824, 823, 'Habbocalypse Prizes', 'Halloween \'15 Prizes', 'default_3x3', 1, 263, 1, 1, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(825, 665, 'Ghost Hunter Crackables', 'Halloween \'16 Crackables', 'default_3x3', 1, 263, 1, 8, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(826, 825, 'Ghost Hunter Prizes', 'Halloween \'16 Prizes', 'default_3x3', 1, 263, 1, 1, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(827, 665, 'Cursed Caves Crackables', 'Halloween \'17 Crackables', 'default_3x3', 1, 263, 1, 9, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(828, 827, 'Cursed Caves Prizes', 'Cursed Caves Prizes', 'default_3x3', 1, 263, 1, 1, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(829, 665, 'Witches Coven\' Crackables', 'Halloween \'19 Crackables', 'default_3x3', 1, 263, 1, 10, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(830, 829, 'Witches\' Coven Prizes', 'Witches\' Coven Prizes', 'default_3x3', 1, 263, 1, 1, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(831, 665, 'Victorian Xmas Crackables', 'Xmas \'17 Crackables', 'default_3x3', 1, 263, 1, 12, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(832, 831, 'Victorian Xmas Prizes', 'Victorian Xmas Prizes', 'default_3x3', 1, 263, 1, 1, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(833, 665, 'Ice Palace Crackables', 'Xmas \'19 Crackables', 'default_3x3', 1, 263, 1, 13, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(834, 833, 'Ice Palace Prizes', 'Ice Palace Prizes', 'default_3x3', 1, 263, 1, 1, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(835, 665, 'Citadel Crackables', 'Xmas \'16 Crackables', 'default_3x3', 1, 263, 1, 11, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(836, 835, 'Citadel Prizes', 'Citadel Prizes', 'default_3x3', 1, 263, 1, 1, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(837, 665, 'Easter Egg Crackables', 'Easter \'13 Crackables', 'default_3x3', 1, 263, 1, 1, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(839, 837, 'Easter Egg Prizes', 'Easter Egg Prizes', 'default_3x3', 1, 263, 1, 1, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(840, 665, 'Fairy Tale Crackables', 'Easter \'19 Crackables', 'default_3x3', 1, 263, 1, 5, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(841, 840, 'Fairy Tale Prizes', 'Fairy Tale Prizes', 'default_3x3', 1, 263, 1, 1, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(842, 665, 'Farm Crackables', 'Easter \'17 Crackables', 'default_3x3', 1, 263, 1, 3, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(843, 842, 'Farm Prizes', 'Farm Prizes', 'default_3x3', 1, 263, 1, 1, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(844, 665, 'Vikings vs. Pirates Crack', 'Easter \'16 Crackables', 'default_3x3', 1, 263, 1, 2, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(845, 844, 'Vikings vs. Pirates Prize', 'Vikings vs. Pirates Prizes', 'default_3x3', 1, 263, 1, 1, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(846, 665, 'Garden Crackables', 'Easter \'18 Crackables', 'default_3x3', 1, 263, 1, 4, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(847, 846, 'Garden Prizes', 'Garden Prizes', 'default_3x3', 1, 263, 1, 1, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(848, 665, 'Alpine Crackables', 'Easter \'20 Crackables', 'default_3x3', 1, 263, 1, 6, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(766, 557, 'rares_by_year', 'Extra Rares By Year', 'default_3x3', 1, 42, 1, 16, '1', '0', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(849, 766, '2010_rares', '2010 Rares', 'default_3x3', 1, 42, 1, 1, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(850, 766, '2011_rares', '2011 Rares', 'default_3x3', 1, 42, 1, 2, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(851, 766, '2012_rares', '2012 Rares', 'default_3x3', 1, 42, 1, 3, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(852, 766, '2013_rares', '2013 Rares', 'default_3x3', 1, 42, 1, 4, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(853, 766, '2014_rares', '2014 Rares', 'default_3x3', 1, 42, 1, 5, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(854, 766, '2015_rares', '2015 Rares', 'default_3x3', 1, 42, 1, 6, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(855, 766, '2017_rares', '2017 Rares', 'default_3x3', 1, 42, 1, 7, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(856, 766, '2018_rares', '2018 Rares', 'default_3x3', 1, 42, 1, 8, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(857, 766, '2019_rares', '2019 Rares', 'default_3x3', 1, 42, 1, 9, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(858, 766, '2020_rares', '2020 Rares', 'default_3x3', 1, 42, 1, 10, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(859, 442, 'Ingman', 'Ingman\'s Ice Cream', 'default_3x3', 1, 10, 1, 32, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(860, 209, 'Autumn', 'Autumn', 'default_3x3', 1, 49, 1, 25, '1', '1', '0', '0', 'autumn20_header', 'autumn20_teaser', '', 'The trees are starting to turn brown, it\'s getting colder and hot drinks are starting to appeal. Get into an autumnal mindset this fall!', NULL, NULL, NULL, 0, ''),
	(861, 125, 'Non-Tradeable New Furni', 'Non-Tradeable New Furni', 'default_3x3', 1, 1, 1, 1, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(862, 375, 'Halloween 2020', '\'20 - Impossible House', 'default_3x3', 1, 293, 1, 14, '1', '1', '0', '0', 'hween20_header', 'hween20_teaser', '', 'Venture inside the Impossible House, home to many evil creatures who are looking for their chance to escape into the real world. Will you be able to find your way out before they do?', NULL, NULL, NULL, 0, ''),
	(863, 665, 'Halloween \'20 Crackables', 'Halloween \'20 Crackables', 'default_3x3', 1, 263, 1, 11, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(864, 863, 'Impossible House Prizes', 'Impossible House Prizes', 'default_3x3', 1, 263, 1, 1, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(865, 373, 'plushie20', '\'20 - Plushie', 'default_3x3', 1, 294, 1, 20, '1', '1', '0', '0', 'Starsheader', 'plushie_teaser', '', NULL, NULL, NULL, NULL, 0, ''),
	(866, 674, 'Plushie Crafting', 'Plushie Crafting', 'default_3x3', 1, 1004, 1, 18, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(867, 866, 'Plushie Ingredients', 'Plushie Ingredients', 'default_3x3', 1, 1, 1, 1, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(868, 866, 'Plushie Craftables', 'Plushie Craftables', 'default_3x3', 1, 1004, 1, 2, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(869, 820, 'Plushie Crackables', 'Plushie Crackables', 'default_3x3', 1, 263, 5, 13, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(870, 869, 'Plushie Prizes', 'Plushie Prizes', 'default_3x3', 1, 263, 1, 1, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(872, 599, 'coati_statues', 'Coati Statues', 'default_3x3', 1, 42, 4, 10, '1', '1', '0', '0', '', 'Spromo_Bonus_Bags', '', NULL, NULL, NULL, NULL, 0, ''),
	(871, 526, 'info_rentables', 'Rentables Info', 'info_rentables', 1, 10, 1, 5, '1', '1', '0', '0', 'rental10', '', '', 'Furniture for rent! (Lagacy)||Rented items appear in your inventory, under the <i>"Rentables"</i> tab.||Placing a rented item in your room will activate the Rentable clock.||The Rentable time can be extended by pressing the <i>"Extend"</i> button. This costs additional Duckets.||See the remaining Rentable time by clicking on your rented item in your inventory.||When a rented item is about to expire, it is marked with a red sign in the inventory.', NULL, NULL, NULL, 0, ''),
	(873, 664, 'bonus_rare_22', 'Bonus Rare 22', 'default_3x3', 1, 263, 1, 7, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(874, 373, 'xmas20', '\'20 - Rune Craft', 'default_3x3', 1, 295, 1, 19, '1', '1', '0', '0', 'xmas20_header', 'runecraft_teaser', '', NULL, NULL, NULL, NULL, 0, ''),
	(875, 665, 'xmas20_crack', 'Xmas \'20 Crackables', 'default_3x3', 1, 263, 1, 14, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(876, 674, 'Rune Crafting', 'Rune Crafting', 'default_3x3', 1, 1004, 1, 19, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(50000, 7, 'unsort0-22', 'Unsorted Items', 'default_3x3', 1, 1, 7, 90, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(50001, 7, 'unsort1-22', 'Unsorted Clothing', 'default_3x3', 1, 1, 7, 91, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(879, 924, 'messi', 'Messi', 'default_3x3', 1, 32, 1, 1, '1', '1', '0', '0', 'messy21_header', 'messy21_teaser', '', 'This room gives you a realistic glimpse into adult life. Some days the mop is just too far.', NULL, NULL, NULL, 0, ''),
	(880, 599, 'capybara_statues', 'Capybara Statues', 'default_3x3', 1, 42, 4, 9, '1', '1', '0', '0', '', 'Spromo_Bonus_Bags', '', NULL, NULL, NULL, NULL, 0, ''),
	(881, 953, 'futuristic', 'Futuristic and Smart', 'default_3x3', 1, 214, 1, 10, '1', '1', '0', '1', 'catalog_header_hc', 'teaser_habboclub', '', 'As a member of Habbo Club or HC, you can shop from this selection of exclusive items. Every now and then we will also be adding items that are currently unavailable in the regular Furni Shop as well!', NULL, NULL, 'For Club members only!', 0, ''),
	(882, 376, 'valentine_2021', '\'21 - Valentine', 'default_3x3', 1, 160, 1, 23, '1', '1', '0', '0', 'val2021_header', 'valentine21_teaser', '', NULL, NULL, NULL, NULL, 0, ''),
	(883, 924, 'fruit', 'Fruit', 'default_3x3', 1, 500, 1, 1, '1', '1', '0', '0', 'fruits21_header', 'fruits21_teaser', '', NULL, NULL, NULL, NULL, 0, ''),
	(884, 374, 'easter_2021', '\'21 FashionWeek', 'default_3x3', 1, 297, 1, 14, '1', '1', '0', '0', 'easter21_header', 'easter21_teaser', '', NULL, NULL, NULL, NULL, 0, ''),
	(885, 924, 'victorian', 'Victorian', 'default_3x3', 1, 297, 1, 1, '1', '1', '0', '0', 'victorian21_header', 'victorian21_teaser', '', 'Victorian England was a pretty harsh place if you weren\'t well off. We\'re putting a Habbo spin on it and keeping it pixellated and... not brutal. Check out the furni we just released!', NULL, NULL, NULL, 0, ''),
	(886, 924, 'tropical_thailand21', 'Tropical Thailand', 'default_3x3', 1, 298, 1, 1, '1', '1', '0', '0', 'thailand21_header', 'thailand21_teaser', '', 'Spend your afternoon getting some peace and quiet in the Thai Temple. Trust us, you don\'t want to miss out on this architecture.', NULL, NULL, NULL, 0, ''),
	(887, 924, 'rainbow', 'Pride Furni', 'default_3x3', 1, 286, 1, 1, '1', '1', '0', '0', 'pride21_header', 'pride21_teaser', '', 'We have added brand new pride furni and clothing to the catalogue for all of your pride celebrations! You will receive Pride Flags with every purchase (with seven switch states to help you express yourself!)', NULL, NULL, NULL, 0, ''),
	(888, 924, 'vaporwave', 'Vaporwave', 'default_3x3', 1, 92, 1, 1, '1', '1', '0', '0', 'vaporwave_header', 'vaporwave_teaser', '', 'You\'ve just made it to Miami where your new mission will take place: find a scammer who for months has been hacking into other people\'s account to steal their furnis and sell them in black markets and gamble them away in illegal casinos.', NULL, NULL, NULL, 0, ''),
	(889, 924, 'mushroom21', 'Mushroom', 'default_3x3', 1, 506, 1, 1, '1', '1', '0', '0', 'mushroom21_header', 'mushroom21_teaser', '', 'Check out the selection of clothing and furni we just dropped as part of Mushroom Month!', NULL, NULL, NULL, 0, ''),
	(890, 375, 'habboween_2021', '21\' - Spirits of Japan', 'default_3x3', 1, 293, 1, 15, '1', '1', '0', '0', 'hween21_header', 'hween21_teaser', '', 'Some say it\'s mist… some say it\'s a Yuki-onna. This is a refuge, but it\'s also seriously spooky. Caution advised.', NULL, NULL, NULL, 0, ''),
	(891, 924, 'icecream_parlor', 'Icecream Parlor', 'default_3x3', 1, 505, 1, 1, '1', '1', '0', '0', 'summer21_header', 'summer21_teaser', '', 'Ice cream! Get your ice cream! We have all the flavours you could possibly imagine right here for you.', NULL, NULL, NULL, 0, ''),
	(892, 924, 'bubblejuice21', 'Bubble Juice', 'default_3x3', 1, 122, 1, 1, '1', '1', '0', '0', 'habbobb21_header', 'spromo_craftingnov21', '', NULL, NULL, NULL, NULL, 0, ''),
	(893, 373, 'xmas2021', '\'21 X-Mas Train', 'default_3x3', 1, 1, 1, 21, '1', '1', '0', '0', 'xmas21_header', 'xmas21_teaser', '', 'This is your chance to travel cross country in style! Make yourself comfy in your very own luxury wagon aboard the Habbo Express and live the life of a VIP.', NULL, NULL, NULL, 0, ''),
	(894, 924, 'ads_teletubbies', 'Teletubbies', 'default_3x3', 1, 507, 1, 72, '1', '1', '0', '0', 'teletubbies_header', 'stars_default_teaser', '', 'Say Eh-oh to the Teletubbies!', NULL, NULL, NULL, 0, ''),
	(895, 924, 'sanrio21', 'Hello Kitty', 'default_3x3', 1, 504, 1, 1, '1', '1', '0', '0', 'senariokitty_header', 'senariokitty_teaser', '', NULL, NULL, NULL, NULL, 0, ''),
	(896, 924, 'garden21', 'Garden 2021', 'default_3x3', 1, 21, 1, 1, '1', '1', '0', '0', 'garden21_header', 'garden21_teaser', '', NULL, NULL, NULL, NULL, 0, ''),
	(897, 376, 'valentine_2022', '\'22 - Valentine', 'default_3x3', 1, 160, 1, 24, '1', '1', '0', '0', 'val2022_header', 'val2022_teaser', '', 'Why wait until the 14th to start celebrating Valentine\'s Day?\r\n\r\nLove is already in the air in Habbo and twinnie and Air would like to take you on some romantic dates!', NULL, NULL, NULL, 0, ''),
	(898, 924, 'spa_22', 'Spa and Wellnes', 'default_3x3', 1, 298, 1, 1, '1', '1', '0', '0', 'spa22_header', 'spa22_teaser', '', 'This Furni was exclusive in an HabboClub Deal Jan-2022', NULL, NULL, NULL, 0, ''),
	(899, 953, 'club_gifts', 'Renaissance', 'club_gift', 1, 214, 1, 11, '1', '1', '0', '1', 'catalog_header_hc', 'teaser_habboclub', '', 'As a member of Habbo Club or HC, you can shop from this selection of exclusive items. Every now and then we will also be adding items that are currently unavailable in the regular Furni Shop as well!', NULL, NULL, 'For Club members only!', 0, ''),
	(900, 442, 'ads_fanta', 'Fanta', 'default_3x3', 1, 10, 4, 73, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(901, 664, 'bonus_rare_21', 'Bonus Rare 21', 'default_3x3', 1, 263, 1, 6, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(902, 820, 'bj21-crackables', 'Bubble Juice', 'default_3x3', 1, 263, 5, 16, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(308, 2, 'purchase_history', 'Purchase History', 'recent_purchases', 1, 258, 1, 50, '1', '1', '0', '0', 'maquinas', 'historys', '', NULL, NULL, NULL, NULL, 0, ''),
	(903, 876, 'Rune Ingredients', 'Rune Ingredients', 'default_3x3', 1, 1004, 5, 19, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, '875'),
	(904, 876, 'Rune Craftables', 'Rune Craftables', 'default_3x3', 1, 1004, 5, 19, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(905, 674, 'Fashion Crafting', 'Fashion Crafting', 'default_3x3', 1, 1004, 5, 20, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(906, 905, 'Fashion Craftables', 'Fashion Craftables', 'default_3x3', 1, 1004, 5, 19, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(907, 905, 'Fashin Ingredients', 'Fashion Ingredients', 'default_3x3', 1, 1004, 5, 19, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(908, 668, '2020-21_ny_acc.', '2020-21 NY Acc.', 'default_3x3', 1, 42, 1, 6, '1', '1', '0', '0', '', '', '', 'This furniture is used in a New Years Crackable.', NULL, NULL, NULL, 0, ''),
	(909, 668, '2021-22_ny_acc.', '2021-22 NY Acc.', 'default_3x3', 1, 42, 1, 7, '1', '1', '0', '0', '', '', '', 'This furniture is used in a New Years Crackable.', NULL, NULL, NULL, 0, ''),
	(910, 442, 'ads_dtlr', 'Dtl', 'default_3x3', 1, 10, 4, 74, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(911, 624, 'rare_clothing_2021', '[R] Clothing - 2021', 'default_3x3', 1, 42, 6, 7, '1', '1', '0', '0', '', 'vippremium2', '', 'Unreleased rare clothing.', NULL, NULL, NULL, 0, ''),
	(912, 624, 'rare_clothing_2022', '[R] Clothing - 2022', 'default_3x3', 1, 42, 6, 8, '1', '1', '0', '0', '', 'vippremium2', '', 'Unreleased rare clothing.', NULL, NULL, NULL, 0, ''),
	(913, 222, 'panel', 'Panel', 'default_3x3', 1, 503, 1, 14, '1', '1', '0', '0', 'block_header', 'teaser_blocks', '', '1 Block... 2 Block... Red Block... Blue Block', NULL, NULL, NULL, 0, ''),
	(914, 222, 'curvedramp', 'Curvedramp', 'default_3x3', 1, 502, 1, 15, '1', '1', '0', '0', 'block_header', 'teaser_blocks', '', '1 Block... 2 Block... Red Block... Blue Block', NULL, NULL, NULL, 0, ''),
	(915, 222, 'block_small', 'Small Blocks', 'default_3x3', 1, 501, 1, 16, '1', '1', '0', '0', 'block_header', 'teaser_blocks', '', '1 Block... 2 Block... Red Block... Blue Block', NULL, NULL, NULL, 0, ''),
	(916, 902, 'bj21-crackables', 'Bubble Prizes', 'default_3x3', 1, 263, 5, 16, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(917, 674, 'bubble_juice_crafting', 'Bubblejuice Crafting', 'default_3x3', 1, 1004, 5, 21, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(918, 917, 'bubble_juice_crafting_i', 'Bubblejuice Ingredients', 'default_3x3', 1, 1004, 5, 1, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(919, 917, 'bubble_juice_crafting_c', 'Bubblejuice Craftables', 'default_3x3', 1, 1004, 5, 2, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(50010, 50000, 'mad_money', '(Test) Mad Money', 'mad_money', 1, 10, 1, 1, '1', '1', '0', '0', 'catalog_madmoney_header_en', 'catalog_money_teaser_test', 'catalog_money_store_en_test', 'MadMoney Subscription!', NULL, NULL, NULL, 0, ''),
	(925, 125, 'monkey', 'Game: Monkey', 'monkey', 1, 128, 1, 2, '1', '1', '0', '0', 'catalog_monkey_headline', 'catalog_monkey_teaser', 'catalog_monkey_store_en', 'Get your own monkey now!', NULL, NULL, NULL, 0, ''),
	(926, 125, 'niko', 'Game: Niko', 'niko', 1, 141, 1, 3, '1', '1', '0', '0', 'catalog_header_niko_en', 'catalog_niko_en', 'catalog_speech_niko_en2', 'Get niko the game now!', NULL, NULL, NULL, 0, ''),
	(50011, 50000, 'collectibles', '(Test) Collectibles', 'collectibles', 1, 1, 1, 1, '1', '1', '0', '0', '', '', '', '', NULL, NULL, NULL, 0, ''),
	(920, 820, 'shroom21_crack', 'Mushroom Month Crackables', 'default_3x3', 1, 263, 5, 17, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(921, 920, 'shroom21_prizes', 'Mushroom Month Prizes', 'default_3x3', 1, 263, 5, 17, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(922, 820, 'rainbow21_crack', 'Pride Furni Crackables', 'default_3x3', 1, 263, 5, 18, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(923, 922, 'rainbow21_prize', 'Pride Furni Prizes', 'default_3x3', 1, 263, 5, 1, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(924, 2, 'new_furnilines', 'New Furnitures', 'default_3x3', 1, 215, 1, 1, '1', '0', '0', '0', '', '', '', 'Grab the newest items clothes and furni from this category!', NULL, NULL, NULL, 0, ''),
	(928, 927, 'val22_prize', 'Val. 22 Prizes', 'default_3x3', 1, 263, 5, 19, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(927, 665, 'val22_crackables', 'Val. 22 Crackables', 'default_3x3', 1, 263, 5, 19, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(929, 665, 'xmas21_crack', 'Xmas \'21 Crackables', 'default_3x3', 1, 263, 5, 15, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(930, 929, 'xmas21_prizes', 'Xmas \'20 Prizes', 'default_3x3', 1, 263, 5, 1, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(931, 674, 'xmas21_crafting', 'Xmas21 Crafting', 'default_3x3', 1, 1004, 5, 23, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(932, 931, 'xmas21_ingredients', 'Xmas21 Ingredients', 'default_3x3', 1, 1004, 5, 1, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, '930'),
	(933, 931, 'xmas21_craftables', 'Xmas21 Craftables', 'default_3x3', 1, 1004, 5, 2, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(934, 125, '2021_calendar', '2021 - Xmas Calendar', 'default_3x3', 1, 168, 5, 5, '1', '1', '0', '0', 'catalog_header_xmas2013', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(618, 218, 'wired_packs', 'Offers', 'default_3x3', 1, 80, 1, 0, '1', '1', '0', '0', 'catalog_wired_header1', 'ctlg_pic_wired_deals', '', 'A few starterpacks for your new automatic experience!', NULL, NULL, NULL, 0, ''),
	(935, 674, 'hween21_crafting', 'Hween21 Crafting', 'default_3x3', 1, 1004, 5, 22, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(936, 935, 'hween21_ingredients', 'Hween21 ingredients', 'default_3x3', 1, 1004, 5, 1, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(937, 935, 'hween21_craftables', 'Hween21 Craftables', 'default_3x3', 1, 1004, 5, 2, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(938, 2, 'ecotron', 'Recycler', 'recycler', 1, 7, 1, 18, '1', '1', '0', '0', 'ecotron_2', 'ctlg_ecotron_image_en', '', NULL, NULL, NULL, NULL, 0, ''),
	(956, 125, 'dev_effects', 'All Effects', 'default_3x3', 1, 61, 5, 11, '1', '1', '0', '0', '2015_header', 'stars_default_teaser', '', 'All usable effects that have an icon are sorted here. By giving one effect in catalogue an number in extradata it will set the duration length of the effect.', NULL, NULL, NULL, 0, ''),
	(939, 938, 'recycler_info', 'How to Recycle?', 'pets3', 1, 10, 1, 1, '1', '1', '0', '0', 'ecotron_2', 'ctlg_ecotron_box', '', 'Learn how to handle your waste.', 'The Recycler', 'On the recycler catalog page, open your inventory. Furniture marked with the <i>Recycle</i> logo can be recycled. Select per recycle process <b>8</b> furnis from your inventory.', 'Prizes and chances can be seen on the <i>What you can get</i> page.', 0, ''),
	(940, 938, 'recycler_prizes', 'What you can get', 'recycler_prizes', 1, 42, 1, 1, '1', '1', '0', '0', 'ecotron_2', 'ctlg_ecotron_box', '', '1', '2', 'D', 'T', 0, ''),
	(941, 951, 'bc_addons', 'Furniture Add Ons', 'builders_club_addons', 1, 194, 1, 5, '1', '1', '1', '0', 'bc_club', 'stars_default_teaser', '', '<b><font size="15" color="#FF6A00">Builders\' Club Upgrades</font></b>\r\n\r\nhave you reached your <b>Furni Limit</b> but want to <b>keep building</b>? No problem! Upgrade to extend your furni limit available below ... Unlock', NULL, NULL, NULL, 0, ''),
	(942, 125, 'habbo_club_lagacy', '(Lagacy) Club Buy', 'club_buy', 1, 172, 7, 1, '1', '1', '0', '0', 'catalog_club_headline1_en', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(50003, 7, 'buildersclub', 'Unsorted Buildersclub', 'default_3x3', 1, 1, 7, 93, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(944, 674, 'vwavec21_crafting', 'V-Wave Crafting', 'default_3x3', 1, 1004, 5, 22, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(945, 944, 'vwavec21_ingreds', 'V-Wave ingredients', 'default_3x3', 1, 1004, 5, 1, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(946, 944, 'vwavec21_craftables', 'V-Wave Craftables', 'default_3x3', 1, 1004, 5, 2, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(947, 924, 'dia_boxes_2', 'Diamond Gift Boxes 2.0', 'default_3x3', 1, 507, 1, 1, '1', '1', '0', '0', 'dia_boxes2_header', 'stars_default_teaser', '', 'The Diamond Gift Box II', NULL, NULL, NULL, 0, ''),
	(5010, 233, 'room_bundle_mar1', 'NEW: Abandoned Hut Bundle', 'room_bundle', 1, 507, 1, 10, '1', '1', '0', '0', 'catalog_header_roombundle', 'catalog_teaser_atcg', '', 'For your Lonelyness.', 'New Room Bundle Exclusive for YOU!', 'Get a collection of 15 EXCLUSIVE Primrose seeds and a dark, abandoned hut with this Bundle! Just watch out for angry spirits ...', '<b><i><color="#E5580E">The Bundle include:</color></b></i>', 60, ''),
	(8, 951, 'habbo_club', 'Habbo Club', 'vip_buy', 1, 172, 1, 1, '1', '1', '0', '0', 'hc2_clubtitle', 'clubcat_pic_en', '', NULL, NULL, NULL, NULL, 0, ''),
	(952, 951, 'builders_club', 'Builder\'s Club (Diamonds)', 'builders_club_loyalty', 1, 193, 1, 4, '1', '1', '0', '0', 'bc_club', 'stars_default_teaser', '', '<b><font size="15" color="#FF6A00">What is Builders\' club?</font></b>\r\n\r\nHave you always dreamed of building a room with tons of furni? Builders\' Club is your ultimate solution! Every month you purchase gives you', NULL, NULL, NULL, 0, ''),
	(953, 951, 'hc_gifts_cat', 'Habbo Club Gifts', 'default_3x3', 1, 172, 1, 2, '1', '0', '1', '0', 'hc2_clubtitle', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(954, 951, 'tade_gift_box', 'BC/HC Tradable Boxes', 'default_3x3', 1, 99, 1, 6, '1', '1', '1', '0', 'hc2_clubtitle', 'hcbcboxes', '', 'Say hello to tradable BC and HC Boxes! Containing either 14 or 31-day chunks of Builders\' Club or Habbo Club membership, this type of furni is just perfect for trading', NULL, NULL, NULL, 0, ''),
	(957, 951, 'builders_club_fp', 'Builders\' Club', 'builders_club_frontpage', 1, 193, 1, 3, '1', '1', '0', '0', 'bc_club', 'stars_default_teaser', '', '<b><font size="15" color="#FF6A00">What is Builders\' club?</font></b>\r\n\r\nHave you ever wanted to build a room with huge collection of  furni? Tired of counting your credits to finish a room? Or do you simply want to let your creativity flow? Builders\' Club is your ultimate solution!\r\n\r\n<b><font size="15" color="#FF6A00">Its\'s as easy as 1-2-Free</font></b>\r\n\r\n<b>.!.!.!.</b>', NULL, NULL, NULL, 0, ''),
	(50002, 7, 'testing_page', 'TESTING', 'default_3x3', 1, 1, 7, 92, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(958, 125, 'deals_classic', '(Lagacy) Classic Deals', 'default_3x3', 1, 11, 1, 1, '1', '1', '0', '0', 'catalog_deals_headline1', 'ctlg_pic_deal04', 'catalog_special_txtbg2', 'The old but gold  Classics, in some need Packs!', NULL, NULL, 'I got riped off!', 0, ''),
	(959, 50000, 'easter_22', '22\' Easter (indev)', 'default_3x3', 1, 1, 1, 1, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(960, 50000, 'nft_bullshit', 'NFT - like WTF?!', 'default_3x3', 1, 1, 1, 1, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(961, 599, 'cactus_pots', 'Cactus Pots', 'default_3x3', 1, 42, 4, 11, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(963, 962, 'easter22_ingredients', 'easter22_ingredients (indev)', 'default_3x3', 1, 1004, 5, 1, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(964, 50000, 'summer_22', '22\' Summer (Indev)', 'default_3x3', 1, 1, 1, 1, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(50004, 7, 'problematic_dev', 'Problematic', 'default_3x3', 1, 1, 7, 94, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(965, 766, '2021_rares', '2021 Rares', 'default_3x3', 1, 42, 1, 12, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(966, 766, '2022_rares', '2022 Rares', 'default_3x3', 1, 42, 1, 13, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(967, 311, 'rare_blackcolor', 'Black Rares', 'default_3x3', 1, 42, 6, 6, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(968, 311, 'rare_browncolor', 'Brown Rares', 'default_3x3', 1, 42, 7, 5, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(969, 372, 'blackfridays', 'Black Friday Deals', 'default_3x3', 1, 6, 1, 7, '1', '1', '0', '0', '2015_header', 'ctlg_pic_a0_deal100', '', 'Black Friday Deals are the Best! Fuck the rest!', NULL, NULL, NULL, 0, ''),
	(962, 674, 'easter22_crafting', 'Easter22 Crafting', 'default_3x3', 1, 1004, 5, 24, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(970, 962, 'easter22_craftables', 'easter22_craftables (indev)', 'default_3x3', 1, 1004, 5, 2, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(971, 300, '2021_ltds', '2021 LTDs', 'default_3x3', 1, 145, 1, 10, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(972, 300, '2022_ltds', '2022 LTDs', 'default_3x3', 1, 145, 1, 11, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, ''),
	(973, 222, 'bc_stairs22', 'Stairs', 'default_3x3', 1, 1002, 1, 21, '1', '1', '0', '0', 'block_header', 'teaser_blocks', '', NULL, NULL, NULL, NULL, 0, ''),
	(974, 222, 'bc_small_spheres22', 'Small Spheres', 'default_3x3', 1, 1002, 1, 17, '1', '1', '0', '0', 'block_header', 'teaser_blocks', '', NULL, NULL, NULL, NULL, 0, ''),
	(975, 222, 'bc_ramp22', 'Ramps', 'default_3x3', 1, 1002, 1, 18, '1', '1', '0', '0', 'block_header', 'teaser_blocks', '', NULL, NULL, NULL, NULL, 0, ''),
	(977, 222, 'bc_stick22', 'Sticks', 'default_3x3', 1, 1002, 1, 19, '1', '1', '0', '0', 'block_header', 'teaser_blocks', '', NULL, NULL, NULL, NULL, 0, ''),
	(978, 222, 'bc_quaterc22', 'Quartercircles', 'default_3x3', 1, 1002, 1, 20, '1', '1', '0', '0', 'block_header', 'teaser_blocks', '', NULL, NULL, NULL, NULL, 0, ''),
	(976, 50000, 'placeholder976', 'placeholder976', 'default_3x3', 1, 1, 1, 1, '1', '1', '0', '0', '', '', '', NULL, NULL, NULL, NULL, 0, '');
/*!40000 ALTER TABLE `catalog_pages` ENABLE KEYS */;

-- Dumping structure for table test.items_base
DROP TABLE IF EXISTS `items_base`;
CREATE TABLE IF NOT EXISTS `items_base` (
  `id` int(7) unsigned NOT NULL AUTO_INCREMENT,
  `sprite_id` int(7) NOT NULL DEFAULT 0,
  `buildersclub` enum('0','1') COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '0' COMMENT 'For DEV only. This collum can be deleted.',
  `public_name` varchar(160) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `item_name` varchar(64) COLLATE utf8mb4_unicode_ci NOT NULL,
  `type` varchar(1) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `width` int(7) NOT NULL DEFAULT 1,
  `length` int(7) NOT NULL DEFAULT 1,
  `stack_height` double(4,2) NOT NULL DEFAULT 0.00,
  `allow_stack` enum('0','1') COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '0',
  `allow_sit` enum('0','1') COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '0',
  `allow_lay` enum('0','1') COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '0',
  `allow_walk` enum('0','1') COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '0',
  `allow_gift` enum('0','1') COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '0',
  `allow_trade` enum('0','1') COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '0',
  `allow_recycle` enum('0','1') COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '0',
  `allow_marketplace_sell` enum('0','1') COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '0',
  `allow_inventory_stack` enum('0','1') COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '1',
  `interaction_type` varchar(500) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT 'default',
  `interaction_modes_count` int(16) NOT NULL DEFAULT 1,
  `vending_ids` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `multiheight` varchar(50) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `customparams` varchar(256) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `effect_id_male` int(3) NOT NULL DEFAULT 0,
  `effect_id_female` int(3) NOT NULL DEFAULT 0,
  `clothing_on_walk` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=65005014 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci ROW_FORMAT=DYNAMIC;

-- Dumping data for table test.items_base: ~12,449 rows (approximately)
/*!40000 ALTER TABLE `items_base` DISABLE KEYS */;
REPLACE INTO `items_base` (`id`, `sprite_id`, `buildersclub`, `public_name`, `item_name`, `type`, `width`, `length`, `stack_height`, `allow_stack`, `allow_sit`, `allow_lay`, `allow_walk`, `allow_gift`, `allow_trade`, `allow_recycle`, `allow_marketplace_sell`, `allow_inventory_stack`, `interaction_type`, `interaction_modes_count`, `vending_ids`, `multiheight`, `customparams`, `effect_id_male`, `effect_id_female`, `clothing_on_walk`) VALUES
	(1, 1, '0', 'post.it', 'post.it', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '0', '0', '1', '1', 'postit', 1, '', '', '', 0, 0, ''),
	(2, 2, '0', 'post.it.vd', 'post.it.vd', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '0', '0', '1', '1', 'postit', 1, '', '', '', 0, 0, ''),
	(3, 3, '0', 'photo', 'photo', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4, 0, '0', 'bot_generic', 'bot_generic', 'R', 0, 0, 0.00, '0', '0', '0', '0', '0', '0', '0', '0', '0', 'bot', 1, '', '', '', 0, 0, ''),
	(5, 0, '0', 'bot_bartender', 'bot_bartender', 'R', 0, 0, 0.00, '0', '0', '0', '0', '0', '0', '0', '0', '0', 'bot', 1, '', '', '', 0, 0, ''),
	(6, 0, '0', 'rentable_bot_visitor_log', 'rentable_bot_visitor_log', 'R', 0, 0, 0.00, '0', '0', '0', '0', '0', '0', '0', '0', '0', 'bot', 1, '', '', '', 0, 0, ''),
	(7, 113, '0', 'product_avatar_effect113', 'product_avatar_effect113', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 113, 113, ''),
	(8, 0, '0', 'room_ad_plus_badge', 'room_ad_plus_badge', 'B', 0, 0, 0.00, '0', '0', '0', '0', '0', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(13, 13, '1', 'shelves_norja', 'shelves_norja', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(14, 14, '1', 'shelves_polyfon', 'shelves_polyfon', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(15, 15, '1', 'shelves_silo', 'shelves_silo', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '1003,1004,1005', '', '', 0, 0, ''),
	(17, 17, '1', 'table_polyfon_small', 'table_polyfon_small', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(18, 18, '0', 'chair_polyfon', 'chair_polyfon', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(20, 20, '1', 'table_norja_med', 'table_norja_med', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(21, 21, '1', 'table_silo_med', 'table_silo_med', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(22, 22, '0', 'table_plasto_4leg', 'table_plasto_4leg', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(23, 23, '0', 'table_plasto_round', 'table_plasto_round', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(24, 24, '0', 'table_plasto_bigsquare', 'table_plasto_bigsquare', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(25, 25, '0', 'stand_polyfon_z', 'stand_polyfon_z', 'S', 1, 1, 0.50, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(26, 26, '1', 'chair_silo', 'chair_silo', 'S', 1, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(28, 28, '1', 'sofa_silo', 'sofa_silo', 'S', 2, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(29, 29, '1', 'couch_norja', 'couch_norja', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(30, 30, '1', 'chair_norja', 'chair_norja', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(31, 31, '1', 'table_polyfon_med', 'table_polyfon_med', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(32, 32, '1', 'doormat_love', 'doormat_love', 'S', 1, 1, 0.10, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(33, 33, '1', 'doormat_plain', 'doormat_plain', 'S', 1, 1, 0.10, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(34, 34, '1', 'sofachair_polyfon', 'sofachair_polyfon', 'S', 1, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(35, 35, '1', 'sofa_polyfon', 'sofa_polyfon', 'S', 2, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(36, 36, '1', 'sofachair_silo', 'sofachair_silo', 'S', 1, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(38, 38, '0', 'chair_plasty', 'chair_plasty', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(39, 39, '0', 'chair_plasto', 'chair_plasto', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40, 40, '0', 'table_plasto_square', 'table_plasto_square', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(41, 41, '1', 'bed_polyfon', 'bed_polyfon', 'S', 2, 3, 1.40, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(42, 42, '1', 'bed_polyfon_one', 'bed_polyfon_one', 'S', 1, 3, 1.80, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(43, 43, '0', 'bed_trad_one', 'bed_trad_one', 'S', 2, 3, 1.80, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(44, 44, '0', 'bed_trad', 'bed_trad', 'S', 2, 3, 1.80, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(45, 45, '1', 'bed_silo_one', 'bed_silo_one', 'S', 1, 3, 1.80, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(46, 46, '1', 'bed_silo_two', 'bed_silo_two', 'S', 2, 3, 1.80, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(47, 47, '1', 'table_silo_small', 'table_silo_small', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'bed', 2, '', '', '', 0, 0, ''),
	(48, 48, '1', 'bed_armas_two', 'bed_armas_two', 'S', 2, 3, 1.80, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(49, 49, '0', 'bed_budget_one', 'bed_budget_one', 'S', 1, 3, 1.70, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(50, 50, '0', 'bed_budget', 'bed_budget', 'S', 2, 3, 1.70, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(51, 51, '1', 'shelves_armas', 'shelves_armas', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(52, 52, '1', 'bench_armas', 'bench_armas', 'S', 2, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(53, 53, '1', 'table_armas', 'table_armas', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(54, 54, '1', 'small_table_armas', 'small_table_armas', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(55, 55, '1', 'small_chair_armas', 'small_chair_armas', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(56, 56, '1', 'fireplace_armas', 'fireplace_armas', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(57, 57, '1', 'lamp_armas', 'lamp_armas', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(58, 58, '1', 'bed_armas_one', 'bed_armas_one', 'S', 1, 3, 1.80, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(59, 59, '1', 'carpet_standard', 'carpet_standard', 'S', 3, 5, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(60, 60, '1', 'carpet_armas', 'carpet_armas', 'S', 2, 4, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(61, 61, '1', 'carpet_polar', 'carpet_polar', 'S', 2, 3, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(62, 62, '1', 'fireplace_polyfon', 'fireplace_polyfon', 'S', 2, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(63, 63, '0', 'table_plasto_4leg*1', 'table_plasto_4leg*1', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(64, 64, '0', 'table_plasto_bigsquare*1', 'table_plasto_bigsquare*1', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(65, 65, '0', 'table_plasto_round*1', 'table_plasto_round*1', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(66, 66, '0', 'table_plasto_square*1', 'table_plasto_square*1', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(67, 67, '0', 'chair_plasto*1', 'chair_plasto*1', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(68, 68, '1', 'carpet_standard*1', 'carpet_standard*1', 'S', 3, 5, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(69, 69, '1', 'doormat_plain*1', 'doormat_plain*1', 'S', 1, 1, 0.10, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(70, 70, '0', 'table_plasto_4leg*2', 'table_plasto_4leg*2', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(71, 71, '0', 'table_plasto_bigsquare*2', 'table_plasto_bigsquare*2', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(72, 72, '0', 'table_plasto_round*2', 'table_plasto_round*2', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(73, 73, '0', 'table_plasto_square*2', 'table_plasto_square*2', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(74, 74, '0', 'chair_plasto*2', 'chair_plasto*2', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(75, 75, '1', 'doormat_plain*2', 'doormat_plain*2', 'S', 1, 1, 0.10, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(76, 76, '1', 'carpet_standard*2', 'carpet_standard*2', 'S', 3, 5, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(77, 77, '0', 'table_plasto_4leg*3', 'table_plasto_4leg*3', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(78, 78, '0', 'table_plasto_bigsquare*3', 'table_plasto_bigsquare*3', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(79, 79, '0', 'table_plasto_round*3', 'table_plasto_round*3', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(80, 80, '0', 'table_plasto_square*3', 'table_plasto_square*3', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(81, 81, '0', 'chair_plasto*3', 'chair_plasto*3', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(82, 82, '1', 'carpet_standard*3', 'carpet_standard*3', 'S', 3, 5, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(83, 83, '1', 'doormat_plain*3', 'doormat_plain*3', 'S', 1, 1, 0.10, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(84, 84, '0', 'table_plasto_4leg*4', 'table_plasto_4leg*4', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(85, 85, '0', 'table_plasto_bigsquare*4', 'table_plasto_bigsquare*4', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(86, 86, '0', 'table_plasto_round*4', 'table_plasto_round*4', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(87, 87, '0', 'table_plasto_square*4', 'table_plasto_square*4', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(88, 88, '0', 'chair_plasto*4', 'chair_plasto*4', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(89, 89, '1', 'carpet_standard*4', 'carpet_standard*4', 'S', 3, 5, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(90, 90, '1', 'doormat_plain*4', 'doormat_plain*4', 'S', 1, 1, 0.10, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(91, 91, '1', 'doormat_plain*6', 'doormat_plain*6', 'S', 1, 1, 0.10, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(93, 93, '1', 'doormat_plain*5', 'doormat_plain*5', 'S', 1, 1, 0.10, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(94, 94, '1', 'carpet_standard*5', 'carpet_standard*5', 'S', 3, 5, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(95, 95, '0', 'table_plasto_4leg*5', 'table_plasto_4leg*5', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(96, 96, '0', 'table_plasto_bigsquare*5', 'table_plasto_bigsquare*5', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(97, 97, '0', 'table_plasto_round*5', 'table_plasto_round*5', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(98, 98, '0', 'table_plasto_square*5', 'table_plasto_square*5', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(99, 99, '0', 'chair_plasto*5', 'chair_plasto*5', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(100, 100, '0', 'table_plasto_4leg*6', 'table_plasto_4leg*6', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(101, 101, '0', 'table_plasto_bigsquare*6', 'table_plasto_bigsquare*6', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(102, 102, '0', 'table_plasto_round*6', 'table_plasto_round*6', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(103, 103, '0', 'table_plasto_square*6', 'table_plasto_square*6', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(104, 104, '0', 'chair_plasto*6', 'chair_plasto*6', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(105, 105, '0', 'table_plasto_4leg*7', 'table_plasto_4leg*7', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(106, 106, '0', 'table_plasto_bigsquare*7', 'table_plasto_bigsquare*7', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(107, 107, '0', 'table_plasto_round*7', 'table_plasto_round*7', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(108, 108, '0', 'table_plasto_square*7', 'table_plasto_square*7', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(109, 109, '0', 'chair_plasto*7', 'chair_plasto*7', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(110, 110, '0', 'table_plasto_4leg*8', 'table_plasto_4leg*8', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(111, 111, '0', 'table_plasto_bigsquare*8', 'table_plasto_bigsquare*8', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(112, 112, '0', 'table_plasto_round*8', 'table_plasto_round*8', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(113, 113, '0', 'table_plasto_square*8', 'table_plasto_square*8', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(114, 114, '0', 'chair_plasto*8', 'chair_plasto*8', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(115, 115, '0', 'table_plasto_4leg*9', 'table_plasto_4leg*9', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(116, 116, '0', 'table_plasto_bigsquare*9', 'table_plasto_bigsquare*9', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(117, 117, '0', 'table_plasto_round*9', 'table_plasto_round*9', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(118, 118, '0', 'table_plasto_square*9', 'table_plasto_square*9', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(119, 119, '0', 'chair_plasto*9', 'chair_plasto*9', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(120, 120, '1', 'carpet_standard*6', 'carpet_standard*6', 'S', 3, 5, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(121, 121, '0', 'chair_plasty*1', 'chair_plasty*1', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(122, 122, '1', 'pizza', 'pizza', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(123, 123, '1', 'drinks', 'drinks', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(124, 124, '0', 'chair_plasty*2', 'chair_plasty*2', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(125, 125, '0', 'chair_plasty*3', 'chair_plasty*3', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(126, 126, '0', 'chair_plasty*4', 'chair_plasty*4', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(127, 127, '1', 'bar_polyfon', 'bar_polyfon', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '1,2', '', '', 0, 0, ''),
	(128, 128, '0', 'plant_cruddy', 'plant_cruddy', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(129, 129, '0', 'bottle', 'bottle', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'dice', 8, '', '', '', 0, 0, ''),
	(130, 130, '1', 'bardesk_polyfon', 'bardesk_polyfon', 'S', 2, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(131, 131, '1', 'bardeskcorner_polyfon', 'bardeskcorner_polyfon', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(132, 132, '0', 'floortile', 'floortile', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(133, 133, '1', 'bar_armas', 'bar_armas', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '1,2', '', '', 0, 0, ''),
	(134, 134, '1', 'bartable_armas', 'bartable_armas', 'S', 1, 3, 1.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(135, 135, '1', 'bar_chair_armas', 'bar_chair_armas', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(136, 136, '1', 'carpet_soft', 'carpet_soft', 'S', 2, 4, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(137, 137, '1', 'carpet_soft*1', 'carpet_soft*1', 'S', 2, 4, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(138, 138, '1', 'carpet_soft*2', 'carpet_soft*2', 'S', 2, 4, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(139, 139, '1', 'carpet_soft*3', 'carpet_soft*3', 'S', 2, 4, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(140, 140, '1', 'carpet_soft*4', 'carpet_soft*4', 'S', 2, 4, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(141, 141, '1', 'carpet_soft*5', 'carpet_soft*5', 'S', 2, 4, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(143, 143, '1', 'carpet_soft*6', 'carpet_soft*6', 'S', 2, 4, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(144, 144, '1', 'red_tv', 'red_tv', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(145, 145, '1', 'wood_tv', 'wood_tv', 'S', 1, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(146, 146, '0', 'carpet_polar*1', 'carpet_polar*1', 'S', 2, 3, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(147, 147, '0', 'chair_plasty*5', 'chair_plasty*5', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(148, 148, '1', 'carpet_polar*2', 'carpet_polar*2', 'S', 2, 3, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(149, 149, '1', 'carpet_polar*3', 'carpet_polar*3', 'S', 2, 3, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(150, 150, '1', 'carpet_polar*4', 'carpet_polar*4', 'S', 2, 3, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(151, 151, '0', 'chair_plasty*6', 'chair_plasty*6', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(152, 152, '1', 'table_polyfon', 'table_polyfon', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(153, 153, '1', 'smooth_table_polyfon', 'smooth_table_polyfon', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(154, 154, '0', 'sofachair_polyfon_girl', 'sofachair_polyfon_girl', 'S', 1, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(155, 155, '0', 'bed_polyfon_girl_one', 'bed_polyfon_girl_one', 'S', 1, 3, 1.50, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(156, 156, '0', 'bed_polyfon_girl', 'bed_polyfon_girl', 'S', 2, 3, 1.40, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(157, 157, '0', 'sofa_polyfon_girl', 'sofa_polyfon_girl', 'S', 2, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(158, 158, '0', 'bed_budgetb_one', 'bed_budgetb_one', 'S', 1, 3, 1.70, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(159, 159, '0', 'bed_budgetb', 'bed_budgetb', 'S', 2, 3, 1.70, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(160, 160, '0', 'plant_pineapple', 'plant_pineapple', 'S', 1, 1, 0.40, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(161, 161, '0', 'plant_fruittree', 'plant_fruittree', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(162, 162, '0', 'plant_small_cactus', 'plant_small_cactus', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(163, 163, '0', 'plant_bonsai', 'plant_bonsai', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(164, 164, '0', 'plant_big_cactus', 'plant_big_cactus', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(165, 165, '0', 'plant_yukka', 'plant_yukka', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(166, 166, '1', 'carpet_standard*7', 'carpet_standard*7', 'S', 3, 5, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(167, 167, '1', 'carpet_standard*8', 'carpet_standard*8', 'S', 3, 5, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(168, 168, '0', 'carpet_standard*9', 'carpet_standard*9', 'S', 3, 5, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(169, 169, '1', 'carpet_standard*10', 'carpet_standard*10', 'S', 3, 5, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(170, 170, '1', 'carpet_standard*11', 'carpet_standard*11', 'S', 3, 5, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(171, 171, '0', 'plant_sunflower', 'plant_sunflower', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine_no_sides', 2, '1002', '', '', 0, 0, ''),
	(172, 172, '0', 'plant_rose', 'plant_rose', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine_no_sides', 2, '1000', '', '', 0, 0, ''),
	(173, 173, '1', 'tv_luxus', 'tv_luxus', 'S', 1, 3, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(174, 174, '1', 'bath', 'bath', 'S', 1, 2, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(177, 177, '1', 'sink', 'sink', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '18', '', '', 0, 0, ''),
	(178, 178, '1', 'toilet', 'toilet', 'S', 1, 1, 1.20, '0', '1', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(179, 179, '1', 'duck', 'duck', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(180, 180, '1', 'tile', 'tile', 'S', 4, 4, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(181, 181, '1', 'toilet_red', 'toilet_red', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(182, 182, '1', 'toilet_yell', 'toilet_yell', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(183, 183, '1', 'tile_red', 'tile_red', 'S', 4, 4, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(184, 184, '1', 'tile_yell', 'tile_yell', 'S', 4, 4, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(185, 185, '0', 'prize1', 'prize1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(186, 186, '0', 'prize2', 'prize2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(187, 187, '0', 'present_gen', 'present_gen', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '0', '0', '0', '1', 'gift', 1, '', '', '', 0, 0, ''),
	(188, 188, '0', 'present_gen1', 'present_gen1', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '0', '0', '1', '1', 'gift', 1, '', '', '', 0, 0, ''),
	(189, 189, '0', 'present_gen2', 'present_gen2', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '0', '0', '1', '1', 'gift', 1, '', '', '', 0, 0, ''),
	(190, 190, '0', 'present_gen3', 'present_gen3', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '0', '0', '1', '1', 'gift', 1, '', '', '', 0, 0, ''),
	(191, 191, '0', 'present_gen4', 'present_gen4', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '0', '0', '1', '1', 'gift', 1, '', '', '', 0, 0, ''),
	(192, 192, '0', 'present_gen5', 'present_gen5', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '0', '0', '1', '1', 'gift', 1, '', '', '', 0, 0, ''),
	(193, 193, '0', 'present_gen6', 'present_gen6', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '0', '0', '1', '1', 'gift', 1, '', '', '', 0, 0, ''),
	(195, 195, '0', 'bar_basic', 'bar_basic', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '1,2,5,6', '', '', 0, 0, ''),
	(196, 196, '1', 'shelves_basic', 'shelves_basic', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(197, 197, '1', 'soft_sofachair_norja', 'soft_sofachair_norja', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(198, 198, '1', 'soft_sofa_norja', 'soft_sofa_norja', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(199, 199, '1', 'lamp_basic', 'lamp_basic', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(200, 200, '1', 'lamp2_armas', 'lamp2_armas', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(201, 201, '1', 'fridge', 'fridge', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '3,4,5,6', '', '', 0, 0, ''),
	(202, 202, '0', 'door', 'door', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'teleport', 1, '', '', '', 0, 0, ''),
	(204, 204, '0', 'doorB', 'doorB', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'teleport', 1, '', '', '', 0, 0, ''),
	(205, 205, '0', 'doorC', 'doorC', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'teleport', 1, '', '', '', 0, 0, ''),
	(206, 206, '0', 'pumpkin', 'pumpkin', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(207, 207, '0', 'skullcandle', 'skullcandle', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(208, 208, '0', 'deadduck', 'deadduck', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(209, 209, '0', 'deadduck2', 'deadduck2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(210, 210, '0', 'deadduck3', 'deadduck3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(211, 211, '0', 'menorah', 'menorah', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(212, 212, '0', 'pudding', 'pudding', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine_no_sides', 2, '1024', '', '', 0, 0, ''),
	(213, 213, '0', 'ham', 'ham', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(214, 214, '0', 'turkey', 'turkey', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine_no_sides', 2, '70', '', '', 0, 0, ''),
	(215, 215, '0', 'xmasduck', 'xmasduck', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(216, 216, '0', 'house', 'house', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(217, 217, '0', 'triplecandle', 'triplecandle', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(218, 218, '0', 'tree3', 'tree3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(219, 219, '0', 'tree4', 'tree4', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(220, 220, '0', 'tree5', 'tree5', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(223, 223, '0', 'ham2', 'ham2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(224, 224, '0', 'wcandleset', 'wcandleset', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(225, 225, '0', 'rcandleset', 'rcandleset', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(226, 226, '0', 'statue', 'statue', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(227, 227, '0', 'heart', 'heart', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(228, 228, '0', 'valeduck', 'valeduck', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(229, 229, '0', 'heartsofa', 'heartsofa', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(230, 230, '0', 'throne', 'throne', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(231, 231, '0', 'samovar', 'samovar', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'vendingmachine', 2, '1', '', '', 0, 0, ''),
	(232, 232, '0', 'giftflowers', 'giftflowers', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine_no_sides', 2, '1006', '', '', 0, 0, ''),
	(233, 233, '0', 'habbocake', 'habbocake', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(234, 234, '0', 'hologram', 'hologram', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(235, 235, '0', 'easterduck', 'easterduck', 'S', 1, 1, 0.50, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(236, 236, '0', 'bunny', 'bunny', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(237, 237, '0', 'basket', 'basket', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(238, 238, '0', 'birdie', 'birdie', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(239, 239, '0', 'edice', 'edice', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'dice', 6, '', '', '', 0, 0, ''),
	(243, 243, '0', 'prize3', 'prize3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(244, 244, '1', 'divider_poly3', 'divider_poly3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(245, 245, '1', 'divider_arm1', 'divider_arm1', 'S', 1, 1, 1.40, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(246, 246, '1', 'divider_arm2', 'divider_arm2', 'S', 2, 1, 1.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(247, 247, '1', 'divider_arm3', 'divider_arm3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(248, 248, '1', 'divider_nor1', 'divider_nor1', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(249, 249, '1', 'divider_silo1', 'divider_silo1', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(250, 250, '1', 'divider_nor2', 'divider_nor2', 'S', 2, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(251, 251, '1', 'divider_silo2', 'divider_silo2', 'S', 2, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(252, 252, '1', 'divider_nor3', 'divider_nor3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(253, 253, '1', 'divider_silo3', 'divider_silo3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(254, 254, '0', 'typingmachine', 'typingmachine', 'S', 1, 1, 0.50, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(260, 260, '0', 'spyro', 'spyro', 'S', 1, 1, 0.50, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(261, 261, '0', 'redhologram', 'redhologram', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(263, 263, '0', 'camera', 'camera', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(264, 264, '0', 'joulutahti', 'joulutahti', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '1023', '', '', 0, 0, ''),
	(265, 265, '0', 'hyacinth1', 'hyacinth1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine_no_sides', 2, '1021', '', '', 0, 0, ''),
	(266, 266, '0', 'hyacinth2', 'hyacinth2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine_no_sides', 2, '1022', '', '', 0, 0, ''),
	(267, 267, '0', 'club_sofa', 'club_sofa', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(268, 268, '0', 'chair_plasto*10', 'chair_plasto*10', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(269, 269, '0', 'chair_plasto*11', 'chair_plasto*11', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(270, 270, '0', 'bardeskcorner_polyfon*12', 'bardeskcorner_polyfon*12', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(271, 271, '0', 'bardeskcorner_polyfon*13', 'bardeskcorner_polyfon*13', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(273, 273, '0', 'chair_plasto*12', 'chair_plasto*12', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(274, 274, '0', 'chair_plasto*13', 'chair_plasto*13', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(275, 275, '0', 'chair_plasto*14', 'chair_plasto*14', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(276, 276, '0', 'table_plasto_4leg*14', 'table_plasto_4leg*14', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(277, 277, '0', 'mocchamaster', 'mocchamaster', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '8,9,10,11,12,13,14,15,16,17', '', '', 0, 0, ''),
	(278, 278, '1', 'carpet_legocourt', 'carpet_legocourt', 'S', 3, 3, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(279, 279, '1', 'bench_lego', 'bench_lego', 'S', 4, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(280, 280, '1', 'legotrophy', 'legotrophy', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 2, '', '', '', 0, 0, ''),
	(283, 283, '0', 'valentinescreen', 'valentinescreen', 'S', 2, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(284, 284, '0', 'edicehc', 'edicehc', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'dice', 6, '', '', '', 0, 0, ''),
	(285, 285, '0', 'rare_daffodil_rug', 'rare_daffodil_rug', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(286, 286, '0', 'rare_beehive_bulb', 'rare_beehive_bulb', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(287, 287, '0', 'hcsohva', 'hcsohva', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(288, 288, '0', 'hcamme', 'hcamme', 'S', 1, 2, 0.60, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(289, 289, '0', 'rare_parasol*0', 'rare_parasol*0', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(290, 290, '0', 'rare_elephant_statue', 'rare_elephant_statue', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(291, 291, '0', 'rare_fountain', 'rare_fountain', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(292, 292, '0', 'rare_stand', 'rare_stand', 'S', 1, 1, 1.70, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(293, 293, '0', 'rare_globe', 'rare_globe', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(294, 294, '0', 'rare_hammock', 'rare_hammock', 'S', 1, 3, 1.57, '0', '0', '1', '0', '1', '1', '0', '1', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(295, 295, '0', 'rare_elephant_statue*1', 'rare_elephant_statue*1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(296, 296, '0', 'rare_elephant_statue*2', 'rare_elephant_statue*2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(297, 297, '0', 'rare_fountain*1', 'rare_fountain*1', 'S', 1, 1, 1.50, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(298, 298, '0', 'rare_fountain*2', 'rare_fountain*2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(299, 299, '0', 'rare_fountain*3', 'rare_fountain*3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(300, 300, '0', 'rare_beehive_bulb*1', 'rare_beehive_bulb*1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(301, 301, '0', 'rare_beehive_bulb*2', 'rare_beehive_bulb*2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(302, 302, '0', 'rare_xmas_screen', 'rare_xmas_screen', 'S', 2, 1, 0.70, '0', '1', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(303, 303, '0', 'rare_parasol*1', 'rare_parasol*1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(304, 304, '0', 'rare_parasol*2', 'rare_parasol*2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(305, 305, '0', 'rare_parasol*3', 'rare_parasol*3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(420, 420, '0', 'soft_jaggara_norja', 'soft_jaggara_norja', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(428, 428, '0', 'house2', 'house2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(449, 449, '0', 'djesko_turntable', 'djesko_turntable', 'S', 1, 1, 0.50, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(456, 456, '0', 'md_sofa', 'md_sofa', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(457, 457, '0', 'md_limukaappi', 'md_limukaappi', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'vendingmachine', 2, '19', '', '', 0, 0, ''),
	(1001, 1001, '0', 'Chess', 'Chess', 'I', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1011, 1011, '0', 'TicTacToe', 'TicTacToe', 'I', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1021, 1021, '0', 'BattleShip', 'BattleShip', 'I', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1484, 1484, '0', 'table_plasto_4leg*10', 'table_plasto_4leg*10', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1486, 1486, '0', 'table_plasto_4leg*15', 'table_plasto_4leg*15', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1487, 1487, '0', 'table_plasto_bigsquare*14', 'table_plasto_bigsquare*14', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1488, 1488, '0', 'table_plasto_bigsquare*15', 'table_plasto_bigsquare*15', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1489, 1489, '0', 'table_plasto_round*14', 'table_plasto_round*14', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1490, 1490, '0', 'table_plasto_round*15', 'table_plasto_round*15', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1491, 1491, '0', 'table_plasto_square*14', 'table_plasto_square*14', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1492, 1492, '0', 'table_plasto_square*15', 'table_plasto_square*15', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1495, 1495, '0', 'chair_plasto*15', 'chair_plasto*15', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1496, 1496, '0', 'chair_plasty*7', 'chair_plasty*7', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1497, 1497, '0', 'chair_plasty*8', 'chair_plasty*8', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1498, 1498, '0', 'chair_plasty*9', 'chair_plasty*9', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1499, 1499, '0', 'chair_plasty*10', 'chair_plasty*10', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1500, 1500, '0', 'chair_plasty*11', 'chair_plasty*11', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1501, 1501, '0', 'chair_plasto*16', 'chair_plasto*16', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1502, 1502, '0', 'table_plasto_4leg*16', 'table_plasto_4leg*16', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1503, 1503, '1', 'hockey_score', 'hockey_score', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'scoreboard', 100, '', '', '', 0, 0, ''),
	(1504, 1504, '1', 'hockey_light', 'hockey_light', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'alert', 2, '', '', '', 0, 0, ''),
	(1505, 1505, '0', 'doorD', 'doorD', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'teleport', 1, '', '', '', 0, 0, ''),
	(1506, 1506, '0', 'prizetrophy2*3', 'prizetrophy2*3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(1507, 1507, '0', 'prizetrophy3*3', 'prizetrophy3*3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(1508, 1508, '0', 'prizetrophy4*3', 'prizetrophy4*3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(1509, 1509, '0', 'prizetrophy5*3', 'prizetrophy5*3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(1510, 1510, '0', 'prizetrophy6*3', 'prizetrophy6*3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(1512, 1512, '0', 'prizetrophy*1', 'prizetrophy*1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(1513, 1513, '0', 'prizetrophy2*1', 'prizetrophy2*1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(1514, 1514, '0', 'prizetrophy3*1', 'prizetrophy3*1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(1515, 1515, '0', 'prizetrophy4*1', 'prizetrophy4*1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(1516, 1516, '0', 'prizetrophy5*1', 'prizetrophy5*1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(1517, 1517, '0', 'prizetrophy6*1', 'prizetrophy6*1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(1518, 1518, '0', 'prizetrophy7*1', 'prizetrophy7*1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(1519, 1519, '0', 'prizetrophy*2', 'prizetrophy*2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(1520, 1520, '0', 'prizetrophy2*2', 'prizetrophy2*2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(1521, 1521, '0', 'prizetrophy3*2', 'prizetrophy3*2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(1522, 1522, '0', 'prizetrophy4*2', 'prizetrophy4*2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(1523, 1523, '0', 'prizetrophy5*2', 'prizetrophy5*2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(1524, 1524, '0', 'prizetrophy6*2', 'prizetrophy6*2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(1525, 1525, '0', 'prizetrophy7*2', 'prizetrophy7*2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(1526, 1526, '0', 'prizetrophy*3', 'prizetrophy*3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(1527, 1527, '0', 'hc_chr', 'hc_chr', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1528, 1528, '0', 'hc_tbl', 'hc_tbl', 'S', 1, 3, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1529, 1529, '0', 'hc_lmp', 'hc_lmp', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1530, 1530, '0', 'hc_dsk', 'hc_dsk', 'S', 1, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1531, 1531, '0', 'nest', 'nest', 'S', 1, 1, 0.10, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'nest', 1, '', '', '', 0, 0, ''),
	(1532, 1532, '0', 'petfood1', 'petfood1', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'pet_food', 4, '', '', '375,10,0', 0, 0, ''),
	(1533, 1533, '0', 'petfood2', 'petfood2', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'pet_food', 4, '', '', '400,10,0', 0, 0, ''),
	(1534, 1534, '0', 'petfood3', 'petfood3', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'pet_food', 4, '', '', '325,10,0', 0, 0, ''),
	(1535, 1535, '0', 'waterbowl*4', 'waterbowl*4', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'pet_drink', 6, '', '', '', 0, 0, ''),
	(1536, 1536, '0', 'waterbowl*5', 'waterbowl*5', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'pet_drink', 6, '', '', '', 0, 0, ''),
	(1537, 1537, '0', 'waterbowl*2', 'waterbowl*2', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'pet_drink', 6, '', '', '', 0, 0, ''),
	(1538, 1538, '0', 'waterbowl*1', 'waterbowl*1', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'pet_drink', 6, '', '', '', 0, 0, ''),
	(1539, 1539, '0', 'waterbowl*3', 'waterbowl*3', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'pet_drink', 6, '', '', '', 0, 0, ''),
	(1540, 1540, '0', 'toy1', 'toy1', 'S', 1, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1541, 1541, '0', 'toy1*1', 'toy1*1', 'S', 1, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1542, 1542, '0', 'toy1*2', 'toy1*2', 'S', 1, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1543, 1543, '0', 'toy1*3', 'toy1*3', 'S', 1, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1544, 1544, '0', 'toy1*4', 'toy1*4', 'S', 1, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1545, 1545, '0', 'goodie1', 'goodie1', 'S', 1, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1546, 1546, '0', 'goodie1*1', 'goodie1*1', 'S', 1, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1547, 1547, '0', 'goodie1*2', 'goodie1*2', 'S', 1, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1548, 1548, '0', 'goodie2', 'goodie2', 'S', 1, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1549, 1549, '0', 'scifiport*0', 'scifiport*0', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(1550, 1550, '0', 'scifiport*9', 'scifiport*9', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(1551, 1551, '0', 'scifiport*8', 'scifiport*8', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(1552, 1552, '0', 'scifiport*7', 'scifiport*7', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(1553, 1553, '0', 'scifiport*6', 'scifiport*6', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(1554, 1554, '0', 'scifiport*5', 'scifiport*5', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(1555, 1555, '0', 'scifiport*4', 'scifiport*4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(1556, 1556, '0', 'scifiport*3', 'scifiport*3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(1557, 1557, '0', 'scifiport*2', 'scifiport*2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(1558, 1558, '0', 'scifiport*1', 'scifiport*1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(1559, 1559, '0', 'scifirocket*9', 'scifirocket*9', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1560, 1560, '0', 'scifirocket*8', 'scifirocket*8', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1561, 1561, '0', 'scifirocket*7', 'scifirocket*7', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1562, 1562, '0', 'scifirocket*6', 'scifirocket*6', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1563, 1563, '0', 'scifirocket*5', 'scifirocket*5', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1564, 1564, '0', 'scifirocket*4', 'scifirocket*4', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1565, 1565, '0', 'scifirocket*3', 'scifirocket*3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1566, 1566, '0', 'scifirocket*2', 'scifirocket*2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1567, 1567, '0', 'scifirocket*1', 'scifirocket*1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1568, 1568, '0', 'scifirocket*0', 'scifirocket*0', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1569, 1569, '0', 'scifidoor*10', 'scifidoor*10', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(1570, 1570, '0', 'scifidoor*9', 'scifidoor*9', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(1571, 1571, '0', 'scifidoor*8', 'scifidoor*8', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(1572, 1572, '0', 'scifidoor*7', 'scifidoor*7', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(1573, 1573, '0', 'scifidoor*6', 'scifidoor*6', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(1574, 1574, '0', 'scifidoor*5', 'scifidoor*5', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(1575, 1575, '0', 'scifidoor*4', 'scifidoor*4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(1576, 1576, '0', 'scifidoor*3', 'scifidoor*3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(1577, 1577, '0', 'scifidoor*2', 'scifidoor*2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(1578, 1578, '0', 'scifidoor*1', 'scifidoor*1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(1579, 1579, '0', 'pillow*5', 'pillow*5', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1580, 1580, '0', 'pillow*8', 'pillow*8', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1581, 1581, '0', 'pillow*0', 'pillow*0', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1582, 1582, '0', 'pillow*1', 'pillow*1', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1583, 1583, '0', 'pillow*2', 'pillow*2', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1584, 1584, '0', 'pillow*7', 'pillow*7', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1585, 1585, '0', 'pillow*9', 'pillow*9', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1586, 1586, '0', 'pillow*4', 'pillow*4', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1587, 1587, '0', 'pillow*6', 'pillow*6', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1588, 1588, '0', 'pillow*3', 'pillow*3', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1589, 1589, '0', 'marquee*1', 'marquee*1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(1590, 1590, '0', 'marquee*2', 'marquee*2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(1591, 1591, '0', 'marquee*7', 'marquee*7', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(1592, 1592, '0', 'marquee*10', 'marquee*10', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(1593, 1593, '0', 'marquee*8', 'marquee*8', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(1594, 1594, '0', 'marquee*9', 'marquee*9', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(1595, 1595, '0', 'marquee*5', 'marquee*5', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(1596, 1596, '0', 'marquee*4', 'marquee*4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(1597, 1597, '0', 'marquee*6', 'marquee*6', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(1598, 1598, '0', 'marquee*3', 'marquee*3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(1599, 1599, '0', 'wooden_screen*1', 'wooden_screen*1', 'S', 1, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1600, 1600, '0', 'wooden_screen*2', 'wooden_screen*2', 'S', 1, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1601, 1601, '0', 'wooden_screen*7', 'wooden_screen*7', 'S', 1, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1602, 1602, '0', 'wooden_screen*0', 'wooden_screen*0', 'S', 1, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1603, 1603, '0', 'wooden_screen*8', 'wooden_screen*8', 'S', 1, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1604, 1604, '0', 'wooden_screen*5', 'wooden_screen*5', 'S', 1, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1605, 1605, '0', 'wooden_screen*9', 'wooden_screen*9', 'S', 1, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1606, 1606, '0', 'wooden_screen*4', 'wooden_screen*4', 'S', 1, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1607, 1607, '0', 'wooden_screen*6', 'wooden_screen*6', 'S', 1, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1608, 1608, '0', 'wooden_screen*3', 'wooden_screen*3', 'S', 1, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1609, 1609, '0', 'pillar*6', 'pillar*6', 'S', 1, 1, 3.50, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1610, 1610, '0', 'pillar*1', 'pillar*1', 'S', 1, 1, 3.50, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1611, 1611, '0', 'pillar*9', 'pillar*9', 'S', 1, 1, 3.50, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1612, 1612, '0', 'pillar*0', 'pillar*0', 'S', 1, 1, 3.50, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1613, 1613, '0', 'pillar*8', 'pillar*8', 'S', 1, 1, 3.50, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1614, 1614, '0', 'pillar*2', 'pillar*2', 'S', 1, 1, 3.50, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1615, 1615, '0', 'pillar*5', 'pillar*5', 'S', 1, 1, 3.50, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1616, 1616, '0', 'pillar*4', 'pillar*4', 'S', 1, 1, 3.50, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1617, 1617, '0', 'pillar*7', 'pillar*7', 'S', 1, 1, 3.50, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1618, 1618, '0', 'pillar*3', 'pillar*3', 'S', 1, 1, 3.50, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1619, 1619, '0', 'rare_dragonlamp*4', 'rare_dragonlamp*4', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1620, 1620, '0', 'rare_dragonlamp*0', 'rare_dragonlamp*0', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1621, 1621, '0', 'rare_dragonlamp*5', 'rare_dragonlamp*5', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1622, 1622, '0', 'rare_dragonlamp*2', 'rare_dragonlamp*2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1623, 1623, '0', 'rare_dragonlamp*8', 'rare_dragonlamp*8', 'S', 1, 1, 2.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1624, 1624, '0', 'rare_dragonlamp*9', 'rare_dragonlamp*9', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1625, 1625, '0', 'rare_dragonlamp*7', 'rare_dragonlamp*7', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1626, 1626, '0', 'rare_dragonlamp*6', 'rare_dragonlamp*6', 'S', 1, 1, 2.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1627, 1627, '0', 'rare_dragonlamp*1', 'rare_dragonlamp*1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1628, 1628, '0', 'rare_dragonlamp*3', 'rare_dragonlamp*3', 'S', 1, 1, 2.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1629, 1629, '0', 'rare_icecream*1', 'rare_icecream*1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'vendingmachine', 2, '4', '', '', 0, 0, ''),
	(1630, 1630, '0', 'rare_icecream*7', 'rare_icecream*7', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'vendingmachine', 2, '4', '', '', 0, 0, ''),
	(1631, 1631, '0', 'rare_icecream*8', 'rare_icecream*8', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'vendingmachine', 2, '4', '', '', 0, 0, ''),
	(1632, 1632, '0', 'rare_icecream*2', 'rare_icecream*2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'vendingmachine', 2, '4', '', '', 0, 0, ''),
	(1633, 1633, '0', 'rare_icecream*6', 'rare_icecream*6', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'vendingmachine', 2, '4', '', '', 0, 0, ''),
	(1634, 1634, '0', 'rare_icecream*9', 'rare_icecream*9', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'vendingmachine', 2, '4', '', '', 0, 0, ''),
	(1635, 1635, '0', 'rare_icecream*3', 'rare_icecream*3', 'S', 1, 1, 2.50, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'vendingmachine', 2, '4', '', '', 0, 0, ''),
	(1636, 1636, '0', 'rare_icecream*0', 'rare_icecream*0', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'vendingmachine', 2, '4', '', '', 0, 0, ''),
	(1637, 1637, '0', 'rare_icecream*4', 'rare_icecream*4', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'vendingmachine', 2, '4', '', '', 0, 0, ''),
	(1638, 1638, '0', 'rare_icecream*5', 'rare_icecream*5', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'vendingmachine', 2, '4', '', '', 0, 0, ''),
	(1639, 1639, '0', 'rare_fan*7', 'rare_fan*7', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1640, 1640, '0', 'rare_fan*6', 'rare_fan*6', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1641, 1641, '0', 'rare_fan*9', 'rare_fan*9', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1642, 1642, '0', 'rare_fan*3', 'rare_fan*3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1643, 1643, '0', 'rare_fan*0', 'rare_fan*0', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1644, 1644, '0', 'rare_fan*4', 'rare_fan*4', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1645, 1645, '0', 'rare_fan*5', 'rare_fan*5', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1646, 1646, '0', 'rare_fan*1', 'rare_fan*1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1647, 1647, '0', 'rare_fan*8', 'rare_fan*8', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1648, 1648, '0', 'rare_fan*2', 'rare_fan*2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1649, 1649, '0', 'queue_tile1*3', 'queue_tile1*3', 'S', 1, 1, 0.50, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'roller', 1, '', '', '', 0, 0, ''),
	(1650, 1650, '0', 'queue_tile1*6', 'queue_tile1*6', 'S', 1, 1, 0.50, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'roller', 1, '', '', '', 0, 0, ''),
	(1651, 1651, '0', 'queue_tile1*4', 'queue_tile1*4', 'S', 1, 1, 0.50, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'roller', 1, '', '', '', 0, 0, ''),
	(1652, 1652, '1', 'queue_tile1*9', 'queue_tile1*9', 'S', 1, 1, 0.50, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'roller', 1, '', '', '', 0, 0, ''),
	(1653, 1653, '1', 'queue_tile1*8', 'queue_tile1*8', 'S', 1, 1, 0.50, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'roller', 1, '', '', '', 0, 0, ''),
	(1654, 1654, '0', 'queue_tile1*5', 'queue_tile1*5', 'S', 1, 1, 0.50, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'roller', 1, '', '', '', 0, 0, ''),
	(1655, 1655, '1', 'queue_tile1*7', 'queue_tile1*7', 'S', 1, 1, 0.50, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'roller', 1, '', '', '', 0, 0, ''),
	(1656, 1656, '1', 'queue_tile1*2', 'queue_tile1*2', 'S', 1, 1, 0.50, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'roller', 1, '', '', '', 0, 0, ''),
	(1657, 1657, '0', 'queue_tile1*1', 'queue_tile1*1', 'S', 1, 1, 0.50, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'roller', 1, '', '', '', 0, 0, ''),
	(1658, 1658, '0', 'queue_tile1*0', 'queue_tile1*0', 'S', 1, 1, 0.50, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'roller', 1, '', '', '', 0, 0, ''),
	(1659, 1659, '0', 'ticket', 'ticket', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1738, 1738, '0', 'rare_snowrug', 'rare_snowrug', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1741, 1741, '0', 'cn_lamp', 'cn_lamp', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1742, 1742, '0', 'cn_sofa', 'cn_sofa', 'S', 3, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1745, 1745, '1', 'sporttrack1*1', 'sporttrack1*1', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1747, 1747, '1', 'sporttrack1*3', 'sporttrack1*3', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1748, 1748, '1', 'sporttrack1*2', 'sporttrack1*2', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1750, 1750, '1', 'sporttrack2*1', 'sporttrack2*1', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1751, 1751, '1', 'sporttrack2*2', 'sporttrack2*2', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1752, 1752, '1', 'sporttrack2*3', 'sporttrack2*3', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1754, 1754, '1', 'sporttrack3*1', 'sporttrack3*1', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1755, 1755, '1', 'sporttrack3*2', 'sporttrack3*2', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1756, 1756, '1', 'sporttrack3*3', 'sporttrack3*3', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1757, 1757, '0', 'footylamp', 'footylamp', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1758, 1758, '0', 'tree1', 'tree1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1759, 1759, '1', 'barchair_silo', 'barchair_silo', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1760, 1760, '1', 'divider_nor4*4', 'divider_nor4*4', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(1761, 1761, '1', 'traffic_light*1', 'traffic_light*1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(1762, 1762, '1', 'traffic_light*2', 'traffic_light*2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(1763, 1763, '1', 'traffic_light*3', 'traffic_light*3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(1764, 1764, '1', 'traffic_light*4', 'traffic_light*4', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(1765, 1765, '1', 'traffic_light*6', 'traffic_light*6', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(1766, 1766, '0', 'rubberchair*1', 'rubberchair*1', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1767, 1767, '1', 'rubberchair*2', 'rubberchair*2', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1768, 1768, '1', 'rubberchair*3', 'rubberchair*3', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1769, 1769, '1', 'rubberchair*4', 'rubberchair*4', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1770, 1770, '1', 'rubberchair*5', 'rubberchair*5', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1771, 1771, '1', 'rubberchair*6', 'rubberchair*6', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1772, 1772, '1', 'barrier*1', 'barrier*1', 'S', 1, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1773, 1773, '1', 'barrier*2', 'barrier*2', 'S', 1, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1774, 1774, '1', 'barrier*3', 'barrier*3', 'S', 1, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1775, 1775, '1', 'rubberchair*7', 'rubberchair*7', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1776, 1776, '1', 'rubberchair*8', 'rubberchair*8', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1777, 1777, '1', 'table_norja_med*2', 'table_norja_med*2', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1778, 1778, '1', 'table_norja_med*3', 'table_norja_med*3', 'S', 2, 2, 1.10, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1779, 1779, '1', 'table_norja_med*4', 'table_norja_med*4', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1780, 1780, '1', 'table_norja_med*5', 'table_norja_med*5', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1781, 1781, '1', 'table_norja_med*6', 'table_norja_med*6', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1782, 1782, '1', 'table_norja_med*7', 'table_norja_med*7', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1783, 1783, '1', 'table_norja_med*8', 'table_norja_med*8', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1784, 1784, '1', 'table_norja_med*9', 'table_norja_med*9', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1785, 1785, '1', 'couch_norja*2', 'couch_norja*2', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1786, 1786, '1', 'couch_norja*3', 'couch_norja*3', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1787, 1787, '1', 'couch_norja*4', 'couch_norja*4', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1788, 1788, '1', 'couch_norja*5', 'couch_norja*5', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1789, 1789, '1', 'couch_norja*6', 'couch_norja*6', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1790, 1790, '1', 'couch_norja*7', 'couch_norja*7', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1791, 1791, '1', 'couch_norja*8', 'couch_norja*8', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1792, 1792, '1', 'couch_norja*9', 'couch_norja*9', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1793, 1793, '1', 'shelves_norja*2', 'shelves_norja*2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1794, 1794, '1', 'shelves_norja*3', 'shelves_norja*3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1795, 1795, '1', 'shelves_norja*4', 'shelves_norja*4', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1796, 1796, '1', 'shelves_norja*5', 'shelves_norja*5', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1797, 1797, '1', 'shelves_norja*6', 'shelves_norja*6', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1798, 1798, '1', 'shelves_norja*7', 'shelves_norja*7', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1799, 1799, '1', 'shelves_norja*8', 'shelves_norja*8', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1800, 1800, '1', 'shelves_norja*9', 'shelves_norja*9', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1801, 1801, '1', 'chair_norja*2', 'chair_norja*2', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1802, 1802, '1', 'chair_norja*3', 'chair_norja*3', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1803, 1803, '1', 'chair_norja*4', 'chair_norja*4', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1804, 1804, '1', 'chair_norja*5', 'chair_norja*5', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1805, 1805, '1', 'chair_norja*6', 'chair_norja*6', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1806, 1806, '1', 'chair_norja*7', 'chair_norja*7', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1807, 1807, '1', 'chair_norja*8', 'chair_norja*8', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1808, 1808, '1', 'chair_norja*9', 'chair_norja*9', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1809, 1809, '1', 'divider_nor1*2', 'divider_nor1*2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1810, 1810, '1', 'divider_nor1*3', 'divider_nor1*3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1811, 1811, '1', 'divider_nor1*4', 'divider_nor1*4', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1812, 1812, '1', 'divider_nor1*5', 'divider_nor1*5', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1813, 1813, '1', 'divider_nor1*6', 'divider_nor1*6', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1814, 1814, '1', 'divider_nor1*7', 'divider_nor1*7', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1815, 1815, '1', 'divider_nor1*8', 'divider_nor1*8', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1816, 1816, '1', 'divider_nor1*9', 'divider_nor1*9', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1817, 1817, '1', 'soft_sofa_norja*2', 'soft_sofa_norja*2', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1818, 1818, '1', 'soft_sofa_norja*3', 'soft_sofa_norja*3', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1819, 1819, '1', 'soft_sofa_norja*4', 'soft_sofa_norja*4', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1820, 1820, '1', 'soft_sofa_norja*5', 'soft_sofa_norja*5', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1821, 1821, '1', 'soft_sofa_norja*6', 'soft_sofa_norja*6', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1822, 1822, '1', 'soft_sofa_norja*7', 'soft_sofa_norja*7', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1823, 1823, '1', 'soft_sofa_norja*8', 'soft_sofa_norja*8', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1824, 1824, '1', 'soft_sofa_norja*9', 'soft_sofa_norja*9', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1825, 1825, '1', 'soft_sofachair_norja*2', 'soft_sofachair_norja*2', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1826, 1826, '1', 'soft_sofachair_norja*3', 'soft_sofachair_norja*3', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1827, 1827, '1', 'soft_sofachair_norja*4', 'soft_sofachair_norja*4', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1828, 1828, '1', 'soft_sofachair_norja*5', 'soft_sofachair_norja*5', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1829, 1829, '1', 'soft_sofachair_norja*6', 'soft_sofachair_norja*6', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1830, 1830, '1', 'soft_sofachair_norja*7', 'soft_sofachair_norja*7', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1831, 1831, '1', 'soft_sofachair_norja*8', 'soft_sofachair_norja*8', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1832, 1832, '1', 'soft_sofachair_norja*9', 'soft_sofachair_norja*9', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1833, 1833, '1', 'sofachair_silo*2', 'sofachair_silo*2', 'S', 1, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1834, 1834, '1', 'sofachair_silo*3', 'sofachair_silo*3', 'S', 1, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1835, 1835, '1', 'sofachair_silo*4', 'sofachair_silo*4', 'S', 1, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1836, 1836, '1', 'sofachair_silo*5', 'sofachair_silo*5', 'S', 1, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1837, 1837, '1', 'sofachair_silo*6', 'sofachair_silo*6', 'S', 1, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1838, 1838, '1', 'sofachair_silo*7', 'sofachair_silo*7', 'S', 1, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1839, 1839, '1', 'sofachair_silo*8', 'sofachair_silo*8', 'S', 1, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1840, 1840, '1', 'sofachair_silo*9', 'sofachair_silo*9', 'S', 1, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1841, 1841, '1', 'table_silo_small*2', 'table_silo_small*2', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1842, 1842, '1', 'table_silo_small*3', 'table_silo_small*3', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1843, 1843, '1', 'table_silo_small*4', 'table_silo_small*4', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1844, 1844, '1', 'table_silo_small*5', 'table_silo_small*5', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1845, 1845, '1', 'table_silo_small*6', 'table_silo_small*6', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1846, 1846, '1', 'table_silo_small*7', 'table_silo_small*7', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1847, 1847, '1', 'table_silo_small*8', 'table_silo_small*8', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1848, 1848, '1', 'table_silo_small*9', 'table_silo_small*9', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1849, 1849, '1', 'divider_silo1*2', 'divider_silo1*2', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1850, 1850, '1', 'divider_silo1*3', 'divider_silo1*3', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1851, 1851, '1', 'divider_silo1*4', 'divider_silo1*4', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1852, 1852, '1', 'divider_silo1*5', 'divider_silo1*5', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1853, 1853, '1', 'divider_silo1*6', 'divider_silo1*6', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1854, 1854, '1', 'divider_silo1*7', 'divider_silo1*7', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1855, 1855, '1', 'divider_silo1*8', 'divider_silo1*8', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1856, 1856, '1', 'divider_silo1*9', 'divider_silo1*9', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1857, 1857, '1', 'divider_silo3*2', 'divider_silo3*2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(1858, 1858, '1', 'divider_silo3*3', 'divider_silo3*3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(1859, 1859, '1', 'divider_silo3*4', 'divider_silo3*4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(1860, 1860, '1', 'divider_silo3*5', 'divider_silo3*5', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(1861, 1861, '1', 'divider_silo3*6', 'divider_silo3*6', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(1862, 1862, '1', 'divider_silo3*7', 'divider_silo3*7', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(1863, 1863, '1', 'divider_silo3*8', 'divider_silo3*8', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(1864, 1864, '1', 'divider_silo3*9', 'divider_silo3*9', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(1865, 1865, '1', 'table_silo_med*2', 'table_silo_med*2', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1866, 1866, '1', 'table_silo_med*3', 'table_silo_med*3', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1867, 1867, '1', 'table_silo_med*4', 'table_silo_med*4', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1868, 1868, '1', 'table_silo_med*5', 'table_silo_med*5', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1869, 1869, '1', 'table_silo_med*6', 'table_silo_med*6', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1870, 1870, '1', 'table_silo_med*7', 'table_silo_med*7', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1871, 1871, '1', 'table_silo_med*8', 'table_silo_med*8', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1872, 1872, '1', 'table_silo_med*9', 'table_silo_med*9', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1873, 1873, '1', 'sofa_silo*2', 'sofa_silo*2', 'S', 2, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1874, 1874, '1', 'sofa_silo*3', 'sofa_silo*3', 'S', 2, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1875, 1875, '1', 'sofa_silo*4', 'sofa_silo*4', 'S', 2, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1876, 1876, '1', 'sofa_silo*5', 'sofa_silo*5', 'S', 2, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1877, 1877, '1', 'sofa_silo*6', 'sofa_silo*6', 'S', 2, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1878, 1878, '1', 'sofa_silo*7', 'sofa_silo*7', 'S', 2, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1879, 1879, '1', 'sofa_silo*8', 'sofa_silo*8', 'S', 2, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1880, 1880, '1', 'sofa_silo*9', 'sofa_silo*9', 'S', 2, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1881, 1881, '0', 'sofachair_polyfon*2', 'sofachair_polyfon*2', 'S', 1, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1882, 1882, '0', 'sofachair_polyfon*3', 'sofachair_polyfon*3', 'S', 1, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1883, 1883, '0', 'sofachair_polyfon*4', 'sofachair_polyfon*4', 'S', 1, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1884, 1884, '1', 'sofachair_polyfon*6', 'sofachair_polyfon*6', 'S', 1, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1885, 1885, '1', 'sofachair_polyfon*7', 'sofachair_polyfon*7', 'S', 1, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1886, 1886, '0', 'sofachair_polyfon*8', 'sofachair_polyfon*8', 'S', 1, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1887, 1887, '0', 'sofachair_polyfon*9', 'sofachair_polyfon*9', 'S', 1, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1888, 1888, '0', 'sofa_polyfon*2', 'sofa_polyfon*2', 'S', 2, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1889, 1889, '0', 'sofa_polyfon*3', 'sofa_polyfon*3', 'S', 2, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1890, 1890, '0', 'sofa_polyfon*4', 'sofa_polyfon*4', 'S', 2, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1891, 1891, '1', 'sofa_polyfon*6', 'sofa_polyfon*6', 'S', 2, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1892, 1892, '1', 'sofa_polyfon*7', 'sofa_polyfon*7', 'S', 2, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1893, 1893, '0', 'sofa_polyfon*8', 'sofa_polyfon*8', 'S', 2, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1894, 1894, '0', 'sofa_polyfon*9', 'sofa_polyfon*9', 'S', 2, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1895, 1895, '0', 'bed_polyfon*2', 'bed_polyfon*2', 'S', 2, 3, 1.50, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(1896, 1896, '0', 'bed_polyfon*3', 'bed_polyfon*3', 'S', 2, 3, 1.50, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(1897, 1897, '0', 'bed_polyfon*4', 'bed_polyfon*4', 'S', 2, 3, 1.50, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(1898, 1898, '1', 'bed_polyfon*6', 'bed_polyfon*6', 'S', 2, 3, 1.50, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(1899, 1899, '1', 'bed_polyfon*7', 'bed_polyfon*7', 'S', 2, 3, 1.50, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(1900, 1900, '0', 'bed_polyfon*8', 'bed_polyfon*8', 'S', 2, 3, 1.60, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(1901, 1901, '0', 'bed_polyfon*9', 'bed_polyfon*9', 'S', 2, 3, 1.50, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(1902, 1902, '0', 'bed_polyfon_one*2', 'bed_polyfon_one*2', 'S', 1, 3, 1.60, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(1903, 1903, '0', 'bed_polyfon_one*3', 'bed_polyfon_one*3', 'S', 1, 3, 1.50, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(1904, 1904, '0', 'bed_polyfon_one*4', 'bed_polyfon_one*4', 'S', 1, 3, 1.50, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(1905, 1905, '1', 'bed_polyfon_one*6', 'bed_polyfon_one*6', 'S', 1, 3, 1.50, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(1906, 1906, '1', 'bed_polyfon_one*7', 'bed_polyfon_one*7', 'S', 1, 3, 1.50, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(1907, 1907, '0', 'bed_polyfon_one*8', 'bed_polyfon_one*8', 'S', 1, 3, 1.50, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(1908, 1908, '0', 'bed_polyfon_one*9', 'bed_polyfon_one*9', 'S', 1, 3, 1.50, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(1909, 1909, '0', 'bardesk_polyfon*2', 'bardesk_polyfon*2', 'S', 2, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1910, 1910, '0', 'bardesk_polyfon*3', 'bardesk_polyfon*3', 'S', 2, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1911, 1911, '0', 'bardesk_polyfon*4', 'bardesk_polyfon*4', 'S', 2, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1912, 1912, '0', 'bardesk_polyfon*5', 'bardesk_polyfon*5', 'S', 2, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1913, 1913, '1', 'bardesk_polyfon*6', 'bardesk_polyfon*6', 'S', 2, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1914, 1914, '1', 'bardesk_polyfon*7', 'bardesk_polyfon*7', 'S', 2, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1915, 1915, '0', 'bardesk_polyfon*8', 'bardesk_polyfon*8', 'S', 2, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1916, 1916, '0', 'bardesk_polyfon*9', 'bardesk_polyfon*9', 'S', 2, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1917, 1917, '0', 'bardeskcorner_polyfon*2', 'bardeskcorner_polyfon*2', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1918, 1918, '0', 'bardeskcorner_polyfon*3', 'bardeskcorner_polyfon*3', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1919, 1919, '0', 'bardeskcorner_polyfon*4', 'bardeskcorner_polyfon*4', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1920, 1920, '0', 'bardeskcorner_polyfon*5', 'bardeskcorner_polyfon*5', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1921, 1921, '1', 'bardeskcorner_polyfon*6', 'bardeskcorner_polyfon*6', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1922, 1922, '1', 'bardeskcorner_polyfon*7', 'bardeskcorner_polyfon*7', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1923, 1923, '0', 'bardeskcorner_polyfon*8', 'bardeskcorner_polyfon*8', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1924, 1924, '0', 'bardeskcorner_polyfon*9', 'bardeskcorner_polyfon*9', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1925, 1925, '0', 'divider_poly3*2', 'divider_poly3*2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(1926, 1926, '0', 'divider_poly3*3', 'divider_poly3*3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(1927, 1927, '0', 'divider_poly3*4', 'divider_poly3*4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(1928, 1928, '0', 'divider_poly3*5', 'divider_poly3*5', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(1929, 1929, '1', 'divider_poly3*6', 'divider_poly3*6', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(1930, 1930, '1', 'divider_poly3*7', 'divider_poly3*7', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(1931, 1931, '0', 'divider_poly3*8', 'divider_poly3*8', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(1932, 1932, '0', 'divider_poly3*9', 'divider_poly3*9', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(1933, 1933, '1', 'chair_silo*2', 'chair_silo*2', 'S', 1, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1934, 1934, '1', 'chair_silo*3', 'chair_silo*3', 'S', 1, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1935, 1935, '1', 'chair_silo*4', 'chair_silo*4', 'S', 1, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1936, 1936, '1', 'chair_silo*5', 'chair_silo*5', 'S', 1, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1937, 1937, '1', 'chair_silo*6', 'chair_silo*6', 'S', 1, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1938, 1938, '1', 'chair_silo*7', 'chair_silo*7', 'S', 1, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1939, 1939, '1', 'chair_silo*8', 'chair_silo*8', 'S', 1, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1940, 1940, '1', 'chair_silo*9', 'chair_silo*9', 'S', 1, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1941, 1941, '1', 'divider_nor3*2', 'divider_nor3*2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 1, '', '', '', 0, 0, ''),
	(1942, 1942, '1', 'divider_nor3*3', 'divider_nor3*3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(1943, 1943, '1', 'divider_nor3*4', 'divider_nor3*4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(1944, 1944, '1', 'divider_nor3*5', 'divider_nor3*5', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(1945, 1945, '1', 'divider_nor3*6', 'divider_nor3*6', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(1946, 1946, '1', 'divider_nor3*7', 'divider_nor3*7', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(1947, 1947, '1', 'divider_nor3*8', 'divider_nor3*8', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(1948, 1948, '1', 'divider_nor3*9', 'divider_nor3*9', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(1949, 1949, '1', 'divider_nor2*2', 'divider_nor2*2', 'S', 2, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1950, 1950, '1', 'divider_nor2*3', 'divider_nor2*3', 'S', 2, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1951, 1951, '1', 'divider_nor2*4', 'divider_nor2*4', 'S', 2, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1952, 1952, '1', 'divider_nor2*5', 'divider_nor2*5', 'S', 2, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1953, 1953, '1', 'divider_nor2*6', 'divider_nor2*6', 'S', 2, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1954, 1954, '1', 'divider_nor2*7', 'divider_nor2*7', 'S', 2, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1955, 1955, '1', 'divider_nor2*8', 'divider_nor2*8', 'S', 2, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1956, 1956, '1', 'divider_nor2*9', 'divider_nor2*9', 'S', 2, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1957, 1957, '1', 'silo_studydesk', 'silo_studydesk', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1958, 1958, '1', 'solarium_norja', 'solarium_norja', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1959, 1959, '1', 'solarium_norja*1', 'solarium_norja*1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1960, 1960, '1', 'solarium_norja*2', 'solarium_norja*2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1961, 1961, '1', 'solarium_norja*3', 'solarium_norja*3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1962, 1962, '1', 'solarium_norja*5', 'solarium_norja*5', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1963, 1963, '1', 'solarium_norja*6', 'solarium_norja*6', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1964, 1964, '1', 'solarium_norja*7', 'solarium_norja*7', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1965, 1965, '1', 'solarium_norja*8', 'solarium_norja*8', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1966, 1966, '1', 'solarium_norja*9', 'solarium_norja*9', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1967, 1967, '0', 'sandrug', 'sandrug', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1968, 1968, '0', 'rare_moonrug', 'rare_moonrug', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1969, 1969, '0', 'chair_china', 'chair_china', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1970, 1970, '0', 'china_table', 'china_table', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1971, 1971, '0', 'sleepingbag*1', 'sleepingbag*1', 'S', 1, 3, 0.80, '0', '0', '1', '0', '1', '1', '0', '1', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(1972, 1972, '0', 'sleepingbag*2', 'sleepingbag*2', 'S', 1, 3, 0.80, '0', '0', '1', '0', '1', '1', '0', '1', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(1973, 1973, '0', 'sleepingbag*3', 'sleepingbag*3', 'S', 1, 3, 0.80, '0', '0', '1', '0', '1', '1', '0', '1', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(1974, 1974, '0', 'sleepingbag*4', 'sleepingbag*4', 'S', 1, 3, 0.80, '0', '0', '1', '0', '1', '1', '0', '1', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(1975, 1975, '1', 'safe_silo', 'safe_silo', 'S', 1, 1, 1.30, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '17', '', '', 0, 0, ''),
	(1976, 1976, '0', 'sleepingbag*7', 'sleepingbag*7', 'S', 1, 3, 0.80, '0', '0', '1', '0', '1', '1', '0', '1', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(1977, 1977, '0', 'sleepingbag*9', 'sleepingbag*9', 'S', 1, 3, 0.80, '0', '0', '1', '0', '1', '1', '0', '1', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(1978, 1978, '0', 'sleepingbag*5', 'sleepingbag*5', 'S', 1, 3, 0.80, '0', '0', '1', '0', '1', '1', '0', '1', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(1979, 1979, '0', 'sleepingbag*10', 'sleepingbag*10', 'S', 1, 3, 0.80, '0', '0', '1', '0', '1', '1', '0', '1', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(1980, 1980, '0', 'sleepingbag*6', 'sleepingbag*6', 'S', 1, 3, 0.80, '0', '0', '1', '0', '1', '1', '0', '1', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(1981, 1981, '0', 'sleepingbag*8', 'sleepingbag*8', 'S', 1, 3, 0.80, '0', '0', '1', '0', '1', '1', '0', '1', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(1982, 1982, '0', 'china_shelve', 'china_shelve', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1983, 1983, '1', 'traffic_light*5', 'traffic_light*5', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(1984, 1984, '1', 'divider_nor4*2', 'divider_nor4*2', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(1985, 1985, '1', 'divider_nor4*3', 'divider_nor4*3', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(1986, 1986, '1', 'divider_nor4*5', 'divider_nor4*5', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(1987, 1987, '1', 'divider_nor4*6', 'divider_nor4*6', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(1988, 1988, '1', 'divider_nor4*7', 'divider_nor4*7', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(1989, 1989, '1', 'divider_nor4*8', 'divider_nor4*8', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(1990, 1990, '1', 'divider_nor4*9', 'divider_nor4*9', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(1991, 1991, '1', 'divider_nor5*2', 'divider_nor5*2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1992, 1992, '1', 'divider_nor5*3', 'divider_nor5*3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1993, 1993, '1', 'divider_nor5*4', 'divider_nor5*4', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1994, 1994, '1', 'divider_nor5*5', 'divider_nor5*5', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1995, 1995, '1', 'divider_nor5*6', 'divider_nor5*6', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1996, 1996, '1', 'divider_nor5*7', 'divider_nor5*7', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1997, 1997, '1', 'divider_nor5*8', 'divider_nor5*8', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1998, 1998, '1', 'divider_nor5*9', 'divider_nor5*9', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(1999, 1999, '1', 'divider_nor5', 'divider_nor5', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2000, 2000, '1', 'divider_nor4', 'divider_nor4', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(2001, 2001, '0', 'wall_china', 'wall_china', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2002, 2002, '0', 'corner_china', 'corner_china', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2003, 2003, '1', 'barchair_silo*2', 'barchair_silo*2', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2004, 2004, '1', 'barchair_silo*3', 'barchair_silo*3', 'S', 1, 1, 1.30, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2005, 2005, '1', 'barchair_silo*4', 'barchair_silo*4', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(2006, 2006, '1', 'barchair_silo*5', 'barchair_silo*5', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(2007, 2007, '1', 'barchair_silo*6', 'barchair_silo*6', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(2008, 2008, '1', 'barchair_silo*7', 'barchair_silo*7', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(2009, 2009, '1', 'barchair_silo*8', 'barchair_silo*8', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(2010, 2010, '1', 'barchair_silo*9', 'barchair_silo*9', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(2011, 2011, '1', 'safe_silo*2', 'safe_silo*2', 'S', 1, 1, 1.30, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '17', '', '', 0, 0, ''),
	(2012, 2012, '1', 'safe_silo*3', 'safe_silo*3', 'S', 1, 1, 1.30, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '17', '', '', 0, 0, ''),
	(2013, 2013, '1', 'safe_silo*4', 'safe_silo*4', 'S', 1, 1, 1.30, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '17', '', '', 0, 0, ''),
	(2014, 2014, '1', 'safe_silo*5', 'safe_silo*5', 'S', 1, 1, 1.30, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '17', '', '', 0, 0, ''),
	(2015, 2015, '1', 'safe_silo*6', 'safe_silo*6', 'S', 1, 1, 1.30, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '17', '', '', 0, 0, ''),
	(2016, 2016, '1', 'safe_silo*7', 'safe_silo*7', 'S', 1, 1, 1.30, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '17', '', '', 0, 0, ''),
	(2017, 2017, '1', 'safe_silo*8', 'safe_silo*8', 'S', 1, 1, 1.30, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '17', '', '', 0, 0, ''),
	(2018, 2018, '1', 'safe_silo*9', 'safe_silo*9', 'S', 1, 1, 1.30, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '17', '', '', 0, 0, ''),
	(2019, 2019, '1', 'glass_shelf', 'glass_shelf', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2020, 2020, '1', 'glass_chair', 'glass_chair', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2021, 2021, '1', 'glass_stool', 'glass_stool', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2022, 2022, '1', 'glass_sofa', 'glass_sofa', 'S', 2, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2023, 2023, '1', 'glass_table', 'glass_table', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2024, 2024, '1', 'glass_table*2', 'glass_table*2', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2025, 2025, '1', 'glass_table*3', 'glass_table*3', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2026, 2026, '1', 'glass_table*4', 'glass_table*4', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2027, 2027, '1', 'glass_table*5', 'glass_table*5', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2028, 2028, '1', 'glass_table*6', 'glass_table*6', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2029, 2029, '1', 'glass_table*7', 'glass_table*7', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2030, 2030, '1', 'glass_table*8', 'glass_table*8', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2031, 2031, '1', 'glass_table*9', 'glass_table*9', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2032, 2032, '1', 'glass_chair*2', 'glass_chair*2', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2033, 2033, '1', 'glass_chair*3', 'glass_chair*3', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2034, 2034, '1', 'glass_chair*4', 'glass_chair*4', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2035, 2035, '1', 'glass_chair*5', 'glass_chair*5', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2036, 2036, '1', 'glass_chair*6', 'glass_chair*6', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2037, 2037, '1', 'glass_chair*7', 'glass_chair*7', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2038, 2038, '1', 'glass_chair*8', 'glass_chair*8', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2039, 2039, '1', 'glass_chair*9', 'glass_chair*9', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2040, 2040, '1', 'glass_sofa*2', 'glass_sofa*2', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2041, 2041, '1', 'glass_sofa*3', 'glass_sofa*3', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2042, 2042, '1', 'glass_sofa*4', 'glass_sofa*4', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2043, 2043, '1', 'glass_sofa*5', 'glass_sofa*5', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2044, 2044, '1', 'glass_sofa*6', 'glass_sofa*6', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2045, 2045, '1', 'glass_sofa*7', 'glass_sofa*7', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2046, 2046, '1', 'glass_sofa*8', 'glass_sofa*8', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2047, 2047, '1', 'glass_sofa*9', 'glass_sofa*9', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2048, 2048, '1', 'glass_stool*2', 'glass_stool*2', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2050, 2050, '1', 'glass_stool*4', 'glass_stool*4', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2051, 2051, '1', 'glass_stool*5', 'glass_stool*5', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2052, 2052, '1', 'glass_stool*6', 'glass_stool*6', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2053, 2053, '1', 'glass_stool*7', 'glass_stool*7', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2054, 2054, '1', 'glass_stool*8', 'glass_stool*8', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2056, 2056, '1', 'glass_stool*3', 'glass_stool*3', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2057, 2057, '1', 'glass_stool*9', 'glass_stool*9', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2063, 2063, '0', 'CF_10_coin_gold', 'CF_10_coin_gold', 'S', 1, 1, 0.20, '1', '0', '0', '0', '0', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2064, 2064, '0', 'CF_1_coin_bronze', 'CF_1_coin_bronze', 'S', 1, 1, 0.20, '1', '0', '0', '0', '0', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2065, 2065, '0', 'CF_20_moneybag', 'CF_20_moneybag', 'S', 1, 1, 1.00, '1', '0', '0', '0', '0', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2066, 2066, '0', 'CF_50_goldbar', 'CF_50_goldbar', 'S', 1, 1, 0.40, '1', '0', '0', '0', '0', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2067, 2067, '0', 'CF_5_coin_silver', 'CF_5_coin_silver', 'S', 1, 1, 0.20, '1', '0', '0', '0', '0', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2068, 2068, '0', 'hc_crpt', 'hc_crpt', 'S', 3, 5, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2069, 2069, '0', 'hc_tv', 'hc_tv', 'S', 2, 1, 1.40, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2070, 2070, '1', 'gothgate', 'gothgate', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(2071, 2071, '1', 'gothiccandelabra', 'gothiccandelabra', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2072, 2072, '1', 'gothrailing', 'gothrailing', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2073, 2073, '1', 'goth_table', 'goth_table', 'S', 1, 5, 1.70, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2074, 2074, '0', 'hc_bkshlf', 'hc_bkshlf', 'S', 1, 4, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2075, 2075, '0', 'hc_btlr', 'hc_btlr', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '24', '', '', 0, 0, ''),
	(2076, 2076, '0', 'hc_crtn', 'hc_crtn', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(2077, 2077, '0', 'hc_djset', 'hc_djset', 'S', 3, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2078, 2078, '0', 'hc_frplc', 'hc_frplc', 'S', 1, 3, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2079, 2079, '0', 'hc_lmpst', 'hc_lmpst', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2080, 2080, '0', 'hc_machine', 'hc_machine', 'S', 1, 3, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2081, 2081, '0', 'hc_rllr', 'hc_rllr', 'S', 1, 1, 0.50, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'roller', 1, '', '', '', 0, 0, ''),
	(2082, 2082, '0', 'hc_rntgn', 'hc_rntgn', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2083, 2083, '0', 'hc_trll', 'hc_trll', 'S', 1, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2084, 2084, '1', 'gothic_chair*1', 'gothic_chair*1', 'S', 1, 1, 1.30, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2085, 2085, '1', 'gothic_sofa*1', 'gothic_sofa*1', 'S', 2, 1, 1.30, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2086, 2086, '1', 'gothic_stool*1', 'gothic_stool*1', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2087, 2087, '1', 'gothic_chair*2', 'gothic_chair*2', 'S', 1, 1, 1.30, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2088, 2088, '1', 'gothic_sofa*2', 'gothic_sofa*2', 'S', 2, 1, 1.30, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2089, 2089, '1', 'gothic_stool*2', 'gothic_stool*2', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2090, 2090, '1', 'gothic_chair*3', 'gothic_chair*3', 'S', 1, 1, 1.30, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2091, 2091, '1', 'gothic_sofa*3', 'gothic_sofa*3', 'S', 2, 1, 1.40, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2092, 2092, '1', 'gothic_stool*3', 'gothic_stool*3', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2093, 2093, '1', 'gothic_chair*4', 'gothic_chair*4', 'S', 1, 1, 1.30, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2094, 2094, '1', 'gothic_sofa*4', 'gothic_sofa*4', 'S', 2, 1, 1.30, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2095, 2095, '1', 'gothic_stool*4', 'gothic_stool*4', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2096, 2096, '1', 'gothic_chair*5', 'gothic_chair*5', 'S', 1, 1, 1.30, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2097, 2097, '1', 'gothic_sofa*5', 'gothic_sofa*5', 'S', 2, 1, 1.40, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2098, 2098, '1', 'gothic_stool*5', 'gothic_stool*5', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2099, 2099, '1', 'gothic_chair*6', 'gothic_chair*6', 'S', 1, 1, 1.30, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2100, 2100, '1', 'gothic_sofa*6', 'gothic_sofa*6', 'S', 2, 1, 1.40, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2101, 2101, '1', 'gothic_stool*6', 'gothic_stool*6', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2102, 2102, '0', 'wcandle', 'wcandle', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2103, 2103, '0', 'val_cauldron', 'val_cauldron', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '25', '', '', 0, 0, ''),
	(2104, 2104, '0', 'tree2', 'tree2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2105, 2105, '0', 'sound_machine', 'sound_machine', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(2106, 2106, '1', 'romantique_pianochair*3', 'romantique_pianochair*3', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2107, 2107, '1', 'romantique_pianochair*5', 'romantique_pianochair*5', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2108, 2108, '1', 'romantique_pianochair*2', 'romantique_pianochair*2', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2109, 2109, '1', 'romantique_pianochair*4', 'romantique_pianochair*4', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2110, 2110, '1', 'romantique_pianochair*1', 'romantique_pianochair*1', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2111, 2111, '1', 'romantique_divan*3', 'romantique_divan*3', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2112, 2112, '1', 'romantique_divan*5', 'romantique_divan*5', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2113, 2113, '1', 'romantique_divan*2', 'romantique_divan*2', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2114, 2114, '1', 'romantique_divan*4', 'romantique_divan*4', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2115, 2115, '1', 'romantique_divan*1', 'romantique_divan*1', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2116, 2116, '1', 'romantique_chair*3', 'romantique_chair*3', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2117, 2117, '1', 'romantique_chair*5', 'romantique_chair*5', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2118, 2118, '1', 'romantique_chair*2', 'romantique_chair*2', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2119, 2119, '1', 'romantique_chair*4', 'romantique_chair*4', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2120, 2120, '1', 'romantique_chair*1', 'romantique_chair*1', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2121, 2121, '0', 'rcandle', 'rcandle', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2122, 2122, '0', 'rare_parasol', 'rare_parasol', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2123, 2123, '0', 'plant_valentinerose*3', 'plant_valentinerose*3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2124, 2124, '0', 'plant_valentinerose*5', 'plant_valentinerose*5', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2125, 2125, '0', 'plant_valentinerose*2', 'plant_valentinerose*2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2126, 2126, '0', 'plant_valentinerose*4', 'plant_valentinerose*4', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2127, 2127, '0', 'plant_valentinerose*1', 'plant_valentinerose*1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2128, 2128, '1', 'plant_mazegate', 'plant_mazegate', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(2129, 2129, '1', 'plant_maze', 'plant_maze', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2130, 2130, '0', 'plant_bulrush', 'plant_bulrush', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2131, 2131, '0', 'petfood4', 'petfood4', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'pet_food', 4, '', '', '550,10,0', 0, 0, ''),
	(2132, 2132, '0', 'carpet_valentine', 'carpet_valentine', 'S', 2, 7, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2133, 2133, '1', 'gothic_carpet', 'gothic_carpet', 'S', 2, 4, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2134, 2134, '1', 'gothic_carpet2', 'gothic_carpet2', 'S', 2, 4, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2135, 2135, '0', 'gothic_chair', 'gothic_chair', 'S', 1, 1, 1.40, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2136, 2136, '0', 'gothic_sofa', 'gothic_sofa', 'S', 2, 1, 1.30, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2137, 2137, '0', 'gothic_stool', 'gothic_stool', 'S', 1, 1, 1.30, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2138, 2138, '1', 'grand_piano*3', 'grand_piano*3', 'S', 2, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2139, 2139, '1', 'grand_piano*5', 'grand_piano*5', 'S', 2, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2140, 2140, '1', 'grand_piano*2', 'grand_piano*2', 'S', 2, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2141, 2141, '1', 'grand_piano*4', 'grand_piano*4', 'S', 2, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2142, 2142, '1', 'grand_piano*1', 'grand_piano*1', 'S', 2, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2143, 2143, '0', 'theatre_seat', 'theatre_seat', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 6, '', '', '', 0, 0, ''),
	(2144, 2144, '1', 'romantique_tray2', 'romantique_tray2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2145, 2145, '1', 'romantique_tray1', 'romantique_tray1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2146, 2146, '1', 'romantique_smalltabl*3', 'romantique_smalltabl*3', 'S', 1, 1, 0.80, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2147, 2147, '1', 'romantique_smalltabl*5', 'romantique_smalltabl*5', 'S', 1, 1, 0.80, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2148, 2148, '1', 'romantique_smalltabl*2', 'romantique_smalltabl*2', 'S', 1, 1, 0.80, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2149, 2149, '1', 'romantique_smalltabl*4', 'romantique_smalltabl*4', 'S', 1, 1, 0.80, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2150, 2150, '1', 'romantique_smalltabl*1', 'romantique_smalltabl*1', 'S', 1, 1, 0.80, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2151, 2151, '1', 'romantique_mirrortabl', 'romantique_mirrortabl', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2152, 2152, '1', 'romantique_divider*3', 'romantique_divider*3', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2153, 2153, '1', 'romantique_divider*2', 'romantique_divider*2', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2154, 2154, '1', 'romantique_divider*4', 'romantique_divider*4', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2155, 2155, '1', 'romantique_divider*1', 'romantique_divider*1', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2156, 2156, '1', 'jp_tatami2', 'jp_tatami2', 'S', 2, 4, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(2157, 2157, '1', 'jp_tatami', 'jp_tatami', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(2158, 2158, '0', 'habbowood_chair', 'habbowood_chair', 'S', 1, 1, 1.30, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2159, 2159, '0', 'jp_bamboo', 'jp_bamboo', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2160, 2160, '1', 'jp_irori', 'jp_irori', 'S', 2, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2161, 2161, '1', 'jp_pillow', 'jp_pillow', 'S', 1, 1, 0.80, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2162, 2162, '0', 'sound_set_1', 'sound_set_1', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2163, 2163, '0', 'sound_set_2', 'sound_set_2', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2164, 2164, '0', 'sound_set_3', 'sound_set_3', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2165, 2165, '0', 'sound_set_4', 'sound_set_4', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2166, 2166, '0', 'sound_set_5', 'sound_set_5', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2167, 2167, '0', 'sound_set_6', 'sound_set_6', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2168, 2168, '0', 'sound_set_7', 'sound_set_7', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2169, 2169, '0', 'sound_set_8', 'sound_set_8', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2170, 2170, '0', 'sound_set_9', 'sound_set_9', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2171, 2171, '0', 'sound_machine*1', 'sound_machine*1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trax_machine', 2, '', '', '', 0, 0, ''),
	(2457, 2457, '0', 'sound_set_23', 'sound_set_23', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2458, 2458, '0', 'rclr_garden', 'rclr_garden', 'S', 1, 3, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2459, 2459, '0', 'rclr_sofa', 'rclr_sofa', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '1', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2460, 2460, '1', 'pura_mdl1*1', 'pura_mdl1*1', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2461, 2461, '1', 'pura_mdl1*2', 'pura_mdl1*2', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2462, 2462, '0', 'pura_mdl1*3', 'pura_mdl1*3', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2463, 2463, '0', 'pura_mdl1*4', 'pura_mdl1*4', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2464, 2464, '1', 'pura_mdl1*5', 'pura_mdl1*5', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2465, 2465, '1', 'pura_mdl1*6', 'pura_mdl1*6', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2466, 2466, '1', 'pura_mdl1*7', 'pura_mdl1*7', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2467, 2467, '1', 'pura_mdl1*8', 'pura_mdl1*8', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2468, 2468, '1', 'pura_mdl1*9', 'pura_mdl1*9', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2469, 2469, '0', 'sound_set_19', 'sound_set_19', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2470, 2470, '0', 'sound_set_25', 'sound_set_25', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2471, 2471, '1', 'jp_lantern', 'jp_lantern', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2472, 2472, '1', 'pura_mdl4*1', 'pura_mdl4*1', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2473, 2473, '1', 'pura_mdl4*2', 'pura_mdl4*2', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2474, 2474, '0', 'pura_mdl4*3', 'pura_mdl4*3', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2475, 2475, '0', 'pura_mdl4*4', 'pura_mdl4*4', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2476, 2476, '1', 'pura_mdl4*5', 'pura_mdl4*5', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2477, 2477, '1', 'pura_mdl4*6', 'pura_mdl4*6', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2478, 2478, '1', 'pura_mdl4*7', 'pura_mdl4*7', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2479, 2479, '1', 'pura_mdl4*8', 'pura_mdl4*8', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2480, 2480, '1', 'pura_mdl4*9', 'pura_mdl4*9', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2481, 2481, '0', 'sound_set_10', 'sound_set_10', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2482, 2482, '0', 'sound_set_14', 'sound_set_14', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2483, 2483, '1', 'pura_mdl2*1', 'pura_mdl2*1', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2484, 2484, '1', 'pura_mdl2*2', 'pura_mdl2*2', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2485, 2485, '0', 'pura_mdl2*3', 'pura_mdl2*3', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2486, 2486, '0', 'pura_mdl2*4', 'pura_mdl2*4', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2487, 2487, '1', 'pura_mdl2*5', 'pura_mdl2*5', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2488, 2488, '1', 'pura_mdl2*6', 'pura_mdl2*6', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2489, 2489, '1', 'pura_mdl2*7', 'pura_mdl2*7', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2490, 2490, '1', 'pura_mdl2*8', 'pura_mdl2*8', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2491, 2491, '1', 'pura_mdl2*9', 'pura_mdl2*9', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2492, 2492, '0', 'sound_set_24', 'sound_set_24', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2493, 2493, '0', 'sound_set_12', 'sound_set_12', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2494, 2494, '0', 'sound_set_21', 'sound_set_21', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2495, 2495, '0', 'sound_set_15', 'sound_set_15', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2496, 2496, '0', 'sound_set_28', 'sound_set_28', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2497, 2497, '0', 'sound_set_18', 'sound_set_18', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2498, 2498, '1', 'bed_budget_one*1', 'bed_budget_one*1', 'S', 1, 3, 1.70, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(2499, 2499, '0', 'bed_budget_one*2', 'bed_budget_one*2', 'S', 1, 3, 1.90, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(2500, 2500, '0', 'bed_budget_one*3', 'bed_budget_one*3', 'S', 1, 3, 1.90, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(2501, 2501, '1', 'bed_budget_one*4', 'bed_budget_one*4', 'S', 1, 3, 1.90, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(2502, 2502, '0', 'bed_budget_one*5', 'bed_budget_one*5', 'S', 1, 3, 1.90, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(2503, 2503, '1', 'bed_budget_one*6', 'bed_budget_one*6', 'S', 1, 3, 1.90, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(2504, 2504, '1', 'bed_budget_one*7', 'bed_budget_one*7', 'S', 1, 3, 1.90, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(2505, 2505, '0', 'bed_budget_one*8', 'bed_budget_one*8', 'S', 1, 3, 1.90, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(2506, 2506, '0', 'bed_budget_one*9', 'bed_budget_one*9', 'S', 1, 3, 1.90, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(2507, 2507, '0', 'rare_icecream_campaign', 'rare_icecream_campaign', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '4', '', '', 0, 0, ''),
	(2508, 2508, '0', 'sound_set_26', 'sound_set_26', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2509, 2509, '1', 'pura_mdl5*1', 'pura_mdl5*1', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2510, 2510, '1', 'pura_mdl5*2', 'pura_mdl5*2', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2511, 2511, '0', 'pura_mdl5*3', 'pura_mdl5*3', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2512, 2512, '0', 'pura_mdl5*4', 'pura_mdl5*4', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2513, 2513, '1', 'pura_mdl5*5', 'pura_mdl5*5', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2514, 2514, '1', 'pura_mdl5*6', 'pura_mdl5*6', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2515, 2515, '1', 'pura_mdl5*7', 'pura_mdl5*7', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2516, 2516, '1', 'pura_mdl5*8', 'pura_mdl5*8', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2517, 2517, '1', 'pura_mdl5*9', 'pura_mdl5*9', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2518, 2518, '1', 'rope_divider', 'rope_divider', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(2519, 2519, '1', 'spotlight', 'spotlight', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 6, '', '', '', 0, 0, ''),
	(2520, 2520, '0', 'romantique_clock', 'romantique_clock', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2521, 2521, '0', 'sound_set_22', 'sound_set_22', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2522, 2522, '1', 'jp_drawer', 'jp_drawer', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2523, 2523, '0', 'sound_set_13', 'sound_set_13', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2524, 2524, '0', 'sound_set_20', 'sound_set_20', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2525, 2525, '1', 'chair_basic*1', 'chair_basic*1', 'S', 1, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2526, 2526, '0', 'chair_basic*2', 'chair_basic*2', 'S', 1, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2527, 2527, '0', 'chair_basic*3', 'chair_basic*3', 'S', 1, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2528, 2528, '0', 'chair_basic*4', 'chair_basic*4', 'S', 1, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2529, 2529, '0', 'chair_basic*5', 'chair_basic*5', 'S', 1, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2530, 2530, '0', 'chair_basic*6', 'chair_basic*6', 'S', 1, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2531, 2531, '1', 'chair_basic*7', 'chair_basic*7', 'S', 1, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2532, 2532, '0', 'chair_basic*8', 'chair_basic*8', 'S', 1, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2533, 2533, '0', 'chair_basic*9', 'chair_basic*9', 'S', 1, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2534, 2534, '1', 'pura_mdl3*1', 'pura_mdl3*1', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2535, 2535, '1', 'pura_mdl3*2', 'pura_mdl3*2', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2536, 2536, '0', 'pura_mdl3*3', 'pura_mdl3*3', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2537, 2537, '0', 'pura_mdl3*4', 'pura_mdl3*4', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2538, 2538, '1', 'pura_mdl3*5', 'pura_mdl3*5', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2539, 2539, '1', 'pura_mdl3*6', 'pura_mdl3*6', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2540, 2540, '1', 'pura_mdl3*7', 'pura_mdl3*7', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2541, 2541, '1', 'pura_mdl3*8', 'pura_mdl3*8', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2542, 2542, '1', 'pura_mdl3*9', 'pura_mdl3*9', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2543, 2543, '0', 'sound_machine*2', 'sound_machine*2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trax_machine', 2, '', '', '', 0, 0, ''),
	(2544, 2544, '0', 'sound_machine*3', 'sound_machine*3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trax_machine', 2, '', '', '', 0, 0, ''),
	(2545, 2545, '0', 'sound_machine*4', 'sound_machine*4', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trax_machine', 2, '', '', '', 0, 0, ''),
	(2546, 2546, '0', 'sound_machine*5', 'sound_machine*5', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trax_machine', 2, '', '', '', 0, 0, ''),
	(2547, 2547, '0', 'sound_machine*6', 'sound_machine*6', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trax_machine', 2, '', '', '', 0, 0, ''),
	(2548, 2548, '0', 'sound_machine*7', 'sound_machine*7', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trax_machine', 2, '', '', '', 0, 0, ''),
	(2549, 2549, '0', 'sound_set_27', 'sound_set_27', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2550, 2550, '0', 'sound_set_17', 'sound_set_17', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2551, 2551, '1', 'rom_lamp', 'rom_lamp', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2552, 2552, '1', 'bed_budget*1', 'bed_budget*1', 'S', 2, 3, 1.70, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(2553, 2553, '0', 'bed_budget*2', 'bed_budget*2', 'S', 2, 3, 1.90, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(2554, 2554, '0', 'bed_budget*3', 'bed_budget*3', 'S', 2, 3, 1.90, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(2555, 2555, '1', 'bed_budget*4', 'bed_budget*4', 'S', 2, 3, 1.90, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(2556, 2556, '0', 'bed_budget*5', 'bed_budget*5', 'S', 2, 3, 1.90, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(2557, 2557, '1', 'bed_budget*6', 'bed_budget*6', 'S', 2, 3, 1.90, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(2558, 2558, '1', 'bed_budget*7', 'bed_budget*7', 'S', 2, 3, 1.90, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(2559, 2559, '0', 'bed_budget*8', 'bed_budget*8', 'S', 2, 3, 1.90, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(2560, 2560, '0', 'bed_budget*9', 'bed_budget*9', 'S', 2, 3, 1.90, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(2561, 2561, '0', 'sound_set_16', 'sound_set_16', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2562, 2562, '0', 'rclr_chair', 'rclr_chair', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2563, 2563, '0', 'sound_set_11', 'sound_set_11', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2564, 2564, '0', 'sound_set_33', 'sound_set_33', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2565, 2565, '0', 'sound_set_37', 'sound_set_37', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2566, 2566, '1', 'tile_marble', 'tile_marble', 'S', 1, 1, 0.15, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2567, 2567, '1', 'exe_rug', 'exe_rug', 'S', 3, 3, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2568, 2568, '1', 'tile_stella', 'tile_stella', 'S', 1, 1, 0.15, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2569, 2569, '0', 'sound_set_32', 'sound_set_32', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2570, 2570, '0', 'sound_set_34', 'sound_set_34', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2571, 2571, '1', 'summer_chair*1', 'summer_chair*1', 'S', 1, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2572, 2572, '1', 'summer_chair*2', 'summer_chair*2', 'S', 1, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2573, 2573, '1', 'summer_chair*3', 'summer_chair*3', 'S', 1, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2574, 2574, '1', 'summer_chair*4', 'summer_chair*4', 'S', 1, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2575, 2575, '1', 'summer_chair*5', 'summer_chair*5', 'S', 1, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2576, 2576, '1', 'summer_chair*6', 'summer_chair*6', 'S', 1, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2577, 2577, '1', 'summer_chair*7', 'summer_chair*7', 'S', 1, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2578, 2578, '1', 'summer_chair*8', 'summer_chair*8', 'S', 1, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2579, 2579, '1', 'summer_chair*9', 'summer_chair*9', 'S', 1, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2580, 2580, '0', 'sound_set_29', 'sound_set_29', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2581, 2581, '1', 'exe_s_table', 'exe_s_table', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2582, 2582, '1', 'tile_brown', 'tile_brown', 'S', 1, 1, 0.15, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2583, 2583, '0', 'sound_set_36', 'sound_set_36', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2584, 2584, '0', 'rare_mnstr', 'rare_mnstr', 'S', 1, 1, 3.50, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(2585, 2585, '0', 'sound_set_30', 'sound_set_30', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2586, 2586, '0', 'prizetrophy7*3', 'prizetrophy7*3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(2587, 2587, '0', 'summer_grill*1', 'summer_grill*1', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2588, 2588, '0', 'summer_grill*2', 'summer_grill*2', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2589, 2589, '0', 'summer_grill*3', 'summer_grill*3', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2590, 2590, '0', 'summer_grill*4', 'summer_grill*4', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2591, 2591, '1', 'summer_pool*1', 'summer_pool*1', 'S', 2, 2, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2592, 2592, '1', 'summer_pool*2', 'summer_pool*2', 'S', 2, 2, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2593, 2593, '1', 'summer_pool*3', 'summer_pool*3', 'S', 2, 2, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2594, 2594, '0', 'summer_pool*4', 'summer_pool*4', 'S', 2, 2, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2595, 2595, '0', 'sound_set_35', 'sound_set_35', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2596, 2596, '0', 'sound_set_31', 'sound_set_31', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2597, 2597, '0', 'one_way_door*1', 'one_way_door*1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'onewaygate', 2, '', '', '', 0, 0, ''),
	(2598, 2598, '0', 'one_way_door*2', 'one_way_door*2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'onewaygate', 2, '', '', '', 0, 0, ''),
	(2599, 2599, '0', 'one_way_door*3', 'one_way_door*3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'onewaygate', 2, '', '', '', 0, 0, ''),
	(2600, 2600, '0', 'one_way_door*4', 'one_way_door*4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'onewaygate', 2, '', '', '', 0, 0, ''),
	(2601, 2601, '0', 'one_way_door*5', 'one_way_door*5', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'onewaygate', 2, '', '', '', 0, 0, ''),
	(2602, 2602, '0', 'one_way_door*6', 'one_way_door*6', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'onewaygate', 2, '', '', '', 0, 0, ''),
	(2603, 2603, '0', 'one_way_door*7', 'one_way_door*7', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'onewaygate', 2, '', '', '', 0, 0, ''),
	(2604, 2604, '0', 'one_way_door*8', 'one_way_door*8', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'onewaygate', 2, '', '', '', 0, 0, ''),
	(2605, 2605, '0', 'one_way_door*9', 'one_way_door*9', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'onewaygate', 2, '', '', '', 0, 0, ''),
	(2606, 2606, '0', 'sound_machine_pro', 'sound_machine_pro', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2607, 2607, '0', 'song_disk', 'song_disk', 'S', 1, 1, 0.15, '1', '0', '0', '0', '1', '1', '0', '0', '0', 'musicdisc', 2, '', '', '', 0, 0, ''),
	(2608, 2608, '0', 'jukebox*1', 'jukebox*1', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'jukebox', 1, '', '', '', 0, 0, ''),
	(2609, 2609, '0', 'carpet_soft_tut', 'carpet_soft_tut', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2610, 2610, '0', 'sound_set_44', 'sound_set_44', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2611, 2611, '0', 'habboween_crypt', 'habboween_crypt', 'S', 1, 3, 1.60, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 2, '', '', '', 0, 0, ''),
	(2612, 2612, '0', 'sound_set_41', 'sound_set_41', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2613, 2613, '1', 'grunge_sign', 'grunge_sign', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2614, 2614, '0', 'sound_set_43', 'sound_set_43', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2615, 2615, '0', 'sound_set_40', 'sound_set_40', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2616, 2616, '0', 'sound_set_38', 'sound_set_38', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2617, 2617, '1', 'grunge_chair', 'grunge_chair', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2618, 2618, '1', 'grunge_mattress', 'grunge_mattress', 'S', 3, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2619, 2619, '1', 'grunge_shelf', 'grunge_shelf', 'S', 3, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2620, 2620, '0', 'hal_grave', 'hal_grave', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2621, 2621, '1', 'grunge_radiator', 'grunge_radiator', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2622, 2622, '0', 'sound_set_39', 'sound_set_39', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2623, 2623, '1', 'grunge_table', 'grunge_table', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2624, 2624, '0', 'sound_set_42', 'sound_set_42', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2625, 2625, '0', 'hal_cauldron', 'hal_cauldron', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'vendingmachine', 2, '30', '', '', 0, 0, ''),
	(2626, 2626, '0', 'habboween_grass', 'habboween_grass', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2627, 2627, '0', 'sound_set_47', 'sound_set_47', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2628, 2628, '0', 'sound_set_45', 'sound_set_45', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2629, 2629, '0', 'sound_set_48', 'sound_set_48', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2630, 2630, '0', 'sound_set_46', 'sound_set_46', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2631, 2631, '0', 'sound_set_51', 'sound_set_51', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2632, 2632, '0', 'sound_set_50', 'sound_set_50', 'S', 1, 1, 0.20, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(2633, 2633, '0', 'sound_set_52', 'sound_set_52', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2634, 2634, '0', 'sound_set_49', 'sound_set_49', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2635, 2635, '0', 'plant_maze_snow', 'plant_maze_snow', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2636, 2636, '0', 'xmas_cstl_gate', 'xmas_cstl_gate', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(2637, 2637, '0', 'christmas_reindeer', 'christmas_reindeer', 'S', 1, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2638, 2638, '0', 'tree6', 'tree6', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2639, 2639, '1', 'exe_sofa', 'exe_sofa', 'S', 3, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2640, 2640, '0', 'plant_mazegate_snow', 'plant_mazegate_snow', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(2641, 2641, '0', 'xmas_icelamp', 'xmas_icelamp', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2642, 2642, '0', 'safe_silo_pb', 'safe_silo_pb', 'S', 1, 1, 1.30, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '3', '', '', 0, 0, ''),
	(2643, 2643, '1', 'exe_bardesk', 'exe_bardesk', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2644, 2644, '1', 'exe_table', 'exe_table', 'S', 3, 2, 1.10, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2645, 2645, '1', 'exe_drinks', 'exe_drinks', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2646, 2646, '0', 'xmas_cstl_wall', 'xmas_cstl_wall', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2647, 2647, '1', 'exe_chair', 'exe_chair', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2648, 2648, '0', 'christmas_sleigh', 'christmas_sleigh', 'S', 2, 2, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2649, 2649, '0', 'sound_set_54', 'sound_set_54', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2650, 2650, '1', 'exe_chair2', 'exe_chair2', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2651, 2651, '0', 'xmas_cstl_twr', 'xmas_cstl_twr', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2652, 2652, '0', 'sound_set_53', 'sound_set_53', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2653, 2653, '0', 'tree7', 'tree7', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2654, 2654, '0', 'christmas_poop', 'christmas_poop', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2655, 2655, '1', 'exe_corner', 'exe_corner', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2656, 2656, '0', 'sound_set_58', 'sound_set_58', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2657, 2657, '0', 'noob_stool*1', 'noob_stool*1', 'S', 1, 1, 1.20, '0', '1', '0', '0', '0', '0', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2658, 2658, '0', 'noob_stool*2', 'noob_stool*2', 'S', 1, 1, 1.20, '0', '1', '0', '0', '0', '0', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2659, 2659, '0', 'noob_stool*3', 'noob_stool*3', 'S', 1, 1, 1.20, '0', '1', '0', '0', '0', '0', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2660, 2660, '0', 'noob_stool*4', 'noob_stool*4', 'S', 1, 1, 1.20, '0', '1', '0', '0', '0', '0', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2661, 2661, '0', 'noob_stool*5', 'noob_stool*5', 'S', 1, 1, 1.20, '0', '1', '0', '0', '0', '0', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2662, 2662, '0', 'noob_stool*6', 'noob_stool*6', 'S', 1, 1, 1.20, '0', '1', '0', '0', '0', '0', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2663, 2663, '0', 'noob_lamp*1', 'noob_lamp*1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2664, 2664, '0', 'noob_lamp*2', 'noob_lamp*2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2665, 2665, '0', 'noob_lamp*3', 'noob_lamp*3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2666, 2666, '0', 'noob_lamp*4', 'noob_lamp*4', 'S', 1, 1, 1.00, '0', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2667, 2667, '0', 'noob_lamp*5', 'noob_lamp*5', 'S', 1, 1, 1.00, '0', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2668, 2668, '0', 'noob_lamp*6', 'noob_lamp*6', 'S', 1, 1, 1.00, '0', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2669, 2669, '0', 'sound_set_56', 'sound_set_56', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2670, 2670, '0', 'sound_set_59', 'sound_set_59', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2671, 2671, '0', 'sound_set_55', 'sound_set_55', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2672, 2672, '0', 'exe_globe', 'exe_globe', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 10, '', '', '', 0, 0, ''),
	(2673, 2673, '0', 'sound_set_57', 'sound_set_57', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2674, 2674, '1', 'exe_plant', 'exe_plant', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2675, 2675, '0', 'noob_chair*1', 'noob_chair*1', 'S', 1, 1, 1.00, '0', '1', '0', '0', '0', '0', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2676, 2676, '0', 'noob_chair*2', 'noob_chair*2', 'S', 1, 1, 1.00, '0', '1', '0', '0', '0', '0', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2677, 2677, '0', 'noob_chair*3', 'noob_chair*3', 'S', 1, 1, 1.00, '0', '1', '0', '0', '0', '0', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2678, 2678, '0', 'noob_chair*4', 'noob_chair*4', 'S', 1, 1, 1.00, '0', '1', '0', '0', '0', '0', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2679, 2679, '0', 'noob_chair*5', 'noob_chair*5', 'S', 1, 1, 1.00, '0', '1', '0', '0', '0', '0', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2680, 2680, '0', 'noob_chair*6', 'noob_chair*6', 'S', 1, 1, 1.00, '0', '1', '0', '0', '0', '0', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2681, 2681, '0', 'noob_rug*1', 'noob_rug*1', 'S', 2, 3, 0.00, '1', '0', '0', '1', '0', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2682, 2682, '0', 'noob_rug*2', 'noob_rug*2', 'S', 2, 3, 0.00, '1', '0', '0', '1', '0', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2683, 2683, '0', 'noob_rug*3', 'noob_rug*3', 'S', 2, 3, 0.00, '1', '0', '0', '1', '0', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2684, 2684, '0', 'noob_rug*4', 'noob_rug*4', 'S', 2, 3, 0.00, '1', '0', '0', '1', '0', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2685, 2685, '0', 'noob_rug*5', 'noob_rug*5', 'S', 2, 3, 0.00, '1', '0', '0', '1', '0', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2686, 2686, '0', 'noob_rug*6', 'noob_rug*6', 'S', 2, 3, 0.00, '1', '0', '0', '1', '0', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2687, 2687, '0', 'noob_table*1', 'noob_table*1', 'S', 2, 2, 1.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2688, 2688, '0', 'noob_table*2', 'noob_table*2', 'S', 2, 2, 1.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2689, 2689, '0', 'noob_table*3', 'noob_table*3', 'S', 2, 2, 1.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2690, 2690, '0', 'noob_table*4', 'noob_table*4', 'S', 2, 2, 1.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2691, 2691, '0', 'noob_table*5', 'noob_table*5', 'S', 2, 2, 1.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2692, 2692, '0', 'noob_table*6', 'noob_table*6', 'S', 2, 2, 1.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2693, 2693, '0', 'teleport_door', 'teleport_door', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'teleport', 2, '', '', '', 0, 0, ''),
	(2694, 2694, '0', 'fortune', 'fortune', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'random_state', 1, '', '', 'states=8,delay=2000', 0, 0, ''),
	(2695, 2695, '0', 'sound_set_60', 'sound_set_60', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2696, 2696, '0', 'val_randomizer', 'val_randomizer', 'S', 4, 1, 1.40, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'random_state', 1, '', '', 'states=4,delay=5700', 0, 0, ''),
	(2697, 2697, '0', 'val_choco', 'val_choco', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2698, 2698, '0', 'sound_set_61', 'sound_set_61', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2699, 2699, '0', 'val_teddy*1', 'val_teddy*1', 'S', 1, 1, 0.90, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2700, 2700, '0', 'val_teddy*2', 'val_teddy*2', 'S', 1, 1, 0.90, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2701, 2701, '0', 'val_teddy*3', 'val_teddy*3', 'S', 1, 1, 0.90, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2702, 2702, '0', 'val_teddy*4', 'val_teddy*4', 'S', 1, 1, 0.90, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2703, 2703, '0', 'val_teddy*5', 'val_teddy*5', 'S', 1, 1, 0.90, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2704, 2704, '0', 'val_teddy*6', 'val_teddy*6', 'S', 1, 1, 0.90, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2705, 2705, '0', 'sand_cstl_twr', 'sand_cstl_twr', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2706, 2706, '1', 'grunge_barrel', 'grunge_barrel', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2707, 2707, '1', 'grunge_bench', 'grunge_bench', 'S', 3, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2708, 2708, '1', 'grunge_candle', 'grunge_candle', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2709, 2709, '0', 'sw_chest', 'sw_chest', 'S', 1, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2710, 2710, '0', 'sand_cstl_wall', 'sand_cstl_wall', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2711, 2711, '0', 'sw_raven', 'sw_raven', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2712, 2712, '0', 'sand_cstl_gate', 'sand_cstl_gate', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(2713, 2713, '0', 'sw_table', 'sw_table', 'S', 1, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2714, 2714, '1', 'arabian_tetbl', 'arabian_tetbl', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2715, 2715, '1', 'jp_tray1', 'jp_tray1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2716, 2716, '1', 'arabian_teamk', 'arabian_teamk', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '1', '', '', 0, 0, ''),
	(2717, 2717, '1', 'jp_tray5', 'jp_tray5', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2718, 2718, '0', 'prizetrophy9*1', 'prizetrophy9*1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(2719, 2719, '1', 'arabian_rug', 'arabian_rug', 'S', 3, 5, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2720, 2720, '1', 'jp_tray6', 'jp_tray6', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2721, 2721, '1', 'arabian_chair', 'arabian_chair', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2722, 2722, '1', 'arabian_pllw', 'arabian_pllw', 'S', 1, 1, 0.80, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2723, 2723, '1', 'arabian_tray3', 'arabian_tray3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2724, 2724, '1', 'jp_tray2', 'jp_tray2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2725, 2725, '1', 'jp_tray4', 'jp_tray4', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2726, 2726, '1', 'jp_tray3', 'jp_tray3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2727, 2727, '0', 'md_rug', 'md_rug', 'S', 4, 4, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2728, 2728, '1', 'arabian_tray4', 'arabian_tray4', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2729, 2729, '0', 'prizetrophy8*1', 'prizetrophy8*1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(2730, 2730, '1', 'arabian_divdr', 'arabian_divdr', 'S', 1, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2731, 2731, '1', 'arabian_bigtb', 'arabian_bigtb', 'S', 3, 2, 0.80, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2732, 2732, '1', 'arabian_snake', 'arabian_snake', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2733, 2733, '0', 'rclr_lamp', 'rclr_lamp', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2734, 2734, '1', 'arabian_tray1', 'arabian_tray1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2735, 2735, '1', 'arabian_tray2', 'arabian_tray2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2736, 2736, '0', 'nouvelle_trax', 'nouvelle_trax', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'musicdisc', 1, '', '', '', 0, 0, ''),
	(2737, 2737, '0', 'calippo', 'calippo', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '4', '', '', 0, 0, ''),
	(2738, 2738, '0', 'sound_set_64', 'sound_set_64', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2739, 2739, '0', 'jukebox_ptv*1', 'jukebox_ptv*1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'jukebox', 2, '', '', '', 0, 0, ''),
	(2740, 2740, '0', 'sound_set_63', 'sound_set_63', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2741, 2741, '0', 'sound_set_62', 'sound_set_62', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2742, 2742, '0', 'traxgold', 'traxgold', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(2743, 2743, '0', 'traxbronze', 'traxbronze', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2744, 2744, '0', 'traxsilver', 'traxsilver', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(2745, 2745, '0', 'bench_puffet', 'bench_puffet', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2746, 2746, '0', 'footylamp_campaign', 'footylamp_campaign', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2747, 2747, '1', 'jp_katana2', 'jp_katana2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2748, 2748, '1', 'jp_katana3', 'jp_katana3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2749, 2749, '1', 'jp_table', 'jp_table', 'S', 2, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(2750, 2750, '0', 'jp_rare', 'jp_rare', 'S', 2, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2751, 2751, '0', 'jp_katana1', 'jp_katana1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2752, 2752, '0', 'sound_set_66', 'sound_set_66', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2753, 2753, '1', 'tiki_tray3', 'tiki_tray3', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2754, 2754, '0', 'tampax_rug', 'tampax_rug', 'S', 3, 4, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2755, 2755, '1', 'tiki_tray1', 'tiki_tray1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2756, 2756, '1', 'tiki_toucan', 'tiki_toucan', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2757, 2757, '1', 'tiki_waterfall', 'tiki_waterfall', 'S', 3, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2758, 2758, '0', 'noob_lamp_tradeable*1', 'noob_lamp_tradeable*1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2759, 2759, '0', 'noob_lamp_tradeable*2', 'noob_lamp_tradeable*2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2760, 2760, '0', 'noob_lamp_tradeable*3', 'noob_lamp_tradeable*3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2761, 2761, '0', 'noob_lamp_tradeable*4', 'noob_lamp_tradeable*4', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2762, 2762, '0', 'noob_lamp_tradeable*5', 'noob_lamp_tradeable*5', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2763, 2763, '0', 'noob_lamp_tradeable*6', 'noob_lamp_tradeable*6', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2764, 2764, '0', 'CFC_500_goldbar', 'CFC_500_goldbar', 'S', 1, 1, 0.50, '1', '0', '0', '0', '0', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2765, 2765, '1', 'tiki_tray4', 'tiki_tray4', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2766, 2766, '0', 'sound_set_65', 'sound_set_65', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2767, 2767, '0', 'sound_set_70', 'sound_set_70', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2768, 2768, '1', 'tiki_tray2', 'tiki_tray2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2769, 2769, '1', 'tiki_parasol', 'tiki_parasol', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2770, 2770, '0', 'CFC_200_moneybag', 'CFC_200_moneybag', 'S', 1, 1, 1.00, '1', '0', '0', '0', '0', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2771, 2771, '0', 'sound_set_67', 'sound_set_67', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2772, 2772, '0', 'CFC_50_coin_silver', 'CFC_50_coin_silver', 'S', 1, 1, 0.20, '1', '0', '0', '0', '0', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2773, 2773, '1', 'tiki_torch', 'tiki_torch', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2774, 2774, '1', 'jp_teamaker', 'jp_teamaker', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '28', '', '', 0, 0, ''),
	(2775, 2775, '0', 'noob_chair_tradeable*1', 'noob_chair_tradeable*1', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2776, 2776, '0', 'noob_chair_tradeable*2', 'noob_chair_tradeable*2', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2777, 2777, '0', 'noob_chair_tradeable*3', 'noob_chair_tradeable*3', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2778, 2778, '0', 'noob_chair_tradeable*4', 'noob_chair_tradeable*4', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2779, 2779, '0', 'noob_chair_tradeable*5', 'noob_chair_tradeable*5', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2780, 2780, '0', 'noob_chair_tradeable*6', 'noob_chair_tradeable*6', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2781, 2781, '1', 'tiki_junglerug', 'tiki_junglerug', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2782, 2782, '1', 'tiki_statue', 'tiki_statue', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2783, 2783, '0', 'noob_plant', 'noob_plant', 'S', 1, 1, 1.00, '0', '0', '0', '0', '0', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2784, 2784, '1', 'tiki_bench', 'tiki_bench', 'S', 1, 1, 1.30, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2785, 2785, '1', 'tiki_bflies', 'tiki_bflies', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(2786, 2786, '0', 'noob_rug_tradeable*1', 'noob_rug_tradeable*1', 'S', 2, 3, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2787, 2787, '0', 'noob_rug_tradeable*2', 'noob_rug_tradeable*2', 'S', 2, 3, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2788, 2788, '0', 'noob_rug_tradeable*3', 'noob_rug_tradeable*3', 'S', 2, 3, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2789, 2789, '0', 'noob_rug_tradeable*4', 'noob_rug_tradeable*4', 'S', 2, 3, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2790, 2790, '0', 'noob_rug_tradeable*5', 'noob_rug_tradeable*5', 'S', 2, 3, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2791, 2791, '0', 'noob_rug_tradeable*6', 'noob_rug_tradeable*6', 'S', 2, 3, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2792, 2792, '1', 'tiki_tray0', 'tiki_tray0', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2793, 2793, '0', 'sound_set_68', 'sound_set_68', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2794, 2794, '1', 'tiki_corner', 'tiki_corner', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2795, 2795, '1', 'tiki_bardesk', 'tiki_bardesk', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2796, 2796, '0', 'CFC_100_coin_gold', 'CFC_100_coin_gold', 'S', 1, 1, 0.20, '1', '0', '0', '0', '0', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2797, 2797, '0', 'CFC_10_coin_bronze', 'CFC_10_coin_bronze', 'S', 1, 1, 0.20, '1', '0', '0', '0', '0', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2798, 2798, '1', 'tiki_sand', 'tiki_sand', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2799, 2799, '0', 'sound_set_69', 'sound_set_69', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2800, 2800, '0', 'diner_tray_4', 'diner_tray_4', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2801, 2801, '0', 'svnr_de', 'svnr_de', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2802, 2802, '0', 'diner_tray_2', 'diner_tray_2', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2803, 2803, '0', 'diner_rug', 'diner_rug', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2804, 2804, '1', 'diner_sofa_2*1', 'diner_sofa_2*1', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2805, 2805, '1', 'diner_sofa_2*2', 'diner_sofa_2*2', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2806, 2806, '0', 'diner_sofa_2*3', 'diner_sofa_2*3', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2807, 2807, '1', 'diner_sofa_2*4', 'diner_sofa_2*4', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2808, 2808, '1', 'diner_sofa_2*5', 'diner_sofa_2*5', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2809, 2809, '1', 'diner_sofa_2*6', 'diner_sofa_2*6', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2810, 2810, '1', 'diner_sofa_2*7', 'diner_sofa_2*7', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2811, 2811, '1', 'diner_sofa_2*8', 'diner_sofa_2*8', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2812, 2812, '1', 'diner_sofa_2*9', 'diner_sofa_2*9', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2813, 2813, '0', 'svnr_it', 'svnr_it', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2814, 2814, '0', 'diner_shaker', 'diner_shaker', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2815, 2815, '0', 'diner_tray_5', 'diner_tray_5', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2816, 2816, '1', 'diner_cashreg*1', 'diner_cashreg*1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2817, 2817, '1', 'diner_cashreg*2', 'diner_cashreg*2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2818, 2818, '0', 'diner_cashreg*3', 'diner_cashreg*3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2819, 2819, '1', 'diner_cashreg*4', 'diner_cashreg*4', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2820, 2820, '1', 'diner_cashreg*5', 'diner_cashreg*5', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2821, 2821, '1', 'diner_cashreg*6', 'diner_cashreg*6', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2822, 2822, '1', 'diner_cashreg*7', 'diner_cashreg*7', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2823, 2823, '1', 'diner_cashreg*8', 'diner_cashreg*8', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2824, 2824, '1', 'diner_cashreg*9', 'diner_cashreg*9', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2825, 2825, '0', 'svnr_nl', 'svnr_nl', 'S', 1, 2, 1.00, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2826, 2826, '0', 'diner_tray_6', 'diner_tray_6', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2827, 2827, '1', 'diner_gumvendor*1', 'diner_gumvendor*1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '67,68,69', '', '', 0, 0, ''),
	(2828, 2828, '1', 'diner_gumvendor*2', 'diner_gumvendor*2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '67,68,69', '', '', 0, 0, ''),
	(2829, 2829, '0', 'diner_gumvendor*3', 'diner_gumvendor*3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '67,68,69', '', '', 0, 0, ''),
	(2830, 2830, '1', 'diner_gumvendor*4', 'diner_gumvendor*4', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '67,68,69', '', '', 0, 0, ''),
	(2831, 2831, '1', 'diner_gumvendor*5', 'diner_gumvendor*5', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '67,68,69', '', '', 0, 0, ''),
	(2832, 2832, '1', 'diner_gumvendor*6', 'diner_gumvendor*6', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '67,68,69', '', '', 0, 0, ''),
	(2833, 2833, '1', 'diner_gumvendor*7', 'diner_gumvendor*7', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '67,68,69', '', '', 0, 0, ''),
	(2834, 2834, '1', 'diner_gumvendor*8', 'diner_gumvendor*8', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '67,68,69', '', '', 0, 0, ''),
	(2835, 2835, '1', 'diner_gumvendor*9', 'diner_gumvendor*9', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '67,68,69', '', '', 0, 0, ''),
	(2836, 2836, '0', 'svnr_aus', 'svnr_aus', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2837, 2837, '0', 'diner_tray_0', 'diner_tray_0', 'S', 1, 1, 0.05, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2838, 2838, '0', 'svnr_uk', 'svnr_uk', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2839, 2839, '0', 'diner_tray_1', 'diner_tray_1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2840, 2840, '0', 'diner_tray_7', 'diner_tray_7', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2841, 2841, '0', 'diner_tray_3', 'diner_tray_3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2842, 2842, '1', 'diner_bardesk_gate*1', 'diner_bardesk_gate*1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(2843, 2843, '1', 'diner_bardesk_gate*2', 'diner_bardesk_gate*2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(2844, 2844, '0', 'diner_bardesk_gate*3', 'diner_bardesk_gate*3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(2845, 2845, '1', 'diner_bardesk_gate*4', 'diner_bardesk_gate*4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(2846, 2846, '1', 'diner_bardesk_gate*5', 'diner_bardesk_gate*5', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(2847, 2847, '1', 'diner_bardesk_gate*6', 'diner_bardesk_gate*6', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(2848, 2848, '1', 'diner_bardesk_gate*7', 'diner_bardesk_gate*7', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(2849, 2849, '1', 'diner_bardesk_gate*8', 'diner_bardesk_gate*8', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(2850, 2850, '1', 'diner_bardesk_gate*9', 'diner_bardesk_gate*9', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(2851, 2851, '1', 'diner_bardesk*1', 'diner_bardesk*1', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2852, 2852, '1', 'diner_bardesk*2', 'diner_bardesk*2', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2853, 2853, '0', 'diner_bardesk*3', 'diner_bardesk*3', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2854, 2854, '1', 'diner_bardesk*4', 'diner_bardesk*4', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2855, 2855, '1', 'diner_bardesk*5', 'diner_bardesk*5', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2856, 2856, '1', 'diner_bardesk*6', 'diner_bardesk*6', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2857, 2857, '1', 'diner_bardesk*7', 'diner_bardesk*7', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2858, 2858, '1', 'diner_bardesk*8', 'diner_bardesk*8', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2859, 2859, '1', 'diner_bardesk*9', 'diner_bardesk*9', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2860, 2860, '0', 'ads_dave_cns', 'ads_dave_cns', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2861, 2861, '1', 'diner_chair*1', 'diner_chair*1', 'S', 1, 1, 1.40, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2862, 2862, '1', 'diner_chair*2', 'diner_chair*2', 'S', 1, 1, 1.40, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2863, 2863, '0', 'diner_chair*3', 'diner_chair*3', 'S', 1, 1, 1.40, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2864, 2864, '1', 'diner_chair*4', 'diner_chair*4', 'S', 1, 1, 1.40, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2865, 2865, '1', 'diner_chair*5', 'diner_chair*5', 'S', 1, 1, 1.40, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2866, 2866, '1', 'diner_chair*6', 'diner_chair*6', 'S', 1, 1, 1.40, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2867, 2867, '1', 'diner_chair*7', 'diner_chair*7', 'S', 1, 1, 1.40, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2868, 2868, '1', 'diner_chair*8', 'diner_chair*8', 'S', 1, 1, 1.40, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2869, 2869, '1', 'diner_chair*9', 'diner_chair*9', 'S', 1, 1, 1.40, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2870, 2870, '1', 'diner_bardesk_corner*1', 'diner_bardesk_corner*1', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2871, 2871, '1', 'diner_bardesk_corner*2', 'diner_bardesk_corner*2', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2872, 2872, '0', 'diner_bardesk_corner*3', 'diner_bardesk_corner*3', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2873, 2873, '1', 'diner_bardesk_corner*4', 'diner_bardesk_corner*4', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2874, 2874, '1', 'diner_bardesk_corner*5', 'diner_bardesk_corner*5', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2875, 2875, '1', 'diner_bardesk_corner*6', 'diner_bardesk_corner*6', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2876, 2876, '1', 'diner_bardesk_corner*7', 'diner_bardesk_corner*7', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2877, 2877, '1', 'diner_bardesk_corner*8', 'diner_bardesk_corner*8', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2878, 2878, '1', 'diner_bardesk_corner*9', 'diner_bardesk_corner*9', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2879, 2879, '1', 'diner_table_2*1', 'diner_table_2*1', 'S', 3, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2880, 2880, '1', 'diner_table_2*2', 'diner_table_2*2', 'S', 3, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2881, 2881, '0', 'diner_table_2*3', 'diner_table_2*3', 'S', 3, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2882, 2882, '1', 'diner_table_2*4', 'diner_table_2*4', 'S', 3, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2883, 2883, '1', 'diner_table_2*5', 'diner_table_2*5', 'S', 3, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2884, 2884, '1', 'diner_table_2*6', 'diner_table_2*6', 'S', 3, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2885, 2885, '1', 'diner_table_2*7', 'diner_table_2*7', 'S', 3, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2886, 2886, '1', 'diner_table_2*8', 'diner_table_2*8', 'S', 3, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2887, 2887, '1', 'diner_table_2*9', 'diner_table_2*9', 'S', 3, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2888, 2888, '1', 'diner_sofa_1*1', 'diner_sofa_1*1', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2889, 2889, '1', 'diner_sofa_1*2', 'diner_sofa_1*2', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2890, 2890, '0', 'diner_sofa_1*3', 'diner_sofa_1*3', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2891, 2891, '1', 'diner_sofa_1*4', 'diner_sofa_1*4', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2892, 2892, '1', 'diner_sofa_1*5', 'diner_sofa_1*5', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2893, 2893, '1', 'diner_sofa_1*6', 'diner_sofa_1*6', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2894, 2894, '1', 'diner_sofa_1*7', 'diner_sofa_1*7', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2895, 2895, '1', 'diner_sofa_1*8', 'diner_sofa_1*8', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2896, 2896, '1', 'diner_sofa_1*9', 'diner_sofa_1*9', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2897, 2897, '1', 'diner_table_1*1', 'diner_table_1*1', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2898, 2898, '1', 'diner_table_1*2', 'diner_table_1*2', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2899, 2899, '0', 'diner_table_1*3', 'diner_table_1*3', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2900, 2900, '1', 'diner_table_1*4', 'diner_table_1*4', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2901, 2901, '1', 'diner_table_1*5', 'diner_table_1*5', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2902, 2902, '1', 'diner_table_1*6', 'diner_table_1*6', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2903, 2903, '1', 'diner_table_1*7', 'diner_table_1*7', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2904, 2904, '1', 'diner_table_1*8', 'diner_table_1*8', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2905, 2905, '1', 'diner_table_1*9', 'diner_table_1*9', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2906, 2906, '1', 'greek_seat', 'greek_seat', 'S', 1, 1, 0.60, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2907, 2907, '0', 'easy_bowl2', 'easy_bowl2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2908, 2908, '1', 'greek_gate', 'greek_gate', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(2909, 2909, '1', 'greek_pillars', 'greek_pillars', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2910, 2910, '1', 'greek_corner', 'greek_corner', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2911, 2911, '0', 'easy_carpet', 'easy_carpet', 'S', 4, 4, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2912, 2912, '0', 'greektrophy*1', 'greektrophy*1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(2913, 2913, '0', 'greektrophy*2', 'greektrophy*2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(2914, 2914, '0', 'greektrophy*3', 'greektrophy*3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(2915, 2915, '1', 'greek_block', 'greek_block', 'S', 2, 1, 0.50, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2916, 2916, '0', 'netari_carpet', 'netari_carpet', 'S', 3, 5, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2917, 2917, '0', 'hcc_shelf', 'hcc_shelf', 'S', 1, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2918, 2918, '1', 'det_divider', 'det_divider', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(2919, 2919, '0', 'hcc_chair', 'hcc_chair', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2920, 2920, '0', 'hcc_stool', 'hcc_stool', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2921, 2921, '0', 'hcc_sofa', 'hcc_sofa', 'S', 2, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2922, 2922, '1', 'det_body', 'det_body', 'S', 2, 3, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2923, 2923, '0', 'hcc_table', 'hcc_table', 'S', 1, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2924, 2924, '0', 'hcc_minibar', 'hcc_minibar', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '24', '', '', 0, 0, ''),
	(2925, 2925, '0', 'hcc_sofachair', 'hcc_sofachair', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2926, 2926, '0', 'hcc_crnr', 'hcc_crnr', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2927, 2927, '0', 'hcc_dvdr', 'hcc_dvdr', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2928, 2928, '0', 'sob_carpet', 'sob_carpet', 'S', 3, 5, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2929, 2929, '0', 'igor_seat', 'igor_seat', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2930, 2930, '0', 'ads_711*1', 'ads_711*1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '19', '', '', 0, 0, ''),
	(2931, 2931, '0', 'ads_711*2', 'ads_711*2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '19', '', '', 0, 0, ''),
	(2932, 2932, '0', 'ads_711*3', 'ads_711*3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '19', '', '', 0, 0, ''),
	(2933, 2933, '0', 'ads_711*4', 'ads_711*4', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '19', '', '', 0, 0, ''),
	(2934, 2934, '0', 'ads_igorswitch', 'ads_igorswitch', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2935, 2935, '0', 'ads_igorraygun', 'ads_igorraygun', 'S', 1, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2936, 2936, '0', 'ads_igorbrain', 'ads_igorbrain', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2937, 2937, '0', 'hween08_bed2', 'hween08_bed2', 'S', 1, 3, 1.90, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 2, '', '', '', 0, 0, ''),
	(2938, 2938, '0', 'hween08_defibs', 'hween08_defibs', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2939, 2939, '0', 'hween08_defibs2', 'hween08_defibs2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2940, 2940, '0', 'hween08_sink2', 'hween08_sink2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '30', '', '', 0, 0, ''),
	(2941, 2941, '0', 'hween08_trll', 'hween08_trll', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2942, 2942, '0', 'hween08_curtain', 'hween08_curtain', 'S', 3, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2943, 2943, '0', 'hween08_bbag', 'hween08_bbag', 'S', 1, 3, 1.30, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 2, '', '', '', 0, 0, ''),
	(2944, 2944, '0', 'hween08_sink', 'hween08_sink', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '29', '', '', 0, 0, ''),
	(2945, 2945, '0', 'hween08_bed', 'hween08_bed', 'S', 1, 3, 1.80, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 2, '', '', '', 0, 0, ''),
	(2946, 2946, '0', 'hween08_manhole', 'hween08_manhole', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2947, 2947, '0', 'hween08_bath2', 'hween08_bath2', 'S', 1, 2, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2948, 2948, '0', 'hween08_bath', 'hween08_bath', 'S', 1, 2, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2949, 2949, '0', 'hween08_curtain2', 'hween08_curtain2', 'S', 3, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2950, 2950, '1', 'party_block2', 'party_block2', 'S', 2, 2, 0.70, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2951, 2951, '1', 'party_tube_bubble', 'party_tube_bubble', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(2952, 2952, '1', 'party_seat', 'party_seat', 'S', 1, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2953, 2953, '1', 'party_mic', 'party_mic', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2954, 2954, '1', 'party_djtable', 'party_djtable', 'S', 1, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2955, 2955, '1', 'party_tray', 'party_tray', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '31', '', '', 0, 0, ''),
	(2956, 2956, '1', 'party_table', 'party_table', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(2957, 2957, '1', 'party_barcorn', 'party_barcorn', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2958, 2958, '1', 'party_floor', 'party_floor', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 10, '', '', '', 0, 0, ''),
	(2959, 2959, '1', 'party_block', 'party_block', 'S', 1, 1, 0.90, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2960, 2960, '1', 'party_chair', 'party_chair', 'S', 1, 1, 1.30, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2961, 2961, '1', 'party_beamer', 'party_beamer', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 7, '', '', '', 0, 0, ''),
	(2962, 2962, '1', 'party_bardesk', 'party_bardesk', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2963, 2963, '1', 'party_discol', 'party_discol', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(2964, 2964, '1', 'party_ball', 'party_ball', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2965, 2965, '1', 'party_ravel', 'party_ravel', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(2966, 2966, '1', 'party_tube_lava', 'party_tube_lava', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(2967, 2967, '0', 'xmas08_icetree', 'xmas08_icetree', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2968, 2968, '0', 'xmas08_lantern', 'xmas08_lantern', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2969, 2969, '0', 'penguin_robot', 'penguin_robot', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2970, 2970, '0', 'xmas08_dvdr2', 'xmas08_dvdr2', 'S', 1, 1, 1.60, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2971, 2971, '0', 'penguin_elf', 'penguin_elf', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2972, 2972, '0', 'xmas08_trph1', 'xmas08_trph1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2973, 2973, '0', 'penguin_skater', 'penguin_skater', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2974, 2974, '0', 'campfire', 'campfire', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(2975, 2975, '0', 'penguin_bunny', 'penguin_bunny', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2976, 2976, '0', 'penguin_ninja', 'penguin_ninja', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2977, 2977, '0', 'penguin_basic', 'penguin_basic', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2978, 2978, '0', 'xmas08_telep', 'xmas08_telep', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'teleport', 1, '', '', '', 0, 0, ''),
	(2979, 2979, '0', 'penguin_boxer', 'penguin_boxer', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2980, 2980, '0', 'xmas08_hole', 'xmas08_hole', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine_no_sides', 2, '34', '', '', 0, 0, ''),
	(2981, 2981, '0', 'penguin_ski', 'penguin_ski', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2982, 2982, '0', 'xmas_snow', 'xmas_snow', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2983, 2983, '0', 'penguin_infected', 'penguin_infected', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2984, 2984, '0', 'penguin_swim', 'penguin_swim', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2985, 2985, '0', 'xmas08_geysir', 'xmas08_geysir', 'S', 2, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2986, 2986, '0', 'xmas08_hottub', 'xmas08_hottub', 'S', 2, 2, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2987, 2987, '0', 'penguin_cowboy', 'penguin_cowboy', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2988, 2988, '0', 'penguin_icehockey', 'penguin_icehockey', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2989, 2989, '0', 'penguin_clown', 'penguin_clown', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2990, 2990, '0', 'penguin_wrestler', 'penguin_wrestler', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2991, 2991, '0', 'svnr_fi', 'svnr_fi', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2992, 2992, '0', 'xmas08_dvdr1', 'xmas08_dvdr1', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2993, 2993, '0', 'penguin_glow', 'penguin_glow', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2994, 2994, '0', 'penguin_sumo', 'penguin_sumo', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2995, 2995, '0', 'penguin_musketeer', 'penguin_musketeer', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2996, 2996, '0', 'penguin_ballet', 'penguin_ballet', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2997, 2997, '0', 'penguin_magician', 'penguin_magician', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2998, 2998, '0', 'penguin_super', 'penguin_super', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(2999, 2999, '0', 'penguin_pirate', 'penguin_pirate', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3000, 3000, '0', 'sound_set_71', 'sound_set_71', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(3001, 3001, '0', 'xmas08_chair', 'xmas08_chair', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3002, 3002, '0', 'xmas08_icerug', 'xmas08_icerug', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(3003, 3003, '0', 'penguin_hunchback', 'penguin_hunchback', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3004, 3004, '0', 'penguin_punk', 'penguin_punk', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3005, 3005, '0', 'xmas08_snowpl', 'xmas08_snowpl', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3006, 3006, '0', 'xmas08_cubetree', 'xmas08_cubetree', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3007, 3007, '0', 'penguin_pilot', 'penguin_pilot', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3008, 3008, '0', 'penguin_suit', 'penguin_suit', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3009, 3009, '0', 'xmas08_table', 'xmas08_table', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3010, 3010, '0', 'penguin_rock', 'penguin_rock', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3011, 3011, '0', 'fx_explosion', 'fx_explosion', 'S', 1, 1, 0.25, '0', '0', '0', '1', '0', '0', '0', '0', '0', 'default', 2, '', '', '', 0, 0, ''),
	(3012, 3012, '0', 'fx_bubble', 'fx_bubble', 'S', 1, 1, 0.25, '0', '0', '0', '1', '0', '0', '0', '0', '0', 'default', 2, '', '', '', 0, 0, ''),
	(3013, 3013, '0', 'fx_flare', 'fx_flare', 'S', 1, 1, 1.00, '0', '0', '0', '0', '0', '0', '0', '0', '0', 'default', 2, '', '', '', 0, 0, ''),
	(3014, 3014, '0', 'ads_cltele', 'ads_cltele', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'teleport', 1, '', '', '', 0, 0, ''),
	(3015, 3015, '0', 'xmas08_trph2', 'xmas08_trph2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3016, 3016, '0', 'lostc_merdragon', 'lostc_merdragon', 'S', 1, 3, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3017, 3017, '0', 'ads_cldesk', 'ads_cldesk', 'S', 2, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3018, 3018, '0', 'ads_ob_pillow', 'ads_ob_pillow', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3019, 3019, '0', 'ads_clfloor', 'ads_clfloor', 'S', 3, 5, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3020, 3020, '0', 'ads_mall_tele', 'ads_mall_tele', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'teleport', 1, '', '', '', 0, 0, ''),
	(3021, 3021, '0', 'ads_cllava2', 'ads_cllava2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3022, 3022, '1', 'bolly_lotus_pool', 'bolly_lotus_pool', 'S', 2, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(3023, 3023, '0', 'kinkysofa', 'kinkysofa', 'S', 2, 1, 1.30, '0', '1', '1', '1', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(3024, 3024, '0', 'china_moongt', 'china_moongt', 'S', 1, 3, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(3025, 3025, '0', 'china_ox', 'china_ox', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3026, 3026, '1', 'bolly_petals', 'bolly_petals', 'S', 2, 2, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(3027, 3027, '1', 'bolly_tile2', 'bolly_tile2', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3028, 3028, '1', 'bolly_tile1', 'bolly_tile1', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3029, 3029, '1', 'bolly_fountain', 'bolly_fountain', 'S', 2, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(3030, 3030, '1', 'bolly_pillow', 'bolly_pillow', 'S', 1, 1, 0.80, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3031, 3031, '1', 'bolly_corner', 'bolly_corner', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3032, 3032, '1', 'bolly_drapec', 'bolly_drapec', 'S', 3, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(3033, 3033, '1', 'bolly_phant', 'bolly_phant', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '35', '', '', 0, 0, ''),
	(3034, 3034, '1', 'bolly_desk', 'bolly_desk', 'S', 2, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3035, 3035, '1', 'bolly_table', 'bolly_table', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3036, 3036, '1', 'bolly_monkey_lamp', 'bolly_monkey_lamp', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3037, 3037, '1', 'bolly_swing', 'bolly_swing', 'S', 2, 1, 1.70, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3038, 3038, '1', 'bolly_drapea', 'bolly_drapea', 'S', 3, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(3039, 3039, '0', 'bolly_palm', 'bolly_palm', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3040, 3040, '1', 'bolly_drapeb', 'bolly_drapeb', 'S', 3, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(3041, 3041, '1', 'bolly_lamp', 'bolly_lamp', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3042, 3042, '1', 'bolly_tree', 'bolly_tree', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3043, 3043, '1', 'bolly_vase', 'bolly_vase', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine_no_sides', 2, '1019', '', '', 0, 0, ''),
	(3044, 3044, '0', 'planet_of_love', 'planet_of_love', 'S', 1, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3045, 3045, '0', 'ads_idol_floor1', 'ads_idol_floor1', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(3046, 3046, '0', 'ads_igor_flask', 'ads_igor_flask', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3047, 3047, '0', 'ads_idol_floor2', 'ads_idol_floor2', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(3048, 3048, '0', 'ads_idol_drape', 'ads_idol_drape', 'S', 3, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(3049, 3049, '0', 'ads_igor_dsk', 'ads_igor_dsk', 'S', 2, 1, 1.50, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3050, 3050, '0', 'ads_idol_desk', 'ads_idol_desk', 'S', 1, 4, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3051, 3051, '0', 'ads_idol_ch', 'ads_idol_ch', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3052, 3052, '0', 'lostc_octopus', 'lostc_octopus', 'S', 1, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3053, 3053, '0', 'ads_idol_tele', 'ads_idol_tele', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'teleport', 1, '', '', '', 0, 0, ''),
	(3054, 3054, '0', 'ads_idol_mic', 'ads_idol_mic', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3055, 3055, '0', 'ads_idol_trax', 'ads_idol_trax', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(3056, 3056, '0', 'ads_idol_pchair', 'ads_idol_pchair', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3057, 3057, '0', 'ads_idol_audChr', 'ads_idol_audChr', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3058, 3058, '0', 'ads_idol_piano', 'ads_idol_piano', 'S', 2, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3059, 3059, '0', 'ads_idol_jukebox*1', 'ads_idol_jukebox*1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'jukebox', 2, '', '', '', 0, 0, ''),
	(3060, 3060, '1', 'lc_glass_floor', 'lc_glass_floor', 'S', 2, 3, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3061, 3061, '1', 'lc_chair', 'lc_chair', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3062, 3062, '1', 'lc_crab1', 'lc_crab1', 'S', 2, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3063, 3063, '1', 'lc_stool', 'lc_stool', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3064, 3064, '1', 'lc_medusa1', 'lc_medusa1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(3065, 3065, '1', 'lc_tubes_straight', 'lc_tubes_straight', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3066, 3066, '0', 'ads_711shelf', 'ads_711shelf', 'S', 1, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '19', '', '', 0, 0, ''),
	(3067, 3067, '1', 'lc_table', 'lc_table', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3068, 3068, '1', 'lc_crab2', 'lc_crab2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3069, 3069, '1', 'lc_tile2', 'lc_tile2', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3070, 3070, '1', 'lc_desk', 'lc_desk', 'S', 2, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3071, 3071, '0', 'lostc_teleport', 'lostc_teleport', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '1', '1', 'teleport', 1, '', '', '', 0, 0, ''),
	(3072, 3072, '1', 'lc_tubes_corners', 'lc_tubes_corners', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3073, 3073, '1', 'lc_medusa2', 'lc_medusa2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(3074, 3074, '1', 'lc_anemone', 'lc_anemone', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(3075, 3075, '1', 'lc_corner', 'lc_corner', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3076, 3076, '1', 'lc_tile1', 'lc_tile1', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3077, 3077, '1', 'lc_coral_divider_low', 'lc_coral_divider_low', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3078, 3078, '1', 'lc_coral_divider_hi', 'lc_coral_divider_hi', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3079, 3079, '0', 'ads_idol_clRack', 'ads_idol_clRack', 'S', 3, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3080, 3080, '0', 'ads_idol_hotspot', 'ads_idol_hotspot', 'S', 1, 1, 0.20, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 103, '', '', '', 0, 0, ''),
	(3081, 3081, '0', 'ads_idol_voting_ch', 'ads_idol_voting_ch', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(3082, 3082, '0', 'eco_light2', 'eco_light2', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3083, 3083, '0', 'eco_cactus1', 'eco_cactus1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3084, 3084, '0', 'eco_chair1', 'eco_chair1', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3085, 3085, '0', 'eco_cactus3', 'eco_cactus3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3086, 3086, '0', 'eco_table3', 'eco_table3', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3087, 3087, '1', 'bump_tottero', 'bump_tottero', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3088, 3088, '0', 'eco_sofa3', 'eco_sofa3', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3089, 3089, '0', 'eco_table2', 'eco_table2', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3090, 3090, '1', 'bump_signs', 'bump_signs', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 7, '', '', '', 0, 0, ''),
	(3091, 3091, '0', 'eco_lamp3', 'eco_lamp3', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3092, 3092, '0', 'eco_lamp2', 'eco_lamp2', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3093, 3093, '0', 'eco_tree1', 'eco_tree1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine_no_sides', 2, '38', '', '', 0, 0, ''),
	(3094, 3094, '0', 'eco_chair3', 'eco_chair3', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3095, 3095, '0', 'ecotron_box', 'ecotron_box', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3096, 3096, '0', 'eco_sofa1', 'eco_sofa1', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3097, 3097, '0', 'eco_lamp1', 'eco_lamp1', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3098, 3098, '0', 'eco_light1', 'eco_light1', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3099, 3099, '0', 'eco_table1', 'eco_table1', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3100, 3100, '0', 'eco_sofa2', 'eco_sofa2', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3101, 3101, '1', 'bump_tires', 'bump_tires', 'S', 1, 1, 0.80, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(3102, 3102, '0', 'eco_fruits2', 'eco_fruits2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine_no_sides', 2, '36,37,38,39', '', '', 0, 0, ''),
	(3103, 3103, '1', 'bump_lights', 'bump_lights', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(3104, 3104, '0', 'eco_fruits3', 'eco_fruits3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine_no_sides', 2, '36,37,38,39', '', '', 0, 0, ''),
	(3105, 3105, '0', 'eco_cactus2', 'eco_cactus2', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3106, 3106, '0', 'eco_chair2', 'eco_chair2', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3107, 3107, '0', 'eco_fruits1', 'eco_fruits1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine_no_sides', 2, '36,37,38,39', '', '', 0, 0, ''),
	(3108, 3108, '0', 'eco_light3', 'eco_light3', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3109, 3109, '0', 'eco_tree2', 'eco_tree2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine_no_sides', 2, '36', '', '', 0, 0, ''),
	(3110, 3110, '1', 'bump_road', 'bump_road', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(3111, 3111, '0', 'ads_frankb', 'ads_frankb', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3112, 3112, '0', 'ads_grefusa_cactus', 'ads_grefusa_cactus', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3113, 3113, '0', 'totem_leg', 'totem_leg', 'S', 1, 1, 1.25, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 12, '', '', '', 0, 0, ''),
	(3114, 3114, '1', 'exe_artlamp', 'exe_artlamp', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3115, 3115, '1', 'env_bushes', 'env_bushes', 'S', 1, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3116, 3116, '0', 'ads_idol_newsDsk', 'ads_idol_newsDsk', 'S', 2, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3117, 3117, '1', 'env_tree1', 'env_tree1', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3118, 3118, '1', 'env_tree4', 'env_tree4', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(3119, 3119, '1', 'exe_gate', 'exe_gate', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(3120, 3120, '0', 'ads_idol_cork', 'ads_idol_cork', 'S', 3, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3121, 3121, '1', 'exe_cubelight', 'exe_cubelight', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(3122, 3122, '1', 'exe_light', 'exe_light', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(3123, 3123, '1', 'env_tree2', 'env_tree2', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3124, 3124, '0', 'ads_idol_ichair', 'ads_idol_ichair', 'S', 1, 1, 1.40, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3125, 3125, '1', 'env_tree3', 'env_tree3', 'S', 1, 1, 1.40, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3126, 3126, '0', 'ads_idol_tube', 'ads_idol_tube', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3127, 3127, '0', 'ads_cl_jukeb', 'ads_cl_jukeb', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3128, 3128, '1', 'env_bushes_gate', 'env_bushes_gate', 'S', 1, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(3129, 3129, '0', 'env_grass', 'env_grass', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3130, 3130, '1', 'tray_glasstower', 'tray_glasstower', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine_no_sides', 2, '40', '', '', 0, 0, ''),
	(3131, 3131, '0', 'ads_malaco_gu', 'ads_malaco_gu', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3132, 3132, '0', 'ads_reebok_block2', 'ads_reebok_block2', 'S', 2, 2, 0.80, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3133, 3133, '1', 'tray_cake', 'tray_cake', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3134, 3134, '1', 'tray_champagne', 'tray_champagne', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3135, 3135, '0', 'ads_malaco_rug', 'ads_malaco_rug', 'S', 3, 3, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3136, 3136, '0', 'ads_idol_tblCloth', 'ads_idol_tblCloth', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3137, 3137, '0', 'ads_cl_sofa', 'ads_cl_sofa', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3138, 3138, '0', 'ads_idol_lamp', 'ads_idol_lamp', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3139, 3139, '0', 'ads_clcake', 'ads_clcake', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3140, 3140, '0', 'ads_idol_carpet', 'ads_idol_carpet', 'S', 2, 7, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3141, 3141, '1', 'country_fnc2', 'country_fnc2', 'S', 2, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3142, 3142, '0', 'eco_mush1', 'eco_mush1', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3143, 3143, '1', 'country_rbw', 'country_rbw', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3144, 3144, '0', 'sound_set_72', 'sound_set_72', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3145, 3145, '1', 'country_soil', 'country_soil', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 6, '', '', '', 0, 0, ''),
	(3146, 3146, '1', 'country_log', 'country_log', 'S', 2, 1, 1.40, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3147, 3147, '0', 'country_trctr', 'country_trctr', 'S', 2, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3148, 3148, '1', 'country_stage', 'country_stage', 'S', 2, 2, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3149, 3149, '1', 'country_well', 'country_well', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '87,44', '', '', 0, 0, ''),
	(3150, 3150, '1', 'country_gate', 'country_gate', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(3151, 3151, '0', 'ads_goldtabl', 'ads_goldtabl', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3152, 3152, '1', 'country_fnc3', 'country_fnc3', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3153, 3153, '1', 'country_rain', 'country_rain', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3154, 3154, '1', 'country_fnc1', 'country_fnc1', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3155, 3155, '0', 'eco_mush2', 'eco_mush2', 'S', 1, 1, 1.50, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3156, 3156, '0', 'ads_calip_cola*1', 'ads_calip_cola*1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '19', '', '', 0, 0, ''),
	(3157, 3157, '0', 'ads_calip_cola*2', 'ads_calip_cola*2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '19', '', '', 0, 0, ''),
	(3158, 3158, '0', 'ads_calip_cola*3', 'ads_calip_cola*3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '19', '', '', 0, 0, ''),
	(3159, 3159, '0', 'ads_calip_cola*4', 'ads_calip_cola*4', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '19', '', '', 0, 0, ''),
	(3160, 3160, '1', 'country_scarecrow', 'country_scarecrow', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(3161, 3161, '0', 'env_telep', 'env_telep', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'teleport', 1, '', '', '', 0, 0, ''),
	(3162, 3162, '1', 'country_grass', 'country_grass', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(3163, 3163, '1', 'country_wheat', 'country_wheat', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3164, 3164, '1', 'country_corner', 'country_corner', 'S', 1, 1, 0.20, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3165, 3165, '1', 'country_ditch', 'country_ditch', 'S', 1, 2, 0.20, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(3166, 3166, '1', 'country_patio', 'country_patio', 'S', 1, 1, 0.20, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3167, 3167, '0', 'totem_head', 'totem_head', 'S', 1, 1, 1.75, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 15, '', '', '', 0, 0, ''),
	(3168, 3168, '0', 'ads_calip_chair', 'ads_calip_chair', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3169, 3169, '0', 'ads_idol_trophy', 'ads_idol_trophy', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(3170, 3170, '1', 'LT_pillar2', 'LT_pillar2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3171, 3171, '1', 'LT_throne', 'LT_throne', 'S', 1, 1, 1.50, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3172, 3172, '1', 'lt_gate', 'lt_gate', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(3173, 3173, '0', 'laptopdesk', 'laptopdesk', 'S', 2, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3174, 3174, '1', 'lt_bughill', 'lt_bughill', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3175, 3175, '1', 'lt_stage2', 'lt_stage2', 'S', 2, 2, 0.90, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3176, 3176, '1', 'lt_lava', 'lt_lava', 'S', 1, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(3177, 3177, '1', 'lt_stone2', 'lt_stone2', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(3178, 3178, '1', 'lt_spider', 'lt_spider', 'S', 1, 1, 0.50, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3179, 3179, '0', 'audChr', 'audChr', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3180, 3180, '1', 'lt_lavac', 'lt_lavac', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3181, 3181, '0', 'saturn', 'saturn', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3182, 3182, '0', 'ads_calip_pool', 'ads_calip_pool', 'S', 2, 2, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3183, 3183, '1', 'lt_stage1', 'lt_stage1', 'S', 1, 1, 0.70, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3184, 3184, '1', 'clrack', 'clrack', 'S', 3, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3185, 3185, '1', 'lt_statue', 'lt_statue', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3186, 3186, '0', 'noticeboard', 'noticeboard', 'S', 3, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3187, 3187, '1', 'LT_pillar', 'LT_pillar', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(3188, 3188, '1', 'lt_patch', 'lt_patch', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(3189, 3189, '1', 'LT_skull', 'LT_skull', 'S', 1, 1, 0.40, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3190, 3190, '0', 'ads_calip_tele', 'ads_calip_tele', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'teleport', 1, '', '', '', 0, 0, ''),
	(3195, 3195, '0', 'ads_calip_parasol', 'ads_calip_parasol', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3196, 3196, '1', 'lt_stone1', 'lt_stone1', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3197, 3197, '0', 'ads_calip_lava', 'ads_calip_lava', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3198, 3198, '0', 'ads_calip_fan', 'ads_calip_fan', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3199, 3199, '1', 'transparent_floor', 'transparent_floor', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(3200, 3200, '0', 'totem_planet', 'totem_planet', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(3201, 3201, '0', 'voting_ch', 'voting_ch', 'S', 1, 1, 1.30, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(3202, 3202, '0', 'ads_mall_coffeem', 'ads_mall_coffeem', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '41', '', '', 0, 0, ''),
	(3203, 3203, '1', 'sf_roof', 'sf_roof', 'S', 2, 4, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3204, 3204, '1', 'SF_crate_2', 'SF_crate_2', 'S', 2, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3205, 3205, '1', 'SF_crate_1', 'SF_crate_1', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3206, 3206, '1', 'sf_stick', 'sf_stick', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(3207, 3207, '1', 'SF_chair_blue', 'SF_chair_blue', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3208, 3208, '1', 'SF_panel3', 'SF_panel3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(3209, 3209, '0', 'sf_roller', 'sf_roller', 'S', 1, 1, 0.50, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'roller', 1, '', '', '', 0, 0, ''),
	(3210, 3210, '0', 'SF_alien', 'SF_alien', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3211, 3211, '1', 'SF_floor_2', 'SF_floor_2', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3212, 3212, '1', 'SF_reactor', 'SF_reactor', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3213, 3213, '1', 'sf_floor', 'sf_floor', 'S', 2, 4, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3214, 3214, '0', 'sf_tele', 'sf_tele', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'teleport', 1, '', '', '', 0, 0, ''),
	(3215, 3215, '1', 'SF_chair_green', 'SF_chair_green', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3216, 3216, '0', 'ads_mall_kiosk', 'ads_mall_kiosk', 'S', 1, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine_no_sides', 2, '34,36,37,38', '', '', 0, 0, ''),
	(3217, 3217, '1', 'SF_panel1', 'SF_panel1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(3218, 3218, '1', 'SF_panel2', 'SF_panel2', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3219, 3219, '0', 'sf_pod', 'sf_pod', 'S', 1, 3, 1.36, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'pressureplate', 2, '', '', '', 0, 0, ''),
	(3220, 3220, '1', 'SF_table', 'SF_table', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3221, 3221, '1', 'sf_gate', 'sf_gate', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(3222, 3222, '1', 'SF_floor_1', 'SF_floor_1', 'S', 2, 2, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3223, 3223, '1', 'SF_chair_red', 'SF_chair_red', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3224, 3224, '1', 'SF_lamp', 'SF_lamp', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(3225, 3225, '0', 'prizetrophy_cool', 'prizetrophy_cool', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(3226, 3226, '0', 'ads_elisa_gnome', 'ads_elisa_gnome', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3227, 3227, '1', 'summer_raft2', 'summer_raft2', 'S', 1, 1, 0.90, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'water_item', 1, '', '', '', 0, 0, ''),
	(3228, 3228, '1', 'summer_raft1', 'summer_raft1', 'S', 1, 1, 0.90, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'water_item', 1, '', '', '', 0, 0, ''),
	(3229, 3229, '0', 'prizetrophy_hot', 'prizetrophy_hot', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(3230, 3230, '0', 'ads_oc_soda', 'ads_oc_soda', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '19', '', '', 0, 0, ''),
	(3231, 3231, '1', 'summer_icebox', 'summer_icebox', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '43', '', '', 0, 0, ''),
	(3232, 3232, '1', 'marsrug', 'marsrug', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(3233, 3233, '1', 'rela_stone', 'rela_stone', 'S', 1, 1, 0.50, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(3234, 3234, '1', 'rela_candles1', 'rela_candles1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3235, 3235, '1', 'rela_candle3', 'rela_candle3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3236, 3236, '1', 'rela_candles3', 'rela_candles3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3237, 3237, '0', 'pix_asteroid', 'pix_asteroid', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3238, 3238, '1', 'rela_candle1', 'rela_candle1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3239, 3239, '1', 'rela_orchid', 'rela_orchid', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3240, 3240, '1', 'rela_stick', 'rela_stick', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(3241, 3241, '0', 'ads_711*5', 'ads_711*5', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '19', '', '', 0, 0, ''),
	(3242, 3242, '0', 'ads_711*6', 'ads_711*6', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '19', '', '', 0, 0, ''),
	(3243, 3243, '0', 'ads_711*7', 'ads_711*7', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '19', '', '', 0, 0, ''),
	(3244, 3244, '1', 'rela_candle2', 'rela_candle2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3245, 3245, '1', 'rela_candles2', 'rela_candles2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3246, 3246, '1', 'rela_plant', 'rela_plant', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3247, 3247, '1', 'rela_hchair', 'rela_hchair', 'S', 1, 1, 1.30, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3248, 3248, '1', 'rela_rock', 'rela_rock', 'S', 1, 1, 0.90, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(3249, 3249, '1', 'ktchn_fridge', 'ktchn_fridge', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '3,36,37,38', '', '', 0, 0, ''),
	(3250, 3250, '1', 'ktchn_inspctr', 'ktchn_inspctr', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '34', '', '', 0, 0, ''),
	(3251, 3251, '0', 'ads_1800tele', 'ads_1800tele', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'teleport', 1, '', '', '', 0, 0, ''),
	(3252, 3252, '1', 'ktchn_pots', 'ktchn_pots', 'S', 2, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 10, '', '', '', 0, 0, ''),
	(3253, 3253, '1', 'ktchn_countr_2', 'ktchn_countr_2', 'S', 2, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3254, 3254, '1', 'ktchn_gate', 'ktchn_gate', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(3255, 3255, '1', 'ktchn_bBlock', 'ktchn_bBlock', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(3256, 3256, '1', 'ktchn_stove', 'ktchn_stove', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(3257, 3257, '1', 'ktchn_cornr', 'ktchn_cornr', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3258, 3258, '1', 'ktchn_light', 'ktchn_light', 'S', 2, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3259, 3259, '1', 'ktchn_dvdr', 'ktchn_dvdr', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3260, 3260, '1', 'ktchn_desk', 'ktchn_desk', 'S', 2, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3261, 3261, '1', 'ktchn_countr_1', 'ktchn_countr_1', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3262, 3262, '1', 'ktchn_sink', 'ktchn_sink', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(3263, 3263, '1', 'ktchn_plates', 'ktchn_plates', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(3264, 3264, '1', 'ktchn_trash', 'ktchn_trash', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3265, 3265, '1', 'urban_lamp', 'urban_lamp', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3266, 3266, '1', 'urban_bin', 'urban_bin', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3267, 3267, '1', 'urban_fence', 'urban_fence', 'S', 1, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3268, 3268, '1', 'urban_carsofa', 'urban_carsofa', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3269, 3269, '1', 'urban_bench', 'urban_bench', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3270, 3270, '1', 'urban_blocker', 'urban_blocker', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3271, 3271, '1', 'urban_bsktbll', 'urban_bsktbll', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3272, 3272, '1', 'urban_wpost', 'urban_wpost', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3273, 3273, '0', 'sf_mbar', 'sf_mbar', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '44', '', '', 0, 0, ''),
	(3274, 3274, '1', 'urban_sidewalk', 'urban_sidewalk', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(3275, 3275, '1', 'urban_fence_corner', 'urban_fence_corner', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3276, 3276, '0', 'ads_idol_l_carpet', 'ads_idol_l_carpet', 'S', 2, 7, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3277, 3277, '0', 'ads_gsArcade_1', 'ads_gsArcade_1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3278, 3278, '0', 'ads_gsArcade_2', 'ads_gsArcade_2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3279, 3279, '0', 'ads_mtvtrophy_gold', 'ads_mtvtrophy_gold', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3280, 3280, '0', 'ads_spang_sleep', 'ads_spang_sleep', 'S', 1, 3, 0.80, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 2, '', '', '', 0, 0, ''),
	(3281, 3281, '0', 'ads_mtvtrophy_silver', 'ads_mtvtrophy_silver', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3282, 3282, '0', 'hween09_organ', 'hween09_organ', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(3283, 3283, '0', 'ads_idol_chmpgn', 'ads_idol_chmpgn', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3284, 3284, '1', 'urban_bench_plain', 'urban_bench_plain', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3285, 3285, '0', 'hween09_hatch', 'hween09_hatch', 'S', 2, 2, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(3286, 3286, '0', 'hween09_table', 'hween09_table', 'S', 1, 3, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3287, 3287, '0', 'hween09_jar', 'hween09_jar', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3288, 3288, '0', 'hween09_floor', 'hween09_floor', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(3289, 3289, '0', 'byesw_hotel', 'byesw_hotel', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 6, '', '', '', 0, 0, ''),
	(3290, 3290, '0', 'hween09_ghost', 'hween09_ghost', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3291, 3291, '0', 'byesw_hand', 'byesw_hand', 'S', 1, 1, 1.35, '0', '1', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3292, 3292, '0', 'hween09_tv', 'hween09_tv', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(3293, 3293, '0', 'hween09_mirror', 'hween09_mirror', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3294, 3294, '0', 'hween09_chandelier', 'hween09_chandelier', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(3295, 3295, '0', 'hween09_chair', 'hween09_chair', 'S', 1, 1, 1.35, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3296, 3296, '0', 'ads_twi_toolbx', 'ads_twi_toolbx', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3297, 3297, '0', 'ads_twi_table', 'ads_twi_table', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3298, 3298, '0', 'ads_twi_tower', 'ads_twi_tower', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3299, 3299, '0', 'ads_twi_piano', 'ads_twi_piano', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3300, 3300, '0', 'ads_twi_chair', 'ads_twi_chair', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3301, 3301, '0', 'ads_twi_fountn', 'ads_twi_fountn', 'S', 2, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3302, 3302, '0', 'ads_twi_dvdr2', 'ads_twi_dvdr2', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3303, 3303, '0', 'ads_twi_dvdr1', 'ads_twi_dvdr1', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3304, 3304, '0', 'ads_twi_roses', 'ads_twi_roses', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3305, 3305, '0', 'exe_elevator', 'exe_elevator', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'teleport', 1, '', '', '', 0, 0, ''),
	(3306, 3306, '0', 'ads_mall_elevator', 'ads_mall_elevator', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'teleport', 1, '', '', '', 0, 0, ''),
	(3307, 3307, '1', 'ktchn_hlthNut', 'ktchn_hlthNut', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '3', '', '', 0, 0, ''),
	(3308, 3308, '0', 'ads_twi_mist', 'ads_twi_mist', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3309, 3309, '0', 'nest_plow_bro', 'nest_plow_bro', 'S', 1, 1, 0.80, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'normal', 1, '', '', '', 0, 0, ''),
	(3310, 3310, '0', 'nest_snug_grn', 'nest_snug_grn', 'S', 1, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'nest', 1, '', '', '', 0, 0, ''),
	(3311, 3311, '0', 'ads_twi_trophy', 'ads_twi_trophy', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(3312, 3312, '1', 'arabian_tile', 'arabian_tile', 'S', 2, 2, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3313, 3313, '0', 'xm09_lrgBauble', 'xm09_lrgBauble', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 10, '', '', '', 0, 0, ''),
	(3314, 3314, '0', 'xm09_candyCane', 'xm09_candyCane', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(3315, 3315, '0', 'nest_snug_blu', 'nest_snug_blu', 'S', 1, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'nest', 1, '', '', '', 0, 0, ''),
	(3316, 3316, '0', 'nest_plow_blu', 'nest_plow_blu', 'S', 1, 1, 0.80, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'nest', 1, '', '', '', 0, 0, ''),
	(3317, 3317, '0', 'nest_snug_red', 'nest_snug_red', 'S', 1, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'nest', 1, '', '', '', 0, 0, ''),
	(3318, 3318, '0', 'nest_plow_reg', 'nest_plow_reg', 'S', 1, 1, 0.80, '0', '1', '0', '1', '1', '1', '0', '0', '1', 'normal', 1, '', '', '', 0, 0, ''),
	(3319, 3319, '0', 'nest_snug_yel', 'nest_snug_yel', 'S', 1, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'nest', 1, '', '', '', 0, 0, ''),
	(3320, 3320, '0', 'nest_plow_red', 'nest_plow_red', 'S', 1, 1, 0.80, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'nest', 1, '', '', '', 0, 0, ''),
	(3321, 3321, '0', 'petfood7', 'petfood7', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'pet_food', 4, '', '', '750,20,0', 0, 0, ''),
	(3322, 3322, '0', 'petfood9', 'petfood9', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'pet_food', 4, '', '', '1375,20,0', 0, 0, ''),
	(3323, 3323, '0', 'petfood6', 'petfood6', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'pet_food', 4, '', '', '350,15,0', 0, 0, ''),
	(3324, 3324, '0', 'petfood5', 'petfood5', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'pet_food', 4, '', '', '350,15,0', 0, 0, ''),
	(3325, 3325, '0', 'petfood8', 'petfood8', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'pet_food', 4, '', '', '825,10,0', 0, 0, ''),
	(3326, 3326, '0', 'petfood10', 'petfood10', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'pet_food', 4, '', '', '825,10,0', 0, 0, ''),
	(3327, 3327, '1', 'party_lantern', 'party_lantern', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3328, 3328, '0', 'xm09_man_b', 'xm09_man_b', 'S', 1, 1, 0.80, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 9, '', '', '', 0, 0, ''),
	(3329, 3329, '0', 'xm09_man_c', 'xm09_man_c', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 8, '', '', '', 0, 0, ''),
	(3330, 3330, '0', 'xm09_man_a', 'xm09_man_a', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(3331, 3331, '0', 'nest_dirt', 'nest_dirt', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'nest', 1, '', '', '', 0, 0, ''),
	(3332, 3332, '0', 'nest_snug_prp', 'nest_snug_prp', 'S', 1, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'nest', 1, '', '', '', 0, 0, ''),
	(3333, 3333, '0', 'nest_basket', 'nest_basket', 'S', 1, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'nest', 1, '', '', '', 0, 0, ''),
	(3334, 3334, '0', 'nest_nest', 'nest_nest', 'S', 1, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'nest', 1, '', '', '', 0, 0, ''),
	(3335, 3335, '0', 'xm09_table', 'xm09_table', 'S', 2, 6, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(3336, 3336, '0', 'nest_nails', 'nest_nails', 'S', 1, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'nest', 1, '', '', '', 0, 0, ''),
	(3337, 3337, '0', 'xm09_cocoa', 'xm09_cocoa', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '15', '', '', 0, 0, ''),
	(3338, 3338, '0', 'nest_snug_bla', 'nest_snug_bla', 'S', 1, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'nest', 1, '', '', '', 0, 0, ''),
	(3339, 3339, '0', 'nest_ice', 'nest_ice', 'S', 1, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'nest', 1, '', '', '', 0, 0, ''),
	(3340, 3340, '0', 'xm09_bench', 'xm09_bench', 'S', 6, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3341, 3341, '0', 'nest_plow_skl', 'nest_plow_skl', 'S', 1, 1, 0.30, '0', '1', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3342, 3342, '0', 'ads_cl_moodi', 'ads_cl_moodi', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '45,46,47', '', '', 0, 0, ''),
	(3343, 3343, '0', 'prizetrophy_nrj', 'prizetrophy_nrj', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(3344, 3344, '0', 'china_tiger', 'china_tiger', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3345, 3345, '0', 'org_chrblk', 'org_chrblk', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(3346, 3346, '0', 'china_tigrSeat', 'china_tigrSeat', 'S', 1, 2, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3347, 3347, '1', 'org_tblblk', 'org_tblblk', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3348, 3348, '1', 'org_lamppnk', 'org_lamppnk', 'S', 1, 1, 1.20, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3349, 3349, '1', 'org_chairblk', 'org_chairblk', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(3350, 3350, '0', 'org_chrpnk', 'org_chrpnk', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(3351, 3351, '0', 'xm09_trophy', 'xm09_trophy', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 2, '', '', '', 0, 0, ''),
	(3352, 3352, '1', 'org_tblpnk', 'org_tblpnk', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3353, 3353, '1', 'org_lampblk', 'org_lampblk', 'S', 1, 1, 1.20, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3354, 3354, '1', 'org_chairpnk', 'org_chairpnk', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(3355, 3355, '0', 'china_plmTree', 'china_plmTree', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3356, 3356, '1', 'org_table', 'org_table', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3357, 3357, '0', 'val09_floor2', 'val09_floor2', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 6, '', '', '', 0, 0, ''),
	(3358, 3358, '0', 'petfood11', 'petfood11', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'pet_food', 5, '', '', '130,10,0', 0, 0, ''),
	(3359, 3359, '0', 'petfood13', 'petfood13', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'pet_food', 5, '', '', '120,30,10', 0, 0, ''),
	(3360, 3360, '1', 'bling_chair_b', 'bling_chair_b', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3361, 3361, '1', 'bling_chair_c', 'bling_chair_c', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3362, 3362, '1', 'bling_toilet', 'bling_toilet', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3363, 3363, '0', 'val09_floor', 'val09_floor', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 6, '', '', '', 0, 0, ''),
	(3364, 3364, '1', 'bling_bed', 'bling_bed', 'S', 2, 3, 1.50, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'bed', 2, '', '', '', 0, 0, ''),
	(3365, 3365, '0', 'ads_droetker_paula', 'ads_droetker_paula', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '49', '', '', 0, 0, ''),
	(3366, 3366, '1', 'bling_fridge', 'bling_fridge', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '35', '', '', 0, 0, ''),
	(3367, 3367, '0', 'ads_chups', 'ads_chups', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '48', '', '', 0, 0, ''),
	(3368, 3368, '1', 'bling_chair_a', 'bling_chair_a', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3369, 3369, '1', 'bling_pool', 'bling_pool', 'S', 3, 1, 0.01, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3370, 3370, '0', 'petfood12', 'petfood12', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'pet_food', 5, '', '', '100,50,0', 0, 0, ''),
	(3371, 3371, '1', 'bling_sofa', 'bling_sofa', 'S', 2, 1, 1.50, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3372, 3372, '0', 'present_wrap*1', 'present_wrap*1', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'gift', 1, '', '', '', 0, 0, ''),
	(3373, 3373, '0', 'present_wrap*10', 'present_wrap*10', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'gift', 1, '', '', '', 0, 0, ''),
	(3374, 3374, '0', 'present_wrap*2', 'present_wrap*2', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'gift', 1, '', '', '', 0, 0, ''),
	(3375, 3375, '0', 'present_wrap*3', 'present_wrap*3', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'gift', 1, '', '', '', 0, 0, ''),
	(3376, 3376, '0', 'present_wrap*4', 'present_wrap*4', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'gift', 1, '', '', '', 0, 0, ''),
	(3377, 3377, '0', 'present_wrap*5', 'present_wrap*5', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'gift', 1, '', '', '', 0, 0, ''),
	(3378, 3378, '0', 'present_wrap*6', 'present_wrap*6', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'gift', 1, '', '', '', 0, 0, ''),
	(3379, 3379, '0', 'present_wrap*7', 'present_wrap*7', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'gift', 1, '', '', '', 0, 0, ''),
	(3380, 3380, '0', 'present_wrap*8', 'present_wrap*8', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'gift', 1, '', '', '', 0, 0, ''),
	(3381, 3381, '0', 'present_wrap*9', 'present_wrap*9', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'gift', 1, '', '', '', 0, 0, ''),
	(3382, 3382, '0', 'val_basket', 'val_basket', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3383, 3383, '0', 'teddy_pink', 'teddy_pink', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3384, 3384, '0', 'teddy_pendergrass', 'teddy_pendergrass', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3385, 3385, '0', 'teddy_bear', 'teddy_bear', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3386, 3386, '0', 'val_hSeat*1', 'val_hSeat*1', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3387, 3387, '0', 'val_hSeat*2', 'val_hSeat*2', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3388, 3388, '0', 'val_hSeat*3', 'val_hSeat*3', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3389, 3389, '0', 'val_hSeat*4', 'val_hSeat*4', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3390, 3390, '0', 'val_hSeat*5', 'val_hSeat*5', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3391, 3391, '0', 'val_hSeat*6', 'val_hSeat*6', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3392, 3392, '0', 'val_hSeat*7', 'val_hSeat*7', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3393, 3393, '0', 'teddy_basic', 'teddy_basic', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3394, 3394, '0', 'bling_fridge_restricted', 'bling_fridge_restricted', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '50', '', '', 0, 0, ''),
	(3395, 3395, '0', 'ads_percyrock', 'ads_percyrock', 'S', 2, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3396, 3396, '1', 'bling_shwr', 'bling_shwr', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3397, 3397, '0', 'val_table1', 'val_table1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(3398, 3398, '0', 'rare_trex', 'rare_trex', 'S', 3, 7, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3399, 3399, '0', 'rare_ironmaiden', 'rare_ironmaiden', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'teleport', 2, '', '', '', 0, 0, ''),
	(3400, 3400, '0', 'crystal_patch', 'crystal_patch', 'S', 3, 3, 0.00, '1', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(3401, 3401, '0', 'beanstalk', 'beanstalk', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 6, '', '', '', 0, 0, ''),
	(3402, 3402, '0', 'rare_mmmth', 'rare_mmmth', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(3403, 3403, '0', 'rare_vdoll', 'rare_vdoll', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 10, '', '', '', 0, 0, ''),
	(3404, 3404, '0', 'garden_mursu', 'garden_mursu', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(3405, 3405, '0', 'garden_jyrki', 'garden_jyrki', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 8, '', '', '', 0, 0, ''),
	(3406, 3406, '0', 'garden_seed', 'garden_seed', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3407, 3407, '0', 'garden_lupin3', 'garden_lupin3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(3408, 3408, '0', 'garden_mursu3', 'garden_mursu3', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(3409, 3409, '0', 'garden_flo2', 'garden_flo2', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'vendingmachine_no_sides', 2, '1008', '', '', 0, 0, ''),
	(3410, 3410, '0', 'prizetrophy_thumb', 'prizetrophy_thumb', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(3411, 3411, '0', 'garden_lupin5', 'garden_lupin5', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(3412, 3412, '0', 'garden_mursu2', 'garden_mursu2', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(3413, 3413, '0', 'garden_orchtree', 'garden_orchtree', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3414, 3414, '0', 'garden_mursu4', 'garden_mursu4', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(3415, 3415, '0', 'garden_flolamp', 'garden_flolamp', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3416, 3416, '0', 'garden_lupin2', 'garden_lupin2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(3417, 3417, '0', 'garden_staringbush', 'garden_staringbush', 'S', 1, 3, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(3418, 3418, '0', 'garden_flo1', 'garden_flo1', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'vendingmachine_no_sides', 2, '1007', '', '', 0, 0, ''),
	(3419, 3419, '0', 'garden_lupin4', 'garden_lupin4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(3420, 3420, '0', 'garden_flytrap', 'garden_flytrap', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'teleport', 1, '', '', '', 0, 0, ''),
	(3421, 3421, '0', 'garden_lupin1', 'garden_lupin1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(3422, 3422, '0', 'garden_jungle', 'garden_jungle', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(3423, 3423, '0', 'ads_grefusa_yum', 'ads_grefusa_yum', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '51', '', '', 0, 0, ''),
	(3424, 3424, '0', 'garden_volcano', 'garden_volcano', 'S', 2, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'alert', 2, '', '', '', 0, 0, ''),
	(3425, 3425, '0', 'garden_leaves', 'garden_leaves', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(3426, 3426, '0', 'garden_flo3', 'garden_flo3', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'vendingmachine_no_sides', 2, '1009', '', '', 0, 0, ''),
	(3427, 3427, '1', 'runway_bigchr_2', 'runway_bigchr_2', 'S', 1, 1, 0.80, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(3428, 3428, '0', 'hc2_vase', 'hc2_vase', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3429, 3429, '1', 'runway_chair_2', 'runway_chair_2', 'S', 1, 1, 1.50, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3430, 3430, '0', 'hc2_cart', 'hc2_cart', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3431, 3431, '0', 'hc3_divider', 'hc3_divider', 'S', 1, 3, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3432, 3432, '1', 'runway_head', 'runway_head', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 7, '', '', '', 0, 0, ''),
	(3433, 3433, '1', 'runway_block_1', 'runway_block_1', 'S', 2, 2, 0.80, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 10, '', '', '', 0, 0, ''),
	(3434, 3434, '0', 'hc2_sofatbl', 'hc2_sofatbl', 'S', 2, 2, 0.50, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3435, 3435, '1', 'runway_bigchr_4', 'runway_bigchr_4', 'S', 1, 1, 0.80, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(3436, 3436, '0', 'hc2_armchair', 'hc2_armchair', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3437, 3437, '1', 'runway_manqn_1', 'runway_manqn_1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(3438, 3438, '0', 'hc3_shelf', 'hc3_shelf', 'S', 3, 1, 1.75, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3439, 3439, '0', 'hc2_barchair', 'hc2_barchair', 'S', 1, 1, 1.80, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3440, 3440, '0', 'hc2_carpet', 'hc2_carpet', 'S', 3, 5, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3441, 3441, '0', 'hc3_sofa', 'hc3_sofa', 'S', 2, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3442, 3442, '1', 'runway_stool', 'runway_stool', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3443, 3443, '1', 'runway_block_2', 'runway_block_2', 'S', 2, 2, 0.80, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 10, '', '', '', 0, 0, ''),
	(3444, 3444, '1', 'runway_table_2', 'runway_table_2', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3445, 3445, '0', 'hc3_bard', 'hc3_bard', 'S', 2, 1, 1.05, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3446, 3446, '0', 'hc2_biglamp', 'hc2_biglamp', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3447, 3447, '0', 'hc3_hugelamp', 'hc3_hugelamp', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3448, 3448, '0', 'hc3_stool', 'hc3_stool', 'S', 1, 1, 1.70, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3449, 3449, '0', 'hc2_divider', 'hc2_divider', 'S', 1, 3, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3450, 3450, '0', 'hc2_coffee', 'hc2_coffee', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '53', '', '', 0, 0, ''),
	(3451, 3451, '1', 'runway_chair_1', 'runway_chair_1', 'S', 1, 1, 1.50, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3452, 3452, '0', 'hc2_sofa', 'hc2_sofa', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3453, 3453, '0', 'ads_cheetos', 'ads_cheetos', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '52', '', '', 0, 0, ''),
	(3454, 3454, '1', 'runway_bigchr_3', 'runway_bigchr_3', 'S', 1, 1, 0.80, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(3455, 3455, '0', 'merger_chest', 'merger_chest', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3456, 3456, '1', 'runway_dvdr', 'runway_dvdr', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3457, 3457, '1', 'runway_display', 'runway_display', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3458, 3458, '0', 'hc2_frplc', 'hc2_frplc', 'S', 1, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3459, 3459, '0', 'hc2_dvn', 'hc2_dvn', 'S', 1, 3, 1.20, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 2, '', '', '', 0, 0, ''),
	(3460, 3460, '1', 'runway_table_1', 'runway_table_1', 'S', 3, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(3461, 3461, '0', 'hc3_dc', 'hc3_dc', 'S', 1, 3, 1.20, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 2, '', '', '', 0, 0, ''),
	(3462, 3462, '1', 'runway_bigchr_1', 'runway_bigchr_1', 'S', 1, 1, 0.80, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(3463, 3463, '1', 'runway_bigchr_5', 'runway_bigchr_5', 'S', 1, 1, 0.80, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(3464, 3464, '1', 'runway_bench', 'runway_bench', 'S', 2, 1, 1.40, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(3465, 3465, '0', 'hc3_light', 'hc3_light', 'S', 2, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3466, 3466, '0', 'hc3_table', 'hc3_table', 'S', 2, 2, 0.50, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3467, 3467, '1', 'runway_manqn_2', 'runway_manqn_2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(3468, 3468, '0', 'cmp_fish_s', 'cmp_fish_s', 'S', 1, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3469, 3469, '0', 'cmp_fish_bk', 'cmp_fish_bk', 'S', 1, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3470, 3470, '0', 'hc3_stereo', 'hc3_stereo', 'S', 3, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3471, 3471, '0', 'cmp_nobox_2', 'cmp_nobox_2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3472, 3472, '0', 'cmp_fish_b', 'cmp_fish_b', 'S', 1, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3473, 3473, '0', 'cmp_nobox_3', 'cmp_nobox_3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3474, 3474, '0', 'cmp_fish_gr', 'cmp_fish_gr', 'S', 1, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3475, 3475, '0', 'cmp_fish_g', 'cmp_fish_g', 'S', 1, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3476, 3476, '0', 'cmp_nobox', 'cmp_nobox', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3477, 3477, '0', 'cmp_fish_r', 'cmp_fish_r', 'S', 1, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3478, 3478, '0', 'cmp_sub', 'cmp_sub', 'S', 7, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3479, 3479, '0', 'hc3_vase', 'hc3_vase', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3480, 3480, '1', 'party_crate2_1', 'party_crate2_1', 'S', 2, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(3481, 3481, '1', 'party_crate1_3', 'party_crate1_3', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(3482, 3482, '1', 'wed_plant', 'wed_plant', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3483, 3483, '1', 'wed_arch', 'wed_arch', 'S', 1, 3, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3484, 3484, '0', 'party_djset', 'party_djset', 'S', 1, 3, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3485, 3485, '1', 'party_crate1_4', 'party_crate1_4', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(3486, 3486, '0', 'ads_chocapic', 'ads_chocapic', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '54', '', '', 0, 0, ''),
	(3487, 3487, '1', 'party_crate1_1', 'party_crate1_1', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(3488, 3488, '1', 'wed_icesculp', 'wed_icesculp', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3489, 3489, '1', 'party_crate1_2', 'party_crate1_2', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(3490, 3490, '1', 'party_crate2_2', 'party_crate2_2', 'S', 2, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(3491, 3491, '1', 'party_crate2_3', 'party_crate2_3', 'S', 2, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(3492, 3492, '1', 'party_crate2_4', 'party_crate2_4', 'S', 2, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(3493, 3493, '1', 'wed_carsofa', 'wed_carsofa', 'S', 2, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3494, 3494, '1', 'fball_bench', 'fball_bench', 'S', 3, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3495, 3495, '1', 'fball_fnc3', 'fball_fnc3', 'S', 1, 3, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3496, 3496, '1', 'fball_score_b', 'fball_score_b', 'S', 1, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'football_counter_blue', 1, '', '', '', 0, 0, ''),
	(3497, 3497, '1', 'fball_ball3', 'fball_ball3', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'football', 2, '', '', '', 0, 0, ''),
	(3498, 3498, '1', 'fball_ptch5', 'fball_ptch5', 'S', 3, 3, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3499, 3499, '1', 'fball_light', 'fball_light', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3500, 3500, '1', 'fball_audbench', 'fball_audbench', 'S', 4, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 3, '', '1.2;1.9;2.5', '', 0, 0, ''),
	(3501, 3501, '1', 'fball_fnc1', 'fball_fnc1', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3502, 3502, '1', 'fball_ptch8', 'fball_ptch8', 'S', 3, 3, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3503, 3503, '1', 'fball_crnr', 'fball_crnr', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3504, 3504, '1', 'fball_ptch4', 'fball_ptch4', 'S', 3, 3, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3505, 3505, '0', 'fball_trophy', 'fball_trophy', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3506, 3506, '0', 'fball_score_y', 'fball_score_y', 'S', 1, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'football_counter_yellow', 1, '', '', '', 0, 0, ''),
	(3507, 3507, '1', 'fball_cote', 'fball_cote', 'S', 3, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3508, 3508, '1', 'fball_ball', 'fball_ball', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'football', 2, '', '', '', 0, 0, ''),
	(3509, 3509, '1', 'fball_ptch7', 'fball_ptch7', 'S', 3, 3, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3510, 3510, '1', 'fball_ball2', 'fball_ball2', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'football', 2, '', '', '', 0, 0, ''),
	(3511, 3511, '1', 'fball_ptch2', 'fball_ptch2', 'S', 3, 3, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3512, 3512, '0', 'fball_score_g', 'fball_score_g', 'S', 1, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'football_counter_green', 1, '', '', '', 0, 0, ''),
	(3513, 3513, '1', 'fball_ptch3', 'fball_ptch3', 'S', 3, 3, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3514, 3514, '1', 'fball_goal_r', 'fball_goal_r', 'S', 3, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'football_goal_red', 2, '', '', '', 0, 0, ''),
	(3515, 3515, '1', 'fball_goal_b', 'fball_goal_b', 'S', 3, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'football_goal_blue', 2, '', '', '', 0, 0, ''),
	(3516, 3516, '0', 'fball_gate', 'fball_gate', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'football_gate', 1, '', '', '', 0, 0, ''),
	(3517, 3517, '1', 'fball_ptch6', 'fball_ptch6', 'S', 3, 3, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3518, 3518, '0', 'fball_ball5', 'fball_ball5', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'football', 2, '', '', '', 0, 0, ''),
	(3519, 3519, '1', 'fball_goal_g', 'fball_goal_g', 'S', 3, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'football_goal_green', 1, '', '', '', 0, 0, ''),
	(3520, 3520, '1', 'fball_ptch0', 'fball_ptch0', 'S', 3, 3, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3521, 3521, '1', 'fball_ball4', 'fball_ball4', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'football', 2, '', '', '', 0, 0, ''),
	(3522, 3522, '1', 'fball_score_r', 'fball_score_r', 'S', 1, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'football_counter_red', 1, '', '', '', 0, 0, ''),
	(3523, 3523, '1', 'fball_goal_y', 'fball_goal_y', 'S', 3, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'football_goal_yellow', 1, '', '', '', 0, 0, ''),
	(3524, 3524, '1', 'fball_ptch1', 'fball_ptch1', 'S', 3, 3, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3525, 3525, '1', 'fball_counter', 'fball_counter', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'game_timer', 1, '', '', '30,60,120,180,300,600', 0, 0, ''),
	(3526, 3526, '1', 'prison_gate', 'prison_gate', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(3527, 3527, '1', 'bw_boat', 'bw_boat', 'S', 2, 2, 0.60, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'water_item', 1, '', '', '', 0, 0, ''),
	(3528, 3528, '1', 'prison_crnr', 'prison_crnr', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3529, 3529, '1', 'bw_lgchair', 'bw_lgchair', 'S', 1, 1, 2.80, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3530, 3530, '1', 'bw_water_1', 'bw_water_1', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'water', 1, '', '', '', 30, 30, ''),
	(3531, 3531, '1', 'prison_tower', 'prison_tower', 'S', 1, 1, 3.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3532, 3532, '1', 'prison_dvdr2', 'prison_dvdr2', 'S', 2, 1, 3.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(3533, 3533, '1', 'bw_sofa', 'bw_sofa', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'water_item', 1, '', '', '', 0, 0, ''),
	(3534, 3534, '1', 'prison_dvdr1', 'prison_dvdr1', 'S', 1, 1, 3.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3535, 3535, '0', 'ads_capri_chair', 'ads_capri_chair', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3536, 3536, '0', 'ads_capri_lava', 'ads_capri_lava', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3537, 3537, '1', 'prison_stone', 'prison_stone', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(3538, 3538, '1', 'bw_fin', 'bw_fin', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3539, 3539, '0', 'bw_ccnuts', 'bw_ccnuts', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3540, 3540, '1', 'bw_shower', 'bw_shower', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3541, 3541, '1', 'bw_water_2', 'bw_water_2', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'water', 1, '', '', '', 29, 29, ''),
	(3542, 3542, '0', 'bw_croc', 'bw_croc', 'S', 1, 3, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'water_item', 1, '', '', '', 0, 0, ''),
	(3543, 3543, '1', 'bw_sboard', 'bw_sboard', 'S', 2, 1, 0.60, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'water_item', 1, '', '', '', 0, 0, ''),
	(3544, 3544, '1', 'bw_chair', 'bw_chair', 'S', 1, 1, 0.80, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'water_item', 1, '', '', '', 0, 0, ''),
	(3545, 3545, '1', 'bw_table', 'bw_table', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'water_item', 1, '', '', '', 0, 0, ''),
	(3546, 3546, '0', 'ads_capri_tree', 'ads_capri_tree', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3547, 3547, '1', 'bw_bball', 'bw_bball', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'football', 2, '', '', '', 0, 0, ''),
	(3548, 3548, '1', 'bw_mttrss', 'bw_mttrss', 'S', 2, 1, 0.80, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'water_item', 1, '', '', '', 0, 0, ''),
	(3549, 3549, '1', 'bw_van', 'bw_van', 'S', 2, 2, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3550, 3550, '0', 'bw_tele', 'bw_tele', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'teleport', 2, '', '', '', 0, 0, ''),
	(3551, 3551, '1', 'bw_fnc_crnr', 'bw_fnc_crnr', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'water_item', 1, '', '', '', 0, 0, ''),
	(3552, 3552, '1', 'bw_fnc', 'bw_fnc', 'S', 1, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'water_item', 1, '', '', '', 0, 0, ''),
	(3553, 3553, '0', 'ads_capri_arcade', 'ads_capri_arcade', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3554, 3554, '0', 'ads_pepsi0', 'ads_pepsi0', 'S', 1, 1, 3.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '55', '', '', 0, 0, ''),
	(3555, 3555, '1', 'bw_boat_p', 'bw_boat_p', 'S', 2, 2, 0.70, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'water_item', 1, '', '', '', 0, 0, ''),
	(3556, 3556, '1', 'bw_pool_a3', 'bw_pool_a3', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3557, 3557, '1', 'bw_fnc_g', 'bw_fnc_g', 'S', 1, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'water_item', 1, '', '', '', 0, 0, ''),
	(3558, 3558, '1', 'bw_mttrss_g', 'bw_mttrss_g', 'S', 2, 1, 0.80, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'water_item', 1, '', '', '', 0, 0, ''),
	(3559, 3559, '1', 'bw_mttrss_p', 'bw_mttrss_p', 'S', 2, 1, 0.60, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'water_item', 1, '', '', '', 0, 0, ''),
	(3560, 3560, '1', 'bw_pool_b1', 'bw_pool_b1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3561, 3561, '1', 'bw_sofa_p', 'bw_sofa_p', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'water_item', 1, '', '', '', 0, 0, ''),
	(3562, 3562, '1', 'bw_sboard_g', 'bw_sboard_g', 'S', 2, 1, 0.60, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3563, 3563, '1', 'bw_fnc_crnr_g', 'bw_fnc_crnr_g', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'water_item', 1, '', '', '', 0, 0, ''),
	(3564, 3564, '1', 'bw_pool_a2', 'bw_pool_a2', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3565, 3565, '1', 'bw_pool_b2', 'bw_pool_b2', 'S', 2, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3566, 3566, '1', 'bw_table_g', 'bw_table_g', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'water_item', 1, '', '', '', 0, 0, ''),
	(3567, 3567, '1', 'bw_chair_p', 'bw_chair_p', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'water_item', 1, '', '', '', 0, 0, ''),
	(3568, 3568, '1', 'bw_boat_g', 'bw_boat_g', 'S', 2, 2, 0.80, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'water_item', 1, '', '', '', 0, 0, ''),
	(3569, 3569, '1', 'bw_fnc_p', 'bw_fnc_p', 'S', 1, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'water_item', 1, '', '', '', 0, 0, ''),
	(3570, 3570, '1', 'bw_van_p', 'bw_van_p', 'S', 2, 2, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3571, 3571, '1', 'bw_sboard_p', 'bw_sboard_p', 'S', 2, 1, 0.60, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3572, 3572, '1', 'bw_chair_g', 'bw_chair_g', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3573, 3573, '1', 'bw_pool_b3', 'bw_pool_b3', 'S', 1, 1, 0.10, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3574, 3574, '1', 'bw_van_g', 'bw_van_g', 'S', 2, 2, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3575, 3575, '1', 'bw_sofa_g', 'bw_sofa_g', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'water_item', 1, '', '', '', 0, 0, ''),
	(3576, 3576, '1', 'bw_fnc_crnr_p', 'bw_fnc_crnr_p', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'water_item', 1, '', '', '', 0, 0, ''),
	(3577, 3577, '1', 'bw_pool_a1', 'bw_pool_a1', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3578, 3578, '1', 'bw_table_p', 'bw_table_p', 'S', 2, 2, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'water_item', 1, '', '', '', 0, 0, ''),
	(3579, 3579, '1', 'african_fence', 'african_fence', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3580, 3580, '1', 'ktchn10_pot', 'ktchn10_pot', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(3581, 3581, '1', 'ktchn10_stove', 'ktchn10_stove', 'S', 2, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3582, 3582, '0', 'easel_0', 'easel_0', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3583, 3583, '0', 'petfood15', 'petfood15', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'pet_food', 5, '', '', '400,10,0', 0, 0, ''),
	(3584, 3584, '1', 'african_tree1', 'african_tree1', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3585, 3585, '0', 'ads_cheetos_hotdog', 'ads_cheetos_hotdog', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '56', '', '', 0, 0, ''),
	(3586, 3586, '0', 'hosptl_cab1', 'hosptl_cab1', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '1011,1013,1014,1015', '', '', 0, 0, ''),
	(3587, 3587, '0', 'nest_lion2', 'nest_lion2', 'S', 1, 1, 0.50, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'nest', 1, '', '', '', 0, 0, ''),
	(3588, 3588, '0', 'hosptl_curtain', 'hosptl_curtain', 'S', 3, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3589, 3589, '1', 'ktchn10_block', 'ktchn10_block', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(3590, 3590, '0', 'hosptl_bed', 'hosptl_bed', 'S', 1, 3, 1.80, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '1011', '', '', 0, 0, ''),
	(3591, 3591, '0', 'hosptl_bbag', 'hosptl_bbag', 'S', 1, 3, 1.20, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 2, '', '', '', 0, 0, ''),
	(3592, 3592, '1', 'ktchn10_tea', 'ktchn10_tea', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3593, 3593, '0', 'ads_cheetos_bath', 'ads_cheetos_bath', 'S', 1, 2, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3594, 3594, '0', 'easel_1', 'easel_1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(3595, 3595, '1', 'tiki_gate', 'tiki_gate', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 1, '', '', '', 0, 0, ''),
	(3596, 3596, '0', 'easel_3', 'easel_3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 5, '', '', '', 0, 0, ''),
	(3597, 3597, '0', 'nest_rhino', 'nest_rhino', 'S', 1, 1, 0.20, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'nest', 1, '', '', '', 0, 0, ''),
	(3598, 3598, '0', 'ads_oc_soda_cherry', 'ads_oc_soda_cherry', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '57', '', '', 0, 0, ''),
	(3599, 3599, '0', 'petfood14', 'petfood14', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'pet_food', 4, '', '', '1375,20,0', 0, 0, ''),
	(3600, 3600, '0', 'easel_4', 'easel_4', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(3601, 3601, '0', 'nest_lion', 'nest_lion', 'S', 1, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'nest', 1, '', '', '', 0, 0, ''),
	(3602, 3602, '1', 'african_patch', 'african_patch', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3603, 3603, '0', 'easel_2', 'easel_2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 5, '', '', '', 0, 0, ''),
	(3604, 3604, '0', 'hosptl_skele', 'hosptl_skele', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3605, 3605, '1', 'african_tree2', 'african_tree2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(3606, 3606, '0', 'hosptl_defibs', 'hosptl_defibs', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3607, 3607, '1', 'african_stage', 'african_stage', 'S', 2, 2, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(3608, 3608, '0', 'hosptl_cab2', 'hosptl_cab2', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '1011,1013,1014,1015', '', '', 0, 0, ''),
	(3609, 3609, '1', 'african_bones', 'african_bones', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3610, 3610, '0', 'hosptl_light', 'hosptl_light', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3611, 3611, '0', 'hosptl_seat', 'hosptl_seat', 'S', 2, 1, 1.50, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3612, 3612, '1', 'ktchn10_sink', 'ktchn10_sink', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(3613, 3613, '0', 'ads_disney_tv', 'ads_disney_tv', 'S', 1, 3, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3614, 3614, '1', 'bb_crnr', 'bb_crnr', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3615, 3615, '0', 'bb_score_b', 'bb_score_b', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'battlebanzai_counter_blue', 2, '', '', '', 0, 0, ''),
	(3616, 3616, '1', 'bb_robo', 'bb_robo', 'S', 2, 2, 2.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(3617, 3617, '1', 'bb_dragon', 'bb_dragon', 'S', 3, 1, 2.50, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(3618, 3618, '1', 'bb_ducklight', 'bb_ducklight', 'S', 1, 1, 3.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 8, '', '', '', 0, 0, ''),
	(3619, 3619, '1', 'bb_caterhead', 'bb_caterhead', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(3620, 3620, '1', 'bb_cargobox', 'bb_cargobox', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(3621, 3621, '1', 'bb_gate_g', 'bb_gate_g', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'battlebanzai_gate_green', 2, '', '', '', 0, 0, ''),
	(3622, 3622, '1', 'bb_crchair3', 'bb_crchair3', 'S', 1, 1, 0.90, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(3623, 3623, '0', 'bb_score_g', 'bb_score_g', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'battlebanzai_counter_green', 1, '', '', '', 0, 0, ''),
	(3624, 3624, '1', 'bb_crchair', 'bb_crchair', 'S', 1, 1, 0.90, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(3625, 3625, '1', 'bb_crchair2', 'bb_crchair2', 'S', 1, 1, 0.90, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(3626, 3626, '0', 'bb_score_y', 'bb_score_y', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'battlebanzai_counter_yellow', 2, '', '', '', 0, 0, ''),
	(3627, 3627, '1', 'bb_knj1', 'bb_knj1', 'S', 2, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(3628, 3628, '1', 'bb_gate_r', 'bb_gate_r', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'battlebanzai_gate_red', 2, '', '', '', 0, 0, ''),
	(3629, 3629, '1', 'bb_tddhnd', 'bb_tddhnd', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3630, 3630, '1', 'bb_lightdiv', 'bb_lightdiv', 'S', 1, 1, 1.35, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 8, '', '', '', 0, 0, ''),
	(3631, 3631, '1', 'bb_tddhead', 'bb_tddhead', 'S', 2, 2, 2.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(3632, 3632, '1', 'bb_pyramid', 'bb_pyramid', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'pyramid', 1, '', '', '', 0, 0, ''),
	(3633, 3633, '1', 'bb_patch1', 'bb_patch1', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'battlebanzai_tile', 4, '', '', '', 0, 0, ''),
	(3634, 3634, '1', 'bb_fnc3', 'bb_fnc3', 'S', 1, 3, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3635, 3635, '1', 'bb_gate_y', 'bb_gate_y', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'battlebanzai_gate_yellow', 1, '', '', '', 34, 0, ''),
	(3636, 3636, '0', 'hween10_zombie', 'hween10_zombie', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '58', '', '', 0, 0, ''),
	(3637, 3637, '1', 'bb_apparatus', 'bb_apparatus', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 8, '', '', '', 0, 0, ''),
	(3638, 3638, '1', 'bb_caterbody', 'bb_caterbody', 'S', 1, 1, 1.70, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(3639, 3639, '1', 'bb_knj2', 'bb_knj2', 'S', 1, 1, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(3640, 3640, '1', 'bb_fnc1', 'bb_fnc1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3641, 3641, '1', 'bb_puck', 'bb_puck', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'battlebanzai_puck', 3, '', '', '', 0, 0, ''),
	(3642, 3642, '0', 'bb_rnd_tele', 'bb_rnd_tele', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'battlebanzai_random_teleport', 1, '', '', '', 0, 0, ''),
	(3643, 3643, '1', 'bb_gate_b', 'bb_gate_b', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'battlebanzai_gate_blue', 2, '', '', '', 35, 35, ''),
	(3644, 3644, '0', 'bb_score_r', 'bb_score_r', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'battlebanzai_counter_red', 999, '', '', '', 0, 0, ''),
	(3645, 3645, '1', 'bb_counter', 'bb_counter', 'S', 1, 4, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'game_timer', 1, '', '', '30,60,120,180,300,600', 0, 0, ''),
	(3646, 3646, '0', 'hween10_tarot', 'hween10_tarot', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'dice', 7, '', ' ', '', 0, 0, ''),
	(3647, 3647, '0', 'hween10_voodoo1', 'hween10_voodoo1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3648, 3648, '0', 'hween10_tree', 'hween10_tree', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3649, 3649, '0', 'hween10_swamp', 'hween10_swamp', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3650, 3650, '0', 'hween10_pond', 'hween10_pond', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(3651, 3651, '0', 'hween10_jar', 'hween10_jar', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3652, 3652, '0', 'hween10_fog', 'hween10_fog', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3653, 3653, '0', 'hween10_voodoo2', 'hween10_voodoo2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3654, 3654, '0', 'hween10_skullpost', 'hween10_skullpost', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3655, 3655, '0', 'hween10_voodoo3', 'hween10_voodoo3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3656, 3656, '0', 'hween10_logs', 'hween10_logs', 'S', 1, 1, 0.20, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3657, 3657, '0', 'hween10_ffly', 'hween10_ffly', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3658, 3658, '0', 'hween10_chicken', 'hween10_chicken', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'club_gate', 2, '', '', '', 0, 0, ''),
	(3659, 3659, '0', 'hween10_tele', 'hween10_tele', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'teleport', 2, '', '', '', 0, 0, ''),
	(3660, 3660, '0', 'hween10_throne', 'hween10_throne', 'S', 1, 1, 1.30, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3661, 3661, '0', 'hween10_portch', 'hween10_portch', 'S', 1, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 7, '', '', '', 0, 0, ''),
	(3662, 3662, '0', 'hween10_bat', 'hween10_bat', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3663, 3663, '0', 'wf_act_move_rotate', 'wf_act_move_rotate', 'S', 1, 1, 0.65, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'wf_act_move_rotate', 4, '', '', '', 0, 0, ''),
	(3664, 3664, '1', 'wf_wire2', 'wf_wire2', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3665, 3665, '0', 'wf_cnd_time_more_than', 'wf_cnd_time_more_than', 'S', 1, 1, 0.65, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'wf_cnd_time_more_than', 2, '', '', '', 0, 0, ''),
	(3666, 3666, '1', 'wf_colortile', 'wf_colortile', 'S', 1, 1, 0.20, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 7, '', '', '', 0, 0, ''),
	(3667, 3667, '1', 'wf_floor_switch2', 'wf_floor_switch2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'switch', 5, '', '', '', 0, 0, ''),
	(3668, 3668, '0', 'wf_trg_state_changed', 'wf_trg_state_changed', 'S', 1, 1, 0.65, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'wf_trg_state_changed', 4, '', '', '', 0, 0, ''),
	(3669, 3669, '0', 'wf_xtra_random', 'wf_xtra_random', 'S', 1, 1, 0.65, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'wf_xtra_random', 4, '', '', '', 0, 0, ''),
	(3670, 3670, '0', 'wf_xtra_unseen', 'wf_xtra_unseen', 'S', 1, 1, 0.65, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'wf_xtra_unseen', 4, '', '', '', 0, 0, ''),
	(3671, 3671, '0', 'wf_trg_periodically', 'wf_trg_periodically', 'S', 1, 1, 0.65, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'wf_trg_periodically', 4, '', '', '', 0, 0, ''),
	(3672, 3672, '1', 'wf_pyramid', 'wf_pyramid', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'pyramid', 3, '', '', '', 0, 0, ''),
	(3673, 3673, '0', 'wf_trg_score_achieved', 'wf_trg_score_achieved', 'S', 1, 1, 0.65, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'wf_trg_score_achieved', 4, '', '', '', 0, 0, ''),
	(3674, 3674, '0', 'wf_act_teleport_to', 'wf_act_teleport_to', 'S', 1, 1, 0.65, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'wf_act_teleport_to', 1, '', '', '', 0, 0, ''),
	(3675, 3675, '0', 'wf_trg_says_something', 'wf_trg_says_something', 'S', 1, 1, 0.65, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'wf_trg_says_something', 4, '', '', '', 0, 0, ''),
	(3676, 3676, '0', 'wf_colorwheel', 'wf_colorwheel', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'colorwheel', 2, '', '', '', 0, 0, ''),
	(3677, 3677, '1', 'wf_wire4', 'wf_wire4', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3678, 3678, '0', 'wf_trg_walks_off_furni', 'wf_trg_walks_off_furni', 'S', 1, 1, 0.65, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'wf_trg_walks_off_furni', 4, '', '', '', 0, 0, ''),
	(3679, 3679, '0', 'wf_trg_at_given_time', 'wf_trg_at_given_time', 'S', 1, 1, 0.65, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'wf_trg_at_given_time', 4, '', '', '', 0, 0, ''),
	(3680, 3680, '0', 'wf_trg_game_ends', 'wf_trg_game_ends', 'S', 1, 1, 0.65, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'wf_trg_game_ends', 5, '', '', '', 0, 0, ''),
	(3681, 3681, '0', 'wf_act_show_message', 'wf_act_show_message', 'S', 1, 1, 0.65, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'wf_act_show_message', 4, '', '', '', 0, 0, ''),
	(3682, 3682, '0', 'wf_cnd_time_less_than', 'wf_cnd_time_less_than', 'S', 1, 1, 0.65, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'wf_cnd_time_less_than', 2, '', '', '', 0, 0, ''),
	(3683, 3683, '0', 'wf_trg_enter_room', 'wf_trg_enter_room', 'S', 1, 1, 0.65, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'wf_trg_enter_room', 4, '', '', '', 0, 0, ''),
	(3684, 3684, '0', 'ads_hh_safe', 'ads_hh_safe', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '58', '', '', 0, 0, ''),
	(3685, 3685, '0', 'wf_act_toggle_state', 'wf_act_toggle_state', 'S', 1, 1, 0.65, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'wf_act_toggle_state', 4, '', '', '', 0, 0, ''),
	(3686, 3686, '1', 'wf_firegate', 'wf_firegate', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(3687, 3687, '1', 'wf_ringplate', 'wf_ringplate', 'S', 1, 1, 0.20, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'pressureplate', 1, '', '', '', 0, 0, ''),
	(3688, 3688, '1', 'wf_pressureplate', 'wf_pressureplate', 'S', 1, 1, 0.20, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'pressureplate', 1, '', '', '', 0, 0, ''),
	(3689, 3689, '1', 'wf_glowball', 'wf_glowball', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'glowball', 2, '', '', '', 0, 0, ''),
	(3690, 3690, '0', 'bb_lightstrip', 'bb_lightstrip', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3691, 3691, '0', 'wf_act_reset_timers', 'wf_act_reset_timers', 'S', 1, 1, 0.65, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'wf_act_reset_timers', 4, '', '', '', 0, 0, ''),
	(3692, 3692, '0', 'wf_cnd_furnis_hv_avtrs', 'wf_cnd_furnis_hv_avtrs', 'S', 1, 1, 0.65, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'wf_cnd_furnis_hv_avtrs', 2, '', '', '', 0, 0, ''),
	(3693, 3693, '1', 'wf_arrowplate', 'wf_arrowplate', 'S', 1, 1, 0.20, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'pressureplate', 4, '', '', '', 0, 0, ''),
	(3694, 3694, '0', 'wf_cnd_trggrer_on_frn', 'wf_cnd_trggrer_on_frn', 'S', 1, 1, 0.65, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'wf_cnd_trggrer_on_frn', 2, '', '', '', 0, 0, ''),
	(3695, 3695, '0', 'wf_cnd_match_snapshot', 'wf_cnd_match_snapshot', 'S', 1, 1, 0.65, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'wf_cnd_match_snapshot', 2, '', '', '', 0, 0, ''),
	(3696, 3696, '1', 'wf_wire1', 'wf_wire1', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3697, 3697, '0', 'wf_act_give_score', 'wf_act_give_score', 'S', 1, 1, 0.65, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'wf_act_give_score', 5, '', '', '', 0, 0, ''),
	(3698, 3698, '1', 'wf_wire3', 'wf_wire3', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3699, 3699, '1', 'wf_glassdoor', 'wf_glassdoor', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(3700, 3700, '0', 'wf_act_match_to_sshot', 'wf_act_match_to_sshot', 'S', 1, 1, 0.65, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'wf_act_match_to_sshot', 4, '', '', '', 0, 0, ''),
	(3701, 3701, '1', 'wf_floor_switch1', 'wf_floor_switch1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'switch', 2, '', '', '', 0, 0, ''),
	(3702, 3702, '0', 'wf_trg_game_starts', 'wf_trg_game_starts', 'S', 1, 1, 0.65, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'wf_trg_game_starts', 5, '', '', '', 0, 0, ''),
	(3703, 3703, '0', 'wf_trg_walks_on_furni', 'wf_trg_walks_on_furni', 'S', 1, 1, 0.65, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'wf_trg_walks_on_furni', 4, '', '', '', 0, 0, ''),
	(3704, 3704, '1', 'exe_copier', 'exe_copier', 'S', 1, 1, 1.80, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 2, '', '1.9;1.8', '', 0, 0, ''),
	(3705, 3705, '1', 'exe_wrkdesk', 'exe_wrkdesk', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3706, 3706, '1', 'exe_glassdvdr', 'exe_glassdvdr', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3707, 3707, '1', 'exe_seccam', 'exe_seccam', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3708, 3708, '0', 'qt_penguin_icehockey', 'qt_penguin_icehockey', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3709, 3709, '0', 'duck_vip', 'duck_vip', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'crackable_subscription_box', 1, '', '', '', 0, 0, ''),
	(3710, 3710, '0', 'duck_hc', 'duck_hc', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'crackable_subscription_box', 1, '', '', '', 0, 0, ''),
	(3711, 3711, '0', 'qt_penguin_ballet', 'qt_penguin_ballet', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3712, 3712, '0', 'es_bench', 'es_bench', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3713, 3713, '0', 'es_icestar', 'es_icestar', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(3714, 3714, '0', 'es_fnc_2', 'es_fnc_2', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3715, 3715, '0', 'qt_xm10_monkey_lamp', 'qt_xm10_monkey_lamp', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3716, 3716, '0', 'es_sidewalk', 'es_sidewalk', 'S', 2, 2, 0.20, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(3717, 3717, '0', 'es_statue', 'es_statue', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(3718, 3718, '0', 'qt_xm10_iceclubsofa', 'qt_xm10_iceclubsofa', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3719, 3719, '0', 'qt_xm10_xmduck', 'qt_xm10_xmduck', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3720, 3720, '0', 'qt_xm10_palm_tree', 'qt_xm10_palm_tree', 'S', 1, 1, 3.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3721, 3721, '0', 'es_fnc_crnr', 'es_fnc_crnr', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3722, 3722, '0', 'qt_xm10_trex', 'qt_xm10_trex', 'S', 3, 7, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3723, 3723, '0', 'es_epictree', 'es_epictree', 'S', 2, 2, 4.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(3724, 3724, '0', 'qt_xm10_elephant', 'qt_xm10_elephant', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '35', '', '', 0, 0, ''),
	(3725, 3725, '0', 'es_wpost', 'es_wpost', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3726, 3726, '0', 'qt_xm10_gnome', 'qt_xm10_gnome', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3727, 3727, '0', 'qt_xm10_iceduck', 'qt_xm10_iceduck', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3728, 3728, '0', 'qt_xm10_icetiger', 'qt_xm10_icetiger', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3729, 3729, '0', 'es_fnc_1', 'es_fnc_1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3730, 3730, '0', 'qt_xm10_iceplasto', 'qt_xm10_iceplasto', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3731, 3731, '0', 'es_icestar_g', 'es_icestar_g', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(3732, 3732, '0', 'qt_xm10_icelupin', 'qt_xm10_icelupin', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3733, 3733, '0', 'prizetrophy_nrj_2011', 'prizetrophy_nrj_2011', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(3734, 3734, '0', 'qt_xm10_iceteddy', 'qt_xm10_iceteddy', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3735, 3735, '0', 'es_lmppst', 'es_lmppst', 'S', 1, 1, 4.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3736, 3736, '1', 'es_skating_ice', 'es_skating_ice', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'icetag_field', 2, '', '', '', 0, 0, ''),
	(3737, 3737, '0', 'qt_xm10_icepillar', 'qt_xm10_icepillar', 'S', 1, 1, 3.50, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3738, 3738, '0', 'es_roaster', 'es_roaster', 'S', 1, 1, 2.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine_no_sides', 2, '60', '', '', 0, 0, ''),
	(3739, 3739, '1', 'es_puck', 'es_puck', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'football', 2, '', '', '', 0, 0, ''),
	(3740, 3740, '0', 'es_santa', 'es_santa', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3741, 3741, '1', 'es_tagging', 'es_tagging', 'S', 1, 1, 3.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'icetag_pole', 2, '', '', '', 0, 0, ''),
	(3742, 3742, '0', 'qt_xm10_nest', 'qt_xm10_nest', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3743, 3743, '0', 'qt_xm10_icesilotable', 'qt_xm10_icesilotable', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3744, 3744, '0', 'petfood16', 'petfood16', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'pet_food', 5, '', '', '130,10,0', 0, 0, ''),
	(3745, 3745, '0', 'es_icestar_r', 'es_icestar_r', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(3746, 3746, '0', 'qt_xm10_icedragon', 'qt_xm10_icedragon', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3747, 3747, '0', 'qt_xm10_stone', 'qt_xm10_stone', 'S', 1, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3748, 3748, '0', 'qt_xm10_ice_fish', 'qt_xm10_ice_fish', 'S', 1, 2, 3.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3749, 3749, '0', 'es_icestar_y', 'es_icestar_y', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(3750, 3750, '0', 'qt_xm10_bench', 'qt_xm10_bench', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3751, 3751, '0', 'xmas10_surprise', 'xmas10_surprise', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '1', '1', 'furniture_teaser', 1, '', '', '', 0, 0, ''),
	(3752, 3752, '0', 'xmas10_fireplace', 'xmas10_fireplace', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'teleport', 2, '', '', '', 0, 0, 'ha-1006'),
	(3753, 3753, '1', 'es_geysir', 'es_geysir', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'pyramid', 2, '', '', '', 0, 0, ''),
	(3754, 3754, '0', 'xmas10_present', 'xmas10_present', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3755, 3755, '0', 'qt_xm10_iceelephant', 'qt_xm10_iceelephant', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3756, 3756, '0', 'es_score_b', 'es_score_b', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'freeze_counter_blue', 1, '', '', '', 0, 0, ''),
	(3757, 3757, '1', 'es_tile', 'es_tile', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'freeze_tile', 1, '', '', '', 0, 0, ''),
	(3758, 3758, '0', 'es_box', 'es_box', 'S', 1, 1, 0.50, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'freeze_block', 1, '', '', '', 0, 0, ''),
	(3759, 3759, '1', 'es_exit', 'es_exit', 'S', 1, 1, 0.20, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'freeze_exit', 1, '', '', '', 0, 0, ''),
	(3760, 3760, '0', 'es_gate_r', 'es_gate_r', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'freeze_gate_red', 1, '', '', '', 0, 0, ''),
	(3761, 3761, '0', 'es_gate_g', 'es_gate_g', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'freeze_gate_green', 1, '', '', '', 0, 0, ''),
	(3762, 3762, '0', 'es_gate_b', 'es_gate_b', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'freeze_gate_blue', 1, '', '', '', 0, 0, ''),
	(3763, 3763, '0', 'es_gate_y', 'es_gate_y', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'freeze_gate_yellow', 1, '', '', '', 0, 0, ''),
	(3764, 3764, '1', 'es_counter', 'es_counter', 'S', 1, 3, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'game_timer', 1, '', '', '30,60,120,180,300,600', 0, 0, ''),
	(3765, 3765, '0', 'es_score_r', 'es_score_r', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'freeze_counter_red', 1, '', '', '', 0, 0, ''),
	(3766, 3766, '0', 'es_score_g', 'es_score_g', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'freeze_counter_green', 1, '', '', '', 0, 0, ''),
	(3767, 3767, '0', 'es_score_y', 'es_score_y', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'freeze_counter_yellow', 1, '', '', '', 0, 0, ''),
	(3768, 3768, '0', 'year2011_waver_y', 'year2011_waver_y', 'S', 1, 1, 3.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3769, 3769, '0', 'prizetrophy_2011_w', 'prizetrophy_2011_w', 'S', 1, 1, 3.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 2, '', '', '', 0, 0, ''),
	(3770, 3770, '0', 'prizetrophy_2011_r', 'prizetrophy_2011_r', 'S', 1, 1, 3.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 2, '', '', '', 0, 0, ''),
	(3771, 3771, '0', 'prizetrophy_2011_y', 'prizetrophy_2011_y', 'S', 1, 1, 3.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 2, '', '', '', 0, 0, ''),
	(3772, 3772, '0', 'fireworks_01', 'fireworks_01', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'fireworks', 3, '', '', '5000', 0, 0, ''),
	(3773, 3773, '0', 'prizetrophy_2011_b', 'prizetrophy_2011_b', 'S', 1, 1, 3.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 2, '', '', '', 0, 0, ''),
	(3774, 3774, '0', 'fireworks_03', 'fireworks_03', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'fireworks', 3, '', '', '5000', 0, 0, ''),
	(3775, 3775, '0', 'prizetrophy_2011_p', 'prizetrophy_2011_p', 'S', 1, 1, 3.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 2, '', '', '', 0, 0, ''),
	(3776, 3776, '0', 'fireworks_02', 'fireworks_02', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'fireworks', 3, '', '', '5000', 0, 0, ''),
	(3777, 3777, '0', 'year2011_waver_r', 'year2011_waver_r', 'S', 1, 1, 3.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3778, 3778, '0', 'prizetrophy_2011_g', 'prizetrophy_2011_g', 'S', 1, 1, 3.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 2, '', '', '', 0, 0, ''),
	(3779, 3779, '0', 'fireworks_05', 'fireworks_05', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'fireworks', 3, '', '', '5000', 0, 0, ''),
	(3780, 3780, '0', 'year2011_waver_g', 'year2011_waver_g', 'S', 1, 1, 3.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3781, 3781, '0', 'year2011_waver_b', 'year2011_waver_b', 'S', 1, 1, 3.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3782, 3782, '0', 'fireworks_07', 'fireworks_07', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'fireworks', 3, '', '', '10000', 0, 0, ''),
	(3783, 3783, '0', 'fireworks_06', 'fireworks_06', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'fireworks', 3, '', '', '5000', 0, 0, ''),
	(3784, 3784, '0', 'fireworks_04', 'fireworks_04', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'fireworks', 3, '', '', '5000', 0, 0, ''),
	(3785, 3785, '1', 'bling11_statue2', 'bling11_statue2', 'S', 2, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(3786, 3786, '1', 'bling11_slot', 'bling11_slot', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 59, 59, ''),
	(3787, 3787, '1', 'bling11_towels', 'bling11_towels', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3788, 3788, '0', 'bling11_rug1', 'bling11_rug1', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3789, 3789, '0', 'bling11_tele', 'bling11_tele', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'teleport', 2, '', '', '', 0, 0, ''),
	(3790, 3790, '1', 'bling11_sofa', 'bling11_sofa', 'S', 3, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3791, 3791, '0', 'bling11_statue1', 'bling11_statue1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(3792, 3792, '1', 'val11_floor', 'val11_floor', 'S', 2, 2, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'rollerskate_field', 3, '', '', '', 0, 0, ''),
	(3793, 3793, '1', 'bling11_dvd', 'bling11_dvd', 'S', 1, 2, 1.60, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3794, 3794, '1', 'bling11_floor', 'bling11_floor', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 9, '', '', '', 0, 0, ''),
	(3795, 3795, '1', 'bling11_plant', 'bling11_plant', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3796, 3796, '0', 'china_rabbit', 'china_rabbit', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3797, 3797, '1', 'bling11_rug2', 'bling11_rug2', 'S', 3, 3, 0.20, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3798, 3798, '1', 'bling11_dvn', 'bling11_dvn', 'S', 1, 3, 1.20, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(3799, 3799, '1', 'bling11_seat2', 'bling11_seat2', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(3800, 3800, '1', 'bling11_seat1', 'bling11_seat1', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3801, 3801, '1', 'bling11_block', 'bling11_block', 'S', 1, 1, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3802, 3802, '1', 'bling11_pillar', 'bling11_pillar', 'S', 1, 1, 3.30, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3803, 3803, '0', 'qt_val11_holoduck', 'qt_val11_holoduck', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3804, 3804, '0', 'val11_playa', 'val11_playa', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3805, 3805, '0', 'qt_val11_discoball', 'qt_val11_discoball', 'S', 1, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3806, 3806, '0', 'val11_chair', 'val11_chair', 'S', 1, 1, 1.30, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3807, 3807, '0', 'qt_val11_nest', 'qt_val11_nest', 'S', 1, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3808, 3808, '0', 'nest_terrarium', 'nest_terrarium', 'S', 1, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'nest', 1, '', '', '', 0, 0, ''),
	(3809, 3809, '0', 'qt_val11_duckformer', 'qt_val11_duckformer', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3810, 3810, '0', 'qt_val11_jellychair', 'qt_val11_jellychair', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3811, 3811, '0', 'qt_val11_jellyheart', 'qt_val11_jellyheart', 'S', 1, 1, 0.80, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3812, 3812, '0', 'val11_rail', 'val11_rail', 'S', 1, 2, 0.50, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'rollerskate_field', 1, '', '', '', 0, 0, ''),
	(3813, 3813, '0', 'qt_val11_holoheart', 'qt_val11_holoheart', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3814, 3814, '0', 'ads_leaf_teleport', 'ads_leaf_teleport', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'teleport', 2, '', '', '', 0, 0, ''),
	(3815, 3815, '0', 'ads_sunnyvend', 'ads_sunnyvend', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '61', '', '', 0, 0, ''),
	(3816, 3816, '0', 'petfood18', 'petfood18', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'pet_food', 4, '', '', '375,15,0 8,26,30', 0, 0, ''),
	(3817, 3817, '0', 'petfood17', 'petfood17', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'pet_food', 4, '', '', '350,15,0', 0, 0, ''),
	(3819, 3819, '1', 'limo_w_mid', 'limo_w_mid', 'S', 2, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3820, 3820, '1', 'limo_w_mid2', 'limo_w_mid2', 'S', 2, 1, 0.20, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3821, 3821, '0', 'petfood19', 'petfood19', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'pet_food', 4, '', '', '8,26', 0, 0, ''),
	(3822, 3822, '1', 'limo_w_back', 'limo_w_back', 'S', 2, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3823, 3823, '1', 'limo_w_front', 'limo_w_front', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3824, 3824, '1', 'gothic_bed', 'gothic_bed', 'S', 2, 3, 1.90, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 2, '', '', '', 0, 0, ''),
	(3825, 3825, '1', 'gothic_candles', 'gothic_candles', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3826, 3826, '1', 'gothic_desk', 'gothic_desk', 'S', 1, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(3827, 3827, '0', 'ads_grefu_trophy', 'ads_grefu_trophy', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(3828, 3828, '1', 'gothic_bowl', 'gothic_bowl', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine_no_sides', 2, '62', '', '', 0, 0, ''),
	(3830, 3830, '0', 'nest_frog', 'nest_frog', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'nest', 1, '', '', '', 0, 0, ''),
	(3831, 3831, '0', 'pond', 'pond', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3832, 3832, '0', 'val11_present', 'val11_present', 'S', 1, 1, 1.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3833, 3833, '0', 'prizetrophy_cine', 'prizetrophy_cine', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(3834, 3834, '1', 'cine_vipsign', 'cine_vipsign', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3835, 3835, '1', 'limo_b_mid3', 'limo_b_mid3', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine_no_sides', 2, '40', '', '', 0, 0, ''),
	(3836, 3836, '1', 'limo_b_mid2', 'limo_b_mid2', 'S', 2, 1, 0.20, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3837, 3837, '1', 'limo_b_front', 'limo_b_front', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3838, 3838, '1', 'limo_b_mid', 'limo_b_mid', 'S', 2, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3839, 3839, '0', 'cine_star', 'cine_star', 'S', 1, 1, 0.15, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3840, 3840, '1', 'limo_b_back', 'limo_b_back', 'S', 2, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3841, 3841, '1', 'cine_curtain', 'cine_curtain', 'S', 8, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(3842, 3842, '1', 'cine_screen', 'cine_screen', 'S', 6, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 7, '', '', '', 0, 0, ''),
	(3843, 3843, '1', 'theatre_seat_g', 'theatre_seat_g', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 6, '', '', '', 0, 0, ''),
	(3844, 3844, '1', 'cine_tile', 'cine_tile', 'S', 1, 1, 0.15, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'pressureplate', 2, '', '', '', 0, 0, ''),
	(3845, 3845, '1', 'cine_bench_b', 'cine_bench_b', 'S', 3, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3846, 3846, '1', 'theatre_seat_b', 'theatre_seat_b', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 6, '', '', '', 0, 0, ''),
	(3847, 3847, '1', 'cine_roof', 'cine_roof', 'S', 3, 3, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(3848, 3848, '1', 'cine_popcorn', 'cine_popcorn', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine_no_sides', 2, '63', '', '', 0, 0, ''),
	(3849, 3849, '1', 'cine_bench', 'cine_bench', 'S', 3, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3850, 3850, '1', 'cine_bench_g', 'cine_bench_g', 'S', 3, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3851, 3851, '1', 'cine_ticket_booth', 'cine_ticket_booth', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3852, 3852, '1', 'cine_projector', 'cine_projector', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3853, 3853, '0', 'wf_box', 'wf_box', 'S', 1, 1, 1.20, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'puzzle_box', 1, '', '', '', 0, 0, ''),
	(3854, 3854, '0', 'wf_maze', 'wf_maze', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(3855, 3855, '0', 'ads_rangocactus', 'ads_rangocactus', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3856, 3856, '1', 'cine_glass', 'cine_glass', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3857, 3857, '0', 'wf_cnd_has_furni_on', 'wf_cnd_has_furni_on', 'S', 1, 1, 0.65, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'wf_cnd_has_furni_on', 2, '', '', '', 0, 0, ''),
	(3858, 3858, '1', 'cubie_lamp_b', 'cubie_lamp_b', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(3859, 3859, '1', 'cubie_chair_b', 'cubie_chair_b', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3860, 3860, '1', 'cubie_rug_b', 'cubie_rug_b', 'S', 2, 3, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(3861, 3861, '1', 'cubie_bigtable_b', 'cubie_bigtable_b', 'S', 2, 2, 0.50, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3862, 3862, '1', 'cubie_beanbag_p', 'cubie_beanbag_p', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3863, 3863, '1', 'cubie_lamp_p', 'cubie_lamp_p', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(3864, 3864, '1', 'cubie_sofaseat_p', 'cubie_sofaseat_p', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3865, 3865, '1', 'cubie_shelf_0_b', 'cubie_shelf_0_b', 'S', 1, 1, 0.60, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(3866, 3866, '1', 'cubie_shelf_4_p', 'cubie_shelf_4_p', 'S', 3, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 6, '', '', '', 0, 0, ''),
	(3867, 3867, '1', 'cubie_shelf_2_p', 'cubie_shelf_2_p', 'S', 2, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 17, '', '', '', 0, 0, ''),
	(3868, 3868, '1', 'cubie_bed_p', 'cubie_bed_p', 'S', 1, 3, 1.80, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(3869, 3869, '1', 'cubie_stool_b', 'cubie_stool_b', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(3870, 3870, '1', 'cubie_rug_p', 'cubie_rug_p', 'S', 2, 3, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(3871, 3871, '1', 'cubie_bed_b', 'cubie_bed_b', 'S', 1, 3, 1.80, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(3872, 3872, '1', 'cubie_shelf_3_b', 'cubie_shelf_3_b', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 9, '', '', '', 0, 0, ''),
	(3873, 3873, '1', 'cubie_shelf_3_p', 'cubie_shelf_3_p', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 9, '', '', '', 0, 0, ''),
	(3874, 3874, '1', 'cubie_shelf_1_p', 'cubie_shelf_1_p', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 14, '', '', '', 0, 0, ''),
	(3875, 3875, '1', 'cubie_shelf_1_b', 'cubie_shelf_1_b', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 14, '', '', '', 0, 0, ''),
	(3876, 3876, '1', 'cubie_bigtable_p', 'cubie_bigtable_p', 'S', 2, 2, 0.50, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3877, 3877, '1', 'cubie_beanbag_b', 'cubie_beanbag_b', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3878, 3878, '1', 'cubie_stool_p', 'cubie_stool_p', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(3879, 3879, '1', 'cubie_chair_p', 'cubie_chair_p', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3880, 3880, '1', 'cubie_table', 'cubie_table', 'S', 1, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3881, 3881, '1', 'cubie_sofaseat_b', 'cubie_sofaseat_b', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3882, 3882, '1', 'cubie_shelf_4_b', 'cubie_shelf_4_b', 'S', 3, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 6, '', '', '', 0, 0, ''),
	(3883, 3883, '1', 'cubie_shelf_2_b', 'cubie_shelf_2_b', 'S', 2, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 17, '', '', '', 0, 0, ''),
	(3884, 3884, '1', 'cubie_shelf_0_p', 'cubie_shelf_0_p', 'S', 1, 1, 0.60, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(3885, 3885, '0', 'newbie_present', 'newbie_present', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(3886, 3886, '1', 'tv_flat', 'tv_flat', 'S', 2, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3887, 3887, '1', 'waasa_table2', 'waasa_table2', 'S', 2, 1, 1.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3888, 3888, '1', 'computer_flatscreen', 'computer_flatscreen', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(3889, 3889, '1', 'waasa_chair', 'waasa_chair', 'S', 1, 1, 1.40, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3890, 3890, '1', 'waasa_ship2', 'waasa_ship2', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3891, 3891, '1', 'waasa_ship1', 'waasa_ship1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3892, 3892, '1', 'waasa_bunk_bed', 'waasa_bunk_bed', 'S', 3, 1, 3.00, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 2, '', '', '', 0, 0, ''),
	(3893, 3893, '1', 'computer_laptop', 'computer_laptop', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3894, 3894, '1', 'computer_old', 'computer_old', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3895, 3895, '1', 'waasa_table1', 'waasa_table1', 'S', 1, 1, 1.10, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3896, 3896, '1', 'waasa_desk', 'waasa_desk', 'S', 2, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3897, 3897, '0', 'newbie_nest', 'newbie_nest', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3898, 3898, '1', 'waasa_rug5', 'waasa_rug5', 'S', 2, 4, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3899, 3899, '1', 'waasa_rug1', 'waasa_rug1', 'S', 2, 4, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3900, 3900, '1', 'waasa_rug3', 'waasa_rug3', 'S', 2, 4, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3901, 3901, '1', 'waasa_aquarium', 'waasa_aquarium', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3902, 3902, '1', 'waasa_rug4', 'waasa_rug4', 'S', 2, 4, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3903, 3903, '1', 'waasa_chair_wood', 'waasa_chair_wood', 'S', 1, 1, 1.05, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3904, 3904, '1', 'waasa_rug2', 'waasa_rug2', 'S', 2, 4, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3905, 3905, '0', 'jukebox_big', 'jukebox_big', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'jukebox', 1, '', '', '', 0, 0, ''),
	(3906, 3906, '0', 'milkbowl', 'milkbowl', 'S', 1, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 6, '', '', '', 0, 0, ''),
	(3907, 3907, '0', 'petfood21', 'petfood21', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'pet_food', 4, '', '', '100,10,0 1,26,28', 0, 0, ''),
	(3908, 3908, '0', 'easter11_basket', 'easter11_basket', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3909, 3909, '0', 'easter11_grasspatch', 'easter11_grasspatch', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'bunnyrun_field', 2, '', '', '', 0, 0, ''),
	(3910, 3910, '0', 'ads_wowpball', 'ads_wowpball', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3911, 3911, '0', 'pet_food_corn', 'pet_food_corn', 'S', 1, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3912, 3912, '0', 'pet_toy_trampoline', 'pet_toy_trampoline', 'S', 1, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3913, 3913, '0', 'nest_chick', 'nest_chick', 'S', 1, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'nest', 1, '', '', '', 0, 0, ''),
	(3914, 3914, '0', 'easter11_tag', 'easter11_tag', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'bunnyrun_pole', 2, '', '', '', 0, 0, ''),
	(3915, 3915, '0', 'easter11_tuip_g', 'easter11_tuip_g', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3916, 3916, '0', 'easter11_tuip_y', 'easter11_tuip_y', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3917, 3917, '0', 'easter11_mushroom4', 'easter11_mushroom4', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(3918, 3918, '0', 'easter11_mushroom1', 'easter11_mushroom1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3919, 3919, '0', 'kuurna_sofa', 'kuurna_sofa', 'S', 2, 1, 1.30, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3920, 3920, '0', 'easter11_mushroom3', 'easter11_mushroom3', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(3921, 3921, '0', 'easter11_mushroom2', 'easter11_mushroom2', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(3922, 3922, '0', 'kuurna_lamp', 'kuurna_lamp', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3923, 3923, '0', 'kuurna_chair', 'kuurna_chair', 'S', 1, 1, 1.40, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3924, 3924, '0', 'kuurna_mat', 'kuurna_mat', 'S', 3, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3925, 3925, '0', 'kuurna_table1', 'kuurna_table1', 'S', 1, 1, 1.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3926, 3926, '0', 'kuurna_table', 'kuurna_table', 'S', 2, 2, 1.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3927, 3927, '0', 'ads_suun', 'ads_suun', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '18', '', '', 0, 0, ''),
	(3928, 3928, '0', 'kuurna_chair1', 'kuurna_chair1', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3929, 3929, '0', 'easter11_tuip_p', 'easter11_tuip_p', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3930, 3930, '0', 'anna_divider*1', 'anna_divider*1', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3931, 3931, '0', 'anna_divider*2', 'anna_divider*2', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3932, 3932, '0', 'anna_divider*3', 'anna_divider*3', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3933, 3933, '0', 'anna_divider*4', 'anna_divider*4', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3934, 3934, '0', 'anna_divider*5', 'anna_divider*5', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3935, 3935, '1', 'anna_div_gate*1', 'anna_div_gate*1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(3936, 3936, '1', 'anna_div_gate*2', 'anna_div_gate*2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(3937, 3937, '1', 'anna_div_gate*3', 'anna_div_gate*3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(3938, 3938, '1', 'anna_div_gate*4', 'anna_div_gate*4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(3939, 3939, '1', 'anna_div_gate*5', 'anna_div_gate*5', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(3940, 3940, '1', 'anna_chair*1', 'anna_chair*1', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3941, 3941, '1', 'anna_chair*2', 'anna_chair*2', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3942, 3942, '1', 'anna_chair*3', 'anna_chair*3', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3943, 3943, '1', 'anna_chair*4', 'anna_chair*4', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3944, 3944, '1', 'anna_chair*5', 'anna_chair*5', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3945, 3945, '1', 'anna_stool*1', 'anna_stool*1', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3946, 3946, '1', 'anna_stool*2', 'anna_stool*2', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3947, 3947, '1', 'anna_stool*3', 'anna_stool*3', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3948, 3948, '1', 'anna_stool*4', 'anna_stool*4', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3949, 3949, '1', 'anna_stool*5', 'anna_stool*5', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3950, 3950, '1', 'anna_table*1', 'anna_table*1', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3951, 3951, '1', 'anna_table*2', 'anna_table*2', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3952, 3952, '1', 'anna_table*3', 'anna_table*3', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3953, 3953, '1', 'anna_table*4', 'anna_table*4', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3954, 3954, '1', 'anna_table*5', 'anna_table*5', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3955, 3955, '1', 'anna_rug*1', 'anna_rug*1', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(3956, 3956, '1', 'anna_rug*2', 'anna_rug*2', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(3957, 3957, '1', 'anna_rug*3', 'anna_rug*3', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(3958, 3958, '1', 'anna_rug*4', 'anna_rug*4', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(3959, 3959, '1', 'anna_rug*5', 'anna_rug*5', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(3960, 3960, '1', 'anna_sofa*1', 'anna_sofa*1', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(3961, 3961, '1', 'anna_sofa*2', 'anna_sofa*2', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(3962, 3962, '1', 'anna_sofa*3', 'anna_sofa*3', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(3963, 3963, '1', 'anna_sofa*4', 'anna_sofa*4', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(3964, 3964, '1', 'anna_sofa*5', 'anna_sofa*5', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(3965, 3965, '1', 'anna_pill*1', 'anna_pill*1', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3966, 3966, '1', 'anna_pill*2', 'anna_pill*2', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3967, 3967, '1', 'anna_pill*3', 'anna_pill*3', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3968, 3968, '1', 'anna_pill*4', 'anna_pill*4', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3969, 3969, '1', 'anna_pill*5', 'anna_pill*5', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3970, 3970, '1', 'anna_lamp*1', 'anna_lamp*1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3971, 3971, '1', 'anna_lamp*2', 'anna_lamp*2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3972, 3972, '1', 'anna_lamp*3', 'anna_lamp*3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3973, 3973, '1', 'anna_lamp*4', 'anna_lamp*4', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3974, 3974, '1', 'anna_lamp*5', 'anna_lamp*5', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3975, 3975, '1', 'anna_div_crnr*1', 'anna_div_crnr*1', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3976, 3976, '1', 'anna_div_crnr*2', 'anna_div_crnr*2', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3977, 3977, '1', 'anna_div_crnr*3', 'anna_div_crnr*3', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3978, 3978, '1', 'anna_div_crnr*4', 'anna_div_crnr*4', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3979, 3979, '1', 'anna_div_crnr*5', 'anna_div_crnr*5', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3980, 3980, '1', 'picnic_blanket_yel', 'picnic_blanket_yel', 'S', 3, 3, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3981, 3981, '1', 'picnic_pillow_yel', 'picnic_pillow_yel', 'S', 1, 1, 0.70, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3982, 3982, '1', 'picnic_food1', 'picnic_food1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3983, 3983, '0', 'note_tag', 'note_tag', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'sticky_pole', 2, '', '', '', 0, 0, ''),
	(3984, 3984, '1', 'picnic_wfall', 'picnic_wfall', 'S', 2, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3985, 3985, '1', 'picnic_blanket_blu', 'picnic_blanket_blu', 'S', 3, 3, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3986, 3986, '1', 'picnic_food3', 'picnic_food3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3987, 3987, '1', 'picnic_blanket', 'picnic_blanket', 'S', 3, 3, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3988, 3988, '1', 'picnic_pillow_blu', 'picnic_pillow_blu', 'S', 1, 1, 0.70, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3989, 3989, '1', 'picnic_food2', 'picnic_food2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3990, 3990, '0', 'picnic_tele', 'picnic_tele', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'teleport', 1, '', '', '', 0, 0, ''),
	(3991, 3991, '1', 'picnic_basket', 'picnic_basket', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3992, 3992, '1', 'picnic_pillow', 'picnic_pillow', 'S', 1, 1, 0.70, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3993, 3993, '1', 'picnic_chair', 'picnic_chair', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(3994, 3994, '1', 'picnic_3brds', 'picnic_3brds', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3995, 3995, '0', 'petfood23', 'petfood23', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'pet_food', 4, '', '', '375,15,175 12,14,26', 0, 0, ''),
	(3996, 3996, '0', 'ads_background', 'ads_background', 'S', 1, 1, 0.00, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'ads_bg', 2, '', '', '', 0, 0, ''),
	(3997, 3997, '0', 'ads_kelloggs_statue', 'ads_kelloggs_statue', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3998, 3998, '0', 'race_trophy', 'race_trophy', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(3999, 3999, '0', 'ads_kfp2statue', 'ads_kfp2statue', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4000, 4000, '0', 'petfood22', 'petfood22', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'pet_food', 4, '', '', '375,15,688 12,14,26', 0, 0, ''),
	(4001, 4001, '0', 'nest_dragon', 'nest_dragon', 'S', 1, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'nest', 1, '', '', '', 0, 0, ''),
	(4002, 4002, '0', 'ashtree', 'ashtree', 'S', 1, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4003, 4003, '0', 'grail_water', 'grail_water', 'S', 1, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 6, '', '', '', 0, 0, ''),
	(4004, 4004, '0', 'grail_nectar', 'grail_nectar', 'S', 1, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 6, '', '', '', 0, 0, ''),
	(4005, 4005, '1', 'dng_cube', 'dng_cube', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4006, 4006, '1', 'dng_ground', 'dng_ground', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4007, 4007, '1', 'dng_pillar', 'dng_pillar', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4008, 4008, '1', 'dng_treasure2', 'dng_treasure2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(4009, 4009, '1', 'dng_floor', 'dng_floor', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4010, 4010, '1', 'dng_stairs', 'dng_stairs', 'S', 1, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4011, 4011, '1', 'dng_treasure', 'dng_treasure', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4012, 4012, '0', 'dng_throne', 'dng_throne', 'S', 1, 1, 1.70, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4013, 4013, '1', 'dng_block', 'dng_block', 'S', 1, 1, 0.80, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4014, 4014, '0', 'petfood_19', 'petfood_19', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'pet_food', 5, '', '', '1375,20,0 9,26', 0, 0, ''),
	(4015, 4015, '0', 'mm_lamp', 'mm_lamp', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4016, 4016, '0', 'mm_lemon_drink', 'mm_lemon_drink', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '64', '', '', 0, 0, ''),
	(4017, 4017, '0', 'qt_sum11_shell1', 'qt_sum11_shell1', 'S', 1, 1, 0.20, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4018, 4018, '0', 'qt_sum11_ictrolley', 'qt_sum11_ictrolley', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '4', '', '', 0, 0, ''),
	(4019, 4019, '0', 'qt_sum11_petfood', 'qt_sum11_petfood', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'pet_food', 2, '', '', '400,10,0', 0, 0, ''),
	(4020, 4020, '0', 'qt_sum11_shell4', 'qt_sum11_shell4', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4021, 4021, '0', 'qt_sum11_shell3', 'qt_sum11_shell3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4022, 4022, '0', 'qt_sum11_platfrm', 'qt_sum11_platfrm', 'S', 2, 2, 0.80, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4023, 4023, '0', 'qt_sum11_shell2', 'qt_sum11_shell2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4024, 4024, '0', 'qt_sum11_shell5', 'qt_sum11_shell5', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4025, 4025, '0', 'qt_sum11_chair', 'qt_sum11_chair', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4026, 4026, '0', 'mm_tub', 'mm_tub', 'S', 1, 2, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4027, 4027, '0', 'prizetrophy_skate*1', 'prizetrophy_skate*1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(4028, 4028, '0', 'prizetrophy_skate*2', 'prizetrophy_skate*2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(4029, 4029, '0', 'prizetrophy_skate*3', 'prizetrophy_skate*3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(4030, 4030, '1', 'sb_rail', 'sb_rail', 'S', 1, 1, 0.70, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4031, 4031, '1', 'sb_ramp', 'sb_ramp', 'S', 2, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4032, 4032, '1', 'sb_block', 'sb_block', 'S', 2, 2, 0.60, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4033, 4033, '1', 'sb_cans', 'sb_cans', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '1060', '', '', 0, 0, ''),
	(4034, 4034, '1', 'sb_tile', 'sb_tile', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4035, 4035, '0', 'nest_turtle', 'nest_turtle', 'S', 1, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'nest', 1, '', '', '', 0, 0, ''),
	(4036, 4036, '0', 'ads_mpu_720', 'ads_mpu_720', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'ads_bg', 1, '', '', '', 0, 0, ''),
	(4037, 4037, '0', 'petfood24', 'petfood24', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'pet_food', 4, '', '', '375,15,100 9,26,28', 0, 0, ''),
	(4039, 4039, '1', 'coco_stool_c2', 'coco_stool_c2', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4040, 4040, '1', 'coco_divan_c4', 'coco_divan_c4', 'S', 2, 1, 1.40, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4041, 4041, '1', 'coco_throne_c3', 'coco_throne_c3', 'S', 1, 1, 1.50, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4042, 4042, '1', 'coco_chair', 'coco_chair', 'S', 1, 1, 1.30, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4043, 4043, '1', 'coco_throne__c2', 'coco_throne__c2', 'S', 1, 1, 1.50, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4044, 4044, '1', 'coco_stool_c4', 'coco_stool_c4', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4045, 4045, '1', 'coco_patch', 'coco_patch', 'S', 2, 3, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4046, 4046, '1', 'coco_divan_c2', 'coco_divan_c2', 'S', 2, 1, 1.40, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4047, 4047, '1', 'coco_sofatable_c3', 'coco_sofatable_c3', 'S', 1, 1, 1.30, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4048, 4048, '1', 'coco_stool_c3', 'coco_stool_c3', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4049, 4049, '1', 'coco_sofatable_c4', 'coco_sofatable_c4', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4050, 4050, '1', 'coco_sofa_c3', 'coco_sofa_c3', 'S', 3, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4051, 4051, '1', 'coco_table', 'coco_table', 'S', 2, 3, 0.40, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4052, 4052, '1', 'coco_stool', 'coco_stool', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4053, 4053, '1', 'coco_chair_c2', 'coco_chair_c2', 'S', 1, 1, 1.30, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4054, 4054, '1', 'coco_stick', 'coco_stick', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4055, 4055, '1', 'coco_throne', 'coco_throne', 'S', 1, 1, 1.50, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4056, 4056, '1', 'coco_table2', 'coco_table2', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4057, 4057, '1', 'coco_sofa_c2', 'coco_sofa_c2', 'S', 3, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4058, 4058, '1', 'coco_chair_c4', 'coco_chair_c4', 'S', 1, 1, 1.30, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4059, 4059, '1', 'coco_chair_c3', 'coco_chair_c3', 'S', 1, 1, 1.30, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4060, 4060, '1', 'coco_divan', 'coco_divan', 'S', 2, 1, 1.40, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4061, 4061, '1', 'coco_divan_c3', 'coco_divan_c3', 'S', 2, 1, 1.40, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'bed', 2, '', '', '', 0, 0, ''),
	(4062, 4062, '1', 'coco_sofatable', 'coco_sofatable', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4063, 4063, '1', 'coco_sofa_c4', 'coco_sofa_c4', 'S', 3, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4064, 4064, '1', 'coco_sofatable_c2', 'coco_sofatable_c2', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4065, 4065, '1', 'coco_throne_c4', 'coco_throne_c4', 'S', 1, 1, 1.50, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4066, 4066, '1', 'coco_sofa', 'coco_sofa', 'S', 3, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4067, 4067, '1', 'lm_crystal_skull', 'lm_crystal_skull', 'S', 1, 1, 0.20, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4068, 4068, '1', 'lm_bananadrink', 'lm_bananadrink', 'S', 1, 1, 3.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '66', '', '', 0, 0, ''),
	(4069, 4069, '0', 'ads_mpu_300', 'ads_mpu_300', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'ads_bg', 1, '', '', '', 0, 0, ''),
	(4070, 4070, '0', 'petfood25', 'petfood25', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'pet_food', 4, '', '', '375,15,0 14,26,30', 0, 0, ''),
	(4071, 4071, '0', 'hole', 'hole', 'S', 2, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(4073, 4073, '1', 'lm_jackbox', 'lm_jackbox', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4074, 4074, '0', 'ads_durex_vend', 'ads_durex_vend', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4075, 4075, '0', 'ads_durex_carpet', 'ads_durex_carpet', 'S', 3, 3, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4076, 4076, '1', 'lm_pond', 'lm_pond', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4077, 4077, '0', 'nest_with_statue', 'nest_with_statue', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'nest', 1, '', '', '', 0, 0, ''),
	(4078, 4078, '0', 'nest_monkey', 'nest_monkey', 'S', 1, 1, 0.50, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'nest', 1, '', '', '', 0, 0, ''),
	(4079, 4079, '0', 'ads_mtv_floor', 'ads_mtv_floor', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4080, 4080, '1', 'studio_monitor', 'studio_monitor', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4081, 4081, '1', 'studio_stool', 'studio_stool', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4082, 4082, '1', 'studio_fencecr', 'studio_fencecr', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4083, 4083, '1', 'studio_guitar', 'studio_guitar', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4084, 4084, '1', 'studio_amp2', 'studio_amp2', 'S', 2, 1, 2.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4085, 4085, '1', 'studio_fence', 'studio_fence', 'S', 1, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4086, 4086, '1', 'studio_amp1', 'studio_amp1', 'S', 2, 1, 2.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4087, 4087, '1', 'studio_floorlight', 'studio_floorlight', 'S', 4, 4, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(4088, 4088, '1', 'studio_mixingdesk', 'studio_mixingdesk', 'S', 5, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4089, 4089, '1', 'studio_camera', 'studio_camera', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4090, 4090, '1', 'studio_tv', 'studio_tv', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4091, 4091, '1', 'studio_lights3', 'studio_lights3', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4092, 4092, '1', 'studio_lights2', 'studio_lights2', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4093, 4093, '1', 'studio_drums', 'studio_drums', 'S', 3, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4094, 4094, '1', 'studio_lights1', 'studio_lights1', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4095, 4095, '1', 'studio_chair', 'studio_chair', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4096, 4096, '0', 'sound_set_73', 'sound_set_73', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4097, 4097, '0', 'sound_set_74', 'sound_set_74', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4098, 4098, '0', 'sound_set_76', 'sound_set_76', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4099, 4099, '0', 'sound_set_75', 'sound_set_75', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4100, 4100, '0', 'summer_blaster', 'summer_blaster', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'jukebox', 2, '', '', '', 0, 0, ''),
	(4101, 4101, '1', 's12_bonfire', 's12_bonfire', 'S', 2, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4102, 4102, '1', 'lm_bigrock', 'lm_bigrock', 'S', 2, 3, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4103, 4103, '1', 'lm_palm1', 'lm_palm1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4104, 4104, '1', 'lm_totem', 'lm_totem', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(4105, 4105, '0', 'hole2', 'hole2', 'S', 2, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4106, 4106, '1', 'lm_palm2', 'lm_palm2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4107, 4107, '0', 'qt_sum11_dragon', 'qt_sum11_dragon', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4108, 4108, '1', 'usva3_rug', 'usva3_rug', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(4109, 4109, '1', 'usva5_sofa', 'usva5_sofa', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4110, 4110, '1', 'usva4_lamble', 'usva4_lamble', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4111, 4111, '1', 'usva3_shelf', 'usva3_shelf', 'S', 1, 1, 0.75, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(4112, 4112, '1', 'usva_rug', 'usva_rug', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(4113, 4113, '1', 'usva2_table', 'usva2_table', 'S', 2, 2, 0.50, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4114, 4114, '1', 'usva_shelf2', 'usva_shelf2', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(4115, 4115, '1', 'usva4_sofa', 'usva4_sofa', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4116, 4116, '1', 'usva_table', 'usva_table', 'S', 2, 2, 0.50, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4117, 4117, '1', 'usva5_table', 'usva5_table', 'S', 2, 2, 0.50, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4118, 4118, '1', 'usva_lamble', 'usva_lamble', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4119, 4119, '1', 'usva2_sofa', 'usva2_sofa', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4120, 4120, '1', 'usva2_chair', 'usva2_chair', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4121, 4121, '1', 'usva_lamp', 'usva_lamp', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4122, 4122, '1', 'usva2_shelf2', 'usva2_shelf2', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4123, 4123, '1', 'usva_chair', 'usva_chair', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4124, 4124, '1', 'usva5_lamble', 'usva5_lamble', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4125, 4125, '1', 'usva2_lamp', 'usva2_lamp', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4126, 4126, '1', 'usva4_chair', 'usva4_chair', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4127, 4127, '1', 'usva3_shelf2', 'usva3_shelf2', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(4128, 4128, '1', 'usva3_table', 'usva3_table', 'S', 2, 2, 0.50, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4129, 4129, '1', 'usva2_rug', 'usva2_rug', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(4130, 4130, '1', 'usva4_table', 'usva4_table', 'S', 2, 2, 0.50, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4131, 4131, '1', 'usva5_lamp', 'usva5_lamp', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4132, 4132, '1', 'usva3_chair', 'usva3_chair', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4133, 4133, '1', 'usva3_lamble', 'usva3_lamble', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4134, 4134, '1', 'usva_sofa', 'usva_sofa', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4135, 4135, '1', 'usva_shelf', 'usva_shelf', 'S', 1, 1, 0.75, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(4136, 4136, '1', 'usva4_lamp', 'usva4_lamp', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4137, 4137, '1', 'usva2_lamble', 'usva2_lamble', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4138, 4138, '1', 'usva3_lamp', 'usva3_lamp', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4139, 4139, '1', 'usva4_rug', 'usva4_rug', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(4140, 4140, '1', 'usva2_shelf', 'usva2_shelf', 'S', 1, 1, 0.75, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(4141, 4141, '1', 'usva3_sofa', 'usva3_sofa', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4142, 4142, '1', 'usva5_rug', 'usva5_rug', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(4143, 4143, '1', 'usva5_chair', 'usva5_chair', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4144, 4144, '0', 'uservoice_soapbox', 'uservoice_soapbox', 'S', 1, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4145, 4145, '1', 'school_platform', 'school_platform', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 4, '', '0.5;1;1.5;2', '', 0, 0, ''),
	(4146, 4146, '0', 'school_locker_b', 'school_locker_b', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'teleport', 1, '', '', '', 0, 0, ''),
	(4147, 4147, '0', 'school_locker_r_nosale', 'school_locker_r_nosale', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4148, 4148, '1', 'school_toilet_stall', 'school_toilet_stall', 'S', 1, 1, 1.30, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4149, 4149, '1', 'school_stuff_06', 'school_stuff_06', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4150, 4150, '0', 'school_locker_r', 'school_locker_r', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'teleport', 1, '', '', '', 0, 0, ''),
	(4151, 4151, '1', 'school_bus', 'school_bus', 'S', 2, 4, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4152, 4152, '1', 'school_table', 'school_table', 'S', 3, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4153, 4153, '1', 'school_bench', 'school_bench', 'S', 3, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4154, 4154, '1', 'school_console', 'school_console', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4155, 4155, '1', 'school_stuff_01', 'school_stuff_01', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4156, 4156, '1', 'school_stuff_05', 'school_stuff_05', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(4157, 4157, '1', 'school_floor', 'school_floor', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4158, 4158, '0', 'school_locker_b_nosale', 'school_locker_b_nosale', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4159, 4159, '1', 'school_stuff_02', 'school_stuff_02', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4160, 4160, '1', 'school_stuff_04', 'school_stuff_04', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(4161, 4161, '1', 'school_stuff_03', 'school_stuff_03', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(4162, 4162, '1', 'school_chair', 'school_chair', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4163, 4163, '0', 'petfood26', 'petfood26', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'pet_food', 4, '', '', '375,15,0 15,26,35', 0, 0, ''),
	(4164, 4164, '1', 'boutique_floor1a', 'boutique_floor1a', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(4165, 4165, '1', 'boutique_table1', 'boutique_table1', 'S', 1, 1, 1.10, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4166, 4166, '1', 'boutique_clothingpile', 'boutique_clothingpile', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 9, '', '', '', 0, 0, ''),
	(4167, 4167, '1', 'boutique_changing1', 'boutique_changing1', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4168, 4168, '1', 'boutique_changing3', 'boutique_changing3', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4169, 4169, '1', 'boutique_sofa2', 'boutique_sofa2', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4170, 4170, '1', 'boutique_mannequin1', 'boutique_mannequin1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'mannequin', 1, '', '', '', 0, 0, ''),
	(4171, 4171, '1', 'boutique_sofa1', 'boutique_sofa1', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4172, 4172, '1', 'boutique_table2', 'boutique_table2', 'S', 3, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4173, 4173, '1', 'boutique_cashreg', 'boutique_cashreg', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4174, 4174, '1', 'boutique_changing2', 'boutique_changing2', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4175, 4175, '1', 'boutique_plant1', 'boutique_plant1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4176, 4176, '1', 'boutique_plant2', 'boutique_plant2', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4177, 4177, '1', 'boutique_counter', 'boutique_counter', 'S', 2, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4178, 4178, '1', 'boutique_floor2b', 'boutique_floor2b', 'S', 3, 3, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(4179, 4179, '1', 'boutique_floor1b', 'boutique_floor1b', 'S', 3, 3, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(4180, 4180, '1', 'boutique_floor2a', 'boutique_floor2a', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(4181, 4181, '0', 'waterbowl_basic*1', 'waterbowl_basic*1', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'pet_drink', 1, '', '', '', 0, 0, ''),
	(4182, 4182, '0', 'waterbowl_basic*2', 'waterbowl_basic*2', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'pet_drink', 1, '', '', '', 0, 0, ''),
	(4183, 4183, '0', 'waterbowl_basic*3', 'waterbowl_basic*3', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'pet_drink', 1, '', '', '', 0, 0, ''),
	(4184, 4184, '0', 'waterbowl_basic*4', 'waterbowl_basic*4', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'pet_drink', 1, '', '', '', 0, 0, ''),
	(4185, 4185, '0', 'waterbowl_basic*5', 'waterbowl_basic*5', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'pet_drink', 1, '', '', '', 0, 0, ''),
	(4186, 4186, '0', 'boutique_hcsign', 'boutique_hcsign', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4187, 4187, '0', 'boutique_vipsign', 'boutique_vipsign', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4188, 4188, '1', 'bubble_lamp1', 'bubble_lamp1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4189, 4189, '1', 'pura_roundpad8', 'pura_roundpad8', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4190, 4190, '0', 'pura_block_lamp1', 'pura_block_lamp1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4191, 4191, '1', 'pura_roundpad9', 'pura_roundpad9', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4192, 4192, '1', 'eleblock2', 'eleblock2', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '0.01;0.60;0.99;1.80;2.00', '', 0, 0, ''),
	(4193, 4193, '0', 'eleblock4', 'eleblock4', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '0.00;0.50;1.00;1.50;2.00;0.00', '', 0, 0, ''),
	(4194, 4194, '1', 'pura_roundpad6', 'pura_roundpad6', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4195, 4195, '1', 'eleblock7', 'eleblock7', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '0.00;0.50;1.00;1.50;2.00;2.50', '', 0, 0, ''),
	(4196, 4196, '0', 'pura_roundpad3', 'pura_roundpad3', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4197, 4197, '0', 'pura_roundpad4', 'pura_roundpad4', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4198, 4198, '1', 'eleblock5', 'eleblock5', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '0.00;0.50;1.00;1.50;2.00;2.50', '', 0, 0, ''),
	(4199, 4199, '0', 'eleblock3', 'eleblock3', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '0.00;0.50;1.00;1.50;2.00;2.50', '', 0, 0, ''),
	(4200, 4200, '1', 'eleblock1', 'eleblock1', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '0.00;0.50;1.00;1.50;2.00;2.50', '', 0, 0, ''),
	(4201, 4201, '1', 'pura_roundpad1', 'pura_roundpad1', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4202, 4202, '1', 'pura_roundpad2', 'pura_roundpad2', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4203, 4203, '1', 'eleblock8', 'eleblock8', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '0.00;0.50;1.00;1.50;2.00;2.50', '', 0, 0, ''),
	(4204, 4204, '1', 'pura_roundpad5', 'pura_roundpad5', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4205, 4205, '1', 'eleblock9', 'eleblock9', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '0.00;0.50;1.00;1.50;2.00;2.50', '', 0, 0, ''),
	(4206, 4206, '1', 'pura_roundpad7', 'pura_roundpad7', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4207, 4207, '1', 'eleblock6', 'eleblock6', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '0.00;0.50;1.00;1.50;2.00;2.50', '', 0, 0, ''),
	(4208, 4208, '0', 'horse_dye_08', 'horse_dye_08', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4209, 4209, '0', 'horse_hayfloor', 'horse_hayfloor', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4210, 4210, '0', 'horse_dye_11', 'horse_dye_11', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4211, 4211, '0', 'horse_hairdye_06', 'horse_hairdye_06', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4212, 4212, '0', 'horse_dye_02', 'horse_dye_02', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4213, 4213, '0', 'horse_stable_gate', 'horse_stable_gate', 'S', 1, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(4214, 4214, '0', 'horse_hairdye_09', 'horse_hairdye_09', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4215, 4215, '0', 'horse_hairdye_07', 'horse_hairdye_07', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4216, 4216, '0', 'horse_dye_12', 'horse_dye_12', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4217, 4217, '0', 'horse_dye_03', 'horse_dye_03', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4218, 4218, '0', 'horse_dye_05', 'horse_dye_05', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4219, 4219, '0', 'horse_hairdye_11', 'horse_hairdye_11', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4220, 4220, '0', 'horse_hairdye_12', 'horse_hairdye_12', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4221, 4221, '0', 'horse_saddle1', 'horse_saddle1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '15 4 9 0 77', 0, 0, ''),
	(4222, 4222, '0', 'horse_stable_fence_w', 'horse_stable_fence_w', 'S', 1, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4223, 4223, '0', 'horse_stable_gate_w', 'horse_stable_gate_w', 'S', 1, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(4224, 4224, '0', 'horse_dye_04', 'horse_dye_04', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4225, 4225, '0', 'horse_hairdye_10', 'horse_hairdye_10', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4226, 4226, '0', 'horse_hairdye_01', 'horse_hairdye_01', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4227, 4227, '0', 'horse_hairdye_02', 'horse_hairdye_02', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4228, 4228, '0', 'horse_dye_13', 'horse_dye_13', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4229, 4229, '0', 'horse_sawdustfloor', 'horse_sawdustfloor', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4230, 4230, '0', 'horse_hairdye_05', 'horse_hairdye_05', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4231, 4231, '0', 'horse_hairdye_04', 'horse_hairdye_04', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4232, 4232, '0', 'horse_hairdye_00', 'horse_hairdye_00', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4233, 4233, '0', 'horse_stable_fence', 'horse_stable_fence', 'S', 1, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4234, 4234, '0', 'horse_dye_09', 'horse_dye_09', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4235, 4235, '0', 'horse_dye_10', 'horse_dye_10', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4236, 4236, '0', 'horse_stbl_fnc_corn_w', 'horse_stbl_fnc_corn_w', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4237, 4237, '0', 'horse_dye_06', 'horse_dye_06', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4238, 4238, '0', 'horse_hairdye_03', 'horse_hairdye_03', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4239, 4239, '0', 'horse_hay', 'horse_hay', 'S', 1, 1, 0.80, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4240, 4240, '0', 'horse_stbl_fnc_corner', 'horse_stbl_fnc_corner', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4241, 4241, '0', 'horse_dye_07', 'horse_dye_07', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4242, 4242, '0', 'horse_dye_14', 'horse_dye_14', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4243, 4243, '0', 'horse_hairdye_08', 'horse_hairdye_08', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4244, 4244, '0', 'horse_dye_01', 'horse_dye_01', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4245, 4245, '0', 'horse_dye_00', 'horse_dye_00', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4246, 4246, '0', 'horse_poop', 'horse_poop', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(4247, 4247, '0', 'horse_trough', 'horse_trough', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4248, 4248, '0', 'gld_carpet', 'gld_carpet', 'S', 2, 3, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'guild_furni', 11, '', '', '', 0, 0, ''),
	(4249, 4249, '0', 'gld_badgewall_tall', 'gld_badgewall_tall', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'guild_furni', 11, '', '', '', 0, 0, ''),
	(4250, 4250, '0', 'gld_stool2', 'gld_stool2', 'S', 1, 1, 1.60, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'guild_furni', 1, '', '', '', 0, 0, ''),
	(4251, 4251, '0', 'gld_stool1', 'gld_stool1', 'S', 1, 1, 1.60, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'guild_furni', 1, '', '', '', 0, 0, ''),
	(4252, 4252, '0', 'gld_wall_tall', 'gld_wall_tall', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'guild_furni', 11, '', '', '', 0, 0, ''),
	(4253, 4253, '0', 'gld_pennant', 'gld_pennant', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'guild_furni', 11, '', '', '', 0, 0, ''),
	(4254, 4254, '0', 'gld_sofa1', 'gld_sofa1', 'S', 2, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'guild_furni', 1, '', '', '', 0, 0, ''),
	(4255, 4255, '0', 'ads_frank_trophy', 'ads_frank_trophy', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4256, 4256, '0', 'horse_hairstyle_3', 'horse_hairstyle_3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4257, 4257, '0', 'horse_hairstyle_5', 'horse_hairstyle_5', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4258, 4258, '0', 'horse_dye_15', 'horse_dye_15', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4259, 4259, '0', 'horse_hairstyle_1', 'horse_hairstyle_1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4260, 4260, '0', 'horse_hairstyle_0', 'horse_hairstyle_0', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4261, 4261, '0', 'horse_hairstyle_4', 'horse_hairstyle_4', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4262, 4262, '0', 'horse_dye_16', 'horse_dye_16', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4263, 4263, '0', 'horse_hairstyle_2', 'horse_hairstyle_2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4264, 4264, '0', 'prizetrophy_hween11', 'prizetrophy_hween11', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(4265, 4265, '0', 'hween11_disflo2', 'hween11_disflo2', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 6, '', '', '', 0, 0, ''),
	(4266, 4266, '0', 'hween11_punch', 'hween11_punch', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '29,34,58', '', '', 0, 0, ''),
	(4267, 4267, '0', 'hween11_dish2', 'hween11_dish2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4268, 4268, '0', 'hween11_pumpkin', 'hween11_pumpkin', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 6, '', '', '', 0, 0, ''),
	(4269, 4269, '0', 'hween11_sofa', 'hween11_sofa', 'S', 2, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4270, 4270, '0', 'hween11_dish3', 'hween11_dish3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4271, 4271, '0', 'hween11_dish4', 'hween11_dish4', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4272, 4272, '0', 'hween11_disflo', 'hween11_disflo', 'S', 2, 2, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 6, '', '', '', 0, 0, ''),
	(4273, 4273, '0', 'hween11_dish1', 'hween11_dish1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4274, 4274, '1', 'lm_pumpkin', 'lm_pumpkin', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4275, 4275, '0', 'horse_poop_luxus', 'horse_poop_luxus', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(4276, 4276, '0', 'ads_mpu_160', 'ads_mpu_160', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'ads_bg', 1, '', '', '', 0, 0, ''),
	(4277, 4277, '0', 'ads_liisu', 'ads_liisu', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4278, 4278, '0', 'hween11_fountain', 'hween11_fountain', 'S', 2, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4279, 4279, '0', 'plant_rose_black', 'plant_rose_black', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine_no_sides', 2, '1001', '', '', 0, 0, ''),
	(4280, 4280, '0', 'ads_pib', 'ads_pib', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4281, 4281, '0', 'wf_cnd_actor_in_group', 'wf_cnd_actor_in_group', 'S', 1, 1, 0.65, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'wf_cnd_actor_in_group', 2, '', '', '', 0, 0, ''),
	(4282, 4282, '0', 'xmas11_sofatable', 'xmas11_sofatable', 'S', 2, 2, 0.50, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4283, 4283, '0', 'xmas11_comfy_chair', 'xmas11_comfy_chair', 'S', 1, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4284, 4284, '0', 'xmas2011_aurora1', 'xmas2011_aurora1', 'S', 1, 4, 0.50, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4285, 4285, '0', 'xmas11_stonedivider', 'xmas11_stonedivider', 'S', 2, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4286, 4286, '0', 'xmas11_yetifeet', 'xmas11_yetifeet', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4287, 4287, '0', 'xmas2011_tree2', 'xmas2011_tree2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(4288, 4288, '0', 'xmas11_woodfloor', 'xmas11_woodfloor', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4289, 4289, '0', 'xmas11_footstool', 'xmas11_footstool', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4290, 4290, '0', 'xmas11_flag', 'xmas11_flag', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4291, 4291, '0', 'xmas2011_tree1', 'xmas2011_tree1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(4292, 4292, '0', 'xmas11_firewood', 'xmas11_firewood', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(4293, 4293, '0', 'xmas11_stool', 'xmas11_stool', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4294, 4294, '0', 'xmas11_stove', 'xmas11_stove', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4295, 4295, '0', 'xmas2011_snowlog', 'xmas2011_snowlog', 'S', 2, 1, 1.30, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4296, 4296, '0', 'xmas11_stonefloor', 'xmas11_stonefloor', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4297, 4297, '0', 'xmas11_comfy_bench', 'xmas11_comfy_bench', 'S', 2, 1, 1.36, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4298, 4298, '0', 'xmas2011_icefall', 'xmas2011_icefall', 'S', 2, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(4299, 4299, '0', 'xmas11_throne', 'xmas11_throne', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4300, 4300, '0', 'xmas11_petfood', 'xmas11_petfood', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'pet_food', 6, '', '', '400,10,0', 0, 0, ''),
	(4301, 4301, '0', 'xmas2011_aurora2', 'xmas2011_aurora2', 'S', 1, 3, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4302, 4302, '0', 'xmas11_nghtstnd', 'xmas11_nghtstnd', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4303, 4303, '0', 'xmas11_chair', 'xmas11_chair', 'S', 1, 1, 1.35, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4304, 4304, '0', 'xmas2011_rock1', 'xmas2011_rock1', 'S', 1, 1, 0.50, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4305, 4305, '0', 'xmas2011_balrail', 'xmas2011_balrail', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4306, 4306, '0', 'xmas2011_tree4', 'xmas2011_tree4', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4307, 4307, '0', 'xmas2011_rock2', 'xmas2011_rock2', 'S', 1, 1, 0.20, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(4308, 4308, '0', 'xmas2011_tree3', 'xmas2011_tree3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4309, 4309, '0', 'xmas11_elewood', 'xmas11_elewood', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '0.01;0.50;1.00;1.50;2.00', '', 0, 0, ''),
	(4310, 4310, '0', 'horse_hairstyle_6', 'horse_hairstyle_6', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4313, 4313, '0', 'xmas_giftbag', 'xmas_giftbag', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine_no_sides', 2, '1025,1026,1027', '', '', 0, 0, ''),
	(4314, 4314, '0', 'joulutahti_notrd', 'joulutahti_notrd', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '1023', '', '', 0, 0, ''),
	(4315, 4315, '0', 'xmas11_comfy_chair_3', 'xmas11_comfy_chair_3', 'S', 1, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4316, 4316, '0', 'xmas11_stool_2', 'xmas11_stool_2', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4317, 4317, '0', 'xmas11_stool_4', 'xmas11_stool_4', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4318, 4318, '0', 'xmas11_stool_3', 'xmas11_stool_3', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4319, 4319, '0', 'xmas11_footstool_4', 'xmas11_footstool_4', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4320, 4320, '0', 'xmas11_comfy_chair_2', 'xmas11_comfy_chair_2', 'S', 1, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4321, 4321, '0', 'xmas11_chair_2', 'xmas11_chair_2', 'S', 1, 1, 1.35, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4322, 4322, '0', 'xmas11_btlr', 'xmas11_btlr', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'vendingmachine', 2, '15', '', '', 0, 0, ''),
	(4323, 4323, '0', 'xmas11_comfy_bench_2', 'xmas11_comfy_bench_2', 'S', 2, 1, 1.36, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4324, 4324, '0', 'xmas11_comfy_chair_4', 'xmas11_comfy_chair_4', 'S', 1, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4325, 4325, '0', 'xmas11_comfy_bench_4', 'xmas11_comfy_bench_4', 'S', 2, 1, 1.36, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4326, 4326, '0', 'xmas11_chair_4', 'xmas11_chair_4', 'S', 1, 1, 1.35, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4327, 4327, '0', 'xmas11_comfy_bench_3', 'xmas11_comfy_bench_3', 'S', 2, 1, 1.36, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4328, 4328, '0', 'xmas11_chair_3', 'xmas11_chair_3', 'S', 1, 1, 1.35, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4329, 4329, '0', 'xmas11_footstool_2', 'xmas11_footstool_2', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4330, 4330, '0', 'xmas11_footstool_3', 'xmas11_footstool_3', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4331, 4331, '1', 'books_1', 'books_1', 'S', 1, 1, 0.20, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 8, '', '', '', 0, 0, ''),
	(4332, 4332, '1', 'homework', 'homework', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4333, 4333, '1', 'gift_mdlcar0', 'gift_mdlcar0', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4334, 4334, '1', 'gift_manlystatue', 'gift_manlystatue', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4335, 4335, '1', 'gift_joystick', 'gift_joystick', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4336, 4336, '1', 'gift_thing', 'gift_thing', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4337, 4337, '1', 'pstack', 'pstack', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4338, 4338, '1', 'pwad', 'pwad', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(4339, 4339, '1', 'gift_incense', 'gift_incense', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4340, 4340, '1', 'pencils', 'pencils', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(4341, 4341, '1', 'pframe', 'pframe', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(4342, 4342, '1', 'toaster', 'toaster', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine_no_sides', 2, '71', '', '', 0, 0, ''),
	(4343, 4343, '1', 'gift_pbank', 'gift_pbank', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(4344, 4344, '1', 'console', 'console', 'S', 1, 1, 0.50, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4345, 4345, '1', 'gift_vase', 'gift_vase', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4346, 4346, '1', 'gift_mypod', 'gift_mypod', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4347, 4347, '1', 'trapkeep', 'trapkeep', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4348, 4348, '1', 'gift_coal', 'gift_coal', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(4349, 4349, '1', 'gift_handbag0', 'gift_handbag0', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(4350, 4350, '1', 'gift_jewel0', 'gift_jewel0', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4351, 4351, '1', 'books_0', 'books_0', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4352, 4352, '0', 'bed_silo_two_notrd', 'bed_silo_two_notrd', 'S', 2, 3, 1.00, '0', '0', '1', '1', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(4353, 4353, '0', 'snst_ballpile', 'snst_ballpile', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4354, 4354, '0', 'starting_position', 'starting_position', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4355, 4355, '0', 'snst_tree1_d', 'snst_tree1_d', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4356, 4356, '0', 'snst_fence', 'snst_fence', 'S', 1, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4357, 4357, '0', 'Snst_tree1', 'Snst_tree1', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4358, 4358, '0', 'Snst_iceblock', 'Snst_iceblock', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4359, 4359, '0', 'hole1x1', 'hole1x1', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4360, 4360, '0', 'snst_block1', 'snst_block1', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4361, 4361, '0', 'snst_fireplace', 'snst_fireplace', 'S', 3, 3, 1.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4362, 4362, '0', 's_snowball_machine', 's_snowball_machine', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4363, 4363, '0', 'ads_honeymonster', 'ads_honeymonster', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '1028', '', '', 0, 0, ''),
	(4364, 4364, '0', 'ads_m6_floor', 'ads_m6_floor', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4365, 4365, '0', 'duck_vipwhite', 'duck_vipwhite', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'crackable_subscription_box', 1, '', '', '', 0, 0, ''),
	(4366, 4366, '0', 'snst_fireplace_nfs', 'snst_fireplace_nfs', 'S', 3, 3, 1.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4367, 4367, '0', 'vote_count_add', 'vote_count_add', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'vote_counter', 2, '', '', '', 0, 0, ''),
	(4368, 4368, '0', 'xmas11_balloon2', 'xmas11_balloon2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(4369, 4369, '0', 'xmas11_luxfloor2', 'xmas11_luxfloor2', 'S', 2, 2, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4370, 4370, '0', 'xmas11_balloon1', 'xmas11_balloon1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(4371, 4371, '0', 'fireworks_09', 'fireworks_09', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'fireworks', 3, '', '', '5000', 0, 0, ''),
	(4372, 4372, '0', 'xmas11_luxtable', 'xmas11_luxtable', 'S', 1, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4373, 4373, '0', 'fireworks_08', 'fireworks_08', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'fireworks', 3, '', '', '5000', 0, 0, ''),
	(4374, 4374, '0', 'xmas11_luxsofa1', 'xmas11_luxsofa1', 'S', 2, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4375, 4375, '0', 'xmas11_luxfloor1', 'xmas11_luxfloor1', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4376, 4376, '0', 'xmas11_balloon', 'xmas11_balloon', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'vendingmachine_no_sides', 2, '1029', '', '', 0, 0, ''),
	(4377, 4377, '0', 'xmas11_balloon3', 'xmas11_balloon3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(4378, 4378, '0', 'xmas11_luxchair1', 'xmas11_luxchair1', 'S', 1, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4379, 4379, '0', 'xmas11_luxdish2', 'xmas11_luxdish2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(4380, 4380, '0', 'fireworks_10', 'fireworks_10', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'fireworks', 3, '', '', '5000', 0, 0, ''),
	(4381, 4381, '0', 'xmas11_luxsofa2', 'xmas11_luxsofa2', 'S', 2, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4382, 4382, '0', 'xmas11_luxdish3', 'xmas11_luxdish3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(4383, 4383, '0', 'xmas11_luxchair3', 'xmas11_luxchair3', 'S', 1, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4384, 4384, '0', 'fireworks_12', 'fireworks_12', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'fireworks', 3, '', '', '5000', 0, 0, ''),
	(4385, 4385, '0', 'xmas11_luxsofa3', 'xmas11_luxsofa3', 'S', 2, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4386, 4386, '0', 'xmas11_luxchair2', 'xmas11_luxchair2', 'S', 1, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4387, 4387, '0', 'fireworks_11', 'fireworks_11', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'fireworks', 3, '', '', '5000', 0, 0, ''),
	(4388, 4388, '0', 'xmas11_luxdish1', 'xmas11_luxdish1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4389, 4389, '0', 'gld_gate', 'gld_gate', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'guild_gate', 2, '', '', '', 0, 0, ''),
	(4390, 4390, '1', 'snowb_slope', 'snowb_slope', 'S', 2, 2, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 7, '', '0.2;1.3;2.4;3.5;4.6;5.7;6.8', '', 97, 97, ''),
	(4391, 4391, '1', 'snowb_jump', 'snowb_jump', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 97, 97, ''),
	(4392, 4392, '1', 'snowb_light1', 'snowb_light1', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(4393, 4393, '1', 'snowb_divider', 'snowb_divider', 'S', 1, 3, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 97, 97, ''),
	(4394, 4394, '0', 'snowb_snowpuff', 'snowb_snowpuff', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'pressureplate', 2, '', '', '', 0, 0, ''),
	(4395, 4395, '1', 'snowb_rail', 'snowb_rail', 'S', 1, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(4402, 4402, '1', 'sfx_lazer', 'sfx_lazer', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4403, 4403, '1', 'sfx_onetwo', 'sfx_onetwo', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4404, 4404, '1', 'sfx_duck', 'sfx_duck', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4405, 4405, '1', 'sfx_whistle', 'sfx_whistle', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4406, 4406, '1', 'sfx_bells', 'sfx_bells', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'sound_fx', 2, '', '', '', 0, 0, ''),
	(4407, 4407, '1', 'sfx_glass', 'sfx_glass', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4408, 4408, '0', 'prizetrophy_niko2', 'prizetrophy_niko2', 'S', 1, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(4409, 4409, '0', 'prizetrophy_niko1', 'prizetrophy_niko1', 'S', 1, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(4410, 4410, '0', 'china_lantern', 'china_lantern', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4411, 4411, '0', 'fireworks_13', 'fireworks_13', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'fireworks', 3, '', '', '5000', 0, 0, ''),
	(4412, 4412, '0', 'rare_fountain_niko', 'rare_fountain_niko', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4413, 4413, '0', 'teleport_dragon', 'teleport_dragon', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'teleport', 1, '', '', '', 0, 0, ''),
	(4414, 4414, '0', 'sfx_rare_lazer', 'sfx_rare_lazer', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4415, 4415, '0', 'sfx_rare_duck', 'sfx_rare_duck', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4416, 4416, '0', 'val12_kbooth', 'val12_kbooth', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'pressureplate_group', 2, '', '', '', 0, 0, ''),
	(4417, 4417, '0', 'val12_flower', 'val12_flower', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4418, 4418, '0', 'val12_carpet', 'val12_carpet', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4419, 4419, '0', 'val12_vines', 'val12_vines', 'S', 1, 2, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'pressureplate_group', 2, '', '', '', 0, 0, ''),
	(4420, 4420, '0', 'val12_shocker', 'val12_shocker', 'S', 1, 2, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'pressureplate_group', 2, '', '', '', 0, 0, ''),
	(4421, 4421, '0', 'val12_hopper1', 'val12_hopper1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'hopper', 1, '', '', '', 0, 0, ''),
	(4422, 4422, '0', 'val12_pillar2', 'val12_pillar2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(4423, 4423, '0', 'val12_xray', 'val12_xray', 'S', 1, 2, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'pressureplate_group', 2, '', '', '', 0, 0, ''),
	(4424, 4424, '0', 'val12_marble2', 'val12_marble2', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4425, 4425, '0', 'val12_elevine', 'val12_elevine', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '0.00;0.50;1.00;1.50;2.00', '', 0, 0, ''),
	(4426, 4426, '0', 'val12_marble1', 'val12_marble1', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4427, 4427, '0', 'val12_hopper2', 'val12_hopper2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'hopper', 1, '', '', '', 0, 0, ''),
	(4428, 4428, '0', 'edice_val12_therm', 'edice_val12_therm', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'dice', 7, '', '', '', 0, 0, ''),
	(4429, 4429, '0', 'val12_therm_nfs', 'val12_therm_nfs', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4430, 4430, '0', 'val12_sofa', 'val12_sofa', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'pressureplate_group', 2, '', '', '', 0, 0, ''),
	(4431, 4431, '0', 'val12_lantern', 'val12_lantern', 'S', 1, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'pressureplate_group', 2, '', '', '', 0, 0, ''),
	(4432, 4432, '0', 'val12_pillar1', 'val12_pillar1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(4433, 4433, '0', 'val12_table', 'val12_table', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 6, '', '', '', 0, 0, ''),
	(4434, 4434, '0', 'ads_antena3_floor', 'ads_antena3_floor', 'S', 2, 2, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4435, 4435, '0', 'hole3', 'hole3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4436, 4436, '0', 'water_bowl1*1', 'water_bowl1*1', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4437, 4437, '0', 'water_bowl1*2', 'water_bowl1*2', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4438, 4438, '0', 'water_bowl1*3', 'water_bowl1*3', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4439, 4439, '0', 'water_bowl1*4', 'water_bowl1*4', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4440, 4440, '0', 'water_bowl1*5', 'water_bowl1*5', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4441, 4441, '0', 'nest_with_egg', 'nest_with_egg', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4442, 4442, '0', 'present_firework', 'present_firework', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4443, 4443, '0', 'val12_hopper_3', 'val12_hopper_3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'hopper', 1, '', '', '', 0, 0, ''),
	(4444, 4444, '1', 'cine_platform', 'cine_platform', 'S', 4, 1, 0.68, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 3, '', '1.50;2.00;2.50', '', 0, 0, ''),
	(4445, 4445, '0', 'magazines', 'magazines', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4446, 4446, '0', 'desk_junk', 'desk_junk', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(4447, 4447, '0', 'coffee_cup', 'coffee_cup', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4448, 4448, '0', 'bowl', 'bowl', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4449, 4449, '0', 'bookpile', 'bookpile', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4450, 4450, '0', 'horse_saddle2', 'horse_saddle2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4451, 4451, '0', 'horse_fin_flag', 'horse_fin_flag', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4452, 4452, '0', 'horse_track_fence_cor', 'horse_track_fence_cor', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4453, 4453, '0', 'obstacle_oxer', 'obstacle_oxer', 'S', 2, 3, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'obstacle', 1, '', '', '', 0, 0, ''),
	(4454, 4454, '0', 'horse_track1', 'horse_track1', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4455, 4455, '0', 'horse_track_fence', 'horse_track_fence', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4456, 4456, '0', 'elmeri', 'elmeri', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4457, 4457, '0', 'petfood20', 'petfood20', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'pet_food', 4, '', '', '350,15,0', 0, 0, ''),
	(4458, 4458, '0', 'elegrass1', 'elegrass1', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '0.01;0.50;1.00;1.50;2.00', '', 0, 0, ''),
	(4459, 4459, '0', 'elerock1', 'elerock1', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '0.2;0.7;1.2;1.7;2.2', '', 0, 0, ''),
	(4460, 4460, '0', 'bling_sofa_mu', 'bling_sofa_mu', 'S', 2, 1, 1.60, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4461, 4461, '0', 'obstacle_bush', 'obstacle_bush', 'S', 2, 3, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'obstacle', 1, '', '', '', 0, 0, ''),
	(4462, 4462, '0', 'obstacle_fring', 'obstacle_fring', 'S', 2, 3, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'obstacle', 1, '', '', '', 0, 0, ''),
	(4463, 4463, '0', 'horse_fin_poster', 'horse_fin_poster', 'S', 2, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(4464, 4464, '0', 'petfood27', 'petfood27', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'pet_food', 4, '', '', '1375,20,0 15,26,35', 0, 0, ''),
	(4465, 4465, '0', 'horse_hairstyle_7', 'horse_hairstyle_7', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '15 2,3 107,107 1,1', 0, 0, ''),
	(4466, 4466, '0', 'horse_track_gate', 'horse_track_gate', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(4467, 4467, '0', 'horse_fin_poster2', 'horse_fin_poster2', 'S', 2, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(4468, 4468, '0', 'horse_fin_flag2', 'horse_fin_flag2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4469, 4469, '0', 'horse_fin_poster3', 'horse_fin_poster3', 'S', 2, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(4470, 4470, '0', 'horse_hopper', 'horse_hopper', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'hopper', 2, '', '', '', 0, 0, ''),
	(4471, 4471, '0', 'obstacle_water3', 'obstacle_water3', 'S', 2, 3, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'obstacle', 1, '', '', '', 0, 0, ''),
	(4472, 4472, '0', 'obstacle_water', 'obstacle_water', 'S', 2, 3, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'obstacle', 1, '', '', '', 0, 0, ''),
	(4473, 4473, '0', 'obstacle_oxer3', 'obstacle_oxer3', 'S', 2, 3, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'obstacle', 1, '', '', '', 0, 0, ''),
	(4474, 4474, '0', 'obstacle_oxer2', 'obstacle_oxer2', 'S', 2, 3, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'obstacle', 5, '', '', '', 0, 0, ''),
	(4475, 4475, '0', 'horse_fin_flag3', 'horse_fin_flag3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4476, 4476, '0', 'obstacle_water2', 'obstacle_water2', 'S', 2, 3, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'obstacle', 1, '', '', '', 0, 0, ''),
	(4477, 4477, '0', 'horse_hairdye_04_horsesho', 'horse_hairdye_04_horsesho', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(4478, 4478, '0', 'ads_ag_crate', 'ads_ag_crate', 'S', 2, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4479, 4479, '0', 'horse_hairstyle_4_hs', 'horse_hairstyle_4_hs', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '15 2,3 104,104 1,1', 0, 0, ''),
	(4480, 4480, '0', 'petfood7_horseshoe', 'petfood7_horseshoe', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'pet_food', 4, '', '', '750,20,0', 0, 0, ''),
	(4481, 4481, '0', 'bolly_cherry', 'bolly_cherry', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4482, 4482, '1', 'jp_ceiling_lamp', 'jp_ceiling_lamp', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4483, 4483, '1', 'jp_bed', 'jp_bed', 'S', 2, 3, 1.60, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(4484, 4484, '0', 'exe_drinks_cabinet', 'exe_drinks_cabinet', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '40', '', '', 0, 0, ''),
	(4485, 4485, '0', 'cine_curtain_red', 'cine_curtain_red', 'S', 8, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(4486, 4486, '0', 'sf_pod_dark', 'sf_pod_dark', 'S', 1, 3, 1.30, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'pressureplate', 2, '', '', '', 0, 0, ''),
	(4487, 4487, '0', 'dark_merdragon', 'dark_merdragon', 'S', 1, 3, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4488, 4488, '1', 'romantique_divider*5', 'romantique_divider*5', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4489, 4489, '0', 'black_dino_egg', 'black_dino_egg', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4490, 4490, '0', 'CF_500_platinum_bar', 'CF_500_platinum_bar', 'S', 1, 1, 0.40, '1', '0', '0', '0', '0', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4491, 4491, '0', 'theatre_stage', 'theatre_stage', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 6, '', '', '', 0, 0, ''),
	(4492, 4492, '0', 'theatre_mask', 'theatre_mask', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(4493, 4493, '0', 'theatre_carpet', 'theatre_carpet', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4494, 4494, '0', 'theatre_lights', 'theatre_lights', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4495, 4495, '0', 'theatre_rug', 'theatre_rug', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 13, '', '', '', 0, 0, ''),
	(4496, 4496, '0', 'theatre_stool', 'theatre_stool', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4497, 4497, '0', 'theatre_wall', 'theatre_wall', 'S', 1, 4, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4498, 4498, '0', 'theatre_switch', 'theatre_switch', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4499, 4499, '0', 'theatre_chair', 'theatre_chair', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4500, 4500, '0', 'theatre_curtain', 'theatre_curtain', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4501, 4501, '0', 'theatre_floor', 'theatre_floor', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4502, 4502, '0', 'theatre_plant', 'theatre_plant', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4503, 4503, '0', 'theatre_edge', 'theatre_edge', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 8, '', '', '', 0, 0, ''),
	(4504, 4504, '0', 'theatre_spotlight', 'theatre_spotlight', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4505, 4505, '0', 'wf_act_give_reward', 'wf_act_give_reward', 'S', 1, 1, 0.65, '1', '0', '0', '1', '1', '1', '0', '1', '1', 'wf_act_give_reward', 1, '', '', '', 0, 0, ''),
	(4506, 4506, '0', 'petfood28', 'petfood28', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'pet_food', 4, '', '', '', 0, 0, ''),
	(4507, 4507, '0', 'toy2', 'toy2', 'S', 1, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4508, 4508, '0', 'nest_bunny', 'nest_bunny', 'S', 1, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'nest', 1, '', '', '', 0, 0, ''),
	(4509, 4509, '0', 'nest_bunny_green', 'nest_bunny_green', 'S', 1, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'nest', 1, '', '', '', 0, 0, ''),
	(4510, 4510, '0', 'nest_bunny_blue', 'nest_bunny_blue', 'S', 1, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'nest', 1, '', '', '', 0, 0, ''),
	(4511, 4511, '0', 'lido_bench', 'lido_bench', 'S', 2, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4512, 4512, '0', 'lidowall3', 'lidowall3', 'S', 4, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(4513, 4513, '0', 'lido_parasol', 'lido_parasol', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4514, 4514, '0', 'lidowall1', 'lidowall1', 'S', 4, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4515, 4515, '0', 'lidofence', 'lidofence', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4516, 4516, '0', 'lido_chair', 'lido_chair', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4517, 4517, '0', 'lido_kiosk', 'lido_kiosk', 'S', 1, 4, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(4518, 4518, '0', 'lido_table', 'lido_table', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(4519, 4519, '0', 'lidotree1', 'lidotree1', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4520, 4520, '0', 'lidodoor', 'lidodoor', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4521, 4521, '0', 'lidotile', 'lidotile', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4522, 4522, '0', 'lido_kiosk_block', 'lido_kiosk_block', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(4523, 4523, '0', 'lidostairs', 'lidostairs', 'S', 2, 2, 0.60, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4524, 4524, '0', 'lidostage', 'lidostage', 'S', 2, 2, 0.60, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4525, 4525, '0', 'lidowall2', 'lidowall2', 'S', 4, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4526, 4526, '0', 'wl_wall2', 'wl_wall2', 'S', 1, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(4527, 4527, '0', 'wl_table2', 'wl_table2', 'S', 1, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4528, 4528, '0', 'wl_sofa', 'wl_sofa', 'S', 3, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4529, 4529, '0', 'wl_wall1', 'wl_wall1', 'S', 1, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 14, '', '', '', 0, 0, ''),
	(4530, 4530, '0', 'wl_floor', 'wl_floor', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(4531, 4531, '0', 'wl_rdesk', 'wl_rdesk', 'S', 1, 1, 1.30, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 8, '', '', '', 0, 0, ''),
	(4532, 4532, '0', 'wl_shelf', 'wl_shelf', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(4533, 4533, '0', 'wl_chair', 'wl_chair', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4534, 4534, '0', 'wl_table1', 'wl_table1', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(4535, 4535, '0', 'pcnc_tilegrass', 'pcnc_tilegrass', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 11, '', '', '', 0, 0, ''),
	(4536, 4536, '0', 'pcnc_dvdrtile', 'pcnc_dvdrtile', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(4537, 4537, '0', 'pcnc_wtable', 'pcnc_wtable', 'S', 3, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4538, 4538, '0', 'pcnc_shrub', 'pcnc_shrub', 'S', 1, 1, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4539, 4539, '0', 'pcnc_fountain', 'pcnc_fountain', 'S', 4, 4, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4540, 4540, '0', 'pcnc_tiledirt', 'pcnc_tiledirt', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4541, 4541, '0', 'pcnc_gazebohack', 'pcnc_gazebohack', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4542, 4542, '0', 'pcnc_wall1', 'pcnc_wall1', 'S', 3, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4543, 4543, '0', 'pcnc_carp', 'pcnc_carp', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4544, 4544, '0', 'pcnc_door', 'pcnc_door', 'S', 2, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4545, 4545, '0', 'pcnc_wood', 'pcnc_wood', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(4546, 4546, '0', 'pcnc_redbench', 'pcnc_redbench', 'S', 2, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4547, 4547, '0', 'pcnc_wall2', 'pcnc_wall2', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(4548, 4548, '0', 'pcnc_swing', 'pcnc_swing', 'S', 2, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4549, 4549, '0', 'pcnc_bbq', 'pcnc_bbq', 'S', 2, 3, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4550, 4550, '0', 'pcnc_tilestone', 'pcnc_tilestone', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(4551, 4551, '0', 'pcnc_tree', 'pcnc_tree', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4552, 4552, '0', 'pcnc_carrot', 'pcnc_carrot', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '3', '', '', 0, 0, ''),
	(4553, 4553, '0', 'pcnc_gazebo', 'pcnc_gazebo', 'S', 5, 5, 0.30, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4554, 4554, '0', 'pcnc_wbench', 'pcnc_wbench', 'S', 3, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4555, 4555, '0', 'nest_bunny_evil', 'nest_bunny_evil', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'nest', 1, '', '', '', 0, 0, ''),
	(4556, 4556, '0', 'nest_bunny_dep', 'nest_bunny_dep', 'S', 1, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'nest', 1, '', '', '', 0, 0, ''),
	(4557, 4557, '0', 'nest_bunny_love', 'nest_bunny_love', 'S', 1, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'nest', 1, '', '', '', 0, 0, ''),
	(4558, 4558, '0', 'ads_dfrisss', 'ads_dfrisss', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '72', '', '', 0, 0, ''),
	(4559, 4559, '0', 'table_plasto_round_lm1', 'table_plasto_round_lm1', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4560, 4560, '0', 'chair_plasty2', 'chair_plasty2', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4561, 4561, '0', 'table_plasto2_sq', 'table_plasto2_sq', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4562, 4562, '0', 'chair_plasto3', 'chair_plasto3', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4563, 4563, '0', 'table_plasto3_4leg', 'table_plasto3_4leg', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4564, 4564, '0', 'chair_plasty3', 'chair_plasty3', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4565, 4565, '0', 'table_plasto_sq_lm1', 'table_plasto_sq_lm1', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4566, 4566, '0', 'chair_plasty_lm1', 'chair_plasty_lm1', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4567, 4567, '0', 'table_plasto3_bigsq', 'table_plasto3_bigsq', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4568, 4568, '0', 'table_plasto3_sq', 'table_plasto3_sq', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4569, 4569, '0', 'table_plasto_bigsq_lm1', 'table_plasto_bigsq_lm1', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4570, 4570, '0', 'table_plasto2_bigsq', 'table_plasto2_bigsq', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4571, 4571, '0', 'table_plasto2_4leg', 'table_plasto2_4leg', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4572, 4572, '0', 'table_plasto2_round', 'table_plasto2_round', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4573, 4573, '0', 'table_plasto_4leg_lm1', 'table_plasto_4leg_lm1', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4574, 4574, '0', 'chair_plasto2', 'chair_plasto2', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4575, 4575, '0', 'chair_plasto_lm1', 'chair_plasto_lm1', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4576, 4576, '0', 'table_plasto3_round', 'table_plasto3_round', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4577, 4577, '0', 'easel_5', 'easel_5', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4578, 4578, '0', 'mnstr_revival', 'mnstr_revival', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '16', 0, 0, ''),
	(4579, 4579, '1', 'gh_div_wall', 'gh_div_wall', 'S', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(4580, 4580, '1', 'watering_can', 'watering_can', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4581, 4581, '1', 'gh_div_cor', 'gh_div_cor', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(4582, 4582, '0', 'mnstr_seed', 'mnstr_seed', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'monsterplant_seed', 2, '', '', '', 0, 0, ''),
	(4583, 4583, '1', 'gardening_box', 'gardening_box', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4584, 4584, '1', 'stone_platform', 'stone_platform', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 3, '', '0;0.5;1', '', 0, 0, ''),
	(4585, 4585, '1', 'stone_stairs', 'stone_stairs', 'S', 2, 1, 0.40, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4586, 4586, '0', 'chair_plasty4', 'chair_plasty4', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4587, 4587, '0', 'table_plasto4_4leg', 'table_plasto4_4leg', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4588, 4588, '0', 'table_plasto4_sq', 'table_plasto4_sq', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4589, 4589, '0', 'table_plasto4_bigsq', 'table_plasto4_bigsq', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4590, 4590, '0', 'chair_plasto4', 'chair_plasto4', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4591, 4591, '0', 'table_plasto4_round', 'table_plasto4_round', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4592, 4592, '0', 'mnstr_rebreed', 'mnstr_rebreed', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4593, 4593, '0', 'mnstr_fert', 'mnstr_fert', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '16', 0, 0, ''),
	(4594, 4594, '0', 'dragonlamp_shinobi', 'dragonlamp_shinobi', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(4595, 4595, '1', 'jp_divider', 'jp_divider', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4596, 4596, '1', 'jp_gate', 'jp_gate', 'S', 1, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4597, 4597, '0', 'prizetrophy_breed*1', 'prizetrophy_breed*1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(4598, 4598, '0', 'prizetrophy_breed*2', 'prizetrophy_breed*2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(4599, 4599, '0', 'prizetrophy_breed*3', 'prizetrophy_breed*3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(4600, 4600, '0', 'prizetrophy_nurture*1', 'prizetrophy_nurture*1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(4601, 4601, '0', 'prizetrophy_nurture*2', 'prizetrophy_nurture*2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(4602, 4602, '0', 'prizetrophy_nurture*3', 'prizetrophy_nurture*3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(4603, 4603, '1', 'stone_flowerbed', 'stone_flowerbed', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4604, 4604, '0', 'mnstr_seed_rare', 'mnstr_seed_rare', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'monsterplant_seed', 2, '', '', '', 0, 0, ''),
	(4605, 4605, '0', 'ads_mad3', 'ads_mad3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4606, 4606, '0', 'mnstr_waterfall', 'mnstr_waterfall', 'S', 2, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4607, 4607, '0', 'mnstr_rebreed_2', 'mnstr_rebreed_2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4608, 4608, '0', 'mnstr_rebreed_3', 'mnstr_rebreed_3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4609, 4609, '0', 'garden_caterpillar', 'garden_caterpillar', 'S', 3, 1, 1.00, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4610, 4610, '0', 'ads_cp_trophy', 'ads_cp_trophy', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4611, 4611, '0', 'ads_ontour', 'ads_ontour', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4612, 4612, '0', 'CF_75_ruby_small', 'CF_75_ruby_small', 'S', 1, 1, 1.00, '0', '0', '0', '0', '0', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4613, 4613, '0', 'CF_200_ruby', 'CF_200_ruby', 'S', 1, 1, 0.90, '1', '0', '0', '0', '0', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4614, 4614, '0', 'prizetrophy_habboway', 'prizetrophy_habboway', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(4615, 4615, '0', 'patch_cloud', 'patch_cloud', 'S', 2, 2, 0.30, '1', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4616, 4616, '0', 'garden_bfly', 'garden_bfly', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4617, 4617, '0', 'kuurna_red_sofa', 'kuurna_red_sofa', 'S', 2, 1, 1.30, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4618, 4618, '0', 'kuurna_red_chair', 'kuurna_red_chair', 'S', 1, 1, 1.40, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4619, 4619, '0', 'kuurna_red_chair1', 'kuurna_red_chair1', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4620, 4620, '0', 'kuurna_red_table', 'kuurna_red_table', 'S', 2, 2, 1.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4621, 4621, '0', 'kuurna_red_table1', 'kuurna_red_table1', 'S', 1, 1, 1.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4622, 4622, '0', 'kuurna_red_lamp', 'kuurna_red_lamp', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4623, 4623, '0', 'pixel_memorial', 'pixel_memorial', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4624, 4624, '0', 'trophy_torch', 'trophy_torch', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4625, 4625, '0', 'js_exe_chair', 'js_exe_chair', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4626, 4626, '0', 'js_exe_gate', 'js_exe_gate', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(4627, 4627, '0', 'js_exe_bardesk', 'js_exe_bardesk', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4628, 4628, '0', 'js_exe_sofa', 'js_exe_sofa', 'S', 3, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4629, 4629, '0', 'js_exe_corner', 'js_exe_corner', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4630, 4630, '0', 'js_exe_rug', 'js_exe_rug', 'S', 3, 3, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4631, 4631, '0', 'js_exe_chair2', 'js_exe_chair2', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4632, 4632, '0', 'js_exe_s_table', 'js_exe_s_table', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4633, 4633, '0', 'anc_pharaoh_tele', 'anc_pharaoh_tele', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'teleport', 1, '', '', '', 0, 0, ''),
	(4634, 4634, '0', 'anc_artifact1', 'anc_artifact1', 'S', 2, 3, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4635, 4635, '1', 'anc_trophy_obsidian', 'anc_trophy_obsidian', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4636, 4636, '1', 'anc_pyramid_block', 'anc_pyramid_block', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(4637, 4637, '1', 'anc_trophy_marble', 'anc_trophy_marble', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4638, 4638, '1', 'anc_trophy_sstone', 'anc_trophy_sstone', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4639, 4639, '1', 'anc_hot_sands', 'anc_hot_sands', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(4640, 4640, '0', 'sp_statue', 'sp_statue', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4641, 4641, '0', 'prizetrophy_frank', 'prizetrophy_frank', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(4642, 4642, '1', 'anc_ele_rock', 'anc_ele_rock', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '0.2;0.7;1.2;1.7;2.2', '', 0, 0, ''),
	(4643, 4643, '1', 'shallow', 'shallow', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 30, 30, ''),
	(4644, 4644, '1', 'anc_ele_grass', 'anc_ele_grass', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '0.01;0.60;0.99;1.80;2.00', '', 0, 0, ''),
	(4645, 4645, '1', 'anc_sun', 'anc_sun', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4646, 4646, '1', 'pink_flamingo', 'pink_flamingo', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4647, 4647, '1', 'anc_bones', 'anc_bones', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(4648, 4648, '0', 'anc_artifact2', 'anc_artifact2', 'S', 2, 2, 2.50, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4649, 4649, '1', 'anc_jngl_patch', 'anc_jngl_patch', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(4650, 4650, '1', 'anc_talltree', 'anc_talltree', 'S', 2, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4651, 4651, '1', 'anc_waterfall', 'anc_waterfall', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4652, 4652, '1', 'anc_mossyrock', 'anc_mossyrock', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(4653, 4653, '1', 'anc_comfy_tree', 'anc_comfy_tree', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4654, 4654, '0', 'gate_of_eternity', 'gate_of_eternity', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'teleport', 2, '', '', '', 0, 0, ''),
	(4655, 4655, '0', 'anc_artifact3', 'anc_artifact3', 'S', 3, 1, 1.50, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(4656, 4656, '1', 'track12_circle', 'track12_circle', 'S', 3, 3, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(4657, 4657, '1', 'track12_hurdle', 'track12_hurdle', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4658, 4658, '1', 'track12_ele_podium2', 'track12_ele_podium2', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 3, '', '0.7;1.2;1.7', '', 0, 0, ''),
	(4659, 4659, '1', 'track12_tea_mother', 'track12_tea_mother', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'vendingmachine', 2, '10', '', '', 0, 0, ''),
	(4660, 4660, '1', 'track12_hammer', 'track12_hammer', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(4661, 4661, '1', 'track12_mini_torch', 'track12_mini_torch', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine_no_sides', 2, '1031', '', '', 0, 0, ''),
	(4662, 4662, '0', 'track12_ele_podium1', 'track12_ele_podium1', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 3, '', '0.7;1.2;1.7', '', 0, 0, ''),
	(4663, 4663, '0', 'track12_ujack_sofa', 'track12_ujack_sofa', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4664, 4664, '1', 'track12_weight', 'track12_weight', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4665, 4665, '0', 'prizetrophy_track12*1', 'prizetrophy_track12*1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 111, 111, ''),
	(4666, 4666, '0', 'prizetrophy_track12*2', 'prizetrophy_track12*2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 110, 110, ''),
	(4667, 4667, '0', 'prizetrophy_track12*3', 'prizetrophy_track12*3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 109, 109, ''),
	(4668, 4668, '0', 'track12_javstatue', 'track12_javstatue', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4669, 4669, '0', 'track12_hcauldron', 'track12_hcauldron', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(4670, 4670, '0', 'lon_block2', 'lon_block2', 'S', 1, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(4671, 4671, '0', 'lon_base', 'lon_base', 'S', 1, 2, 3.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4672, 4672, '0', 'lon_window', 'lon_window', 'S', 1, 2, 3.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4673, 4673, '0', 'lon_gate', 'lon_gate', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(4674, 4674, '0', 'lon_roof', 'lon_roof', 'S', 1, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4675, 4675, '0', 'lon_block1', 'lon_block1', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4676, 4676, '0', 'hof_parameter_test', 'hof_parameter_test', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4677, 4677, '0', 'matic_walkway_red', 'matic_walkway_red', 'S', 1, 1, 4.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4678, 4678, '0', 'matic_tree_green', 'matic_tree_green', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4679, 4679, '0', 'matic_walkway_silver', 'matic_walkway_silver', 'S', 1, 1, 4.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4680, 4680, '0', 'matic_cont_duck', 'matic_cont_duck', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4681, 4681, '0', 'matic_tree_blue', 'matic_tree_blue', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4682, 4682, '0', 'matic_tree_silver', 'matic_tree_silver', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4683, 4683, '0', 'matic_cont_frank', 'matic_cont_frank', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4684, 4684, '0', 'matic_cont_alien', 'matic_cont_alien', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4685, 4685, '0', 'matic_tree_yellow', 'matic_tree_yellow', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4686, 4686, '0', 'matic_probe', 'matic_probe', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4687, 4687, '0', 'matic_walkway_green', 'matic_walkway_green', 'S', 1, 1, 4.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4688, 4688, '0', 'matic_tree_red', 'matic_tree_red', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4689, 4689, '0', 'matic_walkway_blue', 'matic_walkway_blue', 'S', 1, 1, 4.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4690, 4690, '0', 'matic_walkway_yellow', 'matic_walkway_yellow', 'S', 1, 1, 4.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4691, 4691, '0', 'ads_spiderman_trophy', 'ads_spiderman_trophy', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4692, 4692, '0', 'matic_box', 'matic_box', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4693, 4693, '0', 'matic_wirerig', 'matic_wirerig', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4694, 4694, '0', 'matic_dispenser', 'matic_dispenser', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '1,3,28,29,34,36,37,38,39,58,70,71,1013,1014,1015,1019,1029,1031,1032,1033,1034,1035,1036,1037,1038,1051', '', '', 0, 0, ''),
	(4695, 4695, '0', 'matic_mech', 'matic_mech', 'S', 1, 1, 2.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4696, 4696, '0', 'ads_mad3_edit', 'ads_mad3_edit', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4697, 4697, '0', 'roombg_color', 'roombg_color', 'S', 1, 1, 0.45, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'background_toner', 2, '', '', '', 0, 0, ''),
	(4698, 4698, '0', 'roombg_mountains1', 'roombg_mountains1', 'S', 1, 1, 0.45, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4699, 4699, '0', 'roombg_cloud_dark', 'roombg_cloud_dark', 'S', 1, 1, 0.45, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4700, 4700, '0', 'roombg_cloud', 'roombg_cloud', 'S', 1, 1, 0.45, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4701, 4701, '0', 'cloud_egg', 'cloud_egg', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4702, 4702, '0', 'cloud_throne', 'cloud_throne', 'S', 1, 1, 2.30, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4703, 4703, '0', 'jetset_yacht_front', 'jetset_yacht_front', 'S', 3, 3, 3.10, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4704, 4704, '0', 'js_jetski', 'js_jetski', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4705, 4705, '0', 'vip_gate', 'vip_gate', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(4706, 4706, '0', 'jetset_yacht_mid_1', 'jetset_yacht_mid_1', 'S', 3, 1, 4.45, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4707, 4707, '1', 'jetset_landhigh', 'jetset_landhigh', 'S', 1, 1, 2.50, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4708, 4708, '1', 'jetset_landlow', 'jetset_landlow', 'S', 1, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4709, 4709, '0', 'jetset_yacht_back', 'jetset_yacht_back', 'S', 3, 3, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4710, 4710, '0', 'jetset_yacht_mid_2', 'jetset_yacht_mid_2', 'S', 3, 1, 3.10, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4711, 4711, '0', 'jetset_vipscreen', 'jetset_vipscreen', 'S', 1, 3, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4712, 4712, '0', 'jetset_yacht_mid_3', 'jetset_yacht_mid_3', 'S', 3, 1, 3.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4713, 4713, '1', 'js_jetski2', 'js_jetski2', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4714, 4714, '1', 'jetset_tent', 'jetset_tent', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'tent', 2, '', '', '', 0, 0, ''),
	(4715, 4715, '1', 'jetset_stonejetty', 'jetset_stonejetty', 'S', 1, 2, 0.20, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4716, 4716, '0', 'vip_hopper', 'vip_hopper', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'club_hopper', 1, '', '', '', 0, 0, ''),
	(4717, 4717, '0', 'prizetrophy_room_1', 'prizetrophy_room_1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(4718, 4718, '1', 'js_bouncer', 'js_bouncer', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4719, 4719, '0', 'jetset_vault_wall', 'jetset_vault_wall', 'S', 2, 1, 4.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4720, 4720, '0', 'jetset_vault_crnr', 'jetset_vault_crnr', 'S', 1, 1, 4.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4721, 4721, '1', 'jetset_moneypatch', 'jetset_moneypatch', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4722, 4722, '0', 'jetset_vault_door', 'jetset_vault_door', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(4723, 4723, '0', 'diamond_dragon', 'diamond_dragon', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(4724, 4724, '0', 'diamond_throne', 'diamond_throne', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4725, 4725, '0', 'roombg_jetset', 'roombg_jetset', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4726, 4726, '0', 'jetset_vipscreencr', 'jetset_vipscreencr', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4727, 4727, '0', 'jetset_tub', 'jetset_tub', 'S', 1, 2, 1.00, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4728, 4728, '0', 'js_coins', 'js_coins', 'S', 1, 1, 0.20, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'pressureplate', 2, '', '', '', 0, 0, ''),
	(4729, 4729, '0', 'hween12_cart', 'hween12_cart', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4730, 4730, '0', 'hween12_entry', 'hween12_entry', 'S', 1, 2, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4731, 4731, '0', 'hween12_track', 'hween12_track', 'S', 1, 1, 0.20, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'roller', 1, '', '', '', 0, 0, ''),
	(4732, 4732, '0', 'hween12_orb', 'hween12_orb', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4733, 4733, '0', 'hween12_scarecrow', 'hween12_scarecrow', 'S', 1, 1, 2.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4734, 4734, '0', 'roombg_hween12', 'roombg_hween12', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4735, 4735, '0', 'hween12_costume_hopper', 'hween12_costume_hopper', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'costume_hoppper', 2, '', '', '', 0, 0, ''),
	(4736, 4736, '0', 'hween12_track_crl', 'hween12_track_crl', 'S', 1, 1, 0.20, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'roller', 4, '', '', '', 0, 0, ''),
	(4737, 4737, '0', 'hween12_shedskin', 'hween12_shedskin', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(4738, 4738, '0', 'hween12_guillotine', 'hween12_guillotine', 'S', 1, 3, 1.60, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 2, '', '', '', 0, 0, ''),
	(4739, 4739, '0', 'hween12_track_crr', 'hween12_track_crr', 'S', 1, 1, 0.20, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'roller', 1, '', '', '', 0, 0, ''),
	(4740, 4740, '0', 'hween12_moon', 'hween12_moon', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(4741, 4741, '0', 'hween12_coffin', 'hween12_coffin', 'S', 1, 2, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(4742, 4742, '0', 'hween12_lantern', 'hween12_lantern', 'S', 1, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4743, 4743, '0', 'hween12_mirror', 'hween12_mirror', 'S', 1, 1, 0.20, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'pressureplate', 3, '', '', '', 0, 0, ''),
	(4744, 4744, '0', 'cannon', 'cannon', 'S', 1, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'cannon', 2, '', '', '', 0, 0, ''),
	(4745, 4745, '0', 'hween12_duck', 'hween12_duck', 'S', 1, 1, 2.05, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4746, 4746, '0', 'hween12_floor', 'hween12_floor', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4747, 4747, '0', 'hween12_wall', 'hween12_wall', 'S', 1, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4748, 4748, '0', 'costume_gate', 'costume_gate', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(4749, 4749, '0', 'hween12_fortune', 'hween12_fortune', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4750, 4750, '0', 'hween12_cage', 'hween12_cage', 'S', 1, 1, 0.10, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4751, 4751, '0', 'hween12_grabby', 'hween12_grabby', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '1035,1037,1038,1039,1040,1041,1042,1044,1045', '', '', 0, 0, ''),
	(4752, 4752, '0', 'hween12_wolf', 'hween12_wolf', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4753, 4753, '0', 'hween12_strengthtest', 'hween12_strengthtest', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'crackable_master', 2, '', '', '', 0, 0, ''),
	(4754, 4754, '1', 'hs_stage_blue', 'hs_stage_blue', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 3, '', '0.8;1.5;2.1', '', 0, 0, ''),
	(4755, 4755, '1', 'hs_smoke', 'hs_smoke', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(4756, 4756, '1', 'hs_carpet', 'hs_carpet', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4757, 4757, '1', 'hs_circstage', 'hs_circstage', 'S', 2, 2, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(4758, 4758, '1', 'hs_stage_black', 'hs_stage_black', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 3, '', '0.8;1.5;2.1', '', 0, 0, ''),
	(4759, 4759, '1', 'hs_stage_pink', 'hs_stage_pink', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 3, '', '0.8;1.5;2.1', '', 0, 0, ''),
	(4760, 4760, '1', 'hs_prop', 'hs_prop', 'S', 2, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4761, 4761, '1', 'hs_dnctile_1', 'hs_dnctile_1', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'pressureplate', 2, '', '', '', 140, 140, ''),
	(4762, 4762, '1', 'hs_lightstrip_pink', 'hs_lightstrip_pink', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(4763, 4763, '1', 'hs_stage_long_black', 'hs_stage_long_black', 'S', 3, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 3, '', '0.8;1.5;2.1', '', 0, 0, ''),
	(4764, 4764, '1', 'hs_carpet_blk', 'hs_carpet_blk', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4765, 4765, '1', 'hs_stage_long_blue', 'hs_stage_long_blue', 'S', 3, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 3, '', '0.8;1.5;2.1', '', 0, 0, ''),
	(4766, 4766, '1', 'hs_stairs_pink', 'hs_stairs_pink', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 3, '', '0.5;1.2;1.8', '', 0, 0, ''),
	(4767, 4767, '1', 'hs_stage_long_pink', 'hs_stage_long_pink', 'S', 3, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 3, '', '0.8;1.5;2.1', '', 0, 0, ''),
	(4768, 4768, '0', 'hs_bpass', 'hs_bpass', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(4769, 4769, '1', 'hs_stairs_blue', 'hs_stairs_blue', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 3, '', '0.5;1.2;1.8', '', 0, 0, ''),
	(4770, 4770, '1', 'hs_stairs_black', 'hs_stairs_black', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 3, '', '0.5;1.2;1.8', '', 0, 0, ''),
	(4771, 4771, '1', 'hs_lightstrip_blue', 'hs_lightstrip_blue', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(4772, 4772, '1', 'hs_marswalk', 'hs_marswalk', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'floor_switch', 2, '', '', '', 136, 136, ''),
	(4773, 4773, '1', 'hs_balcony', 'hs_balcony', 'S', 1, 1, 2.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(4774, 4774, '0', 'hs_box', 'hs_box', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4775, 4775, '1', 'hs_chair', 'hs_chair', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4776, 4776, '1', 'sfx_xylo', 'sfx_xylo', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4777, 4777, '1', 'sfx_dubstep3_2', 'sfx_dubstep3_2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4778, 4778, '1', 'sfx_dubstep3', 'sfx_dubstep3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4779, 4779, '1', 'sfx_xylo_high', 'sfx_xylo_high', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4780, 4780, '0', 'sfx_bigfinish_jamesbrown', 'sfx_bigfinish_jamesbrown', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4781, 4781, '1', 'sfx_funkhorn', 'sfx_funkhorn', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4782, 4782, '1', 'sfx_dubstep1', 'sfx_dubstep1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4783, 4783, '1', 'sfx_xylo2', 'sfx_xylo2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4784, 4784, '1', 'sfx_dubstep2', 'sfx_dubstep2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4785, 4785, '1', 'sfx_highhatintro', 'sfx_highhatintro', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4786, 4786, '0', 'sfx_jamesbrown_hey', 'sfx_jamesbrown_hey', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4787, 4787, '1', 'sfx_drumloop', 'sfx_drumloop', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4788, 4788, '1', 'sfx_pad3', 'sfx_pad3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4789, 4789, '1', 'sfx_xylopattern', 'sfx_xylopattern', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4790, 4790, '1', 'sfx_pad1', 'sfx_pad1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4791, 4791, '1', 'sfx_pad2', 'sfx_pad2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4792, 4792, '0', 'sound_set_77', 'sound_set_77', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4793, 4793, '0', 'sound_set_78', 'sound_set_78', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4794, 4794, '0', 'dia_uplink', 'dia_uplink', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'hopper', 2, '', '', '', 0, 0, ''),
	(4795, 4795, '0', 'dia_podium', 'dia_podium', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4796, 4796, '0', 'pet_breeding_bear', 'pet_breeding_bear', 'S', 1, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4797, 4797, '0', 'mystery_box', 'mystery_box', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4798, 4798, '1', 'sfx_strange_echoes_2', 'sfx_strange_echoes_2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4799, 4799, '1', 'sfx_bass1', 'sfx_bass1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4800, 4800, '1', 'sfx_sqrpad_dbldotted', 'sfx_sqrpad_dbldotted', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4801, 4801, '1', 'sfx_bass_dbl', 'sfx_bass_dbl', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4802, 4802, '1', 'sfx_strange_echoes_1', 'sfx_strange_echoes_1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4803, 4803, '1', 'sfx_strange_echoes_3', 'sfx_strange_echoes_3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4804, 4804, '0', 'xmas12_floortile', 'xmas12_floortile', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4805, 4805, '0', 'xmas12_bardesk', 'xmas12_bardesk', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4806, 4806, '0', 'xmas12_pork', 'xmas12_pork', 'S', 1, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(4807, 4807, '0', 'xmas12_nutcracker', 'xmas12_nutcracker', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '60', '', '', 0, 0, ''),
	(4808, 4808, '0', 'xmas12_table', 'xmas12_table', 'S', 2, 2, 1.50, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(4809, 4809, '0', 'xmas12_santathrone', 'xmas12_santathrone', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4810, 4810, '0', 'xmas12_npole', 'xmas12_npole', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4811, 4811, '0', 'xmas12_chair', 'xmas12_chair', 'S', 1, 1, 1.21, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4812, 4812, '0', 'xmas12_fireplace', 'xmas12_fireplace', 'S', 1, 3, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4813, 4813, '0', 'xmas12_pillar2', 'xmas12_pillar2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(4814, 4814, '0', 'xmas12_barrel', 'xmas12_barrel', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '73', '', '', 0, 0, ''),
	(4815, 4815, '0', 'xmas12_pillar1', 'xmas12_pillar1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(4816, 4816, '0', 'xmas12_pillar3', 'xmas12_pillar3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(4817, 4817, '0', 'xmas12_snack', 'xmas12_snack', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(4818, 4818, '0', 'xmas12_floortile2', 'xmas12_floortile2', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4819, 4819, '0', 'xmas12_cfloor', 'xmas12_cfloor', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(4820, 4820, '0', 'xmas12_worktable', 'xmas12_worktable', 'S', 1, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(4821, 4821, '0', 'xmas12_cfloorbig', 'xmas12_cfloorbig', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(4822, 4822, '0', 'roombg_aurora', 'roombg_aurora', 'S', 1, 1, 0.50, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4823, 4823, '0', 'pet_toy_ball', 'pet_toy_ball', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(4824, 4824, '0', 'pet_waterbottle', 'pet_waterbottle', 'S', 1, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4825, 4825, '0', 'pet_breeding_terrier', 'pet_breeding_terrier', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'breeding_nest', 2, '', '', '', 0, 0, ''),
	(4826, 4826, '0', 'pet_blanket_pink', 'pet_blanket_pink', 'S', 1, 1, 0.20, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4827, 4827, '0', 'pet_basket_blue', 'pet_basket_blue', 'S', 1, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4828, 4828, '0', 'pet_basket_pink', 'pet_basket_pink', 'S', 1, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4829, 4829, '0', 'pet_blanket_blue', 'pet_blanket_blue', 'S', 1, 1, 0.20, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4830, 4830, '0', 'mnstr_compost', 'mnstr_compost', 'S', 1, 1, 0.20, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 8, '', '', '', 0, 0, ''),
	(4831, 4831, '0', 'ny2013_res', 'ny2013_res', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'achievement_resolution', 1, '', '', '', 0, 0, ''),
	(4832, 4832, '0', 'ny2013_extrares', 'ny2013_extrares', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'achievement_resolution', 1, '', '', '', 0, 0, ''),
	(4833, 4833, '0', 'holo_dragon', 'holo_dragon', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4834, 4834, '0', 'wf_act_call_stacks', 'wf_act_call_stacks', 'S', 1, 1, 0.65, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'wf_act_call_stacks', 1, '', '', '', 0, 0, ''),
	(4835, 4835, '0', 'fireworks_15', 'fireworks_15', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'fireworks', 3, '', '', '5000', 0, 0, ''),
	(4836, 4836, '1', 'ny2013_chair', 'ny2013_chair', 'S', 1, 1, 1.40, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4837, 4837, '0', 'reef_aquarium', 'reef_aquarium', 'S', 4, 4, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4838, 4838, '1', 'ny2013_calendar', 'ny2013_calendar', 'S', 1, 1, 1.70, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4839, 4839, '1', 'ny2013_block', 'ny2013_block', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(4840, 4840, '0', 'fireworks_14', 'fireworks_14', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'fireworks', 3, '', '', '5000', 0, 0, ''),
	(4841, 4841, '1', 'ny2013_aftermath', 'ny2013_aftermath', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4842, 4842, '1', 'ny2013_floor', 'ny2013_floor', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(4843, 4843, '1', 'ny2013_clock', 'ny2013_clock', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4844, 4844, '1', 'ny2013_cup', 'ny2013_cup', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4845, 4845, '0', 'hc_roundchair', 'hc_roundchair', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4846, 4846, '0', 'hc_bigvase', 'hc_bigvase', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4847, 4847, '0', 'hc_knight_1', 'hc_knight_1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4848, 4848, '0', 'hc_roundtable', 'hc_roundtable', 'S', 1, 1, 0.90, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4849, 4849, '0', 'hc_cab', 'hc_cab', 'S', 1, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4850, 4850, '0', 'hc_radio', 'hc_radio', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4851, 4851, '0', 'hc_luggage', 'hc_luggage', 'S', 1, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(4852, 4852, '0', 'rare_dragonlamp_pink', 'rare_dragonlamp_pink', 'S', 1, 1, 2.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4853, 4853, '0', 'pillow_silver', 'pillow_silver', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4854, 4854, '0', 'pillow_bronze', 'pillow_bronze', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4855, 4855, '0', 'prizetrophy_cake*1', 'prizetrophy_cake*1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(4856, 4856, '0', 'prizetrophy_cake*2', 'prizetrophy_cake*2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(4857, 4857, '0', 'prizetrophy_cake*3', 'prizetrophy_cake*3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(4858, 4858, '0', 'china_snake', 'china_snake', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4859, 4859, '0', 'rare_icecream*10', 'rare_icecream*10', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'vendingmachine', 2, '4', '', '', 0, 0, ''),
	(4860, 4860, '0', 'val13_build_3', 'val13_build_3', 'S', 1, 2, 0.40, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'wateritem', 2, '', '', '', 0, 0, ''),
	(4861, 4861, '0', 'val13_gond_post', 'val13_gond_post', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4862, 4862, '0', 'val13_gond_mid1', 'val13_gond_mid1', 'S', 2, 1, 0.40, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4863, 4863, '0', 'val13_water', 'val13_water', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(4864, 4864, '0', 'val13_div_2', 'val13_div_2', 'S', 1, 1, 0.80, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4865, 4865, '0', 'val13_gond_front', 'val13_gond_front', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4866, 4866, '0', 'val13_build_1', 'val13_build_1', 'S', 2, 3, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4867, 4867, '0', 'val13_build_2', 'val13_build_2', 'S', 1, 2, 1.60, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 6, '', '', '', 0, 0, ''),
	(4868, 4868, '0', 'val13_gond_back', 'val13_gond_back', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4869, 4869, '0', 'val13_gond_mid2', 'val13_gond_mid2', 'S', 2, 1, 1.40, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4870, 4870, '0', 'val13_div_1', 'val13_div_1', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4871, 4871, '1', 'pixel_plantred', 'pixel_plantred', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4872, 4872, '1', 'pixel_plantpink', 'pixel_plantpink', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4873, 4873, '1', 'pixel_light_red', 'pixel_light_red', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4874, 4874, '1', 'pixel_plantblue', 'pixel_plantblue', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4875, 4875, '1', 'pixel_plantgreen', 'pixel_plantgreen', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4876, 4876, '1', 'pixel_light_green', 'pixel_light_green', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4877, 4877, '1', 'pixel_light_pink', 'pixel_light_pink', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4878, 4878, '0', 'pixel_plantblack', 'pixel_plantblack', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4879, 4879, '1', 'pixel_light_blue', 'pixel_light_blue', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4880, 4880, '1', 'pixel_carpet_red', 'pixel_carpet_red', 'S', 2, 3, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4881, 4881, '1', 'pixel_carpet_blue', 'pixel_carpet_blue', 'S', 2, 3, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4882, 4882, '1', 'pixel_carpet_pink', 'pixel_carpet_pink', 'S', 2, 3, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4883, 4883, '0', 'pixel_light_black', 'pixel_light_black', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4884, 4884, '0', 'pixel_carpet_black', 'pixel_carpet_black', 'S', 2, 3, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4885, 4885, '0', 'valentines_lovelock', 'valentines_lovelock', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'love_lock', 2, '', '', '', 0, 0, ''),
	(4886, 4886, '1', 'pixel_bed_blue', 'pixel_bed_blue', 'S', 2, 3, 1.70, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(4887, 4887, '1', 'pixel_smalltable_blue', 'pixel_smalltable_blue', 'S', 1, 1, 1.30, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(4888, 4888, '1', 'pixel_smalltable_red', 'pixel_smalltable_red', 'S', 1, 1, 1.30, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(4889, 4889, '1', 'pixel_smalltable_pink', 'pixel_smalltable_pink', 'S', 1, 1, 1.30, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(4890, 4890, '0', 'pixel_smalltable_black', 'pixel_smalltable_black', 'S', 1, 1, 1.30, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(4891, 4891, '1', 'pixel_smalltable_green', 'pixel_smalltable_green', 'S', 1, 1, 1.30, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(4892, 4892, '0', 'valentines_lovelock9', 'valentines_lovelock9', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'love_lock', 3, '', '', '', 0, 0, ''),
	(4893, 4893, '1', 'pixel_table_red', 'pixel_table_red', 'S', 2, 2, 1.30, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(4894, 4894, '1', 'pixel_chair_blue', 'pixel_chair_blue', 'S', 1, 1, 1.50, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(4895, 4895, '1', 'pixel_floor_pink', 'pixel_floor_pink', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(4896, 4896, '1', 'pixel_floor_brown', 'pixel_floor_brown', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(4897, 4897, '1', 'pixel_floor_yellow', 'pixel_floor_yellow', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(4898, 4898, '1', 'pixel_bed_red', 'pixel_bed_red', 'S', 2, 3, 1.70, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(4899, 4899, '1', 'pixel_chair_green', 'pixel_chair_green', 'S', 1, 1, 1.50, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(4900, 4900, '0', 'pixel_table_black', 'pixel_table_black', 'S', 2, 2, 1.30, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(4901, 4901, '0', 'pixel_bed_black', 'pixel_bed_black', 'S', 2, 3, 1.70, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(4902, 4902, '1', 'pixel_table_blue', 'pixel_table_blue', 'S', 2, 2, 1.30, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(4903, 4903, '1', 'pixel_floor_green', 'pixel_floor_green', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(4904, 4904, '1', 'pixel_floor_silver', 'pixel_floor_silver', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(4905, 4905, '1', 'pixel_table_pink', 'pixel_table_pink', 'S', 2, 2, 1.30, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(4906, 4906, '1', 'pixel_chair_pink', 'pixel_chair_pink', 'S', 1, 1, 1.50, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(4907, 4907, '1', 'pixel_table_green', 'pixel_table_green', 'S', 2, 2, 1.30, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(4908, 4908, '1', 'pixel_bed_pink', 'pixel_bed_pink', 'S', 2, 3, 1.70, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(4909, 4909, '1', 'pixel_bed_green', 'pixel_bed_green', 'S', 2, 3, 1.70, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(4910, 4910, '1', 'pixel_chair_red', 'pixel_chair_red', 'S', 1, 1, 1.50, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(4911, 4911, '0', 'pixel_chair_black', 'pixel_chair_black', 'S', 1, 1, 1.50, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(4912, 4912, '1', 'pixel_floor_blue', 'pixel_floor_blue', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(4913, 4913, '0', 'valentines_lovelock8', 'valentines_lovelock8', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'love_lock', 1, '', '', '', 0, 0, ''),
	(4914, 4914, '0', 'valentines_lovelock7', 'valentines_lovelock7', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'love_lock', 1, '', '', '', 0, 0, ''),
	(4915, 4915, '0', 'valentines_lovelock3', 'valentines_lovelock3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'love_lock', 1, '', '', '', 0, 0, ''),
	(4916, 4916, '0', 'valentines_lovelock4', 'valentines_lovelock4', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'love_lock', 1, '', '', '', 0, 0, ''),
	(4917, 4917, '0', 'valentines_lovelock6', 'valentines_lovelock6', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'love_lock', 1, '', '', '', 0, 0, ''),
	(4918, 4918, '0', 'valentines_lovelock5', 'valentines_lovelock5', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'love_lock', 1, '', '', '', 0, 0, ''),
	(4919, 4919, '0', 'valentines_lovelock2', 'valentines_lovelock2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'love_lock', 1, '', '', '', 0, 0, ''),
	(4920, 4920, '0', 'valentines_lovelock10', 'valentines_lovelock10', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'love_lock', 1, '', '', '', 0, 0, ''),
	(4921, 4921, '0', 'val13_div_3', 'val13_div_3', 'S', 1, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4922, 4922, '0', 'val13_archway', 'val13_archway', 'S', 1, 2, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4923, 4923, '0', 'val13_grass', 'val13_grass', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4924, 4924, '0', 'val13_pillar', 'val13_pillar', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4925, 4925, '0', 'val13_floor1', 'val13_floor1', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 9, '', '', '', 0, 0, ''),
	(4926, 4926, '0', 'val13_gazebo', 'val13_gazebo', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4927, 4927, '0', 'val13_div_3_crnr', 'val13_div_3_crnr', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4928, 4928, '0', 'val13_roses', 'val13_roses', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4929, 4929, '0', 'val13_table', 'val13_table', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4930, 4930, '0', 'val13_lamp', 'val13_lamp', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4931, 4931, '0', 'val13_flower', 'val13_flower', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4932, 4932, '0', 'val13_div_3_crnr2', 'val13_div_3_crnr2', 'S', 1, 1, 1.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4933, 4933, '0', 'val13_light', 'val13_light', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4934, 4934, '0', 'val13_chair', 'val13_chair', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4935, 4935, '0', 'val13_shrub_circ', 'val13_shrub_circ', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4936, 4936, '0', 'val13_shrub_duck', 'val13_shrub_duck', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4937, 4937, '1', 'pixel_carpet_green', 'pixel_carpet_green', 'S', 2, 3, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4938, 4938, '0', 'pixel_couch_blue', 'pixel_couch_blue', 'S', 2, 1, 1.30, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4939, 4939, '0', 'val13_easel_4', 'val13_easel_4', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '1051', '', '', 0, 0, ''),
	(4940, 4940, '0', 'val13_easel_3', 'val13_easel_3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '1051', '', '', 0, 0, ''),
	(4941, 4941, '0', 'val13_easel_1', 'val13_easel_1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '1051', '', '', 0, 0, ''),
	(4942, 4942, '0', 'val13_easel_2', 'val13_easel_2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '1051', '', '', 0, 0, ''),
	(4943, 4943, '0', 'val13_easel_5', 'val13_easel_5', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '1051', '', '', 0, 0, ''),
	(4944, 4944, '0', 'val13_statue', 'val13_statue', 'S', 2, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4945, 4945, '0', 'CF_120_sapphire_small', 'CF_120_sapphire_small', 'S', 1, 1, 1.00, '0', '0', '0', '0', '0', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4946, 4946, '0', 'CF_240_sapphire', 'CF_240_sapphire', 'S', 1, 1, 1.00, '1', '0', '0', '0', '0', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4947, 4947, '0', 'wf_act_kick_user', 'wf_act_kick_user', 'S', 1, 1, 0.65, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'wf_act_kick_user', 1, '', '', '', 0, 0, ''),
	(4948, 4948, '1', 'steampunk_table_1', 'steampunk_table_1', 'S', 1, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4949, 4949, '1', 'steampunk_pillar_1', 'steampunk_pillar_1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4950, 4950, '1', 'steampunk_rack', 'steampunk_rack', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4951, 4951, '1', 'steampunk_pillar_2', 'steampunk_pillar_2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(4952, 4952, '1', 'steampunk_chand', 'steampunk_chand', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 6, '', '', '', 0, 0, ''),
	(4953, 4953, '1', 'steampunk_floor1', 'steampunk_floor1', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 6, '', '', '', 0, 0, ''),
	(4954, 4954, '1', 'steampunk_sofachair', 'steampunk_sofachair', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4955, 4955, '1', 'steampunk_chair', 'steampunk_chair', 'S', 1, 1, 1.40, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4956, 4956, '0', 'steampunk_tele', 'steampunk_tele', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'teleport', 1, '', '', '', 0, 0, ''),
	(4957, 4957, '1', 'steampunk_table_2', 'steampunk_table_2', 'S', 2, 2, 1.40, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4958, 4958, '1', 'steampunk_gear_1', 'steampunk_gear_1', 'S', 1, 1, 0.40, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(4959, 4959, '1', 'steampunk_arch', 'steampunk_arch', 'S', 1, 3, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(4960, 4960, '1', 'steampunk_lamp', 'steampunk_lamp', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(4961, 4961, '1', 'steampunk_computer', 'steampunk_computer', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(4962, 4962, '1', 'steampunk_floor2', 'steampunk_floor2', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4963, 4963, '1', 'steampunk_globe', 'steampunk_globe', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4964, 4964, '1', 'steampunk_gear_2', 'steampunk_gear_2', 'S', 1, 1, 0.20, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(4965, 4965, '1', 'steampunk_carpet', 'steampunk_carpet', 'S', 3, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4966, 4966, '0', 'steampunk_gramophone', 'steampunk_gramophone', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4967, 4967, '0', 'steampunk_timemach', 'steampunk_timemach', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4968, 4968, '0', 'steampunk_zep', 'steampunk_zep', 'S', 2, 2, 8.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4969, 4969, '0', 'horse_hairdye_17', 'horse_hairdye_17', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4970, 4970, '0', 'horse_dye_17', 'horse_dye_17', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4971, 4971, '0', 'horse_hairdye_15', 'horse_hairdye_15', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4972, 4972, '0', 'horse_hairdye_14', 'horse_hairdye_14', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4973, 4973, '0', 'horse_hairdye_13', 'horse_hairdye_13', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4974, 4974, '0', 'horse_hairdye_16', 'horse_hairdye_16', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4975, 4975, '0', 'easter13_flower_2', 'easter13_flower_2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4976, 4976, '0', 'easter13_flower_1', 'easter13_flower_1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4977, 4977, '0', 'easter13_arch', 'easter13_arch', 'S', 2, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(4978, 4978, '0', 'easter13_floor_1', 'easter13_floor_1', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(4979, 4979, '0', 'easter13_teleport', 'easter13_teleport', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'teleport', 1, '', '', '', 0, 0, ''),
	(4980, 4980, '0', 'easter13_bulbs', 'easter13_bulbs', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(4981, 4981, '0', 'easter13_stage_1', 'easter13_stage_1', 'S', 1, 1, 0.65, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 10, '', '', '', 0, 0, ''),
	(4982, 4982, '0', 'easter13_sshrooms', 'easter13_sshrooms', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(4983, 4983, '0', 'easter13_stage_2', 'easter13_stage_2', 'S', 1, 2, 0.30, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4984, 4984, '0', 'easter13_flower_3', 'easter13_flower_3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4985, 4985, '0', 'petfood29', 'petfood29', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'pet_food', 4, '', '', '', 0, 0, ''),
	(4986, 4986, '0', 'easter13_egg_0', 'easter13_egg_0', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'crackable', 1000, '', '', '', 0, 0, ''),
	(4987, 4987, '0', 'easter13_egg_3', 'easter13_egg_3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'crackable', 20000, '', '', '', 0, 0, ''),
	(4988, 4988, '0', 'easter13_egg_1', 'easter13_egg_1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'crackable', 5000, '', '', '', 0, 0, ''),
	(4989, 4989, '0', 'easter13_egg_2', 'easter13_egg_2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '0', '1', 'crackable', 10000, '', '', '', 0, 0, ''),
	(4990, 4990, '0', 'table_silo_med*10', 'table_silo_med*10', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'badge_display', 1, '', '', '', 0, 0, ''),
	(4991, 4991, '0', 'sofa_silo*10', 'sofa_silo*10', 'S', 1, 2, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4992, 4992, '0', 'safe_silo*10', 'safe_silo*10', 'S', 1, 1, 1.30, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '17', '', '', 0, 0, ''),
	(4993, 4993, '0', 'sofachair_silo*10', 'sofachair_silo*10', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4994, 4994, '0', 'divider_silo3*10', 'divider_silo3*10', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(4995, 4995, '0', 'chair_silo*10', 'chair_silo*10', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4996, 4996, '0', 'barchair_silo*10', 'barchair_silo*10', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4997, 4997, '0', 'divider_silo1*10', 'divider_silo1*10', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4998, 4998, '0', 'table_silo_small*10', 'table_silo_small*10', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(4999, 4999, '0', 'easter13_globe', 'easter13_globe', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5000, 5000, '0', 'easter13_stonefrank', 'easter13_stonefrank', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(5001, 5001, '0', 'duck_scuba', 'duck_scuba', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5002, 5002, '0', 'duck_afro', 'duck_afro', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5003, 5003, '0', 'duck_frank', 'duck_frank', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5004, 5004, '0', 'penguin_frank', 'penguin_frank', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5005, 5005, '0', 'penguin_tribal', 'penguin_tribal', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5006, 5006, '0', 'easter13_stonehead', 'easter13_stonehead', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(5007, 5007, '0', 'duck_zombie', 'duck_zombie', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5008, 5008, '0', 'penguin_wip', 'penguin_wip', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5009, 5009, '0', 'easter13_sub', 'easter13_sub', 'S', 7, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(5010, 5010, '0', 'penguin_skele', 'penguin_skele', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5011, 5011, '0', 'easter13_dinoegg', 'easter13_dinoegg', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5012, 5012, '0', 'easter13_chair', 'easter13_chair', 'S', 1, 1, 1.30, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(5013, 5013, '0', 'badge_display2', 'badge_display2', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'badge_display', 1, '', '', '', 0, 0, ''),
	(5014, 5014, '0', 'badge_display', 'badge_display', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'badge_display', 1, '', '', '', 0, 0, ''),
	(5015, 5015, '0', 'badge_display4', 'badge_display4', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'badge_display', 1, '', '', '', 0, 0, ''),
	(5016, 5016, '0', 'badge_display3', 'badge_display3', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'badge_display', 1, '', '', '', 0, 0, ''),
	(5017, 5017, '0', 'badge_display5', 'badge_display5', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'badge_display', 1, '', '', '', 0, 0, ''),
	(5018, 5018, '0', 'exe_icecream', 'exe_icecream', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '4', '', '', 0, 0, ''),
	(5019, 5019, '0', 'prizetrophy_hockey*1', 'prizetrophy_hockey*1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(5020, 5020, '0', 'prizetrophy_hockey*2', 'prizetrophy_hockey*2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(5021, 5021, '0', 'prizetrophy_hockey*3', 'prizetrophy_hockey*3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(5022, 5022, '0', 'prizetrophy_football*1', 'prizetrophy_football*1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(5023, 5023, '0', 'prizetrophy_football*2', 'prizetrophy_football*2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(5024, 5024, '0', 'prizetrophy_football*3', 'prizetrophy_football*3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(5025, 5025, '0', 'prizetrophy_freeze*1', 'prizetrophy_freeze*1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(5026, 5026, '0', 'prizetrophy_freeze*2', 'prizetrophy_freeze*2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(5027, 5027, '0', 'prizetrophy_freeze*3', 'prizetrophy_freeze*3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(5028, 5028, '0', 'prizetrophy_bb*1', 'prizetrophy_bb*1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(5029, 5029, '0', 'prizetrophy_bb*2', 'prizetrophy_bb*2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(5030, 5030, '0', 'prizetrophy_bb*3', 'prizetrophy_bb*3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(5031, 5031, '0', 'prizetrophy_snow*1', 'prizetrophy_snow*1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(5032, 5032, '0', 'prizetrophy_snow*2', 'prizetrophy_snow*2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(5033, 5033, '0', 'prizetrophy_snow*3', 'prizetrophy_snow*3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(5034, 5034, '0', 'prizetrophy_roller*1', 'prizetrophy_roller*1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(5035, 5035, '0', 'prizetrophy_roller*2', 'prizetrophy_roller*2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(5036, 5036, '0', 'prizetrophy_roller*3', 'prizetrophy_roller*3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(5037, 5037, '0', 'gld_hangflag2', 'gld_hangflag2', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'guild_furni', 1, '', '', '', 0, 0, ''),
	(5038, 5038, '0', 'gld_tile2', 'gld_tile2', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'guild_furni', 4, '', '', '', 0, 0, ''),
	(5039, 5039, '0', 'gld_hangflag1', 'gld_hangflag1', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'guild_furni', 1, '', '', '', 0, 0, ''),
	(5040, 5040, '0', 'gld_tile1', 'gld_tile1', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'guild_furni', 4, '', '', '', 0, 0, ''),
	(5041, 5041, '0', 'gld_table1', 'gld_table1', 'S', 2, 2, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'guild_furni', 1, '', '', '', 0, 0, ''),
	(5042, 5042, '0', 'wf_trg_period_long', 'wf_trg_period_long', 'S', 1, 1, 0.65, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'wf_trg_period_long', 1, '', '', '', 0, 0, ''),
	(5043, 5043, '0', 'wf_act_give_score_tm', 'wf_act_give_score_tm', 'S', 1, 1, 0.65, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'wf_act_give_score_tm', 1, '', '', '', 0, 0, ''),
	(5044, 5044, '0', 'highscore_classic*1', 'highscore_classic*1', 'S', 1, 1, 0.65, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'wf_highscore', 2, '', '', '', 0, 0, ''),
	(5045, 5045, '0', 'highscore_classic*2', 'highscore_classic*2', 'S', 1, 1, 0.65, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'wf_highscore', 2, '', '', '', 0, 0, ''),
	(5046, 5046, '0', 'highscore_classic*3', 'highscore_classic*3', 'S', 1, 1, 0.65, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'wf_highscore', 2, '', '', '', 0, 0, ''),
	(5047, 5047, '0', 'highscore_classic*4', 'highscore_classic*4', 'S', 1, 1, 0.65, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'wf_highscore', 2, '', '', '', 0, 0, ''),
	(5048, 5048, '0', 'wf_act_move_to_dir', 'wf_act_move_to_dir', 'S', 1, 1, 0.65, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'wf_act_move_to_dir', 1, '', '', '', 0, 0, ''),
	(5049, 5049, '0', 'wf_act_leave_team', 'wf_act_leave_team', 'S', 1, 1, 0.65, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'wf_act_leave_team', 1, '', '', '', 0, 0, ''),
	(5050, 5050, '0', 'wf_trg_collision', 'wf_trg_collision', 'S', 1, 1, 0.65, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'wf_trg_collision', 2, '', '', '', 0, 0, ''),
	(5051, 5051, '0', 'highscore_perteam*1', 'highscore_perteam*1', 'S', 1, 1, 0.65, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'wf_highscore', 2, '', '', '', 0, 0, ''),
	(5052, 5052, '0', 'highscore_perteam*2', 'highscore_perteam*2', 'S', 1, 1, 0.65, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'wf_highscore', 2, '', '', '', 0, 0, ''),
	(5053, 5053, '0', 'highscore_perteam*3', 'highscore_perteam*3', 'S', 1, 1, 0.65, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'wf_highscore', 2, '', '', '', 0, 0, ''),
	(5054, 5054, '0', 'highscore_perteam*4', 'highscore_perteam*4', 'S', 1, 1, 0.65, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'wf_highscore', 2, '', '', '', 0, 0, ''),
	(5055, 5055, '0', 'wf_act_chase', 'wf_act_chase', 'S', 1, 1, 0.65, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'wf_act_chase', 1, '', '', '', 0, 0, ''),
	(5056, 5056, '0', 'wf_cnd_actor_in_team', 'wf_cnd_actor_in_team', 'S', 1, 1, 0.65, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'wf_cnd_actor_in_team', 2, '', '', '', 0, 0, ''),
	(5057, 5057, '0', 'highscore_mostwin*1', 'highscore_mostwin*1', 'S', 1, 1, 0.65, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'wf_highscore', 2, '', '', '', 0, 0, ''),
	(5058, 5058, '0', 'highscore_mostwin*2', 'highscore_mostwin*2', 'S', 1, 1, 0.65, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'wf_highscore', 2, '', '', '', 0, 0, ''),
	(5059, 5059, '0', 'highscore_mostwin*3', 'highscore_mostwin*3', 'S', 1, 1, 0.65, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'wf_highscore', 2, '', '', '', 0, 0, ''),
	(5060, 5060, '0', 'highscore_mostwin*4', 'highscore_mostwin*4', 'S', 1, 1, 0.65, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'wf_highscore', 2, '', '', '', 0, 0, ''),
	(5061, 5061, '0', 'wf_act_flee', 'wf_act_flee', 'S', 1, 1, 0.65, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'wf_act_flee', 1, '', '', '', 0, 0, ''),
	(5062, 5062, '0', 'wf_act_join_team', 'wf_act_join_team', 'S', 1, 1, 0.65, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'wf_act_join_team', 1, '', '', '', 0, 0, ''),
	(5063, 5063, '0', 'arcade_cab', 'arcade_cab', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5064, 5064, '0', 'bb_tddhead_rc1', 'bb_tddhead_rc1', 'S', 2, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5065, 5065, '0', 'bb_robo_rc1', 'bb_robo_rc1', 'S', 2, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5066, 5066, '0', 'bb_apparatus_rc1', 'bb_apparatus_rc1', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(5067, 5067, '1', 'wf_blob', 'wf_blob', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'wf_blob', 2, '', '', '10,true', 0, 0, ''),
	(5068, 5068, '0', 'wf_blob2', 'wf_blob2', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'wf_blob', 2, '', '', '50,true', 0, 0, ''),
	(5069, 5069, '0', 'loyalty_toad', 'loyalty_toad', 'S', 2, 2, 1.00, '0', '0', '0', '0', '1', '1', '1', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5070, 5070, '0', 'statue_dragon', 'statue_dragon', 'S', 1, 2, 1.00, '0', '0', '0', '0', '1', '1', '1', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5071, 5071, '0', 'statue_griffin', 'statue_griffin', 'S', 1, 2, 1.00, '0', '0', '0', '0', '1', '1', '1', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5072, 5072, '0', 'loyalty_mouse', 'loyalty_mouse', 'S', 2, 2, 1.00, '0', '0', '0', '0', '1', '1', '1', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5073, 5073, '0', 'statue_elk', 'statue_elk', 'S', 2, 2, 1.00, '0', '0', '0', '0', '1', '1', '1', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5074, 5074, '1', 'mystics_gstool', 'mystics_gstool', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5075, 5075, '1', 'mystics_bspike2', 'mystics_bspike2', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(5076, 5076, '1', 'mystics_bbench', 'mystics_bbench', 'S', 2, 1, 1.40, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5077, 5077, '1', 'mystics_gblock1', 'mystics_gblock1', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5078, 5078, '1', 'mystics_bfloor', 'mystics_bfloor', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5079, 5079, '1', 'mystics_bstool', 'mystics_bstool', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5080, 5080, '1', 'mystics_gbench', 'mystics_gbench', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5081, 5081, '1', 'mystics_garch', 'mystics_garch', 'S', 1, 3, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5082, 5082, '1', 'mystics_gblock2', 'mystics_gblock2', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5083, 5083, '1', 'mystics_gfloor', 'mystics_gfloor', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5084, 5084, '1', 'mystics_barch', 'mystics_barch', 'S', 1, 3, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5085, 5085, '1', 'mystics_gtile1', 'mystics_gtile1', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5086, 5086, '1', 'mystics_bbed', 'mystics_bbed', 'S', 1, 3, 1.00, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5087, 5087, '1', 'mystics_btile2', 'mystics_btile2', 'S', 1, 1, 1.30, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(5088, 5088, '1', 'mystics_bspike1', 'mystics_bspike1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5089, 5089, '1', 'mystics_btile1', 'mystics_btile1', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5090, 5090, '1', 'mystics_btable', 'mystics_btable', 'S', 3, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(5091, 5091, '1', 'mystics_gtable', 'mystics_gtable', 'S', 1, 3, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5092, 5092, '1', 'mystics_gbed', 'mystics_gbed', 'S', 1, 3, 1.00, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5093, 5093, '1', 'mystics_gtree', 'mystics_gtree', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5094, 5094, '0', 'wf_cnd_wearing_badge', 'wf_cnd_wearing_badge', 'S', 1, 1, 0.65, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'wf_cnd_habbo_owns_badge', 2, '', '', '', 0, 0, ''),
	(5095, 5095, '0', 'wf_cnd_wearing_effect', 'wf_cnd_wearing_effect', 'S', 1, 1, 0.65, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'wf_cnd_wearing_effect', 2, '', '', '', 0, 0, ''),
	(5096, 5096, '0', 'mystics_gthrone', 'mystics_gthrone', 'S', 1, 1, 2.50, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5097, 5097, '0', 'mystics_bthrone', 'mystics_bthrone', 'S', 1, 1, 2.50, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5098, 5098, '0', 'mystics_ltstatue', 'mystics_ltstatue', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5099, 5099, '0', 'mystics_crystal_s', 'mystics_crystal_s', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'crackable', 3, '', '', '', 0, 0, ''),
	(5100, 5100, '0', 'mystics_crystal_m', 'mystics_crystal_m', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'crackable', 3, '', '', '', 0, 0, ''),
	(5101, 5101, '0', 'mystics_duck', 'mystics_duck', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5102, 5102, '0', 'mystics_crystal_l', 'mystics_crystal_l', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'crackable', 15000, '', '', '', 0, 0, ''),
	(5103, 5103, '0', 'tile_stackmagic', 'tile_stackmagic', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'stack_helper', 1, '', '', '', 0, 0, ''),
	(5104, 5104, '0', 'mystics_rfountain', 'mystics_rfountain', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5105, 5105, '0', 'mystics_rpillar', 'mystics_rpillar', 'S', 1, 1, 3.50, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5106, 5106, '0', 'holo_nelly', 'holo_nelly', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5107, 5107, '0', 'ads_woz_mpu', 'ads_woz_mpu', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5108, 5108, '1', 'diner_bardesk_corner*10', 'diner_bardesk_corner*10', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5109, 5109, '1', 'diner_bardesk_gate*10', 'diner_bardesk_gate*10', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(5110, 5110, '1', 'diner_sofa_1*10', 'diner_sofa_1*10', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5111, 5111, '1', 'diner_bardesk*10', 'diner_bardesk*10', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5112, 5112, '1', 'diner_table_1*10', 'diner_table_1*10', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5113, 5113, '1', 'diner_gumvendor*10', 'diner_gumvendor*10', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '67,68,69', '', '', 0, 0, ''),
	(5114, 5114, '1', 'diner_sofa_2*10', 'diner_sofa_2*10', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5115, 5115, '1', 'diner_table_2*10', 'diner_table_2*10', 'S', 3, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5116, 5116, '1', 'diner_chair*10', 'diner_chair*10', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5117, 5117, '1', 'diner_cashreg*10', 'diner_cashreg*10', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5118, 5118, '0', 'loyalty_dolphin', 'loyalty_dolphin', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5119, 5119, '0', 'ads_clearasil_tile1', 'ads_clearasil_tile1', 'S', 1, 1, 0.15, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'pressureplate', 1, '', '', '', 0, 0, ''),
	(5120, 5120, '0', 'ads_clearasil_vend', 'ads_clearasil_vend', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '1046', '', '', 0, 0, ''),
	(5121, 5121, '1', 'tent_orange', 'tent_orange', 'S', 2, 3, 1.00, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'tent', 1, '', '', '', 0, 0, ''),
	(5122, 5122, '1', 'hblooza_bbq', 'hblooza_bbq', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5123, 5123, '1', 'foldabletable_camo', 'foldabletable_camo', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5124, 5124, '1', 'foldabletable_beige', 'foldabletable_beige', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5125, 5125, '1', 'hblooza_icecream', 'hblooza_icecream', 'S', 1, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '4,75,76,77', '', '', 0, 0, ''),
	(5126, 5126, '1', 'hblooza_stage2*1', 'hblooza_stage2*1', 'S', 2, 2, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5127, 5127, '1', 'hblooza_stage2*2', 'hblooza_stage2*2', 'S', 2, 2, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5128, 5128, '1', 'hblooza_stage2*3', 'hblooza_stage2*3', 'S', 2, 2, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5129, 5129, '1', 'hblooza_stage2*4', 'hblooza_stage2*4', 'S', 2, 2, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5130, 5130, '0', 'hblooza_popcorn', 'hblooza_popcorn', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '63', '', '', 0, 0, ''),
	(5131, 5131, '1', 'hblooza_dirtfloor', 'hblooza_dirtfloor', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5132, 5132, '1', 'hblooza_tfnc_1', 'hblooza_tfnc_1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5133, 5133, '1', 'tent_beige', 'tent_beige', 'S', 2, 3, 1.00, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'tent', 1, '', '', '', 0, 0, ''),
	(5134, 5134, '0', 'hblooza_spacerent3x4', 'hblooza_spacerent3x4', 'S', 3, 4, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'rentable_space', 2, '', '', '', 0, 0, ''),
	(5135, 5135, '1', 'hblooza_sfnc_crnr*1', 'hblooza_sfnc_crnr*1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5136, 5136, '1', 'hblooza_sfnc_crnr*2', 'hblooza_sfnc_crnr*2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5137, 5137, '1', 'hblooza_sfnc_crnr*3', 'hblooza_sfnc_crnr*3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5138, 5138, '1', 'hblooza_sfnc_crnr*4', 'hblooza_sfnc_crnr*4', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5139, 5139, '1', 'hblooza_stage1*1', 'hblooza_stage1*1', 'S', 2, 2, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5140, 5140, '1', 'hblooza_stage1*2', 'hblooza_stage1*2', 'S', 2, 2, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5141, 5141, '1', 'hblooza_stage1*3', 'hblooza_stage1*3', 'S', 2, 2, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5142, 5142, '1', 'hblooza_stage1*4', 'hblooza_stage1*4', 'S', 2, 2, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5143, 5143, '1', 'tent_camo', 'tent_camo', 'S', 2, 3, 1.00, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'tent', 1, '', '', '', 0, 0, ''),
	(5144, 5144, '1', 'hblooza_fnc_crnr', 'hblooza_fnc_crnr', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5145, 5145, '0', 'hblooza_bubblejuice', 'hblooza_bubblejuice', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '19', '', '', 0, 0, ''),
	(5146, 5146, '1', 'hblooza_tfnc_2*1', 'hblooza_tfnc_2*1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(5147, 5147, '1', 'hblooza_tfnc_2*2', 'hblooza_tfnc_2*2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(5148, 5148, '1', 'hblooza_tfnc_2*3', 'hblooza_tfnc_2*3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(5149, 5149, '1', 'hblooza_tfnc_2*4', 'hblooza_tfnc_2*4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(5150, 5150, '1', 'hblooza_pillar1', 'hblooza_pillar1', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 6, '', '', '', 0, 0, ''),
	(5151, 5151, '1', 'bigtent_beige', 'bigtent_beige', 'S', 5, 5, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'tent', 1, '', '', '', 0, 0, ''),
	(5152, 5152, '1', 'foldablechair_camo', 'foldablechair_camo', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5153, 5153, '0', 'hblooza_candyfloss', 'hblooza_candyfloss', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '79,80', '', '', 0, 0, ''),
	(5154, 5154, '1', 'hblooza_fnc', 'hblooza_fnc', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5155, 5155, '0', 'hblooza_spacerent6x6', 'hblooza_spacerent6x6', 'S', 6, 6, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'rentable_space', 2, '', '', '', 0, 0, ''),
	(5156, 5156, '0', 'hblooza_hotdog', 'hblooza_hotdog', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '81', '', '', 0, 0, ''),
	(5157, 5157, '1', 'bigtent_camo', 'bigtent_camo', 'S', 5, 5, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'tent', 1, '', '', '', 0, 0, ''),
	(5158, 5158, '1', 'hblooza_sfnc*1', 'hblooza_sfnc*1', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5159, 5159, '1', 'hblooza_sfnc*2', 'hblooza_sfnc*2', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5160, 5160, '1', 'hblooza_sfnc*3', 'hblooza_sfnc*3', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5161, 5161, '1', 'hblooza_sfnc*4', 'hblooza_sfnc*4', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5162, 5162, '1', 'foldablechair_beige', 'foldablechair_beige', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5163, 5163, '1', 'tent_blue', 'tent_blue', 'S', 2, 3, 1.00, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'tent', 1, '', '', '', 0, 0, ''),
	(5164, 5164, '0', 'hblooza_kiosk', 'hblooza_kiosk', 'S', 1, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine_no_sides', 2, '1,3,19,36,38,63,79,81,1036', '', '', 0, 0, ''),
	(5165, 5165, '1', 'hblooza_tgate*1', 'hblooza_tgate*1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(5166, 5166, '1', 'hblooza_tgate*2', 'hblooza_tgate*2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(5167, 5167, '1', 'hblooza_tgate*3', 'hblooza_tgate*3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(5168, 5168, '1', 'hblooza_tgate*4', 'hblooza_tgate*4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(5169, 5169, '1', 'hblooza_chicken', 'hblooza_chicken', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '70', '', '', 0, 0, ''),
	(5170, 5170, '0', 'hblooza_sign', 'hblooza_sign', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(5171, 5171, '0', 'hblooza_spacerent7x7', 'hblooza_spacerent7x7', 'S', 7, 7, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'rentable_space', 2, '', '', '', 0, 0, ''),
	(5172, 5172, '0', 'hblooza_spacerent5x5', 'hblooza_spacerent5x5', 'S', 5, 5, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'rentable_space', 2, '', '', '', 0, 0, ''),
	(5173, 5173, '0', 'yttv3', 'yttv3', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'youtube', 2, '', '', '', 0, 0, ''),
	(5174, 5174, '0', 'yttv2', 'yttv2', 'S', 3, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'youtube', 2, '', '', '', 0, 0, ''),
	(5175, 5175, '0', 'yttv1', 'yttv1', 'S', 2, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'youtube', 2, '', '', '', 0, 0, ''),
	(5176, 5176, '0', 'yttv2b', 'yttv2b', 'S', 3, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'youtube', 2, '', '', '', 0, 0, ''),
	(5177, 5177, '0', 'prizetrophy_hblooza*1', 'prizetrophy_hblooza*1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(5178, 5178, '0', 'prizetrophy_hblooza*2', 'prizetrophy_hblooza*2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(5179, 5179, '0', 'prizetrophy_hblooza*3', 'prizetrophy_hblooza*3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(5180, 5180, '0', 'tile_stackmagic1', 'tile_stackmagic1', 'S', 2, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'stack_helper', 1, '', '', '', 0, 0, ''),
	(5181, 5181, '0', 'tile_stackmagic2', 'tile_stackmagic2', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'stack_helper', 1, '', '', '', 0, 0, ''),
	(5182, 5182, '0', 'hblooza_guitar3', 'hblooza_guitar3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5183, 5183, '0', 'hblooza_guitar1', 'hblooza_guitar1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5184, 5184, '0', 'hblooza_guitar11', 'hblooza_guitar11', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5185, 5185, '0', 'hblooza_guitar7', 'hblooza_guitar7', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5186, 5186, '0', 'hblooza_guitar9', 'hblooza_guitar9', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5187, 5187, '0', 'hblooza_guitar8', 'hblooza_guitar8', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5188, 5188, '0', 'hblooza_guitar6', 'hblooza_guitar6', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5189, 5189, '0', 'hblooza_guitar10', 'hblooza_guitar10', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5190, 5190, '0', 'hblooza_guitar5', 'hblooza_guitar5', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5191, 5191, '0', 'hblooza_guitar4', 'hblooza_guitar4', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5192, 5192, '0', 'hblooza_guitar2', 'hblooza_guitar2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5193, 5193, '0', 'hblooza_pinata2', 'hblooza_pinata2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'crackable', 100, '', '', '', 0, 0, ''),
	(5194, 5194, '0', 'hblooza_pinata1', 'hblooza_pinata1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'crackable', 100, '', '', '', 0, 0, ''),
	(5195, 5195, '0', 'ads_vpiggy_flag', 'ads_vpiggy_flag', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5196, 5196, '0', 'ads_vpiggy_pig', 'ads_vpiggy_pig', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5197, 5197, '0', 'pirate_bottle_1', 'pirate_bottle_1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5198, 5198, '1', 'pirate_dvdr3', 'pirate_dvdr3', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5199, 5199, '0', 'pirate_bottle_3', 'pirate_bottle_3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5200, 5200, '0', 'pirate_bottle_2', 'pirate_bottle_2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5201, 5201, '1', 'pirate_chest1', 'pirate_chest1', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5202, 5202, '1', 'pirate_barrel1', 'pirate_barrel1', 'S', 1, 1, 1.75, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5203, 5203, '1', 'pirate_cannonballs', 'pirate_cannonballs', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine_no_sides', 2, '1047', '', '', 0, 0, ''),
	(5204, 5204, '1', 'pirate_mast2', 'pirate_mast2', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5205, 5205, '0', 'pirate_mast2grp', 'pirate_mast2grp', 'S', 1, 1, 6.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'guild_furni', 2, '', '', '', 0, 0, ''),
	(5206, 5206, '0', 'pirate_bottle_8', 'pirate_bottle_8', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5207, 5207, '0', 'pirate_bottle_7', 'pirate_bottle_7', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5208, 5208, '1', 'pirate_dvdr2', 'pirate_dvdr2', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5209, 5209, '1', 'pirate_crate', 'pirate_crate', 'S', 1, 1, 1.20, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5210, 5210, '1', 'pirate_parrot', 'pirate_parrot', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'talking_furni', 2, '', '', '', 0, 0, ''),
	(5211, 5211, '0', 'pirate_mast3grp', 'pirate_mast3grp', 'S', 1, 1, 4.70, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'guild_furni', 2, '', '', '', 0, 0, ''),
	(5212, 5212, '1', 'pirate_swordrack', 'pirate_swordrack', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'effect_vendingmachine', 2, '162', '', '', 0, 0, ''),
	(5213, 5213, '0', 'pirate_bottle_10', 'pirate_bottle_10', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5214, 5214, '1', 'pirate_gate', 'pirate_gate', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(5215, 5215, '0', 'pirate_side1', 'pirate_side1', 'S', 1, 1, 2.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5216, 5216, '0', 'pirate_roombg', 'pirate_roombg', 'S', 1, 1, 0.50, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5217, 5217, '1', 'pirate_stage3', 'pirate_stage3', 'S', 1, 2, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5218, 5218, '0', 'pirate_bottle_4', 'pirate_bottle_4', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5219, 5219, '0', 'pirate_bottle_9', 'pirate_bottle_9', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5220, 5220, '1', 'pirate_stage2', 'pirate_stage2', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5221, 5221, '1', 'pirate_mast1', 'pirate_mast1', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5222, 5222, '1', 'pirate_cannon', 'pirate_cannon', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'cannon', 3, '', '', '', 0, 0, ''),
	(5223, 5223, '1', 'pirate_stairs', 'pirate_stairs', 'S', 1, 1, 0.40, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5224, 5224, '0', 'spacerent_room', 'spacerent_room', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '1', '1', 'rentable_space', 2, '', '', '', 0, 0, ''),
	(5225, 5225, '0', 'pirate_mast4grp', 'pirate_mast4grp', 'S', 1, 1, 0.10, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'guild_furni', 1, '', '', '', 0, 0, ''),
	(5226, 5226, '1', 'pirate_grate', 'pirate_grate', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(5227, 5227, '1', 'ship_wheel', 'ship_wheel', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5228, 5228, '0', 'pirate_bottle_6', 'pirate_bottle_6', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5229, 5229, '1', 'pirate_mast3', 'pirate_mast3', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5230, 5230, '1', 'pirate_stage', 'pirate_stage', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 4, '', '1.0;2.0;3.0;4.0', '', 0, 0, ''),
	(5231, 5231, '0', 'pirate_bottle_5', 'pirate_bottle_5', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5232, 5232, '1', 'pirate_flag', 'pirate_flag', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5233, 5233, '1', 'pirate_barrel2', 'pirate_barrel2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine_no_sides', 2, '38', '', '', 0, 0, ''),
	(5234, 5234, '1', 'pirate_plank', 'pirate_plank', 'S', 2, 1, 0.60, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5235, 5235, '1', 'pirate_anchor', 'pirate_anchor', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5236, 5236, '1', 'pirate_gunrack', 'pirate_gunrack', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'effect_vendingmachine', 2, '164', '', '', 0, 0, ''),
	(5237, 5237, '1', 'pirate_sandtrap', 'pirate_sandtrap', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'trap', 2, '', '', '', 163, 163, ''),
	(5238, 5238, '1', 'pirate_barrel3', 'pirate_barrel3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine_no_sides', 2, '34', '', '', 0, 0, ''),
	(5239, 5239, '1', 'pirate_mast4', 'pirate_mast4', 'S', 1, 1, 0.30, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(5240, 5240, '1', 'pirate_dvdr1', 'pirate_dvdr1', 'S', 1, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5241, 5241, '0', 'pirate_teleport', 'pirate_teleport', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'teleport', 2, '', '', '', 0, 0, ''),
	(5242, 5242, '0', 'pirate_poseidon', 'pirate_poseidon', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5243, 5243, '0', 'pirate_kraken', 'pirate_kraken', 'S', 3, 3, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5244, 5244, '0', 'pirate_navdesk', 'pirate_navdesk', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '82', '', '', 0, 0, ''),
	(5245, 5245, '0', 'pirate_dvdr1_g', 'pirate_dvdr1_g', 'S', 1, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5246, 5246, '0', 'pirate_stage_g', 'pirate_stage_g', 'S', 2, 2, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5247, 5247, '0', 'pirate_stage3_g', 'pirate_stage3_g', 'S', 1, 2, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5248, 5248, '0', 'pirate_stairs_g', 'pirate_stairs_g', 'S', 1, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5249, 5249, '0', 'pirate_plank_g', 'pirate_plank_g', 'S', 2, 1, 0.60, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5250, 5250, '0', 'pirate_flag_g', 'pirate_flag_g', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5251, 5251, '0', 'pirate_mast_g', 'pirate_mast_g', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5252, 5252, '0', 'pirate_gate_g', 'pirate_gate_g', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5253, 5253, '0', 'pirate_stage2_g', 'pirate_stage2_g', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5254, 5254, '0', 'ship_wheel_g', 'ship_wheel_g', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5255, 5255, '0', 'pirate_dvdr3_g', 'pirate_dvdr3_g', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5256, 5256, '0', 'pirate_dvdr2_g', 'pirate_dvdr2_g', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5257, 5257, '0', 'school_chairgold', 'school_chairgold', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5258, 5258, '1', 'school_coatrack_g', 'school_coatrack_g', 'S', 2, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5259, 5259, '1', 'school_locker_g_notele', 'school_locker_g_notele', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5260, 5260, '1', 'school_coatrack_b', 'school_coatrack_b', 'S', 2, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5261, 5261, '1', 'school_locker_b_notele', 'school_locker_b_notele', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5262, 5262, '1', 'school_chair_b', 'school_chair_b', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5263, 5263, '0', 'school_locker_g', 'school_locker_g', 'S', 1, 1, 0.30, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'teleport', 1, '', '', '', 0, 0, ''),
	(5264, 5264, '0', 'school_consolegold', 'school_consolegold', 'S', 1, 1, 1.20, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5265, 5265, '1', 'school_chair_g', 'school_chair_g', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5266, 5266, '1', 'school_fountain', 'school_fountain', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5267, 5267, '1', 'school_locker_r_notele', 'school_locker_r_notele', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5268, 5268, '1', 'school_console_g', 'school_console_g', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5269, 5269, '1', 'school_console_b', 'school_console_b', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5270, 5270, '1', 'school_coatrack_r', 'school_coatrack_r', 'S', 2, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5271, 5271, '0', 'school_gate', 'school_gate', 'S', 3, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5272, 5272, '1', 'school_cafe', 'school_cafe', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '3,36,34,71', '', '', 0, 0, ''),
	(5273, 5273, '1', 'grungelamp', 'grungelamp', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5274, 5274, '0', 'ads_clearasil_vend2', 'ads_clearasil_vend2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '1064', '', '', 0, 0, ''),
	(5275, 5275, '0', 'golden_apple', 'golden_apple', 'S', 2, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5276, 5276, '0', 'trophy_display', 'trophy_display', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5277, 5277, '0', 'hween13_sheep', 'hween13_sheep', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5278, 5278, '0', 'hween13_rose', 'hween13_rose', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5279, 5279, '0', 'hween13_book', 'hween13_book', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5280, 5280, '0', 'hween13_castleturret3', 'hween13_castleturret3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5281, 5281, '0', 'hween13_castleturret1', 'hween13_castleturret1', 'S', 1, 1, 3.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5282, 5282, '0', 'hween13_castleturret2', 'hween13_castleturret2', 'S', 1, 1, 3.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5283, 5283, '0', 'hween13_castleblock2', 'hween13_castleblock2', 'S', 1, 2, 3.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(5284, 5284, '0', 'hween13_bridgeend', 'hween13_bridgeend', 'S', 1, 1, 0.60, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5285, 5285, '0', 'hween13_thorndiv2', 'hween13_thorndiv2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5286, 5286, '0', 'hween13_thorndiv1', 'hween13_thorndiv1', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5287, 5287, '0', 'hween13_gutsfloor', 'hween13_gutsfloor', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5288, 5288, '0', 'hween13_grass', 'hween13_grass', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5289, 5289, '0', 'hween13_castlespike', 'hween13_castlespike', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(5290, 5290, '0', 'hween13_castleblock1', 'hween13_castleblock1', 'S', 1, 2, 3.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(5291, 5291, '0', 'hween13_floor2', 'hween13_floor2', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(5292, 5292, '0', 'hween13_roombg', 'hween13_roombg', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5293, 5293, '0', 'hween13_bridgemid', 'hween13_bridgemid', 'S', 1, 1, 0.70, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(5294, 5294, '0', 'hween13_fence_1', 'hween13_fence_1', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5295, 5295, '0', 'hween13_stage_s', 'hween13_stage_s', 'S', 1, 1, 0.80, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5296, 5296, '0', 'hween13_crnr_1', 'hween13_crnr_1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5297, 5297, '0', 'hween13_cardtable', 'hween13_cardtable', 'S', 2, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5298, 5298, '0', 'hween13_gate_1', 'hween13_gate_1', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(5299, 5299, '0', 'hween13_tree', 'hween13_tree', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine_no_sides', 2, '83', '', '', 0, 0, ''),
	(5300, 5300, '0', 'hween13_bldtrail', 'hween13_bldtrail', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 6, '', '', '', 0, 0, ''),
	(5301, 5301, '0', 'hween13_teacup', 'hween13_teacup', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'pressureplate', 2, '', '', '', 0, 0, ''),
	(5302, 5302, '0', 'hween13_tile1', 'hween13_tile1', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'pressureplate', 2, '', '', '', 0, 0, ''),
	(5303, 5303, '0', 'hween13_stage_l', 'hween13_stage_l', 'S', 2, 2, 0.80, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5304, 5304, '0', 'hween13_tele', 'hween13_tele', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'teleport', 1, '', '', '', 0, 0, ''),
	(5305, 5305, '0', 'hween13_chair', 'hween13_chair', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5306, 5306, '0', 'hween13_tile2', 'hween13_tile2', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'battlebanzai_random_teleport', 2, '', '', '', 0, 0, ''),
	(5307, 5307, '0', 'hween13_mirror', 'hween13_mirror', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5308, 5308, '0', 'hween13_candle', 'hween13_candle', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(5309, 5309, '0', 'hween13_piglamp', 'hween13_piglamp', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5310, 5310, '0', 'hween13_castlegarg', 'hween13_castlegarg', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5311, 5311, '0', 'hween13_castledoor', 'hween13_castledoor', 'S', 1, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 1, '', '', '', 0, 0, ''),
	(5312, 5312, '0', 'hween13_teaset', 'hween13_teaset', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(5313, 5313, '0', 'hween13_dwarfdiv', 'hween13_dwarfdiv', 'S', 2, 1, 1.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5314, 5314, '0', 'hween13_dwarfcrn', 'hween13_dwarfcrn', 'S', 1, 1, 1.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5315, 5315, '0', 'info_terminal', 'info_terminal', 'S', 1, 1, 1.00, '1', '0', '0', '0', '0', '0', '0', '1', '0', 'information_terminal', 3, '', '', '', 0, 0, ''),
	(5316, 5316, '0', 'button_green', 'button_green', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'switch', 2, '', '', '', 0, 0, ''),
	(5317, 5317, '0', 'hween13_bed', 'hween13_bed', 'S', 1, 3, 1.00, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '1', '', 0, 0, ''),
	(5318, 5318, '0', 'loyalty_pig', 'loyalty_pig', 'S', 2, 2, 1.00, '0', '0', '0', '0', '1', '1', '1', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5319, 5319, '0', 'hween13_monsterpea', 'hween13_monsterpea', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5320, 5320, '0', 'hween13_sheepdemon', 'hween13_sheepdemon', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5321, 5321, '0', 'hween13_throne', 'hween13_throne', 'S', 1, 1, 1.85, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5322, 5322, '0', 'yttv2n', 'yttv2n', 'S', 3, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'youtube', 2, '', '', '', 0, 0, ''),
	(5323, 5323, '0', 'cine_teleport4', 'cine_teleport4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'teleport', 1, '', '', '', 0, 0, ''),
	(5324, 5324, '0', 'cine_starchair', 'cine_starchair', 'S', 1, 1, 1.30, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5325, 5325, '1', 'cine_pillarlight', 'cine_pillarlight', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5326, 5326, '0', 'cine_teleport2', 'cine_teleport2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'teleport', 1, '', '', '', 0, 0, ''),
	(5327, 5327, '1', 'cine_bigcorn', 'cine_bigcorn', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5328, 5328, '0', 'cine_teleport1', 'cine_teleport1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'teleport', 1, '', '', '', 0, 0, ''),
	(5329, 5329, '1', 'cine_soda', 'cine_soda', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5330, 5330, '0', 'cine_teleport3', 'cine_teleport3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'teleport', 1, '', '', '', 0, 0, ''),
	(5331, 5331, '0', 'ads_dtlrare', 'ads_dtlrare', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '1048', '', '', 0, 0, ''),
	(5332, 5332, '0', 'mystics_crystal', 'mystics_crystal', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'crackable', 14, '', '', '', 0, 0, ''),
	(5333, 5333, '0', 'sfx_taperec_breakbeat', 'sfx_taperec_breakbeat', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5334, 5334, '0', 'sfx_taperec', 'sfx_taperec', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5335, 5335, '0', 'sfx_taperec_bassline', 'sfx_taperec_bassline', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5336, 5336, '0', 'sound_set_79', 'sound_set_79', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5337, 5337, '0', 'background_color', 'background_color', 'S', 1, 1, 0.50, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5338, 5338, '0', 'pixel_couch_pink', 'pixel_couch_pink', 'S', 2, 1, 1.30, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5339, 5339, '0', 'pixel_couch_green', 'pixel_couch_green', 'S', 2, 1, 1.30, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5340, 5340, '0', 'pixel_couch_black', 'pixel_couch_black', 'S', 2, 1, 1.30, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(5341, 5341, '0', 'pixel_couch_red', 'pixel_couch_red', 'S', 2, 1, 1.30, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(5342, 5342, '0', 'xmas13_block2', 'xmas13_block2', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5343, 5343, '0', 'xmas13_snowflake10', 'xmas13_snowflake10', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'cannon', 2, '', '', '', 0, 0, ''),
	(5344, 5344, '0', 'xmas13_snowflake2', 'xmas13_snowflake2', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5345, 5345, '0', 'xmas13_table', 'xmas13_table', 'S', 1, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5346, 5346, '0', 'xmas13_snowflake5', 'xmas13_snowflake5', 'S', 1, 1, 2.50, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5347, 5347, '0', 'xmas13_snack', 'xmas13_snack', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5348, 5348, '0', 'xmas13_snowflake9', 'xmas13_snowflake9', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5349, 5349, '0', 'xmas13_snowflake3', 'xmas13_snowflake3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5350, 5350, '0', 'xmas13_block1', 'xmas13_block1', 'S', 1, 2, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5351, 5351, '0', 'xmas13_snowflake6', 'xmas13_snowflake6', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5352, 5352, '0', 'xmas13_snowflake1', 'xmas13_snowflake1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5353, 5353, '0', 'xmas13_snowflake7', 'xmas13_snowflake7', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '18', '', '', 0, 0, ''),
	(5354, 5354, '0', 'xmas13_snowflake4', 'xmas13_snowflake4', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5355, 5355, '0', 'xmas13_snowflake8', 'xmas13_snowflake8', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5356, 5356, '0', 'xmas13_chair', 'xmas13_chair', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5357, 5357, '0', 'xmas13_floor', 'xmas13_floor', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(5358, 5358, '0', 'js_bling_chair_w', 'js_bling_chair_w', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5359, 5359, '0', 'js_bling_bed', 'js_bling_bed', 'S', 2, 3, 1.60, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'bed', 2, '', '', '', 0, 0, ''),
	(5360, 5360, '1', 'js_chandelier', 'js_chandelier', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5361, 5361, '0', 'js_bling11_seat1', 'js_bling11_seat1', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5362, 5362, '0', 'js_bling_fridge', 'js_bling_fridge', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '35', '', '', 0, 0, ''),
	(5363, 5363, '0', 'js_bling11_seat2', 'js_bling11_seat2', 'S', 1, 1, 1.30, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5364, 5364, '0', 'js_bling11_sofa', 'js_bling11_sofa', 'S', 3, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5365, 5365, '0', 'js_bling11_dvn', 'js_bling11_dvn', 'S', 1, 3, 1.20, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(5366, 5366, '0', 'lidotower', 'lidotower', 'S', 4, 3, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5367, 5367, '0', 'test_tent', 'test_tent', 'S', 2, 3, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'tent', 1, '', '', '', 0, 0, ''),
	(5368, 5368, '0', 'test_cnd_not_stuff_is', 'test_cnd_not_stuff_is', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5369, 5369, '0', 'test_cnd_not_furni_on', 'test_cnd_not_furni_on', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5370, 5370, '0', 'info_terminal_test', 'info_terminal_test', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5371, 5371, '0', 'talking_fridge', 'talking_fridge', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5372, 5372, '0', 'telescopetest', 'telescopetest', 'S', 2, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5373, 5373, '0', 'test_spacerent', 'test_spacerent', 'S', 6, 6, 1.00, '1', '0', '0', '1', '1', '1', '0', '1', '1', 'rentable_space', 2, '', '', '', 0, 0, ''),
	(5374, 5374, '0', 'guild_customized', 'guild_customized', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5375, 5375, '0', 'test_effectswitch', 'test_effectswitch', 'S', 1, 3, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5376, 5376, '0', 'test_cnd_not_hv_avtrs', 'test_cnd_not_hv_avtrs', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5377, 5377, '0', 'vimeo_cubie', 'vimeo_cubie', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5378, 5378, '0', 'vote_majority', 'vote_majority', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5379, 5379, '0', 'test_cnd_not_in_group', 'test_cnd_not_in_group', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5380, 5380, '0', 'ytprojector', 'ytprojector', 'S', 3, 3, 1.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(5381, 5381, '0', 'test_cnd_not_match_snap', 'test_cnd_not_match_snap', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5382, 5382, '0', 'testbot', 'testbot', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5383, 5383, '0', 'ach_resolution_test', 'ach_resolution_test', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5384, 5384, '0', 'test_bigtent', 'test_bigtent', 'S', 5, 5, 0.00, '1', '0', '0', '1', '1', '1', '0', '1', '1', 'tent', 1, '', '', '', 0, 0, ''),
	(5385, 5385, '0', 'test_cnd_not_in_team', 'test_cnd_not_in_team', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '1', '1', 'wf_act_give_credits', 1, '', '', '', 0, 0, ''),
	(5386, 5386, '0', 'icecream_stand', 'icecream_stand', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5387, 5387, '0', 'test_candyfloss', 'test_candyfloss', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5388, 5388, '0', 'test_cnd_not_wearing_b', 'test_cnd_not_wearing_b', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5389, 5389, '0', 'shallow_test', 'shallow_test', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5390, 5390, '0', 'test_cnd_not_wearing_f', 'test_cnd_not_wearing_f', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5391, 5391, '0', 'test_builder_placeholder', 'test_builder_placeholder', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5392, 5392, '0', 'test_cnd_not_trggrer_on', 'test_cnd_not_trggrer_on', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5393, 5393, '0', 'change_state_on_step', 'change_state_on_step', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5394, 5394, '0', 'test_highscore*1', 'test_highscore*1', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5395, 5395, '0', 'test_highscore*2', 'test_highscore*2', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5396, 5396, '0', 'test_highscore*3', 'test_highscore*3', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5397, 5397, '0', 'test_highscore*4', 'test_highscore*4', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5398, 5398, '0', 'testtubetv2', 'testtubetv2', 'S', 3, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'yt_tv', 1, '', '', '', 0, 0, ''),
	(5399, 5399, '0', 'vimeo_test', 'vimeo_test', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5400, 5400, '0', 'action_link_furni_test', 'action_link_furni_test', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5401, 5401, '0', 'test_highscore_wins*1', 'test_highscore_wins*1', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5402, 5402, '0', 'test_highscore_wins*2', 'test_highscore_wins*2', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5403, 5403, '0', 'test_highscore_wins*3', 'test_highscore_wins*3', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5404, 5404, '0', 'test_highscore_wins*4', 'test_highscore_wins*4', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5405, 5405, '0', 'cr_tree_basic_01', 'cr_tree_basic_01', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5406, 5406, '0', 'handitem_tester', 'handitem_tester', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5407, 5407, '0', 'random_tele_1', 'random_tele_1', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5408, 5408, '0', 'builder_exp', 'builder_exp', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5409, 5409, '0', 'cameraproto', 'cameraproto', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5410, 5410, '0', 'test_shipside', 'test_shipside', 'S', 1, 2, 1.00, '1', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5411, 5411, '0', 'lovelock_test', 'lovelock_test', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5412, 5412, '0', 'testing_crackable', 'testing_crackable', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5413, 5413, '0', 'royal_sofa', 'royal_sofa', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5414, 5414, '0', 'test_ltd_handitem', 'test_ltd_handitem', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5415, 5415, '0', 'testing_yt', 'testing_yt', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5416, 5416, '0', 'vote_machine', 'vote_machine', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5417, 5417, '0', 'badge_display_case', 'badge_display_case', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5418, 5418, '0', 'testtubetv1', 'testtubetv1', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5419, 5419, '0', 'royal_chair', 'royal_chair', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5420, 5420, '0', 'random_tele_2', 'random_tele_2', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5421, 5421, '0', 'statestoragetesting*1', 'statestoragetesting*1', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5422, 5422, '0', 'statestoragetesting*2', 'statestoragetesting*2', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5423, 5423, '0', 'statestoragetesting*3', 'statestoragetesting*3', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5424, 5424, '0', 'statestoragetesting*4', 'statestoragetesting*4', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5425, 5425, '0', 'statestoragetesting*5', 'statestoragetesting*5', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5426, 5426, '0', 'statestoragetesting*6', 'statestoragetesting*6', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5427, 5427, '0', 'statestoragetesting*7', 'statestoragetesting*7', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5428, 5428, '0', 'statestoragetesting*8', 'statestoragetesting*8', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5429, 5429, '0', 'statestoragetesting*9', 'statestoragetesting*9', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5430, 5430, '0', 'test_cnd_not_user_count', 'test_cnd_not_user_count', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5431, 5431, '0', 'soundblock', 'soundblock', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5432, 5432, '0', 'testing_rentablespace', 'testing_rentablespace', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5433, 5433, '0', 'test_festhotdog', 'test_festhotdog', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5434, 5434, '0', 'random_teleport', 'random_teleport', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'hopper', 2, '', '', '', 0, 0, ''),
	(5435, 5435, '0', 'soundblock_breakbeat', 'soundblock_breakbeat', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5436, 5436, '0', 'stackable_water', 'stackable_water', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5437, 5437, '0', 'water_backdrop', 'water_backdrop', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5438, 5438, '0', 'wf_cnd_not_trggrer_on', 'wf_cnd_not_trggrer_on', 'S', 1, 1, 0.65, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'wf_cnd_not_trggrer_on', 2, '', '', '', 0, 0, ''),
	(5439, 5439, '0', 'wf_cnd_not_in_team', 'wf_cnd_not_in_team', 'S', 1, 1, 0.65, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'wf_cnd_not_in_team', 2, '', '', '', 0, 0, ''),
	(5440, 5440, '0', 'wf_cnd_not_furni_on', 'wf_cnd_not_furni_on', 'S', 1, 1, 0.65, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'wf_cnd_not_furni_on', 2, '', '', '', 0, 0, ''),
	(5441, 5441, '0', 'wf_cnd_not_hv_avtrs', 'wf_cnd_not_hv_avtrs', 'S', 1, 1, 0.65, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'wf_cnd_not_hv_avtrs', 2, '', '', '', 0, 0, ''),
	(5442, 5442, '0', 'wf_trg_at_time_long', 'wf_trg_at_time_long', 'S', 1, 1, 0.65, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'wf_trg_at_time_long', 1, '', '', '', 0, 0, ''),
	(5443, 5443, '0', 'wf_cnd_not_user_count', 'wf_cnd_not_user_count', 'S', 1, 1, 0.65, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'wf_cnd_not_user_count', 2, '', '', '', 0, 0, ''),
	(5444, 5444, '0', 'wf_cnd_not_wearing_fx', 'wf_cnd_not_wearing_fx', 'S', 1, 1, 0.65, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'wf_cnd_not_wearing_fx', 2, '', '', '', 0, 0, ''),
	(5445, 5445, '0', 'wf_cnd_user_count_in', 'wf_cnd_user_count_in', 'S', 1, 1, 0.65, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'wf_cnd_user_count_in', 2, '', '', '', 0, 0, ''),
	(5446, 5446, '0', 'wf_cnd_not_wearing_b', 'wf_cnd_not_wearing_b', 'S', 1, 1, 0.65, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'wf_cnd_not_habbo_owns_badge', 2, '', '', '', 0, 0, ''),
	(5447, 5447, '0', 'wf_cnd_stuff_is', 'wf_cnd_stuff_is', 'S', 1, 1, 0.65, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'wf_cnd_stuff_is', 2, '', '', '', 0, 0, ''),
	(5448, 5448, '0', 'wf_cnd_not_in_group', 'wf_cnd_not_in_group', 'S', 1, 1, 0.65, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'wf_cnd_not_in_group', 2, '', '', '', 0, 0, ''),
	(5449, 5449, '0', 'wf_cnd_not_stuff_is', 'wf_cnd_not_stuff_is', 'S', 1, 1, 0.65, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'wf_cnd_not_stuff_is', 2, '', '', '', 0, 0, ''),
	(5450, 5450, '0', 'wf_act_move_furni_to', 'wf_act_move_furni_to', 'S', 1, 1, 0.65, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'wf_act_move_furni_to', 1, '', '', '', 0, 0, ''),
	(5451, 5451, '0', 'wf_act_toggle_to_rnd', 'wf_act_toggle_to_rnd', 'S', 1, 1, 0.65, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'wf_act_toggle_to_rnd', 1, '', '', '', 0, 0, ''),
	(5452, 5452, '0', 'wf_cnd_not_match_snap', 'wf_cnd_not_match_snap', 'S', 1, 1, 0.65, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'wf_cnd_not_match_snap', 2, '', '', '', 0, 0, ''),
	(5453, 5453, '0', 'crystal_dragon', 'crystal_dragon', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5454, 5454, '0', 'crystal_throne', 'crystal_throne', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5455, 5455, '0', 'white_dino_egg', 'white_dino_egg', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5456, 5456, '0', 'bg_cloud', 'bg_cloud', 'S', 1, 1, 0.50, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5457, 5457, '0', 'hole4', 'hole4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5458, 5458, '0', 'hole1x1test', 'hole1x1test', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5459, 5459, '0', 'teleport_random', 'teleport_random', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5460, 5460, '0', 'teleport_random_2', 'teleport_random_2', 'S', 1, 1, 0.50, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'hopper', 1, '', '', '', 0, 0, ''),
	(5461, 5461, '0', 'CF_5000_suitcase', 'CF_5000_suitcase', 'S', 1, 1, 1.00, '0', '0', '0', '0', '0', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5462, 5462, '1', 'bc_block_0*1', 'bc_block_0*1', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(5463, 5463, '1', 'bc_block_0*10', 'bc_block_0*10', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(5464, 5464, '1', 'bc_block_0*11', 'bc_block_0*11', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(5465, 5465, '1', 'bc_block_0*12', 'bc_block_0*12', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(5466, 5466, '1', 'bc_block_0*13', 'bc_block_0*13', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(5467, 5467, '1', 'bc_block_0*14', 'bc_block_0*14', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(5468, 5468, '1', 'bc_block_0*2', 'bc_block_0*2', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(5469, 5469, '1', 'bc_block_0*3', 'bc_block_0*3', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(5470, 5470, '1', 'bc_block_0*4', 'bc_block_0*4', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(5471, 5471, '1', 'bc_block_0*5', 'bc_block_0*5', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(5472, 5472, '1', 'bc_block_0*6', 'bc_block_0*6', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(5473, 5473, '1', 'bc_block_0*7', 'bc_block_0*7', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(5474, 5474, '1', 'bc_block_0*8', 'bc_block_0*8', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(5475, 5475, '1', 'bc_block_0*9', 'bc_block_0*9', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(5476, 5476, '1', 'bc_block_1*1', 'bc_block_1*1', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 2, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(5477, 5477, '1', 'bc_block_1*10', 'bc_block_1*10', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(5478, 5478, '1', 'bc_block_1*11', 'bc_block_1*11', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(5479, 5479, '1', 'bc_block_1*12', 'bc_block_1*12', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(5480, 5480, '1', 'bc_block_1*13', 'bc_block_1*13', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(5481, 5481, '1', 'bc_block_1*14', 'bc_block_1*14', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(5482, 5482, '1', 'bc_block_1*2', 'bc_block_1*2', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(5483, 5483, '1', 'bc_block_1*3', 'bc_block_1*3', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(5484, 5484, '1', 'bc_block_1*4', 'bc_block_1*4', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(5485, 5485, '1', 'bc_block_1*5', 'bc_block_1*5', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(5486, 5486, '1', 'bc_block_1*6', 'bc_block_1*6', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(5487, 5487, '1', 'bc_block_1*7', 'bc_block_1*7', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(5488, 5488, '1', 'bc_block_1*8', 'bc_block_1*8', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(5489, 5489, '1', 'bc_block_1*9', 'bc_block_1*9', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(5490, 5490, '0', 'xmas13_rug', 'xmas13_rug', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5491, 5491, '0', 'xmas13_shelves', 'xmas13_shelves', 'S', 2, 1, 3.50, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(5492, 5492, '0', 'xmas13_pillar', 'xmas13_pillar', 'S', 1, 1, 4.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(5493, 5493, '0', 'xmas13_toyhorse', 'xmas13_toyhorse', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(5494, 5494, '0', 'xmas13_tools1', 'xmas13_tools1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5495, 5495, '0', 'xmas13_paintsplat1', 'xmas13_paintsplat1', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 6, '', '', '', 0, 0, ''),
	(5496, 5496, '0', 'xmas13_gingerbread', 'xmas13_gingerbread', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine_no_sides', 2, '84', '', '', 0, 0, ''),
	(5497, 5497, '0', 'xmas13_light', 'xmas13_light', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(5498, 5498, '0', 'xmas13_candycane1', 'xmas13_candycane1', 'S', 1, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '48,84,1025', '', '', 0, 0, ''),
	(5499, 5499, '0', 'xmas13_paintsplat3', 'xmas13_paintsplat3', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 6, '', '', '', 0, 0, ''),
	(5500, 5500, '0', 'xmas13_paintsplat4', 'xmas13_paintsplat4', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 6, '', '', '', 0, 0, ''),
	(5501, 5501, '0', 'xmas13_paintsplat2', 'xmas13_paintsplat2', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 6, '', '', '', 0, 0, ''),
	(5502, 5502, '0', 'xmas13_candycane2', 'xmas13_candycane2', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5503, 5503, '0', 'xmas13_bucket1', 'xmas13_bucket1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 7, '', '', '', 0, 0, ''),
	(5504, 5504, '0', 'xmas13_toyblock2', 'xmas13_toyblock2', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5505, 5505, '0', 'xmas13_toyblock4', 'xmas13_toyblock4', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5506, 5506, '0', 'xmas13_toyblock3', 'xmas13_toyblock3', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5507, 5507, '0', 'xmas13_toyblock1', 'xmas13_toyblock1', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5508, 5508, '0', 'hc_exe_seccam', 'hc_exe_seccam', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5509, 5509, '0', 'hc_exe_wrkdesk', 'hc_exe_wrkdesk', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5510, 5510, '0', 'hc_exe_glassdvdr', 'hc_exe_glassdvdr', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5511, 5511, '0', 'hc_exe_sofa', 'hc_exe_sofa', 'S', 3, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5512, 5512, '0', 'hc_exe_s_table', 'hc_exe_s_table', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5513, 5513, '0', 'hc_exe_light', 'hc_exe_light', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(5514, 5514, '0', 'hc_exe_chair2', 'hc_exe_chair2', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5515, 5515, '0', 'hc_exe_table', 'hc_exe_table', 'S', 3, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5516, 5516, '0', 'hc_exe_chair', 'hc_exe_chair', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5517, 5517, '0', 'hc_exe_elevator', 'hc_exe_elevator', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'teleport', 2, '', '', '', 0, 0, ''),
	(5518, 5518, '0', 'hc_exe_cubelight', 'hc_exe_cubelight', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(5519, 5519, '0', 'mutearea_sign', 'mutearea_sign', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '1', '1', 'mutearea', 2, '', '', '', 0, 0, ''),
	(5520, 5520, '0', 'buildarea_sign', 'buildarea_sign', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '1', '1', 'buildarea', 2, '', '', '', 0, 0, ''),
	(5521, 5521, '0', 'xmas13_mincepies', 'xmas13_mincepies', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(5522, 5522, '0', 'xmas13_eggnogbowl', 'xmas13_eggnogbowl', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine_no_sides', 2, '73', '', '', 0, 0, ''),
	(5523, 5523, '0', 'xmas13_eggnogglass', 'xmas13_eggnogglass', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(5524, 5524, '0', 'xmas13_machine1', 'xmas13_machine1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5525, 5525, '0', 'xmas13_jack', 'xmas13_jack', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5526, 5526, '0', 'xmas13_throne', 'xmas13_throne', 'S', 1, 1, 1.30, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5527, 5527, '0', 'xmas13_toolbox', 'xmas13_toolbox', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine_no_sides', 2, '1049', '', '', 0, 0, ''),
	(5528, 5528, '0', 'xmas13_workdesk', 'xmas13_workdesk', 'S', 2, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5529, 5529, '0', 'xmas13_robotdino', 'xmas13_robotdino', 'S', 1, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5530, 5530, '0', 'gnome_box', 'gnome_box', 'S', 1, 1, 2.30, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5531, 5531, '0', 'CF_750_duck', 'CF_750_duck', 'S', 1, 1, 1.00, '1', '0', '0', '0', '0', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5532, 5532, '0', 'CF_350_duck', 'CF_350_duck', 'S', 1, 1, 1.00, '1', '0', '0', '0', '0', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5533, 5533, '0', 'xmas13_terminal', 'xmas13_terminal', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(5534, 5534, '0', 'xmas13_icecream', 'xmas13_icecream', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '4', '', '', 0, 0, ''),
	(5535, 5535, '0', 'roombg_stars', 'roombg_stars', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5536, 5536, '0', 'roombg_city1', 'roombg_city1', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5537, 5537, '0', 'roombg_city2', 'roombg_city2', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5538, 5538, '0', 'rare_chinahorse', 'rare_chinahorse', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5539, 5539, '1', 'bc_block_redbrick*1', 'bc_block_redbrick*1', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5540, 5540, '1', 'bc_block_redbrick*10', 'bc_block_redbrick*10', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5541, 5541, '1', 'bc_block_redbrick*11', 'bc_block_redbrick*11', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5542, 5542, '1', 'bc_block_redbrick*12', 'bc_block_redbrick*12', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5543, 5543, '1', 'bc_block_redbrick*13', 'bc_block_redbrick*13', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5544, 5544, '1', 'bc_block_redbrick*14', 'bc_block_redbrick*14', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5545, 5545, '1', 'bc_block_redbrick*2', 'bc_block_redbrick*2', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5546, 5546, '1', 'bc_block_redbrick*3', 'bc_block_redbrick*3', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5547, 5547, '1', 'bc_block_redbrick*4', 'bc_block_redbrick*4', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5548, 5548, '1', 'bc_block_redbrick*5', 'bc_block_redbrick*5', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5549, 5549, '1', 'bc_block_redbrick*6', 'bc_block_redbrick*6', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5550, 5550, '1', 'bc_block_redbrick*7', 'bc_block_redbrick*7', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5551, 5551, '1', 'bc_block_redbrick*8', 'bc_block_redbrick*8', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5552, 5552, '1', 'bc_block_redbrick*9', 'bc_block_redbrick*9', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5553, 5553, '1', 'bc_block_artdeco1*1', 'bc_block_artdeco1*1', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5554, 5554, '1', 'bc_block_artdeco1*2', 'bc_block_artdeco1*2', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5555, 5555, '1', 'bc_block_artdeco1*3', 'bc_block_artdeco1*3', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5556, 5556, '1', 'bc_block_artdeco1*4', 'bc_block_artdeco1*4', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5557, 5557, '1', 'bc_block_artdeco1*5', 'bc_block_artdeco1*5', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5558, 5558, '1', 'bc_block_industrial*1', 'bc_block_industrial*1', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5559, 5559, '1', 'bc_block_industrial*2', 'bc_block_industrial*2', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5560, 5560, '1', 'bc_block_industrial*3', 'bc_block_industrial*3', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5561, 5561, '1', 'bc_block_industrial*4', 'bc_block_industrial*4', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5562, 5562, '1', 'bc_block_industrial*5', 'bc_block_industrial*5', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5563, 5563, '1', 'bc_lavarock*1', 'bc_lavarock*1', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5564, 5564, '1', 'bc_lavarock*10', 'bc_lavarock*10', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5565, 5565, '1', 'bc_lavarock*11', 'bc_lavarock*11', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5566, 5566, '1', 'bc_lavarock*12', 'bc_lavarock*12', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5567, 5567, '1', 'bc_lavarock*13', 'bc_lavarock*13', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5568, 5568, '1', 'bc_lavarock*14', 'bc_lavarock*14', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5569, 5569, '1', 'bc_lavarock*2', 'bc_lavarock*2', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5570, 5570, '1', 'bc_lavarock*3', 'bc_lavarock*3', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5571, 5571, '1', 'bc_lavarock*4', 'bc_lavarock*4', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5572, 5572, '1', 'bc_lavarock*5', 'bc_lavarock*5', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5573, 5573, '1', 'bc_lavarock*6', 'bc_lavarock*6', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5574, 5574, '1', 'bc_lavarock*7', 'bc_lavarock*7', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5575, 5575, '1', 'bc_lavarock*8', 'bc_lavarock*8', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5576, 5576, '1', 'bc_lavarock*9', 'bc_lavarock*9', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5577, 5577, '1', 'bc_block_metalgrip*1', 'bc_block_metalgrip*1', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5578, 5578, '1', 'bc_block_metalgrip*2', 'bc_block_metalgrip*2', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5579, 5579, '1', 'bc_block_metalgrip*3', 'bc_block_metalgrip*3', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5580, 5580, '1', 'bc_block_metalgrip*4', 'bc_block_metalgrip*4', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5581, 5581, '1', 'bc_block_metalgrip*5', 'bc_block_metalgrip*5', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5582, 5582, '1', 'bc_block_grass*1', 'bc_block_grass*1', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5583, 5583, '1', 'bc_block_grass*2', 'bc_block_grass*2', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5584, 5584, '1', 'bc_block_grass*3', 'bc_block_grass*3', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5585, 5585, '1', 'bc_block_grass*4', 'bc_block_grass*4', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5586, 5586, '1', 'bc_block_grass*5', 'bc_block_grass*5', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5587, 5587, '1', 'bc_block_grass*6', 'bc_block_grass*6', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5588, 5588, '1', 'bc_block_grass*7', 'bc_block_grass*7', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5589, 5589, '1', 'bc_block_marble*1', 'bc_block_marble*1', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5590, 5590, '1', 'bc_block_marble*10', 'bc_block_marble*10', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5591, 5591, '1', 'bc_block_marble*11', 'bc_block_marble*11', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5592, 5592, '1', 'bc_block_marble*12', 'bc_block_marble*12', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5593, 5593, '1', 'bc_block_marble*13', 'bc_block_marble*13', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5594, 5594, '1', 'bc_block_marble*14', 'bc_block_marble*14', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5595, 5595, '1', 'bc_block_marble*2', 'bc_block_marble*2', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5596, 5596, '1', 'bc_block_marble*3', 'bc_block_marble*3', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5597, 5597, '1', 'bc_block_marble*4', 'bc_block_marble*4', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5598, 5598, '1', 'bc_block_marble*5', 'bc_block_marble*5', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5599, 5599, '1', 'bc_block_marble*6', 'bc_block_marble*6', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5600, 5600, '1', 'bc_block_marble*7', 'bc_block_marble*7', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5601, 5601, '1', 'bc_block_marble*8', 'bc_block_marble*8', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5602, 5602, '1', 'bc_block_marble*9', 'bc_block_marble*9', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5603, 5603, '1', 'bc_block_sand*1', 'bc_block_sand*1', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5604, 5604, '1', 'bc_block_sand*2', 'bc_block_sand*2', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5605, 5605, '1', 'bc_block_sand*3', 'bc_block_sand*3', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5606, 5606, '1', 'bc_block_sand*4', 'bc_block_sand*4', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5607, 5607, '1', 'bc_block_sand*5', 'bc_block_sand*5', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5608, 5608, '1', 'bc_block_sand*6', 'bc_block_sand*6', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5609, 5609, '1', 'bc_block_sand*7', 'bc_block_sand*7', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5610, 5610, '1', 'bc_block_glass*1', 'bc_block_glass*1', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5611, 5611, '1', 'bc_block_glass*10', 'bc_block_glass*10', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5612, 5612, '1', 'bc_block_glass*11', 'bc_block_glass*11', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5613, 5613, '1', 'bc_block_glass*12', 'bc_block_glass*12', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5614, 5614, '1', 'bc_block_glass*13', 'bc_block_glass*13', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5615, 5615, '1', 'bc_block_glass*14', 'bc_block_glass*14', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5616, 5616, '1', 'bc_block_glass*2', 'bc_block_glass*2', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5617, 5617, '1', 'bc_block_glass*3', 'bc_block_glass*3', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5618, 5618, '1', 'bc_block_glass*4', 'bc_block_glass*4', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5619, 5619, '1', 'bc_block_glass*5', 'bc_block_glass*5', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5620, 5620, '1', 'bc_block_glass*6', 'bc_block_glass*6', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5621, 5621, '1', 'bc_block_glass*7', 'bc_block_glass*7', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5622, 5622, '1', 'bc_block_glass*8', 'bc_block_glass*8', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5623, 5623, '1', 'bc_block_glass*9', 'bc_block_glass*9', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5624, 5624, '1', 'bc_round*1', 'bc_round*1', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(5625, 5625, '1', 'bc_round*10', 'bc_round*10', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(5626, 5626, '1', 'bc_round*11', 'bc_round*11', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(5627, 5627, '1', 'bc_round*12', 'bc_round*12', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(5628, 5628, '1', 'bc_round*13', 'bc_round*13', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(5629, 5629, '1', 'bc_round*14', 'bc_round*14', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(5630, 5630, '1', 'bc_round*2', 'bc_round*2', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(5631, 5631, '1', 'bc_round*3', 'bc_round*3', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(5632, 5632, '1', 'bc_round*4', 'bc_round*4', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(5633, 5633, '1', 'bc_round*5', 'bc_round*5', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(5634, 5634, '1', 'bc_round*6', 'bc_round*6', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(5635, 5635, '1', 'bc_round*7', 'bc_round*7', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(5636, 5636, '1', 'bc_round*8', 'bc_round*8', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(5637, 5637, '1', 'bc_round*9', 'bc_round*9', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(5638, 5638, '1', 'bc_block_wool*1', 'bc_block_wool*1', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5639, 5639, '1', 'bc_block_wool*10', 'bc_block_wool*10', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5640, 5640, '1', 'bc_block_wool*11', 'bc_block_wool*11', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5641, 5641, '1', 'bc_block_wool*12', 'bc_block_wool*12', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5642, 5642, '1', 'bc_block_wool*13', 'bc_block_wool*13', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5643, 5643, '1', 'bc_block_wool*14', 'bc_block_wool*14', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5644, 5644, '1', 'bc_block_wool*2', 'bc_block_wool*2', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5645, 5645, '1', 'bc_block_wool*3', 'bc_block_wool*3', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5646, 5646, '1', 'bc_block_wool*4', 'bc_block_wool*4', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5647, 5647, '1', 'bc_block_wool*5', 'bc_block_wool*5', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5648, 5648, '1', 'bc_block_wool*6', 'bc_block_wool*6', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5649, 5649, '1', 'bc_block_wool*7', 'bc_block_wool*7', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5650, 5650, '1', 'bc_block_wool*8', 'bc_block_wool*8', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5651, 5651, '1', 'bc_block_wool*9', 'bc_block_wool*9', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5652, 5652, '1', 'bc_stone*1', 'bc_stone*1', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5653, 5653, '1', 'bc_stone*10', 'bc_stone*10', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5654, 5654, '1', 'bc_stone*11', 'bc_stone*11', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5655, 5655, '1', 'bc_stone*12', 'bc_stone*12', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5656, 5656, '1', 'bc_stone*13', 'bc_stone*13', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5657, 5657, '1', 'bc_stone*14', 'bc_stone*14', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5658, 5658, '1', 'bc_stone*2', 'bc_stone*2', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5659, 5659, '1', 'bc_stone*3', 'bc_stone*3', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5660, 5660, '1', 'bc_stone*4', 'bc_stone*4', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5661, 5661, '1', 'bc_stone*5', 'bc_stone*5', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5662, 5662, '1', 'bc_stone*6', 'bc_stone*6', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5663, 5663, '1', 'bc_stone*7', 'bc_stone*7', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5664, 5664, '1', 'bc_stone*8', 'bc_stone*8', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5665, 5665, '1', 'bc_stone*9', 'bc_stone*9', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5666, 5666, '1', 'bc_metalcrate*1', 'bc_metalcrate*1', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5667, 5667, '1', 'bc_metalcrate*10', 'bc_metalcrate*10', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5668, 5668, '1', 'bc_metalcrate*11', 'bc_metalcrate*11', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5669, 5669, '1', 'bc_metalcrate*12', 'bc_metalcrate*12', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5670, 5670, '1', 'bc_metalcrate*13', 'bc_metalcrate*13', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5671, 5671, '1', 'bc_metalcrate*14', 'bc_metalcrate*14', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5672, 5672, '1', 'bc_metalcrate*2', 'bc_metalcrate*2', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5673, 5673, '1', 'bc_metalcrate*3', 'bc_metalcrate*3', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5674, 5674, '1', 'bc_metalcrate*4', 'bc_metalcrate*4', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5675, 5675, '1', 'bc_metalcrate*5', 'bc_metalcrate*5', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5676, 5676, '1', 'bc_metalcrate*6', 'bc_metalcrate*6', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5677, 5677, '1', 'bc_metalcrate*7', 'bc_metalcrate*7', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5678, 5678, '1', 'bc_metalcrate*8', 'bc_metalcrate*8', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5679, 5679, '1', 'bc_metalcrate*9', 'bc_metalcrate*9', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5680, 5680, '0', 'china_horse', 'china_horse', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5681, 5681, '0', 'prizetrophy_storieshero', 'prizetrophy_storieshero', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(5682, 5682, '0', 'book_rare*0', 'book_rare*0', 'S', 1, 1, 0.50, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5683, 5683, '0', 'book_rare*1', 'book_rare*1', 'S', 1, 1, 0.50, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5684, 5684, '0', 'book_rare*2', 'book_rare*2', 'S', 1, 1, 0.50, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5685, 5685, '0', 'book_rare*3', 'book_rare*3', 'S', 1, 1, 0.50, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5686, 5686, '0', 'book_rare*4', 'book_rare*4', 'S', 1, 1, 0.50, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5687, 5687, '0', 'book_rare*5', 'book_rare*5', 'S', 1, 1, 0.50, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5688, 5688, '0', 'book_rare*6', 'book_rare*6', 'S', 1, 1, 0.50, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5689, 5689, '0', 'book_rare*7', 'book_rare*7', 'S', 1, 1, 0.50, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5690, 5690, '0', 'book_rare*8', 'book_rare*8', 'S', 1, 1, 0.50, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5691, 5691, '0', 'book_rare*9', 'book_rare*9', 'S', 1, 1, 0.50, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5692, 5692, '1', 'val14_bench', 'val14_bench', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5693, 5693, '1', 'val14_table', 'val14_table', 'S', 1, 1, 1.10, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5694, 5694, '0', 'val14_rosebook', 'val14_rosebook', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(5695, 5695, '1', 'val14_stool', 'val14_stool', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5696, 5696, '1', 'val14_bed_g', 'val14_bed_g', 'S', 1, 3, 1.60, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(5697, 5697, '1', 'val14_b_roof', 'val14_b_roof', 'S', 1, 1, 1.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5698, 5698, '1', 'val14_gate', 'val14_gate', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(5699, 5699, '1', 'val14_tile2', 'val14_tile2', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(5700, 5700, '1', 'val14_bed_o', 'val14_bed_o', 'S', 1, 3, 1.60, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(5701, 5701, '0', 'val14_wchair', 'val14_wchair', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5702, 5702, '1', 'val14_tile3', 'val14_tile3', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(5703, 5703, '1', 'val14_g_roof', 'val14_g_roof', 'S', 1, 1, 1.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5704, 5704, '1', 'val14_bigplant1', 'val14_bigplant1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(5705, 5705, '1', 'val14_pot1', 'val14_pot1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 6, '', '', '', 0, 0, ''),
	(5706, 5706, '1', 'val14_fbath', 'val14_fbath', 'S', 1, 2, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(5707, 5707, '1', 'val14_largetile', 'val14_largetile', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5708, 5708, '1', 'val14_tile1', 'val14_tile1', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(5709, 5709, '1', 'val14_y_roof', 'val14_y_roof', 'S', 1, 1, 1.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5710, 5710, '1', 'val14_archway', 'val14_archway', 'S', 3, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5711, 5711, '1', 'val14_door', 'val14_door', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(5712, 5712, '1', 'val14_recchair', 'val14_recchair', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5713, 5713, '1', 'val14_bed_b', 'val14_bed_b', 'S', 1, 3, 1.60, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(5714, 5714, '1', 'val14_bigplant2', 'val14_bigplant2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(5715, 5715, '1', 'val14_b_wall', 'val14_b_wall', 'S', 2, 1, 2.85, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(5716, 5716, '1', 'val14_g_wall', 'val14_g_wall', 'S', 2, 1, 2.85, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(5717, 5717, '1', 'val14_y_wall', 'val14_y_wall', 'S', 2, 1, 2.85, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(5718, 5718, '0', 'val14_lovelock1', 'val14_lovelock1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'love_lock', 1, '', '', '', 0, 0, ''),
	(5719, 5719, '0', 'val14_lovelock2', 'val14_lovelock2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'love_lock', 1, '', '', '', 0, 0, ''),
	(5720, 5720, '0', 'prizetrophy_room2*1', 'prizetrophy_room2*1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(5721, 5721, '0', 'prizetrophy_room2*2', 'prizetrophy_room2*2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(5722, 5722, '0', 'prizetrophy_room2*3', 'prizetrophy_room2*3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(5723, 5723, '0', 'prizetrophy_hotel1*1', 'prizetrophy_hotel1*1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(5724, 5724, '0', 'prizetrophy_hotel1*2', 'prizetrophy_hotel1*2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(5725, 5725, '0', 'prizetrophy_hotel1*3', 'prizetrophy_hotel1*3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(5726, 5726, '0', 'rare_pbag*0', 'rare_pbag*0', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5727, 5727, '0', 'rare_pbag*1', 'rare_pbag*1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5728, 5728, '0', 'rare_pbag*2', 'rare_pbag*2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5729, 5729, '0', 'rare_pbag*3', 'rare_pbag*3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5730, 5730, '0', 'rare_pbag*4', 'rare_pbag*4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5731, 5731, '0', 'rare_pbag*5', 'rare_pbag*5', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5732, 5732, '0', 'rare_pbag*6', 'rare_pbag*6', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5733, 5733, '0', 'br_phoenix', 'br_phoenix', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5734, 5734, '0', 'val14_lamp', 'val14_lamp', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5735, 5735, '1', 'stories_shakespeare_tree', 'stories_shakespeare_tree', 'S', 2, 2, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5736, 5736, '1', 'stories_shakespeare_swing', 'stories_shakespeare_swing', 'S', 2, 1, 1.70, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5737, 5737, '1', 'stories_shakespeare_bench', 'stories_shakespeare_bench', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5738, 5738, '1', 'stories_shakespeare_fairy', 'stories_shakespeare_fairy', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5739, 5739, '0', 'hlympic_bear', 'hlympic_bear', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5740, 5740, '0', 'val14_fountain', 'val14_fountain', 'S', 1, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(5741, 5741, '0', 'portabandeira', 'portabandeira', 'S', 4, 4, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5742, 5742, '0', 'val14_lovelock3', 'val14_lovelock3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'love_lock', 1, '', '', '', 0, 0, ''),
	(5743, 5743, '0', 'runway_camera', 'runway_camera', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5744, 5744, '0', 'ads_nick_geyeser', 'ads_nick_geyeser', 'S', 5, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5745, 5745, '0', 'ads_nick_faketile', 'ads_nick_faketile', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5746, 5746, '1', 'runway_hangingb', 'runway_hangingb', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5747, 5747, '1', 'runway_umbrellalight', 'runway_umbrellalight', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5748, 5748, '1', 'runway_fan', 'runway_fan', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(5749, 5749, '1', 'runway_changing', 'runway_changing', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5750, 5750, '0', 'rare_sage', 'rare_sage', 'S', 1, 1, 0.20, '0', '0', '0', '1', '1', '1', '0', '1', '1', 'pressureplate', 4, '', '', '', 0, 0, ''),
	(5751, 5751, '0', 'runway_oldecamera', 'runway_oldecamera', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5752, 5752, '0', 'runway_changingrare', 'runway_changingrare', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5753, 5753, '0', 'rare_stpat14', 'rare_stpat14', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(5754, 5754, '0', 'nest_leprechaun', 'nest_leprechaun', 'S', 2, 2, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5755, 5755, '0', 'nest_gnome', 'nest_gnome', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5756, 5756, '0', 'leprechaun_box', 'leprechaun_box', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5757, 5757, '0', 'newbie_stairs_pink', 'newbie_stairs_pink', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 3, '', '0.5;1.2;1.8', '', 0, 0, ''),
	(5758, 5758, '0', 'newbie_stairs_black', 'newbie_stairs_black', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 3, '', '0.5;1.2;1.8', '', 0, 0, ''),
	(5759, 5759, '0', 'newbie_present_2014', 'newbie_present_2014', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5760, 5760, '0', 'newbie_eleblock5', 'newbie_eleblock5', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '0;0.5;1;1.5;2', '', 0, 0, ''),
	(5761, 5761, '0', 'newbie_eleblock1', 'newbie_eleblock1', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '0;0.5;1;1.5;2', '', 0, 0, ''),
	(5762, 5762, '1', 'stories_sch_book', 'stories_sch_book', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5763, 5763, '1', 'stories_sch_hourglass', 'stories_sch_hourglass', 'S', 1, 1, 1.50, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5764, 5764, '0', 'LTD_fashionistam', 'LTD_fashionistam', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5765, 5765, '0', 'LTD_fashionistaf', 'LTD_fashionistaf', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5766, 5766, '0', 'effect_faketile', 'effect_faketile', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5767, 5767, '1', 'bc_block_water*1', 'bc_block_water*1', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5768, 5768, '1', 'bc_block_water*2', 'bc_block_water*2', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5769, 5769, '1', 'bc_block_water*3', 'bc_block_water*3', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5770, 5770, '1', 'bc_block_water*4', 'bc_block_water*4', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5771, 5771, '1', 'bc_block_water*5', 'bc_block_water*5', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5772, 5772, '1', 'bc_block_water*6', 'bc_block_water*6', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5773, 5773, '1', 'bc_tile*1', 'bc_tile*1', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5774, 5774, '1', 'bc_tile*10', 'bc_tile*10', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5775, 5775, '1', 'bc_tile*11', 'bc_tile*11', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5776, 5776, '1', 'bc_tile*12', 'bc_tile*12', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5777, 5777, '1', 'bc_tile*13', 'bc_tile*13', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5778, 5778, '1', 'bc_tile*14', 'bc_tile*14', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5779, 5779, '1', 'bc_tile*2', 'bc_tile*2', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5780, 5780, '1', 'bc_tile*3', 'bc_tile*3', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5781, 5781, '1', 'bc_tile*4', 'bc_tile*4', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5782, 5782, '1', 'bc_tile*5', 'bc_tile*5', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5783, 5783, '1', 'bc_tile*6', 'bc_tile*6', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5784, 5784, '1', 'bc_tile*7', 'bc_tile*7', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5785, 5785, '1', 'bc_tile*8', 'bc_tile*8', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5786, 5786, '1', 'bc_tile*9', 'bc_tile*9', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5787, 5787, '1', 'bc_terra*1', 'bc_terra*1', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5788, 5788, '1', 'bc_terra*10', 'bc_terra*10', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5789, 5789, '1', 'bc_terra*11', 'bc_terra*11', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5790, 5790, '1', 'bc_terra*12', 'bc_terra*12', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5791, 5791, '1', 'bc_terra*13', 'bc_terra*13', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5792, 5792, '1', 'bc_terra*14', 'bc_terra*14', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5793, 5793, '1', 'bc_terra*2', 'bc_terra*2', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5794, 5794, '1', 'bc_terra*3', 'bc_terra*3', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5795, 5795, '1', 'bc_terra*4', 'bc_terra*4', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5796, 5796, '1', 'bc_terra*5', 'bc_terra*5', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5797, 5797, '1', 'bc_terra*6', 'bc_terra*6', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5798, 5798, '1', 'bc_terra*7', 'bc_terra*7', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5799, 5799, '1', 'bc_terra*8', 'bc_terra*8', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5800, 5800, '1', 'bc_terra*9', 'bc_terra*9', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5801, 5801, '1', 'bc_flowerhedge*1', 'bc_flowerhedge*1', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5802, 5802, '1', 'bc_flowerhedge*10', 'bc_flowerhedge*10', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5803, 5803, '1', 'bc_flowerhedge*11', 'bc_flowerhedge*11', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5804, 5804, '1', 'bc_flowerhedge*12', 'bc_flowerhedge*12', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5805, 5805, '1', 'bc_flowerhedge*13', 'bc_flowerhedge*13', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5806, 5806, '1', 'bc_flowerhedge*14', 'bc_flowerhedge*14', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5807, 5807, '1', 'bc_flowerhedge*2', 'bc_flowerhedge*2', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5808, 5808, '1', 'bc_flowerhedge*3', 'bc_flowerhedge*3', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5809, 5809, '1', 'bc_flowerhedge*4', 'bc_flowerhedge*4', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5810, 5810, '1', 'bc_flowerhedge*5', 'bc_flowerhedge*5', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5811, 5811, '1', 'bc_flowerhedge*6', 'bc_flowerhedge*6', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5812, 5812, '1', 'bc_flowerhedge*7', 'bc_flowerhedge*7', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5813, 5813, '1', 'bc_flowerhedge*8', 'bc_flowerhedge*8', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5814, 5814, '1', 'bc_flowerhedge*9', 'bc_flowerhedge*9', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5815, 5815, '1', 'stories_sch_chair', 'stories_sch_chair', 'S', 1, 1, 1.30, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5816, 5816, '1', 'stories_sch_bookshelf', 'stories_sch_bookshelf', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(5817, 5817, '0', 'easter14_chocchestrare', 'easter14_chocchestrare', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5818, 5818, '0', 'free_placement_room', 'free_placement_room', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5819, 5819, '0', 'easter14_plant', 'easter14_plant', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5820, 5820, '0', 'easter14_elecdivdr', 'easter14_elecdivdr', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5821, 5821, '0', 'easter14_jar', 'easter14_jar', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5822, 5822, '0', 'easter14_pillar', 'easter14_pillar', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5823, 5823, '0', 'easter14_block3', 'easter14_block3', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5824, 5824, '0', 'easter14_block1', 'easter14_block1', 'S', 2, 1, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(5825, 5825, '0', 'easter14_metalfloor', 'easter14_metalfloor', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(5826, 5826, '0', 'easter14_lamp', 'easter14_lamp', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5827, 5827, '0', 'easter14_roombg', 'easter14_roombg', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5828, 5828, '0', 'easter14_corner', 'easter14_corner', 'S', 1, 1, 0.60, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5829, 5829, '1', 'easter14_captainchr', 'easter14_captainchr', 'S', 1, 1, 1.45, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5830, 5830, '0', 'easter14_flower', 'easter14_flower', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5831, 5831, '0', 'easter14_palmtree', 'easter14_palmtree', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine_no_sides', 2, '1050', '', '', 0, 0, ''),
	(5832, 5832, '0', 'easter14_teleport', 'easter14_teleport', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'teleport', 1, '', '', '', 0, 0, ''),
	(5833, 5833, '0', 'easter14_eggplant', 'easter14_eggplant', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5834, 5834, '0', 'easter14_gate', 'easter14_gate', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(5835, 5835, '0', 'easter14_divider', 'easter14_divider', 'S', 2, 1, 0.60, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5836, 5836, '0', 'easter14_block2', 'easter14_block2', 'S', 2, 1, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(5837, 5837, '0', 'easter14_block4', 'easter14_block4', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5838, 5838, '0', 'easter14_techtreebrkn', 'easter14_techtreebrkn', 'S', 2, 1, 2.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5839, 5839, '0', 'easter14_sandfloor', 'easter14_sandfloor', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 7, '', '', '', 0, 0, ''),
	(5840, 5840, '0', 'easter14_chair', 'easter14_chair', 'S', 1, 1, 1.05, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5841, 5841, '0', 'easter14_grasspatch', 'easter14_grasspatch', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5842, 5842, '0', 'easter14_techstump', 'easter14_techstump', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5843, 5843, '0', 'easter14_table', 'easter14_table', 'S', 2, 1, 0.80, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(5844, 5844, '0', 'easter14_effectgiver', 'easter14_effectgiver', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'effect_tile', 1, '', '', '', 171, 171, ''),
	(5845, 5845, '0', 'easter14_eleccrn', 'easter14_eleccrn', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5846, 5846, '0', 'easter14_screen', 'easter14_screen', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5847, 5847, '0', 'easter14_statue', 'easter14_statue', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5848, 5848, '0', 'easter14_bunnysphinx', 'easter14_bunnysphinx', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5849, 5849, '0', 'easter14_eggstar', 'easter14_eggstar', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5850, 5850, '0', 'ltd_habberge3', 'ltd_habberge3', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5851, 5851, '0', 'ltd_habberge2', 'ltd_habberge2', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5852, 5852, '0', 'ltd_habberge4', 'ltd_habberge4', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5853, 5853, '0', 'ltd_habberge5', 'ltd_habberge5', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5854, 5854, '0', 'wf_act_mute_triggerer', 'wf_act_mute_triggerer', 'S', 1, 1, 0.65, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'wf_act_mute_triggerer', 1, '', '', '', 0, 0, ''),
	(5855, 5855, '0', 'ltd_habberge1', 'ltd_habberge1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5856, 5856, '0', 'easter14_habberge6', 'easter14_habberge6', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5857, 5857, '1', 'stories_oldmusic_neon', 'stories_oldmusic_neon', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5858, 5858, '1', 'stories_oldmusic_vinyl', 'stories_oldmusic_vinyl', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5859, 5859, '1', 'stories_oldmusic_guitarcase', 'stories_oldmusic_guitarcase', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5860, 5860, '1', 'stories_oldmusic_mike', 'stories_oldmusic_mike', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5861, 5861, '0', 'wf_cnd_date_rng_active', 'wf_cnd_date_rng_active', 'S', 1, 1, 0.65, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'wf_cnd_date_rng_active', 1, '', '', '', 0, 0, ''),
	(5862, 5862, '0', 'rare_venusstatue', 'rare_venusstatue', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5863, 5863, '0', 'guild_forum', 'guild_forum', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'guild_furni', 1, '', '', '', 0, 0, ''),
	(5864, 5864, '1', 'vikings_table_r', 'vikings_table_r', 'S', 3, 1, 1.10, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5865, 5865, '1', 'vikings_chair_g', 'vikings_chair_g', 'S', 1, 1, 1.30, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5866, 5866, '1', 'vikings_torch', 'vikings_torch', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5867, 5867, '1', 'vikings_bed', 'vikings_bed', 'S', 1, 3, 1.80, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(5868, 5868, '1', 'vikings_house', 'vikings_house', 'S', 2, 2, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'viking_cotie', 7, '', '', '', 0, 0, ''),
	(5869, 5869, '1', 'vikings_spike', 'vikings_spike', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 12, '', '', '', 0, 0, ''),
	(5870, 5870, '1', 'vikings_wooddivdr', 'vikings_wooddivdr', 'S', 2, 1, 1.10, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5871, 5871, '1', 'vikings_floor', 'vikings_floor', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5872, 5872, '1', 'vikings_woodgate', 'vikings_woodgate', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(5873, 5873, '1', 'vikings_flag_r', 'vikings_flag_r', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5874, 5874, '1', 'vikings_stonecrn', 'vikings_stonecrn', 'S', 1, 1, 1.25, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5875, 5875, '1', 'vikings_animal_r', 'vikings_animal_r', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5876, 5876, '1', 'vikings_basket1', 'vikings_basket1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine_no_sides', 2, '3,36,37', '', '', 0, 0, ''),
	(5877, 5877, '1', 'vikings_stonedivdr', 'vikings_stonedivdr', 'S', 1, 1, 1.10, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5878, 5878, '1', 'vikings_outdoorstove', 'vikings_outdoorstove', 'S', 1, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5879, 5879, '1', 'vikings_weapon', 'vikings_weapon', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'effect_vendingmachine', 2, '162', '', '', 0, 0, ''),
	(5880, 5880, '1', 'vikings_animal_g', 'vikings_animal_g', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5881, 5881, '1', 'vikings_indoorstove', 'vikings_indoorstove', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5882, 5882, '1', 'vikings_roof_r', 'vikings_roof_r', 'S', 1, 1, 1.50, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(5883, 5883, '1', 'vikings_gondola1', 'vikings_gondola1', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5884, 5884, '1', 'vikings_basket2', 'vikings_basket2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine_no_sides', 2, '34,70,1035,1040', '', '', 0, 0, ''),
	(5885, 5885, '1', 'vikings_table_g', 'vikings_table_g', 'S', 1, 1, 1.10, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5886, 5886, '1', 'vikings_gondola2b', 'vikings_gondola2b', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5887, 5887, '1', 'vikings_woodcrn', 'vikings_woodcrn', 'S', 1, 1, 1.19, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5888, 5888, '1', 'vikings_gondola3', 'vikings_gondola3', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5889, 5889, '0', 'vikings_teleport', 'vikings_teleport', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'teleport', 1, '', '', '', 0, 0, ''),
	(5890, 5890, '1', 'vikings_flag_g', 'vikings_flag_g', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5891, 5891, '1', 'vikings_gondola2c', 'vikings_gondola2c', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5892, 5892, '1', 'vikings_roof_g', 'vikings_roof_g', 'S', 1, 1, 1.50, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5893, 5893, '1', 'vikings_chair_r', 'vikings_chair_r', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5894, 5894, '0', 'vikings_tombstone', 'vikings_tombstone', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5895, 5895, '1', 'vikings_stonegate', 'vikings_stonegate', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(5896, 5896, '1', 'vikings_stool', 'vikings_stool', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5897, 5897, '1', 'vikings_gondola2a', 'vikings_gondola2a', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5898, 5898, '1', 'vikings_stove', 'vikings_stove', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(5899, 5899, '1', 'vikings_pillar', 'vikings_pillar', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5900, 5900, '1', 'bc_wood*1', 'bc_wood*1', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5901, 5901, '1', 'bc_wood*2', 'bc_wood*2', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5902, 5902, '1', 'bc_wood*3', 'bc_wood*3', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5903, 5903, '1', 'bc_wood*4', 'bc_wood*4', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5904, 5904, '1', 'bc_wood*5', 'bc_wood*5', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5905, 5905, '1', 'bc_wood*6', 'bc_wood*6', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5906, 5906, '0', 'vikings_runestone', 'vikings_runestone', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5907, 5907, '0', 'room_noob_walltl', 'room_noob_walltl', 'S', 1, 9, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5908, 5908, '0', 'room_noob_bar', 'room_noob_bar', 'S', 1, 6, 1.10, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5909, 5909, '0', 'room_noob_walltr1', 'room_noob_walltr1', 'S', 7, 2, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5910, 5910, '0', 'room_noob_table1', 'room_noob_table1', 'S', 1, 1, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5911, 5911, '0', 'room_noob_carpet1', 'room_noob_carpet1', 'S', 3, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5912, 5912, '0', 'room_noob_fxremove', 'room_noob_fxremove', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5913, 5913, '0', 'room_noob_barchair', 'room_noob_barchair', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5914, 5914, '0', 'room_noob_fx1', 'room_noob_fx1', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5915, 5915, '0', 'room_noob_table2', 'room_noob_table2', 'S', 1, 1, 0.80, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5916, 5916, '0', 'room_noob_stairside', 'room_noob_stairside', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5917, 5917, '0', 'room_noob_walltr2', 'room_noob_walltr2', 'S', 8, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5918, 5918, '0', 'room_noob_tallfloor', 'room_noob_tallfloor', 'S', 5, 1, 2.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5919, 5919, '0', 'room_noob_floor1', 'room_noob_floor1', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(5920, 5920, '0', 'room_noob_stairs', 'room_noob_stairs', 'S', 5, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 2, '', '0.5;1.0', '', 0, 0, ''),
	(5921, 5921, '0', 'room_noob_fx2', 'room_noob_fx2', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'tile_fxprovider_nfs', 2, '', '', '', 2, 2, ''),
	(5922, 5922, '0', 'room_noob_barside', 'room_noob_barside', 'S', 1, 1, 1.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(5923, 5923, '0', 'room_noob_sofa', 'room_noob_sofa', 'S', 3, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5924, 5924, '0', 'room_noob_glow', 'room_noob_glow', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5925, 5925, '0', 'room_noob_plant', 'room_noob_plant', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5926, 5926, '0', 'room_noob_wallcrnr', 'room_noob_wallcrnr', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5927, 5927, '0', 'room_noob_wallbl3', 'room_noob_wallbl3', 'S', 1, 14, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5928, 5928, '0', 'room_noob_hanglight', 'room_noob_hanglight', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5929, 5929, '0', 'room_noob_wallbl1', 'room_noob_wallbl1', 'S', 1, 7, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5930, 5930, '0', 'room_noob_div', 'room_noob_div', 'S', 7, 1, 3.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5931, 5931, '0', 'room_noob_floor3', 'room_noob_floor3', 'S', 8, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5932, 5932, '0', 'room_noob_floor2', 'room_noob_floor2', 'S', 2, 2, 0.10, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(5933, 5933, '0', 'room_noob_chair', 'room_noob_chair', 'S', 1, 1, 2.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5934, 5934, '0', 'room_noob_bargate', 'room_noob_bargate', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(5935, 5935, '0', 'room_noob_wallbl2', 'room_noob_wallbl2', 'S', 1, 15, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5936, 5936, '0', 'room_noob_pool', 'room_noob_pool', 'S', 3, 4, 0.10, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5937, 5937, '0', 'room_noob_fx4', 'room_noob_fx4', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5938, 5938, '0', 'room_noob_fx3', 'room_noob_fx3', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5939, 5939, '0', 'wf_blob_invis', 'wf_blob_invis', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '1', '1', 'wf_blob', 2, '', '', '1,true', 0, 0, ''),
	(5940, 5940, '0', 'wf_blob2_vis', 'wf_blob2_vis', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'wf_blob', 2, '', '', '5,true', 0, 0, ''),
	(5941, 5941, '0', 'vikings_throne', 'vikings_throne', 'S', 1, 1, 1.70, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5942, 5942, '0', 'vikings_yggdrasil', 'vikings_yggdrasil', 'S', 2, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5943, 5943, '0', 'vikings_thor', 'vikings_thor', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5944, 5944, '0', 'vikings_chesspiece', 'vikings_chesspiece', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5945, 5945, '0', 'tablet_vendor', 'tablet_vendor', 'S', 1, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '1030', '', '', 0, 0, ''),
	(5946, 5946, '0', 'CF_500_vikings', 'CF_500_vikings', 'S', 1, 1, 0.00, '0', '0', '0', '0', '0', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5947, 5947, '0', 'ads_dtlrare_rc', 'ads_dtlrare_rc', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '1052', '', '', 0, 0, ''),
	(5948, 5948, '0', 'room_noob_exit', 'room_noob_exit', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5949, 5949, '0', 'fball_goldenboot', 'fball_goldenboot', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5950, 5950, '0', 'fball_grp_crnr', 'fball_grp_crnr', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5951, 5951, '0', 'fball_trophybrasil_silver', 'fball_trophybrasil_silver', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5952, 5952, '1', 'fball_ball6', 'fball_ball6', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'football', 2, '', '', '', 0, 0, ''),
	(5953, 5953, '0', 'fball_trophybrasil_bronze', 'fball_trophybrasil_bronze', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5954, 5954, '0', 'fball_trophybrasil_gold', 'fball_trophybrasil_gold', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5955, 5955, '0', 'fball_grp_fnc1', 'fball_grp_fnc1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5956, 5956, '0', 'fball_grp_cote', 'fball_grp_cote', 'S', 1, 3, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5957, 5957, '0', 'fball_grp_bench', 'fball_grp_bench', 'S', 3, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5958, 5958, '0', 'fball_grp_fnc3', 'fball_grp_fnc3', 'S', 3, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5959, 5959, '1', 'fball_audbench2', 'fball_audbench2', 'S', 4, 1, 0.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 3, '', '1.2;1.9;2.5', '', 0, 0, ''),
	(5960, 5960, '0', 'stories_football_board', 'stories_football_board', 'S', 3, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(5961, 5961, '0', 'stories_football_table', 'stories_football_table', 'S', 3, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5962, 5962, '0', 'fball_flag_grp', 'fball_flag_grp', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5963, 5963, '0', 'fball_goldenboot2', 'fball_goldenboot2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5964, 5964, '0', 'fball_mascot', 'fball_mascot', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5965, 5965, '0', 'fball_scales', 'fball_scales', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'pressureplate', 2, '', '', '', 0, 0, ''),
	(5966, 5966, '0', 'CF_diamond_1000', 'CF_diamond_1000', 'S', 1, 1, 0.00, '0', '0', '0', '0', '0', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(5967, 5967, '0', 'CF_diamond_500', 'CF_diamond_500', 'S', 1, 1, 0.00, '0', '0', '0', '0', '0', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(5968, 5968, '0', 'CF_diamond_250', 'CF_diamond_250', 'S', 1, 1, 0.00, '0', '0', '0', '0', '0', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(5969, 5969, '0', 'CF_diamond_100', 'CF_diamond_100', 'S', 1, 1, 0.00, '0', '0', '0', '0', '0', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(5970, 5970, '0', 'CF_diamond_2500', 'CF_diamond_2500', 'S', 1, 1, 0.00, '0', '0', '0', '0', '0', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5971, 5971, '0', 'stories_football_screen', 'stories_football_screen', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5972, 5972, '0', 'fball_ltd14', 'fball_ltd14', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5973, 5973, '0', 'prizetrophy_fballbrazil*1', 'prizetrophy_fballbrazil*1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(5974, 5974, '0', 'prizetrophy_fballbrazil*2', 'prizetrophy_fballbrazil*2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(5975, 5975, '0', 'prizetrophy_fballbrazil*3', 'prizetrophy_fballbrazil*3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(5976, 5976, '0', 'gift_mysterytrophy', 'gift_mysterytrophy', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5977, 5977, '0', 'hblooza14_hotair_b', 'hblooza14_hotair_b', 'S', 1, 1, 7.00, '0', '1', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5978, 5978, '0', 'hblooza14_hotair_y', 'hblooza14_hotair_y', 'S', 1, 1, 7.00, '0', '1', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5979, 5979, '0', 'hblooza14_bundkiosk', 'hblooza14_bundkiosk', 'S', 1, 2, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5980, 5980, '0', 'hblooza14_hotair_p', 'hblooza14_hotair_p', 'S', 1, 1, 7.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5981, 5981, '1', 'hblooza14_tent', 'hblooza14_tent', 'S', 5, 5, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'tent', 1, '', '', '', 0, 0, ''),
	(5982, 5982, '0', 'hblooza14_drinkstall', 'hblooza14_drinkstall', 'S', 1, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '6,24,30,32,57,66,67,72', '', '', 0, 0, ''),
	(5983, 5983, '1', 'hblooza14_shotgall', 'hblooza14_shotgall', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'effect_vendingmachine', 2, '164', '', '', 0, 0, ''),
	(5984, 5984, '1', 'hblooza14_duckhook', 'hblooza14_duckhook', 'S', 2, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine_no_sides', 2, '1053', '', '', 0, 0, ''),
	(5985, 5985, '0', 'hblooza14_pinata2', 'hblooza14_pinata2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(5986, 5986, '1', 'hblooza14_hedgediv', 'hblooza14_hedgediv', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(5987, 5987, '1', 'hblooza14_duckgate', 'hblooza14_duckgate', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(5988, 5988, '0', 'hblooza14_tele', 'hblooza14_tele', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'teleport', 2, '', '', '', 0, 0, ''),
	(5989, 5989, '0', 'hblooza14_duck_balloon_y', 'hblooza14_duck_balloon_y', 'S', 2, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5990, 5990, '0', 'hblooza14_pinata1', 'hblooza14_pinata1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(5991, 5991, '1', 'hblooza14_flowerlight', 'hblooza14_flowerlight', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5992, 5992, '1', 'hblooza14_flagpole', 'hblooza14_flagpole', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5993, 5993, '0', 'hblooza14_hctele', 'hblooza14_hctele', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'teleport', 1, '', '', '', 0, 0, ''),
	(5994, 5994, '1', 'hblooza14_rollercost', 'hblooza14_rollercost', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5995, 5995, '1', 'hblooza14_duckdvdr', 'hblooza14_duckdvdr', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5996, 5996, '0', 'hblooza14_cafe_y', 'hblooza14_cafe_y', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '85,86', '', '', 0, 0, ''),
	(5997, 5997, '1', 'hblooza14_duckhookhc', 'hblooza14_duckhookhc', 'S', 2, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine_no_sides', 2, '1036', '', '', 0, 0, ''),
	(5998, 5998, '1', 'hblooza14_flagpole_p', 'hblooza14_flagpole_p', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(5999, 5999, '0', 'hblooza14_horsecarop', 'hblooza14_horsecarop', 'S', 1, 1, 2.80, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6000, 6000, '0', 'hblooza14_candystall', 'hblooza14_candystall', 'S', 1, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '48,63,79,80,84', '', '', 0, 0, ''),
	(6001, 6001, '0', 'hblooza14_pinata3', 'hblooza14_pinata3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(6002, 6002, '1', 'hblooza14_ballsign', 'hblooza14_ballsign', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6003, 6003, '0', 'hblooza14_horsecaroy', 'hblooza14_horsecaroy', 'S', 1, 1, 2.80, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6004, 6004, '1', 'hblooza14_planepadr', 'hblooza14_planepadr', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'effect_tile', 2, '', '', '', 175, 175, ''),
	(6005, 6005, '0', 'hblooza14_duck_balloon_p', 'hblooza14_duck_balloon_p', 'S', 2, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6006, 6006, '0', 'hblooza14_cafe_b', 'hblooza14_cafe_b', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '85,86', '', '', 0, 0, ''),
	(6007, 6007, '0', 'hblooza14_duck_balloon_b', 'hblooza14_duck_balloon_b', 'S', 2, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6008, 6008, '1', 'hblooza14_flag_p', 'hblooza14_flag_p', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6009, 6009, '1', 'hblooza14_flag_y', 'hblooza14_flag_y', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6010, 6010, '0', 'hblooza14_arrowsign', 'hblooza14_arrowsign', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6011, 6011, '1', 'hblooza14_dance', 'hblooza14_dance', 'S', 1, 1, 0.10, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 140, 140, ''),
	(6012, 6012, '1', 'hblooza14_table', 'hblooza14_table', 'S', 1, 1, 1.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6013, 6013, '1', 'hblooza14_hedgecrn', 'hblooza14_hedgecrn', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6014, 6014, '1', 'hblooza14_duckcrn', 'hblooza14_duckcrn', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6015, 6015, '1', 'hblooza14_stool', 'hblooza14_stool', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6016, 6016, '1', 'hblooza14_flag_b', 'hblooza14_flag_b', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6017, 6017, '0', 'hblooza14_cafe_p', 'hblooza14_cafe_p', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '85,86', '', '', 0, 0, ''),
	(6018, 6018, '1', 'hblooza14_mud', 'hblooza14_mud', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6019, 6019, '1', 'hblooza14_arch', 'hblooza14_arch', 'S', 2, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6020, 6020, '1', 'hblooza14_planepadb', 'hblooza14_planepadb', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'effect_tile', 2, '', '', '', 176, 176, ''),
	(6021, 6021, '0', 'hblooza14_horsecarob', 'hblooza14_horsecarob', 'S', 1, 1, 2.80, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6022, 6022, '1', 'st_palooza_cake', 'st_palooza_cake', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6023, 6023, '0', 'st_palooza_unicorn', 'st_palooza_unicorn', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6024, 6024, '1', 'st_palooza_cupcakes', 'st_palooza_cupcakes', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6025, 6025, '1', 'hblooza14_track_crl', 'hblooza14_track_crl', 'S', 1, 1, 0.20, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'roller', 2, '', '', '', 0, 0, ''),
	(6026, 6026, '1', 'hblooza14_track', 'hblooza14_track', 'S', 1, 1, 0.20, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'roller', 2, '', '', '', 0, 0, ''),
	(6027, 6027, '1', 'hblooza14_track_crr', 'hblooza14_track_crr', 'S', 1, 1, 0.20, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'roller', 2, '', '', '', 0, 0, ''),
	(6028, 6028, '0', 'hblooza14_pinata4', 'hblooza14_pinata4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(6029, 6029, '0', 'st_palooza_screen', 'st_palooza_screen', 'S', 3, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6030, 6030, '1', 'st_palooza_balloons', 'st_palooza_balloons', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine_no_sides', 2, '1054,1055,1056,1057', '', '', 0, 0, ''),
	(6031, 6031, '1', 'st_palooza_pool', 'st_palooza_pool', 'S', 2, 2, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6032, 6032, '0', 'wildwest_minecart', 'wildwest_minecart', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(6033, 6033, '0', 'wildwest_teleport', 'wildwest_teleport', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'teleport', 1, '', '', '', 0, 0, ''),
	(6034, 6034, '0', 'wildwest_piano', 'wildwest_piano', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6035, 6035, '1', 'wildwest_floor', 'wildwest_floor', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 8, '', '', '', 0, 0, ''),
	(6036, 6036, '0', 'wildwest_milkcan', 'wildwest_milkcan', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(6037, 6037, '1', 'wildwest_bank', 'wildwest_bank', 'S', 1, 3, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6038, 6038, '0', 'wildwest_sofa', 'wildwest_sofa', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6039, 6039, '1', 'wildwest_desk', 'wildwest_desk', 'S', 2, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6040, 6040, '1', 'wildwest_pump', 'wildwest_pump', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '87', '', '', 0, 0, ''),
	(6041, 6041, '1', 'wildwest_vulture', 'wildwest_vulture', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6042, 6042, '1', 'wildwest_salooncrn', 'wildwest_salooncrn', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6043, 6043, '1', 'wildwest_floor2', 'wildwest_floor2', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 8, '', '', '', 0, 0, ''),
	(6044, 6044, '1', 'wildwest_chair', 'wildwest_chair', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6045, 6045, '1', 'wildwest_cactus1', 'wildwest_cactus1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6046, 6046, '1', 'wildwest_stagew2', 'wildwest_stagew2', 'S', 1, 2, 0.30, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6047, 6047, '1', 'wildwest_cactus2', 'wildwest_cactus2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6048, 6048, '0', 'wildwest_wagon', 'wildwest_wagon', 'S', 2, 2, 2.55, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6049, 6049, '1', 'wildwest_roofr', 'wildwest_roofr', 'S', 1, 3, 0.30, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6050, 6050, '1', 'wildwest_stager2', 'wildwest_stager2', 'S', 1, 2, 0.30, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6051, 6051, '1', 'wildwest_spittoon2', 'wildwest_spittoon2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6052, 6052, '1', 'wildwest_roofw', 'wildwest_roofw', 'S', 1, 3, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6053, 6053, '1', 'wildwest_store', 'wildwest_store', 'S', 1, 3, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6054, 6054, '1', 'wildwest_bench', 'wildwest_bench', 'S', 2, 1, 1.40, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6055, 6055, '1', 'wildwest_saloondr', 'wildwest_saloondr', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 1, '', '', '', 0, 0, ''),
	(6056, 6056, '1', 'wildwest_divdr', 'wildwest_divdr', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6057, 6057, '1', 'wildwest_gate', 'wildwest_gate', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(6058, 6058, '0', 'wildwest_wanted_poster', 'wildwest_wanted_poster', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'love_lock', 2, '', '', '', 0, 0, ''),
	(6059, 6059, '0', 'wildwest_till', 'wildwest_till', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6060, 6060, '1', 'wildwest_spittoon', 'wildwest_spittoon', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6061, 6061, '1', 'wildwest_stocks', 'wildwest_stocks', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6062, 6062, '1', 'wildwest_light', 'wildwest_light', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '1058', '', '', 0, 0, ''),
	(6063, 6063, '0', 'wildwest_tarbucket', 'wildwest_tarbucket', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6064, 6064, '0', 'wildwest_tree', 'wildwest_tree', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6065, 6065, '1', 'wildwest_saloon', 'wildwest_saloon', 'S', 1, 3, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6066, 6066, '1', 'wildwest_cabinet', 'wildwest_cabinet', 'S', 3, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '88', '', '', 0, 0, ''),
	(6067, 6067, '1', 'wildwest_stageb', 'wildwest_stageb', 'S', 1, 1, 0.30, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6068, 6068, '1', 'wildwest_crn', 'wildwest_crn', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6069, 6069, '1', 'wildwest_longhorn', 'wildwest_longhorn', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6070, 6070, '1', 'wildwest_clothesline', 'wildwest_clothesline', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6071, 6071, '0', 'wildwest_bgland', 'wildwest_bgland', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6072, 6072, '1', 'wildwest_crate', 'wildwest_crate', 'S', 1, 1, 1.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6073, 6073, '1', 'wildwest_weed', 'wildwest_weed', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'football', 2, '', '', '', 0, 0, ''),
	(6074, 6074, '0', 'wildwest_bgland2', 'wildwest_bgland2', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6075, 6075, '0', 'wildwest_bgtrain', 'wildwest_bgtrain', 'S', 15, 8, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6076, 6076, '1', 'wildwest_roofb', 'wildwest_roofb', 'S', 1, 3, 0.30, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6077, 6077, '1', 'wildwest_saloonwall', 'wildwest_saloonwall', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6078, 6078, '1', 'wildwest_sheriff', 'wildwest_sheriff', 'S', 1, 3, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6079, 6079, '1', 'wildwest_snake', 'wildwest_snake', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6080, 6080, '1', 'wildwest_table', 'wildwest_table', 'S', 1, 1, 1.40, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6081, 6081, '1', 'wildwest_stageb2', 'wildwest_stageb2', 'S', 1, 2, 0.30, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6082, 6082, '1', 'wildwest_stager', 'wildwest_stager', 'S', 1, 1, 0.30, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6083, 6083, '1', 'wildwest_stagew', 'wildwest_stagew', 'S', 1, 1, 0.30, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6084, 6084, '0', 'wildwest_gallows', 'wildwest_gallows', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6085, 6085, '0', 'st_wildwest_buffalo', 'st_wildwest_buffalo', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6086, 6086, '1', 'st_wildwest_cards', 'st_wildwest_cards', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6087, 6087, '1', 'st_wildwest_barrel', 'st_wildwest_barrel', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6088, 6088, '1', 'st_wildwest_tnt', 'st_wildwest_tnt', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6089, 6089, '1', 'st_wildwest_goldpick', 'st_wildwest_goldpick', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(6090, 6090, '1', 'st_wildwest_canteen', 'st_wildwest_canteen', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6091, 6091, '0', 'matic_light_cam_red', 'matic_light_cam_red', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6092, 6092, '0', 'matic_light_cam_blue', 'matic_light_cam_blue', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6093, 6093, '0', 'matic_light_cam_green', 'matic_light_cam_green', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6094, 6094, '0', 'matic_sanitizer', 'matic_sanitizer', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6095, 6095, '0', 'matic_light_cam_orange', 'matic_light_cam_orange', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6096, 6096, '1', 'uni_messwardrobe', 'uni_messwardrobe', 'S', 1, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6097, 6097, '1', 'uni_plush1', 'uni_plush1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6098, 6098, '0', 'uni_owl', 'uni_owl', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6099, 6099, '1', 'uni_ottoman', 'uni_ottoman', 'S', 2, 1, 1.40, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6100, 6100, '1', 'uni_drinks', 'uni_drinks', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(6101, 6101, '1', 'uni_brotein', 'uni_brotein', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6102, 6102, '1', 'uni_games', 'uni_games', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6103, 6103, '1', 'uni_girlchair', 'uni_girlchair', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6104, 6104, '1', 'uni_gamershelf', 'uni_gamershelf', 'S', 2, 1, 2.80, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6105, 6105, '1', 'uni_dumbells', 'uni_dumbells', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6106, 6106, '1', 'uni_doorhanging', 'uni_doorhanging', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6107, 6107, '1', 'uni_wardrobe', 'uni_wardrobe', 'S', 1, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6108, 6108, '1', 'uni_jewellery', 'uni_jewellery', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6109, 6109, '1', 'uni_plush2', 'uni_plush2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6110, 6110, '1', 'uni_cafeterie', 'uni_cafeterie', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6111, 6111, '0', 'uni_projector', 'uni_projector', 'S', 3, 3, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6112, 6112, '1', 'uni_rubik', 'uni_rubik', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6113, 6113, '1', 'uni_hipbed', 'uni_hipbed', 'S', 1, 3, 1.80, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(6114, 6114, '1', 'uni_laptop', 'uni_laptop', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6115, 6115, '1', 'uni_wobench', 'uni_wobench', 'S', 1, 3, 1.20, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'tile_fxprovider_nfs', 2, '', '', '', 0, 0, ''),
	(6116, 6116, '1', 'uni_fridge', 'uni_fridge', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '3,18,29,30,34,36,37', '', '', 0, 0, ''),
	(6117, 6117, '1', 'uni_bed', 'uni_bed', 'S', 1, 3, 1.80, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(6118, 6118, '1', 'uni_snacks', 'uni_snacks', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(6119, 6119, '1', 'uni_chair', 'uni_chair', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6120, 6120, '1', 'uni_messbed', 'uni_messbed', 'S', 1, 3, 1.80, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 2, '', '', '', 0, 0, ''),
	(6121, 6121, '1', 'uni_gamerdesk', 'uni_gamerdesk', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6122, 6122, '1', 'uni_pizza', 'uni_pizza', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 7, '', '', '', 0, 0, ''),
	(6123, 6123, '1', 'uni_manga', 'uni_manga', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6124, 6124, '1', 'uni_nstand', 'uni_nstand', 'S', 1, 1, 1.50, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6125, 6125, '1', 'uni_plushpile', 'uni_plushpile', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(6126, 6126, '1', 'uni_bookshelf', 'uni_bookshelf', 'S', 2, 1, 2.80, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6127, 6127, '1', 'uni_gamerbed', 'uni_gamerbed', 'S', 1, 3, 1.80, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 2, '', '', '', 0, 0, ''),
	(6128, 6128, '1', 'uni_hipbookcase', 'uni_hipbookcase', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6129, 6129, '1', 'uni_desk', 'uni_desk', 'S', 2, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6130, 6130, '1', 'uni_girlbed', 'uni_girlbed', 'S', 1, 3, 1.80, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(6131, 6131, '1', 'uni_alarm', 'uni_alarm', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6132, 6132, '0', 'uni_lectern', 'uni_lectern', 'S', 1, 1, 0.70, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6133, 6133, '1', 'uni_catrug', 'uni_catrug', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6134, 6134, '1', 'uni_trashcan', 'uni_trashcan', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 12, '', '', '', 0, 0, ''),
	(6135, 6135, '1', 'bathroom_bath3', 'bathroom_bath3', 'S', 1, 2, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6136, 6136, '1', 'bathroom_sinkmodule3', 'bathroom_sinkmodule3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '18', '', '', 0, 0, ''),
	(6137, 6137, '1', 'bathroom_tablemodule4', 'bathroom_tablemodule4', 'S', 1, 1, 1.40, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6138, 6138, '1', 'bathroom_sinkmodule2', 'bathroom_sinkmodule2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '18', '', '', 0, 0, ''),
	(6139, 6139, '1', 'bathroom_toilet4', 'bathroom_toilet4', 'S', 1, 1, 1.50, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6140, 6140, '1', 'bathroom_tablemodule1', 'bathroom_tablemodule1', 'S', 1, 1, 1.40, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6141, 6141, '1', 'bathroom_toilet1', 'bathroom_toilet1', 'S', 1, 1, 1.50, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6142, 6142, '1', 'bathroom_sinkmodule4', 'bathroom_sinkmodule4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '18', '', '', 0, 0, ''),
	(6143, 6143, '1', 'bathroom_bath2', 'bathroom_bath2', 'S', 1, 2, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6144, 6144, '1', 'bathroom_floortile2', 'bathroom_floortile2', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6145, 6145, '1', 'bathroom_toilet3', 'bathroom_toilet3', 'S', 1, 1, 1.50, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6146, 6146, '1', 'bathroom_floortile4', 'bathroom_floortile4', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6147, 6147, '1', 'bathroom_bath4', 'bathroom_bath4', 'S', 1, 2, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6148, 6148, '1', 'bathroom_shower1', 'bathroom_shower1', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6149, 6149, '1', 'bathroom_floortile3', 'bathroom_floortile3', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6150, 6150, '1', 'bathroom_bath1', 'bathroom_bath1', 'S', 1, 2, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6151, 6151, '1', 'bathroom_toilet2', 'bathroom_toilet2', 'S', 1, 1, 1.50, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6152, 6152, '1', 'bathroom_toiletroll', 'bathroom_toiletroll', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine_no_sides', 2, '1059', '', '', 0, 0, ''),
	(6153, 6153, '1', 'bathroom_shampoo', 'bathroom_shampoo', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 9, '', '', '', 0, 0, ''),
	(6154, 6154, '1', 'bathroom_floortile1', 'bathroom_floortile1', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6155, 6155, '1', 'bathroom_shower2', 'bathroom_shower2', 'S', 1, 1, 0.20, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6156, 6156, '1', 'bathroom_poop', 'bathroom_poop', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6157, 6157, '1', 'bathroom_shower4', 'bathroom_shower4', 'S', 1, 1, 0.20, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6158, 6158, '1', 'bathroom_chamberpot', 'bathroom_chamberpot', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6159, 6159, '1', 'bathroom_tablemodule2', 'bathroom_tablemodule2', 'S', 1, 1, 1.40, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6160, 6160, '1', 'bathroom_shower3', 'bathroom_shower3', 'S', 1, 1, 0.20, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6161, 6161, '1', 'bathroom_tablemodule3', 'bathroom_tablemodule3', 'S', 1, 1, 1.40, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6162, 6162, '1', 'bathroom_sinkmodule1', 'bathroom_sinkmodule1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '18', '', '', 0, 0, ''),
	(6163, 6163, '1', 'st_uni_dnamodel', 'st_uni_dnamodel', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6164, 6164, '1', 'st_uni_testtubes', 'st_uni_testtubes', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6165, 6165, '0', 'st_uni_labtable', 'st_uni_labtable', 'S', 1, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6166, 6166, '1', 'st_uni_ooze', 'st_uni_ooze', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6167, 6167, '0', 'uni_einstein', 'uni_einstein', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6168, 6168, '0', 'st_uni_solarsystem', 'st_uni_solarsystem', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6169, 6169, '0', 'matic_water_dispenser', 'matic_water_dispenser', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '18', '', '', 0, 0, ''),
	(6170, 6170, '0', 'matic_chair', 'matic_chair', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6171, 6171, '0', 'matic_brainjar', 'matic_brainjar', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6172, 6172, '0', 'matic_slime_duck', 'matic_slime_duck', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '1036', '', '', 0, 0, ''),
	(6173, 6173, '0', 'matic_door', 'matic_door', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(6174, 6174, '0', 'hween14_crn', 'hween14_crn', 'S', 1, 1, 2.40, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6175, 6175, '0', 'hween14_floor', 'hween14_floor', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6176, 6176, '0', 'hween14_catrina', 'hween14_catrina', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6177, 6177, '0', 'hween14_hccoffin', 'hween14_hccoffin', 'S', 1, 3, 1.00, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 6, '', '', '', 0, 0, ''),
	(6178, 6178, '0', 'hween14_skelepieces', 'hween14_skelepieces', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 10, '', '', '', 0, 0, ''),
	(6179, 6179, '0', 'hween14_mariachi', 'hween14_mariachi', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6180, 6180, '0', 'hween14_table', 'hween14_table', 'S', 2, 1, 1.10, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6181, 6181, '0', 'hween14_bench', 'hween14_bench', 'S', 2, 1, 1.30, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6182, 6182, '0', 'hween14_doll5', 'hween14_doll5', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6183, 6183, '0', 'hween14_carpet', 'hween14_carpet', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6184, 6184, '0', 'hween14_lovelock', 'hween14_lovelock', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'love_lock', 2, '', '', '', 0, 0, ''),
	(6185, 6185, '0', 'hween14_candletrail', 'hween14_candletrail', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6186, 6186, '0', 'hween14_doll2', 'hween14_doll2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6187, 6187, '0', 'hween14_doll8', 'hween14_doll8', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6188, 6188, '0', 'hween14_doll6', 'hween14_doll6', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6189, 6189, '0', 'hween14_doll1', 'hween14_doll1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6190, 6190, '0', 'hween14_gate', 'hween14_gate', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 1, '', '', '', 0, 0, ''),
	(6191, 6191, '0', 'hween14_goat', 'hween14_goat', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6192, 6192, '0', 'hween14_doll7', 'hween14_doll7', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6193, 6193, '0', 'hween14_grossfood', 'hween14_grossfood', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(6194, 6194, '0', 'hween14_hctele', 'hween14_hctele', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'teleport', 2, '', '', '', 0, 0, ''),
	(6195, 6195, '0', 'hween14_flowertrail', 'hween14_flowertrail', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6196, 6196, '0', 'hween14_doll10', 'hween14_doll10', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6197, 6197, '0', 'hween14_hangskull', 'hween14_hangskull', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6198, 6198, '0', 'hween14_skullcandle', 'hween14_skullcandle', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6199, 6199, '0', 'hween14_rare2', 'hween14_rare2', 'S', 1, 2, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'trap', 2, '', '', '', 0, 0, ''),
	(6200, 6200, '0', 'hween14_altarpieces1', 'hween14_altarpieces1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '1061', '', '', 0, 0, ''),
	(6201, 6201, '0', 'hween14_teleport', 'hween14_teleport', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'teleport', 1, '', '', '', 0, 0, ''),
	(6202, 6202, '0', 'hween14_doll9', 'hween14_doll9', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6203, 6203, '0', 'hween14_doll3', 'hween14_doll3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6204, 6204, '0', 'hween14_doll4', 'hween14_doll4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6205, 6205, '0', 'hween14_chair', 'hween14_chair', 'S', 1, 1, 1.50, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6206, 6206, '0', 'hween14_food', 'hween14_food', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(6207, 6207, '0', 'hween14_bed', 'hween14_bed', 'S', 1, 3, 1.60, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(6208, 6208, '0', 'hween14_altarpieces2', 'hween14_altarpieces2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '1061', '', '', 0, 0, ''),
	(6209, 6209, '0', 'hween14_mirror', 'hween14_mirror', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6210, 6210, '0', 'hween14_flowerpot', 'hween14_flowerpot', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6211, 6211, '0', 'hween14_altarpieces3', 'hween14_altarpieces3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '1061', '', '', 0, 0, ''),
	(6212, 6212, '0', 'hween14_divdr', 'hween14_divdr', 'S', 2, 1, 2.40, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6213, 6213, '0', 'hween14_skulllight', 'hween14_skulllight', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6214, 6214, '0', 'hween14_demon', 'hween14_demon', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6215, 6215, '0', 'st_hween14_jack', 'st_hween14_jack', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6216, 6216, '0', 'st_hween14_skulls', 'st_hween14_skulls', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'vendingmachine', 2, '1062,1063,1064', '', '', 0, 0, ''),
	(6217, 6217, '0', 'hween14_carnivalbg', 'hween14_carnivalbg', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6218, 6218, '0', 'st_hween14_horse', 'st_hween14_horse', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6219, 6219, '0', 'st_hween14_mbox', 'st_hween14_mbox', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6220, 6220, '0', 'st_hween14_fireplace', 'st_hween14_fireplace', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6221, 6221, '0', 'st_hween14_closet', 'st_hween14_closet', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6222, 6222, '0', 'CF_350_skull', 'CF_350_skull', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6223, 6223, '0', 'hween14_rare1', 'hween14_rare1', 'S', 3, 3, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6224, 6224, '0', 'limo_r_front', 'limo_r_front', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6225, 6225, '0', 'limo_r_back', 'limo_r_back', 'S', 2, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6226, 6226, '0', 'limo_r_mid2', 'limo_r_mid2', 'S', 2, 1, 0.20, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6227, 6227, '0', 'limo_r_mid', 'limo_r_mid', 'S', 2, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6228, 6228, '0', 'hween14_ltdalter', 'hween14_ltdalter', 'S', 3, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6229, 6229, '0', 'prizetrophy_mastercard', 'prizetrophy_mastercard', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(6230, 6230, '0', 'xmas14_recliner', 'xmas14_recliner', 'S', 1, 3, 1.20, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 2, '', '', '', 0, 0, ''),
	(6231, 6231, '0', 'xmas14_corner2', 'xmas14_corner2', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6232, 6232, '0', 'xmas14_stages1', 'xmas14_stages1', 'S', 2, 1, 0.20, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6233, 6233, '0', 'xmas14_tikibar2', 'xmas14_tikibar2', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '31', '', '', 0, 0, ''),
	(6234, 6234, '0', 'xmas14_beachhut', 'xmas14_beachhut', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6235, 6235, '0', 'xmas14_divider', 'xmas14_divider', 'S', 2, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6236, 6236, '0', 'xmas14_tikibar', 'xmas14_tikibar', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '31', '', '', 0, 0, ''),
	(6237, 6237, '0', 'xmas14_stages2', 'xmas14_stages2', 'S', 1, 1, 0.20, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6238, 6238, '0', 'xmas14_snowman', 'xmas14_snowman', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6239, 6239, '0', 'xmas14_tele', 'xmas14_tele', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'teleport', 1, '', '', '', 0, 0, ''),
	(6240, 6240, '0', 'xmas14_corner1', 'xmas14_corner1', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6241, 6241, '0', 'xmas14_table', 'xmas14_table', 'S', 2, 1, 1.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6242, 6242, '0', 'xmas14_sunbeams', 'xmas14_sunbeams', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6243, 6243, '0', 'xmas14_sand', 'xmas14_sand', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6244, 6244, '0', 'xmas14_gate1', 'xmas14_gate1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 1, '', '', '', 0, 0, ''),
	(6245, 6245, '0', 'xmas14_chair', 'xmas14_chair', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6246, 6246, '0', 'xmas14_gate2', 'xmas14_gate2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 1, '', '', '', 0, 0, ''),
	(6247, 6247, '0', 'xmas14_lights1', 'xmas14_lights1', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 6, '', '', '', 0, 0, ''),
	(6248, 6248, '0', 'xmas14_lights2', 'xmas14_lights2', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 6, '', '', '', 0, 0, ''),
	(6249, 6249, '0', 'xmas14_starfish', 'xmas14_starfish', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6250, 6250, '0', 'xmas14_inflatabletree', 'xmas14_inflatabletree', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6251, 6251, '0', 'xmas14_palm', 'xmas14_palm', 'S', 1, 1, 5.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6252, 6252, '0', 'xmas14_mermaid', 'xmas14_mermaid', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6253, 6253, '0', 'xmas14_lobsterdin', 'xmas14_lobsterdin', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6254, 6254, '0', 'xmas14_festivehut', 'xmas14_festivehut', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6255, 6255, '0', 'xmas14_octosanta', 'xmas14_octosanta', 'S', 3, 3, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6256, 6256, '0', 'xmas14_sharkthrone', 'xmas14_sharkthrone', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6257, 6257, '0', 'xmas14_boomboxman', 'xmas14_boomboxman', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6258, 6258, '0', 'xmas14_rudolph_ring', 'xmas14_rudolph_ring', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6259, 6259, '0', 'xmas14_snowglobe', 'xmas14_snowglobe', 'S', 2, 2, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6260, 6260, '0', 'xmas14_tubeman', 'xmas14_tubeman', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6261, 6261, '0', 'xmas14_elf8', 'xmas14_elf8', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6262, 6262, '0', 'xmas14_elf7', 'xmas14_elf7', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6263, 6263, '0', 'xmas14_elf3', 'xmas14_elf3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6264, 6264, '0', 'xmas14_elf1', 'xmas14_elf1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6265, 6265, '0', 'xmas14_elf5', 'xmas14_elf5', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6266, 6266, '0', 'xmas14_elf10', 'xmas14_elf10', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6267, 6267, '0', 'xmas14_elf2', 'xmas14_elf2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6268, 6268, '0', 'xmas14_elf9', 'xmas14_elf9', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6269, 6269, '0', 'xmas14_elf4', 'xmas14_elf4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6270, 6270, '0', 'xmas14_elf6', 'xmas14_elf6', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6271, 6271, '0', 'hc_arab_tetbl', 'hc_arab_tetbl', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6272, 6272, '0', 'hc_arab_bigtb', 'hc_arab_bigtb', 'S', 3, 2, 0.60, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6273, 6273, '0', 'xmas14_santateller', 'xmas14_santateller', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6274, 6274, '0', 'memorial_size', 'memorial_size', 'S', 1, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6275, 6275, '0', 'bc_blocktrophy_1', 'bc_blocktrophy_1', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6276, 6276, '0', 'xmas14_hammock', 'xmas14_hammock', 'S', 1, 3, 1.40, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 2, '', '', '', 0, 0, ''),
	(6277, 6277, '0', 'xmas14_santastuck', 'xmas14_santastuck', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6278, 6278, '0', 'clothing_party1', 'clothing_party1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(6279, 6279, '0', 'clothing_geometricskirt', 'clothing_geometricskirt', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(6280, 6280, '0', 'clothing_waistcoatsuit', 'clothing_waistcoatsuit', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(6281, 6281, '0', 'clothing_meowtfit', 'clothing_meowtfit', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(6282, 6282, '0', 'clothing_gatsby', 'clothing_gatsby', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(6283, 6283, '0', 'clothing_bow', 'clothing_bow', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(6284, 6284, '0', 'clothing_squid', 'clothing_squid', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(6285, 6285, '0', 'clothing_baldy', 'clothing_baldy', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(6286, 6286, '0', 'clothing_wavy2', 'clothing_wavy2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(6287, 6287, '0', 'clothing_mutton1', 'clothing_mutton1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(6288, 6288, '0', 'clothing_straw2', 'clothing_straw2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(6289, 6289, '0', 'clothing_fishhat', 'clothing_fishhat', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(6290, 6290, '0', 'clothing_rolled_jeans', 'clothing_rolled_jeans', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(6291, 6291, '0', 'clothing_birdshoes', 'clothing_birdshoes', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(6292, 6292, '0', 'clothing_mermaidoutfit', 'clothing_mermaidoutfit', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(6293, 6293, '0', 'clothing_droopycollar', 'clothing_droopycollar', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(6294, 6294, '0', 'clothing_headband', 'clothing_headband', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(6295, 6295, '0', 'clothing_flowercrown', 'clothing_flowercrown', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(6296, 6296, '0', 'clothing_hheadphones', 'clothing_hheadphones', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(6297, 6297, '0', 'clothing_mutton2', 'clothing_mutton2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(6298, 6298, '0', 'clothing_floralskirt', 'clothing_floralskirt', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(6299, 6299, '0', 'clothing_nightvision', 'clothing_nightvision', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(6300, 6300, '0', 'clothing_mockymouse', 'clothing_mockymouse', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(6301, 6301, '0', 'clothing_xmas1', 'clothing_xmas1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(6302, 6302, '0', 'clothing_shavedside', 'clothing_shavedside', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(6303, 6303, '0', 'clothing_geometricjumper', 'clothing_geometricjumper', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(6304, 6304, '0', 'clothing_beard1', 'clothing_beard1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(6305, 6305, '0', 'clothing_beads', 'clothing_beads', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(6306, 6306, '0', 'clothing_twotonecardi', 'clothing_twotonecardi', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(6307, 6307, '0', 'clothing_animalprint', 'clothing_animalprint', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(6308, 6308, '0', 'clothing_party2', 'clothing_party2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(6309, 6309, '0', 'clothing_tshirt_rolled', 'clothing_tshirt_rolled', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(6310, 6310, '0', 'clothing_rippedjeans', 'clothing_rippedjeans', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(6311, 6311, '0', 'clothing_shoestights', 'clothing_shoestights', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(6312, 6312, '0', 'pet_puppy_toy', 'pet_puppy_toy', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6313, 6313, '0', 'pet_ufo_toy', 'pet_ufo_toy', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6314, 6314, '1', 'yarn', 'yarn', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6315, 6315, '0', 'nest_pig', 'nest_pig', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6316, 6316, '0', 'nest_bed', 'nest_bed', 'S', 1, 1, 0.25, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(6317, 6317, '0', 'nest_box', 'nest_box', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6318, 6318, '0', 'fxbox_fx147', 'fxbox_fx147', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'fx_box', 2, '', '', '', 147, 147, ''),
	(6319, 6319, '0', 'fxbox_fx92', 'fxbox_fx92', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'fx_box', 2, '', '', '', 92, 92, ''),
	(6320, 6320, '0', 'fxbox_fx123', 'fxbox_fx123', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'fx_box', 2, '', '', '', 123, 123, ''),
	(6321, 6321, '0', 'fxbox_fx153', 'fxbox_fx153', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'fx_box', 2, '', '', '', 153, 153, ''),
	(6322, 6322, '0', 'fxbox_fx152', 'fxbox_fx152', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'fx_box', 2, '', '', '', 152, 152, ''),
	(6323, 6323, '0', 'fxbox_fx116', 'fxbox_fx116', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'fx_box', 2, '', '', '', 116, 116, ''),
	(6324, 6324, '0', 'fxbox_fx125', 'fxbox_fx125', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'fx_box', 2, '', '', '', 125, 125, ''),
	(6325, 6325, '0', 'fxbox_fx143', 'fxbox_fx143', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'fx_box', 2, '', '', '', 143, 143, ''),
	(6326, 6326, '0', 'fxbox_fx127', 'fxbox_fx127', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'fx_box', 2, '', '', '', 127, 127, ''),
	(6327, 6327, '0', 'fxbox_fx126', 'fxbox_fx126', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'fx_box', 2, '', '', '', 126, 126, ''),
	(6328, 6328, '0', 'ny2015_floor2', 'ny2015_floor2', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6329, 6329, '0', 'ny2015_archway', 'ny2015_archway', 'S', 2, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6330, 6330, '0', 'ny2015_balloons', 'ny2015_balloons', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6331, 6331, '0', 'ny2015_chocfountain', 'ny2015_chocfountain', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6332, 6332, '0', 'ny2015_conball', 'ny2015_conball', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6333, 6333, '0', 'ny2015_bar', 'ny2015_bar', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '35', '', '', 0, 0, ''),
	(6334, 6334, '0', 'ny2015_table', 'ny2015_table', 'S', 2, 1, 0.75, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6335, 6335, '0', 'ny2015_cctray', 'ny2015_cctray', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine_no_sides', 2, '89', '', '', 0, 0, ''),
	(6336, 6336, '0', 'ny2015_floor1', 'ny2015_floor1', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6337, 6337, '0', 'ny2015_drktray', 'ny2015_drktray', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine_no_sides', 2, '90', '', '', 0, 0, ''),
	(6338, 6338, '0', 'hc_arab_tray3', 'hc_arab_tray3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6339, 6339, '0', 'hc_arab_tray1', 'hc_arab_tray1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6340, 6340, '0', 'hc_arab_rug', 'hc_arab_rug', 'S', 3, 5, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6341, 6341, '0', 'hc_arab_chair', 'hc_arab_chair', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6342, 6342, '0', 'hc_arab_divdr', 'hc_arab_divdr', 'S', 1, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6343, 6343, '0', 'hc_arab_teamk', 'hc_arab_teamk', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '27', '', '', 0, 0, ''),
	(6344, 6344, '0', 'hc_arab_snake', 'hc_arab_snake', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6345, 6345, '0', 'hc_arab_pllw', 'hc_arab_pllw', 'S', 1, 1, 0.80, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6346, 6346, '0', 'pet_breeding_dog', 'pet_breeding_dog', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6347, 6347, '0', 'pet_breeding_pig', 'pet_breeding_pig', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6348, 6348, '0', 'pet_breeding_cat', 'pet_breeding_cat', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6349, 6349, '0', 'ads_vpiggy_santapig', 'ads_vpiggy_santapig', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6350, 6350, '1', 'bc_pyramidtip*1', 'bc_pyramidtip*1', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6351, 6351, '1', 'bc_pyramidtip*10', 'bc_pyramidtip*10', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6352, 6352, '1', 'bc_pyramidtip*11', 'bc_pyramidtip*11', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6353, 6353, '1', 'bc_pyramidtip*12', 'bc_pyramidtip*12', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6354, 6354, '1', 'bc_pyramidtip*13', 'bc_pyramidtip*13', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6355, 6355, '1', 'bc_pyramidtip*14', 'bc_pyramidtip*14', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6356, 6356, '1', 'bc_pyramidtip*15', 'bc_pyramidtip*15', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6357, 6357, '1', 'bc_pyramidtip*16', 'bc_pyramidtip*16', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6358, 6358, '1', 'bc_pyramidtip*17', 'bc_pyramidtip*17', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6359, 6359, '1', 'bc_pyramidtip*18', 'bc_pyramidtip*18', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6360, 6360, '1', 'bc_pyramidtip*19', 'bc_pyramidtip*19', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6361, 6361, '1', 'bc_pyramidtip*2', 'bc_pyramidtip*2', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6362, 6362, '1', 'bc_pyramidtip*20', 'bc_pyramidtip*20', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6363, 6363, '1', 'bc_pyramidtip*21', 'bc_pyramidtip*21', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6364, 6364, '1', 'bc_pyramidtip*22', 'bc_pyramidtip*22', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6365, 6365, '1', 'bc_pyramidtip*23', 'bc_pyramidtip*23', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6366, 6366, '1', 'bc_pyramidtip*24', 'bc_pyramidtip*24', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6367, 6367, '1', 'bc_pyramidtip*25', 'bc_pyramidtip*25', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6368, 6368, '1', 'bc_pyramidtip*26', 'bc_pyramidtip*26', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6369, 6369, '1', 'bc_pyramidtip*27', 'bc_pyramidtip*27', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6370, 6370, '1', 'bc_pyramidtip*28', 'bc_pyramidtip*28', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6371, 6371, '1', 'bc_pyramidtip*29', 'bc_pyramidtip*29', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6372, 6372, '1', 'bc_pyramidtip*3', 'bc_pyramidtip*3', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6373, 6373, '1', 'bc_pyramidtip*30', 'bc_pyramidtip*30', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6374, 6374, '1', 'bc_pyramidtip*31', 'bc_pyramidtip*31', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6375, 6375, '1', 'bc_pyramidtip*32', 'bc_pyramidtip*32', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6376, 6376, '1', 'bc_pyramidtip*33', 'bc_pyramidtip*33', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6377, 6377, '1', 'bc_pyramidtip*34', 'bc_pyramidtip*34', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6378, 6378, '1', 'bc_pyramidtip*35', 'bc_pyramidtip*35', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6379, 6379, '1', 'bc_pyramidtip*36', 'bc_pyramidtip*36', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6380, 6380, '1', 'bc_pyramidtip*37', 'bc_pyramidtip*37', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6381, 6381, '1', 'bc_pyramidtip*38', 'bc_pyramidtip*38', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6382, 6382, '1', 'bc_pyramidtip*39', 'bc_pyramidtip*39', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6383, 6383, '1', 'bc_pyramidtip*4', 'bc_pyramidtip*4', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6384, 6384, '1', 'bc_pyramidtip*40', 'bc_pyramidtip*40', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6385, 6385, '1', 'bc_pyramidtip*41', 'bc_pyramidtip*41', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6386, 6386, '1', 'bc_pyramidtip*42', 'bc_pyramidtip*42', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6387, 6387, '1', 'bc_pyramidtip*43', 'bc_pyramidtip*43', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6388, 6388, '1', 'bc_pyramidtip*44', 'bc_pyramidtip*44', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6389, 6389, '1', 'bc_pyramidtip*45', 'bc_pyramidtip*45', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6390, 6390, '1', 'bc_pyramidtip*46', 'bc_pyramidtip*46', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6391, 6391, '1', 'bc_pyramidtip*47', 'bc_pyramidtip*47', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6392, 6392, '1', 'bc_pyramidtip*48', 'bc_pyramidtip*48', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6393, 6393, '1', 'bc_pyramidtip*49', 'bc_pyramidtip*49', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6394, 6394, '1', 'bc_pyramidtip*5', 'bc_pyramidtip*5', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6395, 6395, '1', 'bc_pyramidtip*50', 'bc_pyramidtip*50', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6396, 6396, '1', 'bc_pyramidtip*51', 'bc_pyramidtip*51', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6397, 6397, '1', 'bc_pyramidtip*52', 'bc_pyramidtip*52', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6398, 6398, '1', 'bc_pyramidtip*53', 'bc_pyramidtip*53', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6399, 6399, '1', 'bc_pyramidtip*54', 'bc_pyramidtip*54', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6400, 6400, '1', 'bc_pyramidtip*55', 'bc_pyramidtip*55', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6401, 6401, '1', 'bc_pyramidtip*56', 'bc_pyramidtip*56', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6402, 6402, '1', 'bc_pyramidtip*57', 'bc_pyramidtip*57', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6403, 6403, '1', 'bc_pyramidtip*58', 'bc_pyramidtip*58', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6404, 6404, '1', 'bc_pyramidtip*59', 'bc_pyramidtip*59', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6405, 6405, '1', 'bc_pyramidtip*6', 'bc_pyramidtip*6', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6406, 6406, '1', 'bc_pyramidtip*60', 'bc_pyramidtip*60', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6407, 6407, '1', 'bc_pyramidtip*61', 'bc_pyramidtip*61', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6408, 6408, '1', 'bc_pyramidtip*62', 'bc_pyramidtip*62', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6409, 6409, '1', 'bc_pyramidtip*63', 'bc_pyramidtip*63', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6410, 6410, '1', 'bc_pyramidtip*64', 'bc_pyramidtip*64', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6411, 6411, '1', 'bc_pyramidtip*65', 'bc_pyramidtip*65', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6412, 6412, '1', 'bc_pyramidtip*66', 'bc_pyramidtip*66', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6413, 6413, '1', 'bc_pyramidtip*67', 'bc_pyramidtip*67', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6414, 6414, '1', 'bc_pyramidtip*68', 'bc_pyramidtip*68', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6415, 6415, '1', 'bc_pyramidtip*69', 'bc_pyramidtip*69', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6416, 6416, '1', 'bc_pyramidtip*7', 'bc_pyramidtip*7', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6417, 6417, '1', 'bc_pyramidtip*8', 'bc_pyramidtip*8', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6418, 6418, '1', 'bc_pyramidtip*9', 'bc_pyramidtip*9', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6419, 6419, '1', 'bc_cone*1', 'bc_cone*1', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6420, 6420, '1', 'bc_cone*10', 'bc_cone*10', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6421, 6421, '1', 'bc_cone*11', 'bc_cone*11', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6422, 6422, '1', 'bc_cone*12', 'bc_cone*12', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6423, 6423, '1', 'bc_cone*13', 'bc_cone*13', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6424, 6424, '1', 'bc_cone*14', 'bc_cone*14', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6425, 6425, '1', 'bc_cone*15', 'bc_cone*15', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6426, 6426, '1', 'bc_cone*16', 'bc_cone*16', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6427, 6427, '1', 'bc_cone*17', 'bc_cone*17', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6428, 6428, '1', 'bc_cone*18', 'bc_cone*18', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6429, 6429, '1', 'bc_cone*19', 'bc_cone*19', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6430, 6430, '1', 'bc_cone*2', 'bc_cone*2', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6431, 6431, '1', 'bc_cone*20', 'bc_cone*20', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6432, 6432, '1', 'bc_cone*21', 'bc_cone*21', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6433, 6433, '1', 'bc_cone*22', 'bc_cone*22', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6434, 6434, '1', 'bc_cone*23', 'bc_cone*23', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6435, 6435, '1', 'bc_cone*24', 'bc_cone*24', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6436, 6436, '1', 'bc_cone*25', 'bc_cone*25', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6437, 6437, '1', 'bc_cone*26', 'bc_cone*26', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6438, 6438, '1', 'bc_cone*27', 'bc_cone*27', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6439, 6439, '1', 'bc_cone*28', 'bc_cone*28', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6440, 6440, '1', 'bc_cone*29', 'bc_cone*29', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6441, 6441, '1', 'bc_cone*3', 'bc_cone*3', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6442, 6442, '1', 'bc_cone*30', 'bc_cone*30', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6443, 6443, '1', 'bc_cone*31', 'bc_cone*31', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6444, 6444, '1', 'bc_cone*32', 'bc_cone*32', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6445, 6445, '1', 'bc_cone*33', 'bc_cone*33', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6446, 6446, '1', 'bc_cone*34', 'bc_cone*34', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6447, 6447, '1', 'bc_cone*35', 'bc_cone*35', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6448, 6448, '1', 'bc_cone*36', 'bc_cone*36', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6449, 6449, '1', 'bc_cone*37', 'bc_cone*37', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6450, 6450, '1', 'bc_cone*38', 'bc_cone*38', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6451, 6451, '1', 'bc_cone*39', 'bc_cone*39', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6452, 6452, '1', 'bc_cone*4', 'bc_cone*4', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6453, 6453, '1', 'bc_cone*40', 'bc_cone*40', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6454, 6454, '1', 'bc_cone*41', 'bc_cone*41', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6455, 6455, '1', 'bc_cone*42', 'bc_cone*42', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6456, 6456, '1', 'bc_cone*43', 'bc_cone*43', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6457, 6457, '1', 'bc_cone*44', 'bc_cone*44', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6458, 6458, '1', 'bc_cone*45', 'bc_cone*45', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6459, 6459, '1', 'bc_cone*46', 'bc_cone*46', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6460, 6460, '1', 'bc_cone*47', 'bc_cone*47', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6461, 6461, '1', 'bc_cone*48', 'bc_cone*48', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6462, 6462, '1', 'bc_cone*49', 'bc_cone*49', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6463, 6463, '1', 'bc_cone*5', 'bc_cone*5', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6464, 6464, '1', 'bc_cone*50', 'bc_cone*50', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6465, 6465, '1', 'bc_cone*51', 'bc_cone*51', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6466, 6466, '1', 'bc_cone*52', 'bc_cone*52', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6467, 6467, '1', 'bc_cone*53', 'bc_cone*53', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6468, 6468, '1', 'bc_cone*54', 'bc_cone*54', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6469, 6469, '1', 'bc_cone*55', 'bc_cone*55', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6470, 6470, '1', 'bc_cone*56', 'bc_cone*56', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6471, 6471, '1', 'bc_cone*57', 'bc_cone*57', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6472, 6472, '1', 'bc_cone*58', 'bc_cone*58', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6473, 6473, '1', 'bc_cone*59', 'bc_cone*59', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6474, 6474, '1', 'bc_cone*6', 'bc_cone*6', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6475, 6475, '1', 'bc_cone*60', 'bc_cone*60', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6476, 6476, '1', 'bc_cone*61', 'bc_cone*61', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6477, 6477, '1', 'bc_cone*62', 'bc_cone*62', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6478, 6478, '1', 'bc_cone*63', 'bc_cone*63', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6479, 6479, '1', 'bc_cone*64', 'bc_cone*64', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6480, 6480, '1', 'bc_cone*65', 'bc_cone*65', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6481, 6481, '1', 'bc_cone*66', 'bc_cone*66', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6482, 6482, '1', 'bc_cone*67', 'bc_cone*67', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6483, 6483, '1', 'bc_cone*68', 'bc_cone*68', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6484, 6484, '1', 'bc_cone*69', 'bc_cone*69', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6485, 6485, '1', 'bc_cone*7', 'bc_cone*7', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6486, 6486, '1', 'bc_cone*8', 'bc_cone*8', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6487, 6487, '1', 'bc_cone*9', 'bc_cone*9', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6488, 6488, '1', 'bc_standinghalfcylinder*1', 'bc_standinghalfcylinder*1', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6489, 6489, '1', 'bc_standinghalfcylinder*10', 'bc_standinghalfcylinder*10', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6490, 6490, '1', 'bc_standinghalfcylinder*11', 'bc_standinghalfcylinder*11', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6491, 6491, '1', 'bc_standinghalfcylinder*12', 'bc_standinghalfcylinder*12', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6492, 6492, '1', 'bc_standinghalfcylinder*13', 'bc_standinghalfcylinder*13', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6493, 6493, '1', 'bc_standinghalfcylinder*14', 'bc_standinghalfcylinder*14', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6494, 6494, '1', 'bc_standinghalfcylinder*15', 'bc_standinghalfcylinder*15', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6495, 6495, '1', 'bc_standinghalfcylinder*16', 'bc_standinghalfcylinder*16', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6496, 6496, '1', 'bc_standinghalfcylinder*17', 'bc_standinghalfcylinder*17', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6497, 6497, '1', 'bc_standinghalfcylinder*18', 'bc_standinghalfcylinder*18', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6498, 6498, '1', 'bc_standinghalfcylinder*19', 'bc_standinghalfcylinder*19', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6499, 6499, '1', 'bc_standinghalfcylinder*2', 'bc_standinghalfcylinder*2', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6500, 6500, '1', 'bc_standinghalfcylinder*20', 'bc_standinghalfcylinder*20', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6501, 6501, '1', 'bc_standinghalfcylinder*21', 'bc_standinghalfcylinder*21', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6502, 6502, '1', 'bc_standinghalfcylinder*22', 'bc_standinghalfcylinder*22', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6503, 6503, '1', 'bc_standinghalfcylinder*23', 'bc_standinghalfcylinder*23', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6504, 6504, '1', 'bc_standinghalfcylinder*24', 'bc_standinghalfcylinder*24', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6505, 6505, '1', 'bc_standinghalfcylinder*25', 'bc_standinghalfcylinder*25', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6506, 6506, '1', 'bc_standinghalfcylinder*26', 'bc_standinghalfcylinder*26', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6507, 6507, '1', 'bc_standinghalfcylinder*27', 'bc_standinghalfcylinder*27', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6508, 6508, '1', 'bc_standinghalfcylinder*28', 'bc_standinghalfcylinder*28', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6509, 6509, '1', 'bc_standinghalfcylinder*29', 'bc_standinghalfcylinder*29', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6510, 6510, '1', 'bc_standinghalfcylinder*3', 'bc_standinghalfcylinder*3', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6511, 6511, '1', 'bc_standinghalfcylinder*30', 'bc_standinghalfcylinder*30', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6512, 6512, '1', 'bc_standinghalfcylinder*31', 'bc_standinghalfcylinder*31', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6513, 6513, '1', 'bc_standinghalfcylinder*32', 'bc_standinghalfcylinder*32', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6514, 6514, '1', 'bc_standinghalfcylinder*33', 'bc_standinghalfcylinder*33', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6515, 6515, '1', 'bc_standinghalfcylinder*34', 'bc_standinghalfcylinder*34', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6516, 6516, '1', 'bc_standinghalfcylinder*35', 'bc_standinghalfcylinder*35', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6517, 6517, '1', 'bc_standinghalfcylinder*36', 'bc_standinghalfcylinder*36', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6518, 6518, '1', 'bc_standinghalfcylinder*37', 'bc_standinghalfcylinder*37', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6519, 6519, '1', 'bc_standinghalfcylinder*38', 'bc_standinghalfcylinder*38', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6520, 6520, '1', 'bc_standinghalfcylinder*39', 'bc_standinghalfcylinder*39', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6521, 6521, '1', 'bc_standinghalfcylinder*4', 'bc_standinghalfcylinder*4', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6522, 6522, '1', 'bc_standinghalfcylinder*40', 'bc_standinghalfcylinder*40', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6523, 6523, '1', 'bc_standinghalfcylinder*41', 'bc_standinghalfcylinder*41', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6524, 6524, '1', 'bc_standinghalfcylinder*42', 'bc_standinghalfcylinder*42', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6525, 6525, '1', 'bc_standinghalfcylinder*43', 'bc_standinghalfcylinder*43', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6526, 6526, '1', 'bc_standinghalfcylinder*44', 'bc_standinghalfcylinder*44', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6527, 6527, '1', 'bc_standinghalfcylinder*45', 'bc_standinghalfcylinder*45', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6528, 6528, '1', 'bc_standinghalfcylinder*46', 'bc_standinghalfcylinder*46', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6529, 6529, '1', 'bc_standinghalfcylinder*47', 'bc_standinghalfcylinder*47', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6530, 6530, '1', 'bc_standinghalfcylinder*48', 'bc_standinghalfcylinder*48', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6531, 6531, '1', 'bc_standinghalfcylinder*49', 'bc_standinghalfcylinder*49', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6532, 6532, '1', 'bc_standinghalfcylinder*5', 'bc_standinghalfcylinder*5', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6533, 6533, '1', 'bc_standinghalfcylinder*50', 'bc_standinghalfcylinder*50', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6534, 6534, '1', 'bc_standinghalfcylinder*51', 'bc_standinghalfcylinder*51', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6535, 6535, '1', 'bc_standinghalfcylinder*52', 'bc_standinghalfcylinder*52', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6536, 6536, '1', 'bc_standinghalfcylinder*53', 'bc_standinghalfcylinder*53', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6537, 6537, '1', 'bc_standinghalfcylinder*54', 'bc_standinghalfcylinder*54', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6538, 6538, '1', 'bc_standinghalfcylinder*55', 'bc_standinghalfcylinder*55', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6539, 6539, '1', 'bc_standinghalfcylinder*56', 'bc_standinghalfcylinder*56', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6540, 6540, '1', 'bc_standinghalfcylinder*57', 'bc_standinghalfcylinder*57', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6541, 6541, '1', 'bc_standinghalfcylinder*58', 'bc_standinghalfcylinder*58', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6542, 6542, '1', 'bc_standinghalfcylinder*59', 'bc_standinghalfcylinder*59', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6543, 6543, '1', 'bc_standinghalfcylinder*6', 'bc_standinghalfcylinder*6', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6544, 6544, '1', 'bc_standinghalfcylinder*60', 'bc_standinghalfcylinder*60', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6545, 6545, '1', 'bc_standinghalfcylinder*61', 'bc_standinghalfcylinder*61', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6546, 6546, '1', 'bc_standinghalfcylinder*62', 'bc_standinghalfcylinder*62', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6547, 6547, '1', 'bc_standinghalfcylinder*63', 'bc_standinghalfcylinder*63', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6548, 6548, '1', 'bc_standinghalfcylinder*64', 'bc_standinghalfcylinder*64', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6549, 6549, '1', 'bc_standinghalfcylinder*65', 'bc_standinghalfcylinder*65', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6550, 6550, '1', 'bc_standinghalfcylinder*66', 'bc_standinghalfcylinder*66', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6551, 6551, '1', 'bc_standinghalfcylinder*67', 'bc_standinghalfcylinder*67', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6552, 6552, '1', 'bc_standinghalfcylinder*68', 'bc_standinghalfcylinder*68', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6553, 6553, '1', 'bc_standinghalfcylinder*69', 'bc_standinghalfcylinder*69', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6554, 6554, '1', 'bc_standinghalfcylinder*7', 'bc_standinghalfcylinder*7', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6555, 6555, '1', 'bc_standinghalfcylinder*8', 'bc_standinghalfcylinder*8', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6556, 6556, '1', 'bc_standinghalfcylinder*9', 'bc_standinghalfcylinder*9', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6557, 6557, '1', 'bc_hemisphere*1', 'bc_hemisphere*1', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 4, '', '0.9;0.6;0.5;0.35', '', 0, 0, ''),
	(6558, 6558, '1', 'bc_hemisphere*10', 'bc_hemisphere*10', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 4, '', '0.9;0.6;0.5;0.35', '', 0, 0, ''),
	(6559, 6559, '1', 'bc_hemisphere*11', 'bc_hemisphere*11', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 4, '', '0.9;0.6;0.5;0.35', '', 0, 0, ''),
	(6560, 6560, '1', 'bc_hemisphere*12', 'bc_hemisphere*12', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 4, '', '0.9;0.6;0.5;0.35', '', 0, 0, ''),
	(6561, 6561, '1', 'bc_hemisphere*13', 'bc_hemisphere*13', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 4, '', '0.9;0.6;0.5;0.35', '', 0, 0, ''),
	(6562, 6562, '1', 'bc_hemisphere*14', 'bc_hemisphere*14', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 4, '', '0.9;0.6;0.5;0.35', '', 0, 0, ''),
	(6563, 6563, '1', 'bc_hemisphere*15', 'bc_hemisphere*15', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 4, '', '0.9;0.6;0.5;0.35', '', 0, 0, ''),
	(6564, 6564, '1', 'bc_hemisphere*16', 'bc_hemisphere*16', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 4, '', '0.9;0.6;0.5;0.35', '', 0, 0, ''),
	(6565, 6565, '1', 'bc_hemisphere*17', 'bc_hemisphere*17', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 4, '', '0.9;0.6;0.5;0.35', '', 0, 0, ''),
	(6566, 6566, '1', 'bc_hemisphere*18', 'bc_hemisphere*18', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 4, '', '0.9;0.6;0.5;0.35', '', 0, 0, ''),
	(6567, 6567, '1', 'bc_hemisphere*19', 'bc_hemisphere*19', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 4, '', '0.9;0.6;0.5;0.35', '', 0, 0, ''),
	(6568, 6568, '1', 'bc_hemisphere*2', 'bc_hemisphere*2', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 4, '', '0.9;0.6;0.5;0.35', '', 0, 0, ''),
	(6569, 6569, '1', 'bc_hemisphere*20', 'bc_hemisphere*20', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 4, '', '0.9;0.6;0.5;0.35', '', 0, 0, ''),
	(6570, 6570, '1', 'bc_hemisphere*21', 'bc_hemisphere*21', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 4, '', '0.9;0.6;0.5;0.35', '', 0, 0, ''),
	(6571, 6571, '1', 'bc_hemisphere*22', 'bc_hemisphere*22', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 4, '', '0.9;0.6;0.5;0.35', '', 0, 0, ''),
	(6572, 6572, '1', 'bc_hemisphere*23', 'bc_hemisphere*23', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 4, '', '0.9;0.6;0.5;0.35', '', 0, 0, ''),
	(6573, 6573, '1', 'bc_hemisphere*24', 'bc_hemisphere*24', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 4, '', '0.9;0.6;0.5;0.35', '', 0, 0, ''),
	(6574, 6574, '1', 'bc_hemisphere*25', 'bc_hemisphere*25', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 4, '', '0.9;0.6;0.5;0.35', '', 0, 0, ''),
	(6575, 6575, '1', 'bc_hemisphere*26', 'bc_hemisphere*26', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 4, '', '0.9;0.6;0.5;0.35', '', 0, 0, ''),
	(6576, 6576, '1', 'bc_hemisphere*27', 'bc_hemisphere*27', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 4, '', '0.9;0.6;0.5;0.35', '', 0, 0, ''),
	(6577, 6577, '1', 'bc_hemisphere*28', 'bc_hemisphere*28', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 4, '', '0.9;0.6;0.5;0.35', '', 0, 0, ''),
	(6578, 6578, '1', 'bc_hemisphere*29', 'bc_hemisphere*29', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 4, '', '0.9;0.6;0.5;0.35', '', 0, 0, ''),
	(6579, 6579, '1', 'bc_hemisphere*3', 'bc_hemisphere*3', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 4, '', '0.9;0.6;0.5;0.35', '', 0, 0, ''),
	(6580, 6580, '1', 'bc_hemisphere*30', 'bc_hemisphere*30', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 4, '', '0.9;0.6;0.5;0.35', '', 0, 0, ''),
	(6581, 6581, '1', 'bc_hemisphere*31', 'bc_hemisphere*31', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 4, '', '0.9;0.6;0.5;0.35', '', 0, 0, ''),
	(6582, 6582, '1', 'bc_hemisphere*32', 'bc_hemisphere*32', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 4, '', '0.9;0.6;0.5;0.35', '', 0, 0, ''),
	(6583, 6583, '1', 'bc_hemisphere*33', 'bc_hemisphere*33', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 4, '', '0.9;0.6;0.5;0.35', '', 0, 0, ''),
	(6584, 6584, '1', 'bc_hemisphere*34', 'bc_hemisphere*34', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 4, '', '0.9;0.6;0.5;0.35', '', 0, 0, ''),
	(6585, 6585, '1', 'bc_hemisphere*35', 'bc_hemisphere*35', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 4, '', '0.9;0.6;0.5;0.35', '', 0, 0, ''),
	(6586, 6586, '1', 'bc_hemisphere*36', 'bc_hemisphere*36', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 4, '', '0.9;0.6;0.5;0.35', '', 0, 0, ''),
	(6587, 6587, '1', 'bc_hemisphere*37', 'bc_hemisphere*37', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 4, '', '0.9;0.6;0.5;0.35', '', 0, 0, ''),
	(6588, 6588, '1', 'bc_hemisphere*38', 'bc_hemisphere*38', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 4, '', '0.9;0.6;0.5;0.35', '', 0, 0, ''),
	(6589, 6589, '1', 'bc_hemisphere*39', 'bc_hemisphere*39', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 4, '', '0.9;0.6;0.5;0.35', '', 0, 0, ''),
	(6590, 6590, '1', 'bc_hemisphere*4', 'bc_hemisphere*4', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 4, '', '0.9;0.6;0.5;0.35', '', 0, 0, ''),
	(6591, 6591, '1', 'bc_hemisphere*40', 'bc_hemisphere*40', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 4, '', '0.9;0.6;0.5;0.35', '', 0, 0, ''),
	(6592, 6592, '1', 'bc_hemisphere*41', 'bc_hemisphere*41', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 4, '', '0.9;0.6;0.5;0.35', '', 0, 0, ''),
	(6593, 6593, '1', 'bc_hemisphere*42', 'bc_hemisphere*42', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 4, '', '0.9;0.6;0.5;0.35', '', 0, 0, ''),
	(6594, 6594, '1', 'bc_hemisphere*43', 'bc_hemisphere*43', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 4, '', '0.9;0.6;0.5;0.35', '', 0, 0, ''),
	(6595, 6595, '1', 'bc_hemisphere*44', 'bc_hemisphere*44', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 4, '', '0.9;0.6;0.5;0.35', '', 0, 0, ''),
	(6596, 6596, '1', 'bc_hemisphere*45', 'bc_hemisphere*45', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 4, '', '0.9;0.6;0.5;0.35', '', 0, 0, ''),
	(6597, 6597, '1', 'bc_hemisphere*46', 'bc_hemisphere*46', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 4, '', '0.9;0.6;0.5;0.35', '', 0, 0, ''),
	(6598, 6598, '1', 'bc_hemisphere*47', 'bc_hemisphere*47', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 4, '', '0.9;0.6;0.5;0.35', '', 0, 0, ''),
	(6599, 6599, '1', 'bc_hemisphere*48', 'bc_hemisphere*48', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 4, '', '0.9;0.6;0.5;0.35', '', 0, 0, ''),
	(6600, 6600, '1', 'bc_hemisphere*49', 'bc_hemisphere*49', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 4, '', '0.9;0.6;0.5;0.35', '', 0, 0, ''),
	(6601, 6601, '1', 'bc_hemisphere*5', 'bc_hemisphere*5', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 4, '', '0.9;0.6;0.5;0.35', '', 0, 0, ''),
	(6602, 6602, '1', 'bc_hemisphere*50', 'bc_hemisphere*50', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 4, '', '0.9;0.6;0.5;0.35', '', 0, 0, ''),
	(6603, 6603, '1', 'bc_hemisphere*51', 'bc_hemisphere*51', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 4, '', '0.9;0.6;0.5;0.35', '', 0, 0, ''),
	(6604, 6604, '1', 'bc_hemisphere*52', 'bc_hemisphere*52', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 4, '', '0.9;0.6;0.5;0.35', '', 0, 0, ''),
	(6605, 6605, '1', 'bc_hemisphere*53', 'bc_hemisphere*53', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 4, '', '0.9;0.6;0.5;0.35', '', 0, 0, ''),
	(6606, 6606, '1', 'bc_hemisphere*54', 'bc_hemisphere*54', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 4, '', '0.9;0.6;0.5;0.35', '', 0, 0, ''),
	(6607, 6607, '1', 'bc_hemisphere*55', 'bc_hemisphere*55', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 4, '', '0.9;0.6;0.5;0.35', '', 0, 0, ''),
	(6608, 6608, '1', 'bc_hemisphere*56', 'bc_hemisphere*56', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 4, '', '0.9;0.6;0.5;0.35', '', 0, 0, ''),
	(6609, 6609, '1', 'bc_hemisphere*57', 'bc_hemisphere*57', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 4, '', '0.9;0.6;0.5;0.35', '', 0, 0, ''),
	(6610, 6610, '1', 'bc_hemisphere*58', 'bc_hemisphere*58', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 4, '', '0.9;0.6;0.5;0.35', '', 0, 0, ''),
	(6611, 6611, '1', 'bc_hemisphere*59', 'bc_hemisphere*59', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 4, '', '0.9;0.6;0.5;0.35', '', 0, 0, ''),
	(6612, 6612, '1', 'bc_hemisphere*6', 'bc_hemisphere*6', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 4, '', '0.9;0.6;0.5;0.35', '', 0, 0, ''),
	(6613, 6613, '1', 'bc_hemisphere*60', 'bc_hemisphere*60', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 4, '', '0.9;0.6;0.5;0.35', '', 0, 0, ''),
	(6614, 6614, '1', 'bc_hemisphere*61', 'bc_hemisphere*61', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 4, '', '0.9;0.6;0.5;0.35', '', 0, 0, ''),
	(6615, 6615, '1', 'bc_hemisphere*62', 'bc_hemisphere*62', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 4, '', '0.9;0.6;0.5;0.35', '', 0, 0, ''),
	(6616, 6616, '1', 'bc_hemisphere*63', 'bc_hemisphere*63', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 4, '', '0.9;0.6;0.5;0.35', '', 0, 0, ''),
	(6617, 6617, '1', 'bc_hemisphere*64', 'bc_hemisphere*64', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 4, '', '0.9;0.6;0.5;0.35', '', 0, 0, ''),
	(6618, 6618, '1', 'bc_hemisphere*65', 'bc_hemisphere*65', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 4, '', '0.9;0.6;0.5;0.35', '', 0, 0, ''),
	(6619, 6619, '1', 'bc_hemisphere*66', 'bc_hemisphere*66', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 4, '', '0.9;0.6;0.5;0.35', '', 0, 0, ''),
	(6620, 6620, '1', 'bc_hemisphere*67', 'bc_hemisphere*67', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 4, '', '0.9;0.6;0.5;0.35', '', 0, 0, ''),
	(6621, 6621, '1', 'bc_hemisphere*68', 'bc_hemisphere*68', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 4, '', '0.9;0.6;0.5;0.35', '', 0, 0, ''),
	(6622, 6622, '1', 'bc_hemisphere*69', 'bc_hemisphere*69', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 4, '', '0.9;0.6;0.5;0.35', '', 0, 0, ''),
	(6623, 6623, '1', 'bc_hemisphere*7', 'bc_hemisphere*7', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 4, '', '0.9;0.6;0.5;0.35', '', 0, 0, ''),
	(6624, 6624, '1', 'bc_hemisphere*8', 'bc_hemisphere*8', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 4, '', '0.9;0.6;0.5;0.35', '', 0, 0, ''),
	(6625, 6625, '1', 'bc_hemisphere*9', 'bc_hemisphere*9', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 4, '', '0.9;0.6;0.5;0.35', '', 0, 0, ''),
	(6626, 6626, '1', 'bc_halfcylinder*1', 'bc_halfcylinder*1', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6627, 6627, '1', 'bc_halfcylinder*10', 'bc_halfcylinder*10', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6628, 6628, '1', 'bc_halfcylinder*11', 'bc_halfcylinder*11', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6629, 6629, '1', 'bc_halfcylinder*12', 'bc_halfcylinder*12', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6630, 6630, '1', 'bc_halfcylinder*13', 'bc_halfcylinder*13', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6631, 6631, '1', 'bc_halfcylinder*14', 'bc_halfcylinder*14', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6632, 6632, '1', 'bc_halfcylinder*15', 'bc_halfcylinder*15', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6633, 6633, '1', 'bc_halfcylinder*16', 'bc_halfcylinder*16', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6634, 6634, '1', 'bc_halfcylinder*17', 'bc_halfcylinder*17', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6635, 6635, '1', 'bc_halfcylinder*18', 'bc_halfcylinder*18', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6636, 6636, '1', 'bc_halfcylinder*19', 'bc_halfcylinder*19', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6637, 6637, '1', 'bc_halfcylinder*2', 'bc_halfcylinder*2', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6638, 6638, '1', 'bc_halfcylinder*20', 'bc_halfcylinder*20', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6639, 6639, '1', 'bc_halfcylinder*21', 'bc_halfcylinder*21', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6640, 6640, '1', 'bc_halfcylinder*22', 'bc_halfcylinder*22', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6641, 6641, '1', 'bc_halfcylinder*23', 'bc_halfcylinder*23', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6642, 6642, '1', 'bc_halfcylinder*24', 'bc_halfcylinder*24', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6643, 6643, '1', 'bc_halfcylinder*25', 'bc_halfcylinder*25', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6644, 6644, '1', 'bc_halfcylinder*26', 'bc_halfcylinder*26', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6645, 6645, '1', 'bc_halfcylinder*27', 'bc_halfcylinder*27', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6646, 6646, '1', 'bc_halfcylinder*28', 'bc_halfcylinder*28', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6647, 6647, '1', 'bc_halfcylinder*29', 'bc_halfcylinder*29', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6648, 6648, '1', 'bc_halfcylinder*3', 'bc_halfcylinder*3', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6649, 6649, '1', 'bc_halfcylinder*30', 'bc_halfcylinder*30', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6650, 6650, '1', 'bc_halfcylinder*31', 'bc_halfcylinder*31', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6651, 6651, '1', 'bc_halfcylinder*32', 'bc_halfcylinder*32', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6652, 6652, '1', 'bc_halfcylinder*33', 'bc_halfcylinder*33', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6653, 6653, '1', 'bc_halfcylinder*34', 'bc_halfcylinder*34', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6654, 6654, '1', 'bc_halfcylinder*35', 'bc_halfcylinder*35', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6655, 6655, '1', 'bc_halfcylinder*36', 'bc_halfcylinder*36', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6656, 6656, '1', 'bc_halfcylinder*37', 'bc_halfcylinder*37', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6657, 6657, '1', 'bc_halfcylinder*38', 'bc_halfcylinder*38', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6658, 6658, '1', 'bc_halfcylinder*39', 'bc_halfcylinder*39', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6659, 6659, '1', 'bc_halfcylinder*4', 'bc_halfcylinder*4', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6660, 6660, '1', 'bc_halfcylinder*40', 'bc_halfcylinder*40', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6661, 6661, '1', 'bc_halfcylinder*41', 'bc_halfcylinder*41', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6662, 6662, '1', 'bc_halfcylinder*42', 'bc_halfcylinder*42', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6663, 6663, '1', 'bc_halfcylinder*43', 'bc_halfcylinder*43', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6664, 6664, '1', 'bc_halfcylinder*44', 'bc_halfcylinder*44', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6665, 6665, '1', 'bc_halfcylinder*45', 'bc_halfcylinder*45', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6666, 6666, '1', 'bc_halfcylinder*46', 'bc_halfcylinder*46', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6667, 6667, '1', 'bc_halfcylinder*47', 'bc_halfcylinder*47', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6668, 6668, '1', 'bc_halfcylinder*48', 'bc_halfcylinder*48', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6669, 6669, '1', 'bc_halfcylinder*49', 'bc_halfcylinder*49', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6670, 6670, '1', 'bc_halfcylinder*5', 'bc_halfcylinder*5', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6671, 6671, '1', 'bc_halfcylinder*50', 'bc_halfcylinder*50', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6672, 6672, '1', 'bc_halfcylinder*51', 'bc_halfcylinder*51', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6673, 6673, '1', 'bc_halfcylinder*52', 'bc_halfcylinder*52', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6674, 6674, '1', 'bc_halfcylinder*53', 'bc_halfcylinder*53', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6675, 6675, '1', 'bc_halfcylinder*54', 'bc_halfcylinder*54', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6676, 6676, '1', 'bc_halfcylinder*55', 'bc_halfcylinder*55', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6677, 6677, '1', 'bc_halfcylinder*56', 'bc_halfcylinder*56', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6678, 6678, '1', 'bc_halfcylinder*57', 'bc_halfcylinder*57', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6679, 6679, '1', 'bc_halfcylinder*58', 'bc_halfcylinder*58', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6680, 6680, '1', 'bc_halfcylinder*59', 'bc_halfcylinder*59', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6681, 6681, '1', 'bc_halfcylinder*6', 'bc_halfcylinder*6', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6682, 6682, '1', 'bc_halfcylinder*60', 'bc_halfcylinder*60', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6683, 6683, '1', 'bc_halfcylinder*61', 'bc_halfcylinder*61', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6684, 6684, '1', 'bc_halfcylinder*62', 'bc_halfcylinder*62', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6685, 6685, '1', 'bc_halfcylinder*63', 'bc_halfcylinder*63', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6686, 6686, '1', 'bc_halfcylinder*64', 'bc_halfcylinder*64', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6687, 6687, '1', 'bc_halfcylinder*65', 'bc_halfcylinder*65', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6688, 6688, '1', 'bc_halfcylinder*66', 'bc_halfcylinder*66', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6689, 6689, '1', 'bc_halfcylinder*67', 'bc_halfcylinder*67', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6690, 6690, '1', 'bc_halfcylinder*68', 'bc_halfcylinder*68', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6691, 6691, '1', 'bc_halfcylinder*69', 'bc_halfcylinder*69', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6692, 6692, '1', 'bc_halfcylinder*7', 'bc_halfcylinder*7', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6693, 6693, '1', 'bc_halfcylinder*8', 'bc_halfcylinder*8', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6694, 6694, '1', 'bc_halfcylinder*9', 'bc_halfcylinder*9', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6695, 6695, '1', 'bc_quarterring*1', 'bc_quarterring*1', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6696, 6696, '1', 'bc_quarterring*10', 'bc_quarterring*10', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6697, 6697, '1', 'bc_quarterring*11', 'bc_quarterring*11', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6698, 6698, '1', 'bc_quarterring*12', 'bc_quarterring*12', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6699, 6699, '1', 'bc_quarterring*13', 'bc_quarterring*13', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6700, 6700, '1', 'bc_quarterring*14', 'bc_quarterring*14', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6701, 6701, '1', 'bc_quarterring*15', 'bc_quarterring*15', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6702, 6702, '1', 'bc_quarterring*16', 'bc_quarterring*16', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6703, 6703, '1', 'bc_quarterring*17', 'bc_quarterring*17', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6704, 6704, '1', 'bc_quarterring*18', 'bc_quarterring*18', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6705, 6705, '1', 'bc_quarterring*19', 'bc_quarterring*19', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6706, 6706, '1', 'bc_quarterring*2', 'bc_quarterring*2', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6707, 6707, '1', 'bc_quarterring*20', 'bc_quarterring*20', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6708, 6708, '1', 'bc_quarterring*21', 'bc_quarterring*21', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6709, 6709, '1', 'bc_quarterring*22', 'bc_quarterring*22', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6710, 6710, '1', 'bc_quarterring*23', 'bc_quarterring*23', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6711, 6711, '1', 'bc_quarterring*24', 'bc_quarterring*24', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6712, 6712, '1', 'bc_quarterring*25', 'bc_quarterring*25', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6713, 6713, '1', 'bc_quarterring*26', 'bc_quarterring*26', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6714, 6714, '1', 'bc_quarterring*27', 'bc_quarterring*27', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6715, 6715, '1', 'bc_quarterring*28', 'bc_quarterring*28', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6716, 6716, '1', 'bc_quarterring*29', 'bc_quarterring*29', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6717, 6717, '1', 'bc_quarterring*3', 'bc_quarterring*3', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6718, 6718, '1', 'bc_quarterring*30', 'bc_quarterring*30', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6719, 6719, '1', 'bc_quarterring*31', 'bc_quarterring*31', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6720, 6720, '1', 'bc_quarterring*32', 'bc_quarterring*32', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6721, 6721, '1', 'bc_quarterring*33', 'bc_quarterring*33', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6722, 6722, '1', 'bc_quarterring*34', 'bc_quarterring*34', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6723, 6723, '1', 'bc_quarterring*35', 'bc_quarterring*35', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6724, 6724, '1', 'bc_quarterring*36', 'bc_quarterring*36', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6725, 6725, '1', 'bc_quarterring*37', 'bc_quarterring*37', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6726, 6726, '1', 'bc_quarterring*38', 'bc_quarterring*38', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6727, 6727, '1', 'bc_quarterring*39', 'bc_quarterring*39', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6728, 6728, '1', 'bc_quarterring*4', 'bc_quarterring*4', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6729, 6729, '1', 'bc_quarterring*40', 'bc_quarterring*40', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6730, 6730, '1', 'bc_quarterring*41', 'bc_quarterring*41', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6731, 6731, '1', 'bc_quarterring*42', 'bc_quarterring*42', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6732, 6732, '1', 'bc_quarterring*43', 'bc_quarterring*43', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6733, 6733, '1', 'bc_quarterring*44', 'bc_quarterring*44', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6734, 6734, '1', 'bc_quarterring*45', 'bc_quarterring*45', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6735, 6735, '1', 'bc_quarterring*46', 'bc_quarterring*46', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6736, 6736, '1', 'bc_quarterring*47', 'bc_quarterring*47', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6737, 6737, '1', 'bc_quarterring*48', 'bc_quarterring*48', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6738, 6738, '1', 'bc_quarterring*49', 'bc_quarterring*49', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6739, 6739, '1', 'bc_quarterring*5', 'bc_quarterring*5', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6740, 6740, '1', 'bc_quarterring*50', 'bc_quarterring*50', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6741, 6741, '1', 'bc_quarterring*51', 'bc_quarterring*51', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6742, 6742, '1', 'bc_quarterring*52', 'bc_quarterring*52', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6743, 6743, '1', 'bc_quarterring*53', 'bc_quarterring*53', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6744, 6744, '1', 'bc_quarterring*54', 'bc_quarterring*54', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6745, 6745, '1', 'bc_quarterring*55', 'bc_quarterring*55', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6746, 6746, '1', 'bc_quarterring*56', 'bc_quarterring*56', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6747, 6747, '1', 'bc_quarterring*57', 'bc_quarterring*57', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6748, 6748, '1', 'bc_quarterring*58', 'bc_quarterring*58', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6749, 6749, '1', 'bc_quarterring*59', 'bc_quarterring*59', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6750, 6750, '1', 'bc_quarterring*6', 'bc_quarterring*6', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6751, 6751, '1', 'bc_quarterring*60', 'bc_quarterring*60', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6752, 6752, '1', 'bc_quarterring*61', 'bc_quarterring*61', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6753, 6753, '1', 'bc_quarterring*62', 'bc_quarterring*62', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6754, 6754, '1', 'bc_quarterring*63', 'bc_quarterring*63', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6755, 6755, '1', 'bc_quarterring*64', 'bc_quarterring*64', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6756, 6756, '1', 'bc_quarterring*65', 'bc_quarterring*65', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6757, 6757, '1', 'bc_quarterring*66', 'bc_quarterring*66', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6758, 6758, '1', 'bc_quarterring*67', 'bc_quarterring*67', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6759, 6759, '1', 'bc_quarterring*68', 'bc_quarterring*68', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6760, 6760, '1', 'bc_quarterring*69', 'bc_quarterring*69', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6761, 6761, '1', 'bc_quarterring*7', 'bc_quarterring*7', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6762, 6762, '1', 'bc_quarterring*8', 'bc_quarterring*8', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6763, 6763, '1', 'bc_quarterring*9', 'bc_quarterring*9', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(6764, 6764, '1', 'bc_glasspanel*1', 'bc_glasspanel*1', 'S', 2, 1, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6765, 6765, '1', 'bc_glasspanel*10', 'bc_glasspanel*10', 'S', 2, 1, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6766, 6766, '1', 'bc_glasspanel*11', 'bc_glasspanel*11', 'S', 2, 1, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6767, 6767, '1', 'bc_glasspanel*12', 'bc_glasspanel*12', 'S', 2, 1, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6768, 6768, '1', 'bc_glasspanel*13', 'bc_glasspanel*13', 'S', 2, 1, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6769, 6769, '1', 'bc_glasspanel*14', 'bc_glasspanel*14', 'S', 2, 1, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6770, 6770, '1', 'bc_glasspanel*15', 'bc_glasspanel*15', 'S', 2, 1, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6771, 6771, '1', 'bc_glasspanel*16', 'bc_glasspanel*16', 'S', 2, 1, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6772, 6772, '1', 'bc_glasspanel*17', 'bc_glasspanel*17', 'S', 2, 1, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6773, 6773, '1', 'bc_glasspanel*18', 'bc_glasspanel*18', 'S', 2, 1, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6774, 6774, '1', 'bc_glasspanel*19', 'bc_glasspanel*19', 'S', 2, 1, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6775, 6775, '1', 'bc_glasspanel*2', 'bc_glasspanel*2', 'S', 2, 1, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6776, 6776, '1', 'bc_glasspanel*20', 'bc_glasspanel*20', 'S', 2, 1, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6777, 6777, '1', 'bc_glasspanel*21', 'bc_glasspanel*21', 'S', 2, 1, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6778, 6778, '1', 'bc_glasspanel*22', 'bc_glasspanel*22', 'S', 2, 1, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6779, 6779, '1', 'bc_glasspanel*23', 'bc_glasspanel*23', 'S', 2, 1, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6780, 6780, '1', 'bc_glasspanel*24', 'bc_glasspanel*24', 'S', 2, 1, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6781, 6781, '1', 'bc_glasspanel*25', 'bc_glasspanel*25', 'S', 2, 1, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6782, 6782, '1', 'bc_glasspanel*26', 'bc_glasspanel*26', 'S', 2, 1, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6783, 6783, '1', 'bc_glasspanel*27', 'bc_glasspanel*27', 'S', 2, 1, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6784, 6784, '1', 'bc_glasspanel*28', 'bc_glasspanel*28', 'S', 2, 1, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6785, 6785, '1', 'bc_glasspanel*29', 'bc_glasspanel*29', 'S', 2, 1, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6786, 6786, '1', 'bc_glasspanel*3', 'bc_glasspanel*3', 'S', 2, 1, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6787, 6787, '1', 'bc_glasspanel*30', 'bc_glasspanel*30', 'S', 2, 1, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6788, 6788, '1', 'bc_glasspanel*31', 'bc_glasspanel*31', 'S', 2, 1, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6789, 6789, '1', 'bc_glasspanel*32', 'bc_glasspanel*32', 'S', 2, 1, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6790, 6790, '1', 'bc_glasspanel*33', 'bc_glasspanel*33', 'S', 2, 1, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6791, 6791, '1', 'bc_glasspanel*34', 'bc_glasspanel*34', 'S', 2, 1, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6792, 6792, '1', 'bc_glasspanel*35', 'bc_glasspanel*35', 'S', 2, 1, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6793, 6793, '1', 'bc_glasspanel*36', 'bc_glasspanel*36', 'S', 2, 1, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6794, 6794, '1', 'bc_glasspanel*37', 'bc_glasspanel*37', 'S', 2, 1, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6795, 6795, '1', 'bc_glasspanel*38', 'bc_glasspanel*38', 'S', 2, 1, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6796, 6796, '1', 'bc_glasspanel*39', 'bc_glasspanel*39', 'S', 2, 1, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6797, 6797, '1', 'bc_glasspanel*4', 'bc_glasspanel*4', 'S', 2, 1, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6798, 6798, '1', 'bc_glasspanel*40', 'bc_glasspanel*40', 'S', 2, 1, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6799, 6799, '1', 'bc_glasspanel*41', 'bc_glasspanel*41', 'S', 2, 1, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6800, 6800, '1', 'bc_glasspanel*42', 'bc_glasspanel*42', 'S', 2, 1, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6801, 6801, '1', 'bc_glasspanel*43', 'bc_glasspanel*43', 'S', 2, 1, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6802, 6802, '1', 'bc_glasspanel*44', 'bc_glasspanel*44', 'S', 2, 1, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6803, 6803, '1', 'bc_glasspanel*45', 'bc_glasspanel*45', 'S', 2, 1, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6804, 6804, '1', 'bc_glasspanel*46', 'bc_glasspanel*46', 'S', 2, 1, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6805, 6805, '1', 'bc_glasspanel*47', 'bc_glasspanel*47', 'S', 2, 1, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6806, 6806, '1', 'bc_glasspanel*48', 'bc_glasspanel*48', 'S', 2, 1, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6807, 6807, '1', 'bc_glasspanel*49', 'bc_glasspanel*49', 'S', 2, 1, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6808, 6808, '1', 'bc_glasspanel*5', 'bc_glasspanel*5', 'S', 2, 1, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6809, 6809, '1', 'bc_glasspanel*50', 'bc_glasspanel*50', 'S', 2, 1, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6810, 6810, '1', 'bc_glasspanel*51', 'bc_glasspanel*51', 'S', 2, 1, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6811, 6811, '1', 'bc_glasspanel*52', 'bc_glasspanel*52', 'S', 2, 1, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6812, 6812, '1', 'bc_glasspanel*53', 'bc_glasspanel*53', 'S', 2, 1, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6813, 6813, '1', 'bc_glasspanel*54', 'bc_glasspanel*54', 'S', 2, 1, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6814, 6814, '1', 'bc_glasspanel*55', 'bc_glasspanel*55', 'S', 2, 1, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6815, 6815, '1', 'bc_glasspanel*56', 'bc_glasspanel*56', 'S', 2, 1, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6816, 6816, '1', 'bc_glasspanel*57', 'bc_glasspanel*57', 'S', 2, 1, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6817, 6817, '1', 'bc_glasspanel*58', 'bc_glasspanel*58', 'S', 2, 1, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6818, 6818, '1', 'bc_glasspanel*59', 'bc_glasspanel*59', 'S', 2, 1, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6819, 6819, '1', 'bc_glasspanel*6', 'bc_glasspanel*6', 'S', 2, 1, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6820, 6820, '1', 'bc_glasspanel*60', 'bc_glasspanel*60', 'S', 2, 1, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6821, 6821, '1', 'bc_glasspanel*61', 'bc_glasspanel*61', 'S', 2, 1, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6822, 6822, '1', 'bc_glasspanel*62', 'bc_glasspanel*62', 'S', 2, 1, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6823, 6823, '1', 'bc_glasspanel*63', 'bc_glasspanel*63', 'S', 2, 1, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6824, 6824, '1', 'bc_glasspanel*64', 'bc_glasspanel*64', 'S', 2, 1, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6825, 6825, '1', 'bc_glasspanel*65', 'bc_glasspanel*65', 'S', 2, 1, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6826, 6826, '1', 'bc_glasspanel*66', 'bc_glasspanel*66', 'S', 2, 1, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6827, 6827, '1', 'bc_glasspanel*67', 'bc_glasspanel*67', 'S', 2, 1, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6828, 6828, '1', 'bc_glasspanel*68', 'bc_glasspanel*68', 'S', 2, 1, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6829, 6829, '1', 'bc_glasspanel*69', 'bc_glasspanel*69', 'S', 2, 1, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6830, 6830, '1', 'bc_glasspanel*7', 'bc_glasspanel*7', 'S', 2, 1, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6831, 6831, '1', 'bc_glasspanel*8', 'bc_glasspanel*8', 'S', 2, 1, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6832, 6832, '1', 'bc_glasspanel*9', 'bc_glasspanel*9', 'S', 2, 1, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(6833, 6833, '1', 'bc_wedge*1', 'bc_wedge*1', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6834, 6834, '1', 'bc_wedge*10', 'bc_wedge*10', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6835, 6835, '1', 'bc_wedge*11', 'bc_wedge*11', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6836, 6836, '1', 'bc_wedge*12', 'bc_wedge*12', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6837, 6837, '1', 'bc_wedge*13', 'bc_wedge*13', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6838, 6838, '1', 'bc_wedge*14', 'bc_wedge*14', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6839, 6839, '1', 'bc_wedge*15', 'bc_wedge*15', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6840, 6840, '1', 'bc_wedge*16', 'bc_wedge*16', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6841, 6841, '1', 'bc_wedge*17', 'bc_wedge*17', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6842, 6842, '1', 'bc_wedge*18', 'bc_wedge*18', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6843, 6843, '1', 'bc_wedge*19', 'bc_wedge*19', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6844, 6844, '1', 'bc_wedge*2', 'bc_wedge*2', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6845, 6845, '1', 'bc_wedge*20', 'bc_wedge*20', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6846, 6846, '1', 'bc_wedge*21', 'bc_wedge*21', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6847, 6847, '1', 'bc_wedge*22', 'bc_wedge*22', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6848, 6848, '1', 'bc_wedge*23', 'bc_wedge*23', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6849, 6849, '1', 'bc_wedge*24', 'bc_wedge*24', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6850, 6850, '1', 'bc_wedge*25', 'bc_wedge*25', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6851, 6851, '1', 'bc_wedge*26', 'bc_wedge*26', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6852, 6852, '1', 'bc_wedge*27', 'bc_wedge*27', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6853, 6853, '1', 'bc_wedge*28', 'bc_wedge*28', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6854, 6854, '1', 'bc_wedge*29', 'bc_wedge*29', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6855, 6855, '1', 'bc_wedge*3', 'bc_wedge*3', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6856, 6856, '1', 'bc_wedge*30', 'bc_wedge*30', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6857, 6857, '1', 'bc_wedge*31', 'bc_wedge*31', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6858, 6858, '1', 'bc_wedge*32', 'bc_wedge*32', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6859, 6859, '1', 'bc_wedge*33', 'bc_wedge*33', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6860, 6860, '1', 'bc_wedge*34', 'bc_wedge*34', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6861, 6861, '1', 'bc_wedge*35', 'bc_wedge*35', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6862, 6862, '1', 'bc_wedge*36', 'bc_wedge*36', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6863, 6863, '1', 'bc_wedge*37', 'bc_wedge*37', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6864, 6864, '1', 'bc_wedge*38', 'bc_wedge*38', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6865, 6865, '1', 'bc_wedge*39', 'bc_wedge*39', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6866, 6866, '1', 'bc_wedge*4', 'bc_wedge*4', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6867, 6867, '1', 'bc_wedge*40', 'bc_wedge*40', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6868, 6868, '1', 'bc_wedge*41', 'bc_wedge*41', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6869, 6869, '1', 'bc_wedge*42', 'bc_wedge*42', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6870, 6870, '1', 'bc_wedge*43', 'bc_wedge*43', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6871, 6871, '1', 'bc_wedge*44', 'bc_wedge*44', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6872, 6872, '1', 'bc_wedge*45', 'bc_wedge*45', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6873, 6873, '1', 'bc_wedge*46', 'bc_wedge*46', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6874, 6874, '1', 'bc_wedge*47', 'bc_wedge*47', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6875, 6875, '1', 'bc_wedge*48', 'bc_wedge*48', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6876, 6876, '1', 'bc_wedge*49', 'bc_wedge*49', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6877, 6877, '1', 'bc_wedge*5', 'bc_wedge*5', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6878, 6878, '1', 'bc_wedge*50', 'bc_wedge*50', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6879, 6879, '1', 'bc_wedge*51', 'bc_wedge*51', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6880, 6880, '1', 'bc_wedge*52', 'bc_wedge*52', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6881, 6881, '1', 'bc_wedge*53', 'bc_wedge*53', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6882, 6882, '1', 'bc_wedge*54', 'bc_wedge*54', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6883, 6883, '1', 'bc_wedge*55', 'bc_wedge*55', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6884, 6884, '1', 'bc_wedge*56', 'bc_wedge*56', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6885, 6885, '1', 'bc_wedge*57', 'bc_wedge*57', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6886, 6886, '1', 'bc_wedge*58', 'bc_wedge*58', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6887, 6887, '1', 'bc_wedge*59', 'bc_wedge*59', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6888, 6888, '1', 'bc_wedge*6', 'bc_wedge*6', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6889, 6889, '1', 'bc_wedge*60', 'bc_wedge*60', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6890, 6890, '1', 'bc_wedge*61', 'bc_wedge*61', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6891, 6891, '1', 'bc_wedge*62', 'bc_wedge*62', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6892, 6892, '1', 'bc_wedge*63', 'bc_wedge*63', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6893, 6893, '1', 'bc_wedge*64', 'bc_wedge*64', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6894, 6894, '1', 'bc_wedge*65', 'bc_wedge*65', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6895, 6895, '1', 'bc_wedge*66', 'bc_wedge*66', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6896, 6896, '1', 'bc_wedge*67', 'bc_wedge*67', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6897, 6897, '1', 'bc_wedge*68', 'bc_wedge*68', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6898, 6898, '1', 'bc_wedge*69', 'bc_wedge*69', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6899, 6899, '1', 'bc_wedge*7', 'bc_wedge*7', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6900, 6900, '1', 'bc_wedge*8', 'bc_wedge*8', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6901, 6901, '1', 'bc_wedge*9', 'bc_wedge*9', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(6902, 6902, '1', 'bc_block_0*15', 'bc_block_0*15', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6903, 6903, '1', 'bc_block_0*16', 'bc_block_0*16', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6904, 6904, '1', 'bc_block_0*17', 'bc_block_0*17', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6905, 6905, '1', 'bc_block_0*18', 'bc_block_0*18', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6906, 6906, '1', 'bc_block_0*19', 'bc_block_0*19', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6907, 6907, '1', 'bc_block_0*20', 'bc_block_0*20', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6908, 6908, '1', 'bc_block_0*21', 'bc_block_0*21', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6909, 6909, '1', 'bc_block_0*22', 'bc_block_0*22', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6910, 6910, '1', 'bc_block_0*23', 'bc_block_0*23', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6911, 6911, '1', 'bc_block_0*24', 'bc_block_0*24', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6912, 6912, '1', 'bc_block_0*25', 'bc_block_0*25', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6913, 6913, '1', 'bc_block_0*26', 'bc_block_0*26', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6914, 6914, '1', 'bc_block_0*27', 'bc_block_0*27', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6915, 6915, '1', 'bc_block_0*28', 'bc_block_0*28', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6916, 6916, '1', 'bc_block_0*29', 'bc_block_0*29', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6917, 6917, '1', 'bc_block_0*30', 'bc_block_0*30', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6918, 6918, '1', 'bc_block_0*31', 'bc_block_0*31', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6919, 6919, '1', 'bc_block_0*32', 'bc_block_0*32', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6920, 6920, '1', 'bc_block_0*33', 'bc_block_0*33', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6921, 6921, '1', 'bc_block_0*34', 'bc_block_0*34', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6922, 6922, '1', 'bc_block_0*35', 'bc_block_0*35', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6923, 6923, '1', 'bc_block_0*36', 'bc_block_0*36', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6924, 6924, '1', 'bc_block_0*37', 'bc_block_0*37', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6925, 6925, '1', 'bc_block_0*38', 'bc_block_0*38', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6926, 6926, '1', 'bc_block_0*39', 'bc_block_0*39', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6927, 6927, '1', 'bc_block_0*40', 'bc_block_0*40', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6928, 6928, '1', 'bc_block_0*41', 'bc_block_0*41', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6929, 6929, '1', 'bc_block_0*42', 'bc_block_0*42', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6930, 6930, '1', 'bc_block_0*43', 'bc_block_0*43', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6931, 6931, '1', 'bc_block_0*44', 'bc_block_0*44', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6932, 6932, '1', 'bc_block_0*45', 'bc_block_0*45', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6933, 6933, '1', 'bc_block_0*46', 'bc_block_0*46', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6934, 6934, '1', 'bc_block_0*47', 'bc_block_0*47', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6935, 6935, '1', 'bc_block_0*48', 'bc_block_0*48', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6936, 6936, '1', 'bc_block_0*49', 'bc_block_0*49', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6937, 6937, '1', 'bc_block_0*50', 'bc_block_0*50', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6938, 6938, '1', 'bc_block_0*51', 'bc_block_0*51', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6939, 6939, '1', 'bc_block_0*52', 'bc_block_0*52', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6940, 6940, '1', 'bc_block_0*53', 'bc_block_0*53', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6941, 6941, '1', 'bc_block_0*54', 'bc_block_0*54', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6942, 6942, '1', 'bc_block_0*55', 'bc_block_0*55', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6943, 6943, '1', 'bc_block_0*56', 'bc_block_0*56', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6944, 6944, '1', 'bc_block_0*57', 'bc_block_0*57', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6945, 6945, '1', 'bc_block_0*58', 'bc_block_0*58', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6946, 6946, '1', 'bc_block_0*59', 'bc_block_0*59', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6947, 6947, '1', 'bc_block_0*60', 'bc_block_0*60', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6948, 6948, '1', 'bc_block_0*61', 'bc_block_0*61', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6949, 6949, '1', 'bc_block_0*62', 'bc_block_0*62', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6950, 6950, '1', 'bc_block_0*63', 'bc_block_0*63', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6951, 6951, '1', 'bc_block_0*64', 'bc_block_0*64', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6952, 6952, '1', 'bc_block_0*65', 'bc_block_0*65', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6953, 6953, '1', 'bc_block_0*66', 'bc_block_0*66', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6954, 6954, '1', 'bc_block_0*67', 'bc_block_0*67', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6955, 6955, '1', 'bc_block_0*68', 'bc_block_0*68', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6956, 6956, '1', 'bc_block_0*69', 'bc_block_0*69', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6957, 6957, '1', 'bc_cylinder*1', 'bc_cylinder*1', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6958, 6958, '1', 'bc_cylinder*10', 'bc_cylinder*10', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6959, 6959, '1', 'bc_cylinder*11', 'bc_cylinder*11', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6960, 6960, '1', 'bc_cylinder*12', 'bc_cylinder*12', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6961, 6961, '1', 'bc_cylinder*13', 'bc_cylinder*13', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6962, 6962, '1', 'bc_cylinder*14', 'bc_cylinder*14', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6963, 6963, '1', 'bc_cylinder*15', 'bc_cylinder*15', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6964, 6964, '1', 'bc_cylinder*16', 'bc_cylinder*16', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6965, 6965, '1', 'bc_cylinder*17', 'bc_cylinder*17', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6966, 6966, '1', 'bc_cylinder*18', 'bc_cylinder*18', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6967, 6967, '1', 'bc_cylinder*19', 'bc_cylinder*19', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6968, 6968, '1', 'bc_cylinder*2', 'bc_cylinder*2', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6969, 6969, '1', 'bc_cylinder*20', 'bc_cylinder*20', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6970, 6970, '1', 'bc_cylinder*21', 'bc_cylinder*21', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6971, 6971, '1', 'bc_cylinder*22', 'bc_cylinder*22', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6972, 6972, '1', 'bc_cylinder*23', 'bc_cylinder*23', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6973, 6973, '1', 'bc_cylinder*24', 'bc_cylinder*24', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6974, 6974, '1', 'bc_cylinder*25', 'bc_cylinder*25', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6975, 6975, '1', 'bc_cylinder*26', 'bc_cylinder*26', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6976, 6976, '1', 'bc_cylinder*27', 'bc_cylinder*27', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6977, 6977, '1', 'bc_cylinder*28', 'bc_cylinder*28', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6978, 6978, '1', 'bc_cylinder*29', 'bc_cylinder*29', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6979, 6979, '1', 'bc_cylinder*3', 'bc_cylinder*3', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6980, 6980, '1', 'bc_cylinder*30', 'bc_cylinder*30', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6981, 6981, '1', 'bc_cylinder*31', 'bc_cylinder*31', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6982, 6982, '1', 'bc_cylinder*32', 'bc_cylinder*32', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6983, 6983, '1', 'bc_cylinder*33', 'bc_cylinder*33', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6984, 6984, '1', 'bc_cylinder*34', 'bc_cylinder*34', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6985, 6985, '1', 'bc_cylinder*35', 'bc_cylinder*35', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6986, 6986, '1', 'bc_cylinder*36', 'bc_cylinder*36', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6987, 6987, '1', 'bc_cylinder*37', 'bc_cylinder*37', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6988, 6988, '1', 'bc_cylinder*38', 'bc_cylinder*38', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6989, 6989, '1', 'bc_cylinder*39', 'bc_cylinder*39', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6990, 6990, '1', 'bc_cylinder*4', 'bc_cylinder*4', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6991, 6991, '1', 'bc_cylinder*40', 'bc_cylinder*40', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6992, 6992, '1', 'bc_cylinder*41', 'bc_cylinder*41', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6993, 6993, '1', 'bc_cylinder*42', 'bc_cylinder*42', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6994, 6994, '1', 'bc_cylinder*43', 'bc_cylinder*43', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6995, 6995, '1', 'bc_cylinder*44', 'bc_cylinder*44', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6996, 6996, '1', 'bc_cylinder*45', 'bc_cylinder*45', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6997, 6997, '1', 'bc_cylinder*46', 'bc_cylinder*46', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6998, 6998, '1', 'bc_cylinder*47', 'bc_cylinder*47', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(6999, 6999, '1', 'bc_cylinder*48', 'bc_cylinder*48', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7000, 7000, '1', 'bc_cylinder*49', 'bc_cylinder*49', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7001, 7001, '1', 'bc_cylinder*5', 'bc_cylinder*5', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7002, 7002, '1', 'bc_cylinder*50', 'bc_cylinder*50', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7003, 7003, '1', 'bc_cylinder*51', 'bc_cylinder*51', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7004, 7004, '1', 'bc_cylinder*52', 'bc_cylinder*52', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7005, 7005, '1', 'bc_cylinder*53', 'bc_cylinder*53', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7006, 7006, '1', 'bc_cylinder*54', 'bc_cylinder*54', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7007, 7007, '1', 'bc_cylinder*55', 'bc_cylinder*55', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7008, 7008, '1', 'bc_cylinder*56', 'bc_cylinder*56', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7009, 7009, '1', 'bc_cylinder*57', 'bc_cylinder*57', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7010, 7010, '1', 'bc_cylinder*58', 'bc_cylinder*58', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7011, 7011, '1', 'bc_cylinder*59', 'bc_cylinder*59', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7012, 7012, '1', 'bc_cylinder*6', 'bc_cylinder*6', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7013, 7013, '1', 'bc_cylinder*60', 'bc_cylinder*60', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7014, 7014, '1', 'bc_cylinder*61', 'bc_cylinder*61', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7015, 7015, '1', 'bc_cylinder*62', 'bc_cylinder*62', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7016, 7016, '1', 'bc_cylinder*63', 'bc_cylinder*63', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7017, 7017, '1', 'bc_cylinder*64', 'bc_cylinder*64', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7018, 7018, '1', 'bc_cylinder*65', 'bc_cylinder*65', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7019, 7019, '1', 'bc_cylinder*66', 'bc_cylinder*66', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7020, 7020, '1', 'bc_cylinder*67', 'bc_cylinder*67', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7021, 7021, '1', 'bc_cylinder*68', 'bc_cylinder*68', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7022, 7022, '1', 'bc_cylinder*69', 'bc_cylinder*69', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7023, 7023, '1', 'bc_cylinder*7', 'bc_cylinder*7', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7024, 7024, '1', 'bc_cylinder*8', 'bc_cylinder*8', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7025, 7025, '1', 'bc_cylinder*9', 'bc_cylinder*9', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7026, 7026, '1', 'bc_standingtriangularprism*1', 'bc_standingtriangularprism*1', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7027, 7027, '1', 'bc_standingtriangularprism*10', 'bc_standingtriangularprism*10', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7028, 7028, '1', 'bc_standingtriangularprism*11', 'bc_standingtriangularprism*11', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7029, 7029, '1', 'bc_standingtriangularprism*12', 'bc_standingtriangularprism*12', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7030, 7030, '1', 'bc_standingtriangularprism*13', 'bc_standingtriangularprism*13', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7031, 7031, '1', 'bc_standingtriangularprism*14', 'bc_standingtriangularprism*14', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7032, 7032, '1', 'bc_standingtriangularprism*15', 'bc_standingtriangularprism*15', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7033, 7033, '1', 'bc_standingtriangularprism*16', 'bc_standingtriangularprism*16', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7034, 7034, '1', 'bc_standingtriangularprism*17', 'bc_standingtriangularprism*17', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7035, 7035, '1', 'bc_standingtriangularprism*18', 'bc_standingtriangularprism*18', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7036, 7036, '1', 'bc_standingtriangularprism*19', 'bc_standingtriangularprism*19', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7037, 7037, '1', 'bc_standingtriangularprism*2', 'bc_standingtriangularprism*2', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7038, 7038, '1', 'bc_standingtriangularprism*20', 'bc_standingtriangularprism*20', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7039, 7039, '1', 'bc_standingtriangularprism*21', 'bc_standingtriangularprism*21', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7040, 7040, '1', 'bc_standingtriangularprism*22', 'bc_standingtriangularprism*22', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7041, 7041, '1', 'bc_standingtriangularprism*23', 'bc_standingtriangularprism*23', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7042, 7042, '1', 'bc_standingtriangularprism*24', 'bc_standingtriangularprism*24', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7043, 7043, '1', 'bc_standingtriangularprism*25', 'bc_standingtriangularprism*25', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7044, 7044, '1', 'bc_standingtriangularprism*26', 'bc_standingtriangularprism*26', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7045, 7045, '1', 'bc_standingtriangularprism*27', 'bc_standingtriangularprism*27', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7046, 7046, '1', 'bc_standingtriangularprism*28', 'bc_standingtriangularprism*28', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7047, 7047, '1', 'bc_standingtriangularprism*29', 'bc_standingtriangularprism*29', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7048, 7048, '1', 'bc_standingtriangularprism*3', 'bc_standingtriangularprism*3', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7049, 7049, '1', 'bc_standingtriangularprism*30', 'bc_standingtriangularprism*30', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7050, 7050, '1', 'bc_standingtriangularprism*31', 'bc_standingtriangularprism*31', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7051, 7051, '1', 'bc_standingtriangularprism*32', 'bc_standingtriangularprism*32', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7052, 7052, '1', 'bc_standingtriangularprism*33', 'bc_standingtriangularprism*33', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7053, 7053, '1', 'bc_standingtriangularprism*34', 'bc_standingtriangularprism*34', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7054, 7054, '1', 'bc_standingtriangularprism*35', 'bc_standingtriangularprism*35', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7055, 7055, '1', 'bc_standingtriangularprism*36', 'bc_standingtriangularprism*36', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(7056, 7056, '1', 'bc_standingtriangularprism*37', 'bc_standingtriangularprism*37', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7057, 7057, '1', 'bc_standingtriangularprism*38', 'bc_standingtriangularprism*38', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7058, 7058, '1', 'bc_standingtriangularprism*39', 'bc_standingtriangularprism*39', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7059, 7059, '1', 'bc_standingtriangularprism*4', 'bc_standingtriangularprism*4', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7060, 7060, '1', 'bc_standingtriangularprism*40', 'bc_standingtriangularprism*40', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7061, 7061, '1', 'bc_standingtriangularprism*41', 'bc_standingtriangularprism*41', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7062, 7062, '1', 'bc_standingtriangularprism*42', 'bc_standingtriangularprism*42', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7063, 7063, '1', 'bc_standingtriangularprism*43', 'bc_standingtriangularprism*43', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7064, 7064, '1', 'bc_standingtriangularprism*44', 'bc_standingtriangularprism*44', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7065, 7065, '1', 'bc_standingtriangularprism*45', 'bc_standingtriangularprism*45', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7066, 7066, '1', 'bc_standingtriangularprism*46', 'bc_standingtriangularprism*46', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7067, 7067, '1', 'bc_standingtriangularprism*47', 'bc_standingtriangularprism*47', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7068, 7068, '1', 'bc_standingtriangularprism*48', 'bc_standingtriangularprism*48', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7069, 7069, '1', 'bc_standingtriangularprism*49', 'bc_standingtriangularprism*49', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7070, 7070, '1', 'bc_standingtriangularprism*5', 'bc_standingtriangularprism*5', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7071, 7071, '1', 'bc_standingtriangularprism*50', 'bc_standingtriangularprism*50', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7072, 7072, '1', 'bc_standingtriangularprism*51', 'bc_standingtriangularprism*51', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7073, 7073, '1', 'bc_standingtriangularprism*52', 'bc_standingtriangularprism*52', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7074, 7074, '1', 'bc_standingtriangularprism*53', 'bc_standingtriangularprism*53', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7075, 7075, '1', 'bc_standingtriangularprism*54', 'bc_standingtriangularprism*54', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7076, 7076, '1', 'bc_standingtriangularprism*55', 'bc_standingtriangularprism*55', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7077, 7077, '1', 'bc_standingtriangularprism*56', 'bc_standingtriangularprism*56', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7078, 7078, '1', 'bc_standingtriangularprism*57', 'bc_standingtriangularprism*57', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7079, 7079, '1', 'bc_standingtriangularprism*58', 'bc_standingtriangularprism*58', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7080, 7080, '1', 'bc_standingtriangularprism*59', 'bc_standingtriangularprism*59', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7081, 7081, '1', 'bc_standingtriangularprism*6', 'bc_standingtriangularprism*6', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7082, 7082, '1', 'bc_standingtriangularprism*60', 'bc_standingtriangularprism*60', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7083, 7083, '1', 'bc_standingtriangularprism*61', 'bc_standingtriangularprism*61', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7084, 7084, '1', 'bc_standingtriangularprism*62', 'bc_standingtriangularprism*62', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7085, 7085, '1', 'bc_standingtriangularprism*63', 'bc_standingtriangularprism*63', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7086, 7086, '1', 'bc_standingtriangularprism*64', 'bc_standingtriangularprism*64', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7087, 7087, '1', 'bc_standingtriangularprism*65', 'bc_standingtriangularprism*65', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7088, 7088, '1', 'bc_standingtriangularprism*66', 'bc_standingtriangularprism*66', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7089, 7089, '1', 'bc_standingtriangularprism*67', 'bc_standingtriangularprism*67', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7090, 7090, '1', 'bc_standingtriangularprism*68', 'bc_standingtriangularprism*68', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7091, 7091, '1', 'bc_standingtriangularprism*69', 'bc_standingtriangularprism*69', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7092, 7092, '1', 'bc_standingtriangularprism*7', 'bc_standingtriangularprism*7', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7093, 7093, '1', 'bc_standingtriangularprism*8', 'bc_standingtriangularprism*8', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7094, 7094, '1', 'bc_standingtriangularprism*9', 'bc_standingtriangularprism*9', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7095, 7095, '1', 'bc_block_1*15', 'bc_block_1*15', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7096, 7096, '1', 'bc_block_1*16', 'bc_block_1*16', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7097, 7097, '1', 'bc_block_1*17', 'bc_block_1*17', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7098, 7098, '1', 'bc_block_1*18', 'bc_block_1*18', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7099, 7099, '1', 'bc_block_1*19', 'bc_block_1*19', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7100, 7100, '1', 'bc_block_1*20', 'bc_block_1*20', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7101, 7101, '1', 'bc_block_1*21', 'bc_block_1*21', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7102, 7102, '1', 'bc_block_1*22', 'bc_block_1*22', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7103, 7103, '1', 'bc_block_1*23', 'bc_block_1*23', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7104, 7104, '1', 'bc_block_1*24', 'bc_block_1*24', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7105, 7105, '1', 'bc_block_1*25', 'bc_block_1*25', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7106, 7106, '1', 'bc_block_1*26', 'bc_block_1*26', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7107, 7107, '1', 'bc_block_1*27', 'bc_block_1*27', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7108, 7108, '1', 'bc_block_1*28', 'bc_block_1*28', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7109, 7109, '1', 'bc_block_1*29', 'bc_block_1*29', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7110, 7110, '1', 'bc_block_1*30', 'bc_block_1*30', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7111, 7111, '1', 'bc_block_1*31', 'bc_block_1*31', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7112, 7112, '1', 'bc_block_1*32', 'bc_block_1*32', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7113, 7113, '1', 'bc_block_1*33', 'bc_block_1*33', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7114, 7114, '1', 'bc_block_1*34', 'bc_block_1*34', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7115, 7115, '1', 'bc_block_1*35', 'bc_block_1*35', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7116, 7116, '1', 'bc_block_1*36', 'bc_block_1*36', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7117, 7117, '1', 'bc_block_1*37', 'bc_block_1*37', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7118, 7118, '1', 'bc_block_1*38', 'bc_block_1*38', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7119, 7119, '1', 'bc_block_1*39', 'bc_block_1*39', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7120, 7120, '1', 'bc_block_1*40', 'bc_block_1*40', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7121, 7121, '1', 'bc_block_1*41', 'bc_block_1*41', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7122, 7122, '1', 'bc_block_1*42', 'bc_block_1*42', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7123, 7123, '1', 'bc_block_1*43', 'bc_block_1*43', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7124, 7124, '1', 'bc_block_1*44', 'bc_block_1*44', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7125, 7125, '1', 'bc_block_1*45', 'bc_block_1*45', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7126, 7126, '1', 'bc_block_1*46', 'bc_block_1*46', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7127, 7127, '1', 'bc_block_1*47', 'bc_block_1*47', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7128, 7128, '1', 'bc_block_1*48', 'bc_block_1*48', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7129, 7129, '1', 'bc_block_1*49', 'bc_block_1*49', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7130, 7130, '1', 'bc_block_1*50', 'bc_block_1*50', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7131, 7131, '1', 'bc_block_1*51', 'bc_block_1*51', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7132, 7132, '1', 'bc_block_1*52', 'bc_block_1*52', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7133, 7133, '1', 'bc_block_1*53', 'bc_block_1*53', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7134, 7134, '1', 'bc_block_1*54', 'bc_block_1*54', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7135, 7135, '1', 'bc_block_1*55', 'bc_block_1*55', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7136, 7136, '1', 'bc_block_1*56', 'bc_block_1*56', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7137, 7137, '1', 'bc_block_1*57', 'bc_block_1*57', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7138, 7138, '1', 'bc_block_1*58', 'bc_block_1*58', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7139, 7139, '1', 'bc_block_1*59', 'bc_block_1*59', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7140, 7140, '1', 'bc_block_1*60', 'bc_block_1*60', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7141, 7141, '1', 'bc_block_1*61', 'bc_block_1*61', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7142, 7142, '1', 'bc_block_1*62', 'bc_block_1*62', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7143, 7143, '1', 'bc_block_1*63', 'bc_block_1*63', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7144, 7144, '1', 'bc_block_1*64', 'bc_block_1*64', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7145, 7145, '1', 'bc_block_1*65', 'bc_block_1*65', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7146, 7146, '1', 'bc_block_1*66', 'bc_block_1*66', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7147, 7147, '1', 'bc_block_1*67', 'bc_block_1*67', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7148, 7148, '1', 'bc_block_1*68', 'bc_block_1*68', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7149, 7149, '1', 'bc_block_1*69', 'bc_block_1*69', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7150, 7150, '1', 'bc_triangularprism*1', 'bc_triangularprism*1', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7151, 7151, '1', 'bc_triangularprism*10', 'bc_triangularprism*10', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7152, 7152, '1', 'bc_triangularprism*11', 'bc_triangularprism*11', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7153, 7153, '1', 'bc_triangularprism*12', 'bc_triangularprism*12', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7154, 7154, '1', 'bc_triangularprism*13', 'bc_triangularprism*13', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7155, 7155, '1', 'bc_triangularprism*14', 'bc_triangularprism*14', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7156, 7156, '1', 'bc_triangularprism*15', 'bc_triangularprism*15', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7157, 7157, '1', 'bc_triangularprism*16', 'bc_triangularprism*16', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7158, 7158, '1', 'bc_triangularprism*17', 'bc_triangularprism*17', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7159, 7159, '1', 'bc_triangularprism*18', 'bc_triangularprism*18', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7160, 7160, '1', 'bc_triangularprism*19', 'bc_triangularprism*19', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7161, 7161, '1', 'bc_triangularprism*2', 'bc_triangularprism*2', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7162, 7162, '1', 'bc_triangularprism*20', 'bc_triangularprism*20', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7163, 7163, '1', 'bc_triangularprism*21', 'bc_triangularprism*21', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7164, 7164, '1', 'bc_triangularprism*22', 'bc_triangularprism*22', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7165, 7165, '1', 'bc_triangularprism*23', 'bc_triangularprism*23', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7166, 7166, '1', 'bc_triangularprism*24', 'bc_triangularprism*24', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7167, 7167, '1', 'bc_triangularprism*25', 'bc_triangularprism*25', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7168, 7168, '1', 'bc_triangularprism*26', 'bc_triangularprism*26', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7169, 7169, '1', 'bc_triangularprism*27', 'bc_triangularprism*27', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7170, 7170, '1', 'bc_triangularprism*28', 'bc_triangularprism*28', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7171, 7171, '1', 'bc_triangularprism*29', 'bc_triangularprism*29', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7172, 7172, '1', 'bc_triangularprism*3', 'bc_triangularprism*3', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7173, 7173, '1', 'bc_triangularprism*30', 'bc_triangularprism*30', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7174, 7174, '1', 'bc_triangularprism*31', 'bc_triangularprism*31', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7175, 7175, '1', 'bc_triangularprism*32', 'bc_triangularprism*32', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7176, 7176, '1', 'bc_triangularprism*33', 'bc_triangularprism*33', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7177, 7177, '1', 'bc_triangularprism*34', 'bc_triangularprism*34', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7178, 7178, '1', 'bc_triangularprism*35', 'bc_triangularprism*35', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7179, 7179, '1', 'bc_triangularprism*36', 'bc_triangularprism*36', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7180, 7180, '1', 'bc_triangularprism*37', 'bc_triangularprism*37', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7181, 7181, '1', 'bc_triangularprism*38', 'bc_triangularprism*38', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7182, 7182, '1', 'bc_triangularprism*39', 'bc_triangularprism*39', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7183, 7183, '1', 'bc_triangularprism*4', 'bc_triangularprism*4', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7184, 7184, '1', 'bc_triangularprism*40', 'bc_triangularprism*40', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7185, 7185, '1', 'bc_triangularprism*41', 'bc_triangularprism*41', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7186, 7186, '1', 'bc_triangularprism*42', 'bc_triangularprism*42', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7187, 7187, '1', 'bc_triangularprism*43', 'bc_triangularprism*43', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7188, 7188, '1', 'bc_triangularprism*44', 'bc_triangularprism*44', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7189, 7189, '1', 'bc_triangularprism*45', 'bc_triangularprism*45', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7190, 7190, '1', 'bc_triangularprism*46', 'bc_triangularprism*46', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7191, 7191, '1', 'bc_triangularprism*47', 'bc_triangularprism*47', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7192, 7192, '1', 'bc_triangularprism*48', 'bc_triangularprism*48', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7193, 7193, '1', 'bc_triangularprism*49', 'bc_triangularprism*49', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7194, 7194, '1', 'bc_triangularprism*5', 'bc_triangularprism*5', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7195, 7195, '1', 'bc_triangularprism*50', 'bc_triangularprism*50', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7196, 7196, '1', 'bc_triangularprism*51', 'bc_triangularprism*51', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7197, 7197, '1', 'bc_triangularprism*52', 'bc_triangularprism*52', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7198, 7198, '1', 'bc_triangularprism*53', 'bc_triangularprism*53', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7199, 7199, '1', 'bc_triangularprism*54', 'bc_triangularprism*54', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7200, 7200, '1', 'bc_triangularprism*55', 'bc_triangularprism*55', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7201, 7201, '1', 'bc_triangularprism*56', 'bc_triangularprism*56', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7202, 7202, '1', 'bc_triangularprism*57', 'bc_triangularprism*57', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7203, 7203, '1', 'bc_triangularprism*58', 'bc_triangularprism*58', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7204, 7204, '1', 'bc_triangularprism*59', 'bc_triangularprism*59', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7205, 7205, '1', 'bc_triangularprism*6', 'bc_triangularprism*6', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7206, 7206, '1', 'bc_triangularprism*60', 'bc_triangularprism*60', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7207, 7207, '1', 'bc_triangularprism*61', 'bc_triangularprism*61', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7208, 7208, '1', 'bc_triangularprism*62', 'bc_triangularprism*62', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7209, 7209, '1', 'bc_triangularprism*63', 'bc_triangularprism*63', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7210, 7210, '1', 'bc_triangularprism*64', 'bc_triangularprism*64', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7211, 7211, '1', 'bc_triangularprism*65', 'bc_triangularprism*65', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7212, 7212, '1', 'bc_triangularprism*66', 'bc_triangularprism*66', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7213, 7213, '1', 'bc_triangularprism*67', 'bc_triangularprism*67', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7214, 7214, '1', 'bc_triangularprism*68', 'bc_triangularprism*68', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7215, 7215, '1', 'bc_triangularprism*69', 'bc_triangularprism*69', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7216, 7216, '1', 'bc_triangularprism*7', 'bc_triangularprism*7', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7217, 7217, '1', 'bc_triangularprism*8', 'bc_triangularprism*8', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7218, 7218, '1', 'bc_triangularprism*9', 'bc_triangularprism*9', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7219, 7219, '1', 'bc_sphere*1', 'bc_sphere*1', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7220, 7220, '1', 'bc_sphere*10', 'bc_sphere*10', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7221, 7221, '1', 'bc_sphere*11', 'bc_sphere*11', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7222, 7222, '1', 'bc_sphere*12', 'bc_sphere*12', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7223, 7223, '1', 'bc_sphere*13', 'bc_sphere*13', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7224, 7224, '1', 'bc_sphere*14', 'bc_sphere*14', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7225, 7225, '1', 'bc_sphere*15', 'bc_sphere*15', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7226, 7226, '1', 'bc_sphere*16', 'bc_sphere*16', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7227, 7227, '1', 'bc_sphere*17', 'bc_sphere*17', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7228, 7228, '1', 'bc_sphere*18', 'bc_sphere*18', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7229, 7229, '1', 'bc_sphere*19', 'bc_sphere*19', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7230, 7230, '1', 'bc_sphere*2', 'bc_sphere*2', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7231, 7231, '1', 'bc_sphere*20', 'bc_sphere*20', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7232, 7232, '1', 'bc_sphere*21', 'bc_sphere*21', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7233, 7233, '1', 'bc_sphere*22', 'bc_sphere*22', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7234, 7234, '1', 'bc_sphere*23', 'bc_sphere*23', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7235, 7235, '1', 'bc_sphere*24', 'bc_sphere*24', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7236, 7236, '1', 'bc_sphere*25', 'bc_sphere*25', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7237, 7237, '1', 'bc_sphere*26', 'bc_sphere*26', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7238, 7238, '1', 'bc_sphere*27', 'bc_sphere*27', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7239, 7239, '1', 'bc_sphere*28', 'bc_sphere*28', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7240, 7240, '1', 'bc_sphere*29', 'bc_sphere*29', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7241, 7241, '1', 'bc_sphere*3', 'bc_sphere*3', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7242, 7242, '1', 'bc_sphere*30', 'bc_sphere*30', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7243, 7243, '1', 'bc_sphere*31', 'bc_sphere*31', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7244, 7244, '1', 'bc_sphere*32', 'bc_sphere*32', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7245, 7245, '1', 'bc_sphere*33', 'bc_sphere*33', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7246, 7246, '1', 'bc_sphere*34', 'bc_sphere*34', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7247, 7247, '1', 'bc_sphere*35', 'bc_sphere*35', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7248, 7248, '1', 'bc_sphere*36', 'bc_sphere*36', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7249, 7249, '1', 'bc_sphere*37', 'bc_sphere*37', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7250, 7250, '1', 'bc_sphere*38', 'bc_sphere*38', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7251, 7251, '1', 'bc_sphere*39', 'bc_sphere*39', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7252, 7252, '1', 'bc_sphere*4', 'bc_sphere*4', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7253, 7253, '1', 'bc_sphere*40', 'bc_sphere*40', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7254, 7254, '1', 'bc_sphere*41', 'bc_sphere*41', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7255, 7255, '1', 'bc_sphere*42', 'bc_sphere*42', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7256, 7256, '1', 'bc_sphere*43', 'bc_sphere*43', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7257, 7257, '1', 'bc_sphere*44', 'bc_sphere*44', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7258, 7258, '1', 'bc_sphere*45', 'bc_sphere*45', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7259, 7259, '1', 'bc_sphere*46', 'bc_sphere*46', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7260, 7260, '1', 'bc_sphere*47', 'bc_sphere*47', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7261, 7261, '1', 'bc_sphere*48', 'bc_sphere*48', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7262, 7262, '1', 'bc_sphere*49', 'bc_sphere*49', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7263, 7263, '1', 'bc_sphere*5', 'bc_sphere*5', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7264, 7264, '1', 'bc_sphere*50', 'bc_sphere*50', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7265, 7265, '1', 'bc_sphere*51', 'bc_sphere*51', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7266, 7266, '1', 'bc_sphere*52', 'bc_sphere*52', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7267, 7267, '1', 'bc_sphere*53', 'bc_sphere*53', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7268, 7268, '1', 'bc_sphere*54', 'bc_sphere*54', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7269, 7269, '1', 'bc_sphere*55', 'bc_sphere*55', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7270, 7270, '1', 'bc_sphere*56', 'bc_sphere*56', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7271, 7271, '1', 'bc_sphere*57', 'bc_sphere*57', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7272, 7272, '1', 'bc_sphere*58', 'bc_sphere*58', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7273, 7273, '1', 'bc_sphere*59', 'bc_sphere*59', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7274, 7274, '1', 'bc_sphere*6', 'bc_sphere*6', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7275, 7275, '1', 'bc_sphere*60', 'bc_sphere*60', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7276, 7276, '1', 'bc_sphere*61', 'bc_sphere*61', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7277, 7277, '1', 'bc_sphere*62', 'bc_sphere*62', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7278, 7278, '1', 'bc_sphere*63', 'bc_sphere*63', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7279, 7279, '1', 'bc_sphere*64', 'bc_sphere*64', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7280, 7280, '1', 'bc_sphere*65', 'bc_sphere*65', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7281, 7281, '1', 'bc_sphere*66', 'bc_sphere*66', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7282, 7282, '1', 'bc_sphere*67', 'bc_sphere*67', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7283, 7283, '1', 'bc_sphere*68', 'bc_sphere*68', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7284, 7284, '1', 'bc_sphere*69', 'bc_sphere*69', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7285, 7285, '1', 'bc_sphere*7', 'bc_sphere*7', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7286, 7286, '1', 'bc_sphere*8', 'bc_sphere*8', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7287, 7287, '1', 'bc_sphere*9', 'bc_sphere*9', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7288, 7288, '1', 'bc_round*15', 'bc_round*15', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7289, 7289, '1', 'bc_round*16', 'bc_round*16', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7290, 7290, '1', 'bc_round*17', 'bc_round*17', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7291, 7291, '1', 'bc_round*18', 'bc_round*18', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7292, 7292, '1', 'bc_round*19', 'bc_round*19', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7293, 7293, '1', 'bc_round*20', 'bc_round*20', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7294, 7294, '1', 'bc_round*21', 'bc_round*21', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7295, 7295, '1', 'bc_round*22', 'bc_round*22', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7296, 7296, '1', 'bc_round*23', 'bc_round*23', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7297, 7297, '1', 'bc_round*24', 'bc_round*24', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7298, 7298, '1', 'bc_round*25', 'bc_round*25', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7299, 7299, '1', 'bc_round*26', 'bc_round*26', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7300, 7300, '1', 'bc_round*27', 'bc_round*27', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7301, 7301, '1', 'bc_round*28', 'bc_round*28', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7302, 7302, '1', 'bc_round*29', 'bc_round*29', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7303, 7303, '1', 'bc_round*30', 'bc_round*30', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7304, 7304, '1', 'bc_round*31', 'bc_round*31', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7305, 7305, '1', 'bc_round*32', 'bc_round*32', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7306, 7306, '1', 'bc_round*33', 'bc_round*33', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7307, 7307, '1', 'bc_round*34', 'bc_round*34', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7308, 7308, '1', 'bc_round*35', 'bc_round*35', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7309, 7309, '1', 'bc_round*36', 'bc_round*36', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7310, 7310, '1', 'bc_round*37', 'bc_round*37', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7311, 7311, '1', 'bc_round*38', 'bc_round*38', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7312, 7312, '1', 'bc_round*39', 'bc_round*39', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7313, 7313, '1', 'bc_round*40', 'bc_round*40', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7314, 7314, '1', 'bc_round*41', 'bc_round*41', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7315, 7315, '1', 'bc_round*42', 'bc_round*42', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7316, 7316, '1', 'bc_round*43', 'bc_round*43', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7317, 7317, '1', 'bc_round*44', 'bc_round*44', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7318, 7318, '1', 'bc_round*45', 'bc_round*45', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7319, 7319, '1', 'bc_round*46', 'bc_round*46', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7320, 7320, '1', 'bc_round*47', 'bc_round*47', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7321, 7321, '1', 'bc_round*48', 'bc_round*48', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7322, 7322, '1', 'bc_round*49', 'bc_round*49', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7323, 7323, '1', 'bc_round*50', 'bc_round*50', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7324, 7324, '1', 'bc_round*51', 'bc_round*51', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7325, 7325, '1', 'bc_round*52', 'bc_round*52', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7326, 7326, '1', 'bc_round*53', 'bc_round*53', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7327, 7327, '1', 'bc_round*54', 'bc_round*54', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7328, 7328, '1', 'bc_round*55', 'bc_round*55', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7329, 7329, '1', 'bc_round*56', 'bc_round*56', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7330, 7330, '1', 'bc_round*57', 'bc_round*57', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7331, 7331, '1', 'bc_round*58', 'bc_round*58', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7332, 7332, '1', 'bc_round*59', 'bc_round*59', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7333, 7333, '1', 'bc_round*60', 'bc_round*60', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7334, 7334, '1', 'bc_round*61', 'bc_round*61', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7335, 7335, '1', 'bc_round*62', 'bc_round*62', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7336, 7336, '1', 'bc_round*63', 'bc_round*63', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7337, 7337, '1', 'bc_round*64', 'bc_round*64', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7338, 7338, '1', 'bc_round*65', 'bc_round*65', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7339, 7339, '1', 'bc_round*66', 'bc_round*66', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7340, 7340, '1', 'bc_round*67', 'bc_round*67', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7341, 7341, '1', 'bc_round*68', 'bc_round*68', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7342, 7342, '1', 'bc_round*69', 'bc_round*69', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(7343, 7343, '0', 'CF_1500_suitcase', 'CF_1500_suitcase', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7344, 7344, '1', 'bc_alpha1_w*1', 'bc_alpha1_w*1', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7345, 7345, '1', 'bc_alpha1_w*10', 'bc_alpha1_w*10', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7346, 7346, '1', 'bc_alpha1_w*11', 'bc_alpha1_w*11', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7347, 7347, '1', 'bc_alpha1_w*12', 'bc_alpha1_w*12', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7348, 7348, '1', 'bc_alpha1_w*13', 'bc_alpha1_w*13', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7349, 7349, '1', 'bc_alpha1_w*14', 'bc_alpha1_w*14', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7350, 7350, '1', 'bc_alpha1_w*2', 'bc_alpha1_w*2', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7351, 7351, '1', 'bc_alpha1_w*3', 'bc_alpha1_w*3', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7352, 7352, '1', 'bc_alpha1_w*4', 'bc_alpha1_w*4', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7353, 7353, '1', 'bc_alpha1_w*5', 'bc_alpha1_w*5', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7354, 7354, '1', 'bc_alpha1_w*6', 'bc_alpha1_w*6', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7355, 7355, '1', 'bc_alpha1_w*7', 'bc_alpha1_w*7', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7356, 7356, '1', 'bc_alpha1_w*8', 'bc_alpha1_w*8', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7357, 7357, '1', 'bc_alpha1_w*9', 'bc_alpha1_w*9', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7358, 7358, '1', 'bc_alpha1_g*1', 'bc_alpha1_g*1', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7359, 7359, '1', 'bc_alpha1_g*10', 'bc_alpha1_g*10', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7360, 7360, '1', 'bc_alpha1_g*11', 'bc_alpha1_g*11', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7361, 7361, '1', 'bc_alpha1_g*12', 'bc_alpha1_g*12', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7362, 7362, '1', 'bc_alpha1_g*13', 'bc_alpha1_g*13', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7363, 7363, '1', 'bc_alpha1_g*14', 'bc_alpha1_g*14', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7364, 7364, '1', 'bc_alpha1_g*2', 'bc_alpha1_g*2', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7365, 7365, '1', 'bc_alpha1_g*3', 'bc_alpha1_g*3', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7366, 7366, '1', 'bc_alpha1_g*4', 'bc_alpha1_g*4', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7367, 7367, '1', 'bc_alpha1_g*5', 'bc_alpha1_g*5', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7368, 7368, '1', 'bc_alpha1_g*6', 'bc_alpha1_g*6', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7369, 7369, '1', 'bc_alpha1_g*7', 'bc_alpha1_g*7', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7370, 7370, '1', 'bc_alpha1_g*8', 'bc_alpha1_g*8', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7371, 7371, '1', 'bc_alpha1_g*9', 'bc_alpha1_g*9', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7372, 7372, '1', 'bc_alpha1_r*1', 'bc_alpha1_r*1', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7373, 7373, '1', 'bc_alpha1_r*10', 'bc_alpha1_r*10', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7374, 7374, '1', 'bc_alpha1_r*11', 'bc_alpha1_r*11', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7375, 7375, '1', 'bc_alpha1_r*12', 'bc_alpha1_r*12', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7376, 7376, '1', 'bc_alpha1_r*13', 'bc_alpha1_r*13', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7377, 7377, '1', 'bc_alpha1_r*14', 'bc_alpha1_r*14', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7378, 7378, '1', 'bc_alpha1_r*2', 'bc_alpha1_r*2', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7379, 7379, '1', 'bc_alpha1_r*3', 'bc_alpha1_r*3', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7380, 7380, '1', 'bc_alpha1_r*4', 'bc_alpha1_r*4', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7381, 7381, '1', 'bc_alpha1_r*5', 'bc_alpha1_r*5', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7382, 7382, '1', 'bc_alpha1_r*6', 'bc_alpha1_r*6', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7383, 7383, '1', 'bc_alpha1_r*7', 'bc_alpha1_r*7', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7384, 7384, '1', 'bc_alpha1_r*8', 'bc_alpha1_r*8', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7385, 7385, '1', 'bc_alpha1_r*9', 'bc_alpha1_r*9', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7386, 7386, '1', 'bc_alpha1_s*1', 'bc_alpha1_s*1', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7387, 7387, '1', 'bc_alpha1_s*10', 'bc_alpha1_s*10', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7388, 7388, '1', 'bc_alpha1_s*11', 'bc_alpha1_s*11', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7389, 7389, '1', 'bc_alpha1_s*12', 'bc_alpha1_s*12', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7390, 7390, '1', 'bc_alpha1_s*13', 'bc_alpha1_s*13', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7391, 7391, '1', 'bc_alpha1_s*14', 'bc_alpha1_s*14', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7392, 7392, '1', 'bc_alpha1_s*2', 'bc_alpha1_s*2', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7393, 7393, '1', 'bc_alpha1_s*3', 'bc_alpha1_s*3', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7394, 7394, '1', 'bc_alpha1_s*4', 'bc_alpha1_s*4', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7395, 7395, '1', 'bc_alpha1_s*5', 'bc_alpha1_s*5', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7396, 7396, '1', 'bc_alpha1_s*6', 'bc_alpha1_s*6', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7397, 7397, '1', 'bc_alpha1_s*7', 'bc_alpha1_s*7', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7398, 7398, '1', 'bc_alpha1_s*8', 'bc_alpha1_s*8', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7399, 7399, '1', 'bc_alpha1_s*9', 'bc_alpha1_s*9', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7400, 7400, '1', 'bc_alpha1_h*1', 'bc_alpha1_h*1', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7401, 7401, '1', 'bc_alpha1_h*10', 'bc_alpha1_h*10', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7402, 7402, '1', 'bc_alpha1_h*11', 'bc_alpha1_h*11', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7403, 7403, '1', 'bc_alpha1_h*12', 'bc_alpha1_h*12', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7404, 7404, '1', 'bc_alpha1_h*13', 'bc_alpha1_h*13', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7405, 7405, '1', 'bc_alpha1_h*14', 'bc_alpha1_h*14', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7406, 7406, '1', 'bc_alpha1_h*2', 'bc_alpha1_h*2', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7407, 7407, '1', 'bc_alpha1_h*3', 'bc_alpha1_h*3', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7408, 7408, '1', 'bc_alpha1_h*4', 'bc_alpha1_h*4', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7409, 7409, '1', 'bc_alpha1_h*5', 'bc_alpha1_h*5', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7410, 7410, '1', 'bc_alpha1_h*6', 'bc_alpha1_h*6', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7411, 7411, '1', 'bc_alpha1_h*7', 'bc_alpha1_h*7', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7412, 7412, '1', 'bc_alpha1_h*8', 'bc_alpha1_h*8', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7413, 7413, '1', 'bc_alpha1_h*9', 'bc_alpha1_h*9', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7414, 7414, '1', 'bc_alpha1_t*1', 'bc_alpha1_t*1', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7415, 7415, '1', 'bc_alpha1_t*10', 'bc_alpha1_t*10', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7416, 7416, '1', 'bc_alpha1_t*11', 'bc_alpha1_t*11', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7417, 7417, '1', 'bc_alpha1_t*12', 'bc_alpha1_t*12', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7418, 7418, '1', 'bc_alpha1_t*13', 'bc_alpha1_t*13', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7419, 7419, '1', 'bc_alpha1_t*14', 'bc_alpha1_t*14', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7420, 7420, '1', 'bc_alpha1_t*2', 'bc_alpha1_t*2', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7421, 7421, '1', 'bc_alpha1_t*3', 'bc_alpha1_t*3', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7422, 7422, '1', 'bc_alpha1_t*4', 'bc_alpha1_t*4', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7423, 7423, '1', 'bc_alpha1_t*5', 'bc_alpha1_t*5', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7424, 7424, '1', 'bc_alpha1_t*6', 'bc_alpha1_t*6', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7425, 7425, '1', 'bc_alpha1_t*7', 'bc_alpha1_t*7', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7426, 7426, '1', 'bc_alpha1_t*8', 'bc_alpha1_t*8', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7427, 7427, '1', 'bc_alpha1_t*9', 'bc_alpha1_t*9', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7428, 7428, '1', 'bc_alpha1_o*1', 'bc_alpha1_o*1', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7429, 7429, '1', 'bc_alpha1_o*10', 'bc_alpha1_o*10', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7430, 7430, '1', 'bc_alpha1_o*11', 'bc_alpha1_o*11', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7431, 7431, '1', 'bc_alpha1_o*12', 'bc_alpha1_o*12', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7432, 7432, '1', 'bc_alpha1_o*13', 'bc_alpha1_o*13', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7433, 7433, '1', 'bc_alpha1_o*14', 'bc_alpha1_o*14', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7434, 7434, '1', 'bc_alpha1_o*2', 'bc_alpha1_o*2', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7435, 7435, '1', 'bc_alpha1_o*3', 'bc_alpha1_o*3', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7436, 7436, '1', 'bc_alpha1_o*4', 'bc_alpha1_o*4', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7437, 7437, '1', 'bc_alpha1_o*5', 'bc_alpha1_o*5', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7438, 7438, '1', 'bc_alpha1_o*6', 'bc_alpha1_o*6', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7439, 7439, '1', 'bc_alpha1_o*7', 'bc_alpha1_o*7', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7440, 7440, '1', 'bc_alpha1_o*8', 'bc_alpha1_o*8', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7441, 7441, '1', 'bc_alpha1_o*9', 'bc_alpha1_o*9', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7442, 7442, '1', 'bc_alpha1_v*1', 'bc_alpha1_v*1', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7443, 7443, '1', 'bc_alpha1_v*10', 'bc_alpha1_v*10', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7444, 7444, '1', 'bc_alpha1_v*11', 'bc_alpha1_v*11', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7445, 7445, '1', 'bc_alpha1_v*12', 'bc_alpha1_v*12', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7446, 7446, '1', 'bc_alpha1_v*13', 'bc_alpha1_v*13', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7447, 7447, '1', 'bc_alpha1_v*14', 'bc_alpha1_v*14', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7448, 7448, '1', 'bc_alpha1_v*2', 'bc_alpha1_v*2', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7449, 7449, '1', 'bc_alpha1_v*3', 'bc_alpha1_v*3', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7450, 7450, '1', 'bc_alpha1_v*4', 'bc_alpha1_v*4', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7451, 7451, '1', 'bc_alpha1_v*5', 'bc_alpha1_v*5', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7452, 7452, '1', 'bc_alpha1_v*6', 'bc_alpha1_v*6', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7453, 7453, '1', 'bc_alpha1_v*7', 'bc_alpha1_v*7', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7454, 7454, '1', 'bc_alpha1_v*8', 'bc_alpha1_v*8', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7455, 7455, '1', 'bc_alpha1_v*9', 'bc_alpha1_v*9', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7456, 7456, '1', 'bc_alpha1_c*1', 'bc_alpha1_c*1', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7457, 7457, '1', 'bc_alpha1_c*10', 'bc_alpha1_c*10', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7458, 7458, '1', 'bc_alpha1_c*11', 'bc_alpha1_c*11', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7459, 7459, '1', 'bc_alpha1_c*12', 'bc_alpha1_c*12', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7460, 7460, '1', 'bc_alpha1_c*13', 'bc_alpha1_c*13', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7461, 7461, '1', 'bc_alpha1_c*14', 'bc_alpha1_c*14', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7462, 7462, '1', 'bc_alpha1_c*2', 'bc_alpha1_c*2', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7463, 7463, '1', 'bc_alpha1_c*3', 'bc_alpha1_c*3', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7464, 7464, '1', 'bc_alpha1_c*4', 'bc_alpha1_c*4', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7465, 7465, '1', 'bc_alpha1_c*5', 'bc_alpha1_c*5', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7466, 7466, '1', 'bc_alpha1_c*6', 'bc_alpha1_c*6', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7467, 7467, '1', 'bc_alpha1_c*7', 'bc_alpha1_c*7', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7468, 7468, '1', 'bc_alpha1_c*8', 'bc_alpha1_c*8', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7469, 7469, '1', 'bc_alpha1_c*9', 'bc_alpha1_c*9', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7470, 7470, '1', 'bc_alpha1_b*1', 'bc_alpha1_b*1', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7471, 7471, '1', 'bc_alpha1_b*10', 'bc_alpha1_b*10', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7472, 7472, '1', 'bc_alpha1_b*11', 'bc_alpha1_b*11', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7473, 7473, '1', 'bc_alpha1_b*12', 'bc_alpha1_b*12', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7474, 7474, '1', 'bc_alpha1_b*13', 'bc_alpha1_b*13', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7475, 7475, '1', 'bc_alpha1_b*14', 'bc_alpha1_b*14', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7476, 7476, '1', 'bc_alpha1_b*2', 'bc_alpha1_b*2', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7477, 7477, '1', 'bc_alpha1_b*3', 'bc_alpha1_b*3', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7478, 7478, '1', 'bc_alpha1_b*4', 'bc_alpha1_b*4', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7479, 7479, '1', 'bc_alpha1_b*5', 'bc_alpha1_b*5', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7480, 7480, '1', 'bc_alpha1_b*6', 'bc_alpha1_b*6', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7481, 7481, '1', 'bc_alpha1_b*7', 'bc_alpha1_b*7', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7482, 7482, '1', 'bc_alpha1_b*8', 'bc_alpha1_b*8', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7483, 7483, '1', 'bc_alpha1_b*9', 'bc_alpha1_b*9', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7484, 7484, '1', 'bc_alpha1_m*1', 'bc_alpha1_m*1', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7485, 7485, '1', 'bc_alpha1_m*10', 'bc_alpha1_m*10', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7486, 7486, '1', 'bc_alpha1_m*11', 'bc_alpha1_m*11', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7487, 7487, '1', 'bc_alpha1_m*12', 'bc_alpha1_m*12', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7488, 7488, '1', 'bc_alpha1_m*13', 'bc_alpha1_m*13', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7489, 7489, '1', 'bc_alpha1_m*14', 'bc_alpha1_m*14', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7490, 7490, '1', 'bc_alpha1_m*2', 'bc_alpha1_m*2', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7491, 7491, '1', 'bc_alpha1_m*3', 'bc_alpha1_m*3', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7492, 7492, '1', 'bc_alpha1_m*4', 'bc_alpha1_m*4', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7493, 7493, '1', 'bc_alpha1_m*5', 'bc_alpha1_m*5', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7494, 7494, '1', 'bc_alpha1_m*6', 'bc_alpha1_m*6', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7495, 7495, '1', 'bc_alpha1_m*7', 'bc_alpha1_m*7', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7496, 7496, '1', 'bc_alpha1_m*8', 'bc_alpha1_m*8', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7497, 7497, '1', 'bc_alpha1_m*9', 'bc_alpha1_m*9', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7498, 7498, '1', 'bc_alpha1_i*1', 'bc_alpha1_i*1', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7499, 7499, '1', 'bc_alpha1_i*10', 'bc_alpha1_i*10', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7500, 7500, '1', 'bc_alpha1_i*11', 'bc_alpha1_i*11', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7501, 7501, '1', 'bc_alpha1_i*12', 'bc_alpha1_i*12', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7502, 7502, '1', 'bc_alpha1_i*13', 'bc_alpha1_i*13', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7503, 7503, '1', 'bc_alpha1_i*14', 'bc_alpha1_i*14', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7504, 7504, '1', 'bc_alpha1_i*2', 'bc_alpha1_i*2', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7505, 7505, '1', 'bc_alpha1_i*3', 'bc_alpha1_i*3', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7506, 7506, '1', 'bc_alpha1_i*4', 'bc_alpha1_i*4', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7507, 7507, '1', 'bc_alpha1_i*5', 'bc_alpha1_i*5', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7508, 7508, '1', 'bc_alpha1_i*6', 'bc_alpha1_i*6', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7509, 7509, '1', 'bc_alpha1_i*7', 'bc_alpha1_i*7', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7510, 7510, '1', 'bc_alpha1_i*8', 'bc_alpha1_i*8', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7511, 7511, '1', 'bc_alpha1_i*9', 'bc_alpha1_i*9', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7512, 7512, '1', 'bc_alpha1_x*1', 'bc_alpha1_x*1', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7513, 7513, '1', 'bc_alpha1_x*10', 'bc_alpha1_x*10', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7514, 7514, '1', 'bc_alpha1_x*11', 'bc_alpha1_x*11', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7515, 7515, '1', 'bc_alpha1_x*12', 'bc_alpha1_x*12', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7516, 7516, '1', 'bc_alpha1_x*13', 'bc_alpha1_x*13', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7517, 7517, '1', 'bc_alpha1_x*14', 'bc_alpha1_x*14', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7518, 7518, '1', 'bc_alpha1_x*2', 'bc_alpha1_x*2', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7519, 7519, '1', 'bc_alpha1_x*3', 'bc_alpha1_x*3', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7520, 7520, '1', 'bc_alpha1_x*4', 'bc_alpha1_x*4', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7521, 7521, '1', 'bc_alpha1_x*5', 'bc_alpha1_x*5', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7522, 7522, '1', 'bc_alpha1_x*6', 'bc_alpha1_x*6', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7523, 7523, '1', 'bc_alpha1_x*7', 'bc_alpha1_x*7', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7524, 7524, '1', 'bc_alpha1_x*8', 'bc_alpha1_x*8', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7525, 7525, '1', 'bc_alpha1_x*9', 'bc_alpha1_x*9', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7526, 7526, '1', 'bc_alpha1_l*1', 'bc_alpha1_l*1', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7527, 7527, '1', 'bc_alpha1_l*10', 'bc_alpha1_l*10', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7528, 7528, '1', 'bc_alpha1_l*11', 'bc_alpha1_l*11', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7529, 7529, '1', 'bc_alpha1_l*12', 'bc_alpha1_l*12', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7530, 7530, '1', 'bc_alpha1_l*13', 'bc_alpha1_l*13', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7531, 7531, '1', 'bc_alpha1_l*14', 'bc_alpha1_l*14', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7532, 7532, '1', 'bc_alpha1_l*2', 'bc_alpha1_l*2', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7533, 7533, '1', 'bc_alpha1_l*3', 'bc_alpha1_l*3', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7534, 7534, '1', 'bc_alpha1_l*4', 'bc_alpha1_l*4', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7535, 7535, '1', 'bc_alpha1_l*5', 'bc_alpha1_l*5', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7536, 7536, '1', 'bc_alpha1_l*6', 'bc_alpha1_l*6', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7537, 7537, '1', 'bc_alpha1_l*7', 'bc_alpha1_l*7', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7538, 7538, '1', 'bc_alpha1_l*8', 'bc_alpha1_l*8', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7539, 7539, '1', 'bc_alpha1_l*9', 'bc_alpha1_l*9', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7540, 7540, '1', 'bc_alpha1_j*1', 'bc_alpha1_j*1', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7541, 7541, '1', 'bc_alpha1_j*10', 'bc_alpha1_j*10', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7542, 7542, '1', 'bc_alpha1_j*11', 'bc_alpha1_j*11', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7543, 7543, '1', 'bc_alpha1_j*12', 'bc_alpha1_j*12', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7544, 7544, '1', 'bc_alpha1_j*13', 'bc_alpha1_j*13', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7545, 7545, '1', 'bc_alpha1_j*14', 'bc_alpha1_j*14', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7546, 7546, '1', 'bc_alpha1_j*2', 'bc_alpha1_j*2', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7547, 7547, '1', 'bc_alpha1_j*3', 'bc_alpha1_j*3', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7548, 7548, '1', 'bc_alpha1_j*4', 'bc_alpha1_j*4', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7549, 7549, '1', 'bc_alpha1_j*5', 'bc_alpha1_j*5', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7550, 7550, '1', 'bc_alpha1_j*6', 'bc_alpha1_j*6', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7551, 7551, '1', 'bc_alpha1_j*7', 'bc_alpha1_j*7', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7552, 7552, '1', 'bc_alpha1_j*8', 'bc_alpha1_j*8', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(7553, 7553, '1', 'bc_alpha1_j*9', 'bc_alpha1_j*9', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7554, 7554, '1', 'bc_alpha1_f*1', 'bc_alpha1_f*1', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7555, 7555, '1', 'bc_alpha1_f*10', 'bc_alpha1_f*10', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7556, 7556, '1', 'bc_alpha1_f*11', 'bc_alpha1_f*11', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7557, 7557, '1', 'bc_alpha1_f*12', 'bc_alpha1_f*12', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7558, 7558, '1', 'bc_alpha1_f*13', 'bc_alpha1_f*13', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7559, 7559, '1', 'bc_alpha1_f*14', 'bc_alpha1_f*14', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7560, 7560, '1', 'bc_alpha1_f*2', 'bc_alpha1_f*2', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7561, 7561, '1', 'bc_alpha1_f*3', 'bc_alpha1_f*3', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7562, 7562, '1', 'bc_alpha1_f*4', 'bc_alpha1_f*4', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7563, 7563, '1', 'bc_alpha1_f*5', 'bc_alpha1_f*5', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7564, 7564, '1', 'bc_alpha1_f*6', 'bc_alpha1_f*6', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7565, 7565, '1', 'bc_alpha1_f*7', 'bc_alpha1_f*7', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7566, 7566, '1', 'bc_alpha1_f*8', 'bc_alpha1_f*8', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7567, 7567, '1', 'bc_alpha1_f*9', 'bc_alpha1_f*9', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7568, 7568, '1', 'bc_alpha1_e*1', 'bc_alpha1_e*1', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7569, 7569, '1', 'bc_alpha1_e*10', 'bc_alpha1_e*10', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7570, 7570, '1', 'bc_alpha1_e*11', 'bc_alpha1_e*11', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7571, 7571, '1', 'bc_alpha1_e*12', 'bc_alpha1_e*12', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, '');
REPLACE INTO `items_base` (`id`, `sprite_id`, `buildersclub`, `public_name`, `item_name`, `type`, `width`, `length`, `stack_height`, `allow_stack`, `allow_sit`, `allow_lay`, `allow_walk`, `allow_gift`, `allow_trade`, `allow_recycle`, `allow_marketplace_sell`, `allow_inventory_stack`, `interaction_type`, `interaction_modes_count`, `vending_ids`, `multiheight`, `customparams`, `effect_id_male`, `effect_id_female`, `clothing_on_walk`) VALUES
	(7572, 7572, '1', 'bc_alpha1_e*13', 'bc_alpha1_e*13', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7573, 7573, '1', 'bc_alpha1_e*14', 'bc_alpha1_e*14', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7574, 7574, '1', 'bc_alpha1_e*2', 'bc_alpha1_e*2', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7575, 7575, '1', 'bc_alpha1_e*3', 'bc_alpha1_e*3', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7576, 7576, '1', 'bc_alpha1_e*4', 'bc_alpha1_e*4', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7577, 7577, '1', 'bc_alpha1_e*5', 'bc_alpha1_e*5', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7578, 7578, '1', 'bc_alpha1_e*6', 'bc_alpha1_e*6', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7579, 7579, '1', 'bc_alpha1_e*7', 'bc_alpha1_e*7', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7580, 7580, '1', 'bc_alpha1_e*8', 'bc_alpha1_e*8', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7581, 7581, '1', 'bc_alpha1_e*9', 'bc_alpha1_e*9', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7582, 7582, '1', 'bc_alpha1_q*1', 'bc_alpha1_q*1', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7583, 7583, '1', 'bc_alpha1_q*10', 'bc_alpha1_q*10', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7584, 7584, '1', 'bc_alpha1_q*11', 'bc_alpha1_q*11', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7585, 7585, '1', 'bc_alpha1_q*12', 'bc_alpha1_q*12', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7586, 7586, '1', 'bc_alpha1_q*13', 'bc_alpha1_q*13', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7587, 7587, '1', 'bc_alpha1_q*14', 'bc_alpha1_q*14', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7588, 7588, '1', 'bc_alpha1_q*2', 'bc_alpha1_q*2', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7589, 7589, '1', 'bc_alpha1_q*3', 'bc_alpha1_q*3', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7590, 7590, '1', 'bc_alpha1_q*4', 'bc_alpha1_q*4', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7591, 7591, '1', 'bc_alpha1_q*5', 'bc_alpha1_q*5', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7592, 7592, '1', 'bc_alpha1_q*6', 'bc_alpha1_q*6', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7593, 7593, '1', 'bc_alpha1_q*7', 'bc_alpha1_q*7', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7594, 7594, '1', 'bc_alpha1_q*8', 'bc_alpha1_q*8', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7595, 7595, '1', 'bc_alpha1_q*9', 'bc_alpha1_q*9', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7596, 7596, '1', 'bc_alpha1_y*1', 'bc_alpha1_y*1', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7597, 7597, '1', 'bc_alpha1_y*10', 'bc_alpha1_y*10', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7598, 7598, '1', 'bc_alpha1_y*11', 'bc_alpha1_y*11', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7599, 7599, '1', 'bc_alpha1_y*12', 'bc_alpha1_y*12', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7600, 7600, '1', 'bc_alpha1_y*13', 'bc_alpha1_y*13', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7601, 7601, '1', 'bc_alpha1_y*14', 'bc_alpha1_y*14', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7602, 7602, '1', 'bc_alpha1_y*2', 'bc_alpha1_y*2', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7603, 7603, '1', 'bc_alpha1_y*3', 'bc_alpha1_y*3', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7604, 7604, '1', 'bc_alpha1_y*4', 'bc_alpha1_y*4', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7605, 7605, '1', 'bc_alpha1_y*5', 'bc_alpha1_y*5', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7606, 7606, '1', 'bc_alpha1_y*6', 'bc_alpha1_y*6', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7607, 7607, '1', 'bc_alpha1_y*7', 'bc_alpha1_y*7', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7608, 7608, '1', 'bc_alpha1_y*8', 'bc_alpha1_y*8', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7609, 7609, '1', 'bc_alpha1_y*9', 'bc_alpha1_y*9', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7610, 7610, '1', 'bc_alpha1_d*1', 'bc_alpha1_d*1', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7611, 7611, '1', 'bc_alpha1_d*10', 'bc_alpha1_d*10', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7612, 7612, '1', 'bc_alpha1_d*11', 'bc_alpha1_d*11', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7613, 7613, '1', 'bc_alpha1_d*12', 'bc_alpha1_d*12', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7614, 7614, '1', 'bc_alpha1_d*13', 'bc_alpha1_d*13', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7615, 7615, '1', 'bc_alpha1_d*14', 'bc_alpha1_d*14', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7616, 7616, '1', 'bc_alpha1_d*2', 'bc_alpha1_d*2', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7617, 7617, '1', 'bc_alpha1_d*3', 'bc_alpha1_d*3', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7618, 7618, '1', 'bc_alpha1_d*4', 'bc_alpha1_d*4', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7619, 7619, '1', 'bc_alpha1_d*5', 'bc_alpha1_d*5', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7620, 7620, '1', 'bc_alpha1_d*6', 'bc_alpha1_d*6', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7621, 7621, '1', 'bc_alpha1_d*7', 'bc_alpha1_d*7', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7622, 7622, '1', 'bc_alpha1_d*8', 'bc_alpha1_d*8', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7623, 7623, '1', 'bc_alpha1_d*9', 'bc_alpha1_d*9', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7624, 7624, '1', 'bc_alpha1_n*1', 'bc_alpha1_n*1', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7625, 7625, '1', 'bc_alpha1_n*10', 'bc_alpha1_n*10', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7626, 7626, '1', 'bc_alpha1_n*11', 'bc_alpha1_n*11', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7627, 7627, '1', 'bc_alpha1_n*12', 'bc_alpha1_n*12', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7628, 7628, '1', 'bc_alpha1_n*13', 'bc_alpha1_n*13', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7629, 7629, '1', 'bc_alpha1_n*14', 'bc_alpha1_n*14', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7630, 7630, '1', 'bc_alpha1_n*2', 'bc_alpha1_n*2', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7631, 7631, '1', 'bc_alpha1_n*3', 'bc_alpha1_n*3', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7632, 7632, '1', 'bc_alpha1_n*4', 'bc_alpha1_n*4', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7633, 7633, '1', 'bc_alpha1_n*5', 'bc_alpha1_n*5', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7634, 7634, '1', 'bc_alpha1_n*6', 'bc_alpha1_n*6', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7635, 7635, '1', 'bc_alpha1_n*7', 'bc_alpha1_n*7', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7636, 7636, '1', 'bc_alpha1_n*8', 'bc_alpha1_n*8', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7637, 7637, '1', 'bc_alpha1_n*9', 'bc_alpha1_n*9', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7638, 7638, '1', 'bc_alpha1_k*1', 'bc_alpha1_k*1', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7639, 7639, '1', 'bc_alpha1_k*10', 'bc_alpha1_k*10', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7640, 7640, '1', 'bc_alpha1_k*11', 'bc_alpha1_k*11', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7641, 7641, '1', 'bc_alpha1_k*12', 'bc_alpha1_k*12', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7642, 7642, '1', 'bc_alpha1_k*13', 'bc_alpha1_k*13', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7643, 7643, '1', 'bc_alpha1_k*14', 'bc_alpha1_k*14', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7644, 7644, '1', 'bc_alpha1_k*2', 'bc_alpha1_k*2', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7645, 7645, '1', 'bc_alpha1_k*3', 'bc_alpha1_k*3', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7646, 7646, '1', 'bc_alpha1_k*4', 'bc_alpha1_k*4', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7647, 7647, '1', 'bc_alpha1_k*5', 'bc_alpha1_k*5', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7648, 7648, '1', 'bc_alpha1_k*6', 'bc_alpha1_k*6', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7649, 7649, '1', 'bc_alpha1_k*7', 'bc_alpha1_k*7', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7650, 7650, '1', 'bc_alpha1_k*8', 'bc_alpha1_k*8', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7651, 7651, '1', 'bc_alpha1_k*9', 'bc_alpha1_k*9', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7652, 7652, '1', 'bc_alpha1_num*1', 'bc_alpha1_num*1', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 10, '', '', '', 0, 0, ''),
	(7653, 7653, '1', 'bc_alpha1_num*10', 'bc_alpha1_num*10', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 10, '', '', '', 0, 0, ''),
	(7654, 7654, '1', 'bc_alpha1_num*11', 'bc_alpha1_num*11', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 10, '', '', '', 0, 0, ''),
	(7655, 7655, '1', 'bc_alpha1_num*12', 'bc_alpha1_num*12', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 10, '', '', '', 0, 0, ''),
	(7656, 7656, '1', 'bc_alpha1_num*13', 'bc_alpha1_num*13', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 10, '', '', '', 0, 0, ''),
	(7657, 7657, '1', 'bc_alpha1_num*14', 'bc_alpha1_num*14', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 10, '', '', '', 0, 0, ''),
	(7658, 7658, '1', 'bc_alpha1_num*2', 'bc_alpha1_num*2', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 10, '', '', '', 0, 0, ''),
	(7659, 7659, '1', 'bc_alpha1_num*3', 'bc_alpha1_num*3', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 10, '', '', '', 0, 0, ''),
	(7660, 7660, '1', 'bc_alpha1_num*4', 'bc_alpha1_num*4', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 10, '', '', '', 0, 0, ''),
	(7661, 7661, '1', 'bc_alpha1_num*5', 'bc_alpha1_num*5', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 10, '', '', '', 0, 0, ''),
	(7662, 7662, '1', 'bc_alpha1_num*6', 'bc_alpha1_num*6', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 10, '', '', '', 0, 0, ''),
	(7663, 7663, '1', 'bc_alpha1_num*7', 'bc_alpha1_num*7', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 10, '', '', '', 0, 0, ''),
	(7664, 7664, '1', 'bc_alpha1_num*8', 'bc_alpha1_num*8', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 10, '', '', '', 0, 0, ''),
	(7665, 7665, '1', 'bc_alpha1_num*9', 'bc_alpha1_num*9', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 10, '', '', '', 0, 0, ''),
	(7666, 7666, '1', 'bc_alpha1_u*1', 'bc_alpha1_u*1', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7667, 7667, '1', 'bc_alpha1_u*10', 'bc_alpha1_u*10', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7668, 7668, '1', 'bc_alpha1_u*11', 'bc_alpha1_u*11', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7669, 7669, '1', 'bc_alpha1_u*12', 'bc_alpha1_u*12', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7670, 7670, '1', 'bc_alpha1_u*13', 'bc_alpha1_u*13', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7671, 7671, '1', 'bc_alpha1_u*14', 'bc_alpha1_u*14', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7672, 7672, '1', 'bc_alpha1_u*2', 'bc_alpha1_u*2', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7673, 7673, '1', 'bc_alpha1_u*3', 'bc_alpha1_u*3', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7674, 7674, '1', 'bc_alpha1_u*4', 'bc_alpha1_u*4', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7675, 7675, '1', 'bc_alpha1_u*5', 'bc_alpha1_u*5', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7676, 7676, '1', 'bc_alpha1_u*6', 'bc_alpha1_u*6', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7677, 7677, '1', 'bc_alpha1_u*7', 'bc_alpha1_u*7', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7678, 7678, '1', 'bc_alpha1_u*8', 'bc_alpha1_u*8', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7679, 7679, '1', 'bc_alpha1_u*9', 'bc_alpha1_u*9', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7680, 7680, '1', 'bc_alpha1_z*1', 'bc_alpha1_z*1', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7681, 7681, '1', 'bc_alpha1_z*10', 'bc_alpha1_z*10', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7682, 7682, '1', 'bc_alpha1_z*11', 'bc_alpha1_z*11', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7683, 7683, '1', 'bc_alpha1_z*12', 'bc_alpha1_z*12', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7684, 7684, '1', 'bc_alpha1_z*13', 'bc_alpha1_z*13', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7685, 7685, '1', 'bc_alpha1_z*14', 'bc_alpha1_z*14', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7686, 7686, '1', 'bc_alpha1_z*2', 'bc_alpha1_z*2', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7687, 7687, '1', 'bc_alpha1_z*3', 'bc_alpha1_z*3', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7688, 7688, '1', 'bc_alpha1_z*4', 'bc_alpha1_z*4', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7689, 7689, '1', 'bc_alpha1_z*5', 'bc_alpha1_z*5', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7690, 7690, '1', 'bc_alpha1_z*6', 'bc_alpha1_z*6', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7691, 7691, '1', 'bc_alpha1_z*7', 'bc_alpha1_z*7', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7692, 7692, '1', 'bc_alpha1_z*8', 'bc_alpha1_z*8', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7693, 7693, '1', 'bc_alpha1_z*9', 'bc_alpha1_z*9', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7694, 7694, '1', 'bc_alpha1_a*1', 'bc_alpha1_a*1', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7695, 7695, '1', 'bc_alpha1_a*10', 'bc_alpha1_a*10', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7696, 7696, '1', 'bc_alpha1_a*11', 'bc_alpha1_a*11', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7697, 7697, '1', 'bc_alpha1_a*12', 'bc_alpha1_a*12', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7698, 7698, '1', 'bc_alpha1_a*13', 'bc_alpha1_a*13', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7699, 7699, '1', 'bc_alpha1_a*14', 'bc_alpha1_a*14', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7700, 7700, '1', 'bc_alpha1_a*2', 'bc_alpha1_a*2', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7701, 7701, '1', 'bc_alpha1_a*3', 'bc_alpha1_a*3', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7702, 7702, '1', 'bc_alpha1_a*4', 'bc_alpha1_a*4', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7703, 7703, '1', 'bc_alpha1_a*5', 'bc_alpha1_a*5', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7704, 7704, '1', 'bc_alpha1_a*6', 'bc_alpha1_a*6', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7705, 7705, '1', 'bc_alpha1_a*7', 'bc_alpha1_a*7', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7706, 7706, '1', 'bc_alpha1_a*8', 'bc_alpha1_a*8', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7707, 7707, '1', 'bc_alpha1_a*9', 'bc_alpha1_a*9', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7708, 7708, '1', 'bc_alpha1_p*1', 'bc_alpha1_p*1', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7709, 7709, '1', 'bc_alpha1_p*10', 'bc_alpha1_p*10', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7710, 7710, '1', 'bc_alpha1_p*11', 'bc_alpha1_p*11', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7711, 7711, '1', 'bc_alpha1_p*12', 'bc_alpha1_p*12', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7712, 7712, '1', 'bc_alpha1_p*13', 'bc_alpha1_p*13', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7713, 7713, '1', 'bc_alpha1_p*14', 'bc_alpha1_p*14', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7714, 7714, '1', 'bc_alpha1_p*2', 'bc_alpha1_p*2', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7715, 7715, '1', 'bc_alpha1_p*3', 'bc_alpha1_p*3', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7716, 7716, '1', 'bc_alpha1_p*4', 'bc_alpha1_p*4', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7717, 7717, '1', 'bc_alpha1_p*5', 'bc_alpha1_p*5', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7718, 7718, '1', 'bc_alpha1_p*6', 'bc_alpha1_p*6', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7719, 7719, '1', 'bc_alpha1_p*7', 'bc_alpha1_p*7', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7720, 7720, '1', 'bc_alpha1_p*8', 'bc_alpha1_p*8', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7721, 7721, '1', 'bc_alpha1_p*9', 'bc_alpha1_p*9', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7722, 7722, '0', 'attic15_cabinet', 'attic15_cabinet', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7723, 7723, '0', 'val15_gift2', 'val15_gift2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7724, 7724, '1', 'val15_zen', 'val15_zen', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 6, '', '', '', 0, 0, ''),
	(7725, 7725, '0', 'val15_tele', 'val15_tele', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'teleport', 1, '', '', '', 0, 0, ''),
	(7726, 7726, '0', 'val15_sakura', 'val15_sakura', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7727, 7727, '1', 'val15_lilys', 'val15_lilys', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7728, 7728, '1', 'val15_rock1', 'val15_rock1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(7729, 7729, '1', 'val15_shamisen', 'val15_shamisen', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7730, 7730, '1', 'val15_tea', 'val15_tea', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine_no_sides', 2, '91', '', '', 0, 0, ''),
	(7731, 7731, '0', 'val15_gift1', 'val15_gift1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7732, 7732, '0', 'val15_hottub', 'val15_hottub', 'S', 2, 2, 0.20, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7733, 7733, '1', 'val15_petals', 'val15_petals', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7734, 7734, '1', 'val15_stage2', 'val15_stage2', 'S', 1, 1, 0.50, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(7735, 7735, '1', 'val15_lantern', 'val15_lantern', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7736, 7736, '0', 'val15_gift3', 'val15_gift3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7737, 7737, '1', 'val15_corner', 'val15_corner', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7738, 7738, '0', 'val15_dogstat', 'val15_dogstat', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7739, 7739, '1', 'val15_table', 'val15_table', 'S', 2, 1, 0.60, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7740, 7740, '1', 'val15_chair', 'val15_chair', 'S', 1, 1, 0.80, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7741, 7741, '1', 'val15_rock2', 'val15_rock2', 'S', 2, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(7742, 7742, '1', 'val15_bridge2', 'val15_bridge2', 'S', 1, 1, 0.75, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7743, 7743, '1', 'val15_divider', 'val15_divider', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7744, 7744, '1', 'val15_water', 'val15_water', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 75, '', '', '', 0, 0, ''),
	(7745, 7745, '0', 'val15_armour', 'val15_armour', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7746, 7746, '0', 'val15_koipond', 'val15_koipond', 'S', 2, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7747, 7747, '0', 'val15_crane', 'val15_crane', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7748, 7748, '1', 'val15_bench', 'val15_bench', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7749, 7749, '1', 'val15_gazebo', 'val15_gazebo', 'S', 2, 2, 0.30, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7750, 7750, '1', 'val15_tree', 'val15_tree', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7751, 7751, '1', 'val15_shinto_arch', 'val15_shinto_arch', 'S', 2, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7752, 7752, '1', 'val15_gate', 'val15_gate', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(7753, 7753, '1', 'val15_bridge1', 'val15_bridge1', 'S', 1, 1, 0.50, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7754, 7754, '1', 'val15_stage1', 'val15_stage1', 'S', 2, 1, 0.45, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7755, 7755, '1', 'attic15_sofa', 'attic15_sofa', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7756, 7756, '1', 'attic15_crn', 'attic15_crn', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7757, 7757, '1', 'attic15_box', 'attic15_box', 'S', 1, 1, 0.70, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(7758, 7758, '0', 'attic15_chest', 'attic15_chest', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '1065,1066,1067', '', '', 0, 0, ''),
	(7759, 7759, '1', 'attic15_oillamp', 'attic15_oillamp', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7760, 7760, '1', 'attic15_bigshelf', 'attic15_bigshelf', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(7761, 7761, '1', 'attic15_chair', 'attic15_chair', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7762, 7762, '1', 'attic15_bigtable', 'attic15_bigtable', 'S', 2, 1, 0.80, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7763, 7763, '1', 'attic15_lamp', 'attic15_lamp', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7764, 7764, '1', 'attic15_table', 'attic15_table', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7765, 7765, '1', 'attic15_paintingfloor', 'attic15_paintingfloor', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7766, 7766, '1', 'attic15_window', 'attic15_window', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7767, 7767, '1', 'attic15_cradle', 'attic15_cradle', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7768, 7768, '0', 'attic15_telescope', 'attic15_telescope', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7769, 7769, '1', 'attic15_gate', 'attic15_gate', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(7770, 7770, '0', 'attic15_clock', 'attic15_clock', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7771, 7771, '1', 'attic15_mousetrap', 'attic15_mousetrap', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'trap', 2, '', '', '', 0, 0, ''),
	(7772, 7772, '1', 'attic15_carpet', 'attic15_carpet', 'S', 3, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '1', '', 0, 0, ''),
	(7773, 7773, '0', 'attic15_tele', 'attic15_tele', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'teleport', 1, '', '', '', 0, 0, ''),
	(7774, 7774, '1', 'attic15_shelf', 'attic15_shelf', 'S', 1, 1, 3.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7775, 7775, '1', 'attic15_divider', 'attic15_divider', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7776, 7776, '1', 'val15_shrub', 'val15_shrub', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(7777, 7777, '0', 'clothing_kimono1', 'clothing_kimono1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(7778, 7778, '0', 'clothing_kimono2', 'clothing_kimono2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(7779, 7779, '0', 'rare_prize15*1', 'rare_prize15*1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7780, 7780, '0', 'rare_prize15*10', 'rare_prize15*10', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7781, 7781, '0', 'rare_prize15*11', 'rare_prize15*11', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7782, 7782, '0', 'rare_prize15*12', 'rare_prize15*12', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7783, 7783, '0', 'rare_prize15*2', 'rare_prize15*2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7784, 7784, '0', 'rare_prize15*3', 'rare_prize15*3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7785, 7785, '0', 'rare_prize15*4', 'rare_prize15*4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7786, 7786, '0', 'rare_prize15*5', 'rare_prize15*5', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7787, 7787, '0', 'rare_prize15*6', 'rare_prize15*6', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7788, 7788, '0', 'rare_prize15*7', 'rare_prize15*7', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7789, 7789, '0', 'rare_prize15*8', 'rare_prize15*8', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7790, 7790, '0', 'rare_prize15*9', 'rare_prize15*9', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7791, 7791, '0', 'carnival15_hotair_brazil', 'carnival15_hotair_brazil', 'S', 1, 1, 7.00, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7792, 7792, '0', 'rare_prize15*13', 'rare_prize15*13', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7793, 7793, '0', 'rare_prize15*14', 'rare_prize15*14', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7794, 7794, '0', 'rare_prize15*15', 'rare_prize15*15', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7795, 7795, '0', 'rare_prize15*16', 'rare_prize15*16', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7796, 7796, '0', 'rare_prize15*17', 'rare_prize15*17', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7797, 7797, '0', 'rare_prize15*18', 'rare_prize15*18', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7798, 7798, '0', 'rare_prize15*19', 'rare_prize15*19', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7799, 7799, '0', 'rare_prize15*20', 'rare_prize15*20', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7800, 7800, '0', 'rare_prize15*21', 'rare_prize15*21', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7801, 7801, '0', 'rare_prize15*22', 'rare_prize15*22', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7802, 7802, '0', 'rare_prize15*23', 'rare_prize15*23', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7803, 7803, '0', 'rare_prize15*24', 'rare_prize15*24', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7804, 7804, '1', 'cpunk_c15_neoarrowup', 'cpunk_c15_neoarrowup', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7805, 7805, '1', 'cpunk_c15_neonx', 'cpunk_c15_neonx', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7806, 7806, '0', 'cpunk15_robofrank', 'cpunk15_robofrank', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7807, 7807, '0', 'cpunk_c15_tele', 'cpunk_c15_tele', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'teleport', 1, '', '', '', 0, 0, ''),
	(7808, 7808, '0', 'cpunk15_robo', 'cpunk15_robo', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7809, 7809, '0', 'cpunk15_gift', 'cpunk15_gift', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7810, 7810, '1', 'cpunk_c15_rain', 'cpunk_c15_rain', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7811, 7811, '1', 'cpunk_c15_table', 'cpunk_c15_table', 'S', 2, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7812, 7812, '0', 'clothing_cyboots', 'clothing_cyboots', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(7813, 7813, '1', 'cpunk_c15_searchlight', 'cpunk_c15_searchlight', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7814, 7814, '0', 'clothing_cyzipped', 'clothing_cyzipped', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(7815, 7815, '0', 'clothing_cystraphood', 'clothing_cystraphood', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(7816, 7816, '0', 'clothing_goggles', 'clothing_goggles', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(7817, 7817, '0', 'cpunk_c15_robojunk', 'cpunk_c15_robojunk', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7818, 7818, '0', 'cpunk15_blimp', 'cpunk15_blimp', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7819, 7819, '0', 'clothing_cyskirt', 'clothing_cyskirt', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(7820, 7820, '0', 'clothing_cyquif', 'clothing_cyquif', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(7821, 7821, '1', 'cpunk_c15_building2', 'cpunk_c15_building2', 'S', 1, 2, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(7822, 7822, '0', 'clothing_cyhood', 'clothing_cyhood', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(7823, 7823, '1', 'cpunk_c15_tubes', 'cpunk_c15_tubes', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(7824, 7824, '0', 'clothing_cyhair', 'clothing_cyhair', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(7825, 7825, '1', 'cpunk_c15_neonsk', 'cpunk_c15_neonsk', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7826, 7826, '1', 'cpunk_c15_neoarrow', 'cpunk_c15_neoarrow', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7827, 7827, '0', 'clothing_cystrappants', 'clothing_cystrappants', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(7828, 7828, '1', 'cpunk_c15_road', 'cpunk_c15_road', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 6, '', '', '', 0, 0, ''),
	(7829, 7829, '0', 'cpunk15_gunvender', 'cpunk15_gunvender', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'effect_vendingmachine', 2, '182', '', '', 0, 0, ''),
	(7830, 7830, '1', 'cpunk_c15_neond', 'cpunk_c15_neond', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7831, 7831, '0', 'clothing_cystrapboots', 'clothing_cystrapboots', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(7832, 7832, '0', 'clothing_cymask', 'clothing_cymask', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(7833, 7833, '1', 'cpunk_c15_stool', 'cpunk_c15_stool', 'S', 1, 1, 1.80, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7834, 7834, '1', 'cpunk_c15_traffic', 'cpunk_c15_traffic', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7835, 7835, '0', 'clothing_cyglass', 'clothing_cyglass', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(7836, 7836, '1', 'cpunk_c15_door', 'cpunk_c15_door', 'S', 1, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(7837, 7837, '0', 'clothing_cygirl', 'clothing_cygirl', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(7838, 7838, '0', 'cpunk15_roborat', 'cpunk15_roborat', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7839, 7839, '0', 'cpunk15_robosheep', 'cpunk15_robosheep', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7840, 7840, '1', 'cpunk_c15_bar', 'cpunk_c15_bar', 'S', 2, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'vendingmachine', 2, '24,29,30,35,53,62,87,90,1041', '', '', 0, 0, ''),
	(7841, 7841, '0', 'clothing_cycircuit', 'clothing_cycircuit', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(7842, 7842, '0', 'clothing_cyleather', 'clothing_cyleather', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(7843, 7843, '0', 'clothing_cyphones', 'clothing_cyphones', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(7844, 7844, '1', 'cpunk_c15_building1', 'cpunk_c15_building1', 'S', 1, 2, 6.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(7845, 7845, '0', 'cny_sheepballoon', 'cny_sheepballoon', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7846, 7846, '0', 'china_goat', 'china_goat', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7847, 7847, '1', 'cpunk_c15_stage1', 'cpunk_c15_stage1', 'S', 2, 2, 0.10, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 3, '', '0.00;1.50;2.70', '', 0, 0, ''),
	(7848, 7848, '0', 'wf_act_bot_clothes', 'wf_act_bot_clothes', 'S', 1, 1, 0.65, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'wf_act_bot_clothes', 1, '', '', '', 0, 0, ''),
	(7849, 7849, '0', 'wf_act_bot_teleport', 'wf_act_bot_teleport', 'S', 1, 1, 0.65, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'wf_act_bot_teleport', 1, '', '', '', 0, 0, ''),
	(7850, 7850, '0', 'wf_trg_bot_reached_stf', 'wf_trg_bot_reached_stf', 'S', 1, 1, 0.65, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'wf_trg_bot_reached_stf', 1, '', '', '', 0, 0, ''),
	(7851, 7851, '0', 'wf_act_bot_follow_avatar', 'wf_act_bot_follow_avatar', 'S', 1, 1, 0.65, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'wf_act_bot_follow_avatar', 1, '', '', '', 0, 0, ''),
	(7852, 7852, '0', 'wf_act_bot_give_handitem', 'wf_act_bot_give_handitem', 'S', 1, 1, 0.65, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'wf_act_bot_give_handitem', 1, '', '', '', 0, 0, ''),
	(7853, 7853, '0', 'wf_act_bot_move', 'wf_act_bot_move', 'S', 1, 1, 0.65, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'wf_act_bot_move', 1, '', '', '', 0, 0, ''),
	(7854, 7854, '0', 'wf_cnd_has_handitem', 'wf_cnd_has_handitem', 'S', 1, 1, 0.65, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'wf_cnd_has_handitem', 1, '', '', '', 0, 0, ''),
	(7855, 7855, '0', 'wf_act_bot_talk_to_avatar', 'wf_act_bot_talk_to_avatar', 'S', 1, 1, 0.65, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'wf_act_bot_talk_to_avatar', 1, '', '', '', 0, 0, ''),
	(7856, 7856, '0', 'wf_trg_bot_reached_avtr', 'wf_trg_bot_reached_avtr', 'S', 1, 1, 0.65, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'wf_trg_bot_reached_avtr', 1, '', '', '', 0, 0, ''),
	(7857, 7857, '0', 'wf_act_bot_talk', 'wf_act_bot_talk', 'S', 1, 1, 0.65, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'wf_act_bot_talk', 1, '', '', '', 0, 0, ''),
	(7858, 7858, '0', 'room_cof15_tree1', 'room_cof15_tree1', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7859, 7859, '0', 'room_cof15_counter2', 'room_cof15_counter2', 'S', 3, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7860, 7860, '0', 'room_cof15_table3', 'room_cof15_table3', 'S', 1, 1, 0.50, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7861, 7861, '0', 'room_cof15_lamp1', 'room_cof15_lamp1', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7862, 7862, '0', 'room_cof15_chair', 'room_cof15_chair', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7863, 7863, '0', 'room_cof15_counter1', 'room_cof15_counter1', 'S', 3, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '89,1024,1053', '', '', 0, 0, ''),
	(7864, 7864, '0', 'room_cof15_table1', 'room_cof15_table1', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7865, 7865, '0', 'room_cof15_table2', 'room_cof15_table2', 'S', 3, 1, 0.70, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7866, 7866, '0', 'room_cof15_sofa1', 'room_cof15_sofa1', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7867, 7867, '0', 'room_cof15_cup', 'room_cof15_cup', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine_no_sides', 2, '8,9,10,11,12,13,14,15,16,17,53,54', '', '', 0, 0, ''),
	(7868, 7868, '0', 'room_cof15_planter', 'room_cof15_planter', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7869, 7869, '0', 'room_cof15_pillar1', 'room_cof15_pillar1', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7870, 7870, '0', 'room_cof15_counter3', 'room_cof15_counter3', 'S', 1, 2, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7871, 7871, '0', 'room_cof15_espresso', 'room_cof15_espresso', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '8', '', '', 0, 0, ''),
	(7872, 7872, '0', 'room_cof15_lamp2', 'room_cof15_lamp2', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7873, 7873, '0', 'room_cof15_shelf2', 'room_cof15_shelf2', 'S', 1, 2, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7874, 7874, '0', 'room_cof15_shelf', 'room_cof15_shelf', 'S', 1, 2, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7875, 7875, '0', 'room_cof15_door', 'room_cof15_door', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(7876, 7876, '0', 'room_cof15_cup2', 'room_cof15_cup2', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine_no_sides', 2, '85,86', '', '', 0, 0, ''),
	(7877, 7877, '0', 'room_cof15_sofa2', 'room_cof15_sofa2', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7878, 7878, '0', 'room_cof15_press', 'room_cof15_press', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7879, 7879, '0', 'room_gh15_cab2', 'room_gh15_cab2', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7880, 7880, '0', 'room_gh15_light', 'room_gh15_light', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 6, '', '', '', 0, 0, ''),
	(7881, 7881, '0', 'room_gh15_cab3', 'room_gh15_cab3', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7882, 7882, '0', 'room_gh15_cab1', 'room_gh15_cab1', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'information_terminal', 2, '', '', '', 0, 0, ''),
	(7883, 7883, '0', 'room_gh15_desk', 'room_gh15_desk', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(7884, 7884, '0', 'room_gh15_cab4', 'room_gh15_cab4', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7885, 7885, '0', 'room_gh15_cab6', 'room_gh15_cab6', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7886, 7886, '0', 'room_gh15_ball', 'room_gh15_ball', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7887, 7887, '0', 'room_gh15_rtele', 'room_gh15_rtele', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'teleporttile', 2, '', '', '', 0, 0, ''),
	(7888, 7888, '0', 'room_gh15_cab5', 'room_gh15_cab5', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7889, 7889, '0', 'room_hcl15_tree2', 'room_hcl15_tree2', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(7890, 7890, '0', 'room_hcl15_gate', 'room_hcl15_gate', 'S', 2, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'club_gate', 2, '', '', '', 0, 0, ''),
	(7891, 7891, '0', 'room_hcl15_dj', 'room_hcl15_dj', 'S', 3, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7892, 7892, '0', 'room_hcl15_table1', 'room_hcl15_table1', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7893, 7893, '0', 'room_hcl15_table2', 'room_hcl15_table2', 'S', 1, 2, 0.50, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7894, 7894, '0', 'room_hcl15_sofa', 'room_hcl15_sofa', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7895, 7895, '0', 'room_hcl15_amp', 'room_hcl15_amp', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7896, 7896, '0', 'room_hcl15_div', 'room_hcl15_div', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7897, 7897, '0', 'room_hcl15_tube', 'room_hcl15_tube', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7898, 7898, '0', 'room_hcl15_bar', 'room_hcl15_bar', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 15, '', '', '', 0, 0, ''),
	(7899, 7899, '0', 'room_hcl15_barchair', 'room_hcl15_barchair', 'S', 1, 1, 1.40, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7900, 7900, '0', 'room_hcl15_floor', 'room_hcl15_floor', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(7901, 7901, '0', 'room_hcl15_tree1', 'room_hcl15_tree1', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(7902, 7902, '0', 'room_hcl15_djtable', 'room_hcl15_djtable', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7903, 7903, '0', 'room_wl15_mag1', 'room_wl15_mag1', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(7904, 7904, '0', 'room_wl15_table1', 'room_wl15_table1', 'S', 1, 2, 0.35, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7905, 7905, '0', 'room_wl15_ele', 'room_wl15_ele', 'S', 2, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'teleport', 2, '', '', '', 0, 0, ''),
	(7906, 7906, '0', 'room_wl15_sink', 'room_wl15_sink', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7907, 7907, '0', 'room_wlof15_bed', 'room_wlof15_bed', 'S', 1, 3, 1.80, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7908, 7908, '0', 'room_wl15_teleblock', 'room_wl15_teleblock', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'teleporttile', 1, '', '', '', 0, 0, ''),
	(7909, 7909, '0', 'room_wl15_tree', 'room_wl15_tree', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 6, '', '', '', 0, 0, ''),
	(7910, 7910, '0', 'room_wl15_infolink', 'room_wl15_infolink', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7911, 7911, '0', 'room_wl15_pillar', 'room_wl15_pillar', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(7912, 7912, '0', 'room_wl15_trashbin', 'room_wl15_trashbin', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7913, 7913, '0', 'room_wl15_table3', 'room_wl15_table3', 'S', 1, 1, 0.95, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7914, 7914, '0', 'room_wl15_bthdoor', 'room_wl15_bthdoor', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'teleport', 2, '', '', '', 0, 0, ''),
	(7915, 7915, '0', 'room_wl15_toiletbroke', 'room_wl15_toiletbroke', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 2, '', '1.2;2.8', '', 0, 0, ''),
	(7916, 7916, '0', 'room_wl15_deskgate', 'room_wl15_deskgate', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(7917, 7917, '0', 'room_wl15_deskfront', 'room_wl15_deskfront', 'S', 1, 4, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(7918, 7918, '0', 'room_wl15_table2', 'room_wl15_table2', 'S', 2, 2, 0.35, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7919, 7919, '0', 'room_wlof15_chair', 'room_wlof15_chair', 'S', 1, 1, 1.40, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7920, 7920, '0', 'room_wl15_mirror', 'room_wl15_mirror', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7921, 7921, '0', 'room_wlof15_wardrobe', 'room_wlof15_wardrobe', 'S', 1, 2, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7922, 7922, '0', 'room_wlof15_bookcase', 'room_wlof15_bookcase', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '1003,1004,1005', '', '', 0, 0, ''),
	(7923, 7923, '0', 'room_wl15_toilet', 'room_wl15_toilet', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'teleport', 2, '', '', '', 0, 0, ''),
	(7924, 7924, '0', 'room_wl15_sofa', 'room_wl15_sofa', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7925, 7925, '0', 'room_hall15_wfall', 'room_hall15_wfall', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7926, 7926, '0', 'room_hall15_dish1', 'room_hall15_dish1', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(7927, 7927, '0', 'room_hall15_ele', 'room_hall15_ele', 'S', 2, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'teleport', 2, '', '', '', 0, 0, ''),
	(7928, 7928, '0', 'room_hall15_light1', 'room_hall15_light1', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(7929, 7929, '0', 'room_hall15_dish2', 'room_hall15_dish2', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(7930, 7930, '0', 'room_hall15_arch', 'room_hall15_arch', 'S', 2, 4, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7931, 7931, '0', 'room_hall15_plant1', 'room_hall15_plant1', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 6, '', '', '', 0, 0, ''),
	(7932, 7932, '0', 'cland_c15_table', 'cland_c15_table', 'S', 1, 1, 0.80, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(7933, 7933, '0', 'cland_c15_icreamtree', 'cland_c15_icreamtree', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7934, 7934, '0', 'clothing_frontswirl', 'clothing_frontswirl', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(7935, 7935, '0', 'clothing_cjersey', 'clothing_cjersey', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(7936, 7936, '0', 'clothing_candygirl', 'clothing_candygirl', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(7937, 7937, '0', 'cland_c15_gate', 'cland_c15_gate', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(7938, 7938, '0', 'cland15_LTD5', 'cland15_LTD5', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7939, 7939, '0', 'cland_c15_jellyseat2', 'cland_c15_jellyseat2', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7940, 7940, '0', 'cland15_tent', 'cland15_tent', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'tent', 1, '', '', '', 0, 0, ''),
	(7941, 7941, '0', 'cland_c15_pillar', 'cland_c15_pillar', 'S', 1, 1, 3.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7942, 7942, '0', 'cland_c15_waferblock', 'cland_c15_waferblock', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7943, 7943, '0', 'clothing_cjumper', 'clothing_cjumper', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(7944, 7944, '0', 'cland_c15_gatepink', 'cland_c15_gatepink', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(7945, 7945, '0', 'cland15_ltd4', 'cland15_ltd4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7946, 7946, '0', 'cland_c15_pavement', 'cland_c15_pavement', 'S', 1, 2, 0.20, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(7947, 7947, '0', 'cland_c15_roof', 'cland_c15_roof', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7948, 7948, '0', 'clothing_cherries', 'clothing_cherries', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(7949, 7949, '0', 'cland_c15_swirltree', 'cland_c15_swirltree', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine_no_sides', 2, '92,93,94,95', '', '', 0, 0, ''),
	(7950, 7950, '0', 'cland_c15_cakeblock', 'cland_c15_cakeblock', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 10, '', '', '', 0, 0, ''),
	(7951, 7951, '0', 'clothing_cshorts', 'clothing_cshorts', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(7952, 7952, '0', 'clothing_habloompa', 'clothing_habloompa', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(7953, 7953, '0', 'cland15_candythrone', 'cland15_candythrone', 'S', 1, 1, 1.40, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7954, 7954, '0', 'clothing_cherrybomb', 'clothing_cherrybomb', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(7955, 7955, '0', 'cland_c15_wafer', 'cland_c15_wafer', 'S', 2, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7956, 7956, '0', 'cland15_ltd3', 'cland15_ltd3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7957, 7957, '0', 'cland15_unipoo', 'cland15_unipoo', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine_no_sides', 2, '4,75,76,77', '', '', 0, 0, ''),
	(7958, 7958, '0', 'clothing_candyphones', 'clothing_candyphones', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(7959, 7959, '0', 'cland_c15_light', 'cland_c15_light', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7960, 7960, '0', 'cland15_unicorn', 'cland15_unicorn', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7961, 7961, '0', 'clothing_sidehat', 'clothing_sidehat', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(7962, 7962, '0', 'cland15_fountain', 'cland15_fountain', 'S', 2, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7963, 7963, '0', 'clothing_swirlskirt', 'clothing_swirlskirt', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(7964, 7964, '0', 'cland_c15_grass', 'cland_c15_grass', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(7965, 7965, '0', 'cland15_ltd1', 'cland15_ltd1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7966, 7966, '0', 'cland15_flosstree', 'cland15_flosstree', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine_no_sides', 2, '79,92,93,94,95', '', '', 0, 0, ''),
	(7967, 7967, '0', 'clothing_chocodrop', 'clothing_chocodrop', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(7968, 7968, '0', 'cland15_ltd2', 'cland15_ltd2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7969, 7969, '0', 'cland_c15_goofloor', 'cland_c15_goofloor', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7970, 7970, '0', 'cland_c15_lollytree', 'cland_c15_lollytree', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(7971, 7971, '0', 'cland_c15_jellyseat3', 'cland_c15_jellyseat3', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7972, 7972, '0', 'cland_c15_jellyseat1', 'cland_c15_jellyseat1', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7973, 7973, '0', 'clothing_swirltop', 'clothing_swirltop', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(7974, 7974, '0', 'cland_c15_chocostick', 'cland_c15_chocostick', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(7975, 7975, '0', 'cland_c15_chocorock', 'cland_c15_chocorock', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 8, '', '', '', 0, 0, ''),
	(7976, 7976, '0', 'clothing_candyboy', 'clothing_candyboy', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(7977, 7977, '0', 'petbox_epic', 'petbox_epic', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7978, 7978, '0', 'clothing_knitalien', 'clothing_knitalien', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(7979, 7979, '0', 'tablet_vendorg', 'tablet_vendorg', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '1071', '', '', 0, 0, ''),
	(7980, 7980, '0', 'prize_alienplush', 'prize_alienplush', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7981, 7981, '0', 'room_info15_shrub1', 'room_info15_shrub1', 'S', 1, 1, 1.60, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 10, '', '', '', 0, 0, ''),
	(7982, 7982, '0', 'room_info15_shrub3', 'room_info15_shrub3', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(7983, 7983, '0', 'room_info15_shrub2', 'room_info15_shrub2', 'S', 2, 1, 1.60, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 10, '', '', '', 0, 0, ''),
	(7984, 7984, '0', 'room_info15_statue1', 'room_info15_statue1', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7985, 7985, '0', 'room_info15_counter3', 'room_info15_counter3', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(7986, 7986, '0', 'room_info15_sofa2', 'room_info15_sofa2', 'S', 3, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7987, 7987, '0', 'room_info15_tree1', 'room_info15_tree1', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(7988, 7988, '0', 'room_info15_bus*1', 'room_info15_bus*1', 'S', 9, 3, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7989, 7989, '0', 'room_info15_bus*10', 'room_info15_bus*10', 'S', 9, 3, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7990, 7990, '0', 'room_info15_bus*11', 'room_info15_bus*11', 'S', 9, 3, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7991, 7991, '0', 'room_info15_bus*12', 'room_info15_bus*12', 'S', 9, 3, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7992, 7992, '0', 'room_info15_bus*13', 'room_info15_bus*13', 'S', 9, 3, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7993, 7993, '0', 'room_info15_bus*14', 'room_info15_bus*14', 'S', 9, 3, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7994, 7994, '0', 'room_info15_bus*15', 'room_info15_bus*15', 'S', 9, 3, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7995, 7995, '0', 'room_info15_bus*16', 'room_info15_bus*16', 'S', 9, 3, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7996, 7996, '0', 'room_info15_bus*17', 'room_info15_bus*17', 'S', 9, 3, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7997, 7997, '0', 'room_info15_bus*18', 'room_info15_bus*18', 'S', 9, 3, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7998, 7998, '0', 'room_info15_bus*19', 'room_info15_bus*19', 'S', 9, 3, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(7999, 7999, '0', 'room_info15_bus*2', 'room_info15_bus*2', 'S', 9, 3, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8000, 8000, '0', 'room_info15_bus*20', 'room_info15_bus*20', 'S', 9, 3, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8001, 8001, '0', 'room_info15_bus*3', 'room_info15_bus*3', 'S', 9, 3, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8002, 8002, '0', 'room_info15_bus*4', 'room_info15_bus*4', 'S', 9, 3, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8003, 8003, '0', 'room_info15_bus*5', 'room_info15_bus*5', 'S', 9, 3, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8004, 8004, '0', 'room_info15_bus*6', 'room_info15_bus*6', 'S', 9, 3, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8005, 8005, '0', 'room_info15_bus*7', 'room_info15_bus*7', 'S', 9, 3, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8006, 8006, '0', 'room_info15_bus*8', 'room_info15_bus*8', 'S', 9, 3, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8007, 8007, '0', 'room_info15_bus*9', 'room_info15_bus*9', 'S', 9, 3, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8008, 8008, '0', 'room_info15_bridge1', 'room_info15_bridge1', 'S', 1, 2, 0.20, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8009, 8009, '0', 'room_info15_bridge2', 'room_info15_bridge2', 'S', 2, 2, 0.80, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8010, 8010, '0', 'room_info15_clouds', 'room_info15_clouds', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8011, 8011, '0', 'room_info15_lamp1', 'room_info15_lamp1', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8012, 8012, '0', 'room_info15_bench', 'room_info15_bench', 'S', 2, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8013, 8013, '0', 'room_info15_sofa1', 'room_info15_sofa1', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8014, 8014, '0', 'room_info15_reed', 'room_info15_reed', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 12, '', '', '', 0, 0, ''),
	(8015, 8015, '0', 'room_info15_fridge', 'room_info15_fridge', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '42', '', '', 0, 0, ''),
	(8016, 8016, '0', 'room_info15_counter4', 'room_info15_counter4', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(8017, 8017, '0', 'room_info15_counter2', 'room_info15_counter2', 'S', 3, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8018, 8018, '0', 'room_info15_counter1', 'room_info15_counter1', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8019, 8019, '0', 'room_info15_statue2', 'room_info15_statue2', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8020, 8020, '0', 'room_info15_bg', 'room_info15_bg', 'S', 1, 1, 0.10, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'background_toner', 2, '', '', '', 0, 0, ''),
	(8021, 8021, '0', 'diamond_painting8', 'diamond_painting8', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8022, 8022, '0', 'army15_copter', 'army15_copter', 'S', 2, 3, 9.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8023, 8023, '1', 'army_c15_contable2', 'army_c15_contable2', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8024, 8024, '0', 'clothing_rank4', 'clothing_rank4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8025, 8025, '0', 'army15_ltdhumvee', 'army15_ltdhumvee', 'S', 2, 3, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8026, 8026, '0', 'army_c15_telemine', 'army_c15_telemine', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'teleport', 1, '', '', '', 0, 0, ''),
	(8027, 8027, '1', 'army_c15_medictent', 'army_c15_medictent', 'S', 4, 3, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'tent', 6, '', '', '', 0, 0, ''),
	(8028, 8028, '1', 'army_c15_notice', 'army_c15_notice', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8029, 8029, '0', 'army_c15_crate', 'army_c15_crate', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(8030, 8030, '0', 'clothing_parade', 'clothing_parade', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8031, 8031, '1', 'army_c15_compass', 'army_c15_compass', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '1072', '', '', 0, 0, ''),
	(8032, 8032, '1', 'army_c15_glasscrn', 'army_c15_glasscrn', 'S', 1, 1, 3.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8033, 8033, '1', 'army_c15_doorscan', 'army_c15_doorscan', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8034, 8034, '0', 'clothing_kevlaroutfit', 'clothing_kevlaroutfit', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8035, 8035, '1', 'army_c15_gate', 'army_c15_gate', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(8036, 8036, '1', 'army_c15_leatherchr', 'army_c15_leatherchr', 'S', 1, 1, 1.30, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8037, 8037, '1', 'army_c15_guardcub', 'army_c15_guardcub', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8038, 8038, '1', 'army_c15_wirecrn', 'army_c15_wirecrn', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8039, 8039, '1', 'army_c15_sandbag', 'army_c15_sandbag', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8040, 8040, '1', 'army_c15_light', 'army_c15_light', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8041, 8041, '0', 'clothing_militaryjacket', 'clothing_militaryjacket', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8042, 8042, '0', 'clothing_camooutfit', 'clothing_camooutfit', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8043, 8043, '0', 'clothing_napkin', 'clothing_napkin', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8044, 8044, '0', 'clothing_kevlar', 'clothing_kevlar', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8045, 8045, '0', 'clothing_camoboots', 'clothing_camoboots', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8046, 8046, '1', 'army_c15_screen', 'army_c15_screen', 'S', 2, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(8047, 8047, '0', 'clothing_rank5', 'clothing_rank5', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8048, 8048, '0', 'army15_scanner', 'army15_scanner', 'S', 1, 1, 2.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(8049, 8049, '1', 'army_c15_wiredividr', 'army_c15_wiredividr', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8050, 8050, '1', 'army_c15_jerrycan', 'army_c15_jerrycan', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8051, 8051, '0', 'clothing_kevlarhat', 'clothing_kevlarhat', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8052, 8052, '1', 'army_c15_watchtwr', 'army_c15_watchtwr', 'S', 1, 1, 3.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8053, 8053, '1', 'army_c15_contable', 'army_c15_contable', 'S', 2, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8054, 8054, '0', 'army15_statue', 'army15_statue', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8055, 8055, '0', 'army_c15_locker', 'army_c15_locker', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8056, 8056, '0', 'clothing_medal1', 'clothing_medal1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8057, 8057, '0', 'clothing_rank3', 'clothing_rank3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8058, 8058, '1', 'army_c15_officetent', 'army_c15_officetent', 'S', 4, 4, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'tent', 1, '', '', '', 0, 0, ''),
	(8059, 8059, '0', 'clothing_medal3', 'clothing_medal3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8060, 8060, '0', 'army_c15_teledoor', 'army_c15_teledoor', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'teleport', 1, '', '', '', 0, 0, ''),
	(8061, 8061, '0', 'army15_ltddesk', 'army15_ltddesk', 'S', 3, 2, 1.10, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8062, 8062, '1', 'army_c15_chair', 'army_c15_chair', 'S', 1, 1, 1.30, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8063, 8063, '0', 'clothing_drillserg', 'clothing_drillserg', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8064, 8064, '1', 'army_c15_plant', 'army_c15_plant', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8065, 8065, '0', 'clothing_rank2', 'clothing_rank2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8066, 8066, '1', 'army_c15_table', 'army_c15_table', 'S', 2, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8067, 8067, '1', 'army_c15_bed', 'army_c15_bed', 'S', 1, 3, 1.50, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 4, '', '', '', 0, 0, ''),
	(8068, 8068, '1', 'army_c15_cabinet', 'army_c15_cabinet', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 6, '', '', '', 0, 0, ''),
	(8069, 8069, '1', 'army_c15_bookshelf', 'army_c15_bookshelf', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(8070, 8070, '1', 'army_c15_gunrack', 'army_c15_gunrack', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8071, 8071, '1', 'army_c15_shipcon', 'army_c15_shipcon', 'S', 3, 2, 2.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(8072, 8072, '0', 'clothing_rank1', 'clothing_rank1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8073, 8073, '1', 'army_c15_glassdivdr', 'army_c15_glassdivdr', 'S', 2, 1, 3.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8074, 8074, '0', 'clothing_armyskirt', 'clothing_armyskirt', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8075, 8075, '0', 'clothing_militarypants', 'clothing_militarypants', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8076, 8076, '1', 'army_c15_food', 'army_c15_food', 'S', 1, 1, 0.50, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(8077, 8077, '1', 'army_c15_carpet', 'army_c15_carpet', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8078, 8078, '0', 'clothing_walkie', 'clothing_walkie', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8079, 8079, '0', 'army15_dog', 'army15_dog', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8080, 8080, '1', 'army_c15_deskcomp', 'army_c15_deskcomp', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 6, '', '', '', 0, 0, ''),
	(8081, 8081, '1', 'army_c15_deskitem', 'army_c15_deskitem', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(8082, 8082, '0', 'army_c15_groupflag', 'army_c15_groupflag', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8083, 8083, '0', 'clothing_medal2', 'clothing_medal2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8084, 8084, '0', 'clothing_camotank', 'clothing_camotank', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8085, 8085, '0', 'clothing_militaryhat', 'clothing_militaryhat', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8086, 8086, '0', 'clothing_camocap', 'clothing_camocap', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8087, 8087, '0', 'clothing_camotuck', 'clothing_camotuck', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8088, 8088, '0', 'room_info15_div', 'room_info15_div', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8089, 8089, '0', 'room_info15_gate', 'room_info15_gate', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(8090, 8090, '0', 'botnest', 'botnest', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8091, 8091, '1', 'dino_c15_footprint', 'dino_c15_footprint', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8092, 8092, '0', 'dino15_dinoprize6', 'dino15_dinoprize6', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8093, 8093, '0', 'dino15_fossil2', 'dino15_fossil2', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'dino_fossil', 20, '', '', '', 0, 0, ''),
	(8094, 8094, '0', 'dino15_fossil5', 'dino15_fossil5', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'dino_fossil', 20, '', '', '', 0, 0, ''),
	(8095, 8095, '0', 'dino_c15_venusfly', 'dino_c15_venusfly', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8096, 8096, '1', 'dino_c15_nest', 'dino_c15_nest', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine_no_sides', 2, '1073,1074,1075,1076', '', '', 0, 0, ''),
	(8097, 8097, '0', 'clothing_dinohat', 'clothing_dinohat', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8098, 8098, '0', 'dino15_throne', 'dino15_throne', 'S', 1, 1, 2.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8099, 8099, '1', 'dino_c15_floor', 'dino_c15_floor', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8100, 8100, '1', 'dino_c15_blocks', 'dino_c15_blocks', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 4, '', '0.5;1.0;1.5;2.0', '', 0, 0, ''),
	(8101, 8101, '1', 'dino_c15_rocksmall', 'dino_c15_rocksmall', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(8102, 8102, '1', 'dino_c15_table', 'dino_c15_table', 'S', 2, 1, 0.40, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8103, 8103, '1', 'dino_c15_dilosaur', 'dino_c15_dilosaur', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8104, 8104, '1', 'dino_c15_tree1', 'dino_c15_tree1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8105, 8105, '1', 'dino_c15_crn', 'dino_c15_crn', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8106, 8106, '1', 'dino_c15_volcano', 'dino_c15_volcano', 'S', 1, 1, 0.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 2, '', '0.6;2.2', '', 0, 0, ''),
	(8107, 8107, '0', 'dino15_amberbug', 'dino15_amberbug', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8108, 8108, '0', 'dino15_dragonfly', 'dino15_dragonfly', 'S', 1, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8109, 8109, '1', 'dino_c15_gate', 'dino_c15_gate', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(8110, 8110, '0', 'dino_c15_tele', 'dino_c15_tele', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'teleport', 1, '', '', '', 0, 0, ''),
	(8111, 8111, '0', 'clothing_caveshirt', 'clothing_caveshirt', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8112, 8112, '1', 'dino_c15_ribcage', 'dino_c15_ribcage', 'S', 2, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(8113, 8113, '1', 'dino_c15_tree2', 'dino_c15_tree2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8114, 8114, '0', 'dino15_dinoprize1', 'dino15_dinoprize1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8115, 8115, '0', 'clothing_cavehair', 'clothing_cavehair', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8116, 8116, '0', 'dino15_fossil3', 'dino15_fossil3', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'dino_fossil', 20, '', '', '', 0, 0, ''),
	(8117, 8117, '1', 'dino_c15_rocklarge', 'dino_c15_rocklarge', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(8118, 8118, '0', 'dino15_amberduck', 'dino15_amberduck', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8119, 8119, '1', 'dino_c15_plant2', 'dino_c15_plant2', 'S', 2, 2, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8120, 8120, '1', 'dino_c15_plant1', 'dino_c15_plant1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(8121, 8121, '0', 'clothing_dino', 'clothing_dino', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8122, 8122, '1', 'dino_c15_divdr', 'dino_c15_divdr', 'S', 3, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8123, 8123, '0', 'dino15_dinoprize3', 'dino15_dinoprize3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8124, 8124, '0', 'dino15_fossil1', 'dino15_fossil1', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'dino_fossil', 20, '', '', '', 0, 0, ''),
	(8125, 8125, '0', 'clothing_caveman', 'clothing_caveman', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8126, 8126, '1', 'dino_c15_log', 'dino_c15_log', 'S', 2, 1, 1.40, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8127, 8127, '0', 'dino15_dinoprize4', 'dino15_dinoprize4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8128, 8128, '0', 'dino15_fossil4', 'dino15_fossil4', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'dino_fossil', 20, '', '', '', 0, 0, ''),
	(8129, 8129, '0', 'dino15_dinoprize5', 'dino15_dinoprize5', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8130, 8130, '0', 'clothing_hat_skulldino', 'clothing_hat_skulldino', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8131, 8131, '0', 'dino15_dinoprize2', 'dino15_dinoprize2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8132, 8132, '1', 'dino_c15_tree3', 'dino_c15_tree3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(8133, 8133, '0', 'fxbox_fx183', 'fxbox_fx183', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'fx_box', 2, '', '', '', 183, 183, ''),
	(8134, 8134, '0', 'CF_300_bricks', 'CF_300_bricks', 'S', 1, 1, 0.60, '1', '0', '0', '0', '0', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8135, 8135, '0', 'room_thr15_spot', 'room_thr15_spot', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8136, 8136, '0', 'room_thr15_chair2', 'room_thr15_chair2', 'S', 1, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8137, 8137, '0', 'room_thr15_div2', 'room_thr15_div2', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8138, 8138, '0', 'room_thr15_curtain1', 'room_thr15_curtain1', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8139, 8139, '0', 'room_thr15_bubjuice', 'room_thr15_bubjuice', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '19', '', '', 0, 0, ''),
	(8140, 8140, '0', 'room_thr15_popcorn', 'room_thr15_popcorn', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '63', '', '', 0, 0, ''),
	(8141, 8141, '0', 'room_thr15_stair', 'room_thr15_stair', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 2, '', '0.0;1.0', '', 0, 0, ''),
	(8142, 8142, '0', 'room_thr15_icecream', 'room_thr15_icecream', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '4,75,76,77', '', '', 0, 0, ''),
	(8143, 8143, '0', 'room_thr15_chair1', 'room_thr15_chair1', 'S', 1, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8144, 8144, '0', 'room_thr15_div3', 'room_thr15_div3', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 12, '', '', '', 0, 0, ''),
	(8145, 8145, '0', 'room_thr15_stage', 'room_thr15_stage', 'S', 1, 1, 1.50, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8146, 8146, '0', 'room_thr15_ramp', 'room_thr15_ramp', 'S', 2, 1, 0.50, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 10, '', '0.00;0.60;1.20;1.80;2.40;3.00;3.60;4.20', '', 0, 0, ''),
	(8147, 8147, '0', 'room_thr15_block', 'room_thr15_block', 'S', 1, 1, 1.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8148, 8148, '0', 'room_thr15_div1', 'room_thr15_div1', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8149, 8149, '0', 'room_thr15_frontcur', 'room_thr15_frontcur', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8150, 8150, '0', 'room_thr15_cover', 'room_thr15_cover', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8151, 8151, '0', 'room_thr15_candy', 'room_thr15_candy', 'S', 1, 4, 1.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '48,67,68,69,79,80,84', '', '', 0, 0, ''),
	(8152, 8152, '0', 'room_thr15_hotdog', 'room_thr15_hotdog', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '81', '', '', 0, 0, ''),
	(8153, 8153, '0', 'room_thr15_sofa', 'room_thr15_sofa', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8154, 8154, '0', 'room_info15_roller', 'room_info15_roller', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'roller', 2, '', '', '', 0, 0, ''),
	(8155, 8155, '0', 'nest_raptor', 'nest_raptor', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8156, 8156, '0', 'velociraptor_egg', 'velociraptor_egg', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8157, 8157, '0', 'pterosaur_egg', 'pterosaur_egg', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8158, 8158, '0', 'petfood31', 'petfood31', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'pet_food', 2, '', '', '', 0, 0, ''),
	(8159, 8159, '0', 'petfood30', 'petfood30', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'pet_food', 2, '', '', '375,0,15 34', 0, 0, ''),
	(8160, 8160, '1', 'paris_c15_roof', 'paris_c15_roof', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8161, 8161, '1', 'paris_c15_crn', 'paris_c15_crn', 'S', 1, 1, 8.20, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8162, 8162, '0', 'paris15_paintings', 'paris15_paintings', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8163, 8163, '0', 'clothing_breton', 'clothing_breton', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8164, 8164, '1', 'paris_c15_table', 'paris_c15_table', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8165, 8165, '0', 'paris15_bicycle', 'paris15_bicycle', 'S', 1, 2, 1.00, '1', '0', '1', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8166, 8166, '1', 'paris_c15_building2', 'paris_c15_building2', 'S', 3, 1, 8.20, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8167, 8167, '1', 'paris_c15_chair', 'paris_c15_chair', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8168, 8168, '0', 'paris15_pigeon', 'paris15_pigeon', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8169, 8169, '0', 'paris_c15_food3', 'paris_c15_food3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 7, '', '', '', 0, 0, ''),
	(8170, 8170, '1', 'paris_c15_menu', 'paris_c15_menu', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(8171, 8171, '1', 'paris_c15_food1', 'paris_c15_food1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 7, '', '', '', 0, 0, ''),
	(8172, 8172, '0', 'paris15_poodle', 'paris15_poodle', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8173, 8173, '0', 'paris15_giftsnails', 'paris15_giftsnails', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8174, 8174, '1', 'paris_c15_flowerpot', 'paris_c15_flowerpot', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(8175, 8175, '1', 'paris_c15_vegstall3', 'paris_c15_vegstall3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '98', '', '', 0, 0, ''),
	(8176, 8176, '0', 'paris15_cake', 'paris15_cake', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '96', '', '', 0, 0, ''),
	(8177, 8177, '1', 'paris_c15_building1', 'paris_c15_building1', 'S', 3, 1, 8.20, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8178, 8178, '1', 'paris_c15_arch', 'paris_c15_arch', 'S', 1, 2, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8179, 8179, '0', 'clothing_necktie', 'clothing_necktie', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8180, 8180, '1', 'paris_c15_shadow', 'paris_c15_shadow', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(8181, 8181, '1', 'paris_c15_vegstall2', 'paris_c15_vegstall2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '99', '', '', 0, 0, ''),
	(8182, 8182, '0', 'paris15_ltdfountain', 'paris15_ltdfountain', 'S', 3, 3, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(8183, 8183, '1', 'paris_c15_floor', 'paris_c15_floor', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8184, 8184, '1', 'paris_c15_food2', 'paris_c15_food2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 8, '', '', '', 0, 0, ''),
	(8185, 8185, '1', 'paris_c15_flowerstl', 'paris_c15_flowerstl', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '1000,1001,1002,1006,1007,1008,1009,1019,1021,1022', '', '', 0, 0, ''),
	(8186, 8186, '1', 'paris_c15_awning', 'paris_c15_awning', 'S', 3, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(8187, 8187, '1', 'paris_c15_pavement', 'paris_c15_pavement', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8188, 8188, '1', 'paris_c15_breadstall', 'paris_c15_breadstall', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '97', '', '', 0, 0, ''),
	(8189, 8189, '1', 'paris_c15_vegstall1', 'paris_c15_vegstall1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '100', '', '', 0, 0, ''),
	(8190, 8190, '1', 'paris_c15_parasol', 'paris_c15_parasol', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(8191, 8191, '0', 'nest_pterosaur', 'nest_pterosaur', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8192, 8192, '0', 'yttv_retro', 'yttv_retro', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'youtube', 2, '', '', '', 0, 0, ''),
	(8193, 8193, '0', 'habbo15_rare_crackable', 'habbo15_rare_crackable', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(8194, 8194, '0', 'habbo15_comp_photo', 'habbo15_comp_photo', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8195, 8195, '0', 'habbo15_comp_clothing', 'habbo15_comp_clothing', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8196, 8196, '0', 'habbo15_comp_room', 'habbo15_comp_room', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8197, 8197, '0', 'habbo15_comp_video', 'habbo15_comp_video', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8198, 8198, '0', 'habbo15_placeholder', 'habbo15_placeholder', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8199, 8199, '0', 'habbo15_comp_furni', 'habbo15_comp_furni', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8200, 8200, '0', 'habbo15_comp_blocks', 'habbo15_comp_blocks', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8201, 8201, '0', 'habbo15_crackable', 'habbo15_crackable', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(8202, 8202, '0', 'room_hall_trophy2', 'room_hall_trophy2', 'S', 2, 2, 1.90, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(8203, 8203, '0', 'room_hall15_window', 'room_hall15_window', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8204, 8204, '0', 'room_hall15_pillar', 'room_hall15_pillar', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(8205, 8205, '0', 'room_hall15_sofa', 'room_hall15_sofa', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8206, 8206, '0', 'room_hall_trophy1', 'room_hall_trophy1', 'S', 1, 1, 1.50, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8207, 8207, '0', 'room_hall15_barch', 'room_hall15_barch', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8208, 8208, '0', 'pillar*10', 'pillar*10', 'S', 1, 1, 3.50, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8209, 8209, '0', 'rare_parasol*4', 'rare_parasol*4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8210, 8210, '0', 'scifidoor*11', 'scifidoor*11', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(8211, 8211, '0', 'sleepingbag*11', 'sleepingbag*11', 'S', 1, 3, 0.80, '0', '0', '1', '0', '1', '1', '0', '1', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(8212, 8212, '0', 'rare_fountain*4', 'rare_fountain*4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8213, 8213, '0', 'rare_dragonlamp*10', 'rare_dragonlamp*10', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8214, 8214, '0', 'rare_fan*10', 'rare_fan*10', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8215, 8215, '0', 'rare_icecream*11', 'rare_icecream*11', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'vendingmachine', 2, '4', '', '', 0, 0, ''),
	(8216, 8216, '0', 'wooden_screen*10', 'wooden_screen*10', 'S', 1, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8217, 8217, '0', 'rare_beehive_bulb*3', 'rare_beehive_bulb*3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8218, 8218, '0', 'pillow*10', 'pillow*10', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8219, 8219, '0', 'scifiport*10', 'scifiport*10', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(8220, 8220, '0', 'rare_elephant_statue*3', 'rare_elephant_statue*3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8221, 8221, '0', 'marquee*11', 'marquee*11', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(8222, 8222, '0', 'scifirocket*10', 'scifirocket*10', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8223, 8223, '0', 'africa15_meerkat', 'africa15_meerkat', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8224, 8224, '1', 'lodge_c15_floor', 'lodge_c15_floor', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8225, 8225, '1', 'drago_c15_bed', 'drago_c15_bed', 'S', 1, 1, 1.70, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 2, '', '', '', 0, 0, ''),
	(8226, 8226, '1', 'drago_c15_sofa', 'drago_c15_sofa', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8227, 8227, '0', 'gothic_c15_toilet', 'gothic_c15_toilet', 'S', 1, 1, 1.60, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8228, 8228, '1', 'gothic_c15_tower', 'gothic_c15_tower', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(8229, 8229, '1', 'gothic_c15_dvdr', 'gothic_c15_dvdr', 'S', 2, 1, 1.50, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(8230, 8230, '1', 'gothic_c15_chandelier', 'gothic_c15_chandelier', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8231, 8231, '1', 'gothic_c15_crn', 'gothic_c15_crn', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8232, 8232, '0', 'anc15_pharaohduck', 'anc15_pharaohduck', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8233, 8233, '1', 'anc_c15_table', 'anc_c15_table', 'S', 1, 2, 0.40, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8234, 8234, '1', 'anc_c15_chair', 'anc_c15_chair', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8235, 8235, '0', 'gothic15_toilet', 'gothic15_toilet', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8236, 8236, '1', 'lt_c15_tree', 'lt_c15_tree', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(8237, 8237, '0', 'lt15_tele', 'lt15_tele', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'teleport', 1, '', '', '', 0, 0, ''),
	(8238, 8238, '1', 'lt_c15_bush', 'lt_c15_bush', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8239, 8239, '1', 'africa_c15_table', 'africa_c15_table', 'S', 2, 1, 0.55, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8240, 8240, '1', 'africa_c15_chair', 'africa_c15_chair', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8241, 8241, '1', 'africa_c15_bongos', 'africa_c15_bongos', 'S', 1, 1, 1.60, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8242, 8242, '0', 'habbo15_win_2', 'habbo15_win_2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8243, 8243, '0', 'habbo15_win_3', 'habbo15_win_3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8244, 8244, '0', 'habbo15_win_1', 'habbo15_win_1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8245, 8245, '1', 'tiki_c15_leigiver', 'tiki_c15_leigiver', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'effect_vendingmachine', 2, '74,75,76', '', '', 0, 0, ''),
	(8246, 8246, '0', 'tiki_c15_tele', 'tiki_c15_tele', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'teleport', 1, '', '', '', 0, 0, ''),
	(8247, 8247, '1', 'greek_c15_floor', 'greek_c15_floor', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(8248, 8248, '1', 'greek_c15_bench', 'greek_c15_bench', 'S', 2, 1, 1.30, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8249, 8249, '1', 'greek_c15_lamp', 'greek_c15_lamp', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8250, 8250, '0', 'greek_c15_tile', 'greek_c15_tile', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8251, 8251, '1', 'garden_c15_toolshed', 'garden_c15_toolshed', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8252, 8252, '1', 'garden_c15_shroomchr', 'garden_c15_shroomchr', 'S', 1, 1, 1.50, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8253, 8253, '0', 'garden15_lawnmower', 'garden15_lawnmower', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8254, 8254, '0', 'habbo15_win_5', 'habbo15_win_5', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8255, 8255, '0', 'habbo15_win_4', 'habbo15_win_4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8256, 8256, '0', 'habbo15_win_10', 'habbo15_win_10', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8257, 8257, '0', 'habbo15_win_7', 'habbo15_win_7', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8258, 8258, '0', 'habbo15_win_6', 'habbo15_win_6', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8259, 8259, '0', 'habbo15_win_8', 'habbo15_win_8', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8260, 8260, '1', 'exe_c15_telephone', 'exe_c15_telephone', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8261, 8261, '1', 'exe_c15_printer', 'exe_c15_printer', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8262, 8262, '1', 'exe_c15_desktidy', 'exe_c15_desktidy', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8263, 8263, '0', 'steampunk15_plane', 'steampunk15_plane', 'S', 1, 1, 3.40, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8264, 8264, '1', 'steampunk_c15_door', 'steampunk_c15_door', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'teleport', 2, '', '', '', 0, 0, ''),
	(8265, 8265, '0', 'steampunk_c15_bed', 'steampunk_c15_bed', 'S', 2, 3, 2.00, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(8266, 8266, '1', 'steampunk_c15_stage', 'steampunk_c15_stage', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8267, 8267, '0', 'habbo15_win_13', 'habbo15_win_13', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8268, 8268, '0', 'habbo15_win_12', 'habbo15_win_12', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8269, 8269, '0', 'habbo15_birthdaycake', 'habbo15_birthdaycake', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8270, 8270, '0', 'habbo15_win_14', 'habbo15_win_14', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8271, 8271, '0', 'habbo15_win_11', 'habbo15_win_11', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8272, 8272, '0', 'habbo15_win_9', 'habbo15_win_9', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8273, 8273, '1', 'romantique_c15_table*1', 'romantique_c15_table*1', 'S', 2, 1, 0.80, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8274, 8274, '1', 'romantique_c15_table*2', 'romantique_c15_table*2', 'S', 2, 1, 0.80, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8275, 8275, '0', 'romantique_c15_table*3', 'romantique_c15_table*3', 'S', 2, 1, 0.80, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8276, 8276, '1', 'romantique_c15_table*4', 'romantique_c15_table*4', 'S', 2, 1, 0.80, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8277, 8277, '1', 'romantique_c15_table*5', 'romantique_c15_table*5', 'S', 2, 1, 0.80, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8278, 8278, '1', 'romantique_c15_dresser', 'romantique_c15_dresser', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 9, '', '', '', 0, 0, ''),
	(8279, 8279, '1', 'uni_c15_lamp', 'uni_c15_lamp', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8280, 8280, '1', 'uni_c15_shelvescrn', 'uni_c15_shelvescrn', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 6, '', '', '', 0, 0, ''),
	(8281, 8281, '1', 'uni_c15_chair', 'uni_c15_chair', 'S', 1, 1, 0.90, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(8282, 8282, '1', 'bling_c15_chandalier', 'bling_c15_chandalier', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8283, 8283, '0', 'bling15_pooltable', 'bling15_pooltable', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8284, 8284, '0', 'jp_c15_daruma', 'jp_c15_daruma', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(8285, 8285, '0', 'jp_c15_dresser', 'jp_c15_dresser', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(8286, 8286, '1', 'jp_c15_teapot', 'jp_c15_teapot', 'S', 2, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(8287, 8287, '0', 'jp15_luckycat', 'jp15_luckycat', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8288, 8288, '0', 'habbo15_win_19', 'habbo15_win_19', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8289, 8289, '0', 'habbo15_win_16', 'habbo15_win_16', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8290, 8290, '0', 'habbo15_win_17', 'habbo15_win_17', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8291, 8291, '0', 'habbo15_win_20', 'habbo15_win_20', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8292, 8292, '0', 'habbo15_win_15', 'habbo15_win_15', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8293, 8293, '0', 'habbo15_win_22', 'habbo15_win_22', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8294, 8294, '0', 'habbo15_win_18', 'habbo15_win_18', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8295, 8295, '0', 'habbo15_win_24', 'habbo15_win_24', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8296, 8296, '0', 'habbo15_win_28', 'habbo15_win_28', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8297, 8297, '0', 'habbo15_win_21', 'habbo15_win_21', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8298, 8298, '0', 'habbo15_win_25', 'habbo15_win_25', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8299, 8299, '0', 'habbo15_win_23', 'habbo15_win_23', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8300, 8300, '0', 'habbo15_win_29', 'habbo15_win_29', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8301, 8301, '0', 'habbo15_win_26', 'habbo15_win_26', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8302, 8302, '0', 'room_pcnc15_dvd2', 'room_pcnc15_dvd2', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8303, 8303, '0', 'room_pcnc15_dvd1', 'room_pcnc15_dvd1', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8304, 8304, '0', 'room_pcnc15_hotdog', 'room_pcnc15_hotdog', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine_no_sides', 2, '81', '', '', 0, 0, ''),
	(8305, 8305, '0', 'room_pcnc15_awn', 'room_pcnc15_awn', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8306, 8306, '0', 'room_pcnc15_carrot', 'room_pcnc15_carrot', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'vendingmachine_no_sides', 2, '3', '', '', 0, 0, ''),
	(8307, 8307, '0', 'room_pcnc15_table1', 'room_pcnc15_table1', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(8308, 8308, '0', 'room_pcnc15_gzb', 'room_pcnc15_gzb', 'S', 1, 1, 0.10, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8309, 8309, '0', 'room_pcnc15_wbench', 'room_pcnc15_wbench', 'S', 1, 1, 0.90, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8310, 8310, '0', 'room_pcnc15_soda', 'room_pcnc15_soda', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine_no_sides', 2, '42,43', '', '', 0, 0, ''),
	(8311, 8311, '0', 'room_pcnc15_table3', 'room_pcnc15_table3', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8312, 8312, '0', 'room_pcnc15_table2', 'room_pcnc15_table2', 'S', 1, 1, 1.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8313, 8313, '0', 'room_pcnc15_blanket', 'room_pcnc15_blanket', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8314, 8314, '0', 'room_pcnc15_chair1', 'room_pcnc15_chair1', 'S', 1, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8315, 8315, '0', 'room_pcnc15_wood', 'room_pcnc15_wood', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8316, 8316, '0', 'room_pcnc15_bbq', 'room_pcnc15_bbq', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8317, 8317, '0', 'habbo15_win_32', 'habbo15_win_32', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8318, 8318, '0', 'habbo15_win_34', 'habbo15_win_34', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8319, 8319, '0', 'habbo15_win_30', 'habbo15_win_30', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8320, 8320, '0', 'habbo15_win_31', 'habbo15_win_31', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8321, 8321, '0', 'habbo15_win_35', 'habbo15_win_35', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8322, 8322, '0', 'habbo15_win_33', 'habbo15_win_33', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8323, 8323, '0', 'habbo15_win_27', 'habbo15_win_27', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8324, 8324, '0', 'habbo15_win_36', 'habbo15_win_36', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8325, 8325, '0', 'habbo15_win_38', 'habbo15_win_38', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8326, 8326, '0', 'habbo15_win_39', 'habbo15_win_39', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8327, 8327, '0', 'habbo15_win_41', 'habbo15_win_41', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8328, 8328, '0', 'habbo15_win_37', 'habbo15_win_37', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8329, 8329, '0', 'habbo15_win_43', 'habbo15_win_43', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8330, 8330, '0', 'habbo15_win_40', 'habbo15_win_40', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8331, 8331, '0', 'habbo15_win_42', 'habbo15_win_42', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8332, 8332, '0', 'habbo15_win_44', 'habbo15_win_44', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8333, 8333, '0', 'habbo15_win_45', 'habbo15_win_45', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8334, 8334, '0', 'clothing_knighttop', 'clothing_knighttop', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8335, 8335, '0', 'clothing_demonoutfit', 'clothing_demonoutfit', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8336, 8336, '0', 'clothing_waterhelm', 'clothing_waterhelm', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8337, 8337, '0', 'clothing_fammask', 'clothing_fammask', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8338, 8338, '0', 'clothing_demoncloak', 'clothing_demoncloak', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8339, 8339, '0', 'clothing_warmask', 'clothing_warmask', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8340, 8340, '0', 'clothing_airhelm', 'clothing_airhelm', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8341, 8341, '0', 'clothing_knightoutfit', 'clothing_knightoutfit', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8342, 8342, '0', 'clothing_firehelm', 'clothing_firehelm', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8343, 8343, '0', 'clothing_demonhood', 'clothing_demonhood', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8344, 8344, '0', 'clothing_knighttrousers', 'clothing_knighttrousers', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8345, 8345, '0', 'clothing_skullnecklace', 'clothing_skullnecklace', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8346, 8346, '0', 'clothing_earthhelm', 'clothing_earthhelm', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8347, 8347, '0', 'clothing_deathmask', 'clothing_deathmask', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8348, 8348, '0', 'clothing_pestmask', 'clothing_pestmask', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8349, 8349, '0', 'hween_c15_angel', 'hween_c15_angel', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(8350, 8350, '0', 'bonusrare16_2*1', 'bonusrare16_2*1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(8351, 8351, '0', 'bonusrare16_2*2', 'bonusrare16_2*2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(8352, 8352, '0', 'bonusrare16_2*3', 'bonusrare16_2*3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(8353, 8353, '0', 'bonusrare16_2*4', 'bonusrare16_2*4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(8354, 8354, '0', 'bonusrare16_1*1', 'bonusrare16_1*1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(8355, 8355, '0', 'bonusrare16_1*2', 'bonusrare16_1*2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8356, 8356, '0', 'bonusrare16_1*3', 'bonusrare16_1*3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8357, 8357, '0', 'bonusrare16_1*4', 'bonusrare16_1*4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8358, 8358, '0', 'bonusrare16_3*1', 'bonusrare16_3*1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(8359, 8359, '0', 'bonusrare16_3*2', 'bonusrare16_3*2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(8360, 8360, '0', 'bonusrare16_3*3', 'bonusrare16_3*3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(8361, 8361, '0', 'bonusrare16_3*4', 'bonusrare16_3*4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(8362, 8362, '0', 'hween_c15_evilcrystal2', 'hween_c15_evilcrystal2', 'S', 1, 1, 0.70, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8363, 8363, '0', 'hween_c15_purecrystal2', 'hween_c15_purecrystal2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8364, 8364, '0', 'hween_c15_stage', 'hween_c15_stage', 'S', 2, 1, 0.90, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(8365, 8365, '0', 'hween_c15_evilcrystal3', 'hween_c15_evilcrystal3', 'S', 1, 1, 0.80, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8366, 8366, '0', 'hween_c15_fog', 'hween_c15_fog', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8367, 8367, '0', 'hween_c15_stagecorner', 'hween_c15_stagecorner', 'S', 1, 1, 0.90, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8368, 8368, '0', 'hween_c15_building', 'hween_c15_building', 'S', 2, 1, 3.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(8369, 8369, '0', 'hween_c15_tele', 'hween_c15_tele', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'teleport', 2, '', '', '', 0, 0, ''),
	(8370, 8370, '0', 'hween_c15_evilcrystal1', 'hween_c15_evilcrystal1', 'S', 1, 1, 0.50, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8371, 8371, '0', 'hween_c15_dump', 'hween_c15_dump', 'S', 2, 2, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8372, 8372, '0', 'hween15_horseman3', 'hween15_horseman3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8373, 8373, '0', 'hween_c15_purecrystal3', 'hween_c15_purecrystal3', 'S', 1, 1, 0.80, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8374, 8374, '0', 'hween_c15_tree', 'hween_c15_tree', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8375, 8375, '0', 'hween15_ltdhorseman4', 'hween15_ltdhorseman4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8376, 8376, '0', 'hween_c15_shinycarpet', 'hween_c15_shinycarpet', 'S', 3, 3, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8377, 8377, '0', 'hween_c15_corner', 'hween_c15_corner', 'S', 1, 1, 3.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8378, 8378, '0', 'hween_c15_car', 'hween_c15_car', 'S', 2, 3, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 7, '', '', '', 0, 0, ''),
	(8379, 8379, '0', 'hween15_saintini', 'hween15_saintini', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8380, 8380, '0', 'hween15_evilfrank', 'hween15_evilfrank', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8381, 8381, '0', 'hween_c15_busstop', 'hween_c15_busstop', 'S', 2, 1, 1.35, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8382, 8382, '0', 'hween_c15_telewire', 'hween_c15_telewire', 'S', 1, 4, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(8383, 8383, '0', 'hween_c15_phone', 'hween_c15_phone', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8384, 8384, '0', 'hween15_evilraider', 'hween15_evilraider', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8385, 8385, '0', 'hween_c15_stairs', 'hween_c15_stairs', 'S', 2, 1, 0.70, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8386, 8386, '0', 'hween_c15_rubbish', 'hween_c15_rubbish', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8387, 8387, '0', 'hween_c15_road', 'hween_c15_road', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(8388, 8388, '0', 'hween_c15_altar', 'hween_c15_altar', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '0', '1', '0', '0', 'crafting', 2, '', '', '', 0, 0, ''),
	(8389, 8389, '0', 'hween_c15_evilcloud', 'hween_c15_evilcloud', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8390, 8390, '0', 'hween_c15_demoncat', 'hween_c15_demoncat', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8391, 8391, '0', 'hween15_ltdhorseman2', 'hween15_ltdhorseman2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8392, 8392, '0', 'hween15_horseman2', 'hween15_horseman2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8393, 8393, '0', 'hween_c15_fire', 'hween_c15_fire', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8394, 8394, '0', 'hween_c15_pavement', 'hween_c15_pavement', 'S', 2, 2, 0.10, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8395, 8395, '0', 'hween15_ltdhorseman3', 'hween15_ltdhorseman3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8396, 8396, '0', 'hween15_horseman1', 'hween15_horseman1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8397, 8397, '0', 'hween_c15_sdcrack', 'hween_c15_sdcrack', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8398, 8398, '0', 'hween_c15_sdwater', 'hween_c15_sdwater', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'water', 1, '', '', '', 185, 185, ''),
	(8399, 8399, '0', 'hween15_ltdhorseman1', 'hween15_ltdhorseman1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8400, 8400, '0', 'hween_c15_lamp', 'hween_c15_lamp', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8401, 8401, '0', 'hween15_saintta', 'hween15_saintta', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8402, 8402, '0', 'hween15_horseman4', 'hween15_horseman4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8403, 8403, '0', 'hween15_horseman5', 'hween15_horseman5', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8404, 8404, '0', 'hween_c15_purecrystal1', 'hween_c15_purecrystal1', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8405, 8405, '0', 'CF_750_evilskull', 'CF_750_evilskull', 'S', 1, 1, 0.00, '0', '0', '0', '0', '0', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8406, 8406, '0', 'hween_c15_altarbed', 'hween_c15_altarbed', 'S', 1, 3, 2.20, '0', '0', '1', '0', '1', '0', '1', '0', '0', 'crafting', 2, '', '', '', 0, 0, ''),
	(8407, 8407, '0', 'horse_dye_18', 'horse_dye_18', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8408, 8408, '0', 'fxbox_fx14', 'fxbox_fx14', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'fx_box', 2, '', '', '', 14, 14, ''),
	(8409, 8409, '0', 'hween_c15_pumpkin2', 'hween_c15_pumpkin2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8410, 8410, '0', 'hween_c15_pumpkin1', 'hween_c15_pumpkin1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8411, 8411, '1', 'ktchn_c15_chair_b', 'ktchn_c15_chair_b', 'S', 1, 1, 1.30, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8412, 8412, '1', 'ktchn_c15_divdr', 'ktchn_c15_divdr', 'S', 2, 1, 1.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(8413, 8413, '1', 'ktchn_c15_table_g', 'ktchn_c15_table_g', 'S', 2, 2, 1.25, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8414, 8414, '1', 'ktchn_c15_floor', 'ktchn_c15_floor', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8415, 8415, '0', 'ktchn_c15_bread', 'ktchn_c15_bread', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(8416, 8416, '1', 'ktchn_c15_table_b', 'ktchn_c15_table_b', 'S', 2, 2, 1.25, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8417, 8417, '0', 'ktchn_c15_chopboard', 'ktchn_c15_chopboard', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(8418, 8418, '1', 'ktchn_c15_chair_g', 'ktchn_c15_chair_g', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8419, 8419, '1', 'ktchn_c15_lamp_p', 'ktchn_c15_lamp_p', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8420, 8420, '0', 'ktchn15_coffeemaker', 'ktchn15_coffeemaker', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '41,53', '', '', 0, 0, ''),
	(8421, 8421, '0', 'ktchn_c15_cereal', 'ktchn_c15_cereal', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(8422, 8422, '1', 'ktchn_c15_lamp_b', 'ktchn_c15_lamp_b', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8423, 8423, '1', 'ktchn_c15_sink', 'ktchn_c15_sink', 'S', 2, 1, 1.20, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 9, '', '', '', 0, 0, ''),
	(8424, 8424, '1', 'ktchn_c15_chair_p', 'ktchn_c15_chair_p', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8425, 8425, '1', 'ktchn_c15_lamp_g', 'ktchn_c15_lamp_g', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8426, 8426, '1', 'ktchn_c15_crn', 'ktchn_c15_crn', 'S', 1, 1, 1.10, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(8427, 8427, '0', 'ktchn15_cabinet', 'ktchn15_cabinet', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(8428, 8428, '0', 'ktchn_c15_tele', 'ktchn_c15_tele', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'teleport', 2, '', '', '', 0, 0, ''),
	(8429, 8429, '1', 'ktchn_c15_dishwasher', 'ktchn_c15_dishwasher', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(8430, 8430, '1', 'ktchn_c15_table_p', 'ktchn_c15_table_p', 'S', 2, 2, 1.25, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8431, 8431, '1', 'ktchn_c15_stove', 'ktchn_c15_stove', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 8, '', '', '', 0, 0, ''),
	(8432, 8432, '0', 'ktchn15_bubblejuicerack', 'ktchn15_bubblejuicerack', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '24,29,50,74,101', '', '', 0, 0, ''),
	(8433, 8433, '1', 'ktchn_c15_gate', 'ktchn_c15_gate', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(8434, 8434, '0', 'ktchn15_fridge', 'ktchn15_fridge', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '3,36,37,38,39', '', '', 0, 0, ''),
	(8435, 8435, '0', 'ktchn_c15_food', 'ktchn_c15_food', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(8436, 8436, '0', 'ktchn_c15_microwave', 'ktchn_c15_microwave', 'S', 1, 1, 0.70, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 8, '', '', '', 0, 0, ''),
	(8437, 8437, '1', 'ktchn_c15_drinks', 'ktchn_c15_drinks', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(8438, 8438, '0', 'habbo15_pumpkin1', 'habbo15_pumpkin1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(8439, 8439, '0', 'habbo15_pumpkin2', 'habbo15_pumpkin2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(8440, 8440, '0', 'xmas_c15_bushy1', 'xmas_c15_bushy1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8441, 8441, '0', 'gold_c15_arc_div2', 'gold_c15_arc_div2', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8442, 8442, '0', 'gold_c15_arc_seat', 'gold_c15_arc_seat', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8443, 8443, '0', 'gold_c15_arc_icerug', 'gold_c15_arc_icerug', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(8444, 8444, '0', 'gold_c15_arc_statue', 'gold_c15_arc_statue', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8445, 8445, '0', 'gold_c15_arc_div1', 'gold_c15_arc_div1', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8446, 8446, '0', 'gold_c15_arc_lantern', 'gold_c15_arc_lantern', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8447, 8447, '0', 'gold_c15_arc_lamp', 'gold_c15_arc_lamp', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8448, 8448, '0', 'gold_c15_arc_camp', 'gold_c15_arc_camp', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8449, 8449, '0', 'gold_c15_arc_tub', 'gold_c15_arc_tub', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8450, 8450, '0', 'gold_c15_arc_chair', 'gold_c15_arc_chair', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8451, 8451, '0', 'gold_rare_crackable', 'gold_rare_crackable', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(8452, 8452, '0', 'gold_c15_arc_tree1', 'gold_c15_arc_tree1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8453, 8453, '0', 'gold_c15_arc_table', 'gold_c15_arc_table', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8454, 8454, '0', 'gold_c15_arc_geysir', 'gold_c15_arc_geysir', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8455, 8455, '0', 'gold_c15_arc_tele', 'gold_c15_arc_tele', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'teleport', 1, '', '', '', 0, 0, ''),
	(8456, 8456, '0', 'gold_c15_arc_hole', 'gold_c15_arc_hole', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine_no_sides', 2, '34', '', '', 0, 0, ''),
	(8457, 8457, '0', 'gold_c15_arc_snow', 'gold_c15_arc_snow', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8458, 8458, '0', 'gold_c15_arc_tree2', 'gold_c15_arc_tree2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8459, 8459, '0', 'xmas15_nutcrackerltd', 'xmas15_nutcrackerltd', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'vendingmachine', 2, '60', '', '', 0, 0, ''),
	(8460, 8460, '0', 'xmas_c15_advent6', 'xmas_c15_advent6', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8461, 8461, '0', 'xmas_c15_bushy5', 'xmas_c15_bushy5', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8462, 8462, '0', 'clothing_santapants', 'clothing_santapants', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8463, 8463, '0', 'xmas_c15_store1', 'xmas_c15_store1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '1026,1053,1065,1066,1067', '', '', 0, 0, ''),
	(8464, 8464, '0', 'clothing_bscarf', 'clothing_bscarf', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8465, 8465, '0', 'xmas_c15_roof1', 'xmas_c15_roof1', 'S', 1, 3, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 6, '', '', '', 0, 0, ''),
	(8466, 8466, '0', 'winter15_freeze', 'winter15_freeze', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8467, 8467, '0', 'xmas_c15_fnc', 'xmas_c15_fnc', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8468, 8468, '0', 'winter15_wpost', 'winter15_wpost', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8469, 8469, '0', 'winter15_icehockey', 'winter15_icehockey', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8470, 8470, '0', 'xmas_c15_buildbase2', 'xmas_c15_buildbase2', 'S', 1, 3, 3.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(8471, 8471, '0', 'xmas_c15_bushy3', 'xmas_c15_bushy3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8472, 8472, '0', 'xmas_c15_store4', 'xmas_c15_store4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '84', '', '', 0, 0, ''),
	(8473, 8473, '0', 'clothing_xmasbow', 'clothing_xmasbow', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8474, 8474, '0', 'xmas_c15_advent5', 'xmas_c15_advent5', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8475, 8475, '0', 'xmas_c15_poinsettia', 'xmas_c15_poinsettia', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8476, 8476, '0', 'xmas_c15_buildbase1', 'xmas_c15_buildbase1', 'S', 1, 3, 3.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(8477, 8477, '0', 'xmas_c15_crnr', 'xmas_c15_crnr', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8478, 8478, '0', 'xmas15_clocktower', 'xmas15_clocktower', 'S', 2, 2, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(8479, 8479, '0', 'clothing_santaoutfit', 'clothing_santaoutfit', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8480, 8480, '0', 'clothing_cladyoutfit', 'clothing_cladyoutfit', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8481, 8481, '0', 'xmas_c15_store2', 'xmas_c15_store2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '48,67,68,69,92,93,94,95', '', '', 0, 0, ''),
	(8482, 8482, '0', 'xmas_c15_stall', 'xmas_c15_stall', 'S', 2, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(8483, 8483, '0', 'xmas_c15_snow', 'xmas_c15_snow', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8484, 8484, '0', 'xmas_c15_bndstnd', 'xmas_c15_bndstnd', 'S', 3, 3, 0.40, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(8485, 8485, '0', 'xmas15_rudolf', 'xmas15_rudolf', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8486, 8486, '0', 'xmas_c15_roof2', 'xmas_c15_roof2', 'S', 1, 3, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 6, '', '', '', 0, 0, ''),
	(8487, 8487, '0', 'clothing_cladydress', 'clothing_cladydress', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8488, 8488, '0', 'xmas_c15_advent2', 'xmas_c15_advent2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8489, 8489, '0', 'winter15_tree4', 'winter15_tree4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8490, 8490, '0', 'xmas_c15_bushy2', 'xmas_c15_bushy2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8491, 8491, '0', 'xmas15_wishltd', 'xmas15_wishltd', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8492, 8492, '0', 'xmas_c15_advent8', 'xmas_c15_advent8', 'S', 1, 1, 1.20, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8493, 8493, '0', 'clothing_cladyhair', 'clothing_cladyhair', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8494, 8494, '0', 'xmas15_glowdeerltd', 'xmas15_glowdeerltd', 'S', 1, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(8495, 8495, '0', 'clothing_santatop', 'clothing_santatop', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8496, 8496, '0', 'clothing_ribbon', 'clothing_ribbon', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8497, 8497, '0', 'xmas_c15_advent3', 'xmas_c15_advent3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8498, 8498, '0', 'clothing_santahat', 'clothing_santahat', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8499, 8499, '0', 'xmas_c15_reindeer', 'xmas_c15_reindeer', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8500, 8500, '0', 'xmas15_fountainltd', 'xmas15_fountainltd', 'S', 3, 3, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8501, 8501, '0', 'clothing_snood', 'clothing_snood', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8502, 8502, '0', 'xmas_c15_store3', 'xmas_c15_store3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine_no_sides', 2, '81,44', '', '', 0, 0, ''),
	(8503, 8503, '0', 'xmas_c15_advent1', 'xmas_c15_advent1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8504, 8504, '0', 'xmas_c15_arch', 'xmas_c15_arch', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8505, 8505, '0', 'winter15_fnc_crnr', 'winter15_fnc_crnr', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8506, 8506, '0', 'xmas_c15_advent4', 'xmas_c15_advent4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8507, 8507, '0', 'clothing_cladyshoes', 'clothing_cladyshoes', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8508, 8508, '0', 'winter15_snowboard', 'winter15_snowboard', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8509, 8509, '0', 'clothing_santabeard', 'clothing_santabeard', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8510, 8510, '0', 'xmas_c15_mntn', 'xmas_c15_mntn', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8511, 8511, '0', 'xmas15_stand', 'xmas15_stand', 'S', 2, 1, 0.30, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8512, 8512, '0', 'xmas_c15_buildmid2', 'xmas_c15_buildmid2', 'S', 1, 3, 3.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8513, 8513, '0', 'xmas_c15_bushy6', 'xmas_c15_bushy6', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8514, 8514, '0', 'xmas_c15_snwbush', 'xmas_c15_snwbush', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8515, 8515, '0', 'xmas15_sleigh', 'xmas15_sleigh', 'S', 1, 2, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8516, 8516, '0', 'winter15_iceskater', 'winter15_iceskater', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8517, 8517, '0', 'xmas_c15_alpinetree', 'xmas_c15_alpinetree', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8518, 8518, '0', 'clothing_knitband', 'clothing_knitband', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8519, 8519, '0', 'xmas_c15_decotree', 'xmas_c15_decotree', 'S', 2, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 7, '', '', '', 0, 0, ''),
	(8520, 8520, '0', 'xmas_c15_stone', 'xmas_c15_stone', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8521, 8521, '0', 'xmas_c15_bushy4', 'xmas_c15_bushy4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8522, 8522, '0', 'winter15_lmppst', 'winter15_lmppst', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8523, 8523, '0', 'xmas_c15_advent7', 'xmas_c15_advent7', 'S', 1, 1, 1.20, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8524, 8524, '1', 'xmas_c15_mlight', 'xmas_c15_mlight', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8525, 8525, '0', 'xmas_c15_buildmid1', 'xmas_c15_buildmid1', 'S', 1, 3, 3.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8526, 8526, '0', 'clothing_knithat', 'clothing_knithat', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8527, 8527, '0', 'hc16_10', 'hc16_10', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(8528, 8528, '0', 'hc16_1', 'hc16_1', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8529, 8529, '0', 'hc16_4', 'hc16_4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(8530, 8530, '0', 'hc16_12', 'hc16_12', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(8531, 8531, '0', 'hc16_11', 'hc16_11', 'S', 1, 3, 1.50, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 2, '', '', '', 0, 0, ''),
	(8532, 8532, '0', 'hc16_5', 'hc16_5', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8533, 8533, '0', 'hc16_9', 'hc16_9', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(8534, 8534, '0', 'hc16_7', 'hc16_7', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8535, 8535, '0', 'hc16_2', 'hc16_2', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8536, 8536, '0', 'hc16_6', 'hc16_6', 'S', 3, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8537, 8537, '0', 'hc16_3', 'hc16_3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '50', '', '', 0, 0, ''),
	(8538, 8538, '0', 'hc16_8', 'hc16_8', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8539, 8539, '0', 'ny16_stars', 'ny16_stars', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8540, 8540, '0', 'clothing_party5', 'clothing_party5', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8541, 8541, '0', 'clothing_party4', 'clothing_party4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8542, 8542, '0', 'clothing_party8', 'clothing_party8', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8543, 8543, '0', 'clothing_party6', 'clothing_party6', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8544, 8544, '0', 'ny_c16_sign', 'ny_c16_sign', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8545, 8545, '0', 'clothing_party3', 'clothing_party3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8546, 8546, '0', 'clothing_party7', 'clothing_party7', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8547, 8547, '0', 'cny16_monkeyballoon', 'cny16_monkeyballoon', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8548, 8548, '0', 'ny16_crackable', 'ny16_crackable', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(8549, 8549, '0', 'clothing_goldpack1', 'clothing_goldpack1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8550, 8550, '0', 'china_monkey', 'china_monkey', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8551, 8551, '0', 'CF_1200_ny16', 'CF_1200_ny16', 'S', 1, 1, 0.00, '0', '0', '0', '0', '0', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8552, 8552, '0', 'tile_fxprovider_nfs', 'tile_fxprovider_nfs', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '1', '1', 'tile_fxprovider_nfs', 2, '', '', '', 0, 0, ''),
	(8553, 8553, '0', 'clothing_hat_space1', 'clothing_hat_space1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8554, 8554, '0', 'rare_prize16*1', 'rare_prize16*1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8555, 8555, '0', 'rare_prize16*10', 'rare_prize16*10', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8556, 8556, '0', 'rare_prize16*11', 'rare_prize16*11', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8557, 8557, '0', 'rare_prize16*12', 'rare_prize16*12', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8558, 8558, '0', 'rare_prize16*13', 'rare_prize16*13', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8559, 8559, '0', 'rare_prize16*14', 'rare_prize16*14', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8560, 8560, '0', 'rare_prize16*2', 'rare_prize16*2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8561, 8561, '0', 'rare_prize16*3', 'rare_prize16*3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8562, 8562, '0', 'rare_prize16*4', 'rare_prize16*4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8563, 8563, '0', 'rare_prize16*5', 'rare_prize16*5', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8564, 8564, '0', 'rare_prize16*6', 'rare_prize16*6', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8565, 8565, '0', 'rare_prize16*7', 'rare_prize16*7', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8566, 8566, '0', 'rare_prize16*8', 'rare_prize16*8', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8567, 8567, '0', 'rare_prize16*9', 'rare_prize16*9', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8568, 8568, '0', 'val16_float2', 'val16_float2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8569, 8569, '0', 'val_c16_lovebirds', 'val_c16_lovebirds', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8570, 8570, '0', 'val_c16_tikicat', 'val_c16_tikicat', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8571, 8571, '0', 'val_c16_tikicat2', 'val_c16_tikicat2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8572, 8572, '0', 'val16_float3', 'val16_float3', 'S', 1, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8573, 8573, '0', 'val_c16_shellfountain', 'val_c16_shellfountain', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8574, 8574, '0', 'val16_float1', 'val16_float1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8575, 8575, '0', 'val16_float4', 'val16_float4', 'S', 1, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8576, 8576, '0', 'val_c16_vase', 'val_c16_vase', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(8577, 8577, '0', 'easter16_habberge6ltd', 'easter16_habberge6ltd', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8578, 8578, '0', 'clothing_pjtop3', 'clothing_pjtop3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8579, 8579, '0', 'clothing_sportpants', 'clothing_sportpants', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8580, 8580, '0', 'clothing_urbanoutfit', 'clothing_urbanoutfit', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8581, 8581, '0', 'clothing_tiedjumper', 'clothing_tiedjumper', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8582, 8582, '0', 'clothing_cumberband', 'clothing_cumberband', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8583, 8583, '0', 'clothing_casualoutfit1', 'clothing_casualoutfit1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8584, 8584, '0', 'clothing_manbun', 'clothing_manbun', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8585, 8585, '0', 'clothing_denimvest', 'clothing_denimvest', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8586, 8586, '0', 'clothing_pjbottoms1', 'clothing_pjbottoms1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8587, 8587, '0', 'clothing_pjtop1', 'clothing_pjtop1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8588, 8588, '0', 'clothing_hipsterglasses', 'clothing_hipsterglasses', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8589, 8589, '0', 'clothing_tux', 'clothing_tux', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8590, 8590, '0', 'clothing_tie1', 'clothing_tie1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8591, 8591, '0', 'clothing_bandage', 'clothing_bandage', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8592, 8592, '0', 'clothing_denimshorts', 'clothing_denimshorts', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8593, 8593, '0', 'clothing_brainjar', 'clothing_brainjar', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8594, 8594, '0', 'easter_c16_mallowduck', 'easter_c16_mallowduck', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8595, 8595, '0', 'clothing_floraloutfit', 'clothing_floraloutfit', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8596, 8596, '0', 'easter16_habberge9ltd', 'easter16_habberge9ltd', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8597, 8597, '0', 'clothing_duckhat', 'clothing_duckhat', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8598, 8598, '0', 'clothing_punkoutfit2', 'clothing_punkoutfit2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8599, 8599, '0', 'clothing_tuxshirt', 'clothing_tuxshirt', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8600, 8600, '0', 'clothing_pjoutfit1', 'clothing_pjoutfit1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8601, 8601, '0', 'clothing_hipoutfit3', 'clothing_hipoutfit3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8602, 8602, '0', 'clothing_sliponcanvas', 'clothing_sliponcanvas', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8603, 8603, '0', 'clothing_punkoutfit1', 'clothing_punkoutfit1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8604, 8604, '0', 'clothing_backcap', 'clothing_backcap', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8605, 8605, '0', 'clothing_mermaid', 'clothing_mermaid', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8606, 8606, '0', 'clothing_jacket_twotone', 'clothing_jacket_twotone', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8607, 8607, '0', 'clothing_hipster2', 'clothing_hipster2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8608, 8608, '0', 'easter16_habberge8ltd', 'easter16_habberge8ltd', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8609, 8609, '0', 'clothing_disco', 'clothing_disco', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8610, 8610, '0', 'clothing_longtshirt', 'clothing_longtshirt', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8611, 8611, '0', 'clothing_sportsjckt', 'clothing_sportsjckt', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8612, 8612, '0', 'clothing_polkadress', 'clothing_polkadress', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8613, 8613, '0', 'clothing_tuxoutfit', 'clothing_tuxoutfit', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8614, 8614, '0', 'clothing_rippedtop', 'clothing_rippedtop', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8615, 8615, '0', 'easter16_habberge7ltd', 'easter16_habberge7ltd', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8616, 8616, '0', 'clothing_hipoutfit1', 'clothing_hipoutfit1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8617, 8617, '0', 'clothing_hipoutfit2', 'clothing_hipoutfit2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8618, 8618, '0', 'clothing_camera', 'clothing_camera', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8619, 8619, '0', 'clothing_bedhair', 'clothing_bedhair', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8620, 8620, '0', 'clothing_halter', 'clothing_halter', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8621, 8621, '0', 'clothing_pjoutfit2', 'clothing_pjoutfit2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8622, 8622, '0', 'clothing_pjtop2', 'clothing_pjtop2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8623, 8623, '0', 'clothing_pjoutfit3', 'clothing_pjoutfit3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8624, 8624, '0', 'clothing_offshldrjumper', 'clothing_offshldrjumper', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8625, 8625, '0', 'clothing_bigshades', 'clothing_bigshades', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8626, 8626, '0', 'clothing_noblecrown', 'clothing_noblecrown', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8627, 8627, '0', 'clothing_ombrehr', 'clothing_ombrehr', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8628, 8628, '0', 'bonusrare16_4*1', 'bonusrare16_4*1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8629, 8629, '0', 'bonusrare16_4*2', 'bonusrare16_4*2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8630, 8630, '0', 'bonusrare16_4*3', 'bonusrare16_4*3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8631, 8631, '0', 'bonusrare16_4*4', 'bonusrare16_4*4', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8632, 8632, '1', 'icedblk_c16_table', 'icedblk_c16_table', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8633, 8633, '1', 'icedblk_c16_table*10', 'icedblk_c16_table*10', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8634, 8634, '1', 'icedblk_c16_table*2', 'icedblk_c16_table*2', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8635, 8635, '1', 'icedblk_c16_table*3', 'icedblk_c16_table*3', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8636, 8636, '1', 'icedblk_c16_table*4', 'icedblk_c16_table*4', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8637, 8637, '1', 'icedblk_c16_table*5', 'icedblk_c16_table*5', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8638, 8638, '1', 'icedblk_c16_table*6', 'icedblk_c16_table*6', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8639, 8639, '1', 'icedblk_c16_table*7', 'icedblk_c16_table*7', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8640, 8640, '1', 'icedblk_c16_table*8', 'icedblk_c16_table*8', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8641, 8641, '1', 'icedblk_c16_table*9', 'icedblk_c16_table*9', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8642, 8642, '1', 'icedblk_c16_div4', 'icedblk_c16_div4', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(8643, 8643, '1', 'icedblk_c16_div4*10', 'icedblk_c16_div4*10', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(8644, 8644, '1', 'icedblk_c16_div4*2', 'icedblk_c16_div4*2', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(8645, 8645, '1', 'icedblk_c16_div4*3', 'icedblk_c16_div4*3', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(8646, 8646, '1', 'icedblk_c16_div4*4', 'icedblk_c16_div4*4', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(8647, 8647, '1', 'icedblk_c16_div4*5', 'icedblk_c16_div4*5', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(8648, 8648, '1', 'icedblk_c16_div4*6', 'icedblk_c16_div4*6', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(8649, 8649, '1', 'icedblk_c16_div4*7', 'icedblk_c16_div4*7', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(8650, 8650, '1', 'icedblk_c16_div4*8', 'icedblk_c16_div4*8', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(8651, 8651, '1', 'icedblk_c16_div4*9', 'icedblk_c16_div4*9', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(8652, 8652, '1', 'icedblk_c16_div2', 'icedblk_c16_div2', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8653, 8653, '1', 'icedblk_c16_div2*10', 'icedblk_c16_div2*10', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8654, 8654, '1', 'icedblk_c16_div2*2', 'icedblk_c16_div2*2', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8655, 8655, '1', 'icedblk_c16_div2*3', 'icedblk_c16_div2*3', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8656, 8656, '1', 'icedblk_c16_div2*4', 'icedblk_c16_div2*4', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8657, 8657, '1', 'icedblk_c16_div2*5', 'icedblk_c16_div2*5', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8658, 8658, '1', 'icedblk_c16_div2*6', 'icedblk_c16_div2*6', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8659, 8659, '1', 'icedblk_c16_div2*7', 'icedblk_c16_div2*7', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8660, 8660, '1', 'icedblk_c16_div2*8', 'icedblk_c16_div2*8', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8661, 8661, '1', 'icedblk_c16_div2*9', 'icedblk_c16_div2*9', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8662, 8662, '1', 'icedblk_c16_couch', 'icedblk_c16_couch', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8663, 8663, '1', 'icedblk_c16_couch*10', 'icedblk_c16_couch*10', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8664, 8664, '1', 'icedblk_c16_couch*2', 'icedblk_c16_couch*2', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8665, 8665, '1', 'icedblk_c16_couch*3', 'icedblk_c16_couch*3', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8666, 8666, '1', 'icedblk_c16_couch*4', 'icedblk_c16_couch*4', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8667, 8667, '1', 'icedblk_c16_couch*5', 'icedblk_c16_couch*5', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8668, 8668, '1', 'icedblk_c16_couch*6', 'icedblk_c16_couch*6', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8669, 8669, '1', 'icedblk_c16_couch*7', 'icedblk_c16_couch*7', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8670, 8670, '1', 'icedblk_c16_couch*8', 'icedblk_c16_couch*8', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8671, 8671, '1', 'icedblk_c16_couch*9', 'icedblk_c16_couch*9', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8672, 8672, '1', 'icedblk_c16_div3', 'icedblk_c16_div3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(8673, 8673, '1', 'icedblk_c16_div3*10', 'icedblk_c16_div3*10', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(8674, 8674, '1', 'icedblk_c16_div3*2', 'icedblk_c16_div3*2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(8675, 8675, '1', 'icedblk_c16_div3*3', 'icedblk_c16_div3*3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(8676, 8676, '1', 'icedblk_c16_div3*4', 'icedblk_c16_div3*4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(8677, 8677, '1', 'icedblk_c16_div3*5', 'icedblk_c16_div3*5', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(8678, 8678, '1', 'icedblk_c16_div3*6', 'icedblk_c16_div3*6', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(8679, 8679, '1', 'icedblk_c16_div3*7', 'icedblk_c16_div3*7', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(8680, 8680, '1', 'icedblk_c16_div3*8', 'icedblk_c16_div3*8', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(8681, 8681, '1', 'icedblk_c16_div3*9', 'icedblk_c16_div3*9', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(8682, 8682, '1', 'icedblk_c16_solarium', 'icedblk_c16_solarium', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8683, 8683, '1', 'icedblk_c16_solarium*10', 'icedblk_c16_solarium*10', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8684, 8684, '1', 'icedblk_c16_solarium*2', 'icedblk_c16_solarium*2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8685, 8685, '1', 'icedblk_c16_solarium*3', 'icedblk_c16_solarium*3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8686, 8686, '1', 'icedblk_c16_solarium*4', 'icedblk_c16_solarium*4', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8687, 8687, '1', 'icedblk_c16_solarium*5', 'icedblk_c16_solarium*5', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8688, 8688, '1', 'icedblk_c16_solarium*6', 'icedblk_c16_solarium*6', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8689, 8689, '1', 'icedblk_c16_solarium*7', 'icedblk_c16_solarium*7', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8690, 8690, '1', 'icedblk_c16_solarium*8', 'icedblk_c16_solarium*8', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8691, 8691, '1', 'icedblk_c16_solarium*9', 'icedblk_c16_solarium*9', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8692, 8692, '1', 'icedblk_c16_shelves', 'icedblk_c16_shelves', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8693, 8693, '1', 'icedblk_c16_shelves*10', 'icedblk_c16_shelves*10', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8694, 8694, '1', 'icedblk_c16_shelves*2', 'icedblk_c16_shelves*2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8695, 8695, '1', 'icedblk_c16_shelves*3', 'icedblk_c16_shelves*3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8696, 8696, '1', 'icedblk_c16_shelves*4', 'icedblk_c16_shelves*4', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8697, 8697, '1', 'icedblk_c16_shelves*5', 'icedblk_c16_shelves*5', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8698, 8698, '1', 'icedblk_c16_shelves*6', 'icedblk_c16_shelves*6', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8699, 8699, '1', 'icedblk_c16_shelves*7', 'icedblk_c16_shelves*7', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8700, 8700, '1', 'icedblk_c16_shelves*8', 'icedblk_c16_shelves*8', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8701, 8701, '1', 'icedblk_c16_shelves*9', 'icedblk_c16_shelves*9', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8702, 8702, '1', 'icedblk_c16_sofachair', 'icedblk_c16_sofachair', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8703, 8703, '1', 'icedblk_c16_sofachair*10', 'icedblk_c16_sofachair*10', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8704, 8704, '1', 'icedblk_c16_sofachair*2', 'icedblk_c16_sofachair*2', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8705, 8705, '1', 'icedblk_c16_sofachair*3', 'icedblk_c16_sofachair*3', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8706, 8706, '1', 'icedblk_c16_sofachair*4', 'icedblk_c16_sofachair*4', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8707, 8707, '1', 'icedblk_c16_sofachair*5', 'icedblk_c16_sofachair*5', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8708, 8708, '1', 'icedblk_c16_sofachair*6', 'icedblk_c16_sofachair*6', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8709, 8709, '1', 'icedblk_c16_sofachair*7', 'icedblk_c16_sofachair*7', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8710, 8710, '1', 'icedblk_c16_sofachair*8', 'icedblk_c16_sofachair*8', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8711, 8711, '1', 'icedblk_c16_sofachair*9', 'icedblk_c16_sofachair*9', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8712, 8712, '1', 'icedblk_c16_div1', 'icedblk_c16_div1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8713, 8713, '1', 'icedblk_c16_div1*10', 'icedblk_c16_div1*10', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8714, 8714, '1', 'icedblk_c16_div1*2', 'icedblk_c16_div1*2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8715, 8715, '1', 'icedblk_c16_div1*3', 'icedblk_c16_div1*3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8716, 8716, '1', 'icedblk_c16_div1*4', 'icedblk_c16_div1*4', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8717, 8717, '1', 'icedblk_c16_div1*5', 'icedblk_c16_div1*5', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8718, 8718, '1', 'icedblk_c16_div1*6', 'icedblk_c16_div1*6', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8719, 8719, '1', 'icedblk_c16_div1*7', 'icedblk_c16_div1*7', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8720, 8720, '1', 'icedblk_c16_div1*8', 'icedblk_c16_div1*8', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8721, 8721, '1', 'icedblk_c16_div1*9', 'icedblk_c16_div1*9', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8722, 8722, '1', 'icedblk_c16_sofa', 'icedblk_c16_sofa', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8723, 8723, '1', 'icedblk_c16_sofa*10', 'icedblk_c16_sofa*10', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8724, 8724, '1', 'icedblk_c16_sofa*2', 'icedblk_c16_sofa*2', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8725, 8725, '1', 'icedblk_c16_sofa*3', 'icedblk_c16_sofa*3', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8726, 8726, '1', 'icedblk_c16_sofa*4', 'icedblk_c16_sofa*4', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8727, 8727, '1', 'icedblk_c16_sofa*5', 'icedblk_c16_sofa*5', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8728, 8728, '1', 'icedblk_c16_sofa*6', 'icedblk_c16_sofa*6', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8729, 8729, '1', 'icedblk_c16_sofa*7', 'icedblk_c16_sofa*7', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8730, 8730, '1', 'icedblk_c16_sofa*8', 'icedblk_c16_sofa*8', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8731, 8731, '1', 'icedblk_c16_sofa*9', 'icedblk_c16_sofa*9', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8732, 8732, '1', 'icedblk_c16_chair', 'icedblk_c16_chair', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8733, 8733, '1', 'icedblk_c16_chair*10', 'icedblk_c16_chair*10', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8734, 8734, '1', 'icedblk_c16_chair*2', 'icedblk_c16_chair*2', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8735, 8735, '1', 'icedblk_c16_chair*3', 'icedblk_c16_chair*3', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8736, 8736, '1', 'icedblk_c16_chair*4', 'icedblk_c16_chair*4', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8737, 8737, '1', 'icedblk_c16_chair*5', 'icedblk_c16_chair*5', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8738, 8738, '1', 'icedblk_c16_chair*6', 'icedblk_c16_chair*6', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8739, 8739, '1', 'icedblk_c16_chair*7', 'icedblk_c16_chair*7', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8740, 8740, '1', 'icedblk_c16_chair*8', 'icedblk_c16_chair*8', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8741, 8741, '1', 'icedblk_c16_chair*9', 'icedblk_c16_chair*9', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8742, 8742, '1', 'icedblk_c16_div5', 'icedblk_c16_div5', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8743, 8743, '1', 'icedblk_c16_div5*10', 'icedblk_c16_div5*10', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8744, 8744, '1', 'icedblk_c16_div5*2', 'icedblk_c16_div5*2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8745, 8745, '1', 'icedblk_c16_div5*3', 'icedblk_c16_div5*3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8746, 8746, '1', 'icedblk_c16_div5*4', 'icedblk_c16_div5*4', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8747, 8747, '1', 'icedblk_c16_div5*5', 'icedblk_c16_div5*5', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8748, 8748, '1', 'icedblk_c16_div5*6', 'icedblk_c16_div5*6', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8749, 8749, '1', 'icedblk_c16_div5*7', 'icedblk_c16_div5*7', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8750, 8750, '1', 'icedblk_c16_div5*8', 'icedblk_c16_div5*8', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8751, 8751, '1', 'icedblk_c16_div5*9', 'icedblk_c16_div5*9', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8752, 8752, '1', 'purablk_c16_shelve', 'purablk_c16_shelve', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8753, 8753, '1', 'purablk_c16_eleblock*1', 'purablk_c16_eleblock*1', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '0;0.5;1;1.5;2', '', 0, 0, ''),
	(8754, 8754, '1', 'purablk_c16_eleblock*10', 'purablk_c16_eleblock*10', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '0;0.5;1;1.5;2', '', 0, 0, ''),
	(8755, 8755, '1', 'purablk_c16_eleblock*2', 'purablk_c16_eleblock*2', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '0;0.5;1;1.5;2', '', 0, 0, ''),
	(8756, 8756, '1', 'purablk_c16_eleblock*3', 'purablk_c16_eleblock*3', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '0;0.5;1;1.5;2', '', 0, 0, ''),
	(8757, 8757, '1', 'purablk_c16_eleblock*4', 'purablk_c16_eleblock*4', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '0;0.5;1;1.5;2', '', 0, 0, ''),
	(8758, 8758, '1', 'purablk_c16_eleblock*5', 'purablk_c16_eleblock*5', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '0;0.5;1;1.5;2', '', 0, 0, ''),
	(8759, 8759, '1', 'purablk_c16_eleblock*6', 'purablk_c16_eleblock*6', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '0;0.5;1;1.5;2', '', 0, 0, ''),
	(8760, 8760, '1', 'purablk_c16_eleblock*7', 'purablk_c16_eleblock*7', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '0;0.5;1;1.5;2', '', 0, 0, ''),
	(8761, 8761, '1', 'purablk_c16_eleblock*8', 'purablk_c16_eleblock*8', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '0;0.5;1;1.5;2', '', 0, 0, ''),
	(8762, 8762, '1', 'purablk_c16_eleblock*9', 'purablk_c16_eleblock*9', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '0;0.5;1;1.5;2', '', 0, 0, ''),
	(8763, 8763, '1', 'purablk_c16_round*1', 'purablk_c16_round*1', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8764, 8764, '1', 'purablk_c16_round*10', 'purablk_c16_round*10', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8765, 8765, '1', 'purablk_c16_round*2', 'purablk_c16_round*2', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8766, 8766, '1', 'purablk_c16_round*3', 'purablk_c16_round*3', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8767, 8767, '1', 'purablk_c16_round*4', 'purablk_c16_round*4', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8768, 8768, '1', 'purablk_c16_round*5', 'purablk_c16_round*5', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8769, 8769, '1', 'purablk_c16_round*6', 'purablk_c16_round*6', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8770, 8770, '1', 'purablk_c16_round*7', 'purablk_c16_round*7', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8771, 8771, '1', 'purablk_c16_round*8', 'purablk_c16_round*8', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8772, 8772, '1', 'purablk_c16_round*9', 'purablk_c16_round*9', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8773, 8773, '1', 'purablk_c16_lamp1', 'purablk_c16_lamp1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8774, 8774, '1', 'purablk_c16_chair*1', 'purablk_c16_chair*1', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8775, 8775, '1', 'purablk_c16_chair*10', 'purablk_c16_chair*10', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8776, 8776, '1', 'purablk_c16_chair*2', 'purablk_c16_chair*2', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8777, 8777, '1', 'purablk_c16_chair*3', 'purablk_c16_chair*3', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8778, 8778, '1', 'purablk_c16_chair*4', 'purablk_c16_chair*4', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8779, 8779, '1', 'purablk_c16_chair*5', 'purablk_c16_chair*5', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8780, 8780, '1', 'purablk_c16_chair*6', 'purablk_c16_chair*6', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8781, 8781, '1', 'purablk_c16_chair*7', 'purablk_c16_chair*7', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8782, 8782, '1', 'purablk_c16_chair*8', 'purablk_c16_chair*8', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8783, 8783, '1', 'purablk_c16_chair*9', 'purablk_c16_chair*9', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8784, 8784, '0', 'purablk_c16_lamp3', 'purablk_c16_lamp3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8785, 8785, '1', 'purablk_c16_bed*1', 'purablk_c16_bed*1', 'S', 2, 1, 1.50, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(8786, 8786, '1', 'purablk_c16_bed*10', 'purablk_c16_bed*10', 'S', 2, 1, 1.50, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(8787, 8787, '1', 'purablk_c16_bed*2', 'purablk_c16_bed*2', 'S', 2, 1, 1.50, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(8788, 8788, '1', 'purablk_c16_bed*3', 'purablk_c16_bed*3', 'S', 2, 1, 1.50, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(8789, 8789, '1', 'purablk_c16_bed*4', 'purablk_c16_bed*4', 'S', 2, 1, 1.50, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(8790, 8790, '1', 'purablk_c16_bed*5', 'purablk_c16_bed*5', 'S', 2, 1, 1.50, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(8791, 8791, '1', 'purablk_c16_bed*6', 'purablk_c16_bed*6', 'S', 2, 1, 1.50, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(8792, 8792, '1', 'purablk_c16_bed*7', 'purablk_c16_bed*7', 'S', 2, 1, 1.50, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(8793, 8793, '1', 'purablk_c16_bed*8', 'purablk_c16_bed*8', 'S', 2, 1, 1.50, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(8794, 8794, '1', 'purablk_c16_bed*9', 'purablk_c16_bed*9', 'S', 2, 1, 1.50, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(8795, 8795, '1', 'purablk_c16_mdl3*1', 'purablk_c16_mdl3*1', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8796, 8796, '1', 'purablk_c16_mdl3*10', 'purablk_c16_mdl3*10', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8797, 8797, '1', 'purablk_c16_mdl3*2', 'purablk_c16_mdl3*2', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8798, 8798, '1', 'purablk_c16_mdl3*3', 'purablk_c16_mdl3*3', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8799, 8799, '1', 'purablk_c16_mdl3*4', 'purablk_c16_mdl3*4', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8800, 8800, '1', 'purablk_c16_mdl3*5', 'purablk_c16_mdl3*5', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8801, 8801, '1', 'purablk_c16_mdl3*6', 'purablk_c16_mdl3*6', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8802, 8802, '1', 'purablk_c16_mdl3*7', 'purablk_c16_mdl3*7', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8803, 8803, '1', 'purablk_c16_mdl3*8', 'purablk_c16_mdl3*8', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8804, 8804, '1', 'purablk_c16_mdl3*9', 'purablk_c16_mdl3*9', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8805, 8805, '1', 'purablk_c16_bedone*1', 'purablk_c16_bedone*1', 'S', 1, 1, 1.60, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8806, 8806, '1', 'purablk_c16_bedone*10', 'purablk_c16_bedone*10', 'S', 1, 1, 1.60, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8807, 8807, '1', 'purablk_c16_bedone*2', 'purablk_c16_bedone*2', 'S', 1, 1, 1.60, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8808, 8808, '1', 'purablk_c16_bedone*3', 'purablk_c16_bedone*3', 'S', 1, 1, 1.60, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8809, 8809, '1', 'purablk_c16_bedone*4', 'purablk_c16_bedone*4', 'S', 1, 1, 1.60, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8810, 8810, '1', 'purablk_c16_bedone*5', 'purablk_c16_bedone*5', 'S', 1, 1, 1.60, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8811, 8811, '1', 'purablk_c16_bedone*6', 'purablk_c16_bedone*6', 'S', 1, 1, 1.60, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8812, 8812, '1', 'purablk_c16_bedone*7', 'purablk_c16_bedone*7', 'S', 1, 1, 1.60, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8813, 8813, '1', 'purablk_c16_bedone*8', 'purablk_c16_bedone*8', 'S', 1, 1, 1.60, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8814, 8814, '1', 'purablk_c16_bedone*9', 'purablk_c16_bedone*9', 'S', 1, 1, 1.60, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8815, 8815, '1', 'purablk_c16_mdl2*1', 'purablk_c16_mdl2*1', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8816, 8816, '1', 'purablk_c16_mdl2*10', 'purablk_c16_mdl2*10', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8817, 8817, '1', 'purablk_c16_mdl2*2', 'purablk_c16_mdl2*2', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8818, 8818, '1', 'purablk_c16_mdl2*3', 'purablk_c16_mdl2*3', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8819, 8819, '1', 'purablk_c16_mdl2*4', 'purablk_c16_mdl2*4', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8820, 8820, '1', 'purablk_c16_mdl2*5', 'purablk_c16_mdl2*5', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8821, 8821, '1', 'purablk_c16_mdl2*6', 'purablk_c16_mdl2*6', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8822, 8822, '1', 'purablk_c16_mdl2*7', 'purablk_c16_mdl2*7', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8823, 8823, '1', 'purablk_c16_mdl2*8', 'purablk_c16_mdl2*8', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8824, 8824, '1', 'purablk_c16_mdl2*9', 'purablk_c16_mdl2*9', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8825, 8825, '0', 'purablk_c16_bar', 'purablk_c16_bar', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '1,2,5,6', '', '', 0, 0, ''),
	(8826, 8826, '1', 'purablk_c16_fridge', 'purablk_c16_fridge', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '3,4,5,6', '', '', 0, 0, ''),
	(8827, 8827, '1', 'purablk_c16_mdl5*1', 'purablk_c16_mdl5*1', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8828, 8828, '1', 'purablk_c16_mdl5*10', 'purablk_c16_mdl5*10', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8829, 8829, '1', 'purablk_c16_mdl5*2', 'purablk_c16_mdl5*2', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8830, 8830, '1', 'purablk_c16_mdl5*3', 'purablk_c16_mdl5*3', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8831, 8831, '1', 'purablk_c16_mdl5*4', 'purablk_c16_mdl5*4', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8832, 8832, '1', 'purablk_c16_mdl5*5', 'purablk_c16_mdl5*5', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8833, 8833, '1', 'purablk_c16_mdl5*6', 'purablk_c16_mdl5*6', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8834, 8834, '1', 'purablk_c16_mdl5*7', 'purablk_c16_mdl5*7', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8835, 8835, '1', 'purablk_c16_mdl5*8', 'purablk_c16_mdl5*8', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8836, 8836, '1', 'purablk_c16_mdl5*9', 'purablk_c16_mdl5*9', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8837, 8837, '1', 'purablk_c16_mdl1*1', 'purablk_c16_mdl1*1', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8838, 8838, '1', 'purablk_c16_mdl1*10', 'purablk_c16_mdl1*10', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8839, 8839, '1', 'purablk_c16_mdl1*2', 'purablk_c16_mdl1*2', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8840, 8840, '1', 'purablk_c16_mdl1*3', 'purablk_c16_mdl1*3', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8841, 8841, '1', 'purablk_c16_mdl1*4', 'purablk_c16_mdl1*4', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8842, 8842, '1', 'purablk_c16_mdl1*5', 'purablk_c16_mdl1*5', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8843, 8843, '1', 'purablk_c16_mdl1*6', 'purablk_c16_mdl1*6', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8844, 8844, '1', 'purablk_c16_mdl1*7', 'purablk_c16_mdl1*7', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8845, 8845, '1', 'purablk_c16_mdl1*8', 'purablk_c16_mdl1*8', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8846, 8846, '1', 'purablk_c16_mdl1*9', 'purablk_c16_mdl1*9', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8847, 8847, '1', 'purablk_c16_lamp2', 'purablk_c16_lamp2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8848, 8848, '1', 'purablk_c16_mdl4*1', 'purablk_c16_mdl4*1', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8849, 8849, '1', 'purablk_c16_mdl4*10', 'purablk_c16_mdl4*10', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8850, 8850, '1', 'purablk_c16_mdl4*2', 'purablk_c16_mdl4*2', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8851, 8851, '1', 'purablk_c16_mdl4*3', 'purablk_c16_mdl4*3', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8852, 8852, '1', 'purablk_c16_mdl4*4', 'purablk_c16_mdl4*4', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8853, 8853, '1', 'purablk_c16_mdl4*5', 'purablk_c16_mdl4*5', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8854, 8854, '1', 'purablk_c16_mdl4*6', 'purablk_c16_mdl4*6', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8855, 8855, '1', 'purablk_c16_mdl4*7', 'purablk_c16_mdl4*7', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8856, 8856, '1', 'purablk_c16_mdl4*8', 'purablk_c16_mdl4*8', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8857, 8857, '1', 'purablk_c16_mdl4*9', 'purablk_c16_mdl4*9', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8858, 8858, '1', 'pura_mdl4*10', 'pura_mdl4*10', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8859, 8859, '1', 'bed_budget*10', 'bed_budget*10', 'S', 2, 3, 1.70, '0', '0', '1', '1', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(8860, 8860, '0', 'pura_c16_roundpad10', 'pura_c16_roundpad10', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8861, 8861, '1', 'bed_budget_one*10', 'bed_budget_one*10', 'S', 1, 1, 1.70, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(8862, 8862, '1', 'pura_mdl3*10', 'pura_mdl3*10', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8863, 8863, '1', 'pura_mdl5*10', 'pura_mdl5*10', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8864, 8864, '1', 'pura_mdl2*10', 'pura_mdl2*10', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8865, 8865, '1', 'chair_basic*10', 'chair_basic*10', 'S', 1, 1, 1.30, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8866, 8866, '0', 'pura_c16_eleblock10', 'pura_c16_eleblock10', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '0;0.5;1;1.5;2', '', 0, 0, ''),
	(8867, 8867, '1', 'pura_mdl1*10', 'pura_mdl1*10', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8868, 8868, '1', 'divider_nor1*10', 'divider_nor1*10', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8869, 8869, '1', 'divider_nor5*10', 'divider_nor5*10', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8870, 8870, '1', 'solarium_norja*10', 'solarium_norja*10', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8871, 8871, '1', 'divider_nor4*10', 'divider_nor4*10', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8872, 8872, '1', 'soft_sofa_norja*10', 'soft_sofa_norja*10', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8873, 8873, '1', 'chair_norja*10', 'chair_norja*10', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8874, 8874, '1', 'table_norja_med*10', 'table_norja_med*10', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8875, 8875, '1', 'shelves_norja*10', 'shelves_norja*10', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8876, 8876, '1', 'divider_nor3*10', 'divider_nor3*10', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(8877, 8877, '1', 'soft_sofachair_norja*10', 'soft_sofachair_norja*10', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8878, 8878, '1', 'couch_norja*10', 'couch_norja*10', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8879, 8879, '1', 'divider_nor2*10', 'divider_nor2*10', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8880, 8880, '0', 'easter_r16_squid', 'easter_r16_squid', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8881, 8881, '0', 'easter_r16_crackable', 'easter_r16_crackable', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(8882, 8882, '0', 'easter_r16_pot', 'easter_r16_pot', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8883, 8883, '0', 'easter_c16_house', 'easter_c16_house', 'S', 2, 2, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 8, '', '', '', 0, 0, ''),
	(8884, 8884, '0', 'easter_r16_gold', 'easter_r16_gold', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8885, 8885, '0', 'easter_c16_nest', 'easter_c16_nest', 'S', 1, 1, 7.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8886, 8886, '0', 'easter_r16_throne', 'easter_r16_throne', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8887, 8887, '0', 'bonusrare16_5*1', 'bonusrare16_5*1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(8888, 8888, '0', 'bonusrare16_5*2', 'bonusrare16_5*2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(8889, 8889, '0', 'bonusrare16_5*3', 'bonusrare16_5*3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(8890, 8890, '0', 'bonusrare16_5*4', 'bonusrare16_5*4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(8891, 8891, '0', 'bonusrare16_5*5', 'bonusrare16_5*5', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(8892, 8892, '0', 'bonusrare16_5*6', 'bonusrare16_5*6', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(8893, 8893, '0', 'bonusrare16_6*1', 'bonusrare16_6*1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(8894, 8894, '0', 'bonusrare16_6*2', 'bonusrare16_6*2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(8895, 8895, '0', 'bonusrare16_6*3', 'bonusrare16_6*3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(8896, 8896, '0', 'bonusrare16_6*4', 'bonusrare16_6*4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(8897, 8897, '0', 'bonusrare16_6*5', 'bonusrare16_6*5', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(8898, 8898, '0', 'bonusrare16_6*6', 'bonusrare16_6*6', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(8899, 8899, '0', 'super_r16_herodisplay', 'super_r16_herodisplay', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(8900, 8900, '0', 'super_r16_adamskele', 'super_r16_adamskele', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(8901, 8901, '0', 'clothing_r16_helmhero', 'clothing_r16_helmhero', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8902, 8902, '0', 'clothing_r16_helmprotect', 'clothing_r16_helmprotect', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8903, 8903, '0', 'room_wl15_telehc', 'room_wl15_telehc', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'teleport', 1, '', '', '', 0, 0, ''),
	(8904, 8904, '1', 'classic1_table2', 'classic1_table2', 'S', 1, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8905, 8905, '1', 'classic1_lamp', 'classic1_lamp', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8906, 8906, '1', 'classic1_pillar', 'classic1_pillar', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8907, 8907, '1', 'classic1_plant', 'classic1_plant', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8908, 8908, '1', 'classic1_chair', 'classic1_chair', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8909, 8909, '1', 'classic1_desk', 'classic1_desk', 'S', 1, 1, 1.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8910, 8910, '1', 'classic1_gate', 'classic1_gate', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(8911, 8911, '1', 'classic1_wall2', 'classic1_wall2', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8912, 8912, '1', 'classic1_table1', 'classic1_table1', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8913, 8913, '1', 'classic1_shelf', 'classic1_shelf', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(8914, 8914, '1', 'classic1_floor', 'classic1_floor', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(8915, 8915, '1', 'classic1_sofa', 'classic1_sofa', 'S', 3, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8916, 8916, '1', 'classic1_wall1', 'classic1_wall1', 'S', 1, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 8, '', '', '', 0, 0, ''),
	(8917, 8917, '0', 'ads_dtlrare_2', 'ads_dtlrare_2', 'S', 1, 1, 2.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '1048', '', '', 0, 0, ''),
	(8918, 8918, '0', 'jungle_c16_flowerd2', 'jungle_c16_flowerd2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'crackable', 12, '', '', '', 0, 0, ''),
	(8919, 8919, '0', 'jungle_c16_flowerd1', 'jungle_c16_flowerd1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'crackable', 12, '', '', '', 0, 0, ''),
	(8920, 8920, '1', 'jungle_c16_roof', 'jungle_c16_roof', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8921, 8921, '0', 'jungle_c16_berry', 'jungle_c16_berry', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8922, 8922, '1', 'jungle_c16_swingsofa', 'jungle_c16_swingsofa', 'S', 2, 1, 2.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8923, 8923, '0', 'jungle_c16_bridgeend3', 'jungle_c16_bridgeend3', 'S', 1, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8924, 8924, '1', 'jungle_c16_light', 'jungle_c16_light', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8925, 8925, '0', 'jungle_c16_table3', 'jungle_c16_table3', 'S', 2, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8926, 8926, '0', 'jungle_c16_flowerc3', 'jungle_c16_flowerc3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'crackable', 12, '', '', '', 0, 0, ''),
	(8927, 8927, '1', 'jungle_c16_stairs', 'jungle_c16_stairs', 'S', 1, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 10, '', '1.0;2.0;3.0;4.0;5.0;6.0;7.0;8.0;9.0;10', '', 0, 0, ''),
	(8928, 8928, '0', 'jungle_c16_gate3', 'jungle_c16_gate3', 'S', 1, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(8929, 8929, '1', 'jungle_c16_pot', 'jungle_c16_pot', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8930, 8930, '1', 'jungle_c16_tallgrass', 'jungle_c16_tallgrass', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8931, 8931, '1', 'jungle_c16_floor', 'jungle_c16_floor', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8932, 8932, '0', 'jungle_ltd16_orangutan', 'jungle_ltd16_orangutan', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8933, 8933, '0', 'jungle_r16_basket', 'jungle_r16_basket', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8934, 8934, '0', 'jungle_c16_mat3', 'jungle_c16_mat3', 'S', 2, 3, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8935, 8935, '1', 'jungle_c16_mat', 'jungle_c16_mat', 'S', 2, 3, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8936, 8936, '0', 'jungle_c16_berry2', 'jungle_c16_berry2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8937, 8937, '0', 'jungle_c16_mat2', 'jungle_c16_mat2', 'S', 2, 3, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8938, 8938, '0', 'jungle_c16_worktable', 'jungle_c16_worktable', 'S', 1, 2, 1.00, '0', '0', '0', '0', '1', '0', '1', '0', '0', 'crafting', 2, '', '', '', 0, 0, ''),
	(8939, 8939, '0', 'jungle_c16_stairs3', 'jungle_c16_stairs3', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 10, '', '1.0;2.0;3.0;4.0;5.0;6.0;7.0;8.0;9.0;10', '', 0, 0, ''),
	(8940, 8940, '0', 'jungle_c16_rafflesia', 'jungle_c16_rafflesia', 'S', 1, 1, 0.30, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8941, 8941, '0', 'jungle_c16_pot2', 'jungle_c16_pot2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8942, 8942, '0', 'jungle_c16_swingsofa2', 'jungle_c16_swingsofa2', 'S', 2, 1, 2.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8943, 8943, '0', 'jungle_c16_wall2', 'jungle_c16_wall2', 'S', 1, 2, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(8944, 8944, '0', 'jungle_c16_bridgeend2', 'jungle_c16_bridgeend2', 'S', 1, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8945, 8945, '0', 'jungle_r16_pitcherplant', 'jungle_r16_pitcherplant', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8946, 8946, '1', 'jungle_c16_tele', 'jungle_c16_tele', 'S', 1, 1, 0.40, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'teleport', 1, '', '', '', 0, 0, ''),
	(8947, 8947, '1', 'jungle_c16_table', 'jungle_c16_table', 'S', 2, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8948, 8948, '0', 'jungle_c16_flowera3', 'jungle_c16_flowera3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'crackable', 12, '', '', '', 0, 0, ''),
	(8949, 8949, '1', 'jungle_c16_tree', 'jungle_c16_tree', 'S', 2, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(8950, 8950, '0', 'jungle_c16_stairs2', 'jungle_c16_stairs2', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 10, '', '1.0;2.0;3.0;4.0;5.0;6.0;7.0;8.0;9.0;10', '', 0, 0, ''),
	(8951, 8951, '0', 'jungle_c16_flowerd3', 'jungle_c16_flowerd3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'crackable', 12, '', '', '', 0, 0, ''),
	(8952, 8952, '0', 'jungle_c16_wall3', 'jungle_c16_wall3', 'S', 1, 2, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(8953, 8953, '0', 'jungle_c16_dvdr2', 'jungle_c16_dvdr2', 'S', 1, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8954, 8954, '0', 'jungle_c16_swingsofa3', 'jungle_c16_swingsofa3', 'S', 2, 1, 2.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8955, 8955, '1', 'jungle_c16_treestage', 'jungle_c16_treestage', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1;2.8;4.8;6.8;8.8', '', 0, 0, ''),
	(8956, 8956, '1', 'jungle_c16_rocks', 'jungle_c16_rocks', 'S', 1, 1, 0.40, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 8, '', '', '', 0, 0, ''),
	(8957, 8957, '1', 'jungle_c16_fruits', 'jungle_c16_fruits', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(8958, 8958, '0', 'jungle_c16_treestage2', 'jungle_c16_treestage2', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 10, '', '1;2.8;4.8;6.8;8.8', '', 0, 0, ''),
	(8959, 8959, '1', 'jungle_c16_bush', 'jungle_c16_bush', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine_no_sides', 2, '1006,1037,1038', '', '', 0, 0, ''),
	(8960, 8960, '0', 'jungle_c16_gate2', 'jungle_c16_gate2', 'S', 1, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(8961, 8961, '1', 'jungle_c16_ctrick', 'jungle_c16_ctrick', 'S', 1, 1, 0.10, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8962, 8962, '1', 'jungle_c16_gate', 'jungle_c16_gate', 'S', 1, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(8963, 8963, '1', 'jungle_c16_dvdr', 'jungle_c16_dvdr', 'S', 1, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8964, 8964, '1', 'jungle_c16_plant', 'jungle_c16_plant', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8965, 8965, '1', 'jungle_c16_sacks', 'jungle_c16_sacks', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(8966, 8966, '0', 'jungle_r16_raft', 'jungle_r16_raft', 'S', 2, 2, 0.20, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8967, 8967, '1', 'jungle_c16_wall', 'jungle_c16_wall', 'S', 1, 2, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(8968, 8968, '0', 'jungle_c16_flowerc2', 'jungle_c16_flowerc2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'crackable', 12, '', '', '', 0, 0, ''),
	(8969, 8969, '1', 'jungle_c16_watertile', 'jungle_c16_watertile', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 30, 30, ''),
	(8970, 8970, '1', 'jungle_c16_watertrap', 'jungle_c16_watertrap', 'S', 2, 2, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8971, 8971, '0', 'jungle_c16_roof3', 'jungle_c16_roof3', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8972, 8972, '0', 'jungle_c16_table2', 'jungle_c16_table2', 'S', 2, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8973, 8973, '1', 'jungle_c16_radio', 'jungle_c16_radio', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8974, 8974, '0', 'clothing_r16_sloth', 'clothing_r16_sloth', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(8975, 8975, '0', 'jungle_c16_flowera1', 'jungle_c16_flowera1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'crackable', 12, '', '', '', 0, 0, ''),
	(8976, 8976, '0', 'jungle_c16_bkcase2', 'jungle_c16_bkcase2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(8977, 8977, '0', 'jungle_c16_flowerb3', 'jungle_c16_flowerb3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'crackable', 12, '', '', '', 0, 0, ''),
	(8978, 8978, '0', 'jungle_c16_roof2', 'jungle_c16_roof2', 'S', 2, 2, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8979, 8979, '1', 'jungle_c16_bridgeend', 'jungle_c16_bridgeend', 'S', 1, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8980, 8980, '0', 'jungle_c16_dvdr3', 'jungle_c16_dvdr3', 'S', 1, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8981, 8981, '0', 'jungle_c16_flowerb2', 'jungle_c16_flowerb2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'crackable', 12, '', '', '', 0, 0, ''),
	(8982, 8982, '0', 'jungle_c16_flowerb1', 'jungle_c16_flowerb1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'crackable', 12, '', '', '', 0, 0, ''),
	(8983, 8983, '0', 'jungle_c16_flowerc1', 'jungle_c16_flowerc1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'crackable', 12, '', '', '', 0, 0, ''),
	(8984, 8984, '0', 'jungle_c16_pot3', 'jungle_c16_pot3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8985, 8985, '0', 'jungle_c16_bkcase3', 'jungle_c16_bkcase3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(8986, 8986, '1', 'jungle_c16_bkcase', 'jungle_c16_bkcase', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(8987, 8987, '0', 'jungle_c16_flowera2', 'jungle_c16_flowera2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'crackable', 12, '', '', '', 0, 0, ''),
	(8988, 8988, '0', 'jungle_c16_treestage3', 'jungle_c16_treestage3', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '1;2.8;4.8;6.8;8.8', '', 0, 0, ''),
	(8989, 8989, '0', 'jungle_c16_bridgemid3', 'jungle_c16_bridgemid3', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8990, 8990, '0', 'jungle_c16_bridgemid2', 'jungle_c16_bridgemid2', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8991, 8991, '1', 'jungle_c16_bridgemid', 'jungle_c16_bridgemid', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8992, 8992, '0', 'fxbox_fx192', 'fxbox_fx192', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'fx_box', 2, '', '', '', 192, 192, ''),
	(8993, 8993, '0', 'bonusbag16_1', 'bonusbag16_1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(8994, 8994, '0', 'bonusbag16_2', 'bonusbag16_2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(8995, 8995, '0', 'js_c16_bed', 'js_c16_bed', 'S', 2, 3, 2.00, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(8996, 8996, '0', 'js_c16_lounger', 'js_c16_lounger', 'S', 1, 1, 1.20, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8997, 8997, '0', 'js_r16_boat', 'js_r16_boat', 'S', 2, 4, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(8998, 8998, '0', 'js_r16_jelly', 'js_r16_jelly', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(8999, 8999, '0', 'js_r16_shark', 'js_r16_shark', 'S', 1, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9000, 9000, '0', 'js_c16_cat', 'js_c16_cat', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9001, 9001, '0', 'js_r16_heli', 'js_r16_heli', 'S', 2, 3, 9.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9002, 9002, '0', 'js_c16_drkcab', 'js_c16_drkcab', 'S', 1, 1, 2.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '43', '', '', 0, 0, ''),
	(9003, 9003, '1', 'olympics_c16_counter', 'olympics_c16_counter', 'S', 1, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(9004, 9004, '1', 'olympics_c16_softmat', 'olympics_c16_softmat', 'S', 1, 1, 0.20, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9005, 9005, '0', 'olympics_c16_pommel', 'olympics_c16_pommel', 'S', 1, 1, 0.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 5, '', '2;2.2;2.4;2.6', '', 0, 0, ''),
	(9006, 9006, '1', 'olympics_c16_weightrack', 'olympics_c16_weightrack', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine_no_sides', 2, '108', '', '', 0, 0, ''),
	(9007, 9007, '0', 'olympics_r16_vendingmchn', 'olympics_r16_vendingmchn', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '107', '', '', 0, 0, ''),
	(9008, 9008, '1', 'olympics_c16_plantdvdr', 'olympics_c16_plantdvdr', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9009, 9009, '1', 'olympics_c16_graperack', 'olympics_c16_graperack', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '105', '', '', 0, 0, ''),
	(9010, 9010, '1', 'olympics_c16_cadorack', 'olympics_c16_cadorack', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '104', '', '', 0, 0, ''),
	(9011, 9011, '0', 'olympics_r16_cheerleader', 'olympics_r16_cheerleader', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9012, 9012, '0', 'olympics_ltd16_missolympus', 'olympics_ltd16_missolympus', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9013, 9013, '1', 'olympics_c16_saladbar', 'olympics_c16_saladbar', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9014, 9014, '1', 'olympics_c16_merchdisplay', 'olympics_c16_merchdisplay', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9015, 9015, '1', 'olympics_c16_merch', 'olympics_c16_merch', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '102', '', '', 0, 0, ''),
	(9016, 9016, '1', 'olympics_c16_banner', 'olympics_c16_banner', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(9017, 9017, '1', 'olympics_c16_adsboard', 'olympics_c16_adsboard', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(9018, 9018, '1', 'olympics_c16_bbeam', 'olympics_c16_bbeam', 'S', 3, 1, 1.50, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9019, 9019, '0', 'olympics_r16_smoothie', 'olympics_r16_smoothie', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '106', '', '', 0, 0, ''),
	(9020, 9020, '1', 'olympics_c16_yogamat*1', 'olympics_c16_yogamat*1', 'S', 1, 3, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(9021, 9021, '1', 'olympics_c16_yogamat*2', 'olympics_c16_yogamat*2', 'S', 1, 3, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(9022, 9022, '1', 'olympics_c16_yogamat*3', 'olympics_c16_yogamat*3', 'S', 1, 3, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(9023, 9023, '1', 'olympics_c16_yogamat*4', 'olympics_c16_yogamat*4', 'S', 1, 3, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(9024, 9024, '1', 'olympics_c16_yogamat*5', 'olympics_c16_yogamat*5', 'S', 1, 3, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(9025, 9025, '1', 'olympics_c16_yogamat*6', 'olympics_c16_yogamat*6', 'S', 1, 3, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(9026, 9026, '1', 'olympics_c16_emptrack', 'olympics_c16_emptrack', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9027, 9027, '1', 'olympics_c16_table', 'olympics_c16_table', 'S', 2, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9028, 9028, '1', 'olympics_c16_trampoline', 'olympics_c16_trampoline', 'S', 1, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'gym_equipment', 2, '', '', '', 193, 193, ''),
	(9029, 9029, '0', 'olympics_c16_veggiething', 'olympics_c16_veggiething', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9030, 9030, '1', 'olympics_c16_sportsbag', 'olympics_c16_sportsbag', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 6, '', '', '', 0, 0, ''),
	(9031, 9031, '1', 'olympics_c16_crosstrainer', 'olympics_c16_crosstrainer', 'S', 1, 1, 0.30, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'gym_equipment', 2, '', '', '', 195, 195, ''),
	(9032, 9032, '1', 'olympics_c16_glssdvdr', 'olympics_c16_glssdvdr', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9033, 9033, '1', 'olympics_c16_mannequin', 'olympics_c16_mannequin', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'mannequin', 1, '', '', '', 0, 0, ''),
	(9034, 9034, '1', 'olympics_c16_rug', 'olympics_c16_rug', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9035, 9035, '1', 'olympics_c16_light', 'olympics_c16_light', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9036, 9036, '1', 'olympics_c16_pillar', 'olympics_c16_pillar', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9037, 9037, '1', 'olympics_c16_nanarack', 'olympics_c16_nanarack', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '103', '', '', 0, 0, ''),
	(9038, 9038, '1', 'olympics_c16_sofa', 'olympics_c16_sofa', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9039, 9039, '0', 'olympics_c16_fitnessduck', 'olympics_c16_fitnessduck', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9040, 9040, '1', 'olympics_c16_chair', 'olympics_c16_chair', 'S', 1, 1, 1.40, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9041, 9041, '0', 'olympics_r16_gymfreak', 'olympics_r16_gymfreak', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9042, 9042, '0', 'olympics_c16_swissball*1', 'olympics_c16_swissball*1', 'S', 1, 1, 2.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'pressureplate', 1, '', '', '', 0, 0, ''),
	(9043, 9043, '0', 'olympics_c16_swissball*2', 'olympics_c16_swissball*2', 'S', 1, 1, 2.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'pressureplate', 1, '', '', '', 0, 0, ''),
	(9044, 9044, '0', 'olympics_c16_swissball*3', 'olympics_c16_swissball*3', 'S', 1, 1, 2.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'pressureplate', 1, '', '', '', 0, 0, ''),
	(9045, 9045, '0', 'olympics_c16_swissball*4', 'olympics_c16_swissball*4', 'S', 1, 1, 2.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'pressureplate', 1, '', '', '', 0, 0, ''),
	(9046, 9046, '0', 'olympics_c16_swissball*5', 'olympics_c16_swissball*5', 'S', 1, 1, 2.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'pressureplate', 1, '', '', '', 0, 0, ''),
	(9047, 9047, '0', 'olympics_c16_swissball*6', 'olympics_c16_swissball*6', 'S', 1, 1, 2.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'pressureplate', 1, '', '', '', 0, 0, ''),
	(9048, 9048, '1', 'olympics_c16_treadmill', 'olympics_c16_treadmill', 'S', 1, 1, 0.30, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'gym_equipment', 2, '', '', '', 194, 194, ''),
	(9049, 9049, '0', 'garden_birdbath', 'garden_birdbath', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(9050, 9050, '0', 'garden_basketflower', 'garden_basketflower', 'S', 1, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9051, 9051, '0', 'garden_basket', 'garden_basket', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9052, 9052, '0', 'garden_climber', 'garden_climber', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(9053, 9053, '0', 'garden_grass', 'garden_grass', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(9054, 9054, '0', 'garden_pond', 'garden_pond', 'S', 1, 2, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9055, 9055, '0', 'garden_boots', 'garden_boots', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9056, 9056, '0', 'garden_patio', 'garden_patio', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9057, 9057, '0', 'garden_stonesteps', 'garden_stonesteps', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9058, 9058, '0', 'garden_smallpot', 'garden_smallpot', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9059, 9059, '0', 'garden_fishgnome', 'garden_fishgnome', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9060, 9060, '0', 'garden_rosearch', 'garden_rosearch', 'S', 2, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9061, 9061, '0', 'garden_rosefence', 'garden_rosefence', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9062, 9062, '0', 'garden_chair', 'garden_chair', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9063, 9063, '0', 'garden_bigpot', 'garden_bigpot', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9064, 9064, '0', 'garden_table', 'garden_table', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9065, 9065, '0', 'garden_flowerbed', 'garden_flowerbed', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(9066, 9066, '1', 'classic2_drinkmach', 'classic2_drinkmach', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '1,18,29,30,42,66', '', '', 0, 0, ''),
	(9067, 9067, '1', 'classic2_gate', 'classic2_gate', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(9068, 9068, '1', 'classic2_corner', 'classic2_corner', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9069, 9069, '1', 'classic2_tray', 'classic2_tray', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9070, 9070, '1', 'classic2_drinkcup', 'classic2_drinkcup', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(9071, 9071, '1', 'classic2_drinkmach2', 'classic2_drinkmach2', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '1,18,29,30,42,66', '', '', 0, 0, ''),
	(9072, 9072, '1', 'classic2_wall', 'classic2_wall', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(9073, 9073, '1', 'classic2_trashcan', 'classic2_trashcan', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9074, 9074, '1', 'classic2_counter', 'classic2_counter', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9075, 9075, '1', 'classic2_sofa', 'classic2_sofa', 'S', 2, 1, 0.80, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9076, 9076, '1', 'classic2_plantdivdr', 'classic2_plantdivdr', 'S', 1, 2, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9077, 9077, '1', 'classic2_grill', 'classic2_grill', 'S', 3, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '109', '', '', 0, 0, ''),
	(9078, 9078, '1', 'classic2_table', 'classic2_table', 'S', 1, 2, 1.10, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9079, 9079, '1', 'classic2_floor', 'classic2_floor', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9080, 9080, '1', 'classic2_burger', 'classic2_burger', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine_no_sides', 2, '109', '', '', 0, 0, ''),
	(9081, 9081, '1', 'classic2_napkin', 'classic2_napkin', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9082, 9082, '1', 'classic3_chair*0', 'classic3_chair*0', 'S', 1, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'battleball_trigger', 2, '', '', '', 0, 0, ''),
	(9083, 9083, '1', 'classic3_chair*1', 'classic3_chair*1', 'S', 1, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'battleball_trigger', 2, '', '', '', 0, 0, ''),
	(9084, 9084, '1', 'classic3_chair*2', 'classic3_chair*2', 'S', 1, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'battleball_trigger', 2, '', '', '', 0, 0, ''),
	(9085, 9085, '1', 'classic3_chair*3', 'classic3_chair*3', 'S', 1, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'battleball_trigger', 2, '', '', '', 0, 0, ''),
	(9086, 9086, '1', 'classic3_plant*0', 'classic3_plant*0', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9087, 9087, '1', 'classic3_plant*1', 'classic3_plant*1', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9088, 9088, '1', 'classic3_plant*2', 'classic3_plant*2', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9089, 9089, '1', 'classic3_plant*3', 'classic3_plant*3', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9090, 9090, '1', 'classic3_plant*4', 'classic3_plant*4', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9091, 9091, '1', 'classic3_pillar1', 'classic3_pillar1', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9092, 9092, '1', 'classic3_div2*0', 'classic3_div2*0', 'S', 2, 1, 0.70, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9093, 9093, '1', 'classic3_div2*1', 'classic3_div2*1', 'S', 2, 1, 0.70, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9094, 9094, '1', 'classic3_div2*2', 'classic3_div2*2', 'S', 2, 1, 0.70, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9095, 9095, '1', 'classic3_div2*3', 'classic3_div2*3', 'S', 2, 1, 0.70, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9096, 9096, '1', 'classic3_div2*4', 'classic3_div2*4', 'S', 2, 1, 0.70, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9097, 9097, '1', 'classic3_floor3*0', 'classic3_floor3*0', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9098, 9098, '1', 'classic3_floor3*1', 'classic3_floor3*1', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9099, 9099, '1', 'classic3_floor3*2', 'classic3_floor3*2', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9100, 9100, '1', 'classic3_floor3*3', 'classic3_floor3*3', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9101, 9101, '1', 'classic3_floor3*4', 'classic3_floor3*4', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9102, 9102, '1', 'classic3_table', 'classic3_table', 'S', 2, 1, 0.60, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9103, 9103, '1', 'classic3_pillar2', 'classic3_pillar2', 'S', 1, 1, 1.90, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(9104, 9104, '1', 'classic3_ticket', 'classic3_ticket', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '1070', '', '', 0, 0, ''),
	(9105, 9105, '1', 'classic3_sofa*0', 'classic3_sofa*0', 'S', 2, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9106, 9106, '1', 'classic3_sofa*1', 'classic3_sofa*1', 'S', 2, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9107, 9107, '1', 'classic3_sofa*2', 'classic3_sofa*2', 'S', 2, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9108, 9108, '1', 'classic3_sofa*3', 'classic3_sofa*3', 'S', 2, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9109, 9109, '1', 'classic3_floor2', 'classic3_floor2', 'S', 2, 2, 0.10, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9110, 9110, '1', 'classic3_stool*0', 'classic3_stool*0', 'S', 1, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9111, 9111, '1', 'classic3_stool*1', 'classic3_stool*1', 'S', 1, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9112, 9112, '1', 'classic3_stool*2', 'classic3_stool*2', 'S', 1, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9113, 9113, '1', 'classic3_stool*3', 'classic3_stool*3', 'S', 1, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9114, 9114, '1', 'classic3_block', 'classic3_block', 'S', 1, 1, 1.10, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9115, 9115, '1', 'classic3_floor1', 'classic3_floor1', 'S', 2, 2, 0.10, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9116, 9116, '1', 'classic3_bench*0', 'classic3_bench*0', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9117, 9117, '1', 'classic3_bench*1', 'classic3_bench*1', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9118, 9118, '1', 'classic3_bench*2', 'classic3_bench*2', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9119, 9119, '1', 'classic3_bench*3', 'classic3_bench*3', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9120, 9120, '1', 'classic3_wall2*0', 'classic3_wall2*0', 'S', 3, 1, 5.70, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9121, 9121, '1', 'classic3_wall2*1', 'classic3_wall2*1', 'S', 3, 1, 5.70, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9122, 9122, '1', 'classic3_wall2*2', 'classic3_wall2*2', 'S', 3, 1, 5.70, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9123, 9123, '1', 'classic3_wall2*3', 'classic3_wall2*3', 'S', 3, 1, 5.70, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9124, 9124, '1', 'classic3_wall2*4', 'classic3_wall2*4', 'S', 3, 1, 5.70, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9125, 9125, '1', 'classic3_wall2*5', 'classic3_wall2*5', 'S', 3, 1, 5.70, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9126, 9126, '1', 'classic3_wall2*6', 'classic3_wall2*6', 'S', 3, 1, 5.70, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9127, 9127, '1', 'classic3_wall2*7', 'classic3_wall2*7', 'S', 3, 1, 5.70, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9128, 9128, '1', 'classic3_wall1', 'classic3_wall1', 'S', 3, 1, 5.70, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9129, 9129, '1', 'classic3_pillar3', 'classic3_pillar3', 'S', 1, 1, 1.90, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(9130, 9130, '1', 'classic3_div1', 'classic3_div1', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9131, 9131, '0', 'rare_colourable_marquee*1', 'rare_colourable_marquee*1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(9132, 9132, '0', 'rare_colourable_scifirocket*1', 'rare_colourable_scifirocket*1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9133, 9133, '0', 'rare_colourable_fountain*1', 'rare_colourable_fountain*1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9134, 9134, '0', 'hhistory_r16_crackable', 'hhistory_r16_crackable', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(9135, 9135, '0', 'rare_colourable_wooden_screen*1', 'rare_colourable_wooden_screen*1', 'S', 1, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9136, 9136, '0', 'rare_colourable_dragonlamp*1', 'rare_colourable_dragonlamp*1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9137, 9137, '0', 'rare_colourable_parasol*1', 'rare_colourable_parasol*1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9138, 9138, '0', 'rare_colourable_pillar*1', 'rare_colourable_pillar*1', 'S', 1, 1, 3.50, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9139, 9139, '0', 'rare_colourable_beehive_bulb*1', 'rare_colourable_beehive_bulb*1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9140, 9140, '0', 'rare_colourable_icecream*1', 'rare_colourable_icecream*1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'vendingmachine', 2, '4', '', '', 0, 0, ''),
	(9141, 9141, '0', 'rare_colourable_elephant_statue*1', 'rare_colourable_elephant_statue*1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9142, 9142, '0', 'rare_colourable_scifidoor*1', 'rare_colourable_scifidoor*1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(9143, 9143, '0', 'rare_colourable_fan*1', 'rare_colourable_fan*1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9144, 9144, '0', 'rare_colourable_pillow*1', 'rare_colourable_pillow*1', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9145, 9145, '0', 'rare_colourable_scifiport*1', 'rare_colourable_scifiport*1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(9146, 9146, '0', 'rare_colourable_barrier*1', 'rare_colourable_barrier*1', 'S', 1, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9147, 9147, '0', 'hween_c16_teleport', 'hween_c16_teleport', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'teleport', 1, '', '', '', 0, 0, ''),
	(9148, 9148, '0', 'hween_c16_chair2', 'hween_c16_chair2', 'S', 1, 1, 1.30, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9149, 9149, '0', 'hween_c16_roundtable', 'hween_c16_roundtable', 'S', 1, 1, 1.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9150, 9150, '0', 'hween_c16_barchair', 'hween_c16_barchair', 'S', 1, 1, 1.80, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9151, 9151, '0', 'hween_c16_lamp2', 'hween_c16_lamp2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9152, 9152, '1', 'hween_c16_balcony', 'hween_c16_balcony', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(9153, 9153, '0', 'hween_c16_fireplace', 'hween_c16_fireplace', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9154, 9154, '0', 'hween_r16_crackable2', 'hween_r16_crackable2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'crackable', 20, '', '', '', 0, 0, ''),
	(9155, 9155, '0', 'hween_c16_cabinet2', 'hween_c16_cabinet2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9156, 9156, '0', 'hween_r16_chandelier', 'hween_r16_chandelier', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9157, 9157, '0', 'hween_c16_barchair2', 'hween_c16_barchair2', 'S', 1, 1, 2.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9158, 9158, '0', 'hween_c16_ghostash', 'hween_c16_ghostash', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9159, 9159, '0', 'hween_c16_webs', 'hween_c16_webs', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9160, 9160, '0', 'hween_c16_fireplace2', 'hween_c16_fireplace2', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9161, 9161, '1', 'hween_c16_wall', 'hween_c16_wall', 'S', 1, 1, 4.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 6, '', '', '', 0, 0, ''),
	(9162, 9162, '1', 'hween_c16_vase', 'hween_c16_vase', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9163, 9163, '0', 'hween_c16_balcony2', 'hween_c16_balcony2', 'S', 2, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(9164, 9164, '0', 'hween_c16_crackable1', 'hween_c16_crackable1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'crackable', 20, '', '', '', 0, 0, ''),
	(9165, 9165, '0', 'hween_r16_grandpiano2', 'hween_r16_grandpiano2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9166, 9166, '0', 'hween_c16_roundtable2', 'hween_c16_roundtable2', 'S', 1, 1, 1.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9167, 9167, '0', 'hween_c16_bed2', 'hween_c16_bed2', 'S', 1, 1, 1.70, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(9168, 9168, '0', 'hween_c16_bar2', 'hween_c16_bar2', 'S', 2, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9169, 9169, '0', 'hween_c16_ghostmchn', 'hween_c16_ghostmchn', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '0', '1', '0', '0', 'crafting', 2, '', '', '', 0, 0, ''),
	(9170, 9170, '0', 'hween_c16_bust', 'hween_c16_bust', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9171, 9171, '0', 'clothing_r16_catface', 'clothing_r16_catface', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9172, 9172, '0', 'hween_c16_floor2', 'hween_c16_floor2', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9173, 9173, '0', 'hween_c16_vanity', 'hween_c16_vanity', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(9174, 9174, '1', 'hween_c16_endtable', 'hween_c16_endtable', 'S', 1, 1, 1.50, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9175, 9175, '0', 'hween_c16_wall2', 'hween_c16_wall2', 'S', 1, 1, 4.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9176, 9176, '1', 'hween_c16_floor', 'hween_c16_floor', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9177, 9177, '0', 'hween_c16_cabinet', 'hween_c16_cabinet', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9178, 9178, '0', 'hween_r16_grandpiano', 'hween_r16_grandpiano', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9179, 9179, '1', 'hween_c16_bkcase', 'hween_c16_bkcase', 'S', 0, 0, 3.50, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9180, 9180, '0', 'hween_c16_bust2', 'hween_c16_bust2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9181, 9181, '0', 'hween_c16_ladder2', 'hween_c16_ladder2', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9182, 9182, '1', 'hween_c16_ladder', 'hween_c16_ladder', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9183, 9183, '0', 'hween_ltd16_ghostcar', 'hween_ltd16_ghostcar', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9184, 9184, '0', 'hween_c16_bkcase2', 'hween_c16_bkcase2', 'S', 1, 1, 3.50, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9185, 9185, '1', 'hween_c16_glasstable', 'hween_c16_glasstable', 'S', 1, 2, 1.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9186, 9186, '1', 'hween_c16_bed', 'hween_c16_bed', 'S', 1, 1, 1.70, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(9187, 9187, '1', 'hween_c16_lamp', 'hween_c16_lamp', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9188, 9188, '0', 'hween_c16_ghostorb', 'hween_c16_ghostorb', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9189, 9189, '0', 'hween_c16_glasstable2', 'hween_c16_glasstable2', 'S', 1, 2, 1.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9190, 9190, '1', 'hween_c16_chair', 'hween_c16_chair', 'S', 1, 1, 1.30, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9191, 9191, '0', 'hween_c16_ghostvial', 'hween_c16_ghostvial', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9192, 9192, '0', 'hween_c16_vanity2', 'hween_c16_vanity2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9193, 9193, '0', 'hween_c16_endtable2', 'hween_c16_endtable2', 'S', 1, 1, 1.50, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9194, 9194, '1', 'hween_c16_bar', 'hween_c16_bar', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9195, 9195, '0', 'hween_r16_chandelier2', 'hween_r16_chandelier2', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9196, 9196, '0', 'hween_c16_vase2', 'hween_c16_vase2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9197, 9197, '0', 'clothing_r16_cyclops', 'clothing_r16_cyclops', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9198, 9198, '0', 'fxbox_fx16', 'fxbox_fx16', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'fx_box', 2, '', '', '', 16, 16, ''),
	(9199, 9199, '0', 'test_ltd', 'test_ltd', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9200, 9200, '0', 'test_ltd2', 'test_ltd2', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9201, 9201, '0', 'xmas_c16_elf8', 'xmas_c16_elf8', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9202, 9202, '0', 'xmas_c16_woodfloor', 'xmas_c16_woodfloor', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9203, 9203, '0', 'xmas_c16_fireplace', 'xmas_c16_fireplace', 'S', 3, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9204, 9204, '0', 'xmas_c16_dvdr', 'xmas_c16_dvdr', 'S', 1, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9205, 9205, '0', 'xmas_r16_throne', 'xmas_r16_throne', 'S', 1, 1, 1.40, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9206, 9206, '0', 'clothing_bearhat', 'clothing_bearhat', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9207, 9207, '0', 'xmas_c16_woodtile', 'xmas_c16_woodtile', 'S', 1, 1, 0.01, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '0.01;0.60;0.99;1.80;2.05', '', 0, 0, ''),
	(9208, 9208, '0', 'xmas_c16_deskitems', 'xmas_c16_deskitems', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 9, '', '', '', 0, 0, ''),
	(9209, 9209, '0', 'clothing_r16_icetiara', 'clothing_r16_icetiara', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9210, 9210, '0', 'xmas_c16_chair', 'xmas_c16_chair', 'S', 1, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9211, 9211, '0', 'xmas_c16_creature3', 'xmas_c16_creature3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9212, 9212, '0', 'xmas_c16_banner', 'xmas_c16_banner', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9213, 9213, '0', 'xmas_c16_presentstack', 'xmas_c16_presentstack', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9214, 9214, '0', 'xmas_c16_creature7', 'xmas_c16_creature7', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'crackable', 23, '', '', '', 0, 0, ''),
	(9215, 9215, '0', 'clothing_bear', 'clothing_bear', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9216, 9216, '0', 'xmas_c16_elf9', 'xmas_c16_elf9', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9217, 9217, '0', 'xmas_c16_elf7', 'xmas_c16_elf7', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9218, 9218, '0', 'xmas_c16_elf3', 'xmas_c16_elf3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9219, 9219, '0', 'xmas_c16_diningtable', 'xmas_c16_diningtable', 'S', 3, 4, 1.50, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9220, 9220, '0', 'xmas_c16_diningbench', 'xmas_c16_diningbench', 'S', 4, 1, 1.50, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9221, 9221, '0', 'xmas_c16_food2', 'xmas_c16_food2', 'S', 2, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(9222, 9222, '0', 'xmas_c16_roundtable', 'xmas_c16_roundtable', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9223, 9223, '0', 'xmas_c16_balcony', 'xmas_c16_balcony', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 1, '', '', '', 0, 0, ''),
	(9224, 9224, '0', 'xmas_c16_creature5', 'xmas_c16_creature5', 'S', 1, 1, 2.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9225, 9225, '0', 'xmas_c16_wreathdeco', 'xmas_c16_wreathdeco', 'S', 1, 2, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(9226, 9226, '0', 'xmas_c16_dresser', 'xmas_c16_dresser', 'S', 2, 1, 2.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(9227, 9227, '0', 'xmas_c16_desk', 'xmas_c16_desk', 'S', 3, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9228, 9228, '0', 'xmas_c16_food3', 'xmas_c16_food3', 'S', 2, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(9229, 9229, '0', 'clothing_bearscarf', 'clothing_bearscarf', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9230, 9230, '0', 'xmas_c16_stocking', 'xmas_c16_stocking', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'crackable', 1, '', '', '', 0, 0, ''),
	(9231, 9231, '0', 'xmas_c16_tinybed', 'xmas_c16_tinybed', 'S', 2, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9232, 9232, '0', 'xmas_c16_egg', 'xmas_c16_egg', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'crackable', 23, '', '', '', 0, 0, ''),
	(9233, 9233, '0', 'xmas_c16_elf1', 'xmas_c16_elf1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9234, 9234, '0', 'xmas_c16_tele', 'xmas_c16_tele', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'teleport', 1, '', '', '', 0, 0, ''),
	(9235, 9235, '0', 'clothing_reindeer', 'clothing_reindeer', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9236, 9236, '0', 'xmas_c16_door', 'xmas_c16_door', 'S', 4, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(9237, 9237, '0', 'xmas_c16_elf10', 'xmas_c16_elf10', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9238, 9238, '0', 'xmas_c16_creature1', 'xmas_c16_creature1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'crackable', 23, '', '', '', 0, 0, ''),
	(9239, 9239, '0', 'xmas_c16_elf6', 'xmas_c16_elf6', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9240, 9240, '0', 'xmas_c16_deskcandles', 'xmas_c16_deskcandles', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9241, 9241, '0', 'xmas_c16_elf4', 'xmas_c16_elf4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9242, 9242, '0', 'xmas_c16_creature6', 'xmas_c16_creature6', 'S', 1, 1, 2.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9243, 9243, '0', 'xmas_c16_food1', 'xmas_c16_food1', 'S', 2, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9244, 9244, '0', 'clothing_xmas2', 'clothing_xmas2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9245, 9245, '0', 'xmas_c16_rug', 'xmas_c16_rug', 'S', 2, 3, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(9246, 9246, '0', 'xmas_c16_creature9', 'xmas_c16_creature9', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9247, 9247, '0', 'clothing_r16_cathat', 'clothing_r16_cathat', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9248, 9248, '0', 'xmas_c16_sofa', 'xmas_c16_sofa', 'S', 2, 1, 1.25, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9249, 9249, '0', 'xmas_c16_tinychair', 'xmas_c16_tinychair', 'S', 2, 2, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9250, 9250, '0', 'xmas_c16_wall', 'xmas_c16_wall', 'S', 2, 1, 4.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9251, 9251, '0', 'xmas_c16_creature4', 'xmas_c16_creature4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'crackable', 23, '', '', '', 0, 0, ''),
	(9252, 9252, '0', 'clothing_xmas3', 'clothing_xmas3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9253, 9253, '0', 'xmas_c16_candles', 'xmas_c16_candles', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9254, 9254, '0', 'xmas_c16_elf2', 'xmas_c16_elf2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9255, 9255, '0', 'xmas_c16_pillarlight', 'xmas_c16_pillarlight', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9256, 9256, '0', 'xmas_c16_creature8', 'xmas_c16_creature8', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9257, 9257, '0', 'xmas_c16_mailshelf', 'xmas_c16_mailshelf', 'S', 1, 2, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '110', '', '', 0, 0, ''),
	(9258, 9258, '0', 'xmas_c16_creature2', 'xmas_c16_creature2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9259, 9259, '0', 'xmas_c16_elf5', 'xmas_c16_elf5', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9260, 9260, '0', 'xmas_r16_owl', 'xmas_r16_owl', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9261, 9261, '0', 'xmas_ltd16_bearbed', 'xmas_ltd16_bearbed', 'S', 1, 3, 1.50, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(9262, 9262, '0', 'clothing_xmas4', 'clothing_xmas4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9263, 9263, '0', 'clothing_longscarf', 'clothing_longscarf', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9264, 9264, '0', 'virus_r16_piratank', 'virus_r16_piratank', 'S', 1, 2, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9265, 9265, '0', 'virus_r16_crabtank', 'virus_r16_crabtank', 'S', 1, 2, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9266, 9266, '0', 'virus_r16_eeltank', 'virus_r16_eeltank', 'S', 1, 2, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9267, 9267, '0', 'virus_r16_troptank', 'virus_r16_troptank', 'S', 1, 2, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9268, 9268, '0', 'virus_r16_pufftank', 'virus_r16_pufftank', 'S', 1, 2, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9269, 9269, '0', 'virus_r16_turttank', 'virus_r16_turttank', 'S', 1, 2, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9270, 9270, '0', 'virus_r16_angtank', 'virus_r16_angtank', 'S', 1, 2, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9271, 9271, '1', 'classic5_sofa', 'classic5_sofa', 'S', 2, 1, 0.90, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9272, 9272, '1', 'classic5_table_yel', 'classic5_table_yel', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9273, 9273, '1', 'classic5_stage', 'classic5_stage', 'S', 2, 2, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9274, 9274, '1', 'classic5_speaker', 'classic5_speaker', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9275, 9275, '1', 'classic5_floor', 'classic5_floor', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9276, 9276, '1', 'classic5_wall', 'classic5_wall', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9277, 9277, '1', 'classic5_chair_blu', 'classic5_chair_blu', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9278, 9278, '1', 'classic5_stairs', 'classic5_stairs', 'S', 2, 1, 0.50, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9279, 9279, '1', 'classic5_chair_yel', 'classic5_chair_yel', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9280, 9280, '1', 'classic5_table_blu', 'classic5_table_blu', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9281, 9281, '0', 'bonusbag16_3', 'bonusbag16_3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(9282, 9282, '0', 'bonusrare16_7*1', 'bonusrare16_7*1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9283, 9283, '0', 'bonusrare16_7*2', 'bonusrare16_7*2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9284, 9284, '0', 'bonusrare16_7*3', 'bonusrare16_7*3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9285, 9285, '0', 'bonusrare16_7*4', 'bonusrare16_7*4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9286, 9286, '0', 'bonusrare16_7*5', 'bonusrare16_7*5', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9287, 9287, '0', 'bonusrare16_7*6', 'bonusrare16_7*6', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9288, 9288, '0', 'ny17_crackable', 'ny17_crackable', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'crackable', 1, '', '', '', 0, 0, ''),
	(9289, 9289, '0', 'clothing_r16_party14', 'clothing_r16_party14', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9290, 9290, '0', 'cny17_roosterballoon', 'cny17_roosterballoon', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9291, 9291, '0', 'clothing_r16_party13', 'clothing_r16_party13', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9292, 9292, '0', 'clothing_r16_party11', 'clothing_r16_party11', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9293, 9293, '0', 'clothing_r16_party9', 'clothing_r16_party9', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9294, 9294, '0', 'clothing_r16_party12', 'clothing_r16_party12', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9295, 9295, '0', 'clothing_r16_party10', 'clothing_r16_party10', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9296, 9296, '0', 'clothing_wink', 'clothing_wink', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9297, 9297, '0', 'clothing_love', 'clothing_love', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9298, 9298, '0', 'clothing_surprised', 'clothing_surprised', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9299, 9299, '0', 'clothing_happy', 'clothing_happy', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9300, 9300, '0', 'clothing_poop', 'clothing_poop', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9301, 9301, '0', 'clothing_angry', 'clothing_angry', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9302, 9302, '0', 'clothing_sad', 'clothing_sad', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9303, 9303, '0', 'clothing_excited', 'clothing_excited', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9304, 9304, '0', 'clothing_cool', 'clothing_cool', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9305, 9305, '0', 'clothing_shy', 'clothing_shy', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9306, 9306, '0', 'clothing_bobba', 'clothing_bobba', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9307, 9307, '0', 'clothing_silly', 'clothing_silly', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9308, 9308, '1', 'classic6_stool', 'classic6_stool', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9309, 9309, '1', 'classic6_sofa', 'classic6_sofa', 'S', 2, 1, 1.30, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9310, 9310, '1', 'classic6_tearice', 'classic6_tearice', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9311, 9311, '1', 'classic6_bigtable', 'classic6_bigtable', 'S', 2, 2, 1.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9312, 9312, '1', 'classic6_chair', 'classic6_chair', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9313, 9313, '1', 'classic6_endtable', 'classic6_endtable', 'S', 1, 1, 1.60, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9314, 9314, '1', 'classic6_lowtable', 'classic6_lowtable', 'S', 2, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9315, 9315, '1', 'classic6_lantern', 'classic6_lantern', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9316, 9316, '1', 'classic6_wall', 'classic6_wall', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9317, 9317, '1', 'classic6_woodfloor', 'classic6_woodfloor', 'S', 2, 2, 0.01, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9318, 9318, '1', 'classic6_stonecarpet', 'classic6_stonecarpet', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9319, 9319, '1', 'classic6_arch', 'classic6_arch', 'S', 2, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9320, 9320, '1', 'classic6_vase', 'classic6_vase', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(9321, 9321, '1', 'classic6_food', 'classic6_food', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 6, '', '', '', 0, 0, ''),
	(9322, 9322, '1', 'classic6_mat', 'classic6_mat', 'S', 2, 1, 0.01, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9323, 9323, '1', 'classic6_dvdr', 'classic6_dvdr', 'S', 2, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9324, 9324, '0', 'bc_gift_31days', 'bc_gift_31days', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'crackable_subscription_box', 1, '', '', '', 0, 0, ''),
	(9325, 9325, '0', 'hc_gift_14days', 'hc_gift_14days', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'crackable_subscription_box', 1, '', '', '', 0, 0, ''),
	(9326, 9326, '0', 'hc_gift_31days', 'hc_gift_31days', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'crackable_subscription_box', 1, '', '', '', 0, 0, ''),
	(9327, 9327, '0', 'bc_gift_14days', 'bc_gift_14days', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'crackable_subscription_box', 1, '', '', '', 0, 0, ''),
	(9328, 9328, '0', 'china_rooster', 'china_rooster', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9329, 9329, '0', 'rare_prize17*1', 'rare_prize17*1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9330, 9330, '0', 'rare_prize17*10', 'rare_prize17*10', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9331, 9331, '0', 'rare_prize17*11', 'rare_prize17*11', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9332, 9332, '0', 'rare_prize17*12', 'rare_prize17*12', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9333, 9333, '0', 'rare_prize17*13', 'rare_prize17*13', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9334, 9334, '0', 'rare_prize17*14', 'rare_prize17*14', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9335, 9335, '0', 'rare_prize17*2', 'rare_prize17*2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9336, 9336, '0', 'rare_prize17*3', 'rare_prize17*3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9337, 9337, '0', 'rare_prize17*4', 'rare_prize17*4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9338, 9338, '0', 'rare_prize17*5', 'rare_prize17*5', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9339, 9339, '0', 'rare_prize17*6', 'rare_prize17*6', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9340, 9340, '0', 'rare_prize17*7', 'rare_prize17*7', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9341, 9341, '0', 'rare_prize17*8', 'rare_prize17*8', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9342, 9342, '0', 'rare_prize17*9', 'rare_prize17*9', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9343, 9343, '0', 'bonusrare17_1*0', 'bonusrare17_1*0', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9344, 9344, '0', 'bonusrare17_1*1', 'bonusrare17_1*1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9345, 9345, '0', 'bonusrare17_1*2', 'bonusrare17_1*2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9346, 9346, '0', 'bonusrare17_1*3', 'bonusrare17_1*3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9347, 9347, '0', 'bonusrare17_1*4', 'bonusrare17_1*4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9348, 9348, '0', 'bonusrare17_1*5', 'bonusrare17_1*5', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9349, 9349, '0', 'bonusrare17_4*1', 'bonusrare17_4*1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9350, 9350, '0', 'bonusrare17_4*2', 'bonusrare17_4*2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9351, 9351, '0', 'bonusrare17_4*3', 'bonusrare17_4*3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9352, 9352, '0', 'bonusrare17_4*4', 'bonusrare17_4*4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9353, 9353, '0', 'bonusrare17_4*5', 'bonusrare17_4*5', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9354, 9354, '0', 'bonusrare17_4*6', 'bonusrare17_4*6', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9355, 9355, '0', 'bonusrare17_3*1', 'bonusrare17_3*1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9356, 9356, '0', 'bonusrare17_3*2', 'bonusrare17_3*2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9357, 9357, '0', 'bonusrare17_3*3', 'bonusrare17_3*3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9358, 9358, '0', 'bonusrare17_3*4', 'bonusrare17_3*4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9359, 9359, '0', 'bonusrare17_3*5', 'bonusrare17_3*5', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9360, 9360, '0', 'bonusrare17_3*6', 'bonusrare17_3*6', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9361, 9361, '0', 'bonusrare17_2*0', 'bonusrare17_2*0', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9362, 9362, '0', 'bonusrare17_2*1', 'bonusrare17_2*1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9363, 9363, '0', 'bonusrare17_2*2', 'bonusrare17_2*2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9364, 9364, '0', 'bonusrare17_2*3', 'bonusrare17_2*3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9365, 9365, '0', 'bonusrare17_2*4', 'bonusrare17_2*4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9366, 9366, '0', 'bonusrare17_2*5', 'bonusrare17_2*5', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9367, 9367, '1', 'classic7_gate', 'classic7_gate', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(9368, 9368, '1', 'classic7_stage', 'classic7_stage', 'S', 2, 2, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9369, 9369, '1', 'classic7_dvdr', 'classic7_dvdr', 'S', 2, 1, 1.30, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9370, 9370, '1', 'classic7_drinks', 'classic7_drinks', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9371, 9371, '1', 'classic7_table', 'classic7_table', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9372, 9372, '1', 'classic7_drinkdispenser', 'classic7_drinkdispenser', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '29,30', '', '', 0, 0, ''),
	(9373, 9373, '1', 'classic7_djbooth', 'classic7_djbooth', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9374, 9374, '1', 'classic7_floor', 'classic7_floor', 'S', 2, 2, 0.01, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9375, 9375, '1', 'classic7_starlight', 'classic7_starlight', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9376, 9376, '1', 'classic7_chair', 'classic7_chair', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9377, 9377, '1', 'classic7_tree', 'classic7_tree', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9378, 9378, '1', 'classic7_stairs', 'classic7_stairs', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9379, 9379, '1', 'classic7_wall', 'classic7_wall', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(9380, 9380, '1', 'classic7_drinkcabinet', 'classic7_drinkcabinet', 'S', 1, 3, 3.50, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '42,43,66', '', '', 0, 0, ''),
	(9381, 9381, '1', 'classic7_fridge', 'classic7_fridge', 'S', 1, 2, 3.50, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '42,43,66', '', '', 0, 0, ''),
	(9382, 9382, '1', 'classic7_crn', 'classic7_crn', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9383, 9383, '0', 'clothing_r17_wedveil', 'clothing_r17_wedveil', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9384, 9384, '0', 'clothing_r17_weddingdress', 'clothing_r17_weddingdress', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9385, 9385, '0', 'clothing_r17_weddingset', 'clothing_r17_weddingset', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9386, 9386, '0', 'val_c17_roseplant', 'val_c17_roseplant', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9387, 9387, '0', 'val_c17_chair', 'val_c17_chair', 'S', 1, 1, 0.80, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9388, 9388, '0', 'val_c17_rosedivider', 'val_c17_rosedivider', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 1, '', '', '', 0, 0, ''),
	(9389, 9389, '0', 'val_c17_bandstand', 'val_c17_bandstand', 'S', 3, 3, 0.40, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9390, 9390, '0', 'val_c17_vase', 'val_c17_vase', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9391, 9391, '0', 'val_r17_organltd', 'val_r17_organltd', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(9392, 9392, '0', 'clothing_goldpack2', 'clothing_goldpack2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9393, 9393, '0', 'exotic_r17_chamele', 'exotic_r17_chamele', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9394, 9394, '0', 'exotic_r17_treefrog', 'exotic_r17_treefrog', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9395, 9395, '0', 'exotic_r17_snake', 'exotic_r17_snake', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9396, 9396, '0', 'exotic_r17_chipmunk', 'exotic_r17_chipmunk', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9397, 9397, '0', 'exotic_r17_birds', 'exotic_r17_birds', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9398, 9398, '0', 'exotic_r17_bat', 'exotic_r17_bat', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9399, 9399, '0', 'exotic_r17_chinchil', 'exotic_r17_chinchil', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9400, 9400, '0', 'exotic_r17_sloth', 'exotic_r17_sloth', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9401, 9401, '0', 'mall_c17_tele', 'mall_c17_tele', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'teleport', 1, '', '', '', 0, 0, ''),
	(9402, 9402, '0', 'mall_c17_kiosk', 'mall_c17_kiosk', 'S', 1, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine_no_sides', 2, '29,30,34,36,37,38,42,83', '', '', 0, 0, ''),
	(9403, 9403, '0', 'mall_r17_coffeem', 'mall_r17_coffeem', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '41', '', '', 0, 0, ''),
	(9404, 9404, '0', 'easter_c17_fence2', 'easter_c17_fence2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9405, 9405, '0', 'clothing_apron', 'clothing_apron', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9406, 9406, '0', 'easter_c17_barngate', 'easter_c17_barngate', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 1, '', '', '', 0, 0, ''),
	(9407, 9407, '0', 'easter_c17_table', 'easter_c17_table', 'S', 2, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9408, 9408, '0', 'easter_c17_floweringbush', 'easter_c17_floweringbush', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'crackable', 1, '', '', '', 0, 0, ''),
	(9409, 9409, '0', 'easter_c17_appletree', 'easter_c17_appletree', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine_no_sides', 2, '83', '', '', 0, 0, ''),
	(9410, 9410, '0', 'clothing_r17_cow', 'clothing_r17_cow', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9411, 9411, '0', 'easter_c17_flour', 'easter_c17_flour', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9412, 9412, '0', 'easter_c17_combistove', 'easter_c17_combistove', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '0', '1', '0', '0', 'crafting', 2, '', '', '', 0, 0, ''),
	(9413, 9413, '0', 'clothing_crownbraid', 'clothing_crownbraid', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9414, 9414, '0', 'easter_c17_chickens', 'easter_c17_chickens', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(9415, 9415, '0', 'easter_ltd17_harvestgoddess', 'easter_ltd17_harvestgoddess', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9416, 9416, '0', 'easter_c17_egg', 'easter_c17_egg', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'crackable', 20, '', '', '', 0, 0, ''),
	(9417, 9417, '0', 'easter_c17_barn', 'easter_c17_barn', 'S', 2, 1, 4.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(9418, 9418, '0', 'easter_c17_fruitsalad', 'easter_c17_fruitsalad', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9419, 9419, '0', 'easter_c17_berrycupcake', 'easter_c17_berrycupcake', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9420, 9420, '0', 'easter_c17_fence', 'easter_c17_fence', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9421, 9421, '0', 'easter_c17_raspjam', 'easter_c17_raspjam', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9422, 9422, '0', 'easter_c17_gate', 'easter_c17_gate', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(9423, 9423, '0', 'easter_c17_pastries', 'easter_c17_pastries', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9424, 9424, '0', 'easter_c17_peachtree', 'easter_c17_peachtree', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine_no_sides', 2, '37', '', '', 0, 0, ''),
	(9425, 9425, '0', 'easter_c17_leafsprout', 'easter_c17_leafsprout', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'crackable', 1, '', '', '', 0, 0, ''),
	(9426, 9426, '0', 'clothing_r17_chicken', 'clothing_r17_chicken', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9427, 9427, '0', 'easter_c17_roof2', 'easter_c17_roof2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9428, 9428, '0', 'easter_c17_choctart', 'easter_c17_choctart', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9429, 9429, '0', 'easter_c17_peartree', 'easter_c17_peartree', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine_no_sides', 2, '36', '', '', 0, 0, ''),
	(9430, 9430, '0', 'easter_c17_windmill', 'easter_c17_windmill', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(9431, 9431, '0', 'easter_c17_strawbsbush', 'easter_c17_strawbsbush', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9432, 9432, '0', 'easter_c17_collie', 'easter_c17_collie', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9433, 9433, '0', 'easter_c17_sapling', 'easter_c17_sapling', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'crackable', 1, '', '', '', 0, 0, ''),
	(9434, 9434, '0', 'easter_c17_raspbush', 'easter_c17_raspbush', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9435, 9435, '0', 'easter_c17_strawbsjam', 'easter_c17_strawbsjam', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9436, 9436, '0', 'easter_c17_carrot', 'easter_c17_carrot', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9437, 9437, '0', 'easter_c17_choccupcake', 'easter_c17_choccupcake', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9438, 9438, '0', 'easter_c17_sprinkler', 'easter_c17_sprinkler', 'S', 2, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(9439, 9439, '0', 'easter_c17_coop', 'easter_c17_coop', 'S', 1, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9440, 9440, '0', 'cowbox', 'cowbox', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9441, 9441, '0', 'clothing_messyhalfbun', 'clothing_messyhalfbun', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9442, 9442, '0', 'easter_c17_tree', 'easter_c17_tree', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9443, 9443, '0', 'easter_r17_farmcutout', 'easter_r17_farmcutout', 'S', 2, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9444, 9444, '0', 'easter_c17_blkberrybush', 'easter_c17_blkberrybush', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9445, 9445, '0', 'easter_c17_seeds', 'easter_c17_seeds', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'crackable', 1, '', '', '', 0, 0, ''),
	(9446, 9446, '0', 'easter_c17_chocbunny', 'easter_c17_chocbunny', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9447, 9447, '0', 'easter_c17_seedbag', 'easter_c17_seedbag', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'crackable', 1, '', '', '', 0, 0, ''),
	(9448, 9448, '0', 'easter_c17_crn', 'easter_c17_crn', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9449, 9449, '0', 'easter_c17_carrotcake', 'easter_c17_carrotcake', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9450, 9450, '0', 'easter_c17_berrytart', 'easter_c17_berrytart', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9451, 9451, '0', 'easter_c17_farmsoil', 'easter_c17_farmsoil', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(9452, 9452, '0', 'cowbox_gold', 'cowbox_gold', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9453, 9453, '0', 'clothing_r17_horse', 'clothing_r17_horse', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9454, 9454, '0', 'easter_c17_beehive', 'easter_c17_beehive', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9455, 9455, '0', 'easter_c17_blkberryjam', 'easter_c17_blkberryjam', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9456, 9456, '0', 'easter_c17_roof', 'easter_c17_roof', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9457, 9457, '0', 'easter_c17_choc', 'easter_c17_choc', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9458, 9458, '0', 'easter_c17_sweetpastries', 'easter_c17_sweetpastries', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9459, 9459, '0', 'easter_c17_strawbscake', 'easter_c17_strawbscake', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9460, 9460, '0', 'easter_c17_chairs', 'easter_c17_chairs', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9461, 9461, '0', 'bonusbag17_1', 'bonusbag17_1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(9462, 9462, '1', 'santorini_c17_pottedplants', 'santorini_c17_pottedplants', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9463, 9463, '0', 'santorini_c17_artefact4', 'santorini_c17_artefact4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(9464, 9464, '1', 'santorini_c17_bar', 'santorini_c17_bar', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9465, 9465, '1', 'santorini_c17_arch', 'santorini_c17_arch', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9466, 9466, '1', 'santorini_c17_pottedshrub', 'santorini_c17_pottedshrub', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9467, 9467, '0', 'santorini_c17_artefact3', 'santorini_c17_artefact3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(9468, 9468, '1', 'santorini_c17_roof', 'santorini_c17_roof', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(9469, 9469, '1', 'santorini_c17_rockroof', 'santorini_c17_rockroof', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9470, 9470, '0', 'clothing_leafcrown', 'clothing_leafcrown', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9471, 9471, '1', 'santorini_c17_flowerdivider', 'santorini_c17_flowerdivider', 'S', 1, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9472, 9472, '0', 'clothing_hermeshat', 'clothing_hermeshat', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9473, 9473, '1', 'santorini_c17_rocks', 'santorini_c17_rocks', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 3, '', '1.0;2.0;3.0', '', 0, 0, ''),
	(9474, 9474, '1', 'santorini_c17_sand', 'santorini_c17_sand', 'S', 2, 2, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9475, 9475, '0', 'santorini_c17_artefact5', 'santorini_c17_artefact5', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(9476, 9476, '1', 'santorini_c17_food1', 'santorini_c17_food1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9477, 9477, '0', 'santorini_r17_chest', 'santorini_r17_chest', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(9478, 9478, '1', 'santorini_c17_trellis', 'santorini_c17_trellis', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9479, 9479, '0', 'clothing_hoplitehelm', 'clothing_hoplitehelm', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9480, 9480, '0', 'santorini_c17_artefact1', 'santorini_c17_artefact1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(9481, 9481, '0', 'santorini_c17_rockpool', 'santorini_c17_rockpool', 'S', 2, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine_no_sides', 2, '111', '', '', 0, 0, ''),
	(9482, 9482, '0', 'clothing_greektoga', 'clothing_greektoga', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9483, 9483, '1', 'santorini_c17_dividerend', 'santorini_c17_dividerend', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9484, 9484, '0', 'santorini_r17_chimera', 'santorini_r17_chimera', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9485, 9485, '0', 'santorini_r17_hydra', 'santorini_r17_hydra', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9486, 9486, '1', 'santorini_c17_rockstage', 'santorini_c17_rockstage', 'S', 2, 2, 0.90, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9487, 9487, '1', 'santorini_c17_donkey', 'santorini_c17_donkey', 'S', 1, 1, 2.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9488, 9488, '1', 'santorini_c17_pierend', 'santorini_c17_pierend', 'S', 2, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9489, 9489, '1', 'santorini_c17_ornatepots', 'santorini_c17_ornatepots', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9490, 9490, '0', 'santorini_c17_dolphin', 'santorini_c17_dolphin', 'S', 2, 2, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'water', 1, '', '', '', 29, 29, ''),
	(9491, 9491, '1', 'santorini_c17_mosaicfloor', 'santorini_c17_mosaicfloor', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9492, 9492, '0', 'clothing_hermesshoes', 'clothing_hermesshoes', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9493, 9493, '1', 'santorini_c17_rockcave', 'santorini_c17_rockcave', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9494, 9494, '1', 'santorini_c17_belltop', 'santorini_c17_belltop', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9495, 9495, '1', 'santorini_c17_gate', 'santorini_c17_gate', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(9496, 9496, '0', 'santorini_r17_centaur', 'santorini_r17_centaur', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9497, 9497, '0', 'santorini_ltd17_lighthouse', 'santorini_ltd17_lighthouse', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '1', '1', 'tent', 2, '', '', '', 0, 0, ''),
	(9498, 9498, '1', 'santorini_c17_divider', 'santorini_c17_divider', 'S', 1, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9499, 9499, '1', 'santorini_c17_piermid', 'santorini_c17_piermid', 'S', 2, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9500, 9500, '1', 'santorini_c17_house', 'santorini_c17_house', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(9501, 9501, '1', 'santorini_c17_table', 'santorini_c17_table', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9502, 9502, '0', 'santorini_c17_artefact2', 'santorini_c17_artefact2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(9503, 9503, '0', 'santorini_r17_minotaur', 'santorini_r17_minotaur', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9504, 9504, '1', 'santorini_c17_chair', 'santorini_c17_chair', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9505, 9505, '0', 'clothing_octohat', 'clothing_octohat', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9506, 9506, '1', 'santorini_c17_pebblefloor', 'santorini_c17_pebblefloor', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9507, 9507, '0', 'santorini_c17_lighthouse', 'santorini_c17_lighthouse', 'S', 2, 2, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'tent', 2, '', '', '', 0, 0, ''),
	(9508, 9508, '1', 'santorini_c17_stairs', 'santorini_c17_stairs', 'S', 1, 1, 0.50, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9509, 9509, '1', 'santorini_c17_food2', 'santorini_c17_food2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(9510, 9510, '1', 'santorini_c17_rockfloat', 'santorini_c17_rockfloat', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9511, 9511, '0', 'scifi_r17_bed', 'scifi_r17_bed', 'S', 1, 3, 0.00, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9512, 9512, '0', 'scifi_c17_xcannon', 'scifi_c17_xcannon', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9513, 9513, '0', 'scifi_c17_airlock', 'scifi_c17_airlock', 'S', 4, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 1, '', '', '', 0, 0, ''),
	(9514, 9514, '0', 'clothing_r17_explorerhelm', 'clothing_r17_explorerhelm', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9515, 9515, '0', 'scifi_r17_cruiser', 'scifi_r17_cruiser', 'S', 2, 3, 9.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9516, 9516, '0', 'scifi_ltd17_mech', 'scifi_ltd17_mech', 'S', 1, 1, 0.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9517, 9517, '0', 'clothing_r17_sentinelhelm', 'clothing_r17_sentinelhelm', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9518, 9518, '0', 'clothing_facehugger', 'clothing_facehugger', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9519, 9519, '0', 'modern_c17_sofa', 'modern_c17_sofa', 'S', 2, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9520, 9520, '0', 'modern_c17_pictures', 'modern_c17_pictures', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 7, '', '', '', 0, 0, ''),
	(9521, 9521, '0', 'modern_c17_pug', 'modern_c17_pug', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(9522, 9522, '0', 'modern_c17_lamp', 'modern_c17_lamp', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9523, 9523, '0', 'modern_c17_bed', 'modern_c17_bed', 'S', 2, 3, 1.80, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(9524, 9524, '0', 'modern_c17_lowtable', 'modern_c17_lowtable', 'S', 1, 3, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(9525, 9525, '0', 'modern_c17_folder', 'modern_c17_folder', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 8, '', '', '', 0, 0, ''),
	(9526, 9526, '0', 'modern_c17_reads', 'modern_c17_reads', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9527, 9527, '0', 'modern_c17_rug', 'modern_c17_rug', 'S', 2, 3, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9528, 9528, '0', 'modern_c17_incense', 'modern_c17_incense', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(9529, 9529, '0', 'modern_c17_plant', 'modern_c17_plant', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(9530, 9530, '0', 'modern_c17_display', 'modern_c17_display', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9531, 9531, '0', 'modern_c17_pillow', 'modern_c17_pillow', 'S', 1, 1, 0.80, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(9532, 9532, '0', 'modern_c17_tv', 'modern_c17_tv', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 6, '', '', '', 0, 0, ''),
	(9533, 9533, '0', 'modern_c17_floor', 'modern_c17_floor', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9534, 9534, '0', 'modern_c17_photos', 'modern_c17_photos', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9535, 9535, '0', 'modern_c17_desk', 'modern_c17_desk', 'S', 1, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9536, 9536, '0', 'modern_c17_wall', 'modern_c17_wall', 'S', 2, 1, 3.70, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 6, '', '', '', 0, 0, ''),
	(9537, 9537, '0', 'modern_c17_iscreen', 'modern_c17_iscreen', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 7, '', '', '', 0, 0, ''),
	(9538, 9538, '0', 'modern_c17_floorlamp', 'modern_c17_floorlamp', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9539, 9539, '0', 'modern_c17_creative', 'modern_c17_creative', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(9540, 9540, '0', 'modern_c17_chair', 'modern_c17_chair', 'S', 1, 1, 1.30, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9541, 9541, '0', 'modern_c17_speakers', 'modern_c17_speakers', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9542, 9542, '0', 'modern_c17_shelf', 'modern_c17_shelf', 'S', 1, 2, 1.90, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9543, 9543, '0', 'modern_c17_endtable', 'modern_c17_endtable', 'S', 1, 1, 1.30, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9544, 9544, '0', 'clothing_toxicfacehugger', 'clothing_toxicfacehugger', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9545, 9545, '0', 'summer_c17_merchstall', 'summer_c17_merchstall', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(9546, 9546, '0', 'summer_c17_astrotelescope', 'summer_c17_astrotelescope', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9547, 9547, '0', 'summer_c17_burgertruck', 'summer_c17_burgertruck', 'S', 2, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'vendingmachine', 2, '109', '', '', 0, 0, ''),
	(9548, 9548, '0', 'summer_c17_promenadelamp', 'summer_c17_promenadelamp', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9549, 9549, '0', 'bonusbag17_2', 'bonusbag17_2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(9550, 9550, '0', 'bazaar_c17_lampbluepinktrim', 'bazaar_c17_lampbluepinktrim', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9551, 9551, '0', 'bazaar_c17_pillowbluepinktrim', 'bazaar_c17_pillowbluepinktrim', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9552, 9552, '0', 'bazaar_c17_lampyellow', 'bazaar_c17_lampyellow', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9553, 9553, '0', 'bazaar_c17_curtainblue', 'bazaar_c17_curtainblue', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9554, 9554, '0', 'bazaar_c17_lamppurple', 'bazaar_c17_lamppurple', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9555, 9555, '0', 'bazaar_c17_curtainyellowbluetrim', 'bazaar_c17_curtainyellowbluetrim', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9556, 9556, '0', 'bazaar_c17_ruggreen', 'bazaar_c17_ruggreen', 'S', 3, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9557, 9557, '1', 'bazaar_c17_pots', 'bazaar_c17_pots', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(9558, 9558, '1', 'bazaar_c17_fruitbasket', 'bazaar_c17_fruitbasket', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(9559, 9559, '0', 'bazaar_c17_rugrolls', 'bazaar_c17_rugrolls', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9560, 9560, '0', 'bazaar_c17_rugpurpleyellowtrim', 'bazaar_c17_rugpurpleyellowtrim', 'S', 3, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9561, 9561, '0', 'bazaar_c17_vasepinkbluetrim', 'bazaar_c17_vasepinkbluetrim', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9562, 9562, '0', 'clothing_exoticbeard', 'clothing_exoticbeard', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9563, 9563, '0', 'bazaar_c17_vasebluepinktrim', 'bazaar_c17_vasebluepinktrim', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9564, 9564, '1', 'bazaar_c17_basket', 'bazaar_c17_basket', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9565, 9565, '1', 'bazaar_c17_camel', 'bazaar_c17_camel', 'S', 1, 1, 3.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9566, 9566, '0', 'bazaar_c17_pillowmystic', 'bazaar_c17_pillowmystic', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9567, 9567, '0', 'bazaar_c17_pillowgreenpurpletrim', 'bazaar_c17_pillowgreenpurpletrim', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9568, 9568, '0', 'bazaar_c17_vasepurple', 'bazaar_c17_vasepurple', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9569, 9569, '0', 'bazaar_c17_curtaingreen', 'bazaar_c17_curtaingreen', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(9570, 9570, '0', 'clothing_alluringeyes', 'clothing_alluringeyes', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9571, 9571, '0', 'bazaar_c17_vasegreenpurpletrim', 'bazaar_c17_vasegreenpurpletrim', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9572, 9572, '0', 'bazaar_c17_curtaingreenpurpletrim', 'bazaar_c17_curtaingreenpurpletrim', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9573, 9573, '0', 'bazaar_c17_rugblue', 'bazaar_c17_rugblue', 'S', 3, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9574, 9574, '0', 'bazaar_c17_dyemystic', 'bazaar_c17_dyemystic', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9575, 9575, '0', 'bazaar_c17_pillowpurple', 'bazaar_c17_pillowpurple', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9576, 9576, '0', 'bazaar_r17_throne', 'bazaar_r17_throne', 'S', 0, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9577, 9577, '0', 'bazaar_c17_rugyellowbluetrim', 'bazaar_c17_rugyellowbluetrim', 'S', 3, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9578, 9578, '0', 'bazaar_c17_vaseblue', 'bazaar_c17_vaseblue', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9579, 9579, '0', 'bazaar_ltd17_ele', 'bazaar_ltd17_ele', 'S', 0, 2, 3.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9580, 9580, '0', 'bazaar_c17_vaseyellowbluetrim', 'bazaar_c17_vaseyellowbluetrim', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9581, 9581, '0', 'bazaar_c17_dyeblue', 'bazaar_c17_dyeblue', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9582, 9582, '0', 'bazaar_c17_dyegreen', 'bazaar_c17_dyegreen', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9583, 9583, '0', 'bazaar_c17_curtainpinkbluetrim', 'bazaar_c17_curtainpinkbluetrim', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9584, 9584, '0', 'bazaar_c17_lampmystic', 'bazaar_c17_lampmystic', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9585, 9585, '1', 'bazaar_c17_curtain', 'bazaar_c17_curtain', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 1, '', '', '', 0, 0, ''),
	(9586, 9586, '0', 'bazaar_c17_pillowyellow', 'bazaar_c17_pillowyellow', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9587, 9587, '0', 'bazaar_c17_rugmystic', 'bazaar_c17_rugmystic', 'S', 3, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9588, 9588, '0', 'bazaar_c17_rugbluepinktrim', 'bazaar_c17_rugbluepinktrim', 'S', 3, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9589, 9589, '1', 'bazaar_c17_flycarpet', 'bazaar_c17_flycarpet', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9590, 9590, '0', 'clothing_exoticvest', 'clothing_exoticvest', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9591, 9591, '1', 'bazaar_c17_sticklizard', 'bazaar_c17_sticklizard', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine_no_sides', 2, '1078', '', '', 0, 0, ''),
	(9592, 9592, '0', 'bazaar_c17_lampblue', 'bazaar_c17_lampblue', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9593, 9593, '0', 'bazaar_c17_pillowblue', 'bazaar_c17_pillowblue', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9594, 9594, '1', 'bazaar_c17_clothroof2', 'bazaar_c17_clothroof2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9595, 9595, '1', 'bazaar_c17_marketroofsmall', 'bazaar_c17_marketroofsmall', 'S', 2, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9596, 9596, '0', 'bazaar_c17_curtainbluepinktrim', 'bazaar_c17_curtainbluepinktrim', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(9597, 9597, '1', 'bazaar_c17_balcony', 'bazaar_c17_balcony', 'S', 0, 2, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9598, 9598, '0', 'bazaar_c17_dyeyellow', 'bazaar_c17_dyeyellow', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9599, 9599, '0', 'bazaar_c17_lampyellowbluetrim', 'bazaar_c17_lampyellowbluetrim', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9600, 9600, '0', 'clothing_bazaarfemale', 'clothing_bazaarfemale', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9601, 9601, '0', 'bazaar_c17_ruggreenpurpletrim', 'bazaar_c17_ruggreenpurpletrim', 'S', 3, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9602, 9602, '0', 'bazaar_c17_pillowyellowbluetrim', 'bazaar_c17_pillowyellowbluetrim', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9603, 9603, '0', 'bazaar_c17_colourbucket', 'bazaar_c17_colourbucket', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '0', '1', '0', '0', 'crafting', 2, '', '', '', 0, 0, ''),
	(9604, 9604, '0', 'bazaar_c17_vasegreen', 'bazaar_c17_vasegreen', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9605, 9605, '1', 'bazaar_c17_meat', 'bazaar_c17_meat', 'S', 0, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9606, 9606, '0', 'bazaar_c17_curtainpurple', 'bazaar_c17_curtainpurple', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9607, 9607, '0', 'bazaar_c17_vasepink', 'bazaar_c17_vasepink', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9608, 9608, '1', 'bazaar_c17_building', 'bazaar_c17_building', 'S', 2, 1, 4.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 8, '', '', '', 0, 0, ''),
	(9609, 9609, '0', 'bazaar_c17_lampgreen', 'bazaar_c17_lampgreen', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9610, 9610, '0', 'bazaar_c17_vaseyellow', 'bazaar_c17_vaseyellow', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9611, 9611, '0', 'bazaar_c17_dyepink', 'bazaar_c17_dyepink', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9612, 9612, '0', 'bazaar_c17_rugpinkbluetrim', 'bazaar_c17_rugpinkbluetrim', 'S', 3, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9613, 9613, '0', 'bazaar_c17_vasemystic', 'bazaar_c17_vasemystic', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9614, 9614, '0', 'bazaar_c17_vasepurpleyellowtrim', 'bazaar_c17_vasepurpleyellowtrim', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9615, 9615, '0', 'clothing_pointyshoes', 'clothing_pointyshoes', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9616, 9616, '0', 'bazaar_c17_scorpion', 'bazaar_c17_scorpion', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9617, 9617, '1', 'bazaar_c17_bubblejuiceblower', 'bazaar_c17_bubblejuiceblower', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine_no_sides', 2, '19', '', '', 0, 0, ''),
	(9618, 9618, '0', 'bazaar_c17_rugyellow', 'bazaar_c17_rugyellow', 'S', 3, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9619, 9619, '0', 'bazaar_c17_lamppink', 'bazaar_c17_lamppink', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9620, 9620, '0', 'bazaar_c17_rugpink', 'bazaar_c17_rugpink', 'S', 3, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9621, 9621, '0', 'bazaar_c17_dyepurple', 'bazaar_c17_dyepurple', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9622, 9622, '1', 'bazaar_c17_rug', 'bazaar_c17_rug', 'S', 3, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9623, 9623, '0', 'clothing_exotictop', 'clothing_exotictop', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9624, 9624, '0', 'clothing_r17_cursedmask', 'clothing_r17_cursedmask', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9625, 9625, '1', 'bazaar_c17_displaytable', 'bazaar_c17_displaytable', 'S', 2, 1, 0.30, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 3, '', '0.3;0.9;1.4', '', 0, 0, ''),
	(9626, 9626, '1', 'bazaar_c17_spice', 'bazaar_c17_spice', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9627, 9627, '1', 'bazaar_c17_lamp', 'bazaar_c17_lamp', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9628, 9628, '0', 'bazaar_c17_pillowpinkbluetrim', 'bazaar_c17_pillowpinkbluetrim', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9629, 9629, '0', 'bazaar_c17_pillowpurpleyellowtrim', 'bazaar_c17_pillowpurpleyellowtrim', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9630, 9630, '0', 'bazaar_r17_fountain', 'bazaar_r17_fountain', 'S', 0, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '18', '', '', 0, 0, ''),
	(9631, 9631, '0', 'bazaar_c17_curtainpink', 'bazaar_c17_curtainpink', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9632, 9632, '1', 'bazaar_c17_pillow', 'bazaar_c17_pillow', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9633, 9633, '0', 'bazaar_c17_pillowgreen', 'bazaar_c17_pillowgreen', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9634, 9634, '1', 'bazaar_c17_marketroofbig', 'bazaar_c17_marketroofbig', 'S', 2, 3, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9635, 9635, '1', 'bazaar_c17_chillies', 'bazaar_c17_chillies', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine_no_sides', 2, '112', '', '', 0, 0, ''),
	(9636, 9636, '0', 'bazaar_c17_curtainpurpleyellowtrim', 'bazaar_c17_curtainpurpleyellowtrim', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9637, 9637, '0', 'bazaar_c17_curtainyellow', 'bazaar_c17_curtainyellow', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9638, 9638, '0', 'bazaar_c17_lamppinkbluetrim', 'bazaar_c17_lamppinkbluetrim', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9639, 9639, '0', 'bazaar_c17_pillowpink', 'bazaar_c17_pillowpink', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9640, 9640, '0', 'bazaar_c17_lampgreenpurpletrim', 'bazaar_c17_lampgreenpurpletrim', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9641, 9641, '0', 'bazaar_c17_rugpurple', 'bazaar_c17_rugpurple', 'S', 3, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9642, 9642, '0', 'bazaar_c17_curtainmystic', 'bazaar_c17_curtainmystic', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(9643, 9643, '0', 'bazaar_r17_monkey', 'bazaar_r17_monkey', 'S', 0, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9644, 9644, '0', 'bazaar_c17_lamppurpleyellowtrim', 'bazaar_c17_lamppurpleyellowtrim', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9645, 9645, '1', 'bazaar_c17_vase', 'bazaar_c17_vase', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9646, 9646, '0', 'clothing_harempants', 'clothing_harempants', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9647, 9647, '1', 'bazaar_c17_clothroof', 'bazaar_c17_clothroof', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9648, 9648, '0', 'clothing_bazaarmale', 'clothing_bazaarmale', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9649, 9649, '1', 'bazaar_c17_arch', 'bazaar_c17_arch', 'S', 2, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9650, 9650, '0', 'summer_r17_sealion', 'summer_r17_sealion', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9651, 9651, '0', 'clothing_r17_boxerbraids', 'clothing_r17_boxerbraids', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9652, 9652, '0', 'summer_r17_fishingboat', 'summer_r17_fishingboat', 'S', 2, 4, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9653, 9653, '0', 'clothing_r17_sharkmask', 'clothing_r17_sharkmask', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9654, 9654, '0', 'bazaar_c17_eleengage', 'bazaar_c17_eleengage', 'S', 2, 2, 1.00, '0', '1', '0', '0', '1', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9655, 9655, '0', 'clothing_flipflopsocks', 'clothing_flipflopsocks', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9656, 9656, '0', 'rare_colourable_marquee*2', 'rare_colourable_marquee*2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(9657, 9657, '0', 'rare_colourable_scifirocket*2', 'rare_colourable_scifirocket*2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9658, 9658, '0', 'rare_colourable_fountain*2', 'rare_colourable_fountain*2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9659, 9659, '0', 'rare_colourable_wooden_screen*2', 'rare_colourable_wooden_screen*2', 'S', 1, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9660, 9660, '0', 'rare_colourable_dragonlamp*2', 'rare_colourable_dragonlamp*2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9661, 9661, '0', 'rare_colourable_parasol*2', 'rare_colourable_parasol*2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9662, 9662, '0', 'rare_colourable_sleepingbag*2', 'rare_colourable_sleepingbag*2', 'S', 1, 3, 0.80, '0', '0', '1', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9663, 9663, '0', 'rare_colourable_pillar*2', 'rare_colourable_pillar*2', 'S', 1, 1, 3.50, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9664, 9664, '0', 'rare_colourable_beehive_bulb*2', 'rare_colourable_beehive_bulb*2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9665, 9665, '0', 'rare_colourable_icecream*2', 'rare_colourable_icecream*2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'vendingmachine', 2, '4', '', '', 0, 0, ''),
	(9666, 9666, '0', 'rare_colourable_elephant_statue*2', 'rare_colourable_elephant_statue*2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9667, 9667, '0', 'hhistory_r17_crackable', 'hhistory_r17_crackable', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(9668, 9668, '0', 'rare_colourable_scifidoor*2', 'rare_colourable_scifidoor*2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(9669, 9669, '0', 'rare_colourable_fan*2', 'rare_colourable_fan*2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9670, 9670, '0', 'rare_colourable_pillow*2', 'rare_colourable_pillow*2', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9671, 9671, '0', 'rare_colourable_scifiport*2', 'rare_colourable_scifiport*2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(9672, 9672, '0', 'rare_colourable_barrier*2', 'rare_colourable_barrier*2', 'S', 1, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9673, 9673, '0', 'dessertcafe_c17_armchair', 'dessertcafe_c17_armchair', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9674, 9674, '0', 'dessertcafe_c17_windoor', 'dessertcafe_c17_windoor', 'S', 1, 2, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9675, 9675, '0', 'clothing_cutie', 'clothing_cutie', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9676, 9676, '0', 'dessertcafe_c17_creamrolls', 'dessertcafe_c17_creamrolls', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9677, 9677, '0', 'dessertcafe_c17_teaplant', 'dessertcafe_c17_teaplant', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9678, 9678, '0', 'dessertcafe_c17_vase', 'dessertcafe_c17_vase', 'S', 1, 1, 0.01, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9679, 9679, '0', 'dessertcafe_c17_table', 'dessertcafe_c17_table', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9680, 9680, '0', 'dessertcafe_c17_floor', 'dessertcafe_c17_floor', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9681, 9681, '0', 'dessertcafe_c17_donut', 'dessertcafe_c17_donut', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9682, 9682, '0', 'dessertcafe_c17_glass', 'dessertcafe_c17_glass', 'S', 1, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9683, 9683, '0', 'dessertcafe_c17_shelf', 'dessertcafe_c17_shelf', 'S', 1, 2, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 2, '', '0.2;1.0', '', 0, 0, ''),
	(9684, 9684, '0', 'dessertcafe_c17_rug', 'dessertcafe_c17_rug', 'S', 2, 3, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9685, 9685, '0', 'clothing_maidband', 'clothing_maidband', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9686, 9686, '0', 'dessertcafe_c17_coffeetable', 'dessertcafe_c17_coffeetable', 'S', 2, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9687, 9687, '0', 'dessertcafe_c17_sofa', 'dessertcafe_c17_sofa', 'S', 2, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9688, 9688, '0', 'clothing_bowtights', 'clothing_bowtights', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9689, 9689, '0', 'dessertcafe_c17_counter', 'dessertcafe_c17_counter', 'S', 1, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9690, 9690, '0', 'clothing_maid', 'clothing_maid', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9691, 9691, '0', 'dessertcafe_c17_mochi', 'dessertcafe_c17_mochi', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9692, 9692, '0', 'clothing_ribbonband', 'clothing_ribbonband', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9693, 9693, '0', 'dessertcafe_c17_wall', 'dessertcafe_c17_wall', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9694, 9694, '0', 'dessertcafe_c17_froyo', 'dessertcafe_c17_froyo', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9695, 9695, '0', 'elegant_c17_window', 'elegant_c17_window', 'S', 2, 1, 5.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9696, 9696, '0', 'elegant_c17_vanity', 'elegant_c17_vanity', 'S', 2, 1, 1.20, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9697, 9697, '0', 'elegantp_c17_sofa', 'elegantp_c17_sofa', 'S', 2, 1, 1.50, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9698, 9698, '0', 'elegantp_c17_chair', 'elegantp_c17_chair', 'S', 1, 1, 1.50, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9699, 9699, '0', 'elegant_c17_flowerpot', 'elegant_c17_flowerpot', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9700, 9700, '0', 'elegant_c17_sofa', 'elegant_c17_sofa', 'S', 2, 1, 1.50, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9701, 9701, '0', 'elegant_c17_bed', 'elegant_c17_bed', 'S', 2, 3, 2.00, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9702, 9702, '0', 'elegant_c17_teaset', 'elegant_c17_teaset', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9703, 9703, '0', 'elegant_c17_stool', 'elegant_c17_stool', 'S', 1, 1, 1.50, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9704, 9704, '0', 'elegant_c17_smalltable', 'elegant_c17_smalltable', 'S', 1, 1, 1.30, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9705, 9705, '0', 'elegant_c17_floor', 'elegant_c17_floor', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9706, 9706, '0', 'elegantp_c17_stool', 'elegantp_c17_stool', 'S', 1, 1, 1.50, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9707, 9707, '0', 'elegant_c17_carpet', 'elegant_c17_carpet', 'S', 3, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9708, 9708, '0', 'elegantp_c17_cat', 'elegantp_c17_cat', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9709, 9709, '0', 'elegant_c17_wall', 'elegant_c17_wall', 'S', 2, 1, 5.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9710, 9710, '0', 'clothing_r17_elegantcrown', 'clothing_r17_elegantcrown', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9711, 9711, '0', 'elegant_c17_chair', 'elegant_c17_chair', 'S', 1, 1, 1.50, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9712, 9712, '0', 'elegantp_c17_window', 'elegantp_c17_window', 'S', 2, 1, 5.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9713, 9713, '0', 'elegant_c17_cat', 'elegant_c17_cat', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9714, 9714, '0', 'elegantp_c17_bed', 'elegantp_c17_bed', 'S', 2, 3, 2.00, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9715, 9715, '0', 'elegantp_c17_carpet', 'elegantp_c17_carpet', 'S', 3, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9716, 9716, '0', 'elegant_c17_cupboard', 'elegant_c17_cupboard', 'S', 1, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9717, 9717, '0', 'elegant_c17_light', 'elegant_c17_light', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9718, 9718, '0', 'elegant_c17_walldecor', 'elegant_c17_walldecor', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9719, 9719, '0', 'elegant_c17_table', 'elegant_c17_table', 'S', 2, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9720, 9720, '0', 'elegantp_c17_flowerpot', 'elegantp_c17_flowerpot', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9721, 9721, '0', 'hween_c17_monstertele', 'hween_c17_monstertele', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'teleport', 1, '', '', '', 0, 0, ''),
	(9722, 9722, '0', 'hween_c17_zombiegrunt', 'hween_c17_zombiegrunt', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9723, 9723, '0', 'hween_ltd17_dragon', 'hween_ltd17_dragon', 'S', 1, 2, 0.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9724, 9724, '0', 'hween_c17_hangingroots', 'hween_c17_hangingroots', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 6, '', '', '', 0, 0, ''),
	(9725, 9725, '0', 'hween_c17_fallingrocks', 'hween_c17_fallingrocks', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'pressureplate', 2, '', '', '', 0, 0, ''),
	(9726, 9726, '0', 'hween_c17_zombiesleep', 'hween_c17_zombiesleep', 'S', 1, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9727, 9727, '0', 'clothing_badasshelmet', 'clothing_badasshelmet', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9728, 9728, '0', 'clothing_layerbuns', 'clothing_layerbuns', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9729, 9729, '0', 'hween_c17_mimic', 'hween_c17_mimic', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9730, 9730, '0', 'hween_r17_lichthrone', 'hween_r17_lichthrone', 'S', 1, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'multiheight', 2, '', '1.2;1.7', '', 0, 0, ''),
	(9731, 9731, '0', 'clothing_demoneyes', 'clothing_demoneyes', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9732, 9732, '0', 'hween_c17_thefallen', 'hween_c17_thefallen', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9733, 9733, '0', 'clothing_herochest', 'clothing_herochest', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9734, 9734, '0', 'clothing_rebelchest', 'clothing_rebelchest', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9735, 9735, '0', 'hween_c17_rat', 'hween_c17_rat', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9736, 9736, '0', 'hween_c17_rockdrip', 'hween_c17_rockdrip', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9737, 9737, '0', 'clothing_r17_bathat', 'clothing_r17_bathat', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9738, 9738, '0', 'clothing_herohelmet', 'clothing_herohelmet', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9739, 9739, '0', 'clothing_legarmour', 'clothing_legarmour', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9740, 9740, '0', 'hween_c17_lichen', 'hween_c17_lichen', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9741, 9741, '0', 'hween_c17_bonfire', 'hween_c17_bonfire', 'S', 2, 2, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9742, 9742, '0', 'hween_c17_hidewall', 'hween_c17_hidewall', 'S', 1, 2, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9743, 9743, '0', 'hween_c17_rock', 'hween_c17_rock', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 8, '', '', '', 0, 0, ''),
	(9744, 9744, '0', 'clothing_plaguemask', 'clothing_plaguemask', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9745, 9745, '0', 'hween_dragengage', 'hween_dragengage', 'S', 1, 1, 2.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9746, 9746, '0', 'hween_c17_portcullis', 'hween_c17_portcullis', 'S', 1, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 1, '', '', '', 0, 0, ''),
	(9747, 9747, '0', 'hween_c17_pillar', 'hween_c17_pillar', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9748, 9748, '0', 'hween_r17_ancdrago', 'hween_r17_ancdrago', 'S', 1, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9749, 9749, '0', 'clothing_r17_hweencrown', 'clothing_r17_hweencrown', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9750, 9750, '0', 'hween_c17_shroomthing', 'hween_c17_shroomthing', 'S', 1, 1, 2.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9751, 9751, '0', 'hween_c17_handstrap', 'hween_c17_handstrap', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'trap', 2, '', '', '', 163, 163, ''),
	(9752, 9752, '0', 'hween_c17_gibbet', 'hween_c17_gibbet', 'S', 1, 1, 2.60, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9753, 9753, '0', 'hween_c17_flamingknight', 'hween_c17_flamingknight', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'crackable', 20, '', '', '', 0, 0, ''),
	(9754, 9754, '0', 'hween_c17_wall', 'hween_c17_wall', 'S', 1, 2, 3.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9755, 9755, '0', 'clothing_zombieeyes', 'clothing_zombieeyes', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9756, 9756, '0', 'hween_c17_pillarsmall', 'hween_c17_pillarsmall', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9757, 9757, '0', 'hween_c17_cavefloor', 'hween_c17_cavefloor', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 4, '', '0;0.5;1.0;1.5;2.0', '', 0, 0, ''),
	(9758, 9758, '0', 'hween_c17_spiketrap', 'hween_c17_spiketrap', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'trap', 2, '', '', '', 0, 0, ''),
	(9759, 9759, '0', 'hween_c17_tent', 'hween_c17_tent', 'S', 2, 3, 1.00, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'tent', 1, '', '', '', 0, 0, ''),
	(9760, 9760, '0', 'clothing_shoearmour', 'clothing_shoearmour', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9761, 9761, '0', 'hween_c17_torturebed', 'hween_c17_torturebed', 'S', 1, 3, 1.40, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9762, 9762, '0', 'hween_c17_rock2', 'hween_c17_rock2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 8, '', '', '', 0, 0, ''),
	(9763, 9763, '0', 'bonusbag17_3', 'bonusbag17_3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(9764, 9764, '0', 'bonusbag17_4', 'bonusbag17_4', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(9765, 9765, '0', 'america_r17_beaver', 'america_r17_beaver', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9766, 9766, '0', 'chess_w_bishop', 'chess_w_bishop', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9767, 9767, '0', 'chess_boardtile', 'chess_boardtile', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9768, 9768, '0', 'chess_b_rook', 'chess_b_rook', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9769, 9769, '0', 'chess_b_knight', 'chess_b_knight', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9770, 9770, '0', 'chess_w_rook', 'chess_w_rook', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9771, 9771, '0', 'chess_w_queen', 'chess_w_queen', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9772, 9772, '0', 'chess_w_king', 'chess_w_king', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9773, 9773, '0', 'chess_w_pawn', 'chess_w_pawn', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9774, 9774, '0', 'chess_b_king', 'chess_b_king', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9775, 9775, '0', 'chess_b_bishop', 'chess_b_bishop', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9776, 9776, '0', 'chess_b_pawn', 'chess_b_pawn', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9777, 9777, '0', 'chess_b_queen', 'chess_b_queen', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9778, 9778, '0', 'chess_w_knight', 'chess_w_knight', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9779, 9779, '0', 'america_r17_skunk', 'america_r17_skunk', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9780, 9780, '0', 'clothing_r17_daveycrockett', 'clothing_r17_daveycrockett', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9781, 9781, '0', 'clothing_r17_frontierbraids', 'clothing_r17_frontierbraids', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9782, 9782, '0', 'america_r17_opossum', 'america_r17_opossum', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9783, 9783, '0', 'america_r17_raccoon', 'america_r17_raccoon', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9784, 9784, '0', 'america_r17_eagle', 'america_r17_eagle', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9785, 9785, '0', 'america_r17_armadillo', 'america_r17_armadillo', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9786, 9786, '0', 'clothing_r17_goldtophat', 'clothing_r17_goldtophat', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9787, 9787, '0', 'xmas_c17_britishbulldog', 'xmas_c17_britishbulldog', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9788, 9788, '0', 'xmas_c17_girl', 'xmas_c17_girl', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9789, 9789, '0', 'xmas_c17_man', 'xmas_c17_man', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9790, 9790, '0', 'xmas_c17_blueprint3', 'xmas_c17_blueprint3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9791, 9791, '0', 'xmas_c17_snowybasket', 'xmas_c17_snowybasket', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9792, 9792, '0', 'xmas_c17_doll2', 'xmas_c17_doll2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9793, 9793, '0', 'xmas_c17_blueprint6', 'xmas_c17_blueprint6', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9794, 9794, '0', 'xmas_c17_sewingmchn', 'xmas_c17_sewingmchn', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '0', '1', '0', '0', 'crafting', 2, '', '', '', 0, 0, ''),
	(9795, 9795, '0', 'xmas_c17_roof', 'xmas_c17_roof', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9796, 9796, '0', 'xmas_c17_door', 'xmas_c17_door', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9797, 9797, '0', 'xmas_c17_hatshop', 'xmas_c17_hatshop', 'S', 2, 1, 4.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9798, 9798, '0', 'xmas_c17_doll4', 'xmas_c17_doll4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9799, 9799, '0', 'xmas_ltd17_ted', 'xmas_ltd17_ted', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9800, 9800, '0', 'xmas_c17_stove', 'xmas_c17_stove', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9801, 9801, '0', 'xmas_c17_blueprint5', 'xmas_c17_blueprint5', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9802, 9802, '0', 'xmas_c17_hangingbasket', 'xmas_c17_hangingbasket', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9803, 9803, '0', 'xmas_c17_lamp', 'xmas_c17_lamp', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9804, 9804, '0', 'xmas_c17_pavement', 'xmas_c17_pavement', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9805, 9805, '0', 'xmas_c17_smallpavement', 'xmas_c17_smallpavement', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 5, '', '0.1;0.7;1.3;1.8;2.3', '', 0, 0, ''),
	(9806, 9806, '0', 'xmas_r17_carriage', 'xmas_r17_carriage', 'S', 2, 2, 1.50, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9807, 9807, '0', 'clothing_featherflower', 'clothing_featherflower', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9808, 9808, '0', 'xmas_c17_book', 'xmas_c17_book', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 1, '', '', '', 0, 0, ''),
	(9809, 9809, '0', 'xmas_c17_chair', 'xmas_c17_chair', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9810, 9810, '0', 'clothing_buttonpants', 'clothing_buttonpants', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9811, 9811, '0', 'xmas_c17_doll1', 'xmas_c17_doll1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9812, 9812, '0', 'xmas_c17_tree', 'xmas_c17_tree', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9813, 9813, '0', 'xmas_c17_frizzycat', 'xmas_c17_frizzycat', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9814, 9814, '0', 'clothing_r17_goldfeatherflower', 'clothing_r17_goldfeatherflower', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9815, 9815, '0', 'xmas_c17_bigwindows2', 'xmas_c17_bigwindows2', 'S', 2, 1, 4.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9816, 9816, '0', 'xmas_c17_teashop', 'xmas_c17_teashop', 'S', 2, 1, 4.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9817, 9817, '0', 'xmas_c17_doll6', 'xmas_c17_doll6', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9818, 9818, '0', 'xmas_c17_snowypot', 'xmas_c17_snowypot', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9819, 9819, '0', 'xmas_c17_cobbleroad', 'xmas_c17_cobbleroad', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9820, 9820, '0', 'xmas_r17_musicbox', 'xmas_r17_musicbox', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9821, 9821, '0', 'xmas_c17_window', 'xmas_c17_window', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9822, 9822, '0', 'xmas_c17_fencecorner', 'xmas_c17_fencecorner', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9823, 9823, '0', 'xmas_c17_chestnutstall', 'xmas_c17_chestnutstall', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '60', '', '', 0, 0, ''),
	(9824, 9824, '0', 'clothing_beautyface', 'clothing_beautyface', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9825, 9825, '0', 'xmas_c17_bench', 'xmas_c17_bench', 'S', 2, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'pressureplate_group', 4, '', '', '', 0, 0, ''),
	(9826, 9826, '0', 'xmas_c17_thread', 'xmas_c17_thread', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9827, 9827, '0', 'xmas_c17_wall', 'xmas_c17_wall', 'S', 2, 1, 4.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9828, 9828, '0', 'xmas_c17_pillar', 'xmas_c17_pillar', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9829, 9829, '0', 'xmas_c17_blueprint4', 'xmas_c17_blueprint4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9830, 9830, '0', 'xmas_c17_drain', 'xmas_c17_drain', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9831, 9831, '0', 'xmas_c17_fence', 'xmas_c17_fence', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9832, 9832, '0', 'xmas_c17_table', 'xmas_c17_table', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9833, 9833, '0', 'xmas_c17_blueprint2', 'xmas_c17_blueprint2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9834, 9834, '0', 'xmas_c17_doll5', 'xmas_c17_doll5', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9835, 9835, '0', 'xmas_c17_boy', 'xmas_c17_boy', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '1050', '', '', 0, 0, ''),
	(9836, 9836, '0', 'clothing_ruffleshirt', 'clothing_ruffleshirt', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9837, 9837, '0', 'xmas_c17_pub2', 'xmas_c17_pub2', 'S', 2, 1, 4.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9838, 9838, '0', 'xmas_c17_cloth', 'xmas_c17_cloth', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9839, 9839, '0', 'clothing_tophat', 'clothing_tophat', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9840, 9840, '0', 'xmas_c17_engage_ted', 'xmas_c17_engage_ted', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9841, 9841, '0', 'xmas_c17_snowygrass', 'xmas_c17_snowygrass', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9842, 9842, '0', 'xmas_c17_blueprint1', 'xmas_c17_blueprint1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9843, 9843, '0', 'xmas_c17_doll3', 'xmas_c17_doll3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9844, 9844, '0', 'xmas_c17_robins', 'xmas_c17_robins', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9845, 9845, '0', 'xmas_c17_woman', 'xmas_c17_woman', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9846, 9846, '0', 'clothing_dress', 'clothing_dress', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9847, 9847, '0', 'xmas_c17_bigwindows1', 'xmas_c17_bigwindows1', 'S', 2, 1, 4.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9848, 9848, '0', 'xmas_c17_pram', 'xmas_c17_pram', 'S', 1, 1, 1.40, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9849, 9849, '0', 'xmas_r17_lion', 'xmas_r17_lion', 'S', 1, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9850, 9850, '0', 'xmas_c17_horse', 'xmas_c17_horse', 'S', 1, 1, 2.40, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9851, 9851, '0', 'clothing_tailedcoat', 'clothing_tailedcoat', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9852, 9852, '0', 'xmas_c17_pub1', 'xmas_c17_pub1', 'S', 2, 1, 4.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9853, 9853, '0', 'xmas_c17_gate', 'xmas_c17_gate', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 4, '', '', '', 0, 0, ''),
	(9854, 9854, '0', 'xmas_c17_candyshop', 'xmas_c17_candyshop', 'S', 2, 1, 4.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9855, 9855, '0', 'clothing_sasquatchmask', 'clothing_sasquatchmask', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9856, 9856, '0', 'rare_prize17xmas', 'rare_prize17xmas', 'S', 1, 1, 0.10, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9857, 9857, '0', 'clothing_loyaltycrown_V', 'clothing_loyaltycrown_V', 'S', 1, 1, 0.00, '0', '0', '0', '0', '0', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9858, 9858, '0', 'clothing_loyaltycrown_X', 'clothing_loyaltycrown_X', 'S', 1, 1, 0.00, '0', '0', '0', '0', '0', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9859, 9859, '0', 'clothing_loyaltycrown_II', 'clothing_loyaltycrown_II', 'S', 1, 1, 0.00, '0', '0', '0', '0', '0', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9860, 9860, '0', 'clothing_goldpack3', 'clothing_goldpack3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9861, 9861, '0', 'bonusrare18_3*0', 'bonusrare18_3*0', 'S', 1, 1, 0.10, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9862, 9862, '0', 'bonusrare18_3*1', 'bonusrare18_3*1', 'S', 1, 1, 0.10, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9863, 9863, '0', 'bonusrare18_3*2', 'bonusrare18_3*2', 'S', 1, 1, 0.10, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9864, 9864, '0', 'bonusrare18_3*3', 'bonusrare18_3*3', 'S', 1, 1, 0.10, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9865, 9865, '0', 'bonusrare18_3*4', 'bonusrare18_3*4', 'S', 1, 1, 0.10, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9866, 9866, '0', 'bonusrare18_3*5', 'bonusrare18_3*5', 'S', 1, 1, 0.10, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9867, 9867, '0', 'bonusbag18_3', 'bonusbag18_3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(9868, 9868, '0', 'bonusbag18_2', 'bonusbag18_2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(9869, 9869, '0', 'bonusrare18_2*0', 'bonusrare18_2*0', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9870, 9870, '0', 'bonusrare18_2*1', 'bonusrare18_2*1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9871, 9871, '0', 'bonusrare18_2*2', 'bonusrare18_2*2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9872, 9872, '0', 'bonusrare18_2*3', 'bonusrare18_2*3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9873, 9873, '0', 'bonusrare18_2*4', 'bonusrare18_2*4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9874, 9874, '0', 'bonusrare18_2*5', 'bonusrare18_2*5', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9875, 9875, '0', 'bonusbag18_4', 'bonusbag18_4', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(9876, 9876, '0', 'bonusbag18_1', 'bonusbag18_1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(9877, 9877, '0', 'bonusrare18_4*0', 'bonusrare18_4*0', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9878, 9878, '0', 'bonusrare18_4*1', 'bonusrare18_4*1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9879, 9879, '0', 'bonusrare18_4*2', 'bonusrare18_4*2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9880, 9880, '0', 'bonusrare18_4*3', 'bonusrare18_4*3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9881, 9881, '0', 'bonusrare18_4*4', 'bonusrare18_4*4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9882, 9882, '0', 'bonusrare18_4*5', 'bonusrare18_4*5', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9883, 9883, '0', 'bonusrare18_1*0', 'bonusrare18_1*0', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'vendingmachine', 2, '113,114,115', '', '', 0, 0, ''),
	(9884, 9884, '0', 'bonusrare18_1*1', 'bonusrare18_1*1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'vendingmachine', 2, '113,114,115', '', '', 0, 0, ''),
	(9885, 9885, '0', 'bonusrare18_1*2', 'bonusrare18_1*2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'vendingmachine', 2, '113,114,115', '', '', 0, 0, ''),
	(9886, 9886, '0', 'bonusrare18_1*3', 'bonusrare18_1*3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'vendingmachine', 2, '113,114,115', '', '', 0, 0, ''),
	(9887, 9887, '0', 'bonusrare18_1*4', 'bonusrare18_1*4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'vendingmachine', 2, '113,114,115', '', '', 0, 0, ''),
	(9888, 9888, '0', 'bonusrare18_1*5', 'bonusrare18_1*5', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'vendingmachine', 2, '113,114,115', '', '', 0, 0, ''),
	(9889, 9889, '0', 'clothing_mini_bowlerhat_dark', 'clothing_mini_bowlerhat_dark', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9890, 9890, '0', 'clothing_mini_bowlerhat_cream', 'clothing_mini_bowlerhat_cream', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9891, 9891, '0', 'clothing_mini_bowlerhat_gold', 'clothing_mini_bowlerhat_gold', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9892, 9892, '0', 'clothing_mini_bowlerhat_green', 'clothing_mini_bowlerhat_green', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9893, 9893, '0', 'clothing_mini_bowlerhat_red', 'clothing_mini_bowlerhat_red', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9894, 9894, '0', 'clothing_mini_bowlerhat_purple', 'clothing_mini_bowlerhat_purple', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9895, 9895, '0', 'clothing_mini_bowlerhat_blue', 'clothing_mini_bowlerhat_blue', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9896, 9896, '0', 'ny18_crackable', 'ny18_crackable', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 1, '', '', '', 0, 0, ''),
	(9897, 9897, '0', 'classic8_bar', 'classic8_bar', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9898, 9898, '1', 'classic9_floor2', 'classic9_floor2', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9899, 9899, '0', 'classic8_chair', 'classic8_chair', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9900, 9900, '0', 'classic9_statue', 'classic9_statue', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9901, 9901, '0', 'classic8_rug', 'classic8_rug', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9902, 9902, '0', 'classic8_records', 'classic8_records', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9903, 9903, '0', 'classic8_sofa', 'classic8_sofa', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9904, 9904, '1', 'classic9_carpet', 'classic9_carpet', 'S', 2, 2, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9905, 9905, '0', 'classic8_statue', 'classic8_statue', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9906, 9906, '0', 'classic8_curtains', 'classic8_curtains', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9907, 9907, '0', 'classic8_stairs', 'classic8_stairs', 'S', 1, 1, 0.60, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9908, 9908, '0', 'classic8_glassfloor', 'classic8_glassfloor', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9909, 9909, '1', 'classic9_counter', 'classic9_counter', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9910, 9910, '1', 'classic9_chair', 'classic9_chair', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9911, 9911, '1', 'classic9_light', 'classic9_light', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9912, 9912, '0', 'classic8_pillar', 'classic8_pillar', 'S', 1, 1, 4.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9913, 9913, '1', 'classic9_floor1', 'classic9_floor1', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9914, 9914, '1', 'classic9_table', 'classic9_table', 'S', 2, 2, 0.70, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9915, 9915, '0', 'classic8_divider', 'classic8_divider', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9916, 9916, '0', 'classic8_floor', 'classic8_floor', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9917, 9917, '0', 'classic8_sign', 'classic8_sign', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9918, 9918, '0', 'classic8_shelf', 'classic8_shelf', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9919, 9919, '1', 'classic9_plant', 'classic9_plant', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9920, 9920, '0', 'classic8_disco', 'classic8_disco', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9921, 9921, '1', 'classic9_stool', 'classic9_stool', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9922, 9922, '1', 'classic9_bookshelf', 'classic9_bookshelf', 'S', 1, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9923, 9923, '0', 'classic8_wall', 'classic8_wall', 'S', 1, 1, 4.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9924, 9924, '1', 'classic9_books', 'classic9_books', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(9925, 9925, '0', 'classic8_plant', 'classic8_plant', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9926, 9926, '1', 'classic9_wall', 'classic9_wall', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9927, 9927, '0', 'rare_prize18*0', 'rare_prize18*0', 'S', 1, 1, 0.10, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9928, 9928, '0', 'rare_prize18*1', 'rare_prize18*1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9929, 9929, '0', 'rare_prize18*10', 'rare_prize18*10', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9930, 9930, '0', 'rare_prize18*11', 'rare_prize18*11', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9931, 9931, '0', 'rare_prize18*12', 'rare_prize18*12', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9932, 9932, '0', 'rare_prize18*2', 'rare_prize18*2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9933, 9933, '0', 'rare_prize18*3', 'rare_prize18*3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9934, 9934, '0', 'rare_prize18*4', 'rare_prize18*4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9935, 9935, '0', 'rare_prize18*5', 'rare_prize18*5', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9936, 9936, '0', 'rare_prize18*6', 'rare_prize18*6', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9937, 9937, '0', 'rare_prize18*7', 'rare_prize18*7', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9938, 9938, '0', 'rare_prize18*8', 'rare_prize18*8', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9939, 9939, '0', 'rare_prize18*9', 'rare_prize18*9', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9940, 9940, '0', 'hc17_3', 'hc17_3', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9941, 9941, '0', 'hc17_8', 'hc17_8', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '1', '1', '1', 'pressureplate', 2, '', '', '', 0, 0, ''),
	(9942, 9942, '0', 'hc17_10', 'hc17_10', 'S', 2, 3, 1.80, '0', '0', '1', '0', '1', '1', '1', '1', '1', 'bed', 2, '', '', '', 0, 0, ''),
	(9943, 9943, '0', 'hc17_11', 'hc17_11', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'vendingmachine', 2, '35', '', '', 0, 0, ''),
	(9944, 9944, '0', 'hc17_5', 'hc17_5', 'S', 1, 3, 1.40, '0', '0', '1', '0', '1', '1', '1', '1', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(9945, 9945, '0', 'hc17_2', 'hc17_2', 'S', 1, 2, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9946, 9946, '0', 'hc17_6', 'hc17_6', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9947, 9947, '0', 'hc17_12', 'hc17_12', 'S', 1, 1, 3.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9948, 9948, '0', 'hc17_9', 'hc17_9', 'S', 1, 1, 1.30, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9949, 9949, '0', 'hc17_4', 'hc17_4', 'S', 1, 1, 1.30, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9950, 9950, '0', 'hc17_1', 'hc17_1', 'S', 1, 1, 2.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9951, 9951, '0', 'val_c18_chest', 'val_c18_chest', 'S', 2, 1, 1.50, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9952, 9952, '0', 'val_c18_wardrobe', 'val_c18_wardrobe', 'S', 1, 2, 3.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9953, 9953, '0', 'clothing_judgewig', 'clothing_judgewig', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9954, 9954, '1', 'clothing_elegantponytail', 'clothing_elegantponytail', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9955, 9955, '0', 'clothing_r18_unicorn', 'clothing_r18_unicorn', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9956, 9956, '0', 'val_c18_swan', 'val_c18_swan', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9957, 9957, '0', 'clothing_r18_dress', 'clothing_r18_dress', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9958, 9958, '0', 'val_r18_bed', 'val_r18_bed', 'S', 1, 1, 1.50, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 1, '', '', '', 0, 0, ''),
	(9959, 9959, '0', 'clothing_gentcap', 'clothing_gentcap', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9960, 9960, '0', 'easter_c18_lemontree', 'easter_c18_lemontree', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine_no_sides', 2, '116', '', '', 0, 0, ''),
	(9961, 9961, '0', 'easter_c18_snowdrop3', 'easter_c18_snowdrop3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 12, '', '', '', 0, 0, ''),
	(9962, 9962, '0', 'clothing_shades', 'clothing_shades', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9963, 9963, '0', 'easter_c18_lupin1', 'easter_c18_lupin1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 12, '', '', '', 0, 0, ''),
	(9964, 9964, '0', 'clothing_braidedwavy', 'clothing_braidedwavy', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9965, 9965, '0', 'easter_c18_tulip2', 'easter_c18_tulip2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 12, '', '', '', 0, 0, ''),
	(9966, 9966, '0', 'easter_c18_seedpackrose', 'easter_c18_seedpackrose', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 1, '', '', '', 0, 0, ''),
	(9967, 9967, '0', 'clothing_satchel', 'clothing_satchel', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9968, 9968, '0', 'easter_c18_dancingplant', 'easter_c18_dancingplant', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9969, 9969, '0', 'easter_c18_badflower', 'easter_c18_badflower', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9970, 9970, '0', 'easter_c18_seedpacktulip', 'easter_c18_seedpacktulip', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 1, '', '', '', 0, 0, ''),
	(9971, 9971, '0', 'easter_c18_rose3', 'easter_c18_rose3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 12, '', '', '', 0, 0, ''),
	(9972, 9972, '0', 'easter_c18_tulip3', 'easter_c18_tulip3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 12, '', '', '', 0, 0, ''),
	(9973, 9973, '0', 'easter_c18_tricyle', 'easter_c18_tricyle', 'S', 1, 1, 1.30, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9974, 9974, '0', 'easter_c18_recyclebin', 'easter_c18_recyclebin', 'S', 1, 1, 0.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(9975, 9975, '0', 'easter_c18_ivybeam', 'easter_c18_ivybeam', 'S', 1, 2, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9976, 9976, '0', 'easter_c18_lupin3', 'easter_c18_lupin3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 12, '', '', '', 0, 0, ''),
	(9977, 9977, '0', 'easter_c18_radio', 'easter_c18_radio', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9978, 9978, '0', 'easter_c18_lupin4', 'easter_c18_lupin4', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 12, '', '', '', 0, 0, ''),
	(9979, 9979, '0', 'easter_c18_ceilingfan', 'easter_c18_ceilingfan', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(9980, 9980, '0', 'easter_c18_ivylight', 'easter_c18_ivylight', 'S', 1, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9981, 9981, '0', 'clothing_tiedtop', 'clothing_tiedtop', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9982, 9982, '0', 'easter_c18_seedpacksnowdrop', 'easter_c18_seedpacksnowdrop', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 1, '', '', '', 0, 0, ''),
	(9983, 9983, '0', 'easter_c18_rose4', 'easter_c18_rose4', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 12, '', '', '', 0, 0, ''),
	(9984, 9984, '0', 'easter_r18_bonzaifountain', 'easter_r18_bonzaifountain', 'S', 1, 1, 0.00, '0', '0', '0', '0', '0', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9985, 9985, '0', 'easter_c18_hutch', 'easter_c18_hutch', 'S', 1, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9986, 9986, '0', 'easter_c18_snowdrop4', 'easter_c18_snowdrop4', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 12, '', '', '', 0, 0, ''),
	(9987, 9987, '0', 'easter_c18_shelfplants', 'easter_c18_shelfplants', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9988, 9988, '0', 'easter_r18_bigbunny', 'easter_r18_bigbunny', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9989, 9989, '0', 'easter_c18_curtains', 'easter_c18_curtains', 'S', 1, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(9990, 9990, '0', 'clothing_r18_bunniemask', 'clothing_r18_bunniemask', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9991, 9991, '0', 'easter_c18_washline', 'easter_c18_washline', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9992, 9992, '0', 'easter_c18_glassbrickcnr', 'easter_c18_glassbrickcnr', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9993, 9993, '0', 'easter_c18_birchpillar', 'easter_c18_birchpillar', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(9994, 9994, '0', 'easter_c18_rose2', 'easter_c18_rose2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 12, '', '', '', 0, 0, ''),
	(9995, 9995, '0', 'easter_c18_boxplanter', 'easter_c18_boxplanter', 'S', 1, 2, 0.50, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(9996, 9996, '0', 'clothing_r18_bunniehat', 'clothing_r18_bunniehat', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9997, 9997, '0', 'easter_c18_tulip1', 'easter_c18_tulip1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 12, '', '', '', 0, 0, ''),
	(9998, 9998, '0', 'clothing_floppyhair', 'clothing_floppyhair', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(9999, 9999, '0', 'easter_ltd18_habberge10', 'easter_ltd18_habberge10', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10000, 10000, '0', 'easter_c18_hangingplant', 'easter_c18_hangingplant', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(10001, 10001, '0', 'easter_c18_woodendeco', 'easter_c18_woodendeco', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(10002, 10002, '0', 'easter_c18_lupin2', 'easter_c18_lupin2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 12, '', '', '', 0, 0, ''),
	(10003, 10003, '0', 'easter_c18_dragonflies', 'easter_c18_dragonflies', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(10004, 10004, '0', 'clothing_retrohair', 'clothing_retrohair', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10005, 10005, '0', 'easter_c18_chair', 'easter_c18_chair', 'S', 1, 1, 1.30, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(10006, 10006, '0', 'easter_c18_tulip4', 'easter_c18_tulip4', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 12, '', '', '', 0, 0, ''),
	(10007, 10007, '0', 'clothing_floppysunhat', 'clothing_floppysunhat', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '0', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10008, 10008, '0', 'easter_c18_patternfloor', 'easter_c18_patternfloor', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(10009, 10009, '0', 'easter_c18_glassdoor', 'easter_c18_glassdoor', 'S', 1, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(10010, 10010, '0', 'easter_c18_slatestack', 'easter_c18_slatestack', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(10011, 10011, '0', 'easter_c18_stackedplants', 'easter_c18_stackedplants', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10012, 10012, '0', 'easter_c18_countryteaset', 'easter_c18_countryteaset', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10013, 10013, '0', 'easter_c18_seedpacklupin', 'easter_c18_seedpacklupin', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 1, '', '', '', 0, 0, ''),
	(10014, 10014, '0', 'easter_c18_glassbrickwall', 'easter_c18_glassbrickwall', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(10015, 10015, '0', 'easter_c18_chiaplants', 'easter_c18_chiaplants', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10016, 10016, '0', 'easter_c18_table', 'easter_c18_table', 'S', 2, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10017, 10017, '0', 'easter_c18_snowdrop1', 'easter_c18_snowdrop1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 12, '', '', '', 0, 0, ''),
	(10018, 10018, '0', 'easter_c18_radiator', 'easter_c18_radiator', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10019, 10019, '0', 'easter_c18_fawn', 'easter_c18_fawn', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10020, 10020, '0', 'easter_c18_veg', 'easter_c18_veg', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine_no_sides', 2, '98', '', '', 0, 0, ''),
	(10021, 10021, '0', 'easter_c18_snowdrop2', 'easter_c18_snowdrop2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 12, '', '', '', 0, 0, ''),
	(10022, 10022, '0', 'easter_c18_rose1', 'easter_c18_rose1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 12, '', '', '', 0, 0, ''),
	(10023, 10023, '0', 'trophy_netsafety_0', 'trophy_netsafety_0', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(10024, 10024, '0', 'clothing_kpopbuns', 'clothing_kpopbuns', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10025, 10025, '0', 'clothing_kpop', 'clothing_kpop', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10026, 10026, '0', 'clothing_bffshirt', 'clothing_bffshirt', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10027, 10027, '0', 'clothing_bffhat', 'clothing_bffhat', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10028, 10028, '0', 'china_dog', 'china_dog', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10029, 10029, '0', 'cny18_dogballoon', 'cny18_dogballoon', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10030, 10030, '0', 'CF_500_moneytree', 'CF_500_moneytree', 'S', 1, 1, 0.00, '0', '0', '0', '0', '0', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(10031, 10031, '0', 'gift_bff_a', 'gift_bff_a', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(10032, 10032, '0', 'crafting_jarhearts', 'crafting_jarhearts', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '0', '1', '0', '0', 'crafting', 2, '', '', '', 0, 0, ''),
	(10033, 10033, '0', 'gift_bff_b', 'gift_bff_b', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(10034, 10034, '0', 'cine_r18_buggy', 'cine_r18_buggy', 'S', 1, 1, 1.50, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10035, 10035, '0', 'cine_r18_camera', 'cine_r18_camera', 'S', 1, 1, 0.00, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'multiheight', 2, '', '1.6;3.0;4.3', '', 0, 0, ''),
	(10036, 10036, '0', 'cine_r18_catcopter', 'cine_r18_catcopter', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10037, 10037, '0', 'clothing_poncho', 'clothing_poncho', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10038, 10038, '0', 'clothing_inmate', 'clothing_inmate', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10039, 10039, '0', 'clothing_mercenary', 'clothing_mercenary', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10040, 10040, '0', 'clothing_yetifeet', 'clothing_yetifeet', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10041, 10041, '0', 'cine_r18_trailer', 'cine_r18_trailer', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '1', '1', 'tent', 2, '', '', '', 0, 0, ''),
	(10042, 10042, '0', 'clothing_c18_cutething', 'clothing_c18_cutething', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10043, 10043, '0', 'gift_c18_cookiejar', 'gift_c18_cookiejar', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'vendingmachine_no_sides', 2, '117', '', '', 0, 0, ''),
	(10044, 10044, '0', 'gaming_c18_hswap', 'gaming_c18_hswap', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(10045, 10045, '0', 'laundry_c18_ironing', 'laundry_c18_ironing', 'S', 1, 2, 1.80, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(10046, 10046, '0', 'laundry_c18_dustpan', 'laundry_c18_dustpan', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10047, 10047, '0', 'gaming_c18_chairpro', 'gaming_c18_chairpro', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10048, 10048, '0', 'laundry_c18_basket', 'laundry_c18_basket', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10049, 10049, '0', 'laundry_c18_products', 'laundry_c18_products', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10050, 10050, '0', 'gaming_c18_gameplush2', 'gaming_c18_gameplush2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10051, 10051, '0', 'laundry_c18_washmachine', 'laundry_c18_washmachine', 'S', 1, 1, 1.30, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10052, 10052, '0', 'gaming_c18_gameplush1', 'gaming_c18_gameplush1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10053, 10053, '0', 'gaming_c18_gamecollection', 'gaming_c18_gamecollection', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(10054, 10054, '0', 'gaming_c18_setuppro', 'gaming_c18_setuppro', 'S', 1, 3, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(10055, 10055, '0', 'gaming_c18_cubelight', 'gaming_c18_cubelight', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10056, 10056, '0', 'laundry_r18_vacuum', 'laundry_r18_vacuum', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10057, 10057, '0', 'laundry_c18_dryingrack', 'laundry_c18_dryingrack', 'S', 1, 1, 1.30, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(10058, 10058, '0', 'gaming_c18_hs4', 'gaming_c18_hs4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10059, 10059, '0', 'gaming_c18_rigpro', 'gaming_c18_rigpro', 'S', 3, 1, 1.20, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10060, 10060, '0', 'jp_r18_asiandoll', 'jp_r18_asiandoll', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10061, 10061, '0', 'clothing_r18_seahorse', 'clothing_r18_seahorse', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10062, 10062, '0', 'coralking_c18_cone', 'coralking_c18_cone', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(10063, 10063, '1', 'coralking_c18_gate', 'coralking_c18_gate', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(10064, 10064, '1', 'coralking_c18_fishnet', 'coralking_c18_fishnet', 'S', 1, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(10065, 10065, '0', 'coralking_c18_spinycoral2', 'coralking_c18_spinycoral2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10066, 10066, '1', 'coralking_c18_anchor', 'coralking_c18_anchor', 'S', 1, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(10067, 10067, '0', 'coralking_r18_turtleride', 'coralking_r18_turtleride', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '1', '1', 'effect_tile', 2, '', '', '', 206, 206, ''),
	(10068, 10068, '0', 'coralking_c18_shelltele', 'coralking_c18_shelltele', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'teleport', 2, '', '', '', 0, 0, ''),
	(10069, 10069, '0', 'coralking_c18_starfish1', 'coralking_c18_starfish1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10070, 10070, '0', 'coralking_c18_treasurechest', 'coralking_c18_treasurechest', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(10071, 10071, '1', 'coralking_c18_tropicalfish', 'coralking_c18_tropicalfish', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10072, 10072, '0', 'coralking_c18_goldenfish', 'coralking_c18_goldenfish', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10073, 10073, '1', 'coralking_c18_bluesand', 'coralking_c18_bluesand', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10074, 10074, '0', 'clothing_luscioushair', 'clothing_luscioushair', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10075, 10075, '1', 'coralking_c18_sunkenpots', 'coralking_c18_sunkenpots', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(10076, 10076, '1', 'coralking_c18_catfish', 'coralking_c18_catfish', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10077, 10077, '0', 'coralking_c18_closedspiral1', 'coralking_c18_closedspiral1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(10078, 10078, '0', 'coralking_r18_goldenchest', 'coralking_r18_goldenchest', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(10079, 10079, '1', 'coralking_c18_bubbleseat', 'coralking_c18_bubbleseat', 'S', 1, 1, 0.00, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'multiheight', 2, '', '1.0;2.5', '', 0, 0, ''),
	(10080, 10080, '0', 'coralking_c18_closedspiral2', 'coralking_c18_closedspiral2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(10081, 10081, '0', 'coralking_c18_spinycoral1', 'coralking_c18_spinycoral1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10082, 10082, '0', 'clothing_flippers', 'clothing_flippers', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10083, 10083, '1', 'coralking_c18_trash', 'coralking_c18_trash', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10084, 10084, '0', 'coralking_c18_bushycoral2', 'coralking_c18_bushycoral2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(10085, 10085, '1', 'coralking_c18_corner', 'coralking_c18_corner', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10086, 10086, '0', 'coralking_c18_openspiral1', 'coralking_c18_openspiral1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10087, 10087, '1', 'coralking_c18_seafloor', 'coralking_c18_seafloor', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10088, 10088, '1', 'coralking_c18_kelppillar', 'coralking_c18_kelppillar', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10089, 10089, '0', 'coralking_c18_clamshell2', 'coralking_c18_clamshell2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(10090, 10090, '1', 'coralking_c18_neoncoral2', 'coralking_c18_neoncoral2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10091, 10091, '0', 'clothing_wetsuit', 'clothing_wetsuit', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10092, 10092, '1', 'coralking_c18_boulders1', 'coralking_c18_boulders1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(10093, 10093, '0', 'clothing_r18_goldfish', 'clothing_r18_goldfish', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10094, 10094, '0', 'coralking_r18_vanitytable', 'coralking_r18_vanitytable', 'S', 2, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10095, 10095, '1', 'coralking_c18_coralfloor', 'coralking_c18_coralfloor', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(10096, 10096, '1', 'coralking_c18_bed', 'coralking_c18_bed', 'S', 1, 3, 2.00, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'bed', 2, '', '', '', 0, 0, ''),
	(10097, 10097, '1', 'coralking_c18_gazebo', 'coralking_c18_gazebo', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10098, 10098, '1', 'coralking_c18_neoncoral3', 'coralking_c18_neoncoral3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10099, 10099, '0', 'coralking_c18_trident', 'coralking_c18_trident', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10100, 10100, '0', 'coralking_c18_starfish2', 'coralking_c18_starfish2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10101, 10101, '1', 'coralking_c18_table', 'coralking_c18_table', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10102, 10102, '1', 'coralking_c18_fence', 'coralking_c18_fence', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10103, 10103, '0', 'coralking_ltd18_royalseahorse', 'coralking_ltd18_royalseahorse', 'S', 2, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(10104, 10104, '0', 'coralking_c18_seaweed', 'coralking_c18_seaweed', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10105, 10105, '1', 'coralking_c18_clownfish', 'coralking_c18_clownfish', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10106, 10106, '0', 'clothing_r18_divershelmet', 'clothing_r18_divershelmet', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10107, 10107, '0', 'clothing_sailortop', 'clothing_sailortop', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10108, 10108, '0', 'coralking_c18_openspiral2', 'coralking_c18_openspiral2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10109, 10109, '1', 'coralking_c18_angelfish', 'coralking_c18_angelfish', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10110, 10110, '0', 'coralking_c18_clamshell3', 'coralking_c18_clamshell3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(10111, 10111, '0', 'coralking_c18_chalice', 'coralking_c18_chalice', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10112, 10112, '1', 'coralking_c18_bubblerock', 'coralking_c18_bubblerock', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10113, 10113, '0', 'clothing_r18_seawreath', 'clothing_r18_seawreath', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10114, 10114, '1', 'coralking_c18_chair', 'coralking_c18_chair', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(10115, 10115, '1', 'coralking_c18_neoncoral1', 'coralking_c18_neoncoral1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10116, 10116, '1', 'coralking_c18_boulders2', 'coralking_c18_boulders2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10117, 10117, '0', 'coralking_c18_pearloyster', 'coralking_c18_pearloyster', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10118, 10118, '0', 'coralking_c18_clamshell1', 'coralking_c18_clamshell1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(10119, 10119, '0', 'coralking_c18_bushycoral1', 'coralking_c18_bushycoral1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(10120, 10120, '0', 'coralking_engageseahorse', 'coralking_engageseahorse', 'S', 1, 1, 2.50, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10121, 10121, '0', 'CF_750_goldenpig', 'CF_750_goldenpig', 'S', 1, 1, 0.00, '0', '0', '0', '0', '0', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10122, 10122, '0', 'clothing_r18_tiedwavylocks', 'clothing_r18_tiedwavylocks', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10123, 10123, '0', 'clothing_r18_frohawk', 'clothing_r18_frohawk', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10124, 10124, '0', 'birds_r18_spoonbill', 'birds_r18_spoonbill', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10125, 10125, '0', 'birds_r18_puffin', 'birds_r18_puffin', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(10126, 10126, '0', 'birds_r18_peacock', 'birds_r18_peacock', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10127, 10127, '0', 'birds_r18_crane', 'birds_r18_crane', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10128, 10128, '0', 'birds_r18_quetzal', 'birds_r18_quetzal', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(10129, 10129, '0', 'birds_r18_cardinal', 'birds_r18_cardinal', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10130, 10130, '0', 'trophy_ltd18_wcup', 'trophy_ltd18_wcup', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10131, 10131, '1', 'tokyo_c18_residential', 'tokyo_c18_residential', 'S', 2, 1, 4.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(10132, 10132, '0', 'tokyo_c18_toy4', 'tokyo_c18_toy4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(10133, 10133, '0', 'tokyo_c18_toy6', 'tokyo_c18_toy6', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(10134, 10134, '0', 'clothing_animehair', 'clothing_animehair', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10135, 10135, '1', 'tokyo_c18_railing', 'tokyo_c18_railing', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10136, 10136, '1', 'tokyo_c18_retroarcade', 'tokyo_c18_retroarcade', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10137, 10137, '1', 'tokyo_c18_motorbike', 'tokyo_c18_motorbike', 'S', 1, 3, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(10138, 10138, '1', 'tokyo_c18_neonsign2', 'tokyo_c18_neonsign2', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(10139, 10139, '0', 'tokyo_c18_toy9', 'tokyo_c18_toy9', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(10140, 10140, '1', 'tokyo_c18_shopdisplay', 'tokyo_c18_shopdisplay', 'S', 2, 1, 4.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(10141, 10141, '1', 'tokyo_c18_pole', 'tokyo_c18_pole', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 7, '', '', '', 0, 0, ''),
	(10142, 10142, '1', 'tokyo_c18_trellis', 'tokyo_c18_trellis', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10143, 10143, '0', 'tokyo_r18_mapletree', 'tokyo_r18_mapletree', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10144, 10144, '0', 'tokyo_c18_toy5', 'tokyo_c18_toy5', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(10145, 10145, '1', 'tokyo_c18_bugsmachine', 'tokyo_c18_bugsmachine', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '1043,1079,1080', '', '', 0, 0, ''),
	(10146, 10146, '1', 'tokyo_c18_drinksmachine', 'tokyo_c18_drinksmachine', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '42,66,118,119', '', '', 0, 0, ''),
	(10147, 10147, '1', 'tokyo_c18_gamesign', 'tokyo_c18_gamesign', 'S', 4, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10148, 10148, '1', 'tokyo_c18_adposters', 'tokyo_c18_adposters', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10149, 10149, '0', 'clothing_sakurajacket', 'clothing_sakurajacket', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10150, 10150, '1', 'tokyo_c18_lights', 'tokyo_c18_lights', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(10151, 10151, '1', 'tokyo_c18_snackroof', 'tokyo_c18_snackroof', 'S', 2, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(10152, 10152, '0', 'tokyo_c18_toy2', 'tokyo_c18_toy2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(10153, 10153, '0', 'clothing_dragonplushhat', 'clothing_dragonplushhat', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10154, 10154, '0', 'tokyo_ltd18_shiba', 'tokyo_ltd18_shiba', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10155, 10155, '0', 'tokyo_c18_toy1', 'tokyo_c18_toy1', 'S', 1, 1, 0.10, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(10156, 10156, '1', 'tokyo_c18_road', 'tokyo_c18_road', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(10157, 10157, '1', 'tokyo_c18_scarydino', 'tokyo_c18_scarydino', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10158, 10158, '1', 'tokyo_c18_jpmerchshop', 'tokyo_c18_jpmerchshop', 'S', 2, 1, 4.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(10159, 10159, '1', 'tokyo_c18_floor', 'tokyo_c18_floor', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10160, 10160, '1', 'tokyo_c18_lanterns', 'tokyo_c18_lanterns', 'S', 3, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10161, 10161, '1', 'tokyo_c18_magazinerack', 'tokyo_c18_magazinerack', 'S', 1, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(10162, 10162, '1', 'tokyo_c18_racearcade', 'tokyo_c18_racearcade', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10163, 10163, '0', 'clothing_cuteglasses', 'clothing_cuteglasses', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10164, 10164, '1', 'tokyo_c18_retroarcade2', 'tokyo_c18_retroarcade2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10165, 10165, '0', 'clothing_shogunhelmet', 'clothing_shogunhelmet', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10166, 10166, '1', 'tokyo_c18_snackdisplay', 'tokyo_c18_snackdisplay', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '112', '', '', 0, 0, ''),
	(10167, 10167, '0', 'tokyo_c18_toy10', 'tokyo_c18_toy10', 'S', 1, 1, 0.10, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(10168, 10168, '0', 'tokyo_c18_toy3', 'tokyo_c18_toy3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(10169, 10169, '0', 'clothing_r18_catbag', 'clothing_r18_catbag', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10170, 10170, '0', 'tokyo_c18_gacha', 'tokyo_c18_gacha', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(10171, 10171, '0', 'tokyo_c18_toy8', 'tokyo_c18_toy8', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(10172, 10172, '1', 'tokyo_c18_snackdisplay2', 'tokyo_c18_snackdisplay2', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '120,121', '', '', 0, 0, ''),
	(10173, 10173, '0', 'clothing_r18_kitsunemask', 'clothing_r18_kitsunemask', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10174, 10174, '0', 'tokyo_c18_craftbot', 'tokyo_c18_craftbot', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '0', '1', '0', '0', 'crafting', 2, '', '', '', 0, 0, ''),
	(10175, 10175, '1', 'tokyo_c18_shopfront', 'tokyo_c18_shopfront', 'S', 2, 1, 4.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(10176, 10176, '0', 'clothing_harajukubow', 'clothing_harajukubow', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10177, 10177, '1', 'tokyo_c18_sakura', 'tokyo_c18_sakura', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10178, 10178, '0', 'clothing_tutu', 'clothing_tutu', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10179, 10179, '1', 'tokyo_c18_adposters2', 'tokyo_c18_adposters2', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10180, 10180, '1', 'tokyo_c18_neonsign1', 'tokyo_c18_neonsign1', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(10181, 10181, '1', 'tokyo_c18_bigbillboard', 'tokyo_c18_bigbillboard', 'S', 2, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10182, 10182, '0', 'clothing_botface', 'clothing_botface', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10183, 10183, '0', 'tokyo_r18_koikite', 'tokyo_r18_koikite', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10184, 10184, '1', 'tokyo_c18_snackroof2', 'tokyo_c18_snackroof2', 'S', 2, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10185, 10185, '0', 'tokyo_c18_toy7', 'tokyo_c18_toy7', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(10186, 10186, '0', 'clothing_harajukuhair', 'clothing_harajukuhair', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10187, 10187, '0', 'anniversary_r18_throne', 'anniversary_r18_throne', 'S', 1, 1, 1.30, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10188, 10188, '0', 'tokyo_c18_gacha2', 'tokyo_c18_gacha2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10189, 10189, '0', 'zengarden_c18_glasspond', 'zengarden_c18_glasspond', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(10190, 10190, '0', 'zengarden_c18_light', 'zengarden_c18_light', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(10191, 10191, '0', 'zengarden_c18_roof', 'zengarden_c18_roof', 'S', 2, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10192, 10192, '0', 'zengarden_c18_stonebench', 'zengarden_c18_stonebench', 'S', 2, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10193, 10193, '0', 'zengarden_c18_rootplant', 'zengarden_c18_rootplant', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10194, 10194, '0', 'zengarden_c18_stonetable', 'zengarden_c18_stonetable', 'S', 1, 1, 0.50, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10195, 10195, '0', 'zengarden_c18_divider', 'zengarden_c18_divider', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10196, 10196, '0', 'zengarden_c18_moss', 'zengarden_c18_moss', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(10197, 10197, '0', 'zengarden_c18_peacefrog', 'zengarden_c18_peacefrog', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10198, 10198, '0', 'zengarden_c18_bamboo', 'zengarden_c18_bamboo', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10199, 10199, '0', 'zengarden_c18_door', 'zengarden_c18_door', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(10200, 10200, '0', 'zengarden_c18_plankfloor', 'zengarden_c18_plankfloor', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10201, 10201, '0', 'zengarden_c18_roofcorner', 'zengarden_c18_roofcorner', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10202, 10202, '0', 'zengarden_c18_spikeyplant', 'zengarden_c18_spikeyplant', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10203, 10203, '0', 'zengarden_r18_fountain', 'zengarden_r18_fountain', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10204, 10204, '0', 'zengarden_c18_pebbles', 'zengarden_c18_pebbles', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10205, 10205, '0', 'clothing_r18_longwavy', 'clothing_r18_longwavy', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10206, 10206, '0', 'rare_colourable_marquee*3', 'rare_colourable_marquee*3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(10207, 10207, '0', 'rare_colourable_scifirocket*3', 'rare_colourable_scifirocket*3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10208, 10208, '0', 'rare_colourable_fountain*3', 'rare_colourable_fountain*3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10209, 10209, '0', 'rare_colourable_wooden_screen*3', 'rare_colourable_wooden_screen*3', 'S', 1, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(10210, 10210, '0', 'rare_colourable_dragonlamp*3', 'rare_colourable_dragonlamp*3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10211, 10211, '0', 'rare_colourable_parasol*3', 'rare_colourable_parasol*3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10212, 10212, '0', 'hhistory_r18_crackable', 'hhistory_r18_crackable', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(10213, 10213, '0', 'rare_colourable_sleepingbag*3', 'rare_colourable_sleepingbag*3', 'S', 1, 3, 0.80, '0', '0', '1', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(10214, 10214, '0', 'rare_colourable_pillar*3', 'rare_colourable_pillar*3', 'S', 1, 1, 3.50, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(10215, 10215, '0', 'rare_colourable_beehive_bulb*3', 'rare_colourable_beehive_bulb*3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10216, 10216, '0', 'rare_colourable_icecream*3', 'rare_colourable_icecream*3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'vendingmachine', 2, '4', '', '', 0, 0, ''),
	(10217, 10217, '0', 'rare_colourable_elephant_statue*3', 'rare_colourable_elephant_statue*3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(10218, 10218, '0', 'rare_colourable_scifidoor*3', 'rare_colourable_scifidoor*3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(10219, 10219, '0', 'rare_colourable_fan*3', 'rare_colourable_fan*3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10220, 10220, '0', 'rare_colourable_pillow*3', 'rare_colourable_pillow*3', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10221, 10221, '0', 'rare_colourable_scifiport*3', 'rare_colourable_scifiport*3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(10222, 10222, '0', 'rare_colourable_barrier*3', 'rare_colourable_barrier*3', 'S', 1, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10223, 10223, '1', 'hotel_c18_pool', 'hotel_c18_pool', 'S', 3, 4, 0.30, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10224, 10224, '1', 'hotel_c18_stairs', 'hotel_c18_stairs', 'S', 1, 2, 0.50, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10225, 10225, '1', 'hotel_c18_roof', 'hotel_c18_roof', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(10226, 10226, '1', 'hotel_c18_rail', 'hotel_c18_rail', 'S', 2, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10227, 10227, '1', 'hotel_c18_fountain', 'hotel_c18_fountain', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10228, 10228, '1', 'hotel_c18_block2', 'hotel_c18_block2', 'S', 1, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(10229, 10229, '1', 'hotel_c18_awning', 'hotel_c18_awning', 'S', 2, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10230, 10230, '1', 'hotel_c18_block1', 'hotel_c18_block1', 'S', 1, 2, 5.40, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(10231, 10231, '1', 'hotel_c18_tree', 'hotel_c18_tree', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10232, 10232, '1', 'hotel_c18_foundation', 'hotel_c18_foundation', 'S', 1, 2, 0.80, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10233, 10233, '1', 'hotel_c18_cypress', 'hotel_c18_cypress', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10234, 10234, '1', 'hotel_c18_rooftop', 'hotel_c18_rooftop', 'S', 1, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10235, 10235, '0', 'hween_c18_deskitems2', 'hween_c18_deskitems2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(10236, 10236, '0', 'hween_c18_ceilingrays', 'hween_c18_ceilingrays', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10237, 10237, '0', 'hween_c18_complexmchn3', 'hween_c18_complexmchn3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(10238, 10238, '0', 'clothing_brownglasses', 'clothing_brownglasses', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10239, 10239, '0', 'hween_c18_toy5old', 'hween_c18_toy5old', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10240, 10240, '0', 'hween_c18_complexmchn2', 'hween_c18_complexmchn2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10241, 10241, '0', 'hween_c18_toy5new', 'hween_c18_toy5new', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10242, 10242, '0', 'clothing_brain', 'clothing_brain', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10243, 10243, '0', 'hween_c18_olddocs2', 'hween_c18_olddocs2', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(10244, 10244, '0', 'hween_c18_ceilingfan', 'hween_c18_ceilingfan', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10245, 10245, '0', 'hween_c18_toy4old', 'hween_c18_toy4old', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10246, 10246, '0', 'hween_c18_labglasswall', 'hween_c18_labglasswall', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10247, 10247, '0', 'hween_c18_retropc', 'hween_c18_retropc', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10248, 10248, '0', 'hween_c18_dimlights', 'hween_c18_dimlights', 'S', 1, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10249, 10249, '0', 'hween_c18_medicineshelf', 'hween_c18_medicineshelf', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '19,44,1014', '', '', 0, 0, ''),
	(10250, 10250, '0', 'hween_c18_labtilewall', 'hween_c18_labtilewall', 'S', 1, 2, 4.40, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10251, 10251, '0', 'hween_c18_labcage', 'hween_c18_labcage', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(10252, 10252, '0', 'hween_ltd18_cosplaycat', 'hween_ltd18_cosplaycat', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(10253, 10253, '0', 'hween_c18_oldceilingrays', 'hween_c18_oldceilingrays', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10254, 10254, '0', 'hween_c18_labcurtains', 'hween_c18_labcurtains', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10255, 10255, '0', 'hween_c18_toy3new', 'hween_c18_toy3new', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10256, 10256, '0', 'hween_c18_toy2new', 'hween_c18_toy2new', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10257, 10257, '0', 'hween_c18_labsteelfloor', 'hween_c18_labsteelfloor', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10258, 10258, '0', 'hween_c18_labmchn1', 'hween_c18_labmchn1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10259, 10259, '0', 'hween_c18_rustyceilingfan', 'hween_c18_rustyceilingfan', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10260, 10260, '0', 'hween_c18_labstoolold', 'hween_c18_labstoolold', 'S', 1, 1, 1.40, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10261, 10261, '0', 'hween_c18_labmchn2', 'hween_c18_labmchn2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10262, 10262, '0', 'hween_c18_brokenglasswall', 'hween_c18_brokenglasswall', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10263, 10263, '0', 'hween_c18_floormould', 'hween_c18_floormould', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(10264, 10264, '0', 'clothing_vintagejacket', 'clothing_vintagejacket', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10265, 10265, '0', 'hween_c18_washliquid', 'hween_c18_washliquid', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'switch', 2, '', '', '', 0, 0, ''),
	(10266, 10266, '0', 'hween_c18_toy1new', 'hween_c18_toy1new', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10267, 10267, '0', 'clothing_sideponytail', 'clothing_sideponytail', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10268, 10268, '0', 'hween_c18_zaptele', 'hween_c18_zaptele', 'S', 1, 1, 0.20, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'teleport', 1, '', '', '', 0, 0, ''),
	(10269, 10269, '0', 'clothing_r18_axe', 'clothing_r18_axe', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10270, 10270, '0', 'hween_c18_washmchn', 'hween_c18_washmchn', 'S', 1, 1, 1.85, '1', '0', '0', '0', '1', '0', '1', '0', '0', 'crafting', 2, '', '', '', 0, 0, ''),
	(10271, 10271, '0', 'hween_c18_labglovebox', 'hween_c18_labglovebox', 'S', 1, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10272, 10272, '0', 'hween_c18_bloodcurtains', 'hween_c18_bloodcurtains', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10273, 10273, '0', 'clothing_legwarmershoes', 'clothing_legwarmershoes', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10274, 10274, '0', 'hween_c18_toy4new', 'hween_c18_toy4new', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10275, 10275, '0', 'hween_c18_labshelf', 'hween_c18_labshelf', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '1043,1044', '', '', 0, 0, ''),
	(10276, 10276, '0', 'clothing_bloodshoes', 'clothing_bloodshoes', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10277, 10277, '0', 'hween_c18_bloodfloorstreak', 'hween_c18_bloodfloorstreak', 'S', 1, 3, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(10278, 10278, '0', 'clothing_r18_vamp', 'clothing_r18_vamp', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10279, 10279, '0', 'hween_c18_labdesk', 'hween_c18_labdesk', 'S', 1, 2, 1.30, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10280, 10280, '0', 'hween_c18_oldlabdesk', 'hween_c18_oldlabdesk', 'S', 1, 2, 1.30, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10281, 10281, '0', 'hween_c18_labchair', 'hween_c18_labchair', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10282, 10282, '0', 'hween_c18_ceilingmould', 'hween_c18_ceilingmould', 'S', 1, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10283, 10283, '0', 'hween_c18_labjar1', 'hween_c18_labjar1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10284, 10284, '0', 'hween_c18_washpowder', 'hween_c18_washpowder', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10285, 10285, '0', 'hween_r18_pupbot', 'hween_r18_pupbot', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10286, 10286, '0', 'hween_c18_labmchn3', 'hween_c18_labmchn3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10287, 10287, '0', 'clothing_bloodjacket', 'clothing_bloodjacket', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10288, 10288, '0', 'hween_c18_complexmchn1', 'hween_c18_complexmchn1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10289, 10289, '0', 'hween_c18_spareparts', 'hween_c18_spareparts', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '44', '', '', 0, 0, ''),
	(10290, 10290, '0', 'clothing_labcoat', 'clothing_labcoat', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10291, 10291, '0', 'hween_c18_toy2old', 'hween_c18_toy2old', 'S', 1, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10292, 10292, '0', 'clothing_shortcurlhair', 'clothing_shortcurlhair', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10293, 10293, '0', 'hween_c18_labjar2', 'hween_c18_labjar2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10294, 10294, '0', 'hween_c18_labstool', 'hween_c18_labstool', 'S', 1, 1, 1.40, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10295, 10295, '0', 'hween_c18_labtooltable', 'hween_c18_labtooltable', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(10296, 10296, '0', 'clothing_bloodponytail', 'clothing_bloodponytail', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10297, 10297, '0', 'hween_r18_antiquechemset', 'hween_r18_antiquechemset', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10298, 10298, '0', 'hween_c18_toy1old', 'hween_c18_toy1old', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10299, 10299, '0', 'hween_c18_oldlabtilewall', 'hween_c18_oldlabtilewall', 'S', 1, 2, 4.40, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10300, 10300, '0', 'hween_c18_deskitems1', 'hween_c18_deskitems1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(10301, 10301, '0', 'clothing_bloodglasses', 'clothing_bloodglasses', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10302, 10302, '0', 'hween_c18_staffoftheyr', 'hween_c18_staffoftheyr', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 8, '', '', '', 0, 0, ''),
	(10303, 10303, '0', 'clothing_bloodscruffyhair', 'clothing_bloodscruffyhair', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10304, 10304, '0', 'hween_c18_olddocs1', 'hween_c18_olddocs1', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 9, '', '', '', 0, 0, ''),
	(10305, 10305, '0', 'hween_c18_toy3old', 'hween_c18_toy3old', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'switch', 2, '', '', '', 0, 0, ''),
	(10306, 10306, '0', 'hween_c18_labtilefloor', 'hween_c18_labtilefloor', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10307, 10307, '0', 'hween_c18_oldlablocker', 'hween_c18_oldlablocker', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10308, 10308, '0', 'hween_c18_flashlight', 'hween_c18_flashlight', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10309, 10309, '0', 'hween_c18_labbed', 'hween_c18_labbed', 'S', 1, 3, 1.60, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10310, 10310, '0', 'hween_c18_lablocker', 'hween_c18_lablocker', 'S', 1, 1, 2.63, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10311, 10311, '0', 'CF_350_jadefish', 'CF_350_jadefish', 'S', 1, 1, 0.00, '0', '0', '0', '0', '0', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(10312, 10312, '1', 'hygge_c18_stove', 'hygge_c18_stove', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10313, 10313, '1', 'hygge_c18_cushion', 'hygge_c18_cushion', 'S', 2, 2, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(10314, 10314, '0', 'clothing_r18_antlers', 'clothing_r18_antlers', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10315, 10315, '0', 'hygge_r18_fox', 'hygge_r18_fox', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10316, 10316, '0', 'clothing_r18_hyggehair', 'clothing_r18_hyggehair', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10317, 10317, '1', 'hygge_c18_shelf', 'hygge_c18_shelf', 'S', 1, 1, 1.20, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(10318, 10318, '1', 'hygge_c18_chair', 'hygge_c18_chair', 'S', 1, 1, 1.15, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10319, 10319, '0', 'clothing_r18_dungarees', 'clothing_r18_dungarees', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10320, 10320, '0', 'clothing_r18_diaparty', 'clothing_r18_diaparty', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10321, 10321, '0', 'clothing_dianoblecrown', 'clothing_dianoblecrown', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10322, 10322, '0', 'diamond_c18_giftbox', 'diamond_c18_giftbox', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(10323, 10323, '0', 'clothing_diafish', 'clothing_diafish', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10324, 10324, '0', 'clothing_dialeafcrown', 'clothing_dialeafcrown', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10325, 10325, '0', 'xmas_c18_deer_comet', 'xmas_c18_deer_comet', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10326, 10326, '0', 'xmas_c18_stocking_snoopy', 'xmas_c18_stocking_snoopy', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10327, 10327, '0', 'xmas_c18_souvenir', 'xmas_c18_souvenir', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(10328, 10328, '0', 'xmas_c18_deer_dasher', 'xmas_c18_deer_dasher', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10329, 10329, '0', 'clothing_halo', 'clothing_halo', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10330, 10330, '0', 'xmas_c18_snowfootball', 'xmas_c18_snowfootball', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'football', 2, '', '', '', 0, 0, ''),
	(10331, 10331, '0', 'xmas_c18_stocking_cinnamon', 'xmas_c18_stocking_cinnamon', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10332, 10332, '0', 'xmas_c18_stool', 'xmas_c18_stool', 'S', 1, 1, 1.40, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10333, 10333, '0', 'xmas_c18_stage', 'xmas_c18_stage', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 2, '', '1;2', '', 0, 0, ''),
	(10334, 10334, '0', 'xmas_c18_metro', 'xmas_c18_metro', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'teleport', 2, '', '', '', 0, 0, ''),
	(10335, 10335, '0', 'xmas_c18_stocking_tiger', 'xmas_c18_stocking_tiger', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10336, 10336, '0', 'xmas_c18_snowman', 'xmas_c18_snowman', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10337, 10337, '0', 'xmas_c18_snowballpit', 'xmas_c18_snowballpit', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10338, 10338, '0', 'xmas_c18_stocking_crusoe', 'xmas_c18_stocking_crusoe', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10339, 10339, '0', 'xmas_c18_stallroof', 'xmas_c18_stallroof', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10340, 10340, '0', 'xmas_c18_presentelf', 'xmas_c18_presentelf', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(10341, 10341, '0', 'xmas_c18_doll10', 'xmas_c18_doll10', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(10342, 10342, '0', 'clothing_rudolphhat', 'clothing_rudolphhat', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10343, 10343, '0', 'xmas_c18_doll8', 'xmas_c18_doll8', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(10344, 10344, '0', 'xmas_c18_deer_vixen', 'xmas_c18_deer_vixen', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10345, 10345, '0', 'xmas_c18_stagecurtains', 'xmas_c18_stagecurtains', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(10346, 10346, '0', 'xmas_c18_stocking_cleo', 'xmas_c18_stocking_cleo', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10347, 10347, '0', 'xmas_c18_presents', 'xmas_c18_presents', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10348, 10348, '0', 'xmas_r18_snowyowl', 'xmas_r18_snowyowl', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10349, 10349, '0', 'xmas_c18_doll6', 'xmas_c18_doll6', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(10350, 10350, '0', 'xmas_c18_stalltable', 'xmas_c18_stalltable', 'S', 1, 1, 0.80, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10351, 10351, '0', 'xmas_c18_streetlight', 'xmas_c18_streetlight', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(10352, 10352, '0', 'xmas_c18_doll5', 'xmas_c18_doll5', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(10353, 10353, '0', 'xmas_r18_lightfountain', 'xmas_r18_lightfountain', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10354, 10354, '0', 'clothing_poinsettia', 'clothing_poinsettia', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10355, 10355, '0', 'clothing_bobblehat', 'clothing_bobblehat', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10356, 10356, '0', 'xmas_c18_groundlight', 'xmas_c18_groundlight', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10357, 10357, '0', 'xmas_c18_stagechair', 'xmas_c18_stagechair', 'S', 1, 1, 1.40, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10358, 10358, '0', 'clothing_r18_featherdress', 'clothing_r18_featherdress', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10359, 10359, '0', 'xmas_c18_stagestairs', 'xmas_c18_stagestairs', 'S', 1, 1, 0.50, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10360, 10360, '0', 'xmas_c18_deer_rudolph', 'xmas_c18_deer_rudolph', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10361, 10361, '0', 'clothing_penguin', 'clothing_penguin', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10362, 10362, '0', 'xmas_c18_xmastree', 'xmas_c18_xmastree', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10363, 10363, '0', 'xmas_c18_booth', 'xmas_c18_booth', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(10364, 10364, '0', 'xmas_c18_curtaintopper', 'xmas_c18_curtaintopper', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10365, 10365, '0', 'xmas_c18_building', 'xmas_c18_building', 'S', 2, 1, 5.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10366, 10366, '0', 'xmas_ltd18_snowhabberge', 'xmas_ltd18_snowhabberge', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10367, 10367, '0', 'xmas_c18_iciclelight', 'xmas_c18_iciclelight', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10368, 10368, '0', 'xmas_c18_deer_cupid', 'xmas_c18_deer_cupid', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10369, 10369, '0', 'xmas_c18_borscht', 'xmas_c18_borscht', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '123', '', '', 0, 0, ''),
	(10370, 10370, '0', 'xmas_c18_doll3', 'xmas_c18_doll3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(10371, 10371, '0', 'xmas_c18_doll2', 'xmas_c18_doll2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(10372, 10372, '0', 'xmas_c18_balllight', 'xmas_c18_balllight', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 8, '', '', '', 0, 0, ''),
	(10373, 10373, '0', 'xmas_c18_harp', 'xmas_c18_harp', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10374, 10374, '0', 'clothing_r18_feathercrown', 'clothing_r18_feathercrown', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10375, 10375, '0', 'xmas_c18_penguin', 'xmas_c18_penguin', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10376, 10376, '0', 'xmas_c18_deer_prancer', 'xmas_c18_deer_prancer', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10377, 10377, '0', 'clothing_sideflopped', 'clothing_sideflopped', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10378, 10378, '0', 'xmas_c18_doll1', 'xmas_c18_doll1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(10379, 10379, '0', 'xmas_c18_rainlightfloor', 'xmas_c18_rainlightfloor', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10380, 10380, '0', 'xmas_c18_candycane', 'xmas_c18_candycane', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10381, 10381, '0', 'xmas_c18_stocking_norbert', 'xmas_c18_stocking_norbert', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10382, 10382, '0', 'clothing_snowman', 'clothing_snowman', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10383, 10383, '0', 'xmas_c18_buildingpillar', 'xmas_c18_buildingpillar', 'S', 1, 1, 5.20, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10384, 10384, '0', 'xmas_c18_doll7', 'xmas_c18_doll7', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(10385, 10385, '0', 'xmas_c18_bounceycastle', 'xmas_c18_bounceycastle', 'S', 3, 3, 0.80, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 193, 193, ''),
	(10386, 10386, '0', 'xmas_c18_babushka', 'xmas_c18_babushka', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10387, 10387, '0', 'xmas_c18_doll9', 'xmas_c18_doll9', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(10388, 10388, '0', 'xmas_c18_stagewindow', 'xmas_c18_stagewindow', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(10389, 10389, '0', 'clothing_xmas5', 'clothing_xmas5', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10390, 10390, '0', 'clothing_mittens', 'clothing_mittens', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10391, 10391, '0', 'xmas_c18_fairylightree', 'xmas_c18_fairylightree', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10392, 10392, '0', 'xmas_c18_deer_blitzen', 'xmas_c18_deer_blitzen', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10393, 10393, '0', 'xmas_c18_stocking_boo', 'xmas_c18_stocking_boo', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10394, 10394, '0', 'xmas_c18_nutcracker', 'xmas_c18_nutcracker', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '0', '1', '0', '0', 'crafting', 2, '', '', '', 0, 0, ''),
	(10395, 10395, '0', 'xmas_c18_stagebackdrop', 'xmas_c18_stagebackdrop', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10396, 10396, '0', 'xmas_c18_bearlight', 'xmas_c18_bearlight', 'S', 1, 1, 2.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10397, 10397, '0', 'xmas_c18_deer_dancer', 'xmas_c18_deer_dancer', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10398, 10398, '0', 'xmas_c18_doll4', 'xmas_c18_doll4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(10399, 10399, '0', 'xmas_c18_food', 'xmas_c18_food', 'S', 1, 1, 0.20, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(10400, 10400, '0', 'xmas_c18_fatherfrost', 'xmas_c18_fatherfrost', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10401, 10401, '0', 'clothing_regiment', 'clothing_regiment', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10402, 10402, '0', 'xmas_c18_piano', 'xmas_c18_piano', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10403, 10403, '0', 'clothing_treepartyhat', 'clothing_treepartyhat', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10404, 10404, '0', 'xmas_c18_deer_donna', 'xmas_c18_deer_donna', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10405, 10405, '0', 'rare_prize18_xmas', 'rare_prize18_xmas', 'S', 1, 1, 0.10, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(10406, 10406, '0', 'hosp_c19_drinksvend', 'hosp_c19_drinksvend', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'vendingmachine', 2, '29,30,42,43', '', '', 0, 0, ''),
	(10407, 10407, '0', 'clothing_r18_goldpack4', 'clothing_r18_goldpack4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10408, 10408, '0', 'attic_c19_hammock', 'attic_c19_hammock', 'S', 1, 3, 2.30, '0', '0', '1', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10409, 10409, '0', 'clothing_r18_sparkleparty2', 'clothing_r18_sparkleparty2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10410, 10410, '0', 'clothing_r18_sparkleparty1', 'clothing_r18_sparkleparty1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10411, 10411, '0', 'clothing_r18_sparkleparty7', 'clothing_r18_sparkleparty7', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10412, 10412, '0', 'clothing_r18_sparkleparty4', 'clothing_r18_sparkleparty4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10413, 10413, '0', 'clothing_r19_longwavy2', 'clothing_r19_longwavy2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10414, 10414, '0', 'ny_r18_crackable', 'ny_r18_crackable', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(10415, 10415, '0', 'clothing_r18_sparkleparty8', 'clothing_r18_sparkleparty8', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10416, 10416, '0', 'clothing_r18_sparkleparty6', 'clothing_r18_sparkleparty6', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10417, 10417, '0', 'clothing_r18_sparkleparty3', 'clothing_r18_sparkleparty3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10418, 10418, '0', 'clothing_r18_sparkleparty5', 'clothing_r18_sparkleparty5', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10419, 10419, '0', 'diamond_c18_giftbox2', 'diamond_c18_giftbox2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(10420, 10420, '0', 'CF_1000_goldenkey', 'CF_1000_goldenkey', 'S', 1, 1, 0.00, '0', '0', '0', '0', '0', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10421, 10421, '0', 'hween13_c19_frog', 'hween13_c19_frog', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 5, '', '', '', 0, 0, ''),
	(10422, 10422, '0', 'hc19_11', 'hc19_11', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10423, 10423, '0', 'hc19_1', 'hc19_1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10424, 10424, '0', 'hc19_4', 'hc19_4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10425, 10425, '0', 'hc19_5', 'hc19_5', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10426, 10426, '0', 'hc19_9', 'hc19_9', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10427, 10427, '0', 'hc19_3', 'hc19_3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10428, 10428, '0', 'hc19_2', 'hc19_2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10429, 10429, '0', 'hc19_10', 'hc19_10', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10430, 10430, '0', 'hc19_12', 'hc19_12', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10431, 10431, '0', 'hc19_7', 'hc19_7', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10432, 10432, '0', 'hc19_6', 'hc19_6', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10433, 10433, '0', 'hc19_8', 'hc19_8', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10434, 10434, '0', 'val_c19_food', 'val_c19_food', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(10435, 10435, '0', 'val_c19_bottlewall', 'val_c19_bottlewall', 'S', 2, 1, 4.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10436, 10436, '0', 'clothing_r19_messybun', 'clothing_r19_messybun', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10437, 10437, '0', 'val_r19_bath', 'val_r19_bath', 'S', 1, 2, 1.00, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10438, 10438, '0', 'val_r19_recordplayer', 'val_r19_recordplayer', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10439, 10439, '0', 'clothing_r19_frilledskirt', 'clothing_r19_frilledskirt', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10440, 10440, '0', 'val_c19_bottle', 'val_c19_bottle', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10441, 10441, '0', 'val_r19_puppy', 'val_r19_puppy', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10442, 10442, '0', 'val_c19_till', 'val_c19_till', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10443, 10443, '0', 'val_r19_unicorn', 'val_r19_unicorn', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(10444, 10444, '0', 'clothing_r19_shortcurly', 'clothing_r19_shortcurly', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10445, 10445, '0', 'clothing_r19_waistcoat', 'clothing_r19_waistcoat', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10446, 10446, '0', 'val_c19_tableacc', 'val_c19_tableacc', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(10447, 10447, '0', 'val_c19_chair', 'val_c19_chair', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10448, 10448, '0', 'val_c19_petals', 'val_c19_petals', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10449, 10449, '0', 'val_c19_awning', 'val_c19_awning', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10450, 10450, '0', 'val_c19_table', 'val_c19_table', 'S', 1, 1, 0.90, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10451, 10451, '0', 'val_r19_sofa', 'val_r19_sofa', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'pressureplate_group', 1, '', '', '', 0, 0, ''),
	(10452, 10452, '0', 'china_pig', 'china_pig', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10453, 10453, '0', 'china_goldenpig', 'china_goldenpig', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10454, 10454, '0', 'clothing_piglethat', 'clothing_piglethat', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10455, 10455, '0', 'rare_prize19*0', 'rare_prize19*0', 'S', 1, 1, 0.10, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(10456, 10456, '0', 'rare_prize19*1', 'rare_prize19*1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10457, 10457, '0', 'rare_prize19*10', 'rare_prize19*10', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10458, 10458, '0', 'rare_prize19*11', 'rare_prize19*11', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10459, 10459, '0', 'rare_prize19*12', 'rare_prize19*12', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10460, 10460, '0', 'rare_prize19*13', 'rare_prize19*13', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10461, 10461, '0', 'rare_prize19*2', 'rare_prize19*2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10462, 10462, '0', 'rare_prize19*3', 'rare_prize19*3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10463, 10463, '0', 'rare_prize19*4', 'rare_prize19*4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10464, 10464, '0', 'rare_prize19*5', 'rare_prize19*5', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10465, 10465, '0', 'rare_prize19*6', 'rare_prize19*6', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10466, 10466, '0', 'rare_prize19*7', 'rare_prize19*7', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10467, 10467, '0', 'rare_prize19*8', 'rare_prize19*8', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10468, 10468, '0', 'rare_prize19*9', 'rare_prize19*9', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10469, 10469, '0', 'room_invisible_block', 'room_invisible_block', 'S', 1, 1, 1.00, '0', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(10470, 10470, '0', 'rare_colourable_scifirocket*4', 'rare_colourable_scifirocket*4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10471, 10471, '0', 'rare_colourable_parasol*4', 'rare_colourable_parasol*4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10472, 10472, '0', 'rare_r19_car1', 'rare_r19_car1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10473, 10473, '0', 'clothing_topbuttonshirt', 'clothing_topbuttonshirt', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10474, 10474, '0', 'clothing_rippedjeans2', 'clothing_rippedjeans2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10475, 10475, '0', 'clothing_r19_scuffedboots', 'clothing_r19_scuffedboots', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10476, 10476, '0', 'clothing_r19_longtwotone', 'clothing_r19_longtwotone', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10477, 10477, '1', 'band_c19_drums', 'band_c19_drums', 'S', 3, 3, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10478, 10478, '0', 'clothing_r19_punkhat', 'clothing_r19_punkhat', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10479, 10479, '1', 'band_c19_guitar', 'band_c19_guitar', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10480, 10480, '0', 'clothing_r19_messybangs', 'clothing_r19_messybangs', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10481, 10481, '0', 'clothing_messycurls', 'clothing_messycurls', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10482, 10482, '1', 'band_c19_synth', 'band_c19_synth', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10483, 10483, '0', 'clothing_highfade', 'clothing_highfade', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10484, 10484, '0', 'easter_c19_kelpie', 'easter_c19_kelpie', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10485, 10485, '0', 'clothing_r19_forrestcrown', 'clothing_r19_forrestcrown', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10486, 10486, '0', 'easter_ltd19_flowerthrone', 'easter_ltd19_flowerthrone', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10487, 10487, '0', 'easter_c19_babyent', 'easter_c19_babyent', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 24, '', '', '', 0, 0, ''),
	(10488, 10488, '0', 'easter_c19_habshirecat', 'easter_c19_habshirecat', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10489, 10489, '0', 'easter_r19_treeswing', 'easter_r19_treeswing', 'S', 2, 1, 1.40, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10490, 10490, '0', 'easter_c19_book4a', 'easter_c19_book4a', 'S', 1, 1, 0.35, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10491, 10491, '0', 'easter_c19_turnipbuddies', 'easter_c19_turnipbuddies', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(10492, 10492, '0', 'easter_c19_wisestone', 'easter_c19_wisestone', 'S', 1, 1, 2.20, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10493, 10493, '0', 'easter_c19_ancientbook2', 'easter_c19_ancientbook2', 'S', 1, 1, 0.35, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10494, 10494, '0', 'clothing_ribboncurls', 'clothing_ribboncurls', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10495, 10495, '0', 'easter_c19_earthdrago', 'easter_c19_earthdrago', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10496, 10496, '0', 'easter_c19_logtable', 'easter_c19_logtable', 'S', 1, 2, 0.60, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10497, 10497, '0', 'easter_c19_book1', 'easter_c19_book1', 'S', 1, 1, 0.35, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(10498, 10498, '0', 'easter_c19_book3', 'easter_c19_book3', 'S', 1, 1, 0.35, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(10499, 10499, '0', 'clothing_archerhat', 'clothing_archerhat', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10500, 10500, '0', 'easter_c19_littlefairies', 'easter_c19_littlefairies', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10501, 10501, '0', 'easter_c19_book2', 'easter_c19_book2', 'S', 1, 1, 0.35, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(10502, 10502, '0', 'easter_c19_logchair', 'easter_c19_logchair', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10503, 10503, '0', 'easter_c19_book3a', 'easter_c19_book3a', 'S', 1, 1, 0.35, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10504, 10504, '0', 'clothing_madhat', 'clothing_madhat', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10505, 10505, '0', 'easter_c19_book4', 'easter_c19_book4', 'S', 1, 1, 0.35, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(10506, 10506, '0', 'easter_c19_book2a', 'easter_c19_book2a', 'S', 1, 1, 0.35, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10507, 10507, '0', 'easter_c19_meadow', 'easter_c19_meadow', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10508, 10508, '0', 'easter_c19_dirtpath', 'easter_c19_dirtpath', 'S', 1, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10509, 10509, '0', 'easter_c19_flowertea', 'easter_c19_flowertea', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10510, 10510, '0', 'easter_c19_babyhippogriff', 'easter_c19_babyhippogriff', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 24, '', '', '', 0, 0, ''),
	(10511, 10511, '0', 'easter_c19_mushrooms', 'easter_c19_mushrooms', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(10512, 10512, '0', 'easter_c19_forrestegg', 'easter_c19_forrestegg', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'crackable', 24, '', '', '', 0, 0, ''),
	(10513, 10513, '0', 'easter_c19_chillgnome', 'easter_c19_chillgnome', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10514, 10514, '0', 'easter_c19_babykelpie2', 'easter_c19_babykelpie2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10515, 10515, '0', 'easter_c19_babyhippogriff2', 'easter_c19_babyhippogriff2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10516, 10516, '0', 'easter_c19_ent', 'easter_c19_ent', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10517, 10517, '0', 'easter_c19_wolf', 'easter_c19_wolf', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10518, 10518, '0', 'easter_c19_ancientbook', 'easter_c19_ancientbook', 'S', 1, 1, 0.35, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(10519, 10519, '0', 'easter_r19_mysticalbird', 'easter_r19_mysticalbird', 'S', 1, 1, 1.70, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10520, 10520, '0', 'clothing_mushroomhat', 'clothing_mushroomhat', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10521, 10521, '0', 'clothing_petaldress', 'clothing_petaldress', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10522, 10522, '0', 'clothing_wolfmask', 'clothing_wolfmask', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10523, 10523, '0', 'clothing_flowerponytail', 'clothing_flowerponytail', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10524, 10524, '0', 'easter_c19_busybunny', 'easter_c19_busybunny', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10525, 10525, '0', 'easter_c19_forrestfood', 'easter_c19_forrestfood', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(10526, 10526, '0', 'easter_c19_springtree', 'easter_c19_springtree', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10527, 10527, '0', 'easter_c19_book1a', 'easter_c19_book1a', 'S', 1, 1, 0.35, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10528, 10528, '0', 'easter_c19_waterdrago', 'easter_c19_waterdrago', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10529, 10529, '0', 'easter_c19_babykelpie', 'easter_c19_babykelpie', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 24, '', '', '', 0, 0, ''),
	(10530, 10530, '0', 'easter_c19_habelina', 'easter_c19_habelina', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10531, 10531, '0', 'easter_c19_babyent2', 'easter_c19_babyent2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10532, 10532, '0', 'easter_c19_woodlandcritters', 'easter_c19_woodlandcritters', 'S', 2, 2, 0.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10533, 10533, '0', 'clothing_r19_fox', 'clothing_r19_fox', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10534, 10534, '0', 'easter_c19_forrestegg2', 'easter_c19_forrestegg2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10535, 10535, '0', 'easter_c19_lilredbonnie', 'easter_c19_lilredbonnie', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10536, 10536, '0', 'easter_c19_magicringtele', 'easter_c19_magicringtele', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'teleporttile', 2, '', '', '', 0, 0, ''),
	(10537, 10537, '0', 'easter_c19_hippogriff', 'easter_c19_hippogriff', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10538, 10538, '0', 'easter_c19_fairyprince', 'easter_c19_fairyprince', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10539, 10539, '0', 'clothing_leafhair', 'clothing_leafhair', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10540, 10540, '0', 'easter_c19_forrestfloor', 'easter_c19_forrestfloor', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10541, 10541, '0', 'easter_c19_bearowl', 'easter_c19_bearowl', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10542, 10542, '0', 'easter_c19_flowerlamp', 'easter_c19_flowerlamp', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10543, 10543, '0', 'bonusbag19_1', 'bonusbag19_1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(10544, 10544, '0', 'bonusrare19_1*0', 'bonusrare19_1*0', 'S', 1, 1, 0.10, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10545, 10545, '0', 'bonusrare19_1*1', 'bonusrare19_1*1', 'S', 1, 1, 0.10, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10546, 10546, '0', 'bonusrare19_1*2', 'bonusrare19_1*2', 'S', 1, 1, 0.10, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10547, 10547, '0', 'bonusrare19_1*3', 'bonusrare19_1*3', 'S', 1, 1, 0.10, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10548, 10548, '0', 'bonusrare19_1*4', 'bonusrare19_1*4', 'S', 1, 1, 0.10, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10549, 10549, '0', 'bonusrare19_1*5', 'bonusrare19_1*5', 'S', 1, 1, 0.10, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10550, 10550, '0', 'clothing_r19_comedymask', 'clothing_r19_comedymask', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10551, 10551, '0', 'greek_c19_scrolls1', 'greek_c19_scrolls1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10552, 10552, '1', 'greek_c19_table', 'greek_c19_table', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10553, 10553, '0', 'greek_c19_vase2', 'greek_c19_vase2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10554, 10554, '0', 'greek_c19_scrolls2', 'greek_c19_scrolls2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10555, 10555, '0', 'greek_c19_harp2', 'greek_c19_harp2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10556, 10556, '0', 'clothing_r19_tragedymask', 'clothing_r19_tragedymask', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10557, 10557, '0', 'greek_c19_fruitbowl', 'greek_c19_fruitbowl', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10558, 10558, '0', 'greek_c19_harp', 'greek_c19_harp', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10559, 10559, '0', 'greek_c19_pythagorascup', 'greek_c19_pythagorascup', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10560, 10560, '0', 'clothing_r19_minotaurhorns', 'clothing_r19_minotaurhorns', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10561, 10561, '0', 'greek_r19_tiledbath', 'greek_r19_tiledbath', 'S', 2, 2, 1.50, '0', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 29, 29, ''),
	(10562, 10562, '0', 'greek_c19_shield2', 'greek_c19_shield2', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10563, 10563, '0', 'greek_c19_vase1', 'greek_c19_vase1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10564, 10564, '1', 'greek_c19_chair', 'greek_c19_chair', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10565, 10565, '0', 'clothing_r19_medusa', 'clothing_r19_medusa', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10566, 10566, '0', 'greek_r19_chariot', 'greek_r19_chariot', 'S', 1, 1, 1.00, '1', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10567, 10567, '1', 'greek_c19_statue', 'greek_c19_statue', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10568, 10568, '0', 'greek_c19_shield1', 'greek_c19_shield1', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10569, 10569, '0', 'greek_ltd19_harp', 'greek_ltd19_harp', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10570, 10570, '0', 'greek_r19_luxbed', 'greek_r19_luxbed', 'S', 1, 3, 1.40, '0', '0', '1', '0', '1', '1', '0', '1', '1', 'bed', 2, '', '', '', 0, 0, ''),
	(10571, 10571, '1', 'greek_c19_wall', 'greek_c19_wall', 'S', 1, 2, 3.10, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10572, 10572, '0', 'booster_c19_box1', 'booster_c19_box1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 1, '', '', '', 0, 0, ''),
	(10573, 10573, '0', 'booster_c19_box2', 'booster_c19_box2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 1, '', '', '', 0, 0, ''),
	(10574, 10574, '1', 'fest_c19_parasol1', 'fest_c19_parasol1', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10575, 10575, '0', 'fest_c19_stool3', 'fest_c19_stool3', 'S', 1, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10576, 10576, '1', 'fest_c19_loverstent', 'fest_c19_loverstent', 'S', 1, 1, 1.00, '0', '0', '1', '0', '1', '1', '0', '1', '1', 'tent', 2, '', '', '', 0, 0, ''),
	(10577, 10577, '1', 'fest_c19_bobbatea', 'fest_c19_bobbatea', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'vendingmachine', 2, '124,125,126', '', '', 0, 0, ''),
	(10578, 10578, '0', 'fest_ltd19_alpaca', 'fest_ltd19_alpaca', 'S', 1, 1, 2.00, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10579, 10579, '1', 'fest_c19_ticketstall', 'fest_c19_ticketstall', 'S', 1, 1, 0.50, '0', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10580, 10580, '0', 'fest_c19_parasol3', 'fest_c19_parasol3', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10581, 10581, '0', 'clothing_bohogems', 'clothing_bohogems', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10582, 10582, '0', 'fest_c19_materials', 'fest_c19_materials', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10583, 10583, '0', 'clothing_bohoheadgems', 'clothing_bohoheadgems', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10584, 10584, '0', 'clothing_plungebikini', 'clothing_plungebikini', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10585, 10585, '1', 'fest_c19_falafelstall', 'fest_c19_falafelstall', 'S', 1, 1, 0.50, '0', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10586, 10586, '1', 'fest_c19_pole', 'fest_c19_pole', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10587, 10587, '0', 'fest_c19_skull3', 'fest_c19_skull3', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10588, 10588, '0', 'clothing_flowerbeard', 'clothing_flowerbeard', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10589, 10589, '1', 'fest_c19_coalicecream', 'fest_c19_coalicecream', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'vendingmachine', 2, '127,128', '', '', 0, 0, ''),
	(10590, 10590, '0', 'clothing_dreadlockstied', 'clothing_dreadlockstied', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10591, 10591, '0', 'fest_c19_cushion3', 'fest_c19_cushion3', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10592, 10592, '1', 'fest_c19_hangingdecor', 'fest_c19_hangingdecor', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10593, 10593, '0', 'clothing_r19_rainbowhair', 'clothing_r19_rainbowhair', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10594, 10594, '0', 'clothing_bohotunic', 'clothing_bohotunic', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10595, 10595, '1', 'fest_c19_backdrop1', 'fest_c19_backdrop1', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10596, 10596, '0', 'fest_c19_dye1', 'fest_c19_dye1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10597, 10597, '0', 'fest_c19_dye2', 'fest_c19_dye2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10598, 10598, '0', 'fest_c19_cushion2', 'fest_c19_cushion2', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10599, 10599, '0', 'clothing_waistbag', 'clothing_waistbag', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10600, 10600, '0', 'fest_c19_bprint1', 'fest_c19_bprint1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10601, 10601, '1', 'fest_c19_dreamcatcher', 'fest_c19_dreamcatcher', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10602, 10602, '1', 'fest_c19_bongos', 'fest_c19_bongos', 'S', 1, 1, 0.50, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10603, 10603, '0', 'fest_r19_gemowl', 'fest_r19_gemowl', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10604, 10604, '0', 'clothing_grandetail', 'clothing_grandetail', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10605, 10605, '1', 'fest_c19_dj', 'fest_c19_dj', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10606, 10606, '0', 'fest_c19_bprint4', 'fest_c19_bprint4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10607, 10607, '0', 'fest_c19_skull5', 'fest_c19_skull5', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10608, 10608, '0', 'fest_c19_skull4', 'fest_c19_skull4', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10609, 10609, '0', 'fest_c19_parasol2', 'fest_c19_parasol2', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10610, 10610, '0', 'fest_c19_skull2', 'fest_c19_skull2', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10611, 10611, '0', 'clothing_bohobackpack', 'clothing_bohobackpack', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10612, 10612, '1', 'fest_c19_brazier', 'fest_c19_brazier', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10613, 10613, '0', 'clothing_flowingshirt', 'clothing_flowingshirt', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10614, 10614, '0', 'fest_c19_bprint3', 'fest_c19_bprint3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10615, 10615, '0', 'clothing_r19_rainbowshades', 'clothing_r19_rainbowshades', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10616, 10616, '1', 'fest_c19_lamp', 'fest_c19_lamp', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 6, '', '', '', 0, 0, ''),
	(10617, 10617, '1', 'fest_c19_palm', 'fest_c19_palm', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10618, 10618, '0', 'clothing_bohovest', 'clothing_bohovest', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10619, 10619, '0', 'clothing_bohotiara', 'clothing_bohotiara', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10620, 10620, '0', 'fest_r19_ladygaia', 'fest_r19_ladygaia', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10621, 10621, '1', 'fest_c19_stool1', 'fest_c19_stool1', 'S', 1, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10622, 10622, '0', 'fest_c19_hipdog', 'fest_c19_hipdog', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10623, 10623, '0', 'fest_c19_backdrop2', 'fest_c19_backdrop2', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10624, 10624, '1', 'fest_c19_amp', 'fest_c19_amp', 'S', 1, 1, 2.80, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10625, 10625, '1', 'fest_c19_didgeridoo', 'fest_c19_didgeridoo', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10626, 10626, '0', 'fest_c19_bprintcrackable', 'fest_c19_bprintcrackable', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(10627, 10627, '0', 'fest_c19_skull1', 'fest_c19_skull1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10628, 10628, '0', 'clothing_ruggedbackpack', 'clothing_ruggedbackpack', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10629, 10629, '0', 'clothing_bohopaint', 'clothing_bohopaint', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10630, 10630, '0', 'clothing_bohobag', 'clothing_bohobag', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10631, 10631, '0', 'fest_c19_backdrop3', 'fest_c19_backdrop3', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10632, 10632, '0', 'fest_c19_skull6', 'fest_c19_skull6', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10633, 10633, '1', 'fest_c19_sitar', 'fest_c19_sitar', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10634, 10634, '0', 'fest_c19_craft', 'fest_c19_craft', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '0', '1', '0', '0', 'crafting', 2, '', '', '', 0, 0, ''),
	(10635, 10635, '0', 'fest_c19_stool2', 'fest_c19_stool2', 'S', 1, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10636, 10636, '0', 'fest_c19_bprint2', 'fest_c19_bprint2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10637, 10637, '1', 'fest_c19_stage', 'fest_c19_stage', 'S', 1, 1, 1.30, '1', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10638, 10638, '1', 'fest_c19_cushion1', 'fest_c19_cushion1', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10639, 10639, '1', 'fest_c19_flags', 'fest_c19_flags', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(10640, 10640, '0', 'pastel_c19_plushie3', 'pastel_c19_plushie3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10641, 10641, '0', 'pastel_c19_stool', 'pastel_c19_stool', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10642, 10642, '0', 'pastel_c19_cupcake', 'pastel_c19_cupcake', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10643, 10643, '0', 'pastel_c19_bedsidetable', 'pastel_c19_bedsidetable', 'S', 1, 1, 1.20, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10644, 10644, '0', 'pastel_c19_stardeco', 'pastel_c19_stardeco', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10645, 10645, '0', 'clothing_r19_rainbowstarjumper', 'clothing_r19_rainbowstarjumper', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10646, 10646, '0', 'pastel_c19_sofa', 'pastel_c19_sofa', 'S', 2, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10647, 10647, '0', 'pastel_c19_cupboard', 'pastel_c19_cupboard', 'S', 1, 1, 2.70, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10648, 10648, '0', 'pastel_c19_unicornposter', 'pastel_c19_unicornposter', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10649, 10649, '0', 'pastel_c19_lamp', 'pastel_c19_lamp', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(10650, 10650, '0', 'pastel_c19_shootingstar', 'pastel_c19_shootingstar', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10651, 10651, '0', 'pastel_c19_carpet', 'pastel_c19_carpet', 'S', 4, 4, 0.00, '1', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10652, 10652, '0', 'pastel_c19_lights', 'pastel_c19_lights', 'S', 2, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(10653, 10653, '0', 'pastel_c19_table', 'pastel_c19_table', 'S', 1, 1, 1.20, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10654, 10654, '0', 'pastel_c19_plushie1', 'pastel_c19_plushie1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10655, 10655, '0', 'pastel_c19_starlights', 'pastel_c19_starlights', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10656, 10656, '0', 'pastel_c19_wall', 'pastel_c19_wall', 'S', 1, 2, 4.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10657, 10657, '0', 'pastel_c19_cubeseat', 'pastel_c19_cubeseat', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10658, 10658, '0', 'pastel_c19_plushiepile', 'pastel_c19_plushiepile', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10659, 10659, '0', 'pastel_c19_floor', 'pastel_c19_floor', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10660, 10660, '0', 'pastel_c19_plushie2', 'pastel_c19_plushie2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10661, 10661, '0', 'pastel_c19_bed', 'pastel_c19_bed', 'S', 2, 3, 1.80, '0', '0', '1', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10662, 10662, '0', 'CF_350_sceptre', 'CF_350_sceptre', 'S', 1, 1, 0.00, '0', '0', '0', '0', '0', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(10663, 10663, '0', 'diamond_painting39', 'diamond_painting39', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10664, 10664, '0', 'fest_c19_bprintcrackableb', 'fest_c19_bprintcrackableb', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10665, 10665, '0', 'bonusbag19_2', 'bonusbag19_2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(10666, 10666, '0', 'bonusrare19_2*0', 'bonusrare19_2*0', 'S', 1, 1, 0.50, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(10667, 10667, '0', 'bonusrare19_2*1', 'bonusrare19_2*1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10668, 10668, '0', 'bonusrare19_2*2', 'bonusrare19_2*2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10669, 10669, '0', 'bonusrare19_2*3', 'bonusrare19_2*3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10670, 10670, '0', 'bonusrare19_2*4', 'bonusrare19_2*4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10671, 10671, '0', 'bonusrare19_2*5', 'bonusrare19_2*5', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10672, 10672, '0', 'rainbow_r19_pineapplefloat', 'rainbow_r19_pineapplefloat', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'water_item', 1, '', '', '', 0, 0, ''),
	(10673, 10673, '1', 'rainbow_c19_table', 'rainbow_c19_table', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10674, 10674, '0', 'rainbow_ltd19_parasol', 'rainbow_ltd19_parasol', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10675, 10675, '1', 'rainbow_c19_rug', 'rainbow_c19_rug', 'S', 2, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10676, 10676, '1', 'rainbow_c19_chair', 'rainbow_c19_chair', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10677, 10677, '1', 'rainbow_c19_lights', 'rainbow_c19_lights', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10678, 10678, '1', 'rainbow_c19_bed', 'rainbow_c19_bed', 'S', 2, 3, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10679, 10679, '0', 'rainbow_r19_peacockfloat', 'rainbow_r19_peacockfloat', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'water_item', 1, '', '', '', 0, 0, ''),
	(10680, 10680, '0', 'rainbow_r19_rainbowfloat', 'rainbow_r19_rainbowfloat', 'S', 1, 1, 0.70, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10681, 10681, '0', 'rainbow_r19_flamingofloat', 'rainbow_r19_flamingofloat', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'water_item', 1, '', '', '', 0, 0, ''),
	(10682, 10682, '0', 'celestial_c19_wardrobe', 'celestial_c19_wardrobe', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10683, 10683, '0', 'celestial_c19_starshower', 'celestial_c19_starshower', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '1', '1', 'pressureplate', 2, '', '', '', 0, 0, ''),
	(10684, 10684, '0', 'celestial_c19_dresser', 'celestial_c19_dresser', 'S', 2, 1, 1.20, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10685, 10685, '0', 'celestial_c19_moonbed', 'celestial_c19_moonbed', 'S', 1, 3, 3.00, '0', '0', '1', '0', '1', '1', '1', '1', '1', 'bed', 2, '', '', '', 0, 0, ''),
	(10686, 10686, '0', 'celestial_c19_spacebun', 'celestial_c19_spacebun', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10687, 10687, '0', 'celestial_c19_rug', 'celestial_c19_rug', 'S', 1, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(10688, 10688, '0', 'celestial_c19_planet', 'celestial_c19_planet', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10689, 10689, '0', 'celestial_c19_tree', 'celestial_c19_tree', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10690, 10690, '0', 'celestial_c19_aurora', 'celestial_c19_aurora', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10691, 10691, '0', 'celestial_c19_flower', 'celestial_c19_flower', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10692, 10692, '0', 'celestial_c19_table', 'celestial_c19_table', 'S', 1, 1, 1.30, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10693, 10693, '0', 'celestial_c19_starchair', 'celestial_c19_starchair', 'S', 1, 1, 1.30, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10694, 10694, '0', 'celestial_c19_floor', 'celestial_c19_floor', 'S', 2, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10695, 10695, '0', 'clothing_r19_celestialdress', 'clothing_r19_celestialdress', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10696, 10696, '0', 'clothing_zebratop', 'clothing_zebratop', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10697, 10697, '0', 'clothing_nt_zebratop', 'clothing_nt_zebratop', 'S', 1, 1, 1.00, '0', '0', '0', '0', '0', '0', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10698, 10698, '0', 'clothing_croppedjumper', 'clothing_croppedjumper', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10699, 10699, '0', 'clothing_layeredlongskirt', 'clothing_layeredlongskirt', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10700, 10700, '1', 'rainbow_c19_flags', 'rainbow_c19_flags', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'vendingmachine', 2, '1082', '', '', 0, 0, ''),
	(10701, 10701, '0', 'clothing_longmohawk', 'clothing_longmohawk', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10702, 10702, '1', 'suncity_c19_botshop', 'suncity_c19_botshop', 'S', 2, 1, 4.70, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10703, 10703, '1', 'suncity_c19_jellyfood', 'suncity_c19_jellyfood', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(10704, 10704, '1', 'suncity_c19_building', 'suncity_c19_building', 'S', 2, 1, 4.70, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(10705, 10705, '1', 'suncity_c19_chair', 'suncity_c19_chair', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10706, 10706, '1', 'suncity_c19_waterway', 'suncity_c19_waterway', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10707, 10707, '1', 'suncity_c19_divider', 'suncity_c19_divider', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10708, 10708, '0', 'clothing_shortcut', 'clothing_shortcut', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10709, 10709, '0', 'clothing_loosekimono', 'clothing_loosekimono', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10710, 10710, '1', 'suncity_c19_flora', 'suncity_c19_flora', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(10711, 10711, '0', 'suncity_c19_glass', 'suncity_c19_glass', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10712, 10712, '1', 'suncity_c19_plantpillar', 'suncity_c19_plantpillar', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10713, 10713, '1', 'suncity_c19_awning', 'suncity_c19_awning', 'S', 2, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(10714, 10714, '0', 'clothing_gardenapron', 'clothing_gardenapron', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10715, 10715, '0', 'suncity_ltd19_duckpond', 'suncity_ltd19_duckpond', 'S', 3, 3, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10716, 10716, '0', 'suncity_c19_clock', 'suncity_c19_clock', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10717, 10717, '0', 'suncity_c19_lamp', 'suncity_c19_lamp', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10718, 10718, '0', 'clothing_nt_flowytop', 'clothing_nt_flowytop', 'S', 1, 1, 1.00, '0', '0', '0', '0', '0', '0', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10719, 10719, '0', 'clothing_butterflymask', 'clothing_butterflymask', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10720, 10720, '0', 'suncity_c19_plastic', 'suncity_c19_plastic', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10721, 10721, '1', 'suncity_c19_munchling', 'suncity_c19_munchling', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10722, 10722, '1', 'suncity_c19_balcony', 'suncity_c19_balcony', 'S', 2, 1, 4.70, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(10723, 10723, '1', 'suncity_c19_solarpanel', 'suncity_c19_solarpanel', 'S', 1, 2, 0.00, '0', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10724, 10724, '0', 'clothing_r19_butterflydress', 'clothing_r19_butterflydress', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10725, 10725, '0', 'suncity_r19_biosphere', 'suncity_r19_biosphere', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(10726, 10726, '1', 'suncity_c19_floor', 'suncity_c19_floor', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10727, 10727, '0', 'clothing_leafmask', 'clothing_leafmask', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10728, 10728, '0', 'clothing_gogglehat', 'clothing_gogglehat', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10729, 10729, '0', 'suncity_c19_paper', 'suncity_c19_paper', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10730, 10730, '1', 'suncity_c19_tree', 'suncity_c19_tree', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10731, 10731, '0', 'clothing_flowytop', 'clothing_flowytop', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10732, 10732, '0', 'suncity_c19_trashboy', 'suncity_c19_trashboy', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '0', '1', '0', '0', 'crafting', 2, '', '', '', 0, 0, ''),
	(10733, 10733, '0', 'suncity_c19_biokit', 'suncity_c19_biokit', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(10734, 10734, '0', 'clothing_leafearrings', 'clothing_leafearrings', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10735, 10735, '1', 'suncity_c19_glasswall', 'suncity_c19_glasswall', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10736, 10736, '1', 'suncity_c19_gazebo', 'suncity_c19_gazebo', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10737, 10737, '0', 'clothing_r19_featheredcowl', 'clothing_r19_featheredcowl', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10738, 10738, '1', 'suncity_c19_wateroutlet', 'suncity_c19_wateroutlet', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'vendingmachine_no_sides', 2, '1081', '', '', 0, 0, ''),
	(10739, 10739, '0', 'clothing_floralbag', 'clothing_floralbag', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10740, 10740, '1', 'suncity_c19_streetlight', 'suncity_c19_streetlight', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10741, 10741, '0', 'suncity_r19_glassfountain', 'suncity_r19_glassfountain', 'S', 2, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10742, 10742, '1', 'suncity_c19_minibridge', 'suncity_c19_minibridge', 'S', 1, 1, 0.20, '1', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10743, 10743, '1', 'suncity_c19_waterwaycrnr', 'suncity_c19_waterwaycrnr', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10744, 10744, '1', 'suncity_c19_table', 'suncity_c19_table', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10745, 10745, '0', 'clothing_sprout', 'clothing_sprout', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10746, 10746, '1', 'suncity_c19_perfumeshop', 'suncity_c19_perfumeshop', 'S', 2, 1, 4.70, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10747, 10747, '0', 'suncity_c19_vase', 'suncity_c19_vase', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10748, 10748, '0', 'clothing_nt_loosekimono', 'clothing_nt_loosekimono', 'S', 1, 1, 1.00, '0', '0', '0', '0', '0', '0', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10749, 10749, '0', 'clothing_nt_shortcut', 'clothing_nt_shortcut', 'S', 1, 1, 1.00, '0', '0', '0', '0', '0', '0', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10750, 10750, '0', 'clothing_nt_sprout', 'clothing_nt_sprout', 'S', 1, 1, 1.00, '0', '0', '0', '0', '0', '0', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10751, 10751, '0', 'clothing_nt_leafearrings', 'clothing_nt_leafearrings', 'S', 1, 1, 1.00, '0', '0', '0', '0', '0', '0', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10752, 10752, '0', 'clothing_nt_gardenapron', 'clothing_nt_gardenapron', 'S', 1, 1, 1.00, '0', '0', '0', '0', '0', '0', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10753, 10753, '1', 'rainyday_c19_lamp', 'rainyday_c19_lamp', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10754, 10754, '1', 'rainyday_c19_beanbag', 'rainyday_c19_beanbag', 'S', 1, 1, 0.80, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(10755, 10755, '1', 'rainyday_c19_pillowfort', 'rainyday_c19_pillowfort', 'S', 2, 1, 0.80, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10756, 10756, '1', 'rainyday_c19_rainwindows', 'rainyday_c19_rainwindows', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10757, 10757, '0', 'clothing_halftiedhair', 'clothing_halftiedhair', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10758, 10758, '0', 'clothing_r19_raincoat', 'clothing_r19_raincoat', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10759, 10759, '1', 'rainyday_c19_boardgames', 'rainyday_c19_boardgames', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(10760, 10760, '0', 'clothing_r19_teddygown', 'clothing_r19_teddygown', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10761, 10761, '0', 'clothing_bookbag', 'clothing_bookbag', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10762, 10762, '1', 'rainyday_c19_tartanseat', 'rainyday_c19_tartanseat', 'S', 3, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(10763, 10763, '1', 'rainyday_c19_rugblanket', 'rainyday_c19_rugblanket', 'S', 2, 2, 0.00, '0', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10764, 10764, '1', 'rainyday_c19_cocoa', 'rainyday_c19_cocoa', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(10765, 10765, '0', 'rainyday_r19_rainbear', 'rainyday_r19_rainbear', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(10766, 10766, '0', 'rainyday_r19_fluffbun', 'rainyday_r19_fluffbun', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10767, 10767, '0', 'market_c19_drygoods', 'market_c19_drygoods', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'vendingmachine', 2, '63,117,138,1028,1089', '', '', 0, 0, ''),
	(10768, 10768, '0', 'market_c19_trolley', 'market_c19_trolley', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10769, 10769, '0', 'market_c19_icecreamfreezer', 'market_c19_icecreamfreezer', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'vendingmachine', 2, '4,75,76,77,127,128,137', '', '', 0, 0, ''),
	(10770, 10770, '0', 'market_c19_deli1', 'market_c19_deli1', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'vendingmachine', 2, '34,81,111,132,136', '', '', 0, 0, ''),
	(10771, 10771, '0', 'market_c19_icecreamtubs', 'market_c19_icecreamtubs', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'vendingmachine', 2, '4,75,76,77,127,128,137', '', '', 0, 0, ''),
	(10772, 10772, '0', 'market_c19_stationary', 'market_c19_stationary', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'vendingmachine', 2, '1003,1004,1005,1068,1069,1070,1087,1088', '', '', 0, 0, ''),
	(10773, 10773, '0', 'market_c19_selfcheckout', 'market_c19_selfcheckout', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(10774, 10774, '0', 'market_c19_spill', 'market_c19_spill', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 9, '', '', '', 0, 0, ''),
	(10775, 10775, '0', 'market_c19_meat', 'market_c19_meat', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'vendingmachine', 2, '70,81,109,122,136', '', '', 0, 0, ''),
	(10776, 10776, '0', 'market_c19_floor', 'market_c19_floor', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10777, 10777, '0', 'market_c19_vegfruit', 'market_c19_vegfruit', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'vendingmachine', 2, '3,36,38,83,98,99,100,112,116,133,134,1084', '', '', 0, 0, ''),
	(10778, 10778, '0', 'market_c19_deli2', 'market_c19_deli2', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'vendingmachine', 2, '39,71,84,89,130,131,135', '', '', 0, 0, ''),
	(10779, 10779, '0', 'market_c19_banner', 'market_c19_banner', 'S', 2, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(10780, 10780, '0', 'market_c19_dairyfridge', 'market_c19_dairyfridge', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'vendingmachine', 2, '42,43,66,107,113,114,115,129,130', '', '', 0, 0, ''),
	(10781, 10781, '0', 'market_c19_basket', 'market_c19_basket', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 5, '', '', '', 0, 0, ''),
	(10782, 10782, '0', 'market_c19_antitheftalarm', 'market_c19_antitheftalarm', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10783, 10783, '0', 'market_c19_dvds', 'market_c19_dvds', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'vendingmachine', 2, '1085,1086', '', '', 0, 0, ''),
	(10784, 10784, '0', 'market_c19_checkoutdesk', 'market_c19_checkoutdesk', 'S', 3, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10785, 10785, '0', 'market_c19_signboard', 'market_c19_signboard', 'S', 2, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10786, 10786, '0', 'hween_c19_autumnfloor', 'hween_c19_autumnfloor', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10787, 10787, '0', 'hween_c19_tarot', 'hween_c19_tarot', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(10788, 10788, '0', 'hween_c19_crookedfloor', 'hween_c19_crookedfloor', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(10789, 10789, '0', 'hween_c19_bewitchedcauldron', 'hween_c19_bewitchedcauldron', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10790, 10790, '0', 'clothing_r19_warlocks', 'clothing_r19_warlocks', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10791, 10791, '0', 'hween_c19_herbs', 'hween_c19_herbs', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10792, 10792, '0', 'clothing_r19_longlonghair', 'clothing_r19_longlonghair', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10793, 10793, '0', 'hween_c19_stonewall', 'hween_c19_stonewall', 'S', 2, 1, 4.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 6, '', '', '', 0, 0, ''),
	(10794, 10794, '0', 'hween_c19_pumpkinpatch', 'hween_c19_pumpkinpatch', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '1', '1', 'vendingmachine_no_sides', 2, '1083', '', '', 0, 0, ''),
	(10795, 10795, '0', 'hween_c19_bewitchedchair', 'hween_c19_bewitchedchair', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10796, 10796, '0', 'hween_c19_bewitchedbed', 'hween_c19_bewitchedbed', 'S', 1, 3, 1.80, '0', '0', '1', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10797, 10797, '0', 'hween_c19_bewitchedtable', 'hween_c19_bewitchedtable', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10798, 10798, '0', 'hween_c19_crystal', 'hween_c19_crystal', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10799, 10799, '0', 'hween_c19_roofcorner', 'hween_c19_roofcorner', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10800, 10800, '0', 'hween_c19_witchsatchel', 'hween_c19_witchsatchel', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 1, '', '', '', 0, 0, ''),
	(10801, 10801, '0', 'hween_c19_flameon', 'hween_c19_flameon', 'S', 1, 1, 2.20, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10802, 10802, '0', 'clothing_nt_possessedeyes', 'clothing_nt_possessedeyes', 'S', 1, 1, 1.00, '0', '0', '0', '0', '0', '0', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10803, 10803, '0', 'hween_c19_angleroof', 'hween_c19_angleroof', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10804, 10804, '0', 'clothing_r19_demonwings', 'clothing_r19_demonwings', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10805, 10805, '0', 'hween_c19_birchtree', 'hween_c19_birchtree', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10806, 10806, '0', 'hween_c19_firechild', 'hween_c19_firechild', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10807, 10807, '0', 'hween_c19_bigroof', 'hween_c19_bigroof', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10808, 10808, '0', 'hween_c19_witchcraft', 'hween_c19_witchcraft', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '0', '1', '0', '0', 'crafting', 2, '', '', '', 0, 0, ''),
	(10809, 10809, '0', 'hween_c19_claddedwall', 'hween_c19_claddedwall', 'S', 2, 1, 4.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 6, '', '', '', 0, 0, ''),
	(10810, 10810, '0', 'clothing_possessedeyes', 'clothing_possessedeyes', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10811, 10811, '0', 'clothing_nt_witchrobes', 'clothing_nt_witchrobes', 'S', 1, 1, 1.00, '0', '0', '0', '0', '0', '0', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10812, 10812, '0', 'hween_c19_bewitchedskull', 'hween_c19_bewitchedskull', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10813, 10813, '0', 'hween_ltd19_skullthrone', 'hween_ltd19_skullthrone', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10814, 10814, '0', 'hween_c19_archway', 'hween_c19_archway', 'S', 2, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10815, 10815, '0', 'hween_r19_weepingwillow', 'hween_r19_weepingwillow', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(10816, 10816, '0', 'hween_c19_smallroof', 'hween_c19_smallroof', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10817, 10817, '0', 'hween_c19_darkwerewolf', 'hween_c19_darkwerewolf', 'S', 1, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10818, 10818, '0', 'hween_r19_witchfamiliar', 'hween_r19_witchfamiliar', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(10819, 10819, '0', 'hween_c19_fireplace', 'hween_c19_fireplace', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10820, 10820, '0', 'clothing_witchhat2', 'clothing_witchhat2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10821, 10821, '0', 'clothing_witchrobes', 'clothing_witchrobes', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10822, 10822, '0', 'hween_c19_spiritowl', 'hween_c19_spiritowl', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10823, 10823, '0', 'hween_c19_steeproof', 'hween_c19_steeproof', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10824, 10824, '0', 'hween_c19_potions', 'hween_c19_potions', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 5, '', '', '', 0, 0, ''),
	(10825, 10825, '0', 'hween_c19_feathers', 'hween_c19_feathers', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10826, 10826, '0', 'hween_c19_crystalball', 'hween_c19_crystalball', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10827, 10827, '0', 'clothing_nt_witchhat2', 'clothing_nt_witchhat2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '0', '0', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10828, 10828, '0', 'hween_c19_slimeblob', 'hween_c19_slimeblob', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10829, 10829, '0', 'hween_c19_bewitchedcandles', 'hween_c19_bewitchedcandles', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(10830, 10830, '0', 'hween_c19_witchsatchel2', 'hween_c19_witchsatchel2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10831, 10831, '0', 'hween_c19_broomstaffstand', 'hween_c19_broomstaffstand', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10832, 10832, '0', 'CF_250_Hucci', 'CF_250_Hucci', 'S', 1, 1, 0.00, '0', '0', '0', '0', '0', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10833, 10833, '0', 'bonusbag19_3', 'bonusbag19_3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(10834, 10834, '0', 'bonusrare19_3*0', 'bonusrare19_3*0', 'S', 1, 1, 0.10, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(10835, 10835, '0', 'bonusrare19_3*1', 'bonusrare19_3*1', 'S', 1, 1, 0.10, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(10836, 10836, '0', 'bonusrare19_3*2', 'bonusrare19_3*2', 'S', 1, 1, 0.10, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(10837, 10837, '0', 'bonusrare19_3*3', 'bonusrare19_3*3', 'S', 1, 1, 0.10, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(10838, 10838, '0', 'bonusrare19_3*4', 'bonusrare19_3*4', 'S', 1, 1, 0.10, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(10839, 10839, '0', 'bonusrare19_3*5', 'bonusrare19_3*5', 'S', 1, 1, 0.10, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(10840, 10840, '0', 'mutearea_sign2', 'mutearea_sign2', 'S', 1, 1, 0.10, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'mutearea', 2, '', '', '', 0, 0, ''),
	(10841, 10841, '0', 'clothing_habpods', 'clothing_habpods', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10842, 10842, '0', 'clothing_nt_shortscarf', 'clothing_nt_shortscarf', 'S', 1, 1, 1.00, '0', '0', '0', '0', '0', '0', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10843, 10843, '0', 'clothing_nt_habpods', 'clothing_nt_habpods', 'S', 1, 1, 1.00, '0', '0', '0', '0', '0', '0', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10844, 10844, '0', 'clothing_nt_flaredtrench', 'clothing_nt_flaredtrench', 'S', 1, 1, 1.00, '0', '0', '0', '0', '0', '0', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10845, 10845, '0', 'clothing_microbag', 'clothing_microbag', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10846, 10846, '0', 'clothing_hitchedjumper', 'clothing_hitchedjumper', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10847, 10847, '0', 'clothing_nt_hitchedjumper', 'clothing_nt_hitchedjumper', 'S', 1, 1, 1.00, '0', '0', '0', '0', '0', '0', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10848, 10848, '0', 'autumn_r19_maplebonsai', 'autumn_r19_maplebonsai', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10849, 10849, '0', 'clothing_shortscarf', 'clothing_shortscarf', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10850, 10850, '0', 'clothing_nt_microbag', 'clothing_nt_microbag', 'S', 1, 1, 1.00, '0', '0', '0', '0', '0', '0', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10851, 10851, '0', 'clothing_flaredtrench', 'clothing_flaredtrench', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10852, 10852, '0', 'wintercabin_c19_window', 'wintercabin_c19_window', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10853, 10853, '0', 'wintercabin_c19_floor', 'wintercabin_c19_floor', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10854, 10854, '0', 'wintercabin_c19_sofa', 'wintercabin_c19_sofa', 'S', 2, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10855, 10855, '0', 'wintercabin_c19_fence', 'wintercabin_c19_fence', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10856, 10856, '0', 'wintercabin_c19_cabintable', 'wintercabin_c19_cabintable', 'S', 1, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10857, 10857, '0', 'wintercabin_c19_stairs', 'wintercabin_c19_stairs', 'S', 1, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10858, 10858, '0', 'wintercabin_c19_antlerlight', 'wintercabin_c19_antlerlight', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10859, 10859, '0', 'wintercabin_c19_corner', 'wintercabin_c19_corner', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10860, 10860, '0', 'wintercabin_c19_stage', 'wintercabin_c19_stage', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '1', '1', 'multiheight', 3, '', '1.2;2.5;3.5', '', 0, 0, ''),
	(10861, 10861, '0', 'wintercabin_c19_fireplace', 'wintercabin_c19_fireplace', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 6, '', '', '', 0, 0, ''),
	(10862, 10862, '0', 'wintercabin_c19_lamp', 'wintercabin_c19_lamp', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10863, 10863, '0', 'wintercabin_c19_cabinrug', 'wintercabin_c19_cabinrug', 'S', 4, 3, 0.00, '1', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10864, 10864, '0', 'wintercabin_c19_glasstable', 'wintercabin_c19_glasstable', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10865, 10865, '0', 'wintercabin_c19_items', 'wintercabin_c19_items', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(10866, 10866, '0', 'wintercabin_c19_wall', 'wintercabin_c19_wall', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10867, 10867, '0', 'wintercabin_c19_drawers', 'wintercabin_c19_drawers', 'S', 2, 1, 1.20, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10868, 10868, '0', 'wintercabin_c19_cabinchair', 'wintercabin_c19_cabinchair', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10869, 10869, '0', 'wintercabin_c19_bed', 'wintercabin_c19_bed', 'S', 2, 3, 1.80, '0', '0', '1', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10870, 10870, '0', 'clothing_leatherhoodie', 'clothing_leatherhoodie', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10871, 10871, '0', 'clothing_nt_shortfluffy', 'clothing_nt_shortfluffy', 'S', 1, 1, 1.00, '0', '0', '0', '0', '0', '0', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10872, 10872, '0', 'clothing_wavy3', 'clothing_wavy3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10873, 10873, '0', 'clothing_r19_autumndress', 'clothing_r19_autumndress', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10874, 10874, '0', 'clothing_nt_leatherhoodie', 'clothing_nt_leatherhoodie', 'S', 1, 1, 1.00, '0', '0', '0', '0', '0', '0', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10875, 10875, '0', 'clothing_r19_autumnhairpiece', 'clothing_r19_autumnhairpiece', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10876, 10876, '0', 'clothing_nt_wavy3', 'clothing_nt_wavy3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '0', '0', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10877, 10877, '0', 'clothing_shortfluffy', 'clothing_shortfluffy', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10878, 10878, '0', 'clothing_r19_puppyacc', 'clothing_r19_puppyacc', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10879, 10879, '0', 'CF_500_orb', 'CF_500_orb', 'S', 1, 1, 0.00, '0', '0', '0', '0', '0', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(10880, 10880, '0', 'xmas_c19_balcony', 'xmas_c19_balcony', 'S', 2, 1, 5.00, '0', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(10881, 10881, '0', 'xmas_c19_jarofgold', 'xmas_c19_jarofgold', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10882, 10882, '0', 'xmas_c19_terrierplushie', 'xmas_c19_terrierplushie', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10883, 10883, '0', 'xmas_c19_icicles', 'xmas_c19_icicles', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(10884, 10884, '0', 'xmas_c19_angelfigure', 'xmas_c19_angelfigure', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10885, 10885, '0', 'xmas_c19_hamsterplushie', 'xmas_c19_hamsterplushie', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10886, 10886, '0', 'xmas_ltd19_icethrone', 'xmas_ltd19_icethrone', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10887, 10887, '0', 'xmas_c19_snowsprites', 'xmas_c19_snowsprites', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(10888, 10888, '0', 'clothing_pompombag', 'clothing_pompombag', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10889, 10889, '0', 'clothing_r19_elisa', 'clothing_r19_elisa', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10890, 10890, '0', 'xmas_c19_box4b', 'xmas_c19_box4b', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(10891, 10891, '0', 'clothing_nt_pompombag', 'clothing_nt_pompombag', 'S', 1, 1, 1.00, '0', '0', '0', '0', '0', '0', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10892, 10892, '0', 'xmas_c19_box1b', 'xmas_c19_box1b', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(10893, 10893, '0', 'xmas_c19_elfguard', 'xmas_c19_elfguard', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10894, 10894, '0', 'xmas_c19_crystalfloor', 'xmas_c19_crystalfloor', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(10895, 10895, '0', 'clothing_nt_frostedbeard', 'clothing_nt_frostedbeard', 'S', 1, 1, 1.00, '0', '0', '0', '0', '0', '0', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10896, 10896, '0', 'xmas_c19_elffairy', 'xmas_c19_elffairy', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10897, 10897, '0', 'xmas_c19_reindeerfigure2', 'xmas_c19_reindeerfigure2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10898, 10898, '0', 'xmas_c19_box6b', 'xmas_c19_box6b', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(10899, 10899, '0', 'xmas_c19_box5b', 'xmas_c19_box5b', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(10900, 10900, '0', 'xmas_c19_curtain', 'xmas_c19_curtain', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(10901, 10901, '0', 'xmas_c19_box3', 'xmas_c19_box3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(10902, 10902, '0', 'xmas_c19_robinfigure', 'xmas_c19_robinfigure', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10903, 10903, '0', 'clothing_snowmansuit', 'clothing_snowmansuit', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10904, 10904, '0', 'clothing_nt_bearmuffs', 'clothing_nt_bearmuffs', 'S', 1, 1, 1.00, '0', '0', '0', '0', '0', '0', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10905, 10905, '0', 'clothing_frostedbeard', 'clothing_frostedbeard', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10906, 10906, '0', 'xmas_c19_icetree', 'xmas_c19_icetree', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10907, 10907, '0', 'xmas_c19_reindeerfigure', 'xmas_c19_reindeerfigure', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10908, 10908, '0', 'xmas_r19_crystalharp', 'xmas_r19_crystalharp', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10909, 10909, '0', 'xmas_c19_archwall', 'xmas_c19_archwall', 'S', 2, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10910, 10910, '0', 'xmas_c19_furbanner', 'xmas_c19_furbanner', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10911, 10911, '0', 'xmas_c19_snowcraft', 'xmas_c19_snowcraft', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '0', '1', '0', '0', 'crafting', 2, '', '', '', 0, 0, ''),
	(10912, 10912, '0', 'clothing_nordicscarf', 'clothing_nordicscarf', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10913, 10913, '0', 'xmas_c19_crystaltable', 'xmas_c19_crystaltable', 'S', 1, 3, 1.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10914, 10914, '0', 'xmas_c19_catplushie', 'xmas_c19_catplushie', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10915, 10915, '0', 'xmas_c19_dragonfigure2', 'xmas_c19_dragonfigure2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10916, 10916, '0', 'xmas_c19_box2', 'xmas_c19_box2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(10917, 10917, '0', 'xmas_c19_elfeskimo', 'xmas_c19_elfeskimo', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10918, 10918, '0', 'xmas_c19_lamp', 'xmas_c19_lamp', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10919, 10919, '0', 'clothing_pompomhat', 'clothing_pompomhat', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10920, 10920, '0', 'xmas_c19_stackedicedrinks', 'xmas_c19_stackedicedrinks', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'vendingmachine_no_sides', 2, '142', '', '', 0, 0, ''),
	(10921, 10921, '0', 'xmas_c19_pugplushie', 'xmas_c19_pugplushie', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10922, 10922, '0', 'clothing_r19_frosted', 'clothing_r19_frosted', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10923, 10923, '0', 'xmas_r19_crystalfountain', 'xmas_r19_crystalfountain', 'S', 2, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10924, 10924, '0', 'xmas_c19_crystalchair', 'xmas_c19_crystalchair', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10925, 10925, '0', 'clothing_bearmuffs', 'clothing_bearmuffs', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10926, 10926, '0', 'xmas_c19_box3b', 'xmas_c19_box3b', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(10927, 10927, '0', 'xmas_c19_windowwall', 'xmas_c19_windowwall', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(10928, 10928, '0', 'xmas_c19_box6', 'xmas_c19_box6', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(10929, 10929, '0', 'xmas_c19_unicornfigure2', 'xmas_c19_unicornfigure2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10930, 10930, '0', 'xmas_c19_dragonfigure', 'xmas_c19_dragonfigure', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10931, 10931, '0', 'xmas_c19_box4', 'xmas_c19_box4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(10932, 10932, '0', 'clothing_nt_pompomhat', 'clothing_nt_pompomhat', 'S', 1, 1, 1.00, '0', '0', '0', '0', '0', '0', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10933, 10933, '0', 'xmas_c19_robinfigure2', 'xmas_c19_robinfigure2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10934, 10934, '0', 'xmas_c19_angelfigure2', 'xmas_c19_angelfigure2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10935, 10935, '0', 'xmas_c19_iceshards', 'xmas_c19_iceshards', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(10936, 10936, '0', 'xmas_c19_box5', 'xmas_c19_box5', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(10937, 10937, '0', 'xmas_c19_elfmage', 'xmas_c19_elfmage', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10938, 10938, '0', 'xmas_c19_chandelier', 'xmas_c19_chandelier', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10939, 10939, '0', 'xmas_c19_box2b', 'xmas_c19_box2b', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(10940, 10940, '0', 'xmas_c19_unicornfigure', 'xmas_c19_unicornfigure', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10941, 10941, '0', 'xmas_c19_icefood', 'xmas_c19_icefood', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(10942, 10942, '0', 'clothing_nt_snowmansuit', 'clothing_nt_snowmansuit', 'S', 1, 1, 1.00, '0', '0', '0', '0', '0', '0', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10943, 10943, '0', 'xmas_c19_box1', 'xmas_c19_box1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(10944, 10944, '0', 'clothing_icecrown', 'clothing_icecrown', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10945, 10945, '0', 'bonusrare19_4*0', 'bonusrare19_4*0', 'S', 1, 1, 0.10, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(10946, 10946, '0', 'bonusrare19_4*1', 'bonusrare19_4*1', 'S', 1, 1, 0.10, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(10947, 10947, '0', 'bonusrare19_4*2', 'bonusrare19_4*2', 'S', 1, 1, 0.10, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(10948, 10948, '0', 'bonusrare19_4*3', 'bonusrare19_4*3', 'S', 1, 1, 0.10, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(10949, 10949, '0', 'bonusrare19_4*4', 'bonusrare19_4*4', 'S', 1, 1, 0.10, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(10950, 10950, '0', 'bonusrare19_4*5', 'bonusrare19_4*5', 'S', 1, 1, 0.10, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(10951, 10951, '0', 'bonusbag19_4', 'bonusbag19_4', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(10952, 10952, '0', 'rare_prize19_xmas', 'rare_prize19_xmas', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10953, 10953, '0', 'shome_keys', 'shome_keys', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10954, 10954, '0', 'shome_hamster', 'shome_hamster', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10955, 10955, '0', 'clothing_goldpack4', 'clothing_goldpack4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10956, 10956, '0', 'clothing_r20_galaxybackpack', 'clothing_r20_galaxybackpack', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10957, 10957, '0', 'clothing_heartnecklace', 'clothing_heartnecklace', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10958, 10958, '0', 'clothing_r20_kittyearphones', 'clothing_r20_kittyearphones', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10959, 10959, '0', 'china_goldenrat', 'china_goldenrat', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10960, 10960, '0', 'china_rat', 'china_rat', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10961, 10961, '0', 'clothing_rat', 'clothing_rat', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10962, 10962, '0', 'clothing_r19_sparklywaist5', 'clothing_r19_sparklywaist5', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10963, 10963, '0', 'clothing_r19_sparklywaist6', 'clothing_r19_sparklywaist6', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10964, 10964, '0', 'clothing_r19_sparklywaist7', 'clothing_r19_sparklywaist7', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10965, 10965, '0', 'clothing_r19_sparklywaist8', 'clothing_r19_sparklywaist8', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10966, 10966, '0', 'clothing_r19_sparklywaist2', 'clothing_r19_sparklywaist2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10967, 10967, '0', 'clothing_r19_sparklywaist3', 'clothing_r19_sparklywaist3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10968, 10968, '0', 'clothing_r19_sparklywaist1', 'clothing_r19_sparklywaist1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10969, 10969, '0', 'clothing_r19_sparklywaist4', 'clothing_r19_sparklywaist4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(10970, 10970, '0', 'ny_r19_crackable', 'ny_r19_crackable', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 1, '', '', '', 0, 0, ''),
	(10971, 10971, '0', 'hc20_9', 'hc20_9', 'S', 1, 1, 0.01, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(10972, 10972, '0', 'hc20_8', 'hc20_8', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10973, 10973, '0', 'hc20_4', 'hc20_4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10974, 10974, '0', 'hc20_2', 'hc20_2', 'S', 3, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10975, 10975, '0', 'hc20_12', 'hc20_12', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10976, 10976, '0', 'hc20_3', 'hc20_3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10977, 10977, '0', 'hc20_7', 'hc20_7', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10978, 10978, '0', 'hc20_10', 'hc20_10', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10979, 10979, '0', 'hc20_11', 'hc20_11', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10980, 10980, '0', 'hc20_5', 'hc20_5', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10981, 10981, '0', 'hc20_6', 'hc20_6', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10982, 10982, '0', 'hc20_1', 'hc20_1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10983, 10983, '0', 'CF_750_minihabberge', 'CF_750_minihabberge', 'S', 1, 1, 0.00, '0', '0', '0', '0', '0', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(10984, 10984, '0', 'rare_prize20*0', 'rare_prize20*0', 'S', 1, 1, 0.01, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(10985, 10985, '0', 'rare_prize20*1', 'rare_prize20*1', 'S', 1, 1, 0.01, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(10986, 10986, '0', 'rare_prize20*10', 'rare_prize20*10', 'S', 1, 1, 0.01, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(10987, 10987, '0', 'rare_prize20*11', 'rare_prize20*11', 'S', 1, 1, 0.01, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(10988, 10988, '0', 'rare_prize20*12', 'rare_prize20*12', 'S', 1, 1, 0.01, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(10989, 10989, '0', 'rare_prize20*13', 'rare_prize20*13', 'S', 1, 1, 0.01, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(10990, 10990, '0', 'rare_prize20*2', 'rare_prize20*2', 'S', 1, 1, 0.01, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(10991, 10991, '0', 'rare_prize20*3', 'rare_prize20*3', 'S', 1, 1, 0.01, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(10992, 10992, '0', 'rare_prize20*4', 'rare_prize20*4', 'S', 1, 1, 0.01, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(10993, 10993, '0', 'rare_prize20*5', 'rare_prize20*5', 'S', 1, 1, 0.01, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(10994, 10994, '0', 'rare_prize20*6', 'rare_prize20*6', 'S', 1, 1, 0.01, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(10995, 10995, '0', 'rare_prize20*7', 'rare_prize20*7', 'S', 1, 1, 0.01, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(10996, 10996, '0', 'rare_prize20*8', 'rare_prize20*8', 'S', 1, 1, 0.01, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(10997, 10997, '0', 'rare_prize20*9', 'rare_prize20*9', 'S', 1, 1, 0.01, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(10998, 10998, '0', 'rare_r20_wardrobe', 'rare_r20_wardrobe', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(10999, 10999, '0', 'clothing_r20_quinn', 'clothing_r20_quinn', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11000, 11000, '0', 'rare_r20_balloonchair', 'rare_r20_balloonchair', 'S', 1, 1, 2.00, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'pressureplate', 2, '', '', '', 0, 0, ''),
	(11001, 11001, '0', 'val_c20_cakestand', 'val_c20_cakestand', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11002, 11002, '0', 'val_c20_chair', 'val_c20_chair', 'S', 1, 1, 1.30, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11003, 11003, '0', 'val_c20_lights', 'val_c20_lights', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11004, 11004, '0', 'val_c20_floor', 'val_c20_floor', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11005, 11005, '0', 'val_c20_blackboard', 'val_c20_blackboard', 'S', 2, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(11006, 11006, '0', 'val_c20_window', 'val_c20_window', 'S', 2, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(11007, 11007, '0', 'val_c20_tablecounter', 'val_c20_tablecounter', 'S', 2, 1, 1.50, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11008, 11008, '0', 'clothing_chocochefoutfit', 'clothing_chocochefoutfit', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11009, 11009, '0', 'val_c20_cakedisplay', 'val_c20_cakedisplay', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11010, 11010, '0', 'val_c20_wall', 'val_c20_wall', 'S', 2, 1, 4.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11011, 11011, '0', 'val_c20_cake', 'val_c20_cake', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(11012, 11012, '0', 'clothing_r20_tattoo', 'clothing_r20_tattoo', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11013, 11013, '0', 'val_c20_chocgift', 'val_c20_chocgift', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(11014, 11014, '0', 'val_c20_chocfountain', 'val_c20_chocfountain', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'vendingmachine_no_sides', 2, '143,144', '', '', 0, 0, ''),
	(11015, 11015, '0', 'val_c20_table', 'val_c20_table', 'S', 1, 1, 1.20, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11016, 11016, '0', 'val_c20_seats', 'val_c20_seats', 'S', 2, 1, 2.00, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11017, 11017, '0', 'bonusbag20_1', 'bonusbag20_1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(11018, 11018, '0', 'bonusrare20_1a*1', 'bonusrare20_1a*1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11019, 11019, '0', 'bonusrare20_1a*2', 'bonusrare20_1a*2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11020, 11020, '0', 'bonusrare20_1a*3', 'bonusrare20_1a*3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11021, 11021, '0', 'bonusrare20_1a*4', 'bonusrare20_1a*4', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11022, 11022, '0', 'bonusrare20_1a*5', 'bonusrare20_1a*5', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11023, 11023, '0', 'bonusrare20_1a*6', 'bonusrare20_1a*6', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11024, 11024, '0', 'bonusrare20_2*1', 'bonusrare20_2*1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11025, 11025, '0', 'bonusrare20_2*2', 'bonusrare20_2*2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11026, 11026, '0', 'bonusrare20_2*3', 'bonusrare20_2*3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11027, 11027, '0', 'bonusrare20_2*4', 'bonusrare20_2*4', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11028, 11028, '0', 'bonusrare20_2*5', 'bonusrare20_2*5', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11029, 11029, '0', 'bonusrare20_2*6', 'bonusrare20_2*6', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11030, 11030, '0', 'bonusbag20_3', 'bonusbag20_3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(11031, 11031, '0', 'bonusrare20_3*1', 'bonusrare20_3*1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'vendingmachine', 2, '53', '', '', 0, 0, ''),
	(11032, 11032, '0', 'bonusrare20_3*2', 'bonusrare20_3*2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'vendingmachine', 2, '53', '', '', 0, 0, ''),
	(11033, 11033, '0', 'bonusrare20_3*3', 'bonusrare20_3*3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'vendingmachine', 2, '53', '', '', 0, 0, ''),
	(11034, 11034, '0', 'bonusrare20_3*4', 'bonusrare20_3*4', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'vendingmachine', 2, '53', '', '', 0, 0, ''),
	(11035, 11035, '0', 'bonusrare20_3*5', 'bonusrare20_3*5', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'vendingmachine', 2, '53', '', '', 0, 0, ''),
	(11036, 11036, '0', 'bonusrare20_3*6', 'bonusrare20_3*6', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'vendingmachine', 2, '53', '', '', 0, 0, ''),
	(11037, 11037, '0', 'bonusrare20_4*0', 'bonusrare20_4*0', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11038, 11038, '0', 'bonusrare20_4*1', 'bonusrare20_4*1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11039, 11039, '0', 'bonusrare20_4*2', 'bonusrare20_4*2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11040, 11040, '0', 'bonusrare20_4*3', 'bonusrare20_4*3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11041, 11041, '0', 'bonusrare20_4*4', 'bonusrare20_4*4', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11042, 11042, '0', 'bonusrare20_4*5', 'bonusrare20_4*5', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11043, 11043, '0', 'bonusbag20_2', 'bonusbag20_2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(11044, 11044, '0', 'bonusbag20_4', 'bonusbag20_4', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(11045, 11045, '0', 'rare_r20_grandebackdrop', 'rare_r20_grandebackdrop', 'S', 3, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11046, 11046, '0', 'clothing_c20_goldheartbp', 'clothing_c20_goldheartbp', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11047, 11047, '0', 'art_c20_plant', 'art_c20_plant', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11048, 11048, '0', 'booster_c20_box', 'booster_c20_box', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 1, '', '', '', 0, 0, ''),
	(11049, 11049, '0', 'art_c20_rug', 'art_c20_rug', 'S', 2, 3, 0.10, '1', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11050, 11050, '0', 'booster_c20_box1', 'booster_c20_box1', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 1, '', '', '', 0, 0, ''),
	(11051, 11051, '0', 'art_c20_floor', 'art_c20_floor', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11052, 11052, '0', 'art_c20_light', 'art_c20_light', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11053, 11053, '0', 'art_c20_paintings', 'art_c20_paintings', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11054, 11054, '0', 'art_c20_gold4', 'art_c20_gold4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11055, 11055, '0', 'art_c20_chair', 'art_c20_chair', 'S', 1, 1, 1.60, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11056, 11056, '0', 'art_c20_pillow', 'art_c20_pillow', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11057, 11057, '0', 'art_c20_bin', 'art_c20_bin', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(11058, 11058, '0', 'art_c20_gold1', 'art_c20_gold1', 'S', 1, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11059, 11059, '0', 'clothing_c20_heartbackpack', 'clothing_c20_heartbackpack', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11060, 11060, '0', 'art_c20_drawingtablet', 'art_c20_drawingtablet', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(11061, 11061, '0', 'art_c20_gold2', 'art_c20_gold2', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11062, 11062, '0', 'art_c20_chair2', 'art_c20_chair2', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11063, 11063, '0', 'art_c20_desk', 'art_c20_desk', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11064, 11064, '0', 'art_c20_shelves', 'art_c20_shelves', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11065, 11065, '0', 'art_c20_chair4', 'art_c20_chair4', 'S', 1, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11066, 11066, '0', 'art_c20_canvas', 'art_c20_canvas', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11067, 11067, '0', 'art_c20_gold5', 'art_c20_gold5', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11068, 11068, '0', 'art_c20_sofa', 'art_c20_sofa', 'S', 2, 1, 0.90, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11069, 11069, '0', 'art_c20_chair1', 'art_c20_chair1', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11070, 11070, '0', 'art_c20_clock', 'art_c20_clock', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11071, 11071, '0', 'art_c20_clotheshanger', 'art_c20_clotheshanger', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11072, 11072, '0', 'art_c20_rolledpaper', 'art_c20_rolledpaper', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(11073, 11073, '0', 'art_c20_gold3', 'art_c20_gold3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11074, 11074, '0', 'art_c20_artstool', 'art_c20_artstool', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11075, 11075, '0', 'art_c20_easel', 'art_c20_easel', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(11076, 11076, '0', 'art_c20_chair3', 'art_c20_chair3', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11077, 11077, '0', 'art_c20_coffeetable', 'art_c20_coffeetable', 'S', 1, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(11078, 11078, '0', 'art_c20_caddy', 'art_c20_caddy', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11079, 11079, '1', 'easter_c20_heather', 'easter_c20_heather', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 8, '', '', '', 0, 0, ''),
	(11080, 11080, '0', 'easter_r20_mountaingoat', 'easter_r20_mountaingoat', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11081, 11081, '0', 'easter_c20_darkrock', 'easter_c20_darkrock', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(11082, 11082, '0', 'clothing_mysticrobes', 'clothing_mysticrobes', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11083, 11083, '0', 'easter_c20_darkprize4', 'easter_c20_darkprize4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 1, '', '', '', 0, 0, ''),
	(11084, 11084, '0', 'easter_c20_scatteredforestfloor', 'easter_c20_scatteredforestfloor', 'S', 2, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11085, 11085, '1', 'easter_c20_fishingpole', 'easter_c20_fishingpole', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'vendingmachine', 2, '1090,1091,1092', '', '', 0, 0, ''),
	(11086, 11086, '0', 'clothing_nt_yogatop', 'clothing_nt_yogatop', 'S', 1, 1, 1.00, '0', '0', '0', '0', '0', '0', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11087, 11087, '0', 'clothing_nt_campingbackpack', 'clothing_nt_campingbackpack', 'S', 1, 1, 1.00, '0', '0', '0', '0', '0', '0', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11088, 11088, '1', 'easter_c20_stickteepee', 'easter_c20_stickteepee', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11089, 11089, '0', 'easter_c20_ancientbird', 'easter_c20_ancientbird', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11090, 11090, '0', 'clothing_explorersash', 'clothing_explorersash', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11091, 11091, '1', 'easter_c20_rockboulders', 'easter_c20_rockboulders', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11092, 11092, '0', 'clothing_r20_bunnyoutfit', 'clothing_r20_bunnyoutfit', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11093, 11093, '0', 'easter_c20_darkprize2', 'easter_c20_darkprize2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 1, '', '', '', 0, 0, ''),
	(11094, 11094, '0', 'clothing_puffyvest', 'clothing_puffyvest', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11095, 11095, '1', 'easter_c20_mountainslopes', 'easter_c20_mountainslopes', 'S', 2, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11096, 11096, '0', 'easter_ltd20_fortuneduck', 'easter_ltd20_fortuneduck', 'S', 2, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11097, 11097, '0', 'easter_r20_mystictree', 'easter_r20_mystictree', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11098, 11098, '0', 'easter_c20_campingessentials', 'easter_c20_campingessentials', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11099, 11099, '0', 'clothing_binoculars', 'clothing_binoculars', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11100, 11100, '0', 'easter_c20_ornamentalrocks', 'easter_c20_ornamentalrocks', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11101, 11101, '1', 'easter_c20_picnicfood', 'easter_c20_picnicfood', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11102, 11102, '0', 'clothing_campingbackpack', 'clothing_campingbackpack', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11103, 11103, '1', 'easter_c20_mountainflats', 'easter_c20_mountainflats', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11104, 11104, '0', 'easter_c20_darkprize3', 'easter_c20_darkprize3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 1, '', '', '', 0, 0, ''),
	(11105, 11105, '0', 'easter_c20_darkprize1', 'easter_c20_darkprize1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 1, '', '', '', 0, 0, ''),
	(11106, 11106, '0', 'clothing_yogatop', 'clothing_yogatop', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11107, 11107, '0', 'clothing_nt_puffyvest', 'clothing_nt_puffyvest', 'S', 1, 1, 1.00, '0', '0', '0', '0', '0', '0', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11108, 11108, '0', 'clothing_nt_sportshair', 'clothing_nt_sportshair', 'S', 1, 1, 1.00, '0', '0', '0', '0', '0', '0', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11109, 11109, '1', 'easter_c20_camprug', 'easter_c20_camprug', 'S', 2, 3, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11110, 11110, '1', 'easter_c20_mossydivider', 'easter_c20_mossydivider', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11111, 11111, '1', 'easter_c20_firstaidkit', 'easter_c20_firstaidkit', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11112, 11112, '0', 'clothing_sportshair', 'clothing_sportshair', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11113, 11113, '0', 'easter_c20_logwalk', 'easter_c20_logwalk', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11114, 11114, '0', 'clothing_mysticcrown', 'clothing_mysticcrown', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11115, 11115, '0', 'clothing_yogapants', 'clothing_yogapants', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11116, 11116, '0', 'easter_c20_ancienthorse', 'easter_c20_ancienthorse', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11117, 11117, '1', 'easter_c20_kayak', 'easter_c20_kayak', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11118, 11118, '0', 'clothing_r20_ponytailcap', 'clothing_r20_ponytailcap', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11119, 11119, '0', 'clothing_nt_yogapants', 'clothing_nt_yogapants', 'S', 1, 1, 1.00, '0', '0', '0', '0', '0', '0', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11120, 11120, '0', 'easter_c20_lightprize3', 'easter_c20_lightprize3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 1, '', '', '', 0, 0, ''),
	(11121, 11121, '0', 'easter_c20_climbingropetele', 'easter_c20_climbingropetele', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'teleport', 2, '', '', '', 0, 0, ''),
	(11122, 11122, '0', 'clothing_nt_sportsshade', 'clothing_nt_sportsshade', 'S', 1, 1, 1.00, '0', '0', '0', '0', '0', '0', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11123, 11123, '0', 'clothing_nt_binoculars', 'clothing_nt_binoculars', 'S', 1, 1, 1.00, '0', '0', '0', '0', '0', '0', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11124, 11124, '0', 'easter_c20_lightprize2', 'easter_c20_lightprize2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 1, '', '', '', 0, 0, ''),
	(11125, 11125, '1', 'easter_c20_forestfriends', 'easter_c20_forestfriends', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(11126, 11126, '0', 'easter_c20_lightrock', 'easter_c20_lightrock', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 1, '', '', '', 0, 0, ''),
	(11127, 11127, '0', 'easter_c20_clayrelic', 'easter_c20_clayrelic', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11128, 11128, '1', 'easter_c20_fishstream', 'easter_c20_fishstream', 'S', 1, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11129, 11129, '0', 'clothing_rainbowegg', 'clothing_rainbowegg', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '3918', 0, 0, ''),
	(11130, 11130, '0', 'easter_c20_jadeguardian', 'easter_c20_jadeguardian', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11131, 11131, '1', 'easter_c20_heatherrock', 'easter_c20_heatherrock', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 5, '', '', '', 0, 0, ''),
	(11132, 11132, '0', 'easter_c20_ancientstatue', 'easter_c20_ancientstatue', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11133, 11133, '0', 'clothing_sportsshade', 'clothing_sportsshade', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11134, 11134, '0', 'easter_c20_lightprize4', 'easter_c20_lightprize4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 1, '', '', '', 0, 0, ''),
	(11135, 11135, '0', 'easter_c20_lightprize1', 'easter_c20_lightprize1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 1, '', '', '', 0, 0, ''),
	(11136, 11136, '0', 'easter_c20_waypointrocks', 'easter_c20_waypointrocks', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11137, 11137, '0', 'easter_c20_energyfood', 'easter_c20_energyfood', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11138, 11138, '0', 'easter_c20_zenmaster', 'easter_c20_zenmaster', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11139, 11139, '0', 'clothing_nt_explorersash', 'clothing_nt_explorersash', 'S', 1, 1, 1.00, '0', '0', '0', '0', '0', '0', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11140, 11140, '1', 'easter_c20_foresttree', 'easter_c20_foresttree', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11141, 11141, '1', 'easter_c20_rapids', 'easter_c20_rapids', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '1', '1', 'roller', 2, '', '', '', 0, 0, ''),
	(11142, 11142, '0', 'easter_c20_lightrock1', 'easter_c20_lightrock1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11143, 11143, '0', 'easter_c20_darkrock1', 'easter_c20_darkrock1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11144, 11144, '0', 'rare_r20_corgi', 'rare_r20_corgi', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11145, 11145, '0', 'rare_r20_marimo', 'rare_r20_marimo', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11146, 11146, '0', 'rare_r20_treehouse', 'rare_r20_treehouse', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11147, 11147, '0', 'spa_c20_bbrose', 'spa_c20_bbrose', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11148, 11148, '0', 'spa_c20_crackable1A', 'spa_c20_crackable1A', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(11149, 11149, '0', 'clothing_towelwraphalf', 'clothing_towelwraphalf', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11150, 11150, '0', 'spa_c20_crackable1B', 'spa_c20_crackable1B', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(11151, 11151, '0', 'clothing_eyemask', 'clothing_eyemask', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11152, 11152, '0', 'clothing_maskmint', 'clothing_maskmint', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11153, 11153, '0', 'spa_c20_bbmint', 'spa_c20_bbmint', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11154, 11154, '0', 'spa_c20_bbcharcoal', 'spa_c20_bbcharcoal', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11155, 11155, '0', 'clothing_towelhair', 'clothing_towelhair', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11156, 11156, '0', 'clothing_eyetomato', 'clothing_eyetomato', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11157, 11157, '0', 'clothing_maskrose', 'clothing_maskrose', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11158, 11158, '0', 'clothing_eyecucumber', 'clothing_eyecucumber', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11159, 11159, '0', 'spa_c20_lavendersalt', 'spa_c20_lavendersalt', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11160, 11160, '0', 'clothing_towelwrapfull', 'clothing_towelwrapfull', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11161, 11161, '0', 'clothing_maskcitrus', 'clothing_maskcitrus', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11162, 11162, '0', 'spa_c20_bbcitrus', 'spa_c20_bbcitrus', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11163, 11163, '0', 'spa_c20_incense', 'spa_c20_incense', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11164, 11164, '0', 'clothing_maskcharcoal', 'clothing_maskcharcoal', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11165, 11165, '0', 'clothing_eyecitrus', 'clothing_eyecitrus', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11166, 11166, '0', 'spa_c20_crackable2A', 'spa_c20_crackable2A', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(11167, 11167, '0', 'clothing_eyestrawberry', 'clothing_eyestrawberry', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11168, 11168, '0', 'spa_c20_crackable2B', 'spa_c20_crackable2B', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11169, 11169, '0', 'spa_c20_bath', 'spa_c20_bath', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '0', '1', '0', '0', 'crafting', 2, '', '', '', 0, 0, ''),
	(11170, 11170, '0', 'CF_500_goldenbeetle', 'CF_500_goldenbeetle', 'S', 1, 1, 0.00, '0', '0', '0', '0', '0', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11171, 11171, '0', 'clothing_r20_monkeyfezhat', 'clothing_r20_monkeyfezhat', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11172, 11172, '0', 'india_c20_saribp', 'india_c20_saribp', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11173, 11173, '0', 'india_c20_longpillow', 'india_c20_longpillow', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11174, 11174, '0', 'clothing_moviestarmakeup', 'clothing_moviestarmakeup', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11175, 11175, '0', 'clothing_cobra', 'clothing_cobra', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11176, 11176, '0', 'india_r20_bengaltiger', 'india_r20_bengaltiger', 'S', 1, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11177, 11177, '0', 'india_c20_incense', 'india_c20_incense', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11178, 11178, '0', 'clothing_exoticcape', 'clothing_exoticcape', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11179, 11179, '0', 'india_c20_capebp', 'india_c20_capebp', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11180, 11180, '0', 'india_c20_eleseat', 'india_c20_eleseat', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11181, 11181, '0', 'india_c20_flowerbelldeco', 'india_c20_flowerbelldeco', 'S', 1, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11182, 11182, '0', 'india_c20_dye', 'india_c20_dye', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(11183, 11183, '0', 'clothing_headjewel', 'clothing_headjewel', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11184, 11184, '0', 'clothing_moviestarhair', 'clothing_moviestarhair', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11185, 11185, '0', 'clothing_grandsari', 'clothing_grandsari', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11186, 11186, '0', 'india_c20_sofa', 'india_c20_sofa', 'S', 2, 1, 1.20, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11187, 11187, '0', 'clothing_grandheadjewel', 'clothing_grandheadjewel', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11188, 11188, '0', 'india_c20_jewellerybox', 'india_c20_jewellerybox', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11189, 11189, '0', 'clothing_sherwani', 'clothing_sherwani', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11190, 11190, '0', 'india_c20_sherwanibp', 'india_c20_sherwanibp', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11191, 11191, '0', 'india_c20_light', 'india_c20_light', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11192, 11192, '0', 'clothing_nt_turban', 'clothing_nt_turban', 'S', 1, 1, 1.00, '0', '0', '0', '0', '0', '0', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11193, 11193, '0', 'india_c20_balconydoor', 'india_c20_balconydoor', 'S', 1, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11194, 11194, '0', 'india_c20_archway', 'india_c20_archway', 'S', 1, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11195, 11195, '0', 'india_c20_snakebp', 'india_c20_snakebp', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11196, 11196, '0', 'india_c20_dessert', 'india_c20_dessert', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(11197, 11197, '0', 'india_c20_tiledfloor', 'india_c20_tiledfloor', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11198, 11198, '0', 'clothing_turban', 'clothing_turban', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11199, 11199, '0', 'india_c20_cloth', 'india_c20_cloth', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11200, 11200, '0', 'clothing_grandsherwani', 'clothing_grandsherwani', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11201, 11201, '0', 'india_c20_curries', 'india_c20_curries', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(11202, 11202, '0', 'india_c20_palmvase', 'india_c20_palmvase', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11203, 11203, '0', 'clothing_nt_moviestarhair', 'clothing_nt_moviestarhair', 'S', 1, 1, 1.00, '0', '0', '0', '0', '0', '0', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11204, 11204, '0', 'clothing_grandexoticcape', 'clothing_grandexoticcape', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11205, 11205, '0', 'india_c20_sewingmachine', 'india_c20_sewingmachine', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '0', '1', '0', '0', 'crafting', 2, '', '', '', 0, 0, ''),
	(11206, 11206, '0', 'india_c20_blueprintb', 'india_c20_blueprintb', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11207, 11207, '0', 'india_c20_eletable', 'india_c20_eletable', 'S', 1, 1, 1.45, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11208, 11208, '0', 'india_r20_exotictent', 'india_r20_exotictent', 'S', 2, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 5, '', '', '', 0, 0, ''),
	(11209, 11209, '0', 'clothing_snake', 'clothing_snake', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11210, 11210, '0', 'india_c20_blueprint', 'india_c20_blueprint', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(11211, 11211, '0', 'india_c20_teaset', 'india_c20_teaset', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(11212, 11212, '0', 'india_c20_headjewelbp', 'india_c20_headjewelbp', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11213, 11213, '0', 'clothing_nt_moviestarmakeup', 'clothing_nt_moviestarmakeup', 'S', 1, 1, 1.00, '0', '0', '0', '0', '0', '0', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11214, 11214, '0', 'india_c20_beadbellsdeco', 'india_c20_beadbellsdeco', 'S', 1, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11215, 11215, '0', 'clothing_sari', 'clothing_sari', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11216, 11216, '0', 'clothing_r20_jewelbraidhair', 'clothing_r20_jewelbraidhair', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11217, 11217, '0', 'india_ltd20_sultanthrone', 'india_ltd20_sultanthrone', 'S', 1, 1, 1.25, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11218, 11218, '0', 'diamond_painting48', 'diamond_painting48', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11219, 11219, '0', 'diamond_painting50', 'diamond_painting50', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11220, 11220, '0', 'diamond_painting49', 'diamond_painting49', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11221, 11221, '0', 'diamond_painting47', 'diamond_painting47', 'S', 1, 2, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11222, 11222, '0', 'clothing_studentcap', 'clothing_studentcap', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11223, 11223, '0', 'clothing_nt_studentcap', 'clothing_nt_studentcap', 'S', 1, 1, 1.00, '0', '0', '0', '0', '0', '0', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11224, 11224, '0', 'clothing_spottedoctohat', 'clothing_spottedoctohat', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11225, 11225, '1', 'rainyday_c20_craftset', 'rainyday_c20_craftset', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 6, '', '', '', 0, 0, ''),
	(11226, 11226, '1', 'rainyday_c20_woodentable', 'rainyday_c20_woodentable', 'S', 1, 1, 1.10, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11227, 11227, '1', 'rainyday_c20_rainceilingwindow', 'rainyday_c20_rainceilingwindow', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(11228, 11228, '1', 'rainyday_c20_paintset', 'rainyday_c20_paintset', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(11229, 11229, '1', 'rainyday_c20_typewriter', 'rainyday_c20_typewriter', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(11230, 11230, '1', 'rainyday_c20_scentedcandles', 'rainyday_c20_scentedcandles', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(11231, 11231, '1', 'rainyday_c20_cosywhippet', 'rainyday_c20_cosywhippet', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11232, 11232, '1', 'rainyday_c20_woodendesk', 'rainyday_c20_woodendesk', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(11233, 11233, '1', 'rainyday_c20_glowstars', 'rainyday_c20_glowstars', 'S', 1, 2, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 6, '', '', '', 0, 0, ''),
	(11234, 11234, '1', 'rainyday_c20_raindropwall', 'rainyday_c20_raindropwall', 'S', 1, 2, 4.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11235, 11235, '1', 'rainyday_c20_woodenfloor', 'rainyday_c20_woodenfloor', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11236, 11236, '1', 'rainyday_c20_snugblanket', 'rainyday_c20_snugblanket', 'S', 1, 1, 0.80, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'pressureplate', 1, '', '', '', 0, 0, ''),
	(11237, 11237, '1', 'rainyday_c20_stackoflogs', 'rainyday_c20_stackoflogs', 'S', 1, 2, 1.80, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11238, 11238, '1', 'rainyday_c20_coathanger', 'rainyday_c20_coathanger', 'S', 1, 2, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(11239, 11239, '1', 'rainyday_c20_homebakes', 'rainyday_c20_homebakes', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11240, 11240, '1', 'rainyday_c20_retrogames', 'rainyday_c20_retrogames', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 8, '', '', '', 0, 0, ''),
	(11241, 11241, '0', 'clothing_nt_starearrings', 'clothing_nt_starearrings', 'S', 1, 1, 1.00, '0', '0', '0', '0', '0', '0', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11242, 11242, '0', 'clothing_starearrings', 'clothing_starearrings', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11243, 11243, '0', 'clothing_glitzypurse', 'clothing_glitzypurse', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11244, 11244, '0', 'clothing_nt_flapperdress', 'clothing_nt_flapperdress', 'S', 1, 1, 1.00, '0', '0', '0', '0', '0', '0', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11245, 11245, '0', 'clothing_chiseledface', 'clothing_chiseledface', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11246, 11246, '0', 'clothing_nt_modernshortwave', 'clothing_nt_modernshortwave', 'S', 1, 1, 1.00, '0', '0', '0', '0', '0', '0', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11247, 11247, '1', 'habbo20_c20_artdecocarpet', 'habbo20_c20_artdecocarpet', 'S', 3, 2, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11248, 11248, '0', 'clothing_nt_silkgloves', 'clothing_nt_silkgloves', 'S', 1, 1, 1.00, '0', '0', '0', '0', '0', '0', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11249, 11249, '1', 'habbo20_c20_balloons', 'habbo20_c20_balloons', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11250, 11250, '0', 'clothing_nt_slickedbackhair', 'clothing_nt_slickedbackhair', 'S', 1, 1, 1.00, '0', '0', '0', '0', '0', '0', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11251, 11251, '0', 'clothing_r20_glitzytux', 'clothing_r20_glitzytux', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11252, 11252, '0', 'clothing_pencilmoustache', 'clothing_pencilmoustache', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11253, 11253, '0', 'clothing_nt_glitzypurse', 'clothing_nt_glitzypurse', 'S', 1, 1, 1.00, '0', '0', '0', '0', '0', '0', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11254, 11254, '0', 'clothing_modernshortwave', 'clothing_modernshortwave', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11255, 11255, '0', 'clothing_slickedbackhair', 'clothing_slickedbackhair', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11256, 11256, '0', 'clothing_flapperdress', 'clothing_flapperdress', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11257, 11257, '0', 'clothing_nt_pencilmoustache', 'clothing_nt_pencilmoustache', 'S', 1, 1, 1.00, '0', '0', '0', '0', '0', '0', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11258, 11258, '1', 'habbo20_c20_artdecochair', 'habbo20_c20_artdecochair', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11259, 11259, '0', 'clothing_silkgloves', 'clothing_silkgloves', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11260, 11260, '1', 'habbo20_c20_artdecobackdrop', 'habbo20_c20_artdecobackdrop', 'S', 1, 2, 0.00, '0', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11261, 11261, '1', 'habbo20_c20_glitzytable', 'habbo20_c20_glitzytable', 'S', 2, 2, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11262, 11262, '0', 'clothing_nt_chiseledface', 'clothing_nt_chiseledface', 'S', 1, 1, 1.00, '0', '0', '0', '0', '0', '0', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11263, 11263, '0', 'neonpunk_c20_wall', 'neonpunk_c20_wall', 'S', 1, 2, 4.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11264, 11264, '0', 'neonpunk_c20_cupboard', 'neonpunk_c20_cupboard', 'S', 1, 1, 2.60, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11265, 11265, '0', 'neonpunk_c20_strawberries', 'neonpunk_c20_strawberries', 'S', 1, 2, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11266, 11266, '0', 'neonpunk_c20_stool', 'neonpunk_c20_stool', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11267, 11267, '0', 'neonpunk_c20_lamp', 'neonpunk_c20_lamp', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(11268, 11268, '0', 'clothing_r20_neonpunkset', 'clothing_r20_neonpunkset', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11269, 11269, '0', 'neonpunk_c20_bed', 'neonpunk_c20_bed', 'S', 2, 3, 1.80, '0', '0', '1', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11270, 11270, '0', 'neonpunk_c20_stardeco', 'neonpunk_c20_stardeco', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11271, 11271, '0', 'neonpunk_c20_unicornposter', 'neonpunk_c20_unicornposter', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11272, 11272, '0', 'neonpunk_c20_candylights', 'neonpunk_c20_candylights', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11273, 11273, '0', 'neonpunk_c20_bows', 'neonpunk_c20_bows', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11274, 11274, '0', 'neonpunk_c20_carpet', 'neonpunk_c20_carpet', 'S', 4, 4, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11275, 11275, '0', 'neonpunk_c20_lights', 'neonpunk_c20_lights', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11276, 11276, '0', 'neonpunk_c20_table', 'neonpunk_c20_table', 'S', 1, 1, 1.20, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11277, 11277, '0', 'neonpunk_c20_cubeseat', 'neonpunk_c20_cubeseat', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11278, 11278, '0', 'neonpunk_c20_storage', 'neonpunk_c20_storage', 'S', 2, 1, 2.60, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11279, 11279, '0', 'neonpunk_c20_plushiepile', 'neonpunk_c20_plushiepile', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11280, 11280, '0', 'neonpunk_c20_plushie1', 'neonpunk_c20_plushie1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11281, 11281, '0', 'neonpunk_c20_dresser', 'neonpunk_c20_dresser', 'S', 1, 2, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11282, 11282, '0', 'neonpunk_c20_food', 'neonpunk_c20_food', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11283, 11283, '0', 'neonpunk_c20_floor', 'neonpunk_c20_floor', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11284, 11284, '0', 'neonpunk_c20_plushie2', 'neonpunk_c20_plushie2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11285, 11285, '0', 'neonpunk_c20_plushie3', 'neonpunk_c20_plushie3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11286, 11286, '0', 'neonpunk_c20_sofa', 'neonpunk_c20_sofa', 'S', 2, 1, 1.20, '0', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11287, 11287, '0', 'neonpunk_c20_bedsidetable', 'neonpunk_c20_bedsidetable', 'S', 1, 1, 1.20, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(11288, 11288, '0', 'gothiccafe_c20_sofa', 'gothiccafe_c20_sofa', 'S', 2, 1, 1.20, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11289, 11289, '0', 'gothiccafe_c20_creamrolls', 'gothiccafe_c20_creamrolls', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(11290, 11290, '0', 'gothiccafe_c20_bookcase', 'gothiccafe_c20_bookcase', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11291, 11291, '0', 'gothiccafe_c20_table', 'gothiccafe_c20_table', 'S', 1, 1, 1.10, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11292, 11292, '0', 'gothiccafe_c20_teaplant', 'gothiccafe_c20_teaplant', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11293, 11293, '0', 'gothiccafe_c20_glass', 'gothiccafe_c20_glass', 'S', 1, 2, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11294, 11294, '0', 'gothiccafe_c20_vase', 'gothiccafe_c20_vase', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11295, 11295, '0', 'gothiccafe_c20_icetea', 'gothiccafe_c20_icetea', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(11296, 11296, '0', 'gothiccafe_c20_donut', 'gothiccafe_c20_donut', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 5, '', '', '', 0, 0, ''),
	(11297, 11297, '0', 'gothiccafe_c20_coffeetable', 'gothiccafe_c20_coffeetable', 'S', 2, 1, 1.10, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11298, 11298, '0', 'gothiccafe_c20_floor', 'gothiccafe_c20_floor', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11299, 11299, '0', 'clothing_r20_gothicset', 'clothing_r20_gothicset', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11300, 11300, '0', 'gothiccafe_c20_rosepainting', 'gothiccafe_c20_rosepainting', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11301, 11301, '0', 'gothiccafe_c20_shelf', 'gothiccafe_c20_shelf', 'S', 1, 2, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'multiheight', 2, '', '0.30;1.10', '', 0, 0, ''),
	(11302, 11302, '0', 'gothiccafe_c20_wall', 'gothiccafe_c20_wall', 'S', 2, 1, 4.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11303, 11303, '0', 'gothiccafe_c20_mochicake', 'gothiccafe_c20_mochicake', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(11304, 11304, '0', 'gothiccafe_c20_counter', 'gothiccafe_c20_counter', 'S', 1, 2, 1.10, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11305, 11305, '0', 'gothiccafe_c20_rug', 'gothiccafe_c20_rug', 'S', 2, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11306, 11306, '0', 'gothiccafe_c20_windoor', 'gothiccafe_c20_windoor', 'S', 1, 2, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 8, '', '', '', 0, 0, ''),
	(11307, 11307, '0', 'gothiccafe_c20_armchair', 'gothiccafe_c20_armchair', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11308, 11308, '0', 'habbo20_r20_crackable', 'habbo20_r20_crackable', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(11309, 11309, '0', 'habbo20_c20_crackable', 'habbo20_c20_crackable', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(11310, 11310, '0', 'habbo20_c20_blackgoldballoon', 'habbo20_c20_blackgoldballoon', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11311, 11311, '0', 'clothing_h20th', 'clothing_h20th', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11312, 11312, '0', 'habbo20_c20_rosegoldballoon', 'habbo20_c20_rosegoldballoon', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11313, 11313, '0', 'rare_blackrosegold_parasol', 'rare_blackrosegold_parasol', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11314, 11314, '0', 'rare_blackrosegold_icecream', 'rare_blackrosegold_icecream', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'vendingmachine', 2, '4', '', '', 0, 0, ''),
	(11315, 11315, '0', 'rare_blackrosegold_fountain', 'rare_blackrosegold_fountain', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11316, 11316, '0', 'rare_r20_candle', 'rare_r20_candle', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11317, 11317, '0', 'rare_blackrosegold_beehive_bulb', 'rare_blackrosegold_beehive_bulb', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11318, 11318, '0', 'rare_blackrosegold_scifidoor', 'rare_blackrosegold_scifidoor', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(11319, 11319, '0', 'rare_blackrosegold_pillar', 'rare_blackrosegold_pillar', 'S', 1, 1, 3.50, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11320, 11320, '0', 'rare_blackrosegold_pillow', 'rare_blackrosegold_pillow', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11321, 11321, '0', 'rare_blackrosegold_wooden_screen', 'rare_blackrosegold_wooden_screen', 'S', 1, 2, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11322, 11322, '0', 'rare_blackrosegold_barrier', 'rare_blackrosegold_barrier', 'S', 1, 2, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11323, 11323, '0', 'rare_blackrosegold_scifirocket', 'rare_blackrosegold_scifirocket', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11324, 11324, '0', 'rare_blackrosegold_marquee', 'rare_blackrosegold_marquee', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(11325, 11325, '0', 'rare_blackrosegold_elephant_statue', 'rare_blackrosegold_elephant_statue', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11326, 11326, '0', 'rare_r20_throne', 'rare_r20_throne', 'S', 1, 1, 1.30, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'pressureplate', 2, '', '', '', 0, 0, ''),
	(11327, 11327, '0', 'rare_blackrosegold_dragonlamp', 'rare_blackrosegold_dragonlamp', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11328, 11328, '0', 'rare_blackrosegold_sleepingbag', 'rare_blackrosegold_sleepingbag', 'S', 1, 3, 0.80, '0', '0', '1', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11329, 11329, '0', 'rare_blackrosegold_scifiport', 'rare_blackrosegold_scifiport', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(11330, 11330, '0', 'rare_blackrosegold_fan', 'rare_blackrosegold_fan', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11331, 11331, '0', 'darkelegant_c20_flowerpot', 'darkelegant_c20_flowerpot', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11332, 11332, '0', 'darkelegant_c20_smalltable', 'darkelegant_c20_smalltable', 'S', 1, 1, 1.20, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11333, 11333, '0', 'darkelegant_c20_floor', 'darkelegant_c20_floor', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11334, 11334, '0', 'darkelegant_c20_chair', 'darkelegant_c20_chair', 'S', 1, 1, 1.50, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11335, 11335, '0', 'darkelegant_c20_walldecor', 'darkelegant_c20_walldecor', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11336, 11336, '0', 'darkelegant_c20_window', 'darkelegant_c20_window', 'S', 2, 1, 4.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11337, 11337, '0', 'darkelegant_c20_vanity', 'darkelegant_c20_vanity', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11338, 11338, '0', 'darkelegant_c20_light', 'darkelegant_c20_light', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11339, 11339, '0', 'darkelegant_c20_lionstatue', 'darkelegant_c20_lionstatue', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11340, 11340, '0', 'darkelegant_c20_teaset', 'darkelegant_c20_teaset', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11341, 11341, '0', 'darkelegant_c20_lamp', 'darkelegant_c20_lamp', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11342, 11342, '0', 'darkelegant_c20_stool', 'darkelegant_c20_stool', 'S', 1, 1, 1.50, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11343, 11343, '0', 'darkelegant_c20_cat', 'darkelegant_c20_cat', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11344, 11344, '0', 'darkelegant_c20_table', 'darkelegant_c20_table', 'S', 2, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11345, 11345, '0', 'clothing_darkelegantset', 'clothing_darkelegantset', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11346, 11346, '0', 'darkelegant_c20_cupboard', 'darkelegant_c20_cupboard', 'S', 1, 2, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11347, 11347, '0', 'darkelegant_c20_bed', 'darkelegant_c20_bed', 'S', 2, 3, 2.00, '0', '0', '1', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11348, 11348, '0', 'darkelegant_c20_sofa', 'darkelegant_c20_sofa', 'S', 2, 1, 1.50, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11349, 11349, '0', 'darkelegant_c20_wall', 'darkelegant_c20_wall', 'S', 2, 1, 4.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11350, 11350, '0', 'darkelegant_c20_carpet', 'darkelegant_c20_carpet', 'S', 3, 2, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11351, 11351, '1', 'sunsetcafe_c20_duck', 'sunsetcafe_c20_duck', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11352, 11352, '1', 'sunsetcafe_c20_plant', 'sunsetcafe_c20_plant', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11353, 11353, '1', 'sunsetcafe_c20_floor', 'sunsetcafe_c20_floor', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 5, '', '', '', 0, 0, ''),
	(11354, 11354, '1', 'sunsetcafe_c20_table', 'sunsetcafe_c20_table', 'S', 1, 2, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11355, 11355, '1', 'sunsetcafe_c20_wallcorner', 'sunsetcafe_c20_wallcorner', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(11356, 11356, '1', 'sunsetcafe_c20_bench', 'sunsetcafe_c20_bench', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11357, 11357, '1', 'sunsetcafe_c20_benchcornerconcave', 'sunsetcafe_c20_benchcornerconcave', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 1, 1, ''),
	(11358, 11358, '1', 'sunsetcafe_c20_coffeemachine', 'sunsetcafe_c20_coffeemachine', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'vendingmachine', 2, '53', '', '', 0, 0, ''),
	(11359, 11359, '1', 'sunsetcafe_c20_logdecor', 'sunsetcafe_c20_logdecor', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 6, '', '', '', 0, 0, ''),
	(11360, 11360, '1', 'sunsetcafe_c20_swordfish', 'sunsetcafe_c20_swordfish', 'S', 3, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11361, 11361, '1', 'sunsetcafe_c20_barcorner', 'sunsetcafe_c20_barcorner', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11362, 11362, '1', 'sunsetcafe_c20_lightupfloor', 'sunsetcafe_c20_lightupfloor', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 6, '', '', '', 0, 0, ''),
	(11363, 11363, '1', 'sunsetcafe_c20_bar', 'sunsetcafe_c20_bar', 'S', 2, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(11364, 11364, '1', 'sunsetcafe_c20_shallow', 'sunsetcafe_c20_shallow', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 30, 30, ''),
	(11365, 11365, '1', 'sunsetcafe_c20_drinks', 'sunsetcafe_c20_drinks', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(11366, 11366, '1', 'sunsetcafe_c20_logsteppingstones', 'sunsetcafe_c20_logsteppingstones', 'S', 1, 1, 0.20, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(11367, 11367, '1', 'sunsetcafe_c20_wall', 'sunsetcafe_c20_wall', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 10, '', '', '', 0, 0, ''),
	(11368, 11368, '0', 'darkmodern_c20_wall', 'darkmodern_c20_wall', 'S', 2, 1, 3.60, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 10, '', '', '', 0, 0, ''),
	(11369, 11369, '0', 'darkmodern_c20_incense', 'darkmodern_c20_incense', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(11370, 11370, '0', 'darkmodern_c20_neonlight', 'darkmodern_c20_neonlight', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(11371, 11371, '0', 'darkmodern_c20_folder', 'darkmodern_c20_folder', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 8, '', '', '', 0, 0, ''),
	(11372, 11372, '0', 'darkmodern_c20_floor', 'darkmodern_c20_floor', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11373, 11373, '0', 'darkmodern_c20_creative', 'darkmodern_c20_creative', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(11374, 11374, '0', 'darkmodern_c20_rug', 'darkmodern_c20_rug', 'S', 2, 3, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11375, 11375, '0', 'darkmodern_c20_display', 'darkmodern_c20_display', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(11376, 11376, '0', 'darkmodern_c20_speakers', 'darkmodern_c20_speakers', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11377, 11377, '0', 'darkmodern_c20_pictures', 'darkmodern_c20_pictures', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 8, '', '', '', 0, 0, ''),
	(11378, 11378, '0', 'darkmodern_c20_bed', 'darkmodern_c20_bed', 'S', 2, 3, 1.80, '0', '0', '1', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11379, 11379, '0', 'darkmodern_c20_glassblockwall', 'darkmodern_c20_glassblockwall', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11380, 11380, '0', 'darkmodern_c20_lowtable', 'darkmodern_c20_lowtable', 'S', 1, 3, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(11381, 11381, '0', 'darkmodern_c20_plant', 'darkmodern_c20_plant', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(11382, 11382, '0', 'darkmodern_c20_endtable', 'darkmodern_c20_endtable', 'S', 1, 1, 1.40, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(11383, 11383, '0', 'darkmodern_c20_reads', 'darkmodern_c20_reads', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(11384, 11384, '0', 'darkmodern_c20_bunnylight', 'darkmodern_c20_bunnylight', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(11385, 11385, '0', 'darkmodern_c20_pillow', 'darkmodern_c20_pillow', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'default', 5, '', '', '', 0, 0, ''),
	(11386, 11386, '0', 'darkmodern_c20_desk', 'darkmodern_c20_desk', 'S', 1, 2, 1.20, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11387, 11387, '0', 'darkmodern_c20_sofa', 'darkmodern_c20_sofa', 'S', 2, 1, 1.40, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11388, 11388, '0', 'darkmodern_c20_hoomba', 'darkmodern_c20_hoomba', 'S', 1, 2, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11389, 11389, '0', 'darkmodern_c20_chair', 'darkmodern_c20_chair', 'S', 1, 1, 1.40, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11390, 11390, '0', 'darkmodern_c20_pug', 'darkmodern_c20_pug', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11391, 11391, '0', 'darkmodern_c20_shelf', 'darkmodern_c20_shelf', 'S', 1, 2, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11392, 11392, '0', 'darkmodern_c20_lamp', 'darkmodern_c20_lamp', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11393, 11393, '0', 'darkmodern_c20_tubelights', 'darkmodern_c20_tubelights', 'S', 1, 1, 1.85, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 8, '', '', '', 0, 0, ''),
	(11394, 11394, '0', 'darkmodern_c20_tv', 'darkmodern_c20_tv', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 5, '', '', '', 0, 0, ''),
	(11395, 11395, '0', 'darkmodern_c20_floorlight', 'darkmodern_c20_floorlight', 'S', 1, 1, 0.20, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 9, '', '', '', 0, 0, ''),
	(11396, 11396, '0', 'zengarden_c20_stonebench', 'zengarden_c20_stonebench', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11397, 11397, '0', 'zengarden_c20_peacedog', 'zengarden_c20_peacedog', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11398, 11398, '0', 'clothing_r20_harmonyset', 'clothing_r20_harmonyset', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11399, 11399, '0', 'zengarden_c20_spikeyplant', 'zengarden_c20_spikeyplant', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11400, 11400, '0', 'zengarden_c20_stonetable', 'zengarden_c20_stonetable', 'S', 1, 1, 0.50, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11401, 11401, '0', 'zengarden_c20_door', 'zengarden_c20_door', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(11402, 11402, '0', 'zengarden_c20_rootplant', 'zengarden_c20_rootplant', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11403, 11403, '0', 'zengarden_c20_light', 'zengarden_c20_light', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 5, '', '', '', 0, 0, ''),
	(11404, 11404, '0', 'zengarden_c20_roof', 'zengarden_c20_roof', 'S', 2, 1, 0.00, '0', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11405, 11405, '0', 'zengarden_c20_plankfloor', 'zengarden_c20_plankfloor', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11406, 11406, '0', 'zengarden_c20_roofcorner', 'zengarden_c20_roofcorner', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11407, 11407, '0', 'zengarden_c20_moss', 'zengarden_c20_moss', 'S', 1, 1, 0.20, '0', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(11408, 11408, '0', 'zengarden_c20_goldenmobile', 'zengarden_c20_goldenmobile', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11409, 11409, '0', 'zengarden_c20_pebbles', 'zengarden_c20_pebbles', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11410, 11410, '0', 'zengarden_c20_bamboo', 'zengarden_c20_bamboo', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11411, 11411, '0', 'zengarden_c20_divider', 'zengarden_c20_divider', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11412, 11412, '0', 'zengarden_c20_glasspond', 'zengarden_c20_glasspond', 'S', 2, 2, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 5, '', '', '', 0, 0, ''),
	(11413, 11413, '0', 'habbo20_c20_trophybronze', 'habbo20_c20_trophybronze', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(11414, 11414, '0', 'habbo20_c20_trophyblock', 'habbo20_c20_trophyblock', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(11415, 11415, '0', 'habbo20_c20_trophygold', 'habbo20_c20_trophygold', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(11416, 11416, '0', 'habbo20_c20_trophylooks', 'habbo20_c20_trophylooks', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(11417, 11417, '0', 'habbo20_c20_trophydesign', 'habbo20_c20_trophydesign', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(11418, 11418, '0', 'habbo20_c20_trophysilver', 'habbo20_c20_trophysilver', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(11419, 11419, '0', 'habbo20_c20_trophyvideo', 'habbo20_c20_trophyvideo', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'trophy', 1, '', '', '', 0, 0, ''),
	(11420, 11420, '0', 'CF_1500_suitcase2', 'CF_1500_suitcase2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11421, 11421, '0', 'clothing_r20_slumberoutfit', 'clothing_r20_slumberoutfit', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11422, 11422, '0', 'dtl_r20_gold', 'dtl_r20_gold', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'vendingmachine', 2, '1093', '', '', 0, 0, ''),
	(11423, 11423, '0', 'party_nt_barcorn', 'party_nt_barcorn', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11424, 11424, '0', 'country_nt_rbw', 'country_nt_rbw', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11425, 11425, '0', 'party_nt_chair', 'party_nt_chair', 'S', 1, 1, 1.30, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11426, 11426, '0', 'bw_nt_water_2', 'bw_nt_water_2', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 29, 29, ''),
	(11427, 11427, '0', 'usva_nt_shelf', 'usva_nt_shelf', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(11428, 11428, '0', 'tiki_nt_bflies', 'tiki_nt_bflies', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(11429, 11429, '0', 'chair_nt_polyfon', 'chair_nt_polyfon', 'S', 1, 1, 0.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11430, 11430, '0', 'party_nt_bardesk', 'party_nt_bardesk', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11431, 11431, '0', 'party_nt_tube_bubble', 'party_nt_tube_bubble', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(11432, 11432, '0', 'usva5_nt_sofa', 'usva5_nt_sofa', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11433, 11433, '0', 'bw_nt_pool_a1', 'bw_nt_pool_a1', 'S', 1, 1, 1.00, '1', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11434, 11434, '0', 'rela_nt_plant', 'rela_nt_plant', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11435, 11435, '0', 'usva_nt_rug', 'usva_nt_rug', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(11436, 11436, '0', 'pura_nt_mdl36', 'pura_nt_mdl36', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11437, 11437, '0', 'bw_nt_pool_a3', 'bw_nt_pool_a3', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11438, 11438, '0', 'rela_nt_rock', 'rela_nt_rock', 'S', 1, 1, 0.90, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11439, 11439, '0', 'anna_nt_table_blue', 'anna_nt_table_blue', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11440, 11440, '0', 'rela_nt_hchair', 'rela_nt_hchair', 'S', 1, 1, 1.30, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11441, 11441, '0', 'cubie_nt_shelf_2_b', 'cubie_nt_shelf_2_b', 'S', 2, 1, 0.60, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 17, '', '', '', 0, 0, ''),
	(11442, 11442, '0', 'lc_nt_tile2', 'lc_nt_tile2', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11443, 11443, '0', 'val12_nt_pillar1', 'val12_nt_pillar1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(11444, 11444, '0', 'party_nt_tube_lava', 'party_nt_tube_lava', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(11445, 11445, '0', 'bb_nt_lightdiv', 'bb_nt_lightdiv', 'S', 1, 1, 1.35, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 8, '', '', '', 0, 0, ''),
	(11446, 11446, '0', 'usva2_nt_shelf2', 'usva2_nt_shelf2', 'S', 1, 1, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11447, 11447, '0', 'cubie_nt_shelf_1_b', 'cubie_nt_shelf_1_b', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 14, '', '', '', 0, 0, ''),
	(11448, 11448, '0', 'pura_nt_mdl26', 'pura_nt_mdl26', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11449, 11449, '0', 'usva5_nt_rug', 'usva5_nt_rug', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(11450, 11450, '0', 'party_nt_floor', 'party_nt_floor', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 10, '', '', '', 0, 0, ''),
	(11451, 11451, '0', 'usva5_nt_chair', 'usva5_nt_chair', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11452, 11452, '0', 'tiki_nt_tray2', 'tiki_nt_tray2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11453, 11453, '0', 'usva5_nt_lamp', 'usva5_nt_lamp', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11454, 11454, '0', 'usva2_nt_shelf', 'usva2_nt_shelf', 'S', 1, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(11455, 11455, '0', 'pixel_nt_floor_silver', 'pixel_nt_floor_silver', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11456, 11456, '0', 'coco_nt_sofatable_c3', 'coco_nt_sofatable_c3', 'S', 1, 1, 1.30, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11457, 11457, '0', 'pura_nt_mdl16', 'pura_nt_mdl16', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11458, 11458, '0', 'rela_nt_stone', 'rela_nt_stone', 'S', 1, 1, 0.50, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(11459, 11459, '0', 'clothing_cyeyepiece', 'clothing_cyeyepiece', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11460, 11460, '1', 'autumn_c20_birdfood', 'autumn_c20_birdfood', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11461, 11461, '1', 'autumn_c20_tree3', 'autumn_c20_tree3', 'S', 2, 2, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11462, 11462, '0', 'clothing_r20_cyborgface', 'clothing_r20_cyborgface', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11463, 11463, '0', 'clothing_cybuns', 'clothing_cybuns', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11464, 11464, '0', 'clothing_cylegs', 'clothing_cylegs', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11465, 11465, '1', 'autumn_c20_tree1', 'autumn_c20_tree1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11466, 11466, '0', 'clothing_cytrainers', 'clothing_cytrainers', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11467, 11467, '0', 'clothing_r20_cyborgwings', 'clothing_r20_cyborgwings', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11468, 11468, '0', 'cpunk_r20_augchair', 'cpunk_r20_augchair', 'S', 1, 1, 1.35, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'pressureplate', 1, '', '', '', 0, 0, 'ha-4018'),
	(11469, 11469, '0', 'clothing_cyfins', 'clothing_cyfins', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11470, 11470, '1', 'autumn_c20_bench', 'autumn_c20_bench', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(11471, 11471, '1', 'autumn_c20_tree2', 'autumn_c20_tree2', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11472, 11472, '1', 'autumn_c20_tree6', 'autumn_c20_tree6', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11473, 11473, '0', 'clothing_cygasmask', 'clothing_cygasmask', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11474, 11474, '1', 'autumn_c20_tree5', 'autumn_c20_tree5', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11475, 11475, '0', 'clothing_cyhelmet', 'clothing_cyhelmet', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11476, 11476, '0', 'clothing_cychest', 'clothing_cychest', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11477, 11477, '0', 'autumn_r20_pond', 'autumn_r20_pond', 'S', 1, 2, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(11478, 11478, '1', 'autumn_c20_tree4', 'autumn_c20_tree4', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11479, 11479, '0', 'hween_c20_eyetv', 'hween_c20_eyetv', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(11480, 11480, '0', 'hween_c20_otherdimension', 'hween_c20_otherdimension', 'S', 2, 3, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11481, 11481, '0', 'hween_c20_secretbkshelf', 'hween_c20_secretbkshelf', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'gate', 2, '', '', '', 0, 0, ''),
	(11482, 11482, '0', 'hween_c20_evilscarecrowb', 'hween_c20_evilscarecrowb', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11483, 11483, '0', 'hween_c20_goddessthrone', 'hween_c20_goddessthrone', 'S', 1, 1, 1.35, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11484, 11484, '0', 'hween_c20_porchfloor', 'hween_c20_porchfloor', 'S', 2, 2, 1.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11485, 11485, '0', 'hween_c20_porchdvdr', 'hween_c20_porchdvdr', 'S', 1, 2, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11486, 11486, '0', 'hween_c20_madpaper', 'hween_c20_madpaper', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 6, '', '', '', 0, 0, ''),
	(11487, 11487, '0', 'hween_c20_pandoraboxB', 'hween_c20_pandoraboxB', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11488, 11488, '0', 'hween_c20_brokenfloor', 'hween_c20_brokenfloor', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(11489, 11489, '0', 'hween_c20_tentaclethrone', 'hween_c20_tentaclethrone', 'S', 1, 1, 1.60, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11490, 11490, '0', 'hween_c20_octobath', 'hween_c20_octobath', 'S', 1, 2, 0.30, '0', '0', '0', '1', '1', '1', '1', '1', '1', 'pressureplate', 2, '', '', '', 0, 0, ''),
	(11491, 11491, '0', 'hween_c20_candyapple', 'hween_c20_candyapple', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11492, 11492, '0', 'hween_c20_crookedclock', 'hween_c20_crookedclock', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11493, 11493, '0', 'hween_c20_infinitywall', 'hween_c20_infinitywall', 'S', 2, 1, 4.00, '0', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11494, 11494, '0', 'hween_c20_tentacletable', 'hween_c20_tentacletable', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11495, 11495, '0', 'hween_c20_pandorabox', 'hween_c20_pandorabox', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(11496, 11496, '0', 'hween_c20_creepyshadow', 'hween_c20_creepyshadow', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11497, 11497, '0', 'clothing_wingstiara', 'clothing_wingstiara', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11498, 11498, '0', 'hween_c20_evilscarecrow', 'hween_c20_evilscarecrow', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'crackable', 25, '', '', '', 0, 0, ''),
	(11499, 11499, '0', 'hween_c20_lamp', 'hween_c20_lamp', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11500, 11500, '0', 'hween_c20_hallway', 'hween_c20_hallway', 'S', 2, 1, 0.00, '0', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11501, 11501, '0', 'hween_c20_warpedsofa', 'hween_c20_warpedsofa', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11502, 11502, '0', 'hween_c20_eyedemon', 'hween_c20_eyedemon', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'crackable', 25, '', '', '', 0, 0, ''),
	(11503, 11503, '0', 'hween_ltd20_tearfountain', 'hween_ltd20_tearfountain', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(11504, 11504, '0', 'hween_c20_octodemon', 'hween_c20_octodemon', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'crackable', 25, '', '', '', 0, 0, ''),
	(11505, 11505, '0', 'hween_c20_vwall', 'hween_c20_vwall', 'S', 1, 2, 4.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11506, 11506, '0', 'clothing_multieyesface', 'clothing_multieyesface', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11507, 11507, '0', 'hween_c20_cursedmirror', 'hween_c20_cursedmirror', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11508, 11508, '0', 'clothing_r20_possessedhair', 'clothing_r20_possessedhair', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11509, 11509, '0', 'hween_c20_door', 'hween_c20_door', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 7, '', '', '', 0, 0, ''),
	(11510, 11510, '0', 'clothing_tentaclehead', 'clothing_tentaclehead', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11511, 11511, '0', 'hween_r20_meltingpainting', 'hween_r20_meltingpainting', 'S', 1, 3, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11512, 11512, '0', 'hween_c20_hwall', 'hween_c20_hwall', 'S', 3, 1, 2.20, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11513, 11513, '0', 'hween_c20_madwall', 'hween_c20_madwall', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(11514, 11514, '0', 'hween_c20_lrstairs', 'hween_c20_lrstairs', 'S', 1, 2, 2.00, '0', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11515, 11515, '0', 'hween_c20_udstairs', 'hween_c20_udstairs', 'S', 1, 2, 1.00, '0', '0', '0', '1', '1', '1', '1', '1', '1', 'multiheight', 2, '', '1.0;2.0', '', 0, 0, ''),
	(11516, 11516, '0', 'clothing_webskirt', 'clothing_webskirt', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11517, 11517, '0', 'hween_c20_floor', 'hween_c20_floor', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11518, 11518, '0', 'clothing_nt_pumpkinbag', 'clothing_nt_pumpkinbag', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11519, 11519, '0', 'hween_r20_evilpandoraboxB', 'hween_r20_evilpandoraboxB', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11520, 11520, '0', 'hween_r20_evilpandorabox', 'hween_r20_evilpandorabox', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(11521, 11521, '0', 'hween_c20_mannequin', 'hween_c20_mannequin', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 6, '', '', '', 0, 0, ''),
	(11522, 11522, '0', 'hween_c20_porchawning', 'hween_c20_porchawning', 'S', 2, 2, 0.00, '0', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(11523, 11523, '0', 'hween_c20_housewall', 'hween_c20_housewall', 'S', 2, 1, 4.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(11524, 11524, '0', 'hween_c20_duckgoddessb', 'hween_c20_duckgoddessb', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11525, 11525, '0', 'hween_c20_floatingbed', 'hween_c20_floatingbed', 'S', 2, 1, 1.00, '0', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11526, 11526, '0', 'clothing_nt_ghost', 'clothing_nt_ghost', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11527, 11527, '0', 'hween_c20_floorstage', 'hween_c20_floorstage', 'S', 2, 2, 1.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11528, 11528, '0', 'hween_c20_window', 'hween_c20_window', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(11529, 11529, '0', 'clothing_pumpkinbag', 'clothing_pumpkinbag', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11530, 11530, '0', 'hween_c20_goddesscrystal', 'hween_c20_goddesscrystal', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11531, 11531, '0', 'hween_c20_duckgoddess', 'hween_c20_duckgoddess', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'crackable', 20, '', '', '', 0, 0, ''),
	(11532, 11532, '0', 'hween_c20_floortrap', 'hween_c20_floortrap', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '1', '1', '1', 'trap', 1, '', '', '', 0, 0, ''),
	(11533, 11533, '0', 'clothing_crookedhat', 'clothing_crookedhat', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11534, 11534, '0', 'hween_c20_octodemonb', 'hween_c20_octodemonb', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11535, 11535, '0', 'hween_c20_crookedtree', 'hween_c20_crookedtree', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'pressureplate', 2, '', '', '', 0, 0, ''),
	(11536, 11536, '0', 'clothing_ghost', 'clothing_ghost', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11537, 11537, '0', 'hween_c20_eyesofa', 'hween_c20_eyesofa', 'S', 2, 1, 1.20, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11538, 11538, '0', 'hween_r20_hourglass', 'hween_r20_hourglass', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11539, 11539, '0', 'clothing_nt_webskirt', 'clothing_nt_webskirt', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11540, 11540, '0', 'hween_c20_eyedemonb', 'hween_c20_eyedemonb', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11541, 11541, '0', 'hween_c20_aspentree', 'hween_c20_aspentree', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11542, 11542, '0', 'clothing_nt_clownmask', 'clothing_nt_clownmask', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11543, 11543, '0', 'clothing_r20_pumpkinoutfit', 'clothing_r20_pumpkinoutfit', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11544, 11544, '0', 'clothing_clownmask', 'clothing_clownmask', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11545, 11545, '0', 'rare_royalchair', 'rare_royalchair', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11546, 11546, '0', 'rare_royalsofa', 'rare_royalsofa', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11547, 11547, '0', 'CF_250_fancywatch', 'CF_250_fancywatch', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11548, 11548, '0', 'hween_c20_porchstairs', 'hween_c20_porchstairs', 'S', 2, 1, 0.60, '0', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11549, 11549, '0', 'antibully_machine', 'antibully_machine', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'vendingmachine_no_sides', 2, '1095', '', '', 0, 0, ''),
	(11550, 11550, '0', 'rare_colourable_parasol*5', 'rare_colourable_parasol*5', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11551, 11551, '0', 'plushie_c20_rainbowlion1', 'plushie_c20_rainbowlion1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11552, 11552, '0', 'plushie_c20_bluebear3', 'plushie_c20_bluebear3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11553, 11553, '0', 'plushie_c20_bluelion', 'plushie_c20_bluelion', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11554, 11554, '0', 'plushie_c20_pinkbear3', 'plushie_c20_pinkbear3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11555, 11555, '0', 'plushie_c20_bluebunny2', 'plushie_c20_bluebunny2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11556, 11556, '0', 'plushie_c20_dyerainbow', 'plushie_c20_dyerainbow', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11557, 11557, '0', 'plushie_c20_stuffing', 'plushie_c20_stuffing', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11558, 11558, '0', 'plushie_c20_crackableB', 'plushie_c20_crackableB', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(11559, 11559, '0', 'plushie_c20_rainbowbunny2', 'plushie_c20_rainbowbunny2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11560, 11560, '0', 'plushie_c20_bluebunny3', 'plushie_c20_bluebunny3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11561, 11561, '0', 'plushie_c20_brownlion3', 'plushie_c20_brownlion3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11562, 11562, '0', 'plushie_c20_crackable', 'plushie_c20_crackable', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(11563, 11563, '0', 'plushie_c20_fabric1', 'plushie_c20_fabric1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11564, 11564, '0', 'plushie_c20_pinklion3', 'plushie_c20_pinklion3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11565, 11565, '0', 'plushie_c20_bluebear2', 'plushie_c20_bluebear2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11566, 11566, '0', 'plushie_c20_bluebunny', 'plushie_c20_bluebunny', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11567, 11567, '0', 'clothing_unicornrainbow', 'clothing_unicornrainbow', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11568, 11568, '0', 'plushie_c20_brownbunny2', 'plushie_c20_brownbunny2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11569, 11569, '0', 'plushie_r20_picnictree', 'plushie_r20_picnictree', 'S', 1, 2, 3.00, '0', '0', '1', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11570, 11570, '0', 'plushie_c20_brownbear', 'plushie_c20_brownbear', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11571, 11571, '0', 'plushie_c20_dyeblue', 'plushie_c20_dyeblue', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11572, 11572, '0', 'plushie_c20_rainbowlion3', 'plushie_c20_rainbowlion3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11573, 11573, '0', 'plushie_c20_rainbowbear', 'plushie_c20_rainbowbear', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11574, 11574, '0', 'plushie_c20_bluebunny1', 'plushie_c20_bluebunny1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11575, 11575, '0', 'plushie_c20_brownbear3', 'plushie_c20_brownbear3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11576, 11576, '0', 'plushie_c20_pinklion1', 'plushie_c20_pinklion1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11577, 11577, '0', 'plushie_c20_dyepink', 'plushie_c20_dyepink', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11578, 11578, '0', 'plushie_c20_pinkbear', 'plushie_c20_pinkbear', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11579, 11579, '0', 'plushie_c20_rainbowlion2', 'plushie_c20_rainbowlion2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11580, 11580, '0', 'plushie_c20_rainbowbunny', 'plushie_c20_rainbowbunny', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11581, 11581, '0', 'plushie_c20_pinkbear1', 'plushie_c20_pinkbear1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11582, 11582, '0', 'plushie_c20_brownbunny1', 'plushie_c20_brownbunny1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11583, 11583, '0', 'plushie_c20_bluebear', 'plushie_c20_bluebear', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11584, 11584, '0', 'plushie_c20_rainbowbunny3', 'plushie_c20_rainbowbunny3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11585, 11585, '0', 'plushie_c20_pinklion', 'plushie_c20_pinklion', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11586, 11586, '0', 'plushie_c20_scarf', 'plushie_c20_scarf', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11587, 11587, '0', 'plushie_r20_hammock', 'plushie_r20_hammock', 'S', 1, 2, 3.00, '0', '0', '1', '0', '1', '1', '1', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(11588, 11588, '0', 'plushie_c20_fabric3', 'plushie_c20_fabric3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11589, 11589, '0', 'plushie_c20_brownbunny', 'plushie_c20_brownbunny', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11590, 11590, '0', 'plushie_c20_pinkbunny3', 'plushie_c20_pinkbunny3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11591, 11591, '0', 'plushie_c20_bow', 'plushie_c20_bow', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11592, 11592, '0', 'plushie_c20_rainbowlion', 'plushie_c20_rainbowlion', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11593, 11593, '0', 'plushie_c20_rainbowbear1', 'plushie_c20_rainbowbear1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11594, 11594, '0', 'plushie_c20_brownlion2', 'plushie_c20_brownlion2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11595, 11595, '0', 'plushie_c20_pinklion2', 'plushie_c20_pinklion2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11596, 11596, '0', 'plushie_c20_flowercrown', 'plushie_c20_flowercrown', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11597, 11597, '0', 'plushie_c20_bluelion1', 'plushie_c20_bluelion1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11598, 11598, '0', 'plushie_c20_bluelion3', 'plushie_c20_bluelion3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11599, 11599, '0', 'plushie_c20_dyeneutral', 'plushie_c20_dyeneutral', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11600, 11600, '0', 'plushie_c20_brownlion', 'plushie_c20_brownlion', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11601, 11601, '0', 'plushie_c20_rainbowbear2', 'plushie_c20_rainbowbear2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11602, 11602, '0', 'plushie_c20_bluelion2', 'plushie_c20_bluelion2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11603, 11603, '0', 'clothing_r20_teddybpack', 'clothing_r20_teddybpack', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11604, 11604, '0', 'plushie_c20_brownlion1', 'plushie_c20_brownlion1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11605, 11605, '0', 'plushie_c20_rainbowbear3', 'plushie_c20_rainbowbear3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11606, 11606, '0', 'plushie_c20_pinkbear2', 'plushie_c20_pinkbear2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11607, 11607, '0', 'plushie_c20_fluffmachine', 'plushie_c20_fluffmachine', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '0', '1', '0', '0', 'crafting', 2, '', '', '', 0, 0, ''),
	(11608, 11608, '0', 'plushie_c20_pinkbunny', 'plushie_c20_pinkbunny', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11609, 11609, '0', 'plushie_c20_brownbear2', 'plushie_c20_brownbear2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11610, 11610, '0', 'plushie_c20_fabric2', 'plushie_c20_fabric2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11611, 11611, '0', 'plushie_c20_bluebear1', 'plushie_c20_bluebear1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11612, 11612, '0', 'plushie_c20_rainbowbunny1', 'plushie_c20_rainbowbunny1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11613, 11613, '0', 'plushie_c20_pinkbunny1', 'plushie_c20_pinkbunny1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11614, 11614, '0', 'plushie_c20_pinkbunny2', 'plushie_c20_pinkbunny2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11615, 11615, '0', 'plushie_c20_brownbunny3', 'plushie_c20_brownbunny3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11616, 11616, '0', 'plushie_c20_brownbear1', 'plushie_c20_brownbear1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11617, 11617, '0', 'clothing_r20_bearset', 'clothing_r20_bearset', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11618, 11618, '0', 'xmas_r20_icefountain', 'xmas_r20_icefountain', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11619, 11619, '0', 'xmas_c20_runerockgreen', 'xmas_c20_runerockgreen', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(11620, 11620, '0', 'xmas_c20_crafter', 'xmas_c20_crafter', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '0', '1', '0', '0', 'crafting', 2, '', '', '', 0, 0, ''),
	(11621, 11621, '0', 'xmas_ltd20_yak', 'xmas_ltd20_yak', 'S', 1, 2, 2.30, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11622, 11622, '0', 'xmas_c20_smallrunestones', 'xmas_c20_smallrunestones', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11623, 11623, '0', 'xmas_r20_magicsword', 'xmas_r20_magicsword', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'vendingmachine_no_sides', 2, '1094', '', '', 0, 0, ''),
	(11624, 11624, '0', 'xmas_c20_frozenstream', 'xmas_c20_frozenstream', 'S', 1, 3, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(11625, 11625, '0', 'clothing_nt_kilt', 'clothing_nt_kilt', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11626, 11626, '1', 'xmas_c20_frostedweeds', 'xmas_c20_frostedweeds', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 6, '', '', '', 0, 0, ''),
	(11627, 11627, '0', 'xmas_c20_woodentrain', 'xmas_c20_woodentrain', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11628, 11628, '0', 'clothing_r20_dragonflywings', 'clothing_r20_dragonflywings', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11629, 11629, '0', 'xmas_c20_woodenplane', 'xmas_c20_woodenplane', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11630, 11630, '0', 'clothing_kilttop', 'clothing_kilttop', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11631, 11631, '0', 'xmas_c20_woodendog', 'xmas_c20_woodendog', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11632, 11632, '1', 'xmas_c20_treestump', 'xmas_c20_treestump', 'S', 2, 2, 1.00, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'tent', 2, '', '', '', 0, 0, ''),
	(11633, 11633, '0', 'xmas_c20_flowerguy', 'xmas_c20_flowerguy', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(11634, 11634, '0', 'xmas_c20_earthguy', 'xmas_c20_earthguy', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11635, 11635, '1', 'xmas_c20_shrine', 'xmas_c20_shrine', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(11636, 11636, '0', 'xmas_c20_rockguy', 'xmas_c20_rockguy', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11637, 11637, '0', 'clothing_kilt', 'clothing_kilt', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11638, 11638, '0', 'xmas_c20_bridge', 'xmas_c20_bridge', 'S', 1, 3, 0.60, '0', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(11639, 11639, '1', 'xmas_c20_frostytree', 'xmas_c20_frostytree', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11640, 11640, '0', 'xmas_c20_woodenblocks', 'xmas_c20_woodenblocks', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(11641, 11641, '0', 'xmas_c20_frozenwaterfall', 'xmas_c20_frozenwaterfall', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11642, 11642, '0', 'xmas_c20_runerockyellow', 'xmas_c20_runerockyellow', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(11643, 11643, '0', 'clothing_lanternstaff', 'clothing_lanternstaff', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11644, 11644, '0', 'xmas_c20_runetele', 'xmas_c20_runetele', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '1', '1', '1', 'teleport', 2, '', '', '', 0, 0, ''),
	(11645, 11645, '1', 'xmas_c20_snowdrops', 'xmas_c20_snowdrops', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(11646, 11646, '0', 'xmas_c20_fireguy', 'xmas_c20_fireguy', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11647, 11647, '1', 'xmas_c20_frostedholly', 'xmas_c20_frostedholly', 'S', 1, 2, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11648, 11648, '1', 'xmas_c20_frostedfungi', 'xmas_c20_frostedfungi', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(11649, 11649, '0', 'xmas_c20_snowguy', 'xmas_c20_snowguy', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11650, 11650, '1', 'xmas_c20_pebblepeeps', 'xmas_c20_pebblepeeps', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 5, '', '', '', 0, 0, ''),
	(11651, 11651, '0', 'xmas_c20_woodenhouse', 'xmas_c20_woodenhouse', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(11652, 11652, '0', 'xmas_c20_beadgame', 'xmas_c20_beadgame', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11653, 11653, '0', 'clothing_nt_kilttop', 'clothing_nt_kilttop', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11654, 11654, '0', 'xmas_c20_bigstump', 'xmas_c20_bigstump', 'S', 2, 2, 1.00, '0', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11655, 11655, '1', 'xmas_c20_snowbush', 'xmas_c20_snowbush', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11656, 11656, '0', 'clothing_nt_lanternstaff', 'clothing_nt_lanternstaff', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11657, 11657, '1', 'xmas_c20_smallstump', 'xmas_c20_smallstump', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 6, '', '', '', 0, 0, ''),
	(11658, 11658, '0', 'xmas_c20_runerockred', 'xmas_c20_runerockred', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(11659, 11659, '0', 'xmas_c20_runerockblue', 'xmas_c20_runerockblue', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(11660, 11660, '0', 'xmas_c20_woodenbird', 'xmas_c20_woodenbird', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11661, 11661, '0', 'xmas_c20_iceguy', 'xmas_c20_iceguy', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11662, 11662, '0', 'xmas_c20_nutcracker', 'xmas_c20_nutcracker', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11663, 11663, '1', 'xmas_c20_stage', 'xmas_c20_stage', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'multiheight', 3, '', '0.0;1.0;2.0', '', 0, 0, ''),
	(11664, 11664, '0', 'xmas_c20_runerockpurple', 'xmas_c20_runerockpurple', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(11665, 11665, '0', 'clothing_r20_inuit', 'clothing_r20_inuit', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11666, 11666, '0', 'clothing_braidedwavyhair', 'clothing_braidedwavyhair', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11667, 11667, '0', 'xmas_c20_magicguy', 'xmas_c20_magicguy', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(11668, 11668, '0', 'xmas_c20_stonecauldron', 'xmas_c20_stonecauldron', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(11669, 11669, '0', 'xmas_c20_stonearch', 'xmas_c20_stonearch', 'S', 1, 2, 0.00, '0', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11670, 11670, '0', 'xmas_c20_runerock', 'xmas_c20_runerock', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(11671, 11671, '0', 'CF_750_perfume', 'CF_750_perfume', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11672, 11672, '0', 'mysterious_trophy', 'mysterious_trophy', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11673, 11673, '0', 'house_sofa', 'house_sofa', 'S', 2, 1, 1.20, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11674, 11674, '0', 'CF_350_sparklybag', 'CF_350_sparklybag', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11675, 11675, '0', 'clothing_nt_braidedwavyhair', 'clothing_nt_braidedwavyhair', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11676, 11676, '0', 'rare_prize20_xmas', 'rare_prize20_xmas', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11677, 11677, '0', 'messy_c21_messyhifi', 'messy_c21_messyhifi', 'S', 1, 2, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11678, 11678, '0', 'messy_c21_messycloset', 'messy_c21_messycloset', 'S', 1, 1, 3.20, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11679, 11679, '0', 'messy_c21_wonkylowtable', 'messy_c21_wonkylowtable', 'S', 1, 2, 0.70, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11680, 11680, '0', 'messy_c21_forgottenvase', 'messy_c21_forgottenvase', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11681, 11681, '0', 'messy_c21_messyfootwear', 'messy_c21_messyfootwear', 'S', 1, 1, 0.10, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 6, '', '', '', 0, 0, ''),
	(11682, 11682, '0', 'messy_c21_wonkydoormat', 'messy_c21_wonkydoormat', 'S', 1, 2, 0.10, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11683, 11683, '0', 'messy_c21_messydrawers', 'messy_c21_messydrawers', 'S', 2, 1, 1.60, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11684, 11684, '0', 'messy_c21_wonkywallitems', 'messy_c21_wonkywallitems', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(11685, 11685, '0', 'messy_c21_stackedletters', 'messy_c21_stackedletters', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 7, '', '', '', 0, 0, ''),
	(11686, 11686, '0', 'messy_c21_kitchenette', 'messy_c21_kitchenette', 'S', 1, 2, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(11687, 11687, '0', 'messy_c21_magazines', 'messy_c21_magazines', 'S', 1, 1, 0.20, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(11688, 11688, '0', 'messy_c21_messyendtable', 'messy_c21_messyendtable', 'S', 1, 1, 1.50, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11689, 11689, '0', 'messy_c21_kitchencorner', 'messy_c21_kitchencorner', 'S', 1, 1, 2.80, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11690, 11690, '0', 'messy_c21_trashbags', 'messy_c21_trashbags', 'S', 1, 1, 0.80, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(11691, 11691, '0', 'messy_c21_messybed', 'messy_c21_messybed', 'S', 1, 3, 1.60, '0', '0', '1', '0', '1', '1', '1', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(11692, 11692, '0', 'messy_c21_oldwall', 'messy_c21_oldwall', 'S', 2, 1, 4.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(11693, 11693, '0', 'messy_c21_messyrug', 'messy_c21_messyrug', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11694, 11694, '0', 'messy_c21_plushcarpet', 'messy_c21_plushcarpet', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11695, 11695, '0', 'messy_c21_wonkytable', 'messy_c21_wonkytable', 'S', 2, 2, 1.20, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 6, '', '', '', 0, 0, ''),
	(11696, 11696, '0', 'messy_c21_wonkylamp', 'messy_c21_wonkylamp', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(11697, 11697, '0', 'messy_c21_messysofa', 'messy_c21_messysofa', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(11698, 11698, '0', 'messy_c21_stepladder', 'messy_c21_stepladder', 'S', 1, 1, 0.70, '0', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11699, 11699, '0', 'messy_c21_wonkychair', 'messy_c21_wonkychair', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11700, 11700, '0', 'messy_c21_clothespile', 'messy_c21_clothespile', 'S', 1, 1, 0.30, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(11701, 11701, '0', 'ny_r20_crackable', 'ny_r20_crackable', 'S', 1, 1, 0.80, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(11702, 11702, '0', 'clothing_r20_mask3', 'clothing_r20_mask3', 'S', 1, 1, 0.95, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11703, 11703, '0', 'clothing_r20_mask1', 'clothing_r20_mask1', 'S', 1, 1, 0.95, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11704, 11704, '0', 'clothing_r20_mask8', 'clothing_r20_mask8', 'S', 1, 1, 0.95, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11705, 11705, '0', 'clothing_r20_mask7', 'clothing_r20_mask7', 'S', 1, 1, 0.95, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11706, 11706, '0', 'clothing_r20_mask4', 'clothing_r20_mask4', 'S', 1, 1, 0.95, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11707, 11707, '0', 'clothing_r21_sunnycloudhat', 'clothing_r21_sunnycloudhat', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11708, 11708, '0', 'clothing_r20_mask5', 'clothing_r20_mask5', 'S', 1, 1, 0.95, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11709, 11709, '0', 'clothing_r20_mask6', 'clothing_r20_mask6', 'S', 1, 1, 0.95, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11710, 11710, '0', 'clothing_r20_mask2', 'clothing_r20_mask2', 'S', 1, 1, 0.95, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11711, 11711, '0', 'clothing_goldhatpack1', 'clothing_goldhatpack1', 'S', 1, 1, 0.65, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11712, 11712, '0', 'bonusbag21_4', 'bonusbag21_4', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(11713, 11713, '0', 'bonusrare21_2*0', 'bonusrare21_2*0', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11714, 11714, '0', 'bonusrare21_2*1', 'bonusrare21_2*1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11715, 11715, '0', 'bonusrare21_2*2', 'bonusrare21_2*2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11716, 11716, '0', 'bonusrare21_2*3', 'bonusrare21_2*3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11717, 11717, '0', 'bonusrare21_2*4', 'bonusrare21_2*4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11718, 11718, '0', 'bonusrare21_2*5', 'bonusrare21_2*5', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11719, 11719, '0', 'bonusrare21_3*1', 'bonusrare21_3*1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11720, 11720, '0', 'bonusrare21_3*2', 'bonusrare21_3*2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11721, 11721, '0', 'bonusrare21_3*3', 'bonusrare21_3*3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11722, 11722, '0', 'bonusrare21_3*4', 'bonusrare21_3*4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11723, 11723, '0', 'bonusrare21_3*5', 'bonusrare21_3*5', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11724, 11724, '0', 'bonusrare21_3*6', 'bonusrare21_3*6', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11725, 11725, '0', 'bonusrare21_4*0', 'bonusrare21_4*0', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11726, 11726, '0', 'bonusrare21_4*1', 'bonusrare21_4*1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11727, 11727, '0', 'bonusrare21_4*2', 'bonusrare21_4*2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11728, 11728, '0', 'bonusrare21_4*3', 'bonusrare21_4*3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11729, 11729, '0', 'bonusrare21_4*4', 'bonusrare21_4*4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11730, 11730, '0', 'bonusrare21_4*5', 'bonusrare21_4*5', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11731, 11731, '0', 'bonusbag21_3', 'bonusbag21_3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(11732, 11732, '0', 'bonusrare21_1a*0', 'bonusrare21_1a*0', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11733, 11733, '0', 'bonusrare21_1a*1', 'bonusrare21_1a*1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11734, 11734, '0', 'bonusrare21_1a*2', 'bonusrare21_1a*2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11735, 11735, '0', 'bonusrare21_1a*3', 'bonusrare21_1a*3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11736, 11736, '0', 'bonusrare21_1a*4', 'bonusrare21_1a*4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11737, 11737, '0', 'bonusrare21_1a*5', 'bonusrare21_1a*5', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11738, 11738, '0', 'bonusbag21_1', 'bonusbag21_1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(11739, 11739, '0', 'bonusbag21_2', 'bonusbag21_2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(11740, 11740, '0', 'clothing_oxset', 'clothing_oxset', 'S', 1, 1, 2.75, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11741, 11741, '0', 'china_goldenox', 'china_goldenox', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11742, 11742, '0', 'china_c21_gong', 'china_c21_gong', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11743, 11743, '0', 'china_c21_vase', 'china_c21_vase', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11744, 11744, '0', 'china_c21_orangebasket', 'china_c21_orangebasket', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'vendingmachine', 2, '38', '', '', 0, 0, ''),
	(11745, 11745, '0', 'rare_r21_coffeesiphon', 'rare_r21_coffeesiphon', 'S', 1, 2, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'vendingmachine', 2, '146', '', '', 0, 0, ''),
	(11746, 11746, '0', 'ltd21_unicornpup', 'ltd21_unicornpup', 'S', 1, 1, 1.00, '0', '0', '0', '0', '0', '1', '0', '0', '0', 'default', 2, '', '', '', 0, 0, ''),
	(11747, 11747, '0', 'hc21_12', 'hc21_12', 'S', 2, 2, 0.00, '0', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11748, 11748, '0', 'hc21_3', 'hc21_3', 'S', 1, 1, 0.10, '0', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11749, 11749, '0', 'hc21_1', 'hc21_1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'vendingmachine', 2, '1096', '', '', 0, 0, ''),
	(11750, 11750, '0', 'hc21_11', 'hc21_11', 'S', 2, 1, 3.10, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'vendingmachine', 2, '3,36,83,100,103,107', '', '', 0, 0, ''),
	(11751, 11751, '0', 'hc21_6', 'hc21_6', 'S', 2, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11752, 11752, '0', 'hc21_4', 'hc21_4', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(11753, 11753, '0', 'hc21_5', 'hc21_5', 'S', 1, 3, 1.25, '0', '0', '1', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11754, 11754, '0', 'hc21_2', 'hc21_2', 'S', 1, 1, 0.20, '0', '0', '0', '1', '1', '1', '1', '1', '1', 'pressureplate', 1, '', '', '', 0, 0, ''),
	(11755, 11755, '0', 'hc21_8', 'hc21_8', 'S', 2, 3, 1.60, '0', '0', '1', '0', '1', '1', '1', '1', '1', 'default', 5, '', '', '', 0, 0, ''),
	(11756, 11756, '0', 'hc21_9', 'hc21_9', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'pressureplate', 2, '', '', '', 0, 0, ''),
	(11757, 11757, '0', 'hc21_10', 'hc21_10', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11758, 11758, '0', 'hc21_7', 'hc21_7', 'S', 1, 1, 0.70, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 5, '', '', '', 0, 0, ''),
	(11759, 11759, '0', 'plushie_r21_kingbear', 'plushie_r21_kingbear', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(11760, 11760, '0', 'diamond_painting62', 'diamond_painting62', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11761, 11761, '0', 'diamond_painting60', 'diamond_painting60', 'S', 1, 1, 2.30, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11762, 11762, '0', 'diamond_painting59', 'diamond_painting59', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11763, 11763, '0', 'diamond_painting54', 'diamond_painting54', 'S', 1, 1, 2.70, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11764, 11764, '0', 'CF_500_egg', 'CF_500_egg', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'credit_furni', 1, '', '', '', 0, 0, ''),
	(11765, 11765, '0', 'CF_750_golddragon', 'CF_750_golddragon', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'credit_furni', 1, '', '', '', 0, 0, ''),
	(11766, 11766, '0', 'CF_350_giantpearl', 'CF_350_giantpearl', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'credit_furni', 1, '', '', '', 0, 0, ''),
	(11767, 11767, '0', 'CF_250_toiletpaper', 'CF_250_toiletpaper', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'credit_furni', 1, '', '', '', 0, 0, ''),
	(11768, 11768, '0', 'garden_r21_wisteriaarch', 'garden_r21_wisteriaarch', 'S', 2, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11769, 11769, '0', 'rare_prize21*0', 'rare_prize21*0', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11770, 11770, '0', 'rare_prize21*1', 'rare_prize21*1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11771, 11771, '0', 'rare_prize21*10', 'rare_prize21*10', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11772, 11772, '0', 'rare_prize21*11', 'rare_prize21*11', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11773, 11773, '0', 'rare_prize21*12', 'rare_prize21*12', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11774, 11774, '0', 'rare_prize21*13', 'rare_prize21*13', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11775, 11775, '0', 'rare_prize21*2', 'rare_prize21*2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11776, 11776, '0', 'rare_prize21*3', 'rare_prize21*3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11777, 11777, '0', 'rare_prize21*4', 'rare_prize21*4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11778, 11778, '0', 'rare_prize21*5', 'rare_prize21*5', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11779, 11779, '0', 'rare_prize21*6', 'rare_prize21*6', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11780, 11780, '0', 'rare_prize21*7', 'rare_prize21*7', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11781, 11781, '0', 'rare_prize21*8', 'rare_prize21*8', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11782, 11782, '0', 'rare_prize21*9', 'rare_prize21*9', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11783, 11783, '0', 'SID_c21_plush', 'SID_c21_plush', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11784, 11784, '0', 'suncity_c21_beehive', 'suncity_c21_beehive', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11785, 11785, '0', 'classic7_c21_neonlights', 'classic7_c21_neonlights', 'S', 1, 2, 3.50, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11786, 11786, '0', 'pastel_c21_accessorykit', 'pastel_c21_accessorykit', 'S', 2, 1, 0.90, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11787, 11787, '0', 'celestial_c21_lamp', 'celestial_c21_lamp', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11788, 11788, '0', 'val_c21_displaycase', 'val_c21_displaycase', 'S', 1, 1, 2.20, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11789, 11789, '0', 'val_r21_narwhalplush', 'val_r21_narwhalplush', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11790, 11790, '0', 'val_c21_flowerwreath', 'val_c21_flowerwreath', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11791, 11791, '0', 'val_r21_bunny', 'val_r21_bunny', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11792, 11792, '0', 'val_c21_plantstand', 'val_c21_plantstand', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11793, 11793, '0', 'clothing_r21_flowerhair', 'clothing_r21_flowerhair', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11794, 11794, '0', 'val_c21_cashier', 'val_c21_cashier', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11795, 11795, '0', 'val_c21_shopsign', 'val_c21_shopsign', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11796, 11796, '0', 'val_r21_clock', 'val_r21_clock', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11797, 11797, '0', 'val_c21_displaybox', 'val_c21_displaybox', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 5, '', '', '', 0, 0, ''),
	(11798, 11798, '0', 'val_c21_parasol', 'val_c21_parasol', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11799, 11799, '0', 'clothing_r21_valcorset', 'clothing_r21_valcorset', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11800, 11800, '0', 'val_c21_vendingmachine', 'val_c21_vendingmachine', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11801, 11801, '0', 'val_c21_bell', 'val_c21_bell', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11802, 11802, '0', 'val_c21_leafmobile', 'val_c21_leafmobile', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11803, 11803, '0', 'fruit_c21_bed', 'fruit_c21_bed', 'S', 1, 3, 1.20, '0', '0', '1', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11804, 11804, '0', 'fruit_c21_cherrylamp', 'fruit_c21_cherrylamp', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11805, 11805, '0', 'fruit_c21_bananachair', 'fruit_c21_bananachair', 'S', 1, 1, 1.50, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11806, 11806, '0', 'fruit_c21_strawbmat', 'fruit_c21_strawbmat', 'S', 2, 2, 0.10, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11807, 11807, '0', 'fruit_c21_avowardrobe', 'fruit_c21_avowardrobe', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11808, 11808, '0', 'clothing_fruitbag', 'clothing_fruitbag', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11809, 11809, '0', 'clothing_r21_dyedbangs', 'clothing_r21_dyedbangs', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11810, 11810, '0', 'fruit_c21_table', 'fruit_c21_table', 'S', 1, 1, 1.31, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11811, 11811, '0', 'fruit_c21_citrussofa', 'fruit_c21_citrussofa', 'S', 2, 1, 1.10, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11812, 11812, '0', 'fruit_c21_clock', 'fruit_c21_clock', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(11813, 11813, '0', 'tokyo_c21_wagashistall', 'tokyo_c21_wagashistall', 'S', 2, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11814, 11814, '0', 'clothing_r21_catbackpack2', 'clothing_r21_catbackpack2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11815, 11815, '0', 'rare_r21_aussiedog', 'rare_r21_aussiedog', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11816, 11816, '0', 'rare_r21_blossomtree', 'rare_r21_blossomtree', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11817, 11817, '0', 'market_c21_toiletroll', 'market_c21_toiletroll', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11818, 11818, '0', 'fest_c21_crystalstall', 'fest_c21_crystalstall', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11819, 11819, '0', 'clothing_camojoggers', 'clothing_camojoggers', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11820, 11820, '0', 'easter_c21_digitalfloor', 'easter_c21_digitalfloor', 'S', 2, 2, 0.20, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11821, 11821, '0', 'clothing_blockcroptop', 'clothing_blockcroptop', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11822, 11822, '0', 'clothing_hiphopsweats', 'clothing_hiphopsweats', 'S', 1, 1, 0.15, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11823, 11823, '0', 'clothing_blockhoodie', 'clothing_blockhoodie', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11824, 11824, '0', 'clothing_darkhoodie', 'clothing_darkhoodie', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11825, 11825, '0', 'clothing_nt_hijab', 'clothing_nt_hijab', 'S', 1, 1, 1.10, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11826, 11826, '0', 'clothing_tiedyejoggers', 'clothing_tiedyejoggers', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11827, 11827, '0', 'clothing_basichoodie', 'clothing_basichoodie', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11828, 11828, '0', 'easter_c21_lightplatform', 'easter_c21_lightplatform', 'S', 1, 1, 0.50, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11829, 11829, '0', 'clothing_patternhoodie', 'clothing_patternhoodie', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11830, 11830, '0', 'clothing_patternjoggers', 'clothing_patternjoggers', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11831, 11831, '0', 'clothing_nt_openshirt', 'clothing_nt_openshirt', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11832, 11832, '0', 'clothing_leathertrousers', 'clothing_leathertrousers', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11833, 11833, '0', 'clothing_leathergloves', 'clothing_leathergloves', 'S', 1, 1, 2.70, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11834, 11834, '0', 'clothing_darkjoggers', 'clothing_darkjoggers', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11835, 11835, '0', 'clothing_middlepart', 'clothing_middlepart', 'S', 1, 1, 1.10, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11836, 11836, '0', 'clothing_aviatorjacket', 'clothing_aviatorjacket', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11837, 11837, '0', 'clothing_nt_eggearrings', 'clothing_nt_eggearrings', 'S', 1, 1, 0.95, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11838, 11838, '0', 'clothing_multibadges', 'clothing_multibadges', 'S', 1, 1, 0.10, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11839, 11839, '0', 'clothing_darkcroptop', 'clothing_darkcroptop', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11840, 11840, '0', 'clothing_croptop', 'clothing_croptop', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11841, 11841, '0', 'clothing_patterncroptop', 'clothing_patterncroptop', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11842, 11842, '0', 'clothing_tiedyehat', 'clothing_tiedyehat', 'S', 1, 1, 1.10, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11843, 11843, '0', 'clothing_camohat', 'clothing_camohat', 'S', 1, 1, 1.10, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11844, 11844, '0', 'easter_r21_pasteldragon', 'easter_r21_pasteldragon', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11845, 11845, '0', 'clothing_offshoulderjumpsuit', 'clothing_offshoulderjumpsuit', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11846, 11846, '0', 'clothing_blockhat', 'clothing_blockhat', 'S', 1, 1, 1.20, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11847, 11847, '0', 'clothing_chestbag', 'clothing_chestbag', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11848, 11848, '0', 'clothing_hijab', 'clothing_hijab', 'S', 1, 1, 1.10, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11849, 11849, '0', 'clothing_patternhat', 'clothing_patternhat', 'S', 1, 1, 0.95, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11850, 11850, '0', 'easter_r21_gianteggbasket', 'easter_r21_gianteggbasket', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11851, 11851, '0', 'clothing_openshirt', 'clothing_openshirt', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11852, 11852, '0', 'easter_c21_digitalwall', 'easter_c21_digitalwall', 'S', 1, 2, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11853, 11853, '0', 'clothing_nt_oxfordshoes', 'clothing_nt_oxfordshoes', 'S', 1, 1, 0.60, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11854, 11854, '0', 'easter_c21_textile', 'easter_c21_textile', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11855, 11855, '0', 'clothing_r21_froghat', 'clothing_r21_froghat', 'S', 1, 1, 1.10, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11856, 11856, '0', 'easter_ltd21_springvibesegg', 'easter_ltd21_springvibesegg', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11857, 11857, '0', 'clothing_basicjoggers', 'clothing_basicjoggers', 'S', 1, 1, 0.15, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11858, 11858, '0', 'clothing_camohoodie', 'clothing_camohoodie', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11859, 11859, '0', 'clothing_holographicskirt', 'clothing_holographicskirt', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11860, 11860, '0', 'clothing_basichat', 'clothing_basichat', 'S', 1, 1, 0.95, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11861, 11861, '0', 'clothing_gothboots', 'clothing_gothboots', 'S', 1, 1, 0.80, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11862, 11862, '0', 'easter_c21_colourfulink', 'easter_c21_colourfulink', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11863, 11863, '0', 'clothing_nutrainers', 'clothing_nutrainers', 'S', 1, 1, 0.35, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11864, 11864, '0', 'clothing_blockjoggers', 'clothing_blockjoggers', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11865, 11865, '0', 'easter_c21_darkink', 'easter_c21_darkink', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11866, 11866, '0', 'clothing_highwaisttrousers', 'clothing_highwaisttrousers', 'S', 1, 1, 0.30, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11867, 11867, '0', 'clothing_oxfordshoes', 'clothing_oxfordshoes', 'S', 1, 1, 0.60, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11868, 11868, '0', 'easter_c21_hanginglight', 'easter_c21_hanginglight', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11869, 11869, '0', 'clothing_camocroptop', 'clothing_camocroptop', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11870, 11870, '0', 'clothing_nt_offshoulderjumpsuit', 'clothing_nt_offshoulderjumpsuit', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11871, 11871, '0', 'clothing_tiedyecroptop', 'clothing_tiedyecroptop', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11872, 11872, '0', 'easter_c21_dyetable', 'easter_c21_dyetable', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '0', '1', '0', '0', 'crafting', 2, '', '', '', 0, 0, ''),
	(11873, 11873, '0', 'clothing_eggearrings', 'clothing_eggearrings', 'S', 1, 1, 0.95, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11874, 11874, '0', 'clothing_tiedyehoodie', 'clothing_tiedyehoodie', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11875, 11875, '0', 'easter_c21_camoink', 'easter_c21_camoink', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11876, 11876, '0', 'clothing_halfcurlyhair', 'clothing_halfcurlyhair', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11877, 11877, '0', 'clothing_grownoutroots', 'clothing_grownoutroots', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11878, 11878, '0', 'clothing_sunsetdress', 'clothing_sunsetdress', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11879, 11879, '0', 'clothing_darkhat', 'clothing_darkhat', 'S', 1, 1, 1.10, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11880, 11880, '0', 'clothing_capecoat', 'clothing_capecoat', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11881, 11881, '0', 'clothing_r21_galaxydress', 'clothing_r21_galaxydress', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11882, 11882, '0', 'ads_dtlrare_gold2', 'ads_dtlrare_gold2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11883, 11883, '0', 'ads_dtlrare_gold', 'ads_dtlrare_gold', 'S', 1, 1, 2.70, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11884, 11884, '0', 'farm_c21_pizzaoven', 'farm_c21_pizzaoven', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11885, 11885, '0', 'rare_colourable_dragonlamp*4', 'rare_colourable_dragonlamp*4', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11886, 11886, '0', 'rainbow_ltd21_fan', 'rainbow_ltd21_fan', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11887, 11887, '0', 'ads_fanta_vendingmachine', 'ads_fanta_vendingmachine', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'vendingmachine', 2, '147', '', '', 0, 0, ''),
	(11888, 11888, '0', 'clothing_r21_tousledwaves', 'clothing_r21_tousledwaves', 'S', 1, 1, 0.95, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11889, 11889, '0', 'animal_r21_gorilla', 'animal_r21_gorilla', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11890, 11890, '0', 'clothing_edwardianblouse', 'clothing_edwardianblouse', 'S', 1, 1, 2.70, '1', '0', '0', '0', '1', '1', '0', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11891, 11891, '1', 'antique_c21_laceparasol', 'antique_c21_laceparasol', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11892, 11892, '1', 'antique_c21_medicinebag', 'antique_c21_medicinebag', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(11893, 11893, '1', 'antique_c21_desk', 'antique_c21_desk', 'S', 3, 1, 1.25, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11894, 11894, '1', 'antique_c21_books', 'antique_c21_books', 'S', 1, 1, 0.90, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(11895, 11895, '1', 'antique_c21_detectiveposter', 'antique_c21_detectiveposter', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11896, 11896, '1', 'antique_c21_oldenrug', 'antique_c21_oldenrug', 'S', 2, 3, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11897, 11897, '1', 'antique_c21_lamp', 'antique_c21_lamp', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11898, 11898, '1', 'antique_c21_magnifyinglass', 'antique_c21_magnifyinglass', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'vendingmachine_no_sides', 2, '148', '', '', 0, 0, ''),
	(11899, 11899, '0', 'antique_r21_curiocabinet', 'antique_r21_curiocabinet', 'S', 1, 2, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11900, 11900, '1', 'antique_c21_doorteleport', 'antique_c21_doorteleport', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '1', '1', '1', 'teleport', 2, '', '', '', 0, 0, ''),
	(11901, 11901, '0', 'clothing_r21_detectiveoutfit', 'clothing_r21_detectiveoutfit', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11902, 11902, '1', 'antique_c21_pennyfarthing', 'antique_c21_pennyfarthing', 'S', 1, 1, 2.45, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11903, 11903, '1', 'antique_c21_teaset', 'antique_c21_teaset', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 5, '', '', '', 0, 0, ''),
	(11904, 11904, '1', 'antique_c21_mysterypie', 'antique_c21_mysterypie', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(11905, 11905, '1', 'antique_c21_wallclock', 'antique_c21_wallclock', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11906, 11906, '1', 'antique_c21_armchair', 'antique_c21_armchair', 'S', 1, 1, 1.20, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11907, 11907, '1', 'antique_c21_birdcage', 'antique_c21_birdcage', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11908, 11908, '1', 'thai_c21_marketstall', 'thai_c21_marketstall', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(11909, 11909, '1', 'thai_c21_candledish', 'thai_c21_candledish', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11910, 11910, '0', 'thai_c21_woodenwardrobe', 'thai_c21_woodenwardrobe', 'S', 1, 2, 3.30, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(11911, 11911, '1', 'thai_c21_buildingpieces', 'thai_c21_buildingpieces', 'S', 2, 1, 4.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 6, '', '', '', 0, 0, ''),
	(11912, 11912, '1', 'thai_c21_bridgewalkway', 'thai_c21_bridgewalkway', 'S', 2, 2, 0.70, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11913, 11913, '1', 'thai_c21_pillow', 'thai_c21_pillow', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11914, 11914, '1', 'thai_c21_waterrock', 'thai_c21_waterrock', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'water_item', 1, '', '', '', 0, 0, ''),
	(11915, 11915, '0', 'clothing_bamboohat', 'clothing_bamboohat', 'S', 1, 1, 1.50, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11916, 11916, '1', 'thai_c21_boat1', 'thai_c21_boat1', 'S', 1, 1, 0.80, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'water_item', 1, '', '', '', 0, 0, ''),
	(11917, 11917, '0', 'clothing_thaisuit', 'clothing_thaisuit', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11918, 11918, '0', 'thai_r21_waterfalltree', 'thai_r21_waterfalltree', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11919, 11919, '1', 'thai_c21_mangrovetree', 'thai_c21_mangrovetree', 'S', 2, 2, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'water_item', 1, '', '', '', 0, 0, ''),
	(11920, 11920, '1', 'thai_c21_strawlamp', 'thai_c21_strawlamp', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11921, 11921, '0', 'clothing_thaihat', 'clothing_thaihat', 'S', 1, 1, 1.20, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11922, 11922, '1', 'thai_c21_roofblock', 'thai_c21_roofblock', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11923, 11923, '0', 'thai_c21_woodenstatue', 'thai_c21_woodenstatue', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11924, 11924, '0', 'thai_c21_woodensofa', 'thai_c21_woodensofa', 'S', 2, 1, 1.30, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11925, 11925, '0', 'thai_r21_clothingboxB', 'thai_r21_clothingboxB', 'S', 1, 1, 0.70, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11926, 11926, '1', 'thai_c21_platform', 'thai_c21_platform', 'S', 2, 2, 0.80, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'water_item', 1, '', '', '', 0, 0, ''),
	(11927, 11927, '1', 'thai_c21_fruits', 'thai_c21_fruits', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(11928, 11928, '1', 'thai_c21_arch', 'thai_c21_arch', 'S', 2, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(11929, 11929, '0', 'thai_ltd21_yakgodstatue', 'thai_ltd21_yakgodstatue', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11930, 11930, '1', 'thai_c21_mangrovecrab', 'thai_c21_mangrovecrab', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(11931, 11931, '0', 'thai_r21_clothingbox', 'thai_r21_clothingbox', 'S', 1, 1, 0.70, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'crackable', 3, '', '', '', 0, 0, ''),
	(11932, 11932, '1', 'thai_c21_divider', 'thai_c21_divider', 'S', 1, 2, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11933, 11933, '0', 'clothing_thaibunhair', 'clothing_thaibunhair', 'S', 1, 1, 0.95, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11934, 11934, '1', 'thai_c21_food', 'thai_c21_food', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(11935, 11935, '1', 'thai_c21_table', 'thai_c21_table', 'S', 2, 1, 1.20, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11936, 11936, '0', 'thai_c21_woodcarvingset', 'thai_c21_woodcarvingset', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'crackable', 4, '', '', '', 0, 0, ''),
	(11937, 11937, '0', 'clothing_thaidress', 'clothing_thaidress', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11938, 11938, '1', 'thai_c21_boat2', 'thai_c21_boat2', 'S', 1, 1, 0.90, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'water_item', 1, '', '', '', 0, 0, ''),
	(11939, 11939, '0', 'clothing_r21_muaythaioutfit', 'clothing_r21_muaythaioutfit', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11940, 11940, '0', 'clothing_r21_pangolin', 'clothing_r21_pangolin', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11941, 11941, '1', 'thai_c21_roof', 'thai_c21_roof', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(11942, 11942, '1', 'thai_c21_indoorstove', 'thai_c21_indoorstove', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(11943, 11943, '1', 'thai_c21_boat3', 'thai_c21_boat3', 'S', 1, 1, 0.40, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'water_item', 1, '', '', '', 0, 0, ''),
	(11944, 11944, '0', 'thai_c21_woodcarvingsetB', 'thai_c21_woodcarvingsetB', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11945, 11945, '0', 'thai_r21_babyele', 'thai_r21_babyele', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11946, 11946, '0', 'thai_c21_woodenendtable', 'thai_c21_woodenendtable', 'S', 1, 1, 1.70, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11947, 11947, '1', 'thai_c21_closetseat', 'thai_c21_closetseat', 'S', 2, 1, 1.50, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11948, 11948, '0', 'clothing_thailei', 'clothing_thailei', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11949, 11949, '1', 'thai_c21_rootedgrass', 'thai_c21_rootedgrass', 'S', 2, 2, 1.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'water_item', 1, '', '', '', 0, 0, ''),
	(11950, 11950, '1', 'thai_c21_crystalwater', 'thai_c21_crystalwater', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'water', 1, '', '', '', 30, 30, ''),
	(11951, 11951, '0', 'clothing_squid2', 'clothing_squid2', 'S', 1, 1, 1.20, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11952, 11952, '0', 'clothing_nt_bamboohat', 'clothing_nt_bamboohat', 'S', 1, 1, 1.50, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11953, 11953, '0', 'clothing_nt_thailei', 'clothing_nt_thailei', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11954, 11954, '0', 'trading_table', 'trading_table', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11955, 11955, '0', 'tile_cursor', 'tile_cursor', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'tile_cursor', 1, '', '', '', 0, 0, ''),
	(11956, 11956, '0', 'clothing_r21_kimono3', 'clothing_r21_kimono3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11957, 11957, '0', 'rainbow_c21_prideflags', 'rainbow_c21_prideflags', 'S', 2, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 7, '', '', '', 0, 0, ''),
	(11958, 11958, '0', 'rainbow_c21_crackable2', 'rainbow_c21_crackable2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(11959, 11959, '0', 'rainbow_c21_bunting', 'rainbow_c21_bunting', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11960, 11960, '0', 'rainbow_c21_crackable1', 'rainbow_c21_crackable1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(11961, 11961, '0', 'rainbow_ltd21_rainbowboa', 'rainbow_ltd21_rainbowboa', 'S', 1, 1, 0.40, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11962, 11962, '0', 'rainbow_c21_balloonarch', 'rainbow_c21_balloonarch', 'S', 1, 2, 0.00, '0', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11963, 11963, '0', 'clothing_r21_beachywaves', 'clothing_r21_beachywaves', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11964, 11964, '0', 'rainbow_c21_crackable1A', 'rainbow_c21_crackable1A', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11965, 11965, '0', 'clothing_pridehoodie', 'clothing_pridehoodie', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11966, 11966, '0', 'clothing_r21_holojacket', 'clothing_r21_holojacket', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11967, 11967, '0', 'clothing_rainbowwings', 'clothing_rainbowwings', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11968, 11968, '0', 'clothing_rainbowundercut', 'clothing_rainbowundercut', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11969, 11969, '0', 'clothing_pridecape', 'clothing_pridecape', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11970, 11970, '0', 'rainbow_c21_rainbowroad', 'rainbow_c21_rainbowroad', 'S', 2, 2, 0.10, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(11971, 11971, '0', 'rainbow_c21_lightbulbheart', 'rainbow_c21_lightbulbheart', 'S', 1, 2, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11972, 11972, '0', 'rainbow_c21_crackable2A', 'rainbow_c21_crackable2A', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11973, 11973, '0', 'garden_r21_rosebench', 'garden_r21_rosebench', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11974, 11974, '0', 'garden_r21_plantwall', 'garden_r21_plantwall', 'S', 1, 2, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11975, 11975, '0', 'vwave_c21_glitchbuildings', 'vwave_c21_glitchbuildings', 'S', 1, 2, 4.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(11976, 11976, '1', 'vwave_c21_neonsigns', 'vwave_c21_neonsigns', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 14, '', '', '', 0, 0, ''),
	(11977, 11977, '1', 'vwave_c21_brokentech', 'vwave_c21_brokentech', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(11978, 11978, '1', 'vwave_c21_cctv', 'vwave_c21_cctv', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(11979, 11979, '0', 'vwave_c21_glitchrailcrnr', 'vwave_c21_glitchrailcrnr', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(11980, 11980, '1', 'vwave_c21_barstool', 'vwave_c21_barstool', 'S', 1, 1, 1.30, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11981, 11981, '0', 'clothing_bubblegum', 'clothing_bubblegum', 'S', 1, 1, 0.95, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11982, 11982, '1', 'vwave_c21_buildings', 'vwave_c21_buildings', 'S', 1, 2, 3.90, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(11983, 11983, '1', 'vwave_c21_railcrnr', 'vwave_c21_railcrnr', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11984, 11984, '0', 'vwave_c21_glitchrailing', 'vwave_c21_glitchrailing', 'S', 2, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(11985, 11985, '0', 'clothing_toughface', 'clothing_toughface', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11986, 11986, '1', 'vwave_c21_wall', 'vwave_c21_wall', 'S', 1, 2, 3.95, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(11987, 11987, '1', 'vwave_c21_bench', 'vwave_c21_bench', 'S', 2, 1, 1.10, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11988, 11988, '0', 'clothing_gemglasses', 'clothing_gemglasses', 'S', 1, 1, 0.95, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11989, 11989, '0', 'vwave_c21_glitchpalm', 'vwave_c21_glitchpalm', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11990, 11990, '1', 'vwave_c21_dumpster', 'vwave_c21_dumpster', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'pressureplate', 1, '', '', '', 0, 0, ''),
	(11991, 11991, '1', 'vwave_c21_planter', 'vwave_c21_planter', 'S', 1, 2, 0.98, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11992, 11992, '1', 'vwave_c21_trash', 'vwave_c21_trash', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(11993, 11993, '0', 'vwave_c21_glitchbench', 'vwave_c21_glitchbench', 'S', 2, 1, 1.10, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11994, 11994, '1', 'vwave_c21_pavement', 'vwave_c21_pavement', 'S', 2, 2, 0.10, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11995, 11995, '0', 'vwave_r21_motorbike', 'vwave_r21_motorbike', 'S', 1, 2, 1.50, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(11996, 11996, '0', 'clothing_retroshirt', 'clothing_retroshirt', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11997, 11997, '0', 'clothing_daffyfunkhelmet', 'clothing_daffyfunkhelmet', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(11998, 11998, '0', 'vwave_c21_glitchnightsand', 'vwave_c21_glitchnightsand', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(11999, 11999, '0', 'vwave_c21_rubiks', 'vwave_c21_rubiks', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12000, 12000, '0', 'vwave_c21_glitchwall', 'vwave_c21_glitchwall', 'S', 1, 2, 4.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(12001, 12001, '1', 'vwave_c21_mocktails', 'vwave_c21_mocktails', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 5, '', '', '', 0, 0, ''),
	(12002, 12002, '1', 'vwave_c21_motelfront', 'vwave_c21_motelfront', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12003, 12003, '0', 'clothing_r21_rollerskates', 'clothing_r21_rollerskates', 'S', 1, 1, 0.40, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(12004, 12004, '0', 'clothing_retrosuit', 'clothing_retrosuit', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(12005, 12005, '1', 'vwave_c21_motelrooms', 'vwave_c21_motelrooms', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(12006, 12006, '0', 'vwave_c21_floppydisk', 'vwave_c21_floppydisk', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12007, 12007, '1', 'vwave_c21_nightclub', 'vwave_c21_nightclub', 'S', 1, 2, 7.95, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 7, '', '', '', 0, 0, ''),
	(12008, 12008, '1', 'vwave_c21_parkingmeter', 'vwave_c21_parkingmeter', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 7, '', '', '', 0, 0, ''),
	(12009, 12009, '0', 'vwave_c21_glitchplanter', 'vwave_c21_glitchplanter', 'S', 1, 2, 0.98, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12010, 12010, '1', 'vwave_c21_railing', 'vwave_c21_railing', 'S', 2, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12011, 12011, '1', 'vwave_c21_barglasses', 'vwave_c21_barglasses', 'S', 1, 2, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'vendingmachine_no_sides', 2, '35,40,50,47,101', '', '', 0, 0, ''),
	(12012, 12012, '0', 'clothing_holographicdress', 'clothing_holographicdress', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(12013, 12013, '0', 'clothing_volumehair', 'clothing_volumehair', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(12014, 12014, '0', 'clothing_r21_polaroid', 'clothing_r21_polaroid', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(12015, 12015, '0', 'vwave_ltd21_lambo', 'vwave_ltd21_lambo', 'S', 2, 3, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 6, '', '', '', 0, 0, ''),
	(12016, 12016, '0', 'clothing_retromakeup', 'clothing_retromakeup', 'S', 1, 1, 0.95, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(12017, 12017, '1', 'vwave_c21_streetlight', 'vwave_c21_streetlight', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(12018, 12018, '0', 'vwave_r21_jukebox', 'vwave_r21_jukebox', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'fx_box', 3, '', '', '', 0, 0, ''),
	(12019, 12019, '0', 'vwave_c21_pc', 'vwave_c21_pc', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '0', '1', '0', '0', 'crafting', 3, '', '', '', 0, 0, ''),
	(12020, 12020, '1', 'vwave_c21_bartable', 'vwave_c21_bartable', 'S', 1, 2, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(12021, 12021, '0', 'vwave_c21_glitchpavement', 'vwave_c21_glitchpavement', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12022, 12022, '1', 'vwave_c21_frenchbulldog', 'vwave_c21_frenchbulldog', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(12023, 12023, '1', 'vwave_c21_posters', 'vwave_c21_posters', 'S', 1, 2, 0.00, '0', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 8, '', '', '', 0, 0, ''),
	(12024, 12024, '1', 'vwave_c21_nightsand', 'vwave_c21_nightsand', 'S', 2, 2, 0.20, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12025, 12025, '1', 'vwave_c21_drinkshelf', 'vwave_c21_drinkshelf', 'S', 1, 2, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(12026, 12026, '1', 'vwave_c21_palm', 'vwave_c21_palm', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12027, 12027, '0', 'clothing_modernmullet', 'clothing_modernmullet', 'S', 1, 1, 1.10, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(12028, 12028, '0', 'vwave_c21_glitchstreetlight', 'vwave_c21_glitchstreetlight', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(12029, 12029, '0', 'clothing_darkcrown', 'clothing_darkcrown', 'S', 1, 1, 1.20, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(12030, 12030, '0', 'clothing_r21_fairyhair', 'clothing_r21_fairyhair', 'S', 1, 1, 1.10, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(12031, 12031, '0', 'clothing_petalhat', 'clothing_petalhat', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(12032, 12032, '0', 'mushroom_c21_shelves', 'mushroom_c21_shelves', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(12033, 12033, '0', 'mushroom_ltd21_fairy', 'mushroom_ltd21_fairy', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12034, 12034, '0', 'mushroom_c21_crackable', 'mushroom_c21_crackable', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(12035, 12035, '0', 'clothing_mushroom2', 'clothing_mushroom2', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(12036, 12036, '0', 'mushroom_c21_chair', 'mushroom_c21_chair', 'S', 1, 1, 1.40, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(12037, 12037, '0', 'mushroom_r21_teapot', 'mushroom_r21_teapot', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12038, 12038, '0', 'mushroom_c21_archway', 'mushroom_c21_archway', 'S', 1, 2, 0.00, '0', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(12039, 12039, '0', 'clothing_r21_fairywings', 'clothing_r21_fairywings', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(12040, 12040, '0', 'clothing_flowerdress', 'clothing_flowerdress', 'S', 1, 1, 2.70, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(12041, 12041, '0', 'mushroom_c21_drawers', 'mushroom_c21_drawers', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(12042, 12042, '0', 'mushroom_r21_magicmirror', 'mushroom_r21_magicmirror', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(12043, 12043, '0', 'mushroom_c21_bouncymushroom', 'mushroom_c21_bouncymushroom', 'S', 1, 1, 1.10, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'pressureplate', 1, '', '', '', 193, 193, ''),
	(12044, 12044, '0', 'mushroom_c21_table', 'mushroom_c21_table', 'S', 2, 2, 1.30, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(12045, 12045, '0', 'mushroom_c21_crackableB', 'mushroom_c21_crackableB', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12046, 12046, '0', 'mushroom_c21_bigmushroom', 'mushroom_c21_bigmushroom', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(12047, 12047, '0', 'clothing_diaicetiara', 'clothing_diaicetiara', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(12048, 12048, '0', 'diamond_c21_giftbox', 'diamond_c21_giftbox', 'S', 1, 1, 1.20, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(12049, 12049, '0', 'clothing_diahermeshat', 'clothing_diahermeshat', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(12050, 12050, '0', 'diamond_c21_giftbox2', 'diamond_c21_giftbox2', 'S', 1, 1, 1.20, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12051, 12051, '0', 'clothing_diaelegantcrown', 'clothing_diaelegantcrown', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(12052, 12052, '0', 'hween_c21_purificationscroll', 'hween_c21_purificationscroll', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12053, 12053, '0', 'hween_c21_stonefloor', 'hween_c21_stonefloor', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(12054, 12054, '0', 'hween_r21_goldenflowerscreen', 'hween_r21_goldenflowerscreen', 'S', 1, 3, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(12055, 12055, '0', 'hween_c21_tatami', 'hween_c21_tatami', 'S', 2, 2, 0.10, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 6, '', '', '', 0, 0, ''),
	(12056, 12056, '0', 'clothing_nt_ghostheadband', 'clothing_nt_ghostheadband', 'S', 1, 1, 0.95, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(12057, 12057, '0', 'hween_c21_biwa', 'hween_c21_biwa', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12058, 12058, '0', 'hween_c21_torii', 'hween_c21_torii', 'S', 2, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(12059, 12059, '0', 'hween_c21_chair', 'hween_c21_chair', 'S', 1, 1, 0.70, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12060, 12060, '0', 'hween_c21_raindoll', 'hween_c21_raindoll', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(12061, 12061, '0', 'clothing_spiritfire', 'clothing_spiritfire', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(12062, 12062, '0', 'hween_c21_kitsune', 'hween_c21_kitsune', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12063, 12063, '0', 'hween_c21_shojislidingdoor', 'hween_c21_shojislidingdoor', 'S', 2, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 6, '', '', '', 0, 0, ''),
	(12064, 12064, '0', 'hween_c21_indoorshrine', 'hween_c21_indoorshrine', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12065, 12065, '0', 'clothing_ghosthair', 'clothing_ghosthair', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(12066, 12066, '0', 'hween_c21_parasol', 'hween_c21_parasol', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(12067, 12067, '0', 'hween_c21_shadownekomata', 'hween_c21_shadownekomata', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12068, 12068, '0', 'hween_c21_shojislidingdoor2', 'hween_c21_shojislidingdoor2', 'S', 2, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(12069, 12069, '0', 'clothing_r21_ninjaoutfit', 'clothing_r21_ninjaoutfit', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(12070, 12070, '0', 'clothing_nt_ghosthair', 'clothing_nt_ghosthair', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(12071, 12071, '0', 'clothing_nt_spiritfire', 'clothing_nt_spiritfire', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(12072, 12072, '0', 'hween_c21_spiderlily', 'hween_c21_spiderlily', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(12073, 12073, '0', 'hween_c21_giantbamboo', 'hween_c21_giantbamboo', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 5, '', '', '', 0, 0, ''),
	(12074, 12074, '0', 'hween_c21_matchabowl', 'hween_c21_matchabowl', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(12075, 12075, '0', 'hween_c21_scrollaltar', 'hween_c21_scrollaltar', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '0', '1', '0', '0', 'crafting', 3, '', '', '', 0, 0, ''),
	(12076, 12076, '0', 'hween_c21_shadowkappa', 'hween_c21_shadowkappa', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12077, 12077, '0', 'hween_c21_futon', 'hween_c21_futon', 'S', 1, 3, 0.90, '0', '0', '1', '0', '1', '1', '1', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(12078, 12078, '0', 'hween_c21_stonetrap', 'hween_c21_stonetrap', 'S', 1, 1, 0.10, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12079, 12079, '0', 'hween_c21_kotatsu', 'hween_c21_kotatsu', 'S', 2, 2, 1.10, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12080, 12080, '0', 'hween_c21_kappa', 'hween_c21_kappa', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12081, 12081, '0', 'hween_c21_gravestone', 'hween_c21_gravestone', 'S', 1, 1, 1.55, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(12082, 12082, '0', 'hween_c21_kitsunestatue', 'hween_c21_kitsunestatue', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12083, 12083, '0', 'hween_c21_nekomata', 'hween_c21_nekomata', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12084, 12084, '0', 'hween_c21_magatama', 'hween_c21_magatama', 'S', 1, 1, 0.10, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(12085, 12085, '0', 'clothing_ghostheadband', 'clothing_ghostheadband', 'S', 1, 1, 0.95, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(12086, 12086, '0', 'hween_c21_lantern', 'hween_c21_lantern', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(12087, 12087, '0', 'hween_c21_doll', 'hween_c21_doll', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(12088, 12088, '0', 'hween_c21_platform', 'hween_c21_platform', 'S', 2, 2, 0.80, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(12089, 12089, '0', 'hween_c21_natto', 'hween_c21_natto', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(12090, 12090, '0', 'hween_c21_tatamiplatform', 'hween_c21_tatamiplatform', 'S', 2, 2, 0.90, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 10, '', '', '', 0, 0, ''),
	(12091, 12091, '0', 'hween_c21_shojiwall', 'hween_c21_shojiwall', 'S', 2, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(12092, 12092, '0', 'hween_r21_mirror', 'hween_r21_mirror', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(12093, 12093, '0', 'hween_c21_onitriomask', 'hween_c21_onitriomask', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(12094, 12094, '0', 'hween_c21_kappapond', 'hween_c21_kappapond', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(12095, 12095, '0', 'hween_c21_shadowoni', 'hween_c21_shadowoni', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12096, 12096, '0', 'hween_c21_wallset', 'hween_c21_wallset', 'S', 2, 1, 4.60, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 5, '', '', '', 0, 0, ''),
	(12097, 12097, '0', 'hween_c21_shadowkitsune', 'hween_c21_shadowkitsune', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12098, 12098, '0', 'hween_c21_pillarcorners', 'hween_c21_pillarcorners', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12099, 12099, '0', 'hween_c21_oni', 'hween_c21_oni', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(12100, 12100, '0', 'clothing_r21_himehair', 'clothing_r21_himehair', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(12101, 12101, '0', 'hween_c21_sushi', 'hween_c21_sushi', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(12102, 12102, '0', 'hween_ltd21_pagoda', 'hween_ltd21_pagoda', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12103, 12103, '0', 'tile_stackmagic6x6', 'tile_stackmagic6x6', 'S', 6, 6, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'stack_helper', 1, '', '', '', 0, 0, ''),
	(12104, 12104, '0', 'tile_stackmagic4x4', 'tile_stackmagic4x4', 'S', 4, 4, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'stack_helper', 1, '', '', '', 0, 0, ''),
	(12105, 12105, '0', 'tile_stackmagic8x8', 'tile_stackmagic8x8', 'S', 8, 8, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'stack_helper', 1, '', '', '', 0, 0, ''),
	(12106, 12106, '0', 'rare_colourable_parasol*6', 'rare_colourable_parasol*6', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12107, 12107, '0', 'rare_colourable_elephant_statue*4', 'rare_colourable_elephant_statue*4', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12108, 12108, '0', 'rare_colourable_fan*4', 'rare_colourable_fan*4', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12109, 12109, '0', 'rainbow_ltd21_dragonlamp', 'rainbow_ltd21_dragonlamp', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(12110, 12110, '0', 'icecream_c21_wall', 'icecream_c21_wall', 'S', 2, 1, 4.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12111, 12111, '0', 'icecream_c21_floor', 'icecream_c21_floor', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12112, 12112, '0', 'icecream_c21_chairpurple', 'icecream_c21_chairpurple', 'S', 1, 1, 1.30, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12113, 12113, '0', 'icecream_c21_light', 'icecream_c21_light', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(12114, 12114, '0', 'icecream_c21_stool', 'icecream_c21_stool', 'S', 1, 1, 1.60, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12115, 12115, '0', 'icecream_c21_glasstable', 'icecream_c21_glasstable', 'S', 2, 2, 1.20, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12116, 12116, '0', 'icecream_c21_chairorange', 'icecream_c21_chairorange', 'S', 1, 1, 1.30, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12117, 12117, '0', 'icecream_c21_sundaes', 'icecream_c21_sundaes', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(12118, 12118, '0', 'icecream_c21_display', 'icecream_c21_display', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(12119, 12119, '0', 'icecream_c21_menu', 'icecream_c21_menu', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12120, 12120, '0', 'icecream_c21_machine', 'icecream_c21_machine', 'S', 1, 1, 1.35, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'vendingmachine', 2, '4,75,76,77', '', '', 0, 0, ''),
	(12121, 12121, '0', 'icecream_c21_counter', 'icecream_c21_counter', 'S', 2, 1, 1.10, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12122, 12122, '0', 'icecream_c21_bartable', 'icecream_c21_bartable', 'S', 2, 1, 1.50, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12123, 12123, '0', 'clothing_conehat', 'clothing_conehat', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(12124, 12124, '0', 'bubblejuice_c21_window', 'bubblejuice_c21_window', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12125, 12125, '0', 'bubblejuice_c21_barrel', 'bubblejuice_c21_barrel', 'S', 1, 1, 1.65, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(12126, 12126, '0', 'bubblejuice_c21_citrus', 'bubblejuice_c21_citrus', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12127, 12127, '0', 'bubblejuice_c21_crackable2', 'bubblejuice_c21_crackable2', 'S', 1, 1, 1.10, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(12128, 12128, '0', 'bubblejuice_c21_hops', 'bubblejuice_c21_hops', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12129, 12129, '0', 'bubblejuice_c21_light', 'bubblejuice_c21_light', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12130, 12130, '0', 'bubblejuice_c21_sofa', 'bubblejuice_c21_sofa', 'S', 2, 1, 1.20, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12131, 12131, '0', 'bubblejuice_c21_drinks', 'bubblejuice_c21_drinks', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 5, '', '', '', 0, 0, ''),
	(12132, 12132, '0', 'bubblejuice_c21_crackable1', 'bubblejuice_c21_crackable1', 'S', 1, 1, 1.10, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(12133, 12133, '0', 'bubblejuice_r21_juicedispenser', 'bubblejuice_r21_juicedispenser', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'vendingmachine', 2, '19,30,66,114', '', '', 0, 0, ''),
	(12134, 12134, '0', 'bubblejuice_c21_dartboard', 'bubblejuice_c21_dartboard', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 6, '', '', '', 0, 0, ''),
	(12135, 12135, '0', 'clothing_limehead', 'clothing_limehead', 'S', 1, 1, 1.20, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(12136, 12136, '0', 'bubblejuice_c21_barley', 'bubblejuice_c21_barley', 'S', 1, 1, 0.10, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12137, 12137, '0', 'bubblejuice_c21_crackable1b', 'bubblejuice_c21_crackable1b', 'S', 1, 1, 1.10, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(12138, 12138, '0', 'bubblejuice_c21_stool', 'bubblejuice_c21_stool', 'S', 1, 1, 1.30, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12139, 12139, '0', 'clothing_r21_milkmaidbraid', 'clothing_r21_milkmaidbraid', 'S', 1, 1, 1.10, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(12140, 12140, '0', 'clothing_r21_cosydungarees', 'clothing_r21_cosydungarees', 'S', 1, 1, 2.70, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(12141, 12141, '0', 'bubblejuice_c21_crackable2b', 'bubblejuice_c21_crackable2b', 'S', 1, 1, 1.10, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(12142, 12142, '0', 'bubblejuice_c21_table', 'bubblejuice_c21_table', 'S', 2, 2, 1.50, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12143, 12143, '0', 'bubblejuice_c21_wall', 'bubblejuice_c21_wall', 'S', 2, 1, 4.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 5, '', '', '', 0, 0, ''),
	(12144, 12144, '0', 'bubblejuice_c21_bar', 'bubblejuice_c21_bar', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12145, 12145, '0', 'bubblejuice_c21_floor', 'bubblejuice_c21_floor', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(12146, 12146, '0', 'bubblejuice_c21_chair', 'bubblejuice_c21_chair', 'S', 1, 1, 1.40, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12147, 12147, '0', 'bubblejuice_c21_secretingredient', 'bubblejuice_c21_secretingredient', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12148, 12148, '0', 'clothing_drinkhat', 'clothing_drinkhat', 'S', 1, 1, 1.20, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(12149, 12149, '0', 'bubblejuice_c21_sideboard', 'bubblejuice_c21_sideboard', 'S', 1, 2, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(12150, 12150, '0', 'clothing_catbeanie', 'clothing_catbeanie', 'S', 1, 1, 1.10, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(12151, 12151, '0', 'bubblejuice_c21_neonsign', 'bubblejuice_c21_neonsign', 'S', 3, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(12152, 12152, '0', 'bubblejuice_r21_fireplace', 'bubblejuice_r21_fireplace', 'S', 2, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(12153, 12153, '0', 'bubblejuice_c21_tableplant', 'bubblejuice_c21_tableplant', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(12154, 12154, '0', 'bubblejuice_c21_dominoes', 'bubblejuice_c21_dominoes', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(12155, 12155, '0', 'bubblejuice_c21_magicbrewer', 'bubblejuice_c21_magicbrewer', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '0', '1', '0', '0', 'crafting', 1, '', '', '', 0, 0, ''),
	(12156, 12156, '0', 'xmas_c21_trainplatform', 'xmas_c21_trainplatform', 'S', 2, 2, 2.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(12157, 12157, '0', 'xmas_c21_afternoontea', 'xmas_c21_afternoontea', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 6, '', '', '', 0, 0, ''),
	(12158, 12158, '0', 'xmas_c21_royalbird', 'xmas_c21_royalbird', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12159, 12159, '0', 'clothing_earringbauble', 'clothing_earringbauble', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(12160, 12160, '0', 'xmas_c21_readingitems', 'xmas_c21_readingitems', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(12161, 12161, '0', 'clothing_pearlnecklace', 'clothing_pearlnecklace', 'S', 1, 1, 0.20, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(12162, 12162, '0', 'xmas_c21_key4', 'xmas_c21_key4', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12163, 12163, '0', 'xmas_c21_advent5', 'xmas_c21_advent5', 'S', 2, 2, 0.10, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12164, 12164, '0', 'xmas_c21_tiffanylamp', 'xmas_c21_tiffanylamp', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(12165, 12165, '0', 'clothing_conductoroutfit', 'clothing_conductoroutfit', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(12166, 12166, '0', 'xmas_c21_key1', 'xmas_c21_key1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12167, 12167, '0', 'xmas_c21_trainroofedge', 'xmas_c21_trainroofedge', 'S', 2, 1, 1.30, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12168, 12168, '0', 'xmas_c21_wallposters', 'xmas_c21_wallposters', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(12169, 12169, '0', 'xmas_c21_governesstable', 'xmas_c21_governesstable', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(12170, 12170, '0', 'clothing_salesoutfit', 'clothing_salesoutfit', 'S', 1, 1, 2.80, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(12171, 12171, '0', 'xmas_c21_advent2', 'xmas_c21_advent2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12172, 12172, '0', 'clothing_governessoutfit', 'clothing_governessoutfit', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(12173, 12173, '0', 'xmas_c21_trainwall', 'xmas_c21_trainwall', 'S', 2, 1, 4.10, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 10, '', '', '', 0, 0, ''),
	(12174, 12174, '0', 'xmas_c21_traintable', 'xmas_c21_traintable', 'S', 1, 1, 1.40, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(12175, 12175, '0', 'xmas_r21_rideabletrain', 'xmas_r21_rideabletrain', 'S', 1, 2, 2.20, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12176, 12176, '0', 'xmas_c21_trainsignal', 'xmas_c21_trainsignal', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(12177, 12177, '0', 'xmas_c21_luggage', 'xmas_c21_luggage', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '0', '1', '0', '0', 'crafting', 1, '', '', '', 0, 0, ''),
	(12178, 12178, '0', 'xmas_c21_teleport', 'xmas_c21_teleport', 'S', 1, 1, 0.00, '0', '0', '0', '1', '1', '1', '1', '1', '1', 'teleport', 2, '', '', '', 0, 0, ''),
	(12179, 12179, '0', 'xmas_c21_doctorscabinet', 'xmas_c21_doctorscabinet', 'S', 1, 1, 1.80, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(12180, 12180, '0', 'xmas_c21_map6', 'xmas_c21_map6', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12181, 12181, '0', 'xmas_c21_trainbase', 'xmas_c21_trainbase', 'S', 2, 2, 1.50, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 6, '', '', '', 0, 0, ''),
	(12182, 12182, '0', 'xmas_c21_trainroof', 'xmas_c21_trainroof', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(12183, 12183, '0', 'xmas_c21_lockpick', 'xmas_c21_lockpick', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12184, 12184, '0', 'xmas_c21_xmasdecor', 'xmas_c21_xmasdecor', 'S', 1, 2, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12185, 12185, '0', 'clothing_r21_warmoversizedcoat', 'clothing_r21_warmoversizedcoat', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(12186, 12186, '0', 'xmas_c21_key3', 'xmas_c21_key3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12187, 12187, '0', 'clothing_nt_pearlnecklace', 'clothing_nt_pearlnecklace', 'S', 1, 1, 0.20, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(12188, 12188, '0', 'xmas_c21_minitrain', 'xmas_c21_minitrain', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12189, 12189, '0', 'clothing_hollyhairpin', 'clothing_hollyhairpin', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(12190, 12190, '0', 'xmas_c21_advent4', 'xmas_c21_advent4', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12191, 12191, '0', 'xmas_c21_advent1', 'xmas_c21_advent1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12192, 12192, '0', 'xmas_c21_advent3', 'xmas_c21_advent3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12193, 12193, '0', 'xmas_c21_map4', 'xmas_c21_map4', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12194, 12194, '0', 'xmas_c21_advent6', 'xmas_c21_advent6', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12195, 12195, '0', 'xmas_c21_key2', 'xmas_c21_key2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12196, 12196, '0', 'xmas_c21_glassroofpillar', 'xmas_c21_glassroofpillar', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 5, '', '', '', 0, 0, ''),
	(12197, 12197, '0', 'xmas_c21_minivase', 'xmas_c21_minivase', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 6, '', '', '', 0, 0, ''),
	(12198, 12198, '0', 'xmas_c21_trainwallcnr', 'xmas_c21_trainwallcnr', 'S', 2, 1, 4.10, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(12199, 12199, '0', 'xmas_c21_map2', 'xmas_c21_map2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12200, 12200, '0', 'xmas_c21_salesmancase', 'xmas_c21_salesmancase', 'S', 1, 1, 0.40, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(12201, 12201, '0', 'xmas_c21_map3', 'xmas_c21_map3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12202, 12202, '0', 'xmas_c21_velvetseat', 'xmas_c21_velvetseat', 'S', 1, 1, 1.40, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12203, 12203, '0', 'xmas_c21_crackableletter', 'xmas_c21_crackableletter', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(12204, 12204, '0', 'xmas_c21_trainroofedgecnr', 'xmas_c21_trainroofedgecnr', 'S', 2, 1, 1.30, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(12205, 12205, '0', 'xmas_c21_advent8', 'xmas_c21_advent8', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(12206, 12206, '0', 'clothing_doctorsoutfit', 'clothing_doctorsoutfit', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(12207, 12207, '0', 'xmas_c21_advent7', 'xmas_c21_advent7', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'vendingmachine_no_sides', 2, '1081', '', '', 0, 0, ''),
	(12208, 12208, '0', 'xmas_r21_luxuryhotchocolate', 'xmas_r21_luxuryhotchocolate', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'vendingmachine', 2, '149', '', '', 0, 0, ''),
	(12209, 12209, '0', 'xmas_c21_traveldocuments', 'xmas_c21_traveldocuments', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(12210, 12210, '0', 'xmas_c21_map1', 'xmas_c21_map1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12211, 12211, '0', 'clothing_nobleoutfit', 'clothing_nobleoutfit', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(12212, 12212, '0', 'clothing_r21_trainoutfit', 'clothing_r21_trainoutfit', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(12213, 12213, '0', 'xmas_ltd21_artdecoegg', 'xmas_ltd21_artdecoegg', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(12214, 12214, '0', 'xmas_c21_key5', 'xmas_c21_key5', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12215, 12215, '0', 'xmas_c21_map5', 'xmas_c21_map5', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12216, 12216, '1', 'bc_curvedramp*1', 'bc_curvedramp*1', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12217, 12217, '1', 'bc_curvedramp*10', 'bc_curvedramp*10', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12218, 12218, '1', 'bc_curvedramp*11', 'bc_curvedramp*11', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12219, 12219, '1', 'bc_curvedramp*12', 'bc_curvedramp*12', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12220, 12220, '1', 'bc_curvedramp*13', 'bc_curvedramp*13', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12221, 12221, '1', 'bc_curvedramp*14', 'bc_curvedramp*14', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12222, 12222, '1', 'bc_curvedramp*15', 'bc_curvedramp*15', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12223, 12223, '1', 'bc_curvedramp*16', 'bc_curvedramp*16', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12224, 12224, '1', 'bc_curvedramp*17', 'bc_curvedramp*17', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12225, 12225, '1', 'bc_curvedramp*18', 'bc_curvedramp*18', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12226, 12226, '1', 'bc_curvedramp*19', 'bc_curvedramp*19', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12227, 12227, '1', 'bc_curvedramp*2', 'bc_curvedramp*2', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12228, 12228, '1', 'bc_curvedramp*20', 'bc_curvedramp*20', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12229, 12229, '1', 'bc_curvedramp*21', 'bc_curvedramp*21', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12230, 12230, '1', 'bc_curvedramp*22', 'bc_curvedramp*22', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12231, 12231, '1', 'bc_curvedramp*23', 'bc_curvedramp*23', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12232, 12232, '1', 'bc_curvedramp*24', 'bc_curvedramp*24', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12233, 12233, '1', 'bc_curvedramp*25', 'bc_curvedramp*25', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12234, 12234, '1', 'bc_curvedramp*26', 'bc_curvedramp*26', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12235, 12235, '1', 'bc_curvedramp*27', 'bc_curvedramp*27', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12236, 12236, '1', 'bc_curvedramp*28', 'bc_curvedramp*28', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12237, 12237, '1', 'bc_curvedramp*29', 'bc_curvedramp*29', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12238, 12238, '1', 'bc_curvedramp*3', 'bc_curvedramp*3', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12239, 12239, '1', 'bc_curvedramp*30', 'bc_curvedramp*30', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12240, 12240, '1', 'bc_curvedramp*31', 'bc_curvedramp*31', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12241, 12241, '1', 'bc_curvedramp*32', 'bc_curvedramp*32', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12242, 12242, '1', 'bc_curvedramp*33', 'bc_curvedramp*33', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12243, 12243, '1', 'bc_curvedramp*34', 'bc_curvedramp*34', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12244, 12244, '1', 'bc_curvedramp*35', 'bc_curvedramp*35', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12245, 12245, '1', 'bc_curvedramp*36', 'bc_curvedramp*36', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12246, 12246, '1', 'bc_curvedramp*37', 'bc_curvedramp*37', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12247, 12247, '1', 'bc_curvedramp*38', 'bc_curvedramp*38', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12248, 12248, '1', 'bc_curvedramp*39', 'bc_curvedramp*39', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12249, 12249, '1', 'bc_curvedramp*4', 'bc_curvedramp*4', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12250, 12250, '1', 'bc_curvedramp*40', 'bc_curvedramp*40', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12251, 12251, '1', 'bc_curvedramp*41', 'bc_curvedramp*41', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12252, 12252, '1', 'bc_curvedramp*42', 'bc_curvedramp*42', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12253, 12253, '1', 'bc_curvedramp*43', 'bc_curvedramp*43', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12254, 12254, '1', 'bc_curvedramp*44', 'bc_curvedramp*44', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12255, 12255, '1', 'bc_curvedramp*45', 'bc_curvedramp*45', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12256, 12256, '1', 'bc_curvedramp*46', 'bc_curvedramp*46', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12257, 12257, '1', 'bc_curvedramp*47', 'bc_curvedramp*47', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12258, 12258, '1', 'bc_curvedramp*48', 'bc_curvedramp*48', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12259, 12259, '1', 'bc_curvedramp*49', 'bc_curvedramp*49', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12260, 12260, '1', 'bc_curvedramp*5', 'bc_curvedramp*5', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12261, 12261, '1', 'bc_curvedramp*50', 'bc_curvedramp*50', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12262, 12262, '1', 'bc_curvedramp*51', 'bc_curvedramp*51', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12263, 12263, '1', 'bc_curvedramp*52', 'bc_curvedramp*52', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12264, 12264, '1', 'bc_curvedramp*53', 'bc_curvedramp*53', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12265, 12265, '1', 'bc_curvedramp*54', 'bc_curvedramp*54', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12266, 12266, '1', 'bc_curvedramp*55', 'bc_curvedramp*55', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12267, 12267, '1', 'bc_curvedramp*56', 'bc_curvedramp*56', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12268, 12268, '1', 'bc_curvedramp*57', 'bc_curvedramp*57', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12269, 12269, '1', 'bc_curvedramp*58', 'bc_curvedramp*58', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12270, 12270, '1', 'bc_curvedramp*59', 'bc_curvedramp*59', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12271, 12271, '1', 'bc_curvedramp*6', 'bc_curvedramp*6', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12272, 12272, '1', 'bc_curvedramp*60', 'bc_curvedramp*60', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12273, 12273, '1', 'bc_curvedramp*61', 'bc_curvedramp*61', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12274, 12274, '1', 'bc_curvedramp*62', 'bc_curvedramp*62', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12275, 12275, '1', 'bc_curvedramp*63', 'bc_curvedramp*63', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12276, 12276, '1', 'bc_curvedramp*64', 'bc_curvedramp*64', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12277, 12277, '1', 'bc_curvedramp*65', 'bc_curvedramp*65', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12278, 12278, '1', 'bc_curvedramp*66', 'bc_curvedramp*66', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12279, 12279, '1', 'bc_curvedramp*67', 'bc_curvedramp*67', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12280, 12280, '1', 'bc_curvedramp*68', 'bc_curvedramp*68', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12281, 12281, '1', 'bc_curvedramp*69', 'bc_curvedramp*69', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12282, 12282, '1', 'bc_curvedramp*7', 'bc_curvedramp*7', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12283, 12283, '1', 'bc_curvedramp*8', 'bc_curvedramp*8', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12284, 12284, '1', 'bc_curvedramp*9', 'bc_curvedramp*9', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12285, 12285, '1', 'bc_block_small*1', 'bc_block_small*1', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(12286, 12286, '1', 'bc_block_small*10', 'bc_block_small*10', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(12287, 12287, '1', 'bc_block_small*11', 'bc_block_small*11', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(12288, 12288, '1', 'bc_block_small*12', 'bc_block_small*12', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(12289, 12289, '1', 'bc_block_small*13', 'bc_block_small*13', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(12290, 12290, '1', 'bc_block_small*14', 'bc_block_small*14', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(12291, 12291, '1', 'bc_block_small*15', 'bc_block_small*15', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(12292, 12292, '1', 'bc_block_small*16', 'bc_block_small*16', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(12293, 12293, '1', 'bc_block_small*17', 'bc_block_small*17', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(12294, 12294, '1', 'bc_block_small*18', 'bc_block_small*18', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(12295, 12295, '1', 'bc_block_small*19', 'bc_block_small*19', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(12296, 12296, '1', 'bc_block_small*2', 'bc_block_small*2', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(12297, 12297, '1', 'bc_block_small*20', 'bc_block_small*20', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(12298, 12298, '1', 'bc_block_small*21', 'bc_block_small*21', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(12299, 12299, '1', 'bc_block_small*22', 'bc_block_small*22', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(12300, 12300, '1', 'bc_block_small*23', 'bc_block_small*23', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(12301, 12301, '1', 'bc_block_small*24', 'bc_block_small*24', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(12302, 12302, '1', 'bc_block_small*25', 'bc_block_small*25', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(12303, 12303, '1', 'bc_block_small*26', 'bc_block_small*26', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(12304, 12304, '1', 'bc_block_small*27', 'bc_block_small*27', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(12305, 12305, '1', 'bc_block_small*28', 'bc_block_small*28', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(12306, 12306, '1', 'bc_block_small*29', 'bc_block_small*29', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(12307, 12307, '1', 'bc_block_small*3', 'bc_block_small*3', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(12308, 12308, '1', 'bc_block_small*30', 'bc_block_small*30', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(12309, 12309, '1', 'bc_block_small*31', 'bc_block_small*31', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(12310, 12310, '1', 'bc_block_small*32', 'bc_block_small*32', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(12311, 12311, '1', 'bc_block_small*33', 'bc_block_small*33', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(12312, 12312, '1', 'bc_block_small*34', 'bc_block_small*34', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(12313, 12313, '1', 'bc_block_small*35', 'bc_block_small*35', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(12314, 12314, '1', 'bc_block_small*36', 'bc_block_small*36', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(12315, 12315, '1', 'bc_block_small*37', 'bc_block_small*37', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(12316, 12316, '1', 'bc_block_small*38', 'bc_block_small*38', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(12317, 12317, '1', 'bc_block_small*39', 'bc_block_small*39', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(12318, 12318, '1', 'bc_block_small*4', 'bc_block_small*4', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(12319, 12319, '1', 'bc_block_small*40', 'bc_block_small*40', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(12320, 12320, '1', 'bc_block_small*41', 'bc_block_small*41', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(12321, 12321, '1', 'bc_block_small*42', 'bc_block_small*42', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(12322, 12322, '1', 'bc_block_small*43', 'bc_block_small*43', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(12323, 12323, '1', 'bc_block_small*44', 'bc_block_small*44', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(12324, 12324, '1', 'bc_block_small*45', 'bc_block_small*45', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(12325, 12325, '1', 'bc_block_small*46', 'bc_block_small*46', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(12326, 12326, '1', 'bc_block_small*47', 'bc_block_small*47', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(12327, 12327, '1', 'bc_block_small*48', 'bc_block_small*48', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(12328, 12328, '1', 'bc_block_small*49', 'bc_block_small*49', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(12329, 12329, '1', 'bc_block_small*5', 'bc_block_small*5', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(12330, 12330, '1', 'bc_block_small*50', 'bc_block_small*50', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(12331, 12331, '1', 'bc_block_small*51', 'bc_block_small*51', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(12332, 12332, '1', 'bc_block_small*52', 'bc_block_small*52', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(12333, 12333, '1', 'bc_block_small*53', 'bc_block_small*53', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(12334, 12334, '1', 'bc_block_small*54', 'bc_block_small*54', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(12335, 12335, '1', 'bc_block_small*55', 'bc_block_small*55', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(12336, 12336, '1', 'bc_block_small*56', 'bc_block_small*56', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(12337, 12337, '1', 'bc_block_small*57', 'bc_block_small*57', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(12338, 12338, '1', 'bc_block_small*58', 'bc_block_small*58', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(12339, 12339, '1', 'bc_block_small*59', 'bc_block_small*59', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(12340, 12340, '1', 'bc_block_small*6', 'bc_block_small*6', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(12341, 12341, '1', 'bc_block_small*60', 'bc_block_small*60', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(12342, 12342, '1', 'bc_block_small*61', 'bc_block_small*61', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(12343, 12343, '1', 'bc_block_small*62', 'bc_block_small*62', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(12344, 12344, '1', 'bc_block_small*63', 'bc_block_small*63', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(12345, 12345, '1', 'bc_block_small*64', 'bc_block_small*64', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(12346, 12346, '1', 'bc_block_small*65', 'bc_block_small*65', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(12347, 12347, '1', 'bc_block_small*66', 'bc_block_small*66', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(12348, 12348, '1', 'bc_block_small*67', 'bc_block_small*67', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(12349, 12349, '1', 'bc_block_small*68', 'bc_block_small*68', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(12350, 12350, '1', 'bc_block_small*69', 'bc_block_small*69', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(12351, 12351, '1', 'bc_block_small*7', 'bc_block_small*7', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(12352, 12352, '1', 'bc_block_small*8', 'bc_block_small*8', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(12353, 12353, '1', 'bc_block_small*9', 'bc_block_small*9', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'multiheight', 5, '', '1.0;0.75;0.5;0.25;0.1', '', 0, 0, ''),
	(12354, 12354, '1', 'bc_panel*1', 'bc_panel*1', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12355, 12355, '1', 'bc_panel*10', 'bc_panel*10', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12356, 12356, '1', 'bc_panel*11', 'bc_panel*11', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12357, 12357, '1', 'bc_panel*12', 'bc_panel*12', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12358, 12358, '1', 'bc_panel*13', 'bc_panel*13', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12359, 12359, '1', 'bc_panel*14', 'bc_panel*14', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12360, 12360, '1', 'bc_panel*15', 'bc_panel*15', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12361, 12361, '1', 'bc_panel*16', 'bc_panel*16', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12362, 12362, '1', 'bc_panel*17', 'bc_panel*17', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12363, 12363, '1', 'bc_panel*18', 'bc_panel*18', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12364, 12364, '1', 'bc_panel*19', 'bc_panel*19', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12365, 12365, '1', 'bc_panel*2', 'bc_panel*2', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12366, 12366, '1', 'bc_panel*20', 'bc_panel*20', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12367, 12367, '1', 'bc_panel*21', 'bc_panel*21', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12368, 12368, '1', 'bc_panel*22', 'bc_panel*22', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12369, 12369, '1', 'bc_panel*23', 'bc_panel*23', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12370, 12370, '1', 'bc_panel*24', 'bc_panel*24', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12371, 12371, '1', 'bc_panel*25', 'bc_panel*25', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12372, 12372, '1', 'bc_panel*26', 'bc_panel*26', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12373, 12373, '1', 'bc_panel*27', 'bc_panel*27', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12374, 12374, '1', 'bc_panel*28', 'bc_panel*28', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12375, 12375, '1', 'bc_panel*29', 'bc_panel*29', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12376, 12376, '1', 'bc_panel*3', 'bc_panel*3', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12377, 12377, '1', 'bc_panel*30', 'bc_panel*30', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12378, 12378, '1', 'bc_panel*31', 'bc_panel*31', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12379, 12379, '1', 'bc_panel*32', 'bc_panel*32', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12380, 12380, '1', 'bc_panel*33', 'bc_panel*33', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12381, 12381, '1', 'bc_panel*34', 'bc_panel*34', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12382, 12382, '1', 'bc_panel*35', 'bc_panel*35', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12383, 12383, '1', 'bc_panel*36', 'bc_panel*36', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12384, 12384, '1', 'bc_panel*37', 'bc_panel*37', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12385, 12385, '1', 'bc_panel*38', 'bc_panel*38', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12386, 12386, '1', 'bc_panel*39', 'bc_panel*39', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12387, 12387, '1', 'bc_panel*4', 'bc_panel*4', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12388, 12388, '1', 'bc_panel*40', 'bc_panel*40', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12389, 12389, '1', 'bc_panel*41', 'bc_panel*41', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12390, 12390, '1', 'bc_panel*42', 'bc_panel*42', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12391, 12391, '1', 'bc_panel*43', 'bc_panel*43', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12392, 12392, '1', 'bc_panel*44', 'bc_panel*44', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12393, 12393, '1', 'bc_panel*45', 'bc_panel*45', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12394, 12394, '1', 'bc_panel*46', 'bc_panel*46', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12395, 12395, '1', 'bc_panel*47', 'bc_panel*47', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12396, 12396, '1', 'bc_panel*48', 'bc_panel*48', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12397, 12397, '1', 'bc_panel*49', 'bc_panel*49', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12398, 12398, '1', 'bc_panel*5', 'bc_panel*5', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12399, 12399, '1', 'bc_panel*50', 'bc_panel*50', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12400, 12400, '1', 'bc_panel*51', 'bc_panel*51', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12401, 12401, '1', 'bc_panel*52', 'bc_panel*52', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12402, 12402, '1', 'bc_panel*53', 'bc_panel*53', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12403, 12403, '1', 'bc_panel*54', 'bc_panel*54', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12404, 12404, '1', 'bc_panel*55', 'bc_panel*55', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12405, 12405, '1', 'bc_panel*56', 'bc_panel*56', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12406, 12406, '1', 'bc_panel*57', 'bc_panel*57', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12407, 12407, '1', 'bc_panel*58', 'bc_panel*58', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12408, 12408, '1', 'bc_panel*59', 'bc_panel*59', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12409, 12409, '1', 'bc_panel*6', 'bc_panel*6', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12410, 12410, '1', 'bc_panel*60', 'bc_panel*60', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12411, 12411, '1', 'bc_panel*61', 'bc_panel*61', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12412, 12412, '1', 'bc_panel*62', 'bc_panel*62', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12413, 12413, '1', 'bc_panel*63', 'bc_panel*63', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12414, 12414, '1', 'bc_panel*64', 'bc_panel*64', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12415, 12415, '1', 'bc_panel*65', 'bc_panel*65', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12416, 12416, '1', 'bc_panel*66', 'bc_panel*66', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12417, 12417, '1', 'bc_panel*67', 'bc_panel*67', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12418, 12418, '1', 'bc_panel*68', 'bc_panel*68', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12419, 12419, '1', 'bc_panel*69', 'bc_panel*69', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12420, 12420, '1', 'bc_panel*7', 'bc_panel*7', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12421, 12421, '1', 'bc_panel*8', 'bc_panel*8', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12422, 12422, '1', 'bc_panel*9', 'bc_panel*9', 'S', 2, 1, 0.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12423, 12423, '0', 'rare_prize21_xmas', 'rare_prize21_xmas', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12424, 12424, '0', 'clothing_goldhatpack2', 'clothing_goldhatpack2', 'S', 1, 1, 0.65, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(12425, 12425, '0', 'spa_c22_massagebed', 'spa_c22_massagebed', 'S', 1, 3, 1.90, '0', '0', '1', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12426, 12426, '0', 'spa_c22_waterfall', 'spa_c22_waterfall', 'S', 3, 1, 7.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12427, 12427, '0', 'spa_c22_sofa', 'spa_c22_sofa', 'S', 2, 1, 0.90, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12428, 12428, '0', 'spa_c22_stone', 'spa_c22_stone', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(12429, 12429, '0', 'spa_c22_towel', 'spa_c22_towel', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(12430, 12430, '0', 'spa_c22_candle', 'spa_c22_candle', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(12431, 12431, '0', 'clothing_r21_nystarhat3', 'clothing_r21_nystarhat3', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(12432, 12432, '0', 'clothing_r21_nystarhat7', 'clothing_r21_nystarhat7', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(12433, 12433, '0', 'clothing_r21_nystarhat6', 'clothing_r21_nystarhat6', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(12434, 12434, '0', 'ny_r21_crackable', 'ny_r21_crackable', 'S', 1, 1, 0.50, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(12435, 12435, '0', 'clothing_r21_nystarhat1', 'clothing_r21_nystarhat1', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(12436, 12436, '0', 'clothing_r21_nystarhat4', 'clothing_r21_nystarhat4', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(12437, 12437, '0', 'clothing_r21_nystarhat2', 'clothing_r21_nystarhat2', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(12438, 12438, '0', 'clothing_r21_nystarhat8', 'clothing_r21_nystarhat8', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(12439, 12439, '0', 'clothing_r21_nystarhat5', 'clothing_r21_nystarhat5', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(12440, 12440, '0', 'nft_club_sofa', 'nft_club_sofa', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12441, 12441, '0', 'xmas_c21_crackableletterb', 'xmas_c21_crackableletterb', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12442, 12442, '0', 'clothing_tinkywinky', 'clothing_tinkywinky', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(12443, 12443, '0', 'clothing_po', 'clothing_po', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(12444, 12444, '0', 'clothing_dipsy', 'clothing_dipsy', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(12445, 12445, '0', 'ads_teletubbies_noonoo', 'ads_teletubbies_noonoo', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12446, 12446, '0', 'ads_teletubbies_tubbytst', 'ads_teletubbies_tubbytst', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(12447, 12447, '0', 'ads_teletubbies_custardmchn', 'ads_teletubbies_custardmchn', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(12448, 12448, '0', 'clothing_laalaa', 'clothing_laalaa', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(12449, 12449, '0', 'sanrio_c21_hellokittysnowman', 'sanrio_c21_hellokittysnowman', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12450, 12450, '0', 'sanrio_c21_hellokittyrug', 'sanrio_c21_hellokittyrug', 'S', 2, 3, 0.10, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12451, 12451, '0', 'clothing_hellokittyhat', 'clothing_hellokittyhat', 'S', 1, 1, 1.10, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(12452, 12452, '0', 'sanrio_c21_hellokittytree', 'sanrio_c21_hellokittytree', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(12453, 12453, '0', 'sanrio_c21_hellokittychair', 'sanrio_c21_hellokittychair', 'S', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(12454, 12454, '0', 'clothing_hellokittybpack', 'clothing_hellokittybpack', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(12455, 12455, '0', 'test_nft_clothing2', 'test_nft_clothing2', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(12456, 12456, '0', 'test_nft_clothing', 'test_nft_clothing', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(12457, 12457, '0', 'hc22_7', 'hc22_7', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12458, 12458, '0', 'hc22_2', 'hc22_2', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(12459, 12459, '0', 'hc22_9', 'hc22_9', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(12460, 12460, '0', 'hc22_11', 'hc22_11', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12461, 12461, '0', 'hc22_12', 'hc22_12', 'S', 2, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12462, 12462, '0', 'hc22_10', 'hc22_10', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12463, 12463, '0', 'hc22_5', 'hc22_5', 'S', 2, 2, 0.70, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12464, 12464, '0', 'hc22_4', 'hc22_4', 'S', 3, 2, 0.10, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12465, 12465, '0', 'hc22_6', 'hc22_6', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(12466, 12466, '0', 'hc22_1', 'hc22_1', 'S', 1, 1, 1.30, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12467, 12467, '0', 'hc22_3', 'hc22_3', 'S', 1, 2, 0.01, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12468, 12468, '0', 'hc22_8', 'hc22_8', 'S', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12469, 12469, '0', 'ltd22_giantcrystal', 'ltd22_giantcrystal', 'S', 1, 1, 0.01, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12470, 12470, '0', 'rare_r22_bluerocococlock', 'rare_r22_bluerocococlock', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12471, 12471, '0', 'rare_r22_carbootcabinet', 'rare_r22_carbootcabinet', 'S', 2, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(12472, 12472, '0', 'rare_r22_treasureboxtank', 'rare_r22_treasureboxtank', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12473, 12473, '0', 'CF_500_champagne', 'CF_500_champagne', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'credit_furni', 1, '', '', '', 0, 0, ''),
	(12474, 12474, '0', 'bohogarden_c21_rug', 'bohogarden_c21_rug', 'S', 2, 3, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12475, 12475, '0', 'bohogarden_c21_rattansofa', 'bohogarden_c21_rattansofa', 'S', 2, 1, 1.10, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(12476, 12476, '0', 'bohogarden_c21_rattansofacorner', 'bohogarden_c21_rattansofacorner', 'S', 1, 1, 1.10, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12477, 12477, '0', 'bohogarden_c21_trellis', 'bohogarden_c21_trellis', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 6, '', '', '', 0, 0, ''),
	(12478, 12478, '0', 'bohogarden_c21_leaves', 'bohogarden_c21_leaves', 'S', 2, 1, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12479, 12479, '0', 'bohogarden_c21_lights', 'bohogarden_c21_lights', 'S', 1, 2, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(12480, 12480, '0', 'bohogarden_c21_snakeplant', 'bohogarden_c21_snakeplant', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(12481, 12481, '0', 'bohogarden_c21_floor', 'bohogarden_c21_floor', 'S', 2, 2, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12482, 12482, '0', 'bohogarden_c21_candlebowl', 'bohogarden_c21_candlebowl', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 6, '', '', '', 0, 0, ''),
	(12483, 12483, '0', 'bohogarden_c21_cheeseplant', 'bohogarden_c21_cheeseplant', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12484, 12484, '0', 'bohogarden_c21_rattanmat', 'bohogarden_c21_rattanmat', 'S', 1, 1, 0.10, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 4, '', '', '', 0, 0, ''),
	(12485, 12485, '0', 'bohogarden_c21_rattantable', 'bohogarden_c21_rattantable', 'S', 2, 1, 0.60, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12486, 12486, '0', 'bohogarden_c21_fanpalm', 'bohogarden_c21_fanpalm', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12487, 12487, '0', 'bohogarden_c21_hanginglantern', 'bohogarden_c21_hanginglantern', 'S', 1, 2, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 6, '', '', '', 0, 0, ''),
	(12488, 12488, '0', 'bohogarden_c21_woodenwall', 'bohogarden_c21_woodenwall', 'S', 2, 1, 0.00, '0', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12489, 12489, '0', 'china_tigerstatue', 'china_tigerstatue', 'S', 1, 1, 2.40, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12490, 12490, '0', 'china_goldentiger', 'china_goldentiger', 'S', 1, 1, 2.40, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12491, 12491, '0', 'clothing_cnytiger', 'clothing_cnytiger', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(12492, 12492, '0', 'val_c22_brokenvan1', 'val_c22_brokenvan1', 'S', 2, 3, 3.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12493, 12493, '0', 'val_r22_butterfly', 'val_r22_butterfly', 'S', 1, 2, 0.00, '1', '0', '0', '1', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12494, 12494, '0', 'val_c22_cosyvan', 'val_c22_cosyvan', 'S', 2, 3, 1.50, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'tent', 2, '', '', '', 0, 0, ''),
	(12495, 12495, '0', 'val_c22_punkvan', 'val_c22_punkvan', 'S', 2, 3, 1.50, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'tent', 1, '', '', '', 0, 0, ''),
	(12496, 12496, '0', 'val_c22_beachvan', 'val_c22_beachvan', 'S', 2, 3, 1.50, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'tent', 2, '', '', '', 0, 0, ''),
	(12497, 12497, '0', 'val_c22_pastelvan', 'val_c22_pastelvan', 'S', 2, 3, 1.50, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'tent', 2, '', '', '', 0, 0, ''),
	(12498, 12498, '0', 'clothing_sunhat', 'clothing_sunhat', 'S', 1, 1, 1.10, '1', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(12499, 12499, '0', 'val_c22_brokenvan', 'val_c22_brokenvan', 'S', 2, 3, 3.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(12500, 12500, '0', 'clothing_r22_messierbun', 'clothing_r22_messierbun', 'S', 1, 1, 1.10, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(12501, 12501, '0', 'clothing_r22_bohoshirt', 'clothing_r22_bohoshirt', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(12502, 12502, '0', 'val_r22_rickshaw', 'val_r22_rickshaw', 'S', 2, 1, 2.00, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12503, 12503, '0', 'val_c22_blingvan', 'val_c22_blingvan', 'S', 2, 3, 1.50, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'tent', 1, '', '', '', 0, 0, ''),
	(12504, 12504, '0', 'val_r22_peacockspider', 'val_r22_peacockspider', 'S', 1, 1, 0.80, '0', '1', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12505, 12505, '0', 'clothing_bohonecklace', 'clothing_bohonecklace', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(12506, 12506, '0', 'rare_prize22*0', 'rare_prize22*0', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12507, 12507, '0', 'rare_prize22*1', 'rare_prize22*1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12508, 12508, '0', 'rare_prize22*10', 'rare_prize22*10', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12509, 12509, '0', 'rare_prize22*11', 'rare_prize22*11', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12510, 12510, '0', 'rare_prize22*12', 'rare_prize22*12', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12511, 12511, '0', 'rare_prize22*13', 'rare_prize22*13', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12512, 12512, '0', 'rare_prize22*2', 'rare_prize22*2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12513, 12513, '0', 'rare_prize22*3', 'rare_prize22*3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12514, 12514, '0', 'rare_prize22*4', 'rare_prize22*4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12515, 12515, '0', 'rare_prize22*5', 'rare_prize22*5', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12516, 12516, '0', 'rare_prize22*6', 'rare_prize22*6', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12517, 12517, '0', 'rare_prize22*7', 'rare_prize22*7', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12518, 12518, '0', 'rare_prize22*8', 'rare_prize22*8', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12519, 12519, '0', 'rare_prize22*9', 'rare_prize22*9', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12520, 12520, '0', 'bohogarden_c21_glasslantern', 'bohogarden_c21_glasslantern', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(12521, 12521, '0', 'bohogarden_c21_fireheater', 'bohogarden_c21_fireheater', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(12522, 12522, '0', 'bonusbag22_2', 'bonusbag22_2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(12523, 12523, '0', 'bonusrare22_1*0', 'bonusrare22_1*0', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12524, 12524, '0', 'bonusrare22_1*1', 'bonusrare22_1*1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12525, 12525, '0', 'bonusrare22_1*2', 'bonusrare22_1*2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12526, 12526, '0', 'bonusrare22_1*3', 'bonusrare22_1*3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12527, 12527, '0', 'bonusrare22_1*4', 'bonusrare22_1*4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12528, 12528, '0', 'bonusrare22_1*5', 'bonusrare22_1*5', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12529, 12529, '0', 'bonusrare22_4*0', 'bonusrare22_4*0', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12530, 12530, '0', 'bonusbag22_3', 'bonusbag22_3', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(12531, 12531, '0', 'bonusrare22_3*0', 'bonusrare22_3*0', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12532, 12532, '0', 'bonusrare22_3*1', 'bonusrare22_3*1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12533, 12533, '0', 'bonusrare22_3*2', 'bonusrare22_3*2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12534, 12534, '0', 'bonusrare22_3*3', 'bonusrare22_3*3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12535, 12535, '0', 'bonusrare22_3*4', 'bonusrare22_3*4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12536, 12536, '0', 'bonusrare22_3*5', 'bonusrare22_3*5', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12537, 12537, '0', 'bonusrare22_2*0', 'bonusrare22_2*0', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12538, 12538, '0', 'bonusrare22_2*1', 'bonusrare22_2*1', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12539, 12539, '0', 'bonusrare22_2*2', 'bonusrare22_2*2', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12540, 12540, '0', 'bonusrare22_2*3', 'bonusrare22_2*3', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12541, 12541, '0', 'bonusrare22_2*4', 'bonusrare22_2*4', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12542, 12542, '0', 'bonusrare22_2*5', 'bonusrare22_2*5', 'S', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12543, 12543, '0', 'bonusbag22_1', 'bonusbag22_1', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(12544, 12544, '0', 'bonusbag22_4', 'bonusbag22_4', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(12545, 12545, '0', 'diamond_painting72', 'diamond_painting72', 'S', 1, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12546, 12546, '0', 'diamond_painting70', 'diamond_painting70', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12547, 12547, '0', 'diamond_painting75', 'diamond_painting75', 'S', 3, 1, 0.01, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12548, 12548, '0', 'diamond_painting69', 'diamond_painting69', 'S', 1, 1, 3.10, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12549, 12549, '0', 'CF_350_goldendecanter', 'CF_350_goldendecanter', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(12550, 12550, '0', 'CF_250_stagmount', 'CF_250_stagmount', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(12551, 12551, '0', 'CF_350_geode', 'CF_350_geode', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12552, 12552, '0', 'CF_250_peacockvase', 'CF_250_peacockvase', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12553, 12553, '0', 'CF_750_hphone', 'CF_750_hphone', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(12554, 12554, '0', 'CF_500_jewelledsnake', 'CF_500_jewelledsnake', 'S', 1, 1, 2.20, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(12555, 12555, '0', 'SID_c22_plush', 'SID_c22_plush', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12556, 12556, '0', 'sanrio_c22_mymelodyvase', 'sanrio_c22_mymelodyvase', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12557, 12557, '0', 'clothing_mymelodyskirt', 'clothing_mymelodyskirt', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(12558, 12558, '0', 'clothing_mymelodyheadband', 'clothing_mymelodyheadband', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(12559, 12559, '0', 'sanrio_c22_mymelodybed', 'sanrio_c22_mymelodybed', 'S', 2, 3, 2.00, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12560, 12560, '0', 'sanrio_c22_mymelodycake', 'sanrio_c22_mymelodycake', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12561, 12561, '0', 'sanrio_c22_mymelodydesk', 'sanrio_c22_mymelodydesk', 'S', 1, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12562, 12562, '0', 'trophy_gameprize', 'trophy_gameprize', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 2, '', '', '', 0, 0, ''),
	(12563, 12563, '0', 'trophy_fansite', 'trophy_fansite', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'trophy', 2, '', '', '', 0, 0, ''),
	(12564, 12564, '0', 'summer_c22_rowboat', 'summer_c22_rowboat', 'S', 1, 3, 1.50, '0', '0', '0', '1', '0', '0', '1', '1', '1', 'water_item', 1, '', '', '-0.45', 0, 0, ''),
	(12565, 12565, '0', 'summer_c22_picnictable', 'summer_c22_picnictable', 'S', 2, 1, 1.00, '1', '0', '0', '0', '0', '0', '1', '1', '1', 'default', 6, '', '', '', 0, 0, ''),
	(12566, 12566, '0', 'summer_c22_lifering', 'summer_c22_lifering', 'S', 1, 1, 1.30, '0', '0', '0', '1', '0', '0', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12567, 12567, '1', 'bc_ramp*1', 'bc_ramp*1', 'S', 1, 1, 1.70, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 3, '', '1.70;1.00;0.50', '', 0, 0, ''),
	(12568, 12568, '1', 'bc_ramp*10', 'bc_ramp*10', 'S', 1, 1, 1.70, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 3, '', '1.70;1.00;0.50', '', 0, 0, ''),
	(12569, 12569, '1', 'bc_ramp*11', 'bc_ramp*11', 'S', 1, 1, 1.70, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 3, '', '1.70;1.00;0.50', '', 0, 0, ''),
	(12570, 12570, '1', 'bc_ramp*12', 'bc_ramp*12', 'S', 1, 1, 1.70, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 3, '', '1.70;1.00;0.50', '', 0, 0, ''),
	(12571, 12571, '1', 'bc_ramp*13', 'bc_ramp*13', 'S', 1, 1, 1.70, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 3, '', '1.70;1.00;0.50', '', 0, 0, ''),
	(12572, 12572, '1', 'bc_ramp*14', 'bc_ramp*14', 'S', 1, 1, 1.70, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 3, '', '1.70;1.00;0.50', '', 0, 0, ''),
	(12573, 12573, '1', 'bc_ramp*15', 'bc_ramp*15', 'S', 1, 1, 1.70, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 3, '', '1.70;1.00;0.50', '', 0, 0, ''),
	(12574, 12574, '1', 'bc_ramp*16', 'bc_ramp*16', 'S', 1, 1, 1.70, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 3, '', '1.70;1.00;0.50', '', 0, 0, ''),
	(12575, 12575, '1', 'bc_ramp*17', 'bc_ramp*17', 'S', 1, 1, 1.70, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 3, '', '1.70;1.00;0.50', '', 0, 0, ''),
	(12576, 12576, '1', 'bc_ramp*18', 'bc_ramp*18', 'S', 1, 1, 1.70, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 3, '', '1.70;1.00;0.50', '', 0, 0, ''),
	(12577, 12577, '1', 'bc_ramp*19', 'bc_ramp*19', 'S', 1, 1, 1.70, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 3, '', '1.70;1.00;0.50', '', 0, 0, ''),
	(12578, 12578, '1', 'bc_ramp*2', 'bc_ramp*2', 'S', 1, 1, 1.70, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 3, '', '1.70;1.00;0.50', '', 0, 0, ''),
	(12579, 12579, '1', 'bc_ramp*20', 'bc_ramp*20', 'S', 1, 1, 1.70, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 3, '', '1.70;1.00;0.50', '', 0, 0, ''),
	(12580, 12580, '1', 'bc_ramp*21', 'bc_ramp*21', 'S', 1, 1, 1.70, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 3, '', '1.70;1.00;0.50', '', 0, 0, ''),
	(12581, 12581, '1', 'bc_ramp*22', 'bc_ramp*22', 'S', 1, 1, 1.70, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 3, '', '1.70;1.00;0.50', '', 0, 0, ''),
	(12582, 12582, '1', 'bc_ramp*23', 'bc_ramp*23', 'S', 1, 1, 1.70, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 3, '', '1.70;1.00;0.50', '', 0, 0, ''),
	(12583, 12583, '1', 'bc_ramp*24', 'bc_ramp*24', 'S', 1, 1, 1.70, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 3, '', '1.70;1.00;0.50', '', 0, 0, ''),
	(12584, 12584, '1', 'bc_ramp*25', 'bc_ramp*25', 'S', 1, 1, 1.70, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 3, '', '1.70;1.00;0.50', '', 0, 0, ''),
	(12585, 12585, '1', 'bc_ramp*26', 'bc_ramp*26', 'S', 1, 1, 1.70, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 3, '', '1.70;1.00;0.50', '', 0, 0, ''),
	(12586, 12586, '1', 'bc_ramp*27', 'bc_ramp*27', 'S', 1, 1, 1.70, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 3, '', '1.70;1.00;0.50', '', 0, 0, ''),
	(12587, 12587, '1', 'bc_ramp*28', 'bc_ramp*28', 'S', 1, 1, 1.70, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 3, '', '1.70;1.00;0.50', '', 0, 0, ''),
	(12588, 12588, '1', 'bc_ramp*29', 'bc_ramp*29', 'S', 1, 1, 1.70, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 3, '', '1.70;1.00;0.50', '', 0, 0, ''),
	(12589, 12589, '1', 'bc_ramp*3', 'bc_ramp*3', 'S', 1, 1, 1.70, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 3, '', '1.70;1.00;0.50', '', 0, 0, ''),
	(12590, 12590, '1', 'bc_ramp*30', 'bc_ramp*30', 'S', 1, 1, 1.70, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 3, '', '1.70;1.00;0.50', '', 0, 0, ''),
	(12591, 12591, '1', 'bc_ramp*31', 'bc_ramp*31', 'S', 1, 1, 1.70, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 3, '', '1.70;1.00;0.50', '', 0, 0, ''),
	(12592, 12592, '1', 'bc_ramp*32', 'bc_ramp*32', 'S', 1, 1, 1.70, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 3, '', '1.70;1.00;0.50', '', 0, 0, ''),
	(12593, 12593, '1', 'bc_ramp*33', 'bc_ramp*33', 'S', 1, 1, 1.70, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 3, '', '1.70;1.00;0.50', '', 0, 0, ''),
	(12594, 12594, '1', 'bc_ramp*34', 'bc_ramp*34', 'S', 1, 1, 1.70, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 3, '', '1.70;1.00;0.50', '', 0, 0, ''),
	(12595, 12595, '1', 'bc_ramp*35', 'bc_ramp*35', 'S', 1, 1, 1.70, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 3, '', '1.70;1.00;0.50', '', 0, 0, ''),
	(12596, 12596, '1', 'bc_ramp*36', 'bc_ramp*36', 'S', 1, 1, 1.70, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 3, '', '1.70;1.00;0.50', '', 0, 0, ''),
	(12597, 12597, '1', 'bc_ramp*37', 'bc_ramp*37', 'S', 1, 1, 1.70, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 3, '', '1.70;1.00;0.50', '', 0, 0, ''),
	(12598, 12598, '1', 'bc_ramp*38', 'bc_ramp*38', 'S', 1, 1, 1.70, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 3, '', '1.70;1.00;0.50', '', 0, 0, ''),
	(12599, 12599, '1', 'bc_ramp*39', 'bc_ramp*39', 'S', 1, 1, 1.70, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 3, '', '1.70;1.00;0.50', '', 0, 0, ''),
	(12600, 12600, '1', 'bc_ramp*4', 'bc_ramp*4', 'S', 1, 1, 1.70, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 3, '', '1.70;1.00;0.50', '', 0, 0, ''),
	(12601, 12601, '1', 'bc_ramp*40', 'bc_ramp*40', 'S', 1, 1, 1.70, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 3, '', '1.70;1.00;0.50', '', 0, 0, ''),
	(12602, 12602, '1', 'bc_ramp*41', 'bc_ramp*41', 'S', 1, 1, 1.70, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 3, '', '1.70;1.00;0.50', '', 0, 0, ''),
	(12603, 12603, '1', 'bc_ramp*42', 'bc_ramp*42', 'S', 1, 1, 1.70, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 3, '', '1.70;1.00;0.50', '', 0, 0, ''),
	(12604, 12604, '1', 'bc_ramp*43', 'bc_ramp*43', 'S', 1, 1, 1.70, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 3, '', '1.70;1.00;0.50', '', 0, 0, ''),
	(12605, 12605, '1', 'bc_ramp*44', 'bc_ramp*44', 'S', 1, 1, 1.70, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 3, '', '1.70;1.00;0.50', '', 0, 0, ''),
	(12606, 12606, '1', 'bc_ramp*45', 'bc_ramp*45', 'S', 1, 1, 1.70, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 3, '', '1.70;1.00;0.50', '', 0, 0, ''),
	(12607, 12607, '1', 'bc_ramp*46', 'bc_ramp*46', 'S', 1, 1, 1.70, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 3, '', '1.70;1.00;0.50', '', 0, 0, ''),
	(12608, 12608, '1', 'bc_ramp*47', 'bc_ramp*47', 'S', 1, 1, 1.70, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 3, '', '1.70;1.00;0.50', '', 0, 0, ''),
	(12609, 12609, '1', 'bc_ramp*48', 'bc_ramp*48', 'S', 1, 1, 1.70, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 3, '', '1.70;1.00;0.50', '', 0, 0, ''),
	(12610, 12610, '1', 'bc_ramp*49', 'bc_ramp*49', 'S', 1, 1, 1.70, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 3, '', '1.70;1.00;0.50', '', 0, 0, ''),
	(12611, 12611, '1', 'bc_ramp*5', 'bc_ramp*5', 'S', 1, 1, 1.70, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 3, '', '1.70;1.00;0.50', '', 0, 0, ''),
	(12612, 12612, '1', 'bc_ramp*50', 'bc_ramp*50', 'S', 1, 1, 1.70, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 3, '', '1.70;1.00;0.50', '', 0, 0, ''),
	(12613, 12613, '1', 'bc_ramp*51', 'bc_ramp*51', 'S', 1, 1, 1.70, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 3, '', '1.70;1.00;0.50', '', 0, 0, ''),
	(12614, 12614, '1', 'bc_ramp*52', 'bc_ramp*52', 'S', 1, 1, 1.70, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 3, '', '1.70;1.00;0.50', '', 0, 0, ''),
	(12615, 12615, '1', 'bc_ramp*53', 'bc_ramp*53', 'S', 1, 1, 1.70, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 3, '', '1.70;1.00;0.50', '', 0, 0, ''),
	(12616, 12616, '1', 'bc_ramp*54', 'bc_ramp*54', 'S', 1, 1, 1.70, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 3, '', '1.70;1.00;0.50', '', 0, 0, ''),
	(12617, 12617, '1', 'bc_ramp*55', 'bc_ramp*55', 'S', 1, 1, 1.70, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 3, '', '1.70;1.00;0.50', '', 0, 0, ''),
	(12618, 12618, '1', 'bc_ramp*56', 'bc_ramp*56', 'S', 1, 1, 1.70, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 3, '', '1.70;1.00;0.50', '', 0, 0, ''),
	(12619, 12619, '1', 'bc_ramp*57', 'bc_ramp*57', 'S', 1, 1, 1.70, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 3, '', '1.70;1.00;0.50', '', 0, 0, ''),
	(12620, 12620, '1', 'bc_ramp*58', 'bc_ramp*58', 'S', 1, 1, 1.70, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 3, '', '1.70;1.00;0.50', '', 0, 0, ''),
	(12621, 12621, '1', 'bc_ramp*59', 'bc_ramp*59', 'S', 1, 1, 1.70, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 3, '', '1.70;1.00;0.50', '', 0, 0, ''),
	(12622, 12622, '1', 'bc_ramp*6', 'bc_ramp*6', 'S', 1, 1, 1.70, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 3, '', '1.70;1.00;0.50', '', 0, 0, ''),
	(12623, 12623, '1', 'bc_ramp*60', 'bc_ramp*60', 'S', 1, 1, 1.70, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 3, '', '1.70;1.00;0.50', '', 0, 0, ''),
	(12624, 12624, '1', 'bc_ramp*61', 'bc_ramp*61', 'S', 1, 1, 1.70, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 3, '', '1.70;1.00;0.50', '', 0, 0, ''),
	(12625, 12625, '1', 'bc_ramp*62', 'bc_ramp*62', 'S', 1, 1, 1.70, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 3, '', '1.70;1.00;0.50', '', 0, 0, ''),
	(12626, 12626, '1', 'bc_ramp*63', 'bc_ramp*63', 'S', 1, 1, 1.70, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 3, '', '1.70;1.00;0.50', '', 0, 0, ''),
	(12627, 12627, '1', 'bc_ramp*64', 'bc_ramp*64', 'S', 1, 1, 1.70, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 3, '', '1.70;1.00;0.50', '', 0, 0, ''),
	(12628, 12628, '1', 'bc_ramp*65', 'bc_ramp*65', 'S', 1, 1, 1.70, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 3, '', '1.70;1.00;0.50', '', 0, 0, ''),
	(12629, 12629, '1', 'bc_ramp*66', 'bc_ramp*66', 'S', 1, 1, 1.70, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 3, '', '1.70;1.00;0.50', '', 0, 0, ''),
	(12630, 12630, '1', 'bc_ramp*67', 'bc_ramp*67', 'S', 1, 1, 1.70, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 3, '', '1.70;1.00;0.50', '', 0, 0, ''),
	(12631, 12631, '1', 'bc_ramp*68', 'bc_ramp*68', 'S', 1, 1, 1.70, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 3, '', '1.70;1.00;0.50', '', 0, 0, ''),
	(12632, 12632, '1', 'bc_ramp*69', 'bc_ramp*69', 'S', 1, 1, 1.70, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 3, '', '1.70;1.00;0.50', '', 0, 0, ''),
	(12633, 12633, '1', 'bc_ramp*7', 'bc_ramp*7', 'S', 1, 1, 1.70, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 3, '', '1.70;1.00;0.50', '', 0, 0, ''),
	(12634, 12634, '1', 'bc_ramp*8', 'bc_ramp*8', 'S', 1, 1, 1.70, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 3, '', '1.70;1.00;0.50', '', 0, 0, ''),
	(12635, 12635, '1', 'bc_ramp*9', 'bc_ramp*9', 'S', 1, 1, 1.70, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 3, '', '1.70;1.00;0.50', '', 0, 0, ''),
	(12636, 12636, '1', 'bc_stairs*1', 'bc_stairs*1', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12637, 12637, '1', 'bc_stairs*10', 'bc_stairs*10', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12638, 12638, '1', 'bc_stairs*11', 'bc_stairs*11', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12639, 12639, '1', 'bc_stairs*12', 'bc_stairs*12', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12640, 12640, '1', 'bc_stairs*13', 'bc_stairs*13', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12641, 12641, '1', 'bc_stairs*14', 'bc_stairs*14', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12642, 12642, '1', 'bc_stairs*15', 'bc_stairs*15', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12643, 12643, '1', 'bc_stairs*16', 'bc_stairs*16', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12644, 12644, '1', 'bc_stairs*17', 'bc_stairs*17', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12645, 12645, '1', 'bc_stairs*18', 'bc_stairs*18', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12646, 12646, '1', 'bc_stairs*19', 'bc_stairs*19', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12647, 12647, '1', 'bc_stairs*2', 'bc_stairs*2', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12648, 12648, '1', 'bc_stairs*20', 'bc_stairs*20', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12649, 12649, '1', 'bc_stairs*21', 'bc_stairs*21', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12650, 12650, '1', 'bc_stairs*22', 'bc_stairs*22', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12651, 12651, '1', 'bc_stairs*23', 'bc_stairs*23', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12652, 12652, '1', 'bc_stairs*24', 'bc_stairs*24', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12653, 12653, '1', 'bc_stairs*25', 'bc_stairs*25', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12654, 12654, '1', 'bc_stairs*26', 'bc_stairs*26', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12655, 12655, '1', 'bc_stairs*27', 'bc_stairs*27', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12656, 12656, '1', 'bc_stairs*28', 'bc_stairs*28', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12657, 12657, '1', 'bc_stairs*29', 'bc_stairs*29', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12658, 12658, '1', 'bc_stairs*3', 'bc_stairs*3', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12659, 12659, '1', 'bc_stairs*30', 'bc_stairs*30', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12660, 12660, '1', 'bc_stairs*31', 'bc_stairs*31', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12661, 12661, '1', 'bc_stairs*32', 'bc_stairs*32', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12662, 12662, '1', 'bc_stairs*33', 'bc_stairs*33', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12663, 12663, '1', 'bc_stairs*34', 'bc_stairs*34', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12664, 12664, '1', 'bc_stairs*35', 'bc_stairs*35', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12665, 12665, '1', 'bc_stairs*36', 'bc_stairs*36', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12666, 12666, '1', 'bc_stairs*37', 'bc_stairs*37', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12667, 12667, '1', 'bc_stairs*38', 'bc_stairs*38', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12668, 12668, '1', 'bc_stairs*39', 'bc_stairs*39', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12669, 12669, '1', 'bc_stairs*4', 'bc_stairs*4', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12670, 12670, '1', 'bc_stairs*40', 'bc_stairs*40', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12671, 12671, '1', 'bc_stairs*41', 'bc_stairs*41', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12672, 12672, '1', 'bc_stairs*42', 'bc_stairs*42', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12673, 12673, '1', 'bc_stairs*43', 'bc_stairs*43', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12674, 12674, '1', 'bc_stairs*44', 'bc_stairs*44', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12675, 12675, '1', 'bc_stairs*45', 'bc_stairs*45', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12676, 12676, '1', 'bc_stairs*46', 'bc_stairs*46', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12677, 12677, '1', 'bc_stairs*47', 'bc_stairs*47', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12678, 12678, '1', 'bc_stairs*48', 'bc_stairs*48', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12679, 12679, '1', 'bc_stairs*49', 'bc_stairs*49', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12680, 12680, '1', 'bc_stairs*5', 'bc_stairs*5', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12681, 12681, '1', 'bc_stairs*50', 'bc_stairs*50', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12682, 12682, '1', 'bc_stairs*51', 'bc_stairs*51', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12683, 12683, '1', 'bc_stairs*52', 'bc_stairs*52', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12684, 12684, '1', 'bc_stairs*53', 'bc_stairs*53', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12685, 12685, '1', 'bc_stairs*54', 'bc_stairs*54', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12686, 12686, '1', 'bc_stairs*55', 'bc_stairs*55', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12687, 12687, '1', 'bc_stairs*56', 'bc_stairs*56', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12688, 12688, '1', 'bc_stairs*57', 'bc_stairs*57', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12689, 12689, '1', 'bc_stairs*58', 'bc_stairs*58', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12690, 12690, '1', 'bc_stairs*59', 'bc_stairs*59', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12691, 12691, '1', 'bc_stairs*6', 'bc_stairs*6', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12692, 12692, '1', 'bc_stairs*60', 'bc_stairs*60', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12693, 12693, '1', 'bc_stairs*61', 'bc_stairs*61', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12694, 12694, '1', 'bc_stairs*62', 'bc_stairs*62', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12695, 12695, '1', 'bc_stairs*63', 'bc_stairs*63', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12696, 12696, '1', 'bc_stairs*64', 'bc_stairs*64', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12697, 12697, '1', 'bc_stairs*65', 'bc_stairs*65', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12698, 12698, '1', 'bc_stairs*66', 'bc_stairs*66', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12699, 12699, '1', 'bc_stairs*67', 'bc_stairs*67', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12700, 12700, '1', 'bc_stairs*68', 'bc_stairs*68', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12701, 12701, '1', 'bc_stairs*69', 'bc_stairs*69', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12702, 12702, '1', 'bc_stairs*7', 'bc_stairs*7', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12703, 12703, '1', 'bc_stairs*8', 'bc_stairs*8', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12704, 12704, '1', 'bc_stairs*9', 'bc_stairs*9', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12705, 12705, '1', 'bc_stick*1', 'bc_stick*1', 'S', 1, 1, 4.00, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 5, '', '4.0;3.0;2.0;1.0;0.0', '', 0, 0, ''),
	(12706, 12706, '1', 'bc_stick*10', 'bc_stick*10', 'S', 1, 1, 4.00, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 5, '', '4.0;3.0;2.0;1.0;0.0', '', 0, 0, ''),
	(12707, 12707, '1', 'bc_stick*11', 'bc_stick*11', 'S', 1, 1, 4.00, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 5, '', '4.0;3.0;2.0;1.0;0.0', '', 0, 0, ''),
	(12708, 12708, '1', 'bc_stick*12', 'bc_stick*12', 'S', 1, 1, 4.00, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 5, '', '4.0;3.0;2.0;1.0;0.0', '', 0, 0, ''),
	(12709, 12709, '1', 'bc_stick*13', 'bc_stick*13', 'S', 1, 1, 4.00, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 5, '', '4.0;3.0;2.0;1.0;0.0', '', 0, 0, ''),
	(12710, 12710, '1', 'bc_stick*14', 'bc_stick*14', 'S', 1, 1, 4.00, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 5, '', '4.0;3.0;2.0;1.0;0.0', '', 0, 0, ''),
	(12711, 12711, '1', 'bc_stick*15', 'bc_stick*15', 'S', 1, 1, 4.00, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 5, '', '4.0;3.0;2.0;1.0;0.0', '', 0, 0, ''),
	(12712, 12712, '1', 'bc_stick*16', 'bc_stick*16', 'S', 1, 1, 4.00, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 5, '', '4.0;3.0;2.0;1.0;0.0', '', 0, 0, ''),
	(12713, 12713, '1', 'bc_stick*17', 'bc_stick*17', 'S', 1, 1, 4.00, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 5, '', '4.0;3.0;2.0;1.0;0.0', '', 0, 0, ''),
	(12714, 12714, '1', 'bc_stick*18', 'bc_stick*18', 'S', 1, 1, 4.00, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 5, '', '4.0;3.0;2.0;1.0;0.0', '', 0, 0, ''),
	(12715, 12715, '1', 'bc_stick*19', 'bc_stick*19', 'S', 1, 1, 4.00, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 5, '', '4.0;3.0;2.0;1.0;0.0', '', 0, 0, ''),
	(12716, 12716, '1', 'bc_stick*2', 'bc_stick*2', 'S', 1, 1, 4.00, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 5, '', '4.0;3.0;2.0;1.0;0.0', '', 0, 0, ''),
	(12717, 12717, '1', 'bc_stick*20', 'bc_stick*20', 'S', 1, 1, 4.00, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 5, '', '4.0;3.0;2.0;1.0;0.0', '', 0, 0, ''),
	(12718, 12718, '1', 'bc_stick*21', 'bc_stick*21', 'S', 1, 1, 4.00, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 5, '', '4.0;3.0;2.0;1.0;0.0', '', 0, 0, ''),
	(12719, 12719, '1', 'bc_stick*22', 'bc_stick*22', 'S', 1, 1, 4.00, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 5, '', '4.0;3.0;2.0;1.0;0.0', '', 0, 0, ''),
	(12720, 12720, '1', 'bc_stick*23', 'bc_stick*23', 'S', 1, 1, 4.00, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 5, '', '4.0;3.0;2.0;1.0;0.0', '', 0, 0, ''),
	(12721, 12721, '1', 'bc_stick*24', 'bc_stick*24', 'S', 1, 1, 4.00, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 5, '', '4.0;3.0;2.0;1.0;0.0', '', 0, 0, ''),
	(12722, 12722, '1', 'bc_stick*25', 'bc_stick*25', 'S', 1, 1, 4.00, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 5, '', '4.0;3.0;2.0;1.0;0.0', '', 0, 0, ''),
	(12723, 12723, '1', 'bc_stick*26', 'bc_stick*26', 'S', 1, 1, 4.00, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 5, '', '4.0;3.0;2.0;1.0;0.0', '', 0, 0, ''),
	(12724, 12724, '1', 'bc_stick*27', 'bc_stick*27', 'S', 1, 1, 4.00, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 5, '', '4.0;3.0;2.0;1.0;0.0', '', 0, 0, ''),
	(12725, 12725, '1', 'bc_stick*28', 'bc_stick*28', 'S', 1, 1, 4.00, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 5, '', '4.0;3.0;2.0;1.0;0.0', '', 0, 0, ''),
	(12726, 12726, '1', 'bc_stick*29', 'bc_stick*29', 'S', 1, 1, 4.00, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 5, '', '4.0;3.0;2.0;1.0;0.0', '', 0, 0, ''),
	(12727, 12727, '1', 'bc_stick*3', 'bc_stick*3', 'S', 1, 1, 4.00, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 5, '', '4.0;3.0;2.0;1.0;0.0', '', 0, 0, ''),
	(12728, 12728, '1', 'bc_stick*30', 'bc_stick*30', 'S', 1, 1, 4.00, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 5, '', '4.0;3.0;2.0;1.0;0.0', '', 0, 0, ''),
	(12729, 12729, '1', 'bc_stick*31', 'bc_stick*31', 'S', 1, 1, 4.00, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 5, '', '4.0;3.0;2.0;1.0;0.0', '', 0, 0, ''),
	(12730, 12730, '1', 'bc_stick*32', 'bc_stick*32', 'S', 1, 1, 4.00, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 5, '', '4.0;3.0;2.0;1.0;0.0', '', 0, 0, ''),
	(12731, 12731, '1', 'bc_stick*33', 'bc_stick*33', 'S', 1, 1, 4.00, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 5, '', '4.0;3.0;2.0;1.0;0.0', '', 0, 0, ''),
	(12732, 12732, '1', 'bc_stick*34', 'bc_stick*34', 'S', 1, 1, 4.00, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 5, '', '4.0;3.0;2.0;1.0;0.0', '', 0, 0, ''),
	(12733, 12733, '1', 'bc_stick*35', 'bc_stick*35', 'S', 1, 1, 4.00, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 5, '', '4.0;3.0;2.0;1.0;0.0', '', 0, 0, ''),
	(12734, 12734, '1', 'bc_stick*36', 'bc_stick*36', 'S', 1, 1, 4.00, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 5, '', '4.0;3.0;2.0;1.0;0.0', '', 0, 0, ''),
	(12735, 12735, '1', 'bc_stick*37', 'bc_stick*37', 'S', 1, 1, 4.00, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 5, '', '4.0;3.0;2.0;1.0;0.0', '', 0, 0, ''),
	(12736, 12736, '1', 'bc_stick*38', 'bc_stick*38', 'S', 1, 1, 4.00, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 5, '', '4.0;3.0;2.0;1.0;0.0', '', 0, 0, ''),
	(12737, 12737, '1', 'bc_stick*39', 'bc_stick*39', 'S', 1, 1, 4.00, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 5, '', '4.0;3.0;2.0;1.0;0.0', '', 0, 0, ''),
	(12738, 12738, '1', 'bc_stick*4', 'bc_stick*4', 'S', 1, 1, 4.00, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 5, '', '4.0;3.0;2.0;1.0;0.0', '', 0, 0, ''),
	(12739, 12739, '1', 'bc_stick*40', 'bc_stick*40', 'S', 1, 1, 4.00, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 5, '', '4.0;3.0;2.0;1.0;0.0', '', 0, 0, ''),
	(12740, 12740, '1', 'bc_stick*41', 'bc_stick*41', 'S', 1, 1, 4.00, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 5, '', '4.0;3.0;2.0;1.0;0.0', '', 0, 0, ''),
	(12741, 12741, '1', 'bc_stick*42', 'bc_stick*42', 'S', 1, 1, 4.00, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 5, '', '4.0;3.0;2.0;1.0;0.0', '', 0, 0, ''),
	(12742, 12742, '1', 'bc_stick*43', 'bc_stick*43', 'S', 1, 1, 4.00, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 5, '', '4.0;3.0;2.0;1.0;0.0', '', 0, 0, ''),
	(12743, 12743, '1', 'bc_stick*44', 'bc_stick*44', 'S', 1, 1, 4.00, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 5, '', '4.0;3.0;2.0;1.0;0.0', '', 0, 0, ''),
	(12744, 12744, '1', 'bc_stick*45', 'bc_stick*45', 'S', 1, 1, 4.00, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 5, '', '4.0;3.0;2.0;1.0;0.0', '', 0, 0, ''),
	(12745, 12745, '1', 'bc_stick*46', 'bc_stick*46', 'S', 1, 1, 4.00, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 5, '', '4.0;3.0;2.0;1.0;0.0', '', 0, 0, ''),
	(12746, 12746, '1', 'bc_stick*47', 'bc_stick*47', 'S', 1, 1, 4.00, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 5, '', '4.0;3.0;2.0;1.0;0.0', '', 0, 0, ''),
	(12747, 12747, '1', 'bc_stick*48', 'bc_stick*48', 'S', 1, 1, 4.00, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 5, '', '4.0;3.0;2.0;1.0;0.0', '', 0, 0, ''),
	(12748, 12748, '1', 'bc_stick*49', 'bc_stick*49', 'S', 1, 1, 4.00, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 5, '', '4.0;3.0;2.0;1.0;0.0', '', 0, 0, ''),
	(12749, 12749, '1', 'bc_stick*5', 'bc_stick*5', 'S', 1, 1, 4.00, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 5, '', '4.0;3.0;2.0;1.0;0.0', '', 0, 0, ''),
	(12750, 12750, '1', 'bc_stick*50', 'bc_stick*50', 'S', 1, 1, 4.00, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 5, '', '4.0;3.0;2.0;1.0;0.0', '', 0, 0, ''),
	(12751, 12751, '1', 'bc_stick*51', 'bc_stick*51', 'S', 1, 1, 4.00, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 5, '', '4.0;3.0;2.0;1.0;0.0', '', 0, 0, ''),
	(12752, 12752, '1', 'bc_stick*52', 'bc_stick*52', 'S', 1, 1, 4.00, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 5, '', '4.0;3.0;2.0;1.0;0.0', '', 0, 0, ''),
	(12753, 12753, '1', 'bc_stick*53', 'bc_stick*53', 'S', 1, 1, 4.00, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 5, '', '4.0;3.0;2.0;1.0;0.0', '', 0, 0, ''),
	(12754, 12754, '1', 'bc_stick*54', 'bc_stick*54', 'S', 1, 1, 4.00, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 5, '', '4.0;3.0;2.0;1.0;0.0', '', 0, 0, ''),
	(12755, 12755, '1', 'bc_stick*55', 'bc_stick*55', 'S', 1, 1, 4.00, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 5, '', '4.0;3.0;2.0;1.0;0.0', '', 0, 0, ''),
	(12756, 12756, '1', 'bc_stick*56', 'bc_stick*56', 'S', 1, 1, 4.00, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 5, '', '4.0;3.0;2.0;1.0;0.0', '', 0, 0, ''),
	(12757, 12757, '1', 'bc_stick*57', 'bc_stick*57', 'S', 1, 1, 4.00, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 5, '', '4.0;3.0;2.0;1.0;0.0', '', 0, 0, ''),
	(12758, 12758, '1', 'bc_stick*58', 'bc_stick*58', 'S', 1, 1, 4.00, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 5, '', '4.0;3.0;2.0;1.0;0.0', '', 0, 0, ''),
	(12759, 12759, '1', 'bc_stick*59', 'bc_stick*59', 'S', 1, 1, 4.00, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 5, '', '4.0;3.0;2.0;1.0;0.0', '', 0, 0, ''),
	(12760, 12760, '1', 'bc_stick*6', 'bc_stick*6', 'S', 1, 1, 4.00, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 5, '', '4.0;3.0;2.0;1.0;0.0', '', 0, 0, ''),
	(12761, 12761, '1', 'bc_stick*60', 'bc_stick*60', 'S', 1, 1, 4.00, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 5, '', '4.0;3.0;2.0;1.0;0.0', '', 0, 0, ''),
	(12762, 12762, '1', 'bc_stick*61', 'bc_stick*61', 'S', 1, 1, 4.00, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 5, '', '4.0;3.0;2.0;1.0;0.0', '', 0, 0, ''),
	(12763, 12763, '1', 'bc_stick*62', 'bc_stick*62', 'S', 1, 1, 4.00, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 5, '', '4.0;3.0;2.0;1.0;0.0', '', 0, 0, ''),
	(12764, 12764, '1', 'bc_stick*63', 'bc_stick*63', 'S', 1, 1, 4.00, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 5, '', '4.0;3.0;2.0;1.0;0.0', '', 0, 0, ''),
	(12765, 12765, '1', 'bc_stick*64', 'bc_stick*64', 'S', 1, 1, 4.00, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 5, '', '4.0;3.0;2.0;1.0;0.0', '', 0, 0, ''),
	(12766, 12766, '1', 'bc_stick*65', 'bc_stick*65', 'S', 1, 1, 4.00, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 5, '', '4.0;3.0;2.0;1.0;0.0', '', 0, 0, ''),
	(12767, 12767, '1', 'bc_stick*66', 'bc_stick*66', 'S', 1, 1, 4.00, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 5, '', '4.0;3.0;2.0;1.0;0.0', '', 0, 0, ''),
	(12768, 12768, '1', 'bc_stick*67', 'bc_stick*67', 'S', 1, 1, 4.00, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 5, '', '4.0;3.0;2.0;1.0;0.0', '', 0, 0, ''),
	(12769, 12769, '1', 'bc_stick*68', 'bc_stick*68', 'S', 1, 1, 4.00, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 5, '', '4.0;3.0;2.0;1.0;0.0', '', 0, 0, ''),
	(12770, 12770, '1', 'bc_stick*69', 'bc_stick*69', 'S', 1, 1, 4.00, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 5, '', '4.0;3.0;2.0;1.0;0.0', '', 0, 0, ''),
	(12771, 12771, '1', 'bc_stick*7', 'bc_stick*7', 'S', 1, 1, 4.00, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 5, '', '4.0;3.0;2.0;1.0;0.0', '', 0, 0, ''),
	(12772, 12772, '1', 'bc_stick*8', 'bc_stick*8', 'S', 1, 1, 4.00, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 5, '', '4.0;3.0;2.0;1.0;0.0', '', 0, 0, ''),
	(12773, 12773, '1', 'bc_stick*9', 'bc_stick*9', 'S', 1, 1, 4.00, '1', '0', '0', '1', '0', '0', '0', '0', '1', 'multiheight', 5, '', '4.0;3.0;2.0;1.0;0.0', '', 0, 0, ''),
	(12774, 12774, '1', 'bc_quartercircle*1', 'bc_quartercircle*1', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12775, 12775, '1', 'bc_quartercircle*10', 'bc_quartercircle*10', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12776, 12776, '1', 'bc_quartercircle*11', 'bc_quartercircle*11', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12777, 12777, '1', 'bc_quartercircle*12', 'bc_quartercircle*12', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12778, 12778, '1', 'bc_quartercircle*13', 'bc_quartercircle*13', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12779, 12779, '1', 'bc_quartercircle*14', 'bc_quartercircle*14', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12780, 12780, '1', 'bc_quartercircle*15', 'bc_quartercircle*15', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12781, 12781, '1', 'bc_quartercircle*16', 'bc_quartercircle*16', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12782, 12782, '1', 'bc_quartercircle*17', 'bc_quartercircle*17', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12783, 12783, '1', 'bc_quartercircle*18', 'bc_quartercircle*18', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12784, 12784, '1', 'bc_quartercircle*19', 'bc_quartercircle*19', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12785, 12785, '1', 'bc_quartercircle*2', 'bc_quartercircle*2', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12786, 12786, '1', 'bc_quartercircle*20', 'bc_quartercircle*20', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12787, 12787, '1', 'bc_quartercircle*21', 'bc_quartercircle*21', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12788, 12788, '1', 'bc_quartercircle*22', 'bc_quartercircle*22', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12789, 12789, '1', 'bc_quartercircle*23', 'bc_quartercircle*23', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12790, 12790, '1', 'bc_quartercircle*24', 'bc_quartercircle*24', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12791, 12791, '1', 'bc_quartercircle*25', 'bc_quartercircle*25', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12792, 12792, '1', 'bc_quartercircle*26', 'bc_quartercircle*26', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12793, 12793, '1', 'bc_quartercircle*27', 'bc_quartercircle*27', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12794, 12794, '1', 'bc_quartercircle*28', 'bc_quartercircle*28', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12795, 12795, '1', 'bc_quartercircle*29', 'bc_quartercircle*29', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12796, 12796, '1', 'bc_quartercircle*3', 'bc_quartercircle*3', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12797, 12797, '1', 'bc_quartercircle*30', 'bc_quartercircle*30', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12798, 12798, '1', 'bc_quartercircle*31', 'bc_quartercircle*31', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12799, 12799, '1', 'bc_quartercircle*32', 'bc_quartercircle*32', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12800, 12800, '1', 'bc_quartercircle*33', 'bc_quartercircle*33', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12801, 12801, '1', 'bc_quartercircle*34', 'bc_quartercircle*34', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12802, 12802, '1', 'bc_quartercircle*35', 'bc_quartercircle*35', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12803, 12803, '1', 'bc_quartercircle*36', 'bc_quartercircle*36', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12804, 12804, '1', 'bc_quartercircle*37', 'bc_quartercircle*37', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12805, 12805, '1', 'bc_quartercircle*38', 'bc_quartercircle*38', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12806, 12806, '1', 'bc_quartercircle*39', 'bc_quartercircle*39', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12807, 12807, '1', 'bc_quartercircle*4', 'bc_quartercircle*4', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12808, 12808, '1', 'bc_quartercircle*40', 'bc_quartercircle*40', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12809, 12809, '1', 'bc_quartercircle*41', 'bc_quartercircle*41', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12810, 12810, '1', 'bc_quartercircle*42', 'bc_quartercircle*42', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12811, 12811, '1', 'bc_quartercircle*43', 'bc_quartercircle*43', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12812, 12812, '1', 'bc_quartercircle*44', 'bc_quartercircle*44', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12813, 12813, '1', 'bc_quartercircle*45', 'bc_quartercircle*45', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12814, 12814, '1', 'bc_quartercircle*46', 'bc_quartercircle*46', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12815, 12815, '1', 'bc_quartercircle*47', 'bc_quartercircle*47', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12816, 12816, '1', 'bc_quartercircle*48', 'bc_quartercircle*48', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12817, 12817, '1', 'bc_quartercircle*49', 'bc_quartercircle*49', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12818, 12818, '1', 'bc_quartercircle*5', 'bc_quartercircle*5', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12819, 12819, '1', 'bc_quartercircle*50', 'bc_quartercircle*50', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12820, 12820, '1', 'bc_quartercircle*51', 'bc_quartercircle*51', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12821, 12821, '1', 'bc_quartercircle*52', 'bc_quartercircle*52', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12822, 12822, '1', 'bc_quartercircle*53', 'bc_quartercircle*53', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12823, 12823, '1', 'bc_quartercircle*54', 'bc_quartercircle*54', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12824, 12824, '1', 'bc_quartercircle*55', 'bc_quartercircle*55', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12825, 12825, '1', 'bc_quartercircle*56', 'bc_quartercircle*56', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12826, 12826, '1', 'bc_quartercircle*57', 'bc_quartercircle*57', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12827, 12827, '1', 'bc_quartercircle*58', 'bc_quartercircle*58', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12828, 12828, '1', 'bc_quartercircle*59', 'bc_quartercircle*59', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12829, 12829, '1', 'bc_quartercircle*6', 'bc_quartercircle*6', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12830, 12830, '1', 'bc_quartercircle*60', 'bc_quartercircle*60', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12831, 12831, '1', 'bc_quartercircle*61', 'bc_quartercircle*61', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12832, 12832, '1', 'bc_quartercircle*62', 'bc_quartercircle*62', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12833, 12833, '1', 'bc_quartercircle*63', 'bc_quartercircle*63', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12834, 12834, '1', 'bc_quartercircle*64', 'bc_quartercircle*64', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12835, 12835, '1', 'bc_quartercircle*65', 'bc_quartercircle*65', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12836, 12836, '1', 'bc_quartercircle*66', 'bc_quartercircle*66', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12837, 12837, '1', 'bc_quartercircle*67', 'bc_quartercircle*67', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12838, 12838, '1', 'bc_quartercircle*68', 'bc_quartercircle*68', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12839, 12839, '1', 'bc_quartercircle*69', 'bc_quartercircle*69', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12840, 12840, '1', 'bc_quartercircle*7', 'bc_quartercircle*7', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12841, 12841, '1', 'bc_quartercircle*8', 'bc_quartercircle*8', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12842, 12842, '1', 'bc_quartercircle*9', 'bc_quartercircle*9', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12843, 12843, '0', 'bc_sphere_small*1', 'bc_sphere_small*1', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12844, 12844, '0', 'bc_sphere_small*10', 'bc_sphere_small*10', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12845, 12845, '0', 'bc_sphere_small*11', 'bc_sphere_small*11', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12846, 12846, '0', 'bc_sphere_small*12', 'bc_sphere_small*12', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12847, 12847, '0', 'bc_sphere_small*13', 'bc_sphere_small*13', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12848, 12848, '0', 'bc_sphere_small*14', 'bc_sphere_small*14', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12849, 12849, '0', 'bc_sphere_small*15', 'bc_sphere_small*15', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12850, 12850, '0', 'bc_sphere_small*16', 'bc_sphere_small*16', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12851, 12851, '0', 'bc_sphere_small*17', 'bc_sphere_small*17', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12852, 12852, '0', 'bc_sphere_small*18', 'bc_sphere_small*18', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12853, 12853, '0', 'bc_sphere_small*19', 'bc_sphere_small*19', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12854, 12854, '0', 'bc_sphere_small*2', 'bc_sphere_small*2', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12855, 12855, '0', 'bc_sphere_small*20', 'bc_sphere_small*20', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12856, 12856, '0', 'bc_sphere_small*21', 'bc_sphere_small*21', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12857, 12857, '0', 'bc_sphere_small*22', 'bc_sphere_small*22', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12858, 12858, '0', 'bc_sphere_small*23', 'bc_sphere_small*23', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12859, 12859, '0', 'bc_sphere_small*24', 'bc_sphere_small*24', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12860, 12860, '0', 'bc_sphere_small*25', 'bc_sphere_small*25', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12861, 12861, '0', 'bc_sphere_small*26', 'bc_sphere_small*26', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12862, 12862, '0', 'bc_sphere_small*27', 'bc_sphere_small*27', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12863, 12863, '0', 'bc_sphere_small*28', 'bc_sphere_small*28', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12864, 12864, '0', 'bc_sphere_small*29', 'bc_sphere_small*29', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12865, 12865, '0', 'bc_sphere_small*3', 'bc_sphere_small*3', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12866, 12866, '0', 'bc_sphere_small*30', 'bc_sphere_small*30', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12867, 12867, '0', 'bc_sphere_small*31', 'bc_sphere_small*31', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12868, 12868, '0', 'bc_sphere_small*32', 'bc_sphere_small*32', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12869, 12869, '0', 'bc_sphere_small*33', 'bc_sphere_small*33', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12870, 12870, '0', 'bc_sphere_small*34', 'bc_sphere_small*34', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12871, 12871, '0', 'bc_sphere_small*35', 'bc_sphere_small*35', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12872, 12872, '0', 'bc_sphere_small*36', 'bc_sphere_small*36', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12873, 12873, '0', 'bc_sphere_small*37', 'bc_sphere_small*37', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12874, 12874, '0', 'bc_sphere_small*38', 'bc_sphere_small*38', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12875, 12875, '0', 'bc_sphere_small*39', 'bc_sphere_small*39', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12876, 12876, '0', 'bc_sphere_small*4', 'bc_sphere_small*4', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12877, 12877, '0', 'bc_sphere_small*40', 'bc_sphere_small*40', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12878, 12878, '0', 'bc_sphere_small*41', 'bc_sphere_small*41', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12879, 12879, '0', 'bc_sphere_small*42', 'bc_sphere_small*42', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12880, 12880, '0', 'bc_sphere_small*43', 'bc_sphere_small*43', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12881, 12881, '0', 'bc_sphere_small*44', 'bc_sphere_small*44', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12882, 12882, '0', 'bc_sphere_small*45', 'bc_sphere_small*45', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12883, 12883, '0', 'bc_sphere_small*46', 'bc_sphere_small*46', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12884, 12884, '0', 'bc_sphere_small*47', 'bc_sphere_small*47', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12885, 12885, '0', 'bc_sphere_small*48', 'bc_sphere_small*48', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12886, 12886, '0', 'bc_sphere_small*49', 'bc_sphere_small*49', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12887, 12887, '0', 'bc_sphere_small*5', 'bc_sphere_small*5', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12888, 12888, '0', 'bc_sphere_small*50', 'bc_sphere_small*50', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12889, 12889, '0', 'bc_sphere_small*51', 'bc_sphere_small*51', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12890, 12890, '0', 'bc_sphere_small*52', 'bc_sphere_small*52', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12891, 12891, '0', 'bc_sphere_small*53', 'bc_sphere_small*53', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12892, 12892, '0', 'bc_sphere_small*54', 'bc_sphere_small*54', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12893, 12893, '0', 'bc_sphere_small*55', 'bc_sphere_small*55', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12894, 12894, '0', 'bc_sphere_small*56', 'bc_sphere_small*56', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12895, 12895, '0', 'bc_sphere_small*57', 'bc_sphere_small*57', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12896, 12896, '0', 'bc_sphere_small*58', 'bc_sphere_small*58', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12897, 12897, '0', 'bc_sphere_small*59', 'bc_sphere_small*59', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12898, 12898, '0', 'bc_sphere_small*6', 'bc_sphere_small*6', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12899, 12899, '0', 'bc_sphere_small*60', 'bc_sphere_small*60', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12900, 12900, '0', 'bc_sphere_small*61', 'bc_sphere_small*61', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12901, 12901, '0', 'bc_sphere_small*62', 'bc_sphere_small*62', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12902, 12902, '0', 'bc_sphere_small*63', 'bc_sphere_small*63', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12903, 12903, '0', 'bc_sphere_small*64', 'bc_sphere_small*64', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12904, 12904, '0', 'bc_sphere_small*65', 'bc_sphere_small*65', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12905, 12905, '0', 'bc_sphere_small*66', 'bc_sphere_small*66', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12906, 12906, '0', 'bc_sphere_small*67', 'bc_sphere_small*67', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12907, 12907, '0', 'bc_sphere_small*68', 'bc_sphere_small*68', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12908, 12908, '0', 'bc_sphere_small*69', 'bc_sphere_small*69', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12909, 12909, '0', 'bc_sphere_small*7', 'bc_sphere_small*7', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12910, 12910, '0', 'bc_sphere_small*8', 'bc_sphere_small*8', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12911, 12911, '0', 'bc_sphere_small*9', 'bc_sphere_small*9', 'S', 1, 1, 0.00, '1', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12912, 12912, '0', 'clothing_r22_bigflowercrown', 'clothing_r22_bigflowercrown', 'S', 1, 1, 1.00, '0', '0', '0', '0', '0', '0', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(12913, 12913, '0', 'clothing_r22_bouquetdress', 'clothing_r22_bouquetdress', 'S', 1, 1, 2.70, '0', '0', '0', '0', '0', '0', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(12914, 12914, '0', 'rare_r22_topiaryanimals', 'rare_r22_topiaryanimals', 'S', 1, 1, 1.00, '0', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 6, '', '', '', 0, 0, ''),
	(12915, 12915, '0', 'rare_r22_fancyfountain', 'rare_r22_fancyfountain', 'S', 2, 2, 1.00, '0', '0', '0', '0', '0', '0', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(12916, 12916, '0', 'easter_c22_titanarumplant', 'easter_c22_titanarumplant', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12917, 12917, '0', 'easter_c22_scarab1', 'easter_c22_scarab1', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(12918, 12918, '0', 'easter_ltd22_butterflyenclosure', 'easter_ltd22_butterflyenclosure', 'S', 1, 1, 0.60, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12919, 12919, '0', 'easter_c22_rockerylight', 'easter_c22_rockerylight', 'S', 2, 2, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 3, '', '', '1', 0, 0, ''),
	(12920, 12920, '0', 'easter_c22_hangingvines', 'easter_c22_hangingvines', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(12921, 12921, '0', 'easter_c22_mantis1', 'easter_c22_mantis1', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(12922, 12922, '0', 'easter_c22_aerialbugs2', 'easter_c22_aerialbugs2', 'S', 1, 1, 1.40, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'crackable', 3, '', '', '', 0, 0, ''),
	(12923, 12923, '0', 'easter_c22_groundbugs2b', 'easter_c22_groundbugs2b', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12924, 12924, '0', 'clothing_snailfriend2', 'clothing_snailfriend2', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(12925, 12925, '0', 'easter_c22_kioskshop', 'easter_c22_kioskshop', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12926, 12926, '0', 'easter_c22_sawstagbeetle2', 'easter_c22_sawstagbeetle2', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12927, 12927, '0', 'easter_c22_deluxebugkitb', 'easter_c22_deluxebugkitb', 'S', 1, 1, 1.10, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12928, 12928, '0', 'easter_c22_bioworldwall', 'easter_c22_bioworldwall', 'S', 2, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12929, 12929, '0', 'easter_c22_caterpillar2', 'easter_c22_caterpillar2', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12930, 12930, '0', 'easter_c22_apparelbagb', 'easter_c22_apparelbagb', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12931, 12931, '0', 'easter_c22_groundbugs4b', 'easter_c22_groundbugs4b', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12932, 12932, '0', 'easter_c22_caterpillar1', 'easter_c22_caterpillar1', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12933, 12933, '0', 'clothing_butterflyhair', 'clothing_butterflyhair', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(12934, 12934, '0', 'easter_c22_bioworldwall2', 'easter_c22_bioworldwall2', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12935, 12935, '0', 'easter_c22_apparelbag', 'easter_c22_apparelbag', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'crackable', 3, '', '', '', 0, 0, ''),
	(12936, 12936, '0', 'easter_c22_pathlight', 'easter_c22_pathlight', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(12937, 12937, '0', 'easter_c22_rockdecor', 'easter_c22_rockdecor', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(12938, 12938, '0', 'clothing_r22_beetle', 'clothing_r22_beetle', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(12939, 12939, '0', 'easter_c22_groundbugs1', 'easter_c22_groundbugs1', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(12940, 12940, '0', 'clothing_ladybirdbag', 'clothing_ladybirdbag', 'S', 1, 1, 2.65, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 1, '', '', '', 0, 0, ''),
	(12941, 12941, '0', 'easter_c22_agrias1', 'easter_c22_agrias1', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12942, 12942, '0', 'easter_c22_rockerydark', 'easter_c22_rockerydark', 'S', 2, 2, 1.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'multiheight', 4, '', '', '1', 0, 0, ''),
	(12943, 12943, '0', 'easter_c22_ladybird2', 'easter_c22_ladybird2', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(12944, 12944, '0', 'easter_c22_rafflesia', 'easter_c22_rafflesia', 'S', 1, 1, 1.30, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(12945, 12945, '0', 'easter_c22_tree', 'easter_c22_tree', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(12946, 12946, '0', 'easter_c22_redtippedplant', 'easter_c22_redtippedplant', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(12947, 12947, '0', 'easter_c22_rockfloor', 'easter_c22_rockfloor', 'S', 2, 2, 0.20, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12948, 12948, '0', 'easter_c22_ladybird1', 'easter_c22_ladybird1', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(12949, 12949, '0', 'easter_c22_ropedivider', 'easter_c22_ropedivider', 'S', 2, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12950, 12950, '0', 'easter_c22_aerialbugs2b', 'easter_c22_aerialbugs2b', 'S', 1, 1, 1.40, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12951, 12951, '0', 'easter_c22_roundpalm', 'easter_c22_roundpalm', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12952, 12952, '0', 'clothing_snailfriend', 'clothing_snailfriend', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(12953, 12953, '0', 'clothing_r22_mothoutfit', 'clothing_r22_mothoutfit', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(12954, 12954, '0', 'easter_r22_boutiquecoffee', 'easter_r22_boutiquecoffee', 'S', 3, 2, 3.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(12955, 12955, '0', 'easter_c22_pottingtable', 'easter_c22_pottingtable', 'S', 1, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12956, 12956, '0', 'easter_c22_waterfeature', 'easter_c22_waterfeature', 'S', 2, 2, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12957, 12957, '0', 'easter_c22_tallgrass', 'easter_c22_tallgrass', 'S', 1, 1, 0.00, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12958, 12958, '0', 'easter_c22_groundbugs2', 'easter_c22_groundbugs2', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(12959, 12959, '0', 'easter_c22_scarab2', 'easter_c22_scarab2', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(12960, 12960, '0', 'easter_c22_barrelcactus', 'easter_c22_barrelcactus', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12961, 12961, '0', 'easter_c22_dragonfly1', 'easter_c22_dragonfly1', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(12962, 12962, '0', 'clothing_net', 'clothing_net', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 1, '', '', '', 0, 0, ''),
	(12963, 12963, '0', 'easter_c22_dirtfloor', 'easter_c22_dirtfloor', 'S', 2, 2, 0.10, '1', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(12964, 12964, '0', 'easter_c22_deluxebugkit', 'easter_c22_deluxebugkit', 'S', 1, 1, 1.10, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(12965, 12965, '0', 'easter_c22_bugkitb', 'easter_c22_bugkitb', 'S', 1, 1, 1.10, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12966, 12966, '0', 'easter_c22_goliathbeetle2', 'easter_c22_goliathbeetle2', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12967, 12967, '0', 'easter_c22_beehotel', 'easter_c22_beehotel', 'S', 1, 1, 2.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12968, 12968, '0', 'easter_c22_driftwood', 'easter_c22_driftwood', 'S', 3, 1, 0.70, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(12969, 12969, '0', 'easter_c22_giantbee', 'easter_c22_giantbee', 'S', 1, 2, 1.80, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12970, 12970, '0', 'easter_c22_agrias2', 'easter_c22_agrias2', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12971, 12971, '0', 'easter_c22_groundbugs4', 'easter_c22_groundbugs4', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(12972, 12972, '0', 'easter_c22_sawstagbeetle1', 'easter_c22_sawstagbeetle1', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12973, 12973, '0', 'easter_c22_aerialbugs1b', 'easter_c22_aerialbugs1b', 'S', 1, 1, 1.40, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12974, 12974, '0', 'easter_c22_goliathbeetle1', 'easter_c22_goliathbeetle1', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12975, 12975, '0', 'easter_c22_aerialbugs1', 'easter_c22_aerialbugs1', 'S', 1, 1, 1.40, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'crackable', 3, '', '', '', 0, 0, ''),
	(12976, 12976, '0', 'easter_c22_bugkit', 'easter_c22_bugkit', 'S', 1, 1, 1.10, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'crackable', 1, '', '', '', 0, 0, ''),
	(12977, 12977, '0', 'easter_c22_groundbugs3', 'easter_c22_groundbugs3', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'crackable', 2, '', '', '', 0, 0, ''),
	(12978, 12978, '0', 'clothing_beetshirt', 'clothing_beetshirt', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(12979, 12979, '0', 'easter_c22_groundbugs3b', 'easter_c22_groundbugs3b', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12980, 12980, '0', 'easter_c22_morpho1', 'easter_c22_morpho1', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12981, 12981, '0', 'easter_c22_fossilbench', 'easter_c22_fossilbench', 'S', 2, 1, 1.30, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12982, 12982, '0', 'easter_c22_morpho2', 'easter_c22_morpho2', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12983, 12983, '0', 'easter_c22_mantis2', 'easter_c22_mantis2', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(12984, 12984, '0', 'easter_c22_groundbugs1b', 'easter_c22_groundbugs1b', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12985, 12985, '0', 'clothing_explorersoutfit', 'clothing_explorersoutfit', 'S', 1, 1, 2.70, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(12986, 12986, '0', 'easter_c22_fanpalm', 'easter_c22_fanpalm', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12987, 12987, '0', 'easter_r22_caterpillarsleepingbag', 'easter_r22_caterpillarsleepingbag', 'S', 1, 3, 1.00, '0', '0', '1', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12988, 12988, '0', 'easter_c22_informationboard', 'easter_c22_informationboard', 'S', 2, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 6, '', '', '', 0, 0, ''),
	(12989, 12989, '0', 'easter_c22_dragonfly2', 'easter_c22_dragonfly2', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(12990, 12990, '0', 'rela_candle4', 'rela_candle4', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(12991, 12991, '0', 'sanrio_c22_badtzdesk', 'sanrio_c22_badtzdesk', 'S', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(12992, 12992, '0', 'sanrio_c22_badtzendtable', 'sanrio_c22_badtzendtable', 'S', 1, 1, 1.30, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(12993, 12993, '0', 'sanrio_c22_badtzcake', 'sanrio_c22_badtzcake', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(12994, 12994, '0', 'clothing_badtzshirt', 'clothing_badtzshirt', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(12995, 12995, '0', 'sanrio_c22_badtzlamp', 'sanrio_c22_badtzlamp', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(12996, 12996, '0', 'clothing_badtzbackpack', 'clothing_badtzbackpack', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(12997, 12997, '0', 'nft_hologram1', 'nft_hologram1', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(12998, 12998, '0', 'nft_hologram3', 'nft_hologram3', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(12999, 12999, '0', 'nft_hologram2', 'nft_hologram2', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(13000, 13000, '0', 'nft_hologram4', 'nft_hologram4', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(13001, 13001, '0', 'bonusrare22_4*1', 'bonusrare22_4*1', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(13002, 13002, '0', 'bonusrare22_4*2', 'bonusrare22_4*2', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(13003, 13003, '0', 'bonusrare22_4*3', 'bonusrare22_4*3', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(13004, 13004, '0', 'bonusrare22_4*4', 'bonusrare22_4*4', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(13005, 13005, '0', 'bonusrare22_4*5', 'bonusrare22_4*5', 'S', 1, 1, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(13006, 13006, '0', 'ads_teletubbies_plushie3', 'ads_teletubbies_plushie3', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(13007, 13007, '0', 'clothing_headband_laalaa', 'clothing_headband_laalaa', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(13008, 13008, '0', 'ads_teletubbies_beanbag3', 'ads_teletubbies_beanbag3', 'S', 1, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(13009, 13009, '0', 'ads_teletubbies_plushie1', 'ads_teletubbies_plushie1', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(13010, 13010, '0', 'ads_teletubbies_plushie2', 'ads_teletubbies_plushie2', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(13011, 13011, '0', 'clothing_headband_dipsy', 'clothing_headband_dipsy', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(13012, 13012, '0', 'clothing_headband_po', 'clothing_headband_po', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(13013, 13013, '0', 'ads_teletubbies_beanbag4', 'ads_teletubbies_beanbag4', 'S', 1, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(13014, 13014, '0', 'clothing_dipsyhat', 'clothing_dipsyhat', 'S', 1, 1, 1.50, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(13015, 13015, '0', 'ads_teletubbies_plushie4', 'ads_teletubbies_plushie4', 'S', 1, 1, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(13016, 13016, '0', 'ads_teletubbies_beanbag2', 'ads_teletubbies_beanbag2', 'S', 1, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(13017, 13017, '0', 'clothing_headband_tinkywinky', 'clothing_headband_tinkywinky', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(13018, 13018, '0', 'ads_teletubbies_beanbag1', 'ads_teletubbies_beanbag1', 'S', 1, 1, 1.10, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(13019, 13019, '0', 'clothing_ukrainesupport', 'clothing_ukrainesupport', 'S', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'clothing', 2, '', '', '', 0, 0, ''),
	(13020, 13020, '0', 'nft_credit_100', 'nft_credit_100', 'S', 1, 1, 1.30, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(13021, 13021, '0', 'nft_credit_50', 'nft_credit_50', 'S', 1, 1, 1.30, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(13022, 13022, '0', 'nft_credit_1000', 'nft_credit_1000', 'S', 1, 1, 1.30, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(13023, 13023, '0', 'nft_credit_10', 'nft_credit_10', 'S', 1, 1, 1.30, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(13024, 13024, '0', 'nft_credit_500', 'nft_credit_500', 'S', 1, 1, 1.30, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(19894, 3002, '0', 'floor', 'floor', 'I', 2, 2, 1.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'roomeffect', 1, '', '', '', 0, 0, ''),
	(19896, 3001, '0', 'wallpaper', 'wallpaper', 'I', 1, 1, 1.00, '0', '0', '0', '1', '1', '0', '0', '0', '0', 'roomeffect', 1, '', '', '', 0, 0, ''),
	(19926, 4055, '1', 'landscape', 'landscape', 'I', 1, 1, 1.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'roomeffect', 1, '', '', '', 0, 0, ''),
	(20060, 20060, '0', 'DEAL_HC_1', 'DEAL_HC_1', 'H', 0, 0, 0.00, '0', '0', '0', '0', '0', '0', '0', '0', '0', 'default', 1, '', '', '', 0, 0, ''),
	(20070, 20070, '0', 'builders_club_1_month', 'builders_club_1_month', 'G', 0, 0, 0.00, '0', '0', '0', '0', '0', '0', '0', '0', '0', 'default', 1, '', '', '', 0, 0, ''),
	(20100, 2010, '0', 'Poker', 'Poker', 'I', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40010, 4001, '1', 'poster', 'poster', 'I', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '0', 'default', 1, '', '', '', 0, 0, ''),
	(40020, 4002, '0', 'gothicfountain', 'gothicfountain', 'I', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40030, 4003, '0', 'hc_wall_lamp', 'hc_wall_lamp', 'I', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40040, 4004, '0', 'industrialfan', 'industrialfan', 'I', 1, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40050, 4005, '1', 'torch', 'torch', 'I', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40060, 4006, '0', 'val_heart', 'val_heart', 'I', 2, 2, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40070, 4007, '1', 'wallmirror', 'wallmirror', 'I', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40080, 4008, '1', 'jp_ninjastars', 'jp_ninjastars', 'I', 1, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40090, 4009, '1', 'habw_mirror', 'habw_mirror', 'I', 2, 2, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40100, 4010, '0', 'habbowheel', 'habbowheel', 'I', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'colorwheel', 10, '', '', '', 0, 0, ''),
	(40110, 4011, '0', 'guitar_skull', 'guitar_skull', 'I', 2, 2, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40120, 4012, '0', 'guitar_v', 'guitar_v', 'I', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40130, 4013, '0', 'hrella_poster_2', 'hrella_poster_2', 'I', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40140, 4014, '0', 'hrella_poster_1', 'hrella_poster_1', 'I', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40150, 4015, '0', 'xmas_light', 'xmas_light', 'I', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40160, 4016, '0', 'hrella_poster_3', 'hrella_poster_3', 'I', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40170, 4017, '0', 'sw_swords', 'sw_swords', 'I', 1, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40180, 4018, '0', 'sw_stone', 'sw_stone', 'I', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40190, 4019, '0', 'sw_hole', 'sw_hole', 'I', 1, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40200, 4020, '1', 'arabian_swords', 'arabian_swords', 'I', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40210, 4021, '1', 'jp_sheet3', 'jp_sheet3', 'I', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40220, 4022, '1', 'arabian_wndw', 'arabian_wndw', 'I', 2, 2, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40230, 4023, '0', 'md_logo_wall', 'md_logo_wall', 'I', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40240, 4024, '1', 'jp_sheet1', 'jp_sheet1', 'I', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40250, 4025, '0', 'md_can', 'md_can', 'I', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40260, 4026, '1', 'jp_sheet2', 'jp_sheet2', 'I', 1, 2, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40270, 4027, '0', 'roomdimmer', 'roomdimmer', 'I', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'dimmer', 1, '', '', '', 0, 0, ''),
	(40280, 4028, '1', 'tiki_surfboard', 'tiki_surfboard', 'I', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 9, '', '', '', 0, 0, ''),
	(40290, 4029, '0', 'tampax_wall', 'tampax_wall', 'I', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40300, 4030, '1', 'tiki_wallplnt', 'tiki_wallplnt', 'I', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40310, 4031, '1', 'window_single_default', 'window_single_default', 'I', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40320, 4032, '1', 'window_double_default', 'window_double_default', 'I', 2, 2, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40330, 4033, '0', 'noob_window_double', 'noob_window_double', 'I', 1, 1, 1.00, '0', '1', '0', '0', '1', '0', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40340, 4034, '1', 'window_chinese_wide', 'window_chinese_wide', 'I', 2, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40350, 4035, '1', 'window_golden', 'window_golden', 'I', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40360, 4036, '1', 'window_square', 'window_square', 'I', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40370, 4037, '1', 'window_romantic_narrow', 'window_romantic_narrow', 'I', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40380, 4038, '1', 'window_chinese_narrow', 'window_chinese_narrow', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40390, 4039, '1', 'window_70s_wide', 'window_70s_wide', 'I', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40400, 4040, '1', 'window_70s_narrow', 'window_70s_narrow', 'I', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40410, 4041, '1', 'window_romantic_wide', 'window_romantic_wide', 'I', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40420, 4042, '1', 'window_basic', 'window_basic', 'I', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40430, 4043, '0', 'ads_sunnyd', 'ads_sunnyd', 'I', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40440, 4044, '1', 'window_grunge', 'window_grunge', 'I', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40450, 4045, '1', 'window_triple', 'window_triple', 'I', 2, 3, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40460, 4046, '1', 'window_diner2', 'window_diner2', 'I', 2, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40470, 4047, '0', 'ads_dave_wall', 'ads_dave_wall', 'I', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40480, 4048, '0', 'diner_walltable', 'diner_walltable', 'I', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40490, 4049, '1', 'window_diner', 'window_diner', 'I', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40500, 4050, '0', 'ads_nokia_logo', 'ads_nokia_logo', 'I', 3, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40510, 4051, '0', 'easy_poster', 'easy_poster', 'I', 2, 3, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40520, 4052, '1', 'window_hole', 'window_hole', 'I', 1, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40530, 4053, '0', 'ads_nokia_phone', 'ads_nokia_phone', 'I', 1, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40540, 4054, '1', 'window_skyscraper', 'window_skyscraper', 'I', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40560, 4056, '1', 'det_bhole', 'det_bhole', 'I', 2, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(40570, 4057, '0', 'netari_poster', 'netari_poster', 'I', 3, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40580, 4058, '0', 'ads_campguitar', 'ads_campguitar', 'I', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40590, 4059, '0', 'hween08_rad', 'hween08_rad', 'I', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40600, 4060, '0', 'hw_08_xray', 'hw_08_xray', 'I', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(40610, 4061, '0', 'hween08_wndwb', 'hween08_wndwb', 'I', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40620, 4062, '0', 'hween08_wndw', 'hween08_wndw', 'I', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40630, 4063, '0', 'hween08_bio', 'hween08_bio', 'I', 3, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40640, 4064, '0', 'hw08_xray', 'hw08_xray', 'I', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(40650, 4065, '0', 'gothicfountain2', 'gothicfountain2', 'I', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40660, 4066, '1', 'party_led', 'party_led', 'I', 3, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(40670, 4067, '0', 'ads_cmusic', 'ads_cmusic', 'I', 1, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40680, 4068, '1', 'party_wc_girl', 'party_wc_girl', 'I', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40690, 4069, '0', 'party_neon1', 'party_neon1', 'I', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(40700, 4070, '1', 'party_wc_boy', 'party_wc_boy', 'I', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40710, 4071, '1', 'party_shelf', 'party_shelf', 'I', 2, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(40720, 4072, '1', 'party_neon4', 'party_neon4', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(40730, 4073, '1', 'party_neon2', 'party_neon2', 'I', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(40740, 4074, '0', 'party_neon5', 'party_neon5', 'I', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(40750, 4075, '1', 'party_neon3', 'party_neon3', 'I', 3, 3, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40760, 4076, '0', 'xmas08_icewall', 'xmas08_icewall', 'I', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(40770, 4077, '0', 'xmas08_wallpaper', 'xmas08_wallpaper', 'I', 1, 1, 1.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'roomeffect', 6, '', '', '', 0, 0, ''),
	(40780, 4078, '0', 'ads_clwall2', 'ads_clwall2', 'I', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40790, 4079, '0', 'ads_clwall3', 'ads_clwall3', 'I', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40800, 4080, '0', 'xmas_icewall', 'xmas_icewall', 'I', 1, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(40810, 4081, '0', 'ads_ob_wall', 'ads_ob_wall', 'I', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40820, 4082, '0', 'ads_clwall1', 'ads_clwall1', 'I', 1, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40830, 4083, '0', 'ads_mall_window', 'ads_mall_window', 'I', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40840, 4084, '0', 'china_pstr1', 'china_pstr1', 'I', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40850, 4085, '0', 'china_pstr2', 'china_pstr2', 'I', 1, 2, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40860, 4086, '0', 'china_light', 'china_light', 'I', 2, 1, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40870, 4087, '1', 'bolly_wdw_wd', 'bolly_wdw_wd', 'I', 4, 4, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(40880, 4088, '0', 'ads_idol_wall', 'ads_idol_wall', 'I', 5, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(40890, 4089, '0', 'ads_igorevilb', 'ads_igorevilb', 'I', 1, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40900, 4090, '0', 'ads_igor_wall', 'ads_igor_wall', 'I', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40910, 4091, '0', 'ads_mall_winpet', 'ads_mall_winpet', 'I', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40920, 4092, '0', 'ads_mall_winfur', 'ads_mall_winfur', 'I', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40930, 4093, '0', 'ads_idol_tv', 'ads_idol_tv', 'I', 3, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40940, 4094, '1', 'lc_window1', 'lc_window1', 'I', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40950, 4095, '1', 'lc_wall1', 'lc_wall1', 'I', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40960, 4096, '1', 'lc_window2', 'lc_window2', 'I', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40970, 4097, '1', 'lc_wall2', 'lc_wall2', 'I', 1, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40980, 4098, '0', 'ads_mall_wincin', 'ads_mall_wincin', 'I', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(40990, 4099, '0', 'ads_idol_mirror', 'ads_idol_mirror', 'I', 1, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(41000, 4100, '0', 'ads_mall_winbea', 'ads_mall_winbea', 'I', 1, 1, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(41010, 4101, '0', 'ads_mall_winmus', 'ads_mall_winmus', 'I', 2, 2, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(41020, 4102, '0', 'eco_curtains2', 'eco_curtains2', 'I', 2, 3, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(41030, 4103, '0', 'ads_mall_winchi', 'ads_mall_winchi', 'I', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(41040, 4104, '0', 'eco_curtains3', 'eco_curtains3', 'I', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(41050, 4105, '0', 'eco_curtains1', 'eco_curtains1', 'I', 2, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(41060, 4106, '0', 'ads_mall_winspo', 'ads_mall_winspo', 'I', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(41070, 4107, '1', 'exe_wfall', 'exe_wfall', 'I', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(41080, 4108, '0', 'ads_idol_logo', 'ads_idol_logo', 'I', 2, 2, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(41090, 4109, '0', 'ads_mall_winice', 'ads_mall_winice', 'I', 2, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(41100, 4110, '1', 'exe_map', 'exe_map', 'I', 1, 1, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(41110, 4111, '0', 'ads_puffet_tv', 'ads_puffet_tv', 'I', 1, 0, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(41120, 4112, '0', 'ads_reebok_tv', 'ads_reebok_tv', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(41130, 4113, '0', 'ads_malaco_tv', 'ads_malaco_tv', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(41140, 4114, '1', 'country_forestwall', 'country_forestwall', 'I', 0, 0, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(41150, 4115, '0', 'ads_lin_wh_c', 'ads_lin_wh_c', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'colorwheel', 10, '', '', '', 0, 0, ''),
	(41160, 4116, '1', 'country_lantern', 'country_lantern', 'I', 0, 0, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(41170, 4117, '1', 'country_fp', 'country_fp', 'I', 0, 0, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(41180, 4118, '1', 'country_wall', 'country_wall', 'I', 0, 0, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(41190, 4119, '1', 'flag_norway', 'flag_norway', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(41200, 4120, '0', 'diner_poster', 'diner_poster', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(41210, 4121, '1', 'lt_jngl_wall', 'lt_jngl_wall', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(41220, 4122, '0', 'ads_mirror', 'ads_mirror', 'I', 0, 0, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(41230, 4123, '1', 'lt_wall', 'lt_wall', 'I', 0, 0, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(42200, 4220, '0', 'post_it_vd', 'post_it_vd', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'postit', 2, '', '', '', 0, 0, ''),
	(42210, 4221, '0', 'post_it', 'post_it', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'postit', 2, '', '', '', 0, 0, ''),
	(42220, 4222, '0', 'ads_veet', 'ads_veet', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(42230, 4223, '1', 'sf_wall3', 'sf_wall3', 'I', 0, 0, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(42240, 4224, '1', 'sf_window', 'sf_window', 'I', 0, 0, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(42250, 4225, '0', 'ads_mall_wintra', 'ads_mall_wintra', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(42260, 4226, '0', 'ads_wwe_poster', 'ads_wwe_poster', 'I', 0, 0, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(42270, 4227, '0', 'sf_wall', 'sf_wall', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(42280, 4228, '1', 'sf_wall2', 'sf_wall2', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(42290, 4229, '1', 'flag_belgium', 'flag_belgium', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(42300, 4230, '0', 'ads_mall_wingar', 'ads_mall_wingar', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(42310, 4231, '1', 'flag_portugal', 'flag_portugal', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(42320, 4232, '1', 'rela_wall', 'rela_wall', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 6, '', '', '', 0, 0, ''),
	(42330, 4233, '1', 'ktchn_knives', 'ktchn_knives', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(42340, 4234, '1', 'ktchn_oven', 'ktchn_oven', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(42350, 4235, '1', 'ktchn_wall', 'ktchn_wall', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(42360, 4236, '0', 'ads_mall_winclo', 'ads_mall_winclo', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(42370, 4237, '0', 'dimmer_swtch', 'dimmer_swtch', 'I', 0, 0, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'dimmer', 1, '', '', '', 0, 0, ''),
	(42380, 4238, '0', 'dimmer_buttn', 'dimmer_buttn', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'dimmer', 1, '', '', '', 0, 0, ''),
	(42390, 4239, '0', 'dimmer_fuse2', 'dimmer_fuse2', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'dimmer', 1, '', '', '', 0, 0, ''),
	(42400, 4240, '0', 'dimmer_fuse6', 'dimmer_fuse6', 'I', 0, 0, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'dimmer', 1, '', '', '', 0, 0, ''),
	(42410, 4241, '0', 'ads_mtv_bigtv', 'ads_mtv_bigtv', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(42420, 4242, '0', 'ads_mtv_tv', 'ads_mtv_tv', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(42430, 4243, '0', 'ads_idol_l_logo', 'ads_idol_l_logo', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(42440, 4244, '1', 'urban_wall', 'urban_wall', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(42450, 4245, '0', 'ads_idol_l_tv', 'ads_idol_l_tv', 'I', 0, 0, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(42460, 4246, '1', 'flag_peru', 'flag_peru', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(42470, 4247, '0', 'hween09_crnr1', 'hween09_crnr1', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(42480, 4248, '1', 'flag_tunisia', 'flag_tunisia', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(42490, 4249, '1', 'flag_singapore', 'flag_singapore', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(42500, 4250, '1', 'flag_mexico', 'flag_mexico', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(42510, 4251, '1', 'flag_philippines', 'flag_philippines', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(42520, 4252, '1', 'flag_malaysia', 'flag_malaysia', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(42530, 4253, '1', 'flag_greece', 'flag_greece', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(42540, 4254, '1', 'flag_venezl', 'flag_venezl', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(42550, 4255, '1', 'flag_turkey', 'flag_turkey', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(42560, 4256, '1', 'flag_chile', 'flag_chile', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(42570, 4257, '0', 'hween09_wall1', 'hween09_wall1', 'I', 0, 0, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(42580, 4258, '1', 'flag_columbia', 'flag_columbia', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(42590, 4259, '0', 'hween09_stonewall', 'hween09_stonewall', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(42600, 4260, '1', 'flag_newzealand', 'flag_newzealand', 'I', 0, 0, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(42610, 4261, '1', 'flag_argentina', 'flag_argentina', 'I', 0, 0, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(42620, 4262, '1', 'flag_panama', 'flag_panama', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(42630, 4263, '0', 'hween09_paint', 'hween09_paint', 'I', 0, 0, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(42640, 4264, '1', 'flag_morocco', 'flag_morocco', 'I', 0, 0, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(42650, 4265, '1', 'flag_dominicanrepublic', 'flag_dominicanrepublic', 'I', 0, 0, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(42660, 4266, '0', 'hween09_curt', 'hween09_curt', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(42670, 4267, '0', 'byesw_loadscreen', 'byesw_loadscreen', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(42680, 4268, '1', 'flag_ecuador', 'flag_ecuador', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(42690, 4269, '0', 'hween09_treewall', 'hween09_treewall', 'I', 0, 0, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(42700, 4270, '1', 'flag_algeria', 'flag_algeria', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(42710, 4271, '0', 'hween09_win', 'hween09_win', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 10, '', '', '', 0, 0, ''),
	(42720, 4272, '0', 'ads_twi_paint', 'ads_twi_paint', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(42730, 4273, '0', 'ads_twi_dreamc', 'ads_twi_dreamc', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(42740, 4274, '0', 'ads_twi_bwall1', 'ads_twi_bwall1', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(42750, 4275, '0', 'ads_twi_crest', 'ads_twi_crest', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(42760, 4276, '0', 'ads_twi_bwall2', 'ads_twi_bwall2', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(42770, 4277, '0', 'ads_twi_windw', 'ads_twi_windw', 'I', 0, 0, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(42780, 4278, '0', 'xm09_bauble_24', 'xm09_bauble_24', 'I', 0, 0, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(42790, 4279, '0', 'xm09_bauble_27', 'xm09_bauble_27', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(42800, 4280, '0', 'xm09_stocking', 'xm09_stocking', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 7, '', '', '', 0, 0, ''),
	(42810, 4281, '0', 'xm09_bauble_17', 'xm09_bauble_17', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(42820, 4282, '0', 'xm09_bauble_4', 'xm09_bauble_4', 'I', 0, 0, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(42830, 4283, '0', 'xm09_bauble_19', 'xm09_bauble_19', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(42840, 4284, '0', 'xm09_bauble_6', 'xm09_bauble_6', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(42850, 4285, '0', 'xm09_bauble_3', 'xm09_bauble_3', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(42860, 4286, '0', 'xm09_bauble_25', 'xm09_bauble_25', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(42870, 4287, '1', 'arabian_wall', 'arabian_wall', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(42880, 4288, '0', 'xm09_bauble_5', 'xm09_bauble_5', 'I', 0, 0, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(42890, 4289, '0', 'xm09_bauble_11', 'xm09_bauble_11', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(42900, 4290, '0', 'xm09_bauble_14', 'xm09_bauble_14', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(42910, 4291, '0', 'xm09_bauble_7', 'xm09_bauble_7', 'I', 0, 0, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(42920, 4292, '0', 'xm09_bauble_23', 'xm09_bauble_23', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(42930, 4293, '0', 'xm09_bauble_10', 'xm09_bauble_10', 'I', 0, 0, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(42940, 4294, '0', 'xm09_bauble_9', 'xm09_bauble_9', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(42950, 4295, '0', 'xm09_bauble_8', 'xm09_bauble_8', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(42960, 4296, '0', 'xm09_bauble_20', 'xm09_bauble_20', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(42970, 4297, '0', 'xm09_bauble_2', 'xm09_bauble_2', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(42980, 4298, '0', 'xm09_bauble_18', 'xm09_bauble_18', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(42990, 4299, '0', 'xm09_bauble_13', 'xm09_bauble_13', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(43000, 4300, '0', 'xm09_bauble_1', 'xm09_bauble_1', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(43010, 4301, '0', 'xm09_bauble_15', 'xm09_bauble_15', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(43020, 4302, '0', 'xm09_bauble_22', 'xm09_bauble_22', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(43030, 4303, '0', 'xm09_bauble_16', 'xm09_bauble_16', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(43040, 4304, '0', 'xm09_bauble_12', 'xm09_bauble_12', 'I', 0, 0, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(43050, 4305, '0', 'xm09_bauble_21', 'xm09_bauble_21', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(43060, 4306, '0', 'xm09_bauble_26', 'xm09_bauble_26', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(43070, 4307, '0', 'xm09_firwall', 'xm09_firwall', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(43080, 4308, '0', 'xm09_forestwall', 'xm09_forestwall', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(43090, 4309, '0', 'xm09_infotv', 'xm09_infotv', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(43100, 4310, '1', 'party_lights', 'party_lights', 'I', 0, 0, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(43110, 4311, '0', 'xm09_lodgewall', 'xm09_lodgewall', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 8, '', '', '', 0, 0, ''),
	(43120, 4312, '0', 'xm09_frplc', 'xm09_frplc', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 9, '', '', '', 0, 0, ''),
	(43130, 4313, '0', 'year2010', 'year2010', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(43140, 4314, '0', 'china_pstr3', 'china_pstr3', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(43150, 4315, '0', 'ads_tv_jaapuisto', 'ads_tv_jaapuisto', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(43160, 4316, '0', 'val09_wall2', 'val09_wall2', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(43170, 4317, '0', 'val09_wdrobe_g', 'val09_wdrobe_g', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(43180, 4318, '0', 'val09_wall1', 'val09_wall1', 'I', 0, 0, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 10, '', '', '', 0, 0, ''),
	(43190, 4319, '1', 'bling_sink', 'bling_sink', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(43200, 4320, '0', 'val09_wdrobe_b', 'val09_wdrobe_b', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(43210, 4321, '1', 'bling_cabinet', 'bling_cabinet', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(43220, 4322, '0', 'ads_percyw', 'ads_percyw', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(43230, 4323, '0', 'ads_boost_surfb', 'ads_boost_surfb', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(43240, 4324, '0', 'ads_tlc_wheel', 'ads_tlc_wheel', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'colorwheel', 10, '', '', '', 0, 0, ''),
	(43250, 4325, '0', 'garden_wall', 'garden_wall', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(43260, 4326, '0', 'ads_tv_yle', 'ads_tv_yle', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(43270, 4327, '1', 'runway_shelf', 'runway_shelf', 'I', 0, 0, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(43280, 4328, '0', 'ads_latrobe_flag', 'ads_latrobe_flag', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(43290, 4329, '0', 'hc3_walldeco', 'hc3_walldeco', 'I', 0, 0, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 10, '', '', '', 0, 0, ''),
	(43300, 4330, '0', 'ads_nokia_x6', 'ads_nokia_x6', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(43310, 4331, '1', 'runway_fabric', 'runway_fabric', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 8, '', '', '', 0, 0, ''),
	(43320, 4332, '0', 'ads_target_wall', 'ads_target_wall', 'I', 0, 0, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(43330, 4333, '0', 'ads_super_pop', 'ads_super_pop', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(43340, 4334, '0', 'ads_tv_chocapic_02', 'ads_tv_chocapic_02', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(43350, 4335, '0', 'ads_tv_chocapic_01', 'ads_tv_chocapic_01', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(43360, 4336, '1', 'bw_jaws', 'bw_jaws', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(43370, 4337, '0', 'ads_grefusa_surfb', 'ads_grefusa_surfb', 'I', 0, 0, 0.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(43380, 4338, '1', 'ktchn10_cabnt', 'ktchn10_cabnt', 'I', 0, 0, 0.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(43390, 4339, '0', 'hosptl_xray', 'hosptl_xray', 'I', 0, 0, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(43400, 4340, '0', 'hween10_fogwall', 'hween10_fogwall', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(43410, 4341, '1', 'bb_painimies1', 'bb_painimies1', 'I', 0, 0, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(43420, 4342, '1', 'bb_painimies2', 'bb_painimies2', 'I', 0, 0, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(43430, 4343, '0', 'ads_mtv_bigtv2', 'ads_mtv_bigtv2', 'I', 0, 0, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(43440, 4344, '0', 'ads_mtv_tv2', 'ads_mtv_tv2', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(43450, 4345, '0', 'hween10_card_3', 'hween10_card_3', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(43460, 4346, '0', 'hween10_card_1', 'hween10_card_1', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(43470, 4347, '0', 'hween10_card_4', 'hween10_card_4', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(43480, 4348, '0', 'hween10_card_6', 'hween10_card_6', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(43490, 4349, '0', 'hween10_wallskull', 'hween10_wallskull', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(43500, 4350, '0', 'hween10_card_2', 'hween10_card_2', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(43510, 4351, '0', 'hween10_card_5', 'hween10_card_5', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(43520, 4352, '0', 'ads_nokiax3_wall2', 'ads_nokiax3_wall2', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(43530, 4353, '0', 'ads_nokiax3_wall3', 'ads_nokiax3_wall3', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(43540, 4354, '0', 'ads_nokiax3_wall1', 'ads_nokiax3_wall1', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(43550, 4355, '0', 'ads_nokiax3_phn', 'ads_nokiax3_phn', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(43560, 4356, '1', 'exe_sensor', 'exe_sensor', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(43570, 4357, '0', 'qt_calendar2', 'qt_calendar2', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(43580, 4358, '0', 'ads_r7logo', 'ads_r7logo', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(43590, 4359, '0', 'qt_calendar0', 'qt_calendar0', 'I', 0, 0, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(43600, 4360, '0', 'qt_calendar1', 'qt_calendar1', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(43610, 4361, '0', 'qt_xm10_bauble2', 'qt_xm10_bauble2', 'I', 0, 0, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(43620, 4362, '0', 'es_build1', 'es_build1', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(43630, 4363, '0', 'es_build4', 'es_build4', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(43640, 4364, '0', 'es_build2', 'es_build2', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(43650, 4365, '0', 'qt_xm10_bauble1', 'qt_xm10_bauble1', 'I', 0, 0, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(43660, 4366, '0', 'es_build3', 'es_build3', 'I', 0, 0, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(43670, 4367, '0', 'es_window', 'es_window', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(43680, 4368, '0', 'qt_xm10_bauble3', 'qt_xm10_bauble3', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(43690, 4369, '0', 'qt_xm10_icestar', 'qt_xm10_icestar', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, '');
REPLACE INTO `items_base` (`id`, `sprite_id`, `buildersclub`, `public_name`, `item_name`, `type`, `width`, `length`, `stack_height`, `allow_stack`, `allow_sit`, `allow_lay`, `allow_walk`, `allow_gift`, `allow_trade`, `allow_recycle`, `allow_marketplace_sell`, `allow_inventory_stack`, `interaction_type`, `interaction_modes_count`, `vending_ids`, `multiheight`, `customparams`, `effect_id_male`, `effect_id_female`, `clothing_on_walk`) VALUES
	(43700, 4370, '0', 'es_big1', 'es_big1', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(43710, 4371, '0', 'es_big3', 'es_big3', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(43720, 4372, '0', 'es_big2', 'es_big2', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(43730, 4373, '0', 'year2011', 'year2011', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(43740, 4374, '1', 'bling11_wall1', 'bling11_wall1', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(43750, 4375, '1', 'bling11_wall4', 'bling11_wall4', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(43760, 4376, '1', 'bling11_wall2', 'bling11_wall2', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(43770, 4377, '1', 'bling11_wall3', 'bling11_wall3', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(43780, 4378, '0', 'qt_val11_heartlights', 'qt_val11_heartlights', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(43790, 4379, '1', 'bling11_big1', 'bling11_big1', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(43800, 4380, '1', 'gothic_st_glass', 'gothic_st_glass', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(43810, 4381, '0', 'ads_bigtv_missmix', 'ads_bigtv_missmix', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(43820, 4382, '1', 'cine_light2', 'cine_light2', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(43830, 4383, '1', 'cine_light1', 'cine_light1', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(43840, 4384, '1', 'cubie_decal_3_b', 'cubie_decal_3_b', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 6, '', '', '', 0, 0, ''),
	(43850, 4385, '1', 'cubie_decklight_p', 'cubie_decklight_p', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(43860, 4386, '1', 'cubie_decal_1_b', 'cubie_decal_1_b', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(43870, 4387, '1', 'cubie_decal_2_b', 'cubie_decal_2_b', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(43880, 4388, '1', 'cubie_decal_3_p', 'cubie_decal_3_p', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 6, '', '', '', 0, 0, ''),
	(43890, 4389, '1', 'cubie_wallshelf_b', 'cubie_wallshelf_b', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 7, '', '', '', 0, 0, ''),
	(43900, 4390, '1', 'cubie_decal_1_p', 'cubie_decal_1_p', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(43910, 4391, '1', 'cubie_decal_3', 'cubie_decal_3', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 6, '', '', '', 0, 0, ''),
	(43920, 4392, '1', 'cubie_wallshelf_p', 'cubie_wallshelf_p', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 7, '', '', '', 0, 0, ''),
	(43930, 4393, '1', 'cubie_decal_2_p', 'cubie_decal_2_p', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(43940, 4394, '1', 'cubie_decklight_b', 'cubie_decklight_b', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(43950, 4395, '1', 'cubie_decal_0', 'cubie_decal_0', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(43960, 4396, '1', 'waasa_wall_shelf2', 'waasa_wall_shelf2', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(43970, 4397, '1', 'waasa_wall_shelf1', 'waasa_wall_shelf1', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(43980, 4398, '0', 'easter11_wall', 'easter11_wall', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(43990, 4399, '0', 'ads_suunvuorow', 'ads_suunvuorow', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(44000, 4400, '0', 'ads_volkswagen_poster', 'ads_volkswagen_poster', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(44010, 4401, '0', 'picture_car', 'picture_car', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(44020, 4402, '0', 'ads_kfp2_tv', 'ads_kfp2_tv', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(44030, 4403, '0', 'ads_kfp2_wall', 'ads_kfp2_wall', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(44040, 4404, '1', 'dng_wall', 'dng_wall', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(44050, 4405, '0', 'ads_cchups_screen', 'ads_cchups_screen', 'I', 0, 0, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(44060, 4406, '1', 'sb_tag1', 'sb_tag1', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(44070, 4407, '1', 'sb_wall', 'sb_wall', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(44080, 4408, '1', 'sb_tag2', 'sb_tag2', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(44090, 4409, '1', 'sb_tag3', 'sb_tag3', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(44100, 4410, '0', 'ads_durex_screen', 'ads_durex_screen', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(44110, 4411, '0', 'ads_mtv_wall', 'ads_mtv_wall', 'I', 0, 0, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(44120, 4412, '0', 'summer_sunset_wall', 'summer_sunset_wall', 'I', 0, 0, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(44130, 4413, '1', 'usva5_wallrug', 'usva5_wallrug', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(44140, 4414, '1', 'usva3_wallrug', 'usva3_wallrug', 'I', 0, 0, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(44150, 4415, '1', 'usva_wallrug', 'usva_wallrug', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(44160, 4416, '1', 'usva4_wallrug', 'usva4_wallrug', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(44170, 4417, '1', 'usva2_wallrug', 'usva2_wallrug', 'I', 0, 0, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(44180, 4418, '1', 'school_chalkboard', 'school_chalkboard', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(44190, 4419, '1', 'school_urinal', 'school_urinal', 'I', 0, 0, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(44200, 4420, '1', 'school_wall', 'school_wall', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(44210, 4421, '1', 'school_charts', 'school_charts', 'I', 0, 0, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(44220, 4422, '1', 'school_toilet_wall', 'school_toilet_wall', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(44230, 4423, '1', 'boutique_lampwall', 'boutique_lampwall', 'I', 0, 0, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(44240, 4424, '1', 'boutique_shrack2', 'boutique_shrack2', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(44250, 4425, '1', 'boutique_shrack1', 'boutique_shrack1', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(44260, 4426, '1', 'boutique_speakers', 'boutique_speakers', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(44270, 4427, '1', 'boutique_clrack2', 'boutique_clrack2', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(44280, 4428, '1', 'boutique_clrack1', 'boutique_clrack1', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(44290, 4429, '0', 'ads_flag_un', 'ads_flag_un', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(44300, 4430, '0', 'horse_pitchfork_wall', 'horse_pitchfork_wall', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(44310, 4431, '0', 'horse_stable_wall', 'horse_stable_wall', 'I', 0, 0, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(44320, 4432, '0', 'horse_stable_wall_w', 'horse_stable_wall_w', 'I', 0, 0, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(44330, 4433, '0', 'horse_shoe_wall', 'horse_shoe_wall', 'I', 0, 0, 9.99, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(44340, 4434, '0', 'hween11_window', 'hween11_window', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(44350, 4435, '0', 'xmas11_hd4', 'xmas11_hd4', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(44360, 4436, '0', 'xmas11_wall', 'xmas11_wall', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(44370, 4437, '0', 'xmas11_hd2', 'xmas11_hd2', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(44380, 4438, '0', 'xmas11_hd5', 'xmas11_hd5', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(44390, 4439, '0', 'xmas11_hd3', 'xmas11_hd3', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(44400, 4440, '0', 'xmas11_hd1', 'xmas11_hd1', 'I', 0, 0, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(44410, 4441, '0', 'xmas11_hd6', 'xmas11_hd6', 'I', 0, 0, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(44420, 4442, '0', 'ads_alvinsurf', 'ads_alvinsurf', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(44430, 4443, '0', 'xmas11_cuckoo', 'xmas11_cuckoo', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(44440, 4444, '0', 'ads_m6_wall', 'ads_m6_wall', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(44450, 4445, '0', 'year2012', 'year2012', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(44460, 4446, '1', 'snowb_mountain_wall', 'snowb_mountain_wall', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(44470, 4447, '1', 'flag_denmark', 'flag_denmark', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(44480, 4448, '0', 'urban_wall_china', 'urban_wall_china', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(44490, 4449, '0', 'ads_antena3_wall', 'ads_antena3_wall', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(44500, 4450, '0', 'xm11_stocking', 'xm11_stocking', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(44510, 4451, '0', 'wallchair', 'wallchair', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(44520, 4452, '1', 'jp_window', 'jp_window', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(44530, 4453, '1', 'jp_wall', 'jp_wall', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 6, '', '', '', 0, 0, ''),
	(44540, 4454, '1', 'stone_wall', 'stone_wall', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(44550, 4455, '1', 'gardenshed_wall', 'gardenshed_wall', 'I', 0, 0, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(44560, 4456, '0', 'js_exe_wfall', 'js_exe_wfall', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(44570, 4457, '1', 'football12_es', 'football12_es', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(44580, 4458, '1', 'football12_it', 'football12_it', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(44590, 4459, '1', 'football12_de', 'football12_de', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(44600, 4460, '1', 'football12_pt', 'football12_pt', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(44610, 4461, '1', 'anc_savanna_wall', 'anc_savanna_wall', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(44620, 4462, '1', 'anc_sunset_wall', 'anc_sunset_wall', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(44630, 4463, '0', 'lon_skyline', 'lon_skyline', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(44640, 4464, '0', 'hween12_dartboard', 'hween12_dartboard', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(44650, 4465, '1', 'hs_wall', 'hs_wall', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 11, '', '', '', 0, 0, ''),
	(44660, 4466, '1', 'hs_wlight', 'hs_wlight', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(44670, 4467, '1', 'hs_applause', 'hs_applause', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(44680, 4468, '0', 'xmas12_wall_in', 'xmas12_wall_in', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(44690, 4469, '0', 'xmas12_window', 'xmas12_window', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(44700, 4470, '0', 'xmas12_wall_out', 'xmas12_wall_out', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(44710, 4471, '0', 'xmas12_door', 'xmas12_door', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(44720, 4472, '0', 'xmas12_torch', 'xmas12_torch', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(44750, 4475, '0', 'year2013', 'year2013', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(44760, 4476, '1', 'ny2013_wall', 'ny2013_wall', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(44770, 4477, '0', 'china_pstr4', 'china_pstr4', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(44780, 4478, '0', 'val13_wall_2', 'val13_wall_2', 'I', 0, 0, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(44790, 4479, '0', 'val13_wall_3', 'val13_wall_3', 'I', 0, 0, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(44800, 4480, '0', 'val13_wall_1', 'val13_wall_1', 'I', 0, 0, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(44810, 4481, '1', 'pixel_clock_red', 'pixel_clock_red', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(44820, 4482, '1', 'pixel_walldeco', 'pixel_walldeco', 'I', 0, 0, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(44830, 4483, '1', 'pixel_clock_pink', 'pixel_clock_pink', 'I', 0, 0, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(44840, 4484, '1', 'pixel_mirror', 'pixel_mirror', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(44850, 4485, '0', 'pixel_clock_black', 'pixel_clock_black', 'I', 0, 0, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(44860, 4486, '1', 'pixel_clock_green', 'pixel_clock_green', 'I', 0, 0, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(44870, 4487, '1', 'pixel_clock_blue', 'pixel_clock_blue', 'I', 0, 0, 1.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(44880, 4488, '1', 'pixel_wall_green', 'pixel_wall_green', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(44890, 4489, '1', 'pixel_wall_red', 'pixel_wall_red', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(44900, 4490, '1', 'pixel_painting_pink', 'pixel_painting_pink', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(44910, 4491, '1', 'pixel_painting_green', 'pixel_painting_green', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(44920, 4492, '1', 'pixel_wall_pink', 'pixel_wall_pink', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(44930, 4493, '0', 'pixel_painting_black', 'pixel_painting_black', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(44940, 4494, '1', 'pixel_painting_blue', 'pixel_painting_blue', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(44950, 4495, '1', 'pixel_painting_red', 'pixel_painting_red', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(44960, 4496, '1', 'pixel_wall_blue', 'pixel_wall_blue', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(44970, 4497, '0', 'pixel_wall_black', 'pixel_wall_black', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(44980, 4498, '0', 'pixel_poster2', 'pixel_poster2', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(44990, 4499, '0', 'dimmer_steampunk', 'dimmer_steampunk', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'dimmer', 1, '', '', '', 0, 0, ''),
	(45000, 4500, '1', 'steampunk_wall2', 'steampunk_wall2', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(45010, 4501, '1', 'steampunk_wall1', 'steampunk_wall1', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(45020, 4502, '1', 'steampunk_window', 'steampunk_window', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(45030, 4503, '1', 'steampunk_map', 'steampunk_map', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(45040, 4504, '0', 'easter13_wall3', 'easter13_wall3', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(45050, 4505, '0', 'easter13_window', 'easter13_window', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(45060, 4506, '0', 'easter13_wall1', 'easter13_wall1', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(45070, 4507, '0', 'easter13_wall2', 'easter13_wall2', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(45080, 4508, '1', 'mystics_bwall', 'mystics_bwall', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(45090, 4509, '1', 'mystics_gwall', 'mystics_gwall', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(45100, 4510, '1', 'flag_austria', 'flag_austria', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(45110, 4511, '1', 'grungewall', 'grungewall', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 6, '', '', '', 0, 0, ''),
	(45120, 4512, '1', 'school_chalkboard2', 'school_chalkboard2', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(45130, 4513, '0', 'cine_pstr_6', 'cine_pstr_6', 'I', 0, 0, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(45140, 4514, '0', 'cine_pstr_4', 'cine_pstr_4', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(45150, 4515, '0', 'cine_pstr_7', 'cine_pstr_7', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(45160, 4516, '0', 'cine_pstr_8', 'cine_pstr_8', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(45170, 4517, '0', 'cine_pstr_1', 'cine_pstr_1', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(45180, 4518, '0', 'cine_pstr_5', 'cine_pstr_5', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(45190, 4519, '0', 'cine_pstr_0', 'cine_pstr_0', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(45200, 4520, '0', 'cine_pstr_3', 'cine_pstr_3', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(45210, 4521, '0', 'cine_pstr_9', 'cine_pstr_9', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(45220, 4522, '0', 'cine_pstr_2', 'cine_pstr_2', 'I', 0, 0, 1.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(45230, 4523, '0', 'habbopage_wall', 'habbopage_wall', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(45240, 4524, '0', 'brnd_cscape_wall', 'brnd_cscape_wall', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(45250, 4525, '0', 'ads_nokiax3_wallb', 'ads_nokiax3_wallb', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(45260, 4526, '0', 'ads_nokiax3_wall', 'ads_nokiax3_wall', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(45270, 4527, '0', 'builderwall_exp', 'builderwall_exp', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(45280, 4528, '0', 'test_habbopage_display', 'test_habbopage_display', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(45290, 4529, '0', 'cine_pstr_10', 'cine_pstr_10', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(45300, 4530, '0', 'hc_exe_wfall', 'hc_exe_wfall', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(45310, 4531, '0', 'post_it_xmas', 'post_it_xmas', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'postit', 2, '', '', '', 0, 0, ''),
	(45320, 4532, '0', 'year2014', 'year2014', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(45330, 4533, '0', 'post_it_dreams', 'post_it_dreams', 'I', 0, 0, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'postit', 2, '', '', '', 0, 0, ''),
	(45340, 4534, '0', 'china_pstr5', 'china_pstr5', 'I', 0, 0, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(45350, 4535, '0', 'storieshero_poster', 'storieshero_poster', 'I', 0, 0, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(45360, 4536, '0', 'external_image_wallitem', 'external_image_wallitem', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'external_image', 2, '', '', '', 0, 0, ''),
	(45370, 4537, '1', 'val14_wall1', 'val14_wall1', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(45380, 4538, '1', 'val14_wall3', 'val14_wall3', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(45390, 4539, '1', 'val14_wall2', 'val14_wall2', 'I', 0, 0, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(45400, 4540, '0', 'post_it_shakesp', 'post_it_shakesp', 'I', 0, 0, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'postit', 2, '', '', '', 0, 0, ''),
	(45410, 4541, '0', 'external_image_wallitem_photo', 'external_image_wallitem_photo', 'I', 0, 0, 0.00, '0', '0', '0', '1', '1', '1', '0', '1', '1', 'external_image', 2, '', '', '', 0, 0, ''),
	(45420, 4542, '0', 'runway_fabric2', 'runway_fabric2', 'I', 0, 0, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(45430, 4543, '1', 'stories_sch_glass', 'stories_sch_glass', 'I', 0, 0, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(45440, 4544, '0', 'easter14_wall', 'easter14_wall', 'I', 0, 0, 0.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(45450, 4545, '0', 'diamond_painting6', 'diamond_painting6', 'I', 0, 0, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(45453, 4545, '0', 'diamond_painting6', 'diamond_painting6', 'I', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(45460, 4546, '0', 'diamond_painting4', 'diamond_painting4', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(45463, 4546, '0', 'diamond_painting4', 'diamond_painting4', 'I', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(45470, 4547, '0', 'diamond_painting2', 'diamond_painting2', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(45473, 4547, '0', 'diamond_painting2', 'diamond_painting2', 'I', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(45480, 4548, '0', 'diamond_painting5', 'diamond_painting5', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(45483, 4548, '0', 'diamond_painting5', 'diamond_painting5', 'I', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(45490, 4549, '0', 'diamond_painting1', 'diamond_painting1', 'I', 0, 0, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(45500, 4550, '0', 'diamond_painting3', 'diamond_painting3', 'I', 0, 0, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(45503, 4550, '0', 'diamond_painting3', 'diamond_painting3', 'I', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(45510, 4551, '1', 'vikings_banner_r', 'vikings_banner_r', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(45520, 4552, '1', 'vikings_banner_g', 'vikings_banner_g', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(45530, 4553, '1', 'vikings_wallshield_g', 'vikings_wallshield_g', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(45540, 4554, '1', 'vikings_wallshield_r', 'vikings_wallshield_r', 'I', 0, 0, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(45550, 4555, '1', 'vikings_wall_g', 'vikings_wall_g', 'I', 0, 0, 0.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(45560, 4556, '1', 'vikings_wall_r', 'vikings_wall_r', 'I', 0, 0, 0.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(45570, 4557, '0', 'post_it_juninas', 'post_it_juninas', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', '', 2, '', '', '', 0, 0, ''),
	(45580, 4558, '1', 'hblooza14_wall', 'hblooza14_wall', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(45590, 4559, '1', 'wildwest_wallpaper', 'wildwest_wallpaper', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(45600, 4560, '1', 'st_wildwest_wallskull', 'st_wildwest_wallskull', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(45610, 4561, '1', 'uni_floppy', 'uni_floppy', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(45620, 4562, '1', 'uni_fairylights', 'uni_fairylights', 'I', 0, 0, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(45630, 4563, '1', 'uni_poster1', 'uni_poster1', 'I', 0, 0, 0.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(45640, 4564, '1', 'uni_pinupgirl', 'uni_pinupgirl', 'I', 0, 0, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(45650, 4565, '1', 'uni_hipdeer', 'uni_hipdeer', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 8, '', '', '', 0, 0, ''),
	(45660, 4566, '1', 'uni_poster2', 'uni_poster2', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(45670, 4567, '0', 'uni_libraryshelf', 'uni_libraryshelf', 'I', 0, 0, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(45680, 4568, '1', 'uni_coatrack', 'uni_coatrack', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(45690, 4569, '1', 'uni_girlcoatrack', 'uni_girlcoatrack', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(45700, 4570, '1', 'uni_pinupboy', 'uni_pinupboy', 'I', 0, 0, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(45710, 4571, '1', 'uni_vinyl', 'uni_vinyl', 'I', 0, 0, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 8, '', '', '', 0, 0, ''),
	(45720, 4572, '1', 'uni_moustache', 'uni_moustache', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(45730, 4573, '1', 'bathroom_wall4', 'bathroom_wall4', 'I', 0, 0, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(45740, 4574, '1', 'bathroom_wall1', 'bathroom_wall1', 'I', 0, 0, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(45750, 4575, '1', 'bathroom_wall3', 'bathroom_wall3', 'I', 0, 0, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(45760, 4576, '1', 'bathroom_wall2', 'bathroom_wall2', 'I', 0, 0, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(45770, 4577, '1', 'st_uni_poster', 'st_uni_poster', 'I', 0, 0, 0.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(45780, 4578, '0', 'hween14_stainglass', 'hween14_stainglass', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(45790, 4579, '0', 'hween14_hcglass', 'hween14_hcglass', 'I', 0, 0, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(45800, 4580, '0', 'hween14_wall', 'hween14_wall', 'I', 0, 0, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(45810, 4581, '0', 'external_image_wallitem_poster', 'external_image_wallitem_poster', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'external_image', 2, '', '', '', 0, 0, ''),
	(45820, 4582, '0', 'cine_pstr_11', 'cine_pstr_11', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(45830, 4583, '0', 'cine_pstr_18', 'cine_pstr_18', 'I', 0, 0, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(45840, 4584, '0', 'cine_pstr_16', 'cine_pstr_16', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(45850, 4585, '0', 'cine_pstr_12', 'cine_pstr_12', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(45860, 4586, '0', 'cine_pstr_19', 'cine_pstr_19', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(45870, 4587, '0', 'cine_pstr_13', 'cine_pstr_13', 'I', 0, 0, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(45880, 4588, '0', 'cine_pstr_15', 'cine_pstr_15', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(45890, 4589, '0', 'cine_pstr_14', 'cine_pstr_14', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(45900, 4590, '0', 'cine_pstr_17', 'cine_pstr_17', 'I', 0, 0, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(45910, 4591, '0', 'st_pstr_felipe', 'st_pstr_felipe', 'I', 0, 0, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(45920, 4592, '0', 'hc_arab_wndw', 'hc_arab_wndw', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(45930, 4593, '0', 'hc_arab_swords', 'hc_arab_swords', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(45940, 4594, '1', 'val15_fujiwall', 'val15_fujiwall', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(45950, 4595, '1', 'attic15_wall', 'attic15_wall', 'I', 0, 0, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(45960, 4596, '1', 'attic15_painting', 'attic15_painting', 'I', 0, 0, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(45970, 4597, '0', 'external_image_wallitem_poster_small', 'external_image_wallitem_poster_small', 'I', 0, 0, 0.00, '0', '0', '0', '1', '1', '1', '0', '1', '1', 'external_image', 2, '', '', '', 0, 0, ''),
	(45980, 4598, '0', 'carnival15_wallmask', 'carnival15_wallmask', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(45990, 4599, '1', 'cpunk_c15_wall', 'cpunk_c15_wall', 'I', 0, 0, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(46000, 4600, '0', 'china_pstr6', 'china_pstr6', 'I', 0, 0, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(46010, 4601, '0', 'cypunk_c15_wall', 'cypunk_c15_wall', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(46020, 4602, '0', 'cland_c15_wall', 'cland_c15_wall', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(46030, 4603, '0', 'diamond_painting9', 'diamond_painting9', 'I', 0, 0, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(46040, 4604, '0', 'diamond_painting18', 'diamond_painting18', 'I', 0, 0, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(46050, 4605, '0', 'diamond_painting17', 'diamond_painting17', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(46060, 4606, '0', 'diamond_painting15', 'diamond_painting15', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(46070, 4607, '0', 'diamond_painting16', 'diamond_painting16', 'I', 0, 0, 0.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(46080, 4608, '0', 'diamond_painting14', 'diamond_painting14', 'I', 0, 0, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(46090, 4609, '0', 'diamond_painting13', 'diamond_painting13', 'I', 0, 0, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(46100, 4610, '0', 'diamond_painting10', 'diamond_painting10', 'I', 0, 0, 0.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(46110, 4611, '0', 'diamond_painting7', 'diamond_painting7', 'I', 0, 0, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(46120, 4612, '0', 'diamond_painting12', 'diamond_painting12', 'I', 0, 0, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(46130, 4613, '0', 'diamond_painting11', 'diamond_painting11', 'I', 0, 0, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(46140, 4614, '0', 'army15_poster', 'army15_poster', 'I', 0, 0, 0.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(46150, 4615, '0', 'army_c15_insig', 'army_c15_insig', 'I', 0, 0, 0.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(46160, 4616, '0', 'army15_largescreen', 'army15_largescreen', 'I', 0, 0, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(46170, 4617, '1', 'army_c15_wall', 'army_c15_wall', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(46180, 4618, '1', 'dino_c15_wallpiece', 'dino_c15_wallpiece', 'I', 0, 0, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 8, '', '', '', 0, 0, ''),
	(46190, 4619, '1', 'paris_c15_wall', 'paris_c15_wall', 'I', 0, 0, 0.00, '0', '1', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(46200, 4620, '1', 'lodge_c15_window', 'lodge_c15_window', 'I', 0, 0, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(46210, 4621, '1', 'lodge_c15_wall', 'lodge_c15_wall', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(46220, 4622, '1', 'drago_c15_flag', 'drago_c15_flag', 'I', 0, 0, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(46230, 4623, '1', 'anc_c15_wall', 'anc_c15_wall', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(46240, 4624, '1', 'tiki_c15_wall', 'tiki_c15_wall', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(46250, 4625, '1', 'exe_c15_wall', 'exe_c15_wall', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(46260, 4626, '1', 'romantique_c15_wall', 'romantique_c15_wall', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(46270, 4627, '1', 'bling_c15_wall', 'bling_c15_wall', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(46280, 4628, '0', 'hween_c15_sky', 'hween_c15_sky', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(46290, 4629, '0', 'cine_pstr_20', 'cine_pstr_20', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(46300, 4630, '1', 'ktchn_c15_cupboard', 'ktchn_c15_cupboard', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(46310, 4631, '0', 'gift_hhome', 'gift_hhome', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(46320, 4632, '0', 'gold_c15_arc_icewall', 'gold_c15_arc_icewall', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(46330, 4633, '0', 'xmas_c15_advent9', 'xmas_c15_advent9', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(46340, 4634, '0', 'xmas_c15_advent10', 'xmas_c15_advent10', 'I', 0, 0, 0.00, '0', '0', '0', '1', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(46350, 4635, '0', 'china_pstr7', 'china_pstr7', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(46360, 4636, '0', 'gothic_r16_fountain', 'gothic_r16_fountain', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(46370, 4637, '0', 'super_c16_pstriron', 'super_c16_pstriron', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(46380, 4638, '0', 'super_c16_pstrcat', 'super_c16_pstrcat', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(46390, 4639, '0', 'super_c16_pstrsulk', 'super_c16_pstrsulk', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(46400, 4640, '0', 'super_c16_pstrlove', 'super_c16_pstrlove', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(46410, 4641, '1', 'olympics_c16_walldecal', 'olympics_c16_walldecal', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(46420, 4642, '0', 'xmas_c16_painting', 'xmas_c16_painting', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(46430, 4643, '1', 'classic5_window', 'classic5_window', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(46440, 4644, '0', 'china_pstr8', 'china_pstr8', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(46450, 4645, '0', 'mall_c17_winclo', 'mall_c17_winclo', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(46460, 4646, '0', 'mall_c17_winpet', 'mall_c17_winpet', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(46470, 4647, '0', 'mall_c17_winspo', 'mall_c17_winspo', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(46480, 4648, '0', 'easter_c17_countrybg', 'easter_c17_countrybg', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 5, '', '', '', 0, 0, ''),
	(46490, 4649, '0', 'year2018', 'year2018', 'I', 0, 0, 0.00, '0', '1', '1', '1', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(46500, 4650, '0', 'hc17_7', 'hc17_7', 'I', 0, 0, 0.00, '0', '1', '1', '1', '1', '1', '0', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(46510, 4651, '0', 'china_pstr9', 'china_pstr9', 'I', 0, 0, 0.00, '0', '1', '1', '1', '1', '1', '0', '1', '0', 'default', 1, '', '', '', 0, 0, ''),
	(46520, 4652, '1', 'coralking_c18_seabg', 'coralking_c18_seabg', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(46530, 4653, '0', 'diamond_painting26', 'diamond_painting26', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(46540, 4654, '0', 'diamond_painting28', 'diamond_painting28', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(46550, 4655, '0', 'diamond_painting27', 'diamond_painting27', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(46560, 4656, '0', 'diamond_painting23', 'diamond_painting23', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(46570, 4657, '0', 'diamond_painting21', 'diamond_painting21', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(46580, 4658, '0', 'diamond_painting20', 'diamond_painting20', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(46590, 4659, '0', 'diamond_painting19', 'diamond_painting19', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(46600, 4660, '0', 'diamond_painting24', 'diamond_painting24', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(46610, 4661, '0', 'diamond_painting29', 'diamond_painting29', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(46620, 4662, '0', 'diamond_painting30', 'diamond_painting30', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(46630, 4663, '0', 'diamond_painting22', 'diamond_painting22', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(46640, 4664, '0', 'diamond_painting25', 'diamond_painting25', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(46650, 4665, '0', 'hween_c18_labwallpanel', 'hween_c18_labwallpanel', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(46660, 4666, '0', 'xmas_c18_starrybg', 'xmas_c18_starrybg', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(46670, 4667, '0', 'year2019', 'year2019', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(46680, 4668, '0', 'china_pstr10', 'china_pstr10', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(46690, 4669, '0', 'easter_c19_forrestbg', 'easter_c19_forrestbg', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(46700, 4670, '1', 'fest_c19_bgwall', 'fest_c19_bgwall', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 6, '', '', '', 0, 0, ''),
	(46710, 4671, '0', 'diamond_painting37', 'diamond_painting37', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(46720, 4672, '0', 'diamond_painting33', 'diamond_painting33', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(46730, 4673, '0', 'diamond_painting31', 'diamond_painting31', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(46740, 4674, '0', 'diamond_painting36', 'diamond_painting36', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(46750, 4675, '0', 'diamond_painting40', 'diamond_painting40', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(46760, 4676, '0', 'diamond_painting35', 'diamond_painting35', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(46770, 4677, '0', 'diamond_painting41', 'diamond_painting41', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(46780, 4678, '0', 'diamond_painting32', 'diamond_painting32', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(46790, 4679, '0', 'diamond_painting38', 'diamond_painting38', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(46800, 4680, '0', 'diamond_painting34', 'diamond_painting34', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(46810, 4681, '0', 'celestial_c19_wall', 'celestial_c19_wall', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(46820, 4682, '0', 'celestial_c19_constellations', 'celestial_c19_constellations', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 6, '', '', '', 0, 0, ''),
	(46830, 4683, '0', 'hween_c19_mistywoodsbg', 'hween_c19_mistywoodsbg', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(46840, 4684, '0', 'china_pstr11', 'china_pstr11', 'I', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(46850, 4685, '0', 'year2020', 'year2020', 'I', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(46860, 4686, '0', 'art_c20_wall', 'art_c20_wall', 'I', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(46870, 4687, '0', 'art_c20_window', 'art_c20_window', 'I', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(46880, 4688, '0', 'india_c20_sunsetbg', 'india_c20_sunsetbg', 'I', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(46890, 4689, '0', 'diamond_painting52', 'diamond_painting52', 'I', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(46900, 4690, '0', 'diamond_painting42', 'diamond_painting42', 'I', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(46910, 4691, '0', 'diamond_painting46', 'diamond_painting46', 'I', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(46920, 4692, '0', 'diamond_painting51', 'diamond_painting51', 'I', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(46930, 4693, '0', 'diamond_painting44', 'diamond_painting44', 'I', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(46940, 4694, '0', 'diamond_painting45', 'diamond_painting45', 'I', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(46950, 4695, '0', 'diamond_painting43', 'diamond_painting43', 'I', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(46960, 4696, '0', 'party_nt_neon4', 'party_nt_neon4', 'I', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(46970, 4697, '0', 'rela_nt_wall', 'rela_nt_wall', 'I', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 6, '', '', '', 0, 0, ''),
	(46980, 4698, '0', 'party_nt_led', 'party_nt_led', 'I', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 4, '', '', '', 0, 0, ''),
	(46990, 4699, '0', 'usva_nt_wallrug', 'usva_nt_wallrug', 'I', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(47000, 4700, '0', 'lt_nt_jngl_wall', 'lt_nt_jngl_wall', 'I', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 3, '', '', '', 0, 0, ''),
	(47010, 4701, '0', 'cine_nt_light1', 'cine_nt_light1', 'I', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(47020, 4702, '0', 'val09_nt_wdrobe_g', 'val09_nt_wdrobe_g', 'I', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(47030, 4703, '0', 'party_nt_shelf', 'party_nt_shelf', 'I', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(47040, 4704, '0', 'window_nt_skyscraper', 'window_nt_skyscraper', 'I', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(47050, 4705, '0', 'window_nt_diner2', 'window_nt_diner2', 'I', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(47060, 4706, '0', 'cubie_nt_decal_2_p', 'cubie_nt_decal_2_p', 'I', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(47070, 4707, '0', 'cubie_nt_decal_1_p', 'cubie_nt_decal_1_p', 'I', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 2, '', '', '', 0, 0, ''),
	(47080, 4708, '0', 'hween_c20_floorwallb', 'hween_c20_floorwallb', 'I', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(47090, 4709, '1', 'xmas_c20_forestbg', 'xmas_c20_forestbg', 'I', 1, 1, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 6, '', '', '', 0, 0, ''),
	(47100, 4710, '0', 'poster_duck', 'poster_duck', 'I', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(47110, 4711, '0', 'pixelduck_wall', 'pixelduck_wall', 'I', 0, 0, 1.70, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(47120, 4712, '0', 'year2021', 'year2021', 'I', 0, 0, 0.35, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 3, '', '', '', 0, 0, ''),
	(47130, 4713, '0', 'diamond_painting55', 'diamond_painting55', 'I', 0, 0, 2.10, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(47140, 4714, '0', 'diamond_painting58', 'diamond_painting58', 'I', 0, 0, 2.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(47150, 4715, '0', 'diamond_painting61', 'diamond_painting61', 'I', 0, 0, 3.50, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(47160, 4716, '0', 'diamond_painting57', 'diamond_painting57', 'I', 0, 0, 2.70, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(47170, 4717, '0', 'diamond_painting63', 'diamond_painting63', 'I', 0, 0, 2.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(47180, 4718, '0', 'diamond_painting56', 'diamond_painting56', 'I', 0, 0, 2.30, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(47190, 4719, '0', 'diamond_painting53', 'diamond_painting53', 'I', 0, 0, 3.50, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(47200, 4720, '1', 'thai_c21_tropicalbg', 'thai_c21_tropicalbg', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 2, '', '', '', 0, 0, ''),
	(47210, 4721, '1', 'vwave_c21_sunsetbg', 'vwave_c21_sunsetbg', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 6, '', '', '', 0, 0, ''),
	(47220, 4722, '1', 'vwave_c21_glitchsunsetbg', 'vwave_c21_glitchsunsetbg', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 8, '', '', '', 0, 0, ''),
	(47230, 4723, '0', 'hween_c21_mistymountainbg', 'hween_c21_mistymountainbg', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 10, '', '', '', 0, 0, ''),
	(47240, 4724, '0', 'xmas_c21_winterrailbg', 'xmas_c21_winterrailbg', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 5, '', '', '', 0, 0, ''),
	(47250, 4725, '0', 'year2022', 'year2022', 'I', 0, 0, 0.35, '0', '0', '0', '0', '1', '1', '1', '1', '1', 'default', 1, '', '', '', 0, 0, ''),
	(47260, 4726, '0', 'diamond_painting74', 'diamond_painting74', 'I', 0, 0, 2.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(47270, 4727, '0', 'diamond_painting67', 'diamond_painting67', 'I', 0, 0, 2.90, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(47280, 4728, '0', 'diamond_painting64', 'diamond_painting64', 'I', 0, 0, 3.60, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(47290, 4729, '0', 'diamond_painting65', 'diamond_painting65', 'I', 0, 0, 3.50, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(47300, 4730, '0', 'diamond_painting66', 'diamond_painting66', 'I', 0, 0, 3.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(47310, 4731, '0', 'diamond_painting68', 'diamond_painting68', 'I', 0, 0, 3.20, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(47320, 4732, '0', 'diamond_painting71', 'diamond_painting71', 'I', 0, 0, 2.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(47330, 4733, '0', 'diamond_painting73', 'diamond_painting73', 'I', 0, 0, 2.40, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(47340, 4734, '0', 'flag_ukraine', 'flag_ukraine', 'I', 0, 0, 1.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(50000, 50000, '0', 'a0 pet0', 'a0 pet0', 'S', 0, 0, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(50001, 50001, '0', 'a0 pet1', 'a0 pet1', 'S', 0, 0, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(50002, 50002, '0', 'a0 pet2', 'a0 pet2', 'S', 0, 0, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(50003, 50003, '0', 'a0 pet3', 'a0 pet3', 'S', 0, 0, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(50004, 50004, '0', 'a0 pet4', 'a0 pet4', 'S', 0, 0, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(50005, 50005, '0', 'a0 pet5', 'a0 pet5', 'S', 0, 0, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(50006, 50006, '0', 'a0 pet6', 'a0 pet6', 'S', 0, 0, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'pet6', 1, '', '', '', 0, 0, ''),
	(50007, 50007, '0', 'a0 pet7', 'a0 pet7', 'S', 0, 0, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'pet7', 1, '', '', '', 0, 0, ''),
	(50008, 50008, '0', 'a0 pet8', 'a0 pet8', 'S', 0, 0, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'pet8', 1, '', '', '', 0, 0, ''),
	(50009, 50009, '0', 'a0 pet9', 'a0 pet9', 'S', 0, 0, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'pet9', 1, '', '', '', 0, 0, ''),
	(50010, 50010, '0', 'a0 pet10', 'a0 pet10', 'S', 0, 0, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'pet10', 1, '', '', '', 0, 0, ''),
	(50011, 50011, '0', 'a0 pet11', 'a0 pet11', 'S', 0, 0, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'pet11', 1, '', '', '', 0, 0, ''),
	(50012, 50012, '0', 'a0 pet12', 'a0 pet12', 'S', 0, 0, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'pet12', 1, '', '', '', 0, 0, ''),
	(50014, 50014, '0', 'a0 pet14', 'a0 pet14', 'S', 0, 0, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'pet14', 1, '', '', '', 0, 0, ''),
	(50015, 50015, '0', 'a0 pet15', 'a0 pet15', 'S', 0, 0, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'pet15', 1, '', '', '', 0, 0, ''),
	(50017, 50017, '0', 'a0 pet17', 'a0 pet17', 'S', 0, 0, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'pet17', 1, '', '', '', 0, 0, ''),
	(50018, 50018, '0', 'a0 pet18', 'a0 pet18', 'S', 0, 0, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'pet18', 1, '', '', '', 0, 0, ''),
	(50019, 50019, '0', 'a0 pet19', 'a0 pet19', 'S', 0, 0, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'pet19', 1, '', '', '', 0, 0, ''),
	(50020, 50020, '0', 'a0 pet20', 'a0 pet20', 'S', 0, 0, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'pet20', 1, '', '', '', 0, 0, ''),
	(50021, 50021, '0', 'a0 pet21', 'a0 pet21', 'S', 0, 0, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'pet21', 1, '', '', '', 0, 0, ''),
	(50022, 50022, '0', 'a0 pet22', 'a0 pet22', 'S', 0, 0, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'pet22', 1, '', '', '', 0, 0, ''),
	(50023, 50023, '0', 'a0 pet23', 'a0 pet23', 'S', 0, 0, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'pet23', 1, '', '', '', 0, 0, ''),
	(50024, 50024, '0', 'a0 pet24', 'a0 pet24', 'S', 0, 0, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'pet24', 1, '', '', '', 0, 0, ''),
	(50025, 50025, '0', 'a0 pet25', 'a0 pet25', 'S', 0, 0, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'pet25', 1, '', '', '', 0, 0, ''),
	(50028, 50028, '0', 'a0 pet28', 'a0 pet28', 'S', 0, 0, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'pet28', 1, '', '', '', 0, 0, ''),
	(50029, 50029, '0', 'a0 pet29', 'a0 pet29', 'S', 0, 0, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'pet29', 1, '', '', '', 0, 0, ''),
	(50030, 50030, '0', 'a0 pet30', 'a0 pet30', 'S', 0, 0, 1.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'pet31', 1, '', '', '', 0, 0, ''),
	(50031, 50031, '0', 'a0 pet31', 'a0 pet31', 'S', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'pet31', 1, '', '', '', 0, 0, ''),
	(50032, 50032, '0', 'a0 pet32', 'a0 pet32', 'S', 0, 0, 0.00, '0', '0', '0', '0', '1', '1', '0', '0', '1', 'pet37', 1, '', '', '', 0, 0, ''),
	(50035, 50035, '0', 'a0 pet35', 'a0 pet35', 'S', 0, 0, 0.00, '1', '0', '0', '0', '1', '1', '0', '0', '1', 'default', 1, '', '', '', 0, 0, ''),
	(50200, 0, '0', 'HTW01', 'HTW01', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50201, 0, '0', 'HTW02', 'HTW02', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50202, 0, '0', 'SPD10', 'SPD10', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50203, 0, '0', 'SPD11', 'SPD11', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50204, 0, '0', 'SPD08', 'SPD08', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50205, 0, '0', 'SPD09', 'SPD09', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50206, 0, '0', 'SPD12', 'SPD12', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50207, 0, '0', 'FRT14', 'FRT14', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50208, 0, '0', 'FRT15', 'FRT15', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50209, 0, '0', 'FRT16', 'FRT16', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50210, 0, '0', 'FRT17', 'FRT17', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50211, 0, '0', 'FRT18', 'FRT18', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50212, 0, '0', 'FRT19', 'FRT19', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50213, 0, '0', 'FRT20', 'FRT20', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50214, 0, '0', 'FRT21', 'FRT21', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50215, 0, '0', 'FRT22', 'FRT22', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50216, 0, '0', 'X2001', 'X2001', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50217, 0, '0', 'X2002', 'X2002', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50218, 0, '0', 'X2012', 'X2012', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50219, 0, '0', 'X2010', 'X2010', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50220, 0, '0', 'X2011', 'X2011', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50221, 0, '0', 'X2009', 'X2009', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50222, 0, '0', 'X2013', 'X2013', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50223, 0, '0', 'FSH01', 'FSH01', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50224, 0, '0', 'FSH08', 'FSH08', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50225, 0, '0', 'FSH09', 'FSH09', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50226, 0, '0', 'FSH10', 'FSH10', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50227, 0, '0', 'FSH11', 'FSH11', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50228, 0, '0', 'FSH12', 'FSH12', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50229, 0, '0', 'MMS06', 'MMS06', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50230, 0, '0', 'MMS07', 'MMS07', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50231, 0, '0', 'MMS09', 'MMS09', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50232, 0, '0', 'MMS08', 'MMS08', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50233, 0, '0', 'MMS10', 'MMS10', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50234, 0, '0', 'MMS11', 'MMS11', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50235, 0, '0', 'MMS12', 'MMS12', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50236, 0, '0', 'MMS13', 'MMS13', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50237, 0, '0', 'MMS14', 'MMS14', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50238, 0, '0', 'BBJ02', 'BBJ02', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50239, 0, '0', 'RVL09', 'RVL09', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50240, 0, '0', 'X2110', 'X2110', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50241, 0, '0', 'X2111', 'X2111', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50242, 0, '0', 'X2112', 'X2112', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50243, 0, '0', 'X2113', 'X2113', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50244, 0, '0', 'X2114', 'X2114', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50245, 0, '0', 'HSJ01', 'HSJ01', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50246, 0, '0', 'HSJ02', 'HSJ02', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50247, 0, '0', 'HSJ03', 'HSJ03', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50248, 0, '0', 'HSJ04', 'HSJ04', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50249, 0, '0', 'HSJ05', 'HSJ05', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50250, 0, '0', 'RVR11', 'RVR11', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50251, 0, '0', 'RVR12', 'RVR12', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50252, 0, '0', 'RVR13', 'RVR13', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50253, 0, '0', 'VPV09', 'VPV09', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50254, 0, '0', 'VPV10', 'VPV10', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50255, 0, '0', 'VPV11', 'VPV11', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50256, 0, '0', 'VPV12', 'VPV12', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50257, 0, '0', 'VPV13', 'VPV13', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50258, 0, '0', 'VPV14', 'VPV14', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50259, 0, '0', 'RVR04', 'RVR04', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50260, 0, '0', 'RVR05', 'RVR05', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50261, 0, '0', 'RVR15', 'RVR15', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50262, 0, '0', 'RVR16', 'RVR16', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50263, 0, '0', 'RVR17', 'RVR17', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50264, 0, '0', 'RVR18', 'RVR18', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50265, 0, '0', 'RVR19', 'RVR19', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50266, 0, '0', 'RVR20', 'RVR20', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50267, 0, '0', 'RVR21', 'RVR21', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50268, 0, '0', 'RVR22', 'RVR22', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50269, 0, '0', 'RVR23', 'RVR23', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50270, 0, '0', 'TLB01', 'TLB01', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50271, 0, '0', 'TTC05', 'TTC05', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50272, 0, '0', 'TTC06', 'TTC06', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50273, 0, '0', 'TTC07', 'TTC07', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50274, 0, '0', 'TTC08', 'TTC08', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50275, 0, '0', 'SCE01', 'SCE01', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50276, 0, '0', 'PRF16', 'PRF16', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50277, 0, '0', 'PRF17', 'PRF17', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50278, 0, '0', 'GTX99', 'GTX99', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50279, 0, '0', 'J2113', 'J2113', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50280, 0, '0', 'J2214', 'J2214', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50281, 0, '0', 'MMS26', 'MMS26', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50282, 0, '0', 'FRT26', 'FRT26', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50283, 0, '0', 'PRF14', 'PRF14', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50284, 0, '0', 'PRF12', 'PRF12', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50285, 0, '0', 'PRF13', 'PRF13', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50286, 0, '0', 'J2112', 'J2112', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50287, 0, '0', 'CBP13', 'CBP13', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50288, 0, '0', 'J2110', 'J2110', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50289, 0, '0', 'AND02', 'AND02', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50290, 0, '0', 'BFR19', 'BFR19', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50291, 0, '0', 'HYG09', 'HYG09', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50292, 0, '0', 'AME13', 'AME13', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50293, 0, '0', 'BFR16', 'BFR16', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50294, 0, '0', 'RVR14', 'RVR14', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50295, 0, '0', 'J2211', 'J2211', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50296, 0, '0', 'J2213', 'J2213', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50297, 0, '0', 'J2212', 'J2212', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50298, 0, '0', 'J2111', 'J2111', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50299, 0, '0', 'FRT12', 'FRT12', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50300, 0, '0', 'FRT13', 'FRT13', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50301, 0, '0', 'TTC09', 'TTC09', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50302, 0, '0', 'UKR01', 'UKR01', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50303, 0, '0', 'RVL01', 'RVL01', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50304, 0, '0', 'RVL02', 'RVL02', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50305, 0, '0', 'FSH09', 'FSH09', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50500, 0, '0', 'Football_PT', 'Football_PT', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50501, 0, '0', 'Football_IT', 'Football_IT', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50502, 0, '0', 'Football_DE', 'Football_DE', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50503, 0, '0', 'Football_PT', 'Football_PT', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50504, 0, '0', 'STG05', 'STG05', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50505, 0, '0', 'STG08', 'STG08', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50506, 0, '0', 'STG07', 'STG07', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50507, 0, '0', 'STG06', 'STG06', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50508, 0, '0', 'SCH17', 'SCH17', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50509, 0, '0', 'SCH16', 'SCH16', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50510, 0, '0', 'SCH15', 'SCH15', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50512, 0, '0', 'MCH01', 'MCH01', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50513, 0, '0', 'MCH02', 'MCH02', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50514, 0, '0', 'MMS01', 'MMS01', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50515, 0, '0', 'MMS02', 'MMS02', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50516, 0, '0', 'MMS03', 'MMS03', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50517, 0, '0', 'MMS04', 'MMS04', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50518, 0, '0', 'MMS05', 'MMS05', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50519, 0, '0', 'SHL04', 'SHL04', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50520, 0, '0', 'SHL01', 'SHL01', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50521, 0, '0', 'SHL02', 'SHL02', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50522, 0, '0', 'SHL03', 'SHL03', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50523, 0, '0', 'CO4', 'CO4', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50524, 0, '0', 'RVL03', 'RVL03', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50525, 0, '0', 'RVL04', 'RVL04', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50526, 0, '0', 'BBJ09', 'BBJ09', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50527, 0, '0', 'BBJ10', 'BBJ10', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50528, 0, '0', 'BBJ11', 'BBJ11', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50529, 0, '0', 'BBJ12', 'BBJ12', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(50530, 0, '0', 'BBJ01', 'BBJ01', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, ''),
	(60200, 0, '0', 'avatar_effect0', 'avatar_effect0', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 0, 0, ''),
	(60201, 1, '0', 'avatar_effect1', 'avatar_effect1', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 1, 1, ''),
	(60202, 2, '0', 'avatar_effect2', 'avatar_effect2', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 2, 2, ''),
	(60203, 3, '0', 'avatar_effect3', 'avatar_effect3', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 3, 3, ''),
	(60204, 4, '0', 'avatar_effect4', 'avatar_effect4', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 4, 4, ''),
	(60205, 5, '0', 'avatar_effect5', 'avatar_effect5', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 5, 5, ''),
	(60206, 6, '0', 'avatar_effect6', 'avatar_effect6', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 6, 6, ''),
	(60207, 7, '0', 'avatar_effect7', 'avatar_effect7', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 7, 7, ''),
	(60208, 8, '0', 'avatar_effect8', 'avatar_effect8', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 8, 8, ''),
	(60209, 9, '0', 'avatar_effect9', 'avatar_effect9', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 9, 9, ''),
	(60210, 10, '0', 'avatar_effect10', 'avatar_effect10', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 10, 10, ''),
	(60211, 11, '0', 'avatar_effect11', 'avatar_effect11', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 11, 11, ''),
	(60212, 12, '0', 'avatar_effect12', 'avatar_effect12', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 12, 12, ''),
	(60213, 13, '0', 'avatar_effect13', 'avatar_effect13', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 13, 13, ''),
	(60214, 14, '0', 'avatar_effect14', 'avatar_effect14', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 14, 14, ''),
	(60215, 15, '0', 'avatar_effect15', 'avatar_effect15', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 15, 15, ''),
	(60216, 16, '0', 'avatar_effect16', 'avatar_effect16', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 16, 16, ''),
	(60217, 17, '0', 'avatar_effect17', 'avatar_effect17', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 17, 17, ''),
	(60218, 18, '0', 'avatar_effect18', 'avatar_effect18', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 18, 18, ''),
	(60219, 19, '0', 'avatar_effect19', 'avatar_effect19', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 19, 19, ''),
	(60220, 20, '0', 'avatar_effect20', 'avatar_effect20', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 20, 20, ''),
	(60221, 21, '0', 'avatar_effect21', 'avatar_effect21', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 21, 21, ''),
	(60222, 22, '0', 'avatar_effect22', 'avatar_effect22', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 22, 22, ''),
	(60223, 23, '0', 'avatar_effect23', 'avatar_effect23', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 23, 23, ''),
	(60224, 24, '0', 'avatar_effect24', 'avatar_effect24', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 24, 24, ''),
	(60225, 25, '0', 'avatar_effect25', 'avatar_effect25', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 25, 25, ''),
	(60226, 26, '0', 'avatar_effect26', 'avatar_effect26', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 26, 26, ''),
	(60227, 27, '0', 'avatar_effect27', 'avatar_effect27', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 27, 27, ''),
	(60228, 28, '0', 'avatar_effect28', 'avatar_effect28', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 28, 28, ''),
	(60229, 29, '0', 'avatar_effect29', 'avatar_effect29', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 29, 29, ''),
	(60230, 30, '0', 'avatar_effect30', 'avatar_effect30', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 30, 30, ''),
	(60231, 31, '0', 'avatar_effect31', 'avatar_effect31', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 31, 31, ''),
	(60232, 32, '0', 'avatar_effect32', 'avatar_effect32', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 32, 32, ''),
	(60233, 33, '0', 'avatar_effect33', 'avatar_effect33', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 33, 33, ''),
	(60234, 34, '0', 'avatar_effect34', 'avatar_effect34', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 34, 34, ''),
	(60235, 35, '0', 'avatar_effect35', 'avatar_effect35', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 35, 35, ''),
	(60236, 36, '0', 'avatar_effect36', 'avatar_effect36', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 36, 36, ''),
	(60237, 37, '0', 'avatar_effect37', 'avatar_effect37', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 37, 37, ''),
	(60238, 38, '0', 'avatar_effect38', 'avatar_effect38', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 38, 38, ''),
	(60239, 39, '0', 'avatar_effect39', 'avatar_effect39', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 39, 39, ''),
	(60240, 40, '0', 'avatar_effect40', 'avatar_effect40', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 40, 40, ''),
	(60241, 41, '0', 'avatar_effect41', 'avatar_effect41', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 41, 41, ''),
	(60242, 42, '0', 'avatar_effect42', 'avatar_effect42', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 42, 42, ''),
	(60243, 43, '0', 'avatar_effect43', 'avatar_effect43', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 43, 43, ''),
	(60244, 44, '0', 'avatar_effect44', 'avatar_effect44', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 44, 44, ''),
	(60245, 45, '0', 'avatar_effect45', 'avatar_effect45', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 45, 45, ''),
	(60246, 46, '0', 'avatar_effect46', 'avatar_effect46', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 46, 46, ''),
	(60247, 47, '0', 'avatar_effect47', 'avatar_effect47', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 47, 47, ''),
	(60248, 48, '0', 'avatar_effect48', 'avatar_effect48', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 48, 48, ''),
	(60249, 49, '0', 'avatar_effect49', 'avatar_effect49', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 49, 49, ''),
	(60250, 50, '0', 'avatar_effect50', 'avatar_effect50', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 50, 50, ''),
	(60251, 51, '0', 'avatar_effect51', 'avatar_effect51', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 51, 51, ''),
	(60252, 52, '0', 'avatar_effect52', 'avatar_effect52', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 52, 52, ''),
	(60253, 53, '0', 'avatar_effect53', 'avatar_effect53', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 53, 53, ''),
	(60254, 54, '0', 'avatar_effect54', 'avatar_effect54', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 54, 54, ''),
	(60255, 55, '0', 'avatar_effect55', 'avatar_effect55', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 55, 55, ''),
	(60256, 56, '0', 'avatar_effect56', 'avatar_effect56', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 56, 56, ''),
	(60257, 57, '0', 'avatar_effect57', 'avatar_effect57', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 57, 57, ''),
	(60258, 58, '0', 'avatar_effect58', 'avatar_effect58', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 58, 58, ''),
	(60259, 59, '0', 'avatar_effect59', 'avatar_effect59', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 59, 59, ''),
	(60260, 60, '0', 'avatar_effect60', 'avatar_effect60', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 60, 60, ''),
	(60261, 61, '0', 'avatar_effect61', 'avatar_effect61', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 61, 61, ''),
	(60262, 62, '0', 'avatar_effect62', 'avatar_effect62', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 62, 62, ''),
	(60263, 63, '0', 'avatar_effect63', 'avatar_effect63', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 63, 63, ''),
	(60264, 64, '0', 'avatar_effect64', 'avatar_effect64', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 64, 64, ''),
	(60265, 65, '0', 'avatar_effect65', 'avatar_effect65', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 65, 65, ''),
	(60266, 66, '0', 'avatar_effect66', 'avatar_effect66', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 66, 66, ''),
	(60267, 67, '0', 'avatar_effect67', 'avatar_effect67', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 67, 67, ''),
	(60268, 68, '0', 'avatar_effect68', 'avatar_effect68', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 68, 68, ''),
	(60269, 69, '0', 'avatar_effect69', 'avatar_effect69', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 69, 69, ''),
	(60270, 70, '0', 'avatar_effect70', 'avatar_effect70', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 70, 70, ''),
	(60271, 71, '0', 'avatar_effect71', 'avatar_effect71', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 71, 71, ''),
	(60272, 72, '0', 'avatar_effect72', 'avatar_effect72', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 72, 72, ''),
	(60273, 73, '0', 'avatar_effect73', 'avatar_effect73', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 73, 73, ''),
	(60274, 74, '0', 'avatar_effect74', 'avatar_effect74', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 74, 74, ''),
	(60275, 75, '0', 'avatar_effect75', 'avatar_effect75', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 75, 75, ''),
	(60276, 76, '0', 'avatar_effect76', 'avatar_effect76', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 76, 76, ''),
	(60277, 77, '0', 'avatar_effect77', 'avatar_effect77', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 77, 77, ''),
	(60278, 78, '0', 'avatar_effect78', 'avatar_effect78', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 78, 78, ''),
	(60279, 79, '0', 'avatar_effect79', 'avatar_effect79', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 79, 79, ''),
	(60280, 80, '0', 'avatar_effect80', 'avatar_effect80', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 80, 80, ''),
	(60281, 81, '0', 'avatar_effect81', 'avatar_effect81', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 81, 81, ''),
	(60282, 82, '0', 'avatar_effect82', 'avatar_effect82', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 82, 82, ''),
	(60283, 83, '0', 'avatar_effect83', 'avatar_effect83', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 83, 83, ''),
	(60284, 84, '0', 'avatar_effect84', 'avatar_effect84', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 84, 84, ''),
	(60285, 85, '0', 'avatar_effect85', 'avatar_effect85', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 85, 85, ''),
	(60286, 86, '0', 'avatar_effect86', 'avatar_effect86', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 86, 86, ''),
	(60287, 87, '0', 'avatar_effect87', 'avatar_effect87', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 87, 87, ''),
	(60288, 88, '0', 'avatar_effect88', 'avatar_effect88', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 88, 88, ''),
	(60289, 89, '0', 'avatar_effect89', 'avatar_effect89', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 89, 89, ''),
	(60290, 90, '0', 'avatar_effect90', 'avatar_effect90', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 90, 90, ''),
	(60291, 91, '0', 'avatar_effect91', 'avatar_effect91', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 91, 91, ''),
	(60292, 92, '0', 'avatar_effect92', 'avatar_effect92', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 92, 92, ''),
	(60293, 93, '0', 'avatar_effect93', 'avatar_effect93', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 93, 93, ''),
	(60294, 94, '0', 'avatar_effect94', 'avatar_effect94', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 94, 94, ''),
	(60295, 95, '0', 'avatar_effect95', 'avatar_effect95', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 95, 95, ''),
	(60296, 96, '0', 'avatar_effect96', 'avatar_effect96', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 96, 96, ''),
	(60297, 97, '0', 'avatar_effect97', 'avatar_effect97', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 97, 97, ''),
	(60298, 98, '0', 'avatar_effect98', 'avatar_effect98', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 98, 98, ''),
	(60299, 99, '0', 'avatar_effect99', 'avatar_effect99', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 99, 99, ''),
	(60300, 100, '0', 'avatar_effect100', 'avatar_effect100', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 100, 100, ''),
	(60301, 101, '0', 'avatar_effect101', 'avatar_effect101', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 101, 101, ''),
	(60302, 102, '0', 'avatar_effect102', 'avatar_effect102', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 102, 102, ''),
	(60303, 103, '0', 'avatar_effect103', 'avatar_effect103', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 103, 103, ''),
	(60304, 104, '0', 'avatar_effect104', 'avatar_effect104', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 104, 104, ''),
	(60305, 105, '0', 'avatar_effect105', 'avatar_effect105', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 105, 105, ''),
	(60306, 106, '0', 'avatar_effect106', 'avatar_effect106', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 106, 106, ''),
	(60307, 107, '0', 'avatar_effect107', 'avatar_effect107', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 107, 107, ''),
	(60308, 108, '0', 'avatar_effect108', 'avatar_effect108', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 108, 108, ''),
	(60309, 109, '0', 'avatar_effect109', 'avatar_effect109', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 109, 109, ''),
	(60310, 110, '0', 'avatar_effect110', 'avatar_effect110', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 110, 110, ''),
	(60311, 111, '0', 'avatar_effect111', 'avatar_effect111', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 111, 111, ''),
	(60312, 112, '0', 'avatar_effect112', 'avatar_effect112', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 112, 112, ''),
	(60313, 113, '0', 'avatar_effect113', 'avatar_effect113', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 113, 113, ''),
	(60314, 114, '0', 'avatar_effect114', 'avatar_effect114', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 114, 114, ''),
	(60315, 115, '0', 'avatar_effect115', 'avatar_effect115', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 115, 115, ''),
	(60316, 116, '0', 'avatar_effect116', 'avatar_effect116', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 116, 116, ''),
	(60317, 117, '0', 'avatar_effect117', 'avatar_effect117', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 117, 117, ''),
	(60318, 118, '0', 'avatar_effect118', 'avatar_effect118', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 118, 118, ''),
	(60319, 119, '0', 'avatar_effect119', 'avatar_effect119', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 119, 119, ''),
	(60320, 120, '0', 'avatar_effect120', 'avatar_effect120', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 120, 120, ''),
	(60321, 121, '0', 'avatar_effect121', 'avatar_effect121', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 121, 121, ''),
	(60322, 122, '0', 'avatar_effect122', 'avatar_effect122', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 122, 122, ''),
	(60323, 123, '0', 'avatar_effect123', 'avatar_effect123', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 123, 123, ''),
	(60324, 124, '0', 'avatar_effect124', 'avatar_effect124', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 124, 124, ''),
	(60325, 125, '0', 'avatar_effect125', 'avatar_effect125', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 125, 125, ''),
	(60326, 126, '0', 'avatar_effect126', 'avatar_effect126', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 126, 126, ''),
	(60327, 127, '0', 'avatar_effect127', 'avatar_effect127', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 127, 127, ''),
	(60328, 128, '0', 'avatar_effect128', 'avatar_effect128', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 128, 128, ''),
	(60329, 129, '0', 'avatar_effect129', 'avatar_effect129', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 129, 129, ''),
	(60330, 130, '0', 'avatar_effect130', 'avatar_effect130', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 130, 130, ''),
	(60331, 131, '0', 'avatar_effect131', 'avatar_effect131', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 131, 131, ''),
	(60332, 132, '0', 'avatar_effect132', 'avatar_effect132', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 132, 132, ''),
	(60333, 133, '0', 'avatar_effect133', 'avatar_effect133', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 133, 133, ''),
	(60334, 134, '0', 'avatar_effect134', 'avatar_effect134', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 134, 134, ''),
	(60335, 135, '0', 'avatar_effect135', 'avatar_effect135', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 135, 135, ''),
	(60336, 136, '0', 'avatar_effect136', 'avatar_effect136', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 136, 136, ''),
	(60337, 137, '0', 'avatar_effect137', 'avatar_effect137', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 137, 137, ''),
	(60338, 138, '0', 'avatar_effect138', 'avatar_effect138', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 138, 138, ''),
	(60339, 139, '0', 'avatar_effect139', 'avatar_effect139', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 139, 139, ''),
	(60340, 140, '0', 'avatar_effect140', 'avatar_effect140', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 140, 140, ''),
	(60341, 141, '0', 'avatar_effect141', 'avatar_effect141', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 141, 141, ''),
	(60342, 142, '0', 'avatar_effect142', 'avatar_effect142', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 142, 142, ''),
	(60343, 143, '0', 'avatar_effect143', 'avatar_effect143', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 143, 143, ''),
	(60344, 144, '0', 'avatar_effect144', 'avatar_effect144', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 144, 144, ''),
	(60345, 145, '0', 'avatar_effect145', 'avatar_effect145', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 145, 145, ''),
	(60346, 146, '0', 'avatar_effect146', 'avatar_effect146', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 146, 146, ''),
	(60347, 147, '0', 'avatar_effect147', 'avatar_effect147', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 147, 147, ''),
	(60348, 148, '0', 'avatar_effect148', 'avatar_effect148', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 148, 148, ''),
	(60349, 149, '0', 'avatar_effect149', 'avatar_effect149', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 149, 149, ''),
	(60350, 150, '0', 'avatar_effect150', 'avatar_effect150', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 150, 150, ''),
	(60351, 151, '0', 'avatar_effect151', 'avatar_effect151', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 151, 151, ''),
	(60352, 152, '0', 'avatar_effect152', 'avatar_effect152', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 152, 152, ''),
	(60353, 153, '0', 'avatar_effect153', 'avatar_effect153', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 153, 153, ''),
	(60354, 154, '0', 'avatar_effect154', 'avatar_effect154', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 154, 154, ''),
	(60355, 155, '0', 'avatar_effect155', 'avatar_effect155', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 155, 155, ''),
	(60356, 156, '0', 'avatar_effect156', 'avatar_effect156', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 156, 156, ''),
	(60357, 157, '0', 'avatar_effect157', 'avatar_effect157', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 157, 157, ''),
	(60358, 158, '0', 'avatar_effect158', 'avatar_effect158', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 158, 158, ''),
	(60359, 159, '0', 'avatar_effect159', 'avatar_effect159', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 159, 159, ''),
	(60360, 160, '0', 'avatar_effect160', 'avatar_effect160', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 160, 160, ''),
	(60361, 161, '0', 'avatar_effect161', 'avatar_effect161', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 161, 161, ''),
	(60362, 162, '0', 'avatar_effect162', 'avatar_effect162', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 162, 162, ''),
	(60363, 163, '0', 'avatar_effect163', 'avatar_effect163', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 163, 163, ''),
	(60364, 164, '0', 'avatar_effect164', 'avatar_effect164', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 164, 164, ''),
	(60365, 165, '0', 'avatar_effect165', 'avatar_effect165', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 165, 165, ''),
	(60366, 166, '0', 'avatar_effect166', 'avatar_effect166', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 166, 166, ''),
	(60367, 167, '0', 'avatar_effect167', 'avatar_effect167', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 167, 167, ''),
	(60368, 168, '0', 'avatar_effect168', 'avatar_effect168', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 168, 168, ''),
	(60369, 169, '0', 'avatar_effect169', 'avatar_effect169', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 169, 169, ''),
	(60370, 170, '0', 'avatar_effect170', 'avatar_effect170', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 170, 170, ''),
	(60371, 171, '0', 'avatar_effect171', 'avatar_effect171', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 171, 171, ''),
	(60372, 172, '0', 'avatar_effect172', 'avatar_effect172', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 172, 172, ''),
	(60373, 173, '0', 'avatar_effect173', 'avatar_effect173', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 173, 173, ''),
	(60374, 174, '0', 'avatar_effect174', 'avatar_effect174', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 174, 174, ''),
	(60375, 175, '0', 'avatar_effect175', 'avatar_effect175', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 175, 175, ''),
	(60376, 176, '0', 'avatar_effect176', 'avatar_effect176', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 176, 176, ''),
	(60377, 177, '0', 'avatar_effect177', 'avatar_effect177', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 177, 177, ''),
	(60378, 178, '0', 'avatar_effect178', 'avatar_effect178', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 178, 178, ''),
	(60379, 179, '0', 'avatar_effect179', 'avatar_effect179', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 179, 179, ''),
	(60380, 180, '0', 'avatar_effect180', 'avatar_effect180', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 180, 180, ''),
	(60381, 181, '0', 'avatar_effect181', 'avatar_effect181', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 181, 181, ''),
	(60382, 182, '0', 'avatar_effect182', 'avatar_effect182', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 182, 182, ''),
	(60383, 183, '0', 'avatar_effect183', 'avatar_effect183', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 183, 183, ''),
	(60384, 184, '0', 'avatar_effect184', 'avatar_effect184', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 184, 184, ''),
	(60385, 185, '0', 'avatar_effect185', 'avatar_effect185', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 185, 185, ''),
	(60386, 186, '0', 'avatar_effect186', 'avatar_effect186', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 186, 186, ''),
	(60387, 187, '0', 'avatar_effect187', 'avatar_effect187', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 187, 187, ''),
	(60388, 188, '0', 'avatar_effect188', 'avatar_effect188', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 188, 188, ''),
	(60389, 189, '0', 'avatar_effect189', 'avatar_effect189', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 189, 189, ''),
	(60390, 190, '0', 'avatar_effect190', 'avatar_effect190', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 190, 190, ''),
	(60391, 191, '0', 'avatar_effect191', 'avatar_effect191', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 191, 191, ''),
	(60392, 192, '0', 'avatar_effect192', 'avatar_effect192', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 192, 192, ''),
	(60393, 193, '0', 'avatar_effect193', 'avatar_effect193', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 193, 193, ''),
	(60394, 194, '0', 'avatar_effect194', 'avatar_effect194', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 194, 194, ''),
	(60395, 195, '0', 'avatar_effect195', 'avatar_effect195', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 195, 195, ''),
	(60396, 196, '0', 'avatar_effect196', 'avatar_effect196', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 196, 196, ''),
	(60397, 197, '0', 'avatar_effect197', 'avatar_effect197', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 197, 197, ''),
	(60398, 198, '0', 'avatar_effect198', 'avatar_effect198', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 198, 198, ''),
	(60399, 199, '0', 'avatar_effect199', 'avatar_effect199', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 199, 199, ''),
	(60400, 200, '0', 'avatar_effect200', 'avatar_effect200', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 200, 200, ''),
	(60401, 201, '0', 'avatar_effect201', 'avatar_effect201', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 201, 201, ''),
	(60402, 202, '0', 'avatar_effect202', 'avatar_effect202', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 202, 202, ''),
	(60403, 203, '0', 'avatar_effect203', 'avatar_effect203', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 203, 203, ''),
	(60404, 204, '0', 'avatar_effect204', 'avatar_effect204', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 204, 204, ''),
	(60405, 205, '0', 'avatar_effect205', 'avatar_effect205', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 205, 205, ''),
	(60406, 206, '0', 'avatar_effect206', 'avatar_effect206', 'E', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '1', 'effect', 1, '', '', '', 206, 206, ''),
	(65005013, 454, '0', '', '', 'B', 0, 0, 0.00, '0', '0', '0', '0', '1', '0', '0', '0', '0', 'badge', 1, '', '', '', 0, 0, '');
/*!40000 ALTER TABLE `items_base` ENABLE KEYS */;

-- Dumping structure for table test.items_crackable
DROP TABLE IF EXISTS `items_crackable`;
CREATE TABLE IF NOT EXISTS `items_crackable` (
  `item_id` int(11) NOT NULL,
  `item_name` varchar(64) COLLATE utf8mb4_unicode_ci NOT NULL COMMENT 'Item name is only for identification',
  `count` int(7) NOT NULL DEFAULT 2,
  `prizes` varchar(200) CHARACTER SET latin1 NOT NULL DEFAULT '179:1' COMMENT 'Used in the format of item_id:chance;item_id_2:chance. item_id must be id in the items_base table. Default value for chance is 100.',
  `achievement_tick` varchar(64) COLLATE utf8mb4_unicode_ci NOT NULL,
  `achievement_cracked` varchar(64) COLLATE utf8mb4_unicode_ci NOT NULL,
  `required_effect` int(3) NOT NULL DEFAULT 0 COMMENT 'Required effect ID for opening',
  `subscription_duration` int(3) DEFAULT NULL COMMENT 'Duration in days',
  `subscription_type` varchar(5) COLLATE utf8mb4_unicode_ci DEFAULT NULL COMMENT 'hc for Habbo Club, bc for Builders Club',
  PRIMARY KEY (`item_id`) USING BTREE,
  UNIQUE KEY `id` (`item_id`) USING BTREE,
  KEY `data` (`count`,`prizes`,`achievement_tick`,`achievement_cracked`) USING BTREE
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci ROW_FORMAT=DYNAMIC;

-- Dumping data for table test.items_crackable: 187 rows
/*!40000 ALTER TABLE `items_crackable` DISABLE KEYS */;
REPLACE INTO `items_crackable` (`item_id`, `item_name`, `count`, `prizes`, `achievement_tick`, `achievement_cracked`, `required_effect`, `subscription_duration`, `subscription_type`) VALUES
	(4986, 'easter13_egg_0', 1000, '1975:11;21:11;26:11;28:11;36:11;47:11;249:11;253:11;1759:11', '', '', 0, NULL, NULL),
	(4987, 'easter13_egg_3', 20000, '5009:20;5000:40;5006:40', '', '', 0, NULL, NULL),
	(4988, 'easter13_egg_1', 5000, '5004:25;5005:25;5008:25;5010:25', '', '', 0, NULL, NULL),
	(4989, 'easter13_egg_2', 10000, '5001:25;5002:25;5007:25;5001:25', '', '', 0, NULL, NULL),
	(5102, 'mystics_crystal_l', 1500000, '5101:100', 'CrystalCracker', 'CrystalLegend', 0, NULL, NULL),
	(5985, 'hblooza14_pinata2', 100, '5996:60;6006:30;6017:10', 'PinataWhacker', 'PinataBreaker', 158, NULL, NULL),
	(5990, 'hblooza14_pinata1', 100, '5989:60;6007:30;6005:10', 'PinataWhacker', 'PinataBreaker', 158, NULL, NULL),
	(6001, 'hblooza14_pinata3', 100, '6003:60;6021:30;5999:10', 'PinataWhacker', 'PinataBreaker', 158, NULL, NULL),
	(6028, 'hblooza14_pinata4', 100, '5978:60;5977:30;5980:10', 'PinataWhacker', 'PinataBreaker', 158, NULL, NULL),
	(8193, 'habbo15_rare_crackable', 2, '8222:7;8221:7;8220:6;8219:7;8218:6;8217:7;8216:6;8215:7;8214:6;8213:7;8212:6;8211:7;8210:6;8209:7;8208:7', '', '', 0, NULL, NULL),
	(8201, 'habbo15_crackable', 2, '8193:1;8201:9;6024:10;6022:10;9325:6;9326:6;8236:6;8224:6;179:6;8239:6;8240:6;3134:6;4275:6;4246:6;46220:10', '', '', 0, NULL, NULL),
	(8439, 'habbo15_pumpkin2', 1, '6191:20;8384:16;8380:16;4738:16;5002:16;8401:16', '', '', 0, NULL, NULL),
	(8438, 'habbo15_pumpkin1', 1, '174:5;4268:5;3294:5;4292:5;6178:5;228:5;179:5;208:5;209:5;210:5;3233:5;6153:5;2102:5;4083:5;2946:5;5300:5;4309:5;177:5;3189:5;5869:5', '', '', 0, NULL, NULL),
	(8451, 'gold_rare_crackable', 2, '8458:6;8457:6;8456:6;8455:6;8454:6;8453:5;8452:6;8450:6;8449:6;8448:6;8447:6;8446:5;8445:6;8444:6;8442:6;8441:6;46320:6', '', '', 0, NULL, NULL),
	(8881, 'easter_r16_crackable', 2, '8880:20;8882:20;8884:20;8886:20;46360:20', '', '', 0, NULL, NULL),
	(8918, 'jungle_c16_flowerd2', 12, '8919:100', '', 'AdvancedHorticulturist', 192, NULL, NULL),
	(8919, 'jungle_c16_flowerd1', 12, '8919:100', '', 'AdvancedHorticulturist', 192, NULL, NULL),
	(8926, 'jungle_c16_flowerc3', 12, '8926:100', '', 'AdvancedHorticulturist', 192, NULL, NULL),
	(8948, 'jungle_c16_flowera3', 12, '8948:100', '', 'AdvancedHorticulturist', 192, NULL, NULL),
	(8951, 'jungle_c16_flowerd3', 12, '8951:100', '', 'AdvancedHorticulturist', 192, NULL, NULL),
	(8968, 'jungle_c16_flowerc2', 12, '8968:100', '', 'AdvancedHorticulturist', 192, NULL, NULL),
	(8975, 'jungle_c16_flowera1', 12, '8975:100', '', 'AdvancedHorticulturist', 192, NULL, NULL),
	(8977, 'jungle_c16_flowerb3', 12, '8977:100', '', 'AdvancedHorticulturist', 192, NULL, NULL),
	(8981, 'jungle_c16_flowerb2', 12, '8981:100', '', 'AdvancedHorticulturist', 192, NULL, NULL),
	(8982, 'jungle_c16_flowerb1', 12, '8982:100', '', 'AdvancedHorticulturist', 192, NULL, NULL),
	(8983, 'jungle_c16_flowerc1', 12, '8983:100', '', 'AdvancedHorticulturist', 192, NULL, NULL),
	(8987, 'jungle_c16_flowera2', 12, '8987:100', '', 'AdvancedHorticulturist', 192, NULL, NULL),
	(8993, 'bonusbag16_1', 2, '8350:9;8351:8;8352:8;8353:8;8354:9;8355:9;8356:8;8357:8;8358:9;8359:8;8360:8;8361:8', '', '', 0, NULL, NULL),
	(8994, 'bonusbag16_2', 2, '8628:10;8629:10;8630:10;8631:10;8887:10;8888:10;8889:10;8890:10;889:101;8892:10', '', '', 0, NULL, NULL),
	(9134, 'hhistory_r16_crackable', 2, '9131:6;9132:8;9133:6;9135:7;9136:6;9137:7;9138:6;9139:7;9140:6;9141:7;9142:6;9143:7;9144:6;9145:8;9146:6', '', '', 0, NULL, NULL),
	(9154, 'hween_r16_crackable2', 20, '9178:30;9156:30;9171:15;9197:25', '', '', 0, NULL, NULL),
	(9164, 'hween_c16_crackable1', 20, '9158:50;9188:35;9191:15', '', '', 0, NULL, NULL),
	(9230, 'xmas_c16_stocking', 1, '9254:5;9218:5;9217:5;9216:5;8499:5;8484:5;6253:5;5496:5;4330:5;4315:5;4304:5;4293:5;4291:5;4287:5;3740:5;3313:5;2064:5;215:5;214:5;212:5', '', '', 0, NULL, NULL),
	(9281, 'bonusbag16_3', 2, '8893:9;8894:8;8895:8;8896:8;8897:9;8898:9;9282:8;9283:8;9284:9;9285:8;9286:8;9287:8', '', '', 0, NULL, NULL),
	(9324, 'bc_gift_31days', 1, '', '', '', 0, 31, 'bc'),
	(9325, 'hc_gift_14days', 1, '', '', '', 0, 14, 'hc'),
	(9326, 'hc_gift_31days', 1, '', '', '', 0, 31, 'hc'),
	(9327, 'bc_gift_14days', 1, '', '', '', 0, 14, 'bc'),
	(9408, 'easter_c17_floweringbush', 1, '9444:50;9431:35;9434:15', '', '', 192, NULL, NULL),
	(9416, 'easter_c17_egg', 20, '9457:10;5838:9;3424:9;9411:9;8583:9;8595:9;3412:9;3921:9;7972:9;5834:9;8252:9', '', '', 0, NULL, NULL),
	(9425, 'easter_c17_leafsprout', 1, '9436:100', '', 'AdvancedHorticulturist', 192, NULL, NULL),
	(9433, 'easter_c17_sapling', 1, '9408:100', '', 'AdvancedHorticulturist', 192, NULL, NULL),
	(9445, 'easter_c17_seeds', 1, '9433:50;9425:50', '', 'AdvancedHorticulturist', 192, NULL, NULL),
	(9447, 'easter_c17_seedbag', 1, '9445:100', '', '', 0, NULL, NULL),
	(9461, 'bonusbag17_1', 2, '9348:12;9347:13;9346:12;9345:13;9344:12;9343:13;9326:12;2065:13', '', '', 0, NULL, NULL),
	(9463, 'santorini_c17_artefact4', 2, '9492:100', '', '', 0, NULL, NULL),
	(9467, 'santorini_c17_artefact3', 2, '9472:100', '', '', 0, NULL, NULL),
	(9475, 'santorini_c17_artefact5', 2, '9479:100', '', '', 0, NULL, NULL),
	(9477, 'santorini_r17_chest', 2, '9463:20;9467:20;9475:20;9480:20;9502:20', '', '', 0, NULL, NULL),
	(9480, 'santorini_c17_artefact1', 2, '9482:100', '', '', 0, NULL, NULL),
	(9502, 'santorini_c17_artefact2', 2, '9470:100', '', '', 0, NULL, NULL),
	(9549, 'bonusbag17_2', 2, '9366:12;9365:13;9364:12;9363:13;9362:12;9361:13;9326:12;2065:13', '', '', 0, NULL, NULL),
	(9667, 'hhistory_r17_crackable', 2, '9656:6;9657:6;9658:6;9659:7;9660:6;9661:6;9662:6;9663:7;9664:6;9665:6;9666:6;9668:7;9669:6;9670:6;9671:6;9672:7', '', '', 0, NULL, NULL),
	(9753, 'hween_c17_flamingknight', 20, '9738:20;9733:20;9739:20;9760:20;9727:10;9734:10', '', '', 0, NULL, NULL),
	(9763, 'bonusbag17_3', 2, '9360:12;9359:13;9358:12;9357:13;9356:12;9355:13;9326:12;2065:13', '', '', 0, NULL, NULL),
	(9764, 'bonusbag17_4', 2, '9354:12;9353:13;9352:12;9351:13;9350:12;9349:13;9326:12;2065:13', '', '', 0, NULL, NULL),
	(9808, 'xmas_c17_book', 1, '9790:17;9793:16;9801:17;9829:17;9833:16;9842:17', '', '', 0, NULL, NULL),
	(9867, 'bonusbag18_3', 2, '9866:12;9865:13;9864:12;9863:13;9862:12;9861:13;9326:12;2065:13', '', '', 0, NULL, NULL),
	(9868, 'bonusbag18_2', 2, '9874:12;9873:13;9872:12;9871:13;9870:12;9869:13;9326:12;2065:13', '', '', 0, NULL, NULL),
	(9875, 'bonusbag18_4', 2, '9882:12;9881:13;9880:12;9879:13;9878:12;9877:13;9326:12;2065:13', '', '', 0, NULL, NULL),
	(9876, 'bonusbag18_1', 2, '9888:12;9887:13;9886:12;9885:13;9884:12;9883:13;9326:12;2065:13', '', '', 0, NULL, NULL),
	(9896, 'ny18_crackable', 2, '9891:10;9889:15;9890:15;9892:15;9893:15;9894:15;9895:15', '', '', 0, NULL, NULL),
	(9961, 'easter_c18_snowdrop3', 12, '10017:80;9969:20;10021:20;9961:20;9986:20', '', 'AdvancedHorticulturist', 192, NULL, NULL),
	(9963, 'easter_c18_lupin1', 12, '9963:80;9969:20;10002:20;9976:20;9978:20', '', 'AdvancedHorticulturist', 192, NULL, NULL),
	(9965, 'easter_c18_tulip2', 12, '9965:80;9969:20', '', 'AdvancedHorticulturist', 192, NULL, NULL),
	(9966, 'easter_c18_seedpackrose', 1, '10022:25;9994:25;9971:25;9983:25', '', '', 0, NULL, NULL),
	(9970, 'easter_c18_seedpacktulip', 1, '9997:25;9965:25;9972:25;10006:25', '', '', 0, NULL, NULL),
	(9971, 'easter_c18_rose3', 12, '10022:20;9971:20;9969:20;9983:20;9994:20', '', 'AdvancedHorticulturist', 192, NULL, NULL),
	(9972, 'easter_c18_tulip3', 12, '9972:80;9969:20', '', 'AdvancedHorticulturist', 192, NULL, NULL),
	(9976, 'easter_c18_lupin3', 12, '9963:80;9969:20;10002:20;9976:20;9978:20', '', 'AdvancedHorticulturist', 192, NULL, NULL),
	(9978, 'easter_c18_lupin4', 12, '9963:80;9969:20;10002:20;9976:20;9978:20', '', 'AdvancedHorticulturist', 192, NULL, NULL),
	(9982, 'easter_c18_seedpacksnowdrop', 1, '10017:25;10021:25;9961:25;9986:25', '', '', 0, NULL, NULL),
	(9983, 'easter_c18_rose4', 12, '10022:20;9971:20;9969:20;9983:20;9994:20', '', 'AdvancedHorticulturist', 192, NULL, NULL),
	(9986, 'easter_c18_snowdrop4', 12, '10017:80;9969:20;10021:20;9961:20;9986:20', '', 'AdvancedHorticulturist', 192, NULL, NULL),
	(9994, 'easter_c18_rose2', 12, '10022:20;9971:20;9969:20;9983:20;9994:20', '', 'AdvancedHorticulturist', 192, NULL, NULL),
	(9997, 'easter_c18_tulip1', 12, '9997:80;9969:20;9965:20;9972:20;10006:20', '', 'AdvancedHorticulturist', 192, NULL, NULL),
	(10002, 'easter_c18_lupin2', 12, '9963:80;9969:20;10002:20;9976:20;9978:20', '', 'AdvancedHorticulturist', 192, NULL, NULL),
	(10006, 'easter_c18_tulip4', 12, '10006:80;9969:20', '', 'AdvancedHorticulturist', 192, NULL, NULL),
	(10013, 'easter_c18_seedpacklupin', 1, '9963:25;10002:25;9976:25;9978:25', '', '', 0, NULL, NULL),
	(10017, 'easter_c18_snowdrop1', 12, '10017:80;9969:20;10021:20;9961:20;9986:20', '', 'AdvancedHorticulturist', 192, NULL, NULL),
	(10021, 'easter_c18_snowdrop2', 12, '10017:80;9969:20;10021:20;9961:20;9986:20', '', 'AdvancedHorticulturist', 192, NULL, NULL),
	(10022, 'easter_c18_rose1', 12, '10022:20;9971:20;9969:20;9983:20;9994:20', '', 'AdvancedHorticulturist', 192, NULL, NULL),
	(10070, 'coralking_c18_treasurechest', 2, '10062:4;10065:4;10069:4;10077:4;10080:4;10081:4;10084:4;10086:4;10089:4;10100:4;10104:4;10108:4;10110:4;10118:4;10119:4;10072:8;10099:7;10111:8;10117:7;10093:5;10113:5', '', '', 0, NULL, NULL),
	(10078, 'coralking_r18_goldenchest', 2, '10072:18;10099:17;10111:18;10117:17;10093:15;10113:15', '', '', 0, NULL, NULL),
	(10170, 'tokyo_c18_gacha', 2, '10132:10;10133:10;10139:10;10144:10;10152:10;10154:10;10155:10;10167:10;10168:10;10185:10', '', '', 0, NULL, NULL),
	(10212, 'hhistory_r18_crackable', 2, '10206:6;10207:6;10208:6;10209:7;10210:6;10211:6;10213:6;10214:7;10215:6;10216:6;10217:6;10218:7;10219:6;10220:6;10221:6;10222:7', '', '', 0, NULL, NULL),
	(10322, 'diamond_c18_giftbox', 2, '10323:45;10324:45;10321:10', '', '', 0, NULL, NULL),
	(10341, 'xmas_c18_doll10', 2, '10349:80;10394:20', '', '', 0, NULL, NULL),
	(10343, 'xmas_c18_doll8', 2, '10387:100', '', '', 0, NULL, NULL),
	(10349, 'xmas_c18_doll6', 2, '10384:100', '', '', 0, NULL, NULL),
	(10352, 'xmas_c18_doll5', 2, '10378:80;10394:20', '', '', 0, NULL, NULL),
	(10370, 'xmas_c18_doll3', 2, '10398:100', '', '', 0, NULL, NULL),
	(10371, 'xmas_c18_doll2', 2, '10370:100', '', '', 0, NULL, NULL),
	(10378, 'xmas_c18_doll1', 2, '10371:100', '', '', 0, NULL, NULL),
	(10384, 'xmas_c18_doll7', 2, '10343:100', '', '', 0, NULL, NULL),
	(10387, 'xmas_c18_doll9', 2, '10341:100', '', '', 0, NULL, NULL),
	(10398, 'xmas_c18_doll4', 2, '10352:100', '', '', 0, NULL, NULL),
	(10414, 'ny_r18_crackable', 2, '10409:12;10410:13;10411:12;10412:13;10415:12;10416:13;10417:12;10418:13', '', '', 0, NULL, NULL),
	(10487, 'easter_c19_babyent', 24, '10516:57;10495:25', '', '', 186, NULL, NULL),
	(10497, 'easter_c19_book1', 2, '10517:45;10535:45;10522:10', '', '', 0, NULL, NULL),
	(10498, 'easter_c19_book3', 2, '10532:45;10513:45;10494:10', '', '', 0, NULL, NULL),
	(10501, 'easter_c19_book2', 2, '10488:45;10524:45;10504:10', '', '', 0, NULL, NULL),
	(10505, 'easter_c19_book4', 2, '10530:45;10538:45;10523:10', '', '', 0, NULL, NULL),
	(10510, 'easter_c19_babyhippogriff', 24, '10541:75;10537:25', '', '', 186, NULL, NULL),
	(10512, 'easter_c19_forrestegg', 24, '10510:50;10487:35;10529:15', '', '', 186, NULL, NULL),
	(10518, 'easter_c19_ancientbook', 1, '10497:25;10501:25;10498:25;10505:25', '', '', 186, NULL, NULL),
	(10529, 'easter_c19_babykelpie', 24, '10484:75;10528:25', '', '', 186, NULL, NULL),
	(10543, 'bonusbag19_1', 2, '10549:12;10548:13;10547:12;10546:13;10545:12;10544:13;9326:12;2065:13', '', '', 0, NULL, NULL),
	(10572, 'booster_c19_box1', 1, '10568:15;10563:16;10559:15;10557:16;10555:13;10551:15;10558:10', '', '', 0, NULL, NULL),
	(10573, 'booster_c19_box2', 1, '10568:15;10563:16;10559:15;10557:16;10555:13;10551:15;10558:10', '', '', 0, NULL, NULL),
	(10665, 'bonusbag19_2', 2, '10671:12;10670:13;10669:12;10668:13;10667:12;10666:13;9326:12;2065:13', '', '', 0, NULL, NULL),
	(10800, 'hween_c19_witchsatchel', 1, '10787:12;10791:13;10798:12;10812:13;10825:13;10826:12;10829:13;10824:12', '', '', 0, NULL, NULL),
	(10833, 'bonusbag19_3', 2, '10839:12;10838:13;10837:12;10836:13;10835:12;10834:13;9326:12;2065:13', '', '', 0, NULL, NULL),
	(10901, 'xmas_c19_box3', 2, '10931:50;10884:50', '', '', 0, NULL, NULL),
	(10916, 'xmas_c19_box2', 2, '10901:50;10907:50', '', '', 0, NULL, NULL),
	(10928, 'xmas_c19_box6', 2, '10944:100', '', '', 0, NULL, NULL),
	(10931, 'xmas_c19_box4', 2, '10936:50;10940:50', '', '', 0, NULL, NULL),
	(10936, 'xmas_c19_box5', 2, '10928:50;10930:50', '', '', 0, NULL, NULL),
	(10943, 'xmas_c19_box1', 2, '10916:50;10902:50', '', '', 0, NULL, NULL),
	(10951, 'bonusbag19_4', 2, '10950:12;10949:13;10948:12;10947:13;10946:12;10945:13;9326:12;2065:13', '', '', 0, NULL, NULL),
	(10970, 'ny_r19_crackable', 1, '10968:13;10966:12;10967:13;10969:12;10962:13;10963:12;10964:13;10965:12', '', '', 0, NULL, NULL),
	(11017, 'bonusbag20_1', 2, '11023:12;11022:13;11021:12;11020:13;11019:12;11018:13;9326:12;2065:13', '', '', 0, NULL, NULL),
	(11030, 'bonusbag20_3', 2, '11036:12;11035:13;11034:12;11033:13;11033:12;11031:13;9326:12;2065:13', '', '', 0, NULL, NULL),
	(11043, 'bonusbag20_2', 2, '11029:12;11028:13;11027:12;11026:13;11025:12;11024:13;9326:12;2065:13', '', '', 0, NULL, NULL),
	(11044, 'bonusbag20_4', 2, '11042:12;11041:13;11040:12;11039:13;11038:12;11037:13;9326:12;2065:13', '', '', 0, NULL, NULL),
	(11048, 'booster_c20_box', 1, '11069:15;11062:14;11076:9;11065:9;11056:8;11070:8;11059:7;11058:6;11061:6;11073:6;11054:5;11067:5;11046:2', '', '', 0, NULL, NULL),
	(11081, 'easter_c20_darkrock', 1, '11104:31;11093:31;11105:31;11083:7', '', '', 183, NULL, NULL),
	(11083, 'easter_c20_darkprize4', 1, '11114:100', '', '', 186, NULL, NULL),
	(11093, 'easter_c20_darkprize2', 1, '11116:100', '', '', 186, NULL, NULL),
	(11104, 'easter_c20_darkprize3', 1, '11138:100', '', '', 186, NULL, NULL),
	(11105, 'easter_c20_darkprize1', 1, '11127:100', '', '', 186, NULL, NULL),
	(11120, 'easter_c20_lightprize3', 1, '11132:100', '', '', 186, NULL, NULL),
	(11124, 'easter_c20_lightprize2', 1, '11130:100', '', '', 186, NULL, NULL),
	(11126, 'easter_c20_lightrock', 1, '11120:31;11124:31;11135:31;11134:7', '', '', 183, NULL, NULL),
	(11134, 'easter_c20_lightprize4', 1, '11082:100', '', '', 186, NULL, NULL),
	(11135, 'easter_c20_lightprize1', 1, '11089:100', '', '', 186, NULL, NULL),
	(11148, 'spa_c20_crackable1A', 2, '11160:10;11153:25;11154:25;11167:20;11165:20', '', '', 0, NULL, NULL),
	(11166, 'spa_c20_crackable2A', 2, '11149:10;11162:25;11147:25;11156:20;11158:20', '', '', 0, NULL, NULL),
	(11210, 'india_c20_blueprint', 2, '11195:20;11190:20;11179:20;11172:20;11212:20', '', '', 0, NULL, NULL),
	(5332, 'mystics_crystal', 14, '179:100', '', '', 0, NULL, NULL),
	(10626, 'fest_c19_bprintcrackable', 2, '10600:25;10606:25;10614:25;10636:25', '', '', 0, NULL, NULL),
	(11308, 'habbo20_r20_crackable', 2, '11327:1;11314:2;11325:4;11315:4;11313:4;11330:6;11329:6;11320:6;11323:7;11318:7;11317:7;11328:9;11324:9;11321:9;11319:9;11322:10', '', '', 0, NULL, NULL),
	(11309, 'habbo20_c20_crackable', 2, '11309:3;11308:1;6281:6;6292:10;8583:10;8335:10;10481:12;7843:12;8589:12;10821:12;8526:12', '', '', 0, NULL, NULL),
	(5194, 'hblooza_pinata1', 100, '5183:17;5192:16;5182:17;5191:17;5190:16;5184:17', 'PinataWhacker', 'PinataBreaker', 158, NULL, NULL),
	(5193, 'hblooza_pinata2', 100, '5188:20;5185:20;5187:20;5189:20;5186:20', 'PinataWhacker', 'PinataBreaker', 158, NULL, NULL),
	(9214, 'xmas_c16_creature7', 24, '9256:50;9246:50', '', '', 186, NULL, NULL),
	(9232, 'xmas_c16_egg', 24, '9214:33;9238:33;9251:34', '', '', 186, NULL, NULL),
	(9238, 'xmas_c16_creature1', 24, '9211:50;9258:50', '', '', 186, NULL, NULL),
	(9251, 'xmas_c16_creature4', 24, '9224:50;9242:50', '', '', 186, NULL, NULL),
	(8548, 'ny16_crackable', 2, '8545:5;8543:15;8546:15;8541:20;8540:20;8542:25', '', '', 0, NULL, NULL),
	(9288, 'ny17_crackable', 2, '9289:5;9291:15;9292:15;9293:20;9294:20;9295:25', '', '', 0, NULL, NULL),
	(11531, 'hween_c20_duckgoddess', 30, '11483:45;11530:45;11497:10', '', '', 186, NULL, NULL),
	(11520, 'hween_r20_evilpandorabox', 2, '11531:25;11498:25;11504:25;11502:25', '', '', 0, NULL, NULL),
	(11502, 'hween_c20_eyedemon', 20, '11537:45;11479:45;11506:10', '', '', 162, NULL, NULL),
	(11504, 'hween_c20_octodemon', 25, '11489:45;11494:45;11494:10', '', '', 117, NULL, NULL),
	(11498, 'hween_c20_evilscarecrow', 25, '11535:45;11492:45;11533:10', '', '', 5, NULL, NULL),
	(11495, 'hween_c20_pandorabox', 2, '10819:15;9761:13;10819:13;10789:10;8381:10;9186:10;10271:9;10271:20', '', '', 0, NULL, NULL),
	(11562, 'plushie_c20_crackable', 2, '11557:13;11571:13;11571:13;11599:13;11577:12;11563:12;11610:12;11610:12', '', '', 0, NULL, NULL),
	(12499, 'val_c22_brokenvan', 2, '12494:25;12495:25;12496:25;12497:25;12503:5', '', '', 183, NULL, NULL),
	(12434, 'ny_r21_crackable', 2, '12432:50;12433:50;12435:50;12436:50;12437:50;12438:50;12439:50;12440:50', '', '', 0, NULL, NULL),
	(12203, 'xmas_c21_crackableletter', 2, '12183:50;12166:25;12195:25;12186:25;12162:25;12214:25;12210:25;12199:25;12201:25;12193:25;12215:25;12180:25', '', '', 0, NULL, NULL),
	(11731, 'bonusbag21_3', 2, '11719:50;11720:50;11721:50;11722:50;11723:50;11724:50', '', '', 0, NULL, NULL),
	(11738, 'bonusbag21_1', 2, '11732:50;11733:50;11734:50;11735:50;11736:50;11737:50', '', '', 0, NULL, NULL),
	(11739, 'bonusbag21_2', 2, '11713:50;11714:50;11715:50;11716:50;11717:50;11718:50', '', '', 0, NULL, NULL),
	(11712, 'bonusbag21_4', 2, '11725:50;11726:50;11727:50;11728:50;11729:50;11730:50', '', '', 0, NULL, NULL),
	(11701, 'ny_r20_crackable', 2, '11702:15;11703:50;11704:50;11705:50;11706:50;11708:50;11709:50;11710:50', '', '', 0, NULL, NULL),
	(11670, 'xmas_c20_runerock', 2, '11664:100', '', '', 0, NULL, NULL),
	(11664, 'xmas_c20_runerockpurple', 2, '11659:100', '', '', 0, NULL, NULL),
	(11659, 'xmas_c20_runerockblue', 2, '11658:100', '', '', 0, NULL, NULL),
	(11658, 'xmas_c20_runerockred', 2, '11642:100', '', '', 0, NULL, NULL),
	(11642, 'xmas_c20_runerockyellow', 2, '11619:100', '', '', 0, NULL, NULL),
	(11619, 'xmas_c20_runerockgreen', 2, '11664:100', '', '', 0, NULL, NULL),
	(12048, 'diamond_c21_giftbox', 2, '12049:1;12051:2;12047:5;10604:7;11847:8;11832:8;8592:8;11863:8;7772:9;10477:9;3396:9;10312:9;10161:9;8260:10', '', '', 0, NULL, NULL),
	(12127, 'bubblejuice_c21_crackable2', 2, '12126:40;12128:40;12136:40;12151:5;12134:10;12130:15', '', '', 0, NULL, NULL),
	(12132, 'bubblejuice_c21_crackable1', 2, '12126:75;12128:75;12136:75', '', '', 0, NULL, NULL),
	(12543, 'bonusbag22_1', 2, '179:1', '', '', 0, NULL, NULL),
	(12522, 'bonusbag22_1', 2, '179:1', '', '', 0, NULL, NULL),
	(12530, 'bonusbag22_3', 2, '179:1', '', '', 0, NULL, NULL),
	(12544, 'bonusbag22_4', 2, '179:1', '', '', 0, NULL, NULL),
	(12034, 'mushroom_c21_crackable', 2, '11841:90;11843:90;11846:90;11847:90;11848:90;11849:90;12040:10;12035:10;12031:10', '', '', 186, NULL, NULL),
	(11960, 'rainbow_c21_crackable1', 2, '11957:90;11959:50;11962:50;11970:50;11971:50', '', '', 0, NULL, NULL),
	(11958, 'rainbow_c21_crackable2', 2, '11957:90;11965:10;11967:10;11968:10;11969:10', '', '', 0, NULL, NULL),
	(11931, 'thai_r21_clothingbox', 2, '11917:25;11921:25;11937:25;11933:25', '', '', 0, NULL, NULL),
	(11936, 'thai_c21_woodcarvingset', 2, '11946:24;11924:24;11923:24;11910:24;11931:4', '', '', 0, NULL, NULL),
	(3710, 'duck_hc', 1, '', '', '', 0, 7, 'hc'),
	(3709, 'duck_vip', 1, '', '', '', 0, 7, 'hc'),
	(4365, 'duck_vipwhite', 1, '', '', '', 0, 7, 'hc');
/*!40000 ALTER TABLE `items_crackable` ENABLE KEYS */;

/*!40101 SET SQL_MODE=IFNULL(@OLD_SQL_MODE, '') */;
/*!40014 SET FOREIGN_KEY_CHECKS=IFNULL(@OLD_FOREIGN_KEY_CHECKS, 1) */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40111 SET SQL_NOTES=IFNULL(@OLD_SQL_NOTES, 1) */;
